/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/common/map","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/browser/1dsAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(Z){for(var e=[],R=0,t=Z.length;R<t;R++)e[R]=re[Z[R]];return e};define(re[110],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(t,L){if(!t)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=R}),define(re[51],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(A){return A?A.replace(/\$\((.*?)\)/g,(I,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=R;class t{constructor(I,b,P){this.id=I,this.definition=b,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\f101"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function L(A,I){const b=["codicon","codicon-"+A];return I&&b.push("codicon-modifier-"+I),b}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(w){if(w instanceof t)return["codicon","codicon-"+w.id];const p=I.exec(w.id);if(!p)return b(t.error);const[,E,d]=p,S=["codicon","codicon-"+E];return d&&S.push("codicon-modifier-"+d.substr(1)),S}A.asClassNameArray=b;function P(w){return b(w).join(" ")}A.asClassName=P;function D(w){return"."+b(w).join(".")}A.asCSSSelector=D})(T=e.CSSIcon||(e.CSSIcon={}))}),define(re[74],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=e.forEach=void 0;function R(I,b){for(const[P,D]of Object.entries(I))if(b({key:P,value:D})===!1)return}e.forEach=R;function t(I,b){const P=Object.create(null);for(const D of I){const w=b(D);let p=P[w];p||(p=P[w]=[]),p.push(D)}return P}e.groupBy=t;function L(I,b){const P=[],D=[];for(const w of I)b.has(w)||P.push(w);for(const w of b)I.has(w)||D.push(w);return{removed:P,added:D}}e.diffSets=L;function T(I,b){const P=[],D=[];for(const[w,p]of I)b.has(w)||P.push(p);for(const[w,p]of b)I.has(w)||D.push(p);return{removed:P,added:D}}e.diffMaps=T;class A{constructor(){this.map=new Map}add(b,P){let D=this.map.get(b);D||(D=new Set,this.map.set(b,D)),D.add(P)}delete(b,P){const D=this.map.get(b);!D||(D.delete(P),D.size===0&&this.map.delete(b))}forEach(b,P){const D=this.map.get(b);!D||D.forEach(P)}}e.SetMap=A}),define(re[60],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(I,b,P)=>{let D=null,w=null;if(typeof P.value=="function"?(D="value",w=P.value):typeof P.get=="function"&&(D="get",w=P.get),!w)throw new Error("not supported");P[D]=A(w,b)}}e.createDecorator=R;function t(A,I,b){let P=null,D=null;if(typeof b.value=="function"?(P="value",D=b.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(P="get",D=b.get),!D)throw new Error("not supported");const w=`$memoize$${I}`;b[P]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,p)}),this[w]}}e.memoize=t;function L(A,I,b){return R((P,D)=>{const w=`$debounce$${D}`,p=`$debounce$result$${D}`;return function(...E){this[p]||(this[p]=b?b():void 0),clearTimeout(this[w]),I&&(this[p]=I(this[p],...E),E=[this[p]]),this[w]=setTimeout(()=>{P.apply(this,E),this[p]=b?b():void 0},A)}})}e.debounce=L;function T(A,I,b){return R((P,D)=>{const w=`$throttle$timer$${D}`,p=`$throttle$result$${D}`,E=`$throttle$lastRun$${D}`,d=`$throttle$pending$${D}`;return function(...S){if(this[p]||(this[p]=b?b():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),I&&(this[p]=I(this[p],...S)),this[d])return;const y=this[E]+A;y<=Date.now()?(this[E]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0):(this[d]=!0,this[w]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),P.apply(this,[this[p]]),this[p]=b?b():void 0},y-Date.now()))}})}e.throttle=T}),define(re[9],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?m.isErrorNoTelemetry(r)?new m(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(n=>{n(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=R,e.errorHandler=new R;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function L(u){b(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=L;function T(u){b(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=T;function A(u){if(u instanceof Error){const{name:r,message:n}=u,i=u.stacktrace||u.stack;return{$isError:!0,name:r,message:n,stack:i,noTelemetry:m.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=A;const I="Canceled";function b(u){return u instanceof P?!0:u instanceof Error&&u.name===I&&u.message===I}e.isCancellationError=b;class P extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=P;function D(){const u=new Error(I);return u.name=u.message,u}e.canceled=D;function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=w;function p(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=p;function E(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function d(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=d;function S(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=S;class y extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=y;class h extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=h;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;class m extends Error{constructor(r){super(r);this.name="ErrorNoTelemetry"}static fromError(r){if(r instanceof m)return r;const n=new m;return n.message=r.message,n.stack=r.stack,n}static isErrorNoTelemetry(r){return r.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=m;class f extends Error{constructor(r){super(r||"An unexpected bug occurred.");Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(re[17],se([0,1,9]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(q,ee=0){return q[q.length-(1+ee)]}e.tail=t;function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=L;function T(q,ee,ne=(oe,le)=>oe===le){if(q===ee)return!0;if(!q||!ee||q.length!==ee.length)return!1;for(let oe=0,le=q.length;oe<le;oe++)if(!ne(q[oe],ee[oe]))return!1;return!0}e.equals=T;function A(q,ee,ne){return I(q.length,oe=>ne(q[oe],ee))}e.binarySearch=A;function I(q,ee){let ne=0,oe=q-1;for(;ne<=oe;){const le=(ne+oe)/2|0,Se=ee(le);if(Se<0)ne=le+1;else if(Se>0)oe=le-1;else return le}return-(ne+1)}e.binarySearch2=I;function b(q,ee){let ne=0,oe=q.length;if(oe===0)return 0;for(;ne<oe;){const le=Math.floor((ne+oe)/2);ee(q[le])?oe=le:ne=le+1}return ne}e.findFirstInSorted=b;function P(q,ee,ne){if(q=q|0,q>=ee.length)throw new TypeError("invalid index");const oe=ee[Math.floor(ee.length*Math.random())],le=[],Se=[],fe=[];for(const pe of ee){const Ce=ne(pe,oe);Ce<0?le.push(pe):Ce>0?Se.push(pe):fe.push(pe)}return q<le.length?P(q,le,ne):q<le.length+fe.length?fe[0]:P(q-(le.length+fe.length),Se,ne)}e.quickSelect=P;function D(q,ee){const ne=[];let oe;for(const le of q.slice(0).sort(ee))!oe||ee(oe[0],le)!==0?(oe=[le],ne.push(oe)):oe.push(le);return ne}e.groupBy=D;function w(q,ee,ne){const oe=[];function le(pe,Ce,be){if(Ce===0&&be.length===0)return;const Ie=oe[oe.length-1];Ie&&Ie.start+Ie.deleteCount===pe?(Ie.deleteCount+=Ce,Ie.toInsert.push(...be)):oe.push({start:pe,deleteCount:Ce,toInsert:be})}let Se=0,fe=0;for(;;){if(Se===q.length){le(Se,0,ee.slice(fe));break}if(fe===ee.length){le(Se,q.length-Se,[]);break}const pe=q[Se],Ce=ee[fe],be=ne(pe,Ce);be===0?(Se+=1,fe+=1):be<0?(le(Se,1,[]),Se+=1):be>0&&(le(Se,0,[Ce]),fe+=1)}return oe}e.sortedDiff=w;function p(q,ee,ne){const oe=w(q,ee,ne),le=[],Se=[];for(const fe of oe)le.push(...q.slice(fe.start,fe.start+fe.deleteCount)),Se.push(...fe.toInsert);return{removed:le,added:Se}}e.delta=p;function E(q,ee,ne){if(ne===0)return[];const oe=q.slice(0,ne).sort(ee);return S(q,ee,oe,ne,q.length),oe}e.top=E;function d(q,ee,ne,oe,le){return ne===0?Promise.resolve([]):new Promise((Se,fe)=>{(async()=>{const pe=q.length,Ce=q.slice(0,ne).sort(ee);for(let be=ne,Ie=Math.min(ne+oe,pe);be<pe;be=Ie,Ie=Math.min(Ie+oe,pe)){if(be>ne&&await new Promise(qe=>setTimeout(qe)),le&&le.isCancellationRequested)throw new R.CancellationError;S(q,ee,Ce,be,Ie)}return Ce})().then(Se,fe)})}e.topAsync=d;function S(q,ee,ne,oe,le){for(const Se=ne.length;oe<le;oe++){const fe=q[oe];if(ee(fe,ne[Se-1])<0){ne.pop();const pe=b(ne,Ce=>ee(fe,Ce)<0);ne.splice(pe,0,fe)}}}function y(q){return q.filter(ee=>!!ee)}e.coalesce=y;function h(q){let ee=0;for(let ne=0;ne<q.length;ne++)q[ne]&&(q[ee]=q[ne],ee+=1);q.length=ee}e.coalesceInPlace=h;function v(q,ee,ne){q.splice(ne,0,q.splice(ee,1)[0])}e.move=v;function m(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=m;function f(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=f;function u(q,ee=ne=>ne){const ne=new Set;return q.filter(oe=>{const le=ee(oe);return ne.has(le)?!1:(ne.add(le),!0)})}e.distinct=u;function r(q){const ee=new Set;return ne=>{const oe=q(ne);return ee.has(oe)?!1:(ee.add(oe),!0)}}e.uniqueFilter=r;function n(q,ee){const ne=i(q,ee);if(ne!==-1)return q[ne]}e.findLast=n;function i(q,ee){for(let ne=q.length-1;ne>=0;ne--){const oe=q[ne];if(ee(oe))return ne}return-1}e.lastIndex=i;function a(q,ee){return q.length>0?q[0]:ee}e.firstOrDefault=a;function l(q,ee){return q.length>0?q[q.length-1]:ee}e.lastOrDefault=l;function o(q,ee,ne=(oe,le)=>oe===le){let oe=0;for(let le=0,Se=Math.min(q.length,ee.length);le<Se&&ne(q[le],ee[le]);le++)oe++;return oe}e.commonPrefixLength=o;function s(q){return[].concat(...q)}e.flatten=s;function c(q,ee){let ne=typeof ee=="number"?q:0;typeof ee=="number"?ne=q:(ne=0,ee=q);const oe=[];if(ne<=ee)for(let le=ne;le<ee;le++)oe.push(le);else for(let le=ne;le>ee;le--)oe.push(le);return oe}e.range=c;function g(q,ee,ne){return q.reduce((oe,le)=>(oe[ee(le)]=ne?ne(le):le,oe),Object.create(null))}e.index=g;function C(q,ee){return q.push(ee),()=>O(q,ee)}e.insert=C;function O(q,ee){const ne=q.indexOf(ee);if(ne>-1)return q.splice(ne,1),ee}e.remove=O;function _(q,ee,ne){const oe=q.slice(0,ee),le=q.slice(ee);return oe.concat(ne,le)}e.arrayInsert=_;function N(q,ee){let ne;if(typeof ee=="number"){let oe=ee;ne=()=>{const le=Math.sin(oe++)*179426549;return le-Math.floor(le)}}else ne=Math.random;for(let oe=q.length-1;oe>0;oe-=1){const le=Math.floor(ne()*(oe+1)),Se=q[oe];q[oe]=q[le],q[le]=Se}}e.shuffle=N;function k(q,ee){const ne=q.indexOf(ee);ne>-1&&(q.splice(ne,1),q.unshift(ee))}e.pushToStart=k;function M(q,ee){const ne=q.indexOf(ee);ne>-1&&(q.splice(ne,1),q.push(ee))}e.pushToEnd=M;function U(q,ee){for(const ne of ee)q.push(ne)}e.pushMany=U;function H(q,ee){return Array.isArray(q)?q.map(ee):ee(q)}e.mapArrayOrNot=H;function W(q){return Array.isArray(q)?q:[q]}e.asArray=W;function z(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=z;function te(q,ee){for(const ne of q){const oe=ee(ne);if(oe!==void 0)return oe}}e.mapFind=te;function V(q,ee,ne){const oe=X(q,ee),le=q.length,Se=ne.length;q.length=le+Se;for(let fe=le-1;fe>=oe;fe--)q[fe+Se]=q[fe];for(let fe=0;fe<Se;fe++)q[fe+oe]=ne[fe]}e.insertInto=V;function G(q,ee,ne,oe){const le=X(q,ee),Se=q.splice(le,ne);return V(q,le,oe),Se}e.splice=G;function X(q,ee){return ee<0?Math.max(ee+q.length,0):Math.min(ee,q.length)}var Y;(function(q){function ee(le){return le<0}q.isLessThan=ee;function ne(le){return le>0}q.isGreaterThan=ne;function oe(le){return le===0}q.isNeitherLessOrGreaterThan=oe,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function x(q,ee){return(ne,oe)=>ee(q(ne),q(oe))}e.compareBy=x;function B(...q){return(ee,ne)=>{for(const oe of q){const le=oe(ee,ne);if(!Y.isNeitherLessOrGreaterThan(le))return le}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=B;const J=(q,ee)=>q-ee;e.numberComparator=J;function F(q,ee){if(q.length===0)return;let ne=q[0];for(let oe=1;oe<q.length;oe++){const le=q[oe];ee(le,ne)>0&&(ne=le)}return ne}e.findMaxBy=F;function $(q,ee){if(q.length===0)return;let ne=q[0];for(let oe=1;oe<q.length;oe++){const le=q[oe];ee(le,ne)>=0&&(ne=le)}return ne}e.findLastMaxBy=$;function j(q,ee){return F(q,(ne,oe)=>-ee(ne,oe))}e.findMinBy=j;class K{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let ne=this.firstIdx;for(;ne<this.items.length&&ee(this.items[ne]);)ne++;const oe=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,oe}takeFromEndWhile(ee){let ne=this.lastIdx;for(;ne>=0&&ee(this.items[ne]);)ne--;const oe=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,oe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const ne=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,ne}}e.ArrayQueue=K}),define(re[75],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(t){const L=this;let T=!1,A;return function(){return T||(T=!0,A=t.apply(L,arguments)),A}}e.once=R}),define(re[52],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(t){function L(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=L;const T=Object.freeze([]);function A(){return T}t.empty=A;function*I(n){yield n}t.single=I;function b(n){return n||T}t.from=b;function P(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=P;function D(n){return n[Symbol.iterator]().next().value}t.first=D;function w(n,i){for(const a of n)if(i(a))return!0;return!1}t.some=w;function p(n,i){for(const a of n)if(i(a))return a}t.find=p;function*E(n,i){for(const a of n)i(a)&&(yield a)}t.filter=E;function*d(n,i){let a=0;for(const l of n)yield i(l,a++)}t.map=d;function*S(...n){for(const i of n)for(const a of i)yield a}t.concat=S;function*y(n){for(const i of n)for(const a of i)yield a}t.concatNested=y;function h(n,i,a){let l=a;for(const o of n)l=i(l,o);return l}t.reduce=h;function v(n,i){let a=0;for(const l of n)i(l,a++)}t.forEach=v;function*m(n,i,a=n.length){for(i<0&&(i+=n.length),a<0?a+=n.length:a>n.length&&(a=n.length);i<a;i++)yield n[i]}t.slice=m;function f(n,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,n];const l=n[Symbol.iterator]();for(let o=0;o<i;o++){const s=l.next();if(s.done)return[a,t.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return l}}]}t.consume=f;function u(n){return f(n)[0]}t.collect=u;function r(n,i,a=(l,o)=>l===o){const l=n[Symbol.iterator](),o=i[Symbol.iterator]();for(;;){const s=l.next(),c=o.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!a(s.value,c.value))return!1}}t.equals=r})(R=e.Iterable||(e.Iterable={}))}),define(re[34],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(r,n=!1){let i=0;const a=r.length;let l="",o=0,s=16,c=0;function g(U){let H=0,W=0;for(;H<U;){const z=r.charCodeAt(i);if(z>=48&&z<=57)W=W*16+z-48;else if(z>=65&&z<=70)W=W*16+z-65+10;else if(z>=97&&z<=102)W=W*16+z-97+10;else break;i++,H++}return H<U&&(W=-1),W}function C(U){i=U,l="",o=0,s=16,c=0}function O(){const U=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&P(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&P(r.charCodeAt(i)))for(i++;i<r.length&&P(r.charCodeAt(i));)i++;else return c=3,r.substring(U,i);let H=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&P(r.charCodeAt(i))){for(i++;i<r.length&&P(r.charCodeAt(i));)i++;H=i}else c=3;return r.substring(U,H)}function _(){let U="",H=i;for(;;){if(i>=a){U+=r.substring(H,i),c=2;break}const W=r.charCodeAt(i);if(W===34){U+=r.substring(H,i),i++;break}if(W===92){if(U+=r.substring(H,i),i++,i>=a){c=2;break}switch(r.charCodeAt(i++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const te=g(4);te>=0?U+=String.fromCharCode(te):c=4;break}default:c=5}H=i;continue}if(W>=0&&W<=31)if(b(W)){U+=r.substring(H,i),c=2;break}else c=6;i++}return U}function N(){if(l="",c=0,o=i,i>=a)return o=a,s=17;let U=r.charCodeAt(i);if(I(U)){do i++,l+=String.fromCharCode(U),U=r.charCodeAt(i);while(I(U));return s=15}if(b(U))return i++,l+=String.fromCharCode(U),U===13&&r.charCodeAt(i)===10&&(i++,l+=`
`),s=14;switch(U){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,l=_(),s=10;case 47:{const H=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<a&&!b(r.charCodeAt(i));)i++;return l=r.substring(H,i),s=12}if(r.charCodeAt(i+1)===42){i+=2;const W=a-1;let z=!1;for(;i<W;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,z=!0;break}i++}return z||(i++,c=1),l=r.substring(H,i),s=13}return l+=String.fromCharCode(U),i++,s=16}case 45:if(l+=String.fromCharCode(U),i++,i===a||!P(r.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=O(),s=11;default:for(;i<a&&k(U);)i++,U=r.charCodeAt(i);if(o!==i){switch(l=r.substring(o,i),l){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return l+=String.fromCharCode(U),i++,s=16}}function k(U){if(I(U)||b(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:C,getPosition:()=>i,scan:n?M:N,getToken:()=>s,getTokenValue:()=>l,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>c}}e.createScanner=A;function I(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function P(r){return r>=48&&r<=57}var D;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(D||(D={}));function w(r,n){const i=[],a=new Object;let l;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function c(g,C,O,_){o.value=g,o.offset=C,o.length=O,o.type=_,o.colonOffset=void 0,l=o}try{m(r,{onObjectBegin:(g,C)=>{if(n<=g)throw a;l=void 0,s=n>g,i.push("")},onObjectProperty:(g,C,O)=>{if(n<C||(c(g,C,O,"property"),i[i.length-1]=g,n<=C+O))throw a},onObjectEnd:(g,C)=>{if(n<=g)throw a;l=void 0,i.pop()},onArrayBegin:(g,C)=>{if(n<=g)throw a;l=void 0,i.push(0)},onArrayEnd:(g,C)=>{if(n<=g)throw a;l=void 0,i.pop()},onLiteralValue:(g,C,O)=>{if(n<C||(c(g,C,O,u(g)),n<=C+O))throw a},onSeparator:(g,C,O)=>{if(n<=C)throw a;if(g===":"&&l&&l.type==="property")l.colonOffset=C,s=!1,l=void 0;else if(g===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(s=!0,i[i.length-1]=""),l=void 0}}})}catch(g){if(g!==a)throw g}return{path:i,previousNode:l,isAtPropertyKey:s,matches:g=>{let C=0;for(let O=0;C<g.length&&O<i.length;O++)if(g[C]===i[O]||g[C]==="*")C++;else if(g[C]!=="**")return!1;return C===g.length}}}e.getLocation=w;function p(r,n=[],i=T.DEFAULT){let a=null,l=[];const o=[];function s(g){Array.isArray(l)?l.push(g):a!==null&&(l[a]=g)}return m(r,{onObjectBegin:()=>{const g={};s(g),o.push(l),l=g,a=null},onObjectProperty:g=>{a=g},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const g=[];s(g),o.push(l),l=g,a=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:s,onError:(g,C,O)=>{n.push({error:g,offset:C,length:O})}},i),l[0]}e.parse=p;function E(r,n=[],i=T.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(g){a.type==="property"&&(a.length=g-a.offset,a=a.parent)}function o(g){return a.children.push(g),g}m(r,{onObjectBegin:g=>{a=o({type:"object",offset:g,length:-1,parent:a,children:[]})},onObjectProperty:(g,C,O)=>{a=o({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:g,offset:C,length:O,parent:a})},onObjectEnd:(g,C)=>{a.length=g+C-a.offset,a=a.parent,l(g+C)},onArrayBegin:(g,C)=>{a=o({type:"array",offset:g,length:-1,parent:a,children:[]})},onArrayEnd:(g,C)=>{a.length=g+C-a.offset,a=a.parent,l(g+C)},onLiteralValue:(g,C,O)=>{o({type:u(g),offset:C,length:O,parent:a,value:g}),l(C+O)},onSeparator:(g,C,O)=>{a.type==="property"&&(g===":"?a.colonOffset=C:g===","&&l(C))},onError:(g,C,O)=>{n.push({error:g,offset:C,length:O})}},i);const c=a.children[0];return c&&delete c.parent,c}e.parseTree=E;function d(r,n){if(!r)return;let i=r;for(const a of n)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let l=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===a){i=o.children[1],l=!0;break}if(!l)return}else{const l=a;if(i.type!=="array"||l<0||!Array.isArray(i.children)||l>=i.children.length)return;i=i.children[l]}return i}e.findNodeAtLocation=d;function S(r){if(!r.parent||!r.parent.children)return[];const n=S(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;n.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&n.push(i)}return n}e.getNodePath=S;function y(r){switch(r.type){case"array":return r.children.map(y);case"object":{const n=Object.create(null);for(const i of r.children){const a=i.children[1];a&&(n[i.children[0].value]=y(a))}return n}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=y;function h(r,n,i=!1){return n>=r.offset&&n<r.offset+r.length||i&&n===r.offset+r.length}e.contains=h;function v(r,n,i=!1){if(h(r,n,i)){const a=r.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=n;l++){const o=v(a[l],n,i);if(o)return o}return r}}e.findNodeAtOffset=v;function m(r,n,i=T.DEFAULT){const a=A(r,!1);function l(B){return B?()=>B(a.getTokenOffset(),a.getTokenLength()):()=>!0}function o(B){return B?J=>B(J,a.getTokenOffset(),a.getTokenLength()):()=>!0}const s=l(n.onObjectBegin),c=o(n.onObjectProperty),g=l(n.onObjectEnd),C=l(n.onArrayBegin),O=l(n.onArrayEnd),_=o(n.onLiteralValue),N=o(n.onSeparator),k=l(n.onComment),M=o(n.onError),U=i&&i.disallowComments,H=i&&i.allowTrailingComma;function W(){for(;;){const B=a.scan();switch(a.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:U||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(B){case 12:case 13:U?z(10):k();break;case 16:z(1);break;case 15:case 14:break;default:return B}}}function z(B,J=[],F=[]){if(M(B),J.length+F.length>0){let $=a.getToken();for(;$!==17;){if(J.indexOf($)!==-1){W();break}else if(F.indexOf($)!==-1)break;$=W()}}}function te(B){const J=a.getTokenValue();return B?_(J):c(J),W(),!0}function V(){switch(a.getToken()){case 11:{let B=0;try{B=JSON.parse(a.getTokenValue()),typeof B!="number"&&(z(2),B=0)}catch{z(2)}_(B);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return W(),!0}function G(){return a.getToken()!==10?(z(3,[],[2,5]),!1):(te(!1),a.getToken()===6?(N(":"),W(),x()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){s(),W();let B=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(B||z(4,[],[]),N(","),W(),a.getToken()===2&&H)break}else B&&z(6,[],[]);G()||z(4,[],[2,5]),B=!0}return g(),a.getToken()!==2?z(7,[2],[]):W(),!0}function Y(){C(),W();let B=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(B||z(4,[],[]),N(","),W(),a.getToken()===4&&H)break}else B&&z(6,[],[]);x()||z(4,[],[4,5]),B=!0}return O(),a.getToken()!==4?z(8,[4],[]):W(),!0}function x(){switch(a.getToken()){case 3:return Y();case 1:return X();case 10:return te(!0);default:return V()}}return W(),a.getToken()===17?i.allowEmptyContent?!0:(z(4,[],[]),!1):x()?(a.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=m;function f(r,n){const i=A(r),a=[];let l,o=0,s;do switch(s=i.getPosition(),l=i.scan(),l){case 12:case 13:case 17:o!==s&&a.push(r.substring(o,s)),n!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,n)),o=i.getPosition();break}while(l!==17);return a.join("")}e.stripComments=f;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(re[53],se([0,1,34]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,D,w){let p,E,d,S,y;if(D){for(S=D.offset,y=S+D.length,d=S;d>0&&!b(P,d-1);)d--;let s=y;for(;s<P.length&&!b(P,s);)s++;E=P.substring(d,s),p=A(E,w)}else E=P,p=0,d=0,S=0,y=P.length;const h=I(w,P);let v=!1,m=0,f;w.insertSpaces?f=T(" ",w.tabSize||4):f="	";const u=(0,R.createScanner)(E,!1);let r=!1;function n(){return h+T(f,p+m)}function i(){let s=u.scan();for(v=!1;s===15||s===14;)v=v||s===14,s=u.scan();return r=s===16||u.getTokenError()!==0,s}const a=[];function l(s,c,g){!r&&c<y&&g>S&&P.substring(c,g)!==s&&a.push({offset:c,length:g-c,content:s})}let o=i();if(o!==17){const s=u.getTokenOffset()+d,c=T(f,p);l(c,d,s)}for(;o!==17;){let s=u.getTokenOffset()+u.getTokenLength()+d,c=i(),g="";for(;!v&&(c===12||c===13);){const O=u.getTokenOffset()+d;l(" ",s,O),s=u.getTokenOffset()+u.getTokenLength()+d,g=c===12?n():"",c=i()}if(c===2)o!==1&&(m--,g=n());else if(c===4)o!==3&&(m--,g=n());else{switch(o){case 3:case 1:m++,g=n();break;case 5:case 12:g=n();break;case 13:v?g=n():g=" ";break;case 6:g=" ";break;case 10:if(c===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?g=" ":c!==5&&c!==17&&(r=!0);break;case 16:r=!0;break}v&&(c===12||c===13)&&(g=n())}const C=u.getTokenOffset()+d;l(g,s,C),o=c}return a}e.format=t;function L(P,D){const w=JSON.stringify(P,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?w.replace(/\r\n|\r|\n/g,D.eol):w}e.toFormattedString=L;function T(P,D){let w="";for(let p=0;p<D;p++)w+=P;return w}function A(P,D){let w=0,p=0;const E=D.tabSize||4;for(;w<P.length;){const d=P.charAt(w);if(d===" ")p++;else if(d==="	")p+=E;else break;w++}return Math.floor(p/E)}function I(P,D){for(let w=0;w<D.length;w++){const p=D.charAt(w);if(p==="\r")return w+1<D.length&&D.charAt(w+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=I;function b(P,D){return`\r
`.indexOf(P.charAt(D))!==-1}e.isEOL=b}),define(re[76],se([0,1,34,53]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(P,D,w){return T(P,D,void 0,w)}e.removeProperty=L;function T(P,D,w,p,E){const d=D.slice(),S=[],y=(0,R.parseTree)(P,S);let h,v;for(;d.length>0&&(v=d.pop(),h=(0,R.findNodeAtLocation)(y,d),h===void 0&&w!==void 0);)typeof v=="string"?w={[v]:w}:w=[w];if(h)if(h.type==="object"&&typeof v=="string"&&Array.isArray(h.children)){const m=(0,R.findNodeAtLocation)(h,[v]);if(m!==void 0)if(w===void 0){if(!m.parent)throw new Error("Malformed AST");const f=h.children.indexOf(m.parent);let u,r=m.parent.offset+m.parent.length;if(f>0){const n=h.children[f-1];u=n.offset+n.length}else u=h.offset+1,h.children.length>1&&(r=h.children[1].offset);return A(P,{offset:u,length:r-u,content:""},p)}else return A(P,{offset:m.offset,length:m.length,content:JSON.stringify(w)},p);else{if(w===void 0)return[];const f=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,u=E?E(h.children.map(n=>n.children[0].value)):h.children.length;let r;if(u>0){const n=h.children[u-1];r={offset:n.offset+n.length,length:0,content:","+f}}else h.children.length===0?r={offset:h.offset+1,length:0,content:f}:r={offset:h.offset+1,length:0,content:f+","};return A(P,r,p)}}else if(h.type==="array"&&typeof v=="number"&&Array.isArray(h.children))if(w!==void 0){const m=`${JSON.stringify(w)}`;let f;if(h.children.length===0||v===0)f={offset:h.offset+1,length:0,content:h.children.length===0?m:m+","};else{const u=v===-1||v>h.children.length?h.children.length:v,r=h.children[u-1];f={offset:r.offset+r.length,length:0,content:","+m}}return A(P,f,p)}else{const m=v,f=h.children[m];let u;if(h.children.length===1)u={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===m){const r=h.children[m-1],n=r.offset+r.length,i=h.offset+h.length;u={offset:n,length:i-2-n,content:""}}else u={offset:f.offset,length:h.children[m+1].offset-f.offset,content:""};return A(P,u,p)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${h.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(w)},p)}}e.setProperty=T;function A(P,D,w){let p=I(P,D),E=D.offset,d=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;E>0&&!(0,t.isEOL)(p,E-1);)E--;for(;d<p.length&&!(0,t.isEOL)(p,d);)d++}const S=(0,t.format)(p,{offset:E,length:d-E},w);for(let h=S.length-1;h>=0;h--){const v=S[h];p=I(p,v),E=Math.min(E,v.offset),d=Math.max(d,v.offset+v.length),d+=v.content.length-v.length}const y=P.length-(p.length-d)-E;return[{offset:E,length:y,content:p.substring(E,d)}]}e.withFormatting=A;function I(P,D){return P.substring(0,D.offset)+D.content+P.substring(D.offset+D.length)}e.applyEdit=I;function b(P,D){const w=D.slice(0).sort((E,d)=>{const S=E.offset-d.offset;return S===0?E.length-d.length:S});let p=P.length;for(let E=w.length-1;E>=0;E--){const d=w[E];if(d.offset+d.length<=p)P=I(P,d);else throw new Error("Overlapping edit");p=d.offset}return P}e.applyEdits=b}),define(re[111],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new R(()=>L(this.getValue()))}}e.Lazy=R}),define(re[2],se([0,1,75,52]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(l){T=l}if(e.setDisposableTracker=A,L){const l="__is_disposable_tracked__";A(new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(s)},3e3)}setParent(o,s){if(o&&o!==v.None)try{o[l]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[l]=!0}catch{}}markAsSingleton(o){}})}function I(l){return T?.trackDisposable(l),l}function b(l){T?.markAsDisposed(l)}function P(l,o){T?.setParent(l,o)}function D(l,o){if(!!T)for(const s of l)T.setParent(s,o)}function w(l){return T?.markAsSingleton(l),l}e.markAsSingleton=w;class p extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=p;function E(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=E;function d(l){if(t.Iterable.is(l)){const o=[];for(const s of l)if(s)try{s.dispose()}catch(c){o.push(c)}if(o.length===1)throw o[0];if(o.length>1)throw new p(o);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=d;function S(...l){const o=y(()=>d(l));return D(l,o),o}e.combinedDisposable=S;function y(l){const o=I({dispose:(0,R.once)(()=>{b(o),l()})});return o}e.toDisposable=y;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return P(o,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new h,I(this),P(this._store,this)}dispose(){b(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&P(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&P(o,null),o}}e.MutableDisposable=m;class f{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(o){let s=o;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,b(this))},this}}e.SafeDisposable=u;class r{constructor(){this.references=new Map}acquire(o,...s){let c=this.references.get(o);c||(c={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,c));const{object:g}=c,C=(0,R.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(o,c.object),this.references.delete(o))});return c.counter++,{object:g,dispose:C}}}e.ReferenceCollection=r;class n{constructor(o){this.referenceCollection=o}async acquire(o,...s){const c=this.referenceCollection.acquire(o,...s);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(g){throw c.dispose(),g}}}e.AsyncReferenceCollection=n;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function a(l){const o=new h;try{l(o)}finally{o.dispose()}}e.disposeOnReturn=a}),define(re[112],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class t{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const A=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const I=new R(T);if(this._first===R.Undefined)this._first=I,this._last=I;else if(A){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(I))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),function(){function Z(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(b){T.push(b,Date.now())}function I(){const b=[];for(let P=0;P<T.length;P+=2)b.push({name:T[P],startTime:T[P+1]});return b}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function R(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=R(t))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var t in R)(typeof exports=="object"?exports:Z)[t]=R[t]}}(typeof self!="undefined"?self:this,function(){return function(Z){var e={};function R(t){if(e[t])return e[t].exports;var L=e[t]={i:t,l:!1,exports:{}};return Z[t].call(L.exports,L,L.exports,R),L.l=!0,L.exports}return R.m=Z,R.c=e,R.d=function(t,L,T){R.o(t,L)||Object.defineProperty(t,L,{enumerable:!0,get:T})},R.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},R.t=function(t,L){if(1&L&&(t=R(t)),8&L||4&L&&typeof t=="object"&&t&&t.__esModule)return t;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:t}),2&L&&typeof t!="string")for(var A in t)R.d(T,A,function(I){return t[I]}.bind(null,A));return T},R.n=function(t){var L=t&&t.__esModule?function(){return t.default}:function(){return t};return R.d(L,"a",L),L},R.o=function(t,L){return Object.prototype.hasOwnProperty.call(t,L)},R.p="",R(R.s=0)}([function(Z,e,R){(function(t){var L;e=Z.exports=F,L=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],P=0,D=P++;b[D]="0|[1-9]\\d*";var w=P++;b[w]="[0-9]+";var p=P++;b[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=P++;b[E]="("+b[D]+")\\.("+b[D]+")\\.("+b[D]+")";var d=P++;b[d]="("+b[w]+")\\.("+b[w]+")\\.("+b[w]+")";var S=P++;b[S]="(?:"+b[D]+"|"+b[p]+")";var y=P++;b[y]="(?:"+b[w]+"|"+b[p]+")";var h=P++;b[h]="(?:-("+b[S]+"(?:\\."+b[S]+")*))";var v=P++;b[v]="(?:-?("+b[y]+"(?:\\."+b[y]+")*))";var m=P++;b[m]="[0-9A-Za-z-]+";var f=P++;b[f]="(?:\\+("+b[m]+"(?:\\."+b[m]+")*))";var u=P++,r="v?"+b[E]+b[h]+"?"+b[f]+"?";b[u]="^"+r+"$";var n="[v=\\s]*"+b[d]+b[v]+"?"+b[f]+"?",i=P++;b[i]="^"+n+"$";var a=P++;b[a]="((?:<|>)?=?)";var l=P++;b[l]=b[w]+"|x|X|\\*";var o=P++;b[o]=b[D]+"|x|X|\\*";var s=P++;b[s]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[h]+")?"+b[f]+"?)?)?";var c=P++;b[c]="[v=\\s]*("+b[l]+")(?:\\.("+b[l]+")(?:\\.("+b[l]+")(?:"+b[v]+")?"+b[f]+"?)?)?";var g=P++;b[g]="^"+b[a]+"\\s*"+b[s]+"$";var C=P++;b[C]="^"+b[a]+"\\s*"+b[c]+"$";var O=P++;b[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=P++;b[_]="(?:~>?)";var N=P++;b[N]="(\\s*)"+b[_]+"\\s+",I[N]=new RegExp(b[N],"g");var k=P++;b[k]="^"+b[_]+b[s]+"$";var M=P++;b[M]="^"+b[_]+b[c]+"$";var U=P++;b[U]="(?:\\^)";var H=P++;b[H]="(\\s*)"+b[U]+"\\s+",I[H]=new RegExp(b[H],"g");var W=P++;b[W]="^"+b[U]+b[s]+"$";var z=P++;b[z]="^"+b[U]+b[c]+"$";var te=P++;b[te]="^"+b[a]+"\\s*("+n+")$|^$";var V=P++;b[V]="^"+b[a]+"\\s*("+r+")$|^$";var G=P++;b[G]="(\\s*)"+b[a]+"\\s*("+n+"|"+b[s]+")",I[G]=new RegExp(b[G],"g");var X=P++;b[X]="^\\s*("+b[s]+")\\s+-\\s+("+b[s]+")\\s*$";var Y=P++;b[Y]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var x=P++;b[x]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)L(B,b[B]),I[B]||(I[B]=new RegExp(b[B]));function J(ae,ue){if(ae instanceof F)return ae;if(typeof ae!="string"||ae.length>T||!(ue?I[i]:I[u]).test(ae))return null;try{return new F(ae,ue)}catch{return null}}function F(ae,ue){if(ae instanceof F){if(ae.loose===ue)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof F))return new F(ae,ue);L("SemVer",ae,ue),this.loose=ue;var he=ae.trim().match(ue?I[i]:I[u]);if(!he)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Pe=+Ee;if(Pe>=0&&Pe<A)return Pe}return Ee}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=J,e.valid=function(ae,ue){var he=J(ae,ue);return he?he.version:null},e.clean=function(ae,ue){var he=J(ae.trim().replace(/^[=v]+/,""),ue);return he?he.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(ae){return L("SemVer.compare",this.version,this.loose,ae),ae instanceof F||(ae=new F(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},F.prototype.compareMain=function(ae){return ae instanceof F||(ae=new F(ae,this.loose)),j(this.major,ae.major)||j(this.minor,ae.minor)||j(this.patch,ae.patch)},F.prototype.comparePre=function(ae){if(ae instanceof F||(ae=new F(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ue=0;do{var he=this.prerelease[ue],Ee=ae.prerelease[ue];if(L("prerelease compare",ue,he,Ee),he===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(he===void 0)return-1;if(he!==Ee)return j(he,Ee)}while(++ue)},F.prototype.inc=function(ae,ue){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ue,he,Ee){typeof he=="string"&&(Ee=he,he=void 0);try{return new F(ae,he).inc(ue,Ee).version}catch{return null}},e.diff=function(ae,ue){if(ne(ae,ue))return null;var he=J(ae),Ee=J(ue);if(he.prerelease.length||Ee.prerelease.length){for(var Pe in he)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&he[Pe]!==Ee[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in he)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&he[Pe]!==Ee[Pe])return Pe},e.compareIdentifiers=j;var $=/^[0-9]+$/;function j(ae,ue){var he=$.test(ae),Ee=$.test(ue);return he&&Ee&&(ae=+ae,ue=+ue),he&&!Ee?-1:Ee&&!he?1:ae<ue?-1:ae>ue?1:0}function K(ae,ue,he){return new F(ae,he).compare(new F(ue,he))}function q(ae,ue,he){return K(ae,ue,he)>0}function ee(ae,ue,he){return K(ae,ue,he)<0}function ne(ae,ue,he){return K(ae,ue,he)===0}function oe(ae,ue,he){return K(ae,ue,he)!==0}function le(ae,ue,he){return K(ae,ue,he)>=0}function Se(ae,ue,he){return K(ae,ue,he)<=0}function fe(ae,ue,he,Ee){var Pe;switch(ue){case"===":typeof ae=="object"&&(ae=ae.version),typeof he=="object"&&(he=he.version),Pe=ae===he;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof he=="object"&&(he=he.version),Pe=ae!==he;break;case"":case"=":case"==":Pe=ne(ae,he,Ee);break;case"!=":Pe=oe(ae,he,Ee);break;case">":Pe=q(ae,he,Ee);break;case">=":Pe=le(ae,he,Ee);break;case"<":Pe=ee(ae,he,Ee);break;case"<=":Pe=Se(ae,he,Ee);break;default:throw new TypeError("Invalid operator: "+ue)}return Pe}function pe(ae,ue){if(ae instanceof pe){if(ae.loose===ue)return ae;ae=ae.value}if(!(this instanceof pe))return new pe(ae,ue);L("comparator",ae,ue),this.loose=ue,this.parse(ae),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ae,ue){return j(ue,ae)},e.major=function(ae,ue){return new F(ae,ue).major},e.minor=function(ae,ue){return new F(ae,ue).minor},e.patch=function(ae,ue){return new F(ae,ue).patch},e.compare=K,e.compareLoose=function(ae,ue){return K(ae,ue,!0)},e.rcompare=function(ae,ue,he){return K(ue,ae,he)},e.sort=function(ae,ue){return ae.sort(function(he,Ee){return e.compare(he,Ee,ue)})},e.rsort=function(ae,ue){return ae.sort(function(he,Ee){return e.rcompare(he,Ee,ue)})},e.gt=q,e.lt=ee,e.eq=ne,e.neq=oe,e.gte=le,e.lte=Se,e.cmp=fe,e.Comparator=pe;var Ce={};function be(ae,ue){if(ae instanceof be)return ae.loose===ue?ae:new be(ae.raw,ue);if(ae instanceof pe)return new be(ae.value,ue);if(!(this instanceof be))return new be(ae,ue);if(this.loose=ue,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ie(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function qe(ae,ue,he,Ee,Pe,Ue,Re,Ne,_e,Te,Me,ie,ce){return((ue=Ie(he)?"":Ie(Ee)?">="+he+".0.0":Ie(Pe)?">="+he+"."+Ee+".0":">="+ue)+" "+(Ne=Ie(_e)?"":Ie(Te)?"<"+(+_e+1)+".0.0":Ie(Me)?"<"+_e+"."+(+Te+1)+".0":ie?"<="+_e+"."+Te+"."+Me+"-"+ie:"<="+Ne)).trim()}function Qe(ae,ue){for(var he=0;he<ae.length;he++)if(!ae[he].test(ue))return!1;if(ue.prerelease.length){for(he=0;he<ae.length;he++)if(L(ae[he].semver),ae[he].semver!==Ce&&ae[he].semver.prerelease.length>0){var Ee=ae[he].semver;if(Ee.major===ue.major&&Ee.minor===ue.minor&&Ee.patch===ue.patch)return!0}return!1}return!0}function Ke(ae,ue,he){try{ue=new be(ue,he)}catch{return!1}return ue.test(ae)}function Ye(ae,ue,he,Ee){var Pe,Ue,Re,Ne,_e;switch(ae=new F(ae,Ee),ue=new be(ue,Ee),he){case">":Pe=q,Ue=Se,Re=ee,Ne=">",_e=">=";break;case"<":Pe=ee,Ue=le,Re=q,Ne="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ke(ae,ue,Ee))return!1;for(var Te=0;Te<ue.set.length;++Te){var Me=ue.set[Te],ie=null,ce=null;if(Me.forEach(function(de){de.semver===Ce&&(de=new pe(">=0.0.0")),ie=ie||de,ce=ce||de,Pe(de.semver,ie.semver,Ee)?ie=de:Re(de.semver,ce.semver,Ee)&&(ce=de)}),ie.operator===Ne||ie.operator===_e||(!ce.operator||ce.operator===Ne)&&Ue(ae,ce.semver)||ce.operator===_e&&Re(ae,ce.semver))return!1}return!0}pe.prototype.parse=function(ae){var ue=this.loose?I[te]:I[V],he=ae.match(ue);if(!he)throw new TypeError("Invalid comparator: "+ae);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new F(he[2],this.loose):this.semver=Ce},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ae){return L("Comparator.test",ae,this.loose),this.semver===Ce||(typeof ae=="string"&&(ae=new F(ae,this.loose)),fe(ae,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ae,ue){if(!(ae instanceof pe))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new be(ae.value,ue),Ke(this.value,he,ue);if(ae.operator==="")return he=new be(this.value,ue),Ke(ae.semver,he,ue);var Ee=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Ue=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ne=fe(this.semver,"<",ae.semver,ue)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),_e=fe(this.semver,">",ae.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ee||Pe||Ue&&Re||Ne||_e},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ae){var ue=this.loose;ae=ae.trim(),L("range",ae,ue);var he=ue?I[Y]:I[X];ae=ae.replace(he,qe),L("hyphen replace",ae),ae=ae.replace(I[G],"$1$2$3"),L("comparator trim",ae,I[G]),ae=(ae=(ae=ae.replace(I[N],"$1~")).replace(I[H],"$1^")).split(/\s+/).join(" ");var Ee=ue?I[te]:I[V],Pe=ae.split(" ").map(function(Ue){return function(Re,Ne){return L("comp",Re),Re=function(_e,Te){return _e.trim().split(/\s+/).map(function(Me){return function(ie,ce){L("caret",ie,ce);var de=ce?I[z]:I[W];return ie.replace(de,function(ve,ge,we,De,ke){var Le;return L("caret",ie,ve,ge,we,De,ke),Ie(ge)?Le="":Ie(we)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(De)?Le=ge==="0"?">="+ge+"."+we+".0 <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+".0 <"+(+ge+1)+".0.0":ke?(L("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=ge==="0"?we==="0"?">="+ge+"."+we+"."+De+ke+" <"+ge+"."+we+"."+(+De+1):">="+ge+"."+we+"."+De+ke+" <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+"."+De+ke+" <"+(+ge+1)+".0.0"):(L("no pr"),Le=ge==="0"?we==="0"?">="+ge+"."+we+"."+De+" <"+ge+"."+we+"."+(+De+1):">="+ge+"."+we+"."+De+" <"+ge+"."+(+we+1)+".0":">="+ge+"."+we+"."+De+" <"+(+ge+1)+".0.0"),L("caret return",Le),Le})}(Me,Te)}).join(" ")}(Re,Ne),L("caret",Re),Re=function(_e,Te){return _e.trim().split(/\s+/).map(function(Me){return function(ie,ce){var de=ce?I[M]:I[k];return ie.replace(de,function(ve,ge,we,De,ke){var Le;return L("tilde",ie,ve,ge,we,De,ke),Ie(ge)?Le="":Ie(we)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(De)?Le=">="+ge+"."+we+".0 <"+ge+"."+(+we+1)+".0":ke?(L("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+ge+"."+we+"."+De+ke+" <"+ge+"."+(+we+1)+".0"):Le=">="+ge+"."+we+"."+De+" <"+ge+"."+(+we+1)+".0",L("tilde return",Le),Le})}(Me,Te)}).join(" ")}(Re,Ne),L("tildes",Re),Re=function(_e,Te){return L("replaceXRanges",_e,Te),_e.split(/\s+/).map(function(Me){return function(ie,ce){ie=ie.trim();var de=ce?I[C]:I[g];return ie.replace(de,function(ve,ge,we,De,ke,Le){L("xRange",ie,ve,ge,we,De,ke,Le);var Ae=Ie(we),Fe=Ae||Ie(De),$e=Fe||Ie(ke);return ge==="="&&$e&&(ge=""),Ae?ve=ge===">"||ge==="<"?"<0.0.0":"*":ge&&$e?(Fe&&(De=0),$e&&(ke=0),ge===">"?(ge=">=",Fe?(we=+we+1,De=0,ke=0):$e&&(De=+De+1,ke=0)):ge==="<="&&(ge="<",Fe?we=+we+1:De=+De+1),ve=ge+we+"."+De+"."+ke):Fe?ve=">="+we+".0.0 <"+(+we+1)+".0.0":$e&&(ve=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),L("xRange return",ve),ve})}(Me,Te)}).join(" ")}(Re,Ne),L("xrange",Re),Re=function(_e,Te){return L("replaceStars",_e,Te),_e.trim().replace(I[x],"")}(Re,Ne),L("stars",Re),Re}(Ue,ue)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(Ee)})),Pe=Pe.map(function(Ue){return new pe(Ue,ue)})},be.prototype.intersects=function(ae,ue){if(!(ae instanceof be))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ee){return ae.set.some(function(Pe){return Pe.every(function(Ue){return Ee.intersects(Ue,ue)})})})})},e.toComparators=function(ae,ue){return new be(ae,ue).set.map(function(he){return he.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new F(ae,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Qe(this.set[ue],ae))return!0;return!1},e.satisfies=Ke,e.maxSatisfying=function(ae,ue,he){var Ee=null,Pe=null;try{var Ue=new be(ue,he)}catch{return null}return ae.forEach(function(Re){Ue.test(Re)&&(Ee&&Pe.compare(Re)!==-1||(Pe=new F(Ee=Re,he)))}),Ee},e.minSatisfying=function(ae,ue,he){var Ee=null,Pe=null;try{var Ue=new be(ue,he)}catch{return null}return ae.forEach(function(Re){Ue.test(Re)&&(Ee&&Pe.compare(Re)!==1||(Pe=new F(Ee=Re,he)))}),Ee},e.validRange=function(ae,ue){try{return new be(ae,ue).range||"*"}catch{return null}},e.ltr=function(ae,ue,he){return Ye(ae,ue,"<",he)},e.gtr=function(ae,ue,he){return Ye(ae,ue,">",he)},e.outside=Ye,e.prerelease=function(ae,ue){var he=J(ae,ue);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(ae,ue,he){return ae=new be(ae,he),ue=new be(ue,he),ae.intersects(ue)},e.coerce=function(ae){if(ae instanceof F)return ae;if(typeof ae!="string")return null;var ue=ae.match(I[O]);return ue==null?null:J((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,R(1))},function(Z,e){var R,t,L=Z.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(y){if(R===setTimeout)return setTimeout(y,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(y,0);try{return R(y,0)}catch{try{return R.call(null,y,0)}catch{return R.call(this,y,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch{R=T}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var b,P=[],D=!1,w=-1;function p(){D&&b&&(D=!1,b.length?P=b.concat(P):w=-1,P.length&&E())}function E(){if(!D){var y=I(p);D=!0;for(var h=P.length;h;){for(b=P,P=[];++w<h;)b&&b[w].run();w=-1,h=P.length}b=null,D=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(y)}}function d(y,h){this.fun=y,this.array=h}function S(){}L.nextTick=function(y){var h=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)h[v-1]=arguments[v];P.push(new d(y,h)),P.length!==1||D||I(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=S,L.addListener=S,L.once=S,L.off=S,L.removeListener=S,L.removeAllListeners=S,L.emit=S,L.prependListener=S,L.prependOnceListener=S,L.listeners=function(y){return[]},L.binding=function(y){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(y){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(re[113],se([0,1]),function(Z,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,b,P){this.level=I,this.key=b,this.value=P,this.forward=[]}}const L=void 0;class T{constructor(I,b=2**16){this.comparator=I,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new t(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,L,L)}has(I){return Boolean(T._search(this,I,this.comparator))}get(I){return T._search(this,I,this.comparator)?.value}set(I,b){return T._insert(this,I,b,this.comparator)&&(this._size+=1),this}delete(I){const b=T._delete(this,I,this.comparator);return b&&(this._size-=1),b}forEach(I,b){let P=this._header.forward[0];for(;P;)I.call(b,P.value,P.key,this),P=P.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this._header.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static _search(I,b,P){let D=I._header;for(let w=I._level-1;w>=0;w--)for(;D.forward[w]&&P(D.forward[w].key,b)<0;)D=D.forward[w];if(D=D.forward[0],D&&P(D.key,b)===0)return D}static _insert(I,b,P,D){const w=[];let p=I._header;for(let E=I._level-1;E>=0;E--){for(;p.forward[E]&&D(p.forward[E].key,b)<0;)p=p.forward[E];w[E]=p}if(p=p.forward[0],p&&D(p.key,b)===0)return p.value=P,!1;{const E=T._randomLevel(I);if(E>I._level){for(let d=I._level;d<E;d++)w[d]=I._header;I._level=E}p=new t(E,b,P);for(let d=0;d<E;d++)p.forward[d]=w[d].forward[d],w[d].forward[d]=p;return!0}}static _randomLevel(I,b=.5){let P=1;for(;Math.random()<b&&P<I._maxLevel;)P+=1;return P}static _delete(I,b,P){const D=[];let w=I._header;for(let p=I._level-1;p>=0;p--){for(;w.forward[p]&&P(w.forward[p].key,b)<0;)w=w.forward[p];D[p]=w}if(w=w.forward[0],!w||P(w.key,b)!==0)return!1;for(let p=0;p<I._level&&D[p].forward[p]===w;p++)D[p].forward[p]=w.forward[p];for(;I._level>0&&I._header.forward[I._level-1]===L;)I._level-=1;return!0}}e.SkipList=T}),define(re[41],se([0,1,9,2]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function L(f){const u=f;return u?typeof u.read=="function":!1}e.isReadable=L;function T(f){const u=f;return u?[u.on,u.pause,u.resume,u.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=T;function A(f){const u=f;return u?T(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function I(f,u){return new b(f,u)}e.newWriteableStream=I;class b{constructor(u,r){this.reducer=u,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(r=>r(u))}emitError(u){this.listeners.error.length===0?(0,R.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(r=>r(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,r){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(u,r){if(this.state.destroyed)return;let n;switch(u){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const i=n.indexOf(r);i>=0&&n.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(f,u){const r=[];let n;for(;(n=f.read())!==null;)r.push(n);return u(r)}e.consumeReadable=P;function D(f,u,r){const n=[];let i;for(;(i=f.read())!==null&&n.length<r;)n.push(i);return i===null&&n.length>0?u(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i!="undefined"){const a=i;return i=void 0,a}return f.read()}}}e.peekReadable=D;function w(f,u){return new Promise((r,n)=>{const i=[];p(f,{onData:a=>{u&&i.push(a)},onError:a=>{u?n(a):r(void 0)},onEnd:()=>{r(u?u(i):void 0)}})})}e.consumeStream=w;function p(f,u){let r=!1;return f.on("error",n=>{r||u.onError(n)}),f.on("end",()=>{r||u.onEnd()}),f.on("data",n=>{r||u.onData(n)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=p;function E(f,u){return new Promise((r,n)=>{const i=new t.DisposableStore,a=[],l=c=>{if(a.push(c),a.length>u)return i.dispose(),f.pause(),r({stream:f,buffer:a,ended:!1})},o=c=>n(c),s=()=>r({stream:f,buffer:a,ended:!0});i.add((0,t.toDisposable)(()=>f.removeListener("error",o))),f.on("error",o),i.add((0,t.toDisposable)(()=>f.removeListener("end",s))),f.on("end",s),i.add((0,t.toDisposable)(()=>f.removeListener("data",l))),f.on("data",l)})}e.peekStream=E;function d(f,u){const r=I(u);return r.end(f),r}e.toStream=d;function S(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function y(f){let u=!1;return{read:()=>u?null:(u=!0,f)}}e.toReadable=y;function h(f,u,r){const n=I(r);return p(f,{onData:i=>n.write(u.data(i)),onError:i=>n.error(u.error?u.error(i):i),onEnd:()=>n.end()}),n}e.transform=h;function v(f,u,r){let n=!1;return{read:()=>{const i=u.read();return n?i:(n=!0,i!==null?r([f,i]):f)}}}e.prefixedReadable=v;function m(f,u,r){let n=!1;const i=I(r);return p(u,{onData:a=>n?i.write(a):(n=!0,i.write(r([f,a]))),onError:a=>i.error(a),onEnd:()=>{n||(n=!0,i.write(f)),i.end()}}),i}e.prefixedStream=m}),define(re[16],se([0,1,41]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let L,T;class A{constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}static alloc(c){return t?new A(Buffer.allocUnsafe(c)):new A(new Uint8Array(c))}static wrap(c){return t&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new A(c)}static fromString(c,g){return!(g?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(c)):(L||(L=new TextEncoder),new A(L.encode(c)))}static fromByteArray(c){const g=A.alloc(c.length);for(let C=0,O=c.length;C<O;C++)g.buffer[C]=c[C];return g}static concat(c,g){if(typeof g=="undefined"){g=0;for(let _=0,N=c.length;_<N;_++)g+=c[_].byteLength}const C=A.alloc(g);let O=0;for(let _=0,N=c.length;_<N;_++){const k=c[_];C.set(k,O),O+=k.byteLength}return C}clone(){const c=A.alloc(this.byteLength);return c.set(this),c}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(c,g){return new A(this.buffer.subarray(c,g))}set(c,g){if(c instanceof A)this.buffer.set(c.buffer,g);else if(c instanceof Uint8Array)this.buffer.set(c,g);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),g);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return P(this.buffer,c)}writeUInt32BE(c,g){D(this.buffer,c,g)}readUInt32LE(c){return w(this.buffer,c)}writeUInt32LE(c,g){p(this.buffer,c,g)}readUInt8(c){return E(this.buffer,c)}writeUInt8(c,g){d(this.buffer,c,g)}}e.VSBuffer=A;function I(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0}e.readUInt16LE=I;function b(s,c,g){s[g+0]=c&255,c=c>>>8,s[g+1]=c&255}e.writeUInt16LE=b;function P(s,c){return s[c]*2**24+s[c+1]*2**16+s[c+2]*2**8+s[c+3]}e.readUInt32BE=P;function D(s,c,g){s[g+3]=c,c=c>>>8,s[g+2]=c,c=c>>>8,s[g+1]=c,c=c>>>8,s[g]=c}e.writeUInt32BE=D;function w(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0|s[c+2]<<16>>>0|s[c+3]<<24>>>0}e.readUInt32LE=w;function p(s,c,g){s[g+0]=c&255,c=c>>>8,s[g+1]=c&255,c=c>>>8,s[g+2]=c&255,c=c>>>8,s[g+3]=c&255}e.writeUInt32LE=p;function E(s,c){return s[c]}e.readUInt8=E;function d(s,c,g){s[g]=c}e.writeUInt8=d;function S(s){return R.consumeReadable(s,c=>A.concat(c))}e.readableToBuffer=S;function y(s){return R.toReadable(s)}e.bufferToReadable=y;function h(s){return R.consumeStream(s,c=>A.concat(c))}e.streamToBuffer=h;async function v(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await h(s.stream)])}e.bufferedStreamToBuffer=v;function m(s){return R.toStream(s,c=>A.concat(c))}e.bufferToStream=m;function f(s){return R.transform(s,{data:c=>typeof c=="string"?A.fromString(c):A.wrap(c)},c=>A.concat(c))}e.streamToBufferReadableStream=f;function u(s){return R.newWriteableStream(c=>A.concat(c),s)}e.newWriteableBufferStream=u;function r(s,c){return R.prefixedReadable(s,c,g=>A.concat(g))}e.prefixedBufferReadable=r;function n(s,c){return R.prefixedStream(s,c,g=>A.concat(g))}e.prefixedBufferStream=n;function i(s){let c=0,g=0,C=0;const O=new Uint8Array(Math.floor(s.length/4*3)),_=k=>{switch(g){case 3:O[C++]=c|k,g=0;break;case 2:O[C++]=c|k>>>2,c=k<<6,g=3;break;case 1:O[C++]=c|k>>>4,c=k<<4,g=2;break;default:c=k<<2,g=1}};for(let k=0;k<s.length;k++){const M=s.charCodeAt(k);if(M>=65&&M<=90)_(M-65);else if(M>=97&&M<=122)_(M-97+26);else if(M>=48&&M<=57)_(M-48+52);else if(M===43||M===45)_(62);else if(M===47||M===95)_(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${s[k]}`)}}const N=C;for(;g>0;)_(0);return A.wrap(O).slice(0,N)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:s},c=!0,g=!1){const C=g?l:a;let O="";const _=s.byteLength%3;let N=0;for(;N<s.byteLength-_;N+=3){const k=s[N+0],M=s[N+1],U=s[N+2];O+=C[k>>>2],O+=C[(k<<4|M>>>4)&63],O+=C[(M<<2|U>>>6)&63],O+=C[U&63]}if(_===1){const k=s[N+0];O+=C[k>>>2],O+=C[k<<4&63],c&&(O+="==")}else if(_===2){const k=s[N+0],M=s[N+1];O+=C[k>>>2],O+=C[(k<<4|M>>>4)&63],O+=C[M<<2&63],c&&(O+="=")}return O}e.encodeBase64=o}),define(re[14],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(s){return Array.isArray(s)}e.isArray=R;function t(s){return typeof s=="string"}e.isString=t;function L(s){return Array.isArray(s)&&s.every(c=>t(c))}e.isStringArray=L;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function A(s){return typeof s=="object"&&(s instanceof Uint8Array||s instanceof Uint16Array||s instanceof Uint32Array||s instanceof Float32Array||s instanceof Float64Array||s instanceof Int8Array||s instanceof Int16Array||s instanceof Int32Array||s instanceof BigInt64Array||s instanceof BigUint64Array||s instanceof Uint8ClampedArray)}e.isTypedArray=A;function I(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=I;function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=b;function P(s){return s===!0||s===!1}e.isBoolean=P;function D(s){return typeof s=="undefined"}e.isUndefined=D;function w(s){return!p(s)}e.isDefined=w;function p(s){return D(s)||s===null}e.isUndefinedOrNull=p;function E(s,c){if(!s)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=E;function d(s){if(p(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=d;function S(...s){const c=[];for(let g=0;g<s.length;g++){const C=s[g];if(p(C))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);c.push(C)}return c}e.assertAllDefined=S;const y=Object.prototype.hasOwnProperty;function h(s){if(!T(s))return!1;for(const c in s)if(y.call(s,c))return!1;return!0}e.isEmptyObject=h;function v(s){return typeof s=="function"}e.isFunction=v;function m(...s){return s.length>0&&s.every(v)}e.areFunctions=m;function f(s,c){const g=Math.min(s.length,c.length);for(let C=0;C<g;C++)u(s[C],c[C])}e.validateConstraints=f;function u(s,c){if(t(c)){if(typeof s!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(v(c)){try{if(s instanceof c)return}catch{}if(!p(s)&&s.constructor===c||c.length===1&&c.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function r(s){let c=[],g=Object.getPrototypeOf(s);for(;Object.prototype!==g;)c=c.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return c}e.getAllPropertyNames=r;function n(s){const c=[];for(const g of r(s))typeof s[g]=="function"&&c.push(g);return c}e.getAllMethodNames=n;function i(s,c){const g=O=>function(){const _=Array.prototype.slice.call(arguments,0);return c(O,_)},C={};for(const O of s)C[O]=g(O);return C}e.createProxyObject=i;function a(s){return s===null?void 0:s}e.withNullAsUndefined=a;function l(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=l;function o(s,c="Unreachable"){throw new Error(c)}e.assertNever=o}),define(re[29],se([0,1,14]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.keys(d).forEach(y=>{d[y]&&typeof d[y]=="object"?S[y]=t(d[y]):S[y]=d[y]}),S}e.deepClone=t;function L(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const y=S.shift();Object.freeze(y);for(const h in y)if(T.call(y,h)){const v=y[h];typeof v=="object"&&!Object.isFrozen(v)&&!(0,R.isTypedArray)(v)&&S.push(v)}}return d}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(d,S){return I(d,S,new Set)}e.cloneAndChange=A;function I(d,S,y){if((0,R.isUndefinedOrNull)(d))return d;const h=S(d);if(typeof h!="undefined")return h;if((0,R.isArray)(d)){const v=[];for(const m of d)v.push(I(m,S,y));return v}if((0,R.isObject)(d)){if(y.has(d))throw new Error("Cannot clone recursive data-structure");y.add(d);const v={};for(const m in d)T.call(d,m)&&(v[m]=I(d[m],S,y));return y.delete(d),v}return d}function b(d,S,y=!0){return(0,R.isObject)(d)?((0,R.isObject)(S)&&Object.keys(S).forEach(h=>{h in d?y&&((0,R.isObject)(d[h])&&(0,R.isObject)(S[h])?b(d[h],S[h],y):d[h]=S[h]):d[h]=S[h]}),d):S}e.mixin=b;function P(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let y,h;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(y=0;y<d.length;y++)if(!P(d[y],S[y]))return!1}else{const v=[];for(h in d)v.push(h);v.sort();const m=[];for(h in S)m.push(h);if(m.sort(),!P(v,m))return!1;for(y=0;y<v.length;y++)if(!P(d[v[y]],S[v[y]]))return!1}return!0}e.equals=P;function D(d){const S=new Set;return JSON.stringify(d,(y,h)=>{if((0,R.isObject)(h)||Array.isArray(h)){if(S.has(h))return"[Circular]";S.add(h)}return h})}e.safeStringify=D;function w(d,S){const y=Object.create(null);return!d||!S||Object.keys(S).forEach(v=>{const m=d[v],f=S[v];P(m,f)||(y[v]=f)}),y}e.distinct=w;function p(d,S){const y=S.toLowerCase(),h=Object.keys(d).find(v=>v.toLowerCase()===y);return h?d[h]:d[S]}e.getCaseInsensitive=p;function E(d,S){const y=Object.create(null);for(const[h,v]of Object.entries(d))S(h,v)&&(y[h]=v);return y}e.filter=E}),define(re[31],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(L){return R.test(L)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const T=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){L(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let b=0,P="";return P+=A[T[b++]],P+=A[T[b++]],P+=A[T[b++]],P+=A[T[b++]],P+="-",P+=A[T[b++]],P+=A[T[b++]],P+="-",P+=A[T[b++]],P+=A[T[b++]],P+="-",P+=A[T[b++]],P+=A[T[b++]],P+="-",P+=A[T[b++]],P+=A[T[b++]],P+=A[T[b++]],P+=A[T[b++]],P+=A[T[b++]],P+=A[T[b++]],P}}()}),define(re[114],se([0,1,266]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(T="utf8"){this.stringDecoder=new R.StringDecoder(T),this.remaining=null}write(T){const A=[],I=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(I.length<1)return A;let b=0,P,D=b;for(;D<I.length;)if(P=I.charCodeAt(D),P===13||P===10){if(A.push(I.substring(b,D)),D++,D<I.length){const w=P;P=I.charCodeAt(D),(w===13&&P===10||w===10&&P===13)&&D++}b=D}else D++;return this.remaining=b<I.length?I.substr(b):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(re[115],se([0,1,36]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const I=A.replace(/\-/g,":").toLowerCase();return!t.has(I)}function T(){const A=(0,R.networkInterfaces)();for(const I in A){const b=A[I];if(b){for(const{mac:P}of b)if(L(P))return P}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(re[116],se([0,1,77]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,b,P,D=1){let w=!1;return new Promise(p=>{const E=setTimeout(()=>{if(!w)return w=!0,p(0)},P);L(I,b,D,d=>{if(!w)return w=!0,clearTimeout(E),p(d)})})}e.findFreePort=t;function L(I,b,P,D){if(b===0)return D(0);const w=new R.Socket;w.once("connect",()=>(A(w),L(I+P,b-1,P,D))),w.once("data",()=>{}),w.once("error",p=>(A(w),p.code!=="ECONNREFUSED"?L(I+P,b-1,P,D):D(I))),w.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(I,b,P){let D=!1,w,p=1;const E=R.createServer({pauseOnConnect:!0});function d(S,y){D||(D=!0,E.removeAllListeners(),E.close(),w&&clearTimeout(w),y(S))}return new Promise(S=>{w=setTimeout(()=>{d(0,S)},P),E.on("listening",()=>{d(I,S)}),E.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&p<b?(I++,p++,E.listen(I,"127.0.0.1")):d(0,S)}),E.on("close",()=>{d(0,S)}),E.listen(I,"127.0.0.1")})}e.findFreePortFaster=T;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),define(re[117],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function t(T){return T instanceof L?!0:T instanceof Error&&T.name===R&&T.message===R}e.isOfflineError=t;class L extends Error{constructor(){super(R);this.name=this.message}}e.OfflineError=L}),define(re[118],se([0,1,16,9,117]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(b,P){if(!navigator.onLine)throw new L.OfflineError;b.proxyAuthorization&&(b.headers={...b.headers||{},"Proxy-Authorization":b.proxyAuthorization});const D=new XMLHttpRequest;return new Promise((w,p)=>{D.open(b.type||"GET",b.url||"",!0,b.user,b.password),A(D,b),D.responseType="arraybuffer",D.onerror=E=>p(new Error(D.statusText&&"XHR failed: "+D.statusText||"XHR failed")),D.onload=E=>{w({res:{statusCode:D.status,headers:I(D)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(D.response)))})},D.ontimeout=E=>p(new Error(`XHR timeout: ${b.timeout}ms`)),b.timeout&&(D.timeout=b.timeout),D.send(b.data),P.onCancellationRequested(()=>{D.abort(),p((0,t.canceled)())})})}e.request=T;function A(b,P){if(P.headers){e:for(const D in P.headers){switch(D){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}b.setRequestHeader(D,P.headers[D])}}}function I(b){const P=Object.create(null);for(const D of b.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(D){const w=D.indexOf(":");P[D.substr(0,w).trim().toLowerCase()]=D.substr(w+1).trim()}return P}}),define(re[119],se([10,11]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(re[61],se([0,1,119]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,L=t*60,T=L*24,A=T*7,I=T*30,b=T*365;function P(w,p,E){typeof w!="number"&&(w=w.getTime());const d=Math.round((new Date().getTime()-w)/1e3);if(d<-30)return(0,R.localize)(0,null,P(new Date().getTime()+d*1e3,!1));if(d<30)return(0,R.localize)(1,null);let S;return d<t?(S=d,p?S===1?E?(0,R.localize)(2,null,S):(0,R.localize)(3,null,S):E?(0,R.localize)(4,null,S):(0,R.localize)(5,null,S):S===1?E?(0,R.localize)(6,null,S):(0,R.localize)(7,null,S):E?(0,R.localize)(8,null,S):(0,R.localize)(9,null,S)):d<L?(S=Math.floor(d/t),p?S===1?E?(0,R.localize)(10,null,S):(0,R.localize)(11,null,S):E?(0,R.localize)(12,null,S):(0,R.localize)(13,null,S):S===1?E?(0,R.localize)(14,null,S):(0,R.localize)(15,null,S):E?(0,R.localize)(16,null,S):(0,R.localize)(17,null,S)):d<T?(S=Math.floor(d/L),p?S===1?E?(0,R.localize)(18,null,S):(0,R.localize)(19,null,S):E?(0,R.localize)(20,null,S):(0,R.localize)(21,null,S):S===1?E?(0,R.localize)(22,null,S):(0,R.localize)(23,null,S):E?(0,R.localize)(24,null,S):(0,R.localize)(25,null,S)):d<A?(S=Math.floor(d/T),p?S===1?(0,R.localize)(26,null,S):(0,R.localize)(27,null,S):S===1?(0,R.localize)(28,null,S):(0,R.localize)(29,null,S)):d<I?(S=Math.floor(d/A),p?S===1?E?(0,R.localize)(30,null,S):(0,R.localize)(31,null,S):E?(0,R.localize)(32,null,S):(0,R.localize)(33,null,S):S===1?E?(0,R.localize)(34,null,S):(0,R.localize)(35,null,S):E?(0,R.localize)(36,null,S):(0,R.localize)(37,null,S)):d<b?(S=Math.floor(d/I),p?S===1?E?(0,R.localize)(38,null,S):(0,R.localize)(39,null,S):E?(0,R.localize)(40,null,S):(0,R.localize)(41,null,S):S===1?E?(0,R.localize)(42,null,S):(0,R.localize)(43,null,S):E?(0,R.localize)(44,null,S):(0,R.localize)(45,null,S)):(S=Math.floor(d/b),p?S===1?E?(0,R.localize)(46,null,S):(0,R.localize)(47,null,S):E?(0,R.localize)(48,null,S):(0,R.localize)(49,null,S):S===1?E?(0,R.localize)(50,null,S):(0,R.localize)(51,null,S):E?(0,R.localize)(52,null,S):(0,R.localize)(53,null,S))}e.fromNow=P;function D(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(re[120],se([10,11]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(re[37],se([0,1,17,14,120]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(w,p){return p&&(w.stack||w.stacktrace)?L.localize(0,null,I(w),A(w.stack)||A(w.stacktrace)):I(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function I(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?L.localize(1,null,w.message):w.message||L.localize(2,null)}function b(w=null,p=!1){if(!w)return L.localize(3,null);if(Array.isArray(w)){const E=R.coalesce(w),d=b(E[0],p);return E.length>1?L.localize(4,null,d,E.length):d}if(t.isString(w))return w;if(w.detail){const E=w.detail;if(E.error)return T(E.error,p);if(E.exception)return T(E.exception,p)}return w.stack?T(w,p):w.message?w.message:L.localize(5,null)}e.toErrorMessage=b;function P(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=P;function D(w,p){let E;return typeof w=="string"?E=new Error(w):E=w,E.actions=p,E}e.createErrorWithActions=D}),define(re[121],se([10,11]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(re[122],se([0,1,121]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(L){switch(L){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(re[123],se([10,11]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(re[4],se([0,1,123]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let L=!1,T=!1,A=!1,I=!1,b=!1,P=!1,D=!1,w=!1,p=!1,E,d=t,S,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const v=typeof h?.versions?.electron=="string",m=v&&h?.type==="renderer";if(typeof navigator=="object"&&!m)y=navigator.userAgent,L=y.indexOf("Windows")>=0,T=y.indexOf("Macintosh")>=0,w=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=y.indexOf("Linux")>=0,P=!0,E=R.getConfiguredDefaultLocale(R.localize(0,null))||t,d=E;else if(typeof h=="object"){L=h.platform==="win32",T=h.platform==="darwin",A=h.platform==="linux",I=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,D=v,p=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=t,d=t;const s=h.env.VSCODE_NLS_CONFIG;if(s)try{const c=JSON.parse(s),g=c.availableLanguages["*"];E=c.locale,d=g||t,S=c._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var f;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function u(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let r=0;T?r=1:L?r=3:A&&(r=2),e.isWindows=L,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=I,e.isNative=b,e.isElectron=D,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isCI=p,e.platform=r,e.userAgent=y,e.language=d;var n;(function(s){function c(){return e.language}s.value=c;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=g;function C(){return e.language==="en"}s.isDefault=C})(n=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let C=0,O=s.length;C<O;C++){const _=s[C];if(_.id===g.data.vscodeScheduleAsyncWork){s.splice(C,1),_.callback();return}}});let c=0;return g=>{const C=++c;s.push({id:C,callback:g}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||w?2:L?1:3;let a=!0,l=!1;function o(){if(!l){l=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[35],se([0,1,4]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const L=R.globals.vscode.process;t={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(re[12],se([0,1,35]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,L=97,T=90,A=122,I=46,b=47,P=92,D=58,w=63;class p extends Error{constructor(f,u,r){let n;typeof u=="string"&&u.indexOf("not ")===0?(n="must not be",u=u.replace(/^not /,"")):n="must be";const i=f.indexOf(".")!==-1?"property":"argument";let a=`The "${f}" ${i} ${n} of type ${u}`;a+=`. Received type ${typeof r}`;super(a);this.code="ERR_INVALID_ARG_TYPE"}}function E(m,f){if(typeof m!="string")throw new p(f,"string",m)}function d(m){return m===b||m===P}function S(m){return m===b}function y(m){return m>=t&&m<=T||m>=L&&m<=A}function h(m,f,u,r){let n="",i=0,a=-1,l=0,o=0;for(let s=0;s<=m.length;++s){if(s<m.length)o=m.charCodeAt(s);else{if(r(o))break;o=b}if(r(o)){if(!(a===s-1||l===1))if(l===2){if(n.length<2||i!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const c=n.lastIndexOf(u);c===-1?(n="",i=0):(n=n.slice(0,c),i=n.length-1-n.lastIndexOf(u)),a=s,l=0;continue}else if(n.length!==0){n="",i=0,a=s,l=0;continue}}f&&(n+=n.length>0?`${u}..`:"..",i=2)}else n.length>0?n+=`${u}${m.slice(a+1,s)}`:n=m.slice(a+1,s),i=s-a-1;a=s,l=0}else o===I&&l!==-1?++l:l=-1}return n}function v(m,f){if(f===null||typeof f!="object")throw new p("pathObject","Object",f);const u=f.dir||f.root,r=f.base||`${f.name||""}${f.ext||""}`;return u?u===f.root?`${u}${r}`:`${u}${m}${r}`:r}e.win32={resolve(...m){let f="",u="",r=!1;for(let n=m.length-1;n>=-1;n--){let i;if(n>=0){if(i=m[n],E(i,"path"),i.length===0)continue}else f.length===0?i=R.cwd():(i=R.env[`=${f}`]||R.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==f.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${f}\\`));const a=i.length;let l=0,o="",s=!1;const c=i.charCodeAt(0);if(a===1)d(c)&&(l=1,s=!0);else if(d(c))if(s=!0,d(i.charCodeAt(1))){let g=2,C=g;for(;g<a&&!d(i.charCodeAt(g));)g++;if(g<a&&g!==C){const O=i.slice(C,g);for(C=g;g<a&&d(i.charCodeAt(g));)g++;if(g<a&&g!==C){for(C=g;g<a&&!d(i.charCodeAt(g));)g++;(g===a||g!==C)&&(o=`\\\\${O}\\${i.slice(C,g)}`,l=g)}}}else l=1;else y(c)&&i.charCodeAt(1)===D&&(o=i.slice(0,2),l=2,a>2&&d(i.charCodeAt(2))&&(s=!0,l=3));if(o.length>0)if(f.length>0){if(o.toLowerCase()!==f.toLowerCase())continue}else f=o;if(r){if(f.length>0)break}else if(u=`${i.slice(l)}\\${u}`,r=s,s&&f.length>0)break}return u=h(u,!r,"\\",d),r?`${f}\\${u}`:`${f}${u}`||"."},normalize(m){E(m,"path");const f=m.length;if(f===0)return".";let u=0,r,n=!1;const i=m.charCodeAt(0);if(f===1)return S(i)?"\\":m;if(d(i))if(n=!0,d(m.charCodeAt(1))){let l=2,o=l;for(;l<f&&!d(m.charCodeAt(l));)l++;if(l<f&&l!==o){const s=m.slice(o,l);for(o=l;l<f&&d(m.charCodeAt(l));)l++;if(l<f&&l!==o){for(o=l;l<f&&!d(m.charCodeAt(l));)l++;if(l===f)return`\\\\${s}\\${m.slice(o)}\\`;l!==o&&(r=`\\\\${s}\\${m.slice(o,l)}`,u=l)}}}else u=1;else y(i)&&m.charCodeAt(1)===D&&(r=m.slice(0,2),u=2,f>2&&d(m.charCodeAt(2))&&(n=!0,u=3));let a=u<f?h(m.slice(u),!n,"\\",d):"";return a.length===0&&!n&&(a="."),a.length>0&&d(m.charCodeAt(f-1))&&(a+="\\"),r===void 0?n?`\\${a}`:a:n?`${r}\\${a}`:`${r}${a}`},isAbsolute(m){E(m,"path");const f=m.length;if(f===0)return!1;const u=m.charCodeAt(0);return d(u)||f>2&&y(u)&&m.charCodeAt(1)===D&&d(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let f,u;for(let i=0;i<m.length;++i){const a=m[i];E(a,"path"),a.length>0&&(f===void 0?f=u=a:f+=`\\${a}`)}if(f===void 0)return".";let r=!0,n=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++n;const i=u.length;i>1&&d(u.charCodeAt(1))&&(++n,i>2&&(d(u.charCodeAt(2))?++n:r=!1))}if(r){for(;n<f.length&&d(f.charCodeAt(n));)n++;n>=2&&(f=`\\${f.slice(n)}`)}return e.win32.normalize(f)},relative(m,f){if(E(m,"from"),E(f,"to"),m===f)return"";const u=e.win32.resolve(m),r=e.win32.resolve(f);if(u===r||(m=u.toLowerCase(),f=r.toLowerCase(),m===f))return"";let n=0;for(;n<m.length&&m.charCodeAt(n)===P;)n++;let i=m.length;for(;i-1>n&&m.charCodeAt(i-1)===P;)i--;const a=i-n;let l=0;for(;l<f.length&&f.charCodeAt(l)===P;)l++;let o=f.length;for(;o-1>l&&f.charCodeAt(o-1)===P;)o--;const s=o-l,c=a<s?a:s;let g=-1,C=0;for(;C<c;C++){const _=m.charCodeAt(n+C);if(_!==f.charCodeAt(l+C))break;_===P&&(g=C)}if(C!==c){if(g===-1)return r}else{if(s>c){if(f.charCodeAt(l+C)===P)return r.slice(l+C+1);if(C===2)return r.slice(l+C)}a>c&&(m.charCodeAt(n+C)===P?g=C:C===2&&(g=3)),g===-1&&(g=0)}let O="";for(C=n+g+1;C<=i;++C)(C===i||m.charCodeAt(C)===P)&&(O+=O.length===0?"..":"\\..");return l+=g,O.length>0?`${O}${r.slice(l,o)}`:(r.charCodeAt(l)===P&&++l,r.slice(l,o))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const f=e.win32.resolve(m);if(f.length<=2)return m;if(f.charCodeAt(0)===P){if(f.charCodeAt(1)===P){const u=f.charCodeAt(2);if(u!==w&&u!==I)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(y(f.charCodeAt(0))&&f.charCodeAt(1)===D&&f.charCodeAt(2)===P)return`\\\\?\\${f}`;return m},dirname(m){E(m,"path");const f=m.length;if(f===0)return".";let u=-1,r=0;const n=m.charCodeAt(0);if(f===1)return d(n)?m:".";if(d(n)){if(u=r=1,d(m.charCodeAt(1))){let l=2,o=l;for(;l<f&&!d(m.charCodeAt(l));)l++;if(l<f&&l!==o){for(o=l;l<f&&d(m.charCodeAt(l));)l++;if(l<f&&l!==o){for(o=l;l<f&&!d(m.charCodeAt(l));)l++;if(l===f)return m;l!==o&&(u=r=l+1)}}}}else y(n)&&m.charCodeAt(1)===D&&(u=f>2&&d(m.charCodeAt(2))?3:2,r=u);let i=-1,a=!0;for(let l=f-1;l>=r;--l)if(d(m.charCodeAt(l))){if(!a){i=l;break}}else a=!1;if(i===-1){if(u===-1)return".";i=u}return m.slice(0,i)},basename(m,f){f!==void 0&&E(f,"ext"),E(m,"path");let u=0,r=-1,n=!0,i;if(m.length>=2&&y(m.charCodeAt(0))&&m.charCodeAt(1)===D&&(u=2),f!==void 0&&f.length>0&&f.length<=m.length){if(f===m)return"";let a=f.length-1,l=-1;for(i=m.length-1;i>=u;--i){const o=m.charCodeAt(i);if(d(o)){if(!n){u=i+1;break}}else l===-1&&(n=!1,l=i+1),a>=0&&(o===f.charCodeAt(a)?--a==-1&&(r=i):(a=-1,r=l))}return u===r?r=l:r===-1&&(r=m.length),m.slice(u,r)}for(i=m.length-1;i>=u;--i)if(d(m.charCodeAt(i))){if(!n){u=i+1;break}}else r===-1&&(n=!1,r=i+1);return r===-1?"":m.slice(u,r)},extname(m){E(m,"path");let f=0,u=-1,r=0,n=-1,i=!0,a=0;m.length>=2&&m.charCodeAt(1)===D&&y(m.charCodeAt(0))&&(f=r=2);for(let l=m.length-1;l>=f;--l){const o=m.charCodeAt(l);if(d(o)){if(!i){r=l+1;break}continue}n===-1&&(i=!1,n=l+1),o===I?u===-1?u=l:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||n===-1||a===0||a===1&&u===n-1&&u===r+1?"":m.slice(u,n)},format:v.bind(null,"\\"),parse(m){E(m,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return f;const u=m.length;let r=0,n=m.charCodeAt(0);if(u===1)return d(n)?(f.root=f.dir=m,f):(f.base=f.name=m,f);if(d(n)){if(r=1,d(m.charCodeAt(1))){let g=2,C=g;for(;g<u&&!d(m.charCodeAt(g));)g++;if(g<u&&g!==C){for(C=g;g<u&&d(m.charCodeAt(g));)g++;if(g<u&&g!==C){for(C=g;g<u&&!d(m.charCodeAt(g));)g++;g===u?r=g:g!==C&&(r=g+1)}}}}else if(y(n)&&m.charCodeAt(1)===D){if(u<=2)return f.root=f.dir=m,f;if(r=2,d(m.charCodeAt(2))){if(u===3)return f.root=f.dir=m,f;r=3}}r>0&&(f.root=m.slice(0,r));let i=-1,a=r,l=-1,o=!0,s=m.length-1,c=0;for(;s>=r;--s){if(n=m.charCodeAt(s),d(n)){if(!o){a=s+1;break}continue}l===-1&&(o=!1,l=s+1),n===I?i===-1?i=s:c!==1&&(c=1):i!==-1&&(c=-1)}return l!==-1&&(i===-1||c===0||c===1&&i===l-1&&i===a+1?f.base=f.name=m.slice(a,l):(f.name=m.slice(a,i),f.base=m.slice(a,l),f.ext=m.slice(i,l))),a>0&&a!==r?f.dir=m.slice(0,a-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let f="",u=!1;for(let r=m.length-1;r>=-1&&!u;r--){const n=r>=0?m[r]:R.cwd();E(n,"path"),n.length!==0&&(f=`${n}/${f}`,u=n.charCodeAt(0)===b)}return f=h(f,!u,"/",S),u?`/${f}`:f.length>0?f:"."},normalize(m){if(E(m,"path"),m.length===0)return".";const f=m.charCodeAt(0)===b,u=m.charCodeAt(m.length-1)===b;return m=h(m,!f,"/",S),m.length===0?f?"/":u?"./":".":(u&&(m+="/"),f?`/${m}`:m)},isAbsolute(m){return E(m,"path"),m.length>0&&m.charCodeAt(0)===b},join(...m){if(m.length===0)return".";let f;for(let u=0;u<m.length;++u){const r=m[u];E(r,"path"),r.length>0&&(f===void 0?f=r:f+=`/${r}`)}return f===void 0?".":e.posix.normalize(f)},relative(m,f){if(E(m,"from"),E(f,"to"),m===f||(m=e.posix.resolve(m),f=e.posix.resolve(f),m===f))return"";const u=1,r=m.length,n=r-u,i=1,a=f.length-i,l=n<a?n:a;let o=-1,s=0;for(;s<l;s++){const g=m.charCodeAt(u+s);if(g!==f.charCodeAt(i+s))break;g===b&&(o=s)}if(s===l)if(a>l){if(f.charCodeAt(i+s)===b)return f.slice(i+s+1);if(s===0)return f.slice(i+s)}else n>l&&(m.charCodeAt(u+s)===b?o=s:s===0&&(o=0));let c="";for(s=u+o+1;s<=r;++s)(s===r||m.charCodeAt(s)===b)&&(c+=c.length===0?"..":"/..");return`${c}${f.slice(i+o)}`},toNamespacedPath(m){return m},dirname(m){if(E(m,"path"),m.length===0)return".";const f=m.charCodeAt(0)===b;let u=-1,r=!0;for(let n=m.length-1;n>=1;--n)if(m.charCodeAt(n)===b){if(!r){u=n;break}}else r=!1;return u===-1?f?"/":".":f&&u===1?"//":m.slice(0,u)},basename(m,f){f!==void 0&&E(f,"ext"),E(m,"path");let u=0,r=-1,n=!0,i;if(f!==void 0&&f.length>0&&f.length<=m.length){if(f===m)return"";let a=f.length-1,l=-1;for(i=m.length-1;i>=0;--i){const o=m.charCodeAt(i);if(o===b){if(!n){u=i+1;break}}else l===-1&&(n=!1,l=i+1),a>=0&&(o===f.charCodeAt(a)?--a==-1&&(r=i):(a=-1,r=l))}return u===r?r=l:r===-1&&(r=m.length),m.slice(u,r)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===b){if(!n){u=i+1;break}}else r===-1&&(n=!1,r=i+1);return r===-1?"":m.slice(u,r)},extname(m){E(m,"path");let f=-1,u=0,r=-1,n=!0,i=0;for(let a=m.length-1;a>=0;--a){const l=m.charCodeAt(a);if(l===b){if(!n){u=a+1;break}continue}r===-1&&(n=!1,r=a+1),l===I?f===-1?f=a:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||r===-1||i===0||i===1&&f===r-1&&f===u+1?"":m.slice(f,r)},format:v.bind(null,"/"),parse(m){E(m,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return f;const u=m.charCodeAt(0)===b;let r;u?(f.root="/",r=1):r=0;let n=-1,i=0,a=-1,l=!0,o=m.length-1,s=0;for(;o>=r;--o){const c=m.charCodeAt(o);if(c===b){if(!l){i=o+1;break}continue}a===-1&&(l=!1,a=o+1),c===I?n===-1?n=o:s!==1&&(s=1):n!==-1&&(s=-1)}if(a!==-1){const c=i===0&&u?1:i;n===-1||s===0||s===1&&n===a-1&&n===i+1?f.base=f.name=m.slice(c,a):(f.name=m.slice(c,n),f.base=m.slice(c,a),f.ext=m.slice(n,a))}return i>0?f.dir=m.slice(0,i-1):u&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[124],se([0,1,12]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(D){const w=(0,R.extname)(D),p=t[w.toLowerCase()];return p!==void 0?p:A(D)}e.getMediaOrTextMime=T;function A(D){const w=(0,R.extname)(D);return L[w.toLowerCase()]}e.getMediaMime=A;function I(D){for(const w in L)if(L[w]===D)return w}e.getExtensionForMimeType=I;const b=/^(.+)\/(.+?)(;.+)?$/;function P(D,w){const p=b.exec(D);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:w?void 0:D}e.normalizeMimeType=P}),define(re[78],se([0,1,4]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var L;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(I,...b){const P=b.reduce((p,E)=>(p[E]=!0,p),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(p=>!P[p]).forEach(p=>{for(let E=0;E<D.length;E++)if(p.search(D[E])!==-1){delete I[p];break}})}e.sanitizeProcessEnvironment=T;function A(I){!I||(delete I.DEBUG,R.isMacintosh&&delete I.DYLD_LIBRARY_PATH,R.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(re[125],se([0,1,4]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=R.globals.performance&&typeof R.globals.performance.now=="function";class L{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=L}),define(re[3],se([0,1,9,75,2,112,125]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const I=!1,b=!1;var P;(function(o){o.None=()=>L.Disposable.None;function s($){if(b){const{onListenerDidAdd:j}=$,K=d.create();let q=0;$.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),j?.()}}}function c($){return(j,K=null,q)=>{let ee=!1,ne;return ne=$(oe=>{if(!ee)return ne?ne.dispose():ee=!0,j.call(K,oe)},null,q),ee&&ne.dispose(),ne}}o.once=c;function g($,j,K){return M((q,ee=null,ne)=>$(oe=>q.call(ee,j(oe)),null,ne),K)}o.map=g;function C($,j,K){return M((q,ee=null,ne)=>$(oe=>{j(oe),q.call(ee,oe)},null,ne),K)}o.forEach=C;function O($,j,K){return M((q,ee=null,ne)=>$(oe=>j(oe)&&q.call(ee,oe),null,ne),K)}o.filter=O;function _($){return $}o.signal=_;function N(...$){return(j,K=null,q)=>(0,L.combinedDisposable)(...$.map(ee=>ee(ne=>j.call(K,ne),null,q)))}o.any=N;function k($,j,K,q){let ee=K;return g($,ne=>(ee=j(ee,ne),ee),q)}o.reduce=k;function M($,j){let K;const q={onFirstListenerAdd(){K=$(ee.fire,ee)},onLastListenerRemove(){K?.dispose()}};j||s(q);const ee=new y(q);return j?.add(ee),ee.event}function U($,j,K=100,q=!1,ee,ne){let oe,le,Se,fe=0;const pe={leakWarningThreshold:ee,onFirstListenerAdd(){oe=$(be=>{fe++,le=j(le,be),q&&!Se&&(Ce.fire(le),le=void 0),clearTimeout(Se),Se=setTimeout(()=>{const Ie=le;le=void 0,Se=void 0,(!q||fe>1)&&Ce.fire(Ie),fe=0},K)})},onLastListenerRemove(){oe.dispose()}};ne||s(pe);const Ce=new y(pe);return ne?.add(Ce),Ce.event}o.debounce=U;function H($,j=(q,ee)=>q===ee,K){let q=!0,ee;return O($,ne=>{const oe=q||!j(ne,ee);return q=!1,ee=ne,oe},K)}o.latch=H;function W($,j,K){return[o.filter($,j,K),o.filter($,q=>!j(q),K)]}o.split=W;function z($,j=!1,K=[]){let q=K.slice(),ee=$(le=>{q?q.push(le):oe.fire(le)});const ne=()=>{q?.forEach(le=>oe.fire(le)),q=null},oe=new y({onFirstListenerAdd(){ee||(ee=$(le=>oe.fire(le)))},onFirstListenerDidAdd(){q&&(j?setTimeout(ne):ne())},onLastListenerRemove(){ee&&ee.dispose(),ee=null}});return oe.event}o.buffer=z;class te{constructor(j){this.event=j,this.disposables=new L.DisposableStore}map(j){return new te(g(this.event,j,this.disposables))}forEach(j){return new te(C(this.event,j,this.disposables))}filter(j){return new te(O(this.event,j,this.disposables))}reduce(j,K){return new te(k(this.event,j,K,this.disposables))}latch(){return new te(H(this.event,void 0,this.disposables))}debounce(j,K=100,q=!1,ee){return new te(U(this.event,j,K,q,ee,this.disposables))}on(j,K,q){return this.event(j,K,q)}once(j,K,q){return c(this.event)(j,K,q)}dispose(){this.disposables.dispose()}}function V($){return new te($)}o.chain=V;function G($,j,K=q=>q){const q=(...le)=>oe.fire(K(...le)),ee=()=>$.on(j,q),ne=()=>$.removeListener(j,q),oe=new y({onFirstListenerAdd:ee,onLastListenerRemove:ne});return oe.event}o.fromNodeEventEmitter=G;function X($,j,K=q=>q){const q=(...le)=>oe.fire(K(...le)),ee=()=>$.addEventListener(j,q),ne=()=>$.removeEventListener(j,q),oe=new y({onFirstListenerAdd:ee,onLastListenerRemove:ne});return oe.event}o.fromDOMEventEmitter=X;function Y($){return new Promise(j=>c($)(j))}o.toPromise=Y;function x($,j){return j(void 0),$(K=>j(K))}o.runAndSubscribe=x;function B($,j){let K=null;function q(ne){K?.dispose(),K=new L.DisposableStore,j(ne,K)}q(void 0);const ee=$(ne=>q(ne));return(0,L.toDisposable)(()=>{ee.dispose(),K?.dispose()})}o.runAndSubscribeWithStore=B;class J{constructor(j,K){this.obs=j,this._counter=0,this._hasChanged=!1;const q={onFirstListenerAdd:()=>{j.addObserver(this)},onLastListenerRemove:()=>{j.removeObserver(this)}};K||s(q),this.emitter=new y(q),K&&K.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,K){this._hasChanged=!0}endUpdate(j){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function F($,j){return new J($,j).emitter.event}o.fromObservable=F})(P=e.Event||(e.Event={}));class D{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${D._idPool++}`}start(s){this._stopWatch=new A.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let w=-1;function p(o){const s=w;return w=o,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=p;class E{constructor(s,c=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s,c){let g=w;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||c<g)return;this._stacks||(this._stacks=new Map);const C=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,C+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let O,_=0;for(const[N,k]of this._stacks)(!O||_<k)&&(O=N,_=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${_}):`),console.warn(O)}return()=>{const O=this._stacks.get(s.value)||0;this._stacks.set(s.value,O-1)}}}class d{constructor(s){this.value=s}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(s,c,g){this.callback=s,this.callbackThis=c,this.stack=g,this.subscription=new L.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class y{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=w>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const c of s)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,c,g)=>{this._listeners||(this._listeners=new T.LinkedList);const C=this._listeners.isEmpty();C&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,_;this._leakageMon&&this._listeners.size>=30&&(_=d.create(),O=this._leakageMon.check(_,this._listeners.size+1)),I&&(_=_??d.create());const N=new S(s,c,_),k=this._listeners.push(N);C&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,c);const M=N.subscription.set(()=>{O?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return g instanceof L.DisposableStore?g.add(M):Array.isArray(g)&&g.push(M),M}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const c of this._listeners)this._deliveryQueue.push(this,c,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class h{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(s,c,g){this._queue.push(new m(s,c,g))}clear(s){const c=new T.LinkedList;for(const g of this._queue)g.emitter!==s&&c.push(g);this._queue=c}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(c){(0,R.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=h;class v extends h{clear(s){this._queue.clear()}}class m{constructor(s,c,g){this.emitter=s,this.listener=c,this.event=g}}class f extends y{async fireAsync(s,c,g){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const C of this._listeners)this._asyncDeliveryQueue.push([C,s]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[C,O]=this._asyncDeliveryQueue.shift(),_=[],N={...O,token:c,waitUntil:k=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");g&&(k=g(k,C.callback)),_.push(k)}};try{C.invoke(N)}catch(k){(0,R.onUnexpectedError)(k);continue}Object.freeze(_),await Promise.allSettled(_).then(k=>{for(const M of k)M.status==="rejected"&&(0,R.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=f;class u extends y{constructor(s){super(s);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=u;class r extends u{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=r;class n extends y{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]})}}e.MicrotaskEmitter=n;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const c={event:s,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const g=()=>{this.hasListeners&&this.unhook(c);const C=this.events.indexOf(c);this.events.splice(C,1)};return(0,L.toDisposable)((0,t.once)(g))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(c=>this.emitter.fire(c))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.buffers=[]}wrapEvent(s){return(c,g,C)=>s(O=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>c.call(g,O)):c.call(g,O)},void 0,C)}bufferEvents(s){const c=[];this.buffers.push(c);const g=s();return this.buffers.pop(),c.forEach(C=>C()),g}}e.EventBufferer=a;class l{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=L.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(re[23],se([0,1,3]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,b){const P=setTimeout(I.bind(b),0);return{dispose(){clearTimeout(P)}}});var L;(function(I){function b(P){return P===I.None||P===I.Cancelled||P instanceof T?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=b,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(re[126],se([0,1,23]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new R.CancellationTokenSource,b=this.task(I.token);return this.result={promise:b,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class L{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const b=JSON.stringify(I);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=L;class T{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const b=this.fn(I);return this._map.set(I,b),b}}e.CachedFunction=T}),define(re[79],se([0,1,3,2]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const L=A=>({onDidChange:R.Event.None,value:A});e.staticObservableValue=L;class T extends t.Disposable{constructor(I){super();this._value=I,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}}e.MutableObservableValue=T}),define(re[26],se([0,1,126,111]),function(Z,e,R,t){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function I(ie,...ce){return ce.length===0?ie:ie.replace(A,function(de,ve){const ge=parseInt(ve,10);return isNaN(ge)||ge<0||ge>=ce.length?de:ce[ge]})}e.format=I;const b=/{([^}]+)}/g;function P(ie,ce){return ie.replace(b,(de,ve)=>ce[ve]??de)}e.format2=P;function D(ie){return ie.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=D;function w(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function p(ie,ce){let de=0;const ve=ce.charCodeAt(0);for(let ge=ie.length-1;ge>=0;ge--)ie.charCodeAt(ge)===ve&&de++;return de}e.count=p;function E(ie,ce,de="\u2026"){return ie.length<=ce?ie:`${ie.substr(0,ce)}${de}`}e.truncate=E;function d(ie,ce=" "){const de=S(ie,ce);return y(de,ce)}e.trim=d;function S(ie,ce){if(!ie||!ce)return ie;const de=ce.length;if(de===0||ie.length===0)return ie;let ve=0;for(;ie.indexOf(ce,ve)===ve;)ve=ve+de;return ie.substring(ve)}e.ltrim=S;function y(ie,ce){if(!ie||!ce)return ie;const de=ce.length,ve=ie.length;if(de===0||ve===0)return ie;let ge=ve,we=-1;for(;we=ie.lastIndexOf(ce,ge-1),!(we===-1||we+de!==ge);){if(we===0)return"";ge=we}return ie.substring(0,ge)}e.rtrim=y;function h(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function v(ie){return ie.replace(/\*/g,"")}e.stripWildcards=v;function m(ie,ce,de={}){if(!ie)throw new Error("Cannot create regex from empty string");ce||(ie=w(ie)),de.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ve="";return de.global&&(ve+="g"),de.matchCase||(ve+="i"),de.multiline&&(ve+="m"),de.unicode&&(ve+="u"),new RegExp(ie,ve)}e.createRegExp=m;function f(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function u(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=r;function n(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=n;function i(ie){for(let ce=0,de=ie.length;ce<de;ce++){const ve=ie.charCodeAt(ce);if(ve!==32&&ve!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function a(ie,ce=0,de=ie.length){for(let ve=ce;ve<de;ve++){const ge=ie.charCodeAt(ve);if(ge!==32&&ge!==9)return ie.substring(ce,ve)}return ie.substring(ce,de)}e.getLeadingWhitespace=a;function l(ie,ce=ie.length-1){for(let de=ce;de>=0;de--){const ve=ie.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}e.lastNonWhitespaceIndex=l;function o(ie,ce,de){const ve=[];let ge=0;for(const we of ie.matchAll(ce)){if(ve.push(ie.slice(ge,we.index)),we.index===void 0)throw new Error("match.index should be defined");ge=we.index+we[0].length,ve.push(de(we[0],...we.slice(1),we.index,ie,we.groups))}return ve.push(ie.slice(ge)),Promise.all(ve).then(we=>we.join(""))}e.replaceAsync=o;function s(ie,ce){return ie<ce?-1:ie>ce?1:0}e.compare=s;function c(ie,ce,de=0,ve=ie.length,ge=0,we=ce.length){for(;de<ve&&ge<we;de++,ge++){const Le=ie.charCodeAt(de),Ae=ce.charCodeAt(ge);if(Le<Ae)return-1;if(Le>Ae)return 1}const De=ve-de,ke=we-ge;return De<ke?-1:De>ke?1:0}e.compareSubstring=c;function g(ie,ce){return C(ie,ce,0,ie.length,0,ce.length)}e.compareIgnoreCase=g;function C(ie,ce,de=0,ve=ie.length,ge=0,we=ce.length){for(;de<ve&&ge<we;de++,ge++){let Le=ie.charCodeAt(de),Ae=ce.charCodeAt(ge);if(Le===Ae)continue;if(Le>=128||Ae>=128)return c(ie.toLowerCase(),ce.toLowerCase(),de,ve,ge,we);_(Le)&&(Le-=32),_(Ae)&&(Ae-=32);const Fe=Le-Ae;if(Fe!==0)return Fe}const De=ve-de,ke=we-ge;return De<ke?-1:De>ke?1:0}e.compareSubstringIgnoreCase=C;function O(ie){return ie>=48&&ie<=57}e.isAsciiDigit=O;function _(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=_;function N(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=N;function k(ie,ce){return ie.length===ce.length&&C(ie,ce)===0}e.equalsIgnoreCase=k;function M(ie,ce){const de=ce.length;return ce.length>ie.length?!1:C(ie,ce,0,de)===0}e.startsWithIgnoreCase=M;function U(ie,ce){const de=Math.min(ie.length,ce.length);let ve;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ve)!==ce.charCodeAt(ve))return ve;return de}e.commonPrefixLength=U;function H(ie,ce){const de=Math.min(ie.length,ce.length);let ve;const ge=ie.length-1,we=ce.length-1;for(ve=0;ve<de;ve++)if(ie.charCodeAt(ge-ve)!==ce.charCodeAt(we-ve))return ve;return de}e.commonSuffixLength=H;function W(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=W;function z(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=z;function te(ie,ce){return(ie-55296<<10)+(ce-56320)+65536}e.computeCodePoint=te;function V(ie,ce,de){const ve=ie.charCodeAt(de);if(W(ve)&&de+1<ce){const ge=ie.charCodeAt(de+1);if(z(ge))return te(ve,ge)}return ve}e.getNextCodePoint=V;function G(ie,ce){const de=ie.charCodeAt(ce-1);if(z(de)&&ce>1){const ve=ie.charCodeAt(ce-2);if(W(ve))return te(ve,de)}return de}class X{constructor(ce,de=0){this._str=ce,this._len=ce.length,this._offset=de}get offset(){return this._offset}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=G(this._str,this._offset);return this._offset-=ce>=65536?2:1,ce}nextCodePoint(){const ce=V(this._str,this._len,this._offset);return this._offset+=ce>=65536?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=X;class Y{constructor(ce,de=0){this._iterator=new X(ce,de)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ce=Ee.getInstance(),de=this._iterator,ve=de.offset;let ge=ce.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const we=de.offset,De=ce.getGraphemeBreakType(de.nextCodePoint());if(ue(ge,De)){de.setOffset(we);break}ge=De}return de.offset-ve}prevGraphemeLength(){const ce=Ee.getInstance(),de=this._iterator,ve=de.offset;let ge=ce.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const we=de.offset,De=ce.getGraphemeBreakType(de.prevCodePoint());if(ue(De,ge)){de.setOffset(we);break}ge=De}return ve-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function x(ie,ce){return new Y(ie,ce).nextGraphemeLength()}e.nextCharLength=x;function B(ie,ce){return new Y(ie,ce).prevGraphemeLength()}e.prevCharLength=B;function J(ie,ce){ce>0&&z(ie.charCodeAt(ce))&&ce--;const de=ce+x(ie,ce);return[de-B(ie,de),de]}e.getCharContainingOffset=J;const F=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(ie){return F.test(ie)}e.containsRTL=$;const j=/^[\t\n\r\x20-\x7E]*$/;function K(ie){return j.test(ie)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=q;function ee(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=ee;function ne(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=ne;function oe(ie,ce){if(ie.length<ce)return ie;const de=/\b/g;let ve=0;for(;de.test(ie)&&!(ie.length-de.lastIndex<ce);)ve=de.lastIndex,de.lastIndex+=1;return ie.substring(ve).replace(/^\s/,"")}e.lcut=oe;const le=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function pe(ie){return ie&&(ie=ie.replace(le,""),ie=ie.replace(Se,""),ie=ie.replace(fe,"")),ie}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function be(ie){return Ce(ie)?ie.substr(1):ie}e.stripUTF8BOM=be;function Ie(ie,ce){if(!ie||!ce||ie.length<ce.length)return!1;const de=ce.length,ve=ie.toLowerCase();let ge=0,we=-1;for(;ge<de;){const De=ve.indexOf(ce[ge],we+1);if(De<0)return!1;we=De,ge++}return!0}e.fuzzyContains=Ie;function qe(ie,ce=!1){return ie?(ce&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=qe;function Qe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Qe;function Ke(ie,ce=1){if(ce===0)return"";let de=-1;do de=ie.indexOf(`
`,de+1),ce--;while(ce>0&&de>=0);return de===-1?ie:(ie[de-1]==="\r"&&de--,ie.substr(0,de))}e.getNLines=Ke;function Ye(ie){const ce=90-65+1;return ie=ie%(2*ce),ie<ce?String.fromCharCode(97+ie):String.fromCharCode(65+ie-ce)}e.singleLetterHash=Ye;function ae(ie){return Ee.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ae;function ue(ie,ce){return ie===0?ce!==5&&ce!==7:ie===2&&ce===3?!1:ie===4||ie===2||ie===3||ce===4||ce===2||ce===3?!0:!(ie===8&&(ce===8||ce===9||ce===11||ce===12)||(ie===11||ie===9)&&(ce===9||ce===10)||(ie===12||ie===10)&&ce===10||ce===5||ce===13||ce===7||ie===1||ie===13&&ce===14||ie===6&&ce===6)}var he;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=Pe()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const de=this._data,ve=de.length/3;let ge=1;for(;ge<=ve;)if(ce<de[3*ge])ge=2*ge;else if(ce>de[3*ge+1])ge=2*ge+1;else return de[3*ge+2];return 0}}Ee._INSTANCE=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(ie,ce){if(ie===0)return 0;const de=Re(ie,ce);if(de!==void 0)return de;const ve=new X(ce,ie);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=Ue;function Re(ie,ce){const de=new X(ce,ie);let ve=de.prevCodePoint();for(;Ne(ve)||ve===65039||ve===8419;){if(de.offset===0)return;ve=de.prevCodePoint()}if(!ne(ve))return;let ge=de.offset;return ge>0&&de.prevCodePoint()===8205&&(ge=de.offset),ge}function Ne(ie){return 127995<=ie&&ie<=127999}var _e;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.noBreakWhitespace="\xA0";class Te{constructor(ce){this.confusableDictionary=ce}static getInstance(ce){return Te.cache.get(Array.from(ce))}static getLocales(){return Te._locales.getValue()}isAmbiguous(ce){return this.confusableDictionary.has(ce)}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,L=Te,Te.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new R.LRUCachedFunction(ie=>{function ce(Ae){const Fe=new Map;for(let $e=0;$e<Ae.length;$e+=2)Fe.set(Ae[$e],Ae[$e+1]);return Fe}function de(Ae,Fe){const $e=new Map(Ae);for(const[Xe,rt]of Fe)$e.set(Xe,rt);return $e}function ve(Ae,Fe){if(!Ae)return Fe;const $e=new Map;for(const[Xe,rt]of Ae)Fe.has(Xe)&&$e.set(Xe,rt);return $e}const ge=L.ambiguousCharacterData.getValue();let we=ie.filter(Ae=>!Ae.startsWith("_")&&Ae in ge);we.length===0&&(we=["_default"]);let De;for(const Ae of we){const Fe=ce(ge[Ae]);De=ve(De,Fe)}const ke=ce(ge._common),Le=de(ke,De);return new Te(Le)}),Te._locales=new t.Lazy(()=>Object.keys(Te.ambiguousCharacterData.getValue()).filter(ie=>!ie.startsWith("_")));class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(ce){return Me.getData().has(ce)}static get codePoints(){return Me.getData()}}e.InvisibleCharacters=Me,Me._data=void 0}),define(re[42],se([0,1,12,4,26,14]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(l){return l===47||l===92}e.isPathSeparator=A;function I(l){return l.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=I;function b(l){return l.indexOf("/")===-1&&(l=I(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=b;function P(l,o=R.posix.sep){if(!l)return"";const s=l.length,c=l.charCodeAt(0);if(A(c)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let C=3;const O=C;for(;C<s&&!A(l.charCodeAt(C));C++);if(O!==C&&!A(l.charCodeAt(C+1))){for(C+=1;C<s;C++)if(A(l.charCodeAt(C)))return l.slice(0,C+1).replace(/[\\/]/g,o)}}return o}else if(h(c)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+o:l.slice(0,2);let g=l.indexOf("://");if(g!==-1){for(g+=3;g<s;g++)if(A(l.charCodeAt(g)))return l.slice(0,g+1)}return""}e.getRoot=P;function D(l){if(!t.isWindows||!l||l.length<5)return!1;let o=l.charCodeAt(0);if(o!==92||(o=l.charCodeAt(1),o!==92))return!1;let s=2;const c=s;for(;s<l.length&&(o=l.charCodeAt(s),o!==92);s++);return!(c===s||(o=l.charCodeAt(s+1),isNaN(o)||o===92))}e.isUNC=D;const w=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(l,o=t.isWindows){const s=o?w:p;return!(!l||l.length===0||/^\s+$/.test(l)||(s.lastIndex=0,s.test(l))||o&&E.test(l)||l==="."||l===".."||o&&l[l.length-1]==="."||o&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=d;function S(l,o,s){const c=l===o;return!s||c?c:!l||!o?!1:(0,L.equalsIgnoreCase)(l,o)}e.isEqual=S;function y(l,o,s,c=R.sep){if(l===o)return!0;if(!l||!o||o.length>l.length)return!1;if(s){if(!(0,L.startsWithIgnoreCase)(l,o))return!1;if(o.length===l.length)return!0;let C=o.length;return o.charAt(o.length-1)===c&&C--,l.charAt(C)===c}return o.charAt(o.length-1)!==c&&(o+=c),l.indexOf(o)===0}e.isEqualOrParent=y;function h(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=h;function v(l,o){return t.isWindows&&l.endsWith(":")&&(l+=R.sep),(0,R.isAbsolute)(l)||(l=(0,R.join)(o,l)),l=(0,R.normalize)(l),t.isWindows?(l=(0,L.rtrim)(l,R.sep),l.endsWith(":")&&(l+=R.sep)):(l=(0,L.rtrim)(l,R.sep),l||(l=R.sep)),l}e.sanitizeFilePath=v;function m(l){const o=(0,R.normalize)(l);return t.isWindows?l.length>3?!1:f(o)&&(l.length===2||o.charCodeAt(2)===92):o===R.posix.sep}e.isRootOrDriveLetter=m;function f(l,o=t.isWindows){return o?h(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(l){return f(l)?l[0]:void 0}e.getDriveLetter=u;function r(l,o,s){return o.length>l.length?-1:l===o?0:(s&&(l=l.toLowerCase(),o=o.toLowerCase()),l.indexOf(o))}e.indexOfPath=r;function n(l){const o=l.split(":");let s,c,g;for(const C of o){const O=Number(C);(0,T.isNumber)(O)?c===void 0?c=O:g===void 0&&(g=O):s=s?[s,C].join(":"):C}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:g!==void 0?g:c!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(l,o,s=8){let c="";for(let C=0;C<s;C++)c+=i.charAt(Math.floor(Math.random()*i.length));let g;return o?g=`${o}-${c}`:g=c,l?(0,R.join)(l,g):g}e.randomPath=a}),define(re[62],se([0,1,26]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return L(h,0)}e.hash=t;function L(h,v){switch(typeof h){case"object":return h===null?T(349,v):Array.isArray(h)?b(h,v):P(h,v);case"string":return I(h,v);case"boolean":return A(h,v);case"number":return T(h,v);case"undefined":return T(937,v);default:return T(617,v)}}e.doHash=L;function T(h,v){return(v<<5)-v+h|0}e.numberHash=T;function A(h,v){return T(h?433:863,v)}function I(h,v){v=T(149417,v);for(let m=0,f=h.length;m<f;m++)v=T(h.charCodeAt(m),v);return v}e.stringHash=I;function b(h,v){return v=T(104579,v),h.reduce((m,f)=>L(f,m),v)}function P(h,v){return v=T(181387,v),Object.keys(h).sort().reduce((m,f)=>(m=I(f,m),L(h[f],m)),v)}class D{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=L(v,this._value),this._value}}e.Hasher=D;var w;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(h,v,m=32){const f=m-v,u=~((1<<f)-1);return(h<<v|(u&h)>>>f)>>>0}function E(h,v=0,m=h.byteLength,f=0){for(let u=0;u<m;u++)h[v+u]=f}function d(h,v,m="0"){for(;h.length<v;)h=m+h;return h}function S(h,v=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(m=>m.toString(16).padStart(2,"0")).join(""):d((h>>>0).toString(16),v/4)}e.toHexString=S;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const m=v.length;if(m===0)return;const f=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,n,i;for(r!==0?(n=r,i=-1,r=0):(n=v.charCodeAt(0),i=0);;){let a=n;if(R.isHighSurrogate(n))if(i+1<m){const l=v.charCodeAt(i+1);R.isLowSurrogate(l)?(i++,a=R.computeCodePoint(n,l)):a=65533}else{r=n;break}else R.isLowSurrogate(n)&&(a=65533);if(u=this._push(f,u,a),i++,i<m)n=v.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(v,m,f){return f<128?v[m++]=f:f<2048?(v[m++]=192|(f&1984)>>>6,v[m++]=128|(f&63)>>>0):f<65536?(v[m++]=224|(f&61440)>>>12,v[m++]=128|(f&4032)>>>6,v[m++]=128|(f&63)>>>0):(v[m++]=240|(f&1835008)>>>18,v[m++]=128|(f&258048)>>>12,v[m++]=128|(f&4032)>>>6,v[m++]=128|(f&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=y._bigBlock32,m=this._buffDV;for(let s=0;s<64;s+=4)v.setUint32(s,m.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)v.setUint32(s,p(v.getUint32(s-12,!1)^v.getUint32(s-32,!1)^v.getUint32(s-56,!1)^v.getUint32(s-64,!1),1),!1);let f=this._h0,u=this._h1,r=this._h2,n=this._h3,i=this._h4,a,l,o;for(let s=0;s<80;s++)s<20?(a=u&r|~u&n,l=1518500249):s<40?(a=u^r^n,l=1859775393):s<60?(a=u&r|u&n|r&n,l=2400959708):(a=u^r^n,l=3395469782),o=p(f,5)+a+i+l+v.getUint32(s*4,!1)&4294967295,i=n,n=r,r=p(u,30),u=f,f=o;this._h0=this._h0+f&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(Z,e,R,t,L){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!L:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?L.call(Z,R):L?L.value=R:e.set(Z,R),R},Ge=this&&this.__classPrivateFieldGet||function(Z,e,R,t){if(R==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?t:R==="a"?t.call(Z):t?t.value:e.get(Z)};define(re[38],se([0,1,17,26]),function(Z,e,R,t){"use strict";var L,T,A,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(l,o,s){let c=l.get(o);return c===void 0&&(c=s,l.set(o,c)),c}e.getOrSet=b;function P(l){const o=[];return l.forEach((s,c)=>{o.push(`${c} => ${s}`)}),`Map(${l.size}) {${o.join(", ")}}`}e.mapToString=P;function D(l){const o=[];return l.forEach(s=>{o.push(s)}),`Set(${l.size}) {${o.join(", ")}}`}e.setToString=D;class w{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const s=o.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=w;class p{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,t.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=p;class E{constructor(o=!0,s=!0){this._splitOnBackslash=o,this._caseSensitive=s}reset(o){this._from=0,this._to=0,this._value=o,this._valueLen=o.length;for(let s=o.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let o=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,t.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var d;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(d||(d={}));class S{constructor(o,s){this._ignorePathCasing=o,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(o)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,t.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(h||(h={}));class v{constructor(o){this._iter=o}static forUris(o=()=>!1,s=()=>!1){return new v(new S(o,s))}static forPaths(o=!1){return new v(new E(void 0,!o))}static forStrings(){return new v(new w)}static forConfigKeys(){return new v(new p)}clear(){this._root=void 0}fill(o,s){if(s){const c=s.slice(0);(0,R.shuffle)(c);for(const g of c)this.set(g,o)}else{const c=o.slice(0);(0,R.shuffle)(c);for(const g of c)this.set(g[0],g[1])}}set(o,s){const c=this._iter.reset(o);let g;this._root||(this._root=new y,this._root.segment=c.value());const C=[];for(g=this._root;;){const _=c.cmp(g.segment);if(_>0)g.left||(g.left=new y,g.left.segment=c.value()),C.push([-1,g]),g=g.left;else if(_<0)g.right||(g.right=new y,g.right.segment=c.value()),C.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new y,g.mid.segment=c.value()),C.push([0,g]),g=g.mid;else break}const O=g.value;g.value=s,g.key=o;for(let _=C.length-1;_>=0;_--){const N=C[_][1];N.updateHeight();const k=N.balanceFactor();if(k<-1||k>1){const M=C[_][0],U=C[_+1][0];if(M===1&&U===1)C[_][1]=N.rotateLeft();else if(M===-1&&U===-1)C[_][1]=N.rotateRight();else if(M===1&&U===-1)N.right=C[_+1][1]=C[_+1][1].rotateRight(),C[_][1]=N.rotateLeft();else if(M===-1&&U===1)N.left=C[_+1][1]=C[_+1][1].rotateLeft(),C[_][1]=N.rotateRight();else throw new Error;if(_>0)switch(C[_-1][0]){case-1:C[_-1][1].left=C[_][1];break;case 1:C[_-1][1].right=C[_][1];break;case 0:C[_-1][1].mid=C[_][1];break}else this._root=C[0][1]}}return O}get(o){return this._getNode(o)?.value}_getNode(o){const s=this._iter.reset(o);let c=this._root;for(;c;){const g=s.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(o){const s=this._getNode(o);return!(s?.value===void 0&&s?.mid===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,s){const c=this._iter.reset(o),g=[];let C=this._root;for(;C;){const O=c.cmp(C.segment);if(O>0)g.push([-1,C]),C=C.left;else if(O<0)g.push([1,C]),C=C.right;else if(c.hasNext())c.next(),g.push([0,C]),C=C.mid;else break}if(!!C){if(s?(C.left=void 0,C.mid=void 0,C.right=void 0,C.height=1):(C.key=void 0,C.value=void 0),!C.mid&&!C.value)if(C.left&&C.right){const O=this._min(C.right),{key:_,value:N,segment:k}=O;this._delete(O.key,!1),C.key=_,C.value=N,C.segment=k}else{const O=C.left??C.right;if(g.length>0){const[_,N]=g[g.length-1];switch(_){case-1:N.left=O;break;case 0:N.mid=O;break;case 1:N.right=O;break}}else this._root=O}for(let O=g.length-1;O>=0;O--){const _=g[O][1];_.updateHeight();const N=_.balanceFactor();if(N>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),g[O][1]=_.rotateLeft()):N<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),g[O][1]=_.rotateRight()),O>0)switch(g[O-1][0]){case-1:g[O-1][1].left=g[O][1];break;case 1:g[O-1][1].right=g[O][1];break;case 0:g[O-1][1].mid=g[O][1];break}else this._root=g[0][1]}}}_min(o){for(;o.left;)o=o.left;return o}findSubstr(o){const s=this._iter.reset(o);let c=this._root,g;for(;c;){const C=s.cmp(c.segment);if(C>0)c=c.left;else if(C<0)c=c.right;else if(s.hasNext())s.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(o){const s=this._iter.reset(o);let c=this._root;for(;c;){const g=s.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(o){for(const[s,c]of this)o(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){!o||(o.left&&(yield*this._entries(o.left)),o.value&&(yield[o.key,o.value]),o.mid&&(yield*this._entries(o.mid)),o.right&&(yield*this._entries(o.right)))}_isBalanced(){const o=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:o(s.left)&&o(s.right)};return o(this._root)}}e.TernarySearchTree=v;class m{constructor(o,s){this.uri=o,this.value=s}}class f{constructor(o,s){this[L]="ResourceMap",o instanceof f?(this.map=new Map(o.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=o??f.defaultToKey)}set(o,s){return this.map.set(this.toKey(o),new m(o,s)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,s){typeof s!="undefined"&&(o=o.bind(s));for(const[c,g]of this.map)o(g.value,g.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}e.ResourceMap=f,f.defaultToKey=l=>l.toString();class u{constructor(o,s){this[T]="ResourceSet",!o||typeof o=="function"?this._map=new f(o):(this._map=new f(s),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,s){this._map.forEach((c,g)=>o.call(s,g,g,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var r;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class n{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,s=0){const c=this._map.get(o);if(!!c)return s!==0&&this.touch(c,s),c.value}set(o,s,c=0){let g=this._map.get(o);if(g)g.value=s,c!==0&&this.touch(g,c);else{switch(g={key:o,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(o,g),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const s=this._map.get(o);if(!!s)return this._map.delete(o),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,s){const c=this._state;let g=this._head;for(;g;){if(s?o.bind(s)(g.value,g.key,this):o(g.value,g.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const o=this,s=this._state;let c=this._head;const g={[Symbol.iterator](){return g},next(){if(o._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.key,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return g}values(){const o=this,s=this._state;let c=this._head;const g={[Symbol.iterator](){return g},next(){if(o._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:c.value,done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return g}entries(){const o=this,s=this._state;let c=this._head;const g={[Symbol.iterator](){return g},next(){if(o._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const C={value:[c.key,c.value],done:!1};return c=c.next,C}else return{value:void 0,done:!0}}};return g}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>o;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const s=o.next,c=o.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}o.next=void 0,o.previous=void 0,this._state++}touch(o,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(o===this._head)return;const c=o.next,g=o.previous;o===this._tail?(g.next=void 0,this._tail=g):(c.previous=g,g.next=c),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(s===2){if(o===this._tail)return;const c=o.next,g=o.previous;o===this._head?(c.previous=void 0,this._head=c):(c.previous=g,g.next=c),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((s,c)=>{o.push([c,s])}),o}fromJSON(o){this.clear();for(const[s,c]of o)this.set(s,c)}}e.LinkedMap=n;class i extends n{constructor(o,s=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,s=2){return super.get(o,s)}peek(o){return super.get(o,0)}set(o,s){return super.set(o,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class a{constructor(o){I.set(this,void 0),It(this,I,o,"f")}get size(){return Ge(this,I,"f").size}forEach(o,s){Ge(this,I,"f").forEach(o,s)}get(o){return Ge(this,I,"f").get(o)}has(o){return Ge(this,I,"f").has(o)}entries(){return Ge(this,I,"f").entries()}keys(){return Ge(this,I,"f").keys()}values(){return Ge(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Ge(this,I,"f").entries()}}e.ReadonlyMapView=a}),define(re[80],se([0,1,38]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new R.LRUCache(1e4);function L(P){return b(P,"NFC",t)}e.normalizeNFC=L;const T=new R.LRUCache(1e4);function A(P){return b(P,"NFD",T)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function b(P,D,w){if(!P)return P;const p=w.get(P);if(p)return p;let E;return I.test(P)?E=P.normalize(D):E=P,w.set(P,E),E}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(D){return A(D).replace(P,"")}}()}),define(re[81],se([0,1,26]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(t||(t={})),function(L){const T="error",A="warning",I="warn",b="info",P="ignore";function D(p){return p?R.equalsIgnoreCase(T,p)?L.Error:R.equalsIgnoreCase(A,p)||R.equalsIgnoreCase(I,p)?L.Warning:R.equalsIgnoreCase(b,p)?L.Info:L.Ignore:L.Ignore}L.fromValue=D;function w(p){switch(p){case L.Error:return T;case L.Warning:return A;case L.Info:return b;default:return P}}L.toString=w}(t||(t={})),e.default=t}),define(re[8],se([0,1,12,4]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function I(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,a){return!i&&!a?"file":i}function P(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==w&&(a=w+a):a=w;break}return a}const D="",w="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(a,l,o,s,c,g=!1){typeof a=="object"?(this.scheme=a.scheme||D,this.authority=a.authority||D,this.path=a.path||D,this.query=a.query||D,this.fragment=a.fragment||D):(this.scheme=b(a,g),this.authority=l||D,this.path=P(this.scheme,o||D),this.query=s||D,this.fragment=c||D,I(this,g))}static isUri(a){return a instanceof E?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return m(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:o,path:s,query:c,fragment:g}=a;return l===void 0?l=this.scheme:l===null&&(l=D),o===void 0?o=this.authority:o===null&&(o=D),s===void 0?s=this.path:s===null&&(s=D),c===void 0?c=this.query:c===null&&(c=D),g===void 0?g=this.fragment:g===null&&(g=D),l===this.scheme&&o===this.authority&&s===this.path&&c===this.query&&g===this.fragment?this:new S(l,o,s,c,g)}static parse(a,l=!1){const o=p.exec(a);return o?new S(o[2]||D,n(o[4]||D),n(o[5]||D),n(o[7]||D),n(o[9]||D),l):new S(D,D,D,D,D)}static file(a){let l=D;if(t.isWindows&&(a=a.replace(/\\/g,w)),a[0]===w&&a[1]===w){const o=a.indexOf(w,2);o===-1?(l=a.substring(2),a=w):(l=a.substring(2,o),a=a.substring(o)||w)}return new S("file",l,a,D,D)}static from(a){const l=new S(a.scheme,a.authority,a.path,a.query,a.fragment);return I(l,!0),l}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&a.scheme==="file"?o=E.file(R.win32.join(m(a,!0),...l)).path:o=R.posix.join(a.path,...l),a.with({path:o})}toString(a=!1){return f(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof E)return a;{const l=new S(a);return l._formatted=a.external,l._fsPath=a._sep===d?a.fsPath:null,l}}else return a}}e.URI=E;const d=t.isWindows?1:void 0;class S extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(a=!1){return a?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,a){let l,o=-1;for(let s=0;s<i.length;s++){const c=i.charCodeAt(s);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||a&&c===47)o!==-1&&(l+=encodeURIComponent(i.substring(o,s)),o=-1),l!==void 0&&(l+=i.charAt(s));else{l===void 0&&(l=i.substr(0,s));const g=y[c];g!==void 0?(o!==-1&&(l+=encodeURIComponent(i.substring(o,s)),o=-1),l+=g):o===-1&&(o=s)}}return o!==-1&&(l+=encodeURIComponent(i.substring(o))),l!==void 0?l:i}function v(i){let a;for(let l=0;l<i.length;l++){const o=i.charCodeAt(l);o===35||o===63?(a===void 0&&(a=i.substr(0,l)),a+=y[o]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function m(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,t.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=m;function f(i,a){const l=a?v:h;let o="",{scheme:s,authority:c,path:g,query:C,fragment:O}=i;if(s&&(o+=s,o+=":"),(c||s==="file")&&(o+=w,o+=w),c){let _=c.indexOf("@");if(_!==-1){const N=c.substr(0,_);c=c.substr(_+1),_=N.indexOf(":"),_===-1?o+=l(N,!1):(o+=l(N.substr(0,_),!1),o+=":",o+=l(N.substr(_+1),!1)),o+="@"}c=c.toLowerCase(),_=c.indexOf(":"),_===-1?o+=l(c,!1):(o+=l(c.substr(0,_),!1),o+=c.substr(_))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const _=g.charCodeAt(1);_>=65&&_<=90&&(g=`/${String.fromCharCode(_+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const _=g.charCodeAt(0);_>=65&&_<=90&&(g=`${String.fromCharCode(_+32)}:${g.substr(2)}`)}o+=l(g,!0)}return C&&(o+="?",o+=l(C,!1)),O&&(o+="#",o+=a?O:h(O,!1)),o}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(r)?i.replace(r,a=>u(a)):i}}),define(re[127],se([0,1,8]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(P){const D=P;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=t;function L(P){const D=[];let w;try{const p=JSON.parse(P.arguments),E=p[p.length-1];E&&E.__$stack&&(p.pop(),w=E.__$stack),D.push(...p)}catch{D.push("Unable to log remote console arguments",P.arguments)}return{args:D,stack:w}}e.parse=L;function T(P){if(typeof P!="string")return T(L(P).stack);const D=P;if(D){const w=A(D),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:R.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=T;function A(P){if(!P)return P;const D=P.indexOf(`
`);return D===-1?P:P.substring(0,D)}function I(P,D){const{args:w,stack:p}=L(P),E=typeof w[0]=="string"&&w.length===1;let d=A(p);d&&(d=`(${d.trim()})`);let S=[];if(typeof w[0]=="string"?d&&E?S=[`%c[${D}] %c${w[0]} %c${d}`,b("blue"),b(""),b("grey")]:S=[`%c[${D}] %c${w[0]}`,b("blue"),b(""),...w.slice(1)]:S=[`%c[${D}]%`,b("blue"),...w],d&&!E&&S.push(d),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,S)}e.log=I;function b(P){return`color: ${P}`}}),define(re[63],se([0,1,16,26,8]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(P){return JSON.stringify(P,I)}e.stringify=T;function A(P){let D=JSON.parse(P);return D=b(D),D}e.parse=A;function I(P,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,t.regExpFlags)(D)}:D}function b(P,D=0){if(!P||D>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return L.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof R.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let w=0;w<P.length;++w)P[w]=b(P[w],D+1);else for(const w in P)Object.hasOwnProperty.call(P,w)&&(P[w]=b(P[w],D+1))}return P}e.revive=b}),define(re[20],se([0,1,4,8]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${L.vscodeRemoteResource}`}set(b,P,D){this._hosts[b]=P,this._ports[b]=D}setConnectionToken(b,P){this._connectionTokens[b]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const P=b.authority;let D=this._hosts[P];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const w=this._ports[P],p=this._connectionTokens[P];let E=`path=${encodeURIComponent(b.path)}`;return typeof p=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:R.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${D}:${w}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new T;class A{asBrowserUri(b,P){const D=this.toUri(b,P);return D.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===L.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?D.with({scheme:L.vscodeFileResource,authority:D.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(b,P){const D=this.toUri(b,P);return D.scheme===L.vscodeFileResource?D.with({scheme:L.file,authority:D.authority!==A.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(b,P){return t.URI.isUri(b)?b:t.URI.parse(P.toUrl(b))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(re[19],se([0,1,42,20,12,4,26,8]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(E){return(0,I.uriToFsPath)(E,!0)}e.originalFSPath=b;class P{constructor(d){this._ignorePathCasing=d}compare(d,S,y=!1){return d===S?0:(0,A.compare)(this.getComparisonKey(d,y),this.getComparisonKey(S,y))}isEqual(d,S,y=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,y)===this.getComparisonKey(S,y)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,y=!1){if(d.scheme===S.scheme){if(d.scheme===t.Schemas.file)return R.isEqualOrParent(b(d),b(S),this._ignorePathCasing(d))&&d.query===S.query&&(y||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return R.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(y||d.fragment===S.fragment)}return!1}joinPath(d,...S){return I.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return L.posix.basename(d.path)}extname(d){return L.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===t.Schemas.file?S=I.URI.file(L.dirname(b(d))).path:(S=L.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===t.Schemas.file?S=I.URI.file(L.normalize(b(d))).path:S=L.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===t.Schemas.file){const v=L.relative(b(d),b(S));return T.isWindows?R.toSlashes(v):v}let y=d.path||"/";const h=S.path||"/";if(this._ignorePathCasing(d)){let v=0;for(const m=Math.min(y.length,h.length);v<m&&!(y.charCodeAt(v)!==h.charCodeAt(v)&&y.charAt(v).toLowerCase()!==h.charAt(v).toLowerCase());v++);y=h.substr(0,v)+y.substr(v)}return L.posix.relative(y,h)}resolvePath(d,S){if(d.scheme===t.Schemas.file){const y=I.URI.file(L.resolve(b(d),S));return d.with({authority:y.authority,path:y.path})}return S=R.toPosixPath(S),d.with({path:L.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=L.sep){if(d.scheme===t.Schemas.file){const y=b(d);return y.length>R.getRoot(y).length&&y[y.length-1]===S}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=L.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=L.sep){let y=!1;if(d.scheme===t.Schemas.file){const h=b(d);y=h!==void 0&&h.length===R.getRoot(h).length&&h[h.length-1]===S}else{S="/";const h=d.path;y=h.length===1&&h.charCodeAt(h.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(E=>E.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new P(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(E,d){const S=[];for(let y=0;y<E.length;y++){const h=d(E[y]);E.some((v,m)=>m===y?!1:(0,e.isEqualOrParent)(h,d(v)))||S.push(E[y])}return S}e.distinctParents=D;var w;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function d(S){const y=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(m=>{const[f,u]=m.split(":");f&&u&&y.set(f,u)});const v=S.path.substring(0,S.path.indexOf(";"));return v&&y.set(E.META_DATA_MIME,v),y}E.parseMetaData=d})(w=e.DataUri||(e.DataUri={}));function p(E,d,S){if(d){let y=E.path;return y&&y[0]!==L.posix.sep&&(y=L.posix.sep+y),E.with({scheme:S,authority:d,path:y})}return E.with({scheme:S})}e.toLocalResource=p}),define(re[6],se([0,1,23,9,3,2,19,4]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(J){return!!J&&typeof J.then=="function"}e.isThenable=b;function P(J){const F=new R.CancellationTokenSource,$=J(F.token),j=new Promise((K,q)=>{const ee=F.token.onCancellationRequested(()=>{ee.dispose(),F.dispose(),q(new t.CancellationError)});Promise.resolve($).then(ne=>{ee.dispose(),F.dispose(),K(ne)},ne=>{ee.dispose(),F.dispose(),q(ne)})});return new class{cancel(){F.cancel()}then(K,q){return j.then(K,q)}catch(K){return this.then(void 0,K)}finally(K){return j.finally(K)}}}e.createCancelablePromise=P;function D(J,F,$){return new Promise((j,K)=>{const q=F.onCancellationRequested(()=>{q.dispose(),j($)});J.then(j,K).finally(()=>q.dispose())})}e.raceCancellation=D;function w(J,F){return new Promise(($,j)=>{const K=F.onCancellationRequested(()=>{K.dispose(),j(new t.CancellationError)});J.then($,j).finally(()=>K.dispose())})}e.raceCancellationError=w;async function p(J){let F=-1;const $=J.map((K,q)=>K.then(ee=>(F=q,ee))),j=await Promise.race($);return J.forEach((K,q)=>{q!==F&&K.cancel()}),j}e.raceCancellablePromises=p;function E(J,F,$){let j;const K=setTimeout(()=>{j?.(void 0),$?.()},F);return Promise.race([J.finally(()=>clearTimeout(K)),new Promise(q=>j=q)])}e.raceTimeout=E;function d(J){return new Promise((F,$)=>{const j=J();b(j)?j.then(F,$):F(j)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then($,$).then(j)})}return new Promise(($,j)=>{this.queuedPromise.then($,j)})}return this.activePromise=F(),new Promise(($,j)=>{this.activePromise.then(K=>{this.activePromise=null,$(K)},K=>{this.activePromise=null,j(K)})})}}e.Throttler=S;class y{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=y;class h{constructor(){this.promiseMap=new Map}queue(F,$){const K=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(F)===K&&this.promiseMap.delete(F)});return this.promiseMap.set(F,K),K}}e.SequencerByKey=h;const v=(J,F)=>{let $=!0;const j=setTimeout(()=>{$=!1,F()},J);return{isTriggered:()=>$,dispose:()=>{clearTimeout(j),$=!1}}},m=J=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,J())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,$=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((K,q)=>{this.doResolve=K,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const K=this.task;return this.task=null,K()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=$===e.MicrotaskDelay?m(j):v($,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class u{constructor(F){this.delayer=new f(F),this.throttler=new S}trigger(F,$){return this.delayer.trigger(()=>this.throttler.queue(F),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class r{constructor(){this._isOpen=!1,this._promise=new Promise((F,$)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class n extends r{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function i(J,F){return F?new Promise(($,j)=>{const K=setTimeout(()=>{q.dispose(),$()},J),q=F.onCancellationRequested(()=>{clearTimeout(K),q.dispose(),j(new t.CancellationError)})}):P($=>i(J,$))}e.timeout=i;function a(J,F=0){const $=setTimeout(J,F);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=a;function l(J){const F=[];let $=0;const j=J.length;function K(){return $<j?J[$++]():null}function q(ee){ee!=null&&F.push(ee);const ne=K();return ne?ne.then(q):Promise.resolve(F)}return Promise.resolve(null).then(q)}e.sequence=l;function o(J,F=j=>!!j,$=null){let j=0;const K=J.length,q=()=>{if(j>=K)return Promise.resolve($);const ee=J[j++];return Promise.resolve(ee()).then(oe=>F(oe)?Promise.resolve(oe):q())};return q()}e.first=o;function s(J,F=j=>!!j,$=null){if(J.length===0)return Promise.resolve($);let j=J.length;const K=()=>{j=-1;for(const q of J)q.cancel?.()};return new Promise((q,ee)=>{for(const ne of J)ne.then(oe=>{--j>=0&&F(oe)?(K(),q(oe)):j===0&&q($)}).catch(oe=>{--j>=0&&(K(),ee(oe))})})}e.firstParallel=s;class c{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(F){return this._size++,new Promise(($,j)=>{this.outstandingPromises.push({factory:F,c:$,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const $=F.factory();$.then(F.c,F.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=c;class g extends c{constructor(){super(1)}}e.Queue=g;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new V;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,$=A.extUri){const j=$.getComparisonKey(F);let K=this.queues.get(j);return K||(K=new g,L.Event.once(K.onDrained)(()=>{K?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,K)),K}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class O{constructor(F,$){this._token=-1,typeof F=="function"&&typeof $=="number"&&this.setIfNotSet(F,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},$)}setIfNotSet(F,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},$))}}e.TimeoutTimer=O;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,$){this.cancel(),this._token=setInterval(()=>{F()},$)}}e.IntervalTimer=_;class N{constructor(F,$){this.timeoutToken=-1,this.runner=F,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class k{constructor(F,$){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class M extends N{constructor(F,$){super(F,$);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner?.(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class U extends T.Disposable{constructor(F,$){super();this.options=F,this.handler=$,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,I.setTimeout0)(()=>{if(F)return;const $=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(J,F)=>{const $=requestIdleCallback(J,typeof F=="number"?{timeout:F}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback($))}}}}();class H{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function W(J,F,$){let j;for(let K=0;K<$;K++)try{return await J()}catch(q){j=q,await i(F)}throw j}e.retry=W;class z{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,$,j){return this._pending={taskId:F,cancel:()=>j?.(),promise:$},$.then(()=>this.donePending(F),()=>this.donePending(F)),$}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let $,j;const K=new Promise((q,ee)=>{$=q,j=ee});this._next={run:F,promise:K,promiseResolve:$,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=z;class te{constructor(F,$=()=>Date.now()){this.interval=F,this.nowFn=$,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,$)=>{this.completeCallback=F,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise($=>{this.completeCallback(F),this.resolved=!0,$()})}error(F){return new Promise($=>{this.errorCallback(F),this.rejected=!0,$()})}cancel(){new Promise(F=>{this.errorCallback(new t.CancellationError),this.rejected=!0,F()})}}e.DeferredPromise=V;var G;(function(J){async function F(j){let K;const q=await Promise.all(j.map(ee=>ee.then(ne=>ne,ne=>{K||(K=ne)})));if(typeof K!="undefined")throw K;return q}J.settled=F;function $(j){return new Promise(async(K,q)=>{try{await j(K,q)}catch(ee){q(ee)}})}J.withAsyncBody=$})(G=e.Promises||(e.Promises={}));var X;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(X||(X={}));class Y{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const $={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(F($)),this.resolve()}catch(j){this.reject(j)}finally{$.emitOne=void 0,$.emitMany=void 0,$.reject=void 0}})}static fromArray(F){return new Y($=>{$.emitMany(F)})}static fromPromise(F){return new Y(async $=>{$.emitMany(await F)})}static fromPromises(F){return new Y(async $=>{await Promise.all(F.map(async j=>$.emitOne(await j)))})}static merge(F){return new Y(async $=>{await Promise.all(F.map(async j=>{for await(const K of j)$.emitOne(K)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,$){return new Y(async j=>{for await(const K of F)j.emitOne($(K))})}map(F){return Y.map(this,F)}static filter(F,$){return new Y(async j=>{for await(const K of F)$(K)&&j.emitOne(K)})}filter(F){return Y.filter(this,F)}static coalesce(F){return Y.filter(F,$=>!!$)}coalesce(){return Y.coalesce(this)}static async toPromise(F){const $=[];for await(const j of F)$.push(j);return $}toPromise(){return Y.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class x extends Y{constructor(F,$){super($);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=x;function B(J){const F=new R.CancellationTokenSource,$=J(F.token);return new x(F,async j=>{const K=F.token.onCancellationRequested(()=>{K.dispose(),F.dispose(),j.reject(new t.CancellationError)});try{for await(const q of $){if(F.token.isCancellationRequested)return;j.emitOne(q)}K.dispose(),F.dispose()}catch(q){K.dispose(),F.dispose(),j.reject(q)}})}e.createCancelableAsyncIterable=B}),define(re[82],se([0,1,17,6,42,38,12,4,26]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",w="[^/\\\\]",p=/\//g;function E(V,G){switch(V){case 0:return"";case 1:return`${w}*?`;default:return`(?:${D}|${w}+${D}${G?`|${D}${w}+`:""})*?`}}function d(V,G){if(!V)return[];const X=[];let Y=!1,x=!1,B="";for(const J of V){switch(J){case G:if(!Y&&!x){X.push(B),B="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":x=!0;break;case"]":x=!1;break}B+=J}return B&&X.push(B),X}e.splitGlobAware=d;function S(V){if(!V)return"";let G="";const X=d(V,e.GLOB_SPLIT);if(X.every(Y=>Y===e.GLOBSTAR))G=".*";else{let Y=!1;X.forEach((x,B)=>{if(x===e.GLOBSTAR){if(Y)return;G+=E(2,B===X.length-1)}else{let J=!1,F="",$=!1,j="";for(const K of x){if(K!=="}"&&J){F+=K;continue}if($&&(K!=="]"||!j)){let q;K==="-"?q=K:(K==="^"||K==="!")&&!j?q="^":K===e.GLOB_SPLIT?q="":q=(0,b.escapeRegExpCharacters)(K),j+=q;continue}switch(K){case"{":J=!0;continue;case"[":$=!0;continue;case"}":{G+=`(?:${d(F,",").map(ne=>S(ne)).join("|")})`,J=!1,F="";break}case"]":{G+="["+j+"]",$=!1,j="";break}case"?":G+=w;continue;case"*":G+=E(1);continue;default:G+=(0,b.escapeRegExpCharacters)(K)}}B<X.length-1&&(X[B+1]!==e.GLOBSTAR||B+2<X.length)&&(G+=D)}Y=x===e.GLOBSTAR})}return G}const y=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new T.LRUCache(1e4),n=function(){return!1},i=function(){return null};function a(V,G){if(!V)return i;let X;typeof V!="string"?X=V.pattern:X=V,X=X.trim();const Y=`${X}_${!!G.trimForExclusions}`;let x=r.get(Y);if(x)return l(x,V);let B;return y.test(X)?x=s(X.substr(4),X):(B=h.exec(o(X,G)))?x=c(B[1],X):(G.trimForExclusions?m:v).test(X)?x=g(X,G):(B=f.exec(o(X,G)))?x=C(B[1].substr(1),X,!0):(B=u.exec(o(X,G)))?x=C(B[1],X,!1):x=O(X),r.set(Y,x),l(x,V)}function l(V,G){if(typeof G=="string")return V;const X=function(Y,x){return(0,L.isEqualOrParent)(Y,G.base,!I.isLinux)?V(Y.substr(G.base.length+1),x):null};return X.allBasenames=V.allBasenames,X.allPaths=V.allPaths,X.basenames=V.basenames,X.patterns=V.patterns,X}function o(V,G){return G.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function s(V,G){return function(X,Y){return typeof X=="string"&&X.endsWith(V)?G:null}}function c(V,G){const X=`/${V}`,Y=`\\${V}`,x=function(J,F){return typeof J!="string"?null:F?F===V?G:null:J===V||J.endsWith(X)||J.endsWith(Y)?G:null},B=[V];return x.basenames=B,x.patterns=[G],x.allBasenames=B,x}function g(V,G){const X=z(V.slice(1,-1).split(",").map(F=>a(F,G)).filter(F=>F!==i),V),Y=X.length;if(!Y)return i;if(Y===1)return X[0];const x=function(F,$){for(let j=0,K=X.length;j<K;j++)if(X[j](F,$))return V;return null},B=X.find(F=>!!F.allBasenames);B&&(x.allBasenames=B.allBasenames);const J=X.reduce((F,$)=>$.allPaths?F.concat($.allPaths):F,[]);return J.length&&(x.allPaths=J),x}function C(V,G,X){const Y=A.sep===A.posix.sep,x=Y?V:V.replace(p,A.sep),B=A.sep+x,J=A.posix.sep+V;let F;return X?F=function($,j){return typeof $=="string"&&($===x||$.endsWith(B)||!Y&&($===V||$.endsWith(J)))?G:null}:F=function($,j){return typeof $=="string"&&($===x||!Y&&$===V)?G:null},F.allPaths=[(X?"*/":"./")+V],F}function O(V){try{const G=new RegExp(`^${S(V)}$`);return function(X){return G.lastIndex=0,typeof X=="string"&&G.test(X)?V:null}}catch{return i}}function _(V,G,X){return!V||typeof G!="string"?!1:N(V)(G,void 0,X)}e.match=_;function N(V,G={}){if(!V)return n;if(typeof V=="string"||k(V)){const X=a(V,G);if(X===i)return n;const Y=function(x,B){return!!X(x,B)};return X.allBasenames&&(Y.allBasenames=X.allBasenames),X.allPaths&&(Y.allPaths=X.allPaths),Y}return H(V,G)}e.parse=N;function k(V){const G=V;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.isRelativePattern=k;function M(V){return V.allBasenames||[]}e.getBasenameTerms=M;function U(V){return V.allPaths||[]}e.getPathTerms=U;function H(V,G){const X=z(Object.getOwnPropertyNames(V).map(F=>W(F,V[F],G)).filter(F=>F!==i)),Y=X.length;if(!Y)return i;if(!X.some(F=>!!F.requiresSiblings)){if(Y===1)return X[0];const F=function(K,q){let ee;for(let ne=0,oe=X.length;ne<oe;ne++){const le=X[ne](K,q);if(typeof le=="string")return le;(0,t.isThenable)(le)&&(ee||(ee=[]),ee.push(le))}return ee?(async()=>{for(const ne of ee){const oe=await ne;if(typeof oe=="string")return oe}return null})():null},$=X.find(K=>!!K.allBasenames);$&&(F.allBasenames=$.allBasenames);const j=X.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return j.length&&(F.allPaths=j),F}const x=function(F,$,j){let K,q;for(let ee=0,ne=X.length;ee<ne;ee++){const oe=X[ee];oe.requiresSiblings&&j&&($||($=(0,A.basename)(F)),K||(K=$.substr(0,$.length-(0,A.extname)(F).length)));const le=oe(F,$,K,j);if(typeof le=="string")return le;(0,t.isThenable)(le)&&(q||(q=[]),q.push(le))}return q?(async()=>{for(const ee of q){const ne=await ee;if(typeof ne=="string")return ne}return null})():null},B=X.find(F=>!!F.allBasenames);B&&(x.allBasenames=B.allBasenames);const J=X.reduce((F,$)=>$.allPaths?F.concat($.allPaths):F,[]);return J.length&&(x.allPaths=J),x}function W(V,G,X){if(G===!1)return i;const Y=a(V,X);if(Y===i)return i;if(typeof G=="boolean")return Y;if(G){const x=G.when;if(typeof x=="string"){const B=(J,F,$,j)=>{if(!j||!Y(J,F))return null;const K=x.replace("$(basename)",$),q=j(K);return(0,t.isThenable)(q)?q.then(ee=>ee?V:null):q?V:null};return B.requiresSiblings=!0,B}}return Y}function z(V,G){const X=V.filter(F=>!!F.basenames);if(X.length<2)return V;const Y=X.reduce((F,$)=>{const j=$.basenames;return j?F.concat(j):F},[]);let x;if(G){x=[];for(let F=0,$=Y.length;F<$;F++)x.push(G)}else x=X.reduce((F,$)=>{const j=$.patterns;return j?F.concat(j):F},[]);const B=function(F,$){if(typeof F!="string")return null;if(!$){let K;for(K=F.length;K>0;K--){const q=F.charCodeAt(K-1);if(q===47||q===92)break}$=F.substr(K)}const j=Y.indexOf($);return j!==-1?x[j]:null};B.basenames=Y,B.patterns=x,B.allBasenames=Y;const J=V.filter(F=>!F.basenames);return J.push(B),J}function te(V,G){return(0,R.equals)(V,G,(X,Y)=>typeof X=="string"&&typeof Y=="string"?X===Y:typeof X!="string"&&typeof Y!="string"?X.base===Y.base&&X.pattern===Y.pattern:!1)}e.patternsEquals=te}),define(re[128],se([0,1,8]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(D){return D.toJSON()}class L{constructor(w){this._uriTransformer=w}transformIncoming(w){const p=this._uriTransformer.transformIncoming(w);return p===w?w:t(R.URI.from(p))}transformOutgoing(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:t(R.URI.from(p))}transformOutgoingURI(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:R.URI.from(p)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function T(D,w,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof R.URI)return w.transformOutgoing(D);for(const E in D)if(Object.hasOwnProperty.call(D,E)){const d=T(D[E],w,p+1);d!==null&&(D[E]=d)}}return null}function A(D,w){const p=T(D,w,0);return p===null?D:p}e.transformOutgoingURIs=A;function I(D,w,p,E){if(!D||E>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?R.URI.revive(w.transformIncoming(D)):w.transformIncoming(D);for(const d in D)if(Object.hasOwnProperty.call(D,d)){const S=I(D[d],w,p,E+1);S!==null&&(D[d]=S)}}return null}function b(D,w){const p=I(D,w,!1,0);return p===null?D:p}e.transformIncomingURIs=b;function P(D,w){const p=I(D,w,!0,0);return p===null?D:p}e.transformAndReviveIncomingURIs=P}),define(re[129],se([0,1,36,9,38,31,115]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,w=0;const p=(0,R.networkInterfaces)();for(const E in p){const d=p[E];if(d)for(const{mac:S,internal:y}of d)y||(w+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(D+=1))}this._value=w>0?D/w:0}return this._value}};let I;async function b(){return I||(I=(async()=>await P()||T.generateUuid())()),I}e.getMachineId=b;async function P(){try{const D=await new Promise((p,E)=>{Z(["crypto"],p,E)}),w=(0,A.getMac)();return D.createHash("sha256").update(w,"utf8").digest("hex")}catch(D){t.onUnexpectedError(D);return}}}),define(re[27],se([0,1,54,36,267,6,42,80,12,4,19,8]),function(Z,e,R,t,L,T,A,I,b,P,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function E(U,H=p.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return H===p.UNLINK?S(U):d(U)}async function d(U){try{const H=(0,A.randomPath)((0,t.tmpdir)());try{await R.promises.rename(U,H)}catch{return S(U)}S(H).catch(W=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function S(U){return(0,L.promisify)(R.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function y(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function h(U,H){return f(await(H?v(U):(0,L.promisify)(R.readdir)(U)))}async function v(U){try{return await(0,L.promisify)(R.readdir)(U,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const H=[],W=await h(U);for(const z of W){let te=!1,V=!1,G=!1;try{const X=await e.Promises.lstat((0,b.join)(U,z));te=X.isFile(),V=X.isDirectory(),G=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}H.push({name:z,isFile:()=>te,isDirectory:()=>V,isSymbolicLink:()=>G})}return H}function m(U){return f(R.readdirSync(U))}e.readdirSync=m;function f(U){return U.map(H=>typeof H=="string"?P.isMacintosh?(0,I.normalizeNFC)(H):H:(H.name=P.isMacintosh?(0,I.normalizeNFC)(H.name):H.name,H))}async function u(U){const H=await h(U),W=[];for(const z of H)await n.existsDirectory((0,b.join)(U,z))&&W.push(z);return W}function r(U,H=1e3){return new Promise(W=>{let z=!1;const te=setInterval(()=>{z||(z=!0,R.access(U,V=>{z=!1,V&&(clearInterval(te),W(void 0))}))},H)})}e.whenDeleted=r;var n;(function(U){async function H(te){let V;try{if(V=await e.Promises.lstat(te),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(P.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw X}throw G}}U.stat=H;async function W(te){try{const{stat:V,symbolicLink:G}=await U.stat(te);return V.isFile()&&G?.dangling!==!0}catch{}return!1}U.existsFile=W;async function z(te){try{const{stat:V,symbolicLink:G}=await U.stat(te);return V.isDirectory()&&G?.dangling!==!0}catch{}return!1}U.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function a(U,H,W){return i.queueFor(w.URI.file(U),D.extUriBiasedIgnorePathCase).queue(()=>{const z=c(W);return new Promise((te,V)=>o(U,H,z,G=>G?V(G):te()))})}let l=!0;function o(U,H,W,z){if(!l)return R.writeFile(U,H,{mode:W.mode,flag:W.flag},z);R.open(U,W.flag,W.mode,(te,V)=>{if(te)return z(te);R.writeFile(V,H,G=>{if(G)return R.close(V,()=>z(G));R.fdatasync(V,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),l=!1),R.close(V,Y=>z(Y))))})})}function s(U,H,W){const z=c(W);if(!l)return R.writeFileSync(U,H,{mode:z.mode,flag:z.flag});const te=R.openSync(U,z.flag,z.mode);try{R.writeFileSync(te,H);try{R.fdatasyncSync(te)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),l=!1}}finally{R.closeSync(te)}}e.writeFileSync=s;function c(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function g(U,H){if(U!==H)try{await e.Promises.rename(U,H)}catch(W){if(U.toLowerCase()!==H.toLowerCase()&&W.code==="EXDEV"||U.endsWith("."))await C(U,H,{preserveSymlinks:!1}),await E(U,p.MOVE);else throw W}}async function C(U,H,W){return _(U,H,{root:{source:U,target:H},options:W,handledSourcePaths:new Set})}const O=511;async function _(U,H,W){if(W.handledSourcePaths.has(U))return;W.handledSourcePaths.add(U);const{stat:z,symbolicLink:te}=await n.stat(U);if(te){if(W.options.preserveSymlinks)try{return await M(U,H,W)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(te.dangling)return}return z.isDirectory()?N(U,H,z.mode&O,W):k(U,H,z.mode&O)}async function N(U,H,W,z){await e.Promises.mkdir(H,{recursive:!0,mode:W});const te=await h(U);for(const V of te)await _((0,b.join)(U,V),(0,b.join)(H,V),z)}async function k(U,H,W){await e.Promises.copyFile(U,H),await e.Promises.chmod(H,W)}async function M(U,H,W){let z=await e.Promises.readlink(U);(0,A.isEqualOrParent)(z,W.root.source,!P.isLinux)&&(z=(0,b.join)(W.root.target,z.substr(W.root.source.length+1))),await e.Promises.symlink(z,H)}e.Promises=new class{get access(){return(0,L.promisify)(R.access)}get stat(){return(0,L.promisify)(R.stat)}get lstat(){return(0,L.promisify)(R.lstat)}get utimes(){return(0,L.promisify)(R.utimes)}get read(){return(U,H,W,z,te)=>new Promise((V,G)=>{R.read(U,H,W,z,te,(X,Y,x)=>X?G(X):V({bytesRead:Y,buffer:x}))})}get readFile(){return(0,L.promisify)(R.readFile)}get write(){return(U,H,W,z,te)=>new Promise((V,G)=>{R.write(U,H,W,z,te,(X,Y,x)=>X?G(X):V({bytesWritten:Y,buffer:x}))})}get appendFile(){return(0,L.promisify)(R.appendFile)}get fdatasync(){return(0,L.promisify)(R.fdatasync)}get truncate(){return(0,L.promisify)(R.truncate)}get rename(){return(0,L.promisify)(R.rename)}get copyFile(){return(0,L.promisify)(R.copyFile)}get open(){return(0,L.promisify)(R.open)}get close(){return(0,L.promisify)(R.close)}get symlink(){return(0,L.promisify)(R.symlink)}get readlink(){return(0,L.promisify)(R.readlink)}get chmod(){return(0,L.promisify)(R.chmod)}get mkdir(){return(0,L.promisify)(R.mkdir)}get unlink(){return(0,L.promisify)(R.unlink)}get rmdir(){return(0,L.promisify)(R.rmdir)}get realpath(){return(0,L.promisify)(R.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return u}get writeFile(){return a}get rm(){return E}get move(){return g}get copy(){return C}}}),define(re[130],se([0,1,54,12,4,26,27]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(p){if(L.isLinux)return p;const E=(0,t.dirname)(p);if(p===E)return p;const d=((0,t.basename)(p)||p).toLowerCase();try{const y=(0,A.readdirSync)(E).filter(h=>h.toLowerCase()===d);if(y.length===1){const h=I(E);if(h)return(0,t.join)(h,y[0])}else if(y.length>1){const h=y.indexOf(d);if(h>=0){const v=I(E);if(v)return(0,t.join)(v,y[h])}}}catch{}return null}e.realcaseSync=I;async function b(p){if(L.isLinux)return p;const E=(0,t.dirname)(p);if(p===E)return p;const d=((0,t.basename)(p)||p).toLowerCase();try{const y=(await A.Promises.readdir(E)).filter(h=>h.toLowerCase()===d);if(y.length===1){const h=await b(E);if(h)return(0,t.join)(h,y[0])}else if(y.length>1){const h=y.indexOf(d);if(h>=0){const v=await b(E);if(v)return(0,t.join)(v,y[h])}}}catch{}return null}e.realcase=b;async function P(p){try{return await A.Promises.realpath(p)}catch{const d=w(p);return await A.Promises.access(d,R.constants.R_OK),d}}e.realpath=P;function D(p){try{return R.realpathSync(p)}catch{const d=w(p);return R.accessSync(d,R.constants.R_OK),d}}e.realpathSync=D;function w(p){return(0,T.rtrim)((0,t.normalize)(p),t.sep)}}),define(re[83],se([0,1,36,12,27]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(b||(b={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class w{constructor(u,r,n){this.exePath=u,this.displayName=r,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:f=!1}={}){return f?P===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:f=!1,findPreview:u=!1}={}){const r=p({useAlternateBitness:f});if(!r)return null;const n=t.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(n))return null;let i=-1,a=null;for(const s of await L.Promises.readdir(n)){let c=-1;if(u){const C=s.indexOf("-");if(C<0)continue;const O=s.substring(0,C);if(!T.test(O)||s.substring(C+1)!=="preview")continue;c=parseInt(O,10)}else{if(!T.test(s))continue;c=parseInt(s,10)}if(c<=i)continue;const g=t.join(n,s,"pwsh.exe");!await L.SymlinkSupport.existsFile(g)||(a=g,i=c)}if(!a)return null;const l=r.includes("x86")?" (x86)":"",o=u?" Preview":"";return new w(a,`PowerShell${o}${l}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:n}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(u))if(r.test(i)){const a=t.join(u,i,"pwsh.exe");return new w(a,n)}return null}function S(){const f=t.join(R.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function y(){const f=t.join(process.env.windir,P===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*h(){let f=await E();f&&(yield f),f=await E({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=S(),f&&(yield f),f=await E({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await E({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=y(),f&&(yield f)}async function*v(){for await(const f of h())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=v;async function m(){for await(const f of v())return f;return null}e.getFirstAvailablePowerShellInstallation=m}),define(re[131],se([0,1,48,20]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((I,b)=>{let P;const D=new Map;function w(E,d,S,y,h){const v=D.get(d);if(E===A||v){const m={name:p(S),cmd:S,pid:E,ppid:d,load:y,mem:h};D.set(E,m),E===A&&(P=m),v&&(v.children||(v.children=[]),v.children.push(m),v.children.length>1&&(v.children=v.children.sort((f,u)=>f.pid-u.pid)))}}function p(E){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,v=/--vscode-utility-kind=extensionHost/,m=/--crashes-directory/,f=/\\pipe\\winpty-control/,u=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(m.exec(E))return"electron-crash-reporter";if(f.exec(E))return"winpty-process";if(u.exec(E))return"console-window-host (Windows internal process)";let n=r.exec(E);if(n&&n.length===2){if(n[1]==="renderer")return d.exec(E)?"shared-process":S.exec(E)?"issue-reporter":y.exec(E)?"process-explorer":"window";if(n[1]==="utility"){if(h.exec(E))return"utility-network-service";if(v.exec(E))return"extension-host"}return n[1]}const i=/[a-zA-Z-]+\.js/g;let a="";do n=i.exec(E),n&&(a+=n+" ");while(n);return a&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${a}`:E}if(process.platform==="win32"){const E=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{Z(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(A,S=>{if(!S){b(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(S,y=>{const h=new Map;y.forEach(v=>{const m=E(v.commandLine||"");h.set(v.pid,{name:p(m),cmd:m,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),P=h.get(A),P?(h.forEach(v=>{const m=h.get(v.ppid);m&&(m.children||(m.children=[]),m.children.push(v))}),h.forEach(v=>{v.children&&(v.children=v.children.sort((m,f)=>m.pid-f.pid))}),I(P)):b(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let E=function(){let d=[P];const S=[];for(;d.length;){const h=d.shift();h&&(S.push(h.pid),h.children&&(d=d.concat(h.children)))}let y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Z).fsPath);y+=" "+S.join(" "),(0,R.exec)(y,{},(h,v,m)=>{if(h||m)b(h||new Error(m.toString()));else{const f=v.toString().split(`
`);for(let u=0;u<S.length;u++){const r=D.get(S[u]);r.load=parseFloat(f[u])}if(!P){b(new Error(`Root process ${A} not found`));return}I(P)}})};(0,R.exec)("which ps",{},(d,S,y)=>{if(d||y)if(process.platform!=="linux")b(d||new Error(y.toString()));else{const h=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Z).fsPath);(0,R.exec)(h,{},(v,m,f)=>{v||f?b(v||new Error(f.toString())):(T(m,w),E())})}else{const h=S.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${h} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,f,u)=>{m||u&&!u.includes("screen size is bogus")?b(m||new Error(u.toString())):(T(f,w),process.platform==="linux"?E():P?I(P):b(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,P=A.toString().split(`
`);for(const D of P){const w=b.exec(D.trim());w&&w.length===6&&I(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}});var me=this&&this.__decorate||function(Z,e,R,t){var L=arguments.length,T=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,R):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Z,e,R,t);else for(var I=Z.length-1;I>=0;I--)(A=Z[I])&&(T=(L<3?A(T):L>3?A(e,R,T):A(e,R))||T);return L>3&&T&&Object.defineProperty(e,R,T),T};define(re[39],se([0,1,17,6,16,23,60,9,3,2,63,26,14]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function d(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function y(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(h||(h={}));class v{constructor(G){this.buffer=G,this.pos=0}read(G){const X=this.buffer.slice(this.pos,this.pos+G);return this.pos+=X.byteLength,X}}class m{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(G){this.buffers.push(G)}}var f;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(f||(f={}));function u(V){const G=L.VSBuffer.alloc(4);return G.writeUInt32BE(V,0),G}function r(V){return V.read(4).readUInt32BE(0)}function n(V){const G=L.VSBuffer.alloc(1);return G.writeUInt8(V,0),G}const i={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},a=typeof Buffer!="undefined";function l(V,G){if(typeof G=="undefined")V.write(i.Undefined);else if(typeof G=="string"){const X=L.VSBuffer.fromString(G);V.write(i.String),V.write(u(X.byteLength)),V.write(X)}else if(a&&Buffer.isBuffer(G)){const X=L.VSBuffer.wrap(G);V.write(i.Buffer),V.write(u(X.byteLength)),V.write(X)}else if(G instanceof L.VSBuffer)V.write(i.VSBuffer),V.write(u(G.byteLength)),V.write(G);else if(Array.isArray(G)){V.write(i.Array),V.write(u(G.length));for(const X of G)l(V,X)}else{const X=L.VSBuffer.fromString(JSON.stringify(G));V.write(i.Object),V.write(u(X.byteLength)),V.write(X)}}function o(V){switch(V.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return V.read(r(V)).toString();case f.Buffer:return V.read(r(V)).buffer;case f.VSBuffer:return V.read(r(V));case f.Array:{const X=r(V),Y=[];for(let x=0;x<X;x++)Y.push(o(V));return Y}case f.Object:return JSON.parse(V.read(r(V)).toString())}}class s{constructor(G,X,Y=null,x=1e3){this.protocol=G,this.ctx=X,this.logger=Y,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(G,X){this.channels.set(G,X),setTimeout(()=>this.flushPendingRequests(G),0)}sendResponse(G){switch(G.type){case 200:{const X=this.send([G.type]);this.logger?.logOutgoing(X,0,1,y(G.type));return}case 201:case 202:case 204:case 203:{const X=this.send([G.type,G.id],G.data);this.logger?.logOutgoing(X,G.id,1,y(G.type),G.data);return}}}send(G,X=void 0){const Y=new m;return l(Y,G),l(Y,X),this.sendBuffer(Y.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onRawMessage(G){const X=new v(G),Y=o(X),x=o(X),B=Y[0];switch(B){case 100:return this.logger?.logIncoming(G.byteLength,Y[1],1,`${d(B)}: ${Y[2]}.${Y[3]}`,x),this.onPromise({type:B,id:Y[1],channelName:Y[2],name:Y[3],arg:x});case 102:return this.logger?.logIncoming(G.byteLength,Y[1],1,`${d(B)}: ${Y[2]}.${Y[3]}`,x),this.onEventListen({type:B,id:Y[1],channelName:Y[2],name:Y[3],arg:x});case 101:return this.logger?.logIncoming(G.byteLength,Y[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:Y[1]});case 103:return this.logger?.logIncoming(G.byteLength,Y[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:Y[1]})}}onPromise(G){const X=this.channels.get(G.channelName);if(!X){this.collectPendingRequest(G);return}const Y=new T.CancellationTokenSource;let x;try{x=X.call(this.ctx,G.name,G.arg,Y.token)}catch(F){x=Promise.reject(F)}const B=G.id;x.then(F=>{this.sendResponse({id:B,data:F,type:201}),this.activeRequests.delete(G.id)},F=>{F instanceof Error?this.sendResponse({id:B,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:B,data:F,type:203}),this.activeRequests.delete(G.id)});const J=(0,P.toDisposable)(()=>Y.cancel());this.activeRequests.set(G.id,J)}onEventListen(G){const X=this.channels.get(G.channelName);if(!X){this.collectPendingRequest(G);return}const Y=G.id,B=X.listen(this.ctx,G.name,G.arg)(J=>this.sendResponse({id:Y,data:J,type:204}));this.activeRequests.set(G.id,B)}disposeActiveRequest(G){const X=this.activeRequests.get(G.id);X&&(X.dispose(),this.activeRequests.delete(G.id))}collectPendingRequest(G){let X=this.pendingRequests.get(G.channelName);X||(X=[],this.pendingRequests.set(G.channelName,X));const Y=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.sendResponse({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:G,timeoutTimer:Y})}flushPendingRequests(G){const X=this.pendingRequests.get(G);if(X){for(const Y of X)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(G)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=s;var c;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(G,X=null){this.protocol=G,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=X}getChannel(G){const X=this;return{call(Y,x,B){return X.isDisposed?Promise.reject(I.canceled()):X.requestPromise(G,Y,x,B)},listen(Y,x){return X.isDisposed?b.Event.None:X.requestEvent(G,Y,x)}}}requestPromise(G,X,Y,x=T.CancellationToken.None){const B=this.lastRequestId++,F={id:B,type:100,channelName:G,name:X,arg:Y};if(x.isCancellationRequested)return Promise.reject(I.canceled());let $;return new Promise((K,q)=>{if(x.isCancellationRequested)return q(I.canceled());const ee=()=>{const Se=fe=>{switch(fe.type){case 201:this.handlers.delete(B),K(fe.data);break;case 202:{this.handlers.delete(B);const pe=new Error(fe.data.message);pe.stack=fe.data.stack,pe.name=fe.data.name,q(pe);break}case 203:this.handlers.delete(B),q(fe.data);break}};this.handlers.set(B,Se),this.sendRequest(F)};let ne=null;this.state===h.Idle?ee():(ne=(0,t.createCancelablePromise)(Se=>this.whenInitialized()),ne.then(()=>{ne=null,ee()}));const oe=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:B,type:101}),q(I.canceled())},le=x.onCancellationRequested(oe);$=(0,P.combinedDisposable)((0,P.toDisposable)(oe),le),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(G,X,Y){const x=this.lastRequestId++,J={id:x,type:102,channelName:G,name:X,arg:Y};let F=null;const $=new b.Emitter({onFirstListenerAdd:()=>{F=(0,t.createCancelablePromise)(K=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add($),this.sendRequest(J)})},onLastListenerRemove:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete($),this.sendRequest({id:x,type:103}))}}),j=K=>$.fire(K.data);return this.handlers.set(x,j),$.event}sendRequest(G){switch(G.type){case 100:case 102:{const X=this.send([G.type,G.id,G.channelName,G.name],G.arg);this.logger?.logOutgoing(X,G.id,0,`${d(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const X=this.send([G.type,G.id]);this.logger?.logOutgoing(X,G.id,0,d(G.type));return}}}send(G,X=void 0){const Y=new m;return l(Y,G),l(Y,X),this.sendBuffer(Y.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onBuffer(G){const X=new v(G),Y=o(X),x=o(X),B=Y[0];switch(B){case 200:return this.logger?.logIncoming(G.byteLength,0,0,y(B)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(G.byteLength,Y[1],0,y(B),x),this.onResponse({type:Y[0],id:Y[1],data:x})}}onResponse(G){if(G.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(G.id)?.(G)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}me([A.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class C{constructor(G){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,G(({protocol:X,onDidClientDisconnect:Y})=>{b.Event.once(X.onMessage)(B=>{const J=new v(B),F=o(J),$=new s(X,F),j=new g(X);this.channels.forEach((q,ee)=>$.registerChannel(ee,q));const K={channelServer:$,channelClient:j,ctx:F};this._connections.add(K),this._onDidAddConnection.fire(K),Y(()=>{$.dispose(),j.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const G=[];return this._connections.forEach(X=>G.push(X)),G}getChannel(G,X){const Y=this;return{call(x,B,J){let F;if((0,p.isFunction)(X)){const j=(0,R.getRandomElement)(Y.connections.filter(X));F=j?Promise.resolve(j):b.Event.toPromise(b.Event.filter(Y.onDidAddConnection,X))}else F=X.routeCall(Y,x,B);const $=F.then(j=>j.channelClient.getChannel(G));return _($).call(x,B,J)},listen(x,B){if((0,p.isFunction)(X))return Y.getMulticastEvent(G,X,x,B);const J=X.routeEvent(Y,x,B).then(F=>F.channelClient.getChannel(G));return _(J).listen(x,B)}}}getMulticastEvent(G,X,Y,x){const B=this;let J=new P.DisposableStore;const F=new b.Emitter({onFirstListenerAdd:()=>{J=new P.DisposableStore;const $=new b.EventMultiplexer,j=new Map,K=ee=>{const oe=ee.channelClient.getChannel(G).listen(Y,x),le=$.add(oe);j.set(ee,le)},q=ee=>{const ne=j.get(ee);!ne||(ne.dispose(),j.delete(ee))};B.connections.filter(X).forEach(K),b.Event.filter(B.onDidAddConnection,X)(K,void 0,J),B.onDidRemoveConnection(q,void 0,J),$.event(F.fire,F,J),J.add($)},onLastListenerRemove:()=>{J.dispose()}});return F.event}registerChannel(G,X){this.channels.set(G,X),this._connections.forEach(Y=>{Y.channelServer.registerChannel(G,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class O{constructor(G,X,Y=null){const x=new m;l(x,X),G.send(x.buffer),this.channelClient=new g(G,Y),this.channelServer=new s(G,X,Y)}getChannel(G){return this.channelClient.getChannel(G)}registerChannel(G,X){this.channelServer.registerChannel(G,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function _(V){return{call(G,X,Y){return V.then(x=>x.call(G,X,Y))},listen(G,X){const Y=new b.Relay;return V.then(x=>Y.input=x.listen(G,X)),Y.event}}}e.getDelayedChannel=_;function N(V){let G=!1;return{call(X,Y,x){return G?V.call(X,Y,x):(0,t.timeout)(0).then(()=>G=!0).then(()=>V.call(X,Y,x))},listen(X,Y){if(G)return V.listen(X,Y);const x=new b.Relay;return(0,t.timeout)(0).then(()=>G=!0).then(()=>x.input=V.listen(X,Y)),x.event}}}e.getNextTickChannel=N;class k{constructor(G){this.fn=G}routeCall(G){return this.route(G)}routeEvent(G){return this.route(G)}async route(G){for(const X of G.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(G.onDidAddConnection),await this.route(G)}}e.StaticRouter=k;var M;(function(V){function G(B,J){const F=B,$=J&&J.disableMarshalling,j=new Map;for(const K in F)Y(K)&&j.set(K,b.Event.buffer(F[K],!0));return new class{listen(K,q,ee){const ne=j.get(q);if(ne)return ne;if(x(q)){const oe=F[q];if(typeof oe=="function")return oe.call(F,ee)}throw new Error(`Event not found: ${q}`)}call(K,q,ee){const ne=F[q];if(typeof ne=="function"){if(!$&&Array.isArray(ee))for(let oe=0;oe<ee.length;oe++)ee[oe]=(0,D.revive)(ee[oe]);return ne.apply(F,ee)}throw new Error(`Method not found: ${q}`)}}}V.fromService=G;function X(B,J){const F=J&&J.disableMarshalling;return new Proxy({},{get($,j){if(typeof j=="string")return J?.properties?.has(j)?J.properties.get(j):x(j)?function(K){return B.listen(j,K)}:Y(j)?B.listen(j):async function(...K){let q;J&&!(0,p.isUndefinedOrNull)(J.context)?q=[J.context,...K]:q=K;const ee=await B.call(j,q);return F?ee:(0,D.revive)(ee)};throw new Error(`Property not found: ${String(j)}`)}})}V.toService=X;function Y(B){return B[0]==="o"&&B[1]==="n"&&w.isUpperAsciiLetter(B.charCodeAt(2))}function x(B){return/^onDynamic/.test(B)&&w.isUpperAsciiLetter(B.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const G=V.toString();if(G!=="[object Object]")return G}return V}function W(V){return Array.isArray(V)?V.map(H):H(V)}function z(V,G,X,Y,x,B,J){J=W(J);const F=U[x],$=F[Y%F.length];let j=[`%c[${V}]%c[${String(G).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(B)?(j=j.concat(J),j.push(")")):j.push(J),console.log.apply(console,j)}e.logWithColors=z;class te{constructor(G,X){this._outgoingPrefix=G,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(G,X,Y,x,B){this._totalOutgoing+=G,z(this._outgoingPrefix,this._totalOutgoing,G,X,Y,x,B)}logIncoming(G,X,Y,x,B){this._totalIncoming+=G,z(this._incomingPrefix,this._totalIncoming,G,X,Y,x,B)}}e.IPCLogger=te}),define(re[132],se([0,1,16,3,39]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(b){this.port=b,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",P=>R.VSBuffer.wrap(P.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(b,P){const D=new T(b);super(D,P);this.protocol=D}dispose(){this.protocol.disconnect()}}e.Client=A}),define(re[84],se([0,1,16,3,2,39]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(a){a.enableDiagnostics=!1,a.records=[];const l=new WeakMap;let o=0;function s(g,C){if(!l.has(g)){const O=String(++o);l.set(g,O)}return l.get(g)}function c(g,C,O,_){if(!a.enableDiagnostics)return;const N=s(g,C);if(_ instanceof R.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const k=R.VSBuffer.alloc(_.byteLength);k.set(_),a.records.push({timestamp:Date.now(),id:N,label:C,type:O,buff:k})}else a.records.push({timestamp:Date.now(),id:N,label:C,type:O,data:_})}a.traceSocketEvent=c})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function D(){return P||(P=R.VSBuffer.alloc(0)),P}class w{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(l){this._chunks.push(l),this._totalLength+=l.byteLength}read(l){return this._read(l,!0)}peek(l){return this._read(l,!1)}_read(l,o){if(l===0)return D();if(l>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===l){const C=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=l),C}if(this._chunks[0].byteLength>l){const C=this._chunks[0].slice(0,l);return o&&(this._chunks[0]=this._chunks[0].slice(l),this._totalLength-=l),C}const s=R.VSBuffer.alloc(l);let c=0,g=0;for(;l>0;){const C=this._chunks[g];if(C.byteLength>l){const O=C.slice(0,l);s.set(O,c),c+=l,o&&(this._chunks[g]=C.slice(l),this._totalLength-=l),l-=l}else s.set(C,c),c+=C.byteLength,o?(this._chunks.shift(),this._totalLength-=C.byteLength):g++,l-=C.byteLength}return s}}e.ChunkStream=w;var p;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume"})(p||(p={}));function E(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(l,o,s,c){this.type=l,this.id=o,this.ack=s,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends L.Disposable{constructor(l){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=l,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const s=this._state.messageType,c=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new S(s,c,g,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(l){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=l,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(l){if(this._isDisposed)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.VSBuffer.alloc(13);o.writeUInt8(l.type,0),o.writeUInt32BE(l.id,1),o.writeUInt32BE(l.ack,5),o.writeUInt32BE(l.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",l.data),this._writeSoon(o,l.data)}_bufferAdd(l,o){const s=this._totalLength===0;return this._data.push(l,o),this._totalLength+=l.byteLength+o.byteLength,s}_bufferTake(){const l=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,l}_writeSoon(l,o){this._bufferAdd(l,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const l=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this._socket.write(l)}}class v extends L.Disposable{constructor(l){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=l,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(l){this._socketWriter.write(new S(1,0,0,l))}}e.Protocol=v;class m extends T.IPCClient{constructor(l,o,s=null){super(l,o,s);this.protocol=l}static fromSocket(l,o){return new m(new v(l),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const l=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),l.end()}}e.Client=m;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(l){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(l):this._emitter.fire(l):this._bufferedMessages.push(l)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class u{constructor(l){this.data=l,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const l=[];let o=0,s=this._first;for(;s;)l[o++]=s.data,s=s.next;return l}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(l){const o=new u(l);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class n{constructor(){this.lastRuns=[];const l=Date.now();for(let o=0;o<n._HISTORY_LENGTH;o++)this.lastRuns[o]=l-1e3*o;setInterval(()=>{for(let o=n._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const l=Date.now(),o=(1+n._HISTORY_LENGTH)*1e3;let s=0;for(let c=0;c<n._HISTORY_LENGTH;c++)l-this.lastRuns[c]<=o&&s++;return 1-s/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class i{constructor(l,o=null,s=n.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=l,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const l=new S(5,0,0,D());this._socketWriter.write(l),this._socketWriter.flush()}sendPause(){const l=new S(7,0,0,D());this._socketWriter.write(l)}sendResume(){const l=new S(8,0,0,D());this._socketWriter.write(l)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(l,o){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=l,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const l=new S(3,0,this._incomingAckId,D());this._socketWriter.write(l);const o=this._outgoingUnackMsg.toArray();for(let s=0,c=o.length;s<c;s++)this._socketWriter.write(o[s]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(l){if(l.ack>this._outgoingAckId){this._outgoingAckId=l.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=l.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this._incomingMsgId)if(l.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new S(6,0,0,D())))}else this._incomingMsgId=l.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(l.data);break}case 2:{this._onControlMessage.fire(l.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let s=0,c=o.length;s<c;s++)this._socketWriter.write(o[s]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(l){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new S(1,o,this._incomingAckId,l);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(l){const o=new S(2,0,0,l);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const l=Date.now()-this._incomingMsgLastTime;if(l>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-l+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const l=this._outgoingUnackMsg.peek(),o=Date.now()-l.writtenTime,s=Date.now()-this._socketReader.lastReadTime,c=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&s>=2e4&&c>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const g=Math.max(2e4-o,2e4-s,2e4-c,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const l=new S(3,0,this._incomingAckId,D());this._socketWriter.write(l)}}e.PersistentProtocol=i}),define(re[133],se([0,1,85,3,39,132]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const b=t.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(P,D)=>D);return t.Event.map(b,P=>{const{port1:D,port2:w}=new MessageChannel,E={protocol:new T.Protocol(D),onDidClientDisconnect:t.Event.fromDOMEventEmitter(D,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",P,[w]),E})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(re[134],se([0,1,16,9,3,2,12,4,31,39,84]),function(Z,e,R,t,L,T,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:Z.__$__nodeRequire("crypto"),zlib:Z.__$__nodeRequire("zlib"),net:Z.__$__nodeRequire("net"),os:Z.__$__nodeRequire("os")}}class p{constructor(s,c=""){this.debugLabel=c,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=g=>{if(this.traceSocketEvent("error",{code:g?.code,message:g?.message}),g){if(g.code==="EPIPE")return;(0,t.onUnexpectedError)(g)}},this.socket.on("error",this._errorListener)}traceSocketEvent(s,c){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,c)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(s){const c=g=>{this.traceSocketEvent("read",g),s(R.VSBuffer.wrap(g))};return this.socket.on("data",c),{dispose:()=>this.socket.off("data",c)}}onClose(s){const c=g=>{this.traceSocketEvent("close",{hadError:g}),s({type:0,hadError:g,error:void 0})};return this.socket.on("close",c),{dispose:()=>this.socket.off("close",c)}}onEnd(s){const c=()=>{this.traceSocketEvent("nodeEndReceived"),s()};return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(s){if(!this.socket.destroyed)try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,c=>{if(c){if(c.code==="EPIPE")return;(0,t.onUnexpectedError)(c)}})}catch(c){if(c.code==="EPIPE")return;(0,t.onUnexpectedError)(c)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,c)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const g=()=>{this.socket.off("close",g),this.socket.off("end",g),this.socket.off("error",g),this.socket.off("timeout",g),this.socket.off("drain",g),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",g),this.socket.on("end",g),this.socket.on("error",g),this.socket.on("timeout",g),this.socket.on("drain",g)})}}e.NodeSocket=p;var E;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var d;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(d||(d={}));class S extends T.Disposable{constructor(s,c,g,C){super();this._onData=this._register(new L.Emitter),this._onClose=this._register(new L.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:c,inflateBytesLength:g?.byteLength||0,recordInflateBytes:C}),this._flowManager=this._register(new y(this,c,g,C,this._onData,(O,_)=>this._write(O,_))),this._register(this._flowManager.onError(O=>{console.error(O),(0,t.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new D.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(s,c){this.socket.traceSocketEvent(s,c)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this._onData.event(s)}onClose(s){return this._onClose.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this._flowManager.writeMessage(s)}_write(s,c){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let g=2;s.byteLength<126?g+=0:s.byteLength<2**16?g+=2:g+=8;const C=R.VSBuffer.alloc(g);if(c?C.writeUInt8(194,0):C.writeUInt8(130,0),s.byteLength<126)C.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){C.writeUInt8(126,1);let O=1;C.writeUInt8(s.byteLength>>>8&255,++O),C.writeUInt8(s.byteLength>>>0&255,++O)}else{C.writeUInt8(127,1);let O=1;C.writeUInt8(0,++O),C.writeUInt8(0,++O),C.writeUInt8(0,++O),C.writeUInt8(0,++O),C.writeUInt8(s.byteLength>>>24&255,++O),C.writeUInt8(s.byteLength>>>16&255,++O),C.writeUInt8(s.byteLength>>>8&255,++O),C.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(R.VSBuffer.concat([C,s]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(s){if(s.byteLength!==0){for(this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const c=this._incomingData.peek(this._state.readLen),g=c.readUInt8(0),C=(g&128)>>>7,O=(g&64)>>>6,_=c.readUInt8(1),N=(_&128)>>>7,k=_&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(k===126?2:0)+(k===127?8:0),this._state.fin=C,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(C),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const c=this._incomingData.read(this._state.readLen),g=c.readUInt8(1),C=(g&128)>>>7;let O=g&127,_=1;O===126?O=c.readUInt8(++_)*2**8+c.readUInt8(++_):O===127&&(O=c.readUInt8(++_)*0+c.readUInt8(++_)*0+c.readUInt8(++_)*0+c.readUInt8(++_)*0+c.readUInt8(++_)*2**24+c.readUInt8(++_)*2**16+c.readUInt8(++_)*2**8+c.readUInt8(++_));let N=0;C&&(N=c.readUInt8(++_)*2**24+c.readUInt8(++_)*2**16+c.readUInt8(++_)*2**8+c.readUInt8(++_)),this._state.state=3,this._state.readLen=O,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const c=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",c),m(c,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",c),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(c,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await L.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class y extends T.Disposable{constructor(s,c,g,C,O,_){super();this._tracer=s,this._onData=O,this._writeFn=_,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new L.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,c?(this._zlibInflateStream=this._register(new h(this._tracer,C,g,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}writeMessage(s){this._writeQueue.push(s),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const s=this._writeQueue.shift();if(this._zlibDeflateStream){const c=await this._deflateMessage(this._zlibDeflateStream,s);this._writeFn(c,!0)}else this._writeFn(s,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(s,c){return new Promise((g,C)=>{s.write(c),s.flush(O=>g(O))})}acceptFrame(s,c,g){this._readQueue.push({data:s,isCompressed:c,isLastFrameOfMessage:g}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const s=this._readQueue.shift();if(this._zlibInflateStream&&s.isCompressed){const c=await this._inflateFrame(this._zlibInflateStream,s.data,s.isLastFrameOfMessage);this._onData.fire(c)}else this._onData.fire(s.data)}this._isProcessingReadQueue=!1}}_inflateFrame(s,c,g){return new Promise((C,O)=>{s.write(c),g&&s.write(R.VSBuffer.fromByteArray([0,0,255,255])),s.flush(_=>C(_))})}}class h extends T.Disposable{constructor(s,c,g,C){super();this._tracer=s,this._recordInflateBytes=c,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(C),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(R.VSBuffer.wrap(O))}),g&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",g.buffer),this._zlibInflate.write(g.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}write(s){this._recordInflateBytes&&this._recordedInflateBytes.push(s.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",s),this._zlibInflate.write(s.buffer)}flush(s){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const c=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,s(c)})}}class v extends T.Disposable{constructor(s,c){super();this._tracer=s,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",g=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:g?.message,code:g?.code}),this._onError.fire(g)}),this._zlibDeflate.on("data",g=>{this._tracer.traceSocketEvent("zlibDeflateData",g),this._pendingDeflateData.push(R.VSBuffer.wrap(g))})}write(s){this._tracer.traceSocketEvent("zlibDeflateWrite",s.buffer),this._zlibDeflate.write(s.buffer)}flush(s){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let c=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,c=c.slice(0,c.byteLength-4),s(c)})}}function m(o,s){if(s===0)return;const c=o.byteLength>>>2;for(let k=0;k<c;k++){const M=o.readUInt32BE(k*4);o.writeUInt32BE(M^s,k*4)}const g=c*4,C=o.byteLength-g,O=s>>>24&255,_=s>>>16&255,N=s>>>8&255;C>=1&&o.writeUInt8(o.readUInt8(g)^O,g),C>=2&&o.writeUInt8(o.readUInt8(g+1)^_,g+1),C>=3&&o.writeUInt8(o.readUInt8(g+2)^N,g+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function u(){const o=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):s=(0,A.join)(w().os.tmpdir(),`vscode-ipc-${o}.sock`),n(s),s}e.createRandomIPCHandle=u;function r(o,s,c){const g=w().crypto.createHash("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${g}-${c}-${s}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${g.substr(0,8)}-${c}-${s}.sock`):C=(0,A.join)(o,`${c}-${s}.sock`),n(C),C}e.createStaticIPCHandle=r;function n(o){const s=f[I.platform];typeof s=="number"&&o.length>=s&&console.warn(`WARNING: IPC handle "${o}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends P.IPCServer{constructor(s){super(i.toClientConnectionEvent(s));this.server=s}static toClientConnectionEvent(s){const c=L.Event.fromNodeEventEmitter(s,"connection");return L.Event.map(c,g=>({protocol:new D.Protocol(new p(g,"ipc-server-connection")),onDidClientDisconnect:L.Event.once(L.Event.fromNodeEventEmitter(g,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function a(o){return new Promise((s,c)=>{const g=w().net.createServer();g.on("error",c),g.listen(o,()=>{g.removeListener("error",c),s(new i(g))})})}e.serve=a;function l(o,s){return new Promise((c,g)=>{const C=w().net.createConnection(o,()=>{C.removeListener("error",g),c(D.Client.fromSocket(new p(C,`ipc-client${s}`),s))});C.once("error",g)})}e.connect=l}),define(re[86],se([0,1,6,3,2,14]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function I(w){const p=w;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var b;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(b=e.StorageState||(e.StorageState={}));class P extends L.Disposable{constructor(p,E=Object.create(null)){super();this.database=p,this.options=E,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((E,d)=>this.accept(d,E)),p.deleted?.forEach(E=>this.accept(E,void 0))}accept(p,E){if(this.state===b.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(E)?d=this.cache.delete(p):this.cache.get(p)!==E&&(this.cache.set(p,E),d=!0),d&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,E){const d=this.cache.get(p);return(0,T.isUndefinedOrNull)(d)?E:d}getBoolean(p,E){const d=this.get(p);return(0,T.isUndefinedOrNull)(d)?E:d==="true"}getNumber(p,E){const d=this.get(p);return(0,T.isUndefinedOrNull)(d)?E:parseInt(d,10)}async set(p,E){if(this.state===b.Closed)return;if((0,T.isUndefinedOrNull)(E))return this.delete(p);const d=String(E);if(this.cache.get(p)!==d)return this.cache.set(p,d),this.pendingInserts.set(p,d),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===b.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((E,d)=>this.items.set(d,E)),p.delete?.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=D}),define(re[135],se([10,11]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(re[87],se([0,1,48,42,20,29,12,4,35,78,14,114,27,135]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(u,r){if(I.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};r&&(n.cwd=r);const i=R.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],n);return new Promise(a=>{i.once("error",l=>{a({success:!1,error:l})}),i.once("exit",(l,o)=>{a(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?d(n.status):1})}else if(I.isLinux||I.isMacintosh)try{const n=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{R.execFile(n,[u.pid.toString()],{encoding:"utf8",shell:!0},(a,l,o)=>{i(a?{success:!1,error:a}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function y(u=b.env){return u.comspec||"cmd.exe"}e.getWindowsShell=y;class h{constructor(r,n,i,a){if(n!==void 0&&i!==void 0&&a!==void 0)this.cmd=r,this.args=n,this.shell=i,this.options=a;else{const l=r;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(b.env).forEach(o=>{l[o]=b.env[o]}),Object.keys(this.options.env).forEach(o=>{l[o]=this.options.env[o]}),this.options.env=l}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const n=r.lastIndexOf(A.sep);return n!==-1&&(r=r.substring(n+1)),h.WellKnowCommands[r]?r:"other"}start(r){return I.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(b.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let i,a;const l=new Promise((o,s)=>{i=o,a=s});if(n){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=R.exec(o,this.options,(s,c,g)=>{this.childProcess=null;const C=s;C&&C.killed?a({killed:this.terminateRequested,stdout:c.toString(),stderr:g.toString()}):this.handleExec(i,r,s,c,g)})}else{let o=null;const s=c=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(c,i,r,a);const g={terminated:this.terminateRequested};D.isNumber(c)&&(g.cmdCode=c),i(g)};if(this.shell&&I.isWindows){const c=T.deepClone(this.options);c.windowsVerbatimArguments=!0,c.detached=!1;let g=!1,C=!1;const O=[];let _=this.ensureQuotes(this.cmd);O.push(_.value),g=_.quoted,this.args&&this.args.forEach(k=>{_=this.ensureQuotes(k),O.push(_.value),C=C&&_.quoted});const N=["/s","/c"];g?C?N.push('"'+O.join(" ")+'"'):O.length>1?N.push('"'+O[0]+'" '+O.slice(1).join(" ")):N.push('"'+O[0]+'"'):N.push(O.join(" ")),o=R.spawn(y(),N,c)}else this.cmd&&(o=R.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(D.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",c=>{this.childProcess=null,a({terminated:this.terminateRequested,error:c})}),o.pid&&(this.childProcess.on("close",s),this.handleSpawn(o,i,r,a,!0)))}return l})}handleClose(r,n,i,a){}ensureQuotes(r){return h.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,S(r,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!I.isWindows)return r(!1);const n=R.spawn(y(),["/s","/c"]);n.on("error",i=>r(!0)),n.on("exit",i=>r(!1))})}}e.AbstractProcess=h,h.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},h.regexp=/^[^"].* .*[^"]/;class v extends h{constructor(r,n,i,a){super(r,n,i,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,n,i,a,l){[a,l].forEach((o,s)=>{const c=new w.LineDecoder;c.write(o).forEach(O=>{n({line:O,source:s===0?0:1})});const C=c.end();C&&n({line:C,source:s===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,n,i,a,l){const o=new w.LineDecoder,s=new w.LineDecoder;r.stdout.on("data",c=>{o.write(c).forEach(C=>i({line:C,source:0}))}),r.stderr.on("data",c=>{s.write(c).forEach(C=>i({line:C,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=s}handleClose(r,n,i,a){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&i({line:l,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=v;function m(u){let r=[],n=!1;const i=function(a){if(n){r.push(a);return}(!u.send(a,o=>{if(o&&console.error(o),n=!1,r.length>0){const s=r.slice(0);r=[],s.forEach(c=>i(c))}})||I.isWindows)&&(n=!0)};return{send:i}}e.createQueuedSender=m;var f;(function(u){async function r(n,i,a){if(A.isAbsolute(n))return n;if(i===void 0&&(i=b.cwd()),A.dirname(n)!=="."||(a===void 0&&D.isString(b.env.PATH)&&(a=b.env.PATH.split(A.delimiter)),a===void 0||a.length===0))return A.join(i,n);async function o(s){if(await p.Promises.exists(s)){let c;try{c=await p.Promises.stat(s)}catch(g){g.message.startsWith("EACCES")&&(c=await p.Promises.lstat(s))}return c?!c.isDirectory():!1}return!1}for(const s of a){let c;if(A.isAbsolute(s)?c=A.join(s,n):c=A.join(i,s,n),await o(c))return c;let g=c+".com";if(await o(g)||(g=c+".exe",await o(g)))return g}return A.join(i,n)}u.findExecutable=r})(f=e.win32||(e.win32={}))}),define(re[136],se([0,1,36,4,83,87]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(E,d){return E===1?t.isWindows?w():T.getWindowsShell(d):P(E,d)}e.getSystemShell=A;function I(E,d){return E===1?t.isWindows?p(d):T.getWindowsShell(d):P(E,d)}e.getSystemShellSync=I;let b=null;function P(E,d){if(t.isLinux&&E===2||t.isMacintosh&&E===3)return"/bin/bash";if(!b){let S;if(t.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,R.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}b=S}return b}let D=null;async function w(){return D||(D=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),D}function p(E){if(D)return D;const d=t.isWindows&&parseFloat((0,R.release)())>=10,S=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${E.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?y:T.getWindowsShell(E)}}),define(re[64],se([0,1,48,6,16,23,127,9,3,2,29,87,78,39]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends E.ChannelServer{constructor(h){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",v=>L.VSBuffer.wrap(Buffer.from(v,"base64")))},h);process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(h,v){this.modulePath=h,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(m),this.child=null,this._client=null}getChannel(h){const v=this;return{call(m,f,u){return v.requestPromise(h,m,f,u)},listen(m,f){return v.requestEvent(h,m,f)}}}requestPromise(h,v,m,f=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(h),r=(0,t.createCancelablePromise)(a=>u.call(v,m,a)),n=f.onCancellationRequested(()=>r.cancel()),i=(0,P.toDisposable)(()=>r.cancel());return this.activeRequests.add(i),r.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(h,v,m){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let f;const u=new b.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(h).listen(v,m)(u.fire,u),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),(0,p.removeDangerousEnvVariables)(v.env),this.child=(0,R.fork)(this.modulePath,h,v);const m=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,A.isRemoteConsoleLog)(l)){(0,A.log)(l,`IPC Library: ${this.options.serverName}`);return}m.fire(L.VSBuffer.wrap(Buffer.from(l,"base64")))});const u=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,r=l=>this.child&&this.child.connected&&u.send(l.buffer.toString("base64")),n=m.event,i={send:r,onMessage:n};this._client=new E.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,o)=>{process.removeListener("exit",a),this.activeRequests.forEach(s=>(0,P.dispose)(s)),this.activeRequests.clear(),l!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:o})})}return this._client}getCachedChannel(h){let v=this.channels.get(h);return v||(v=this.client.getChannel(h),this.channels.set(h,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(re[137],se([10,11]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(re[138],se([10,11]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[139],se([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(re[140],se([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(re[141],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[142],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[143],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[144],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[145],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[146],se([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[147],se([10,11]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[148],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(re[149],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(re[150],se([10,11]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(re[151],se([10,11]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[152],se([10,11]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[153],se([10,11]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(re[154],se([10,11]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(re[155],se([10,11]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[156],se([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[157],se([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[158],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[159],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[160],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[161],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[162],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[163],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[164],se([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[88],se([0,1,61,60,20,12,35,19,8]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class P{constructor(S,y,h){this._args=S,this.paths=y,this.productService=h,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",Z).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return b.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?b.URI.file((0,T.join)(S,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,T.resolve)(S):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",Z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,T.resolve)(S):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,T.resolve)(S);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const h=A.env.VSCODE_PORTABLE;return h?(0,T.join)(h,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(y=>/^[^:/?#]+?:\/\//.test(y)?b.URI.parse(y):b.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?b.URI.parse(S):b.URI.file((0,T.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return b.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?b.URI.file((0,T.join)(S,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}me([t.memoize],P.prototype,"appRoot",null),me([t.memoize],P.prototype,"userHome",null),me([t.memoize],P.prototype,"userDataPath",null),me([t.memoize],P.prototype,"appSettingsHome",null),me([t.memoize],P.prototype,"tmpDir",null),me([t.memoize],P.prototype,"cacheHome",null),me([t.memoize],P.prototype,"stateResource",null),me([t.memoize],P.prototype,"userRoamingDataHome",null),me([t.memoize],P.prototype,"userDataSyncHome",null),me([t.memoize],P.prototype,"userDataSyncLogResource",null),me([t.memoize],P.prototype,"editSessionsLogResource",null),me([t.memoize],P.prototype,"sync",null),me([t.memoize],P.prototype,"machineSettingsResource",null),me([t.memoize],P.prototype,"workspaceStorageHome",null),me([t.memoize],P.prototype,"localHistoryHome",null),me([t.memoize],P.prototype,"keyboardLayoutResource",null),me([t.memoize],P.prototype,"argvResource",null),me([t.memoize],P.prototype,"isExtensionDevelopment",null),me([t.memoize],P.prototype,"untitledWorkspacesHome",null),me([t.memoize],P.prototype,"installSourcePath",null),me([t.memoize],P.prototype,"builtinExtensionsPath",null),me([t.memoize],P.prototype,"extensionsPath",null),me([t.memoize],P.prototype,"extensionDevelopmentLocationURI",null),me([t.memoize],P.prototype,"extensionDevelopmentKind",null),me([t.memoize],P.prototype,"extensionTestsLocationURI",null),me([t.memoize],P.prototype,"debugExtensionHost",null),me([t.memoize],P.prototype,"serviceMachineIdResource",null),me([t.memoize],P.prototype,"telemetryLogResource",null),me([t.memoize],P.prototype,"disableWorkspaceTrust",null),me([t.memoize],P.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=P;function D(d,S){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=D;function w(d,S){return E(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=w;function p(d,S){return E(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=p;function E(d,S,y,h,v,m){const u=Number(S||d)||(h?null:y),r=u?Boolean(!!S):!1;let n;if(m)try{n=JSON.parse(m)}catch{}return{port:u,break:r,debugId:v,env:n}}}),define(re[165],se([0,1,268,4,139]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(d,S,y=A){const h={},v=["_"],m=[];for(const n in S){const i=S[n];i.alias&&(h[n]=i.alias),i.type==="string"||i.type==="string[]"?(v.push(n),i.deprecates&&v.push(...i.deprecates)):i.type==="boolean"&&(m.push(n),i.deprecates&&m.push(...i.deprecates))}const f=R(d,{string:v,boolean:m,alias:h}),u={},r=f;u._=f._.map(n=>String(n)).filter(n=>n.length>0),delete r._;for(const n in S){const i=S[n];i.alias&&delete r[i.alias];let a=r[n];if(i.deprecates)for(const l of i.deprecates)r.hasOwnProperty(l)&&(a||(a=r[l],a&&y.onDeprecatedOption(l,i.deprecationMessage||(0,L.localize)(33,null,n))),delete r[l]);if(typeof a!="undefined"){if(i.type==="string[]"){if(Array.isArray(a)||(a=[a]),!i.allowEmptyValue){const l=a.filter(o=>o.length>0);l.length!==a.length&&(y.onEmptyValue(n),a=l.length>0?l:void 0)}}else i.type==="string"&&(Array.isArray(a)?(a=a.pop(),y.onMultipleValues(n,a)):!a&&!i.allowEmptyValue&&(y.onEmptyValue(n),a=void 0));u[n]=a,i.deprecationMessage&&y.onDeprecatedOption(n,i.deprecationMessage)}delete r[n]}for(const n in r)y.onUnknownOption(n);return u}e.parseArgs=I;function b(d,S){let y="";return S.args&&(Array.isArray(S.args)?y=` <${S.args.join("> <")}>`:y=` <${S.args}>`),S.alias?`-${S.alias} --${d}${y}`:`--${d}${y}`}function P(d,S){let y=0;const h=[];for(const u in d){const r=d[u],n=b(u,r);y=Math.max(y,n.length),h.push([n,r.description])}const v=y+2+1;if(S-v<25)return h.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);const m=S-v-1,f=[];for(const u of h){const r=u[0],n=w(u[1],m),i=D(v-r.length-2);f.push("  "+r+i+n[0]);for(let a=1;a<n.length;a++)f.push(D(v)+n[a])}return f}e.formatOptions=P;function D(d){return" ".repeat(d)}function w(d,S){const y=[];for(;d.length;){const h=d.length<S?d.length:d.lastIndexOf(" ",S),v=d.slice(0,h).trim();d=d.slice(h),y.push(v)}return y}function p(d,S,y,h,v){const m=process.stdout.isTTY&&process.stdout.columns||80,f=v?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",u=[`${d} ${y}`];u.push(""),u.push(`${(0,L.localize)(35,null)}: ${S} [${(0,L.localize)(36,null)}]${f}`),u.push(""),v?.noPipe!==!0&&(t.isWindows?u.push((0,L.localize)(37,null,S)):u.push((0,L.localize)(38,null,S)),u.push(""));const r={};for(const n in h){const i=h[n];if(i.description&&i.cat){let a=r[i.cat];a||(r[i.cat]=a={}),a[n]=i}}for(const n in r){const i=n,a=r[i];a&&(u.push(T[i]),u.push(...P(a,m)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=p;function E(d,S){return`${d||(0,L.localize)(39,null)}
${S||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=E}),define(re[166],se([0,1,269,140,165]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(p,E){const d={onUnknownOption:y=>{console.warn((0,t.localize)(0,null,y))},onMultipleValues:(y,h)=>{console.warn((0,t.localize)(1,null,y,h))},onEmptyValue:y=>{console.warn((0,t.localize)(2,null,y))},onDeprecatedOption:(y,h)=>{console.warn((0,t.localize)(3,null,y,h))}},S=(0,L.parseArgs)(p,L.OPTIONS,E?d:void 0);return S.goto&&S._.forEach(y=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,t.localize)(4,null))),S["max-memory"]&&R(parseInt(S["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),S}function I(p){const E=p.findIndex(d=>!/^-/.test(d));if(E>-1)return[...p.slice(0,E),...p.slice(E+1)]}function b(p){let[,...E]=p;process.env.VSCODE_DEV&&(E=I(E)||[]);const d=!w(process.env);return A(E,d)}e.parseMainProcessArgv=b;function P(p){const[,,...E]=p;return A(E,!0)}e.parseCLIProcessArgv=P;function D(p,...E){const d=p.indexOf("--");return d===-1?p.push(...E):p.splice(d,0,...E),p}e.addArg=D;function w(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Z(e,R,t,L){function T(I){const b=A(I),P=[b];return e.isAbsolute(b)||P.unshift(L),e.resolve(...P)}function A(I){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,t);const D=I["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(w,"AppData","Roaming")}break;case"darwin":P=e.join(R.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,t)}return{getUserDataPath:T}}if(typeof define=="function")define(re[167],se([0,270,36,20,19,35]),function(e,R,t,L,T,A){const I=T.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(T.joinPath(I,"package.json").fsPath);return Z(R,t,b.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),t=require("os");module.exports=Z(R,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[168],se([0,1,36,88,167]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends t.AbstractNativeEnvironmentService{constructor(I,b){super(I,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,L.getUserDataPath)(I)},b)}}e.NativeEnvironmentService=T}),define(re[169],se([0,1,8]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function P(y){const h=y.match(A);return h?h[1]:null}function D(y){if(y.indexOf("://")===-1){const h=y.match(t);return h?P(h[2]):null}try{const h=R.URI.parse(y);if(h.authority)return P(h.authority)}catch{}return null}function w(y,h){const v=new Set;let m;for(;m=I.exec(y);){const u=D(m[1]);u&&v.add(u)}const f=new Set(h);return Array.from(v).map(u=>f.has(u)?u:u.replace(b,"a"))}e.getDomainsOfRemotes=w;function p(y){const h=y.match(T);return h?h[2]:null}function E(y,h,v){return y&&h?(v&&h.endsWith(".git")&&(h=h.substr(0,h.length-4)),h.indexOf("/")===0?`${y}${h}`:`${y}/${h}`):null}function d(y,h){if(y.indexOf("://")===-1){const v=y.match(L);if(v)return E(v[2],v[3],h)}try{const v=R.URI.parse(y);if(v.authority)return E(p(v.authority),v.path,h)}catch{}return null}function S(y,h=!1){const v=[];let m;for(;m=I.exec(y);){const f=d(m[1],h);f&&v.push(f)}return v}e.getRemotes=S}),define(re[170],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,I,b){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,I,b])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class t{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(re[65],se([0,1,19,81,147,55]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function b(h){return h=h.trim(),h==="*"||A.test(h)}e.isValidVersionStr=b;function P(h){if(!b(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=h.match(A);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=P;function D(h){if(!h)return null;const v=h.majorBase,m=h.majorMustEqual,f=h.minorBase;let u=h.minorMustEqual;const r=h.patchBase;let n=h.patchMustEqual;h.hasCaret&&(v===0||(u=!1),n=!1);let i=0;if(h.preRelease){const a=I.exec(h.preRelease);if(a){const[,l,o,s]=a;i=Date.UTC(Number(l),Number(o)-1,Number(s))}}return{majorBase:v,majorMustEqual:m,minorBase:f,minorMustEqual:u,patchBase:r,patchMustEqual:n,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=D;function w(h,v,m){let f;typeof h=="string"?f=D(P(h)):f=h;let u;v instanceof Date?u=v.getTime():typeof v=="string"&&(u=new Date(v).getTime());let r;if(typeof m=="string"?r=D(P(m)):r=m,!f||!r)return!1;const n=f.majorBase,i=f.minorBase,a=f.patchBase;let l=r.majorBase,o=r.minorBase,s=r.patchBase;const c=r.notBefore;let g=r.majorMustEqual,C=r.minorMustEqual,O=r.patchMustEqual;return r.isMinimum?n>l?!0:n<l?!1:i>o?!0:i<o||u&&u<c?!1:a>=s:(n===1&&l===0&&(!g||!C||!O)&&(l=1,o=0,s=0,g=!0,C=!1,O=!1),n<l?!1:n>l?!g:i<o?!1:i>o?!C:a<s?!1:a>s?!O:!(u&&u<c))}e.isValidVersion=w;function p(h,v,m,f,u){const r=[];if(typeof f.publisher!="undefined"&&typeof f.publisher!="string")return r.push([t.default.Error,L.localize(0,null)]),r;if(typeof f.name!="string")return r.push([t.default.Error,L.localize(1,null,"name")]),r;if(typeof f.version!="string")return r.push([t.default.Error,L.localize(2,null,"version")]),r;if(!f.engines)return r.push([t.default.Error,L.localize(3,null,"engines")]),r;if(typeof f.engines.vscode!="string")return r.push([t.default.Error,L.localize(4,null,"engines.vscode")]),r;if(typeof f.extensionDependencies!="undefined"&&!y(f.extensionDependencies))return r.push([t.default.Error,L.localize(5,null,"extensionDependencies")]),r;if(typeof f.activationEvents!="undefined"){if(!y(f.activationEvents))return r.push([t.default.Error,L.localize(6,null,"activationEvents")]),r;if(typeof f.main=="undefined"&&typeof f.browser=="undefined")return r.push([t.default.Error,L.localize(7,null,"activationEvents","main")]),r}if(typeof f.extensionKind!="undefined"&&typeof f.main=="undefined"&&r.push([t.default.Warning,L.localize(8,null,"extensionKind")]),typeof f.main!="undefined"){if(typeof f.main!="string")return r.push([t.default.Error,L.localize(9,null,"main")]),r;{const a=(0,R.joinPath)(m,f.main);(0,R.isEqualOrParent)(a,m)||r.push([t.default.Warning,L.localize(10,null,a.path,m.path)])}if(typeof f.activationEvents=="undefined")return r.push([t.default.Error,L.localize(11,null,"activationEvents","main")]),r}if(typeof f.browser!="undefined"){if(typeof f.browser!="string")return r.push([t.default.Error,L.localize(12,null,"browser")]),r;{const a=(0,R.joinPath)(m,f.browser);(0,R.isEqualOrParent)(a,m)||r.push([t.default.Warning,L.localize(13,null,a.path,m.path)])}if(typeof f.activationEvents=="undefined")return r.push([t.default.Error,L.localize(14,null,"activationEvents","browser")]),r}if(!T.valid(f.version))return r.push([t.default.Error,L.localize(15,null)]),r;const n=[];if(!E(h,v,f,u,n))for(const a of n)r.push([t.default.Error,a]);return r}e.validateExtensionManifest=p;function E(h,v,m,f,u){return f||typeof m.main=="undefined"&&typeof m.browser=="undefined"?!0:S(h,v,m.engines.vscode,u)}e.isValidExtensionVersion=E;function d(h,v,m){return h==="*"||S(v,m,h)}e.isEngineValid=d;function S(h,v,m,f=[]){const u=D(P(m));if(!u)return f.push(L.localize(16,null,m)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return f.push(L.localize(17,null,m)),!1}else if(!u.majorMustEqual)return f.push(L.localize(18,null,m)),!1;return w(h,v,u)?!0:(f.push(L.localize(19,null,h,m)),!1)}function y(h){if(!Array.isArray(h))return!1;for(let v=0,m=h.length;v<m;v++)if(typeof h[v]!="string")return!1;return!0}}),define(re[49],se([0,1,16,31]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,I){let b=I&&I.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const D=(await A.readFile(T.serviceMachineIdResource)).value.toString();b=(0,t.isUUID)(D)?D:null}catch{b=null}if(!b){b=(0,t.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(b))}catch{}}return I?.store("storage.serviceMachineId",b,-1,1),b}e.getServiceMachineId=L}),define(re[56],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(re[89],se([0,1,56]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function L(A,I,b){I instanceof R.SyncDescriptor||(I=new R.SyncDescriptor(I,[],b)),t.push([A,I])}e.registerSingleton=L;function T(){return t}e.getSingletonServiceDescriptors=T}),define(re[171],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=R;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const I=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(A);I.outgoing.set(this._hashFn(A),b),b.incoming.set(this._hashFn(T),I)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(const I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let I=this._nodes.get(A);return I||(I=new R(T),this._nodes.set(A,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[A,I]of this._nodes)T.push(`${A}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this._nodes){const I=new Set([T]),b=this._findCycle(A,I);if(b)return b}}_findCycle(T,A){for(const[I,b]of T.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const P=this._findCycle(b,A);if(P)return P;A.delete(I)}}}e.Graph=t}),define(re[5],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(R=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function t(A,I,b){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:A,index:b}):(I[R.DI_DEPENDENCIES]=[{id:A,index:b}],I[R.DI_TARGET]=I)}function L(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const I=function(b,P,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,b,D)};return I.toString=()=>A,R.serviceIds.set(A,I),I}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(re[172],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(re[18],se([0,1,14,8,5]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=T;function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||R.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function P(h,v){const m=Object.create(null);for(const f in h)D(m,f,h[f],v);return m}e.toValuesTree=P;function D(h,v,m,f){const u=v.split("."),r=u.pop();let n=h;for(let i=0;i<u.length;i++){const a=u[i];let l=n[a];switch(typeof l){case"undefined":l=n[a]=Object.create(null);break;case"object":break;default:f(`Ignoring ${v} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(l)}`);return}n=l}if(typeof n=="object"&&n!==null)try{n[r]=m}catch{f(`Ignoring ${v} as ${u.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${v} as ${u.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=D;function w(h,v){const m=v.split(".");p(h,m)}e.removeFromValueTree=w;function p(h,v){const m=v.shift();if(v.length===0){delete h[m];return}if(Object.keys(h).indexOf(m)!==-1){const f=h[m];typeof f=="object"&&!Array.isArray(f)&&(p(f,v),Object.keys(f).length===0&&delete h[m])}}function E(h,v,m){function f(n,i){let a=n;for(const l of i){if(typeof a!="object"||a===null)return;a=a[l]}return a}const u=v.split("."),r=f(h,u);return typeof r=="undefined"?m:r}e.getConfigurationValue=E;function d(h,v,m){Object.keys(v).forEach(f=>{f!=="__proto__"&&(f in h?R.isObject(h[f])&&R.isObject(v[f])?d(h[f],v[f],m):m&&(h[f]=v[f]):h[f]=v[f])})}e.merge=d;function S(h,v,m){const f=h.inspect(v),u=h.inspect(m);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:f.defaultValue}e.getMigratedSettingValue=S;function y(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(re[173],se([0,1,4,26,5]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",R.isMacintosh),T.set("isLinux",R.isLinux),T.set("isWindows",R.isWindows),T.set("isWeb",R.isWeb),T.set("isMacNative",R.isMacintosh&&!R.isWeb),T.set("isEdge",R.isEdge),T.set("isFirefox",R.isFirefox),T.set("isChrome",R.isChrome),T.set("isSafari",R.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(k){return E.create(k)}static equals(k,M){return d.create(k,M)}static notEquals(k,M){return h.create(k,M)}static regex(k,M){return i.create(k,M)}static in(k,M){return S.create(k,M)}static not(k){return v.create(k)}static and(...k){return o.create(k,null)}static or(...k){return s.create(k,null,!0)}static greater(k,M){return f.create(k,M)}static greaterEquals(k,M){return u.create(k,M)}static smaller(k,M){return r.create(k,M)}static smallerEquals(k,M){return n.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){const U=k.split("||");return s.create(U.map(H=>this._deserializeAndExpression(H,M)),null,!0)}static _deserializeAndExpression(k,M){const U=k.split("&&");return o.create(U.map(H=>this._deserializeOne(H,M)),null)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){const U=k.split("!=");return h.create(U[0].trim(),this._deserializeValue(U[1],M))}if(k.indexOf("==")>=0){const U=k.split("==");return d.create(U[0].trim(),this._deserializeValue(U[1],M))}if(k.indexOf("=~")>=0){const U=k.split("=~");return i.create(U[0].trim(),this._deserializeRegexValue(U[1],M))}if(k.indexOf(" in ")>=0){const U=k.split(" in ");return S.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const U=k.split(">=");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const U=k.split(">");return f.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const U=k.split("<=");return n.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const U=k.split("<");return r.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(k)?v.create(k.substr(1).trim()):E.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const U=/^'([^']*)'$/.exec(k);return U?U[1].trim():k}static _deserializeRegexValue(k,M){if((0,t.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const U=k.indexOf("/"),H=k.lastIndexOf("/");if(U===H||U<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const W=k.slice(U+1,H),z=k[H+1]==="i"?"i":"";try{return new RegExp(W,z)}catch(te){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${te}`);return console.warn(`bad regexp-value '${k}', parse error: ${te}`),null}}}e.ContextKeyExpr=b;function P(N,k){const M=N?N.substituteConstants():void 0,U=k?k.substituteConstants():void 0;return!M&&!U?!0:!M||!U?!1:M.equals(U)}e.expressionsAreEqualWithConstantSubstitution=P;function D(N,k){return N.cmp(k)}class w{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class p{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class E{constructor(k,M){this.key=k,this.negated=M,this.type=2}static create(k,M=null){const U=T.get(k);return typeof U=="boolean"?U?p.INSTANCE:w.INSTANCE:new E(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:g(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?p.INSTANCE:w.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class d{constructor(k,M,U){this.key=k,this.value=M,this.negated=U,this.type=4}static create(k,M,U=null){if(typeof M=="boolean")return M?E.create(k,U):v.create(k,U);const H=T.get(k);return typeof H=="boolean"?M===(H?"true":"false")?p.INSTANCE:w.INSTANCE:new d(k,M,U)}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?p.INSTANCE:w.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class S{constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}static create(k,M){return new S(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),U=k.getValue(this.key);return Array.isArray(M)?M.includes(U):typeof U=="string"&&typeof M=="object"&&M!==null?A.call(M,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this)),this.negated}}e.ContextKeyInExpr=S;class y{constructor(k){this._actual=k,this.type=11}static create(k){return new y(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new y(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=y;class h{constructor(k,M,U){this.key=k,this.value=M,this.negated=U,this.type=5}static create(k,M,U=null){if(typeof M=="boolean")return M?v.create(k,U):E.create(k,U);const H=T.get(k);return typeof H=="boolean"?M===(H?"true":"false")?w.INSTANCE:p.INSTANCE:new h(k,M,U)}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?w.INSTANCE:p.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class v{constructor(k,M){this.key=k,this.negated=M,this.type=3}static create(k,M=null){const U=T.get(k);return typeof U=="boolean"?U?w.INSTANCE:p.INSTANCE:new v(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:g(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?w.INSTANCE:p.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function m(N,k){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?k(N):w.INSTANCE}class f{constructor(k,M,U){this.key=k,this.value=M,this.negated=U,this.type=12}static create(k,M,U=null){return m(M,H=>new f(k,H,U))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class u{constructor(k,M,U){this.key=k,this.value=M,this.negated=U,this.type=13}static create(k,M,U=null){return m(M,H=>new u(k,H,U))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class r{constructor(k,M,U){this.key=k,this.value=M,this.negated=U,this.type=14}static create(k,M,U=null){return m(M,H=>new r(k,H,U))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class n{constructor(k,M,U){this.key=k,this.value=M,this.negated=U,this.type=15}static create(k,M,U=null){return m(M,H=>new n(k,H,U))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class i{constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}static create(k,M){return new i(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",U=k.regexp?k.regexp.source:"";return M<U?-1:M>U?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",U=k.regexp?k.regexp.source:"";return this.key===k.key&&M===U}return!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class a{constructor(k){this._actual=k,this.type=8}static create(k){return new a(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new a(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function l(N){let k=null;for(let M=0,U=N.length;M<U;M++){const H=N[M].substituteConstants();if(N[M]!==H&&k===null){k=[];for(let W=0;W<M;W++)k[W]=N[W]}k!==null&&(k[M]=H)}return k===null?N:k}class o{constructor(k,M){this.expr=k,this.negated=M,this.type=6}static create(k,M){return o._normalizeArr(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const H=D(this.expr[M],k.expr[M]);if(H!==0)return H}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=l(this.expr);return k===this.expr?this:o.create(k,this.negated)}evaluate(k){for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M){const U=[];let H=!1;for(const W of k)if(!!W){if(W.type===1){H=!0;continue}if(W.type===0)return w.INSTANCE;if(W.type===6){U.push(...W.expr);continue}U.push(W)}if(U.length===0&&H)return p.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(D);for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];for(;U.length>1;){const W=U[U.length-1];if(W.type!==9)break;U.pop();const z=U.pop(),te=U.length===0,V=s.create(W.expr.map(G=>o.create([G,z],null)),null,te);V&&(U.push(V),U.sort(D))}return U.length===1?U[0]:new o(U,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new o(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());this.negated=s.create(k,this,!0)}return this.negated}}class s{constructor(k,M){this.expr=k,this.negated=M,this.type=9}static create(k,M,U){return s._normalizeArr(k,M,U)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const H=D(this.expr[M],k.expr[M]);if(H!==0)return H}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=l(this.expr);return k===this.expr?this:s.create(k,this.negated,!1)}evaluate(k){for(let M=0,U=this.expr.length;M<U;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,U){let H=[],W=!1;if(k){for(let z=0,te=k.length;z<te;z++){const V=k[z];if(!!V){if(V.type===0){W=!0;continue}if(V.type===1)return p.INSTANCE;if(V.type===9){H=H.concat(V.expr);continue}H.push(V)}}if(H.length===0&&W)return w.INSTANCE;H.sort(D)}if(H.length!==0){if(H.length===1)return H[0];for(let z=1;z<H.length;z++)H[z-1].equals(H[z])&&(H.splice(z,1),z--);if(H.length===1)return H[0];if(U){for(let z=0;z<H.length;z++)for(let te=z+1;te<H.length;te++)O(H[z],H[te])&&(H.splice(te,1),te--);if(H.length===1)return H[0]}return new s(H,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const M of this.expr)k.push(...M.keys());return k}map(k){return new s(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(const M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),U=k.shift(),H=[];for(const z of _(M))for(const te of _(U))H.push(o.create([z,te],null));const W=k.length===0;k.unshift(s.create(H,null,W))}this.negated=k[0]}return this.negated}}class c extends E{constructor(k,M,U){super(k,null);this._defaultValue=M,typeof U=="object"?c._info.push({...U,key:k}):U!==!0&&c._info.push({key:k,description:U,type:M!=null?typeof M:void 0})}static all(){return c._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return d.create(this.key,k)}notEqualsTo(k){return h.create(this.key,k)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(N,k){return N<k?-1:N>k?1:0}function C(N,k,M,U){return N<M?-1:N>M?1:k<U?-1:k>U?1:0}function O(N,k){if(k.type===6&&N.type!==9&&N.type!==6){for(const H of k.expr)if(N.equals(H))return!0}const M=N.negate(),U=_(M).concat(_(k));U.sort(D);for(let H=0;H<U.length;H++){const z=U[H].negate();for(let te=H+1;te<U.length;te++){const V=U[te];if(z.equals(V))return!0}}return!1}e.implies=O;function _(N){return N.type===9?N.expr:[N]}}),define(re[90],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function t(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=t;class L{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=L}),define(re[91],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(re[15],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(re[30],se([0,1,142,5]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function L(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function T(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(h,v){switch(h){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function I(h,v){return v==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function b(h,v,m){return I(v,m)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===m?!0:P(m).includes(h)}e.isTargetPlatformCompatible=b;function P(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D;var w;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var E;(function(h){h.Install="install",h.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var S;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(v,m){super(v);this.code=m,this.name=m}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(re[174],se([0,1,3,2,63,29,8,128,30]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(y,h){return A.URI.revive(h?h.transformIncoming(y):y)}function D(y,h){return h?h.transformOutgoingURI(y):y}function w(y,h){h=h||I.DefaultURITransformer;const v=y.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...y,manifest:void 0},h),manifest:v}}function p(y,h){return h?(0,T.cloneAndChange)(y,v=>v instanceof A.URI?h.transformOutgoingURI(v):void 0):y}class E{constructor(h,v){this.service=h,this.getUriTransformer=v,this.onInstallExtension=R.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(h.onDidUninstallExtension,!0)}listen(h,v){const m=this.getUriTransformer(h);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,f=>f.map(u=>({...u,local:u.local?p(u.local,m):u.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(h,v,m){const f=this.getUriTransformer(h);switch(v){case"zip":return this.service.zip(w(m[0],f)).then(u=>D(u,f));case"unzip":return this.service.unzip(P(m[0],f));case"install":return this.service.install(P(m[0],f),(0,L.revive)(m[1]));case"getManifest":return this.service.getManifest(P(m[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(m[0]);case"installFromGallery":return this.service.installFromGallery(m[0],(0,L.revive)(m[1]));case"uninstall":return this.service.uninstall(w(m[0],f),(0,L.revive)(m[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(w(m[0],f));case"getInstalled":return this.service.getInstalled(m[0],A.URI.revive(m[1])).then(u=>u.map(r=>p(r,f)));case"getMetadata":return this.service.getMetadata(w(m[0],f));case"updateMetadata":return this.service.updateMetadata(w(m[0],f),m[1]).then(u=>p(u,f));case"updateExtensionScope":return this.service.updateExtensionScope(w(m[0],f),m[1]).then(u=>p(u,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=E;class d extends t.Disposable{constructor(h){super();this.channel=h,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(v=>this._onInstallExtension.fire({identifier:v.identifier,source:this.isUriComponents(v.source)?A.URI.revive(v.source):v.source,profileLocation:A.URI.revive(v.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(v=>this._onDidInstallExtensions.fire(v.map(m=>({...m,local:m.local?w(m.local,null):m.local,source:this.isUriComponents(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(v=>this._onUninstallExtension.fire({identifier:v.identifier,profileLocation:A.URI.revive(v.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(v=>this._onDidUninstallExtension.fire({...v,profileLocation:A.URI.revive(v.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const v=await this.getTargetPlatform();return h.allTargetPlatforms.some(m=>(0,b.isTargetPlatformCompatible)(m,h.allTargetPlatforms,v))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(v=>A.URI.revive(v)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,v){return Promise.resolve(this.channel.call("install",[h,v])).then(m=>w(m,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,v){return Promise.resolve(this.channel.call("installFromGallery",[h,v])).then(m=>w(m,null))}uninstall(h,v){return Promise.resolve(this.channel.call("uninstall",[h,v]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h]))}getInstalled(h=null,v){return Promise.resolve(this.channel.call("getInstalled",[h,v])).then(m=>m.map(f=>w(f,null)))}getMetadata(h){return Promise.resolve(this.channel.call("getMetadata",[h]))}updateMetadata(h,v){return Promise.resolve(this.channel.call("updateMetadata",[h,v])).then(m=>w(m,null))}updateExtensionScope(h,v){return Promise.resolve(this.channel.call("updateExtensionScope",[h,v])).then(m=>w(m,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class S{constructor(h){this.service=h}listen(h,v){throw new Error("Invalid listen")}call(h,v,m){switch(v){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(re[92],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[13],se([0,1,38,12,26,14,8,149,5]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function P(z){return z.create===!0}e.isFileOpenForWriteOptions=P;var D;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var w;(function(z){z[z.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var p;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=E;function d(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=d;function S(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=S;function y(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function h(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=h;function v(z){return E(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var m;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(te,V){super(te);this.code=V}}e.FileSystemProviderError=f;function u(z,te){const V=new f(z.toString(),te);return n(V,te),V}e.createFileSystemProviderError=u;function r(z){return z||u((0,I.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=r;function n(z,te){return z.name=te?`${te} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=n;function i(z){if(!z)return m.Unknown;if(z instanceof f)return z.code;const te=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!te)return m.Unknown;switch(te[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=i;function a(z){if(z instanceof C)return z.fileOperationResult;switch(i(z)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var l;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class o{constructor(te,V,G){this.resource=te,this.operation=V,this.target=G}isOperation(te){return this.operation===te}}e.FileOperationEvent=o;var s;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(te,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=te;const G=new Map;for(const X of te){const Y=G.get(X.type);switch(Y?Y.push([X.resource,X]):G.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,Y]of G)switch(X){case 1:this.added=R.TernarySearchTree.forUris(()=>V),this.added.fill(Y);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>V),this.updated.fill(Y);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>V),this.deleted.fill(Y);break}}contains(te,...V){return this.doContains(te,{includeChildren:!1},...V)}affects(te,...V){return this.doContains(te,{includeChildren:!0},...V)}doContains(te,V,...G){if(!te)return!1;const X=G.length>0;return!!((!X||G.includes(1))&&(this.added?.get(te)||V.includeChildren&&this.added?.findSuperstr(te))||(!X||G.includes(0))&&(this.updated?.get(te)||V.includeChildren&&this.updated?.findSuperstr(te))||(!X||G.includes(2))&&(this.deleted?.findSubstr(te)||V.includeChildren&&this.deleted?.findSuperstr(te)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function g(z,te,V){return!z||!te||z===te||te.length>z.length?!1:(te.charAt(te.length-1)!==t.sep&&(te+=t.sep),V?(0,L.startsWithIgnoreCase)(z,te):z.indexOf(te)===0)}e.isParent=g;class C extends Error{constructor(te,V,G){super(te);this.fileOperationResult=V,this.options=G}}e.FileOperationError=C;class O extends C{constructor(te,V,G){super(te,2,G);this.stat=V}}e.NotModifiedSinceFileOperationError=O;var _;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=k;async function M(z,te){if(!te.hasProvider(A.URI.from({scheme:z.scheme})))return new Promise(V=>{const G=te.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===z.scheme&&X.added&&(G.dispose(),V())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(te){return(0,T.isNumber)(te)||(te=0),te<U.KB?(0,I.localize)(1,null,te.toFixed(0)):te<U.MB?(0,I.localize)(2,null,(te/U.KB).toFixed(2)):te<U.GB?(0,I.localize)(3,null,(te/U.MB).toFixed(2)):te<U.TB?(0,I.localize)(4,null,(te/U.GB).toFixed(2)):(0,I.localize)(5,null,(te/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var H;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function W(z){return{maxFileSize:z===0?300*U.MB:16*U.GB,maxHeapSize:z===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=W});var Q=this&&this.__param||function(Z,e){return function(R,t){e(R,t,Z)}};define(re[175],se([0,1,176,41,13]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(I){this.fileService=I}async checksum(I){const b=(await this.fileService.readFileStream(I)).value;return new Promise((P,D)=>{const w=(0,R.createHash)("md5");(0,t.listenStream)(b,{onData:p=>w.update(p.buffer),onError:p=>D(p),onEnd:()=>P(w.digest("base64").replace(/=+$/,""))})})}};T=me([Q(0,L.IFileService)],T),e.ChecksumService=T}),define(re[177],se([0,1,16,37,9,3,2,41,8,31,13]),function(Z,e,R,t,L,T,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends A.Disposable{constructor(E,d){super();this.channel=E,this.extraCapabilities=d,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(E){return this.channel.call("stat",[E])}readdir(E){return this.channel.call("readdir",[E])}async readFile(E,d){const{buffer:S}=await this.channel.call("readFile",[E,d]);return S}readFileStream(E,d,S){const y=(0,I.newWriteableStream)(v=>R.VSBuffer.concat(v.map(m=>R.VSBuffer.wrap(m))).buffer),h=this.channel.listen("readFileStream",[E,d])(v=>{if(v instanceof R.VSBuffer)y.write(v.buffer);else{if(v==="end")y.end();else{let m=v;m instanceof Error||(m=(0,D.createFileSystemProviderError)((0,t.toErrorMessage)(m),D.FileSystemProviderErrorCode.Unknown)),y.error(m),y.end()}h.dispose()}});return S.onCancellationRequested(()=>{y.error((0,L.canceled)()),y.end(),h.dispose()}),y}writeFile(E,d,S){return this.channel.call("writeFile",[E,R.VSBuffer.wrap(d),S])}open(E,d){return this.channel.call("open",[E,d])}close(E){return this.channel.call("close",[E])}async read(E,d,S,y,h){const[v,m]=await this.channel.call("read",[E,d,h]);return S.set(v.buffer.slice(0,m),y),m}write(E,d,S,y,h){return this.channel.call("write",[E,d,R.VSBuffer.wrap(S),y,h])}mkdir(E){return this.channel.call("mkdir",[E])}delete(E,d){return this.channel.call("delete",[E,d])}rename(E,d,S){return this.channel.call("rename",[E,d,S])}copy(E,d,S){return this.channel.call("copy",[E,d,S])}cloneFile(E,d){return this.channel.call("cloneFile",[E,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(E=>{if(Array.isArray(E)){const d=E;this._onDidChange.fire(d.map(S=>({resource:b.URI.revive(S.resource),type:S.type})))}else{const d=E;this._onDidWatchError.fire(d)}}))}watch(E,d){const S=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,S,E,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=w}),define(re[93],se([0,1,16,9,150,13]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(D,w,p,E,d,S){let y;try{await I(D,w,p,E,d,S)}catch(h){y=h}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y!="undefined"&&p.error(y),p.end()}}e.readFileIntoStream=A;async function I(D,w,p,E,d,S){b(S);const y=await D.open(w,{create:!1});try{b(S);let h=0,v=0,m=d&&typeof d.length=="number"?d.length:void 0,f=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),u=d&&typeof d.position=="number"?d.position:0,r=0;do v=await D.read(y,u,f.buffer,r,f.byteLength-r),u+=v,r+=v,h+=v,typeof m=="number"&&(m-=v),r===f.byteLength&&(await p.write(E(f)),f=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof m=="number"?m:d.bufferSize)),r=0);while(v>0&&(typeof m!="number"||m>0)&&b(S)&&P(h,d));if(r>0){let n=r;typeof m=="number"&&(n=Math.min(r,m)),p.write(E(f.slice(0,n)))}}catch(h){throw(0,T.ensureFileSystemProviderError)(h)}finally{await D.close(y)}}function b(D){if(D.isCancellationRequested)throw(0,t.canceled)();return!0}function P(D,w){if(w?.limits){if(typeof w.limits.memory=="number"&&D>w.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&D>w.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[57],se([0,1,82,2,12,4,8,13]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function b(h){return h.recursive===!0}e.isRecursiveWatchRequest=b;class P extends t.Disposable{constructor(v,m,f,u){super();this.onFileChanges=v,this.onLogMessage=m,this.verboseLogging=f,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),v.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),v.add(this.watcher.onDidError(m=>this.onError(m)))}onError(v){this.options.restartOnError?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P,P.MAX_RESTARTS=5;class D extends P{constructor(v,m,f){super(v,m,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class w extends P{constructor(v,m,f){super(v,m,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function p(h){return h.map(v=>({type:v.type,resource:A.URI.file(v.path)}))}e.toFileChanges=p;function E(h){const v=new y;for(const m of h)v.processEvent(m);return v.coalesce()}e.coalesceEvents=E;function d(h,v){return typeof v=="string"&&!v.startsWith(R.GLOBSTAR)&&!(0,L.isAbsolute)(v)?{base:h,pattern:v}:v}e.normalizeWatcherPattern=d;function S(h,v){const m=[];for(const f of v)m.push((0,R.parse)(d(h,f)));return m}e.parseWatcherPatterns=S;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return T.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const m=this.mapPathToChange.get(this.toKey(v));let f=!1;if(m){const u=m.type,r=v.type;m.path!==v.path&&(v.type===2||v.type===1)?f=!0:u===1&&r===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(m)):u===2&&r===1?m.type=0:u===1&&r===0||(m.type=r)}else f=!0;f&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],m=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(v.push(f),!1):!0).sort((f,u)=>f.path.length-u.path.length).filter(f=>m.some(u=>(0,I.isParent)(f.path,u,!T.isLinux))?!1:(m.push(f.path),!0)).concat(v)}}}),define(re[178],se([0,1,54,6,23,42,2,80,12,4,130,27,57]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class E extends A.Disposable{constructor(y,h,v,m){super();this.request=y,this.onDidFilesChange=h,this.onLogMessage=v,this.verboseLogging=m,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(E.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await w.Promises.stat(y);this._register(await this.doWatch(y,h.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let h=y.path;try{h=await w.Promises.realpath(y.path),y.path===h&&(h=await(0,D.realcase)(y.path)??y.path),y.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${h})`)}catch{}return h}async doWatch(y,h){if(P.isMacintosh&&(0,T.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const v=new L.CancellationTokenSource(this.cts.token),m=new A.DisposableStore;try{const f=(0,b.basename)(y),u=(0,R.watch)(y);m.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${y}'`);const r=new Set;if(h)try{for(const i of await w.Promises.readdir(y))r.add(i)}catch(i){this.error(i)}const n=new Map;m.add((0,A.toDisposable)(()=>{for(const[,i]of n)i.dispose();n.clear()})),u.on("error",(i,a)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),u.on("change",(i,a)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${a}`);let l="";if(a&&(l=a.toString(),P.isMacintosh&&(l=(0,I.normalizeNFC)(l))),!(!l||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){n.get(l)?.dispose();const o=setTimeout(async()=>{if(n.delete(l),l===f&&!await w.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.existsChildStrictCase((0,b.join)(y,l));if(v.token.isCancellationRequested)return;let c;s?r.has(l)?c=0:(c=1,r.add(l)):(r.delete(l),c=2),this.onFileChange({path:(0,b.join)(this.request.path,l),type:c})},E.FILE_DELETE_HANDLER_DELAY);n.set(l,(0,A.toDisposable)(()=>clearTimeout(o)))}else{let o;r.has(l)?o=0:(o=1,r.add(l)),this.onFileChange({path:(0,b.join)(this.request.path,l),type:o})}else if(i==="rename"||l!==f){const o=setTimeout(async()=>{const s=await w.Promises.exists(y);v.token.isCancellationRequested||(s?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},E.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,A.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await w.Promises.exists(y)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{v.dispose(!0),m.dispose()})}async onFileChange(y,h=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!h&&this.excludes.some(v=>v(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,p.coalesceEvents)(v);if(m.length>0){if(this.verboseLogging)for(const u of m)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(m)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(P.isLinux)return w.Promises.exists(y);try{const h=(0,b.basename)(y);return(await w.Promises.readdir((0,b.dirname)(y))).some(m=>m===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=E,E.FILE_DELETE_HANDLER_DELAY=100,E.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,y,h,v,m=512){const f=await w.Promises.open(S,"r"),u=Buffer.allocUnsafe(m),r=new L.CancellationTokenSource(v);let n,i=!1;const a={path:S,excludes:[],recursive:!1},l=new E(a,o=>{(async()=>{for(const{type:s}of o)if(s===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:c}=await w.Promises.read(f,u,0,m,null);if(!c||r.token.isCancellationRequested)break;y(u.slice(0,c))}}catch(c){n=new Error(c),r.dispose(!0)}finally{i=!1}}})()});return await l.ready,h(),new Promise((o,s)=>{r.token.onCancellationRequested(async()=>{l.dispose();try{await w.Promises.close(f)}catch(c){n=new Error(c)}n?s(n):o()})})}e.watchFileContents=d}),define(re[179],se([0,1,3,82,2,4,178]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(P){const D=this.normalizeRequests(P),w=D.filter(E=>{const d=this.watchers.get(E.path);return d?!(0,t.patternsEquals)(d.request.excludes,E.excludes)||!(0,t.patternsEquals)(d.request.includes,E.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:E})=>!D.find(d=>d.path===E.path&&(0,t.patternsEquals)(d.excludes,E.excludes)&&(0,t.patternsEquals)(d.includes,E.includes))).map(({request:E})=>E.path);w.length&&this.trace(`Request to start watching: ${w.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const E of p)this.stopWatching(E);for(const E of w)this.startWatching(E)}startWatching(P){const D=new A.NodeJSFileWatcherLibrary(P,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),w={request:P,instance:D};this.watchers.set(P.path,w)}async stop(){for(const[P]of this.watchers)this.stopWatching(P);this.watchers.clear()}stopWatching(P){const D=this.watchers.get(P);D&&(this.watchers.delete(P),D.instance.dispose())}normalizeRequests(P){const D=new Map;for(const w of P){const p=T.isLinux?w.path:w.path.toLowerCase();D.set(p,w)}return Array.from(D.values())}async setVerboseLogging(P){this.verboseLogging=P;for(const[,D]of this.watchers)D.instance.setVerboseLogging(P)}trace(P){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P)})}toMessage(P,D){return D?`[File Watcher (node.js)] ${P} (path: ${D.request.path})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=I}),define(re[180],se([0,1,57,179]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends R.AbstractNonRecursiveWatcherClient{constructor(A,I,b){super(A,I,b);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(re[181],se([0,1,20,39,64,57]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(b,P,D){super(b,P,D);this.init()}createWatcher(b){const P=b.add(new L.Client(R.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(P.onDidProcessExit(({code:D,signal:w})=>this.onError(`terminated by itself with code ${D}, signal: ${w}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(P.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(re[94],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...L){this._entries=new Map;for(const[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=R}),define(re[182],se([0,1,6,9,56,171,5,94]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class P extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class D{constructor(d=new I.ServiceCollection,S=!1,y){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=y,this._services.set(A.IInstantiationService,this)}createChild(d){return new D(d,this._strict,this)}invokeFunction(d,...S){const y=p.traceInvocation(d);let h=!1;try{return d({get:m=>{if(h)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(m,y);if(!f)throw new Error(`[invokeFunction] unknown service '${m}'`);return f}},...S)}finally{h=!0,y.stop()}}createInstance(d,...S){let y,h;return d instanceof L.SyncDescriptor?(y=p.traceCreation(d.ctor),h=this._createInstance(d.ctor,d.staticArguments.concat(S),y)):(y=p.traceCreation(d),h=this._createInstance(d,S,y)),y.stop(),h}_createInstance(d,S=[],y){const h=A._util.getServiceDependencies(d).sort((f,u)=>f.index-u.index),v=[];for(const f of h){const u=this._getOrCreateServiceInstance(f.id,y);u||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${f.id}.`,!1),v.push(u)}const m=h.length>0?h[0].index:S.length;if(S.length!==m){console.trace(`[createInstance] First service dependency of ${d.name} at position ${m+1} conflicts with ${S.length} static arguments`);const f=m-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,m)}return new d(...[...S,...v])}_setServiceInstance(d,S){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){const y=this._getServiceInstanceOrDescriptor(d);return y instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,y,S.branch(d,!0)):(S.branch(d,!1),y)}_safeCreateAndCacheServiceInstance(d,S,y){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,y)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,y){const h=new T.Graph(f=>f.id.toString());let v=0;const m=[{id:d,desc:S,_trace:y}];for(;m.length;){const f=m.pop();if(h.lookupOrInsertNode(f),v++>1e3)throw new P(h);for(const u of A._util.getServiceDependencies(f.desc.ctor)){const r=this._getServiceInstanceOrDescriptor(u.id);if(r||this._throwIfStrict(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`,!0),r instanceof L.SyncDescriptor){const n={id:u.id,desc:r,_trace:f._trace.branch(u.id,!0)};h.insertEdge(f,n),m.push(n)}}}for(;;){const f=h.roots();if(f.length===0){if(!h.isEmpty())throw new P(h);break}for(const{data:u}of f){if(this._getServiceInstanceOrDescriptor(u.id)instanceof L.SyncDescriptor){const n=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,n)}h.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,y=[],h,v){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(S,y,h,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,y,h,v);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],y,h){if(y){const v=new R.IdleValue(()=>this._createInstance(d,S,h));return new Proxy(Object.create(null),{get(m,f){if(f in m)return m[f];const u=v.value;let r=u[f];return typeof r!="function"||(r=r.bind(u),m[f]=r),r},set(m,f,u){return v.value[f]=u,!0}})}else return this._createInstance(d,S,h)}_throwIfStrict(d,S){if(S&&console.warn(S),this._strict)throw new Error(d)}}e.InstantiationService=D;var w;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(w||(w={}));class p{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return b?new p(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(d){return b?new p(0,d.name):p._None}branch(d,S){const y=new p(2,d.toString());return this._dep.push([d,S,y]),y}stop(){const d=Date.now()-this._start;p._totals+=d;let S=!1;function y(v,m){const f=[],u=new Array(v+1).join("	");for(const[r,n,i]of m._dep)if(n&&i){S=!0,f.push(`${u}CREATES -> ${r}`);const a=y(v+1,i);a&&f.push(a)}else f.push(`${u}uses -> ${r}`);return f.join(`
`)}const h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(h.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(re[183],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=R}),define(re[95],se([0,1,39,56,89,5]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(E,d,S){const y=S.getChannel(E);return I(d)?new d.channelClientCtor(y):R.ProxyChannel.toService(y,d?.proxyOptions)}}function I(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let b=class extends A{constructor(E,d,S){super(E,d,S)}};b=me([Q(2,e.IMainProcessService)],b);function P(p,E,d){(0,L.registerSingleton)(p,new t.SyncDescriptor(b,[E,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=P,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let D=class extends A{constructor(E,d,S){super(E,d,S)}};D=me([Q(2,e.ISharedProcessService)],D);function w(p,E,d){(0,L.registerSingleton)(p,new t.SyncDescriptor(D,[E,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(re[66],se([0,1,23,2,4,152,30,5]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let b=class extends t.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new R.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const E=w.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(S=>S.startsWith("lp-"))).map(d=>{const S=d.properties.localizedLanguages?.[0],y=d.tags.find(v=>v.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:y,label:S}),extensionId:d.identifier.id,galleryExtension:d}});return E.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),E}createQuickPickItem(D){const w=D.label??D.locale;let p=D.locale!==D.label?D.locale:void 0;return D.locale.toLowerCase()===L.language.toLowerCase()&&(p||(p=""),p+=(0,T.localize)(0,null)),{id:D.locale,label:w,description:p}}};b=me([Q(0,A.IExtensionGalleryService)],b),e.LanguagePackBaseService=b}),define(re[184],se([0,1,2,66]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends R.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=me([Q(0,t.ILanguagePackService)],L),e.LocalizationsUpdater=L}),define(re[7],se([0,1,37,3,2,4,5]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var b;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function P(n,i,a){switch(i){case b.Trace:n.trace(a);break;case b.Debug:n.debug(a);break;case b.Info:n.info(a);break;case b.Warning:n.warn(a);break;case b.Error:n.error(a);break;case b.Critical:n.critical(a);break;default:throw new Error("Invalid log level")}}e.log=P;function D(n){let i="";for(let a=0;a<n.length;a++){let l=n[a];if(typeof l=="object")try{l=JSON.stringify(l)}catch{}i+=(a>0?" ":"")+l}return i}e.format=D;class w extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class p extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(b.Trace)&&this.log(b.Trace,D([i,...a]))}debug(i,...a){this.checkLogLevel(b.Debug)&&this.log(b.Debug,D([i,...a]))}info(i,...a){this.checkLogLevel(b.Info)&&this.log(b.Info,D([i,...a]))}warn(i,...a){this.checkLogLevel(b.Warning)&&this.log(b.Warning,D([i,...a]))}error(i,...a){if(this.checkLogLevel(b.Error))if(i instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=i.stack,this.log(b.Error,D(l))}else this.log(b.Error,D([i,...a]))}critical(i,...a){this.checkLogLevel(b.Critical)&&this.log(b.Critical,D([i,...a]))}flush(){}}e.AbstractMessageLogger=p;class E extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...a){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}debug(i,...a){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}info(i,...a){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...a):console.log(`[main ${I()}]`,i,...a))}warn(i,...a){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...a):console.warn(`[main ${I()}]`,i,...a))}error(i,...a){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...a):console.error(`[main ${I()}]`,i,...a))}critical(i,...a){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...a):console.error(`[main ${I()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class d extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends w{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,R.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class y extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const l of this.logServices)l.trace(i,...a)}debug(i,...a){for(const l of this.logServices)l.debug(i,...a)}info(i,...a){for(const l of this.logServices)l.info(i,...a)}warn(i,...a){for(const l of this.logServices)l.warn(i,...a)}error(i,...a){for(const l of this.logServices)l.error(i,...a)}critical(i,...a){for(const l of this.logServices)l.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=y;class h extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=h;class v extends L.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(l))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let l=this.loggers.get(i.toString());return l||(l=this.doCreateLogger(i,a?.always?b.Trace:this.logLevel,a),this.loggers.set(i.toString(),l),a?.always||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=m;function f(n){if(n.verbose)return b.Trace;if(typeof n.logLevel=="string"){const i=u(n.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function u(n){switch(n){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=u;function r(n){switch(n){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(re[185],se([0,1,6,9,2,12,27,15,7]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let P=class extends L.Disposable{constructor(w,p){super();this.environmentService=w,this.logService=p,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,T.basename)(this.environmentService.logsPath),p=(0,T.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(p)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==w),y=S.slice(0,Math.max(0,S.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(h=>A.Promises.rm((0,T.join)(p,h)))))}catch(w){(0,t.onUnexpectedError)(w)}}};P=me([Q(0,I.IEnvironmentService),Q(1,b.ILogService)],P),e.LogsDataCleaner=P}),define(re[186],se([0,1,6,9,2,12,27,15,7]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let P=class mt extends L.Disposable{constructor(w,p,E){super();this.backupWorkspacesPath=w,this.environmentService=p,this.logService=E,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const w=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(w).emptyWorkspaceInfos.map(S=>S.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async S=>{S.length===mt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===mt.EXTENSION_DEV_EMPTY_WINDOW_ID||E.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(w){(0,t.onUnexpectedError)(w)}}};P.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,P.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",P=me([Q(1,I.INativeEnvironmentService),Q(2,b.ILogService)],P),e.StorageDataCleaner=P}),define(re[187],se([0,1,17,6,9,3,2,12,57,7]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends A.Disposable{constructor(p,E){super();this.logService=p,this.options=E,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(p,E){return E.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,E):this.watchNonRecursive(p,E)}watchUniversal(p,E){const d={path:this.toFilePath(p),excludes:E.excludes,includes:E.includes,recursive:E.recursive},S=(0,R.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,L.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(E=>this._onDidChangeFile.fire((0,b.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const E of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(E)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const E of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(E)&&p.includes(E.path)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,E){const d={path:this.toFilePath(p),excludes:E.excludes,includes:E.includes,recursive:!1},S=(0,R.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,L.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,b.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,I.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(re[188],se([0,1,17,6,16,23,3,62,52,2,38,20,189,19,41,148,13,93,7]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends P.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,r){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${u}`);const n=new P.DisposableStore;return this.provider.set(u,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:r}),n.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new y.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:u}))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:r}),this.provider.delete(u),(0,P.dispose)(n)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(n){r.push(n)}}),!this.provider.has(u)&&await t.Promises.settled(r)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,r){const n=this.provider.get(u.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([u,r])=>({scheme:u,capabilities:r.capabilities}))}async withProvider(u){if(!(0,E.isAbsolutePath)(u))throw new y.FileOperationError((0,S.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const r=this.provider.get(u.scheme);if(!r){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,u.toString()),n}return r}async withReadProvider(u){const r=await this.withProvider(u);if((0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r)||(0,y.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const r=await this.withProvider(u);if((0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,r){try{return await this.doResolveFile(u,r)}catch(n){throw(0,y.toFileSystemProviderErrorCode)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,S.localize)(2,null,this.resourceForError(u)),1):(0,y.ensureFileSystemProviderError)(n)}}async doResolveFile(u,r){const n=await this.withProvider(u),i=this.isPathCaseSensitive(n),a=r?.resolveTo,l=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,s=await n.stat(u);let c;return this.toFileStat(n,u,s,void 0,!!o,(g,C)=>(c||(c=D.TernarySearchTree.forUris(()=>!i),c.set(u,!0),a&&c.fill(!0,a)),c.get(g.resource)||c.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&l?C===1:!1))}async toFileStat(u,r,n,i,a,l){const{providerExtUri:o}=this.getExtUri(u),s={resource:r,name:o.basename(r),isFile:(n.type&y.FileType.File)!=0,isDirectory:(n.type&y.FileType.Directory)!=0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&y.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,y.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(s.isDirectory&&l(s,i)){try{const c=await u.readdir(r),g=await t.Promises.settled(c.map(async([C,O])=>{try{const _=o.joinPath(r,C),N=a?await u.stat(_):{type:O};return await this.toFileStat(u,_,N,c.length,a,l)}catch(_){return this.logService.trace(_),null}}));s.children=(0,R.coalesce)(g)}catch(c){this.logService.trace(c),s.children=[]}return s}return s}async resolveAll(u){return t.Promises.settled(u.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(u){const r=await this.withProvider(u),n=await r.stat(u);return this.toFileStat(r,u,n,void 0,!0,()=>!1)}async exists(u){const r=await this.withProvider(u);try{return!!await r.stat(u)}catch{return!1}}async canCreateFile(u,r){try{await this.doValidateCreateFile(u,r)}catch(n){return n}return!0}async doValidateCreateFile(u,r){if(!r?.overwrite&&await this.exists(u))throw new y.FileOperationError((0,S.localize)(3,null,this.resourceForError(u)),3,r)}async createFile(u,r=L.VSBuffer.fromString(""),n){await this.doValidateCreateFile(u,n);const i=await this.writeFile(u,r);return this._onDidRunOperation.fire(new y.FileOperationEvent(u,0,i)),i}async writeFile(u,r,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:a}=this.getExtUri(i);try{await this.validateWriteFile(i,u,n)||await this.mkdirp(i,a.dirname(u));let o;if((0,y.hasReadWriteCapability)(i)&&!(r instanceof L.VSBuffer))if((0,d.isReadableStream)(r)){const s=await(0,d.peekStream)(r,3);s.ended?o=L.VSBuffer.concat(s.buffer):o=s}else o=(0,d.peekReadable)(r,s=>L.VSBuffer.concat(s),3);else o=r;!(0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)&&o instanceof L.VSBuffer?await this.doWriteUnbuffered(i,u,n,o):await this.doWriteBuffered(i,u,n,o instanceof L.VSBuffer?(0,L.bufferToReadable)(o):o),this._onDidRunOperation.fire(new y.FileOperationEvent(u,4))}catch(l){throw new y.FileOperationError((0,S.localize)(4,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(l).toString()),(0,y.toFileOperationResult)(l),n)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,r,n){if(!!n?.unlock&&!(u.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(r)));let a;try{a=await u.stat(r)}catch{return}if((a.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,S.localize)(6,null,this.resourceForError(r)),0,n);if(this.throwIfFileIsReadonly(r,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,y.etag)({mtime:n.mtime,size:a.size}))throw new y.FileOperationError((0,S.localize)(7,null),3,n);return a}async readFile(u,r,n){const i=await this.withReadProvider(u);return r?.atomic?this.doReadFileAtomic(i,u,r,n):this.doReadFile(i,u,r,n)}async doReadFileAtomic(u,r,n,i){return new Promise((a,l)=>{this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(u,r,n,i);a(o)}catch(o){l(o)}})})}async doReadFile(u,r,n,i){const a=await this.doReadFileStream(u,r,{...n,preferUnbuffered:!0},i);return{...a,value:await(0,L.streamToBuffer)(a.value)}}async readFileStream(u,r,n){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,r,n)}async doReadFileStream(u,r,n,i){const a=new T.CancellationTokenSource(i),l=this.validateReadFile(r,n).then(s=>s,s=>{throw a.cancel(),s});let o;try{return typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&await l,n?.atomic&&(0,y.hasFileAtomicReadCapability)(u)||!((0,y.hasOpenReadWriteCloseCapability)(u)||(0,y.hasFileReadStreamCapability)(u))||(0,y.hasReadWriteCapability)(u)&&n?.preferUnbuffered?o=this.readFileUnbuffered(u,r,n):(0,y.hasFileReadStreamCapability)(u)?o=this.readFileStreamed(u,r,a.token,n):o=this.readFileBuffered(u,r,a.token,n),{...await l,value:o}}catch(s){o&&await(0,d.consumeStream)(o);const c=(0,S.localize)(8,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(s).toString());throw s instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(c,s.stat,n):new y.FileOperationError(c,(0,y.toFileOperationResult)(s),n)}}readFileStreamed(u,r,n,i=Object.create(null)){const a=u.readFileStream(r,i,n);return(0,d.transform)(a,{data:l=>l instanceof L.VSBuffer?l:L.VSBuffer.wrap(l),error:l=>new y.FileOperationError((0,S.localize)(9,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(l).toString()),(0,y.toFileOperationResult)(l),i)},l=>L.VSBuffer.concat(l))}readFileBuffered(u,r,n,i=Object.create(null)){const a=(0,L.newWriteableBufferStream)();return(0,h.readFileIntoStream)(u,r,a,l=>l,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:l=>new y.FileOperationError((0,S.localize)(10,null,this.resourceForError(r),(0,y.ensureFileSystemProviderError)(l).toString()),(0,y.toFileOperationResult)(l),i)},n),a}readFileUnbuffered(u,r,n){const i=(0,d.newWriteableStream)(a=>L.VSBuffer.concat(a));return(async()=>{try{let a;n?.atomic&&(0,y.hasFileAtomicReadCapability)(u)?a=await u.readFile(r,{atomic:!0}):a=await u.readFile(r),typeof n?.position=="number"&&(a=a.slice(n.position)),typeof n?.length=="number"&&(a=a.slice(0,n.length)),this.validateReadFileLimits(r,a.byteLength,n),i.end(L.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async validateReadFile(u,r){const n=await this.resolve(u,{resolveMetadata:!0});if(n.isDirectory)throw new y.FileOperationError((0,S.localize)(11,null,this.resourceForError(u)),0,r);if(typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&r.etag===n.etag)throw new y.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,r);return this.validateReadFileLimits(u,n.size,r),n}validateReadFileLimits(u,r,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&r>n.limits.size&&(i=7),typeof i=="number")throw new y.FileOperationError((0,S.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,r,n){return this.doCanMoveCopy(u,r,"move",n)}async canCopy(u,r,n){return this.doCanMoveCopy(u,r,"copy",n)}async doCanMoveCopy(u,r,n,i){if(u.toString()!==r.toString())try{const a=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(a,u,l,r,n,i)}catch(a){return a}return!0}async move(u,r,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),l=await this.doMoveCopy(i,u,a,r,"move",!!n),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(u,l==="move"?2:3,o)),o}async copy(u,r,n){const i=await this.withReadProvider(u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),l=await this.doMoveCopy(i,u,a,r,"copy",!!n),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(u,l==="copy"?3:2,o)),o}async doMoveCopy(u,r,n,i,a,l){if(r.toString()===i.toString())return a;const{exists:o,isSameResourceWithDifferentPathCase:s}=await this.doValidateMoveCopy(u,r,n,i,a,l);if(o&&!s&&l&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),a==="copy"){if(u===n&&(0,y.hasFileFolderCopyCapability)(u))await u.copy(r,i,{overwrite:l});else{const c=await this.resolve(r);c.isDirectory?await this.doCopyFolder(u,c,n,i):await this.doCopyFile(u,r,n,i)}return a}else return u===n?(await u.rename(r,i,{overwrite:l}),a):(await this.doMoveCopy(u,r,n,i,"copy",l),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(u,r,n,i){if((0,y.hasOpenReadWriteCloseCapability)(u)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(u,r,n,i);if((0,y.hasOpenReadWriteCloseCapability)(u)&&(0,y.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(u,r,n,i);if((0,y.hasReadWriteCapability)(u)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(u,r,n,i);if((0,y.hasReadWriteCapability)(u)&&(0,y.hasReadWriteCapability)(n))return this.doPipeUnbuffered(u,r,n,i)}async doCopyFolder(u,r,n,i){await n.mkdir(i),Array.isArray(r.children)&&await t.Promises.settled(r.children.map(async a=>{const l=this.getExtUri(n).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.doCopyFolder(u,await this.resolve(a.resource),n,l):this.doCopyFile(u,a.resource,n,l)}))}async doValidateMoveCopy(u,r,n,i,a,l){let o=!1;if(u===n){const{providerExtUri:c,isPathCaseSensitive:g}=this.getExtUri(u);if(g||(o=c.isEqual(r,i)),o&&a==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!o&&c.isEqualOrParent(i,r))throw new Error((0,S.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const s=await this.exists(i);if(s&&!o){if(!l)throw new y.FileOperationError((0,S.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(u===n){const{providerExtUri:c}=this.getExtUri(u);if(c.isEqualOrParent(r,i))throw new Error((0,S.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:s,isSameResourceWithDifferentPathCase:o}}getExtUri(u){const r=this.isPathCaseSensitive(u);return{providerExtUri:r?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(r,u);const n=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(u,0,n)),n}async mkdirp(u,r){const n=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(r,i.dirname(r));)try{if(((await u.stat(r)).type&y.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(r)));break}catch(a){if((0,y.toFileSystemProviderErrorCode)(a)!==y.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(i.basename(r)),r=i.dirname(r)}for(let a=n.length-1;a>=0;a--){r=i.joinPath(r,n[a]);try{await u.mkdir(r)}catch(l){if((0,y.toFileSystemProviderErrorCode)(l)!==y.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(u,r){try{await this.doValidateDelete(u,r)}catch(n){return n}return!0}async doValidateDelete(u,r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(u)));let a;try{a=await n.stat(u)}catch{}if(a)this.throwIfFileIsReadonly(u,a);else throw new y.FileOperationError((0,S.localize)(20,null,this.resourceForError(u)),1);if(!!!r?.recursive){const o=await this.resolve(u);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(u)))}return n}async del(u,r){const n=await this.doValidateDelete(u,r),i=!!r?.useTrash,a=!!r?.recursive;await n.delete(u,{recursive:a,useTrash:i}),this._onDidRunOperation.fire(new y.FileOperationEvent(u,1))}async cloneFile(u,r){const n=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(u,r))return;if(n===i&&(0,y.hasFileCloneCapability)(n))return n.cloneFile(u,r);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r));const a=this.writeQueue.queueFor(u,this.getExtUri(n).providerExtUri);return n===i&&(0,y.hasFileFolderCopyCapability)(n)?a.queue(()=>n.copy(u,r,{overwrite:!0})):a.queue(()=>this.doCopyFile(n,u,i,r))}watch(u,r={recursive:!1,excludes:[]}){const n=new P.DisposableStore;let i=!1,a=()=>{i=!0};return n.add((0,P.toDisposable)(()=>a())),(async()=>{try{const l=await this.doWatch(u,r);i?(0,P.dispose)(l):a=()=>(0,P.dispose)(l)}catch(l){this.logService.error(l)}})(),n}async doWatch(u,r){const n=await this.withProvider(u),i=(0,I.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(u),r]);let a=this.activeWatchers.get(i);return a||(a={count:0,disposable:n.watch(u,r)},this.activeWatchers.set(i,a)),a.count+=1,(0,P.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,P.dispose)(a.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,P.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,r,n,i){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(async()=>{const a=await u.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,a,i):await this.doWriteReadableBufferedQueued(u,a,i)}catch(l){throw(0,y.ensureFileSystemProviderError)(l)}finally{await u.close(a)}})}async doWriteStreamBufferedQueued(u,r,n){let i=0,a;if((0,d.isReadableBufferedStream)(n)){if(n.buffer.length>0){const l=L.VSBuffer.concat(n.buffer);await this.doWriteBuffer(u,r,l,l.byteLength,i,0),i+=l.byteLength}if(n.ended)return;a=n.stream}else a=n;return new Promise((l,o)=>{(0,d.listenStream)(a,{onData:async s=>{a.pause();try{await this.doWriteBuffer(u,r,s,s.byteLength,i,0)}catch(c){return o(c)}i+=s.byteLength,setTimeout(()=>a.resume())},onError:s=>o(s),onEnd:()=>l()})})}async doWriteReadableBufferedQueued(u,r,n){let i=0,a;for(;(a=n.read())!==null;)await this.doWriteBuffer(u,r,a,a.byteLength,i,0),i+=a.byteLength}async doWriteBuffer(u,r,n,i,a,l){let o=0;for(;o<i;)o+=await u.write(r,a+o,n.buffer,l+o,i-o)}async doWriteUnbuffered(u,r,n,i){return this.writeQueue.queueFor(r,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,r,n,i))}async doWriteUnbufferedQueued(u,r,n,i){let a;i instanceof L.VSBuffer?a=i:(0,d.isReadableStream)(i)?a=await(0,L.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?a=await(0,L.bufferedStreamToBuffer)(i):a=(0,L.readableToBuffer)(i),await u.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(u,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,r,n,i))}async doPipeBufferedQueued(u,r,n,i){let a,l;try{a=await u.open(r,{create:!1}),l=await n.open(i,{create:!0,unlock:!1});const o=L.VSBuffer.alloc(this.BUFFER_SIZE);let s=0,c=0,g=0;do g=await u.read(a,s,o.buffer,c,o.byteLength-c),await this.doWriteBuffer(n,l,o,g,s,c),s+=g,c+=g,c===o.byteLength&&(c=0);while(g>0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await t.Promises.settled([typeof a=="number"?u.close(a):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async doPipeUnbuffered(u,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,r,n,i))}async doPipeUnbufferedQueued(u,r,n,i){return n.writeFile(i,await u.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,r,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,r,n,i))}async doPipeUnbufferedToBufferedQueued(u,r,n,i){const a=await n.open(i,{create:!0,unlock:!1});try{const l=await u.readFile(r);await this.doWriteBuffer(n,a,L.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,y.ensureFileSystemProviderError)(l)}finally{await n.close(a)}}async doPipeBufferedToUnbuffered(u,r,n,i){const a=await(0,L.streamToBuffer)(this.readFileBuffered(u,r,T.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,a)}throwIfFileSystemIsReadonly(u,r){if(u.capabilities&2048)throw new y.FileOperationError((0,S.localize)(22,null,this.resourceForError(r)),6);return u}throwIfFileIsReadonly(u,r){if((r.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,S.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===w.Schemas.file?u.fsPath:u.toString(!0)}};m=me([Q(0,v.ILogService)],m),e.FileService=m}),define(re[190],se([0,1,54,271,6,38,16,3,42,2,12,4,19,41,27,151,13,93,187,37,181,180]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(R)}catch(n){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(n)}`)}})();class r extends v.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new T.ResourceMap(l=>p.extUriBiasedIgnorePathCase.getComparisonKey(l)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:l}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,l),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),l=[];return await Promise.all(a.map(async o=>{try{let s;o.isSymbolicLink()?s=(await this.stat((0,p.joinPath)(i,o.name))).type:s=this.toType(o),l.push([o.name,s])}catch(s){this.logService.trace(s)}})),l}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let l;return a?.dangling?l=y.FileType.Unknown:i.isFile()?l=y.FileType.File:i.isDirectory()?l=y.FileType.Directory:l=y.FileType.Unknown,a&&(l|=y.FileType.SymbolicLink),l}async createResourceLock(i){const a=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let l;for(;l=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await l.wait();const o=new L.Barrier;return this.resourceLocks.set(i,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,P.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.resourceLocks.get(i)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),o.open()})}async readFile(i,a){let l;try{a?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),l=await this.createResourceLock(i));const o=this.toFilePath(i);return await d.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{l?.dispose()}}readFileStream(i,a,l){const o=(0,E.newWriteableStream)(s=>A.VSBuffer.concat(s.map(c=>A.VSBuffer.wrap(c))).buffer);return(0,h.readFileIntoStream)(this,i,o,s=>s.buffer,{...a,bufferSize:256*1024},l),o}async writeFile(i,a,l){let o;try{const s=this.toFilePath(i);if(!l.create||!l.overwrite){if(await d.Promises.exists(s)){if(!l.overwrite)throw(0,y.createFileSystemProviderError)((0,S.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,y.createFileSystemProviderError)((0,S.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:l.unlock}),await this.write(o,0,a,0,a.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(i,s)}finally{typeof o=="number"&&await this.close(o)}}async open(i,a){const l=this.toFilePath(i);let o;(0,y.isFileOpenForWriteOptions)(a)&&(o=await this.createResourceLock(i));let s;try{if((0,y.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:g}=await d.SymlinkSupport.stat(l);g.mode&128||await d.Promises.chmod(l,g.mode|128)}catch(g){this.logService.trace(g)}let c;if((0,y.isFileOpenForWriteOptions)(a)){if(w.isWindows)try{await d.Promises.truncate(l,0),c="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}c||(c="w")}else c="r";s=await d.Promises.open(l,c)}catch(c){throw o?.dispose(),(0,y.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}if(this.mapHandleToPos.set(s,0),(0,y.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(s,i),o){const c=this.mapHandleToLock.get(s);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${l})`),this.mapHandleToLock.set(s,o),c&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${l})`),c.dispose())}return s}async close(i){const a=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(l){this.canFlush=!1,this.logService.error(l)}return await d.Promises.close(i)}catch(l){throw this.toFileSystemProviderError(l)}finally{a&&(this.mapHandleToLock.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,l,o,s){const c=this.normalizePos(i,a);let g=null;try{g=(await d.Promises.read(i,l,o,s,c)).bytesRead}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(i,c,g)}return g}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,l){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof a=="number"||(typeof l=="number"?this.mapHandleToPos.set(i,o+l):this.mapHandleToPos.delete(i)))}async write(i,a,l,o,s){return(0,L.retry)(()=>this.doWrite(i,a,l,o,s),100,3)}async doWrite(i,a,l,o,s){const c=this.normalizePos(i,a);let g=null;try{g=(await d.Promises.write(i,l,o,s,c)).bytesWritten}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),C)}finally{this.updatePos(i,c,g)}return g}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const l=this.toFilePath(i);a.recursive?await d.Promises.rm(l,d.RimRafMode.MOVE):await d.Promises.unlink(l)}catch(l){throw this.toFileSystemProviderError(l)}}async rename(i,a,l){const o=this.toFilePath(i),s=this.toFilePath(a);if(o!==s)try{await this.validateTargetDeleted(i,a,"move",l.overwrite),await d.Promises.move(o,s)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,S.localize)(2,null,(0,D.basename)(o),(0,D.basename)((0,D.dirname)(s)),c.toString()))),this.toFileSystemProviderError(c)}}async copy(i,a,l){const o=this.toFilePath(i),s=this.toFilePath(a);if(o!==s)try{await this.validateTargetDeleted(i,a,"copy",l.overwrite),await d.Promises.copy(o,s,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,S.localize)(3,null,(0,D.basename)(o),(0,D.basename)((0,D.dirname)(s)),c.toString()))),this.toFileSystemProviderError(c)}}async validateTargetDeleted(i,a,l,o){const s=this.toFilePath(i),c=this.toFilePath(a);let g=!1;if(!!(this.capabilities&1024)||(g=(0,b.isEqual)(s,c,!0)),g&&l==="copy")throw(0,y.createFileSystemProviderError)((0,S.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!g&&await d.Promises.exists(c)){if(!o)throw(0,y.createFileSystemProviderError)((0,S.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.doCloneFile(i,a,!1)}async doCloneFile(i,a,l){const o=this.toFilePath(i),s=this.toFilePath(a),c=!!(this.capabilities&1024);if((0,b.isEqual)(o,s,!c))return;const g=new P.DisposableStore;try{const[C,O]=await Promise.all([this.createResourceLock(i),this.createResourceLock(a)]);g.add(C),g.add(O),l&&await d.Promises.mkdir((0,D.dirname)(s),{recursive:!0}),await d.Promises.copyFile(o,s)}catch(C){if(C.code==="ENOENT"&&!l)return this.doCloneFile(i,a,!0);throw this.toFileSystemProviderError(C)}finally{g.dispose()}}createUniversalWatcher(i,a,l){return new f.UniversalWatcherClient(o=>i(o),o=>a(o),l)}createNonRecursiveWatcher(i,a,l){return new u.NodeJSWatcherClient(o=>i(o),o=>a(o),l)}toFileSystemProviderError(i){if(i instanceof y.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=y.FileSystemProviderErrorCode.NoPermissions;break;default:a=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let l=this.toFileSystemProviderError(a);if(i&&l.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(l=(0,y.createFileSystemProviderError)(a,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return l}}e.DiskFileSystemProvider=r}),define(re[96],se([0,1,3,8,7]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(p){this.service=p,this.onDidChangeLogLevel=R.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(p,E,d){switch(E){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=T;class A{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){A.setLevel(this.channel,p)}static setLevel(p,E){return p.call("setLevel",E)}}e.LogLevelChannelClient=A;class I{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,E){throw new Error(`Event not found: ${E}`)}async call(p,E,d){switch(E){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${E}`)}createLogger(p,E){this.loggers.set(p.toString(),this.loggerService.createLogger(p,E))}consoleLog(p,E){let d=console.log;switch(p){case L.LogLevel.Error:d=console.error;break;case L.LogLevel.Warning:d=console.warn;break;case L.LogLevel.Info:d=console.info;break}d.call(console,...E)}log(p,E){const d=this.loggers.get(p.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,y]of E)(0,L.log)(d,S,y)}}e.LoggerChannel=I;class b extends L.AbstractLoggerService{constructor(p,E,d){super(p,E);this.channel=d}createConsoleMainLogger(){return new L.AdapterLogger({log:(p,E)=>{this.channel.call("consoleLog",[p,E])}})}doCreateLogger(p,E,d){return new P(this.channel,p,E,d)}}e.LoggerChannelClient=b;class P extends L.AbstractMessageLogger{constructor(p,E,d,S){super(S?.always);this.channel=p,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[E,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,E){const d=[[p,E]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(p){this.channel.call("log",[this.file,p])}}class D extends L.LogService{constructor(p,E){super(E);this.parent=p,this._register(p.onDidChangeLogLevel(d=>E.setLevel(d)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=D}),define(re[67],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(re[58],se([0,1,3,52,2,5]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class A extends L.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(P){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...P,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(P),t.Iterable.reduce(this.policies.entries(),(w,[p,E])=>({...w,[p]:E}),{})}getPolicyValue(P){return this.policies.get(P)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(P,[D,w])=>({...P,[D]:{definition:w,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=A;class I{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(re[191],se([0,1,3,2,58]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(b){this.service=b,this.disposables=new t.DisposableStore}listen(b,P){switch(P){case"onDidChange":return R.Event.map(this.service.onDidChange,D=>D.reduce((w,p)=>({...w,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${P}`)}call(b,P,D){switch(P){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(D)}throw new Error(`Call not found: ${P}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class A extends L.AbstractPolicyService{constructor(b,P){super();this.channel=P;for(const D in b){const{definition:w,value:p}=b[D];this.policyDefinitions[D]=w,p!==void 0&&this.policies.set(D,p)}this.channel.listen("onDidChange")(D=>{for(const w in D){const p=D[w];p===null?this.policies.delete(w):this.policies.set(w,p)}this._onDidChange.fire(Object.keys(D))})}async initializePolicies(b){const P=await this.channel.call("registerPolicyDefinitions",b);for(const D in P)this.policies.set(D,P[D])}}e.PolicyChannelClient=A}),define(re[97],se([0,1,20,4,35,19]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const I=t.globals.vscode.context.configuration();if(I)A=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const I=(0,T.dirname)(R.FileAccess.asFileUri("",Z));A=Z.__$__nodeRequire((0,T.joinPath)(I,"product.json").fsPath);const b=Z.__$__nodeRequire((0,T.joinPath)(I,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:b.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[24],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[192],se([0,1,6,9,2,12,27,7,24]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let P=class extends L.Disposable{constructor(w,p,E){super();this.productService=p,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},30*1e3)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),E=(0,T.dirname)(w),d=(0,T.basename)(w),S=await A.Promises.readdir(E);await Promise.all(S.map(async y=>{if(y===d)return;const h=(0,T.join)(E,y),v=await A.Promises.stat(h);if(v.isDirectory()&&p-v.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),A.Promises.rm(h)}))}catch(p){(0,t.onUnexpectedError)(p)}}};P=me([Q(1,b.IProductService),Q(2,I.ILogService)],P),e.CodeCacheCleaner=P}),define(re[193],se([0,1,6,9,2,12,27,15,7,24]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends L.Disposable{constructor(p,E,d){super();this.environmentService=p,this.logService=E,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),E=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const v of Object.keys(E)){const m=E[v];p[`${m.hash}.${v}`]=!0}const d=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const y=await A.Promises.readdir(d);for(const v of y){if(p[v]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await A.Promises.rm((0,T.join)(d,v))}const h=Date.now();for(const v of Object.keys(p)){const m=(0,T.join)(d,v),f=await A.Promises.readdir(m);for(const u of f){if(u==="tcf.json")continue;const r=(0,T.join)(m,u),n=await A.Promises.stat(r);n.isDirectory()&&h-n.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(v,u)}`),await A.Promises.rm(r))}}}catch(p){(0,t.onUnexpectedError)(p)}}};D=me([Q(0,I.INativeEnvironmentService),Q(1,b.ILogService),Q(2,P.IProductService)],D),e.LanguagePackCachedDataCleaner=D}),define(re[194],se([0,1,12,5]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(I,b="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,R.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(P.callFrame.url))&&(P.callFrame.url=(0,R.join)(b,(0,R.basename)(P.callFrame.url)));return I}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(re[195],se([0,1,31]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(T){const I=await(await new Promise((P,D)=>{Z(["v8-inspect-profiler"],P,D)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,R.generateUuid)();return this._sessions.set(b,I),b}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const I=await A.stop();return this._sessions.delete(T),I.profile}}e.InspectProfilingService=t}),define(re[40],se([0,1,110,14]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,I){R.ok(t.isString(A)),R.ok(t.isObject(I)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(re[98],se([0,1,3,40]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,P){this.schemasById[L(b)]=P,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;t.Registry.add(e.Extensions.JSONContribution,A)}),define(re[43],se([0,1,17,3,14,138,18,98,40]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=b.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,n=!0){this.registerConfigurations([r],n)}registerConfigurations(r,n=!0){const i=this.doRegisterConfigurations(r,n);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const n=this.doDeregisterConfigurations(r);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:r,remove:n}){const i=[];i.push(...this.doDeregisterConfigurations(n)),i.push(...this.doRegisterConfigurations(r,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(i)})}registerDefaultConfigurations(r){const n=[],i=[];for(const{overrides:a,source:l}of r)for(const o in a)if(n.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s=this.configurationDefaultsOverrides.get(o),c=s?.valuesSources??new Map;if(l)for(const _ of Object.keys(a[o]))c.set(_,l);const g={...s?.value||{},...a[o]};this.configurationDefaultsOverrides.set(o,{source:l,value:g,valuesSources:c});const C=(0,A.getLanguageTagSettingPlainKey)(o),O={type:"object",default:g,description:T.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:L.isString(l)?void 0:l,defaultValueSource:l};i.push(...S(o)),this.configurationProperties[o]=O,this.defaultLanguageConfigurationOverridesNode.properties[o]=O}else{this.configurationDefaultsOverrides.set(o,{value:a[o],source:l});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const n=[];for(const{overrides:i,source:a}of r)for(const l in i){const o=this.configurationDefaultsOverrides.get(l),s=L.isString(a)?a:a?.id,c=L.isString(o?.source)?o?.source:o?.source?.id;if(s===c)if(n.push(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const g=this.configurationProperties[l];g&&(this.updatePropertyDefaultValue(l,g),this.updateSchema(l,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const n of r)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,n){const i=[];return r.forEach(a=>{i.push(...this.validateAndRegisterProperties(a,n,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),i}doDeregisterConfigurations(r){const n=[],i=a=>{if(a.properties)for(const l in a.properties){n.push(l);const o=this.configurationProperties[l];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,a.properties[l])}a.allOf?.forEach(l=>i(l))};for(const a of r){i(a);const l=this.configurationContributors.indexOf(a);l!==-1&&this.configurationContributors.splice(l,1)}return n}validateAndRegisterProperties(r,n=!0,i,a,l=3){l=L.isUndefinedOrNull(r.scope)?l:r.scope;const o=[],s=r.properties;if(s)for(const g in s){const C=s[g];if(n&&m(g,C)){delete s[g];continue}if(C.source=i,C.defaultDefaultValue=s[g].default,this.updatePropertyDefaultValue(g,C),e.OVERRIDE_PROPERTY_REGEX.test(g)?C.scope=void 0:(C.scope=L.isUndefinedOrNull(C.scope)?l:C.scope,C.restricted=L.isUndefinedOrNull(C.restricted)?!!a?.includes(g):C.restricted),s[g].hasOwnProperty("included")&&!s[g].included){this.excludedConfigurationProperties[g]=s[g],delete s[g];continue}else this.configurationProperties[g]=s[g],s[g].policy?.name&&this.policyConfigurations.set(s[g].policy.name,g);!s[g].deprecationMessage&&s[g].markdownDeprecationMessage&&(s[g].deprecationMessage=s[g].markdownDeprecationMessage),o.push(g)}const c=r.allOf;if(c)for(const g of c)o.push(...this.validateAndRegisterProperties(g,n,i,a,l));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const n=i=>{const a=i.properties;if(a)for(const o in a)this.updateSchema(o,a[o]);i.allOf?.forEach(n)};n(r)}updateSchema(r,n){switch(e.allSettings.properties[r]=n,n.scope){case 1:e.applicationSettings.properties[r]=n;break;case 2:e.machineSettings.properties[r]=n;break;case 6:e.machineOverridableSettings.properties[r]=n;break;case 3:e.windowSettings.properties[r]=n;break;case 4:e.resourceSettings.properties[r]=n;break;case 5:e.resourceSettings.properties[r]=n,this.resourceLanguageSettingsSchema.properties[r]=n;break}}removeFromSchema(r,n){switch(delete e.allSettings.properties[r],n.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const n=`[${r}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,n){const i=this.configurationDefaultsOverrides.get(r);let a=i?.value,l=i?.source;L.isUndefined(a)&&(a=n.defaultDefaultValue,l=void 0),L.isUndefined(a)&&(a=h(n.type)),n.default=a,n.defaultValueSource=l}}const E="\\[([^\\]]+)\\]",d=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(u){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let n=d.exec(u);for(;n?.length;){const i=n[1].trim();i&&r.push(i),n=d.exec(u)}}return(0,R.distinct)(r)}e.overrideIdentifiersFromKey=S;function y(u){return u.reduce((r,n)=>`${r}[${n}]`,"")}e.keyFromOverrideIdentifiers=y;function h(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const v=new p;b.Registry.add(e.Extensions.Configuration,v);function m(u,r){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?T.localize(7,null,u):v.getConfigurationProperties()[u]!==void 0?T.localize(8,null,u):r.policy?.name&&v.getPolicyConfigurations().get(r.policy?.name)!==void 0?T.localize(9,null,u,r.policy?.name,v.getPolicyConfigurations().get(r.policy?.name)):null:T.localize(6,null)}e.validateProperty=m;function f(){const u=[],r=v.getConfigurationProperties();for(const n of Object.keys(r))u.push([n,r[n].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=f}),define(re[68],se([0,1,17,3,34,2,38,29,14,8,18,43,40]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class E{constructor(n={},i=[],a=[]){this._contents=n,this._keys=i,this._overrides=a,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const a=this.getContentsForOverrideIdentifer(i);return a?n?(0,D.getConfigurationValue)(a,n):a:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const a of this.overrides)a.identifiers.includes(n)&&i.push(...a.keys);return R.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return R.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),a=I.deepClone(this.overrides),l=[...this.keys];for(const o of n)if(!o.isEmpty()){this.mergeContents(i,o.contents);for(const s of o.overrides){const[c]=a.filter(g=>R.equals(g.identifiers,s.identifiers));c?(this.mergeContents(c.contents,s.contents),c.keys.push(...s.keys),c.keys=R.distinct(c.keys)):a.push(I.deepClone(s))}for(const s of o.keys)l.indexOf(s)===-1&&l.push(s)}return new E(i,l,a)}freeze(){return this.frozen=!0,this}clone(){return new E(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of R.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[l];const s=i[l];s&&(typeof o=="object"&&typeof s=="object"?(o=I.deepClone(o),this.mergeContents(o,s)):o=s),a[l]=o}return new E(a,this.keys,this.overrides)}mergeContents(n,i){for(const a of Object.keys(i)){if(a in n&&b.isObject(n[a])&&b.isObject(i[a])){this.mergeContents(n[a],i[a]);continue}n[a]=I.deepClone(i[a])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?I.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,a=null;const l=o=>{o&&(a?this.mergeContents(a,o):a=I.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[n])?i=o.contents:o.identifiers.includes(n)&&l(o.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,D.addToValueTree)(this.contents,n,i,a=>{throw new Error(a)})}removeValue(n){this.removeKey(n)&&(0,D.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let a=0;a<i;a++)n.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,n)}removeKey(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=E;class d{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!b.isUndefinedOrNull(n)){const a=this.doParseContent(n);this.parseRaw(a,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:a,keys:l,overrides:o,restricted:s}=this.doParseRaw(n,i);this._configurationModel=new E(a,l,o),this._restrictedConfigurations=s||[]}doParseContent(n){let i={},a=null,l=[];const o=[],s=[];function c(C){Array.isArray(l)?l.push(C):a!==null&&(l[a]=C)}const g={onObjectBegin:()=>{const C={};c(C),o.push(l),l=C,a=null},onObjectProperty:C=>{a=C},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const C=[];c(C),o.push(l),l=C,a=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:c,onError:(C,O,_)=>{s.push({error:C,offset:O,length:_})}};if(n)try{L.visit(n,g),i=l[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return i}doParseRaw(n,i){const a=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),l=this.filter(n,a,!0,i);n=l.raw;const o=(0,D.toValuesTree)(n,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),s=Object.keys(n),c=this.toOverrides(n,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:o,keys:s,overrides:c,restricted:l.restricted}}filter(n,i,a,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:n,restricted:[]};const o={},s=[];for(const c in n)if(w.OVERRIDE_PROPERTY_REGEX.test(c)&&a){const g=this.filter(n[c],i,!1,l);o[c]=g.raw,s.push(...g.restricted)}else{const g=i[c],C=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&s.push(c),(C===void 0||l.scopes===void 0||l.scopes.includes(C))&&(l.skipRestricted&&g?.restricted||(o[c]=n[c]))}return{raw:o,restricted:s}}toOverrides(n,i){const a=[];for(const l of Object.keys(n))if(w.OVERRIDE_PROPERTY_REGEX.test(l)){const o={};for(const s in n[l])o[s]=n[l][s];a.push({identifiers:(0,w.overrideIdentifiersFromKey)(l),keys:Object.keys(o),contents:(0,D.toValuesTree)(o,i)})}return a}}e.ConfigurationModelParser=d;class S extends T.Disposable{constructor(n,i,a,l){super();this.userSettingsResource=n,this.scopes=i,this.fileService=l,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&a.isEqual(o.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class y{constructor(n,i,a,l,o=new E,s=new E,c=new A.ResourceMap,g=new E,C=new A.ResourceMap,O=!0){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=a,this._localUserConfiguration=l,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=g,this._memoryConfigurationByResource=C,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,i,a){return this.getConsolidatedConfigurationModel(n,i,a).getValue(n)}updateValue(n,i,a={}){let l;a.resource?(l=this._memoryConfigurationByResource.get(a.resource),l||(l=new E,this._memoryConfigurationByResource.set(a.resource,l))):l=this._memoryConfiguration,i===void 0?l.removeValue(n):l.setValue(n,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,a){const l=this.getConsolidatedConfigurationModel(n,i,a),o=this.getFolderConfigurationModelForResource(i.resource,a),s=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,c=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),g=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),C=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),O=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),_=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),N=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),k=a?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,M=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(n):o.freeze().getValue(n):void 0,U=i.overrideIdentifier?s.override(i.overrideIdentifier).getValue(n):s.getValue(n),H=l.getValue(n),W=R.distinct(l.overrides.map(z=>z.identifiers).flat()).filter(z=>l.getOverrideValue(n,z)!==void 0);return{defaultValue:c,policyValue:g,applicationValue:C,userValue:O,userLocalValue:_,userRemoteValue:N,workspaceValue:k,workspaceFolderValue:M,memoryValue:U,value:H,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,policy:g!==void 0?{value:g}:void 0,application:C!==void 0?{value:C,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:M!==void 0?{value:o?.freeze().getValue(n),override:i.overrideIdentifier?o?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:s.getValue(n),override:i.overrideIdentifier?s.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const a=[];if(!i){const{added:l,updated:o,removed:s}=f(this._defaultConfiguration,n);i=[...l,...o,...s]}for(const l of i)for(const o of(0,w.overrideIdentifiersFromKey)(l)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(o),c=n.getKeysForOverrideIdentifier(o),g=[...c.filter(C=>s.indexOf(C)===-1),...s.filter(C=>c.indexOf(C)===-1),...s.filter(C=>!I.equals(this._defaultConfiguration.override(o).getValue(C),n.override(o).getValue(C)))];a.push([o,g])}return this.updateDefaultConfiguration(n),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:a,removed:l}=f(this._policyConfiguration,n),o=[...i,...a,...l];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:a,removed:l,overrides:o}=f(this.applicationConfiguration,n),s=[...i,...a,...l];return s.length&&this.updateApplicationConfiguration(n),{keys:s,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:a,removed:l,overrides:o}=f(this.localUserConfiguration,n),s=[...i,...a,...l];return s.length&&this.updateLocalUserConfiguration(n),{keys:s,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:a,removed:l,overrides:o}=f(this.remoteUserConfiguration,n),s=[...i,...a,...l];return s.length&&this.updateRemoteUserConfiguration(n),{keys:s,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:a,removed:l,overrides:o}=f(this.workspaceConfiguration,n),s=[...i,...a,...l];return s.length&&this.updateWorkspaceConfiguration(n),{keys:s,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const a=this.folderConfigurations.get(n),{added:l,updated:o,removed:s,overrides:c}=f(a,i),g=[...l,...o,...s];return(g.length||!a)&&this.updateFolderConfiguration(n,i),{keys:g,overrides:c}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:a,updated:l,removed:o,overrides:s}=f(i,void 0);return{keys:[...a,...l,...o],overrides:s}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,a){let l=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:n},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const l=i.getFolder(n);l&&(a=this.getFolderConsolidatedConfiguration(l.uri)||a);const o=this._memoryConfigurationByResource.get(n);o&&(a=a.merge(o))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(n);l?(i=a.merge(l),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=a}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const a=i.getFolder(n);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:a,overrides:l,keys:o}=this._folderConfigurations.get(i);return n.push([i,{contents:a,overrides:l,keys:o}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(a=>n.add(a))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>n.add(a))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(n).forEach(l=>i.add(l))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),a=this.parseConfigurationModel(n.policy),l=this.parseConfigurationModel(n.application),o=this.parseConfigurationModel(n.user),s=this.parseConfigurationModel(n.workspace),c=n.folders.reduce((g,C)=>(g.set(P.URI.revive(C[0]),this.parseConfigurationModel(C[1])),g),new A.ResourceMap);return new y(i,a,l,o,new E,s,c,new E,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=y;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,i=new Map;for(const l of r)l.keys.forEach(o=>n.add(o)),l.overrides.forEach(([o,s])=>{const c=(0,A.getOrSet)(i,o,new Set);s.forEach(g=>c.add(g))});const a=[];return i.forEach((l,o)=>a.push([o,[...l.values()]])),{keys:[...n.values()],overrides:a}}e.mergeChanges=h;class v{constructor(n,i,a,l){this.change=n,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=l,this._previousConfiguration=void 0;const o=new Set;n.keys.forEach(c=>o.add(c)),n.overrides.forEach(([,c])=>c.forEach(g=>o.add(g))),this.affectedKeys=[...o.values()];const s=new E;this.affectedKeys.forEach(c=>s.setValue(c,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!I.equals(a,l)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let a=(0,D.toValuesTree)({[i]:!0},()=>{}),l;for(;typeof a=="object"&&(l=Object.keys(a)[0]);){if(n=n[l],!n)return!1;a=a[l]}return!0}}e.ConfigurationChangeEvent=v;class m extends v{constructor(n,i,a,l){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=a,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=m;function f(r,n){const{added:i,removed:a,updated:l}=u(n,r),o=[],s=r?.getAllOverrideIdentifiers()||[],c=n?.getAllOverrideIdentifiers()||[];if(n){const g=c.filter(C=>!s.includes(C));for(const C of g)o.push([C,n.getKeysForOverrideIdentifier(C)])}if(r){const g=s.filter(C=>!c.includes(C));for(const C of g)o.push([C,r.getKeysForOverrideIdentifier(C)])}if(n&&r){for(const g of s)if(c.includes(g)){const C=u({contents:r.getOverrideValue(void 0,g)||{},keys:r.getKeysForOverrideIdentifier(g)},{contents:n.getOverrideValue(void 0,g)||{},keys:n.getKeysForOverrideIdentifier(g)});o.push([g,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:a,updated:l,overrides:o}}function u(r,n){const i=r?n?r.keys.filter(o=>n.keys.indexOf(o)===-1):[...r.keys]:[],a=n?r?n.keys.filter(o=>r.keys.indexOf(o)===-1):[...n.keys]:[],l=[];if(r&&n){for(const o of n.keys)if(r.keys.indexOf(o)!==-1){const s=(0,D.getConfigurationValue)(n.contents,o),c=(0,D.getConfigurationValue)(r.contents,o);I.equals(s,c)||l.push(o)}}return{added:i,removed:a,updated:l}}}),define(re[196],se([0,1,17,3,2,29,14,18,68,43,7,58,40]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class E extends L.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:m})=>this.onDidUpdateConfiguration(v,m))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,m){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=E;class d extends b.ConfigurationModel{constructor(v={}){const m=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(m),u=Object.create(null),r=[];for(const n in m){const i=v[n],a=i!==void 0?i:m[n].default;(0,I.addToValueTree)(u,n,a,l=>console.error(`Conflict in default settings: ${l}`))}for(const n of Object.keys(u))P.OVERRIDE_PROPERTY_REGEX.test(n)&&r.push({identifiers:(0,P.overrideIdentifiersFromKey)(n),keys:Object.keys(u[n]),contents:(0,I.toValuesTree)(u[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(u,f,r)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new b.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let y=class extends L.Disposable{constructor(v,m,f){super();this.defaultConfiguration=v,this.policyService=m,this.logService=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const m={},f=[],u=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const r of v){const n=u[r];if(!n){f.push(r);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(r),m[n.policy.name]={type:n.type}}}return(0,A.isEmptyObject)(m)||await this.policyService.registerPolicyDefinitions(m),f}onDidChangePolicies(v){const m=p.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(v.map(u=>m.get(u)));this.update(f,!0)}update(v,m){const f=p.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),u=[],r=this._configurationModel.isEmpty();for(const n of v){const i=f[n]?.policy?.name;if(i){const a=this.policyService.getPolicyValue(i);(r?a!==void 0:!(0,T.equals)(this._configurationModel.getValue(n),a))&&u.push([n,a])}else this._configurationModel.getValue(n)!==void 0&&u.push([n,void 0])}if(u.length){const n=this._configurationModel;this._configurationModel=new b.ConfigurationModel;for(const i of n.keys)this._configurationModel.setValue(i,n.getValue(i));for(const[i,a]of u)a===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,a);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=me([Q(1,w.IPolicyService),Q(2,D.ILogService)],y),e.PolicyConfiguration=y}),define(re[197],se([0,1,6,3,2,19,18,68,196,58]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends L.Disposable{constructor(p,E,d,S){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new b.DefaultConfiguration),this.policyConfiguration=d instanceof P.NullPolicyService?new b.NullPolicyConfiguration:this._register(new b.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,E)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:h})=>this.onDidDefaultConfigurationChange(y,h))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,E,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(p,E,new I.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(p,E){const d=typeof p=="string"?p:void 0,S=(0,A.isConfigurationOverrides)(p)?p:(0,A.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(d,S,void 0)}updateValue(p,E,d,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const E=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(d,E,1)}onDidDefaultConfigurationChange(p,E){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(p,E);this.trigger(S,d,6)}onDidPolicyConfigurationChange(p){const E=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(d,E,6)}trigger(p,E,d){const S=new I.ConfigurationChangeEvent(p,{data:E},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(re[198],se([0,1,9,5]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var L;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends R.ErrorNoTelemetry{constructor(I,b=L.Unknown,P){super(I);this._message=I,this._code=b,this._detail=P,this.isHandled=b===L.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(I){return I instanceof T&&I._code===L.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof T&&I._code===L.NoResolverFound}static isHandled(I){return I instanceof T&&I.isHandled}}e.RemoteAuthorityResolverError=T}),define(re[99],se([0,1,20]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===R.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function L(P){if(!P)return;const D=P.indexOf("+");return D<0?P:P.substr(0,D)}e.getRemoteName=L;function T(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=T;function A(P){const{host:D,port:w}=b(P);if(typeof w=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:w}}e.parseAuthorityWithPort=A;function I(P,D){let{host:w,port:p}=b(P);return typeof p=="undefined"&&(p=D),{host:w,port:p}}e.parseAuthorityWithOptionalPort=I;function b(P){const D=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const w=P.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=P.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:P,port:void 0}}}),define(re[50],se([0,1,26,5,99]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=T;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var b;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,y){if(typeof S=="undefined"||S===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof S=="string"||typeof y=="string"){const h=typeof S=="string"?S:S.value,v=typeof y=="string"?y:y.value;return R.equalsIgnoreCase(h,v)}return S._lower===y._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=P;function D(d){return w(d)}e.isApplicationScopedExtension=D;function w(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function E(d,S){if(S){const y=`onResolveRemoteAuthority:${(0,L.getRemoteName)(S)}`;return d.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[32],se([0,1,26,30,50,4,8,9,35]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,a){return i.uuid&&a.uuid?i.uuid===a.uuid:i.id===a.id?!0:(0,R.compareIgnoreCase)(i.id,a.id)===0}e.areSameExtensions=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(a,l,o="undefined"){this.version=l,this.targetPlatform=o,this.id=a.id}static create(a){const l=a.manifest?a.manifest.version:a.version,o=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new w(a.identifier,l,o)}static parse(a){const l=D.exec(a);return l&&l[1]&&l[2]?new w({id:l[1]},l[2],l[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof w?P(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=w;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const a=p.exec(i);return a&&a[1]?[S(a[1]),a[2]]:[S(i),void 0]}e.getIdAndVersion=E;function d(i,a){return`${i}.${a}`}e.getExtensionId=d;function S(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function y(i,a){return S(d(i,a))}e.getGalleryExtensionId=y;function h(i,a){const l=[],o=s=>{for(const c of l)if(c.some(g=>P(a(g),a(s))))return c;return null};for(const s of i){const c=o(s);c?c.push(s):l.push([s])}return l}e.groupByExtension=h;function v(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function m(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function f(i){const a=new Set;if(i.malicious)for(const l of i.malicious)a.add(l.id);return a}e.getMaliciousExtensionsSet=f;function u(i,a){const l=[],o=a.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const s=o.shift();if(s&&l.every(c=>!P(c.identifier,{id:s}))){const c=i.filter(g=>P(g.identifier,{id:s}));c.length===1&&(l.push(c[0]),o.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=u;async function r(i,a){if(!T.isLinux)return!1;let l;try{l=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){a.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(s))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function n(i,a){const l=await r(i,a),o=(0,t.getTargetPlatform)(l?"alpine":T.platform,b.arch);return a.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=n}),define(re[199],se([0,1,23,32]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,I,b,P){try{const D=await T.getExtensionsControlManifest();if(!D.deprecated)return;const w=await T.getInstalled(1);for(const[p,E]of Object.entries(D.deprecated)){if(!E?.extension)continue;const{id:d,autoMigrate:S,preRelease:y}=E.extension;if(!S)continue;const h=w.find(m=>(0,t.areSameExtensions)(m.identifier,{id:p}));if(!h)continue;const v=(await A.getExtensions([{id:d,preRelease:y}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!v){P.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{P.info(`Migrating '${h.identifier.id}' extension to '${d}' extension...`);const m=!b.getDisabledExtensions().some(u=>(0,t.areSameExtensions)(u,h.identifier));await T.uninstall(h),P.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let f=w.find(u=>(0,t.areSameExtensions)(u.identifier,{id:d}));(!f||!f.isPreReleaseVersion&&m)&&(f=await T.installFromGallery(v,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),P.info(`Installed the pre-release extension '${f.identifier.id}'`),m||(await b.disableExtension(f.identifier),P.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),S.storage&&(I.addToMigrationList((0,t.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,t.getExtensionId)(f.manifest.publisher,f.manifest.name)),P.info("Added pre-release extension to the storage migration list"))),P.info(`Migrated '${h.identifier.id}' extension to '${d}' extension.`)}catch(m){P.error(m)}}}catch(D){P.error(D)}}e.migrateUnsupportedExtensions=L}),define(re[200],se([0,1,6,9,2,4,19,55,8,31,27,15,30,32,13,7]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=class extends L.Disposable{constructor(v,m,f,u){super();this.fileService=m,this.extensionGalleryService=f,this.logService=u,this.extensionsDownloadDir=b.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,m){await this.cleanUpPromise;const f=this.getName(v),u=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(u)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(v,r,m);try{await this.rename(r,u,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,r.path),n}}return u}async delete(v){await this.cleanUpPromise,await this.fileService.del(v)}async rename(v,m,f){try{await D.Promises.rename(v.fsPath,m.fsPath)}catch(u){if(T.isWindows&&u&&u.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${v} to ${m} with 'EPERM' error. Trying again...`),this.rename(v,m,f);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const m=[],f=[];for(const n of v.children){const i=E.ExtensionKey.parse(n.name);i&&f.push([i,n])}const u=(0,E.groupByExtension)(f,([n])=>n),r=[];for(const n of u)n.sort((i,a)=>I.rcompare(i[0].version,a[0].version)),m.push(...n.slice(1).map(i=>i[1].resource)),r.push(n[0][1]);r.sort((n,i)=>n.mtime-i.mtime),m.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(n=>n.resource)),await R.Promises.settled(m.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?E.ExtensionKey.create(v).toString().toLowerCase():(0,P.generateUuid)()}};y=me([Q(0,w.INativeEnvironmentService),Q(1,d.IFileService),Q(2,p.IExtensionGalleryService),Q(3,S.ILogService)],y),e.ExtensionsDownloader=y}),define(re[201],se([0,1,2,12,27,50]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(b,P){super();this.environmentService=b,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(P.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(P.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(b){b.some(P=>!!P.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(re[202],se([0,1,176,17,6,2,20,12,27,15,30,32,7,66]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends E.LanguagePackBaseService{constructor(v,m,f,u){super(f);this.extensionManagementService=v,this.logService=u,this.cache=this._register(new S(m,u)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getInstalledLanguages(){const v=await this.cache.getLanguagePacks(),m=Object.keys(v).map(f=>{const u=v[f];return{...this.createQuickPickItem({locale:f,label:u.label}),extensionId:u.extensions[0].extensionIdentifier.id}});return m.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),m}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const m=await this.cache.getLanguagePacks();Object.keys(m).some(f=>m[f]&&m[f].extensions.some(u=>(0,w.areSameExtensions)(u.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(m);return!(0,t.equals)(Object.keys(v),Object.keys(f))}};d=me([Q(0,D.IExtensionManagementService),Q(1,P.INativeEnvironmentService),Q(2,D.IExtensionGalleryService),Q(3,p.ILogService)],d),e.NativeLanguagePackService=d;let S=class extends T.Disposable{constructor(v,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(m=>{Object.keys(m).forEach(f=>delete m[f]),this.createLanguagePacksFromExtensions(m,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...m){for(const f of m)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,f);Object.keys(v).forEach(f=>this.updateHash(v[f]))}createLanguagePacksFromExtension(v,m){const f=m.identifier,u=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const r of u)if(m.location.scheme===A.Schemas.file&&y(r)){let n=v[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},v[r.languageId]=n);const i=n.extensions.filter(a=>(0,w.areSameExtensions)(a.extensionIdentifier,f))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:f,version:m.manifest.version});for(const a of r.translations)n.translations[a.id]=(0,I.join)(m.location.fsPath,a.path)}}updateHash(v){if(v){const m=(0,R.createHash)("md5");for(const f of v.extensions)m.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);v.hash=m.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(m=v(f),f)).then(f=>{for(const r of Object.keys(f))f[r]||delete f[r];this.languagePacks=f,this.initializedCache=!0;const u=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",u),b.Promises.writeFile(this.languagePacksFilePath,u)}).then(()=>m,f=>this.logService.error(f))})}};S=me([Q(0,P.INativeEnvironmentService),Q(1,p.ILogService)],S);function y(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const v of h.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(re[203],se([0,1,6,16,23,9,3,2,31,84,198,99]),function(Z,e,R,t,L,T,A,I,b,P,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var E;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function d(x){switch(x){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(x){const B=new L.CancellationTokenSource;return setTimeout(()=>B.cancel(),x),B.token}function y(x,B){if(x.isCancellationRequested||B.isCancellationRequested)return L.CancellationToken.Cancelled;const J=new L.CancellationTokenSource;return x.onCancellationRequested(()=>J.cancel()),B.onCancellationRequested(()=>J.cancel()),J.token}class h{constructor(B){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((J,F)=>{this._resolvePromise=J,this._rejectPromise=F}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function v(x,B){const J=new h(B);return J.registerDisposable(x.onControlMessage(F=>{const $=JSON.parse(F.toString()),j=te($);j?J.reject(j):J.resolve($)})),J.promise}function m(x,B,J,F,$,j,K,q){const ee=new h(q);return B.connect(J,F,$,j,K,(ne,oe)=>{ee.didTimeout?(ne&&x.error(ne),oe?.dispose()):ne||!oe?ee.reject(ne):ee.resolve(oe)}),ee.promise}function f(x,B){const J=new h(B);return x.then(F=>{J.didTimeout||J.resolve(F)},F=>{J.didTimeout||J.reject(F)}),J.promise}async function u(x,B,J,F){const $=X(x,B);x.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let j;try{j=await m(x.logService,x.socketFactory,x.host,x.port,(0,w.getRemoteServerRootPath)(x),`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,`renderer-${d(B)}-${x.reconnectionToken}`,F)}catch(oe){throw x.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),x.logService.error(oe),oe}x.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let K,q;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(j,null),K=x.reconnectionProtocol,q=!1):(K=new P.PersistentProtocol(j,null),q=!0),x.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const ee=await f(x.signService.createNewMessage((0,b.generateUuid)()),F),ne={type:"auth",auth:x.connectionToken||"00000000000000000000",data:ee.data};K.sendControl(t.VSBuffer.fromString(JSON.stringify(ne)));try{const oe=await v(K,y(F,S(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(x.logService.trace(`${$} 4/6. received SignRequest control message.`),!await f(x.signService.validate(ee,oe.signedData),F)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const Se=await f(x.signService.sign(oe.data),F),fe={type:"connectionType",commit:x.commit,signedData:Se,desiredConnectionType:B};return J&&(fe.args=J),x.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(t.VSBuffer.fromString(JSON.stringify(fe))),{protocol:K,ownsProtocol:q}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(x.logService.error(`${$} the handshake timed out. Error:`),x.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${$} received error control message when negotiating connection. Error:`),x.logService.error(oe)),q&&z(K),oe}}async function r(x,B,J,F){const $=Date.now(),j=X(x,B),{protocol:K,ownsProtocol:q}=await u(x,B,J,F),ee=new h(F);return ee.registerDisposable(K.onControlMessage(ne=>{const oe=JSON.parse(ne.toString()),le=te(oe);le?(x.logService.error(`${j} received error control message when negotiating connection. Error:`),x.logService.error(le),q&&z(K),ee.reject(le)):(x.reconnectionProtocol&&x.reconnectionProtocol.endAcceptReconnection(),x.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Y($)}!`),ee.resolve({protocol:K,firstMessage:oe}))})),ee.promise}async function n(x,B){const{protocol:J}=await r(x,1,void 0,B);return{protocol:J}}async function i(x,B,J){const{protocol:F,firstMessage:$}=await r(x,2,B,J),j=$&&$.debugPort;return{protocol:F,debugPort:j}}async function a(x,B,J){const F=Date.now(),$=X(x,3),{protocol:j}=await u(x,3,B,J);return x.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Y(F)}!`),j}async function l(x,B,J){const{host:F,port:$,connectionToken:j}=await x.addressProvider.getAddress();return{commit:x.commit,quality:x.quality,host:F,port:$,connectionToken:j,reconnectionToken:B,reconnectionProtocol:J,socketFactory:x.socketFactory,signService:x.signService,logService:x.logService}}async function o(x,B,J){try{const F=(0,b.generateUuid)(),$=await l(x,F,null),{protocol:j}=await n($,L.CancellationToken.None);return new H(x,B,J,F,j)}catch(F){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(F),U.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=o;async function s(x,B){try{const J=(0,b.generateUuid)(),F=await l(x,J,null),{protocol:$,debugPort:j}=await i(F,B,L.CancellationToken.None);return new W(x,B,J,$,j)}catch(J){throw x.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),x.logService.error(J),U.triggerPermanentFailure(0,0,D.RemoteAuthorityResolverError.isHandled(J)),J}}e.connectRemoteAgentExtensionHost=s;async function c(x,B,J){const F=await l(x,(0,b.generateUuid)(),null);return await a(F,{host:B,port:J},L.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function g(x){return(0,R.createCancelablePromise)(B=>new Promise((J,F)=>{const $=setTimeout(J,x*1e3);B.onCancellationRequested(()=>{clearTimeout($),J()})}))}var C;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(C=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(B,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.type=0}}e.ConnectionLostEvent=O;class _{constructor(B,J,F,$){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.durationSeconds=F,this.cancellableTimer=$,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class N{constructor(B,J,F){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=N;class k{constructor(B,J,F){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=F,this.type=4}}e.ConnectionGainEvent=k;class M{constructor(B,J,F,$){this.reconnectionToken=B,this.millisSinceLastIncomingData=J,this.attempt=F,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class U extends I.Disposable{constructor(B,J,F,$,j){super();this._connectionType=B,this._options=J,this.reconnectionToken=F,this.protocol=$,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new k(this.reconnectionToken,0,0)),this._register($.onSocketClose(K=>{const q=G(this._connectionType,this.reconnectionToken,!0);K?K.type===0?(this._options.logService.info(`${q} received socket close event (hadError: ${K.hadError}).`),K.error&&this._options.logService.error(K.error)):(this._options.logService.info(`${q} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this._options.logService.error(K.event)):this._options.logService.info(`${q} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(()=>{const K=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${K} received socket timeout event.`),this._beginReconnecting()})),U._instances.push(this),this._register((0,I.toDisposable)(()=>{const K=U._instances.indexOf(this);K>=0&&U._instances.splice(K,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(U._permanentFailureMillisSinceLastIncomingData,U._permanentFailureAttempt,U._permanentFailureHandled)}static triggerPermanentFailure(B,J,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=J,this._permanentFailureHandled=F,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(B=>B._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(B=>B._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||U._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const B=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const J=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const $=F<J.length?J[F]:J[J.length-1];try{if($>0){const K=g($);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,K)),this._options.logService.info(`${B} waiting for ${$} seconds before reconnecting...`);try{await K}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${B} resolving connection...`);const j=await l(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,S(p)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(D.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,T.isCancellationError)(j)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof D.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,D.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(B,J,F){this._reconnectionFailureIsFatal?U.triggerPermanentFailure(B,J,F):this._gotoPermanentFailure(B,J,F)}_gotoPermanentFailure(B,J,F){this._onDidStateChange.fire(new M(this.reconnectionToken,B,J,F)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=U,U._permanentFailure=!1,U._permanentFailureMillisSinceLastIncomingData=0,U._permanentFailureAttempt=0,U._permanentFailureHandled=!1,U._instances=[];class H extends U{constructor(B,J,F,$,j){super(1,B,$,j,!0);this.client=this._register(new P.Client(j,{remoteAuthority:J,clientId:F},B.ipcLogger))}async _reconnect(B,J){await n(B,J)}}e.ManagementPersistentConnection=H;class W extends U{constructor(B,J,F,$,j){super(2,B,F,$,!1);this._startArguments=J,this.debugPort=j}async _reconnect(B,J){await i(B,this._startArguments,J)}}e.ExtensionHostPersistentConnection=W;function z(x){try{x.acceptDisconnect();const B=x.getSocket();x.dispose(),B.dispose()}catch(B){(0,T.onUnexpectedError)(B)}}function te(x){if(x&&x.type==="error"){const B=new Error(`Connection error: ${x.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function V(x,B){for(;x.length<B;)x+=" ";return x}function G(x,B,J){return`[remote-connection][${V(d(x),13)}][${B.substr(0,5)}\u2026][${J?"reconnect":"initial"}]`}function X(x,B){return`${G(B,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.host}:${x.port}]`}function Y(x){return`${Date.now()-x} ms`}}),define(re[204],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[205],se([0,1,77,134]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,I,b,P){const D=p=>P(p,void 0),w=R.createConnection({host:L,port:T},()=>{w.removeListener("error",D);const p=Buffer.alloc(16);for(let y=0;y<16;y++)p[y]=Math.round(Math.random()*256);const E=p.toString("base64"),d=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}${A}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];w.write(d.join(`\r
`)+`\r
\r
`);const S=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),P(void 0,new t.NodeSocket(w,b)))};w.on("data",S)});w.setNoDelay(!0),w.once("error",D)}}}),define(re[206],se([0,1,118,18,7]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(I,b){this.configurationService=I,this.logService=b}async request(I,b){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const P=await(0,R.request)(I,b);return this.logService.trace("RequestService#request (browser) - success",I.url),P}catch(P){throw this.logService.error("RequestService#request (browser) - error",I.url,P),P}}async resolveProxy(I){}};T=me([Q(0,t.IConfigurationService),Q(1,L.ILogService)],T),e.RequestService=T}),define(re[44],se([0,1,16,153,43,5,40]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function I(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=I;function b(S){return S.res.statusCode===204}async function P(S){return b(S)?null:(await(0,R.streamToBuffer)(S.stream)).toString()}e.asText=P;async function D(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);return P(S)}e.asTextOrError=D;async function w(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);if(b(S))return null;const h=(await(0,R.streamToBuffer)(S.stream)).toString();try{return JSON.parse(h)}catch(v){throw v.message+=`:
`+h,v}}e.asJson=w;function p(S){d(S)}e.updateProxyConfigurationsScope=p;let E;function d(S){const y=A.Registry.as(L.Extensions.Configuration),h=E;E={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[E],remove:h?[h]:[]})}d(2)}),define(re[207],se([0,1,23,20,13,44]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(b,P){this.requestService=b,this.fileService=P}async download(b,P,D=R.CancellationToken.None){if(b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(b,P);return}const w={type:"GET",url:b.toString(!0)},p=await this.requestService.request(w,D);if(p.res.statusCode===200)await this.fileService.writeFile(P,p.stream);else{const E=await(0,T.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${E}`)}}};A=me([Q(0,T.IRequestService),Q(1,L.IFileService)],A),e.DownloadService=A}),define(re[208],se([0,1,17,23,74,2,19,169,13,7,24,44]),function(Z,e,R,t,L,T,A,I,b,P,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let p=class extends T.Disposable{constructor(d,S,y,h){super();this.fileService=d,this.productService=S,this.requestService=y,this.logService=h,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const S=[];for(const[y,h]of this.allConfigBasedTips)if(!(h.configScheme&&h.configScheme!==d.scheme))try{const v=await this.fileService.readFile((0,A.joinPath)(d,y)),m=new Map;(0,L.forEach)(h.recommendations,({key:u,value:r})=>{if((0,R.isNonEmptyArray)(r.remotes))for(const n of r.remotes)m.set(n,{extensionId:u,extensionName:r.name,configName:h.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled});else S.push({extensionId:u,extensionName:r.name,configName:h.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack,whenNotInstalled:r.whenNotInstalled})});const f=(0,I.getDomainsOfRemotes)(v.value.toString(),[...m.keys()]);for(const u of f){const r=m.get(u);r&&S.push(r)}}catch{}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const d=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(d.res.statusCode!==200)return[];const S=await(0,w.asJson)(d);return S?S.workspaceRecommendations||[]:[]}catch(d){return this.logService.error(d),[]}}};p=me([Q(0,b.IFileService),Q(1,D.IProductService),Q(2,w.IRequestService),Q(3,P.ILogService)],p),e.ExtensionTipsService=p}),define(re[100],se([0,1,62,5]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,R.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[209],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[210],se([0,1,85,6,23,3,2,20,31,7,100,209]),function(Z,e,R,t,L,T,A,I,b,P,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const y=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${y})`);const h=(0,D.hash)(S);this.processeDisposables.has(h)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${y})`),this.doDisposeWorker(S));const v=new L.CancellationTokenSource;let m,f,u;this.processeDisposables.set(h,a=>{v.dispose(!0),m?.terminate(S,L.CancellationToken.None),f?.close(),u?.close(),this.processeDisposables.delete(h);const l=this.processResolvers.get(h);l&&(this.processResolvers.delete(h),l({reason:a}))}),m=await this.getOrCreateWebWorker(S);const r=new Promise(a=>{this.processResolvers.set(h,a)});if(v.token.isCancellationRequested)return r;const{port1:n,port2:i}=new MessageChannel;return f=n,u=i,await m.spawn(S,u,v.token),v.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${y})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),r}getOrCreateWebWorker(S){let y=this.workers.get(S.process.moduleId);if(!y){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const h=new E(S.process.type,this.logService);y=h.init(),h.onDidProcessSelfTerminate(({configuration:v,reason:m})=>{this.doDisposeWorker(v,m)}),this.workers.set(S.process.moduleId,y)}return y}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,y){const h=this.processeDisposables.get((0,D.hash)(S));h&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),h(y))}};p=me([Q(0,P.ILogService)],p),e.SharedProcessWorkerService=p;class E extends A.Disposable{constructor(S,y){super();this.type=S,this.logService=y,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new t.DeferredPromise,y=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return y.onerror=h=>{this.logService.error(`SharedProcess: worker error (${this.type})`,h.message)},y.onmessageerror=h=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,h)},y.onmessage=h=>{const{id:v,message:m,configuration:f,nonce:u}=h.data;switch(v){case w.SharedProcessWorkerMessages.Ready:S.complete(y);break;case w.SharedProcessWorkerMessages.Ack:if(u){const r=this.mapMessageNonceToPendingMessageResolve.get(u);r&&(this.mapMessageNonceToPendingMessageResolve.delete(u),r())}break;case w.SharedProcessWorkerMessages.SelfTerminated:f&&m&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(m)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,m);break;case w.SharedProcessWorkerMessages.Info:m&&this.logService.info(m);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,m);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,m);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,h)}},y.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,y,h){const v=await this.workerReady;if(!y.isCancellationRequested)return new Promise(m=>{const f=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,m);const u={...S,nonce:f};h?v.postMessage(u,[h]):v.postMessage(u),y.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&m()})})}spawn(S,y,h){const v={id:w.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Z).fsPath}};return this.send(v,h,y)}terminate(S,y){const h={id:w.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(h,y)}}}),define(re[211],se([0,1,60,20,168]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.vscodeUserData})}}me([R.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(re[212],se([0,1,48,12,154,23,37,9,4,31,136,166,6]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const E=1e4;let d;async function S(h,v,m){return v["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(m)&&!v["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(m)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=p.Promises.withAsyncBody(async(f,u)=>{const r=new T.CancellationTokenSource,n=setTimeout(()=>{r.dispose(!0),u(new Error((0,L.localize)(0,null)))},E);try{f(await y(h,r.token))}catch(i){!(0,I.isCancellationError)(i)&&!r.token.isCancellationRequested?u(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(i)))):f({})}finally{clearTimeout(n),r.dispose()}})),d)}e.getResolvedShellEnv=S;async function y(h,v){const m=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",m);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",f);const u=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",n);const i=await(0,D.getSystemShell)(b.OS,n);return h.trace("getUnixShellEnvironment#shell",i),new Promise((a,l)=>{if(v.isCancellationRequested)return l((0,I.canceled)());const o=(0,t.basename)(i);let s,c;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(s=`& '${process.execPath}' ${g} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,c=["-Login","-Command"]):(s=`'${process.execPath}' ${g} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?c=["-ic"]:c=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),s);const C=(0,R.spawn)(i,[...c,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});v.onCancellationRequested(()=>(C.kill(),l((0,I.canceled)()))),C.on("error",N=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(N)),l(N)});const O=[];C.stdout.on("data",N=>O.push(N));const _=[];C.stderr.on("data",N=>_.push(N)),C.on("close",(N,k)=>{const M=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",M);const U=Buffer.concat(_).toString("utf8");if(U.trim()&&h.trace("getUnixShellEnvironment#stderr",U),N||k)return l(new Error((0,L.localize)(2,null,N,k)));const H=r.exec(M),W=H?H[1]:"{}";try{const z=JSON.parse(W);m?z.ELECTRON_RUN_AS_NODE=m:delete z.ELECTRON_RUN_AS_NODE,f?z.ELECTRON_NO_ATTACH_CONSOLE=f:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",z),a(z)}catch(z){h.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(z)),l(z)}})})}}),define(re[101],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[213],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>Z(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const I=String(R._nextId++);return this.validators.set(I,A),{id:I,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=R,R._nextId=1}),define(re[214],se([0,1,3,2]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class L extends t.Disposable{constructor(D,w,p){super();this.channel=D,this.profile=w,this.workspace=p}async getItems(){const D={profile:this.profile,workspace:this.workspace},w=await this.channel.call("getItems",D);return new Map(w)}updateItems(D){const w={profile:this.profile,workspace:this.workspace};return D.insert&&(w.insert=Array.from(D.insert.entries())),D.delete&&(w.delete=Array.from(D.delete.values())),this.channel.call("updateItems",w)}}class T extends L{constructor(D,w){super(D,w,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(D=>this.onDidChangeStorage(D)))}onDidChangeStorage(D){(Array.isArray(D.changed)||Array.isArray(D.deleted))&&this._onDidChangeItemsExternal.fire({changed:D.changed?new Map(D.changed):void 0,deleted:D.deleted?new Set(D.deleted):void 0})}}class A extends T{constructor(D){super(D,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class I extends T{constructor(D,w){super(D,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class b extends L{constructor(D,w){super(D,void 0,w);this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=b}),define(re[215],se([0,1,4,35,8,31]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(R.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function I(P,D,w,p,E,d,S,y,h,v){const m=Object.create(null);m["common.machineId"]=S,m.sessionID=(0,T.generateUuid)()+Date.now(),m.commitHash=E,m.version=d,m["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,R.PlatformToString)(R.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=p,m["common.product"]=v||"desktop";const f=b(y||[]);f&&(m["common.msftInternal"]=f);let u=0;const r=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),R.isLinuxSnap&&(m["common.snap"]="true");const n=A(w);n&&(m["common.platformDetail"]=n);try{const i=await P.readFile(L.URI.file(h));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=I;function b(P){const D=t.env.USERDNSDOMAIN;if(!D)return!1;const w=D.toLowerCase();return P.some(p=>w===p)}e.verifyMicrosoftInternalDomain=b}),define(re[21],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[216],se([0,1,36,52,6,34,20,12,4,8,129,27,131,90,13,24,21]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function v(n,i){const a=`${n}::${i.join(":")}`,l=h.get(a);if(l)return l;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],s=new Map,c=new Map,g=2e4;function C(_,N,k,M){const U=N.substring(_.length+1);return L.Promises.withAsyncBody(async H=>{let W;try{W=await w.Promises.readdir(N,{withFileTypes:!0})}catch{H();return}if(M.count>=g){M.count+=W.length,M.maxReached=!0,H();return}let z=W.length;if(z===0){H();return}let te=W;M.count+W.length>g&&(M.maxReached=!0,z=g-M.count,te=W.slice(0,z)),M.count+=W.length;for(const V of te)if(V.isDirectory()){if(k.includes(V.name)||await C(_,(0,I.join)(N,V.name),k,M),--z==0){H();return}}else{const G=V.name.lastIndexOf(".");if(G>=0){const X=V.name.substring(G+1);X&&s.set(X,(s.get(X)??0)+1)}for(const X of o)X.relativePathPattern?.test(U)!==!1&&X.filePattern.test(V.name)&&c.set(X.tag,(c.get(X.tag)??0)+1);if(--z==0){H();return}}})}const O=L.Promises.withAsyncBody(async _=>{const N={count:0,maxReached:!1};await C(n,n,i,N);const k=await u(n);_({configFiles:m(c),fileTypes:m(s),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:k})});return h.set(a,O),O}e.collectWorkspaceStats=v;function m(n){return[...t.Iterable.map(n.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function f(){const n={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},i=R.cpus();return i&&i.length>0&&(n.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),n}e.getMachineInfo=f;async function u(n){try{const i=new Map,a=(0,I.join)(n,".vscode","launch.json"),l=await w.Promises.readFile(a),o=[],s=(0,T.parse)(l.toString(),o);if(o.length)return console.log(`Unable to parse ${a}`),[];if((0,T.getNodeType)(s)==="object"&&s.configurations)for(const c of s.configurations){const g=c.type;g&&(i.has(g)?i.set(g,i.get(g)+1):i.set(g,1))}return m(i)}catch{return[]}}e.collectLaunchConfigs=u;let r=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const l=R.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||a.push(`Load (avg):       ${R.loadavg().map(o=>Math.round(o)).join(", ")}`),a.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,p.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async l=>{let[o,s]=l,c=this.formatProcessList(i,o);return a.forEach(g=>{if((0,E.isRemoteDiagnosticError)(g))c+=`
${g.errorMessage}`,s+=`
${g.errorMessage}`;else if(c+=`

Remote: ${g.hostName}`,g.processes&&(c+=`
${this.formatProcessList(i,g.processes)}`),g.workspaceMetadata){s+=`
|  Remote: ${g.hostName}`;for(const C of Object.keys(g.workspaceMetadata)){const O=g.workspaceMetadata[C];let _=`${O.fileCount} files`;O.maxFilesReached&&(_=`more than ${_}`),s+=`|    Folder (${C}): ${_}`,s+=this.formatWorkspaceStats(O)}}}),{processInfo:c,workspaceInfo:s}})}async getSystemInfo(i,a){const{memory:l,vmHint:o,os:s,cpus:c}=f(),g={os:s,memory:l,cpus:c,vmHint:o,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return b.isWindows||(g.load=`${R.loadavg().map(C=>Math.round(C)).join(", ")}`),b.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(i,a){const l=[];return(0,p.listProcesses)(i.mainPID).then(async o=>(l.push(""),l.push(this.formatEnvironment(i)),l.push(""),l.push(this.formatProcessList(i,o)),i.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.formatWorkspaceMetadata(i))),a.forEach(s=>{if((0,E.isRemoteDiagnosticError)(s))l.push(`
${s.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${s.hostName}`),l.push(this.formatMachineInfo(s.machineInfo)),s.processes&&l.push(this.formatProcessList(i,s.processes)),s.workspaceMetadata)for(const c of Object.keys(s.workspaceMetadata)){const g=s.workspaceMetadata[c];let C=`${g.fileCount} files`;g.maxFilesReached&&(C=`more than ${C}`),l.push(`Folder (${c}): ${C}`),l.push(this.formatWorkspaceStats(g))}}),l.push(""),l.push(""),l.join(`
`)))}formatWorkspaceStats(i){const a=[],l=60;let o=0;const s=(O,_)=>{const N=` ${O}(${_})`;o+N.length>l?(a.push(c),c="|                 ",o=c.length):o+=N.length,c+=N};let c="|      File types:";const g=10,C=i.fileTypes.length>g?g:i.fileTypes.length;for(let O=0;O<C;O++){const _=i.fileTypes[O];s(_.name,_.count)}if(a.push(c),i.configFiles.length>=0&&(c="|      Conf files:",o=0,i.configFiles.forEach(O=>{s(O.name,O.count)}),a.push(c)),i.launchConfigFiles.length>0){let O="|      Launch Configs:";i.launchConfigFiles.forEach(_=>{O+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),a.push(O)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(l=>l.length));return Object.keys(i).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${i[l]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],l=[];return i.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(a.push(`|  Window (${o.title})`),o.folderURIs.forEach(s=>{const c=P.URI.revive(s);if(c.scheme===A.Schemas.file){const g=c.fsPath;l.push(v(g,["node_modules",".git"]).then(C=>{let O=`${C.fileCount} files`;C.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.basename)(g)}): ${O}`),a.push(this.formatWorkspaceStats(C))}).catch(C=>{a.push(`|      Error: Unable to collect workspace stats for folder ${g} (${C.toString()})`)}))}else a.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(o=>a.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(i,a){const l=new Map;i.windows.forEach(s=>l.set(s.pid,s.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,l,o,a,0),o.join(`
`)}formatProcessItem(i,a,l,o,s){const c=s===0;let g;c?g=o.pid===i?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(s)} ${o.name}`,o.name==="window"&&(g=`${g} (${a.get(o.pid)})`));const C=process.platform==="win32"?o.mem:R.totalmem()*(o.mem/100);l.push(`${o.load.toFixed(0).padStart(5," ")}	${(C/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(o.children)&&o.children.forEach(O=>this.formatProcessItem(i,a,l,O,s+1))}async getWorkspaceFileExtensions(i){const a=new Set;for(const{uri:l}of i.folders){const o=P.URI.revive(l);if(o.scheme!==A.Schemas.file)continue;const s=o.fsPath;try{(await v(s,["node_modules",".git"])).fileTypes.forEach(g=>a.add(g.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const l=P.URI.revive(a);if(l.scheme!==A.Schemas.file)continue;const o=l.fsPath;try{const s=await v(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),s.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:c.name,count:c.count})}),s.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:c.name,count:c.count})}),s.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};r=me([Q(0,y.ITelemetryService),Q(1,S.IProductService)],r),e.DiagnosticsService=r}),define(re[102],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:I,data:b}){return this.appenders.forEach(P=>P.log(I,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class t{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(re[45],se([0,1,29,79,14,18,21]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(f,u){return Promise.resolve(void 0)}publicLog2(f,u){return this.publicLog(f,u)}publicLogError(f,u){return Promise.resolve(void 0)}publicLogError2(f,u){return this.publicLogError(f,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class b{async publicLog(f,u,r){}async publicLogError(f,u,r){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(m,f){return f.onDidChangeConfiguration(u=>{u.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(u.source),configurationKeys:y(u.sourceConfig)})})}e.configurationTelemetry=P;function D(m,f){return!(f.disableTelemetry||!m.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=D;function w(m){const f=m.getValue(A.TELEMETRY_SETTING_ID),u=m.getValue("telemetry.enableCrashReporter");if(m.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function p(m){const f={},u={},r={};S(m,r);for(let n in r){n=n.length>150?n.substr(n.length-149):n;const i=r[n];typeof i=="number"?u[n]=i:typeof i=="boolean"?u[n]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${i.length}`),f[n]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(f[n]=i)}return{properties:f,measurements:u}}e.validateTelemetryData=p;const E=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function d(m){if(!m)return"none";for(const f of E)if(m.startsWith(`${f}+`))return f;return"other"}e.cleanRemoteAuthority=d;function S(m,f,u=0,r){if(!!m)for(const n of Object.getOwnPropertyNames(m)){const i=m[n],a=r?r+n:n;Array.isArray(i)?f[a]=(0,R.safeStringify)(i):i instanceof Date?f[a]=i.toISOString():(0,L.isObject)(i)?u<2?S(i,f,u+1,a+"."):f[a]=(0,R.safeStringify)(i):f[a]=i}}function y(m){if(!m)return[];const f=[];return h(f,"",m),f}function h(m,f,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(r=>h(m,f?`${f}.${r}`:r,u[r])):m.push(f)}function v(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=v}),define(re[217],se([0,1,49,45]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,A,I,b,P,D,w){const p={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},E=await(0,R.getServiceMachineId)(I,P,D),{sessionId:d}=await w.getTelemetryInfo();return(0,t.supportsTelemetry)(A,I)&&(0,t.getTelemetryLevel)(b)===3&&(p["X-Market-User-Id"]=E,p["VSCode-SessionId"]=d),p}e.resolveMarketplaceHeaders=L}),define(re[218],se([0,1,9,29,45]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(b,P,D){const w=await new Promise((y,h)=>{Z(["@microsoft/1ds-core-js"],y,h)}),p=await new Promise((y,h)=>{Z(["@microsoft/1ds-post-js"],y,h)}),E=new w.AppInsightsCore,d=new p.PostChannel,S={instrumentationKey:b,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(D){S.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:D};S.extensionConfig[d.identifier]=y}return E.initialize(S,[]),E.addTelemetryInitializer(y=>{P&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),E}class I{constructor(P,D,w,p,E){this._configurationService=P,this._eventPrefix=D,this._defaultData=w,this._xhrOverride=E,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(P){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}if(!this._asyncAiCore){const D=this._configurationService.getValue("telemetry.internalTesting");this._asyncAiCore=A(this._aiCoreOrKey,D,this._xhrOverride)}this._asyncAiCore.then(D=>{P(D)},D=>{(0,R.onUnexpectedError)(D),console.error(D)})}}log(P,D){if(!this._aiCoreOrKey)return;D=(0,t.mixin)(D,this._defaultData),D=(0,L.validateTelemetryData)(D);const w=this._eventPrefix+"/"+P;try{this._withAIClient(p=>p.track({name:w,baseData:{name:w,properties:D?.properties,measurements:D?.measurements}}))}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(D=>{D.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(re[219],se([0,1,218]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemWebAppender=void 0;class t extends R.AbstractOneDataSystemAppender{constructor(T,A,I,b){super(T,A,I,b);fetch(this.endPointUrl,{method:"POST"}).catch(P=>{this._aiCoreOrKey=void 0})}}e.OneDataSystemWebAppender=t}),define(re[103],se([0,1,2,15,7,45]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(b,P,D=""){super();this.prefix=D;const w=b.getLogger(P.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(b.createLogger(P.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,P){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,T.validateTelemetryData)(P))}};A=me([Q(0,L.ILoggerService),Q(1,t.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(re[104],se([0,1,2,29,79,4,26,155,18,43,97,24,40,21,45]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(v,m,f){this._configurationService=m,this._productService=f,this._experimentProperties={},this.telemetryLevel=new L.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){let v=(0,d.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const f=m.usage?3:m.error?2:0;v=Math.min(v,f)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,m=v.sessionID,f=v["common.machineId"],u=v["common.firstSessionDate"],r=v["common.msftInternal"];return{sessionId:m,machineId:f,firstSessionDate:u,msftInternal:r}}dispose(){this._disposables.dispose()}_log(v,m,f,u){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(r=>{f=(0,t.mixin)(f,r),f=(0,t.mixin)(f,this._experimentProperties),f=(0,t.cloneAndChange)(f,n=>{if(typeof n=="string")return this._cleanupInfo(n,u)}),this._appenders.forEach(n=>n.log(v,f))},r=>{console.error(r)})}publicLog(v,m,f){return this._log(v,3,m,f)}publicLog2(v,m,f){return this.publicLog(v,m,f)}publicLogError(v,m){return this._sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const f=[];for(const i of this._cleanupPatterns)for(;;){const a=i.exec(v);if(!a)break;f.push([a.index,i.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(m="";;){const i=r.exec(v);if(!i)break;!u.test(i[0])&&f.every(([a,l])=>i.index<a||i.index>=l)&&(m+=v.substring(n,i.index)+"<REDACTED: user-file-path>",n=r.lastIndex)}return n<v.length&&(m+=v.substr(n)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of f)if(u.regex.test(m))return`<REDACTED: ${u.label}>`;return v}_cleanupInfo(v,m){let f=v;m&&(f=this._anonymizeFilePaths(f));for(const u of this._cleanupPatterns)f=f.replace(u,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=me([Q(1,b.IConfigurationService),Q(2,w.IProductService)],S),e.TelemetryService=S;function y(){const h=(0,I.localize)(0,null,D.default.nameLong),v=D.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=T.isWeb?"":(0,I.localize)(3,null),f=(0,I.localize)(4,null),u=(0,I.localize)(5,null),r=(0,I.localize)(6,null),n=(0,I.localize)(7,null),i=`
|       | ${f} | ${u} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,I.localize)(8,null);return`
${h} ${v} ${m}

&nbsp;

${n}
${i}

&nbsp;

${a}
`}p.Registry.as(P.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(P.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,I.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,I.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[220],se([0,1,9,29,45]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(I){const b=await new Promise((D,w)=>{Z(["applicationinsights"],D,w)});let P;return b.defaultClient?(P=new b.TelemetryClient(I),P.channel.setUseDiskRetryCaching(!0)):(b.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=b.defaultClient),I.indexOf("AIF-")===0&&(P.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),P}class A{constructor(b,P,D){this._eventPrefix=b,this._defaultData=P,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(P=>{b(P)},P=>{(0,R.onUnexpectedError)(P),console.error(P)})}}log(b,P){if(!!this._aiClient){P=(0,t.mixin)(P,this._defaultData),P=(0,L.validateTelemetryData)(P);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+b,properties:P.properties,measurements:P.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(P=>{try{P.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(re[221],se([0,1,20,64,18,15,7,24,21,102,103,104]),function(Z,e,R,t,L,T,A,I,b,P,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(d,S,y,h,v){this.configurationService=d,this.telemetryService=S,this.loggerService=y,this.environmentService=h,this.productService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:S,sessionId:y}=await this.telemetryService.getTelemetryInfo(),h=Object.create(null);h["common.vscodemachineid"]=S,h["common.vscodesessionid"]=y;const v=[d.id,JSON.stringify(h),d.aiKey],f=new t.Client(R.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new P.TelemetryAppenderClient(f),new D.TelemetryLogAppender(this.loggerService,this.environmentService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new w.TelemetryService({appenders:u,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,S,y){await(await this.getCustomTelemetryService(d)).publicLog(S,y)}async publicLogError(d,S,y){await(await this.getCustomTelemetryService(d)).publicLogError(S,y)}};p=me([Q(0,L.IConfigurationService),Q(1,b.ITelemetryService),Q(2,A.ILoggerService),Q(3,T.IEnvironmentService),Q(4,I.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(re[222],se([0,1,6,23,3,2,7]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends T.Disposable{constructor(P,D){super();this._logService=D,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=P===void 0?15e3:P}createRequest(P){return new Promise((D,w)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,D),this._onCreateRequest.fire({requestId:p,...P});const E=new t.CancellationTokenSource;(0,R.timeout)(this._timeout,E.token).then(()=>w(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,T.toDisposable)(()=>E.cancel())])})}acceptReply(P,D){const w=this._pendingRequests.get(P);w?(this._pendingRequests.delete(P),(0,T.dispose)(this._pendingRequestDisposables.get(P)||[]),this._pendingRequestDisposables.delete(P),w(D)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${P}`)}};I=me([Q(1,A.ILogService)],I),e.RequestStore=I}),define(re[105],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",h.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",h.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(h){h.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var I;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var b;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(b=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var D;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(D=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(h){h.TerminalView="view",h.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(re[223],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(re[224],se([0,1,36,20,29,12,4,35,26,14,27]),function(Z,e,R,t,L,T,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let u=0;return f&&f.length===4&&(u=parseInt(f[3])),u}e.getWindowsBuildNumber=w;async function p(f,u,r,n=I.env,i=D.Promises.exists){if(T.isAbsolute(f))return await i(f)?f:void 0;if(u===void 0&&(u=I.cwd()),T.dirname(f)!=="."){const s=T.join(u,f);return await i(s)?s:void 0}const l=(0,L.getCaseInsensitive)(n,"PATH");if(r===void 0&&(0,P.isString)(l)&&(r=l.split(T.delimiter)),r===void 0||r.length===0){const s=T.join(u,f);return await i(s)?s:void 0}for(const s of r){let c;if(T.isAbsolute(s)?c=T.join(s,f):c=T.join(u,s,f),await i(c))return c;if(A.isWindows){let g=c+".com";if(await i(g)||(g=c+".exe",await i(g)))return g}}const o=T.join(u,f);return await i(o)?o:void 0}e.findExecutable=p;function E(f,u,r){if(!u.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const n=f.args,i=I.platform==="win32"?T.basename(f.executable).toLowerCase():T.basename(f.executable),a=T.dirname(t.FileAccess.asFileUri("",Z).fsPath);let l;const o={VSCODE_INJECTION:"1"};if(A.isWindows){if(i==="pwsh.exe")return!n||v(n)?l=e.shellIntegrationArgs.get(d.WindowsPwsh):h(n)&&(l=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),l?(l&&(l=[...l],l[l.length-1]=(0,b.format)(l[l.length-1],a,"")),{newArgs:l,envMixin:o}):void 0;r.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(i){case"bash":return!n||n.length===0?l=e.shellIntegrationArgs.get(d.Bash):m(n)&&(o.VSCODE_SHELL_LOGIN="1",l=e.shellIntegrationArgs.get(d.Bash)),l?(l=[...l],l[l.length-1]=(0,b.format)(l[l.length-1],a),{newArgs:l,envMixin:o}):void 0;case"pwsh":return!n||v(n)?l=e.shellIntegrationArgs.get(d.Pwsh):h(n)&&(l=e.shellIntegrationArgs.get(d.PwshLogin)),l?(l=[...l],l[l.length-1]=(0,b.format)(l[l.length-1],a,""),{newArgs:l,envMixin:o}):void 0;case"zsh":{if(!n||n.length===0?l=e.shellIntegrationArgs.get(d.Zsh):m(n)?l=e.shellIntegrationArgs.get(d.ZshLogin):(n===e.shellIntegrationArgs.get(d.Zsh)||n===e.shellIntegrationArgs.get(d.ZshLogin))&&(l=n),!l)return;l=[...l],l[l.length-1]=(0,b.format)(l[l.length-1],a);const s=T.join(R.tmpdir(),"vscode-zsh");o.ZDOTDIR=s;const c=[];return c.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(s,".zshrc")}),c.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(s,".zprofile")}),c.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(s,".zshenv")}),c.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(s,".zlogin")}),{newArgs:l,envMixin:o,filesToCopy:c}}}r.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=E;var d;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],y=["-nol","-nologo"];function h(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(y.includes(f[0].toLowerCase())||y.includes(f[1].toLowerCase()))}function v(f){return typeof f=="string"?y.includes(f.toLowerCase()):f.length===0||f?.length===1&&y.includes(f[0].toLowerCase())}function m(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(re[225],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function t(T){return T===R.HIGH_CONTRAST_DARK||T===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function L(T){return T===R.DARK||T===R.HIGH_CONTRAST_DARK}e.isDark=L}),define(re[106],se([0,1,51,3,2,5,40,225]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var b;(function(y){function h(v){return v&&typeof v=="object"&&typeof v.id=="string"}y.isThemeColor=h})(b=e.ThemeColor||(e.ThemeColor={}));function P(y){return{id:y}}e.themeColorFromId=P;var D;(function(y){function h(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||b.isThemeColor(a.color))}y.isThemeIcon=h;const v=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function m(a){const l=v.exec(a);if(!l)return;const[,o]=l;return{id:o}}y.fromString=m;function f(a){return{id:a}}y.fromId=f;function u(a,l){let o=a.id;const s=o.lastIndexOf("~");return s!==-1&&(o=o.substring(0,s)),l&&(o=`${o}~${l}`),{id:o}}y.modify=u;function r(a){const l=a.id.lastIndexOf("~");if(l!==-1)return a.id.substring(l+1)}y.getModifier=r;function n(a,l){return a.id===l.id&&a.color?.id===l.color?.id}y.isEqual=n;function i(a,l){return{id:a.id,color:l?P(l):void 0}}y.asThemeIcon=i,y.asClassNameArray=R.CSSIcon.asClassNameArray,y.asClassName=R.CSSIcon.asClassName,y.asCSSSelector=R.CSSIcon.asCSSSelector})(D=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function w(y){switch(y){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,L.toDisposable)(()=>{const v=this.themingParticipants.indexOf(h);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const E=new p;A.Registry.add(e.Extensions.ThemingContribution,E);function d(y){return E.onColorThemeChange(y)}e.registerThemingParticipant=d;class S extends L.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,v){let m=this.theme.getColor(h);return m&&v&&(m=v(m,this.theme)),m?m.toString():null}}e.Themable=S}),define(re[226],se([0,1,51,8,157,106]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(p,E){const d=[{name:null,description:(0,L.localize)(0,null)}];return d.push(...p.map(S=>({name:S.profileName,description:I(S)}))),E&&d.push(...E.map(S=>({name:S.title,description:b(S)}))),{values:d.map(S=>S.name),markdownDescriptions:d.map(S=>S.description)}}e.createProfileSchemaEnums=A;function I(p){let E=`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:R.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?E+=`
- args: "${p.args}"`:E+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(E+=`
- overrideName: ${p.overrideName}`),p.color&&(E+=`
- color: ${p.color}`),p.env&&(E+=`
- env: ${JSON.stringify(p.env)}`),E}function b(p){return`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:R.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function P(p,E){if(!p&&!E)return!0;if(typeof p=="string"&&typeof E=="string")return p===E;if(Array.isArray(p)&&Array.isArray(E)){if(p.length!==E.length)return!1;for(let d=0;d<p.length;d++)if(p[d]!==E[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=P;function D(p,E){if(!p&&!E)return!0;if(!p||!E)return!1;if(T.ThemeIcon.isThemeIcon(p)&&T.ThemeIcon.isThemeIcon(E))return p.id===E.id&&p.color===E.color;if(typeof p=="object"&&p&&"light"in p&&"dark"in p&&typeof E=="object"&&E&&"light"in E&&"dark"in E){const d=p,S=E;if((t.URI.isUri(d.light)||w(d.light))&&(t.URI.isUri(d.dark)||w(d.dark))&&(t.URI.isUri(S.light)||w(S.light))&&(t.URI.isUri(S.dark)||w(S.dark)))return d.light.path===S.light.path&&d.dark.path===S.dark.path}if(t.URI.isUri(p)&&t.URI.isUri(E)||w(p)||w(E)){const d=p,S=E;return d.path===S.path&&d.scheme===S.scheme}return!1}e.terminalIconsEqual=D;function w(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=w}),define(re[227],se([0,1,51,156,43,40,226]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const I={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(R.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),f=>`$(${f.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},P={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...I}},D=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),E=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:D},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:D},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...I}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(y),m()}e.registerTerminalPlatformConfiguration=h;let v;function m(f,u){const r=T.Registry.as(L.Extensions.Configuration);let n;f&&(n=(0,A.createProfileSchemaEnums)(f?.profiles,u));const i=v;v={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?n?.values:void 0,markdownEnumDescriptions:f?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?n?.values:void 0,markdownEnumDescriptions:f?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?n?.values:void 0,markdownEnumDescriptions:f?.os===1?n?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[v],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(re[228],se([0,1,48,51,12,4,27,83,224,106]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let D,w=!0;function p(n,i,a,l,o=process.env,s,c,g,C){return s=s||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?E(a,s,o,c,l.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:l.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:l.getValue("terminal.integrated.defaultProfile.windows"),C,g):f(s,c,a,n&&typeof n=="object"?{...n}:l.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:l.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),C,g,o)}e.detectAvailableProfiles=p;async function E(n,i,a,l,o,s,c,g,C){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let N=!1;(0,b.getWindowsBuildNumber)()>=16299&&(N=!0),await y(g);const k=new Map;n&&(k.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),k.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(s,k);const M=await d(k.entries(),c,i,a,l,C);if(n||!n&&o)try{const U=await v(`${_}\\${N?"wsl":"bash"}.exe`,c);for(const H of U)(!s||!(H.profileName in s))&&M.push(H)}catch{w&&(l?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return M}async function d(n,i,a,l=process.env,o,s){const c=[];for(const[g,C]of n){if(C===null)continue;let O,_,N;if("source"in C){const U=D?.get(C.source);if(!U)continue;O=U.paths,_=C.args||U.args,C.icon?N=S(C.icon):U.icon&&(N=U.icon)}else O=Array.isArray(C.path)?C.path:[C.path],_=T.isWindows||Array.isArray(C.args)?C.args:void 0,N=S(C.icon);const k=await s?.(O)||O.slice(),M=await r(g,i,k,a,l,_,C.env,C.overrideName,C.isAutoDetected,o);M?(M.isAutoDetected=C.isAutoDetected,M.icon=N,M.color=C.color,c.push(M)):o?.debug("Terminal profile not validated",g,O)}return o?.debug("Validated terminal profiles",c),c}function S(n){return typeof n=="string"?{id:n}:n}async function y(n){D&&!n||(D=new Map,D.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),D.set("PowerShell",{profileName:"PowerShell",paths:n||await h(),icon:P.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function h(){const n=[];for await(const i of(0,I.enumeratePowerShellInstallations)())n.push(i.exePath);return n}async function v(n,i){const a=[],l=await new Promise((c,g)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,O)=>{if(C)return g("Problem occurred when getting wsl distros");c(O)})});if(!l)return[];const o=new RegExp(/[\r?\n]/),s=l.split(o).filter(c=>c.trim().length>0&&c!=="");for(const c of s){if(c===""||c.startsWith("docker-desktop"))continue;const g=`${c} (WSL)`,C={profileName:g,path:n,args:["-d",`${c}`],isDefault:g===i,icon:m(c),isAutoDetected:!1};a.push(C)}return a}function m(n){return n.includes("Ubuntu")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):n.includes("Debian")?P.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):P.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function f(n,i,a,l,o,s,c,g){const C=new Map;if(a){const O=(await n.readFile("/etc/shells")).toString(),_=s||O.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),N=new Map;for(const k of _){let M=(0,L.basename)(k),U=N.get(M)||0;U++,U>1&&(M=`${M} (${U})`),N.set(M,U),C.set(M,{path:k,isAutoDetected:!0})}}return u(l,C),await d(C.entries(),o,n,g,i,c)}function u(n,i){if(!!n)for(const[a,l]of Object.entries(n))l===null||!("path"in l)&&!("source"in l)?i.delete(a):(l.icon=l.icon||i.get(a)?.icon,i.set(a,l))}async function r(n,i,a,l,o,s,c,g,C,O){if(a.length===0)return Promise.resolve(void 0);const _=a.shift();if(_==="")return r(n,i,a,l,o,s,c,g,C);const N={profileName:n,path:_,args:s,env:c,overrideName:g,isAutoDetected:C,isDefault:n===i};if((0,L.basename)(_)===_){const M=o.PATH?o.PATH.split(L.delimiter):void 0,U=await(0,b.findExecutable)(_,void 0,M,void 0,l.existsFile);return U?(N.path=U,N.isFromPath=!0,N):r(n,i,a,l,o,s)}return await l.existsFile((0,L.normalize)(_))?N:r(n,i,a,l,o,s,c,g,C)}}),define(re[229],se([0,1,3,2,20,4,39,64,18,15,88,212,7,96,222,105,227,228]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var v;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let m=0,f=class extends t.Disposable{constructor(r,n,i,a){super();this._reconnectConstants=r,this._configurationService=n,this._environmentService=i,this._logService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(r){return this._logService.error("ptyHost was unable to resolve shell environment",r),{}}}_startPtyHost(){const r={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,D.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?r.debugBrk=n.port:!n.break&&n.port&&(r.debug=n.port));const i=new I.Client(L.FileAccess.asFileUri("bootstrap-fork",Z).fsPath,r);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(s=>{this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=v.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const l=i.getChannel(S.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const o=A.ProxyChannel.toService(i.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(o.onProcessData(s=>this._onProcessData.fire(s))),this._register(o.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(o.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(o.onDidChangeProperty(s=>this._onDidChangeProperty.fire(s))),this._register(o.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(o.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(o.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[i,o]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(r,n,i,a,l,o,s,c,g,C,O){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(r,n,i,a,l,o,s,c,g,C,O);return clearTimeout(_),m=Math.max(m,N),N}updateTitle(r,n,i){return this._proxy.updateTitle(r,n,i)}updateIcon(r,n,i){return this._proxy.updateIcon(r,n,i)}attachToProcess(r){return this._proxy.attachToProcess(r)}detachFromProcess(r){return this._proxy.detachFromProcess(r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(r){return this._proxy.start(r)}shutdown(r,n){return this._proxy.shutdown(r,n)}input(r,n){return this._proxy.input(r,n)}processBinary(r,n){return this._proxy.processBinary(r,n)}resize(r,n,i){return this._proxy.resize(r,n,i)}acknowledgeDataEvent(r,n){return this._proxy.acknowledgeDataEvent(r,n)}setUnicodeVersion(r,n){return this._proxy.setUnicodeVersion(r,n)}getInitialCwd(r){return this._proxy.getInitialCwd(r)}getCwd(r){return this._proxy.getCwd(r)}getLatency(r){return this._proxy.getLatency(r)}orphanQuestionReply(r){return this._proxy.orphanQuestionReply(r)}installAutoReply(r,n){return this._proxy.installAutoReply(r,n)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(r){return this._proxy.uninstallAutoReply(r)}getDefaultSystemShell(r){return this._proxy.getDefaultSystemShell(r)}async getProfiles(r,n,i,a=!1){const l=await this._shellEnv;return(0,h.detectAvailableProfiles)(n,i,a,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,r))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(r){return this._proxy.getWslPath(r)}setTerminalLayoutInfo(r){return this._proxy.setTerminalLayoutInfo(r)}async getTerminalLayoutInfo(r){return await this._proxy.getTerminalLayoutInfo(r)}async requestDetachInstance(r,n){return this._proxy.requestDetachInstance(r,n)}async acceptDetachInstanceReply(r,n){return this._proxy.acceptDetachInstanceReply(r,n)}async serializeTerminalState(r){return this._proxy.serializeTerminalState(r)}async reviveTerminalProcesses(r,n){return this._proxy.reviveTerminalProcesses(r,n)}async refreshProperty(r,n){return this._proxy.refreshProperty(r,n)}async updateProperty(r,n,i){return this._proxy.updateProperty(r,n,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(r,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:r,originalText:n})}async acceptPtyHostResolvedVariables(r,n){this._resolveVariablesRequestStore.acceptReply(r,n)}};f=me([Q(1,b.IConfigurationService),Q(2,P.IEnvironmentService),Q(3,p.ILogService)],f),e.PtyHostService=f}),define(re[69],se([0,1,3,4,5,7]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=D,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=w;function p(S,y){return y?y!==1&&S<1024:!t.isWindows&&S<1024}e.isPortPrivileged=p;class E{constructor(y,h,v){this.remoteAddress=y,this.localAddress=h,this._dispose=v,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let d=class{constructor(y){this.logService=y,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y){return this._tunnelProvider=y,y?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],h=Array.from(this._tunnels.values());for(const v of h){const m=Array.from(v.values());for(const f of m){const u=await f.value;u&&y.push(u)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:h}of y.values())await h.then(v=>v?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,h,v,m,f=!1,u,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${v} on local port ${m}.`),!y)return;if(h||(h="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(y,h,v,m,f,u,r);return n?n.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const h=this._tunnels.get(y.tunnelRemoteHost);if(h){const v=h.get(y.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,v))}}}}async tryDisposeTunnel(y,h,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${h}.`);const m=v.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(h),m}}async closeTunnel(y,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${h} `);const v=this._tunnels.get(y);if(v&&v.has(h)){const m=v.get(h);m.refcount=0,await this.tryDisposeTunnel(y,h,m)}}addTunnelToMap(y,h,v){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(h,{refcount:1,value:v})}async removeEmptyTunnelFromMap(y,h){const v=this._tunnels.get(y);v&&(await v.get(h)||v.delete(h),v.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,h){const v=[y];D(y)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):w(y)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const m=v.map(f=>this._tunnels.get(f));for(const f of m){const u=f?.get(h);if(u)return u}}canTunnel(y){return!!P(y)}createWithProvider(y,h,v,m,f,u,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${v} on local port ${m}.`);const n=v;this._factoryInProgress.add(n);const a={elevationRequired:f?p(m===void 0?v:m):!1},l={remoteAddress:{host:h,port:v},localAddressPort:m,privacy:u,public:u?u!==I.Private:void 0,protocol:r},o=y.forwardPort(l,a);return o?(this.addTunnelToMap(h,v,o),o.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),o}};d=me([Q(0,T.ILogService)],d),e.AbstractTunnelService=d}),define(re[230],se([0,1,7,69,2,9,6]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(D){this._address=D,this._addressPromise&&(this._addressPromise.complete(D),this._addressPromise=null)}setTunnel(D){this._register(D)}}let b=class Pt extends L.Disposable{constructor(D,w){super();this._tunnelService=D,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(D=>D.dispose())}async createTunnel(){return{id:String(++Pt._lastId)}}async startTunnel(D,w,p,E,d,S){const y=new I,h=await Promise.resolve(this._tunnelService.openTunnel(D,y,p,E,d,S));if(!h)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${E} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),y.dispose(),await h.dispose(),(0,T.canceled)();return y.setTunnel(h),this._tunnels.set(w,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${h.localAddress} (local) to ${p}:${E} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(D,w){const p=this._tunnels.get(D);!p||p.setAddress(w)}async destroyTunnel(D){const w=this._tunnels.get(D);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${D}.`),this._tunnels.delete(D),await w.dispose();return}this._disposedTunnels.add(D)}};b._lastId=0,b=me([Q(0,t.ISharedTunnelsService),Q(1,R.ILogService)],b),e.SharedProcessTunnelService=b}),define(re[231],se([0,1,77,116,205,6,2,18,7,24,203,69,101]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(v,m,f,u,r){let n;for(let i=3;i&&(n&&n.dispose(),n=await new d(v,m,f,u,r).waitForReady(),!(r&&t.BROWSER_RESTRICTED_PORTS[r]||!t.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));i--);return n}class d extends A.Disposable{constructor(m,f,u,r,n){super();this.defaultTunnelHost=f,this.suggestedLocalPort=n,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let m=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(m){m.pause();const f=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,D.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),r=u.getSocket().socket,n=u.readEntireBuffer();u.dispose(),n.byteLength>0&&m.write(n.buffer),m.on("end",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),r.end()}),m.on("close",()=>r.end()),m.on("error",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),r.destroy()}),r.on("end",()=>m.end()),r.on("close",()=>m.end()),r.on("error",()=>{m.destroy()}),m.pipe(r),r.pipe(m),m.localAddress&&this._socketsDispose.set(m.localAddress,()=>{m.end(),r.end()})}}let S=class extends w.AbstractTunnelService{constructor(m,f,u,r,n){super(f);this.socketFactory=m,this.signService=u,this.productService=r,this.configurationService=n}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,f,u,r,n,i,a){const l=this.getTunnelFromMap(f,u);if(l)return++l.refcount,l.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,u,r,n,i,a);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${u} on local port ${r}.`);const o={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},s=E(o,this.defaultTunnelHost,f,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,u,s),s}}};S=me([Q(1,b.ILogService),Q(2,p.ISignService),Q(3,P.IProductService),Q(4,I.IConfigurationService)],S),e.BaseTunnelService=S;let y=class extends S{constructor(m,f,u,r){super(L.nodeSocketFactory,m,f,u,r)}};y=me([Q(0,b.ILogService),Q(1,p.ISignService),Q(2,P.IProductService),Q(3,I.IConfigurationService)],y),e.TunnelService=y;let h=class extends A.Disposable{constructor(m,f,u,r){super();this.logService=m,this.productService=f,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(m,f,u,r,n,i,a,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${n}.`),!this._tunnelServices.has(m)){const o=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(m,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(m))})}return this._tunnelServices.get(m).openTunnel(f,u,r,n,i,a,l)}};h=me([Q(0,b.ILogService),Q(1,P.IProductService),Q(2,p.ISignService),Q(3,I.IConfigurationService)],h),e.SharedTunnelsService=h}),define(re[33],se([0,1,5]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(re[232],se([0,1,3,2,8,15,32,13,7,33]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let D=class extends t.Disposable{constructor(p,E,d,S,y){super();this.extensionsManagementService=p,this.logService=S,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(v=>{this.installedExtensions=v.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(v=>this.onInstallExtension(v))),this._register(p.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(p.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const h=L.URI.file(d.extensionsPath);this._register(E.watch(h)),this._register(R.Event.filter(E.onDidFilesChange,v=>v.rawChanges.some(m=>this.doesChangeAffects(m,h)))(()=>this.onDidChange()))}doesChangeAffects(p,E){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),E)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const E of p)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(E=>!(0,A.areSameExtensions)(E,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,A.areSameExtensions)(E,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),E=p.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,A.areSameExtensions)(y,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),d=this.installedExtensions.filter(S=>this.installingExtensions.some(y=>(0,A.areSameExtensions)(y,S))?!1:p.every(y=>!(0,A.areSameExtensions)(y.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=p.map(S=>S.identifier),(E.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:d})}}};D=me([Q(1,I.IFileService),Q(2,T.INativeEnvironmentService),Q(3,b.ILogService),Q(4,P.IUriIdentityService)],D),e.ExtensionsWatcher=D}),define(re[233],se([0,1,33,89,13,19,113,3,2]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class P{constructor(p){this.uri=p,this.time=P._clock++}touch(){return this.time=P._clock++,this}}P._clock=0;let D=class{constructor(p){this._fileService=p,this._dispooables=new b.DisposableStore,this._limit=2**16;const E=new Map,d=S=>{let y=E.get(S.scheme);return y===void 0&&(y=p.hasProvider(S)&&!this._fileService.hasCapability(S,1024),E.set(S.scheme,y)),y};this._dispooables.add(I.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{E.delete(S.scheme)})),this.extUri=new T.ExtUri(d),this._canonicalUris=new A.SkipList((S,y)=>this.extUri.compare(S,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,T.normalizePath)(p));const E=this._canonicalUris.get(p);return E?E.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new P(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);P._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let d=0;d<E;d++)this._canonicalUris.set(p[d][0],p[d][1].touch())}};D=me([Q(0,L.IFileService)],D),e.UriIdentityService=D,(0,t.registerSingleton)(R.IUriIdentityService,D,!0)}),define(re[234],se([0,1,3,2,13,41,38,16]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class b extends t.Disposable{constructor(D,w,p,E){super();this.fileSystemScheme=D,this.fileSystemProvider=w,this.userDataScheme=p,this.logService=E,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(d=>this.handleFileChanges(d)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(D,w){this.watchResources.set(D,D);const p=this.fileSystemProvider.watch(this.toFileSystemResource(D),w);return(0,t.toDisposable)(()=>{this.watchResources.delete(D),p.dispose()})}stat(D){return this.fileSystemProvider.stat(this.toFileSystemResource(D))}mkdir(D){return this.fileSystemProvider.mkdir(this.toFileSystemResource(D))}rename(D,w,p){return this.fileSystemProvider.rename(this.toFileSystemResource(D),this.toFileSystemResource(w),p)}readFile(D){return this.fileSystemProvider.readFile(this.toFileSystemResource(D),{atomic:!0})}readFileStream(D,w,p){const E=(0,T.newWriteableStream)(d=>I.VSBuffer.concat(d.map(S=>I.VSBuffer.wrap(S))).buffer);return(async()=>{try{const d=await this.readFile(D);E.end(d)}catch(d){E.error(d),E.end()}})(),E}readdir(D){return this.fileSystemProvider.readdir(this.toFileSystemResource(D))}writeFile(D,w,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(D),w,p)}delete(D,w){return this.fileSystemProvider.delete(this.toFileSystemResource(D),w)}copy(D,w,p){if((0,L.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(D),this.toFileSystemResource(w),p);throw new Error("copy not supported")}handleFileChanges(D){const w=[];for(const p of D){if(p.resource.scheme!==this.fileSystemScheme)continue;const E=this.toUserDataResource(p.resource);this.watchResources.findSubstr(E)&&w.push({resource:E,type:p.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(D){return D.with({scheme:this.fileSystemScheme})}toUserDataResource(D){return D.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=b}),define(re[28],se([0,1,62,3,2,19,14,8,158,15,13,5,7]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function E(h){const v=h;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&typeof v.isDefault=="boolean"&&typeof v.name=="string"&&I.URI.isUri(v.location)&&I.URI.isUri(v.globalStorageHome)&&I.URI.isUri(v.settingsResource)&&I.URI.isUri(v.keybindingsResource)&&I.URI.isUri(v.tasksResource)&&I.URI.isUri(v.snippetsHome)&&((0,A.isUndefined)(v.extensionsResource)||I.URI.isUri(v.extensionsResource)))}e.isUserDataProfile=E,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function d(h,v){return{id:h.id,isDefault:h.isDefault,name:h.name,location:I.URI.revive(h.location).with({scheme:v}),globalStorageHome:I.URI.revive(h.globalStorageHome).with({scheme:v}),settingsResource:I.URI.revive(h.settingsResource).with({scheme:v}),keybindingsResource:I.URI.revive(h.keybindingsResource).with({scheme:v}),tasksResource:I.URI.revive(h.tasksResource).with({scheme:v}),snippetsHome:I.URI.revive(h.snippetsHome).with({scheme:v}),extensionsResource:I.URI.revive(h.extensionsResource)?.with({scheme:v})}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function S(h,v,m){return{id:(0,R.hash)(v.path).toString(16),name:h,location:v,isDefault:!1,globalStorageHome:(0,T.joinPath)(v,"globalStorage"),settingsResource:(0,T.joinPath)(v,"settings.json"),keybindingsResource:(0,T.joinPath)(v,"keybindings.json"),tasksResource:(0,T.joinPath)(v,"tasks.json"),snippetsHome:(0,T.joinPath)(v,"snippets"),extensionsResource:(0,T.joinPath)(v,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:m}}e.toUserDataProfile=S;let y=class extends L.Disposable{constructor(v,m,f){super();this.environmentService=v,this.fileService=m,this.logService=f,this._defaultProfile=this.createDefaultUserDataProfile(!1),this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]??this._defaultProfile}get profiles(){return[]}newProfile(v,m){return S(v,(0,T.joinPath)(this.profilesHome,(0,R.hash)(v).toString(16)),m)}createDefaultUserDataProfile(v){const m=S((0,b.localize)(0,null),this.environmentService.userRoamingDataHome);return{...m,isDefault:!0,extensionsResource:v?m.extensionsResource:void 0}}createProfile(v,m){throw new Error("Not implemented")}setProfileForWorkspace(v,m){throw new Error("Not implemented")}getProfile(v){throw new Error("Not implemented")}removeProfile(v){throw new Error("Not implemented")}};y=me([Q(0,P.IEnvironmentService),Q(1,D.IFileService),Q(2,p.ILogService)],y),e.UserDataProfilesService=y}),define(re[46],se([0,1,6,16,2,38,8,32,13,5,7,33,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let E=class extends L.Disposable{constructor(S,y,h,v){super();this.fileService=S,this.uriIdentityService=y,this.userDataProfilesService=h,this.logService=v,this.resourcesAccessQueueMap=new T.ResourceMap,this.migratePromise=this.migrate()}async migrate(){await Promise.all(this.userDataProfilesService.profiles.map(async S=>{if(!!S.extensionsResource)try{let y=!1;const h=JSON.parse((await this.fileService.readFile(S.extensionsResource)).value.toString());for(const v of h)if(!!v.location&&!v.version)try{const m=(await this.fileService.readFile(this.uriIdentityService.extUri.joinPath(A.URI.revive(v.location),"package.json"))).value.toString();v.version=JSON.parse(m).version,y=!0}catch{}y&&await this.fileService.writeFile(S.extensionsResource,t.VSBuffer.fromString(JSON.stringify(h)))}catch{}}))}scanProfileExtensions(S){return this.withProfileExtensions(S)}addExtensionsToProfile(S,y){return this.withProfileExtensions(y,h=>(h=h.filter(v=>S.some(([m])=>!(0,I.areSameExtensions)(v.identifier,m.identifier))),h.push(...S.map(([v,m])=>({identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:m}))),h))}removeExtensionFromProfile(S,y){return this.withProfileExtensions(y,h=>h.filter(v=>!(0,I.areSameExtensions)(v.identifier,S)))}async withProfileExtensions(S,y){return await this.migratePromise,this.getResourceAccessQueue(S).queue(async()=>{let h=[];try{const v=await this.fileService.readFile(S),m=JSON.parse(v.value.toString());for(const f of m){if(!f.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",f);continue}if(!f.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",f);continue}if(!f.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",f);continue}h.push({identifier:f.identifier,location:A.URI.revive(f.location),version:f.version,metadata:f.metadata})}}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}if(y){h=y(h);const v=h.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(S,t.VSBuffer.fromString(JSON.stringify(v)))}return h})}getResourceAccessQueue(S){let y=this.resourcesAccessQueueMap.get(S);return y||(y=new R.Queue,this.resourcesAccessQueueMap.set(S,y)),y}};E=me([Q(0,b.IFileService),Q(1,w.IUriIdentityService),Q(2,p.IUserDataProfilesService),Q(3,D.ILogService)],E),e.ExtensionsProfileScannerService=E}),define(re[235],se([0,1,17,6,23,9,3,2,4,8,141,30,32,46,7,24,21,33,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends I.Disposable{constructor(o,s,c,g,C,O,_){super();this.userDataProfilesService=o,this.uriIdenityService=s,this.galleryService=c,this.extensionsProfileScannerService=g,this.telemetryService=C,this.logService=O,this.productService=_,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(N=>N.cancel()),this.uninstallingExtensions.forEach(N=>N.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const s=await this.getTargetPlatform();return o.allTargetPlatforms.some(c=>(0,w.isTargetPlatformCompatible)(c,o.allTargetPlatforms,s))}async installFromGallery(o,s={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(D.localize(0,null),w.ExtensionManagementErrorCode.Internal);const c=await this.checkAndGetCompatibleVersion(o,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(c.manifest,c.extension,s)}catch(c){throw r(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(o),error:c}),this.logService.error("Failed to install extension.",o.identifier.id),this.logService.error(c),u(c)}}async uninstall(o,s={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,s)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const s=await this.getTargetPlatform(),[c]=await this.galleryService.getExtensions([{...o.identifier,preRelease:o.preRelease}],{targetPlatform:s,compatible:!0},L.CancellationToken.None);if(!c)throw new Error(D.localize(2,null));await this.createDefaultUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(c)}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async installExtension(o,s,c){if(!P.URI.isUri(s)){const N=this.installingExtensions.get(p.ExtensionKey.create(s).toString());if(N){this.logService.info("Extensions is already requested to install",s.identifier.id);const k=this.createWaitUntilInstallExtensionTaskIsFinishedTask(N,c),{local:M}=await k.waitUntilTaskIsFinished();return M}c={...c,installOnlyNewlyAddedFromExtensionPack:!0}}const g=[],C=[],O=this.createInstallExtensionTask(o,s,c);P.URI.isUri(s)||this.installingExtensions.set(p.ExtensionKey.create(s).toString(),O),this._onInstallExtension.fire({identifier:O.identifier,source:s,profileLocation:c.profileLocation}),this.logService.info("Installing extension:",O.identifier.id),g.push({task:O,manifest:o});let _=!1;try{if(c.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const k=await this.getAllDepsAndPackExtensionsToInstall(O.identifier,o,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation);for(const{gallery:M,manifest:U}of k){_=_||!!U.extensionDependencies?.some(W=>(0,p.areSameExtensions)({id:W},O.identifier));const H=p.ExtensionKey.create(M).toString();if(this.installingExtensions.has(H))this.logService.info("Extension is already requested to install",M.identifier.id);else{const W=this.createInstallExtensionTask(U,M,{...c,donotIncludePackAndDependencies:!0});this.installingExtensions.set(H,W),this._onInstallExtension.fire({identifier:W.identifier,source:M,profileLocation:c.profileLocation}),this.logService.info("Installing extension:",W.identifier.id),g.push({task:W,manifest:U})}}}catch(k){if(P.URI.isUri(O.source))(0,R.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",O.identifier.id,k.message),(0,R.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",O.identifier.id,k.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),k}const N=g.reduce((k,{task:M,manifest:U})=>(k.set(M.identifier.id.toLowerCase(),{task:M,manifest:U}),k),new Map);for(;N.size;){let k;const M=[...N.values()].filter(({manifest:U})=>!U.extensionDependencies?.some(H=>N.has(H.toLowerCase())));M.length?k=N.size===1?M:M.filter(({task:U})=>!(U===O&&!_)):(this.logService.info("Found extensions with circular dependencies",M.map(({task:U})=>U.identifier.id)),k=[...N.values()]),await this.joinAllSettled(k.map(async({task:U})=>{const H=new Date().getTime();try{const{local:W}=await U.run();if(await this.joinAllSettled(this.participants.map(z=>z.postInstall(W,U.source,c,L.CancellationToken.None))),!P.URI.isUri(U.source)){const z=U.operation===3,te=z?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(r(this.telemetryService,z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(U.source),duration:new Date().getTime()-H,durationSinceUpdate:te}),b.isWeb&&U.operation!==3)try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}C.push({local:W,identifier:U.identifier,operation:U.operation,source:U.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw P.URI.isUri(U.source)||r(this.telemetryService,U.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(U.source),duration:new Date().getTime()-H,error:W}),this.logService.error("Error while installing the extension:",U.identifier.id),W}finally{N.delete(U.identifier.id.toLowerCase())}}))}return C.forEach(({identifier:k})=>this.logService.info("Extension installed successfully:",k.id)),this._onDidInstallExtensions.fire(C),C.filter(({identifier:k})=>(0,p.areSameExtensions)(k,O.identifier))[0].local}catch(N){if(g.forEach(({task:k})=>k.cancel()),C.length)try{const k=await Promise.allSettled(C.map(({local:M})=>this.createUninstallExtensionTask(M,{versionOnly:!0},c.profileLocation).run()));for(let M=0;M<k.length;M++){const U=k[M],{identifier:H}=C[M];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",H.id):this.logService.warn("Rollback: Error while uninstalling extension",H.id,(0,T.getErrorMessage)(U.reason))}}catch(k){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(k),C.map(({identifier:M})=>M.id))}throw this._onDidInstallExtensions.fire(g.map(({task:k})=>({identifier:k.identifier,operation:2,source:k.source,context:c.context,profileLocation:c.profileLocation}))),N}finally{for(const{task:N}of g)if(!P.URI.isUri(N.source)){const k=p.ExtensionKey.create(N.source).toString();this.installingExtensions.delete(k)||this.logService.warn("Installation task is not found in the cache",k)}}}async joinAllSettled(o){const s=[],c=[],g=await Promise.allSettled(o);for(const C of g)C.status==="fulfilled"?s.push(C.value):c.push(C.reason);if(c.length)throw f(c);return s}async getAllDepsAndPackExtensionsToInstall(o,s,c,g,C){if(!this.galleryService.isEnabled())return[];let O=await this.getInstalled(void 0,C);const _=[o,...O.map(M=>M.identifier)],N=[],k=async(M,U)=>{const H=U.extensionDependencies||[],W=[...H];if(U.extensionPack){const z=c?O.find(te=>(0,p.areSameExtensions)(te.identifier,M)):void 0;for(const te of U.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(V=>(0,p.areSameExtensions)({id:V},{id:te}))||W.every(V=>!(0,p.areSameExtensions)({id:V},{id:te}))&&W.push(te)}if(W.length){const z=[..._,...N.map(V=>V.gallery.identifier)],te=W.filter(V=>z.every(G=>!(0,p.areSameExtensions)(G,{id:V})));if(te.length){const V=await this.galleryService.getExtensions(te.map(G=>({id:G,preRelease:g})),L.CancellationToken.None);for(const G of V){if(z.find(x=>(0,p.areSameExtensions)(x,G.identifier)))continue;const X=H.some(x=>(0,p.areSameExtensions)({id:x},G.identifier));let Y;try{Y=await this.checkAndGetCompatibleVersion(G,!1,g)}catch(x){if(x instanceof w.ExtensionManagementError&&x.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.logService.info("Skipping the packed extension as it cannot be installed",G.identifier.id);continue}else throw x}N.push({gallery:Y.extension,manifest:Y.manifest}),await k(Y.extension.identifier,Y.manifest)}}}};return await k(o,s),O=await this.getInstalled(void 0,C),N.filter(M=>!O.some(U=>(0,p.areSameExtensions)(U.identifier,M.gallery.identifier)))}async checkAndGetCompatibleVersion(o,s,c){const g=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(g).has(o.identifier.id))throw new w.ExtensionManagementError(D.localize(3,null,o.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(o)){const _=await this.getTargetPlatform();throw new w.ExtensionManagementError(D.localize(4,null,o.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(_)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const C=await this.getCompatibleVersion(o,s,c);if(C){if(c&&!s&&o.hasPreReleaseVersion&&!C.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(D.localize(5,null,o.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&o.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([o.identifier],L.CancellationToken.None))[0]?new w.ExtensionManagementError(D.localize(6,null,o.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(D.localize(7,null,o.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",C.identifier.id);const O=await this.galleryService.getManifest(C,L.CancellationToken.None);if(O===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(O.version!==C.version)throw new w.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:O}}async getCompatibleVersion(o,s,c){const g=await this.getTargetPlatform();let C=null;return!s&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==c&&(C=(await this.galleryService.getExtensions([{...o.identifier,preRelease:c}],{targetPlatform:g,compatible:!0},L.CancellationToken.None))[0]||null),!C&&await this.galleryService.isExtensionCompatible(o,c,g)&&(C=o),C||(s?C=(await this.galleryService.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:g,compatible:!0},L.CancellationToken.None))[0]||null:C=await this.galleryService.getCompatibleExtension(o,c,g)),C}async unininstallExtension(o,s){const c=k=>`${k.id.toLowerCase()}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,g=this.uninstallingExtensions.get(c(o.identifier));if(g)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),g.waitUntilTaskIsFinished();const C=(k,M)=>{const U=this.createUninstallExtensionTask(k,M,s.profileLocation);return this.uninstallingExtensions.set(c(U.extension.identifier),U),s.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${k.identifier.id}@${k.manifest.version}`,s.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${k.identifier.id}@${k.manifest.version}`),this._onUninstallExtension.fire({identifier:k.identifier,profileLocation:s.profileLocation,applicationScoped:k.isApplicationScoped}),U},O=(k,M)=>{M?s.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${k.identifier.id}@${k.manifest.version}`,s.profileLocation.toString(),M.message):this.logService.error("Failed to uninstall extension:",`${k.identifier.id}@${k.manifest.version}`,M.message):s.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${k.identifier.id}@${k.manifest.version}`,s.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${k.identifier.id}@${k.manifest.version}`),r(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(k),error:M}),this._onDidUninstallExtension.fire({identifier:k.identifier,version:k.manifest.version,error:M?.code,profileLocation:s.profileLocation,applicationScoped:k.isApplicationScoped})},_=[],N=[];try{_.push(C(o,s));const k=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${o.identifier.id}@${o.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(o,k);for(const U of M)this.uninstallingExtensions.has(c(U.identifier))?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):_.push(C(U,s))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${o.identifier.id}@${o.manifest.version}`):this.checkForDependents(_.map(M=>M.extension),k,o),await this.joinAllSettled(_.map(async M=>{try{if(await M.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(M.extension,s,L.CancellationToken.None))),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}O(M.extension)}catch(U){const H=U instanceof w.ExtensionManagementError?U:new w.ExtensionManagementError((0,T.getErrorMessage)(U),w.ExtensionManagementErrorCode.Internal);throw O(M.extension,H),H}finally{N.push(M)}}))}catch(k){const M=k instanceof w.ExtensionManagementError?k:new w.ExtensionManagementError((0,T.getErrorMessage)(k),w.ExtensionManagementErrorCode.Internal);for(const U of _){try{U.cancel()}catch{}N.includes(U)||O(U.extension,M)}throw M}finally{for(const k of _)this.uninstallingExtensions.delete(c(k.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",k.extension.identifier.id)}}checkForDependents(o,s,c){for(const g of o){const C=this.getDependents(g,s);if(C.length){const O=C.filter(_=>!o.some(N=>(0,p.areSameExtensions)(N.identifier,_.identifier)));if(O.length)throw new Error(this.getDependentsErrorMessage(g,O,c))}}}getDependentsErrorMessage(o,s,c){return c===o?s.length===1?D.localize(8,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?D.localize(9,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):D.localize(10,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?D.localize(11,null,c.manifest.displayName||c.manifest.name,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?D.localize(12,null,c.manifest.displayName||c.manifest.name,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):D.localize(13,null,c.manifest.displayName||c.manifest.name,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(o,s,c=[]){if(c.indexOf(o)!==-1)return[];c.push(o);const g=o.manifest.extensionPack?o.manifest.extensionPack:[];if(g.length){const C=s.filter(_=>!_.isBuiltin&&g.some(N=>(0,p.areSameExtensions)({id:N},_.identifier))),O=[];for(const _ of C)O.push(...this.getAllPackExtensionsToUninstall(_,s,c));return[...C,...O]}return[]}getDependents(o,s){return s.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(g=>(0,p.areSameExtensions)({id:g},o.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",o),o}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(o,s,c){const g=this.createDefaultInstallExtensionTask(o,s,c);return c.profileLocation&&this.userDataProfilesService.defaultProfile.extensionsResource?new i(g,c.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService):g}createWaitUntilInstallExtensionTaskIsFinishedTask(o,s){return!s.profileLocation||!this.userDataProfilesService.defaultProfile.extensionsResource||o instanceof i&&this.uriIdenityService.extUri.isEqual(o.profileLocation,s.profileLocation)?o:new i(o,s.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService)}createUninstallExtensionTask(o,s,c){return c&&this.userDataProfilesService.defaultProfile.extensionsResource?new a(o,c,this.userDataProfilesService,this.extensionsProfileScannerService):this.createDefaultUninstallExtensionTask(o,s)}};m=me([Q(0,v.IUserDataProfilesService),Q(1,h.IUriIdentityService),Q(2,w.IExtensionGalleryService),Q(3,E.IExtensionsProfileScannerService),Q(4,y.ITelemetryService),Q(5,d.ILogService),Q(6,S.IProductService)],m),e.AbstractExtensionManagementService=m;function f(l){const o=Array.isArray(l)?l:[l];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=f;function u(l){if(l instanceof w.ExtensionManagementError)return l;const o=new w.ExtensionManagementError(l.message,w.ExtensionManagementErrorCode.Internal);return o.stack=l.stack,o}function r(l,o,{extensionData:s,duration:c,error:g,durationSinceUpdate:C}){const O=g?g instanceof w.ExtensionManagementError?g.code:w.ExtensionManagementErrorCode.Internal:void 0;l.publicLog(o,{...s,success:!g,duration:c,errorcode:O,durationSinceUpdate:C})}e.reportTelemetry=r;class n{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(o=>new Promise((s,c)=>{const g=o.onCancellationRequested(()=>{g.dispose(),c(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n;class i{constructor(o,s,c,g){this.task=o,this.profileLocation=s,this.defaultProfileLocation=c,this.extensionsProfileScannerService=g,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const o=await this.task.waitUntilTaskIsFinished(),s=o.local.isApplicationScoped?this.defaultProfileLocation:this.profileLocation;return await this.extensionsProfileScannerService.addExtensionsToProfile([[o.local,o.metadata]],s),o}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class a extends n{constructor(o,s,c,g){super();this.extension=o,this.profileLocation=s,this.userDataProfilesService=c,this.extensionsProfileScannerService=g}async doRun(o){const s=[];s.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)),this.extension.isApplicationScoped&&this.userDataProfilesService.defaultProfile.extensionsResource&&s.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.userDataProfilesService.defaultProfile.extensionsResource)),await Promise.all(s)}}}),define(re[70],se([0,1,17,6,29,16,9,34,122,2,20,12,4,19,55,81,14,8,143,15,32,50,65,13,5,7,24,3,63,46,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u,r,n,i,a,l,o,s,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var C;(function(H){function W(z,te){if(z===te)return!0;const V=Object.keys(z),G=new Set;for(const X of Object.keys(te))G.add(X);if(V.length!==G.size)return!1;for(const X of V){if(z[X]!==te[X])return!1;G.delete(X)}return G.size===0}H.equals=W})(C=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let O=class extends P.Disposable{constructor(W,z,te,V,G,X,Y,x,B,J){super();this.systemExtensionsLocation=W,this.userExtensionsLocation=z,this.extensionsControlLocation=te,this.cacheLocation=V,this.userDataProfilesService=G,this.extensionsProfileScannerService=X,this.fileService=Y,this.logService=x,this.environmentService=B,this.productService=J,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,E.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(new k((0,E.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new k((0,E.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.extensionsScanner=this._register(new N(this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,z){const[te,V]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(z)]),G=await this.scanExtensionsUnderDevelopment(W,[...te,...V]);return this.dedupExtensions(te,V,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const z=[];z.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),z.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[te,V]=await Promise.all(z);return this.applyScanOptions([...te,...V],0,W,!1)}async scanUserExtensions(W){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(W.profileLocation??this.userExtensionsLocation,!!W.profileLocation,1,!W.includeUninstalled,W.language);let V=await(W.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return V=await this.applyScanOptions(V,1,W,!0),this.logService.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(W,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const te=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(V=>V.scheme===D.Schemas.file).map(async V=>{const G=await this.createExtensionScannerInput(V,!1,1,!0,W.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(G)).map(Y=>(Y.type=z.find(x=>(0,f.areSameExtensions)(x.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,G)))}))).flat();return this.applyScanOptions(te,"development",W,!0)}return[]}async scanExistingExtension(W,z,te){const V=await this.createExtensionScannerInput(W,!1,z,!0,te.language),G=await this.extensionsScanner.scanExtension(V);return!G||!te.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(W,z,te){const V=await this.createExtensionScannerInput(W,!1,z,!0,te.language),G=await this.extensionsScanner.scanOneOrMultipleExtensions(V);return this.applyScanOptions(G,z,te,!0)}async scanMetadata(W){const z=(0,E.joinPath)(W,"package.json"),te=(await this.fileService.readFile(z)).value.toString();return JSON.parse(te).__metadata}async updateMetadata(W,z){const te=(0,E.joinPath)(W,"package.json"),V=(await this.fileService.readFile(te)).value.toString(),G=JSON.parse(V);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,G.__metadata={...G.__metadata,...z},await this.fileService.writeFile((0,E.joinPath)(W,"package.json"),T.VSBuffer.fromString(JSON.stringify(G,null,"	")))}async applyScanOptions(W,z,te,V){return te.includeAllVersions||(W=this.dedupExtensions(z===0?W:void 0,z===1?W:void 0,z==="development"?W:void 0,await this.getTargetPlatform(),V)),te.includeInvalid||(W=W.filter(G=>G.isValid)),W.sort((G,X)=>{const Y=w.basename(G.location.fsPath),x=w.basename(X.location.fsPath);return Y<x?-1:Y>x?1:0})}dedupExtensions(W,z,te,V,G){const X=(x,B)=>{if(x.isValid&&!B.isValid)return!1;if(x.isValid===B.isValid){if(G&&d.gt(x.manifest.version,B.manifest.version))return this.logService.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(d.eq(x.manifest.version,B.manifest.version)){if(x.type===0)return this.logService.debug(`Skipping extension ${B.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===V)return this.logService.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return x.type===0?this.logService.debug(`Overwriting system extension ${x.location.path} with ${B.location.path}.`):this.logService.warn(`Overwriting user extension ${x.location.path} with ${B.location.path}.`),!0},Y=new Map;return W?.forEach(x=>{const B=u.ExtensionIdentifier.toKey(x.identifier.id),J=Y.get(B);(!J||X(J,x))&&Y.set(B,x)}),z?.forEach(x=>{const B=u.ExtensionIdentifier.toKey(x.identifier.id),J=Y.get(B);if(!J&&W&&x.type===0){this.logService.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!J||X(J,x))&&Y.set(B,x)}),te?.forEach(x=>{const B=u.ExtensionIdentifier.toKey(x.identifier.id),J=Y.get(B);(!J||X(J,x))&&Y.set(B,x),Y.set(B,x)}),[...Y.values()]}async scanDefaultSystemExtensions(W,z){this.logService.trace("Started scanning system extensions");const te=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),G=await(W&&!te.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(te);return this.logService.trace("Scanned system extensions:",G.length),G}async scanDevSystemExtensions(W,z){const te=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!te?.length)return[];this.logService.trace("Started scanning dev system extensions");const V=z?await this.getBuiltInExtensionControl():{},G=[],X=h.URI.file(w.normalize(w.join(D.FileAccess.asFileUri("",Z).fsPath,"..",".build","builtInExtensions")));for(const x of te){const B=V[x.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":G.push((0,E.joinPath)(X,x.name));break;default:G.push(h.URI.file(B));break}}const Y=await Promise.all(G.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,!1,0,!0,W))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,R.coalesce)(Y)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,z,te,V,G,X=!0){const Y=await this.getTranslations(G??p.language),x=await this.getMtime(W),B=z?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,J=B?await this.getMtime(B):void 0;return new _(W,x,B,J,z,te,V,X,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,G,Y)}async getMtime(W){try{const z=await this.fileService.stat(W);if(typeof z.mtime=="number")return z.mtime}catch{}}};O=me([Q(4,g.IUserDataProfilesService),Q(5,c.IExtensionsProfileScannerService),Q(6,n.IFileService),Q(7,a.ILogService),Q(8,m.IEnvironmentService),Q(9,l.IProductService)],O),e.AbstractExtensionsScannerService=O;class _{constructor(W,z,te,V,G,X,Y,x,B,J,F,$,j,K){this.location=W,this.mtime=z,this.applicationExtensionslocation=te,this.applicationExtensionslocationMtime=V,this.profile=G,this.type=X,this.excludeObsolete=Y,this.validate=x,this.productVersion=B,this.productDate=J,this.productCommit=F,this.devMode=$,this.language=j,this.translations=K}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,z){return(0,E.isEqual)(W.location,z.location)&&W.mtime===z.mtime&&(0,E.isEqual)(W.applicationExtensionslocation,z.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&W.profile===z.profile&&W.type===z.type&&W.excludeObsolete===z.excludeObsolete&&W.validate===z.validate&&W.productVersion===z.productVersion&&W.productDate===z.productDate&&W.productCommit===z.productCommit&&W.devMode===z.devMode&&W.language===z.language&&C.equals(W.translations,z.translations)}}class N extends P.Disposable{constructor(W,z,te,V){super();this.obsoleteFile=W,this.extensionsProfileScannerService=z,this.fileService=te,this.logService=V}async scanExtensions(W){const z=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let te={};if(W.excludeObsolete&&W.type===1)try{const V=(await this.fileService.readFile(this.obsoleteFile)).value.toString();te=JSON.parse(V)}catch{}return(0,y.isEmptyObject)(te)?z:z.filter(V=>!te[f.ExtensionKey.create(V).toString()])}async scanExtensionsFromLocation(W){const z=await this.fileService.resolve(W.location);if(!z.children?.length)return[];const te=await Promise.all(z.children.map(async V=>{if(!V.isDirectory||W.type===1&&(0,E.basename)(V.resource).indexOf(".")===0)return null;const G=new _(V.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(G)}));return(0,R.coalesce)(te).sort((V,G)=>V.location.path<G.location.path?-1:1)}async scanExtensionsFromProfile(W){const z=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W),te=await this.scanApplicationExtensions(W);return[...z,...te]}async scanApplicationExtensions(W){return W.applicationExtensionslocation?this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,W):[]}async scanExtensionsFromProfileResource(W,z,te){const V=await this.extensionsProfileScannerService.scanProfileExtensions(W);if(!V.length)return[];const G=await Promise.all(V.map(async X=>{if(z(X)){const Y=new _(X.location,te.mtime,te.applicationExtensionslocation,te.applicationExtensionslocationMtime,te.profile,te.type,te.excludeObsolete,te.validate,te.productVersion,te.productDate,te.productCommit,te.devMode,te.language,te.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,R.coalesce)(G)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,E.joinPath)(W.location,"package.json"))){const z=await this.scanExtension(W);return z?[z]:[]}else return await this.scanExtensions(W)}catch(z){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,A.getErrorMessage)(z)),[]}}async scanExtension(W,z){try{let te=await this.scanExtensionManifest(W.location);if(te){te.publisher||(te.publisher=u.UNDEFINED_PUBLISHER),z=z??te.__metadata,delete te.__metadata;const V=(0,f.getGalleryExtensionId)(te.publisher,te.name),G=z?.id?{id:V,uuid:z.id}:{id:V},X=z?.isSystem?0:W.type,Y=X===0||!!z?.isBuiltin;te=await this.translateManifest(W.location,te,_.createNlsConfiguration(W));const x={type:X,identifier:G,manifest:te,location:W.location,isBuiltin:Y,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return W.validate?this.validate(x,W):x}}catch(te){W.type!==0&&this.logService.error(te)}return null}validate(W,z){let te=!0;const V=(0,r.validateExtensionManifest)(z.productVersion,z.productDate,z.location,W.manifest,W.isBuiltin);for(const[G,X]of V)G===S.default.Error&&(te=!1,this.logService.error(this.formatMessage(z.location,X)));return W.isValid=te,W.validations=V,W}async scanExtensionManifest(W){const z=(0,E.joinPath)(W,"package.json");let te;try{te=(await this.fileService.readFile(z)).value.toString()}catch(G){return(0,n.toFileOperationResult)(G)!==1&&this.logService.error(this.formatMessage(W,(0,v.localize)(0,null,z.path,G.message))),null}let V;try{V=JSON.parse(te)}catch{const X=[];(0,I.parse)(te,X);for(const Y of X)this.logService.error(this.formatMessage(W,(0,v.localize)(1,null,z.path,Y.offset,Y.length,(0,b.getParseErrorMessage)(Y.error))));return null}return(0,I.getNodeType)(V)!=="object"?(this.logService.error(this.formatMessage(W,(0,v.localize)(2,null,z.path))),null):V}async translateManifest(W,z,te){const V=await this.getLocalizedMessages(W,z,te);if(V)try{const G=[],X=await this.resolveOriginalMessageBundle(V.default,G);if(G.length>0)return G.forEach(x=>{this.logService.error(this.formatMessage(W,(0,v.localize)(3,null,V.default?.path,(0,b.getParseErrorMessage)(x.error))))}),z;if((0,I.getNodeType)(V)!=="object")return this.logService.error(this.formatMessage(W,(0,v.localize)(4,null,V.default?.path))),z;const Y=V.values||Object.create(null);this.replaceNLStrings(te.pseudo,z,Y,X,W)}catch{}return z}async getLocalizedMessages(W,z,te){const V=(0,E.joinPath)(W,"package.nls.json"),G=(B,J)=>{J.forEach(F=>{this.logService.error(this.formatMessage(W,(0,v.localize)(5,null,B?.path,(0,b.getParseErrorMessage)(F.error))))})},X=B=>{this.logService.error(this.formatMessage(W,(0,v.localize)(6,null,B?.path)))},Y=`${z.publisher}.${z.name}`,x=te.translations[Y];if(x)try{const B=h.URI.file(x),J=(await this.fileService.readFile(B)).value.toString(),F=[],$=(0,I.parse)(J,F);return F.length>0?(G(B,F),{values:void 0,default:V}):(0,I.getNodeType)($)!=="object"?(X(B),{values:void 0,default:V}):{values:$.contents?$.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.fileService.exists(V))return;let J;try{J=await this.findMessageBundles(W,te)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const F=(await this.fileService.readFile(J.localized)).value.toString(),$=[],j=(0,I.parse)(F,$);return $.length>0?(G(J.localized,$),{values:void 0,default:J.original}):(0,I.getNodeType)(j)!=="object"?(X(J.localized),{values:void 0,default:J.original}):{values:j,default:J.original}}catch{return{values:void 0,default:J.original}}}}async resolveOriginalMessageBundle(W,z){if(W)try{const te=(await this.fileService.readFile(W)).value.toString();return(0,I.parse)(te,z)}catch{return null}else return null}findMessageBundles(W,z){return new Promise((te,V)=>{const G=X=>{const Y=(0,E.joinPath)(W,`package.nls.${X}.json`);this.fileService.exists(Y).then(x=>{x&&te({localized:Y,original:(0,E.joinPath)(W,"package.nls.json")});const B=X.lastIndexOf("-");B===-1?te({localized:(0,E.joinPath)(W,"package.nls.json"),original:null}):(X=X.substring(0,B),G(X))})};if(z.devMode||z.pseudo||!z.language)return te({localized:(0,E.joinPath)(W,"package.nls.json"),original:null});G(z.language)})}replaceNLStrings(W,z,te,V,G){const X=(Y,x,B)=>{const J=Y[x];if((0,y.isString)(J)){const F=J,$=F.length;if($>1&&F[0]==="%"&&F[$-1]==="%"){const j=F.substr(1,$-2);let K=te[j];K===void 0&&V&&(K=V[j]);let q=typeof K=="string"?K:typeof K?.message=="string"?K.message:void 0;q!==void 0?(W&&(q="\uFF3B"+q.replace(/[aouei]/g,"$&$&")+"\uFF3D"),Y[x]=B&&(x==="title"||x==="category")&&V?{value:q,original:V[j]}:q):this.logService.warn(this.formatMessage(G,(0,v.localize)(7,null,j)))}}else if((0,y.isObject)(J))for(const F in J)J.hasOwnProperty(F)&&(F==="commands"?X(J,F,!0):X(J,F,B));else if((0,y.isArray)(J))for(let F=0;F<J.length;F++)X(J,F,B)};for(const Y in z)z.hasOwnProperty(Y)&&X(z,Y)}formatMessage(W,z){return`[${W.path}]: ${z}`}}class k extends N{constructor(W,z,te,V,G){super(z,te,V,G);this.cacheFile=W,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const z=await this.readExtensionCache();if(this.input=W,z&&z.input&&_.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(V=>(V.location=h.URI.revive(V.location),V));const te=await super.scanExtensions(W);return await this.writeExtensionCache({input:W,result:te}),te}async readExtensionCache(){try{const W=await this.fileService.readFile(this.cacheFile),z=JSON.parse(W.value.toString());return{result:z.result,input:(0,s.revive)(z.input)}}catch(W){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(W))}return null}async writeExtensionCache(W){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(W)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const W=await this.readExtensionCache();if(!W)return;const z=W.result,te=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!L.equals(te,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(V){this.logService.error(V)}}}function M(H,W){const z=(0,f.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:z,identifier:new u.ExtensionIdentifier(z),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:W,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=M;class U extends O{constructor(W,z,te,V,G,X,Y,x,B,J){super(W,z,(0,E.joinPath)(te,".vscode-oss-dev","extensions","control.json"),(0,E.joinPath)(V,u.MANIFEST_CACHE_FOLDER),G,X,Y,x,B,J);this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const F=await this.fileService.readFile(h.URI.file(p.translationsConfigFile));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=U}),define(re[236],se([0,1,48,6,37,3,2,20,12,27,7,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends A.Disposable{constructor(d,S){super();this.userDataProfilesService=d,this.logService=S,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const S=this.parseScript(d,"uninstall");return S&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${y}`)))),P.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(d,S){const y=`vscode:${S}`;if(d.location.scheme===I.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[y]=="string"){const h=d.manifest.scripts[y].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${y} should be a node script`),null):{script:(0,b.join)(d.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(d,S,y,h,v){return new Promise((m,f)=>{const u=this.start(d,S,y,v);let r;const n=i=>{r&&(clearTimeout(r),r=null),i?f(i):m(void 0)};u.on("error",i=>{n((0,L.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,a)=>{n(i?`post-${S} process exited with code ${i}`:void 0)}),h&&(r=setTimeout(()=>{r=null,u.kill(),f("timed out")},5e3))})}start(d,S,y,h){const v={silent:!0,execArgv:void 0},m=(0,R.fork)(d,[`--type=extension-post-${S}`,...y],v);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const f=T.Event.fromNodeEventEmitter(m.stdout,"data"),u=T.Event.fromNodeEventEmitter(m.stderr,"data");f(i=>this.logService.info(h.identifier.id,h.manifest.version,`post-${S}`,i)),u(i=>this.logService.error(h.identifier.id,h.manifest.version,`post-${S}`,i));const r=T.Event.any(T.Event.map(f,i=>({data:`%c${i}`,format:[""]})),T.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(r,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),m}getExtensionStoragePath(d){return(0,b.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};p=me([Q(0,w.IUserDataProfilesService),Q(1,D.ILogService)],p),e.ExtensionsLifecycle=p}),define(re[237],se([0,1,8,15,46,70,13,7,24,28]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let D=class extends T.NativeExtensionsScannerService{constructor(p,E,d,S,y,h){super(R.URI.file(y.builtinExtensionsPath),R.URI.file(y.extensionsPath),y.userHome,R.URI.file(y.userDataPath),p,E,d,S,y,h)}};D=me([Q(0,P.IUserDataProfilesService),Q(1,L.IExtensionsProfileScannerService),Q(2,A.IFileService),Q(3,I.ILogService),Q(4,t.INativeEnvironmentService),Q(5,b.IProductService)],D),e.ExtensionsScannerService=D}),define(re[22],se([0,1,6,3,2,189,14,86,5,28]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const D="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var w;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var E;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class d extends L.Disposable{constructor(m={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,f){if(f===D){switch(m){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:m})}else this._onDidChangeValue.fire({scope:m,key:f,target:this.getKeyTargets(m)[f]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,f,u){return this.getStorage(f)?.get(m,u)}getBoolean(m,f,u){return this.getStorage(f)?.getBoolean(m,u)}getNumber(m,f,u){return this.getStorage(f)?.getNumber(m,u)}store(m,f,u,r){if((0,A.isUndefinedOrNull)(f)){this.remove(m,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,u,r),this.getStorage(u)?.set(m,f)})}remove(m,f){this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,void 0),this.getStorage(f)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,f){const u=[],r=this.getKeyTargets(m);for(const n of Object.keys(r))r[n]===f&&u.push(n);return u}updateKeyTarget(m,f,u){const r=this.getKeyTargets(f);typeof u=="number"?r[m]!==u&&(r[m]=u,this.getStorage(f)?.set(D,JSON.stringify(r))):typeof r[m]=="number"&&(delete r[m],this.getStorage(f)?.set(D,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(m){switch(m){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(m){const f=this.get(D,m);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=w.NONE){this._onWillSaveState.fire({reason:m});const f=this.getStorage(-1),u=this.getStorage(0),r=this.getStorage(1);switch(m){case w.NONE:await R.Promises.settled([f?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await R.Promises.settled([f?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return h(m,f,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(m,f){return this.emitWillSaveState(w.NONE),(0,P.isUserDataProfile)(m)?this.switchToProfile(m,f):this.switchToWorkspace(m,f)}canSwitchProfile(m,f){return!(m.id===f.id||S(f)&&S(m))}switchData(m,f,u,r){this.withPausedEmitters(()=>{if(r)for(const[n,i]of m)f.set(n,i);else{const n=new Set;for(const[i,a]of m)n.add(i),f.get(i)!==a&&this.emitDidChangeValue(u,i);for(const[i]of f.items)n.has(i)||this.emitDidChangeValue(u,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class y extends d{constructor(){super();this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.profileStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),this._register(this.applicationStorage.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m)))}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=y;async function h(v,m,f,u,r,n){const i=_=>{try{return JSON.parse(_)}catch{return _}},a=new Map,l=new Map;v.forEach((_,N)=>{a.set(N,_),l.set(N,i(_))});const o=new Map,s=new Map;m.forEach((_,N)=>{o.set(N,_),s.set(N,i(_))});const c=new Map,g=new Map;f.forEach((_,N)=>{c.set(N,_),g.set(N,i(_))}),console.group(u!==r?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const C=[];if(a.forEach((_,N)=>{C.push({key:N,value:_})}),console.table(C),console.groupEnd(),console.log(l),u!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const _=[];o.forEach((N,k)=>{_.push({key:k,value:N})}),console.table(_),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${n})`);const O=[];c.forEach((_,N)=>{O.push({key:N,value:_})}),console.table(O),console.groupEnd(),console.log(g)}e.logStorage=h}),define(re[238],se([0,1,3,2,14,30,32,22]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends t.Disposable{constructor(w,p){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new P(w)),this._register(this.storageManger.onDidChange(E=>this._onDidChangeEnablement.fire({extensions:E,source:"storage"}))),this._register(p.onDidInstallExtensions(E=>E.forEach(({local:d,operation:S})=>{d&&S===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(w,p){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}async disableExtension(w,p){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const p=this.getDisabledExtensions();return p.every(E=>!(0,A.areSameExtensions)(E,w))?(p.push(w),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(w){const p=this.getDisabledExtensions();for(let E=0;E<p.length;E++){const d=p[E];if((0,A.areSameExtensions)(d,w))return p.splice(E,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(w){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,p){this.storageManger.set(w,p,0)}};b=me([Q(0,I.IStorageService),Q(1,T.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class P extends t.Disposable{constructor(w){super();this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(w,p){let E;return p===0?((0,L.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,p)),E=this.storage[w]):E=this._get(w,p),JSON.parse(E)}set(w,p,E){const d=JSON.stringify(p.map(({id:y,uuid:h})=>({id:y,uuid:h})));this._get(w,E)!==d&&(E===0&&(p.length?this.storage[w]=d:delete this.storage[w]),this._set(w,p.length?d:void 0,E))}onDidStorageChange(w){if(w.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const E=this.get(w.key,w.scope);delete this.storage[w.key];const d=this.get(w.key,w.scope),S=E.filter(h=>!d.some(v=>(0,A.areSameExtensions)(h,v))),y=d.filter(h=>!E.some(v=>(0,A.areSameExtensions)(v,h)));(S.length||y.length)&&this._onDidChange.fire([...S,...y])}}_get(w,p){return this.storageService.get(w,p,"[]")}_set(w,p,E){p?this.storageService.store(w,p,E,1):this.storageService.remove(w,E)}}e.StorageManager=P}),define(re[239],se([0,1,17,23,9,4,35,14,8,18,15,30,32,65,13,7,24,44,217,22,21]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=T.isWeb?"web":(0,w.getTargetPlatform)(T.platform,A.arch);var r;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function n(...F){return String(F.reduce(($,j)=>$|j,0))}var i;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class c{constructor($=s){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage($,j=this.state.pageSize){return new c({...this.state,pageNumber:$,pageSize:j})}withFilter($,...j){const K=[...this.state.criteria,...j.length?j.map(q=>({filterType:$,value:q})):[{filterType:$}]];return new c({...this.state,criteria:K})}withSortBy($){return new c({...this.state,sortBy:$})}withSortOrder($){return new c({...this.state,sortOrder:$})}withFlags(...$){return new c({...this.state,flags:$.reduce((j,K)=>j|K,0)})}withAssetTypes(...$){return new c({...this.state,assetTypes:$})}withSource($){return new c({...this.state,source:$})}get raw(){const{criteria:$,pageNumber:j,pageSize:K,sortBy:q,sortOrder:ee,flags:ne,assetTypes:oe}=this.state;return{filters:[{criteria:$,pageNumber:j,pageSize:K,sortBy:q,sortOrder:ee}],assetTypes:oe,flags:ne}}get searchText(){const $=this.state.criteria.filter(j=>j.filterType===i.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function g(F,$){const j=(F||[]).filter(K=>K.statisticName===$)[0];return j?j.value:0}function C(F){const $="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(K=>K.assetType.indexOf($)===0).reduce((K,q)=>{const ee=N(F,q.assetType);return ee&&K.push([q.assetType.substring($.length),ee]),K},[])}function O(F){if(F.properties){const $=F.properties.filter(q=>q.key===a.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=$.filter(q=>j.test(q.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return N(F,a.Repository)}function _(F){return{uri:`${F.fallbackAssetUri}/${a.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${a.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function N(F,$){return F.files.filter(K=>K.assetType===$)[0]?{uri:`${F.assetUri}/${$}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${$}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function k(F,$){const j=F.properties?F.properties.filter(q=>q.key===$):[],K=j.length>0&&j[0].value;return K?K.split(",").map(q=>(0,p.adoptToGalleryExtensionId)(q)):[]}function M(F){const $=F.properties?F.properties.filter(j=>j.key===l.Engine):[];return $.length>0&&$[0].value||""}function U(F){const $=F.properties?F.properties.filter(j=>j.key===l.PreRelease):[];return $.length>0&&$[0].value==="true"}function H(F){const $=F.properties?F.properties.filter(K=>K.key===l.LocalizedLanguages):[],j=$.length>0&&$[0].value||"";return j?j.split(","):[]}function W(F){return F.properties?.find($=>$.key===l.SponsorLink)?.value}function z(F){return F.indexOf("preview")!==-1}function te(F){return F.targetPlatform?(0,w.toTargetPlatform)(F.targetPlatform):"undefined"}function V(F){const $=(0,R.distinct)(F.versions.map(te)),j=!!F.tags?.includes(w.WEB_EXTENSION_TAG),K=$.indexOf("web");return j?K===-1&&$.push("web"):K!==-1&&$.splice(K,1),$}function G(F,$){const j=(0,w.getFallbackTargetPlarforms)($);for(let K=0;K<F.length;K++){const q=F[K];if(q.version===F[K-1]?.version){let ee=K;const ne=te(q);if(ne===$)for(;ee>0&&F[ee-1].version===q.version;)ee--;else if(j.includes(ne))for(;ee>0&&F[ee-1].version===q.version&&te(F[ee-1])!==$;)ee--;ee!==K&&(F.splice(K,1),F.splice(ee,0,q))}}return F}e.sortExtensionVersions=G;function X(F,$,j){F.telemetryData={index:$,querySource:j}}function Y(F,$,j){const K=F.versions[0],q={manifest:N($,a.Manifest),readme:N($,a.Details),changelog:N($,a.Changelog),license:N($,a.License),repository:O($),download:_($),icon:N($,a.Icon),coreTranslations:C($)};return{identifier:{id:(0,p.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:$.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(K),description:F.shortDescription||"",installCount:g(F.statistics,"install"),rating:g(F.statistics,"averagerating"),ratingCount:g(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:j,assets:q,properties:{dependencies:k($,l.Dependency),extensionPack:k($,l.ExtensionPack),engine:M($),localizedLanguages:H($),targetPlatform:te($),isPreReleaseVersion:U($)},hasPreReleaseVersion:U(K),hasReleaseVersion:!0,preview:z(F.flags)}}let x=class{constructor($,j,K,q,ee,ne,oe,le){this.requestService=j,this.logService=K,this.environmentService=q,this.telemetryService=ee,this.fileService=ne,this.productService=oe,this.configurationService=le;const Se=oe.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=(0,v.resolveMarketplaceHeaders)(oe.version,oe,this.environmentService,this.configurationService,this.fileService,$,this.telemetryService)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,j,K){const q=t.CancellationToken.isCancellationToken(j)?{}:j,ee=t.CancellationToken.isCancellationToken(j)?j:K,ne=[],oe=[],le=[],Se=[];let fe=!0;for(const be of $){be.uuid?oe.push(be.uuid):ne.push(be.id);const Ie=!!(be.version||be.preRelease);le.push({id:be.id,uuid:be.uuid,includePreRelease:Ie}),be.version&&Se.push({id:be.id,uuid:be.uuid,version:be.version}),fe=fe&&!!be.hasPreRelease&&!Ie}if(!oe.length&&!ne.length)return[];let pe=new c().withPage(1,$.length);oe.length&&(pe=pe.withFilter(i.ExtensionId,...oe)),ne.length&&(pe=pe.withFilter(i.ExtensionName,...ne)),(q.queryAllVersions||fe)&&(pe=pe.withFlags(pe.flags,r.IncludeVersions)),q.source&&(pe=pe.withSource(q.source));const{extensions:Ce}=await this.queryGalleryExtensions(pe,{targetPlatform:q.targetPlatform??u,includePreRelease:le,versions:Se,compatible:!!q.compatible},ee);return q.source&&Ce.forEach((be,Ie)=>X(be,Ie,q.source)),Ce}async getCompatibleExtension($,j,K){if((0,w.isNotWebExtensionInWebTargetPlatform)($.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible($,j,K))return $;const q=new c().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,$.identifier.uuid),{extensions:ee}=await this.queryGalleryExtensions(q,{targetPlatform:K,compatible:!0,includePreRelease:j},t.CancellationToken.None);return ee[0]||null}async isExtensionCompatible($,j,K){if(!(0,w.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,K)||!j&&$.properties.isPreReleaseVersion)return!1;let q=$.properties.engine;if(!q){const ee=await this.getManifest($,t.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");q=ee.engines.vscode}return(0,E.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion($,j,K,q,ee){if(!(0,w.isTargetPlatformCompatible)(te($),q,ee)||j!=="any"&&U($)!==(j==="prerelease"))return!1;if(K)try{const ne=await this.getEngine($);if(!(0,E.isEngineValid)(ne,this.productService.version,this.productService.date))return!1}catch(ne){return this.logService.error(`Error while getting the engine for the version ${$.version}.`,(0,L.getErrorMessage)(ne)),!1}return!0}async query($,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let K=$.text||"";const q=$.pageSize??50;let ee=new c().withPage(1,q);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,pe,Ce)=>(ee=ee.withFilter(i.Category,Ce||pe),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,pe,Ce)=>(ee=ee.withFilter(i.Tag,Ce||pe),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),ee=ee.withFilter(i.SearchText,K)),ee=ee.withSortBy(0)):$.ids?ee=ee.withFilter(i.ExtensionId,...$.ids):$.names?ee=ee.withFilter(i.ExtensionName,...$.names):ee=ee.withSortBy(4),typeof $.sortBy=="number"&&(ee=ee.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(ee=ee.withSortOrder($.sortOrder)),$.source&&(ee=ee.withSource($.source));const ne=async(fe,pe)=>{const{extensions:Ce,total:be}=await this.queryGalleryExtensions(fe,{targetPlatform:u,compatible:!1,includePreRelease:!!$.includePreRelease},pe);return Ce.forEach((Ie,qe)=>X(Ie,(fe.pageNumber-1)*fe.pageSize+qe,$.source)),{extensions:Ce,total:be}},{extensions:oe,total:le}=await ne(ee,j),Se=async(fe,pe)=>{if(pe.isCancellationRequested)throw new L.CancellationError;const{extensions:Ce}=await ne(ee.withPage(fe+1),pe);return Ce};return{firstPage:oe,total:le,pageSize:ee.pageSize,getPage:Se}}async queryGalleryExtensions($,j,K){const q=$.flags;!!($.flags&r.IncludeLatestVersionOnly)&&!!($.flags&r.IncludeVersions)&&($=$.withFlags($.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!($.flags&r.IncludeLatestVersionOnly)&&!($.flags&r.IncludeVersions)&&($=$.withFlags($.flags,r.IncludeLatestVersionOnly)),j.versions?.length&&($=$.withFlags($.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),$=$.withFlags($.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:ee,total:ne}=await this.queryRawGalleryExtensions($,K);if(!($.flags&r.IncludeLatestVersionOnly)){const fe=[];for(const pe of ee){const Ce=await this.toGalleryExtensionWithCriteria(pe,j);Ce&&fe.push(Ce)}return{extensions:fe,total:ne}}const le=[],Se=new Map;for(let fe=0;fe<ee.length;fe++){const pe=ee[fe],Ce={id:(0,p.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(qe=>(0,p.areSameExtensions)(qe,Ce))?.includePreRelease;if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(V(pe),j.targetPlatform))continue;const Ie=await this.toGalleryExtensionWithCriteria(pe,j);!Ie||Ie.properties.isPreReleaseVersion&&(!be||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==j.targetPlatform&&Ie.hasPreReleaseVersion?Se.set(pe.extensionId,fe):le.push([fe,Ie])}if(Se.size){const fe=new Date().getTime(),pe=new c().withFlags(q&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,Se.size).withFilter(i.ExtensionId,...Se.keys()),{extensions:Ce}=await this.queryGalleryExtensions(pe,j,K);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-fe,count:Se.size});for(const be of Ce){const Ie=Se.get(be.identifier.uuid);le.push([Ie,be])}}return{extensions:le.sort((fe,pe)=>fe[0]-pe[0]).map(([,fe])=>fe),total:ne}}async toGalleryExtensionWithCriteria($,j){const K={id:(0,p.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},q=j.versions?.find(le=>(0,p.areSameExtensions)(le,K))?.version,ee=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(le=>(0,p.areSameExtensions)(le,K))?.includePreRelease,ne=V($),oe=G($.versions,j.targetPlatform);if(j.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ne,j.targetPlatform))return null;for(let le=0;le<oe.length;le++){const Se=oe[le];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,ee?"any":"release",j.compatible,ne,j.targetPlatform))return Y($,Se,ne);if(q&&Se.version===q)return null}}return q||j.compatible?null:Y($,$.versions[0],ne)}async queryRawGalleryExtensions($,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(r.Unpublished));const K=await this.commonHeadersPromise,q=JSON.stringify($.raw),ee={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ne=new Date().getTime();let oe,le,Se=0;try{if(oe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:ee},j),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:Se};const fe=await(0,h.asJson)(oe);if(fe){const pe=fe.results[0],Ce=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return Se=be&&be.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:Se}}return{galleryExtensions:[],total:Se}}catch(fe){throw le=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ne,success:!!oe&&(0,h.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:le?(0,L.isCancellationError)(le)?"canceled":(0,L.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic($,j,K,q){if(!this.isEnabled())return;const ee=T.isWeb?this.api(`/itemName/${$}.${j}/version/${K}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${j}/${K}/stats?statType=${q}`),ne=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:ne};try{await this.requestService.request({type:"POST",url:ee,headers:le},t.CancellationToken.None)}catch{}}async download($,j,K){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const q=(0,p.getGalleryExtensionTelemetryData)($),ee=new Date().getTime(),ne=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:fe}),oe=K===2?"install":K===3?"update":"",le=oe?{uri:`${$.assets.download.uri}${b.URI.parse($.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${$.assets.download.fallbackUri}${b.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:$.assets.download,Se=await this.getAsset(le);await this.fileService.writeFile(j,Se.stream),ne(new Date().getTime()-ee)}async getReadme($,j){if($.assets.readme){const K=await this.getAsset($.assets.readme,{},j);return await(0,h.asTextOrError)(K)||""}return""}async getManifest($,j){if($.assets.manifest){const K=await this.getAsset($.assets.manifest,{},j),q=await(0,h.asTextOrError)(K);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion($,j){const K=N($,a.Manifest);if(!K)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},ee=await this.getAsset(K,{headers:q});return await(0,h.asJson)(ee)}async getCoreTranslation($,j){const K=$.assets.coreTranslations.filter(q=>q[0]===j.toUpperCase())[0];if(K){const q=await this.getAsset(K[1]),ee=await(0,h.asTextOrError)(q);return ee?JSON.parse(ee):null}return null}async getChangelog($,j){if($.assets.changelog){const K=await this.getAsset($.assets.changelog,{},j);return await(0,h.asTextOrError)(K)||""}return""}async getAllCompatibleVersions($,j,K){let q=new c().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?q=q.withFilter(i.ExtensionId,$.identifier.uuid):q=q.withFilter(i.ExtensionName,$.identifier.id);const{galleryExtensions:ee}=await this.queryRawGalleryExtensions(q,t.CancellationToken.None);if(!ee.length)return[];const ne=V(ee[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(ne,K))return[];const oe=[];await Promise.all(ee[0].versions.map(async fe=>{try{await this.isValidVersion(fe,j?"any":"release",!0,ne,K)&&oe.push(fe)}catch{}}));const le=[],Se=new Set;for(const fe of G(oe,K))Se.has(fe.version)||(Se.add(fe.version),le.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:U(fe)}));return le}async getAsset($,j={},K=t.CancellationToken.None){const q=await this.commonHeadersPromise,ee={type:"GET"},ne={...q,...j.headers||{}};j={...j,...ee,headers:ne};const oe=$.uri,le=$.fallbackUri,Se={...j,url:oe};try{const fe=await this.requestService.request(Se,K);if(fe.res.statusCode===200)return fe;const pe=await(0,h.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${pe}`)}catch(fe){if((0,L.isCancellationError)(fe))throw fe;const pe=(0,L.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:pe});const Ce={...j,url:le};return this.requestService.request(Ce,K)}}async getEngine($){let j=M($);if(!j){const K=await this.getManifestFromRawExtensionVersion($,t.CancellationToken.None);if(!K)throw new Error("Manifest was not found");j=K.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,h.asJson)($),K=[],q={};if(j){for(const ee of j.malicious)K.push({id:ee});if(j.migrateToPreRelease)for(const[ee,ne]of Object.entries(j.migrateToPreRelease))(!ne.engine||(0,E.isEngineValid)(ne.engine,this.productService.version,this.productService.date))&&(q[ee.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[ee,ne]of Object.entries(j.deprecated))ne&&(q[ee.toLowerCase()]=(0,I.isBoolean)(ne)?{}:ne)}return{malicious:K,deprecated:q}}};x=me([Q(1,h.IRequestService),Q(2,S.ILogService),Q(3,D.IEnvironmentService),Q(4,f.ITelemetryService),Q(5,d.IFileService),Q(6,y.IProductService),Q(7,P.IConfigurationService)],x);let B=class extends x{constructor($,j,K,q,ee,ne,oe,le){super($,j,K,q,ee,ne,oe,le)}};B=me([Q(0,m.IStorageService),Q(1,h.IRequestService),Q(2,S.ILogService),Q(3,D.IEnvironmentService),Q(4,f.ITelemetryService),Q(5,d.IFileService),Q(6,y.IProductService),Q(7,P.IConfigurationService)],B),e.ExtensionGalleryService=B;let J=class extends x{constructor($,j,K,q,ee,ne,oe){super(void 0,$,j,K,q,ee,ne,oe)}};J=me([Q(0,h.IRequestService),Q(1,S.ILogService),Q(2,D.IEnvironmentService),Q(3,f.ITelemetryService),Q(4,d.IFileService),Q(5,y.IProductService),Q(6,P.IConfigurationService)],J),e.ExtensionGalleryServiceWithNoStorageService=J}),define(re[71],se([0,1,5,3,2,22,32,24,17,7,14]),function(Z,e,R,t,L,T,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Je extends L.Disposable{constructor(d,S,y){super();this.storageService=d,this.productService=S,this.logService=y,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(d),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const S=w.exec(d);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(d,S){const y=await d.getInstalled(),h=[];for(const[v,m]of Je.readAllExtensionsWithKeysForSync(S)){const f=y.find(u=>(0,A.areSameExtensions)(u.identifier,{id:v}))?.manifest.version;for(const u of m)f!==u&&h.push(Je.toKey({id:v,version:u}))}for(const v of h)S.remove(v,0)}static readAllExtensionsWithKeysForSync(d){const S=new Map,y=d.keys(0,1);for(const h of y){const v=Je.fromKey(h);if(v){let m=S.get(v.id.toLowerCase());m||S.set(v.id.toLowerCase(),m=[]),m.push(v.version)}}return S}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Je.fromKey(d.key);if(S){if(this.storageService.get(d.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let y=this.extensionsWithKeysForSync.get(S.id.toLowerCase());y||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),y=[]),y.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(d){if((0,D.isString)(d))return d;const S=d.manifest?d.manifest.publisher:d.publisher,y=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(S,y)}getExtensionState(d,S){const y=this.getExtensionId(d),h=this.storageService.get(y,S?0:1);if(h)try{return JSON.parse(h)}catch(v){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${S}): ${v}`)}}setExtensionState(d,S,y){const h=this.getExtensionId(d);S===void 0?this.storageService.remove(h,y?0:1):this.storageService.store(h,JSON.stringify(S),y?0:1,1)}setKeysForSync(d,S){this.storageService.store(Je.toKey(d),JSON.stringify(S),0,1)}getKeysForSync(d){const S=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],y=this.storageService.get(Je.toKey(d),0),h=y?JSON.parse(y):void 0;return h&&S?(0,b.distinct)([...h,...S]):h||S}addToMigrationList(d,S){if(d!==S){const y=this.migrationList.filter(h=>!h.includes(d)&&!h.includes(S));y.push([d,S]),this.migrationList=y}}getSourceExtensionToMigrate(d){const S=this.migrationList.find(([,y])=>d===y);return S?S[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(d);if((0,D.isArray)(S))return S}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=me([Q(0,T.IStorageService),Q(1,I.IProductService),Q(2,P.ILogService)],p),e.ExtensionStorageService=p}),define(re[240],se([0,1,17,6,74,3,12,4,35,8,144,15,30,32,208,92,13,7,67,24,44,22,21]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let a=class extends d.ExtensionTipsService{constructor(o,s,c,g,C,O,_,N,k,M){super(_,N,k,M);this.environmentService=o,this.telemetryService=s,this.extensionManagementService=c,this.storageService=g,this.nativeHostService=C,this.extensionRecommendationNotificationService=O,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,N.exeBasedExtensionTips&&(0,L.forEach)(N.exeBasedExtensionTips,({key:U,value:H})=>{const W=[],z=[],te=[];(0,L.forEach)(H.recommendations,({key:V,value:G})=>{G.important?H.important?W.push({extensionId:V,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):z.push({extensionId:V,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):te.push({extensionId:V,extensionName:G.name,isExtensionPack:!!G.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(U,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:W}),z.length&&this.mediumImportanceExecutableTips.set(U,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:z}),te.length&&this.allOtherExecutableTips.set(U,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:te})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,c)}groupImportantTipsByExe(o,s){const c=new Map;o.forEach(N=>c.set(N.extensionId.toLowerCase(),N));const{installed:g,uninstalled:C}=this.groupByInstalled([...c.keys()],s);for(const N of g){const k=c.get(N);k&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:N,exeName:k.exeName})}for(const N of C){const k=c.get(N);k&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:N,exeName:k.exeName})}const O=this.getPromptedExecutableTips(),_=new Map;for(const N of C){const k=c.get(N);if(k&&(!O[k.exeName]||!O[k.exeName].includes(k.extensionId))){let M=_.get(k.exeName);M||(M=[],_.set(k.exeName,M)),M.push(k)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const g=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,t.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),s=Date.now()-o,c=7*24*60*60*1e3;if(s<c){const O=this._register((0,t.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},c-s));return}const[g,C]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(C).then(O=>{switch(O){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(C[0].exeName,C);const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(o){const s=await this.extensionManagementService.getInstalled(1),c=o.filter(C=>!C.whenNotInstalled||C.whenNotInstalled.every(O=>s.every(_=>!(0,E.areSameExtensions)(_.identifier,{id:O})))).map(({extensionId:C})=>C.toLowerCase()),g=(0,D.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,g,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(i,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(i,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(o,s){const c=this.getPromptedExecutableTips();c[o]=s.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(n,JSON.stringify(c),-1,0)}groupByInstalled(o,s){const c=[],g=[],C=s.reduce((O,_)=>(O.add(_.identifier.id.toLowerCase()),O),new Set);return o.forEach(O=>{C.has(O.toLowerCase())?c.push(O):g.push(O)}),{installed:c,uninstalled:g}}async getValidExecutableBasedExtensionTips(o){const s=[],c=new Map;for(const g of o.keys()){const C=o.get(g);if(!C||!(0,R.isNonEmptyArray)(C.recommendations))continue;const O=[];I.isWindows?C.windowsPath&&O.push(C.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(O.push((0,A.join)("/usr/local/bin",g)),O.push((0,A.join)("/usr/bin",g)),O.push((0,A.join)(this.environmentService.userHome.fsPath,g)));for(const _ of O){let N=c.get(_);if(N===void 0&&(N=await this.fileService.exists(P.URI.file(_)),c.set(_,N)),N)for(const{extensionId:k,extensionName:M,isExtensionPack:U,whenNotInstalled:H}of C.recommendations)s.push({extensionId:k,extensionName:M,isExtensionPack:U,exeName:g,exeFriendlyName:C.exeFriendlyName,windowsPath:C.windowsPath,whenNotInstalled:H})}}return s}};a=me([Q(0,w.INativeEnvironmentService),Q(1,r.ITelemetryService),Q(2,p.IExtensionManagementService),Q(3,u.IStorageService),Q(4,v.INativeHostService),Q(5,S.IExtensionRecommendationNotificationService),Q(6,y.IFileService),Q(7,m.IProductService),Q(8,f.IRequestService),Q(9,h.ILogService)],a),e.ExtensionTipsService=a}),define(re[241],se([0,1,6,2,19,86,22,214]),function(Z,e,R,t,L,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends A.AbstractStorageService{constructor(D,w,p,E){super();this.initialWorkspace=D,this.initialProfiles=w,this.mainProcessService=p,this.environmentService=E,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new t.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new t.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const D=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),w=this._register(new T.Storage(D));return this._register(w.onDidChangeStorage(p=>this.emitDidChangeValue(-1,p))),w}createProfileStorage(D){this.profileStorageDisposables.clear(),this.profileStorageProfile=D;let w;if((0,A.isProfileUsingDefaultStorage)(D))w=this.applicationStorage;else{const p=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),D));w=this.profileStorageDisposables.add(new T.Storage(p))}return this.profileStorageDisposables.add(w.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),w}createWorkspaceStorage(D){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=D?.id;let w;if(D){const p=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),D));w=this.workspaceStorageDisposables.add(new T.Storage(p)),this.workspaceStorageDisposables.add(w.onDidChangeStorage(E=>this.emitDidChangeValue(1,E)))}return w}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(D){switch(D){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(D){switch(D){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(D,w){if(!this.canSwitchProfile(this.profileStorageProfile,D))return;const p=this.profileStorage,E=p.items;p!==this.applicationStorage&&await p.close(),this.profileStorage=this.createProfileStorage(D),await this.profileStorage.init(),this.switchData(E,this.profileStorage,0,w)}async switchToWorkspace(D,w){const p=this.workspaceStorage,E=p?.items??new Map;await p?.close(),this.workspaceStorage=this.createWorkspaceStorage(D),await this.workspaceStorage.init(),this.switchData(E,this.workspaceStorage,1,w)}}e.NativeStorageService=b}),define(re[242],se([0,1,15,13,95,7,28]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends A.UserDataProfilesService{constructor(P,D,w,p,E){super(w,p,E);this._profiles=[],this.channel=D.getChannel("userDataProfiles"),this._profiles=P.map(d=>(0,A.reviveProfile)(d,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(d=>{const S=d.added.map(h=>(0,A.reviveProfile)(h,this.profilesHome.scheme)),y=d.removed.map(h=>(0,A.reviveProfile)(h,this.profilesHome.scheme));this._profiles=d.all.map(h=>(0,A.reviveProfile)(h,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:S,removed:y,all:this.profiles})}))}get profiles(){return this._profiles}async createProfile(P,D){const w=await this.channel.call("createProfile",[P,D]);return(0,A.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(P,D){const w=await this.channel.call("setProfileForWorkspace",[P,D]);return(0,A.reviveProfile)(w,this.profilesHome.scheme)}removeProfile(P){return this.channel.call("removeProfile",[P])}};I=me([Q(1,L.IMainProcessService),Q(2,R.IEnvironmentService),Q(3,t.IFileService),Q(4,T.ILogService)],I),e.UserDataProfilesNativeService=I}),define(re[59],se([0,1,76]),function(Z,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(A,I,b,P){const D=(0,R.setProperty)(A,I,b,P)[0];return D&&(A=A.substring(0,D.offset)+D.content+A.substring(D.offset+D.length)),A}e.edit=t;function L(A,I,b){let P=b;for(;P>=0;){if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1)return P+1;if(P--,I.length===2&&P>=0&&A.charAt(P)===I.charAt(0))return P+2}return 0}e.getLineStartOffset=L;function T(A,I,b){let P=b;for(;P>=0;)if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1||(P++,I.length===2&&P>=0&&A.charAt(P)===I.charAt(1)))return P;return A.length-1}e.getLineEndOffset=T}),define(re[243],se([0,1,29,55,14]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(p,E,d,S,y){const h=[],v=[],m=[];if(!E){const _=p.filter(({identifier:N})=>y.every(k=>k.toLowerCase()!==N.id.toLowerCase()));return{local:{added:h,removed:v,updated:m},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}p=p.map(D),E=E.map(D),d=d?d.map(D):null;const f=new Map,u=_=>{_.uuid&&f.set(_.id.toLowerCase(),_.uuid)};p.forEach(({identifier:_})=>u(_)),E.forEach(({identifier:_})=>u(_)),d?.forEach(({identifier:_})=>u(_));const r=_=>{const N=_.identifier.uuid||f.get(_.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${_.identifier.id.toLowerCase()}`},n=(_,N)=>(_.set(r(N),N),_),i=p.reduce(n,new Map),a=E.reduce(n,new Map),l=E.reduce((_,N)=>{const k=r(N);N=(0,R.deepClone)(N);const M=i.get(k);return M&&(M.installed&&(N.installed=!0),N.version||(N.version=M.version)),n(_,N)},new Map),o=d?d.reduce(n,new Map):null,s=S.reduce(n,new Map),c=y.reduce((_,N)=>{const k=f.get(N.toLowerCase());return _.add(k?`uuid:${k}`:`id:${N.toLowerCase()}`)},new Set),g=A(i,a,c);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const _=A(o,i,c),N=A(o,a,c),k=(M,U)=>{const H=i.get(M);if(H){const W=a.get(M),z=U?W:H;return{...z,version:W.version&&(!H.installed||t.gt(W.version,H.version))?W.version:H.version,state:I(H,W,o?.get(M)),preRelease:(0,L.isUndefined)(z.preRelease)?H.preRelease:H.installed?z.preRelease:W.preRelease}}};for(const M of N.removed.values()){const U=i.get(M);U&&v.push(U.identifier)}for(const M of N.added.values())if(_.added.has(M)){if(g.updated.has(M)){const U=k(M,!0);U&&(m.push(w(U,M)),l.set(M,U))}}else{const U=a.get(M);U.installed&&h.push(w(U,M))}for(const M of N.updated.values()){const U=k(M,!0);U&&(m.push(w(U,M)),l.set(M,U))}for(const M of _.added.values())N.added.has(M)||l.set(M,i.get(M));for(const M of _.updated.values())if(!N.removed.has(M)&&!N.updated.has(M)){const U=k(M,!1);U&&(l.get(M)?.installed&&(U.installed=!0),l.set(M,U))}for(const M of _.removed.values())!s.has(M)&&!N.updated.has(M)&&o?.get(M)?.installed&&l.delete(M)}const C=[],O=A(a,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&l.forEach((_,N)=>C.push(w(_,N))),{local:{added:h,removed:v,updated:m},remote:C.length?{added:[...O.added].map(_=>l.get(_)),updated:[...O.updated].map(_=>l.get(_)),removed:[...O.removed].map(_=>a.get(_)),all:C}:null}}e.merge=T;function A(p,E,d,{checkInstalledProperty:S,checkVersionProperty:y}={checkInstalledProperty:!1,checkVersionProperty:!1}){const h=p?[...p.keys()].filter(r=>!d.has(r)):[],v=[...E.keys()].filter(r=>!d.has(r)),m=v.filter(r=>h.indexOf(r)===-1).reduce((r,n)=>(r.add(n),r),new Set),f=h.filter(r=>v.indexOf(r)===-1).reduce((r,n)=>(r.add(n),r),new Set),u=new Set;for(const r of h){if(f.has(r))continue;const n=p.get(r),i=E.get(r);(!i||n.disabled!==i.disabled||n.installed&&i.installed&&n.preRelease!==i.preRelease||!P(n.state,i.state)||y&&n.version!==i.version||S&&n.installed!==i.installed)&&u.add(r)}return{added:m,removed:f,updated:u}}function I(p,E,d){const S=p.state,y=E.state,h=d?.state;if(!E.version||S&&t.gt(p.version,E.version))return S;if(y&&t.gt(E.version,p.version)||!S)return y;if(!y)return S;const v=(0,R.deepClone)(S),m=h?b(h,y):{added:Object.keys(y).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set},f=h?b(h,S):{added:Object.keys(S).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set};for(const u of[...m.added.values(),...m.updated.values()])v[u]=y[u];for(const u of m.removed.values())f.updated.has(u)||delete v[u];return v}function b(p,E){const d=Object.keys(p),S=Object.keys(E),y=S.filter(m=>d.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),h=d.filter(m=>S.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),v=new Set;for(const m of d){if(h.has(m))continue;const f=p[m],u=E[m];(0,R.equals)(f,u)||v.add(m)}return{added:y,removed:h,updated:v}}function P(p={},E={}){const{added:d,removed:S,updated:y}=b(p,E);return d.size===0&&S.size===0&&y.size===0}function D(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function w(p,E){const d={identifier:{id:p.identifier.id,uuid:E.startsWith("uuid:")?E.substring("uuid:".length):void 0},preRelease:!!p.preRelease};return p.version&&(d.version=p.version),p.disabled&&(d.disabled=!0),p.installed&&(d.installed=!0),p.state&&(d.state=p.state),d}}),define(re[107],se([0,1,17,18,5]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,b){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return P=P.filter(D=>D!==I&&D!==`-${I}`),b&&P.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,1)}updateSynchronizedExtensions(I,b){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return P=P.filter(D=>D!==I&&D!==`-${I}`),b&&P.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,1)}getIgnoredExtensions(I){const b=I.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),P=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),D=[],w=[];if(Array.isArray(P))for(const p of P)p.startsWith("-")?w.push(p.substring(1)):D.push(p);return(0,R.distinct)([...b,...D].filter(p=>w.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};T=me([Q(0,t.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(re[244],se([0,1,17,34,29,173,59]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(f){return(0,t.parse)(f)||[]}e.parseKeybindings=I;async function b(f,u,r,n,i){const a=I(f),l=I(u),o=r?I(r):null,s=[...a,...l,...o||[]].map(W=>W.key),c=await i.resolveUserBindings(s),g=D(a,l,o,c);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const C=p(a),O=p(l),_=o?p(o):null,N=d(C,O,c),k=_?d(_,C,c):{added:[...C.keys()].reduce((W,z)=>(W.add(z),W),new Set),removed:new Set,updated:new Set},M=_?d(_,O,c):{added:[...O.keys()].reduce((W,z)=>(W.add(z),W),new Set),removed:new Set,updated:new Set},U=P(N,k,M);let H=f;for(const W of U.removed.values())U.conflicts.has(W)||(H=v(H,W,n));for(const W of U.added.values()){if(U.conflicts.has(W))continue;const z=O.get(W);if(z.some(te=>te.command!==`-${W}`&&g.conflicts.has(c[te.key]))){U.conflicts.add(W);continue}H=h(H,z,n)}for(const W of U.updated.values()){if(U.conflicts.has(W))continue;const z=O.get(W);if(z.some(te=>te.command!==`-${W}`&&g.conflicts.has(c[te.key]))){U.conflicts.add(W);continue}H=m(H,W,z,n)}return{mergeContent:H,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=b;function P(f,u,r){const n=new Set,i=new Set,a=new Set,l=new Set;for(const o of u.removed.values())r.updated.has(o)&&l.add(o);for(const o of r.removed.values())l.has(o)||(u.updated.has(o)?l.add(o):i.add(o));for(const o of u.added.values())l.has(o)||r.added.has(o)&&f.updated.has(o)&&l.add(o);for(const o of r.added.values())l.has(o)||(u.added.has(o)?f.updated.has(o)&&l.add(o):n.add(o));for(const o of u.updated.values())l.has(o)||r.updated.has(o)&&f.updated.has(o)&&l.add(o);for(const o of r.updated.values())l.has(o)||(u.updated.has(o)?f.updated.has(o)&&l.add(o):a.add(o));return{added:n,removed:i,updated:a,conflicts:l}}function D(f,u,r,n){const i=new Set,a=w(f,n),l=w(u,n),o=r?w(r,n):null,s=E(a,l);if(s.added.size===0&&s.removed.size===0&&s.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const c=o?E(o,a):{added:[...a.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const g=o?E(o,l):{added:[...l.keys()].reduce((k,M)=>(k.add(M),k),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:C,removed:O,updated:_,conflicts:N}=P(s,c,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:O,updated:_,conflicts:N}}function w(f,u){const r=new Map;for(const n of f){const i=u[n.key];let a=r.get(i);a||(a=[],r.set(i,a)),a.push(n)}return r}function p(f){const u=new Map;for(const r of f){const n=r.command[0]==="-"?r.command.substring(1):r.command;let i=u.get(n);i||(i=[],u.set(n,i)),i.push(r)}return u}function E(f,u){const r=[...f.keys()],n=[...u.keys()],i=n.filter(o=>r.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),a=r.filter(o=>n.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),l=new Set;for(const o of r){if(a.has(o))continue;const s=f.get(o).map(g=>({...g,key:o})),c=u.get(o).map(g=>({...g,key:o}));(0,R.equals)(s,c,(g,C)=>y(g,C))||l.add(o)}return{added:i,removed:a,updated:l}}function d(f,u,r){const n=[...f.keys()],i=[...u.keys()],a=i.filter(s=>n.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),l=n.filter(s=>i.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),o=new Set;for(const s of n){if(l.has(s))continue;const c=f.get(s).map(C=>({...C,key:r[C.key]})),g=u.get(s).map(C=>({...C,key:r[C.key]}));S(c,g)||o.add(s)}return{added:a,removed:l,updated:o}}function S(f,u){return!(!(0,R.equals)(f.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,n)=>y(r,n))||!(0,R.equals)(f.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,n)=>y(r,n)))}function y(f,u){if(f.command!==u.command||f.key!==u.key)return!1;const r=T.ContextKeyExpr.deserialize(f.when),n=T.ContextKeyExpr.deserialize(u.when);return!(r&&!n||!r&&n||r&&n&&!r.equals(n)||!L.equals(f.args,u.args))}function h(f,u,r){for(const n of u)f=A.edit(f,[-1],n,r);return f}function v(f,u,r){const n=I(f);for(let i=n.length-1;i>=0;i--)(n[i].command===u||n[i].command===`-${u}`)&&(f=A.edit(f,[i],void 0,r));return f}function m(f,u,r,n){const i=I(f),a=i.findIndex(l=>l.command===u||l.command===`-${u}`);for(let l=i.length-1;l>=0;l--)(i[l].command===u||i[l].command===`-${u}`)&&(f=A.edit(f,[l],void 0,n));for(let l=r.length-1;l>=0;l--)f=A.edit(f,[a],r[l],n);return f}}),define(re[245],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,A,I){const b={},P={},D=new Set;if(!A)return{local:{added:b,updated:P,removed:[...D.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const w=t(T,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:b,updated:P,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=t(I,T),E=t(I,A),d={},S={},y=new Set,h=new Set;for(const v of p.removed.values())E.updated.has(v)?b[v]=A[v]:y.add(v);for(const v of E.removed.values())h.has(v)||(p.updated.has(v)?h.add(v):D.add(v));for(const v of p.updated.values())h.has(v)||(E.updated.has(v)?w.updated.has(v)&&h.add(v):S[v]=T[v]);for(const v of E.updated.values())h.has(v)||(p.updated.has(v)?w.updated.has(v)&&h.add(v):T[v]!==void 0&&(P[v]=A[v]));for(const v of p.added.values())h.has(v)||(E.added.has(v)?w.updated.has(v)&&h.add(v):d[v]=T[v]);for(const v of E.added.values())h.has(v)||(p.added.has(v)?w.updated.has(v)&&h.add(v):b[v]=A[v]);return{local:{added:b,removed:[...D.values()],updated:P},remote:{added:d,removed:[...y.values()],updated:S},conflicts:[...h.values()]}}e.merge=R;function t(T,A){const I=T?Object.keys(T):[],b=A?Object.keys(A):[],P=b.filter(p=>I.indexOf(p)===-1).reduce((p,E)=>(p.add(E),p),new Set),D=I.filter(p=>b.indexOf(p)===-1).reduce((p,E)=>(p.add(E),p),new Set),w=new Set;for(const p of I){if(D.has(p))continue;const E=T[p],d=A[p];E!==d&&w.add(p)}return{added:P,removed:D,updated:w}}function L(T,A){const{added:I,removed:b,updated:P}=t(T,A);return I.size===0&&b.size===0&&P.size===0}e.areSame=L}),define(re[25],se([0,1,17,19,14,163,43,30,5,98,40]),function(Z,e,R,t,L,T,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const o=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(s=>!!o[s].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function p(){const o=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(o).filter(C=>!!o[C].ignoreSync),c=Object.keys(o).filter(C=>o[C].scope===2||o[C].scope===6),g=w();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...s,...c,...g])}e.getDefaultIgnoredSettings=p,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function E(){const o="vscode://schemas/ignoredSettings",s=D.Registry.as(A.Extensions.Configuration);s.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const c=D.Registry.as(P.Extensions.JSONContribution),g=()=>{const C=w(),O=p().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),_=Object.keys(A.allSettings.properties).filter(M=>O.indexOf(M)===-1),N=O.filter(M=>C.indexOf(M)===-1),k={items:{type:"string",enum:[..._,...N.map(M=>`-${M}`)]}};c.registerSchema(o,k)};return s.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=E;function d(o){return o&&(0,L.isObject)(o)&&(0,L.isString)(o.id)&&(0,L.isArray)(o.scopes)}e.isAuthenticationProvider=d;var S;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function y(o,s,c){return c.joinPath(s.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(o){const s={};return s[e.HEADER_EXECUTION_ID]=o,s}e.createSyncHeaders=h;var v;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class m extends Error{constructor(s,c,g,C){super(s);this.code=c,this.resource=g,this.operationId=C,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=m;class f extends m{constructor(s,c,g,C,O){super(s,g,void 0,O);this.url=c,this.serverCode=C}}e.UserDataSyncStoreError=f;class u extends m{constructor(s,c){super(s,c)}}e.UserDataAutoSyncError=u,function(o){function s(c){if(c instanceof o)return c;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(c.name);if(g&&g[1]){const C=g[2]==="unknown"?void 0:g[2],O=g[3]==="unknown"?void 0:g[3];return new o(c.message,g[1],C,O)}return new o(c.message,"Unknown")}o.toUserDataSyncError=s}(m=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var n;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(n=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(o){return`sync.enable.${o}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function l(o,s){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:s.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(c=>(0,t.isEqualOrParent)(o,(0,t.joinPath)(s.userDataSyncHome,c,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=l}),define(re[47],se([0,1,17,6,16,23,3,34,2,26,14,8,159,18,15,13,7,49,22,21,33,25,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function n(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=n;let i=class extends b.Disposable{constructor(c,g,C,O,_,N,k,M,U,H,W){super();this.resource=c,this.fileService=g,this.environmentService=C,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=N,this.userDataSyncEnablementService=k,this.telemetryService=M,this.logService=U,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,P.uppercaseFirstLetter)(this.resource),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(C.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(c,C,this.extUri),this.currentMachineIdPromise=(0,h.getServiceMachineId)(C,g,O)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const g=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(g)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){this._status!==c&&(this._status=c,this._onDidChangStatus.fire(c))}async sync(c,g={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),g)}async preview(c,g,C={}){return this._sync(c,!1,g,C)}async apply(c,g={}){try{this.syncHeaders={...g};const C=await this.doApply(c);return this.setStatus(C),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,g,C,O){try{if(this.syncHeaders={...O},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const N=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(c,N);return _=await this.performSync(k,N,g,C),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(c){const g=await this.resolveContent(c);if(!g)return!1;const C=this.parseSyncData(g);if(!C)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const O=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,O),N=await this.isRemoteDataFromCurrentMachine(_),k=await this.generateSyncPreview({ref:_.ref,syncData:C},O,N,this.getUserDataSyncConfiguration(),T.CancellationToken.None),M=[];for(const U of k){const H=await this.getAcceptResult(U,U.remoteResource,void 0,T.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(U,U.previewResource,U.remoteContent,T.CancellationToken.None);M.push([U,{...H,remoteChange:W!==0?W:2}])}await this.applyResult(_,O,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const g=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===g}async getLatestRemoteUserData(c,g){if(g){const C=c&&c.latest?c.latest[this.resource]:void 0;if(g.ref===C||C===void 0&&g.syncData===null)return g}return this.getRemoteUserData(g)}async performSync(c,g,C,O){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,g,C,O)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,g,C,O);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),g=await this.getLastSyncUserData(),this.performSync(c,g,C,O)}throw _}}async doSync(c,g,C,O){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(N=>this.doGenerateSyncResourcePreview(c,g,C,O,N)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:N})=>N==="conflict")?"hasConflicts":C?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(c){return await this.updateSyncResourcePreview(c,async g=>{const C=await this.getMergeResult(g,T.CancellationToken.None);await this.fileService.writeFile(g.previewResource,L.VSBuffer.fromString(C?.content||""));const O=C&&!C.hasConflicts?await this.getAcceptResult(g,g.previewResource,void 0,T.CancellationToken.None):void 0;return g.acceptResult=O,g.mergeState=C.hasConflicts?"conflict":O?"accepted":"preview",g.localChange=O?O.localChange:C.localChange,g.remoteChange=O?O.remoteChange:C.remoteChange,g}),this.syncPreviewPromise}async accept(c,g){return await this.updateSyncResourcePreview(c,async C=>{const O=await this.getAcceptResult(C,c,g,T.CancellationToken.None);return C.acceptResult=O,C.mergeState="accepted",C.localChange=O.localChange,C.remoteChange=O.remoteChange,C}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async g=>{const C=await this.getMergeResult(g,T.CancellationToken.None);return await this.fileService.writeFile(g.previewResource,L.VSBuffer.fromString(C.content||"")),g.acceptResult=void 0,g.mergeState="preview",g.localChange=C.localChange,g.remoteChange=C.remoteChange,g}),this.syncPreviewPromise}async updateSyncResourcePreview(c,g){if(!this.syncPreviewPromise)return;let C=await this.syncPreviewPromise;const O=C.resourcePreviews.findIndex(({localResource:_,remoteResource:N,previewResource:k})=>this.extUri.isEqual(_,c)||this.extUri.isEqual(N,c)||this.extUri.isEqual(k,c));O!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const N=[...C.resourcePreviews];return N[O]=await g(N[O]),{...C,resourcePreviews:N}}),C=await this.syncPreviewPromise,this.updateConflicts(C.resourcePreviews),C.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const g=await this.syncPreviewPromise;return g.resourcePreviews.some(({mergeState:C})=>C==="conflict")?"hasConflicts":g.resourcePreviews.some(({mergeState:C})=>C!=="accepted")?"syncing":(await this.applyResult(g.remoteUserData,g.lastSyncUserData,g.resourcePreviews.map(C=>[C,C.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const g=c.filter(({mergeState:C})=>C==="conflict");(0,R.equals)(this._conflicts,g,(C,O)=>this.extUri.isEqual(C.previewResource,O.previewResource))||(this._conflicts=g,this._onDidChangeConflicts.fire(g))}async hasPreviouslySynced(){const c=await this.getLastSyncUserData();return!!c&&c.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:g,ref:C})=>({created:g,uri:this.toRemoteBackupResource(C)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:g,ref:C})=>({created:g,uri:this.toLocalBackupResource(C)}))}toRemoteBackupResource(c){return w.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return w.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const g=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(g))){const{content:C}=await this.getUserData(g);if(C)return this.parseSyncData(C)?.machineId}}async resolveContent(c){const g=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(g))){const{content:C}=await this.getUserData(g);return C}return this.extUri.isEqual(c,this.toLocalBackupResource(g))?this.userDataSyncBackupStoreService.resolveContent(this.resource,g):null}async resolvePreviewContent(c){const g=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(g)for(const C of g.resourcePreviews){if(this.extUri.isEqual(C.acceptedResource,c))return C.acceptResult?C.acceptResult.content:null;if(this.extUri.isEqual(C.remoteResource,c))return C.remoteContent;if(this.extUri.isEqual(C.localResource,c))return C.localContent;if(this.extUri.isEqual(C.baseResource,c))return C.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,g,C,O,_){const N=await this.isRemoteDataFromCurrentMachine(c),k=await this.generateSyncPreview(c,g,N,O,_),M=[];for(const U of k){const H=U.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)M.push({...U,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=C?await this.getMergeResult(U,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,L.VSBuffer.fromString(W?.content||""));const z=W&&!W.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,_):void 0;M.push({...U,acceptResult:z,mergeState:W?.hasConflicts?"conflict":z?"accepted":"preview",localChange:z?z.localChange:W?W.localChange:U.localChange,remoteChange:z?z.remoteChange:W?W.remoteChange:U.remoteChange})}}return{remoteUserData:c,lastSyncUserData:g,resourcePreviews:M,isLastSyncFromCurrentMachine:N}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),g=JSON.parse(c.value.toString()),C=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=g.version&&C&&g.version!==C,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${g.version} is not compatible with current sync state version ${C}.`),await this.resetLocal(),null;const O=g;if(O.content===null)return{ref:g.ref,syncData:null};const _=JSON.parse(O.content);if(n(_))return{...g,syncData:_,content:void 0}}catch(c){c instanceof S.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,g={}){if(g.ref||g.content||g.version)throw new Error("Cannot have core properties as additional");const C=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),O={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:C,...g};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(O)))}async getRemoteUserData(c){const{ref:g,content:C}=await this.getUserData(c);let O=null;return C!==null&&(O=this.parseSyncData(C)),{ref:g,syncData:O}}parseSyncData(c){try{const g=JSON.parse(c);if(n(g))return g}catch(g){this.logService.error(g)}throw new u.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,D.isString)(c)){const g=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:g}}else{const g=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,g,this.syncHeaders)}}async updateRemoteUserData(c,g){const C=await this.currentMachineIdPromise,O={version:this.version,machineId:C,content:c};return g=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(O),g,this.syncHeaders),{ref:g,syncData:O}}async backupLocal(c){const g={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(g))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=me([Q(1,S.IFileService),Q(2,d.IEnvironmentService),Q(3,v.IStorageService),Q(4,u.IUserDataSyncStoreService),Q(5,u.IUserDataSyncBackupStoreService),Q(6,u.IUserDataSyncEnablementService),Q(7,m.ITelemetryService),Q(8,u.IUserDataSyncLogService),Q(9,E.IConfigurationService),Q(10,f.IUriIdentityService)],i),e.AbstractSynchroniser=i;let a=class extends i{constructor(c,g,C,O,_,N,k,M,U,H,W,z){super(g,C,O,_,N,k,M,U,H,W,z);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(te=>this.onFileChanges(te)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,g,C){try{g?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),C?void 0:g):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:C})}catch(O){throw O instanceof S.FileOperationError&&O.fileOperationResult===1||O instanceof S.FileOperationError&&O.fileOperationResult===3?new u.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};a=me([Q(2,S.IFileService),Q(3,d.IEnvironmentService),Q(4,v.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,m.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,E.IConfigurationService),Q(11,f.IUriIdentityService)],a),e.AbstractFileSynchroniser=a;let l=class extends a{constructor(c,g,C,O,_,N,k,M,U,H,W,z,te){super(c,g,C,O,_,N,k,M,U,H,z,te);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(c,g){const C=[],O=(0,I.parse)(c,C,{allowEmptyContent:!0,allowTrailingComma:!0});return C.length>0||!(0,D.isUndefined)(O)&&g!==Array.isArray(O)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};l=me([Q(2,S.IFileService),Q(3,d.IEnvironmentService),Q(4,v.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,m.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,u.IUserDataSyncUtilService),Q(11,E.IConfigurationService),Q(12,f.IUriIdentityService)],l),e.AbstractJsonFileSynchroniser=l;let o=class{constructor(c,g,C,O,_,N){this.resource=c,this.userDataProfilesService=g,this.environmentService=C,this.logService=O,this.fileService=_,this.extUri=N.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,C,this.extUri)}async initialize({ref:c,content:g}){if(!g){this.logService.info("Remote content does not exist.",this.resource);return}const C=this.parseSyncData(g);if(!!C)try{await this.doInitialize({ref:c,syncData:C})}catch(O){this.logService.error(O)}}parseSyncData(c){try{const g=JSON.parse(c);if(n(g))return g}catch(g){this.logService.error(g)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,g={}){const C={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...g};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(C)))}};o=me([Q(1,r.IUserDataProfilesService),Q(2,d.IEnvironmentService),Q(3,y.ILogService),Q(4,S.IFileService),Q(5,f.IUriIdentityService)],o),e.AbstractInitializer=o}),define(re[246],se([0,1,6,23,9,3,53,26,8,18,15,30,32,71,13,7,22,21,33,28,47,243,107,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function i(o,s){const c=JSON.parse(o.content);if(o.version===1||o.version===2){const g=(await s.getInstalled(0)).filter(C=>C.isBuiltin);for(const C of c)o.version===1&&(C.enabled===!1&&(C.disabled=!0),delete C.enabled),o.version===2&&g.every(O=>!(0,p.areSameExtensions)(O.identifier,C.identifier))&&(C.installed=!0)}return c}let a=class vt extends f.AbstractSynchroniser{constructor(s,c,g,C,O,_,N,k,M,U,H,W,z,te,V){super("extensions",c,s,g,C,O,W,z,M,H,V);this.extensionManagementService=_,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=k,this.extensionGalleryService=U,this.extensionStorageService=te,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,G=>G.some(({local:X})=>!!X)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,G=>!G.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,c){const g=s.syncData?await i(s.syncData,this.extensionManagementService):null,C=c?.skippedExtensions||[],O=c?.syncData?await i(c.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0),N=this.getLocalExtensions(_),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:U}=(0,u.merge)(N,g,O,C,k),H={local:M,remote:U,content:this.getPreviewContent(N,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:U!==null?2:0},W=this.stringify(N,!1);return[{skippedExtensions:C,baseResource:this.baseResource,baseContent:O?this.stringify(O,!1):W,localResource:this.localResource,localContent:W,localExtensions:N,remoteResource:this.remoteResource,remoteContent:g?this.stringify(g,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const c=s.syncData?await i(s.syncData,this.extensionManagementService):null,g=await this.extensionManagementService.getInstalled(void 0),C=this.getLocalExtensions(g),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),{remote:_}=(0,u.merge)(C,c,c,s.skippedExtensions||[],O);return _!==null}getPreviewContent(s,c,g,C){const O=[...c,...g],_=new Set,N=k=>{_.add(k.id.toLowerCase()),k.uuid&&_.add(k.uuid)};O.forEach(({identifier:k})=>N(k)),C.forEach(N);for(const k of s)_.has(k.identifier.id.toLowerCase())||k.identifier.uuid&&_.has(k.identifier.uuid)||O.push(k);return this.stringify(O,!1)}async getMergeResult(s,c){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,c,g,C){if(this.extUri.isEqual(c,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(c,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(c,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async acceptLocal(s){const c=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),C=(0,u.merge)(s.localExtensions,null,null,s.skippedExtensions,g),{local:O,remote:_}=C;return{content:s.localContent,local:O,remote:_,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const c=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),C=s.remoteContent?JSON.parse(s.remoteContent):null;if(C!==null){const O=(0,u.merge)(s.localExtensions,C,s.localExtensions,[],g),{local:_,remote:N}=O;return{content:s.remoteContent,local:_,remote:N,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,c,g,C){let{skippedExtensions:O,localExtensions:_}=g[0][0];const{local:N,remote:k,localChange:M,remoteChange:U}=g[0][1];if(M===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(_)),O=await this.updateLocalExtensions(N.added,N.removed,N.updated,O)),k){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const H=JSON.stringify(k.all);s=await this.updateRemoteUserData(H,C?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${k.added.length?` Added: ${JSON.stringify(k.added.map(W=>W.identifier.id))}.`:""}${k.updated.length?` Updated: ${JSON.stringify(k.updated.map(W=>W.identifier.id))}.`:""}${k.removed.length?` Removed: ${JSON.stringify(k.removed.map(W=>W.identifier.id))}.`:""}`)}c?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(H=>H.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:vt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,vt.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),C=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),O=this.getLocalExtensions(g).filter(_=>!C.some(N=>(0,p.areSameExtensions)({id:N},_.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const g=await this.resolvePreviewContent(s);return g&&this.stringify(JSON.parse(g),!0)}let c=await super.resolveContent(s);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(s)),c){const g=this.parseSyncData(c);if(g)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(g),!0)}}return null}stringify(s,c){return s.sort((g,C)=>!g.identifier.uuid&&C.identifier.uuid?-1:g.identifier.uuid&&!C.identifier.uuid?1:(0,I.compare)(g.identifier.id,C.identifier.id)),c?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(g=>g.installed||g.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,c,g,C){const O=[],_=[],N=await this.extensionManagementService.getInstalled();if(c.length){const M=N.filter(({identifier:U,isBuiltin:H})=>!H&&c.some(W=>(0,p.areSameExtensions)(U,W)));await R.Promises.settled(M.map(async U=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,U.identifier.id),await this.extensionManagementService.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,U.identifier.id),O.push(U.identifier)}))}(s.length||g.length)&&await R.Promises.settled([...s,...g].map(async M=>{const U=N.find(W=>(0,p.areSameExtensions)(W.identifier,M.identifier));if(U&&U.isBuiltin){M.state&&U.manifest.version===M.version&&this.updateExtensionState(M.state,U,U.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(z=>(0,p.areSameExtensions)(z,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),O.push(M.identifier);return}const H=(await this.extensionGalleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],t.CancellationToken.None))[0];if(M.state&&(U?U.manifest.version===M.version:!!H)&&this.updateExtensionState(M.state,U||H,U?.manifest.version),H)try{this.extensionEnablementService.getDisabledExtensions().some(z=>(0,p.areSameExtensions)(z,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,H.version),await this.extensionEnablementService.disableExtension(H.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,H.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,H.version),await this.extensionEnablementService.enableExtension(H.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,H.version))),(!U||U.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(H)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,H.version),await this.extensionManagementService.installFromGallery(H,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,H.version),O.push(H.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,H.displayName||H.identifier.id),_.push(M)))}catch(W){_.push(M),W instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(W.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,H.displayName||H.identifier.id):(this.logService.error(W),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,H.displayName||H.identifier.id))}else _.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const k=[];for(const M of C)O.some(U=>(0,p.areSameExtensions)(U,M.identifier))||k.push(M);for(const M of _)k.some(U=>(0,p.areSameExtensions)(U.identifier,M.identifier))||k.push(M);return k}updateExtensionState(s,c,g){const C=this.extensionStorageService.getExtensionState(c,!0)||{},O=g?this.extensionStorageService.getKeysForSync({id:c.identifier.id,version:g}):void 0;O?O.forEach(_=>{C[_]=s[_]}):Object.keys(s).forEach(_=>C[_]=s[_]),this.extensionStorageService.setExtensionState(c,C,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const c=this.extensionEnablementService.getDisabledExtensions();return s.map(g=>{const{identifier:C,isBuiltin:O,manifest:_,preRelease:N}=g,k={identifier:C,preRelease:N,version:_.version};c.some(M=>(0,p.areSameExtensions)(M,C))&&(k.disabled=!0),O||(k.installed=!0);try{const M=this.extensionStorageService.getKeysForSync({id:C.id,version:_.version});if(M){const U=this.extensionStorageService.getExtensionState(g,!0)||{};k.state=Object.keys(U).reduce((H,W)=>(M.includes(W)&&(H[W]=U[W]),H),{})}}catch(M){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(M))}return k})}};a.EXTENSIONS_DATA_URI=b.URI.from({scheme:n.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),a=me([Q(0,D.IEnvironmentService),Q(1,d.IFileService),Q(2,y.IStorageService),Q(3,n.IUserDataSyncStoreService),Q(4,n.IUserDataSyncBackupStoreService),Q(5,w.IExtensionManagementService),Q(6,w.IGlobalExtensionEnablementService),Q(7,r.IIgnoredExtensionsManagementService),Q(8,n.IUserDataSyncLogService),Q(9,w.IExtensionGalleryService),Q(10,P.IConfigurationService),Q(11,n.IUserDataSyncEnablementService),Q(12,h.ITelemetryService),Q(13,E.IExtensionStorageService),Q(14,v.IUriIdentityService)],a),e.ExtensionsSynchroniser=a;let l=class extends f.AbstractInitializer{constructor(s,c,g,C,O,_,N){super("extensions",C,O,_,g,N);this.extensionManagementService=s,this.ignoredExtensionsManagementService=c}async parseExtensions(s){return s.syncData?await i(s.syncData,this.extensionManagementService):null}generatePreview(s,c){const g=[],C=[],O=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const N=c.find(k=>(0,p.areSameExtensions)(k.identifier,_.identifier));N?(g.push(N),_.disabled&&O.push(_.identifier)):_.installed&&(C.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&O.push(_.identifier))}return{installedExtensions:g,newExtensions:C,disabledExtensions:O,remoteExtensions:s}}};l=me([Q(0,w.IExtensionManagementService),Q(1,r.IIgnoredExtensionsManagementService),Q(2,d.IFileService),Q(3,m.IUserDataProfilesService),Q(4,D.IEnvironmentService),Q(5,S.ILogService),Q(6,v.IUriIdentityService)],l),e.AbstractExtensionsInitializer=l}),define(re[247],se([0,1,29,25]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(I,b,P,D,w){if(!b)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const p=T(I,b);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=P?T(P,b):{added:Object.keys(b).reduce((v,m)=>(v.add(m),v),new Set),removed:new Set,updated:new Set},d=P?T(P,I):{added:Object.keys(I).reduce((v,m)=>(v.add(m),v),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},y=R.deepClone(b),h=!P;for(const v of d.added.values())v!==t.SYNC_SERVICE_URL_TYPE&&h&&E.added.has(v)||(y[v]=I[v]);for(const v of d.updated.values())y[v]=I[v];for(const v of d.removed.values())D.unregistered.includes(v)||delete y[v];for(const v of E.added.values()){const m=b[v];if(D.machine.includes(v)){w.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(P&&d.added.has(v))continue;const f=I[v];f&&f.value===m.value||v===t.SYNC_SERVICE_URL_TYPE&&h&&d.added.has(v)||(f?S.updated[v]=m:S.added[v]=m)}for(const v of E.updated.values()){const m=b[v];if(D.machine.includes(v)){w.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(v)||d.removed.has(v))continue;const f=I[v];f&&f.value===m.value||(S.updated[v]=m)}for(const v of E.removed.values()){if(D.machine.includes(v)){w.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}d.updated.has(v)||d.removed.has(v)||S.removed.push(v)}return{local:S,remote:A(y,b)?null:y}}e.merge=L;function T(I,b){const P=Object.keys(I),D=Object.keys(b),w=D.filter(d=>P.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),p=P.filter(d=>D.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),E=new Set;for(const d of P){if(p.has(d))continue;const S=I[d],y=b[d];R.equals(S,y)||E.add(d)}return{added:w,removed:p,updated:E}}function A(I,b){const{added:P,removed:D,updated:w}=T(I,b);return P.size===0&&D.size===0&&w.size===0}}),define(re[248],se([0,1,16,9,3,34,53,4,8,31,18,15,13,7,49,22,21,33,47,59,247,25,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const n="globalState.argv.",i=["locale"];function a(g,C){const O=g.storage?Object.keys(g.storage).sort():[],_={};return O.forEach(N=>_[N]=g.storage[N]),g.storage=_,C?(0,A.toFormattedString)(g,{}):JSON.stringify(g)}const l=1;let o=class pt extends v.AbstractSynchroniser{constructor(C,O,_,N,k,M,U,H,W,z){super("globalState",C,k,W,O,_,M,U,N,H,z);this.storageService=W,this.version=l,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(C.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(C.onDidFilesChange,te=>te.contains(this.environmentService.argvResource)),L.Event.filter(W.onDidChangeValue,te=>te.scope===0&&te.target!==void 0?te.target===0:W.keys(0,0).includes(te.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(C,O,_){const N=C.syncData?JSON.parse(C.syncData.content):null;O=O===null&&_?C:O;const k=O&&O.syncData?JSON.parse(O.syncData.content):null,M=await this.getLocalGlobalState();N?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const U=this.getStorageKeys(k),{local:H,remote:W}=(0,f.merge)(M.storage,N?N.storage:null,k?k.storage:null,U,this.logService),z={content:null,local:H,remote:W,localChange:Object.keys(H.added).length>0||Object.keys(H.updated).length>0||H.removed.length>0?2:0,remoteChange:W!==null?2:0},te=a(M,!1);return[{baseResource:this.baseResource,baseContent:k?a(k,!1):te,localResource:this.localResource,localContent:te,localUserData:M,remoteResource:this.remoteResource,remoteContent:N?a(N,!1):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:U}]}async hasRemoteChanged(C){const O=C.syncData?JSON.parse(C.syncData.content):null;if(O===null)return!0;const _=await this.getLocalGlobalState(),N=this.getStorageKeys(O),{remote:k}=(0,f.merge)(_.storage,O.storage,O.storage,N,this.logService);return k!==null}async getMergeResult(C,O){return{...C.previewResult,hasConflicts:!1}}async getAcceptResult(C,O,_,N){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(C);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(C);if(this.extUri.isEqual(O,this.previewResource))return C.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(C){return{content:C.localContent,local:{added:{},removed:[],updated:{}},remote:C.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(C){if(C.remoteContent!==null){const O=JSON.parse(C.remoteContent),{local:_,remote:N}=(0,f.merge)(C.localUserData.storage,O.storage,null,C.storageKeys,this.logService);return{content:C.remoteContent,local:_,remote:N,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:C.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(C,O,_,N){const{localUserData:k}=_[0][0],{local:M,remote:U,localChange:H,remoteChange:W}=_[0][1];if(H===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(k)),await this.writeLocalGlobalState(M),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:U});C=await this.updateRemoteUserData(z,N?null:C.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==C.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(C),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:C}){return[{resource:this.extUri.joinPath(C,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(C){if(this.extUri.isEqual(C,pt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return a(_,!0)}if(this.extUri.isEqual(this.remoteResource,C)||this.extUri.isEqual(this.baseResource,C)||this.extUri.isEqual(this.localResource,C)||this.extUri.isEqual(this.acceptedResource,C)){const _=await this.resolvePreviewContent(C);return _&&a(JSON.parse(_),!0)}let O=await super.resolveContent(C);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(C)),O){const _=this.parseSyncData(O);if(_)switch(this.extUri.basename(C)){case"globalState.json":return a(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:C}=await this.getLocalGlobalState();if(Object.keys(C).length>1||C[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const C={},O=await this.getLocalArgvContent(),_=(0,T.parse)(O);for(const N of i)_[N]!==void 0&&(C[`${n}${N}`]={version:1,value:_[N]});for(const N of this.storageService.keys(0,0)){const k=this.storageService.get(N,0);k&&(C[N]={version:1,value:k})}return{storage:C}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const C=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),C.value.toString()}catch(C){this.logService.debug((0,t.getErrorMessage)(C))}return"{}"}async writeLocalGlobalState({added:C,removed:O,updated:_}){const N={},k={},M=(H,W)=>{for(const z of H){if(z.startsWith(n)){N[z.substring(n.length)]=W?W[z].value:void 0;continue}if(W){const te=W[z];te.value!==String(this.storageService.get(z,0))&&(k[z]=te.value)}else this.storageService.get(z,0)!==void 0&&(k[z]=void 0)}};if(M(Object.keys(C),C),M(Object.keys(_),_),M(O),Object.keys(N).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(N),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(k).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(k))this.storageService.store(H,k[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(k))}}async updateArgv(C){const O=await this.getLocalArgvContent();let _=O;for(const N of Object.keys(C))_=(0,m.edit)(_,[N],C[N],{});O!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(C){const O=this.storageService.keys(0,0),_=this.storageService.keys(0,1),N=[...O,..._],k=C?.storage?Object.keys(C.storage).filter(M=>!M.startsWith(n)&&!N.includes(M)&&this.storageService.get(M,0)!==void 0):[];if(!I.isWeb){const M=[...u.ALL_SYNC_RESOURCES.map(U=>(0,u.getEnablementKey)(U)),u.SYNC_SERVICE_URL_TYPE];k.push(...M),_.push(...M)}return{user:O,machine:_,unregistered:k}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=me([Q(0,p.IFileService),Q(1,u.IUserDataSyncStoreService),Q(2,u.IUserDataSyncBackupStoreService),Q(3,u.IUserDataSyncLogService),Q(4,w.IEnvironmentService),Q(5,u.IUserDataSyncEnablementService),Q(6,y.ITelemetryService),Q(7,D.IConfigurationService),Q(8,S.IStorageService),Q(9,h.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends v.AbstractInitializer{constructor(C,O,_,N,k,M){super("globalState",_,N,k,O,M);this.storageService=C}async doInitialize(C){const O=C.syncData?JSON.parse(C.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},N={};for(const k of Object.keys(O.storage))k.startsWith(n)?_[k.substring(n.length)]=O.storage[k].value:this.storageService.get(k,0)===void 0&&(N[k]=O.storage[k].value);if(Object.keys(_).length){let k="{}";try{k=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const M of Object.keys(_))k=(0,m.edit)(k,[M],_[M],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(k))}if(Object.keys(N).length)for(const k of Object.keys(N))this.storageService.store(k,N[k],0,0)}};s=me([Q(0,S.IStorageService),Q(1,p.IFileService),Q(2,r.IUserDataProfilesService),Q(3,w.IEnvironmentService),Q(4,u.IUserDataSyncLogService),Q(5,h.IUriIdentityService)],s),e.GlobalStateInitializer=s;let c=class{constructor(C,O,_,N,k){this.userDataSyncStoreClient=C,this.storageService=O,this.environmentService=_,this.fileService=N,this.logService=k}getSyncStoreType(C){return this.parseGlobalState(C)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(C){const O=(0,u.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(C,O)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(C,O)}throw _}}async doSync(C,O){const _=await this.userDataSyncStoreClient.read("globalState",null,O),N=this.parseGlobalState(_)||{storage:{}};N.storage[u.SYNC_SERVICE_URL_TYPE]={value:C,version:l};const k=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),M={version:l,machineId:k,content:a(N,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(M),_.ref,O)}parseGlobalState({content:C}){if(!C)return null;const O=JSON.parse(C);if((0,v.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};c=me([Q(1,S.IStorageService),Q(2,w.IEnvironmentService),Q(3,p.IFileService),Q(4,E.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(re[249],se([0,1,17,16,3,34,4,14,160,18,15,13,22,21,33,28,47,244,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function m(r,n,i){try{const a=JSON.parse(r);if(!n)return(0,I.isUndefined)(a.all)?null:a.all;switch(A.OS){case 2:return(0,I.isUndefined)(a.mac)?null:a.mac;case 3:return(0,I.isUndefined)(a.linux)?null:a.linux;case 1:return(0,I.isUndefined)(a.windows)?null:a.windows}}catch(a){return i.error(a),null}}e.getKeybindingsContentFromSyncContent=m;let f=class extends y.AbstractJsonFileSynchroniser{constructor(n,i,a,l,o,s,c,g,C,O,_,N){super(c.defaultProfile.keybindingsResource,"keybindings",s,g,C,n,i,o,_,a,O,l,N);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(l.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(n,i,a,l){const o=n.syncData?m(n.syncData.content,l.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;i=i===null&&a?n:i;const s=i?this.getKeybindingsContentFromLastSyncUserData(i):null,c=await this.getLocalFileContent(),g=await this.getFormattingOptions();let C=null,O=!1,_=!1,N=!1;if(o){let U=c?c.value.toString():"[]";if(U=U||"[]",this.hasErrors(U,!0))throw new v.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==U||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const H=await(0,h.merge)(U,o,s,g,this.userDataSyncUtilService);H.hasChanges&&(C=H.mergeContent,N=H.hasConflicts,O=N||H.mergeContent!==U,_=N||H.mergeContent!==o)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),C=c.value.toString(),_=!0);const k={content:C,localChange:O?c?2:1:0,remoteChange:_?2:0,hasConflicts:N},M=c?c.value.toString():null;return[{fileContent:c,baseResource:this.baseResource,baseContent:s!==null?s:M,localResource:this.localResource,localContent:M,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const i=this.getKeybindingsContentFromLastSyncUserData(n);if(i===null)return!0;const a=await this.getLocalFileContent(),l=a?a.value.toString():"",o=await this.getFormattingOptions(),s=await(0,h.merge)(l||"[]",i,i,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==i}async getMergeResult(n,i){return n.previewResult}async getAcceptResult(n,i,a,l){if(this.extUri.isEqual(i,this.localResource))return{content:n.fileContent?n.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:n.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return a===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(n,i,a,l){const{fileContent:o}=a[0][0];let{content:s,localChange:c,remoteChange:g}=a[0][1];if(c===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s,!0)))throw new v.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,l),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const C=this.toSyncContent(s||"[]",n.syncData?.content);n=await this.updateRemoteUserData(C,l?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(n,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const i=(0,T.parse)(n.value.toString());if((0,R.isNonEmptyArray)(i))return!0}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"keybindings.json"),comparableResource:i}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.baseResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n))return this.resolvePreviewContent(n);let i=await super.resolveContent(n);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(n)),i){const a=this.parseSyncData(i);if(a)switch(this.extUri.basename(n)){case"keybindings.json":return m(a.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(n){return!n.syncData||n.platformSpecific!==void 0&&n.platformSpecific!==this.syncKeybindingsPerPlatform()?null:m(n.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(n,i){let a={};try{a=JSON.parse(i||"{}")}catch(l){this.logService.error(l)}switch(this.syncKeybindingsPerPlatform()?delete a.all:a.all=n,A.OS){case 2:a.mac=n;break;case 3:a.linux=n;break;case 1:a.windows=n;break}return JSON.stringify(a)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=me([Q(0,v.IUserDataSyncStoreService),Q(1,v.IUserDataSyncBackupStoreService),Q(2,v.IUserDataSyncLogService),Q(3,P.IConfigurationService),Q(4,v.IUserDataSyncEnablementService),Q(5,w.IFileService),Q(6,S.IUserDataProfilesService),Q(7,D.IEnvironmentService),Q(8,p.IStorageService),Q(9,v.IUserDataSyncUtilService),Q(10,E.ITelemetryService),Q(11,d.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let u=class extends y.AbstractInitializer{constructor(n,i,a,l,o){super("keybindings",i,a,l,n,o)}async doInitialize(n){const i=n.syncData?this.getKeybindingsContentFromSyncContent(n.syncData.content):null;if(!i){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,t.VSBuffer.fromString(i)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),i=(0,T.parse)(n.value.toString());return!(0,R.isNonEmptyArray)(i)}catch(n){return n.fileOperationResult===1}}getKeybindingsContentFromSyncContent(n){try{return m(n,!0,this.logService)}catch(i){return this.logService.error(i),null}}};u=me([Q(0,w.IFileService),Q(1,S.IUserDataProfilesService),Q(2,D.IEnvironmentService),Q(3,v.IUserDataSyncLogService),Q(4,d.IUriIdentityService)],u),e.KeybindingsInitializer=u}),define(re[250],se([0,1,17,34,76,53,29,59,25]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function P(s,c,g){let C=[];g?C=w(g):C=D(c);const O=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(C))for(const N of C)N.startsWith("-")?_.push(N.substring(1)):O.push(N);return(0,R.distinct)([...s,...O].filter(N=>_.indexOf(N)===-1))}e.getIgnoredSettings=P;function D(s){let c=s.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=s.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:s.getValue("settingsSync.ignoredSettings")||[]}function w(s){const c=(0,t.parse)(s);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function p(s,c){const g=(0,t.parse)(s)||{};let C="{}";for(const O of Object.keys(g)){const _=(0,L.setProperty)(C,[O],g[O],c);C=(0,L.applyEdits)(C,_)}return C}e.removeComments=p;function E(s,c,g,C){if(g.length){const O=o(c),_=(0,t.parse)(c)||{},N=(0,t.parse)(s);if(!N)return s;const k=[];for(const M of g){const U=_[M],H=N[M];U===void 0?s=I.edit(s,[M],void 0,C):H!==void 0?s=I.edit(s,[M],U,C):k.push(r(M,O))}k.sort((M,U)=>M.startOffset-U.startOffset),k.forEach(M=>s=v(M.setting.key,c,s,C))}return s}e.updateIgnoredSettings=E;function d(s,c,g,C,O,_){const N=E(s,c,C,_),k=g!==N,M=g!==c;if(!k&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!k)return{conflictsSettings:[],localContent:E(c,s,C,_),remoteContent:null,hasConflicts:!1};if(g===null&&y(s)){const K=S(s,c,C)?null:E(c,s,C,_);return{conflictsSettings:[],localContent:K,remoteContent:null,hasConflicts:!1}}let U=s,H=c;const W=(0,t.parse)(s),z=(0,t.parse)(c),te=g?(0,t.parse)(g):null,V=C.reduce((K,q)=>(K.add(q),K),new Set),G=h(W,z,V),X=h(te,W,V),Y=h(te,z,V),x=new Map,B=new Set,J=K=>{B.add(K);const q=O.filter(({key:ee})=>ee===K)[0];q?(U=I.edit(U,[K],q.value,_),H=I.edit(H,[K],q.value,_)):x.set(K,{key:K,localValue:W[K],remoteValue:z[K]})};for(const K of X.removed.values())Y.updated.has(K)?J(K):H=I.edit(H,[K],void 0,_);for(const K of Y.removed.values())B.has(K)||(X.updated.has(K)?J(K):U=I.edit(U,[K],void 0,_));for(const K of X.updated.values())B.has(K)||(Y.updated.has(K)?G.updated.has(K)&&J(K):H=I.edit(H,[K],W[K],_));for(const K of Y.updated.values())B.has(K)||(X.updated.has(K)?G.updated.has(K)&&J(K):U=I.edit(U,[K],z[K],_));for(const K of X.added.values())B.has(K)||(Y.added.has(K)?G.updated.has(K)&&J(K):H=v(K,U,H,_));for(const K of Y.added.values())B.has(K)||(X.added.has(K)?G.updated.has(K)&&J(K):U=v(K,H,U,_));const F=x.size>0||!S(U,H,C),$=F||!S(U,s,[]),j=F||!S(H,c,[]);return{localContent:$?U:null,remoteContent:j?H:null,conflictsSettings:[...x.values()],hasConflicts:F}}e.merge=d;function S(s,c,g){if(s===c)return!0;const C=(0,t.parse)(s),O=(0,t.parse)(c),_=g.reduce((M,U)=>(M.add(U),M),new Set),N=o(s).filter(M=>!(M.setting&&_.has(M.setting.key))),k=o(c).filter(M=>!(M.setting&&_.has(M.setting.key)));if(N.length!==k.length)return!1;for(let M=0;M<N.length;M++){const U=N[M],H=k[M];if(U.setting&&H.setting){if(U.setting.key!==H.setting.key||!A.equals(C[U.setting.key],O[U.setting.key]))return!1}else if(!U.setting&&!H.setting){if(U.value!==H.value)return!1}else return!1}return!0}e.areSame=S;function y(s){return s?o(s).length===0:!0}e.isEmpty=y;function h(s,c,g){const C=s?Object.keys(s).filter(M=>!g.has(M)):[],O=Object.keys(c).filter(M=>!g.has(M)),_=O.filter(M=>C.indexOf(M)===-1).reduce((M,U)=>(M.add(U),M),new Set),N=C.filter(M=>O.indexOf(M)===-1).reduce((M,U)=>(M.add(U),M),new Set),k=new Set;if(s)for(const M of C){if(N.has(M))continue;const U=s[M],H=c[M];A.equals(U,H)||k.add(M)}return{added:_,removed:N,updated:k}}function v(s,c,g,C){const O=(0,t.parse)(c),_=o(c),N=o(g),k=m(s,_,N);return f(g,s,O[s],k,N,C)}e.addSetting=v;function m(s,c,g){const C=c.findIndex(_=>_.setting?.key===s),O=c[C-1];if(O){if(O.setting){const N=r(O.setting.key,g);if(N)return{index:g.indexOf(N),insertAfter:!0}}else{const N=n(C,c);if(N){const k=r(N.setting.key,g);if(k){const M=i(g.indexOf(k),g),U=a(c,N,c[C]);if(M){const H=a(g,k,M),W=l(U,H);return W?{index:g.indexOf(W),insertAfter:!0}:{index:g.indexOf(M),insertAfter:!1}}else{const H=a(g,k,g[g.length-1]),W=l(U,H);return W?{index:g.indexOf(W),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const _=c[C+1];if(_)if(_.setting){const N=r(_.setting.key,g);if(N)return{index:g.indexOf(N),insertAfter:!1}}else{const N=i(C,c);if(N){const k=r(N.setting.key,g);if(k){const M=n(g.indexOf(k),g),U=a(c,c[C],N);if(M){const H=a(g,M,k),W=l(U.reverse(),H.reverse());return W?{index:g.indexOf(W),insertAfter:!1}:{index:g.indexOf(M),insertAfter:!0}}else{const H=a(g,g[0],k),W=l(U.reverse(),H.reverse());return W?{index:g.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(s,c,g,C,O,_){let N;return C.index===-1?N=(0,L.setProperty)(s,[c],g,_):N=u(s,c,g,C,O,_).map(k=>(0,L.withFormatting)(s,k,_)[0]),(0,L.applyEdits)(s,N)}function u(s,c,g,C,O,_){const N=`${JSON.stringify(c)}: ${JSON.stringify(g)}`,k=(0,T.getEOL)(_,s),M=O[C.index];if(C.insertAfter){const U=[];if(M.setting)U.push({offset:M.endOffset,length:0,content:","+N});else{const H=i(C.index,O),W=n(C.index,O),z=W?.setting?.commaOffset;W&&z===void 0&&U.push({offset:W.endOffset,length:0,content:","});const te=z!==void 0&&z>M.endOffset;U.push({offset:te?z+1:M.endOffset,length:0,content:H?k+N+",":k+N})}return U}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const U=(O[C.index-1]&&!O[C.index-1].setting?k:"")+N+(i(C.index,O)?",":"")+k;return[{offset:M.startOffset,length:0,content:U}]}}function r(s,c){return c.filter(g=>g.setting?.key===s)[0]}function n(s,c){for(let g=s-1;g>=0;g--)if(c[g].setting)return c[g]}function i(s,c){for(let g=s+1;g<c.length;g++)if(c[g].setting)return c[g]}function a(s,c,g){const C=s.indexOf(c),O=s.indexOf(g);return s.filter((_,N)=>C<N&&N<O)}function l(s,c){if(s.length&&c.length){let g=0;for(;g<c.length&&g<s.length;g++)if(s[g].value!==c[g].value)return c[g-1];return c[g-1]}}function o(s){const c=[];let g=-1,C,O;const _={onObjectBegin:N=>{g++},onObjectProperty:(N,k,M)=>{g===0&&(C=k,O=N)},onObjectEnd:(N,k)=>{g--,g===0&&c.push({startOffset:C,endOffset:N+k,value:s.substring(C,N+k),setting:{key:O,commaOffset:void 0}})},onArrayBegin:(N,k)=>{g++},onArrayEnd:(N,k)=>{g--,g===0&&c.push({startOffset:C,endOffset:N+k,value:s.substring(C,N+k),setting:{key:O,commaOffset:void 0}})},onLiteralValue:(N,k,M)=>{g===0&&c.push({startOffset:C,endOffset:k+M,value:s.substring(C,k+M),setting:{key:O,commaOffset:void 0}})},onSeparator:(N,k,M)=>{if(g===0&&N===","){let U=c.length-1;for(;U>=0&&!c[U].setting;U--);const H=c[U];H&&c.splice(U,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:k}})}},onComment:(N,k)=>{g===0&&c.push({startOffset:N,endOffset:N+k,value:s.substring(N,N+k)})}};return(0,t.visit)(s,_),c}}),define(re[251],se([0,1,16,3,161,18,68,15,30,13,22,21,33,28,47,59,250,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function v(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function m(r){const n=JSON.parse(r);return v(n)?n:{settings:r}}e.parseSettingsSyncContent=m;let f=class extends d.AbstractJsonFileSynchroniser{constructor(n,i,a,l,o,s,c,g,C,O,_,N,k){super(i.defaultProfile.settingsResource,"settings",n,a,l,o,s,O,_,c,g,C,k);this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(n){const i=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(n,i),l=this.getSettingsSyncContent(a),o=new A.ConfigurationModelParser(h.USER_DATA_SYNC_CONFIGURATION_SCOPE);return l?.settings&&o.parse(l.settings),o.configurationModel.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(n,i,a){const l=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(n);i=i===null&&a?n:i;const c=i?this.getSettingsSyncContent(i):null,g=await this.getIgnoredSettings();let C=null,O=!1,_=!1,N=!1;if(s){let U=l?l.value.toString().trim():"{}";U=U||"{}",this.validateContent(U),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const H=(0,y.merge)(U,s.settings,c?c.settings:null,g,[],o);C=H.localContent||H.remoteContent,O=H.localContent!==null,_=H.remoteContent!==null,N=H.hasConflicts}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),C=l.value.toString().trim()||"{}",this.validateContent(C),_=!0);const k={content:C,localChange:O?2:0,remoteChange:_?2:0,hasConflicts:N},M=l?l.value.toString():null;return[{fileContent:l,baseResource:this.baseResource,baseContent:c?c.settings:M,localResource:this.localResource,localContent:M,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(n){const i=this.getSettingsSyncContent(n);if(i===null)return!0;const a=await this.getLocalFileContent(),l=a?a.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,y.merge)(l||"{}",i.settings,i.settings,o,[],s).remoteContent!==null}async getMergeResult(n,i){const a=await this.getFormattingOptions(),l=await this.getIgnoredSettings();return{...n.previewResult,content:n.previewResult.content?(0,y.updateIgnoredSettings)(n.previewResult.content,"{}",l,a):null}}async getAcceptResult(n,i,a,l){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:n.fileContent?(0,y.updateIgnoredSettings)(n.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:n.remoteContent!==null?(0,y.updateIgnoredSettings)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return a===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:a!==null?(0,y.updateIgnoredSettings)(a,n.fileContent?n.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(n,i,a,l){const{fileContent:o}=a[0][0];let{content:s,localChange:c,remoteChange:g}=a[0][1];if(c===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,l),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const C=await this.getFormattingOptions(),O=this.getSettingsSyncContent(n),_=await this.getIgnoredSettings(s);s=(0,y.updateIgnoredSettings)(s,O?O.settings:"{}",_,C),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),n=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),l?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(n),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const i=await this.getFormattingOptions(),a=(0,S.edit)(n.value.toString(),[h.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,y.isEmpty)(a)}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"settings.json"),comparableResource:i}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n)||this.extUri.isEqual(this.baseResource,n))return this.resolvePreviewContent(n);let i=await super.resolveContent(n);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(n)),i){const a=this.parseSyncData(i);if(a){const l=this.parseSettingsSyncContent(a.content);if(l)switch(this.extUri.basename(n)){case"settings.json":return l.settings}}}return null}async resolvePreviewContent(n){let i=await super.resolvePreviewContent(n);if(i){const a=await this.getFormattingOptions(),l=await this.getIgnoredSettings();i=(0,y.updateIgnoredSettings)(i,"{}",l,a)}return i}getSettingsSyncContent(n){return n.syncData?this.parseSettingsSyncContent(n.syncData.content):null}parseSettingsSyncContent(n){try{return m(n)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(n){return{settings:n}}async getIgnoredSettings(n){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const a=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,l=>l.some(({local:o})=>!!o)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,l=>!l.error))(()=>{a.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(i,this.configurationService,n)}validateContent(n){if(this.hasErrors(n,!1))throw new h.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};f=me([Q(0,P.IFileService),Q(1,E.IUserDataProfilesService),Q(2,I.IEnvironmentService),Q(3,D.IStorageService),Q(4,h.IUserDataSyncStoreService),Q(5,h.IUserDataSyncBackupStoreService),Q(6,h.IUserDataSyncLogService),Q(7,h.IUserDataSyncUtilService),Q(8,T.IConfigurationService),Q(9,h.IUserDataSyncEnablementService),Q(10,w.ITelemetryService),Q(11,b.IExtensionManagementService),Q(12,p.IUriIdentityService)],f),e.SettingsSynchroniser=f;let u=class extends d.AbstractInitializer{constructor(n,i,a,l,o){super("settings",i,a,l,n,o)}async doInitialize(n){const i=n.syncData?this.parseSettingsSyncContent(n.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(n.value.toString().trim())}catch(n){return n.fileOperationResult===1}}parseSettingsSyncContent(n){try{return m(n)}catch(i){this.logService.error(i)}return null}};u=me([Q(0,P.IFileService),Q(1,E.IUserDataProfilesService),Q(2,I.IEnvironmentService),Q(3,h.IUserDataSyncLogService),Q(4,p.IUriIdentityService)],u),e.SettingsInitializer=u}),define(re[252],se([0,1,16,3,29,18,15,13,22,21,33,28,47,245,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends p.AbstractSynchroniser{constructor(v,m,f,u,r,n,i,a,l,o,s){super("snippets",m,v,u,r,n,l,o,i,a,s);this.version=1,this.snippetsFolder=f.defaultProfile.snippetsHome,this._register(this.fileService.watch(v.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(v,m,f){const u=await this.getSnippetsFileContents(),r=this.toSnippetsContents(u),n=v.syncData?this.parseSnippets(v.syncData):null;m=m===null&&f?v:m;const i=m&&m.syncData?this.parseSnippets(m.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const a=(0,E.merge)(r,n,i);return this.getResourcePreviews(a,u,n||{},i||{})}async hasRemoteChanged(v){const m=v.syncData?this.parseSnippets(v.syncData):null;if(m===null)return!0;const f=await this.getSnippetsFileContents(),u=this.toSnippetsContents(f),r=(0,E.merge)(u,m,m);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async getMergeResult(v,m){return v.previewResult}async getAcceptResult(v,m,f,u){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:v.fileContent?v.fileContent.value.toString():null,localChange:0,remoteChange:v.fileContent?v.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:v.remoteContent,localChange:v.remoteContent!==null?v.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder))return f===void 0?{content:v.previewResult.content,localChange:v.previewResult.localChange,remoteChange:v.previewResult.remoteChange}:{content:f,localChange:f===null?v.fileContent!==null?3:0:2,remoteChange:f===null?v.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(v,m,f,u){const r=f.map(([n,i])=>({...n,acceptResult:i}));r.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,u)),r.some(({remoteChange:n})=>n!==0)&&(v=await this.updateRemoteSnippets(r,v,u)),m?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.fileService.del(n)}catch{}}getResourcePreviews(v,m,f,u){const r=new Map;for(const n of Object.keys(v.local.added)){const i={content:v.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(v.local.updated)){const i={content:v.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},a=m[n]?m[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of v.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},a=m[n]?m[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(v.remote.added)){const i={content:v.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},a=m[n]?m[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(v.remote.updated)){const i={content:v.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},a=m[n]?m[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of v.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of v.conflicts){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:f[n]?2:1},a=m[n]?m[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n]||null,localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m))if(!r.has(n)){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},a=m[n]?m[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[n]??a,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n]||null,localContent:a,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async getAssociatedResources({uri:v}){const m=await super.resolveContent(v);if(m){const f=this.parseSyncData(m);if(f){const u=this.parseSnippets(f),r=[];for(const n of Object.keys(u)){const i=this.extUri.joinPath(v,n),a=this.extUri.joinPath(this.snippetsFolder,n),l=await this.fileService.exists(a);r.push({resource:i,comparableResource:l?a:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})})}return r}}return[]}async resolveContent(v){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(v);let m=await super.resolveContent(v);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(v)),m){const f=this.parseSyncData(m);if(f)return this.parseSnippets(f)[this.extUri.basename(v)]||null}return null}async hasLocalData(){try{const v=await this.getSnippetsFileContents();if(Object.keys(v).length)return!0}catch{}return!1}async updateLocalBackup(v){const m={};for(const f of v)f.fileContent&&(m[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(m)))}async updateLocalSnippets(v,m){for(const{fileContent:f,acceptResult:u,localResource:r,remoteResource:n,localChange:i}of v)if(i!==0){const a=n?this.extUri.basename(n):this.extUri.basename(r),l=this.extUri.joinPath(this.snippetsFolder,a);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(l)),await this.fileService.del(l),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(l))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(l)),await this.fileService.createFile(l,R.VSBuffer.fromString(u.content),{overwrite:m}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(l))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(l)),await this.fileService.writeFile(l,R.VSBuffer.fromString(u.content),m?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(l)))}}async updateRemoteSnippets(v,m,f){const u=m.syncData?this.parseSnippets(m.syncData):{},r=(0,L.deepClone)(u);for(const{acceptResult:n,localResource:i,remoteResource:a,remoteChange:l}of v)if(l!==0){const o=i?this.extUri.basename(i):this.extUri.basename(a);l===3?delete r[o]:r[o]=n.content}return(0,E.areSame)(u,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),m=await this.updateRemoteUserData(JSON.stringify(r),f?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),m}parseSnippets(v){return JSON.parse(v.content)}toSnippetsContents(v){const m={};for(const f of Object.keys(v))m[f]=v[f].value.toString();return m}async getSnippetsFileContents(){const v={};let m;try{m=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof I.FileOperationError&&f.fileOperationResult===1)return v;throw f}for(const f of m.children||[]){const u=f.resource,r=this.extUri.extname(u);if(r===".json"||r===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,u),i=await this.fileService.readFile(u);v[n]=i}}return v}};S=me([Q(0,A.IEnvironmentService),Q(1,I.IFileService),Q(2,w.IUserDataProfilesService),Q(3,b.IStorageService),Q(4,d.IUserDataSyncStoreService),Q(5,d.IUserDataSyncBackupStoreService),Q(6,d.IUserDataSyncLogService),Q(7,T.IConfigurationService),Q(8,d.IUserDataSyncEnablementService),Q(9,P.ITelemetryService),Q(10,D.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let y=class extends p.AbstractInitializer{constructor(v,m,f,u,r){super("snippets",m,f,u,v,r)}async doInitialize(v){const m=v.syncData?JSON.parse(v.syncData.content):null;if(!m){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(m)){const r=m[u];if(r){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,u);await this.fileService.createFile(n,R.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(v)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(v){return v.fileOperationResult===1}}};y=me([Q(0,I.IFileService),Q(1,w.IUserDataProfilesService),Q(2,A.IEnvironmentService),Q(3,d.IUserDataSyncLogService),Q(4,D.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(re[253],se([0,1,16,18,15,13,22,21,33,28,47,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(y,h){try{return JSON.parse(y).tasks}catch(v){return h.error(v),null}}e.getTasksContentFromSyncContent=p;let E=class extends D.AbstractFileSynchroniser{constructor(h,v,m,f,u,r,n,i,a,l,o){super(o.defaultProfile.tasksResource,"tasks",r,n,i,h,v,u,a,m,f,l);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(h,v,m,f){const u=h.syncData?p(h.syncData.content,this.logService):null;v=v===null&&m?h:v;const r=v?.syncData?p(v.syncData.content,this.logService):null,n=await this.getLocalFileContent();let i=null,a=!1,l=!1,o=!1;if(u){const g=n?n.value.toString():null;if(!r||r!==g||r!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const C=S(g,u,r);i=C.content,o=C.hasConflicts,a=C.hasLocalChanged,l=C.hasRemoteChanged}}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),i=n.value.toString(),l=!0);const s={content:i,localChange:a?n?2:1:0,remoteChange:l?2:0,hasConflicts:o},c=n?n.value.toString():null;return[{fileContent:n,baseResource:this.baseResource,baseContent:r!==null?r:c,localResource:this.localResource,localContent:c,localChange:s.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:s.remoteChange,previewResource:this.previewResource,previewResult:s,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const v=h?.syncData?p(h.syncData.content,this.logService):null;if(v===null)return!0;const m=await this.getLocalFileContent(),f=m?m.value.toString():null,u=S(f,v,v);return u.hasLocalChanged||u.hasRemoteChanged}async getMergeResult(h,v){return h.previewResult}async getAcceptResult(h,v,m,f){if(this.extUri.isEqual(v,this.localResource))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(v,this.remoteResource))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(v,this.previewResource))return m===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(h,v,m,f){const{fileContent:u}=m[0][0],{content:r,localChange:n,remoteChange:i}=m[0][1];if(n===0&&i===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),n!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),u&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(u.value.toString()))),await this.updateLocalFileContent(r||"{}",u,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),i!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const a=JSON.stringify(this.toTasksSyncContent(r||"{}"));h=await this.updateRemoteUserData(a,f?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}v?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:h}){const v=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(h,"tasks.json"),comparableResource:v}]}async resolveContent(h){if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let v=await super.resolveContent(h);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(h)),v){const m=this.parseSyncData(v);if(m)switch(this.extUri.basename(h)){case"tasks.json":return p(m.content,this.logService)}}return null}toTasksSyncContent(h){return{tasks:h}}};E=me([Q(0,w.IUserDataSyncStoreService),Q(1,w.IUserDataSyncBackupStoreService),Q(2,w.IUserDataSyncLogService),Q(3,t.IConfigurationService),Q(4,w.IUserDataSyncEnablementService),Q(5,T.IFileService),Q(6,L.IEnvironmentService),Q(7,A.IStorageService),Q(8,I.ITelemetryService),Q(9,b.IUriIdentityService),Q(10,P.IUserDataProfilesService)],E),e.TasksSynchroniser=E;let d=class extends D.AbstractInitializer{constructor(h,v,m,f,u){super("tasks",v,m,f,h,u);this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(h){const v=h.syncData?p(h.syncData.content,this.logService):null;if(!v){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(v)),await this.updateLastSyncUserData(h)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};d=me([Q(0,T.IFileService),Q(1,P.IUserDataProfilesService),Q(2,L.IEnvironmentService),Q(3,w.IUserDataSyncLogService),Q(4,b.IUriIdentityService)],d),e.TasksInitializer=d;function S(y,h,v){if(y===null&&h===null&&v===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=v!==y,f=v!==h;return!m&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!f?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!m?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[72],se([0,1,3,2,5,25]),function(Z,e,R,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends t.Disposable{constructor(b,P){super();this.userDataSyncStoreService=b,this.logService=P,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};A=me([Q(0,T.IUserDataSyncStoreService),Q(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(re[254],se([0,1,6,16,61,2,19,18,15,13,25]),function(Z,e,R,t,L,T,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends T.Disposable{constructor(E,d,S,y){super();this.environmentService=E,this.fileService=d,this.configurationService=S,this.logService=y,D.ALL_SYNC_RESOURCES.forEach(h=>this.cleanUpBackup(h))}async getAllRefs(E){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,E),S=await this.fileService.resolve(d);return S.children?S.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort().reverse().map(h=>({ref:h.name,created:this.getCreationTime(h)})):[]}async resolveContent(E,d){if(!d){const S=await this.getAllRefs(E);S.length&&(d=S[S.length-1].ref)}if(d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,E,d);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(E,d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,E),y=(0,A.joinPath)(S,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(y,t.VSBuffer.fromString(d))}catch(h){this.logService.error(h)}try{this.cleanUpBackup(E)}catch{}}async cleanUpBackup(E){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(d))return}catch{return}const S=await this.fileService.resolve(d);if(S.children){const y=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=y.filter(f=>Date.now()-this.getCreationTime(f)>h);const m=y.length-v.length;m<10&&(v=v.slice(10-m)),await R.Promises.settled(v.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};w=me([Q(0,b.IEnvironmentService),Q(1,P.IFileService),Q(2,I.IConfigurationService),Q(3,D.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(re[255],se([0,1,3,2,4,15,22,21,25]),function(Z,e,R,t,L,T,A,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const P="sync.enable";let D=class extends t.Disposable{constructor(p,E,d,S){super();this.storageService=p,this.telemetryService=E,this.environmentService=d,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(y=>this.onDidStorageChange(y)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(P,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(P,{enabled:p}),this.storageService.store(P,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,b.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,E){if(this.isResourceEnabled(p)!==E){const d=(0,b.getEnablementKey)(p);this.storeResourceEnablement(d,E)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,E){this.storageService.store(p,E,-1,L.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(P===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const E=b.ALL_SYNC_RESOURCES.filter(d=>(0,b.getEnablementKey)(d)===p.key)[0];if(E){this._onDidChangeResourceEnablement.fire([E,this.isResourceEnabled(E)]);return}}};D=me([Q(0,A.IStorageService),Q(1,I.ITelemetryService),Q(2,T.IEnvironmentService),Q(3,b.IUserDataSyncStoreManagementService)],D),e.UserDataSyncEnablementService=D}),define(re[256],se([0,1,2,8]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(p){this.service=p}listen(p,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(p,E,d){switch(E){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(p){this.service=p}listen(p,E){throw new Error(`Event not found: ${E}`)}call(p,E,d){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=A;class I{constructor(p){this.service=p}listen(p,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(p,E,d){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class b{constructor(p){this.service=p}listen(p,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(p,E,d){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class P{constructor(p){this.service=p}listen(p,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(p,E,d){switch(E){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=P;class D extends R.Disposable{constructor(p){super();this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:t.URI.revive(p.url),type:p.type,defaultUrl:t.URI.revive(p.defaultUrl),insidersUrl:t.URI.revive(p.insidersUrl),stableUrl:t.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(re[257],se([0,1,15,7]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends t.AbstractLogger{constructor(A,I){super();this.logger=this._register(A.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...I){this.logger.trace(A,...I)}debug(A,...I){this.logger.debug(A,...I)}info(A,...I){this.logger.info(A,...I)}warn(A,...I){this.logger.warn(A,...I)}error(A,...I){this.logger.error(A,...I)}critical(A,...I){this.logger.critical(A,...I)}flush(){this.logger.flush()}};L=me([Q(0,t.ILoggerService),Q(1,R.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(re[73],se([0,1,3,2,4,26,164,15,13,5,24,49,22,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,P.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",S="Safari",y="Chrome",h="Edge",v="Firefox",m="Android";function f(n){switch(n){case S:case y:case h:case v:case m:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function u(){return L.isSafari?S:L.isChrome?y:L.isEdge?h:L.isFirefox?v:L.isAndroid?m:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let r=class nt extends t.Disposable{constructor(i,a,l,o,s,c){super();this.storageService=l,this.userDataSyncStoreService=o,this.logService=s,this.productService=c,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(i,a,l)}async getMachines(i){const a=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(o=>({...o,isCurrent:o.id===a}))}async addCurrentMachine(i){const a=await this.currentMachineIdPromise,l=await this.readMachinesData(i);l.machines.some(({id:o})=>o===a)||(l.machines.push({id:a,name:this.computeCurrentMachineName(l.machines),platform:u()}),await this.writeMachinesData(l))}async removeCurrentMachine(i){const a=await this.currentMachineIdPromise,l=await this.readMachinesData(i),o=l.machines.filter(({id:s})=>s!==a);o.length!==l.machines.length&&(l.machines=o,await this.writeMachinesData(l))}async renameMachine(i,a,l){const o=await this.readMachinesData(l),s=o.machines.find(({id:c})=>c===i);if(s){s.name=a,await this.writeMachinesData(o);const c=await this.currentMachineIdPromise;i===c&&this.storageService.store(d,a,-1,1)}}async setEnablements(i){const a=await this.readMachinesData();for(const[l,o]of i){const s=a.machines.find(c=>c.id===l);s&&(s.disabled=o?void 0:!0)}await this.writeMachinesData(a)}computeCurrentMachineName(i){const a=this.storageService.get(d,-1);if(a)return a;const l=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(l)}\\s#(\\d+)`);let s=0;for(const c of i){const g=o.exec(c.name),C=g?parseInt(g[1]):0;s=C>s?C:s}return`${l} #${s+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const a=this.parse(this.userData);if(a.version!==nt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return a}async writeMachinesData(i){const a=JSON.stringify(i),l=await this.userDataSyncStoreService.write(nt.RESOURCE,a,this.userData?.ref||null);this.userData={ref:l,content:a},this._onDidChange.fire()}async readUserData(i){if(this.userData){const a=i&&i.latest?i.latest[nt.RESOURCE]:void 0;if(this.userData.ref===a)return this.userData;if(a===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(nt.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(a){this.logService.error(a)}return{version:nt.VERSION,machines:[]}}};r.VERSION=1,r.RESOURCE="machines",r=me([Q(0,I.IEnvironmentService),Q(1,b.IFileService),Q(2,p.IStorageService),Q(3,E.IUserDataSyncStoreService),Q(4,E.IUserDataSyncLogService),Q(5,D.IProductService)],r),e.UserDataSyncMachinesService=r}),define(re[258],se([0,1,6,61,37,9,3,2,4,19,8,162,24,22,21,25,72,73]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const v="sync.disableMachineEventually",m="sync.sessionId",f="sync.storeUrl",u="sync.productQuality";let r=class extends I.Disposable{constructor(a,l,o,s,c,g,C,O,_,N){super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=s,this.userDataSyncService=c,this.logService=g,this.userDataSyncAccountService=C,this.telemetryService=O,this.userDataSyncMachinesService=_,this.storageService=N,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=a.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{(0,P.isEqual)(this.syncUrl,l.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(C.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(c.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const a=this.storageService.get(f,-1);return a?D.URI.parse(a):void 0}set syncUrl(a){a?this.storageService.store(f,a.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(u,-1)}set productQuality(a){a?this.storageService.store(u,a,-1,1):this.storageService.remove(u,-1)}updateAutoSync(){const{enabled:a,message:l}=this.isAutoSyncEnabled();a?this.autoSync.value===void 0&&(this.autoSync.value=new n(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(a,l,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(m,-1),a?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(s){if(l)this.logService.error(s),this.updateEnablement(!1);else throw s}}updateEnablement(a){this.userDataSyncEnablementService.isEnabled()!==a&&(this.userDataSyncEnablementService.setEnablement(a),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(a){if(!a){this.successiveFailures=0;return}const l=S.UserDataSyncError.toUserDataSyncError(a);l instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):l.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code==="UpgradeRequired"||l.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code==="ServiceChanged"||l.code==="DefaultServiceChanged"?b.isWeb&&l.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(v,!0,-1,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(v,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(v,-1)}async triggerSync(a,l,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...a),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};r=me([Q(0,p.IProductService),Q(1,S.IUserDataSyncStoreManagementService),Q(2,S.IUserDataSyncStoreService),Q(3,S.IUserDataSyncEnablementService),Q(4,S.IUserDataSyncService),Q(5,S.IUserDataSyncLogService),Q(6,y.IUserDataSyncAccountService),Q(7,d.ITelemetryService),Q(8,h.IUserDataSyncMachinesService),Q(9,E.IStorageService)],r),e.UserDataAutoSyncService=r;class n extends I.Disposable{constructor(a,l,o,s,c,g,C,O){super();this.lastSyncUrl=a,this.interval=l,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncService=c,this.userDataSyncMachinesService=g,this.logService=C,this.storageService=O,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(n.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(n.INTERVAL_SYNCING,!1),this.interval)}sync(a,l){const o=(0,R.createCancelablePromise)(async s=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(c){if((0,T.isCancellationError)(c))return}return this.doSync(a,l,s)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,P.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const a=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!a&&(!(0,P.isEqual)(l.defaultUrl,a.defaultUrl)||!(0,P.isEqual)(l.insidersUrl,a.insidersUrl)||!(0,P.isEqual)(l.stableUrl,a.stableUrl))}async doSync(a,l,o){this.logService.info(`Auto Sync: Triggered by ${a}`),this._onDidStartSync.fire();let s;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,l),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const c=this.storageService.get(m,-1);if(c&&this.manifest&&c!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const g=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const C=g.find(O=>O.isCurrent);if(C?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new S.UserDataAutoSyncError((0,L.toErrorMessage)(O),O instanceof S.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==c&&this.storageService.store(m,this.manifest.session,-1,1),o.isCancellationRequested)return;C||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(c){this.logService.error(c),s=c}this._onDidFinishSync.fire(s)}register(a){return super._register(a)}}n.INTERVAL_SYNCING="Interval"}),define(re[259],se([0,1,17,6,37,3,2,19,14,31,18,30,5,22,21,246,248,249,251,252,253,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const r="sync.lastSyncTime";let n=class extends A.Disposable{constructor(s,c,g,C,O,_,N,k){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=c,this.instantiationService=g,this.configurationService=C,this.logService=O,this.telemetryService=_,this.storageService=N,this.userDataSyncEnablementService=k,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(r,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s,c){this.checkEnablement();const g=(0,P.generateUuid)();try{const k=(0,u.createSyncHeaders)(g);c&&(k["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,k)}catch(k){const M=u.UserDataSyncError.toUserDataSyncError(k);throw this.reportUserDataSyncError(M,g),M}const C=!1,O=this,_=this.getEnabledSynchronizers();let N;return{manifest:s,async run(){if(C)throw new Error("Can run a task only once");return N=(0,t.createCancelablePromise)(k=>O.sync(_,s,g,k)),N.finally(()=>N=void 0)},async stop(){if(N&&N.cancel(),O.status!=="idle")return O.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new u.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,P.generateUuid)(),c=(0,u.createSyncHeaders)(s);let g;try{g=await this.userDataSyncStoreService.manifest(null,c)}catch(_){const N=u.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(N,s),N}await this.resetLocal();const C=this.getEnabledSynchronizers(),O=async()=>{await this.stop(C),await this.resetLocal()};return new i(s,g,c,C,O,this.configurationService,this.logService)}async sync(s,c,g,C){if(C.isCancellationRequested||!s.length)return;const O=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,u.createSyncHeaders)(g);for(const N of s){if(C.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(N.resource))return;try{await N.sync(c,_)}catch(k){let M=!1;if(k instanceof u.UserDataSyncError)switch(k.code){case"TooLarge":k=new u.UserDataSyncError(k.message,k.code,N.resource),M=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":M=!0;break}const U=u.UserDataSyncError.toUserDataSyncError(k);if(this.reportUserDataSyncError(U,g),M)throw U;this.logService.error(k),this.logService.error(`${N.resource}: ${(0,L.toErrorMessage)(k)}`),this._syncErrors.push([N.resource,U])}}this.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),this.updateLastSyncTime()}catch(_){const N=u.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(N,g),N}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const c of s)try{c.status!=="idle"&&await c.stop()}catch(g){this.logService.error(g)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(s))return!0})}async accept(s,c,g,C){this.checkEnablement(),await this.performSynchronizerAction(async O=>{if(O.resource===s)return await O.accept(c,g),C&&await O.apply(!1,(0,u.createSyncHeaders)((0,P.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async c=>{const g=await c.resolveContent(s);if(g)return g})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async g=>{if(g.resource===s)return g.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async g=>{if(g.resource===s)return g.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,c){return await this.performSynchronizerAction(async C=>{if(C.resource===s)return C.getAssociatedResources(c)})||[]}async getMachineId(s,c){return await this.performSynchronizerAction(async C=>{if(C.resource===s)return await C.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(r,-1),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(c){this.logService.error(`${s.resource}: ${(0,L.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const c=new A.DisposableStore;try{const g=this.synchronizers.value||c.add(this.instantiationService.createInstance(a,()=>{},()=>{},()=>{})),C=[...g.enabled,...g.disabled.map(O=>c.add(g.createSynchronizer(O)))];for(const O of C){const _=await s(O);if(!(0,b.isUndefined)(_))return _}return null}finally{c.dispose()}}setStatus(s){const c=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const c=this.computeStatus(s);this.setStatus(c)}updateConflicts(s){const c=this.computeConflicts(s);(0,R.equals)(this._conflicts,c,([g,C],[O,_])=>g===g&&(0,R.equals)(C,_,(N,k)=>(0,I.isEqual)(N.previewResource,k.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(c))}computeConflicts(s){return s.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(l)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(c=>c.status==="hasConflicts")?"hasConflicts":s.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(r,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,c){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof u.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof u.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(a,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};n=me([Q(0,u.IUserDataSyncStoreService),Q(1,u.IUserDataSyncStoreManagementService),Q(2,p.IInstantiationService),Q(3,D.IConfigurationService),Q(4,u.IUserDataSyncLogService),Q(5,d.ITelemetryService),Q(6,E.IStorageService),Q(7,u.IUserDataSyncEnablementService)],n),e.UserDataSyncService=n;class i extends A.Disposable{constructor(s,c,g,C,O,_,N){super();this.id=s,this.manifest=c,this.syncHeaders=g,this.synchronisers=C,this.onStop=O,this.configurationService=_,this.logService=N,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,t.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,c){try{return await this.performAction(s,g=>g.accept(s,c))}catch(g){throw this.logService.error(g),g}}async merge(s){try{return s?await this.performAction(s,c=>c.merge(s)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(s){try{return await this.performAction(s,c=>c.discard(s))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,c]of this.previews)for(const g of c.resourcePreviews)g.mergeState==="conflict"&&s.push(g.previewResource);for(const c of s)await this.discard(c);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[c,g]of this.previews){this.synchronizingResources.push([c,g.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(_=>_.resource===c);for(const _ of g.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await C.merge(_.previewResource);const O=await C.apply(!1,this.syncHeaders);O&&s.push(this.toSyncResourcePreview(C.resource,O)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(C=>C.resource===s);for(const C of c.resourcePreviews)await g.accept(C.remoteResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const g=this.synchronisers.find(C=>C.resource===s);for(const C of c.resourcePreviews)await g.accept(C.localResource);await g.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const g=this.previews.findIndex(([,H])=>H.resourcePreviews.some(({localResource:W,previewResource:z,remoteResource:te})=>(0,I.isEqual)(s,W)||(0,I.isEqual)(s,z)||(0,I.isEqual)(s,te)));if(g===-1)return this.previews;const[C,O]=this.previews[g],_=O.resourcePreviews.find(({localResource:H,remoteResource:W,previewResource:z})=>(0,I.isEqual)(H,s)||(0,I.isEqual)(W,s)||(0,I.isEqual)(z,s));if(!_)return this.previews;let N=this.synchronizingResources.find(H=>H[0]===C);N||(N=[C,[]],this.synchronizingResources.push(N)),N[1].some(H=>(0,I.isEqual)(H,_.localResource))||(N[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const k=this.synchronisers.find(H=>H.resource===this.previews[g][0]),M=await c(k);M?this.previews.splice(g,1,this.toSyncResourcePreview(k.resource,M)):this.previews.splice(g,1);const U=this.synchronizingResources.findIndex(H=>H[0]===C);return this.synchronizingResources[U][1].splice(N[1].findIndex(H=>(0,I.isEqual)(H,_.localResource)),1),N[1].length||(this.synchronizingResources.splice(U,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[c,g]of this.previews){this.synchronizingResources.push([c,g.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(_=>_.resource===c);let O=g;for(const _ of g.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(O=await C.merge(_.previewResource));O&&s.push(this.toSyncResourcePreview(C.resource,O)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const c=[],g=await this.getUserDataSyncConfiguration();for(const C of this.synchronisers){if(s.isCancellationRequested)return[];const O=await C.preview(this.manifest,g,this.syncHeaders);O&&c.push(this.toSyncResourcePreview(C.resource,O))}return c}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=this.synchronisers.find(g=>g instanceof v.SettingsSynchroniser);if(c){const g=await c.getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...g}}return s}toSyncResourcePreview(s,c){return[s,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(l)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let a=class extends A.Disposable{constructor(s,c,g,C,O,_,N){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=c,this.onDidChangeLocal=g,this.userDataSyncEnablementService=C,this.instantiationService=O,this.extensionGalleryService=_,this.logService=N,this._enabled=[],this._register(C.onDidChangeResourceEnablement(([k,M])=>this.onDidChangeResourceEnablement(k,M))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,k])=>k.dispose())));for(const k of u.ALL_SYNC_RESOURCES)C.isResourceEnabled(k)&&this.registerSynchronizer(k)}get enabled(){return this._enabled.sort((s,c)=>s[1]-c[1]).map(([s])=>s)}get disabled(){return u.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}onDidChangeResourceEnablement(s,c){c?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([O])=>O.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new A.DisposableStore,g=c.add(this.createSynchronizer(s));c.add(g.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(g.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(g.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const C=this.getOrder(s);this._enabled.push([g,C,c])}deRegisterSynchronizer(s){const c=this._enabled.findIndex(([g])=>g.resource===s);if(c!==-1){const g=this._enabled.splice(c,1);for(const[C,,O]of g){if(C.status!=="idle"){const _=C.conflicts.length>0;C.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}O.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(v.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(h.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(m.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(f.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(y.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};a=me([Q(3,u.IUserDataSyncEnablementService),Q(4,p.IInstantiationService),Q(5,w.IExtensionGalleryService),Q(6,u.IUserDataSyncLogService)],a);function l(o){return{baseResource:o.baseResource,localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(re[260],se([0,1,3,2,14,8,25]),function(Z,e,R,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class I{constructor(w,p){this.service=w,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(w,p){switch(p){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${p}`)}async call(w,p,E){try{return await this._call(w,p,E)}catch(d){throw this.logService.error(d),d}}async _call(w,p,E){switch(p){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],T.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:T.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:T.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(p.startsWith("manualSync/")){const d=p.substring("manualSync/".length),S=E[0],y=this.getManualSyncTask(S);switch(E=E.slice(1),d){case"preview":return y.preview();case"accept":return y.accept(T.URI.revive(E[0]),E[1]);case"merge":return y.merge(T.URI.revive(E[0]));case"discard":return y.discard(T.URI.revive(E[0]));case"discardConflicts":return y.discardConflicts();case"apply":return y.apply();case"pull":return y.pull();case"push":return y.push();case"stop":return y.stop();case"_getStatus":return y.status;case"dispose":return this.disposeManualSyncTask(y)}}throw new Error("Invalid call")}getManualSyncTask(w){const p=this.manualSyncTasks.get(this.createKey(w));if(!p)throw new Error(`Manual sync taks not found: ${w}`);return p.manualSyncTask}async createManualSyncTask(){const w=new t.DisposableStore,p=w.add(await this.service.createManualSyncTask());return w.add(p.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:p.id,data:E}))),this.manualSyncTasks.set(this.createKey(p.id),{manualSyncTask:p,disposables:w}),{id:p.id,manifest:p.manifest,status:p.status}}disposeManualSyncTask(w){w.dispose();const p=this.createKey(w.id);this.manualSyncTasks.get(p)?.disposables.dispose(),this.manualSyncTasks.delete(p)}createKey(w){return`manualSyncTask-${w}`}}e.UserDataSyncChannel=I;class b extends t.Disposable{constructor(w){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,E,d){return w.call(p,E,d).then(null,S=>{throw A.UserDataSyncError.toUserDataSyncError(S)})},listen(p,E){return w.listen(p,E)}},this.channel.call("_getInitialData").then(([p,E,d])=>{this.updateStatus(p),this.updateConflicts(E),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(([E,d])=>[E,A.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:w,manifest:p,status:E}=await this.channel.call("createManualSyncTask"),d=this,S=new P(w,p,E,{async call(y,h,v){return d.channel.call(`manualSync/${y}`,[w,...(0,L.isArray)(h)?h:[h]],v)},listen(y,h){return R.Event.map(R.Event.filter(d.channel.listen(`manualSync/${y}`,h),v=>!S.isDiposed()&&v.manualSyncTaskId===w),v=>v.data)}});return S}replace(w){return this.channel.call("replace",[w])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(w,p,E,d){return this.channel.call("accept",[w,p,E,d])}resolveContent(w){return this.channel.call("resolveContent",[w])}async getLocalSyncResourceHandles(w){return(await this.channel.call("getLocalSyncResourceHandles",[w])).map(({created:E,uri:d})=>({created:E,uri:T.URI.revive(d)}))}async getRemoteSyncResourceHandles(w){return(await this.channel.call("getRemoteSyncResourceHandles",[w])).map(({created:E,uri:d})=>({created:E,uri:T.URI.revive(d)}))}async getAssociatedResources(w,p){return(await this.channel.call("getAssociatedResources",[w,p])).map(({resource:d,comparableResource:S})=>({resource:T.URI.revive(d),comparableResource:T.URI.revive(S)}))}async getMachineId(w,p){return this.channel.call("getMachineId",[w,p])}async updateStatus(w){this._status=w,this._onDidChangeStatus.fire(w)}async updateConflicts(w){this._conflicts=w.map(([p,E])=>[p,E.map(d=>({...d,baseResource:T.URI.revive(d.baseResource),localResource:T.URI.revive(d.localResource),remoteResource:T.URI.revive(d.remoteResource),previewResource:T.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(w){this._lastSyncTime!==w&&(this._lastSyncTime=w,this._onDidChangeLastSyncTime.fire(w))}}e.UserDataSyncChannelClient=b;class P extends t.Disposable{constructor(w,p,E,d){super();this.id=w,this.manifest=p,this._disposed=!1,this._status=E;const S=this;this.channel={async call(y,h,v){try{const m=await d.call(y,h,v);return S.isDiposed()||(S._status=await d.call("_getStatus")),m}catch(m){throw A.UserDataSyncError.toUserDataSyncError(m)}},listen(y,h){return d.listen(y,h)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const w=await this.channel.call("preview");return this.deserializePreviews(w)}async accept(w,p){const E=await this.channel.call("accept",[w,p]);return this.deserializePreviews(E)}async merge(w){const p=await this.channel.call("merge",[w]);return this.deserializePreviews(p)}async discard(w){const p=await this.channel.call("discard",[w]);return this.deserializePreviews(p)}async discardConflicts(){const w=await this.channel.call("discardConflicts");return this.deserializePreviews(w)}async apply(){const w=await this.channel.call("apply");return this.deserializePreviews(w)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(w){return w.map(([p,E])=>[p,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(d=>({...d,baseResource:T.URI.revive(d.baseResource),localResource:T.URI.revive(d.localResource),remoteResource:T.URI.revive(d.remoteResource),previewResource:T.URI.revive(d.previewResource),acceptedResource:T.URI.revive(d.acceptedResource)}))}])}}}),define(re[261],se([0,1,6,23,9,3,2,124,4,19,14,8,31,18,15,13,24,44,49,22,25]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",a=100,l=1e3*60*5;let o=class extends A.Disposable{constructor(_,N,k){super();this.productService=_,this.configurationService=N,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(k.onDidChangeValue,M=>M.key===f.SYNC_SERVICE_URL_TYPE&&M.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,_,-1,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,N){_=b.isWeb&&_?.web?{..._,..._.web}:_;const k={..._||{},...N||{}};if(k&&(0,D.isString)(k.url)&&(0,D.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(M=>(0,D.isArray)(k.authenticationProviders[M].scopes))){const M=k,U=!!M.canSwitch&&!N?.url,H=M.url===M.insidersUrl?"insiders":"stable",W=(U?this.userDataSyncStoreType:void 0)||H,z=N?.url||(W==="insiders"?M.insidersUrl:W==="stable"?M.stableUrl:M.url);return{url:w.URI.parse(z),type:W,defaultType:H,defaultUrl:w.URI.parse(M.url),stableUrl:w.URI.parse(M.stableUrl),insidersUrl:w.URI.parse(M.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(M.authenticationProviders).reduce((te,V)=>(te.push({id:V,scopes:M.authenticationProviders[V].scopes}),te),[])}}}};o=me([Q(0,y.IProductService),Q(1,E.IConfigurationService),Q(2,m.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let s=class extends o{constructor(_,N,k){super(_,N,k);const M=this.storageService.get(u,-1);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const U=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];U?this.storageService.store(u,JSON.stringify(U),-1,1):this.storageService.remove(u,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};s=me([Q(0,y.IProductService),Q(1,E.IConfigurationService),Q(2,m.IStorageService)],s),e.UserDataSyncStoreManagementService=s;let c=class extends A.Disposable{constructor(_,N,k,M,U,H,W){super();this.requestService=k,this.logService=M,this.storageService=W,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,v.getServiceMachineId)(U,H,W).then(z=>{const te={"X-Client-Name":`${N.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(te["X-Client-Commit"]=N.commit),te}),this.session=new C(a,l,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(_,N){this.authToken={token:_,type:N}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,P.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(r,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(N=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_),k={},M=await this.request(N.toString(),{type:"GET",headers:k},[],t.CancellationToken.None);return(await(0,h.asJson)(M)||[]).map(({url:H,created:W})=>({ref:(0,P.relativePath)(N,N.with({path:H})),created:W*1e3}))}async resolveContent(_,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,N).toString(),M={};M["Cache-Control"]="no-cache";const U=await this.request(k,{type:"GET",headers:M},[],t.CancellationToken.None);return await(0,h.asTextOrError)(U)}async delete(_,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=N!==null?(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,N).toString():(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString(),M={};await this.request(k,{type:"DELETE",headers:M},[],t.CancellationToken.None)}async read(_,N,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_,"latest").toString();k={...k},k["Cache-Control"]="no-cache",N&&(k["If-None-Match"]=N.ref);const U=await this.request(M,{type:"GET",headers:k},[304],t.CancellationToken.None);let H=null;if(U.res.statusCode===304&&(H=N),H===null){const W=U.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",U.res.statusCode,U.res.headers[f.HEADER_OPERATION_ID]);const z=await(0,h.asTextOrError)(U);if(!z&&U.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",M,"EmptyResponse",U.res.statusCode,U.res.headers[f.HEADER_OPERATION_ID]);H={ref:W,content:z}}return H}async write(_,N,k,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",_).toString();M={...M},M["Content-Type"]=I.Mimes.text,k&&(M["If-Match"]=k);const H=await this.request(U,{type:"POST",data:N,headers:M},[],t.CancellationToken.None),W=H.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",H.res.statusCode,H.res.headers[f.HEADER_OPERATION_ID]);return W}async manifest(_,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,P.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",_&&(N["If-None-Match"]=_.ref);const M=await this.request(k,{type:"GET",headers:N},[304],t.CancellationToken.None);let U=null;if(M.res.statusCode===304&&(U=_),!U){const W=M.res.headers.etag;if(!W)throw new f.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);const z=await(0,h.asTextOrError)(M);if(!z&&M.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",k,"EmptyResponse",M.res.statusCode,M.res.headers[f.HEADER_OPERATION_ID]);z&&(U={...JSON.parse(z),ref:W})}const H=this.storageService.get(n,-1);return H&&U&&H!==U.session&&this.clearSession(),U===null&&H&&this.clearSession(),U&&this.storageService.store(n,U.session,-1,1),U}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":I.Mimes.text};await this.request(_,{type:"DELETE",headers:N},[],t.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(i,-1)}async request(_,N,k,M){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const U=await this.commonHeadersPromise;N.headers={...N.headers||{},...U,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:_,type:N.type,headers:{...N.headers,authorization:void 0}});let H;try{H=await this.session.request(_,N,M)}catch(V){if(!(V instanceof f.UserDataSyncStoreError)){let G="RequestFailed";const X=(0,L.getErrorMessage)(V).toLowerCase();X.includes("xhr timeout")?G="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?G="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?G="RequestPathNotEscaped":X.includes("headers must be an object")?G="RequestHeadersNotObject":(0,L.isCancellationError)(V)&&(G="RequestCanceled"),V=new f.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,G,void 0,void 0)}throw this.logService.info("Request failed",_),V}const W=H.res.headers[f.HEADER_OPERATION_ID],z={url:_,status:H.res.statusCode,"execution-id":N.headers[f.HEADER_EXECUTION_ID],"operation-id":W},te=(0,h.isSuccess)(H)||H.res.statusCode&&k.indexOf(H.res.statusCode)!==-1;if(te?this.logService.trace("Request succeeded",z):this.logService.info("Request failed",z),H.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",H.res.statusCode,W);if(this._onTokenSucceed.fire(),H.res.statusCode===409)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",H.res.statusCode,W);if(H.res.statusCode===410)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",H.res.statusCode,W);if(H.res.statusCode===412)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",H.res.statusCode,W);if(H.res.statusCode===413)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",H.res.statusCode,W);if(H.res.statusCode===426)throw new f.UserDataSyncStoreError(`${N.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",H.res.statusCode,W);if(H.res.statusCode===429){const V=H.res.headers["retry-after"];throw V?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(V)*1e3)),new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",H.res.statusCode,W)):new f.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",H.res.statusCode,W)}if(!te)throw new f.UserDataSyncStoreError("Server returned "+H.res.statusCode,_,"Unknown",H.res.statusCode,W);return H}addSessionHeaders(_){let N=this.storageService.get(i,-1);N===void 0&&(N=(0,p.generateUuid)(),this.storageService.store(i,N,-1,1)),_["X-Machine-Session-Id"]=N;const k=this.storageService.get(n,-1);k!==void 0&&(_["X-User-Session-Id"]=k)}};c=me([Q(1,y.IProductService),Q(2,h.IRequestService),Q(3,f.IUserDataSyncLogService),Q(4,d.IEnvironmentService),Q(5,S.IFileService),Q(6,m.IStorageService)],c),e.UserDataSyncStoreClient=c;let g=class extends c{constructor(_,N,k,M,U,H,W){super(_.userDataSyncStore?.url,N,k,M,U,H,W);this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};g=me([Q(0,f.IUserDataSyncStoreManagementService),Q(1,y.IProductService),Q(2,h.IRequestService),Q(3,f.IUserDataSyncLogService),Q(4,d.IEnvironmentService),Q(5,S.IFileService),Q(6,m.IStorageService)],g),e.UserDataSyncStoreService=g;class C{constructor(_,N,k,M){this.limit=_,this.interval=N,this.requestService=k,this.logService=M,this.requests=[],this.startTime=void 0}request(_,N,k){if(this.isExpired()&&this.reset(),N.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(N,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=C}),define(re[262],se([0,1,3,67,24,22,21,258,25,72,73]),function(Z,e,R,t,L,T,A,I,b,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends I.UserDataAutoSyncService{constructor(E,d,S,y,h,v,m,f,u,r,n){super(E,d,S,y,h,m,f,u,r,n);this._register(R.Event.debounce(R.Event.any(R.Event.map(v.onDidFocusWindow,()=>"windowFocus"),R.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(i,a)=>i?[...i,a]:[a],1e3)(i=>this.triggerSync(i,!0,!1)))}};w=me([Q(0,L.IProductService),Q(1,b.IUserDataSyncStoreManagementService),Q(2,b.IUserDataSyncStoreService),Q(3,b.IUserDataSyncEnablementService),Q(4,b.IUserDataSyncService),Q(5,t.INativeHostService),Q(6,b.IUserDataSyncLogService),Q(7,P.IUserDataSyncAccountService),Q(8,A.ITelemetryService),Q(9,D.IUserDataSyncMachinesService),Q(10,T.IStorageService)],w),e.UserDataAutoSyncService=w}),define(re[263],se([0,1,6,3,2]),function(Z,e,R,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:b,getActiveWindowId:P}){super();this.disposables=this._register(new L.DisposableStore),t.Event.latch(t.Event.any(I,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>P()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(re[108],se([0,1,54,6,12,14,27,137,272,273]),function(Z,e,R,t,L,T,A,I,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(r,n){let i=n.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=n}}e.ExtractError=D;function w(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(n=>r&n).reduce((n,i)=>n+i,r&61440)}function p(u){if(u instanceof D)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new D(r,u)}function E(u,r,n,i,a,l){const o=L.dirname(r),s=L.join(i,o);if(!s.startsWith(i))return Promise.reject(new Error(I.localize(0,null,r)));const c=L.join(i,r);let g;return l.onCancellationRequested(()=>{g&&g.destroy()}),Promise.resolve(A.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((C,O)=>{if(!l.isCancellationRequested)try{g=(0,R.createWriteStream)(c,{mode:n}),g.once("close",()=>C()),g.once("error",O),u.once("error",O),u.pipe(g)}catch(_){O(_)}}))}function d(u,r,n,i){let a=(0,t.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{a.cancel(),u.close()}),new Promise((o,s)=>{const c=new t.Sequencer,g=C=>{C.isCancellationRequested||(l++,u.readEntry())};u.once("error",s),u.once("close",()=>a.then(()=>{i.isCancellationRequested||u.entryCount===l?o():s(new D("Incomplete",new Error(I.localize(1,null,l,u.entryCount))))},s)),u.readEntry(),u.on("entry",C=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(C.fileName)){g(i);return}const O=C.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(O)){const k=L.join(r,O);a=(0,t.createCancelablePromise)(M=>A.Promises.mkdir(k,{recursive:!0}).then(()=>g(M)).then(void 0,s));return}const _=y(u,C),N=w(C);a=(0,t.createCancelablePromise)(k=>c.queue(()=>_.then(M=>E(M,O,N,r,n,k).then(()=>g(k)))).then(null,s))})})}function S(u,r=!1){return new Promise((n,i)=>{(0,b.open)(u,r?{lazyEntries:!0}:void 0,(a,l)=>{a?i(p(a)):n((0,T.assertIsDefined)(l))})})}function y(u,r){return new Promise((n,i)=>{u.openReadStream(r,(a,l)=>{a?i(p(a)):n((0,T.assertIsDefined)(l))})})}function h(u,r){return new Promise((n,i)=>{const a=new P.ZipFile;r.forEach(o=>{o.contents?a.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&a.addFile(o.localPath,o.path)}),a.end();const l=(0,R.createWriteStream)(u);a.outputStream.pipe(l),a.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>n(u))})}e.zip=h;function v(u,r,n={},i){const a=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let l=S(u,!0);return n.overwrite&&(l=l.then(o=>A.Promises.rm(r).then(()=>o))),l.then(o=>d(o,r,{sourcePathRegex:a},i))}e.extract=v;function m(u,r){return S(u).then(n=>new Promise((i,a)=>{n.on("entry",l=>{l.fileName===r&&y(n,l).then(o=>i(o),o=>a(o))}),n.once("close",()=>a(new Error(I.localize(2,null,r))))}))}function f(u,r){return m(u,r).then(n=>new Promise((i,a)=>{const l=[];n.once("error",a),n.on("data",o=>l.push(o)),n.on("end",()=>i(Buffer.concat(l)))}))}e.buffer=f}),define(re[264],se([0,1,108,146]),function(Z,e,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,R.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=L}),define(re[109],se([0,1,6,37,9,2,20,12,4,19,55,14,8,31,27,108,145,91,15,235,30,32,46,70,200,236,264,201,232,50,65,13,5,7,24,21,33,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u,r,n,i,a,l,o,s,c,g,C,O,_,N,k,M,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,O.refineServiceDecorator)(f.IServerExtensionManagementService);let H=class extends m.AbstractExtensionManagementService{constructor(Y,x,B,J,F,$,j,K,q,ee,ne,oe){super(oe,ne,Y,$,x,B,ee);this.environmentService=J,this.extensionsScannerService=F,this.downloadService=j,this.fileService=q;const le=this._register(K.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(W,fe=>le.postUninstall(fe))),this.manifestCache=this._register(new o.ExtensionsManifestCache(J,this)),this.extensionsDownloader=this._register(K.createInstance(i.ExtensionsDownloader));const Se=this._register(new s.ExtensionsWatcher(this,q,J,B,ne));this._register(Se.onDidChangeExtensionsByAnotherSource(({added:fe,removed:pe})=>{fe.length&&this._onDidInstallExtensions.fire(fe.map(Ce=>({identifier:Ce.identifier,operation:1,local:Ce}))),pe.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Y){this.logService.trace("ExtensionManagementService#zip",Y.identifier.id);const x=await this.collectFiles(Y),B=await(0,S.zip)((0,P.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,x);return p.URI.file(B)}async unzip(Y){return this.logService.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const x=await this.downloadVsix(Y),B=I.resolve(x.fsPath);return(0,l.getManifest)(B)}getInstalled(Y,x){return this.extensionsScanner.scanExtensions(Y??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(Y,x={}){this.logService.trace("ExtensionManagementService#install",Y.toString());const B=await this.downloadVsix(Y),J=await(0,l.getManifest)(I.resolve(B.fsPath));if(J.engines&&J.engines.vscode&&!(0,g.isEngineValid)(J.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,u.getGalleryExtensionId)(J.publisher,J.name),this.productService.version));return this.installExtension(J,B,x)}getMetadata(Y){return this.extensionsScannerService.scanMetadata(Y.location)}async updateMetadata(Y,x){this.logService.trace("ExtensionManagementService#updateMetadata",Y.identifier.id);const B={...x};return x.isPreReleaseVersion&&(B.preRelease=!0),Y=await this.extensionsScanner.updateMetadata(Y,B),this.manifestCache.invalidate(),Y}async updateExtensionScope(Y,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Y.identifier.id),Y=await this.extensionsScanner.updateMetadata(Y,{isMachineScoped:x}),this.manifestCache.invalidate(),Y}removeUninstalledExtensions(Y){return this.extensionsScanner.cleanUp(Y)}async downloadVsix(Y){if(Y.scheme===A.Schemas.file)return Y;const x=(0,P.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(Y,x),x}createDefaultInstallExtensionTask(Y,x,B){return p.URI.isUri(x)?new V(Y,x,B,this.galleryService,this.extensionsScanner,this.logService):new te(Y,x,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createDefaultUninstallExtensionTask(Y,x){return new G(Y,x,this.extensionsScanner)}async collectFiles(Y){const x=async J=>{let F=await d.Promises.readdir(J);F=F.map(K=>I.join(J,K));const $=await Promise.all(F.map(K=>d.Promises.stat(K)));let j=Promise.resolve([]);return $.forEach((K,q)=>{const ee=F[q];K.isFile()&&(j=j.then(ne=>[...ne,ee])),K.isDirectory()&&(j=j.then(ne=>x(ee).then(oe=>[...ne,...oe])))}),j};return(await x(Y.location.fsPath)).map(J=>({path:`extension/${I.relative(Y.location.fsPath,J)}`,localPath:J}))}};H=me([Q(0,f.IExtensionGalleryService),Q(1,k.ITelemetryService),Q(2,_.ILogService),Q(3,v.INativeEnvironmentService),Q(4,n.IExtensionsScannerService),Q(5,r.IExtensionsProfileScannerService),Q(6,h.IDownloadService),Q(7,O.IInstantiationService),Q(8,C.IFileService),Q(9,N.IProductService),Q(10,M.IUriIdentityService),Q(11,U.IUserDataProfilesService)],H),e.ExtensionManagementService=H;let W=class extends T.Disposable{constructor(Y,x,B,J){super();this.beforeRemovingExtension=Y,this.fileService=x,this.extensionsScannerService=B,this.logService=J,this.uninstalledPath=(0,P.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(Y){await this.removeUninstalledExtensions(),Y&&await this.removeOutdatedExtensions()}async scanExtensions(Y,x){const B={includeInvalid:!0,profileLocation:x};let J=[];return Y===null||Y===0?J.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},B)):Y===1&&J.push(...await this.extensionsScannerService.scanUserExtensions(B)),J=Y!==null?J.filter(F=>F.type===Y):J,Promise.all(J.map(F=>this.toLocalExtension(F)))}async scanUserExtensions(Y){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(x.map(B=>this.toLocalExtension(B)))}async extractUserExtension(Y,x,B,J){const F=Y.toString(),$=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),j=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,F);try{await d.Promises.rm(j)}catch{throw new f.ExtensionManagementError(y.localize(1,null,j,Y.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(Y,x,$,J),B={...B,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(p.URI.file($),B);try{await this.rename(Y,$,j,Date.now()+2*60*1e3),this.logService.info("Renamed to",j)}catch(K){try{await d.Promises.rm($)}catch{}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(K)}. Deleted from extracted location`,$),K}return this.scanLocalExtension(p.URI.file(j),1)}async updateMetadata(Y,x){return await this.extensionsScannerService.updateMetadata(Y.location,x),this.scanLocalExtension(Y.location,Y.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...Y){const x=Y.map(B=>u.ExtensionKey.create(B));await this.withUninstalledExtensions(B=>{x.forEach(J=>B[J.toString()]=!0)})}async setInstalled(Y){await this.withUninstalledExtensions(J=>delete J[Y.toString()]);const B=(await this.scanUserExtensions(!0)).find(J=>u.ExtensionKey.create(J).equals(Y))||null;return B?this.updateMetadata(B,{installedTimestamp:Date.now()}):null}async removeExtension(Y,x){this.logService.trace(`Deleting ${x} extension from disk`,Y.identifier.id,Y.location.fsPath),await d.Promises.rm(Y.location.fsPath),this.logService.info("Deleted from disk",Y.identifier.id,Y.location.fsPath)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[u.ExtensionKey.create(Y).toString()])}async withUninstalledExtensions(Y){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(J){if(J.code!=="ENOENT")throw J}let B={};if(x)try{B=JSON.parse(x)}catch{}return Y&&(Y(B),Object.keys(B).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(B)):await d.Promises.rm(this.uninstalledPath)),B})}async extractAtLocation(Y,x,B,J){this.logService.trace(`Started extracting the extension from ${x} to ${B}`);try{await d.Promises.rm(B)}catch(F){throw new f.ExtensionManagementError(this.joinErrors(F).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(x,B,{sourcePath:"extension",overwrite:!0},J),this.logService.info(`Extracted extension to ${B}:`,Y.id)}catch(F){try{await d.Promises.rm(B)}catch{}let $=f.ExtensionManagementErrorCode.Extract;throw F instanceof S.ExtractError&&(F.type==="CorruptZip"?$=f.ExtensionManagementErrorCode.CorruptZip:F.type==="Incomplete"&&($=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(F.message,$)}}async rename(Y,x,B,J){try{await d.Promises.rename(x,B)}catch(F){if(b.isWindows&&F&&F.code==="EPERM"&&Date.now()<J)return this.logService.info(`Failed renaming ${x} to ${B} with 'EPERM' error. Trying again...`,Y.id),this.rename(Y,x,B,J);throw new f.ExtensionManagementError(F.message||y.localize(2,null,x,B),F.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Y,x){const B=await this.extensionsScannerService.scanExistingExtension(Y,x,{includeInvalid:!0});if(B)return this.toLocalExtension(B);throw new Error(y.localize(3,null,Y.path))}async toLocalExtension(Y){const x=await this.fileService.resolve(Y.location);let B,J;return x.children&&(B=x.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,J=x.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:B,changelogUrl:J,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated}}async removeUninstalledExtensions(){const Y=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=new Set;for(const $ of x)Y[u.ExtensionKey.create($).toString()]||B.add($.identifier.id.toLowerCase());const J=(0,u.groupByExtension)(x,$=>$.identifier);await R.Promises.settled(J.map(async $=>{const j=$.sort((K,q)=>D.rcompare(K.manifest.version,q.manifest.version))[0];B.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(j))}));const F=x.filter($=>Y[u.ExtensionKey.create($).toString()]);await R.Promises.settled(F.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const Y=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=[],J=await this.extensionsScannerService.getTargetPlatform(),F=(0,u.groupByExtension)(x,$=>$.identifier);for(const $ of F)if($.length>1&&B.push(...$.sort((j,K)=>{const q=D.rcompare(j.manifest.version,K.manifest.version);return q!==0?q:j.targetPlatform===J?-1:1}).slice(1)),$[0].type===0){const j=Y.find(K=>(0,u.areSameExtensions)(K.identifier,$[0].identifier));(!j||D.gte(j.manifest.version,$[0].manifest.version))&&B.push($[0])}await R.Promises.settled(B.map($=>this.removeExtension($,"outdated")))}joinErrors(Y){const x=Array.isArray(Y)?Y:[Y];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((B,J)=>new Error(`${B.message}${B.message?",":""}${J instanceof Error?J.message:J}`),new Error(""))}};W=me([Q(1,C.IFileService),Q(2,n.IExtensionsScannerService),Q(3,_.ILogService)],W);class z extends m.AbstractExtensionTask{constructor(Y,x,B,J,F){super();this.identifier=Y,this.source=x,this.options=B,this.extensionsScanner=J,this.logService=F,this._operation=2}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(Y,x){try{const B=await this.unsetUninstalledAndGetLocal(Y.key);if(B)return Y.metadata?this.extensionsScanner.updateMetadata(B,Y.metadata):B}catch{throw b.isMacintosh?new f.ExtensionManagementError(y.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(y.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(Y,x)}async unsetUninstalledAndGetLocal(Y){if(!await this.isUninstalled(Y))return null;this.logService.trace("Removing the extension from uninstalled list:",Y.id);const B=await this.extensionsScanner.setInstalled(Y);return this.logService.info("Removed the extension from uninstalled list:",Y.id),B}async isUninstalled(Y){return!!(await this.extensionsScanner.getUninstalledExtensions())[Y.toString()]}async extract({zipPath:Y,key:x,metadata:B},J){const F=await this.extensionsScanner.extractUserExtension(x,Y,B,J);return this.logService.info("Extracting completed.",x.id),F}}class te extends z{constructor(Y,x,B,J,F,$){super(x.identifier,x,B,F,$);this.manifest=Y,this.gallery=x,this.extensionsDownloader=J}async doRun(Y){const B=(await this.extensionsScanner.scanExtensions(null,void 0)).find($=>(0,u.areSameExtensions)($.identifier,this.gallery.identifier));B&&(this._operation=3);const J={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,c.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||B?.isMachineScoped,isBuiltin:this.options.isBuiltin||B?.isBuiltin,isSystem:B?.type===0?!0:void 0,updated:!!B,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:B?.preRelease)};if(B?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(B,J),metadata:J};const F=await this.downloadExtension(this.gallery,this._operation);try{const $=await this.installExtension({zipPath:F,key:u.ExtensionKey.create(this.gallery),metadata:J},Y);return B&&!this.options.profileLocation&&(B.targetPlatform!==$.targetPlatform||D.neq(B.manifest.version,$.manifest.version))&&await this.extensionsScanner.setUninstalled(B),{local:$,metadata:J}}catch($){throw await this.deleteDownloadedVSIX(F),$}}async deleteDownloadedVSIX(Y){try{await this.extensionsDownloader.delete(p.URI.file(Y))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",Y.toString(),(0,L.getErrorMessage)(x))}}async downloadExtension(Y,x){let B;try{this.logService.trace("Started downloading extension:",Y.identifier.id),B=(await this.extensionsDownloader.downloadExtension(Y,x)).fsPath,this.logService.info("Downloaded extension:",Y.identifier.id,B)}catch(J){throw new f.ExtensionManagementError((0,m.joinErrors)(J).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,l.getManifest)(B),B}catch(J){throw await this.deleteDownloadedVSIX(B),new f.ExtensionManagementError((0,m.joinErrors)(J).message,f.ExtensionManagementErrorCode.Invalid)}}}class V extends z{constructor(Y,x,B,J,F,$){super({id:(0,u.getGalleryExtensionId)(Y.publisher,Y.name)},x,B,F,$);this.manifest=Y,this.location=x,this.galleryService=J}async doRun(Y){const x=new u.ExtensionKey(this.identifier,this.manifest.version),J=(await this.extensionsScanner.scanExtensions(1,void 0)).find(j=>(0,u.areSameExtensions)(this.identifier,j.identifier)),F=await this.getMetadata(this.identifier.id,this.manifest.version,Y);if(F.isApplicationScoped=(0,c.isApplicationScopedExtension)(this.manifest),F.isMachineScoped=this.options.isMachineScoped||J?.isMachineScoped,F.isBuiltin=this.options.isBuiltin||J?.isBuiltin,J)if(this._operation=3,x.equals(new u.ExtensionKey(J.identifier,J.manifest.version)))try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&D.gt(J.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(J);else{const j=await this.unsetUninstalledAndGetLocal(x);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:I.resolve(this.location.fsPath),key:x,metadata:F},Y),metadata:F}}async getMetadata(Y,x,B){try{let[J]=await this.galleryService.getExtensions([{id:Y,version:x}],B);if(J||([J]=await this.galleryService.getExtensions([{id:Y}],B)),J)return{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class G extends m.AbstractExtensionTask{constructor(Y,x,B){super();this.extension=Y,this.options=x,this.extensionsScanner=B}async doRun(Y){const x=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const J=u.ExtensionKey.create(this.extension);x.push(...B.filter(F=>J.equals(u.ExtensionKey.create(F))))}else x.push(...B.filter(J=>(0,u.areSameExtensions)(J.identifier,this.extension.identifier)));if(!x.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const J of x)try{Y.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(J)}catch(F){throw new Error(y.localize(9,null,(0,t.toErrorMessage)(F)))}}}}),define(re[265],se([0,1,2,30,32,46,71,199,109,50,5,7,22,33,28]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let y=class extends R.Disposable{constructor(m,f,u,r,n,i,a,l){super();this.userDataProfilesService=f,m.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===0),(0,I.migrateUnsupportedExtensions)(m,u,r,n,l),A.ExtensionStorageService.removeOutdatedExtensionVersions(m,a),this._register(i.createInstance(h))}};y=me([Q(0,b.INativeServerExtensionManagementService),Q(1,d.IUserDataProfilesService),Q(2,t.IExtensionGalleryService),Q(3,A.IExtensionStorageService),Q(4,t.IGlobalExtensionEnablementService),Q(5,D.IInstantiationService),Q(6,p.IStorageService),Q(7,w.ILogService)],y),e.ExtensionsCleaner=y;let h=class extends R.Disposable{constructor(m,f,u,r,n){super();this.extensionManagementService=m,this.userDataProfilesService=f,this.extensionsProfileScannerService=u,this.uriIdentityService=r,this.logService=n,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new R.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:m,removed:f,all:u}){try{await Promise.all(f.map(r=>r.extensionsResource?this.removeExtensionsFromProfile(r.extensionsResource):Promise.resolve()))}catch(r){this.logService.error(r)}if(u.length===0){this.profileModeDisposables.clear();const r=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{r.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{m.length&&(await Promise.all(m.map(r=>r.extensionsResource?this.populateExtensionsFromProfile(r.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new R.DisposableStore,this.profileModeDisposables.value.add((0,R.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(r=>this.onDidChangeProfiles(r))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(r=>this.onDidInstallExtensions(r))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(r=>this.onDidUninstallExtension(r))),await this.uninstallExtensionsNotInProfiles()))}catch(r){this.logService.error(r)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(u=>!this.profileExtensionsLocations.has(this.getKey(u.identifier,u.manifest.version)));f.length&&await Promise.all(f.map(u=>this.extensionManagementService.uninstall(u,S)))}async onDidInstallExtensions(m){for(const{local:f,profileLocation:u}of m)!f||!u||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),u)}async onDidUninstallExtension(m){!m.profileLocation||!m.version||this.removeExtensionWithKey(this.getKey(m.identifier,m.version),m.profileLocation)&&await this.uninstallExtensions([{identifier:m.identifier,version:m.version}])}async populateExtensionsFromProfile(m){const f=await this.extensionsProfileScannerService.scanProfileExtensions(m);for(const u of f)this.addExtensionWithKey(this.getKey(u.identifier,u.version),m)}async removeExtensionsFromProfile(m){const f=[];for(const u of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(u,m))continue;const r=this.fromKey(u);r&&f.push(r)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(m,f){let u=this.profileExtensionsLocations.get(m);u||(u=[],this.profileExtensionsLocations.set(m,u)),u.push(f)}removeExtensionWithKey(m,f){const u=this.profileExtensionsLocations.get(m);if(u){const r=u.findIndex(n=>this.uriIdentityService.extUri.isEqual(n,f));r>-1&&u.splice(r,1)}return u?.length?!1:(this.profileExtensionsLocations.delete(m),!0)}async uninstallExtensions(m){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(r=>m.some(n=>this.getKey(r.identifier,r.manifest.version)===this.getKey(n.identifier,n.version)));u.length&&await Promise.all(u.map(r=>this.extensionManagementService.uninstall(r,S)))}getKey(m,f){return`${P.ExtensionIdentifier.toKey(m.id)}@${f}`}fromKey(m){const[f,u]=(0,L.getIdAndVersion)(m);return u?{identifier:{id:f},version:u}:void 0}};h=me([Q(0,b.INativeServerExtensionManagementService),Q(1,d.IUserDataProfilesService),Q(2,T.IExtensionsProfileScannerService),Q(3,E.IUriIdentityService),Q(4,w.ILogService)],h)}),define(re[274],se([0,1,85,36,37,9,2,20,19,8,39,133,192,265,193,184,185,186,172,175,18,197,90,216,91,207,15,211,238,239,30,174,240,109,92,170,13,188,190,56,5,182,94,183,95,66,202,7,96,67,97,24,206,44,22,241,215,21,102,103,104,45,220,221,105,223,229,71,107,25,72,254,256,257,73,255,259,260,261,262,263,101,213,69,231,204,230,100,210,33,233,4,234,177,195,194,70,237,28,46,191,58,242,219]),function(Z,e,R,t,L,T,A,I,b,P,D,w,p,E,d,S,y,h,v,m,f,u,r,n,i,a,l,o,s,c,g,C,O,_,N,k,M,U,H,W,z,te,V,G,X,Y,x,B,J,F,$,j,K,q,ee,ne,oe,le,Se,fe,pe,Ce,be,Ie,qe,Qe,Ke,Ye,ae,ue,he,Ee,Pe,Ue,Re,Ne,_e,Te,Me,ie,ce,de,ve,ge,we,De,ke,Le,Ae,Fe,$e,Xe,rt,St,Dt,yt,Rt,kt,Lt,wt,Tt,Et,At,_t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ot extends A.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",ze=(xe,Ze)=>this.onDisposeWorker(Ze);R.ipcRenderer.on(Oe,ze),this._register((0,A.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,ze)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,ue.registerConfiguration)(),ye.invokeFunction(Oe=>{const ze=Oe.get(B.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(ze)}),this._register((0,A.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(d.LanguagePackCachedDataCleaner),ye.createInstance(h.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(y.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(E.ExtensionsCleaner)))}async initServices(){const ye=new V.ServiceCollection,Oe={_serviceBrand:void 0,...$.default};ye.set(j.IProductService,Oe);const ze=new D.StaticRouter(He=>He==="main"),xe=new G.MessagePortMainProcessService(this.server,ze);ye.set(X.IMainProcessService,xe);const Ze=this.configuration.policiesData?new Tt.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,Ze);const We=new o.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(l.INativeEnvironmentService,We);const at=new J.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),et=new J.LoggerChannelClient(this.configuration.logLevel,at.onDidChangeLogLevel,xe.getChannel("logger"));ye.set(B.ILoggerService,et);const ut=this._register(new B.MultiplexLogService([this._register(new B.ConsoleLogger(this.configuration.logLevel)),this._register(et.createLogger((0,b.joinPath)(P.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),je=this._register(new J.FollowerLogService(at,ut));ye.set(B.ILogService,je),this.sharedProcessWorkerService=new Ae.SharedProcessWorkerService(je),ye.set(Le.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new U.FileService(je));ye.set(M.IFileService,Ve);const ht=this._register(new H.DiskFileSystemProvider(je));Ve.registerProvider(I.Schemas.file,ht);const dt=this._register(new rt.FileUserDataProvider(I.Schemas.file,this._register(new St.DiskFileSystemProviderClient(xe.getChannel(St.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Xe.isLinux})),I.Schemas.vscodeUserData,je));Ve.registerProvider(I.Schemas.vscodeUserData,dt);const tt=this._register(new At.UserDataProfilesNativeService(this.configuration.profiles,xe,We,Ve,je));ye.set(Lt.IUserDataProfilesService,tt);const Be=this._register(new u.ConfigurationService(tt.defaultProfile.settingsResource,Ve,Ze,je));ye.set(f.IConfigurationService,Be);const st=new ne.NativeStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},xe,We);ye.set(ee.IStorageService,st),this._register((0,A.toDisposable)(()=>st.flush())),await Promise.all([Be.initialize(),st.initialize()]),ye.set(Fe.IUriIdentityService,new $e.UriIdentityService(Ve)),ye.set(q.IRequestService,new W.SyncDescriptor(K.RequestService)),ye.set(v.IChecksumService,new W.SyncDescriptor(m.ChecksumService)),ye.set(yt.IV8InspectProfilingService,new W.SyncDescriptor(Dt.InspectProfilingService));const ct=D.ProxyChannel.toService(xe.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(F.INativeHostService,ct),ye.set(i.IDownloadService,new W.SyncDescriptor(a.DownloadService));const ft=this._register(new ce.ActiveWindowManager(ct)),Mt=new D.StaticRouter(He=>ft.getActiveClientId().then(gt=>He===gt));ye.set(N.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let lt;const it=[];if((0,Ce.supportsTelemetry)(Oe,We)){const He=new fe.TelemetryLogAppender(et,We);it.push(He);const{installSourcePath:gt}=We;if(Be.getValue("telemetry.internalTesting")&&Oe.aiConfig?.ariaKey){const ot=new _t.OneDataSystemWebAppender(Be,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>ot.flush())),it.push(ot)}else if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=new be.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>ot.flush())),it.push(ot)}lt=new pe.TelemetryService({appenders:it,commonProperties:(0,oe.resolveCommonProperties)(Ve,(0,t.release)(),(0,t.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:(0,Ce.getPiiPathsFromEnvironment)(We)},Be,Oe)}else{lt=Ce.NullTelemetryService;const He=Ce.NullAppender;it.push(He)}this.server.registerChannel("telemetryAppender",new Se.TelemetryAppenderChannel(it)),ye.set(le.ITelemetryService,lt);const Ft=new Ie.CustomEndpointTelemetryService(Be,lt,et,We,Oe);ye.set(le.ICustomEndpointTelemetryService,Ft),ye.set(wt.IExtensionsProfileScannerService,new W.SyncDescriptor(wt.ExtensionsProfileScannerService)),ye.set(Rt.IExtensionsScannerService,new W.SyncDescriptor(kt.ExtensionsScannerService)),ye.set(_.INativeServerExtensionManagementService,new W.SyncDescriptor(_.ExtensionManagementService)),ye.set(g.IExtensionGalleryService,new W.SyncDescriptor(c.ExtensionGalleryService)),ye.set(g.IExtensionTipsService,new W.SyncDescriptor(O.ExtensionTipsService)),ye.set(Y.ILanguagePackService,new W.SyncDescriptor(x.NativeLanguagePackService)),ye.set(r.IDiagnosticsService,new W.SyncDescriptor(n.DiagnosticsService)),ye.set(he.IUserDataSyncAccountService,new W.SyncDescriptor(he.UserDataSyncAccountService)),ye.set(ue.IUserDataSyncLogService,new W.SyncDescriptor(Ue.UserDataSyncLogService)),ye.set(ue.IUserDataSyncUtilService,new Pe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ye.set(g.IGlobalExtensionEnablementService,new W.SyncDescriptor(s.GlobalExtensionEnablementService)),ye.set(ae.IIgnoredExtensionsManagementService,new W.SyncDescriptor(ae.IgnoredExtensionsManagementService)),ye.set(Ye.IExtensionStorageService,new W.SyncDescriptor(Ye.ExtensionStorageService)),ye.set(ue.IUserDataSyncStoreManagementService,new W.SyncDescriptor(Me.UserDataSyncStoreManagementService)),ye.set(ue.IUserDataSyncStoreService,new W.SyncDescriptor(Me.UserDataSyncStoreService)),ye.set(Re.IUserDataSyncMachinesService,new W.SyncDescriptor(Re.UserDataSyncMachinesService)),ye.set(ue.IUserDataSyncBackupStoreService,new W.SyncDescriptor(Ee.UserDataSyncBackupStoreService)),ye.set(ue.IUserDataSyncEnablementService,new W.SyncDescriptor(Ne.UserDataSyncEnablementService)),ye.set(ue.IUserDataSyncService,new W.SyncDescriptor(_e.UserDataSyncService));const Ct=new Ke.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,We,je);return Ct.initialize(),ye.set(Qe.ILocalPtyService,this._register(Ct)),ye.set(de.ISignService,new W.SyncDescriptor(ve.SignService)),ye.set(ge.ISharedTunnelsService,new W.SyncDescriptor(we.SharedTunnelsService)),ye.set(De.ISharedProcessTunnelService,new W.SyncDescriptor(ke.SharedProcessTunnelService)),new te.InstantiationService(ye)}initChannels(ye){const Oe=new C.ExtensionManagementChannel(ye.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const ze=D.ProxyChannel.fromService(ye.get(Y.ILanguagePackService));this.server.registerChannel("languagePacks",ze);const xe=D.ProxyChannel.fromService(ye.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",xe);const Ze=new C.ExtensionTipsChannel(ye.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ze);const We=D.ProxyChannel.fromService(ye.get(v.IChecksumService));this.server.registerChannel("checksum",We);const at=D.ProxyChannel.fromService(ye.get(yt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",at);const et=new Pe.UserDataSyncMachinesServiceChannel(ye.get(Re.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",et);const ut=D.ProxyChannel.fromService(ye.get(le.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ut);const je=new Pe.UserDataSyncAccountServiceChannel(ye.get(he.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",je);const Ve=new Pe.UserDataSyncStoreManagementServiceChannel(ye.get(ue.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const ht=new Te.UserDataSyncChannel(ye.get(ue.IUserDataSyncService),ye.get(B.ILogService));this.server.registerChannel("userDataSync",ht);const dt=this._register(ye.get(z.IInstantiationService).createInstance(ie.UserDataAutoSyncService)),tt=new Pe.UserDataAutoSyncChannel(dt);this.server.registerChannel("userDataAutoSync",tt);const Be=ye.get(Qe.ILocalPtyService),st=D.ProxyChannel.fromService(Be);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,st);const ct=D.ProxyChannel.fromService(ye.get(De.ISharedProcessTunnelService));this.server.registerChannel(De.ipcSharedProcessTunnelChannelName,ct);const ft=D.ProxyChannel.fromService(ye.get(Le.ISharedProcessWorkerService));this.server.registerChannel(Le.ipcSharedProcessWorkerChannelName,ft)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const ze=(0,L.toErrorMessage)(Oe,!0);!ze||ye.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function Ut(bt){const ye=new Ot(bt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ut})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a36f047dd34d67abb45728037a02cfdb530fc59c/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
