/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/platform/log/common/log","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/base/common/strings","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/base/common/map","vs/platform/policy/common/policy","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","child_process","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/node/decoder","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/processes","vs/base/common/extpath","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/workspace/common/workspace","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","crypto","vs/platform/environment/node/argvHelper","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ie=function(q){for(var e=[],C=0,I=q.length;C<I;C++)e[C]=ee[q[C]];return e};define(ee[67],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function C(I,w){if(!I)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=C}),define(ee[50],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function C(k){return(y,l,d)=>{let D=null,b=null;if(typeof d.value=="function"?(D="value",b=d.value):typeof d.get=="function"&&(D="get",b=d.get),!b)throw new Error("not supported");d[D]=k(b,l)}}e.createDecorator=C;function I(k,y,l){let d=null,D=null;if(typeof l.value=="function"?(d="value",D=l.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(d="get",D=l.get),!D)throw new Error("not supported");const b=`$memoize$${y}`;l[d]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,m)}),this[b]}}e.memoize=I;function w(k,y,l){return C((d,D)=>{const b=`$debounce$${D}`,m=`$debounce$result$${D}`;return function(...P){this[m]||(this[m]=l?l():void 0),clearTimeout(this[b]),y&&(this[m]=y(this[m],...P),P=[this[m]]),this[b]=setTimeout(()=>{d.apply(this,P),this[m]=l?l():void 0},k)}})}e.debounce=w;function L(k,y,l){return C((d,D)=>{const b=`$throttle$timer$${D}`,m=`$throttle$result$${D}`,P=`$throttle$lastRun$${D}`,u=`$throttle$pending$${D}`;return function(...g){if(this[m]||(this[m]=l?l():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),y&&(this[m]=y(this[m],...g)),this[u])return;const E=this[P]+k;E<=Date.now()?(this[P]=Date.now(),d.apply(this,[this[m]]),this[m]=l?l():void 0):(this[u]=!0,this[b]=setTimeout(()=>{this[u]=!1,this[P]=Date.now(),d.apply(this,[this[m]]),this[m]=l?l():void 0},E-Date.now()))}})}e.throttle=L}),define(ee[51],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function k(t,n=!1){let i=0;const r=t.length;let o="",h=0,p=16,S=0;function R(Y){let ce=0,x=0;for(;ce<Y;){const j=t.charCodeAt(i);if(j>=48&&j<=57)x=x*16+j-48;else if(j>=65&&j<=70)x=x*16+j-65+10;else if(j>=97&&j<=102)x=x*16+j-97+10;else break;i++,ce++}return ce<Y&&(x=-1),x}function M(Y){i=Y,o="",h=0,p=16,S=0}function H(){const Y=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&d(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&d(t.charCodeAt(i)))for(i++;i<t.length&&d(t.charCodeAt(i));)i++;else return S=3,t.substring(Y,i);let ce=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&d(t.charCodeAt(i))){for(i++;i<t.length&&d(t.charCodeAt(i));)i++;ce=i}else S=3;return t.substring(Y,ce)}function Z(){let Y="",ce=i;for(;;){if(i>=r){Y+=t.substring(ce,i),S=2;break}const x=t.charCodeAt(i);if(x===34){Y+=t.substring(ce,i),i++;break}if(x===92){if(Y+=t.substring(ce,i),i++,i>=r){S=2;break}switch(t.charCodeAt(i++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const K=R(4);K>=0?Y+=String.fromCharCode(K):S=4;break}default:S=5}ce=i;continue}if(x>=0&&x<=31)if(l(x)){Y+=t.substring(ce,i),S=2;break}else S=6;i++}return Y}function ne(){if(o="",S=0,h=i,i>=r)return h=r,p=17;let Y=t.charCodeAt(i);if(y(Y)){do i++,o+=String.fromCharCode(Y),Y=t.charCodeAt(i);while(y(Y));return p=15}if(l(Y))return i++,o+=String.fromCharCode(Y),Y===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),p=14;switch(Y){case 123:return i++,p=1;case 125:return i++,p=2;case 91:return i++,p=3;case 93:return i++,p=4;case 58:return i++,p=6;case 44:return i++,p=5;case 34:return i++,o=Z(),p=10;case 47:{const ce=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!l(t.charCodeAt(i));)i++;return o=t.substring(ce,i),p=12}if(t.charCodeAt(i+1)===42){i+=2;const x=r-1;let j=!1;for(;i<x;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,j=!0;break}i++}return j||(i++,S=1),o=t.substring(ce,i),p=13}return o+=String.fromCharCode(Y),i++,p=16}case 45:if(o+=String.fromCharCode(Y),i++,i===r||!d(t.charCodeAt(i)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=H(),p=11;default:for(;i<r&&Q(Y);)i++,Y=t.charCodeAt(i);if(h!==i){switch(o=t.substring(h,i),o){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return o+=String.fromCharCode(Y),i++,p=16}}function Q(Y){if(y(Y)||l(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let Y;do Y=ne();while(Y>=12&&Y<=15);return Y}return{setPosition:M,getPosition:()=>i,scan:n?oe:ne,getToken:()=>p,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>i-h,getTokenError:()=>S}}e.createScanner=k;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function l(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function b(t,n){const i=[],r=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function S(R,M,H,Z){h.value=R,h.offset=M,h.length=H,h.type=Z,h.colonOffset=void 0,o=h}try{v(t,{onObjectBegin:(R,M)=>{if(n<=R)throw r;o=void 0,p=n>R,i.push("")},onObjectProperty:(R,M,H)=>{if(n<M||(S(R,M,H,"property"),i[i.length-1]=R,n<=M+H))throw r},onObjectEnd:(R,M)=>{if(n<=R)throw r;o=void 0,i.pop()},onArrayBegin:(R,M)=>{if(n<=R)throw r;o=void 0,i.push(0)},onArrayEnd:(R,M)=>{if(n<=R)throw r;o=void 0,i.pop()},onLiteralValue:(R,M,H)=>{if(n<M||(S(R,M,H,s(R)),n<=M+H))throw r},onSeparator:(R,M,H)=>{if(n<=M)throw r;if(R===":"&&o&&o.type==="property")o.colonOffset=M,p=!1,o=void 0;else if(R===","){const Z=i[i.length-1];typeof Z=="number"?i[i.length-1]=Z+1:(p=!0,i[i.length-1]=""),o=void 0}}})}catch(R){if(R!==r)throw R}return{path:i,previousNode:o,isAtPropertyKey:p,matches:R=>{let M=0;for(let H=0;M<R.length&&H<i.length;H++)if(R[M]===i[H]||R[M]==="*")M++;else if(R[M]!=="**")return!1;return M===R.length}}}e.getLocation=b;function m(t,n=[],i=L.DEFAULT){let r=null,o=[];const h=[];function p(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}return v(t,{onObjectBegin:()=>{const R={};p(R),h.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const R=[];p(R),h.push(o),o=R,r=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:p,onError:(R,M,H)=>{n.push({error:R,offset:M,length:H})}},i),o[0]}e.parse=m;function P(t,n=[],i=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function h(R){return r.children.push(R),R}v(t,{onObjectBegin:R=>{r=h({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,M,H)=>{r=h({type:"property",offset:M,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:M,length:H,parent:r})},onObjectEnd:(R,M)=>{r.length=R+M-r.offset,r=r.parent,o(R+M)},onArrayBegin:(R,M)=>{r=h({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,M)=>{r.length=R+M-r.offset,r=r.parent,o(R+M)},onLiteralValue:(R,M,H)=>{h({type:s(R),offset:M,length:H,parent:r,value:R}),o(M+H)},onSeparator:(R,M,H)=>{r.type==="property"&&(R===":"?r.colonOffset=M:R===","&&o(M))},onError:(R,M,H)=>{n.push({error:R,offset:M,length:H})}},i);const S=r.children[0];return S&&delete S.parent,S}e.parseTree=P;function u(t,n){if(!t)return;let i=t;for(const r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const h of i.children)if(Array.isArray(h.children)&&h.children[0].value===r){i=h.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=u;function g(t){if(!t.parent||!t.parent.children)return[];const n=g(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=g;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":{const n=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function f(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=f;function c(t,n,i=!1){if(f(t,n,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const h=c(r[o],n,i);if(h)return h}return t}}e.findNodeAtOffset=c;function v(t,n,i=L.DEFAULT){const r=k(t,!1);function o(N){return N?()=>N(r.getTokenOffset(),r.getTokenLength()):()=>!0}function h(N){return N?$=>N($,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=o(n.onObjectBegin),S=h(n.onObjectProperty),R=o(n.onObjectEnd),M=o(n.onArrayBegin),H=o(n.onArrayEnd),Z=h(n.onLiteralValue),ne=h(n.onSeparator),Q=o(n.onComment),oe=h(n.onError),Y=i&&i.disallowComments,ce=i&&i.allowTrailingComma;function x(){for(;;){const N=r.scan();switch(r.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:Y||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(N){case 12:case 13:Y?j(10):Q();break;case 16:j(1);break;case 15:case 14:break;default:return N}}}function j(N,$=[],O=[]){if(oe(N),$.length+O.length>0){let F=r.getToken();for(;F!==17;){if($.indexOf(F)!==-1){x();break}else if(O.indexOf(F)!==-1)break;F=x()}}}function K(N){const $=r.getTokenValue();return N?Z($):S($),x(),!0}function z(){switch(r.getToken()){case 11:{let N=0;try{N=JSON.parse(r.getTokenValue()),typeof N!="number"&&(j(2),N=0)}catch{j(2)}Z(N);break}case 7:Z(null);break;case 8:Z(!0);break;case 9:Z(!1);break;default:return!1}return x(),!0}function A(){return r.getToken()!==10?(j(3,[],[2,5]),!1):(K(!1),r.getToken()===6?(ne(":"),x(),U()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function B(){p(),x();let N=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(N||j(4,[],[]),ne(","),x(),r.getToken()===2&&ce)break}else N&&j(6,[],[]);A()||j(4,[],[2,5]),N=!0}return R(),r.getToken()!==2?j(7,[2],[]):x(),!0}function T(){M(),x();let N=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(N||j(4,[],[]),ne(","),x(),r.getToken()===4&&ce)break}else N&&j(6,[],[]);U()||j(4,[],[4,5]),N=!0}return H(),r.getToken()!==4?j(8,[4],[]):x(),!0}function U(){switch(r.getToken()){case 3:return T();case 1:return B();case 10:return K(!0);default:return z()}}return x(),r.getToken()===17?i.allowEmptyContent?!0:(j(4,[],[]),!1):U()?(r.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=v;function a(t,n){const i=k(t),r=[];let o,h=0,p;do switch(p=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:h!==p&&r.push(t.substring(h,p)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),h=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=a;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function q(w){const L=[];typeof w=="number"&&L.push("code/timeOrigin",w);function k(l){L.push(l,Date.now())}function y(){const l=[];for(let d=0;d<L.length;d+=2)l.push({name:L[d],startTime:L[d+1]});return l}return{mark:k,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const k of performance.getEntriesByType("mark"))L.push({name:k.name,startTime:Math.round(w+k.startTime)});return L}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function C(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=C(I))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var I in C)(typeof exports=="object"?exports:q)[I]=C[I]}}(typeof self!="undefined"?self:this,function(){return function(q){var e={};function C(I){if(e[I])return e[I].exports;var w=e[I]={i:I,l:!1,exports:{}};return q[I].call(w.exports,w,w.exports,C),w.l=!0,w.exports}return C.m=q,C.c=e,C.d=function(I,w,L){C.o(I,w)||Object.defineProperty(I,w,{enumerable:!0,get:L})},C.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},C.t=function(I,w){if(1&w&&(I=C(I)),8&w||4&w&&typeof I=="object"&&I&&I.__esModule)return I;var L=Object.create(null);if(C.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:I}),2&w&&typeof I!="string")for(var k in I)C.d(L,k,function(y){return I[y]}.bind(null,k));return L},C.n=function(I){var w=I&&I.__esModule?function(){return I.default}:function(){return I};return C.d(w,"a",w),w},C.o=function(I,w){return Object.prototype.hasOwnProperty.call(I,w)},C.p="",C(C.s=0)}([function(q,e,C){(function(I){var w;e=q.exports=O,w=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],l=e.src=[],d=0,D=d++;l[D]="0|[1-9]\\d*";var b=d++;l[b]="[0-9]+";var m=d++;l[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=d++;l[P]="("+l[D]+")\\.("+l[D]+")\\.("+l[D]+")";var u=d++;l[u]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var g=d++;l[g]="(?:"+l[D]+"|"+l[m]+")";var E=d++;l[E]="(?:"+l[b]+"|"+l[m]+")";var f=d++;l[f]="(?:-("+l[g]+"(?:\\."+l[g]+")*))";var c=d++;l[c]="(?:-?("+l[E]+"(?:\\."+l[E]+")*))";var v=d++;l[v]="[0-9A-Za-z-]+";var a=d++;l[a]="(?:\\+("+l[v]+"(?:\\."+l[v]+")*))";var s=d++,t="v?"+l[P]+l[f]+"?"+l[a]+"?";l[s]="^"+t+"$";var n="[v=\\s]*"+l[u]+l[c]+"?"+l[a]+"?",i=d++;l[i]="^"+n+"$";var r=d++;l[r]="((?:<|>)?=?)";var o=d++;l[o]=l[b]+"|x|X|\\*";var h=d++;l[h]=l[D]+"|x|X|\\*";var p=d++;l[p]="[v=\\s]*("+l[h]+")(?:\\.("+l[h]+")(?:\\.("+l[h]+")(?:"+l[f]+")?"+l[a]+"?)?)?";var S=d++;l[S]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[a]+"?)?)?";var R=d++;l[R]="^"+l[r]+"\\s*"+l[p]+"$";var M=d++;l[M]="^"+l[r]+"\\s*"+l[S]+"$";var H=d++;l[H]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Z=d++;l[Z]="(?:~>?)";var ne=d++;l[ne]="(\\s*)"+l[Z]+"\\s+",y[ne]=new RegExp(l[ne],"g");var Q=d++;l[Q]="^"+l[Z]+l[p]+"$";var oe=d++;l[oe]="^"+l[Z]+l[S]+"$";var Y=d++;l[Y]="(?:\\^)";var ce=d++;l[ce]="(\\s*)"+l[Y]+"\\s+",y[ce]=new RegExp(l[ce],"g");var x=d++;l[x]="^"+l[Y]+l[p]+"$";var j=d++;l[j]="^"+l[Y]+l[S]+"$";var K=d++;l[K]="^"+l[r]+"\\s*("+n+")$|^$";var z=d++;l[z]="^"+l[r]+"\\s*("+t+")$|^$";var A=d++;l[A]="(\\s*)"+l[r]+"\\s*("+n+"|"+l[p]+")",y[A]=new RegExp(l[A],"g");var B=d++;l[B]="^\\s*("+l[p]+")\\s+-\\s+("+l[p]+")\\s*$";var T=d++;l[T]="^\\s*("+l[S]+")\\s+-\\s+("+l[S]+")\\s*$";var U=d++;l[U]="(<|>)?=?\\s*\\*";for(var N=0;N<35;N++)w(N,l[N]),y[N]||(y[N]=new RegExp(l[N]));function $(V,G){if(V instanceof O)return V;if(typeof V!="string"||V.length>L||!(G?y[i]:y[s]).test(V))return null;try{return new O(V,G)}catch{return null}}function O(V,G){if(V instanceof O){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof O))return new O(V,G);w("SemVer",V,G),this.loose=G;var X=V.trim().match(G?y[i]:y[s]);if(!X)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<k)return me}return fe}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=$,e.valid=function(V,G){var X=$(V,G);return X?X.version:null},e.clean=function(V,G){var X=$(V.trim().replace(/^[=v]+/,""),G);return X?X.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(V){return w("SemVer.compare",this.version,this.loose,V),V instanceof O||(V=new O(V,this.loose)),this.compareMain(V)||this.comparePre(V)},O.prototype.compareMain=function(V){return V instanceof O||(V=new O(V,this.loose)),W(this.major,V.major)||W(this.minor,V.minor)||W(this.patch,V.patch)},O.prototype.comparePre=function(V){if(V instanceof O||(V=new O(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var X=this.prerelease[G],fe=V.prerelease[G];if(w("prerelease compare",G,X,fe),X===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(X===void 0)return-1;if(X!==fe)return W(X,fe)}while(++G)},O.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,G,X,fe){typeof X=="string"&&(fe=X,X=void 0);try{return new O(V,X).inc(G,fe).version}catch{return null}},e.diff=function(V,G){if(le(V,G))return null;var X=$(V),fe=$(G);if(X.prerelease.length||fe.prerelease.length){for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==fe[me])return me},e.compareIdentifiers=W;var F=/^[0-9]+$/;function W(V,G){var X=F.test(V),fe=F.test(G);return X&&fe&&(V=+V,G=+G),X&&!fe?-1:fe&&!X?1:V<G?-1:V>G?1:0}function _(V,G,X){return new O(V,X).compare(new O(G,X))}function J(V,G,X){return _(V,G,X)>0}function te(V,G,X){return _(V,G,X)<0}function le(V,G,X){return _(V,G,X)===0}function ue(V,G,X){return _(V,G,X)!==0}function pe(V,G,X){return _(V,G,X)>=0}function ve(V,G,X){return _(V,G,X)<=0}function re(V,G,X,fe){var me;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),me=V===X;break;case"!==":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),me=V!==X;break;case"":case"=":case"==":me=le(V,X,fe);break;case"!=":me=ue(V,X,fe);break;case">":me=J(V,X,fe);break;case">=":me=pe(V,X,fe);break;case"<":me=te(V,X,fe);break;case"<=":me=ve(V,X,fe);break;default:throw new TypeError("Invalid operator: "+G)}return me}function ae(V,G){if(V instanceof ae){if(V.loose===G)return V;V=V.value}if(!(this instanceof ae))return new ae(V,G);w("comparator",V,G),this.loose=G,this.parse(V),this.semver===he?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(V,G){return W(G,V)},e.major=function(V,G){return new O(V,G).major},e.minor=function(V,G){return new O(V,G).minor},e.patch=function(V,G){return new O(V,G).patch},e.compare=_,e.compareLoose=function(V,G){return _(V,G,!0)},e.rcompare=function(V,G,X){return _(G,V,X)},e.sort=function(V,G){return V.sort(function(X,fe){return e.compare(X,fe,G)})},e.rsort=function(V,G){return V.sort(function(X,fe){return e.rcompare(X,fe,G)})},e.gt=J,e.lt=te,e.eq=le,e.neq=ue,e.gte=pe,e.lte=ve,e.cmp=re,e.Comparator=ae;var he={};function ge(V,G){if(V instanceof ge)return V.loose===G?V:new ge(V.raw,G);if(V instanceof ae)return new ge(V.value,G);if(!(this instanceof ge))return new ge(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ye(V){return!V||V.toLowerCase()==="x"||V==="*"}function Te(V,G,X,fe,me,De,we,Re,be,Oe,Me,Ce,Le){return((G=ye(X)?"":ye(fe)?">="+X+".0.0":ye(me)?">="+X+"."+fe+".0":">="+G)+" "+(Re=ye(be)?"":ye(Oe)?"<"+(+be+1)+".0.0":ye(Me)?"<"+be+"."+(+Oe+1)+".0":Ce?"<="+be+"."+Oe+"."+Me+"-"+Ce:"<="+Re)).trim()}function Ae(V,G){for(var X=0;X<V.length;X++)if(!V[X].test(G))return!1;if(G.prerelease.length){for(X=0;X<V.length;X++)if(w(V[X].semver),V[X].semver!==he&&V[X].semver.prerelease.length>0){var fe=V[X].semver;if(fe.major===G.major&&fe.minor===G.minor&&fe.patch===G.patch)return!0}return!1}return!0}function Ue(V,G,X){try{G=new ge(G,X)}catch{return!1}return G.test(V)}function xe(V,G,X,fe){var me,De,we,Re,be;switch(V=new O(V,fe),G=new ge(G,fe),X){case">":me=J,De=ve,we=te,Re=">",be=">=";break;case"<":me=te,De=pe,we=J,Re="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(V,G,fe))return!1;for(var Oe=0;Oe<G.set.length;++Oe){var Me=G.set[Oe],Ce=null,Le=null;if(Me.forEach(function(Fe){Fe.semver===he&&(Fe=new ae(">=0.0.0")),Ce=Ce||Fe,Le=Le||Fe,me(Fe.semver,Ce.semver,fe)?Ce=Fe:we(Fe.semver,Le.semver,fe)&&(Le=Fe)}),Ce.operator===Re||Ce.operator===be||(!Le.operator||Le.operator===Re)&&De(V,Le.semver)||Le.operator===be&&we(V,Le.semver))return!1}return!0}ae.prototype.parse=function(V){var G=this.loose?y[K]:y[z],X=V.match(G);if(!X)throw new TypeError("Invalid comparator: "+V);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new O(X[2],this.loose):this.semver=he},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(V){return w("Comparator.test",V,this.loose),this.semver===he||(typeof V=="string"&&(V=new O(V,this.loose)),re(V,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(V,G){if(!(V instanceof ae))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new ge(V.value,G),Ue(this.value,X,G);if(V.operator==="")return X=new ge(this.value,G),Ue(V.semver,X,G);var fe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Re=re(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),be=re(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return fe||me||De&&we||Re||be},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),w("range",V,G);var X=G?y[T]:y[B];V=V.replace(X,Te),w("hyphen replace",V),V=V.replace(y[A],"$1$2$3"),w("comparator trim",V,y[A]),V=(V=(V=V.replace(y[ne],"$1~")).replace(y[ce],"$1^")).split(/\s+/).join(" ");var fe=G?y[K]:y[z],me=V.split(" ").map(function(De){return function(we,Re){return w("comp",we),we=function(be,Oe){return be.trim().split(/\s+/).map(function(Me){return function(Ce,Le){w("caret",Ce,Le);var Fe=Le?y[j]:y[x];return Ce.replace(Fe,function(Ne,Se,Ee,Pe,Ie){var ke;return w("caret",Ce,Ne,Se,Ee,Pe,Ie),ye(Se)?ke="":ye(Ee)?ke=">="+Se+".0.0 <"+(+Se+1)+".0.0":ye(Pe)?ke=Se==="0"?">="+Se+"."+Ee+".0 <"+Se+"."+(+Ee+1)+".0":">="+Se+"."+Ee+".0 <"+(+Se+1)+".0.0":Ie?(w("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=Se==="0"?Ee==="0"?">="+Se+"."+Ee+"."+Pe+Ie+" <"+Se+"."+Ee+"."+(+Pe+1):">="+Se+"."+Ee+"."+Pe+Ie+" <"+Se+"."+(+Ee+1)+".0":">="+Se+"."+Ee+"."+Pe+Ie+" <"+(+Se+1)+".0.0"):(w("no pr"),ke=Se==="0"?Ee==="0"?">="+Se+"."+Ee+"."+Pe+" <"+Se+"."+Ee+"."+(+Pe+1):">="+Se+"."+Ee+"."+Pe+" <"+Se+"."+(+Ee+1)+".0":">="+Se+"."+Ee+"."+Pe+" <"+(+Se+1)+".0.0"),w("caret return",ke),ke})}(Me,Oe)}).join(" ")}(we,Re),w("caret",we),we=function(be,Oe){return be.trim().split(/\s+/).map(function(Me){return function(Ce,Le){var Fe=Le?y[oe]:y[Q];return Ce.replace(Fe,function(Ne,Se,Ee,Pe,Ie){var ke;return w("tilde",Ce,Ne,Se,Ee,Pe,Ie),ye(Se)?ke="":ye(Ee)?ke=">="+Se+".0.0 <"+(+Se+1)+".0.0":ye(Pe)?ke=">="+Se+"."+Ee+".0 <"+Se+"."+(+Ee+1)+".0":Ie?(w("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+Se+"."+Ee+"."+Pe+Ie+" <"+Se+"."+(+Ee+1)+".0"):ke=">="+Se+"."+Ee+"."+Pe+" <"+Se+"."+(+Ee+1)+".0",w("tilde return",ke),ke})}(Me,Oe)}).join(" ")}(we,Re),w("tildes",we),we=function(be,Oe){return w("replaceXRanges",be,Oe),be.split(/\s+/).map(function(Me){return function(Ce,Le){Ce=Ce.trim();var Fe=Le?y[M]:y[R];return Ce.replace(Fe,function(Ne,Se,Ee,Pe,Ie,ke){w("xRange",Ce,Ne,Se,Ee,Pe,Ie,ke);var We=ye(Ee),ze=We||ye(Pe),Ve=ze||ye(Ie);return Se==="="&&Ve&&(Se=""),We?Ne=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Ve?(ze&&(Pe=0),Ve&&(Ie=0),Se===">"?(Se=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):Ve&&(Pe=+Pe+1,Ie=0)):Se==="<="&&(Se="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=Se+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ve&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),w("xRange return",Ne),Ne})}(Me,Oe)}).join(" ")}(we,Re),w("xrange",we),we=function(be,Oe){return w("replaceStars",be,Oe),be.trim().replace(y[U],"")}(we,Re),w("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(fe)})),me=me.map(function(De){return new ae(De,G)})},ge.prototype.intersects=function(V,G){if(!(V instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(fe){return V.set.some(function(me){return me.every(function(De){return fe.intersects(De,G)})})})})},e.toComparators=function(V,G){return new ge(V,G).set.map(function(X){return X.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new O(V,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],V))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(V,G,X){var fe=null,me=null;try{var De=new ge(G,X)}catch{return null}return V.forEach(function(we){De.test(we)&&(fe&&me.compare(we)!==-1||(me=new O(fe=we,X)))}),fe},e.minSatisfying=function(V,G,X){var fe=null,me=null;try{var De=new ge(G,X)}catch{return null}return V.forEach(function(we){De.test(we)&&(fe&&me.compare(we)!==1||(me=new O(fe=we,X)))}),fe},e.validRange=function(V,G){try{return new ge(V,G).range||"*"}catch{return null}},e.ltr=function(V,G,X){return xe(V,G,"<",X)},e.gtr=function(V,G,X){return xe(V,G,">",X)},e.outside=xe,e.prerelease=function(V,G){var X=$(V,G);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(V,G,X){return V=new ge(V,X),G=new ge(G,X),V.intersects(G)},e.coerce=function(V){if(V instanceof O)return V;if(typeof V!="string")return null;var G=V.match(y[H]);return G==null?null:$((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,C(1))},function(q,e){var C,I,w=q.exports={};function L(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function y(E){if(C===setTimeout)return setTimeout(E,0);if((C===L||!C)&&setTimeout)return C=setTimeout,setTimeout(E,0);try{return C(E,0)}catch{try{return C.call(null,E,0)}catch{return C.call(this,E,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:L}catch{C=L}try{I=typeof clearTimeout=="function"?clearTimeout:k}catch{I=k}})();var l,d=[],D=!1,b=-1;function m(){D&&l&&(D=!1,l.length?d=l.concat(d):b=-1,d.length&&P())}function P(){if(!D){var E=y(m);D=!0;for(var f=d.length;f;){for(l=d,d=[];++b<f;)l&&l[b].run();b=-1,f=d.length}l=null,D=!1,function(c){if(I===clearTimeout)return clearTimeout(c);if((I===k||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(c);try{I(c)}catch{try{return I.call(null,c)}catch{return I.call(this,c)}}}(E)}}function u(E,f){this.fun=E,this.array=f}function g(){}w.nextTick=function(E){var f=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)f[c-1]=arguments[c];d.push(new u(E,f)),d.length!==1||D||y(P)},u.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=g,w.addListener=g,w.once=g,w.off=g,w.removeListener=g,w.removeAllListeners=g,w.emit=g,w.prependListener=g,w.prependOnceListener=g,w.listeners=function(E){return[]},w.binding=function(E){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(E){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(ee[68],ie([0,1]),function(q,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class I{constructor(y,l,d){this.level=y,this.key=l,this.value=d,this.forward=[]}}const w=void 0;class L{constructor(y,l=2**16){this.comparator=y,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new I(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,w,w)}has(y){return Boolean(L._search(this,y,this.comparator))}get(y){return L._search(this,y,this.comparator)?.value}set(y,l){return L._insert(this,y,l,this.comparator)&&(this._size+=1),this}delete(y){const l=L._delete(this,y,this.comparator);return l&&(this._size-=1),l}forEach(y,l){let d=this._header.forward[0];for(;d;)y.call(l,d.value,d.key,this),d=d.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",l=this._header.forward[0];for(;l;)y+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return y}static _search(y,l,d){let D=y._header;for(let b=y._level-1;b>=0;b--)for(;D.forward[b]&&d(D.forward[b].key,l)<0;)D=D.forward[b];if(D=D.forward[0],D&&d(D.key,l)===0)return D}static _insert(y,l,d,D){const b=[];let m=y._header;for(let P=y._level-1;P>=0;P--){for(;m.forward[P]&&D(m.forward[P].key,l)<0;)m=m.forward[P];b[P]=m}if(m=m.forward[0],m&&D(m.key,l)===0)return m.value=d,!1;{const P=L._randomLevel(y);if(P>y._level){for(let u=y._level;u<P;u++)b[u]=y._header;y._level=P}m=new I(P,l,d);for(let u=0;u<P;u++)m.forward[u]=b[u].forward[u],b[u].forward[u]=m;return!0}}static _randomLevel(y,l=.5){let d=1;for(;Math.random()<l&&d<y._maxLevel;)d+=1;return d}static _delete(y,l,d){const D=[];let b=y._header;for(let m=y._level-1;m>=0;m--){for(;b.forward[m]&&d(b.forward[m].key,l)<0;)b=b.forward[m];D[m]=b}if(b=b.forward[0],!b||d(b.key,l)!==0)return!1;for(let m=0;m<y._level&&D[m].forward[m]===b;m++)D[m].forward[m]=b.forward[m];for(;y._level>0&&y._header.forward[y._level-1]===w;)y._level-=1;return!0}}e.SkipList=L}),define(ee[43],ie([0,1,12,2]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(a){const s=a;return s?typeof s.read=="function":!1}e.isReadable=w;function L(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function k(a){const s=a;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=k;function y(a,s){return new l(a,s)}e.newWriteableStream=y;class l{constructor(s,t){this.reducer=s,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(t=>t(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(t=>t(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,t){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(s,t){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const i=n.indexOf(t);i>=0&&n.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(a,s){const t=[];let n;for(;(n=a.read())!==null;)t.push(n);return s(t)}e.consumeReadable=d;function D(a,s,t){const n=[];let i;for(;(i=a.read())!==null&&n.length<t;)n.push(i);return i===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i!="undefined"){const r=i;return i=void 0,r}return a.read()}}}e.peekReadable=D;function b(a,s){return new Promise((t,n)=>{const i=[];m(a,{onData:r=>{s&&i.push(r)},onError:r=>{s?n(r):t(void 0)},onEnd:()=>{t(s?s(i):void 0)}})})}e.consumeStream=b;function m(a,s){let t=!1;return a.on("error",n=>{t||s.onError(n)}),a.on("end",()=>{t||s.onEnd()}),a.on("data",n=>{t||s.onData(n)}),(0,I.toDisposable)(()=>t=!0)}e.listenStream=m;function P(a,s){return new Promise((t,n)=>{const i=new I.DisposableStore,r=[],o=S=>{if(r.push(S),r.length>s)return i.dispose(),a.pause(),t({stream:a,buffer:r,ended:!1})},h=S=>n(S),p=()=>t({stream:a,buffer:r,ended:!0});i.add((0,I.toDisposable)(()=>a.removeListener("error",h))),a.on("error",h),i.add((0,I.toDisposable)(()=>a.removeListener("end",p))),a.on("end",p),i.add((0,I.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}e.peekStream=P;function u(a,s){const t=y(s);return t.end(a),t}e.toStream=u;function g(){const a=y(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=g;function E(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}e.toReadable=E;function f(a,s,t){const n=y(t);return m(a,{onData:i=>n.write(s.data(i)),onError:i=>n.error(s.error?s.error(i):i),onEnd:()=>n.end()}),n}e.transform=f;function c(a,s,t){let n=!1;return{read:()=>{const i=s.read();return n?i:(n=!0,i!==null?t([a,i]):a)}}}e.prefixedReadable=c;function v(a,s,t){let n=!1;const i=y(t);return m(s,{onData:r=>n?i.write(r):(n=!0,i.write(t([a,r]))),onError:r=>i.error(r),onEnd:()=>{n||(n=!0,i.write(a)),i.end()}}),i}e.prefixedStream=v}),define(ee[15],ie([0,1,43]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined";let w,L;class k{constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}static alloc(S){return I?new k(Buffer.allocUnsafe(S)):new k(new Uint8Array(S))}static wrap(S){return I&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new k(S)}static fromString(S,R){return!(R?.dontUseNodeBuffer||!1)&&I?new k(Buffer.from(S)):(w||(w=new TextEncoder),new k(w.encode(S)))}static fromByteArray(S){const R=k.alloc(S.length);for(let M=0,H=S.length;M<H;M++)R.buffer[M]=S[M];return R}static concat(S,R){if(typeof R=="undefined"){R=0;for(let Z=0,ne=S.length;Z<ne;Z++)R+=S[Z].byteLength}const M=k.alloc(R);let H=0;for(let Z=0,ne=S.length;Z<ne;Z++){const Q=S[Z];M.set(Q,H),H+=Q.byteLength}return M}clone(){const S=k.alloc(this.byteLength);return S.set(this),S}toString(){return I?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(S,R){return new k(this.buffer.subarray(S,R))}set(S,R){if(S instanceof k)this.buffer.set(S.buffer,R);else if(S instanceof Uint8Array)this.buffer.set(S,R);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),R);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return d(this.buffer,S)}writeUInt32BE(S,R){D(this.buffer,S,R)}readUInt32LE(S){return b(this.buffer,S)}writeUInt32LE(S,R){m(this.buffer,S,R)}readUInt8(S){return P(this.buffer,S)}writeUInt8(S,R){u(this.buffer,S,R)}}e.VSBuffer=k;function y(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0}e.readUInt16LE=y;function l(p,S,R){p[R+0]=S&255,S=S>>>8,p[R+1]=S&255}e.writeUInt16LE=l;function d(p,S){return p[S]*2**24+p[S+1]*2**16+p[S+2]*2**8+p[S+3]}e.readUInt32BE=d;function D(p,S,R){p[R+3]=S,S=S>>>8,p[R+2]=S,S=S>>>8,p[R+1]=S,S=S>>>8,p[R]=S}e.writeUInt32BE=D;function b(p,S){return p[S+0]<<0>>>0|p[S+1]<<8>>>0|p[S+2]<<16>>>0|p[S+3]<<24>>>0}e.readUInt32LE=b;function m(p,S,R){p[R+0]=S&255,S=S>>>8,p[R+1]=S&255,S=S>>>8,p[R+2]=S&255,S=S>>>8,p[R+3]=S&255}e.writeUInt32LE=m;function P(p,S){return p[S]}e.readUInt8=P;function u(p,S,R){p[R]=S}e.writeUInt8=u;function g(p){return C.consumeReadable(p,S=>k.concat(S))}e.readableToBuffer=g;function E(p){return C.toReadable(p)}e.bufferToReadable=E;function f(p){return C.consumeStream(p,S=>k.concat(S))}e.streamToBuffer=f;async function c(p){return p.ended?k.concat(p.buffer):k.concat([...p.buffer,await f(p.stream)])}e.bufferedStreamToBuffer=c;function v(p){return C.toStream(p,S=>k.concat(S))}e.bufferToStream=v;function a(p){return C.transform(p,{data:S=>typeof S=="string"?k.fromString(S):k.wrap(S)},S=>k.concat(S))}e.streamToBufferReadableStream=a;function s(p){return C.newWriteableStream(S=>k.concat(S),p)}e.newWriteableBufferStream=s;function t(p,S){return C.prefixedReadable(p,S,R=>k.concat(R))}e.prefixedBufferReadable=t;function n(p,S){return C.prefixedStream(p,S,R=>k.concat(R))}e.prefixedBufferStream=n;function i(p){let S=0,R=0,M=0;const H=new Uint8Array(Math.floor(p.length/4*3)),Z=Q=>{switch(R){case 3:H[M++]=S|Q,R=0;break;case 2:H[M++]=S|Q>>>2,S=Q<<6,R=3;break;case 1:H[M++]=S|Q>>>4,S=Q<<4,R=2;break;default:S=Q<<2,R=1}};for(let Q=0;Q<p.length;Q++){const oe=p.charCodeAt(Q);if(oe>=65&&oe<=90)Z(oe-65);else if(oe>=97&&oe<=122)Z(oe-97+26);else if(oe>=48&&oe<=57)Z(oe-48+52);else if(oe===43||oe===45)Z(62);else if(oe===47||oe===95)Z(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${p[Q]}`)}}const ne=M;for(;R>0;)Z(0);return k.wrap(H).slice(0,ne)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:p},S=!0,R=!1){const M=R?o:r;let H="";const Z=p.byteLength%3;let ne=0;for(;ne<p.byteLength-Z;ne+=3){const Q=p[ne+0],oe=p[ne+1],Y=p[ne+2];H+=M[Q>>>2],H+=M[(Q<<4|oe>>>4)&63],H+=M[(oe<<2|Y>>>6)&63],H+=M[Y&63]}if(Z===1){const Q=p[ne+0];H+=M[Q>>>2],H+=M[Q<<4&63],S&&(H+="==")}else if(Z===2){const Q=p[ne+0],oe=p[ne+1];H+=M[Q>>>2],H+=M[(Q<<4|oe>>>4)&63],H+=M[oe<<2&63],S&&(H+="=")}return H}e.encodeBase64=h}),define(ee[25],ie([0,1,7]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.keys(u).forEach(E=>{u[E]&&typeof u[E]=="object"?g[E]=I(u[E]):g[E]=u[E]}),g}e.deepClone=I;function w(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const E=g.shift();Object.freeze(E);for(const f in E)if(L.call(E,f)){const c=E[f];typeof c=="object"&&!Object.isFrozen(c)&&!(0,C.isTypedArray)(c)&&g.push(c)}}return u}e.deepFreeze=w;const L=Object.prototype.hasOwnProperty;function k(u,g){return y(u,g,new Set)}e.cloneAndChange=k;function y(u,g,E){if((0,C.isUndefinedOrNull)(u))return u;const f=g(u);if(typeof f!="undefined")return f;if((0,C.isArray)(u)){const c=[];for(const v of u)c.push(y(v,g,E));return c}if((0,C.isObject)(u)){if(E.has(u))throw new Error("Cannot clone recursive data-structure");E.add(u);const c={};for(const v in u)L.call(u,v)&&(c[v]=y(u[v],g,E));return E.delete(u),c}return u}function l(u,g,E=!0){return(0,C.isObject)(u)?((0,C.isObject)(g)&&Object.keys(g).forEach(f=>{f in u?E&&((0,C.isObject)(u[f])&&(0,C.isObject)(g[f])?l(u[f],g[f],E):u[f]=g[f]):u[f]=g[f]}),u):g}e.mixin=l;function d(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let E,f;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(E=0;E<u.length;E++)if(!d(u[E],g[E]))return!1}else{const c=[];for(f in u)c.push(f);c.sort();const v=[];for(f in g)v.push(f);if(v.sort(),!d(c,v))return!1;for(E=0;E<c.length;E++)if(!d(u[c[E]],g[c[E]]))return!1}return!0}e.equals=d;function D(u){const g=new Set;return JSON.stringify(u,(E,f)=>{if((0,C.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=D;function b(u,g){const E=Object.create(null);return!u||!g||Object.keys(g).forEach(c=>{const v=u[c],a=g[c];d(v,a)||(E[c]=a)}),E}e.distinct=b;function m(u,g){const E=g.toLowerCase(),f=Object.keys(u).find(c=>c.toLowerCase()===E);return f?u[f]:u[g]}e.getCaseInsensitive=m;function P(u,g){const E=Object.create(null);for(const[f,c]of Object.entries(u))g(f,c)&&(E[f]=c);return E}e.filter=P}),define(ee[34],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(w){return C.test(w)}e.isUUID=I,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(y){for(let l=0;l<y.length;l++)y[l]=Math.floor(Math.random()*256);return y};const L=new Uint8Array(16),k=[];for(let y=0;y<256;y++)k.push(y.toString(16).padStart(2,"0"));return function(){w(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let l=0,d="";return d+=k[L[l++]],d+=k[L[l++]],d+=k[L[l++]],d+=k[L[l++]],d+="-",d+=k[L[l++]],d+=k[L[l++]],d+="-",d+=k[L[l++]],d+=k[L[l++]],d+="-",d+=k[L[l++]],d+=k[L[l++]],d+="-",d+=k[L[l++]],d+=k[L[l++]],d+=k[L[l++]],d+=k[L[l++]],d+=k[L[l++]],d+=k[L[l++]],d}}()}),define(ee[69],ie([0,1,149]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(L="utf8"){this.stringDecoder=new C.StringDecoder(L),this.remaining=null}write(L){const k=[],y=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(y.length<1)return k;let l=0,d,D=l;for(;D<y.length;)if(d=y.charCodeAt(D),d===13||d===10){if(k.push(y.substring(l,D)),D++,D<y.length){const b=d;d=y.charCodeAt(D),(b===13&&d===10||b===10&&d===13)&&D++}l=D}else D++;return this.remaining=l<y.length?y.substr(l):null,k}end(){return this.remaining}}e.LineDecoder=I}),define(ee[70],ie([5,6]),function(q,e){return q.create("vs/base/common/date",e)}),define(ee[71],ie([0,1,70]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,w=I*60,L=w*24,k=L*7,y=L*30,l=L*365;function d(b,m,P){typeof b!="number"&&(b=b.getTime());const u=Math.round((new Date().getTime()-b)/1e3);if(u<-30)return(0,C.localize)(0,null,d(new Date().getTime()+u*1e3,!1));if(u<30)return(0,C.localize)(1,null);let g;return u<I?(g=u,m?g===1?P?(0,C.localize)(2,null,g):(0,C.localize)(3,null,g):P?(0,C.localize)(4,null,g):(0,C.localize)(5,null,g):g===1?P?(0,C.localize)(6,null,g):(0,C.localize)(7,null,g):P?(0,C.localize)(8,null,g):(0,C.localize)(9,null,g)):u<w?(g=Math.floor(u/I),m?g===1?P?(0,C.localize)(10,null,g):(0,C.localize)(11,null,g):P?(0,C.localize)(12,null,g):(0,C.localize)(13,null,g):g===1?P?(0,C.localize)(14,null,g):(0,C.localize)(15,null,g):P?(0,C.localize)(16,null,g):(0,C.localize)(17,null,g)):u<L?(g=Math.floor(u/w),m?g===1?P?(0,C.localize)(18,null,g):(0,C.localize)(19,null,g):P?(0,C.localize)(20,null,g):(0,C.localize)(21,null,g):g===1?P?(0,C.localize)(22,null,g):(0,C.localize)(23,null,g):P?(0,C.localize)(24,null,g):(0,C.localize)(25,null,g)):u<k?(g=Math.floor(u/L),m?g===1?(0,C.localize)(26,null,g):(0,C.localize)(27,null,g):g===1?(0,C.localize)(28,null,g):(0,C.localize)(29,null,g)):u<y?(g=Math.floor(u/k),m?g===1?P?(0,C.localize)(30,null,g):(0,C.localize)(31,null,g):P?(0,C.localize)(32,null,g):(0,C.localize)(33,null,g):g===1?P?(0,C.localize)(34,null,g):(0,C.localize)(35,null,g):P?(0,C.localize)(36,null,g):(0,C.localize)(37,null,g)):u<l?(g=Math.floor(u/y),m?g===1?P?(0,C.localize)(38,null,g):(0,C.localize)(39,null,g):P?(0,C.localize)(40,null,g):(0,C.localize)(41,null,g):g===1?P?(0,C.localize)(42,null,g):(0,C.localize)(43,null,g):P?(0,C.localize)(44,null,g):(0,C.localize)(45,null,g)):(g=Math.floor(u/l),m?g===1?P?(0,C.localize)(46,null,g):(0,C.localize)(47,null,g):P?(0,C.localize)(48,null,g):(0,C.localize)(49,null,g):g===1?P?(0,C.localize)(50,null,g):(0,C.localize)(51,null,g):P?(0,C.localize)(52,null,g):(0,C.localize)(53,null,g))}e.fromNow=d;function D(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(ee[72],ie([5,6]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(ee[29],ie([0,1,19,7,72]),function(q,e,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(b,m){return m&&(b.stack||b.stacktrace)?w.localize(0,null,y(b),k(b.stack)||k(b.stacktrace)):y(b)}function k(b){return Array.isArray(b)?b.join(`
`):b}function y(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?w.localize(1,null,b.message):b.message||w.localize(2,null)}function l(b=null,m=!1){if(!b)return w.localize(3,null);if(Array.isArray(b)){const P=C.coalesce(b),u=l(P[0],m);return P.length>1?w.localize(4,null,u,P.length):u}if(I.isString(b))return b;if(b.detail){const P=b.detail;if(P.error)return L(P.error,m);if(P.exception)return L(P.exception,m)}return b.stack?L(b,m):b.message?b.message:w.localize(5,null)}e.toErrorMessage=l;function d(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=d;function D(b,m){let P;return typeof b=="string"?P=new Error(b):P=b,P.actions=m,P}e.createErrorWithActions=D}),define(ee[73],ie([5,6]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(ee[74],ie([0,1,73]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function I(w){switch(w){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}e.getParseErrorMessage=I}),define(ee[52],ie([0,1,13]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var I;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(I=e.Source||(e.Source={}));var w;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(w=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(y,...l){const d=l.reduce((m,P)=>(m[P]=!0,m),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(m=>!d[m]).forEach(m=>{for(let P=0;P<D.length;P++)if(m.search(D[P])!==-1){delete y[m];break}})}e.sanitizeProcessEnvironment=L;function k(y){!y||(delete y.DEBUG,C.isMacintosh&&delete y.DYLD_LIBRARY_PATH,C.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(ee[53],ie([0,1,3,2]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const w=k=>({onDidChange:C.Event.None,value:k});e.staticObservableValue=w;class L extends I.Disposable{constructor(y){super();this._value=y,this.changeEmitter=this._register(new C.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}}e.MutableObservableValue=L}),define(ee[54],ie([0,1,30]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function I(f){return w(f,0)}e.hash=I;function w(f,c){switch(typeof f){case"object":return f===null?L(349,c):Array.isArray(f)?l(f,c):d(f,c);case"string":return y(f,c);case"boolean":return k(f,c);case"number":return L(f,c);case"undefined":return L(937,c);default:return L(617,c)}}e.doHash=w;function L(f,c){return(c<<5)-c+f|0}e.numberHash=L;function k(f,c){return L(f?433:863,c)}function y(f,c){c=L(149417,c);for(let v=0,a=f.length;v<a;v++)c=L(f.charCodeAt(v),c);return c}e.stringHash=y;function l(f,c){return c=L(104579,c),f.reduce((v,a)=>w(a,v),c)}function d(f,c){return c=L(181387,c),Object.keys(f).sort().reduce((v,a)=>(v=y(a,v),w(f[a],v)),c)}class D{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=w(c,this._value),this._value}}e.Hasher=D;var b;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(f,c,v=32){const a=v-c,s=~((1<<a)-1);return(f<<c|(s&f)>>>a)>>>0}function P(f,c=0,v=f.byteLength,a=0){for(let s=0;s<v;s++)f[c+s]=a}function u(f,c,v="0"){for(;f.length<c;)f=v+f;return f}function g(f,c=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(v=>v.toString(16).padStart(2,"0")).join(""):u((f>>>0).toString(16),c/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const v=c.length;if(v===0)return;const a=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,n,i;for(t!==0?(n=t,i=-1,t=0):(n=c.charCodeAt(0),i=0);;){let r=n;if(C.isHighSurrogate(n))if(i+1<v){const o=c.charCodeAt(i+1);C.isLowSurrogate(o)?(i++,r=C.computeCodePoint(n,o)):r=65533}else{t=n;break}else C.isLowSurrogate(n)&&(r=65533);if(s=this._push(a,s,r),i++,i<v)n=c.charCodeAt(i);else break}this._buffLen=s,this._leftoverHighSurrogate=t}_push(c,v,a){return a<128?c[v++]=a:a<2048?(c[v++]=192|(a&1984)>>>6,c[v++]=128|(a&63)>>>0):a<65536?(c[v++]=224|(a&61440)>>>12,c[v++]=128|(a&4032)>>>6,c[v++]=128|(a&63)>>>0):(c[v++]=240|(a&1835008)>>>18,c[v++]=128|(a&258048)>>>12,c[v++]=128|(a&4032)>>>6,c[v++]=128|(a&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,P(this._buff,this._buffLen),this._buffLen>56&&(this._step(),P(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=E._bigBlock32,v=this._buffDV;for(let p=0;p<64;p+=4)c.setUint32(p,v.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)c.setUint32(p,m(c.getUint32(p-12,!1)^c.getUint32(p-32,!1)^c.getUint32(p-56,!1)^c.getUint32(p-64,!1),1),!1);let a=this._h0,s=this._h1,t=this._h2,n=this._h3,i=this._h4,r,o,h;for(let p=0;p<80;p++)p<20?(r=s&t|~s&n,o=1518500249):p<40?(r=s^t^n,o=1859775393):p<60?(r=s&t|s&n|t&n,o=2400959708):(r=s^t^n,o=3395469782),h=m(a,5)+r+i+o+c.getUint32(p*4,!1)&4294967295,i=n,n=t,t=m(s,30),s=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[55],ie([0,1,30]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(I||(I={})),function(w){const L="error",k="warning",y="warn",l="info",d="ignore";function D(m){return m?C.equalsIgnoreCase(L,m)?w.Error:C.equalsIgnoreCase(k,m)||C.equalsIgnoreCase(y,m)?w.Warning:C.equalsIgnoreCase(l,m)?w.Info:w.Ignore:w.Ignore}w.fromValue=D;function b(m){switch(m){case w.Error:return L;case w.Warning:return k;case w.Info:return l;default:return d}}w.toString=b}(I||(I={})),e.default=I}),define(ee[75],ie([0,1,9]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function I(d){const D=d;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=I;function w(d){const D=[];let b;try{const m=JSON.parse(d.arguments),P=m[m.length-1];P&&P.__$stack&&(m.pop(),b=P.__$stack),D.push(...m)}catch{D.push("Unable to log remote console arguments",d.arguments)}return{args:D,stack:b}}e.parse=w;function L(d){if(typeof d!="string")return L(w(d).stack);const D=d;if(D){const b=k(D),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:C.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=L;function k(d){if(!d)return d;const D=d.indexOf(`
`);return D===-1?d:d.substring(0,D)}function y(d,D){const{args:b,stack:m}=w(d),P=typeof b[0]=="string"&&b.length===1;let u=k(m);u&&(u=`(${u.trim()})`);let g=[];if(typeof b[0]=="string"?u&&P?g=[`%c[${D}] %c${b[0]} %c${u}`,l("blue"),l(""),l("grey")]:g=[`%c[${D}] %c${b[0]}`,l("blue"),l(""),...b.slice(1)]:g=[`%c[${D}]%`,l("blue"),...b],u&&!P&&g.push(u),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,g)}e.log=y;function l(d){return`color: ${d}`}}),define(ee[44],ie([0,1,15,30,9]),function(q,e,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(d){return JSON.stringify(d,y)}e.stringify=L;function k(d){let D=JSON.parse(d);return D=l(D),D}e.parse=k;function y(d,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,I.regExpFlags)(D)}:D}function l(d,D=0){if(!d||D>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return w.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof C.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let b=0;b<d.length;++b)d[b]=l(d[b],D+1);else for(const b in d)Object.hasOwnProperty.call(d,b)&&(d[b]=l(d[b],D+1))}return d}e.revive=l}),define(ee[76],ie([0,1,39,14,20]),function(q,e,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,k=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var l;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(l||(l={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class b{constructor(s,t,n){this.exePath=s,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?d===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:a=!1,findPreview:s=!1}={}){const t=m({useAlternateBitness:a});if(!t)return null;const n=I.join(t,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const p of await w.Promises.readdir(n)){let S=-1;if(s){const M=p.indexOf("-");if(M<0)continue;const H=p.substring(0,M);if(!L.test(H)||p.substring(M+1)!=="preview")continue;S=parseInt(H,10)}else{if(!L.test(p))continue;S=parseInt(p,10)}if(S<=i)continue;const R=I.join(n,p,"pwsh.exe");!await w.SymlinkSupport.existsFile(R)||(r=R,i=S)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",h=s?" Preview":"";return new b(r,`PowerShell${h}${o}`,!0)}async function u({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=a?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await w.Promises.readdir(s))if(t.test(i)){const r=I.join(s,i,"pwsh.exe");return new b(r,n)}return null}function g(){const a=I.join(C.homedir(),".dotnet","tools","pwsh.exe");return new b(a,".NET Core PowerShell Global Tool")}function E(){const a=I.join(process.env.windir,d===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(a,"Windows PowerShell",!0)}async function*f(){let a=await P();a&&(yield a),a=await P({useAlternateBitness:!0}),a&&(yield a),a=await u(),a&&(yield a),a=g(),a&&(yield a),a=await P({findPreview:!0}),a&&(yield a),a=await u({findPreview:!0}),a&&(yield a),a=await P({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=E(),a&&(yield a)}async function*c(){for await(const a of f())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=c;async function v(){for await(const a of c())return a;return null}e.getFirstAvailablePowerShellInstallation=v});var de=this&&this.__decorate||function(q,e,C,I){var w=arguments.length,L=w<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,C):I,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(q,e,C,I);else for(var y=q.length-1;y>=0;y--)(k=q[y])&&(L=(w<3?k(L):w>3?k(e,C,L):k(e,C))||L);return w>3&&L&&Object.defineProperty(e,C,L),L};define(ee[56],ie([0,1,19,4,15,26,50,12,3,2,44,30,7]),function(q,e,C,I,w,L,k,y,l,d,D,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var P;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(P=e.RequestType||(e.RequestType={}));function u(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));class c{constructor(A){this.buffer=A,this.pos=0}read(A){const B=this.buffer.slice(this.pos,this.pos+A);return this.pos+=B.byteLength,B}}class v{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var a;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(a||(a={}));function s(z){const A=w.VSBuffer.alloc(4);return A.writeUInt32BE(z,0),A}function t(z){return z.read(4).readUInt32BE(0)}function n(z){const A=w.VSBuffer.alloc(1);return A.writeUInt8(z,0),A}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object)},r=typeof Buffer!="undefined";function o(z,A){if(typeof A=="undefined")z.write(i.Undefined);else if(typeof A=="string"){const B=w.VSBuffer.fromString(A);z.write(i.String),z.write(s(B.byteLength)),z.write(B)}else if(r&&Buffer.isBuffer(A)){const B=w.VSBuffer.wrap(A);z.write(i.Buffer),z.write(s(B.byteLength)),z.write(B)}else if(A instanceof w.VSBuffer)z.write(i.VSBuffer),z.write(s(A.byteLength)),z.write(A);else if(Array.isArray(A)){z.write(i.Array),z.write(s(A.length));for(const B of A)o(z,B)}else{const B=w.VSBuffer.fromString(JSON.stringify(A));z.write(i.Object),z.write(s(B.byteLength)),z.write(B)}}function h(z){switch(z.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return z.read(t(z)).toString();case a.Buffer:return z.read(t(z)).buffer;case a.VSBuffer:return z.read(t(z));case a.Array:{const B=t(z),T=[];for(let U=0;U<B;U++)T.push(h(z));return T}case a.Object:return JSON.parse(z.read(t(z)).toString())}}class p{constructor(A,B,T=null,U=1e3){this.protocol=A,this.ctx=B,this.logger=T,this.timeoutDelay=U,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(A,B){this.channels.set(A,B),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const B=this.send([A.type]);this.logger?.logOutgoing(B,0,1,E(A.type));return}case 201:case 202:case 204:case 203:{const B=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(B,A.id,1,E(A.type),A.data);return}}}send(A,B=void 0){const T=new v;return o(T,A),o(T,B),this.sendBuffer(T.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const B=new c(A),T=h(B),U=h(B),N=T[0];switch(N){case 100:return this.logger?.logIncoming(A.byteLength,T[1],1,`${u(N)}: ${T[2]}.${T[3]}`,U),this.onPromise({type:N,id:T[1],channelName:T[2],name:T[3],arg:U});case 102:return this.logger?.logIncoming(A.byteLength,T[1],1,`${u(N)}: ${T[2]}.${T[3]}`,U),this.onEventListen({type:N,id:T[1],channelName:T[2],name:T[3],arg:U});case 101:return this.logger?.logIncoming(A.byteLength,T[1],1,`${u(N)}`),this.disposeActiveRequest({type:N,id:T[1]});case 103:return this.logger?.logIncoming(A.byteLength,T[1],1,`${u(N)}`),this.disposeActiveRequest({type:N,id:T[1]})}}onPromise(A){const B=this.channels.get(A.channelName);if(!B){this.collectPendingRequest(A);return}const T=new L.CancellationTokenSource;let U;try{U=B.call(this.ctx,A.name,A.arg,T.token)}catch(O){U=Promise.reject(O)}const N=A.id;U.then(O=>{this.sendResponse({id:N,data:O,type:201}),this.activeRequests.delete(A.id)},O=>{O instanceof Error?this.sendResponse({id:N,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:N,data:O,type:203}),this.activeRequests.delete(A.id)});const $=(0,d.toDisposable)(()=>T.cancel());this.activeRequests.set(A.id,$)}onEventListen(A){const B=this.channels.get(A.channelName);if(!B){this.collectPendingRequest(A);return}const T=A.id,N=B.listen(this.ctx,A.name,A.arg)($=>this.sendResponse({id:T,data:$,type:204}));this.activeRequests.set(A.id,N)}disposeActiveRequest(A){const B=this.activeRequests.get(A.id);B&&(B.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let B=this.pendingRequests.get(A.channelName);B||(B=[],this.pendingRequests.set(A.channelName,B));const T=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:A,timeoutTimer:T})}flushPendingRequests(A){const B=this.pendingRequests.get(A);if(B){for(const T of B)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=p;var S;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(A,B=null){this.protocol=A,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=B}getChannel(A){const B=this;return{call(T,U,N){return B.isDisposed?Promise.reject(y.canceled()):B.requestPromise(A,T,U,N)},listen(T,U){return B.isDisposed?l.Event.None:B.requestEvent(A,T,U)}}}requestPromise(A,B,T,U=L.CancellationToken.None){const N=this.lastRequestId++,O={id:N,type:100,channelName:A,name:B,arg:T};if(U.isCancellationRequested)return Promise.reject(y.canceled());let F;return new Promise((_,J)=>{if(U.isCancellationRequested)return J(y.canceled());const te=()=>{const ve=re=>{switch(re.type){case 201:this.handlers.delete(N),_(re.data);break;case 202:{this.handlers.delete(N);const ae=new Error(re.data.message);ae.stack=re.data.stack,ae.name=re.data.name,J(ae);break}case 203:this.handlers.delete(N),J(re.data);break}};this.handlers.set(N,ve),this.sendRequest(O)};let le=null;this.state===f.Idle?te():(le=(0,I.createCancelablePromise)(ve=>this.whenInitialized()),le.then(()=>{le=null,te()}));const ue=()=>{le?(le.cancel(),le=null):this.sendRequest({id:N,type:101}),J(y.canceled())},pe=U.onCancellationRequested(ue);F=(0,d.combinedDisposable)((0,d.toDisposable)(ue),pe),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(A,B,T){const U=this.lastRequestId++,$={id:U,type:102,channelName:A,name:B,arg:T};let O=null;const F=new l.Emitter({onFirstListenerAdd:()=>{O=(0,I.createCancelablePromise)(_=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(F),this.sendRequest($)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(F),this.sendRequest({id:U,type:103}))}}),W=_=>F.fire(_.data);return this.handlers.set(U,W),F.event}sendRequest(A){switch(A.type){case 100:case 102:{const B=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(B,A.id,0,`${u(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const B=this.send([A.type,A.id]);this.logger?.logOutgoing(B,A.id,0,u(A.type));return}}}send(A,B=void 0){const T=new v;return o(T,A),o(T,B),this.sendBuffer(T.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const B=new c(A),T=h(B),U=h(B),N=T[0];switch(N){case 200:return this.logger?.logIncoming(A.byteLength,0,0,E(N)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,T[1],0,E(N),U),this.onResponse({type:T[0],id:T[1],data:U})}}onResponse(A){if(A.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([k.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class M{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:B,onDidClientDisconnect:T})=>{l.Event.once(B.onMessage)(N=>{const $=new c(N),O=h($),F=new p(B,O),W=new R(B);this.channels.forEach((J,te)=>F.registerChannel(te,J));const _={channelServer:F,channelClient:W,ctx:O};this._connections.add(_),this._onDidAddConnection.fire(_),T(()=>{F.dispose(),W.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}get connections(){const A=[];return this._connections.forEach(B=>A.push(B)),A}getChannel(A,B){const T=this;return{call(U,N,$){let O;if((0,m.isFunction)(B)){const W=(0,C.getRandomElement)(T.connections.filter(B));O=W?Promise.resolve(W):l.Event.toPromise(l.Event.filter(T.onDidAddConnection,B))}else O=B.routeCall(T,U,N);const F=O.then(W=>W.channelClient.getChannel(A));return Z(F).call(U,N,$)},listen(U,N){if((0,m.isFunction)(B))return T.getMulticastEvent(A,B,U,N);const $=B.routeEvent(T,U,N).then(O=>O.channelClient.getChannel(A));return Z($).listen(U,N)}}}getMulticastEvent(A,B,T,U){const N=this;let $=new d.DisposableStore;const O=new l.Emitter({onFirstListenerAdd:()=>{$=new d.DisposableStore;const F=new l.EventMultiplexer,W=new Map,_=te=>{const ue=te.channelClient.getChannel(A).listen(T,U),pe=F.add(ue);W.set(te,pe)},J=te=>{const le=W.get(te);!le||(le.dispose(),W.delete(te))};N.connections.filter(B).forEach(_),l.Event.filter(N.onDidAddConnection,B)(_,void 0,$),N.onDidRemoveConnection(J,void 0,$),F.event(O.fire,O,$),$.add(F)},onLastListenerRemove:()=>{$.dispose()}});return O.event}registerChannel(A,B){this.channels.set(A,B),this._connections.forEach(T=>{T.channelServer.registerChannel(A,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=M;class H{constructor(A,B,T=null){const U=new v;o(U,B),A.send(U.buffer),this.channelClient=new R(A,T),this.channelServer=new p(A,B,T)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,B){this.channelServer.registerChannel(A,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=H;function Z(z){return{call(A,B,T){return z.then(U=>U.call(A,B,T))},listen(A,B){const T=new l.Relay;return z.then(U=>T.input=U.listen(A,B)),T.event}}}e.getDelayedChannel=Z;function ne(z){let A=!1;return{call(B,T,U){return A?z.call(B,T,U):(0,I.timeout)(0).then(()=>A=!0).then(()=>z.call(B,T,U))},listen(B,T){if(A)return z.listen(B,T);const U=new l.Relay;return(0,I.timeout)(0).then(()=>A=!0).then(()=>U.input=z.listen(B,T)),U.event}}}e.getNextTickChannel=ne;class Q{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const B of A.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=Q;var oe;(function(z){function A(N,$){const O=N,F=$&&$.disableMarshalling,W=new Map;for(const _ in O)T(_)&&W.set(_,l.Event.buffer(O[_],!0));return new class{listen(_,J,te){const le=W.get(J);if(le)return le;if(U(J)){const ue=O[J];if(typeof ue=="function")return ue.call(O,te)}throw new Error(`Event not found: ${J}`)}call(_,J,te){const le=O[J];if(typeof le=="function"){if(!F&&Array.isArray(te))for(let ue=0;ue<te.length;ue++)te[ue]=(0,D.revive)(te[ue]);return le.apply(O,te)}throw new Error(`Method not found: ${J}`)}}}z.fromService=A;function B(N,$){const O=$&&$.disableMarshalling;return new Proxy({},{get(F,W){if(typeof W=="string")return $?.properties?.has(W)?$.properties.get(W):U(W)?function(_){return N.listen(W,_)}:T(W)?N.listen(W):async function(..._){let J;$&&!(0,m.isUndefinedOrNull)($.context)?J=[$.context,..._]:J=_;const te=await N.call(W,J);return O?te:(0,D.revive)(te)};throw new Error(`Property not found: ${String(W)}`)}})}z.toService=B;function T(N){return N[0]==="o"&&N[1]==="n"&&b.isUpperAsciiLetter(N.charCodeAt(2))}function U(N){return/^onDynamic/.test(N)&&b.isUpperAsciiLetter(N.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const A=z.toString();if(A!=="[object Object]")return A}return z}function x(z){return Array.isArray(z)?z.map(ce):ce(z)}function j(z,A,B,T,U,N,$){$=x($);const O=Y[U],F=O[T%O.length];let W=[`%c[${z}]%c[${String(A).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(N)?(W=W.concat($),W.push(")")):W.push($),console.log.apply(console,W)}e.logWithColors=j;class K{constructor(A,B){this._outgoingPrefix=A,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,B,T,U,N){this._totalOutgoing+=A,j(this._outgoingPrefix,this._totalOutgoing,A,B,T,U,N)}logIncoming(A,B,T,U,N){this._totalIncoming+=A,j(this._incomingPrefix,this._totalIncoming,A,B,T,U,N)}}e.IPCLogger=K}),define(ee[77],ie([0,1,4,3,2,7]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function y(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var l;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(l=e.StorageState||(e.StorageState={}));class d extends w.Disposable{constructor(m,P=Object.create(null)){super();this.database=m,this.options=P,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((P,u)=>this.accept(u,P)),m.deleted?.forEach(P=>this.accept(P,void 0))}accept(m,P){if(this.state===l.Closed)return;let u=!1;(0,L.isUndefinedOrNull)(P)?u=this.cache.delete(m):this.cache.get(m)!==P&&(this.cache.set(m,P),u=!0),u&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,P){const u=this.cache.get(m);return(0,L.isUndefinedOrNull)(u)?P:u}getBoolean(m,P){const u=this.get(m);return(0,L.isUndefinedOrNull)(u)?P:u==="true"}getNumber(m,P){const u=this.get(m);return(0,L.isUndefinedOrNull)(u)?P:parseInt(u,10)}async set(m,P){if(this.state===l.Closed)return;if((0,L.isUndefinedOrNull)(P))return this.delete(m);const u=String(P);if(this.cache.get(m)!==u)return this.cache.set(m,u),this.pendingInserts.set(m,u),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===l.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((P,u)=>this.items.set(u,P)),m.delete?.forEach(P=>this.items.delete(P))}async close(){}}e.InMemoryStorageDatabase=D}),define(ee[78],ie([5,6]),function(q,e){return q.create("vs/base/node/processes",e)}),define(ee[57],ie([0,1,45,79,16,25,14,13,31,52,7,69,20,78]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function u(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(s,t){if(y.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const i=C.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(r=>{i.once("error",o=>{r({success:!1,error:o})}),i.once("exit",(o,h)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?u(n.status):1})}else if(y.isLinux||y.isMacintosh)try{const n=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(i=>{C.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,h)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function E(s=l.env){return s.comspec||"cmd.exe"}e.getWindowsShell=E;class f{constructor(t,n,i,r){if(n!==void 0&&i!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=i,this.options=r;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(l.env).forEach(h=>{o[h]=l.env[h]}),Object.keys(this.options.env).forEach(h=>{o[h]=this.options.env[h]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(k.sep);return n!==-1&&(t=t.substring(n+1)),f.WellKnowCommands[t]?t:"other"}start(t){return y.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(n=>{let i,r;const o=new Promise((h,p)=>{i=h,r=p});if(n){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=C.exec(h,this.options,(p,S,R)=>{this.childProcess=null;const M=p;M&&M.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:R.toString()}):this.handleExec(i,t,p,S,R)})}else{let h=null;const p=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,i,t,r);const R={terminated:this.terminateRequested};D.isNumber(S)&&(R.cmdCode=S),i(R)};if(this.shell&&y.isWindows){const S=L.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let R=!1,M=!1;const H=[];let Z=this.ensureQuotes(this.cmd);H.push(Z.value),R=Z.quoted,this.args&&this.args.forEach(Q=>{Z=this.ensureQuotes(Q),H.push(Z.value),M=M&&Z.quoted});const ne=["/s","/c"];R?M?ne.push('"'+H.join(" ")+'"'):H.length>1?ne.push('"'+H[0]+'" '+H.slice(1).join(" ")):ne.push('"'+H[0]+'"'):ne.push(H.join(" ")),h=C.spawn(E(),ne,S)}else this.cmd&&(h=C.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(D.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),h.pid&&(this.childProcess.on("close",p),this.handleSpawn(h,i,t,r,!0)))}return o})}handleClose(t,n,i,r){}ensureQuotes(t){return f.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,g(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!y.isWindows)return t(!1);const n=C.spawn(E(),["/s","/c"]);n.on("error",i=>t(!0)),n.on("exit",i=>t(!1))})}}e.AbstractProcess=f,f.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},f.regexp=/^[^"].* .*[^"]/;class c extends f{constructor(t,n,i,r){super(t,n,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,i,r,o){[r,o].forEach((h,p)=>{const S=new b.LineDecoder;S.write(h).forEach(H=>{n({line:H,source:p===0?0:1})});const M=S.end();M&&n({line:M,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:i})}handleSpawn(t,n,i,r,o){const h=new b.LineDecoder,p=new b.LineDecoder;t.stdout.on("data",S=>{h.write(S).forEach(M=>i({line:M,source:0}))}),t.stderr.on("data",S=>{p.write(S).forEach(M=>i({line:M,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=p}handleClose(t,n,i,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&i({line:h,source:1})}}e.LineProcess=c;function v(s){let t=[],n=!1;const i=function(r){if(n){t.push(r);return}(!s.send(r,h=>{if(h&&console.error(h),n=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(S=>i(S))}})||y.isWindows)&&(n=!0)};return{send:i}}e.createQueuedSender=v;var a;(function(s){async function t(n,i,r){if(k.isAbsolute(n))return n;if(i===void 0&&(i=l.cwd()),k.dirname(n)!=="."||(r===void 0&&D.isString(l.env.PATH)&&(r=l.env.PATH.split(k.delimiter)),r===void 0||r.length===0))return k.join(i,n);async function h(p){if(await m.Promises.exists(p)){let S;try{S=await m.Promises.stat(p)}catch(R){R.message.startsWith("EACCES")&&(S=await m.Promises.lstat(p))}return S?!S.isDirectory():!1}return!1}for(const p of r){let S;if(k.isAbsolute(p)?S=k.join(p,n):S=k.join(i,p,n),await h(S))return S;let R=S+".com";if(await h(R)||(R=S+".exe",await h(R)))return R}return k.join(i,n)}s.findExecutable=t})(a=e.win32||(e.win32={}))}),define(ee[80],ie([0,1,39,13,76,57]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(P,u){return P===1?I.isWindows?b():L.getWindowsShell(u):d(P,u)}e.getSystemShell=k;function y(P,u){return P===1?I.isWindows?m(u):L.getWindowsShell(u):d(P,u)}e.getSystemShellSync=y;let l=null;function d(P,u){if(I.isLinux&&P===2||I.isMacintosh&&P===3)return"/bin/bash";if(!l){let g;if(I.isWindows)g="/bin/bash";else{if(g=u.SHELL,!g)try{g=(0,C.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}l=g}return l}let D=null;async function b(){return D||(D=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),D}function m(P){if(D)return D;const u=I.isWindows&&parseFloat((0,C.release)())>=10,g=P.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${P.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?E:L.getWindowsShell(P)}}),define(ee[81],ie([0,1,45,4,15,26,75,12,3,2,25,57,52,56]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends P.ChannelServer{constructor(f){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",c=>w.VSBuffer.wrap(Buffer.from(c,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=u;class g{constructor(f,c){this.modulePath=f,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new I.Delayer(v),this.child=null,this._client=null}getChannel(f){const c=this;return{call(v,a,s){return c.requestPromise(f,v,a,s)},listen(v,a){return c.requestEvent(f,v,a)}}}requestPromise(f,c,v,a=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(f),t=(0,I.createCancelablePromise)(r=>s.call(c,v,r)),n=a.onCancellationRequested(()=>t.cancel()),i=(0,d.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(f,c,v){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let a;const s=new l.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(f).listen(c,v)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(c.env),this.child=(0,C.fork)(this.modulePath,f,c);const v=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,k.isRemoteConsoleLog)(o)){(0,k.log)(o,`IPC Library: ${this.options.serverName}`);return}v.fire(w.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=v.event,i={send:t,onMessage:n};this._client=new P.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,h)=>{process.removeListener("exit",r),this.activeRequests.forEach(p=>(0,d.dispose)(p)),this.activeRequests.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+h),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:h})})}return this._client}getCachedChannel(f){let c=this.channels.get(f);return c||(c=this.client.getChannel(f),this.channels.set(f,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(ee[82],ie([5,6]),function(q,e){return q.create("vs/base/node/zip",e)}),define(ee[83],ie([5,6]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[84],ie([5,6]),function(q,e){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ee[85],ie([5,6]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[86],ie([5,6]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ee[87],ie([5,6]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[88],ie([5,6]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ee[89],ie([5,6]),function(q,e){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ee[90],ie([5,6]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[91],ie([5,6]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(ee[92],ie([5,6]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(ee[93],ie([5,6]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[94],ie([5,6]),function(q,e){return q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ee[95],ie([5,6]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(ee[96],ie([5,6]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(ee[97],ie([5,6]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[98],ie([5,6]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[99],ie([5,6]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(ee[100],ie([0,1,71,50,16,14,31,17,9]),function(q,e,C,I,w,L,k,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class d{constructor(g,E,f){this._args=g,this.paths=E,this.productService=f,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(w.FileAccess.asFileUri("",q).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(l.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=k.env.VSCODE_PORTABLE;return g?l.URI.file((0,L.join)(g,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,L.resolve)(g):(0,L.normalize)((0,L.join)(w.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,L.resolve)(g):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,L.resolve)(g);const E=k.env.VSCODE_EXTENSIONS;if(E)return E;const f=k.env.VSCODE_PORTABLE;return f?(0,L.join)(f,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(E=>/^[^:/?#]+?:\/\//.test(E)?l.URI.parse(E):l.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,L.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,y.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=k.env.VSCODE_PORTABLE;return g?l.URI.file((0,L.join)(g,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}de([I.memoize],d.prototype,"appRoot",null),de([I.memoize],d.prototype,"userHome",null),de([I.memoize],d.prototype,"userDataPath",null),de([I.memoize],d.prototype,"appSettingsHome",null),de([I.memoize],d.prototype,"tmpDir",null),de([I.memoize],d.prototype,"cacheHome",null),de([I.memoize],d.prototype,"stateResource",null),de([I.memoize],d.prototype,"userRoamingDataHome",null),de([I.memoize],d.prototype,"userDataSyncHome",null),de([I.memoize],d.prototype,"userDataSyncLogResource",null),de([I.memoize],d.prototype,"editSessionsLogResource",null),de([I.memoize],d.prototype,"sync",null),de([I.memoize],d.prototype,"machineSettingsResource",null),de([I.memoize],d.prototype,"workspaceStorageHome",null),de([I.memoize],d.prototype,"localHistoryHome",null),de([I.memoize],d.prototype,"keyboardLayoutResource",null),de([I.memoize],d.prototype,"argvResource",null),de([I.memoize],d.prototype,"isExtensionDevelopment",null),de([I.memoize],d.prototype,"untitledWorkspacesHome",null),de([I.memoize],d.prototype,"installSourcePath",null),de([I.memoize],d.prototype,"builtinExtensionsPath",null),de([I.memoize],d.prototype,"extensionsPath",null),de([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([I.memoize],d.prototype,"extensionDevelopmentKind",null),de([I.memoize],d.prototype,"extensionTestsLocationURI",null),de([I.memoize],d.prototype,"debugExtensionHost",null),de([I.memoize],d.prototype,"serviceMachineIdResource",null),de([I.memoize],d.prototype,"telemetryLogResource",null),de([I.memoize],d.prototype,"disableWorkspaceTrust",null),de([I.memoize],d.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=d;function D(u,g){return P(u["inspect-extensions"],u["inspect-brk-extensions"],5870,g,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=D;function b(u,g){return P(u["inspect-search"],u["inspect-brk-search"],5876,g,u.extensionEnvironment)}e.parseSearchPort=b;function m(u,g){return P(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,g,u.extensionEnvironment)}e.parsePtyHostPort=m;function P(u,g,E,f,c,v){const s=Number(g||u)||(f?null:E),t=s?Boolean(!!g):!1;let n;if(v)try{n=JSON.parse(v)}catch{}return{port:s,break:t,debugId:c,env:n}}}),function(){"use strict";function q(e,C,I,w){function L(y){const l=k(y),d=[l];return e.isAbsolute(l)||d.unshift(w),e.resolve(...d)}function k(y){const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,I);const D=y["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(b,"AppData","Roaming")}break;case"darwin":d=e.join(C.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,I)}return{getUserDataPath:L}}if(typeof define=="function")define(ee[101],ie([0,150,39,16,17,31]),function(e,C,I,w,L,k){const y=L.dirname(w.FileAccess.asFileUri("",e)),l=e.__$__nodeRequire(L.joinPath(y,"package.json").fsPath);return q(C,I,l.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),C=require("path"),I=require("os");module.exports=q(C,I,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[102],ie([0,1,39,100,101]),function(q,e,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends I.AbstractNativeEnvironmentService{constructor(y,l){super(y,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,w.getUserDataPath)(y)},l)}}e.NativeEnvironmentService=L}),define(ee[46],ie([0,1,17,55,90,40]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function l(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=l;function d(f){if(!l(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=f.match(k);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=d;function D(f){if(!f)return null;const c=f.majorBase,v=f.majorMustEqual,a=f.minorBase;let s=f.minorMustEqual;const t=f.patchBase;let n=f.patchMustEqual;f.hasCaret&&(c===0||(s=!1),n=!1);let i=0;if(f.preRelease){const r=y.exec(f.preRelease);if(r){const[,o,h,p]=r;i=Date.UTC(Number(o),Number(h)-1,Number(p))}}return{majorBase:c,majorMustEqual:v,minorBase:a,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=D;function b(f,c,v){let a;typeof f=="string"?a=D(d(f)):a=f;let s;c instanceof Date?s=c.getTime():typeof c=="string"&&(s=new Date(c).getTime());let t;if(typeof v=="string"?t=D(d(v)):t=v,!a||!t)return!1;const n=a.majorBase,i=a.minorBase,r=a.patchBase;let o=t.majorBase,h=t.minorBase,p=t.patchBase;const S=t.notBefore;let R=t.majorMustEqual,M=t.minorMustEqual,H=t.patchMustEqual;return t.isMinimum?n>o?!0:n<o?!1:i>h?!0:i<h||s&&s<S?!1:r>=p:(n===1&&o===0&&(!R||!M||!H)&&(o=1,h=0,p=0,R=!0,M=!1,H=!1),n<o?!1:n>o?!R:i<h?!1:i>h?!M:r<p?!1:r>p?!H:!(s&&s<S))}e.isValidVersion=b;function m(f,c,v,a,s){const t=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return t.push([I.default.Error,w.localize(0,null)]),t;if(typeof a.name!="string")return t.push([I.default.Error,w.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([I.default.Error,w.localize(2,null,"version")]),t;if(!a.engines)return t.push([I.default.Error,w.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([I.default.Error,w.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies!="undefined"&&!E(a.extensionDependencies))return t.push([I.default.Error,w.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents!="undefined"){if(!E(a.activationEvents))return t.push([I.default.Error,w.localize(6,null,"activationEvents")]),t;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return t.push([I.default.Error,w.localize(7,null,"activationEvents","main")]),t}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&t.push([I.default.Warning,w.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return t.push([I.default.Error,w.localize(9,null,"main")]),t;{const r=(0,C.joinPath)(v,a.main);(0,C.isEqualOrParent)(r,v)||t.push([I.default.Warning,w.localize(10,null,r.path,v.path)])}if(typeof a.activationEvents=="undefined")return t.push([I.default.Error,w.localize(11,null,"activationEvents","main")]),t}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return t.push([I.default.Error,w.localize(12,null,"browser")]),t;{const r=(0,C.joinPath)(v,a.browser);(0,C.isEqualOrParent)(r,v)||t.push([I.default.Warning,w.localize(13,null,r.path,v.path)])}if(typeof a.activationEvents=="undefined")return t.push([I.default.Error,w.localize(14,null,"activationEvents","browser")]),t}if(!L.valid(a.version))return t.push([I.default.Error,w.localize(15,null)]),t;const n=[];if(!P(f,c,a,s,n))for(const r of n)t.push([I.default.Error,r]);return t}e.validateExtensionManifest=m;function P(f,c,v,a,s){return a||typeof v.main=="undefined"&&typeof v.browser=="undefined"?!0:g(f,c,v.engines.vscode,s)}e.isValidExtensionVersion=P;function u(f,c,v){return f==="*"||g(c,v,f)}e.isEngineValid=u;function g(f,c,v,a=[]){const s=D(d(v));if(!s)return a.push(w.localize(16,null,v)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return a.push(w.localize(17,null,v)),!1}else if(!s.majorMustEqual)return a.push(w.localize(18,null,v)),!1;return b(f,c,s)?!0:(a.push(w.localize(19,null,f,v)),!1)}function E(f){if(!Array.isArray(f))return!1;for(let c=0,v=f.length;c<v;c++)if(typeof f[c]!="string")return!1;return!0}}),define(ee[103],ie([0,1,15,34]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function w(L,k,y){let l=y&&y.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const D=(await k.readFile(L.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(D)?D:null}catch{l=null}if(!l){l=(0,I.generateUuid)();try{await k.writeFile(L.serviceMachineIdResource,C.VSBuffer.fromString(l))}catch{}}return y?.store("storage.serviceMachineId",l,-1,1),l}e.getServiceMachineId=w}),define(ee[47],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(w,L=[],k=!1){this.ctor=w,this.staticArguments=L,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=C}),define(ee[104],ie([0,1,47]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function w(k,y,l){y instanceof C.SyncDescriptor||(y=new C.SyncDescriptor(y,[],l)),I.push([k,y])}e.registerSingleton=w;function L(){return I}e.getSingletonServiceDescriptors=L}),define(ee[105],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=C;class I{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const k of this._nodes.values())k.outgoing.size===0&&L.push(k);return L}insertEdge(L,k){const y=this.lookupOrInsertNode(L),l=this.lookupOrInsertNode(k);y.outgoing.set(this._hashFn(k),l),l.incoming.set(this._hashFn(L),y)}removeNode(L){const k=this._hashFn(L);this._nodes.delete(k);for(const y of this._nodes.values())y.outgoing.delete(k),y.incoming.delete(k)}lookupOrInsertNode(L){const k=this._hashFn(L);let y=this._nodes.get(k);return y||(y=new C(L),this._nodes.set(k,y)),y}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[k,y]of this._nodes)L.push(`${k}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,k]of this._nodes){const y=new Set([L]),l=this._findCycle(k,y);if(l)return l}}_findCycle(L,k){for(const[y,l]of L.outgoing){if(k.has(y))return[...k,y].join(" -> ");k.add(y);const d=this._findCycle(l,k);if(d)return d;k.delete(y)}}}e.Graph=I}),define(ee[21],ie([0,1,7,9,10]),function(q,e,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof I.URI)}e.isConfigurationOverrides=L;function k(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||C.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=k;var y;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function l(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=l;function d(f,c){const v=Object.create(null);for(const a in f)D(v,a,f[a],c);return v}e.toValuesTree=d;function D(f,c,v,a){const s=c.split("."),t=s.pop();let n=f;for(let i=0;i<s.length;i++){const r=s[i];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${c} as ${s.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[t]=v}catch{a(`Ignoring ${c} as ${s.join(".")} is ${JSON.stringify(n)}`)}else a(`Ignoring ${c} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=D;function b(f,c){const v=c.split(".");m(f,v)}e.removeFromValueTree=b;function m(f,c){const v=c.shift();if(c.length===0){delete f[v];return}if(Object.keys(f).indexOf(v)!==-1){const a=f[v];typeof a=="object"&&!Array.isArray(a)&&(m(a,c),Object.keys(a).length===0&&delete f[v])}}function P(f,c,v){function a(n,i){let r=n;for(const o of i){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=c.split("."),t=a(f,s);return typeof t=="undefined"?v:t}e.getConfigurationValue=P;function u(f,c,v){Object.keys(c).forEach(a=>{a!=="__proto__"&&(a in f?C.isObject(f[a])&&C.isObject(c[a])?u(f[a],c[a],v):v&&(f[a]=c[a]):f[a]=c[a])})}e.merge=u;function g(f,c,v){const a=f.inspect(c),s=f.inspect(v);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:a.defaultValue}e.getMigratedSettingValue=g;function E(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(ee[58],ie([0,1,10]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,C.createDecorator)("downloadService")}),define(ee[18],ie([0,1,10]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[22],ie([0,1,85,10]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function L(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function k(f,c){switch(f){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function y(f,c){return c==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function l(f,c,v){return y(c,v)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===v?!0:d(v).includes(f)}e.isTargetPlatformCompatible=l;function d(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D;var b;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var P;(function(f){f.Install="install",f.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var u;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var g;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(c,v){super(c);this.code=v,this.name=v}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,I.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,C.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ee[59],ie([0,1,15,12,92,11]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(D,b,m,P,u,g){let E;try{await y(D,b,m,P,u,g)}catch(f){E=f}finally{E&&u.errorTransformer&&(E=u.errorTransformer(E)),typeof E!="undefined"&&m.error(E),m.end()}}e.readFileIntoStream=k;async function y(D,b,m,P,u,g){l(g);const E=await D.open(b,{create:!1});try{l(g);let f=0,c=0,v=u&&typeof u.length=="number"?u.length:void 0,a=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof v=="number"?v:u.bufferSize)),s=u&&typeof u.position=="number"?u.position:0,t=0;do c=await D.read(E,s,a.buffer,t,a.byteLength-t),s+=c,t+=c,f+=c,typeof v=="number"&&(v-=c),t===a.byteLength&&(await m.write(P(a)),a=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof v=="number"?v:u.bufferSize)),t=0);while(c>0&&(typeof v!="number"||v>0)&&l(g)&&d(f,u));if(t>0){let n=t;typeof v=="number"&&(n=Math.min(t,v)),m.write(P(a.slice(0,n)))}}catch(f){throw(0,L.ensureFileSystemProviderError)(f)}finally{await D.close(E)}}function l(D){if(D.isCancellationRequested)throw(0,I.canceled)();return!0}function d(D,b){if(b?.limits){if(typeof b.limits.memory=="number"&&D>b.limits.memory)throw(0,L.createFileSystemProviderError)((0,w.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&D>b.limits.size)throw(0,L.createFileSystemProviderError)((0,w.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[106],ie([0,1,3,151,2,13,152]),function(q,e,C,I,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends w.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const D=this.normalizeRequests(d),b=D.filter(P=>{const u=this.watchers.get(P.path);return u?!(0,I.patternsEquals)(u.request.excludes,P.excludes)||!(0,I.patternsEquals)(u.request.includes,P.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:P})=>!D.find(u=>u.path===P.path&&(0,I.patternsEquals)(u.excludes,P.excludes)&&(0,I.patternsEquals)(u.includes,P.includes))).map(({request:P})=>P.path);b.length&&this.trace(`Request to start watching: ${b.map(P=>`${P.path} (excludes: ${P.excludes.length>0?P.excludes:"<none>"}, includes: ${P.includes&&P.includes.length>0?JSON.stringify(P.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const P of m)this.stopWatching(P);for(const P of b)this.startWatching(P)}startWatching(d){const D=new k.NodeJSFileWatcherLibrary(d,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),b={request:d,instance:D};this.watchers.set(d.path,b)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const D=this.watchers.get(d);D&&(this.watchers.delete(d),D.instance.dispose())}normalizeRequests(d){const D=new Map;for(const b of d){const m=L.isLinux?b.path:b.path.toLowerCase();D.set(m,b)}return Array.from(D.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,D]of this.watchers)D.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,D){return D?`[File Watcher (node.js)] ${d} (path: ${D.request.path})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=y}),define(ee[107],ie([0,1,60,106]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class w extends C.AbstractNonRecursiveWatcherClient{constructor(k,y,l){super(k,y,l);this.init()}createWatcher(){return new I.NodeJSWatcher}}e.NodeJSWatcherClient=w}),define(ee[108],ie([0,1,16,56,81,60]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends L.AbstractUniversalWatcherClient{constructor(l,d,D){super(l,d,D);this.init()}createWatcher(l){const d=l.add(new w.Client(C.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(d.onDidProcessExit(({code:D,signal:b})=>this.onError(`terminated by itself with code ${D}, signal: ${b}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ee[61],ie([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...w){this._entries=new Map;for(const[L,k]of w)this.set(L,k)}set(w,L){const k=this._entries.get(w);return this._entries.set(w,L),k}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=C}),define(ee[109],ie([0,1,4,12,47,105,10,61]),function(q,e,C,I,w,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const l=!1;class d extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class D{constructor(u=new y.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=u,this._strict=g,this._parent=E,this._services.set(k.IInstantiationService,this)}createChild(u){return new D(u,this._strict,this)}invokeFunction(u,...g){const E=m.traceInvocation(u);let f=!1;try{return u({get:v=>{if(f)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(v,E);if(!a)throw new Error(`[invokeFunction] unknown service '${v}'`);return a}},...g)}finally{f=!0,E.stop()}}createInstance(u,...g){let E,f;return u instanceof w.SyncDescriptor?(E=m.traceCreation(u.ctor),f=this._createInstance(u.ctor,u.staticArguments.concat(g),E)):(E=m.traceCreation(u),f=this._createInstance(u,g,E)),E.stop(),f}_createInstance(u,g=[],E){const f=k._util.getServiceDependencies(u).sort((a,s)=>a.index-s.index),c=[];for(const a of f){const s=this._getOrCreateServiceInstance(a.id,E);s||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${a.id}.`,!1),c.push(s)}const v=f.length>0?f[0].index:g.length;if(g.length!==v){console.trace(`[createInstance] First service dependency of ${u.name} at position ${v+1} conflicts with ${g.length} static arguments`);const a=v-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,v)}return new u(...[...g,...c])}_setServiceInstance(u,g){if(this._services.get(u)instanceof w.SyncDescriptor)this._services.set(u,g);else if(this._parent)this._parent._setServiceInstance(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const g=this._services.get(u);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):g}_getOrCreateServiceInstance(u,g){const E=this._getServiceInstanceOrDescriptor(u);return E instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,E,g.branch(u,!0)):(g.branch(u,!1),E)}_safeCreateAndCacheServiceInstance(u,g,E){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,g,E)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,g,E){const f=new L.Graph(a=>a.id.toString());let c=0;const v=[{id:u,desc:g,_trace:E}];for(;v.length;){const a=v.pop();if(f.lookupOrInsertNode(a),c++>1e3)throw new d(f);for(const s of k._util.getServiceDependencies(a.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),t instanceof w.SyncDescriptor){const n={id:s.id,desc:t,_trace:a._trace.branch(s.id,!0)};f.insertEdge(a,n),v.push(n)}}}for(;;){const a=f.roots();if(a.length===0){if(!f.isEmpty())throw new d(f);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}f.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,g,E=[],f,c){if(this._services.get(u)instanceof w.SyncDescriptor)return this._createServiceInstance(g,E,f,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,g,E,f,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(u,g=[],E,f){if(E){const c=new C.IdleValue(()=>this._createInstance(u,g,f));return new Proxy(Object.create(null),{get(v,a){if(a in v)return v[a];const s=c.value;let t=s[a];return typeof t!="function"||(t=t.bind(s),v[a]=t),t},set(v,a,s){return c.value[a]=s,!0}})}else return this._createInstance(u,g,f)}_throwIfStrict(u,g){if(g&&console.warn(g),this._strict)throw new Error(u)}}e.InstantiationService=D;var b;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(b||(b={}));class m{constructor(u,g){this.type=u,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new m(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(u){return l?new m(0,u.name):m._None}branch(u,g){const E=new m(2,u.toString());return this._dep.push([u,g,E]),E}stop(){const u=Date.now()-this._start;m._totals+=u;let g=!1;function E(c,v){const a=[],s=new Array(c+1).join("	");for(const[t,n,i]of v._dep)if(n&&i){g=!0,a.push(`${s}CREATES -> ${t}`);const r=E(c+1,i);r&&a.push(r)}else a.push(`${s}uses -> ${t}`);return a.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(u>2||g)&&console.log(f.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0});var se=this&&this.__param||function(q,e){return function(C,I){e(C,I,q)}};define(ee[62],ie([0,1,26,2,13,94,22,10]),function(q,e,C,I,w,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,y.createDecorator)("languagePackService");let l=class extends I.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new C.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const P=b.firstPage.filter(u=>u.properties.localizedLanguages?.length&&u.tags.some(g=>g.startsWith("lp-"))).map(u=>{const g=u.properties.localizedLanguages?.[0],E=u.tags.find(c=>c.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:E,label:g}),extensionId:u.identifier.id,galleryExtension:u}});return P.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),P}createQuickPickItem(D){const b=D.label??D.locale;let m=D.locale!==D.label?D.locale:void 0;return D.locale.toLowerCase()===w.language.toLowerCase()&&(m||(m=""),m+=(0,L.localize)(0,null)),{id:D.locale,label:b,description:m}}};l=de([se(0,k.IExtensionGalleryService)],l),e.LanguagePackBaseService=l}),define(ee[8],ie([0,1,29,3,2,13,10]),function(q,e,C,I,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function y(){return new Date().toISOString()}var l;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function d(n,i,r){switch(i){case l.Trace:n.trace(r);break;case l.Debug:n.debug(r);break;case l.Info:n.info(r);break;case l.Warning:n.warn(r);break;case l.Error:n.error(r);break;case l.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}e.log=d;function D(n){let i="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(r>0?" ":"")+o}return i}e.format=D;class b extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class m extends b{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(l.Trace)&&this.log(l.Trace,D([i,...r]))}debug(i,...r){this.checkLogLevel(l.Debug)&&this.log(l.Debug,D([i,...r]))}info(i,...r){this.checkLogLevel(l.Info)&&this.log(l.Info,D([i,...r]))}warn(i,...r){this.checkLogLevel(l.Warning)&&this.log(l.Warning,D([i,...r]))}error(i,...r){if(this.checkLogLevel(l.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(l.Error,D(o))}else this.log(l.Error,D([i,...r]))}critical(i,...r){this.checkLogLevel(l.Critical)&&this.log(l.Critical,D([i,...r]))}flush(){}}e.AbstractMessageLogger=m;class P extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...r){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...r):console.log(`[main ${y()}]`,i,...r))}debug(i,...r){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...r):console.log(`[main ${y()}]`,i,...r))}info(i,...r){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...r):console.log(`[main ${y()}]`,i,...r))}warn(i,...r){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,i,...r):console.warn(`[main ${y()}]`,i,...r))}error(i,...r){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,i,...r):console.error(`[main ${y()}]`,i,...r))}critical(i,...r){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,i,...r):console.error(`[main ${y()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class u extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...r){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=u;class g extends b{constructor(i,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,C.toErrorMessage)(i,this.getLevel()<=l.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class E extends b{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const o of this.logServices)o.trace(i,...r)}debug(i,...r){for(const o of this.logServices)o.debug(i,...r)}info(i,...r){for(const o of this.logServices)o.info(i,...r)}warn(i,...r){for(const o of this.logServices)o.warn(i,...r)}error(i,...r){for(const o of this.logServices)o.error(i,...r)}critical(i,...r){for(const o of this.logServices)o.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=E;class f extends w.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=f;class c extends w.Disposable{constructor(i,r){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,r?.always?l.Trace:this.logLevel,r),this.loggers.set(i.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=c;class v{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(i){}getLevel(){return l.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=v;function a(n){if(n.verbose)return l.Trace;if(typeof n.logLevel=="string"){const i=s(n.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function s(n){switch(n){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}e.parseLogLevel=s;function t(n){switch(n){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}e.LogLevelToString=t}),define(ee[110],ie([0,1,19,4,12,3,2,14,60,8]),function(q,e,C,I,w,L,k,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends k.Disposable{constructor(m,P){super();this.logService=m,this.options=P,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(m,P){return P.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,P):this.watchNonRecursive(m,P)}watchUniversal(m,P){const u={path:this.toFilePath(m),excludes:P.excludes,includes:P.includes,recursive:P.recursive},g=(0,C.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,w.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(P=>this._onDidChangeFile.fire((0,l.toFileChanges)(P)),P=>this.onWatcherLogMessage(P),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const P of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(P)&&(P.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const P of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(P)&&m.includes(P.path)&&(P.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,P){const u={path:this.toFilePath(m),excludes:P.excludes,includes:P.includes,recursive:!1},g=(0,C.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,w.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,l.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,y.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(ee[111],ie([0,1,19,4,15,26,3,54,63,2,35,16,112,17,43,91,11,59,8]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g,E,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends d.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${s}`);const n=new d.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(i=>this._onDidFilesChange.fire(new E.FileChangesEvent(i,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,d.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){t.push(n)}}),!this.provider.has(s)&&await I.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return l.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,P.isAbsolutePath)(s))throw new E.FileOperationError((0,g.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const n=new Error;throw n.name="ENOPRO",n.message=(0,g.localize)(1,null,s.toString()),n}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)||(0,E.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,g.localize)(2,null,this.resourceForError(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async doResolveFile(s,t){const n=await this.withProvider(s),i=this.isPathCaseSensitive(n),r=t?.resolveTo,o=t?.resolveSingleChildDescendants,h=t?.resolveMetadata,p=await n.stat(s);let S;return this.toFileStat(n,s,p,void 0,!!h,(R,M)=>(S||(S=D.TernarySearchTree.forUris(()=>!i),S.set(s,!0),r&&S.fill(!0,r)),S.get(R.resource)||S.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&o?M===1:!1))}async toFileStat(s,t,n,i,r,o){const{providerExtUri:h}=this.getExtUri(s),p={resource:t,name:h.basename(t),isFile:(n.type&E.FileType.File)!=0,isDirectory:(n.type&E.FileType.Directory)!=0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(p.isDirectory&&o(p,i)){try{const S=await s.readdir(t),R=await I.Promises.settled(S.map(async([M,H])=>{try{const Z=h.joinPath(t,M),ne=r?await s.stat(Z):{type:H};return await this.toFileStat(s,Z,ne,S.length,r,o)}catch(Z){return this.logService.trace(Z),null}}));p.children=(0,C.coalesce)(R)}catch(S){this.logService.trace(S),p.children=[]}return p}return p}async resolveAll(s){return I.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),n=await t.stat(s);return this.toFileStat(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(n){return n}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,g.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=w.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const i=await this.writeFile(s,t);return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,i)),i}async writeFile(s,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,s,n)||await this.mkdirp(i,r.dirname(s));let h;if((0,E.hasReadWriteCapability)(i)&&!(t instanceof w.VSBuffer))if((0,u.isReadableStream)(t)){const p=await(0,u.peekStream)(t,3);p.ended?h=w.VSBuffer.concat(p.buffer):h=p}else h=(0,u.peekReadable)(t,p=>w.VSBuffer.concat(p),3);else h=t;!(0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)&&h instanceof w.VSBuffer?await this.doWriteUnbuffered(i,s,n,h):await this.doWriteBuffered(i,s,n,h instanceof w.VSBuffer?(0,w.bufferToReadable)(h):h),this._onDidRunOperation.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,g.localize)(4,null,this.resourceForError(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(t)));let r;try{r=await s.stat(t)}catch{return}if((r.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,g.localize)(6,null,this.resourceForError(t)),0,n);if(this.throwIfFileIsReadonly(t,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,g.localize)(7,null),3,n);return r}async readFile(s,t,n){const i=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(i,s,t,n):this.doReadFile(i,s,t,n)}async doReadFileAtomic(s,t,n,i){return new Promise((r,o)=>{this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{try{const h=await this.doReadFile(s,t,n,i);r(h)}catch(h){o(h)}})})}async doReadFile(s,t,n,i){const r=await this.doReadFileStream(s,t,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,w.streamToBuffer)(r.value)}}async readFileStream(s,t,n){const i=await this.withReadProvider(s);return this.doReadFileStream(i,s,t,n)}async doReadFileStream(s,t,n,i){const r=new L.CancellationTokenSource(i),o=this.validateReadFile(t,n).then(p=>p,p=>{throw r.cancel(),p});let h;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?h=this.readFileUnbuffered(s,t,n):(0,E.hasFileReadStreamCapability)(s)?h=this.readFileStreamed(s,t,r.token,n):h=this.readFileBuffered(s,t,r.token,n),{...await o,value:h}}catch(p){h&&await(0,u.consumeStream)(h);const S=(0,g.localize)(8,null,this.resourceForError(t),(0,E.ensureFileSystemProviderError)(p).toString());throw p instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(S,p.stat,n):new E.FileOperationError(S,(0,E.toFileOperationResult)(p),n)}}readFileStreamed(s,t,n,i=Object.create(null)){const r=s.readFileStream(t,i,n);return(0,u.transform)(r,{data:o=>o instanceof w.VSBuffer?o:w.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,g.localize)(9,null,this.resourceForError(t),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},o=>w.VSBuffer.concat(o))}readFileBuffered(s,t,n,i=Object.create(null)){const r=(0,w.newWriteableBufferStream)();return(0,f.readFileIntoStream)(s,t,r,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new E.FileOperationError((0,g.localize)(10,null,this.resourceForError(t),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},n),r}readFileUnbuffered(s,t,n){const i=(0,u.newWriteableStream)(r=>w.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(t,{atomic:!0}):r=await s.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(t,r.byteLength,n),i.end(w.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,g.localize)(11,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==E.ETAG_DISABLED&&t.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,g.localize)(12,null),n,t);return this.validateReadFileLimits(s,n.size,t),n}validateReadFileLimits(s,t,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&t>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&t>n.limits.size&&(i=7),typeof i=="number")throw new E.FileOperationError((0,g.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,t,n){return this.doCanMoveCopy(s,t,"move",n)}async canCopy(s,t,n){return this.doCanMoveCopy(s,t,"copy",n)}async doCanMoveCopy(s,t,n,i){if(s.toString()!==t.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(r,s,o,t,n,i)}catch(r){return r}return!0}async move(s,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,s,r,t,"move",!!n),h=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="move"?2:3,h)),h}async copy(s,t,n){const i=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,s,r,t,"copy",!!n),h=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="copy"?3:2,h)),h}async doMoveCopy(s,t,n,i,r,o){if(t.toString()===i.toString())return r;const{exists:h,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(s,t,n,i,r,o);if(h&&!p&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(t,i,{overwrite:o});else{const S=await this.resolve(t);S.isDirectory?await this.doCopyFolder(s,S,n,i):await this.doCopyFile(s,t,n,i)}return r}else return s===n?(await s.rename(t,i,{overwrite:o}),r):(await this.doMoveCopy(s,t,n,i,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,n,i){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,t,n,i);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,t,n,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,t,n,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,t,n,i)}async doCopyFolder(s,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await I.Promises.settled(t.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,t,n,i,r,o){let h=!1;if(s===n){const{providerExtUri:S,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(h=S.isEqual(t,i)),h&&r==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(t),this.resourceForError(i)));if(!h&&S.isEqualOrParent(i,t))throw new Error((0,g.localize)(15,null,this.resourceForError(t),this.resourceForError(i)))}const p=await this.exists(i);if(p&&!h){if(!o)throw new E.FileOperationError((0,g.localize)(16,null,this.resourceForError(t),this.resourceForError(i)),4);if(s===n){const{providerExtUri:S}=this.getExtUri(s);if(S.isEqualOrParent(t,i))throw new Error((0,g.localize)(17,null,this.resourceForError(t),this.resourceForError(i)))}}return{exists:p,isSameResourceWithDifferentPathCase:h}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,n)),n}async mkdirp(s,t){const n=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(t,i.dirname(t));)try{if(((await s.stat(t)).type&E.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(t)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(t)),t=i.dirname(t)}for(let r=n.length-1;r>=0;r--){t=i.joinPath(t,n[r]);try{await s.mkdir(t)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(n){return n}return!0}async doValidateDelete(s,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!t?.useTrash&&!(n.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new E.FileOperationError((0,g.localize)(20,null,this.resourceForError(s)),1);if(!!!t?.recursive){const h=await this.resolve(s);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(s)))}return n}async del(s,t){const n=await this.doValidateDelete(s,t),i=!!t?.useTrash,r=!!t?.recursive;await n.delete(s,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.withProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(s,t))return;if(n===i&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,t);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===i&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,t,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,i,t))}watch(s,t={recursive:!1,excludes:[]}){const n=new d.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,t);i?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,t){const n=await this.withProvider(s),i=(0,y.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),t]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:n.watch(s,t)},this.activeWatchers.set(i,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,n,i){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,r,i):await this.doWriteReadableBufferedQueued(s,r,i)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,t,n){let i=0,r;if((0,u.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=w.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,t,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,h)=>{(0,u.listenStream)(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(s,t,p,p.byteLength,i,0)}catch(S){return h(S)}i+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>h(p),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,t,n){let i=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,t,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(s,t,n,i,r,o){let h=0;for(;h<i;)h+=await s.write(t,r+h,n.buffer,o+h,i-h)}async doWriteUnbuffered(s,t,n,i){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,t,n,i))}async doWriteUnbufferedQueued(s,t,n,i){let r;i instanceof w.VSBuffer?r=i:(0,u.isReadableStream)(i)?r=await(0,w.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?r=await(0,w.bufferedStreamToBuffer)(i):r=(0,w.readableToBuffer)(i),await s.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,t,n,i))}async doPipeBufferedQueued(s,t,n,i){let r,o;try{r=await s.open(t,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const h=w.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,S=0,R=0;do R=await s.read(r,p,h.buffer,S,h.byteLength-S),await this.doWriteBuffer(n,o,h,R,p,S),p+=R,S+=R,S===h.byteLength&&(S=0);while(R>0)}catch(h){throw(0,E.ensureFileSystemProviderError)(h)}finally{await I.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,t,n,i))}async doPipeUnbufferedQueued(s,t,n,i){return n.writeFile(i,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,t,n,i))}async doPipeUnbufferedToBufferedQueued(s,t,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(t);await this.doWriteBuffer(n,r,w.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,t,n,i){const r=await(0,w.streamToBuffer)(this.readFileBuffered(s,t,L.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,r)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new E.FileOperationError((0,g.localize)(22,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,g.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString(!0)}};v=de([se(0,c.ILogService)],v),e.FileService=v}),define(ee[113],ie([0,1,114,153,4,35,15,3,79,2,14,13,17,43,20,93,11,59,110,29,108,107]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g,E,f,c,v,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(n)}`)}})();class t extends c.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r);this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new L.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async h=>{try{let p;h.isSymbolicLink()?p=(await this.stat((0,m.joinPath)(i,h.name))).type:p=this.toType(h),o.push([h.name,p])}catch(p){this.logService.trace(p)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let o;return r?.dangling?o=E.FileType.Unknown:i.isFile()?o=E.FileType.File:i.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async createResourceLock(i){const r=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const h=new w.Barrier;return this.resourceLocks.set(i,h),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===h&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),h.open()})}async readFile(i,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const h=this.toFilePath(i);return await u.Promises.readFile(h)}catch(h){throw this.toFileSystemProviderError(h)}finally{o?.dispose()}}readFileStream(i,r,o){const h=(0,P.newWriteableStream)(p=>k.VSBuffer.concat(p.map(S=>k.VSBuffer.wrap(S))).buffer);return(0,f.readFileIntoStream)(this,i,h,p=>p.buffer,{...r,bufferSize:256*1024},o),h}async writeFile(i,r,o){let h;try{const p=this.toFilePath(i);if(!o.create||!o.overwrite){if(await u.Promises.exists(p)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,g.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,g.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(h,0,r,0,r.byteLength)}catch(p){throw await this.toFileSystemProviderWriteError(i,p)}finally{typeof h=="number"&&await this.close(h)}}async open(i,r){const o=this.toFilePath(i);let h;(0,E.isFileOpenForWriteOptions)(r)&&(h=await this.createResourceLock(i));let p;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:R}=await u.SymlinkSupport.stat(o);R.mode&128||await u.Promises.chmod(o,R.mode|128)}catch(R){this.logService.trace(R)}let S;if((0,E.isFileOpenForWriteOptions)(r)){if(b.isWindows)try{await u.Promises.truncate(o,0),S="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}S||(S="w")}else S="r";p=await u.Promises.open(o,S)}catch(S){throw h?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,S):this.toFileSystemProviderError(S)}if(this.mapHandleToPos.set(p,0),(0,E.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(p,i),h){const S=this.mapHandleToLock.get(p);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${p} (${o})`),this.mapHandleToLock.set(p,h),S&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${p} (${o})`),S.dispose())}return p}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await u.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await u.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,o,h,p){const S=this.normalizePos(i,r);let R=null;try{R=(await u.Promises.read(i,o,h,p,S)).bytesRead}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(i,S,R)}return R}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,o){const h=this.mapHandleToPos.get(i);typeof h=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,h+o):this.mapHandleToPos.delete(i)))}async write(i,r,o,h,p){return(0,w.retry)(()=>this.doWrite(i,r,o,h,p),100,3)}async doWrite(i,r,o,h,p){const S=this.normalizePos(i,r);let R=null;try{R=(await u.Promises.write(i,o,h,p,S)).bytesWritten}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),M)}finally{this.updatePos(i,S,R)}return R}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const o=this.toFilePath(i);r.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,r,o){const h=this.toFilePath(i),p=this.toFilePath(r);if(h!==p)try{await this.validateTargetDeleted(i,r,"move",o.overwrite),await u.Promises.move(h,p)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,g.localize)(2,null,(0,D.basename)(h),(0,D.basename)((0,D.dirname)(p)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(i,r,o){const h=this.toFilePath(i),p=this.toFilePath(r);if(h!==p)try{await this.validateTargetDeleted(i,r,"copy",o.overwrite),await u.Promises.copy(h,p,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,g.localize)(3,null,(0,D.basename)(h),(0,D.basename)((0,D.dirname)(p)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(i,r,o,h){const p=this.toFilePath(i),S=this.toFilePath(r);let R=!1;if(!!(this.capabilities&1024)||(R=(0,l.isEqual)(p,S,!0)),R&&o==="copy")throw(0,E.createFileSystemProviderError)((0,g.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!R&&await u.Promises.exists(S)){if(!h)throw(0,E.createFileSystemProviderError)((0,g.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,o){const h=this.toFilePath(i),p=this.toFilePath(r),S=!!(this.capabilities&1024);if((0,l.isEqual)(h,p,!S))return;const R=new d.DisposableStore;try{const[M,H]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);R.add(M),R.add(H),o&&await u.Promises.mkdir((0,D.dirname)(p),{recursive:!0}),await u.Promises.copyFile(h,p)}catch(M){if(M.code==="ENOENT"&&!o)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(M)}finally{R.dispose()}}createUniversalWatcher(i,r,o){return new a.UniversalWatcherClient(h=>i(h),h=>r(h),o)}createNonRecursiveWatcher(i,r,o){return new s.NodeJSWatcherClient(h=>i(h),h=>r(h),o)}toFileSystemProviderError(i){if(i instanceof E.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let o=this.toFileSystemProviderError(r);if(i&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await u.SymlinkSupport.stat(this.toFilePath(i));h.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return o}}e.DiskFileSystemProvider=t}),define(ee[115],ie([0,1,11,8]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function w(y,l,d,D,b){try{const m=await new Promise((u,g)=>{q(["spdlog"],u,g)});m.setFlushOn(I.LogLevel.Trace);const P=await m.createAsyncRotatingLogger(y,l,d,D);return b&&P.clearFormatters(),P}catch(m){console.error(m)}return null}function L(y,l,d){switch(l){case I.LogLevel.Trace:y.trace(d);break;case I.LogLevel.Debug:y.debug(d);break;case I.LogLevel.Info:y.info(d);break;case I.LogLevel.Warning:y.warn(d);break;case I.LogLevel.Error:y.error(d);break;case I.LogLevel.Critical:y.critical(d);break;default:throw new Error("Invalid log level")}}class k extends I.AbstractMessageLogger{constructor(l,d,D,b,m){super();this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(l,d,D,b),this._register(this.onDidChangeLogLevel(P=>{this._logger?.setLevel(P)}))}async _createSpdLogLogger(l,d,D,b){const m=D?6:1,P=30/m*C.ByteSize.MB,u=await w(l,d,P,m,b);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:g,message:E}of this.buffer)L(this._logger,g,E);this.buffer=[]}}log(l,d){this._logger?L(this._logger,l,d):this.getLevel()<=l&&this.buffer.push({level:l,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ee[36],ie([0,1,3,63,2,10]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class k extends w.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),I.Iterable.reduce(this.policies.entries(),(b,[m,P])=>({...b,[m]:P}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return I.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[D,b])=>({...d,[D]:{definition:b,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=k;class y{constructor(){this.onDidChange=C.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(ee[116],ie([0,1,4,3,63,7,11,8,36]),function(q,e,C,I,w,L,k,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function d(b,m){const P=[];for(const u of w.Iterable.concat(b.keys(),m.keys()))b.get(u)!==m.get(u)&&P.push(u);return P}let D=class extends l.AbstractPolicyService{constructor(m,P,u){super();this.file=m,this.fileService=P,this.logService=u,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const g=I.Event.filter(P.onDidFilesChange,E=>E.affects(m));this._register(P.watch(m)),this._register(g(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(m){await this.refresh()}async read(){const m=new Map;try{const P=await this.fileService.readFile(this.file),u=JSON.parse(P.value.toString());if(!(0,L.isObject)(u))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(u))this.policyDefinitions[g]&&m.set(g,u[g])}catch(P){P.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",P)}return m}async refresh(){const m=await this.read(),P=d(this.policies,m);this.policies=m,P.length>0&&this._onDidChange.fire(P)}};D=de([se(1,k.IFileService),se(2,y.ILogService)],D),e.FilePolicyService=D}),define(ee[27],ie([0,1,10]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[32],ie([0,1,67,7]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(k,y){C.ok(I.isString(k)),C.ok(I.isObject(y)),C.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,y)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new w}),define(ee[117],ie([0,1,3,32]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class L{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,d){this.schemasById[w(l)]=d,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new L;I.Registry.add(e.Extensions.JSONContribution,k)}),define(ee[41],ie([0,1,19,3,7,83,21,117,32]),function(q,e,C,I,w,L,k,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=l.Registry.as(y.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const i=this.doRegisterConfigurations(t,n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const n=this.doDeregisterConfigurations(t);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:t,remove:n}){const i=[];i.push(...this.doDeregisterConfigurations(n)),i.push(...this.doRegisterConfigurations(t,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(i)})}registerDefaultConfigurations(t){const n=[],i=[];for(const{overrides:r,source:o}of t)for(const h in r)if(n.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const p=this.configurationDefaultsOverrides.get(h),S=p?.valuesSources??new Map;if(o)for(const Z of Object.keys(r[h]))S.set(Z,o);const R={...p?.value||{},...r[h]};this.configurationDefaultsOverrides.set(h,{source:o,value:R,valuesSources:S});const M=(0,k.getLanguageTagSettingPlainKey)(h),H={type:"object",default:R,description:L.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:w.isString(o)?void 0:o,defaultValueSource:o};i.push(...g(h)),this.configurationProperties[h]=H,this.defaultLanguageConfigurationOverridesNode.properties[h]=H}else{this.configurationDefaultsOverrides.set(h,{value:r[h],source:o});const p=this.configurationProperties[h];p&&(this.updatePropertyDefaultValue(h,p),this.updateSchema(h,p))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const n=[];for(const{overrides:i,source:r}of t)for(const o in i){const h=this.configurationDefaultsOverrides.get(o),p=w.isString(r)?r:r?.id,S=w.isString(h?.source)?h?.source:h?.source?.id;if(p===S)if(n.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const R=this.configurationProperties[o];R&&(this.updatePropertyDefaultValue(o,R),this.updateSchema(o,R))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const n of t)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,n){const i=[];return t.forEach(r=>{i.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),i}doDeregisterConfigurations(t){const n=[],i=r=>{if(r.properties)for(const o in r.properties){n.push(o);const h=this.configurationProperties[o];h?.policy?.name&&this.policyConfigurations.delete(h.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>i(o))};for(const r of t){i(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(t,n=!0,i,r,o=3){o=w.isUndefinedOrNull(t.scope)?o:t.scope;const h=[],p=t.properties;if(p)for(const R in p){const M=p[R];if(n&&v(R,M)){delete p[R];continue}if(M.source=i,M.defaultDefaultValue=p[R].default,this.updatePropertyDefaultValue(R,M),e.OVERRIDE_PROPERTY_REGEX.test(R)?M.scope=void 0:(M.scope=w.isUndefinedOrNull(M.scope)?o:M.scope,M.restricted=w.isUndefinedOrNull(M.restricted)?!!r?.includes(R):M.restricted),p[R].hasOwnProperty("included")&&!p[R].included){this.excludedConfigurationProperties[R]=p[R],delete p[R];continue}else this.configurationProperties[R]=p[R],p[R].policy?.name&&this.policyConfigurations.set(p[R].policy.name,R);!p[R].deprecationMessage&&p[R].markdownDeprecationMessage&&(p[R].deprecationMessage=p[R].markdownDeprecationMessage),h.push(R)}const S=t.allOf;if(S)for(const R of S)h.push(...this.validateAndRegisterProperties(R,n,i,r,o));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const n=i=>{const r=i.properties;if(r)for(const h in r)this.updateSchema(h,r[h]);i.allOf?.forEach(n)};n(t)}updateSchema(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.resourceLanguageSettingsSchema.properties[t]=n;break}}removeFromSchema(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const n=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,n){const i=this.configurationDefaultsOverrides.get(t);let r=i?.value,o=i?.source;w.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),w.isUndefined(r)&&(r=f(n.type)),n.default=r,n.defaultValueSource=o}}const P="\\[([^\\]]+)\\]",u=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(s){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=u.exec(s);for(;n?.length;){const i=n[1].trim();i&&t.push(i),n=u.exec(s)}}return(0,C.distinct)(t)}e.overrideIdentifiersFromKey=g;function E(s){return s.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=E;function f(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const c=new m;l.Registry.add(e.Extensions.Configuration,c);function v(s,t){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):c.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,s,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=v;function a(){const s=[],t=c.getConfigurationProperties();for(const n of Object.keys(t))s.push([n,t[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=a}),define(ee[64],ie([0,1,19,3,51,2,35,25,7,9,21,41,32]),function(q,e,C,I,w,L,k,y,l,d,D,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class P{constructor(n={},i=[],r=[]){this._contents=n,this._keys=i,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const r=this.getContentsForOverrideIdentifer(i);return r?n?(0,D.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return C.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return C.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=y.deepClone(this.contents),r=y.deepClone(this.overrides),o=[...this.keys];for(const h of n)if(!h.isEmpty()){this.mergeContents(i,h.contents);for(const p of h.overrides){const[S]=r.filter(R=>C.equals(R.identifiers,p.identifiers));S?(this.mergeContents(S.contents,p.contents),S.keys.push(...p.keys),S.keys=C.distinct(S.keys)):r.push(y.deepClone(p))}for(const p of h.keys)o.indexOf(p)===-1&&o.push(p)}return new P(i,o,r)}freeze(){return this.frozen=!0,this}clone(){return new P(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[o];const p=i[o];p&&(typeof h=="object"&&typeof p=="object"?(h=y.deepClone(h),this.mergeContents(h,p)):h=p),r[o]=h}return new P(r,this.keys,this.overrides)}mergeContents(n,i){for(const r of Object.keys(i)){if(r in n&&l.isObject(n[r])&&l.isObject(i[r])){this.mergeContents(n[r],i[r]);continue}n[r]=y.deepClone(i[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?y.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,r=null;const o=h=>{h&&(r?this.mergeContents(r,h):r=y.deepClone(h))};for(const h of this.overrides)C.equals(h.identifiers,[n])?i=h.contents:h.identifiers.includes(n)&&o(h.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,D.addToValueTree)(this.contents,n,i,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,D.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let r=0;r<i;r++)n.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,n)}removeKey(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=P;class u{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!l.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:r,keys:o,overrides:h,restricted:p}=this.doParseRaw(n,i);this._configurationModel=new P(r,o,h),this._restrictedConfigurations=p||[]}doParseContent(n){let i={},r=null,o=[];const h=[],p=[];function S(M){Array.isArray(o)?o.push(M):r!==null&&(o[r]=M)}const R={onObjectBegin:()=>{const M={};S(M),h.push(o),o=M,r=null},onObjectProperty:M=>{r=M},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const M=[];S(M),h.push(o),o=M,r=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:S,onError:(M,H,Z)=>{p.push({error:M,offset:H,length:Z})}};if(n)try{w.visit(n,R),i=o[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return i}doParseRaw(n,i){const r=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,i);n=o.raw;const h=(0,D.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),p=Object.keys(n),S=this.toOverrides(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:h,keys:p,overrides:S,restricted:o.restricted}}filter(n,i,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const h={},p=[];for(const S in n)if(b.OVERRIDE_PROPERTY_REGEX.test(S)&&r){const R=this.filter(n[S],i,!1,o);h[S]=R.raw,p.push(...R.restricted)}else{const R=i[S],M=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&p.push(S),(M===void 0||o.scopes===void 0||o.scopes.includes(M))&&(o.skipRestricted&&R?.restricted||(h[S]=n[S]))}return{raw:h,restricted:p}}toOverrides(n,i){const r=[];for(const o of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const h={};for(const p in n[o])h[p]=n[o][p];r.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(h),contents:(0,D.toValuesTree)(h,i)})}return r}}e.ConfigurationModelParser=u;class g extends L.Disposable{constructor(n,i,r,o){super();this.userSettingsResource=n,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&r.isEqual(h.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class E{constructor(n,i,r,o,h=new P,p=new P,S=new k.ResourceMap,R=new P,M=new k.ResourceMap,H=!0){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=h,this._workspaceConfiguration=p,this._folderConfigurations=S,this._memoryConfiguration=R,this._memoryConfigurationByResource=M,this._freeze=H,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(n,i,r){return this.getConsolidatedConfigurationModel(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new P,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,r){const o=this.getConsolidatedConfigurationModel(n,i,r),h=this.getFolderConfigurationModelForResource(i.resource,r),p=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,S=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),R=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),M=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),H=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),Z=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),ne=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),Q=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,oe=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(n):h.freeze().getValue(n):void 0,Y=i.overrideIdentifier?p.override(i.overrideIdentifier).getValue(n):p.getValue(n),ce=o.getValue(n),x=C.distinct(o.overrides.map(j=>j.identifiers).flat()).filter(j=>o.getOverrideValue(n,j)!==void 0);return{defaultValue:S,policyValue:R,applicationValue:M,userValue:H,userLocalValue:Z,userRemoteValue:ne,workspaceValue:Q,workspaceFolderValue:oe,memoryValue:Y,value:ce,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,policy:R!==void 0?{value:R}:void 0,application:M!==void 0?{value:M,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:H!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:Z!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:ne!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:oe!==void 0?{value:h?.freeze().getValue(n),override:i.overrideIdentifier?h?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:p.getValue(n),override:i.overrideIdentifier?p.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:h,removed:p}=a(this._defaultConfiguration,n);i=[...o,...h,...p]}for(const o of i)for(const h of(0,b.overrideIdentifiersFromKey)(o)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(h),S=n.getKeysForOverrideIdentifier(h),R=[...S.filter(M=>p.indexOf(M)===-1),...p.filter(M=>S.indexOf(M)===-1),...p.filter(M=>!y.equals(this._defaultConfiguration.override(h).getValue(M),n.override(h).getValue(M)))];r.push([h,R])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=a(this._policyConfiguration,n),h=[...i,...r,...o];return h.length&&this.updatePolicyConfiguration(n),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:h}=a(this.applicationConfiguration,n),p=[...i,...r,...o];return p.length&&this.updateApplicationConfiguration(n),{keys:p,overrides:h}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:h}=a(this.localUserConfiguration,n),p=[...i,...r,...o];return p.length&&this.updateLocalUserConfiguration(n),{keys:p,overrides:h}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:h}=a(this.remoteUserConfiguration,n),p=[...i,...r,...o];return p.length&&this.updateRemoteUserConfiguration(n),{keys:p,overrides:h}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:h}=a(this.workspaceConfiguration,n),p=[...i,...r,...o];return p.length&&this.updateWorkspaceConfiguration(n),{keys:p,overrides:h}}compareAndUpdateFolderConfiguration(n,i){const r=this.folderConfigurations.get(n),{added:o,updated:h,removed:p,overrides:S}=a(r,i),R=[...o,...h,...p];return(R.length||!r)&&this.updateFolderConfiguration(n,i),{keys:R,overrides:S}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:h,overrides:p}=a(i,void 0);return{keys:[...r,...o,...h],overrides:p}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,r){let o=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const o=i.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const h=this._memoryConfigurationByResource.get(n);h&&(r=r.merge(h))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(i=r.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=r}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:h}=this._folderConfigurations.get(i);return n.push([i,{contents:r,overrides:o,keys:h}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),h=this.parseConfigurationModel(n.user),p=this.parseConfigurationModel(n.workspace),S=n.folders.reduce((R,M)=>(R.set(d.URI.revive(M[0]),this.parseConfigurationModel(M[1])),R),new k.ResourceMap);return new E(i,r,o,h,new P,p,S,new P,new k.ResourceMap,!1)}static parseConfigurationModel(n){return new P(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=E;function f(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const n=new Set,i=new Map;for(const o of t)o.keys.forEach(h=>n.add(h)),o.overrides.forEach(([h,p])=>{const S=(0,k.getOrSet)(i,h,new Set);p.forEach(R=>S.add(R))});const r=[];return i.forEach((o,h)=>r.push([h,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=f;class c{constructor(n,i,r,o){this.change=n,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const h=new Set;n.keys.forEach(S=>h.add(S)),n.overrides.forEach(([,S])=>S.forEach(R=>h.add(R))),this.affectedKeys=[...h.values()];const p=new P;this.affectedKeys.forEach(S=>p.setValue(S,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let r=(0,D.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=c;class v extends c{constructor(n,i,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=v;function a(t,n){const{added:i,removed:r,updated:o}=s(n,t),h=[],p=t?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const R=S.filter(M=>!p.includes(M));for(const M of R)h.push([M,n.getKeysForOverrideIdentifier(M)])}if(t){const R=p.filter(M=>!S.includes(M));for(const M of R)h.push([M,t.getKeysForOverrideIdentifier(M)])}if(n&&t){for(const R of p)if(S.includes(R)){const M=s({contents:t.getOverrideValue(void 0,R)||{},keys:t.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});h.push([R,[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:r,updated:o,overrides:h}}function s(t,n){const i=t?n?t.keys.filter(h=>n.keys.indexOf(h)===-1):[...t.keys]:[],r=n?t?n.keys.filter(h=>t.keys.indexOf(h)===-1):[...n.keys]:[],o=[];if(t&&n){for(const h of n.keys)if(t.keys.indexOf(h)!==-1){const p=(0,D.getConfigurationValue)(n.contents,h),S=(0,D.getConfigurationValue)(t.contents,h);y.equals(p,S)||o.push(h)}}return{added:i,removed:r,updated:o}}}),define(ee[118],ie([0,1,19,3,2,25,7,21,64,41,8,36,32]),function(q,e,C,I,w,L,k,y,l,d,D,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class P extends w.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new u(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:v})=>this.onDidUpdateConfiguration(c,v))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(c,v){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:c})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=P;class u extends l.ConfigurationModel{constructor(c={}){const v=m.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(v),s=Object.create(null),t=[];for(const n in v){const i=c[n],r=i!==void 0?i:v[n].default;(0,y.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(n)&&t.push({identifiers:(0,d.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,y.toValuesTree)(s[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(s,a,t)}}e.DefaultConfigurationModel=u;class g{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let E=class extends w.Disposable{constructor(c,v,a){super();this.defaultConfiguration=c,this.policyService=v,this.logService=a,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(c=>this.onDidChangePolicies(c))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:c})=>this.update(await this.registerPolicyDefinitions(c),!0))),this._configurationModel}async registerPolicyDefinitions(c){const v={},a=[],s=m.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const t of c){const n=s[t];if(!n){a.push(t);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}a.push(t),v[n.policy.name]={type:n.type}}}return(0,k.isEmptyObject)(v)||await this.policyService.registerPolicyDefinitions(v),a}onDidChangePolicies(c){const v=m.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),a=(0,C.coalesce)(c.map(s=>v.get(s)));this.update(a,!0)}update(c,v){const a=m.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],t=this._configurationModel.isEmpty();for(const n of c){const i=a[n]?.policy?.name;if(i){const r=this.policyService.getPolicyValue(i);(t?r!==void 0:!(0,L.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const i of n.keys)this._configurationModel.setValue(i,n.getValue(i));for(const[i,r]of s)r===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,r);v&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=de([se(1,b.IPolicyService),se(2,D.ILogService)],E),e.PolicyConfiguration=E}),define(ee[119],ie([0,1,4,3,2,17,21,64,118,36]),function(q,e,C,I,w,L,k,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends w.Disposable{constructor(m,P,u,g){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=u instanceof d.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,u,g)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,P)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:E,properties:f})=>this.onDidDefaultConfigurationChange(E,f))),this._register(this.policyConfiguration.onDidChangeConfiguration(E=>this.onDidPolicyConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,P,u]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(m,P,new y.ConfigurationModel,u)}getConfigurationData(){return this.configuration.toData()}getValue(m,P){const u=typeof m=="string"?m:void 0,g=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(P)?P:{};return this.configuration.getValue(u,g,void 0)}updateValue(m,P,u,g){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const P=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(u,P,1)}onDidDefaultConfigurationChange(m,P){const u=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(m,P);this.trigger(g,u,6)}onDidPolicyConfigurationChange(m){const P=this.configuration.toData(),u=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(u,P,6)}trigger(m,P,u){const g=new y.ConfigurationChangeEvent(m,{data:P},this.configuration);g.source=u,g.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(ee[120],ie([0,1,16]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function I(d){return d.scheme===C.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=I;function w(d){if(!d)return;const D=d.indexOf("+");return D<0?d:d.substr(0,D)}e.getRemoteName=w;function L(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.getRemoteServerRootPath=L;function k(d){const{host:D,port:b}=l(d);if(typeof b=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:b}}e.parseAuthorityWithPort=k;function y(d,D){let{host:b,port:m}=l(d);return typeof m=="undefined"&&(m=D),{host:b,port:m}}e.parseAuthorityWithOptionalPort=y;function l(d){const D=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const b=d.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=d.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:d,port:void 0}}}),define(ee[37],ie([0,1,30,10,120]),function(q,e,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=L;function k(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var l;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(l=e.TargetPlatform||(e.TargetPlatform={}));class d{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,E){if(typeof g=="undefined"||g===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof g=="string"||typeof E=="string"){const f=typeof g=="string"?g:g.value,c=typeof E=="string"?E:E.value;return C.equalsIgnoreCase(f,c)}return g._lower===E._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=d;function D(u){return b(u)}e.isApplicationScopedExtension=D;function b(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function m(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function P(u,g){if(g){const E=`onResolveRemoteAuthority:${(0,w.getRemoteName)(g)}`;return u.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[23],ie([0,1,30,22,37,13,9,12,31]),function(q,e,C,I,w,L,k,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function d(i,r){return i.uuid&&r.uuid?i.uuid===r.uuid:i.id===r.id?!0:(0,C.compareIgnoreCase)(i.id,r.id)===0}e.areSameExtensions=d;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{constructor(r,o,h="undefined"){this.version=o,this.targetPlatform=h,this.id=r.id}static create(r){const o=r.manifest?r.manifest.version:r.version,h=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new b(r.identifier,o,h)}static parse(r){const o=D.exec(r);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof b?d(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=b;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(i){const r=m.exec(i);return r&&r[1]?[g(r[1]),r[2]]:[g(i),void 0]}e.getIdAndVersion=P;function u(i,r){return`${i}.${r}`}e.getExtensionId=u;function g(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function E(i,r){return g(u(i,r))}e.getGalleryExtensionId=E;function f(i,r){const o=[],h=p=>{for(const S of o)if(S.some(R=>d(r(R),r(p))))return S;return null};for(const p of i){const S=h(p);S?S.push(p):o.push([p])}return o}e.groupByExtension=f;function c(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=c;function v(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function a(i){const r=new Set;if(i.malicious)for(const o of i.malicious)r.add(o.id);return r}e.getMaliciousExtensionsSet=a;function s(i,r){const o=[],h=r.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const p=h.shift();if(p&&o.every(S=>!d(S.identifier,{id:p}))){const S=i.filter(R=>d(R.identifier,{id:p}));S.length===1&&(o.push(S[0]),h.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=s;async function t(i,r){if(!L.isLinux)return!1;let o;try{o=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){r.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(p))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function n(i,r){const o=await t(i,r),h=(0,I.getTargetPlatform)(o?"alpine":L.platform,l.arch);return r.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=n}),define(ee[121],ie([0,1,26,12,16,17,40,9,86,22,23,37]),function(q,e,C,I,w,L,k,y,l,d,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const m=E=>(0,l.localize)(0,null,E),P=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(E,f){return f?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let g=class{constructor(f,c){this.extensionManagementService=f,this.extensionGalleryService=c}get location(){}async listExtensions(f,c,v=console){let a=await this.extensionManagementService.getInstalled(1);const s=b.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(c&&c!==""){if(s.indexOf(c.toLowerCase())<0){v.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}a=a.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){v.log("Possible Categories: "),s.forEach(n=>{v.log(n)});return}this.location&&v.log((0,l.localize)(2,null,this.location)),a=a.sort((n,i)=>n.identifier.id.localeCompare(i.identifier.id));let t;for(const n of a)t!==n.identifier.id&&(t=n.identifier.id,v.log(u(n.manifest,f)))}async installExtensions(f,c,v,a,s=console){const t=[],n=[];f.length&&s.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),r=(S,R)=>{const M=i.find(H=>(0,D.areSameExtensions)(H.identifier,{id:S}));if(M){if(!a&&(!R||R==="prerelease"&&M.preRelease))return s.log((0,l.localize)(5,null,S,M.manifest.version,S)),!1;if(R&&M.manifest.version===R)return s.log((0,l.localize)(6,null,`${S}@${R}`)),!1}return!0},o=(S,R,M)=>{p.push({id:S,version:R!=="prerelease"?R:void 0,installOptions:{...v,isBuiltin:M,installPreReleaseVersion:R==="prerelease"||v.installPreReleaseVersion}})},h=[],p=[];for(const S of f)if(S instanceof y.URI)h.push(S);else{const[R,M]=(0,D.getIdAndVersion)(S);r(R,M)&&o(R,M,!1)}for(const S of c){const[R,M]=(0,D.getIdAndVersion)(S);r(R,M)&&o(R,M,!0)}if(h.length&&await Promise.all(h.map(async S=>{try{const R=await this.installVSIX(S,{...v,isBuiltin:!1},a,s);R&&n.push(R)}catch(R){s.error(R.message||R.stack||R),t.push(S.toString())}})),p.length){const S=await this.getGalleryExtensions(p);await Promise.all(p.map(async R=>{const M=S.get(R.id.toLowerCase());if(M)try{const H=await this.installFromGallery(R,M,i,a,s);H&&n.push(H)}catch(H){s.error(H.message||H.stack||H),t.push(R.id)}else s.error(`${m(R.version?`${R.id}@${R.version}`:R.id)}
${P}`),t.push(R.id)}))}if(t.length)throw new Error((0,l.localize)(7,null,t.join(", ")))}async installVSIX(f,c,v,a){const s=await this.extensionManagementService.getManifest(f);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,v,a))try{return await this.extensionManagementService.install(f,c),a.log((0,l.localize)(8,null,(0,L.basename)(f))),s}catch(n){if((0,I.isCancellationError)(n))return a.log((0,l.localize)(9,null,(0,L.basename)(f))),null;throw n}return null}async getGalleryExtensions(f){const c=new Map,v=f.some(s=>s.installOptions.installPreReleaseVersion),a=await this.extensionGalleryService.getExtensions(f.map(s=>({...s,preRelease:v})),C.CancellationToken.None);for(const s of a)c.set(s.identifier.id.toLowerCase(),s);return c}async installFromGallery({id:f,version:c,installOptions:v},a,s,t,n){const i=await this.extensionGalleryService.getManifest(a,C.CancellationToken.None);if(i&&!this.validateExtensionKind(i,n))return null;const r=s.find(o=>(0,D.areSameExtensions)(o.identifier,a.identifier));if(r){if(a.version===r.manifest.version)return n.log((0,l.localize)(10,null,c?`${f}@${c}`:f)),null;n.log((0,l.localize)(11,null,f,a.version))}try{return v.isBuiltin?n.log(c?(0,l.localize)(12,null,f,c):(0,l.localize)(13,null,f)):n.log(c?(0,l.localize)(14,null,f,c):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(a,{...v,installGivenVersion:!!c}),n.log((0,l.localize)(16,null,f,a.version)),i}catch(o){if((0,I.isCancellationError)(o))return n.log((0,l.localize)(17,null,f)),null;throw o}}validateExtensionKind(f,c){return!0}async validateVSIX(f,c,v){const a={id:(0,D.getGalleryExtensionId)(f.publisher,f.name)},t=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,D.areSameExtensions)(a,n.identifier)&&(0,k.gt)(n.manifest.version,f.version));return t&&!c?(v.log((0,l.localize)(18,null,t.identifier.id,t.manifest.version,f.version)),!1):this.validateExtensionKind(f,v)}async uninstallExtensions(f,c,v=console){const a=async t=>{if(t instanceof y.URI){const n=await this.extensionManagementService.getManifest(t);return u(n)}return t},s=[];for(const t of f){const n=await a(t),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,D.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${P}`);if(r.some(o=>o.type===0)){v.log((0,l.localize)(19,null,n));return}if(!c&&r.some(o=>o.isBuiltin)){v.log((0,l.localize)(20,null,n));return}v.log((0,l.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?v.log((0,l.localize)(22,null,n,this.location)):v.log((0,l.localize)(23,null,n))}}async locateExtension(f,c=console){const v=await this.extensionManagementService.getInstalled();f.forEach(a=>{v.forEach(s=>{if(s.identifier.id===a&&s.location.scheme===w.Schemas.file){c.log(s.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};g=de([se(0,d.IExtensionManagementService),se(1,d.IExtensionGalleryService)],g),e.ExtensionManagementCLIService=g}),define(ee[122],ie([0,1,4,12,2,13,17,40,9,34,20,18,22,23,11,8]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let E=class extends w.Disposable{constructor(c,v,a,s){super();this.fileService=v,this.extensionGalleryService=a,this.logService=s,this.extensionsDownloadDir=l.URI.file(c.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(c,v){await this.cleanUpPromise;const a=this.getName(c),s=(0,k.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(s)){const t=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(c,t,v);try{await this.rename(t,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(t)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",c.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,t.path),n}}return s}async delete(c){await this.cleanUpPromise,await this.fileService.del(c)}async rename(c,v,a){try{await D.Promises.rename(c.fsPath,v.fsPath)}catch(s){if(L.isWindows&&s&&s.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${c} to ${v} with 'EPERM' error. Trying again...`),this.rename(c,v,a);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const c=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(c.children){const v=[],a=[];for(const n of c.children){const i=P.ExtensionKey.parse(n.name);i&&a.push([i,n])}const s=(0,P.groupByExtension)(a,([n])=>n),t=[];for(const n of s)n.sort((i,r)=>y.rcompare(i[0].version,r[0].version)),v.push(...n.slice(1).map(i=>i[1].resource)),t.push(n[0][1]);t.sort((n,i)=>n.mtime-i.mtime),v.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(v.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(c){this.logService.error(c)}}getName(c){return this.cache?P.ExtensionKey.create(c).toString().toLowerCase():(0,d.generateUuid)()}};E=de([se(0,b.INativeEnvironmentService),se(1,u.IFileService),se(2,m.IExtensionGalleryService),se(3,g.ILogService)],E),e.ExtensionsDownloader=E}),define(ee[123],ie([0,1,2,14,20,37]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends C.Disposable{constructor(l,d){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(d.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(l){l.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(ee[124],ie([0,1,154,19,4,2,16,14,20,18,22,23,8,62]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let u=class extends P.LanguagePackBaseService{constructor(c,v,a,s){super(a);this.extensionManagementService=c,this.logService=s,this.cache=this._register(new g(v,s)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getInstalledLanguages(){const c=await this.cache.getLanguagePacks(),v=Object.keys(c).map(a=>{const s=c[a];return{...this.createQuickPickItem({locale:a,label:s.label}),extensionId:s.extensions[0].extensionIdentifier.id}});return v.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),v}async postInstallExtension(c){c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",c.identifier.id),await this.update())}async postUninstallExtension(c){const v=await this.cache.getLanguagePacks();Object.keys(v).some(a=>v[a]&&v[a].extensions.some(s=>(0,b.areSameExtensions)(s.extensionIdentifier,c.identifier)))&&(this.logService.info("Removing language packs from the extension",c.identifier.id),await this.update())}async update(){const[c,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(v);return!(0,I.equals)(Object.keys(c),Object.keys(a))}};u=de([se(0,D.IExtensionManagementService),se(1,d.INativeEnvironmentService),se(2,D.IExtensionGalleryService),se(3,m.ILogService)],u),e.NativeLanguagePackService=u;let g=class extends L.Disposable{constructor(c,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,y.join)(c.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(c){return this.withLanguagePacks(v=>{Object.keys(v).forEach(a=>delete v[a]),this.createLanguagePacksFromExtensions(v,...c)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(c,...v){for(const a of v)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(c,a);Object.keys(c).forEach(a=>this.updateHash(c[a]))}createLanguagePacksFromExtension(c,v){const a=v.identifier,s=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const t of s)if(v.location.scheme===k.Schemas.file&&E(t)){let n=c[t.languageId];n||(n={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},c[t.languageId]=n);const i=n.extensions.filter(r=>(0,b.areSameExtensions)(r.extensionIdentifier,a))[0];i?i.version=v.manifest.version:n.extensions.push({extensionIdentifier:a,version:v.manifest.version});for(const r of t.translations)n.translations[r.id]=(0,y.join)(v.location.fsPath,r.path)}}updateHash(c){if(c){const v=(0,C.createHash)("md5");for(const a of c.extensions)v.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);c.hash=v.digest("hex")}}withLanguagePacks(c=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(v=c(a),a)).then(a=>{for(const t of Object.keys(a))a[t]||delete a[t];this.languagePacks=a,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),l.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>v,a=>this.logService.error(a))})}};g=de([se(0,d.INativeEnvironmentService),se(1,m.ILogService)],g);function E(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const c of f.translations)if(typeof c.id!="string"||typeof c.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ee[48],ie([0,1,15,95,41,10,32]),function(q,e,C,I,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function y(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=y;function l(g){return g.res.statusCode===204}async function d(g){return l(g)?null:(await(0,C.streamToBuffer)(g.stream)).toString()}e.asText=d;async function D(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);return d(g)}e.asTextOrError=D;async function b(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);if(l(g))return null;const f=(await(0,C.streamToBuffer)(g.stream)).toString();try{return JSON.parse(f)}catch(c){throw c.message+=`:
`+f,c}}e.asJson=b;function m(g){u(g)}e.updateProxyConfigurationsScope=m;let P;function u(g){const E=k.Registry.as(w.Extensions.Configuration),f=P;P={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[P],remove:f?[f]:[]})}u(2)}),define(ee[125],ie([0,1,26,16,11,48]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(l,d){this.requestService=l,this.fileService=d}async download(l,d,D=C.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,d);return}const b={type:"GET",url:l.toString(!0)},m=await this.requestService.request(b,D);if(m.res.statusCode===200)await this.fileService.writeFile(d,m.stream);else{const P=await(0,L.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${P}`)}}};k=de([se(0,L.IRequestService),se(1,w.IFileService)],k),e.DownloadService=k}),define(ee[126],ie([0,1,127,7]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function w(k,y){return k.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:k.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function L(k,y,l={}){const d=(0,C.parse)(k),D=l.proxyUrl||w(d,y);if(!D)return null;const b=(0,C.parse)(D);if(!/^https?:$/.test(b.protocol||""))return null;const m={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((P,u)=>{q(["http-proxy-agent"],P,u)}))(m):new(await new Promise((P,u)=>{q(["https-proxy-agent"],P,u)}))(m)}e.getProxyAgent=L}),define(ee[128],ie([0,1,45,14,96,26,29,12,13,34,80,155,4]),function(q,e,C,I,w,L,k,y,l,d,D,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const P=1e4;let u;async function g(f,c,v){return c["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(v)&&!c["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=m.Promises.withAsyncBody(async(a,s)=>{const t=new L.CancellationTokenSource,n=setTimeout(()=>{t.dispose(!0),s(new Error((0,w.localize)(0,null)))},P);try{a(await E(f,t.token))}catch(i){!(0,y.isCancellationError)(i)&&!t.token.isCancellationRequested?s(new Error((0,w.localize)(1,null,(0,k.toErrorMessage)(i)))):a({})}finally{clearTimeout(n),t.dispose()}})),u)}e.getResolvedShellEnv=g;async function E(f,c){const v=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",v);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",a);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",n);const i=await(0,D.getSystemShell)(l.OS,n);return f.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(c.isCancellationRequested)return o((0,y.canceled)());const h=(0,I.basename)(i);let p,S;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(p=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,S=["-Login","-Command"]):(p=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h==="tcsh"?S=["-ic"]:S=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),p);const M=(0,C.spawn)(i,[...S,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});c.onCancellationRequested(()=>(M.kill(),o((0,y.canceled)()))),M.on("error",ne=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(ne)),o(ne)});const H=[];M.stdout.on("data",ne=>H.push(ne));const Z=[];M.stderr.on("data",ne=>Z.push(ne)),M.on("close",(ne,Q)=>{const oe=Buffer.concat(H).toString("utf8");f.trace("getUnixShellEnvironment#raw",oe);const Y=Buffer.concat(Z).toString("utf8");if(Y.trim()&&f.trace("getUnixShellEnvironment#stderr",Y),ne||Q)return o(new Error((0,w.localize)(2,null,ne,Q)));const ce=t.exec(oe),x=ce?ce[1]:"{}";try{const j=JSON.parse(x);v?j.ELECTRON_RUN_AS_NODE=v:delete j.ELECTRON_RUN_AS_NODE,a?j.ELECTRON_NO_ATTACH_CONSOLE=a:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",j),r(j)}catch(j){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(j)),o(j)}})})}}),define(ee[65],ie([0,1,10]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,C.createDecorator)("stateService")}),define(ee[129],ie([0,1,4,15,7,18,11,8]),function(q,e,C,I,w,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class l{constructor(b,m,P){this.storagePath=b,this.logService=m,this.fileService=P,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new C.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,m){const P=this.storage[b];return(0,w.isUndefinedOrNull)(P)?m:P}setItem(b,m){this.setItems([{key:b,data:m}])}setItems(b){let m=!1;for(const{key:P,data:u}of b)this.storage[P]!==u&&((0,w.isUndefinedOrNull)(u)?(0,w.isUndefined)(this.storage[P])||(this.storage[P]=void 0,m=!0):(this.storage[P]=u,m=!0));m&&this.save()}removeItem(b){(0,w.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(b){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),b)}async doSave(){if(!this.initializing)return;await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,I.VSBuffer.fromString(b)),this.lastSavedStorageContents=b}catch(m){this.logService.error(m)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=l;let d=class{constructor(b,m,P){this.fileStorage=new l(b.stateResource,m,P)}async init(){await this.fileStorage.init()}getItem(b,m){return this.fileStorage.getItem(b,m)}};d=de([se(0,L.IEnvironmentService),se(1,y.ILogService),se(2,k.IFileService)],d),e.StateService=d}),define(ee[130],ie([0,1,13,31,9,34]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(d){if(C.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function y(d,D,b,m,P,u,g,E,f,c){const v=Object.create(null);v["common.machineId"]=g,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=P,v.version=u,v["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,C.PlatformToString)(C.platform),v["common.nodePlatform"]=I.platform,v["common.nodeArch"]=m,v["common.product"]=c||"desktop";const a=l(E||[]);a&&(v["common.msftInternal"]=a);let s=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.isLinuxSnap&&(v["common.snap"]="true");const n=k(b);n&&(v["common.platformDetail"]=n);try{const i=await d.readFile(w.URI.file(f));v["common.source"]=i.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=y;function l(d){const D=I.env.USERDNSDOMAIN;if(!D)return!1;const b=D.toLowerCase();return d.some(m=>b===m)}e.verifyMicrosoftInternalDomain=l}),define(ee[33],ie([0,1,10]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(I=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[42],ie([0,1,25,53,7,21,33]),function(q,e,C,I,w,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(a,s){return Promise.resolve(void 0)}publicLog2(a,s){return this.publicLog(a,s)}publicLogError(a,s){return Promise.resolve(void 0)}publicLogError2(a,s){return this.publicLogError(a,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class l{async publicLog(a,s,t){}async publicLogError(a,s,t){}}e.NullEndpointTelemetryService=l,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(v,a){return a.onDidChangeConfiguration(s=>{s.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(s.source),configurationKeys:E(s.sourceConfig)})})}e.configurationTelemetry=d;function D(v,a){return!(a.disableTelemetry||!v.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=D;function b(v){const a=v.getValue(k.TELEMETRY_SETTING_ID),s=v.getValue("telemetry.enableCrashReporter");if(v.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function m(v){const a={},s={},t={};g(v,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const i=t[n];typeof i=="number"?s[n]=i:typeof i=="boolean"?s[n]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${i.length}`),a[n]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(a[n]=i)}return{properties:a,measurements:s}}e.validateTelemetryData=m;const P=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function u(v){if(!v)return"none";for(const a of P)if(v.startsWith(`${a}+`))return a;return"other"}e.cleanRemoteAuthority=u;function g(v,a,s=0,t){if(!!v)for(const n of Object.getOwnPropertyNames(v)){const i=v[n],r=t?t+n:n;Array.isArray(i)?a[r]=(0,C.safeStringify)(i):i instanceof Date?a[r]=i.toISOString():(0,w.isObject)(i)?s<2?g(i,a,s+1,r+"."):a[r]=(0,C.safeStringify)(i):a[r]=i}}function E(v){if(!v)return[];const a=[];return f(a,"",v),a}function f(v,a,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(t=>f(v,a?`${a}.${t}`:t,s[t])):v.push(a)}function c(v){return[v.appRoot,v.extensionsPath,v.userHome.fsPath,v.tmpDir.fsPath,v.userDataPath]}e.getPiiPathsFromEnvironment=c}),define(ee[131],ie([0,1,103,42]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function w(L,k,y,l,d,D,b){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${k.nameShort})`},P=await(0,C.getServiceMachineId)(y,d,D),{sessionId:u}=await b.getTelemetryInfo();return(0,I.supportsTelemetry)(k,y)&&(0,I.getTelemetryLevel)(l)===3&&(m["X-Market-User-Id"]=P,m["VSCode-SessionId"]=u),m}e.resolveMarketplaceHeaders=w}),define(ee[132],ie([0,1,2,25,53,13,30,97,21,41,133,27,32,33,42]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(c,v,a){this._configurationService=v,this._productService=a,this._experimentProperties={},this.telemetryLevel=new w.MutableObservableValue(3),this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=c.appenders,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(c,v){this._experimentProperties[c]=v}_updateTelemetryLevel(){let c=(0,u.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const a=v.usage?3:v.error?2:0;c=Math.min(c,a)}this.telemetryLevel.value=c}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const c=await this._commonProperties,v=c.sessionID,a=c["common.machineId"],s=c["common.firstSessionDate"],t=c["common.msftInternal"];return{sessionId:v,machineId:a,firstSessionDate:s,msftInternal:t}}dispose(){this._disposables.dispose()}_log(c,v,a,s){return this.telemetryLevel.value<v?Promise.resolve(void 0):this._commonProperties.then(t=>{a=(0,I.mixin)(a,t),a=(0,I.mixin)(a,this._experimentProperties),a=(0,I.cloneAndChange)(a,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(c,a))},t=>{console.error(t)})}publicLog(c,v,a){return this._log(c,3,v,a)}publicLog2(c,v,a){return this.publicLog(c,v,a)}publicLogError(c,v){return this._sendErrorTelemetry?this._log(c,2,v,!0):Promise.resolve(void 0)}publicLogError2(c,v){return this.publicLogError(c,v)}_anonymizeFilePaths(c){let v=c;const a=[];for(const i of this._cleanupPatterns)for(;;){const r=i.exec(c);if(!r)break;a.push([r.index,i.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,t=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(v="";;){const i=t.exec(c);if(!i)break;!s.test(i[0])&&a.every(([r,o])=>i.index<r||i.index>=o)&&(v+=c.substring(n,i.index)+"<REDACTED: user-file-path>",n=t.lastIndex)}return n<c.length&&(v+=c.substr(n)),v}_removePropertiesWithPossibleUserInfo(c){if(!c)return c;const v=c.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of a)if(s.regex.test(v))return`<REDACTED: ${s.label}>`;return c}_cleanupInfo(c,v){let a=c;v&&(a=this._anonymizeFilePaths(a));for(const s of this._cleanupPatterns)a=a.replace(s,"");return a=this._removePropertiesWithPossibleUserInfo(a),a}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=de([se(1,l.IConfigurationService),se(2,b.IProductService)],g),e.TelemetryService=g;function E(){const f=(0,y.localize)(0,null,D.default.nameLong),c=D.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=L.isWeb?"":(0,y.localize)(3,null),a=(0,y.localize)(4,null),s=(0,y.localize)(5,null),t=(0,y.localize)(6,null),n=(0,y.localize)(7,null),i=`
|       | ${a} | ${s} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,y.localize)(8,null);return`
${f} ${c} ${v}

&nbsp;

${n}
${i}

&nbsp;

${r}
`}m.Registry.as(d.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(d.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,y.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,y.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[134],ie([0,1,12,25,42]),function(q,e,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(y){const l=await new Promise((D,b)=>{q(["applicationinsights"],D,b)});let d;return l.defaultClient?(d=new l.TelemetryClient(y),d.channel.setUseDiskRetryCaching(!0)):(l.setup(y).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=l.defaultClient),y.indexOf("AIF-")===0&&(d.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),d}class k{constructor(l,d,D){this._eventPrefix=l,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(d=>{l(d)},d=>{(0,C.onUnexpectedError)(d),console.error(d)})}}log(l,d){if(!!this._aiClient){d=(0,I.mixin)(d,this._defaultData),d=(0,w.validateTelemetryData)(d);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+l,properties:d.properties,measurements:d.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(d=>{try{d.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(ee[135],ie([0,1,14,20]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function w(L,k){const y=Object.create(null),l=(D,b)=>{const m=JSON.parse(D);y[b]=m};if(k){const D=[],b=await I.Promises.readdir(k);for(const P of b)try{(await I.Promises.stat((0,C.join)(k,P))).isDirectory()&&D.push(P)}catch{}const m=[];for(const P of D)(await I.Promises.readdir((0,C.join)(k,P))).filter(g=>g==="telemetry.json").length===1&&m.push(P);for(const P of m){const u=(await I.Promises.readFile((0,C.join)(k,P,"telemetry.json"))).toString();l(u,P)}}let d=(await I.Promises.readFile((0,C.join)(L,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await I.Promises.readFile((0,C.join)(L,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(y,null,4)}e.buildTelemetryMessage=w}),define(ee[28],ie([0,1,10]),function(q,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(ee[136],ie([0,1,3,2,9,18,23,11,8,28]),function(q,e,C,I,w,L,k,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let D=class extends I.Disposable{constructor(m,P,u,g,E){super();this.extensionsManagementService=m,this.logService=g,this.uriIdentityService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(c=>{this.installedExtensions=c.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(c=>this.onInstallExtension(c))),this._register(m.onDidInstallExtensions(c=>this.onDidInstallExtensions(c))),this._register(m.onDidUninstallExtension(c=>this.onDidUninstallExtension(c)));const f=w.URI.file(u.extensionsPath);this._register(P.watch(f)),this._register(C.Event.filter(P.onDidFilesChange,c=>c.rawChanges.some(v=>this.doesChangeAffects(v,f)))(()=>this.onDidChange()))}doesChangeAffects(m,P){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),P)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(P,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const P of m)this.removeInstallingExtension(P.identifier),P.local&&this.addInstalledExtension(P.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(P=>!(0,k.areSameExtensions)(P,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(P=>!(0,k.areSameExtensions)(P,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),P=m.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,k.areSameExtensions)(E,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),u=this.installedExtensions.filter(g=>this.installingExtensions.some(E=>(0,k.areSameExtensions)(E,g))?!1:m.every(E=>!(0,k.areSameExtensions)(E.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=m.map(g=>g.identifier),(P.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P,removed:u})}}};D=de([se(1,y.IFileService),se(2,L.INativeEnvironmentService),se(3,l.ILogService),se(4,d.IUriIdentityService)],D),e.ExtensionsWatcher=D}),define(ee[137],ie([0,1,28,104,11,17,68,3,2]),function(q,e,C,I,w,L,k,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{constructor(m){this.uri=m,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let D=class{constructor(m){this._fileService=m,this._dispooables=new l.DisposableStore,this._limit=2**16;const P=new Map,u=g=>{let E=P.get(g.scheme);return E===void 0&&(E=m.hasProvider(g)&&!this._fileService.hasCapability(g,1024),P.set(g.scheme,E)),E};this._dispooables.add(y.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(g=>{P.delete(g.scheme)})),this.extUri=new L.ExtUri(u),this._canonicalUris=new k.SkipList((g,E)=>this.extUri.compare(g,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,L.normalizePath)(m));const P=this._canonicalUris.get(m);return P?P.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new d(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((u,g)=>u[1].touch<g[1].touch?1:u[1].touch>g[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const P=this._limit*.5;for(let u=0;u<P;u++)this._canonicalUris.set(m[u][0],m[u][1].touch())}};D=de([se(0,w.IFileService)],D),e.UriIdentityService=D,(0,I.registerSingleton)(C.IUriIdentityService,D,!0)}),define(ee[24],ie([0,1,54,3,2,17,7,9,98,18,11,10,8]),function(q,e,C,I,w,L,k,y,l,d,D,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function P(f){const c=f;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&y.URI.isUri(c.location)&&y.URI.isUri(c.globalStorageHome)&&y.URI.isUri(c.settingsResource)&&y.URI.isUri(c.keybindingsResource)&&y.URI.isUri(c.tasksResource)&&y.URI.isUri(c.snippetsHome)&&((0,k.isUndefined)(c.extensionsResource)||y.URI.isUri(c.extensionsResource)))}e.isUserDataProfile=P,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function u(f,c){return{id:f.id,isDefault:f.isDefault,name:f.name,location:y.URI.revive(f.location).with({scheme:c}),globalStorageHome:y.URI.revive(f.globalStorageHome).with({scheme:c}),settingsResource:y.URI.revive(f.settingsResource).with({scheme:c}),keybindingsResource:y.URI.revive(f.keybindingsResource).with({scheme:c}),tasksResource:y.URI.revive(f.tasksResource).with({scheme:c}),snippetsHome:y.URI.revive(f.snippetsHome).with({scheme:c}),extensionsResource:y.URI.revive(f.extensionsResource)?.with({scheme:c})}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function g(f,c,v){return{id:(0,C.hash)(c.path).toString(16),name:f,location:c,isDefault:!1,globalStorageHome:(0,L.joinPath)(c,"globalStorage"),settingsResource:(0,L.joinPath)(c,"settings.json"),keybindingsResource:(0,L.joinPath)(c,"keybindings.json"),tasksResource:(0,L.joinPath)(c,"tasks.json"),snippetsHome:(0,L.joinPath)(c,"snippets"),extensionsResource:(0,L.joinPath)(c,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:v}}e.toUserDataProfile=g;let E=class extends w.Disposable{constructor(c,v,a){super();this.environmentService=c,this.fileService=v,this.logService=a,this._defaultProfile=this.createDefaultUserDataProfile(!1),this._onDidChangeProfiles=this._register(new I.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]??this._defaultProfile}get profiles(){return[]}newProfile(c,v){return g(c,(0,L.joinPath)(this.profilesHome,(0,C.hash)(c).toString(16)),v)}createDefaultUserDataProfile(c){const v=g((0,l.localize)(0,null),this.environmentService.userRoamingDataHome);return{...v,isDefault:!0,extensionsResource:c?v.extensionsResource:void 0}}createProfile(c,v){throw new Error("Not implemented")}setProfileForWorkspace(c,v){throw new Error("Not implemented")}getProfile(c){throw new Error("Not implemented")}removeProfile(c){throw new Error("Not implemented")}};E=de([se(0,d.IEnvironmentService),se(1,D.IFileService),se(2,m.ILogService)],E),e.UserDataProfilesService=E}),define(ee[38],ie([0,1,4,15,2,35,9,23,11,10,8,28,24]),function(q,e,C,I,w,L,k,y,l,d,D,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let P=class extends w.Disposable{constructor(g,E,f,c){super();this.fileService=g,this.uriIdentityService=E,this.userDataProfilesService=f,this.logService=c,this.resourcesAccessQueueMap=new L.ResourceMap,this.migratePromise=this.migrate()}async migrate(){await Promise.all(this.userDataProfilesService.profiles.map(async g=>{if(!!g.extensionsResource)try{let E=!1;const f=JSON.parse((await this.fileService.readFile(g.extensionsResource)).value.toString());for(const c of f)if(!!c.location&&!c.version)try{const v=(await this.fileService.readFile(this.uriIdentityService.extUri.joinPath(k.URI.revive(c.location),"package.json"))).value.toString();c.version=JSON.parse(v).version,E=!0}catch{}E&&await this.fileService.writeFile(g.extensionsResource,I.VSBuffer.fromString(JSON.stringify(f)))}catch{}}))}scanProfileExtensions(g){return this.withProfileExtensions(g)}addExtensionsToProfile(g,E){return this.withProfileExtensions(E,f=>(f=f.filter(c=>g.some(([v])=>!(0,y.areSameExtensions)(c.identifier,v.identifier))),f.push(...g.map(([c,v])=>({identifier:c.identifier,version:c.manifest.version,location:c.location,metadata:v}))),f))}removeExtensionFromProfile(g,E){return this.withProfileExtensions(E,f=>f.filter(c=>!(0,y.areSameExtensions)(c.identifier,g)))}async withProfileExtensions(g,E){return await this.migratePromise,this.getResourceAccessQueue(g).queue(async()=>{let f=[];try{const c=await this.fileService.readFile(g),v=JSON.parse(c.value.toString());for(const a of v){if(!a.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",a);continue}if(!a.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",a);continue}if(!a.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",a);continue}f.push({identifier:a.identifier,location:k.URI.revive(a.location),version:a.version,metadata:a.metadata})}}catch(c){c.fileOperationResult!==1&&this.logService.error(c)}if(E){f=E(f);const c=f.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),metadata:v.metadata}));await this.fileService.writeFile(g,I.VSBuffer.fromString(JSON.stringify(c)))}return f})}getResourceAccessQueue(g){let E=this.resourcesAccessQueueMap.get(g);return E||(E=new C.Queue,this.resourcesAccessQueueMap.set(g,E)),E}};P=de([se(0,l.IFileService),se(1,b.IUriIdentityService),se(2,m.IUserDataProfilesService),se(3,D.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(ee[138],ie([0,1,19,4,26,12,3,2,13,9,84,22,23,38,8,27,33,28,24]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g,E,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends y.Disposable{constructor(h,p,S,R,M,H,Z){super();this.userDataProfilesService=h,this.uriIdenityService=p,this.galleryService=S,this.extensionsProfileScannerService=R,this.telemetryService=M,this.logService=H,this.productService=Z,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,y.toDisposable)(()=>{this.installingExtensions.forEach(ne=>ne.cancel()),this.uninstallingExtensions.forEach(ne=>ne.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(h){const p=await this.getTargetPlatform();return h.allTargetPlatforms.some(S=>(0,b.isTargetPlatformCompatible)(S,h.allTargetPlatforms,p))}async installFromGallery(h,p={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(D.localize(0,null),b.ExtensionManagementErrorCode.Internal);const S=await this.checkAndGetCompatibleVersion(h,!!p.installGivenVersion,!!p.installPreReleaseVersion);return await this.installExtension(S.manifest,S.extension,p)}catch(S){throw t(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(h),error:S}),this.logService.error("Failed to install extension.",h.identifier.id),this.logService.error(S),s(S)}}async uninstall(h,p={}){return this.logService.trace("ExtensionManagementService#uninstall",h.identifier.id),this.unininstallExtension(h,p)}async reinstallFromGallery(h){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",h.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const p=await this.getTargetPlatform(),[S]=await this.galleryService.getExtensions([{...h.identifier,preRelease:h.preRelease}],{targetPlatform:p,compatible:!0},w.CancellationToken.None);if(!S)throw new Error(D.localize(2,null));await this.createDefaultUninstallExtensionTask(h,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(S)}getExtensionsControlManifest(){const h=new Date().getTime();return(!this.extensionsControlManifest||h-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=h),this.extensionsControlManifest}registerParticipant(h){this.participants.push(h)}async installExtension(h,p,S){if(!d.URI.isUri(p)){const ne=this.installingExtensions.get(m.ExtensionKey.create(p).toString());if(ne){this.logService.info("Extensions is already requested to install",p.identifier.id);const Q=this.createWaitUntilInstallExtensionTaskIsFinishedTask(ne,S),{local:oe}=await Q.waitUntilTaskIsFinished();return oe}S={...S,installOnlyNewlyAddedFromExtensionPack:!0}}const R=[],M=[],H=this.createInstallExtensionTask(h,p,S);d.URI.isUri(p)||this.installingExtensions.set(m.ExtensionKey.create(p).toString(),H),this._onInstallExtension.fire({identifier:H.identifier,source:p,profileLocation:S.profileLocation}),this.logService.info("Installing extension:",H.identifier.id),R.push({task:H,manifest:h});let Z=!1;try{if(S.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",H.identifier.id);else try{const Q=await this.getAllDepsAndPackExtensionsToInstall(H.identifier,h,!!S.installOnlyNewlyAddedFromExtensionPack,!!S.installPreReleaseVersion,S.profileLocation);for(const{gallery:oe,manifest:Y}of Q){Z=Z||!!Y.extensionDependencies?.some(x=>(0,m.areSameExtensions)({id:x},H.identifier));const ce=m.ExtensionKey.create(oe).toString();if(this.installingExtensions.has(ce))this.logService.info("Extension is already requested to install",oe.identifier.id);else{const x=this.createInstallExtensionTask(Y,oe,{...S,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ce,x),this._onInstallExtension.fire({identifier:x.identifier,source:oe,profileLocation:S.profileLocation}),this.logService.info("Installing extension:",x.identifier.id),R.push({task:x,manifest:Y})}}}catch(Q){if(d.URI.isUri(H.source))(0,C.isNonEmptyArray)(h.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",H.identifier.id,Q.message),(0,C.isNonEmptyArray)(h.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",H.identifier.id,Q.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",H.identifier.id),Q}const ne=R.reduce((Q,{task:oe,manifest:Y})=>(Q.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:Y}),Q),new Map);for(;ne.size;){let Q;const oe=[...ne.values()].filter(({manifest:Y})=>!Y.extensionDependencies?.some(ce=>ne.has(ce.toLowerCase())));oe.length?Q=ne.size===1?oe:oe.filter(({task:Y})=>!(Y===H&&!Z)):(this.logService.info("Found extensions with circular dependencies",oe.map(({task:Y})=>Y.identifier.id)),Q=[...ne.values()]),await this.joinAllSettled(Q.map(async({task:Y})=>{const ce=new Date().getTime();try{const{local:x}=await Y.run();if(await this.joinAllSettled(this.participants.map(j=>j.postInstall(x,Y.source,S,w.CancellationToken.None))),!d.URI.isUri(Y.source)){const j=Y.operation===3,K=j?void 0:(new Date().getTime()-Y.source.lastUpdated)/1e3;if(t(this.telemetryService,j?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(Y.source),duration:new Date().getTime()-ce,durationSinceUpdate:K}),l.isWeb&&Y.operation!==3)try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch{}}M.push({local:x,identifier:Y.identifier,operation:Y.operation,source:Y.source,context:S.context,profileLocation:S.profileLocation,applicationScoped:x.isApplicationScoped})}catch(x){throw d.URI.isUri(Y.source)||t(this.telemetryService,Y.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(Y.source),duration:new Date().getTime()-ce,error:x}),this.logService.error("Error while installing the extension:",Y.identifier.id),x}finally{ne.delete(Y.identifier.id.toLowerCase())}}))}return M.forEach(({identifier:Q})=>this.logService.info("Extension installed successfully:",Q.id)),this._onDidInstallExtensions.fire(M),M.filter(({identifier:Q})=>(0,m.areSameExtensions)(Q,H.identifier))[0].local}catch(ne){if(R.forEach(({task:Q})=>Q.cancel()),M.length)try{const Q=await Promise.allSettled(M.map(({local:oe})=>this.createUninstallExtensionTask(oe,{versionOnly:!0},S.profileLocation).run()));for(let oe=0;oe<Q.length;oe++){const Y=Q[oe],{identifier:ce}=M[oe];Y.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ce.id):this.logService.warn("Rollback: Error while uninstalling extension",ce.id,(0,L.getErrorMessage)(Y.reason))}}catch(Q){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(Q),M.map(({identifier:oe})=>oe.id))}throw this._onDidInstallExtensions.fire(R.map(({task:Q})=>({identifier:Q.identifier,operation:2,source:Q.source,context:S.context,profileLocation:S.profileLocation}))),ne}finally{for(const{task:ne}of R)if(!d.URI.isUri(ne.source)){const Q=m.ExtensionKey.create(ne.source).toString();this.installingExtensions.delete(Q)||this.logService.warn("Installation task is not found in the cache",Q)}}}async joinAllSettled(h){const p=[],S=[],R=await Promise.allSettled(h);for(const M of R)M.status==="fulfilled"?p.push(M.value):S.push(M.reason);if(S.length)throw a(S);return p}async getAllDepsAndPackExtensionsToInstall(h,p,S,R,M){if(!this.galleryService.isEnabled())return[];let H=await this.getInstalled(void 0,M);const Z=[h,...H.map(oe=>oe.identifier)],ne=[],Q=async(oe,Y)=>{const ce=Y.extensionDependencies||[],x=[...ce];if(Y.extensionPack){const j=S?H.find(K=>(0,m.areSameExtensions)(K.identifier,oe)):void 0;for(const K of Y.extensionPack)j&&j.manifest.extensionPack&&j.manifest.extensionPack.some(z=>(0,m.areSameExtensions)({id:z},{id:K}))||x.every(z=>!(0,m.areSameExtensions)({id:z},{id:K}))&&x.push(K)}if(x.length){const j=[...Z,...ne.map(z=>z.gallery.identifier)],K=x.filter(z=>j.every(A=>!(0,m.areSameExtensions)(A,{id:z})));if(K.length){const z=await this.galleryService.getExtensions(K.map(A=>({id:A,preRelease:R})),w.CancellationToken.None);for(const A of z){if(j.find(U=>(0,m.areSameExtensions)(U,A.identifier)))continue;const B=ce.some(U=>(0,m.areSameExtensions)({id:U},A.identifier));let T;try{T=await this.checkAndGetCompatibleVersion(A,!1,R)}catch(U){if(U instanceof b.ExtensionManagementError&&U.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",A.identifier.id);continue}else throw U}ne.push({gallery:T.extension,manifest:T.manifest}),await Q(T.extension.identifier,T.manifest)}}}};return await Q(h,p),H=await this.getInstalled(void 0,M),ne.filter(oe=>!H.some(Y=>(0,m.areSameExtensions)(Y.identifier,oe.gallery.identifier)))}async checkAndGetCompatibleVersion(h,p,S){const R=await this.getExtensionsControlManifest();if((0,m.getMaliciousExtensionsSet)(R).has(h.identifier.id))throw new b.ExtensionManagementError(D.localize(3,null,h.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(h)){const Z=await this.getTargetPlatform();throw new b.ExtensionManagementError(D.localize(4,null,h.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(Z)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const M=await this.getCompatibleVersion(h,p,S);if(M){if(S&&!p&&h.hasPreReleaseVersion&&!M.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(D.localize(5,null,h.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!S&&h.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([h.identifier],w.CancellationToken.None))[0]?new b.ExtensionManagementError(D.localize(6,null,h.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(D.localize(7,null,h.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",M.identifier.id);const H=await this.galleryService.getManifest(M,w.CancellationToken.None);if(H===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${h.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(H.version!==M.version)throw new b.ExtensionManagementError(`Cannot install '${h.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:M,manifest:H}}async getCompatibleVersion(h,p,S){const R=await this.getTargetPlatform();let M=null;return!p&&h.hasPreReleaseVersion&&h.properties.isPreReleaseVersion!==S&&(M=(await this.galleryService.getExtensions([{...h.identifier,preRelease:S}],{targetPlatform:R,compatible:!0},w.CancellationToken.None))[0]||null),!M&&await this.galleryService.isExtensionCompatible(h,S,R)&&(M=h),M||(p?M=(await this.galleryService.getExtensions([{...h.identifier,version:h.version}],{targetPlatform:R,compatible:!0},w.CancellationToken.None))[0]||null:M=await this.galleryService.getCompatibleExtension(h,S,R)),M}async unininstallExtension(h,p){const S=Q=>`${Q.id.toLowerCase()}${p.profileLocation?`@${p.profileLocation.toString()}`:""}`,R=this.uninstallingExtensions.get(S(h.identifier));if(R)return this.logService.info("Extensions is already requested to uninstall",h.identifier.id),R.waitUntilTaskIsFinished();const M=(Q,oe)=>{const Y=this.createUninstallExtensionTask(Q,oe,p.profileLocation);return this.uninstallingExtensions.set(S(Y.extension.identifier),Y),p.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,p.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Q.identifier.id}@${Q.manifest.version}`),this._onUninstallExtension.fire({identifier:Q.identifier,profileLocation:p.profileLocation,applicationScoped:Q.isApplicationScoped}),Y},H=(Q,oe)=>{oe?p.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,p.profileLocation.toString(),oe.message):this.logService.error("Failed to uninstall extension:",`${Q.identifier.id}@${Q.manifest.version}`,oe.message):p.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,p.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Q.identifier.id}@${Q.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(Q),error:oe}),this._onDidUninstallExtension.fire({identifier:Q.identifier,version:Q.manifest.version,error:oe?.code,profileLocation:p.profileLocation,applicationScoped:Q.isApplicationScoped})},Z=[],ne=[];try{Z.push(M(h,p));const Q=await this.getInstalled(1,p.profileLocation);if(p.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${h.identifier.id}@${h.manifest.version}`);else{const oe=this.getAllPackExtensionsToUninstall(h,Q);for(const Y of oe)this.uninstallingExtensions.has(S(Y.identifier))?this.logService.info("Extensions is already requested to uninstall",Y.identifier.id):Z.push(M(Y,p))}p.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${h.identifier.id}@${h.manifest.version}`):this.checkForDependents(Z.map(oe=>oe.extension),Q,h),await this.joinAllSettled(Z.map(async oe=>{try{if(await oe.run(),await this.joinAllSettled(this.participants.map(Y=>Y.postUninstall(oe.extension,p,w.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.galleryService.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}H(oe.extension)}catch(Y){const ce=Y instanceof b.ExtensionManagementError?Y:new b.ExtensionManagementError((0,L.getErrorMessage)(Y),b.ExtensionManagementErrorCode.Internal);throw H(oe.extension,ce),ce}finally{ne.push(oe)}}))}catch(Q){const oe=Q instanceof b.ExtensionManagementError?Q:new b.ExtensionManagementError((0,L.getErrorMessage)(Q),b.ExtensionManagementErrorCode.Internal);for(const Y of Z){try{Y.cancel()}catch{}ne.includes(Y)||H(Y.extension,oe)}throw oe}finally{for(const Q of Z)this.uninstallingExtensions.delete(S(Q.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}checkForDependents(h,p,S){for(const R of h){const M=this.getDependents(R,p);if(M.length){const H=M.filter(Z=>!h.some(ne=>(0,m.areSameExtensions)(ne.identifier,Z.identifier)));if(H.length)throw new Error(this.getDependentsErrorMessage(R,H,S))}}}getDependentsErrorMessage(h,p,S){return S===h?p.length===1?D.localize(8,null,S.manifest.displayName||S.manifest.name,p[0].manifest.displayName||p[0].manifest.name):p.length===2?D.localize(9,null,S.manifest.displayName||S.manifest.name,p[0].manifest.displayName||p[0].manifest.name,p[1].manifest.displayName||p[1].manifest.name):D.localize(10,null,S.manifest.displayName||S.manifest.name,p[0].manifest.displayName||p[0].manifest.name,p[1].manifest.displayName||p[1].manifest.name):p.length===1?D.localize(11,null,S.manifest.displayName||S.manifest.name,h.manifest.displayName||h.manifest.name,p[0].manifest.displayName||p[0].manifest.name):p.length===2?D.localize(12,null,S.manifest.displayName||S.manifest.name,h.manifest.displayName||h.manifest.name,p[0].manifest.displayName||p[0].manifest.name,p[1].manifest.displayName||p[1].manifest.name):D.localize(13,null,S.manifest.displayName||S.manifest.name,h.manifest.displayName||h.manifest.name,p[0].manifest.displayName||p[0].manifest.name,p[1].manifest.displayName||p[1].manifest.name)}getAllPackExtensionsToUninstall(h,p,S=[]){if(S.indexOf(h)!==-1)return[];S.push(h);const R=h.manifest.extensionPack?h.manifest.extensionPack:[];if(R.length){const M=p.filter(Z=>!Z.isBuiltin&&R.some(ne=>(0,m.areSameExtensions)({id:ne},Z.identifier))),H=[];for(const Z of M)H.push(...this.getAllPackExtensionsToUninstall(Z,p,S));return[...M,...H]}return[]}getDependents(h,p){return p.filter(S=>S.manifest.extensionDependencies&&S.manifest.extensionDependencies.some(R=>(0,m.areSameExtensions)({id:R},h.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const h=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",h),h}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(h,p,S){const R=this.createDefaultInstallExtensionTask(h,p,S);return S.profileLocation&&this.userDataProfilesService.defaultProfile.extensionsResource?new i(R,S.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService):R}createWaitUntilInstallExtensionTaskIsFinishedTask(h,p){return!p.profileLocation||!this.userDataProfilesService.defaultProfile.extensionsResource||h instanceof i&&this.uriIdenityService.extUri.isEqual(h.profileLocation,p.profileLocation)?h:new i(h,p.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService)}createUninstallExtensionTask(h,p,S){return S&&this.userDataProfilesService.defaultProfile.extensionsResource?new r(h,S,this.userDataProfilesService,this.extensionsProfileScannerService):this.createDefaultUninstallExtensionTask(h,p)}};v=de([se(0,c.IUserDataProfilesService),se(1,f.IUriIdentityService),se(2,b.IExtensionGalleryService),se(3,P.IExtensionsProfileScannerService),se(4,E.ITelemetryService),se(5,u.ILogService),se(6,g.IProductService)],v),e.AbstractExtensionManagementService=v;function a(o){const h=Array.isArray(o)?o:[o];return h.length===1?h[0]instanceof Error?h[0]:new Error(h[0]):h.reduce((p,S)=>new Error(`${p.message}${p.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}e.joinErrors=a;function s(o){if(o instanceof b.ExtensionManagementError)return o;const h=new b.ExtensionManagementError(o.message,b.ExtensionManagementErrorCode.Internal);return h.stack=o.stack,h}function t(o,h,{extensionData:p,duration:S,error:R,durationSinceUpdate:M}){const H=R?R instanceof b.ExtensionManagementError?R.code:b.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(h,{...p,success:!R,duration:S,errorcode:H,durationSinceUpdate:M})}e.reportTelemetry=t;class n{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(h=>this.doRun(h))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(h=>new Promise((p,S)=>{const R=h.onCancellationRequested(()=>{R.dispose(),S(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n;class i{constructor(h,p,S,R){this.task=h,this.profileLocation=p,this.defaultProfileLocation=S,this.extensionsProfileScannerService=R,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const h=await this.task.waitUntilTaskIsFinished(),p=h.local.isApplicationScoped?this.defaultProfileLocation:this.profileLocation;return await this.extensionsProfileScannerService.addExtensionsToProfile([[h.local,h.metadata]],p),h}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class r extends n{constructor(h,p,S,R){super();this.extension=h,this.profileLocation=p,this.userDataProfilesService=S,this.extensionsProfileScannerService=R}async doRun(h){const p=[];p.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)),this.extension.isApplicationScoped&&this.userDataProfilesService.defaultProfile.extensionsResource&&p.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.userDataProfilesService.defaultProfile.extensionsResource)),await Promise.all(p)}}}),define(ee[49],ie([0,1,19,4,25,15,12,51,74,2,16,14,13,17,40,55,7,9,87,18,23,37,46,11,10,8,27,3,44,38,24]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g,E,f,c,v,a,s,t,n,i,r,o,h,p,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var M;(function(ce){function x(j,K){if(j===K)return!0;const z=Object.keys(j),A=new Set;for(const B of Object.keys(K))A.add(B);if(z.length!==A.size)return!1;for(const B of z){if(j[B]!==K[B])return!1;A.delete(B)}return A.size===0}ce.equals=x})(M=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let H=class extends d.Disposable{constructor(x,j,K,z,A,B,T,U,N,$){super();this.systemExtensionsLocation=x,this.userExtensionsLocation=j,this.extensionsControlLocation=K,this.cacheLocation=z,this.userDataProfilesService=A,this.extensionsProfileScannerService=B,this.fileService=T,this.logService=U,this.environmentService=N,this.productService=$,this._onDidChangeCache=this._register(new h.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,P.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(new Q((0,P.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new Q((0,P.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.extensionsScanner=this._register(new ne(this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,a.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(x,j){const[K,z]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(j)]),A=await this.scanExtensionsUnderDevelopment(x,[...K,...z]);return this.dedupExtensions(K,z,A,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const j=[];j.push(this.scanDefaultSystemExtensions(!!x.useCache,x.language)),j.push(this.scanDevSystemExtensions(x.language,!!x.checkControlFile));const[K,z]=await Promise.all(j);return this.applyScanOptions([...K,...z],0,x,!1)}async scanUserExtensions(x){this.logService.trace("Started scanning user extensions");const j=await this.createExtensionScannerInput(x.profileLocation??this.userExtensionsLocation,!!x.profileLocation,1,!x.includeUninstalled,x.language);let z=await(x.useCache&&!j.devMode&&j.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return z=await this.applyScanOptions(z,1,x,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(x,j){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const K=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===D.Schemas.file).map(async z=>{const A=await this.createExtensionScannerInput(z,!1,1,!0,x.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(A)).map(T=>(T.type=j.find(U=>(0,a.areSameExtensions)(U.identifier,T.identifier))?.type??T.type,this.extensionsScanner.validate(T,A)))}))).flat();return this.applyScanOptions(K,"development",x,!0)}return[]}async scanExistingExtension(x,j,K){const z=await this.createExtensionScannerInput(x,!1,j,!0,K.language),A=await this.extensionsScanner.scanExtension(z);return!A||!K.includeInvalid&&!A.isValid?null:A}async scanOneOrMultipleExtensions(x,j,K){const z=await this.createExtensionScannerInput(x,!1,j,!0,K.language),A=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions(A,j,K,!0)}async scanMetadata(x){const j=(0,P.joinPath)(x,"package.json"),K=(await this.fileService.readFile(j)).value.toString();return JSON.parse(K).__metadata}async updateMetadata(x,j){const K=(0,P.joinPath)(x,"package.json"),z=(await this.fileService.readFile(K)).value.toString(),A=JSON.parse(z);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,A.__metadata={...A.__metadata,...j},await this.fileService.writeFile((0,P.joinPath)(x,"package.json"),L.VSBuffer.fromString(JSON.stringify(A,null,"	")))}async applyScanOptions(x,j,K,z){return K.includeAllVersions||(x=this.dedupExtensions(j===0?x:void 0,j===1?x:void 0,j==="development"?x:void 0,await this.getTargetPlatform(),z)),K.includeInvalid||(x=x.filter(A=>A.isValid)),x.sort((A,B)=>{const T=b.basename(A.location.fsPath),U=b.basename(B.location.fsPath);return T<U?-1:T>U?1:0})}dedupExtensions(x,j,K,z,A){const B=(U,N)=>{if(U.isValid&&!N.isValid)return!1;if(U.isValid===N.isValid){if(A&&u.gt(U.manifest.version,N.manifest.version))return this.logService.debug(`Skipping extension ${N.location.path} with lower version ${N.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(u.eq(U.manifest.version,N.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${N.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===z)return this.logService.debug(`Skipping extension ${N.location.path} from different target platform ${N.targetPlatform}`),!1}}return U.type===0?this.logService.debug(`Overwriting system extension ${U.location.path} with ${N.location.path}.`):this.logService.warn(`Overwriting user extension ${U.location.path} with ${N.location.path}.`),!0},T=new Map;return x?.forEach(U=>{const N=s.ExtensionIdentifier.toKey(U.identifier.id),$=T.get(N);(!$||B($,U))&&T.set(N,U)}),j?.forEach(U=>{const N=s.ExtensionIdentifier.toKey(U.identifier.id),$=T.get(N);if(!$&&x&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!$||B($,U))&&T.set(N,U)}),K?.forEach(U=>{const N=s.ExtensionIdentifier.toKey(U.identifier.id),$=T.get(N);(!$||B($,U))&&T.set(N,U),T.set(N,U)}),[...T.values()]}async scanDefaultSystemExtensions(x,j){this.logService.trace("Started scanning system extensions");const K=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,j),A=await(x&&!K.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(K);return this.logService.trace("Scanned system extensions:",A.length),A}async scanDevSystemExtensions(x,j){const K=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!K?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=j?await this.getBuiltInExtensionControl():{},A=[],B=f.URI.file(b.normalize(b.join(D.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const U of K){const N=z[U.name]||"marketplace";switch(N){case"disabled":break;case"marketplace":A.push((0,P.joinPath)(B,U.name));break;default:A.push(f.URI.file(N));break}}const T=await Promise.all(A.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,x))));return this.logService.trace("Scanned dev system extensions:",T.length),(0,C.coalesce)(T)}async getBuiltInExtensionControl(){try{const x=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(x.value.toString())}catch{return{}}}async createExtensionScannerInput(x,j,K,z,A,B=!0){const T=await this.getTranslations(A??m.language),U=await this.getMtime(x),N=j?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,$=N?await this.getMtime(N):void 0;return new Z(x,U,N,$,j,K,z,B,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,A,T)}async getMtime(x){try{const j=await this.fileService.stat(x);if(typeof j.mtime=="number")return j.mtime}catch{}}};H=de([se(4,R.IUserDataProfilesService),se(5,S.IExtensionsProfileScannerService),se(6,n.IFileService),se(7,r.ILogService),se(8,v.IEnvironmentService),se(9,o.IProductService)],H),e.AbstractExtensionsScannerService=H;class Z{constructor(x,j,K,z,A,B,T,U,N,$,O,F,W,_){this.location=x,this.mtime=j,this.applicationExtensionslocation=K,this.applicationExtensionslocationMtime=z,this.profile=A,this.type=B,this.excludeObsolete=T,this.validate=U,this.productVersion=N,this.productDate=$,this.productCommit=O,this.devMode=F,this.language=W,this.translations=_}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,j){return(0,P.isEqual)(x.location,j.location)&&x.mtime===j.mtime&&(0,P.isEqual)(x.applicationExtensionslocation,j.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&x.profile===j.profile&&x.type===j.type&&x.excludeObsolete===j.excludeObsolete&&x.validate===j.validate&&x.productVersion===j.productVersion&&x.productDate===j.productDate&&x.productCommit===j.productCommit&&x.devMode===j.devMode&&x.language===j.language&&M.equals(x.translations,j.translations)}}class ne extends d.Disposable{constructor(x,j,K,z){super();this.obsoleteFile=x,this.extensionsProfileScannerService=j,this.fileService=K,this.logService=z}async scanExtensions(x){const j=x.profile?await this.scanExtensionsFromProfile(x):await this.scanExtensionsFromLocation(x);let K={};if(x.excludeObsolete&&x.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();K=JSON.parse(z)}catch{}return(0,E.isEmptyObject)(K)?j:j.filter(z=>!K[a.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(x){const j=await this.fileService.resolve(x.location);if(!j.children?.length)return[];const K=await Promise.all(j.children.map(async z=>{if(!z.isDirectory||x.type===1&&(0,P.basename)(z.resource).indexOf(".")===0)return null;const A=new Z(z.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(A)}));return(0,C.coalesce)(K).sort((z,A)=>z.location.path<A.location.path?-1:1)}async scanExtensionsFromProfile(x){const j=await this.scanExtensionsFromProfileResource(x.location,()=>!0,x),K=await this.scanApplicationExtensions(x);return[...j,...K]}async scanApplicationExtensions(x){return x.applicationExtensionslocation?this.scanExtensionsFromProfileResource(x.applicationExtensionslocation,j=>!!j.metadata?.isApplicationScoped,x):[]}async scanExtensionsFromProfileResource(x,j,K){const z=await this.extensionsProfileScannerService.scanProfileExtensions(x);if(!z.length)return[];const A=await Promise.all(z.map(async B=>{if(j(B)){const T=new Z(B.location,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(T,B.metadata)}return null}));return(0,C.coalesce)(A)}async scanOneOrMultipleExtensions(x){try{if(await this.fileService.exists((0,P.joinPath)(x.location,"package.json"))){const j=await this.scanExtension(x);return j?[j]:[]}else return await this.scanExtensions(x)}catch(j){return this.logService.error(`Error scanning extensions at ${x.location.path}:`,(0,k.getErrorMessage)(j)),[]}}async scanExtension(x,j){try{let K=await this.scanExtensionManifest(x.location);if(K){K.publisher||(K.publisher=s.UNDEFINED_PUBLISHER),j=j??K.__metadata,delete K.__metadata;const z=(0,a.getGalleryExtensionId)(K.publisher,K.name),A=j?.id?{id:z,uuid:j.id}:{id:z},B=j?.isSystem?0:x.type,T=B===0||!!j?.isBuiltin;K=await this.translateManifest(x.location,K,Z.createNlsConfiguration(x));const U={type:B,identifier:A,manifest:K,location:x.location,isBuiltin:T,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return x.validate?this.validate(U,x):U}}catch(K){x.type!==0&&this.logService.error(K)}return null}validate(x,j){let K=!0;const z=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,x.manifest,x.isBuiltin);for(const[A,B]of z)A===g.default.Error&&(K=!1,this.logService.error(this.formatMessage(j.location,B)));return x.isValid=K,x.validations=z,x}async scanExtensionManifest(x){const j=(0,P.joinPath)(x,"package.json");let K;try{K=(await this.fileService.readFile(j)).value.toString()}catch(A){return(0,n.toFileOperationResult)(A)!==1&&this.logService.error(this.formatMessage(x,(0,c.localize)(0,null,j.path,A.message))),null}let z;try{z=JSON.parse(K)}catch{const B=[];(0,y.parse)(K,B);for(const T of B)this.logService.error(this.formatMessage(x,(0,c.localize)(1,null,j.path,T.offset,T.length,(0,l.getParseErrorMessage)(T.error))));return null}return(0,y.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(x,(0,c.localize)(2,null,j.path))),null):z}async translateManifest(x,j,K){const z=await this.getLocalizedMessages(x,j,K);if(z)try{const A=[],B=await this.resolveOriginalMessageBundle(z.default,A);if(A.length>0)return A.forEach(U=>{this.logService.error(this.formatMessage(x,(0,c.localize)(3,null,z.default?.path,(0,l.getParseErrorMessage)(U.error))))}),j;if((0,y.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(x,(0,c.localize)(4,null,z.default?.path))),j;const T=z.values||Object.create(null);this.replaceNLStrings(K.pseudo,j,T,B,x)}catch{}return j}async getLocalizedMessages(x,j,K){const z=(0,P.joinPath)(x,"package.nls.json"),A=(N,$)=>{$.forEach(O=>{this.logService.error(this.formatMessage(x,(0,c.localize)(5,null,N?.path,(0,l.getParseErrorMessage)(O.error))))})},B=N=>{this.logService.error(this.formatMessage(x,(0,c.localize)(6,null,N?.path)))},T=`${j.publisher}.${j.name}`,U=K.translations[T];if(U)try{const N=f.URI.file(U),$=(await this.fileService.readFile(N)).value.toString(),O=[],F=(0,y.parse)($,O);return O.length>0?(A(N,O),{values:void 0,default:z}):(0,y.getNodeType)(F)!=="object"?(B(N),{values:void 0,default:z}):{values:F.contents?F.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let $;try{$=await this.findMessageBundles(x,K)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const O=(await this.fileService.readFile($.localized)).value.toString(),F=[],W=(0,y.parse)(O,F);return F.length>0?(A($.localized,F),{values:void 0,default:$.original}):(0,y.getNodeType)(W)!=="object"?(B($.localized),{values:void 0,default:$.original}):{values:W,default:$.original}}catch{return{values:void 0,default:$.original}}}}async resolveOriginalMessageBundle(x,j){if(x)try{const K=(await this.fileService.readFile(x)).value.toString();return(0,y.parse)(K,j)}catch{return null}else return null}findMessageBundles(x,j){return new Promise((K,z)=>{const A=B=>{const T=(0,P.joinPath)(x,`package.nls.${B}.json`);this.fileService.exists(T).then(U=>{U&&K({localized:T,original:(0,P.joinPath)(x,"package.nls.json")});const N=B.lastIndexOf("-");N===-1?K({localized:(0,P.joinPath)(x,"package.nls.json"),original:null}):(B=B.substring(0,N),A(B))})};if(j.devMode||j.pseudo||!j.language)return K({localized:(0,P.joinPath)(x,"package.nls.json"),original:null});A(j.language)})}replaceNLStrings(x,j,K,z,A){const B=(T,U,N)=>{const $=T[U];if((0,E.isString)($)){const O=$,F=O.length;if(F>1&&O[0]==="%"&&O[F-1]==="%"){const W=O.substr(1,F-2);let _=K[W];_===void 0&&z&&(_=z[W]);let J=typeof _=="string"?_:typeof _?.message=="string"?_.message:void 0;J!==void 0?(x&&(J="\uFF3B"+J.replace(/[aouei]/g,"$&$&")+"\uFF3D"),T[U]=N&&(U==="title"||U==="category")&&z?{value:J,original:z[W]}:J):this.logService.warn(this.formatMessage(A,(0,c.localize)(7,null,W)))}}else if((0,E.isObject)($))for(const O in $)$.hasOwnProperty(O)&&(O==="commands"?B($,O,!0):B($,O,N));else if((0,E.isArray)($))for(let O=0;O<$.length;O++)B($,O,N)};for(const T in j)j.hasOwnProperty(T)&&B(j,T)}formatMessage(x,j){return`[${x.path}]: ${j}`}}class Q extends ne{constructor(x,j,K,z,A){super(j,K,z,A);this.cacheFile=x,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new h.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(x){const j=await this.readExtensionCache();if(this.input=x,j&&j.input&&Z.equals(j.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),j.result.map(z=>(z.location=f.URI.revive(z.location),z));const K=await super.scanExtensions(x);return await this.writeExtensionCache({input:x,result:K}),K}async readExtensionCache(){try{const x=await this.fileService.readFile(this.cacheFile),j=JSON.parse(x.value.toString());return{result:j.result,input:(0,p.revive)(j.input)}}catch(x){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(x))}return null}async writeExtensionCache(x){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(x)))}catch(j){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(j))}}async validateCache(){if(!this.input)return;const x=await this.readExtensionCache();if(!x)return;const j=x.result,K=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!w.equals(K,j))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}}function oe(ce,x){const j=(0,a.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:j,identifier:new s.ExtensionIdentifier(j),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:x,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=oe;class Y extends H{constructor(x,j,K,z,A,B,T,U,N,$){super(x,j,(0,P.joinPath)(K,".vscode-oss-dev","extensions","control.json"),(0,P.joinPath)(z,s.MANIFEST_CACHE_FOLDER),A,B,T,U,N,$);this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const O=await this.fileService.readFile(f.URI.file(m.translationsConfigFile));return JSON.parse(O.value.toString())}catch{}return Object.create(null)})()}getTranslations(x){return this.translationsPromise}}e.NativeExtensionsScannerService=Y}),define(ee[139],ie([0,1,45,4,29,3,2,16,14,20,8,24]),function(q,e,C,I,w,L,k,y,l,d,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends k.Disposable{constructor(u,g){super();this.userDataProfilesService=u,this.logService=g,this.processesLimiter=new I.Limiter(5)}async postUninstall(u){const g=this.parseScript(u,"uninstall");return g&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${E}`)))),d.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(u,g){const E=`vscode:${g}`;if(u.location.scheme===y.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[E]=="string"){const f=u.manifest.scripts[E].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${E} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(u,g,E,f,c){return new Promise((v,a)=>{const s=this.start(u,g,E,c);let t;const n=i=>{t&&(clearTimeout(t),t=null),i?a(i):v(void 0)};s.on("error",i=>{n((0,w.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${g} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,s.kill(),a("timed out")},5e3))})}start(u,g,E,f){const c={silent:!0,execArgv:void 0},v=(0,C.fork)(u,[`--type=extension-post-${g}`,...E],c);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const a=L.Event.fromNodeEventEmitter(v.stdout,"data"),s=L.Event.fromNodeEventEmitter(v.stderr,"data");a(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${g}`,i)),s(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${g}`,i));const t=L.Event.any(L.Event.map(a,i=>({data:`%c${i}`,format:[""]})),L.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),v}getExtensionStoragePath(u){return(0,l.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};m=de([se(0,b.IUserDataProfilesService),se(1,D.ILogService)],m),e.ExtensionsLifecycle=m}),define(ee[140],ie([0,1,9,18,38,49,11,8,27,24]),function(q,e,C,I,w,L,k,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let D=class extends L.NativeExtensionsScannerService{constructor(m,P,u,g,E,f){super(C.URI.file(E.builtinExtensionsPath),C.URI.file(E.extensionsPath),E.userHome,C.URI.file(E.userDataPath),m,P,u,g,E,f)}};D=de([se(0,d.IUserDataProfilesService),se(1,w.IExtensionsProfileScannerService),se(2,k.IFileService),se(3,y.ILogService),se(4,I.INativeEnvironmentService),se(5,l.IProductService)],D),e.ExtensionsScannerService=D}),define(ee[141],ie([0,1,4,3,2,112,7,77,10,24]),function(q,e,C,I,w,L,k,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const D="__$__targetStorageMarker";e.IStorageService=(0,l.createDecorator)("storageService");var b;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var m;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(m=e.StorageScope||(e.StorageScope={}));var P;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(P=e.StorageTarget||(e.StorageTarget={}));class u extends w.Disposable{constructor(v={flushInterval:u.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,a){if(a===D){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:a,target:this.getKeyTargets(v)[a]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,a,s){return this.getStorage(a)?.get(v,s)}getBoolean(v,a,s){return this.getStorage(a)?.getBoolean(v,s)}getNumber(v,a,s){return this.getStorage(a)?.getNumber(v,s)}store(v,a,s,t){if((0,k.isUndefinedOrNull)(a)){this.remove(v,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,s,t),this.getStorage(s)?.set(v,a)})}remove(v,a){this.withPausedEmitters(()=>{this.updateKeyTarget(v,a,void 0),this.getStorage(a)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,a){const s=[],t=this.getKeyTargets(v);for(const n of Object.keys(t))t[n]===a&&s.push(n);return s}updateKeyTarget(v,a,s){const t=this.getKeyTargets(a);typeof s=="number"?t[v]!==s&&(t[v]=s,this.getStorage(a)?.set(D,JSON.stringify(t))):typeof t[v]=="number"&&(delete t[v],this.getStorage(a)?.set(D,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const a=this.get(D,v);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=b.NONE){this._onWillSaveState.fire({reason:v});const a=this.getStorage(-1),s=this.getStorage(0),t=this.getStorage(1);switch(v){case b.NONE:await C.Promises.settled([a?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await C.Promises.settled([a?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,a=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return f(v,a,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(v,a){return this.emitWillSaveState(b.NONE),(0,d.isUserDataProfile)(v)?this.switchToProfile(v,a):this.switchToWorkspace(v,a)}canSwitchProfile(v,a){return!(v.id===a.id||g(a)&&g(v))}switchData(v,a,s,t){this.withPausedEmitters(()=>{if(t)for(const[n,i]of v)a.set(n,i);else{const n=new Set;for(const[i,r]of v)n.add(i),a.get(i)!==r&&this.emitDidChangeValue(s,i);for(const[i]of a.items)n.has(i)||this.emitDidChangeValue(s,i)}})}}e.AbstractStorageService=u,u.DEFAULT_FLUSH_INTERVAL=60*1e3;function g(c){return c.isDefault||!!c.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class E extends u{constructor(){super();this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=E;async function f(c,v,a,s,t,n){const i=Z=>{try{return JSON.parse(Z)}catch{return Z}},r=new Map,o=new Map;c.forEach((Z,ne)=>{r.set(ne,Z),o.set(ne,i(Z))});const h=new Map,p=new Map;v.forEach((Z,ne)=>{h.set(ne,Z),p.set(ne,i(Z))});const S=new Map,R=new Map;a.forEach((Z,ne)=>{S.set(ne,Z),R.set(ne,i(Z))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const M=[];if(r.forEach((Z,ne)=>{M.push({key:ne,value:Z})}),console.table(M),console.groupEnd(),console.log(o),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Z=[];h.forEach((ne,Q)=>{Z.push({key:Q,value:ne})}),console.table(Z),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${n})`);const H=[];S.forEach((Z,ne)=>{H.push({key:ne,value:Z})}),console.table(H),console.groupEnd(),console.log(R)}e.logStorage=f}),define(ee[142],ie([0,1,19,26,12,13,31,7,9,21,18,22,23,46,11,8,27,48,131,141,33]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g,E,f,c,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,b.getTargetPlatform)(L.platform,k.arch);var t;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...O){return String(O.reduce((F,W)=>F|W,0))}var i;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class S{constructor(F=p){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,W=this.state.pageSize){return new S({...this.state,pageNumber:F,pageSize:W})}withFilter(F,...W){const _=[...this.state.criteria,...W.length?W.map(J=>({filterType:F,value:J})):[{filterType:F}]];return new S({...this.state,criteria:_})}withSortBy(F){return new S({...this.state,sortBy:F})}withSortOrder(F){return new S({...this.state,sortOrder:F})}withFlags(...F){return new S({...this.state,flags:F.reduce((W,_)=>W|_,0)})}withAssetTypes(...F){return new S({...this.state,assetTypes:F})}withSource(F){return new S({...this.state,source:F})}get raw(){const{criteria:F,pageNumber:W,pageSize:_,sortBy:J,sortOrder:te,flags:le,assetTypes:ue}=this.state;return{filters:[{criteria:F,pageNumber:W,pageSize:_,sortBy:J,sortOrder:te}],assetTypes:ue,flags:le}}get searchText(){const F=this.state.criteria.filter(W=>W.filterType===i.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function R(O,F){const W=(O||[]).filter(_=>_.statisticName===F)[0];return W?W.value:0}function M(O){const F="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(_=>_.assetType.indexOf(F)===0).reduce((_,J)=>{const te=ne(O,J.assetType);return te&&_.push([J.assetType.substring(F.length),te]),_},[])}function H(O){if(O.properties){const F=O.properties.filter(J=>J.key===r.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=F.filter(J=>W.test(J.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return ne(O,r.Repository)}function Z(O){return{uri:`${O.fallbackAssetUri}/${r.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${r.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function ne(O,F){return O.files.filter(_=>_.assetType===F)[0]?{uri:`${O.assetUri}/${F}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${F}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function Q(O,F){const W=O.properties?O.properties.filter(J=>J.key===F):[],_=W.length>0&&W[0].value;return _?_.split(",").map(J=>(0,m.adoptToGalleryExtensionId)(J)):[]}function oe(O){const F=O.properties?O.properties.filter(W=>W.key===o.Engine):[];return F.length>0&&F[0].value||""}function Y(O){const F=O.properties?O.properties.filter(W=>W.key===o.PreRelease):[];return F.length>0&&F[0].value==="true"}function ce(O){const F=O.properties?O.properties.filter(_=>_.key===o.LocalizedLanguages):[],W=F.length>0&&F[0].value||"";return W?W.split(","):[]}function x(O){return O.properties?.find(F=>F.key===o.SponsorLink)?.value}function j(O){return O.indexOf("preview")!==-1}function K(O){return O.targetPlatform?(0,b.toTargetPlatform)(O.targetPlatform):"undefined"}function z(O){const F=(0,C.distinct)(O.versions.map(K)),W=!!O.tags?.includes(b.WEB_EXTENSION_TAG),_=F.indexOf("web");return W?_===-1&&F.push("web"):_!==-1&&F.splice(_,1),F}function A(O,F){const W=(0,b.getFallbackTargetPlarforms)(F);for(let _=0;_<O.length;_++){const J=O[_];if(J.version===O[_-1]?.version){let te=_;const le=K(J);if(le===F)for(;te>0&&O[te-1].version===J.version;)te--;else if(W.includes(le))for(;te>0&&O[te-1].version===J.version&&K(O[te-1])!==F;)te--;te!==_&&(O.splice(_,1),O.splice(te,0,J))}}return O}e.sortExtensionVersions=A;function B(O,F,W){O.telemetryData={index:F,querySource:W}}function T(O,F,W){const _=O.versions[0],J={manifest:ne(F,r.Manifest),readme:ne(F,r.Details),changelog:ne(F,r.Changelog),license:ne(F,r.License),repository:H(F),download:Z(F),icon:ne(F,r.Icon),coreTranslations:M(F)};return{identifier:{id:(0,m.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:F.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(_),description:O.shortDescription||"",installCount:R(O.statistics,"install"),rating:R(O.statistics,"averagerating"),ratingCount:R(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:W,assets:J,properties:{dependencies:Q(F,o.Dependency),extensionPack:Q(F,o.ExtensionPack),engine:oe(F),localizedLanguages:ce(F),targetPlatform:K(F),isPreReleaseVersion:Y(F)},hasPreReleaseVersion:Y(_),hasReleaseVersion:!0,preview:j(O.flags)}}let U=class{constructor(F,W,_,J,te,le,ue,pe){this.requestService=W,this.logService=_,this.environmentService=J,this.telemetryService=te,this.fileService=le,this.productService=ue,this.configurationService=pe;const ve=ue.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,c.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,F,this.telemetryService)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,W,_){const J=I.CancellationToken.isCancellationToken(W)?{}:W,te=I.CancellationToken.isCancellationToken(W)?W:_,le=[],ue=[],pe=[],ve=[];let re=!0;for(const ge of F){ge.uuid?ue.push(ge.uuid):le.push(ge.id);const ye=!!(ge.version||ge.preRelease);pe.push({id:ge.id,uuid:ge.uuid,includePreRelease:ye}),ge.version&&ve.push({id:ge.id,uuid:ge.uuid,version:ge.version}),re=re&&!!ge.hasPreRelease&&!ye}if(!ue.length&&!le.length)return[];let ae=new S().withPage(1,F.length);ue.length&&(ae=ae.withFilter(i.ExtensionId,...ue)),le.length&&(ae=ae.withFilter(i.ExtensionName,...le)),(J.queryAllVersions||re)&&(ae=ae.withFlags(ae.flags,t.IncludeVersions)),J.source&&(ae=ae.withSource(J.source));const{extensions:he}=await this.queryGalleryExtensions(ae,{targetPlatform:J.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!J.compatible},te);return J.source&&he.forEach((ge,ye)=>B(ge,ye,J.source)),he}async getCompatibleExtension(F,W,_){if((0,b.isNotWebExtensionInWebTargetPlatform)(F.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(F,W,_))return F;const J=new S().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,F.identifier.uuid),{extensions:te}=await this.queryGalleryExtensions(J,{targetPlatform:_,compatible:!0,includePreRelease:W},I.CancellationToken.None);return te[0]||null}async isExtensionCompatible(F,W,_){if(!(0,b.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,_)||!W&&F.properties.isPreReleaseVersion)return!1;let J=F.properties.engine;if(!J){const te=await this.getManifest(F,I.CancellationToken.None);if(!te)throw new Error("Manifest was not found");J=te.engines.vscode}return(0,P.isEngineValid)(J,this.productService.version,this.productService.date)}async isValidVersion(F,W,_,J,te){if(!(0,b.isTargetPlatformCompatible)(K(F),J,te)||W!=="any"&&Y(F)!==(W==="prerelease"))return!1;if(_)try{const le=await this.getEngine(F);if(!(0,P.isEngineValid)(le,this.productService.version,this.productService.date))return!1}catch(le){return this.logService.error(`Error while getting the engine for the version ${F.version}.`,(0,w.getErrorMessage)(le)),!1}return!0}async query(F,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=F.text||"";const J=F.pageSize??50;let te=new S().withPage(1,J);_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,ae,he)=>(te=te.withFilter(i.Category,he||ae),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,ae,he)=>(te=te.withFilter(i.Tag,he||ae),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(i.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),te=te.withFilter(i.SearchText,_)),te=te.withSortBy(0)):F.ids?te=te.withFilter(i.ExtensionId,...F.ids):F.names?te=te.withFilter(i.ExtensionName,...F.names):te=te.withSortBy(4),typeof F.sortBy=="number"&&(te=te.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(te=te.withSortOrder(F.sortOrder)),F.source&&(te=te.withSource(F.source));const le=async(re,ae)=>{const{extensions:he,total:ge}=await this.queryGalleryExtensions(re,{targetPlatform:s,compatible:!1,includePreRelease:!!F.includePreRelease},ae);return he.forEach((ye,Te)=>B(ye,(re.pageNumber-1)*re.pageSize+Te,F.source)),{extensions:he,total:ge}},{extensions:ue,total:pe}=await le(te,W),ve=async(re,ae)=>{if(ae.isCancellationRequested)throw new w.CancellationError;const{extensions:he}=await le(te.withPage(re+1),ae);return he};return{firstPage:ue,total:pe,pageSize:te.pageSize,getPage:ve}}async queryGalleryExtensions(F,W,_){const J=F.flags;!!(F.flags&t.IncludeLatestVersionOnly)&&!!(F.flags&t.IncludeVersions)&&(F=F.withFlags(F.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(F.flags&t.IncludeLatestVersionOnly)&&!(F.flags&t.IncludeVersions)&&(F=F.withFlags(F.flags,t.IncludeLatestVersionOnly)),W.versions?.length&&(F=F.withFlags(F.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),F=F.withFlags(F.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:le}=await this.queryRawGalleryExtensions(F,_);if(!(F.flags&t.IncludeLatestVersionOnly)){const re=[];for(const ae of te){const he=await this.toGalleryExtensionWithCriteria(ae,W);he&&re.push(he)}return{extensions:re,total:le}}const pe=[],ve=new Map;for(let re=0;re<te.length;re++){const ae=te[re],he={id:(0,m.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),uuid:ae.extensionId},ge=(0,y.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Te=>(0,m.areSameExtensions)(Te,he))?.includePreRelease;if(W.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(z(ae),W.targetPlatform))continue;const ye=await this.toGalleryExtensionWithCriteria(ae,W);!ye||ye.properties.isPreReleaseVersion&&(!ge||!ye.hasReleaseVersion)||!ye.properties.isPreReleaseVersion&&ye.properties.targetPlatform!==W.targetPlatform&&ye.hasPreReleaseVersion?ve.set(ae.extensionId,re):pe.push([re,ye])}if(ve.size){const re=new Date().getTime(),ae=new S().withFlags(J&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ve.size).withFilter(i.ExtensionId,...ve.keys()),{extensions:he}=await this.queryGalleryExtensions(ae,W,_);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-re,count:ve.size});for(const ge of he){const ye=ve.get(ge.identifier.uuid);pe.push([ye,ge])}}return{extensions:pe.sort((re,ae)=>re[0]-ae[0]).map(([,re])=>re),total:le}}async toGalleryExtensionWithCriteria(F,W){const _={id:(0,m.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},J=W.versions?.find(pe=>(0,m.areSameExtensions)(pe,_))?.version,te=(0,y.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(pe=>(0,m.areSameExtensions)(pe,_))?.includePreRelease,le=z(F),ue=A(F.versions,W.targetPlatform);if(W.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(le,W.targetPlatform))return null;for(let pe=0;pe<ue.length;pe++){const ve=ue[pe];if(!(J&&ve.version!==J)){if(await this.isValidVersion(ve,te?"any":"release",W.compatible,le,W.targetPlatform))return T(F,ve,le);if(J&&ve.version===J)return null}}return J||W.compatible?null:T(F,F.versions[0],le)}async queryRawGalleryExtensions(F,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(t.Unpublished));const _=await this.commonHeadersPromise,J=JSON.stringify(F.raw),te={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},le=new Date().getTime();let ue,pe,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:J,headers:te},W),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const re=await(0,f.asJson)(ue);if(re){const ae=re.results[0],he=ae.extensions,ge=ae.resultMetadata&&ae.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return ve=ge&&ge.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:ve}}return{galleryExtensions:[],total:ve}}catch(re){throw pe=re,re}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-le,success:!!ue&&(0,f.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(F,W,_,J){if(!this.isEnabled())return;const te=L.isWeb?this.api(`/itemName/${F}.${W}/version/${_}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${W}/${_}/stats?statType=${J}`),le=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:le};try{await this.requestService.request({type:"POST",url:te,headers:pe},I.CancellationToken.None)}catch{}}async download(F,W,_){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const J=(0,m.getGalleryExtensionTelemetryData)(F),te=new Date().getTime(),le=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...J,duration:re}),ue=_===2?"install":_===3?"update":"",pe=ue?{uri:`${F.assets.download.uri}${l.URI.parse(F.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${F.assets.download.fallbackUri}${l.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:F.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(W,ve.stream),le(new Date().getTime()-te)}async getReadme(F,W){if(F.assets.readme){const _=await this.getAsset(F.assets.readme,{},W);return await(0,f.asTextOrError)(_)||""}return""}async getManifest(F,W){if(F.assets.manifest){const _=await this.getAsset(F.assets.manifest,{},W),J=await(0,f.asTextOrError)(_);return J?JSON.parse(J):null}return null}async getManifestFromRawExtensionVersion(F,W){const _=ne(F,r.Manifest);if(!_)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},te=await this.getAsset(_,{headers:J});return await(0,f.asJson)(te)}async getCoreTranslation(F,W){const _=F.assets.coreTranslations.filter(J=>J[0]===W.toUpperCase())[0];if(_){const J=await this.getAsset(_[1]),te=await(0,f.asTextOrError)(J);return te?JSON.parse(te):null}return null}async getChangelog(F,W){if(F.assets.changelog){const _=await this.getAsset(F.assets.changelog,{},W);return await(0,f.asTextOrError)(_)||""}return""}async getAllCompatibleVersions(F,W,_){let J=new S().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?J=J.withFilter(i.ExtensionId,F.identifier.uuid):J=J.withFilter(i.ExtensionName,F.identifier.id);const{galleryExtensions:te}=await this.queryRawGalleryExtensions(J,I.CancellationToken.None);if(!te.length)return[];const le=z(te[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(le,_))return[];const ue=[];await Promise.all(te[0].versions.map(async re=>{try{await this.isValidVersion(re,W?"any":"release",!0,le,_)&&ue.push(re)}catch{}}));const pe=[],ve=new Set;for(const re of A(ue,_))ve.has(re.version)||(ve.add(re.version),pe.push({version:re.version,date:re.lastUpdated,isPreReleaseVersion:Y(re)}));return pe}async getAsset(F,W={},_=I.CancellationToken.None){const J=await this.commonHeadersPromise,te={type:"GET"},le={...J,...W.headers||{}};W={...W,...te,headers:le};const ue=F.uri,pe=F.fallbackUri,ve={...W,url:ue};try{const re=await this.requestService.request(ve,_);if(re.res.statusCode===200)return re;const ae=await(0,f.asTextOrError)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${ae}`)}catch(re){if((0,w.isCancellationError)(re))throw re;const ae=(0,w.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:ae});const he={...W,url:pe};return this.requestService.request(he,_)}}async getEngine(F){let W=oe(F);if(!W){const _=await this.getManifestFromRawExtensionVersion(F,I.CancellationToken.None);if(!_)throw new Error("Manifest was not found");W=_.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,f.asJson)(F),_=[],J={};if(W){for(const te of W.malicious)_.push({id:te});if(W.migrateToPreRelease)for(const[te,le]of Object.entries(W.migrateToPreRelease))(!le.engine||(0,P.isEngineValid)(le.engine,this.productService.version,this.productService.date))&&(J[te.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[te,le]of Object.entries(W.deprecated))le&&(J[te.toLowerCase()]=(0,y.isBoolean)(le)?{}:le)}return{malicious:_,deprecated:J}}};U=de([se(1,f.IRequestService),se(2,g.ILogService),se(3,D.IEnvironmentService),se(4,a.ITelemetryService),se(5,u.IFileService),se(6,E.IProductService),se(7,d.IConfigurationService)],U);let N=class extends U{constructor(F,W,_,J,te,le,ue,pe){super(F,W,_,J,te,le,ue,pe)}};N=de([se(0,v.IStorageService),se(1,f.IRequestService),se(2,g.ILogService),se(3,D.IEnvironmentService),se(4,a.ITelemetryService),se(5,u.IFileService),se(6,E.IProductService),se(7,d.IConfigurationService)],N),e.ExtensionGalleryService=N;let $=class extends U{constructor(F,W,_,J,te,le,ue){super(void 0,F,W,_,J,te,le,ue)}};$=de([se(0,f.IRequestService),se(1,g.ILogService),se(2,D.IEnvironmentService),se(3,a.ITelemetryService),se(4,u.IFileService),se(5,E.IProductService),se(6,d.IConfigurationService)],$),e.ExtensionGalleryServiceWithNoStorageService=$}),define(ee[143],ie([0,1,99,14,35,17,9,10,16]),function(q,e,C,I,w,L,k,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function d(i){const r=i;return typeof r?.id=="string"&&k.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=d;function D(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=D;function b(i){const r=i;return typeof r?.id=="string"&&k.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=b;function m(i){const r=i;if(r?.uri)return{id:r.id,uri:k.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:k.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var P;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function u(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=u;function g(i){const r=i;return!!(r&&typeof r=="object"&&k.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=g;class E{constructor(r,o,h,p,S){this._id=r,this._transient=h,this._configuration=p,this._ignorePathCasing=S,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class f{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,L.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function c(i){return new f({uri:i,index:0,name:(0,L.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=c,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(i,r){return L.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function s(i){let r;return k.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===l.Schemas.tmp}e.isTemporaryWorkspace=s;function t(i,r){return!a(i,r)&&!s(i)}e.isSavedWorkspace=t;function n(i){return(typeof i=="string"?(0,I.extname)(i):(0,L.extname)(i))===v}e.hasWorkspaceFileExtension=n}),define(ee[144],ie([0,1,35,44,9,18,11,8,65,28,24,143]),function(q,e,C,I,w,L,k,y,l,d,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class je extends D.UserDataProfilesService{constructor(u,g,E,f,c){super(E,f,c);this.stateService=u,this.uriIdentityService=g,this.enabled=!1}setEnablement(u){this._profilesObject=void 0,this.enabled=u}get profilesObject(){if(!this.enabled)return{profiles:[],workspaces:new C.ResourceMap};if(!this._profilesObject){const u=this.getStoredProfiles().map(f=>(0,D.toUserDataProfile)(f.name,f.location,f.useDefaultFlags));let g;const E=new C.ResourceMap;if(u.length){u.unshift(this.createDefaultUserDataProfile(!0));const f=this.getStoredProfileAssociations();if(f.workspaces)for(const[c,v]of Object.entries(f.workspaces)){const a=w.URI.parse(c),s=w.URI.parse(v),t=u.find(n=>this.uriIdentityService.extUri.isEqual(n.location,s));t&&E.set(a,t)}if(f.emptyWindow){const c=w.URI.parse(f.emptyWindow);g=u.find(v=>this.uriIdentityService.extUri.isEqual(v.location,c))}}this._profilesObject={profiles:u,workspaces:E,emptyWindow:g}}return this._profilesObject}get profiles(){return this.profilesObject.profiles}getProfile(u){const g=this.getWorkspace(u);return(w.URI.isUri(g)?this.profilesObject.workspaces.get(g):this.profilesObject.emptyWindow)??this.defaultProfile}getWorkspace(u){return(0,b.isSingleFolderWorkspaceIdentifier)(u)?u.uri:(0,b.isWorkspaceIdentifier)(u)?u.configPath:"empty-window"}getStoredProfiles(){return(0,I.revive)(this.stateService.getItem(je.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,I.revive)(this.stateService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{}))}};m.PROFILES_KEY="userDataProfiles",m.PROFILE_ASSOCIATIONS_KEY="profileAssociations",m=de([se(0,l.IStateService),se(1,d.IUriIdentityService),se(2,L.IEnvironmentService),se(3,k.IFileService),se(4,y.ILogService)],m),e.UserDataProfilesService=m}),define(ee[145],ie([0,1,36,4,156,2]),function(q,e,C,I,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class k extends C.AbstractPolicyService{constructor(l){super();this.productName=l,this.throttler=new I.Throttler,this.watcher=this._register(new L.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((d,D)=>{try{this.watcher.value=(0,w.createWatcher)(this.productName,l,b=>{for(const m in b){const P=b[m];P===void 0?this.policies.delete(m):this.policies.set(m,P)}this._onDidChange.fire(Object.keys(b)),d()})}catch(b){D(b)}}))}}e.NativePolicyService=k}),define(ee[66],ie([0,1,114,4,14,7,20,82,157,158]),function(q,e,C,I,w,L,k,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(t,n){let i=n.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=n}}e.ExtractError=D;function b(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,i)=>n+i,t&61440)}function m(s){if(s instanceof D)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new D(t,s)}function P(s,t,n,i,r,o){const h=w.dirname(t),p=w.join(i,h);if(!p.startsWith(i))return Promise.reject(new Error(y.localize(0,null,t)));const S=w.join(i,t);let R;return o.onCancellationRequested(()=>{R&&R.destroy()}),Promise.resolve(k.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((M,H)=>{if(!o.isCancellationRequested)try{R=(0,C.createWriteStream)(S,{mode:n}),R.once("close",()=>M()),R.once("error",H),s.once("error",H),s.pipe(R)}catch(Z){H(Z)}}))}function u(s,t,n,i){let r=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((h,p)=>{const S=new I.Sequencer,R=M=>{M.isCancellationRequested||(o++,s.readEntry())};s.once("error",p),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===o?h():p(new D("Incomplete",new Error(y.localize(1,null,o,s.entryCount))))},p)),s.readEntry(),s.on("entry",M=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(M.fileName)){R(i);return}const H=M.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(H)){const Q=w.join(t,H);r=(0,I.createCancelablePromise)(oe=>k.Promises.mkdir(Q,{recursive:!0}).then(()=>R(oe)).then(void 0,p));return}const Z=E(s,M),ne=b(M);r=(0,I.createCancelablePromise)(Q=>S.queue(()=>Z.then(oe=>P(oe,H,ne,t,n,Q).then(()=>R(Q)))).then(null,p))})})}function g(s,t=!1){return new Promise((n,i)=>{(0,l.open)(s,t?{lazyEntries:!0}:void 0,(r,o)=>{r?i(m(r)):n((0,L.assertIsDefined)(o))})})}function E(s,t){return new Promise((n,i)=>{s.openReadStream(t,(r,o)=>{r?i(m(r)):n((0,L.assertIsDefined)(o))})})}function f(s,t){return new Promise((n,i)=>{const r=new d.ZipFile;t.forEach(h=>{h.contents?r.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&r.addFile(h.localPath,h.path)}),r.end();const o=(0,C.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(s))})}e.zip=f;function c(s,t,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=g(s,!0);return n.overwrite&&(o=o.then(h=>k.Promises.rm(t).then(()=>h))),o.then(h=>u(h,t,{sourcePathRegex:r},i))}e.extract=c;function v(s,t){return g(s).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===t&&E(n,o).then(h=>i(h),h=>r(h))}),n.once("close",()=>r(new Error(y.localize(2,null,t))))}))}function a(s,t){return v(s,t).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",h=>o.push(h)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=a}),define(ee[146],ie([0,1,66,89]),function(q,e,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function w(L){return(0,C.buffer)(L,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}e.getManifest=w}),define(ee[147],ie([0,1,4,29,12,2,16,14,13,17,40,7,9,34,20,66,88,58,18,138,22,23,38,49,122,139,146,123,136,37,46,11,10,8,27,33,28,24]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g,E,f,c,v,a,s,t,n,i,r,o,h,p,S,R,M,H,Z,ne,Q,oe,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,H.refineServiceDecorator)(a.IServerExtensionManagementService);let ce=class extends v.AbstractExtensionManagementService{constructor(T,U,N,$,O,F,W,_,J,te,le,ue){super(ue,le,T,F,U,N,te);this.environmentService=$,this.extensionsScannerService=O,this.downloadService=W,this.fileService=J;const pe=this._register(_.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(_.createInstance(x,re=>pe.postUninstall(re))),this.manifestCache=this._register(new h.ExtensionsManifestCache($,this)),this.extensionsDownloader=this._register(_.createInstance(i.ExtensionsDownloader));const ve=this._register(new p.ExtensionsWatcher(this,J,$,N,le));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:re,removed:ae})=>{re.length&&this._onDidInstallExtensions.fire(re.map(he=>({identifier:he.identifier,operation:1,local:he}))),ae.forEach(he=>this._onDidUninstallExtension.fire({identifier:he}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const U=await this.collectFiles(T),N=await(0,g.zip)((0,d.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)()).fsPath,U);return m.URI.file(N)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const U=await this.downloadVsix(T),N=y.resolve(U.fsPath);return(0,o.getManifest)(N)}getInstalled(T,U){return this.extensionsScanner.scanExtensions(T??null,U)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(T,U={}){this.logService.trace("ExtensionManagementService#install",T.toString());const N=await this.downloadVsix(T),$=await(0,o.getManifest)(y.resolve(N.fsPath));if($.engines&&$.engines.vscode&&!(0,R.isEngineValid)($.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,(0,s.getGalleryExtensionId)($.publisher,$.name),this.productService.version));return this.installExtension($,N,U)}getMetadata(T){return this.extensionsScannerService.scanMetadata(T.location)}async updateMetadata(T,U){this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id);const N={...U};return U.isPreReleaseVersion&&(N.preRelease=!0),T=await this.extensionsScanner.updateMetadata(T,N),this.manifestCache.invalidate(),T}async updateExtensionScope(T,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.updateMetadata(T,{isMachineScoped:U}),this.manifestCache.invalidate(),T}removeUninstalledExtensions(T){return this.extensionsScanner.cleanUp(T)}async downloadVsix(T){if(T.scheme===k.Schemas.file)return T;const U=(0,d.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)());return await this.downloadService.download(T,U),U}createDefaultInstallExtensionTask(T,U,N){return m.URI.isUri(U)?new z(T,U,N,this.galleryService,this.extensionsScanner,this.logService):new K(T,U,N,this.extensionsDownloader,this.extensionsScanner,this.logService)}createDefaultUninstallExtensionTask(T,U){return new A(T,U,this.extensionsScanner)}async collectFiles(T){const U=async $=>{let O=await u.Promises.readdir($);O=O.map(_=>y.join($,_));const F=await Promise.all(O.map(_=>u.Promises.stat(_)));let W=Promise.resolve([]);return F.forEach((_,J)=>{const te=O[J];_.isFile()&&(W=W.then(le=>[...le,te])),_.isDirectory()&&(W=W.then(le=>U(te).then(ue=>[...le,...ue])))}),W};return(await U(T.location.fsPath)).map($=>({path:`extension/${y.relative(T.location.fsPath,$)}`,localPath:$}))}};ce=de([se(0,a.IExtensionGalleryService),se(1,Q.ITelemetryService),se(2,Z.ILogService),se(3,c.INativeEnvironmentService),se(4,n.IExtensionsScannerService),se(5,t.IExtensionsProfileScannerService),se(6,f.IDownloadService),se(7,H.IInstantiationService),se(8,M.IFileService),se(9,ne.IProductService),se(10,oe.IUriIdentityService),se(11,Y.IUserDataProfilesService)],ce),e.ExtensionManagementService=ce;let x=class extends L.Disposable{constructor(T,U,N,$){super();this.beforeRemovingExtension=T,this.fileService=U,this.extensionsScannerService=N,this.logService=$,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new C.Queue}async cleanUp(T){await this.removeUninstalledExtensions(),T&&await this.removeOutdatedExtensions()}async scanExtensions(T,U){const N={includeInvalid:!0,profileLocation:U};let $=[];return T===null||T===0?$.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},N)):T===1&&$.push(...await this.extensionsScannerService.scanUserExtensions(N)),$=T!==null?$.filter(O=>O.type===T):$,Promise.all($.map(O=>this.toLocalExtension(O)))}async scanUserExtensions(T){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(U.map(N=>this.toLocalExtension(N)))}async extractUserExtension(T,U,N,$){const O=T.toString(),F=y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,P.generateUuid)()}`),W=y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,O);try{await u.Promises.rm(W)}catch{throw new a.ExtensionManagementError(E.localize(1,null,W,T.id),a.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(T,U,F,$),N={...N,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(m.URI.file(F),N);try{await this.rename(T,F,W,Date.now()+2*60*1e3),this.logService.info("Renamed to",W)}catch(_){try{await u.Promises.rm(F)}catch{}if(_.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(_)}. Deleted from extracted location`,F),_}return this.scanLocalExtension(m.URI.file(W),1)}async updateMetadata(T,U){return await this.extensionsScannerService.updateMetadata(T.location,U),this.scanLocalExtension(T.location,T.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...T){const U=T.map(N=>s.ExtensionKey.create(N));await this.withUninstalledExtensions(N=>{U.forEach($=>N[$.toString()]=!0)})}async setInstalled(T){await this.withUninstalledExtensions($=>delete $[T.toString()]);const N=(await this.scanUserExtensions(!0)).find($=>s.ExtensionKey.create($).equals(T))||null;return N?this.updateMetadata(N,{installedTimestamp:Date.now()}):null}async removeExtension(T,U){this.logService.trace(`Deleting ${U} extension from disk`,T.identifier.id,T.location.fsPath),await u.Promises.rm(T.location.fsPath),this.logService.info("Deleted from disk",T.identifier.id,T.location.fsPath)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[s.ExtensionKey.create(T).toString()])}async withUninstalledExtensions(T){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await u.Promises.readFile(this.uninstalledPath,"utf8")}catch($){if($.code!=="ENOENT")throw $}let N={};if(U)try{N=JSON.parse(U)}catch{}return T&&(T(N),Object.keys(N).length?await u.Promises.writeFile(this.uninstalledPath,JSON.stringify(N)):await u.Promises.rm(this.uninstalledPath)),N})}async extractAtLocation(T,U,N,$){this.logService.trace(`Started extracting the extension from ${U} to ${N}`);try{await u.Promises.rm(N)}catch(O){throw new a.ExtensionManagementError(this.joinErrors(O).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(U,N,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${N}:`,T.id)}catch(O){try{await u.Promises.rm(N)}catch{}let F=a.ExtensionManagementErrorCode.Extract;throw O instanceof g.ExtractError&&(O.type==="CorruptZip"?F=a.ExtensionManagementErrorCode.CorruptZip:O.type==="Incomplete"&&(F=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError(O.message,F)}}async rename(T,U,N,$){try{await u.Promises.rename(U,N)}catch(O){if(l.isWindows&&O&&O.code==="EPERM"&&Date.now()<$)return this.logService.info(`Failed renaming ${U} to ${N} with 'EPERM' error. Trying again...`,T.id),this.rename(T,U,N,$);throw new a.ExtensionManagementError(O.message||E.localize(2,null,U,N),O.code||a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(T,U){const N=await this.extensionsScannerService.scanExistingExtension(T,U,{includeInvalid:!0});if(N)return this.toLocalExtension(N);throw new Error(E.localize(3,null,T.path))}async toLocalExtension(T){const U=await this.fileService.resolve(T.location);let N,$;return U.children&&(N=U.children.find(({name:O})=>/^readme(\.txt|\.md|)$/i.test(O))?.resource,$=U.children.find(({name:O})=>/^changelog(\.txt|\.md|)$/i.test(O))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:N,changelogUrl:$,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated}}async removeUninstalledExtensions(){const T=await this.getUninstalledExtensions(),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const F of U)T[s.ExtensionKey.create(F).toString()]||N.add(F.identifier.id.toLowerCase());const $=(0,s.groupByExtension)(U,F=>F.identifier);await C.Promises.settled($.map(async F=>{const W=F.sort((_,J)=>D.rcompare(_.manifest.version,J.manifest.version))[0];N.has(W.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(W))}));const O=U.filter(F=>T[s.ExtensionKey.create(F).toString()]);await C.Promises.settled(O.map(F=>this.removeUninstalledExtension(F)))}async removeOutdatedExtensions(){const T=await this.extensionsScannerService.scanSystemExtensions({}),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=[],$=await this.extensionsScannerService.getTargetPlatform(),O=(0,s.groupByExtension)(U,F=>F.identifier);for(const F of O)if(F.length>1&&N.push(...F.sort((W,_)=>{const J=D.rcompare(W.manifest.version,_.manifest.version);return J!==0?J:W.targetPlatform===$?-1:1}).slice(1)),F[0].type===0){const W=T.find(_=>(0,s.areSameExtensions)(_.identifier,F[0].identifier));(!W||D.gte(W.manifest.version,F[0].manifest.version))&&N.push(F[0])}await C.Promises.settled(N.map(F=>this.removeExtension(F,"outdated")))}joinErrors(T){const U=Array.isArray(T)?T:[T];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((N,$)=>new Error(`${N.message}${N.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}};x=de([se(1,M.IFileService),se(2,n.IExtensionsScannerService),se(3,Z.ILogService)],x);class j extends v.AbstractExtensionTask{constructor(T,U,N,$,O){super();this.identifier=T,this.source=U,this.options=N,this.extensionsScanner=$,this.logService=O,this._operation=2}get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(T,U){try{const N=await this.unsetUninstalledAndGetLocal(T.key);if(N)return T.metadata?this.extensionsScanner.updateMetadata(N,T.metadata):N}catch{throw l.isMacintosh?new a.ExtensionManagementError(E.localize(4,null),a.ExtensionManagementErrorCode.Internal):new a.ExtensionManagementError(E.localize(5,null),a.ExtensionManagementErrorCode.Internal)}return this.extract(T,U)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const N=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),N}async isUninstalled(T){return!!(await this.extensionsScanner.getUninstalledExtensions())[T.toString()]}async extract({zipPath:T,key:U,metadata:N},$){const O=await this.extensionsScanner.extractUserExtension(U,T,N,$);return this.logService.info("Extracting completed.",U.id),O}}class K extends j{constructor(T,U,N,$,O,F){super(U.identifier,U,N,O,F);this.manifest=T,this.gallery=U,this.extensionsDownloader=$}async doRun(T){const N=(await this.extensionsScanner.scanExtensions(null,void 0)).find(F=>(0,s.areSameExtensions)(F.identifier,this.gallery.identifier));N&&(this._operation=3);const $={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,S.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(N,$),metadata:$};const O=await this.downloadExtension(this.gallery,this._operation);try{const F=await this.installExtension({zipPath:O,key:s.ExtensionKey.create(this.gallery),metadata:$},T);return N&&!this.options.profileLocation&&(N.targetPlatform!==F.targetPlatform||D.neq(N.manifest.version,F.manifest.version))&&await this.extensionsScanner.setUninstalled(N),{local:F,metadata:$}}catch(F){throw await this.deleteDownloadedVSIX(O),F}}async deleteDownloadedVSIX(T){try{await this.extensionsDownloader.delete(m.URI.file(T))}catch(U){this.logService.warn("Error while deleting the downloaded vsix",T.toString(),(0,w.getErrorMessage)(U))}}async downloadExtension(T,U){let N;try{this.logService.trace("Started downloading extension:",T.identifier.id),N=(await this.extensionsDownloader.downloadExtension(T,U)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,N)}catch($){throw new a.ExtensionManagementError((0,v.joinErrors)($).message,a.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(N),N}catch($){throw await this.deleteDownloadedVSIX(N),new a.ExtensionManagementError((0,v.joinErrors)($).message,a.ExtensionManagementErrorCode.Invalid)}}}class z extends j{constructor(T,U,N,$,O,F){super({id:(0,s.getGalleryExtensionId)(T.publisher,T.name)},U,N,O,F);this.manifest=T,this.location=U,this.galleryService=$}async doRun(T){const U=new s.ExtensionKey(this.identifier,this.manifest.version),$=(await this.extensionsScanner.scanExtensions(1,void 0)).find(W=>(0,s.areSameExtensions)(this.identifier,W.identifier)),O=await this.getMetadata(this.identifier.id,this.manifest.version,T);if(O.isApplicationScoped=(0,S.isApplicationScopedExtension)(this.manifest),O.isMachineScoped=this.options.isMachineScoped||$?.isMachineScoped,O.isBuiltin=this.options.isBuiltin||$?.isBuiltin,$)if(this._operation=3,U.equals(new s.ExtensionKey($.identifier,$.manifest.version)))try{await this.extensionsScanner.removeExtension($,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&D.gt($.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled($);else{const W=await this.unsetUninstalledAndGetLocal(U);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:y.resolve(this.location.fsPath),key:U,metadata:O},T),metadata:O}}async getMetadata(T,U,N){try{let[$]=await this.galleryService.getExtensions([{id:T,version:U}],N);if($||([$]=await this.galleryService.getExtensions([{id:T}],N)),$)return{id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId,isPreReleaseVersion:$.properties.isPreReleaseVersion,preRelease:$.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class A extends v.AbstractExtensionTask{constructor(T,U,N){super();this.extension=T,this.options=U,this.extensionsScanner=N}async doRun(T){const U=[],N=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const $=s.ExtensionKey.create(this.extension);U.push(...N.filter(O=>$.equals(s.ExtensionKey.create(O))))}else U.push(...N.filter($=>(0,s.areSameExtensions)($.identifier,this.extension.identifier)));if(!U.length)throw new Error(E.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...U),this.options.remove)for(const $ of U)try{T.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension($)}catch(O){throw new Error(E.localize(9,null,(0,I.toErrorMessage)(O)))}}}}),define(ee[148],ie([0,1,127,4,15,12,2,7,21,18,128,8,126,159]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let u=class extends k.Disposable{constructor(E,f,c){super();this.environmentService=f,this.logService=c,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,f){this.logService.trace("RequestService#request (node) - begin",E.url);const{proxyUrl:c,strictSSL:v}=this;let a;try{a=await(0,D.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...a},t=E.agent?E.agent:await(0,m.getProxyAgent)(E.url||"",s,{proxyUrl:c,strictSSL:v});E.agent=t,E.strictSSL=v,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(E,f);return this.logService.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",E.url,n),n}}async getNodeRequest(E){return((0,C.parse)(E.url).protocol==="https:"?await new Promise((v,a)=>{q(["https"],v,a)}):await new Promise((v,a)=>{q(["http"],v,a)})).request}_request(E,f){return I.Promises.withAsyncBody(async(c,v)=>{const a=(0,C.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,y.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(t.auth=E.user+":"+E.password);const n=s(t,i=>{const r=(0,y.isNumber)(E.followRedirects)?E.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...E,url:i.headers.location,followRedirects:r-1},f).then(c,v);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,P.createGunzip)())),c({res:i,stream:(0,w.streamToBufferReadableStream)(o)})}});n.on("error",v),E.timeout&&n.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),f.onCancellationRequested(()=>{n.abort(),v((0,L.canceled)())})})}async resolveProxy(E){}};u=de([se(0,l.IConfigurationService),se(1,d.INativeEnvironmentService),se(2,b.ILogService)],u),e.RequestService=u}),define(ee[160],ie([0,1,39,4,15,29,12,2,16,14,13,31,9,20,21,119,58,125,18,102,142,22,121,38,49,147,140,11,111,113,47,109,61,62,124,8,115,116,36,145,133,27,48,148,65,129,130,33,132,42,134,135,28,137,24,144]),function(q,e,C,I,w,L,k,y,l,d,D,b,m,P,u,g,E,f,c,v,a,s,t,n,i,r,o,h,p,S,R,M,H,Z,ne,Q,oe,Y,ce,x,j,K,z,A,B,T,U,N,$,O,F,W,_,J,te,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends y.Disposable{constructor(re){super();this.argv=re,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[re,ae]=await this.initServices();return re.invokeFunction(async he=>{const ge=he.get(Q.ILogService),ye=he.get(h.IFileService),Te=he.get(c.INativeEnvironmentService),Ae=he.get(s.IExtensionManagementCLIService);ge.info("CLI main",this.argv),this.registerErrorHandler(ge),await this.doRun(Te,Ae,ye),await Promise.all(ae.map(Ue=>{(0,I.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const re=new H.ServiceCollection,ae={_serviceBrand:void 0,...j.default};re.set(K.IProductService,ae);const he=new v.NativeEnvironmentService(this.argv,ae);re.set(c.INativeEnvironmentService,he),await Promise.all([he.appSettingsHome.fsPath,he.extensionsPath].map(De=>De?P.Promises.mkdir(De,{recursive:!0}):void 0));const ge=(0,Q.getLogLevel)(he),ye=[];ye.push(new oe.SpdLogLogger("cli",(0,d.join)(he.logsPath,"cli.log"),!0,!1,ge)),ge===Q.LogLevel.Trace&&ye.push(new Q.ConsoleLogger(ge));const Te=this._register(new Q.MultiplexLogService(ye));re.set(Q.ILogService,Te);const Ae=this._register(new p.FileService(Te));re.set(h.IFileService,Ae);const Ue=this._register(new S.DiskFileSystemProvider(Te));Ae.registerProvider(l.Schemas.file,Ue);const xe=new T.StateService(he,Te,Ae);re.set(B.IStateService,xe);const V=new J.UriIdentityService(Ae);re.set(_.IUriIdentityService,V);const G=new le.UserDataProfilesService(xe,V,he,Ae,Te);re.set(te.IUserDataProfilesService,G);const X=D.isWindows&&ae.win32RegValueName?this._register(new x.NativePolicyService(ae.win32RegValueName)):he.policyFile?this._register(new Y.FilePolicyService(he.policyFile,Ae,Te)):new ce.NullPolicyService;re.set(ce.IPolicyService,X);const fe=this._register(new g.ConfigurationService(G.defaultProfile.settingsResource,Ae,X,Te));re.set(u.IConfigurationService,fe),await Promise.all([xe.init(),fe.initialize()]),G.setEnablement(!!fe.getValue(te.PROFILES_ENABLEMENT_CONFIG)),re.set(_.IUriIdentityService,new J.UriIdentityService(Ae)),re.set(z.IRequestService,new R.SyncDescriptor(A.RequestService)),re.set(E.IDownloadService,new R.SyncDescriptor(f.DownloadService)),re.set(n.IExtensionsProfileScannerService,new R.SyncDescriptor(n.ExtensionsProfileScannerService)),re.set(i.IExtensionsScannerService,new R.SyncDescriptor(o.ExtensionsScannerService)),re.set(r.INativeServerExtensionManagementService,new R.SyncDescriptor(r.ExtensionManagementService)),re.set(s.IExtensionGalleryService,new R.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService)),re.set(s.IExtensionManagementCLIService,new R.SyncDescriptor(t.ExtensionManagementCLIService)),re.set(Z.ILanguagePackService,new R.SyncDescriptor(ne.NativeLanguagePackService));const me=[];if((0,O.supportsTelemetry)(ae,he)){ae.aiConfig&&ae.aiConfig.asimovKey&&me.push(new F.AppInsightsAppender("monacoworkbench",null,ae.aiConfig.asimovKey));const{installSourcePath:De}=he,we={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let Re;try{const be=await P.Promises.readFile(he.stateResource.fsPath);Re=JSON.parse(be.toString())[N.machineIdKey]}catch(be){be.code!=="ENOENT"&&Te.error(be)}return(0,U.resolveCommonProperties)(Ae,(0,C.release)(),(0,C.hostname)(),process.arch,ae.commit,ae.version,Re,ae.msftInternalDomains,De)})(),piiPaths:(0,O.getPiiPathsFromEnvironment)(he)};re.set(N.ITelemetryService,new R.SyncDescriptor($.TelemetryService,[we]))}else re.set(N.ITelemetryService,O.NullTelemetryService);return[new M.InstantiationService(re),me]}registerErrorHandler(re){(0,k.setUnexpectedErrorHandler)(ae=>{const he=(0,L.toErrorMessage)(ae,!0);!he||re.error(`[uncaught exception in CLI]: ${he}`)}),process.on("uncaughtException",ae=>(0,k.onUnexpectedError)(ae)),process.on("unhandledRejection",ae=>(0,k.onUnexpectedError)(ae))}async doRun(re,ae,he){if(this.argv["install-source"])return this.setInstallSource(re,he,this.argv["install-source"]);if(this.argv["list-extensions"])return ae.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ge={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return ae.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ge,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return ae.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return ae.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,W.buildTelemetryMessage)(re.appRoot,re.extensionsPath))}}asExtensionIdOrVSIX(re){return re.map(ae=>/\.vsix$/i.test(ae)?m.URI.file((0,d.isAbsolute)(ae)?ae:(0,d.join)((0,b.cwd)(),ae)):ae)}async setInstallSource(re,ae,he){await ae.writeFile(m.URI.file(re.installSourcePath),w.VSBuffer.fromString(he.slice(0,30)))}}async function pe(ve){const re=new ue(ve);try{await re.run()}finally{re.dispose()}}e.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a36f047dd34d67abb45728037a02cfdb530fc59c/core/vs/code/node/cliProcessMain.js.map
