/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","child_process","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","string_decoder","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(X){for(var e=[],u=0,n=X.length;u<n;u++)e[u]=Ie[X[u]];return e};define(Ie[56],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(n,S){if(!n)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=u}),define(Ie[76],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(C){return C?C.replace(/\$\((.*?)\)/g,(D,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=u;class n{constructor(D,E,k){this.id=D,this.definition=E,this.description=k,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\f101"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function S(C,D){const E=["codicon","codicon-"+C];return D&&E.push("codicon-modifier-"+D),E}e.getClassNamesArray=S;var A;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function E(I){if(I instanceof n)return["codicon","codicon-"+I.id];const _=D.exec(I.id);if(!_)return E(n.error);const[,P,b]=_,w=["codicon","codicon-"+P];return b&&w.push("codicon-modifier-"+b.substr(1)),w}C.asClassNameArray=E;function k(I){return E(I).join(" ")}C.asClassName=k;function R(I){return"."+E(I).join(".")}C.asCSSSelector=R})(A=e.CSSIcon||(e.CSSIcon={}))}),define(Ie[77],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=e.forEach=void 0;function u(D,E){for(const[k,R]of Object.entries(D))if(E({key:k,value:R})===!1)return}e.forEach=u;function n(D,E){const k=Object.create(null);for(const R of D){const I=E(R);let _=k[I];_||(_=k[I]=[]),_.push(R)}return k}e.groupBy=n;function S(D,E){const k=[],R=[];for(const I of D)E.has(I)||k.push(I);for(const I of E)D.has(I)||R.push(I);return{removed:k,added:R}}e.diffSets=S;function A(D,E){const k=[],R=[];for(const[I,_]of D)E.has(I)||k.push(_);for(const[I,_]of E)D.has(I)||R.push(_);return{removed:k,added:R}}e.diffMaps=A;class C{constructor(){this.map=new Map}add(E,k){let R=this.map.get(E);R||(R=new Set,this.map.set(E,R)),R.add(k)}delete(E,k){const R=this.map.get(E);!R||(R.delete(k),R.size===0&&this.map.delete(E))}forEach(E,k){const R=this.map.get(E);!R||R.forEach(k)}}e.SetMap=C}),define(Ie[57],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(C){return(D,E,k)=>{let R=null,I=null;if(typeof k.value=="function"?(R="value",I=k.value):typeof k.get=="function"&&(R="get",I=k.get),!I)throw new Error("not supported");k[R]=C(I,E)}}e.createDecorator=u;function n(C,D,E){let k=null,R=null;if(typeof E.value=="function"?(k="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${D}`;E[k]=function(..._){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,_)}),this[I]}}e.memoize=n;function S(C,D,E){return u((k,R)=>{const I=`$debounce$${R}`,_=`$debounce$result$${R}`;return function(...P){this[_]||(this[_]=E?E():void 0),clearTimeout(this[I]),D&&(this[_]=D(this[_],...P),P=[this[_]]),this[I]=setTimeout(()=>{k.apply(this,P),this[_]=E?E():void 0},C)}})}e.debounce=S;function A(C,D,E){return u((k,R)=>{const I=`$throttle$timer$${R}`,_=`$throttle$result$${R}`,P=`$throttle$lastRun$${R}`,b=`$throttle$pending$${R}`;return function(...w){if(this[_]||(this[_]=E?E():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),D&&(this[_]=D(this[_],...w)),this[b])return;const p=this[P]+C;p<=Date.now()?(this[P]=Date.now(),k.apply(this,[this[_]]),this[_]=E?E():void 0):(this[b]=!0,this[I]=setTimeout(()=>{this[b]=!1,this[P]=Date.now(),k.apply(this,[this[_]]),this[_]=E?E():void 0},p-Date.now()))}})}e.throttle=A}),define(Ie[12],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?f.isErrorNoTelemetry(a)?new f(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(h=>{h(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=u,e.errorHandler=new u;function n(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=n;function S(m){E(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=S;function A(m){E(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=A;function C(m){if(m instanceof Error){const{name:a,message:h}=m,r=m.stacktrace||m.stack;return{$isError:!0,name:a,message:h,stack:r,noTelemetry:f.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=C;const D="Canceled";function E(m){return m instanceof k?!0:m instanceof Error&&m.name===D&&m.message===D}e.isCancellationError=E;class k extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=k;function R(){const m=new Error(D);return m.name=m.message,m}e.canceled=R;function I(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=I;function _(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=_;function P(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=P;function b(m){const a=new Error(`${m} has been disposed`);return a.name="DISPOSED",a}e.disposed=b;function w(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=w;class p extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=p;class g extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=g;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;class f extends Error{constructor(a){super(a);this.name="ErrorNoTelemetry"}static fromError(a){if(a instanceof f)return a;const h=new f;return h.message=a.message,h.stack=a.stack,h}static isErrorNoTelemetry(a){return a.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=f;class c extends Error{constructor(a){super(a||"An unexpected bug occurred.");Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(Ie[16],ke([1,0,12]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(me,Te=0){return me[me.length-(1+Te)]}e.tail=n;function S(me){if(me.length===0)throw new Error("Invalid tail call");return[me.slice(0,me.length-1),me[me.length-1]]}e.tail2=S;function A(me,Te,le=(pe,be)=>pe===be){if(me===Te)return!0;if(!me||!Te||me.length!==Te.length)return!1;for(let pe=0,be=me.length;pe<be;pe++)if(!le(me[pe],Te[pe]))return!1;return!0}e.equals=A;function C(me,Te,le){return D(me.length,pe=>le(me[pe],Te))}e.binarySearch=C;function D(me,Te){let le=0,pe=me-1;for(;le<=pe;){const be=(le+pe)/2|0,ae=Te(be);if(ae<0)le=be+1;else if(ae>0)pe=be-1;else return be}return-(le+1)}e.binarySearch2=D;function E(me,Te){let le=0,pe=me.length;if(pe===0)return 0;for(;le<pe;){const be=Math.floor((le+pe)/2);Te(me[be])?pe=be:le=be+1}return le}e.findFirstInSorted=E;function k(me,Te,le){if(me=me|0,me>=Te.length)throw new TypeError("invalid index");const pe=Te[Math.floor(Te.length*Math.random())],be=[],ae=[],he=[];for(const ee of Te){const ne=le(ee,pe);ne<0?be.push(ee):ne>0?ae.push(ee):he.push(ee)}return me<be.length?k(me,be,le):me<be.length+he.length?he[0]:k(me-(be.length+he.length),ae,le)}e.quickSelect=k;function R(me,Te){const le=[];let pe;for(const be of me.slice(0).sort(Te))!pe||Te(pe[0],be)!==0?(pe=[be],le.push(pe)):pe.push(be);return le}e.groupBy=R;function I(me,Te,le){const pe=[];function be(ee,ne,O){if(ne===0&&O.length===0)return;const $=pe[pe.length-1];$&&$.start+$.deleteCount===ee?($.deleteCount+=ne,$.toInsert.push(...O)):pe.push({start:ee,deleteCount:ne,toInsert:O})}let ae=0,he=0;for(;;){if(ae===me.length){be(ae,0,Te.slice(he));break}if(he===Te.length){be(ae,me.length-ae,[]);break}const ee=me[ae],ne=Te[he],O=le(ee,ne);O===0?(ae+=1,he+=1):O<0?(be(ae,1,[]),ae+=1):O>0&&(be(ae,0,[ne]),he+=1)}return pe}e.sortedDiff=I;function _(me,Te,le){const pe=I(me,Te,le),be=[],ae=[];for(const he of pe)be.push(...me.slice(he.start,he.start+he.deleteCount)),ae.push(...he.toInsert);return{removed:be,added:ae}}e.delta=_;function P(me,Te,le){if(le===0)return[];const pe=me.slice(0,le).sort(Te);return w(me,Te,pe,le,me.length),pe}e.top=P;function b(me,Te,le,pe,be){return le===0?Promise.resolve([]):new Promise((ae,he)=>{(async()=>{const ee=me.length,ne=me.slice(0,le).sort(Te);for(let O=le,$=Math.min(le+pe,ee);O<ee;O=$,$=Math.min($+pe,ee)){if(O>le&&await new Promise(G=>setTimeout(G)),be&&be.isCancellationRequested)throw new u.CancellationError;w(me,Te,ne,O,$)}return ne})().then(ae,he)})}e.topAsync=b;function w(me,Te,le,pe,be){for(const ae=le.length;pe<be;pe++){const he=me[pe];if(Te(he,le[ae-1])<0){le.pop();const ee=E(le,ne=>Te(he,ne)<0);le.splice(ee,0,he)}}}function p(me){return me.filter(Te=>!!Te)}e.coalesce=p;function g(me){let Te=0;for(let le=0;le<me.length;le++)me[le]&&(me[Te]=me[le],Te+=1);me.length=Te}e.coalesceInPlace=g;function v(me,Te,le){me.splice(le,0,me.splice(Te,1)[0])}e.move=v;function f(me){return!Array.isArray(me)||me.length===0}e.isFalsyOrEmpty=f;function c(me){return Array.isArray(me)&&me.length>0}e.isNonEmptyArray=c;function m(me,Te=le=>le){const le=new Set;return me.filter(pe=>{const be=Te(pe);return le.has(be)?!1:(le.add(be),!0)})}e.distinct=m;function a(me){const Te=new Set;return le=>{const pe=me(le);return Te.has(pe)?!1:(Te.add(pe),!0)}}e.uniqueFilter=a;function h(me,Te){const le=r(me,Te);if(le!==-1)return me[le]}e.findLast=h;function r(me,Te){for(let le=me.length-1;le>=0;le--){const pe=me[le];if(Te(pe))return le}return-1}e.lastIndex=r;function s(me,Te){return me.length>0?me[0]:Te}e.firstOrDefault=s;function i(me,Te){return me.length>0?me[me.length-1]:Te}e.lastOrDefault=i;function t(me,Te,le=(pe,be)=>pe===be){let pe=0;for(let be=0,ae=Math.min(me.length,Te.length);be<ae&&le(me[be],Te[be]);be++)pe++;return pe}e.commonPrefixLength=t;function o(me){return[].concat(...me)}e.flatten=o;function l(me,Te){let le=typeof Te=="number"?me:0;typeof Te=="number"?le=me:(le=0,Te=me);const pe=[];if(le<=Te)for(let be=le;be<Te;be++)pe.push(be);else for(let be=le;be>Te;be--)pe.push(be);return pe}e.range=l;function d(me,Te,le){return me.reduce((pe,be)=>(pe[Te(be)]=le?le(be):be,pe),Object.create(null))}e.index=d;function y(me,Te){return me.push(Te),()=>L(me,Te)}e.insert=y;function L(me,Te){const le=me.indexOf(Te);if(le>-1)return me.splice(le,1),Te}e.remove=L;function M(me,Te,le){const pe=me.slice(0,Te),be=me.slice(Te);return pe.concat(le,be)}e.arrayInsert=M;function F(me,Te){let le;if(typeof Te=="number"){let pe=Te;le=()=>{const be=Math.sin(pe++)*179426549;return be-Math.floor(be)}}else le=Math.random;for(let pe=me.length-1;pe>0;pe-=1){const be=Math.floor(le()*(pe+1)),ae=me[pe];me[pe]=me[be],me[be]=ae}}e.shuffle=F;function T(me,Te){const le=me.indexOf(Te);le>-1&&(me.splice(le,1),me.unshift(Te))}e.pushToStart=T;function U(me,Te){const le=me.indexOf(Te);le>-1&&(me.splice(le,1),me.push(Te))}e.pushToEnd=U;function N(me,Te){for(const le of Te)me.push(le)}e.pushMany=N;function H(me,Te){return Array.isArray(me)?me.map(Te):Te(me)}e.mapArrayOrNot=H;function te(me){return Array.isArray(me)?me:[me]}e.asArray=te;function B(me){return me[Math.floor(Math.random()*me.length)]}e.getRandomElement=B;function z(me,Te){for(const le of me){const pe=Te(le);if(pe!==void 0)return pe}}e.mapFind=z;function q(me,Te,le){const pe=j(me,Te),be=me.length,ae=le.length;me.length=be+ae;for(let he=be-1;he>=pe;he--)me[he+ae]=me[he];for(let he=0;he<ae;he++)me[he+pe]=le[he]}e.insertInto=q;function V(me,Te,le,pe){const be=j(me,Te),ae=me.splice(be,le);return q(me,be,pe),ae}e.splice=V;function j(me,Te){return Te<0?Math.max(Te+me.length,0):Math.min(Te,me.length)}var ie;(function(me){function Te(be){return be<0}me.isLessThan=Te;function le(be){return be>0}me.isGreaterThan=le;function pe(be){return be===0}me.isNeitherLessOrGreaterThan=pe,me.greaterThan=1,me.lessThan=-1,me.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function Q(me,Te){return(le,pe)=>Te(me(le),me(pe))}e.compareBy=Q;function ue(...me){return(Te,le)=>{for(const pe of me){const be=pe(Te,le);if(!ie.isNeitherLessOrGreaterThan(be))return be}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=ue;const ve=(me,Te)=>me-Te;e.numberComparator=ve;function J(me,Te){if(me.length===0)return;let le=me[0];for(let pe=1;pe<me.length;pe++){const be=me[pe];Te(be,le)>0&&(le=be)}return le}e.findMaxBy=J;function ge(me,Te){if(me.length===0)return;let le=me[0];for(let pe=1;pe<me.length;pe++){const be=me[pe];Te(be,le)>=0&&(le=be)}return le}e.findLastMaxBy=ge;function Ee(me,Te){return J(me,(le,pe)=>-Te(le,pe))}e.findMinBy=Ee;class Pe{constructor(Te){this.items=Te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Te){let le=this.firstIdx;for(;le<this.items.length&&Te(this.items[le]);)le++;const pe=le===this.firstIdx?null:this.items.slice(this.firstIdx,le);return this.firstIdx=le,pe}takeFromEndWhile(Te){let le=this.lastIdx;for(;le>=0&&Te(this.items[le]);)le--;const pe=le===this.lastIdx?null:this.items.slice(le+1,this.lastIdx+1);return this.lastIdx=le,pe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Te=this.items[this.firstIdx];return this.firstIdx++,Te}removeLast(){const Te=this.items[this.lastIdx];return this.lastIdx--,Te}takeCount(Te){const le=this.items.slice(this.firstIdx,this.firstIdx+Te);return this.firstIdx+=Te,le}}e.ArrayQueue=Pe}),define(Ie[58],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(n){const S=this;let A=!1,C;return function(){return A||(A=!0,C=n.apply(S,arguments)),C}}e.once=u}),define(Ie[93],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(Ie[59],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(n){function S(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}n.is=S;const A=Object.freeze([]);function C(){return A}n.empty=C;function*D(h){yield h}n.single=D;function E(h){return h||A}n.from=E;function k(h){return!h||h[Symbol.iterator]().next().done===!0}n.isEmpty=k;function R(h){return h[Symbol.iterator]().next().value}n.first=R;function I(h,r){for(const s of h)if(r(s))return!0;return!1}n.some=I;function _(h,r){for(const s of h)if(r(s))return s}n.find=_;function*P(h,r){for(const s of h)r(s)&&(yield s)}n.filter=P;function*b(h,r){let s=0;for(const i of h)yield r(i,s++)}n.map=b;function*w(...h){for(const r of h)for(const s of r)yield s}n.concat=w;function*p(h){for(const r of h)for(const s of r)yield s}n.concatNested=p;function g(h,r,s){let i=s;for(const t of h)i=r(i,t);return i}n.reduce=g;function v(h,r){let s=0;for(const i of h)r(i,s++)}n.forEach=v;function*f(h,r,s=h.length){for(r<0&&(r+=h.length),s<0?s+=h.length:s>h.length&&(s=h.length);r<s;r++)yield h[r]}n.slice=f;function c(h,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,h];const i=h[Symbol.iterator]();for(let t=0;t<r;t++){const o=i.next();if(o.done)return[s,n.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return i}}]}n.consume=c;function m(h){return c(h)[0]}n.collect=m;function a(h,r,s=(i,t)=>i===t){const i=h[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const o=i.next(),l=t.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!s(o.value,l.value))return!1}}n.equals=a})(u=e.Iterable||(e.Iterable={}))}),define(Ie[142],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var n;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(a){a.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function C(a,h=!1){let r=0;const s=a.length;let i="",t=0,o=16,l=0;function d(N){let H=0,te=0;for(;H<N;){const B=a.charCodeAt(r);if(B>=48&&B<=57)te=te*16+B-48;else if(B>=65&&B<=70)te=te*16+B-65+10;else if(B>=97&&B<=102)te=te*16+B-97+10;else break;r++,H++}return H<N&&(te=-1),te}function y(N){r=N,i="",t=0,o=16,l=0}function L(){const N=r;if(a.charCodeAt(r)===48)r++;else for(r++;r<a.length&&k(a.charCodeAt(r));)r++;if(r<a.length&&a.charCodeAt(r)===46)if(r++,r<a.length&&k(a.charCodeAt(r)))for(r++;r<a.length&&k(a.charCodeAt(r));)r++;else return l=3,a.substring(N,r);let H=r;if(r<a.length&&(a.charCodeAt(r)===69||a.charCodeAt(r)===101))if(r++,(r<a.length&&a.charCodeAt(r)===43||a.charCodeAt(r)===45)&&r++,r<a.length&&k(a.charCodeAt(r))){for(r++;r<a.length&&k(a.charCodeAt(r));)r++;H=r}else l=3;return a.substring(N,H)}function M(){let N="",H=r;for(;;){if(r>=s){N+=a.substring(H,r),l=2;break}const te=a.charCodeAt(r);if(te===34){N+=a.substring(H,r),r++;break}if(te===92){if(N+=a.substring(H,r),r++,r>=s){l=2;break}switch(a.charCodeAt(r++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const z=d(4);z>=0?N+=String.fromCharCode(z):l=4;break}default:l=5}H=r;continue}if(te>=0&&te<=31)if(E(te)){N+=a.substring(H,r),l=2;break}else l=6;r++}return N}function F(){if(i="",l=0,t=r,r>=s)return t=s,o=17;let N=a.charCodeAt(r);if(D(N)){do r++,i+=String.fromCharCode(N),N=a.charCodeAt(r);while(D(N));return o=15}if(E(N))return r++,i+=String.fromCharCode(N),N===13&&a.charCodeAt(r)===10&&(r++,i+=`
`),o=14;switch(N){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,i=M(),o=10;case 47:{const H=r-1;if(a.charCodeAt(r+1)===47){for(r+=2;r<s&&!E(a.charCodeAt(r));)r++;return i=a.substring(H,r),o=12}if(a.charCodeAt(r+1)===42){r+=2;const te=s-1;let B=!1;for(;r<te;){if(a.charCodeAt(r)===42&&a.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,l=1),i=a.substring(H,r),o=13}return i+=String.fromCharCode(N),r++,o=16}case 45:if(i+=String.fromCharCode(N),r++,r===s||!k(a.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=L(),o=11;default:for(;r<s&&T(N);)r++,N=a.charCodeAt(r);if(t!==r){switch(i=a.substring(t,r),i){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return i+=String.fromCharCode(N),r++,o=16}}function T(N){if(D(N)||E(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let N;do N=F();while(N>=12&&N<=15);return N}return{setPosition:y,getPosition:()=>r,scan:h?U:F,getToken:()=>o,getTokenValue:()=>i,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>l}}e.createScanner=C;function D(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function E(a){return a===10||a===13||a===8232||a===8233}function k(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function I(a,h){const r=[],s=new Object;let i;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(d,y,L,M){t.value=d,t.offset=y,t.length=L,t.type=M,t.colonOffset=void 0,i=t}try{f(a,{onObjectBegin:(d,y)=>{if(h<=d)throw s;i=void 0,o=h>d,r.push("")},onObjectProperty:(d,y,L)=>{if(h<y||(l(d,y,L,"property"),r[r.length-1]=d,h<=y+L))throw s},onObjectEnd:(d,y)=>{if(h<=d)throw s;i=void 0,r.pop()},onArrayBegin:(d,y)=>{if(h<=d)throw s;i=void 0,r.push(0)},onArrayEnd:(d,y)=>{if(h<=d)throw s;i=void 0,r.pop()},onLiteralValue:(d,y,L)=>{if(h<y||(l(d,y,L,m(d)),h<=y+L))throw s},onSeparator:(d,y,L)=>{if(h<=y)throw s;if(d===":"&&i&&i.type==="property")i.colonOffset=y,o=!1,i=void 0;else if(d===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(o=!0,r[r.length-1]=""),i=void 0}}})}catch(d){if(d!==s)throw d}return{path:r,previousNode:i,isAtPropertyKey:o,matches:d=>{let y=0;for(let L=0;y<d.length&&L<r.length;L++)if(d[y]===r[L]||d[y]==="*")y++;else if(d[y]!=="**")return!1;return y===d.length}}}e.getLocation=I;function _(a,h=[],r=A.DEFAULT){let s=null,i=[];const t=[];function o(d){Array.isArray(i)?i.push(d):s!==null&&(i[s]=d)}return f(a,{onObjectBegin:()=>{const d={};o(d),t.push(i),i=d,s=null},onObjectProperty:d=>{s=d},onObjectEnd:()=>{i=t.pop()},onArrayBegin:()=>{const d=[];o(d),t.push(i),i=d,s=null},onArrayEnd:()=>{i=t.pop()},onLiteralValue:o,onError:(d,y,L)=>{h.push({error:d,offset:y,length:L})}},r),i[0]}e.parse=_;function P(a,h=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(d){s.type==="property"&&(s.length=d-s.offset,s=s.parent)}function t(d){return s.children.push(d),d}f(a,{onObjectBegin:d=>{s=t({type:"object",offset:d,length:-1,parent:s,children:[]})},onObjectProperty:(d,y,L)=>{s=t({type:"property",offset:y,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:d,offset:y,length:L,parent:s})},onObjectEnd:(d,y)=>{s.length=d+y-s.offset,s=s.parent,i(d+y)},onArrayBegin:(d,y)=>{s=t({type:"array",offset:d,length:-1,parent:s,children:[]})},onArrayEnd:(d,y)=>{s.length=d+y-s.offset,s=s.parent,i(d+y)},onLiteralValue:(d,y,L)=>{t({type:m(d),offset:y,length:L,parent:s,value:d}),i(y+L)},onSeparator:(d,y,L)=>{s.type==="property"&&(d===":"?s.colonOffset=y:d===","&&i(y))},onError:(d,y,L)=>{h.push({error:d,offset:y,length:L})}},r);const l=s.children[0];return l&&delete l.parent,l}e.parseTree=P;function b(a,h){if(!a)return;let r=a;for(const s of h)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let i=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===s){r=t.children[1],i=!0;break}if(!i)return}else{const i=s;if(r.type!=="array"||i<0||!Array.isArray(r.children)||i>=r.children.length)return;r=r.children[i]}return r}e.findNodeAtLocation=b;function w(a){if(!a.parent||!a.parent.children)return[];const h=w(a.parent);if(a.parent.type==="property"){const r=a.parent.children[0].value;h.push(r)}else if(a.parent.type==="array"){const r=a.parent.children.indexOf(a);r!==-1&&h.push(r)}return h}e.getNodePath=w;function p(a){switch(a.type){case"array":return a.children.map(p);case"object":{const h=Object.create(null);for(const r of a.children){const s=r.children[1];s&&(h[r.children[0].value]=p(s))}return h}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=p;function g(a,h,r=!1){return h>=a.offset&&h<a.offset+a.length||r&&h===a.offset+a.length}e.contains=g;function v(a,h,r=!1){if(g(a,h,r)){const s=a.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=h;i++){const t=v(s[i],h,r);if(t)return t}return a}}e.findNodeAtOffset=v;function f(a,h,r=A.DEFAULT){const s=C(a,!1);function i(ue){return ue?()=>ue(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(ue){return ue?ve=>ue(ve,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=i(h.onObjectBegin),l=t(h.onObjectProperty),d=i(h.onObjectEnd),y=i(h.onArrayBegin),L=i(h.onArrayEnd),M=t(h.onLiteralValue),F=t(h.onSeparator),T=i(h.onComment),U=t(h.onError),N=r&&r.disallowComments,H=r&&r.allowTrailingComma;function te(){for(;;){const ue=s.scan();switch(s.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:N||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ue){case 12:case 13:N?B(10):T();break;case 16:B(1);break;case 15:case 14:break;default:return ue}}}function B(ue,ve=[],J=[]){if(U(ue),ve.length+J.length>0){let ge=s.getToken();for(;ge!==17;){if(ve.indexOf(ge)!==-1){te();break}else if(J.indexOf(ge)!==-1)break;ge=te()}}}function z(ue){const ve=s.getTokenValue();return ue?M(ve):l(ve),te(),!0}function q(){switch(s.getToken()){case 11:{let ue=0;try{ue=JSON.parse(s.getTokenValue()),typeof ue!="number"&&(B(2),ue=0)}catch{B(2)}M(ue);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return te(),!0}function V(){return s.getToken()!==10?(B(3,[],[2,5]),!1):(z(!1),s.getToken()===6?(F(":"),te(),Q()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){o(),te();let ue=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ue||B(4,[],[]),F(","),te(),s.getToken()===2&&H)break}else ue&&B(6,[],[]);V()||B(4,[],[2,5]),ue=!0}return d(),s.getToken()!==2?B(7,[2],[]):te(),!0}function ie(){y(),te();let ue=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ue||B(4,[],[]),F(","),te(),s.getToken()===4&&H)break}else ue&&B(6,[],[]);Q()||B(4,[],[4,5]),ue=!0}return L(),s.getToken()!==4?B(8,[4],[]):te(),!0}function Q(){switch(s.getToken()){case 3:return ie();case 1:return j();case 10:return z(!0);default:return q()}}return te(),s.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):Q()?(s.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=f;function c(a,h){const r=C(a),s=[];let i,t=0,o;do switch(o=r.getPosition(),i=r.scan(),i){case 12:case 13:case 17:t!==o&&s.push(a.substring(t,o)),h!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,h)),t=r.getPosition();break}while(i!==17);return s.join("")}e.stripComments=c;function m(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(Ie[78],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new u(()=>S(this.getValue()))}}e.Lazy=u}),define(Ie[6],ke([1,0,58,59]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const S=!1;let A=null;function C(i){A=i}if(e.setDisposableTracker=C,S){const i="__is_disposable_tracked__";C(new class{trackDisposable(t){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[i]||console.log(o)},3e3)}setParent(t,o){if(t&&t!==v.None)try{t[i]=!0}catch{}}markAsDisposed(t){if(t&&t!==v.None)try{t[i]=!0}catch{}}markAsSingleton(t){}})}function D(i){return A?.trackDisposable(i),i}function E(i){A?.markAsDisposed(i)}function k(i,t){A?.setParent(i,t)}function R(i,t){if(!!A)for(const o of i)A.setParent(o,t)}function I(i){return A?.markAsSingleton(i),i}e.markAsSingleton=I;class _ extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=_;function P(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=P;function b(i){if(n.Iterable.is(i)){const t=[];for(const o of i)if(o)try{o.dispose()}catch(l){t.push(l)}if(t.length===1)throw t[0];if(t.length>1)throw new _(t);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=b;function w(...i){const t=p(()=>b(i));return R(i,t),t}e.combinedDisposable=w;function p(i){const t=D({dispose:(0,u.once)(()=>{E(t),i()})});return t}e.toDisposable=p;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return k(t,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new g,D(this),k(this._store,this)}dispose(){E(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&k(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&k(t,null),t}}e.MutableDisposable=f;class c{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(t){let o=t;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,E(this))},this}}e.SafeDisposable=m;class a{constructor(){this.references=new Map}acquire(t,...o){let l=this.references.get(t);l||(l={counter:0,object:this.createReferencedObject(t,...o)},this.references.set(t,l));const{object:d}=l,y=(0,u.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(t,l.object),this.references.delete(t))});return l.counter++,{object:d,dispose:y}}}e.ReferenceCollection=a;class h{constructor(t){this.referenceCollection=t}async acquire(t,...o){const l=this.referenceCollection.acquire(t,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(d){throw l.dispose(),d}}}e.AsyncReferenceCollection=h;class r{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=r;function s(i){const t=new g;try{i(t)}finally{t.dispose()}}e.disposeOnReturn=s}),define(Ie[79],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(A){this.element=A,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class n{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let A=this._first;for(;A!==u.Undefined;){const C=A.next;A.prev=u.Undefined,A.next=u.Undefined,A=C}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,C){const D=new u(A);if(this._first===u.Undefined)this._first=D,this._last=D;else if(C){const k=this._last;this._last=D,D.prev=k,k.next=D}else{const k=this._first;this._first=D,D.next=k,k.prev=D}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(D))}}shift(){if(this._first!==u.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==u.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==u.Undefined&&A.next!==u.Undefined){const C=A.prev;C.next=A.next,A.next.prev=C}else A.prev===u.Undefined&&A.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):A.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):A.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==u.Undefined;)yield A.element,A=A.next}}e.LinkedList=n}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ie[143],ke([0]),e):(X=typeof globalThis!="undefined"?globalThis:X||self,e(X.marked={}))}(this,function(X){"use strict";function e(le,pe){for(var be=0;be<pe.length;be++){var ae=pe[be];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(le,ae.key,ae)}}function u(le,pe,be){return pe&&e(le.prototype,pe),be&&e(le,be),Object.defineProperty(le,"prototype",{writable:!1}),le}function n(le,pe){if(!!le){if(typeof le=="string")return S(le,pe);var be=Object.prototype.toString.call(le).slice(8,-1);if(be==="Object"&&le.constructor&&(be=le.constructor.name),be==="Map"||be==="Set")return Array.from(le);if(be==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(be))return S(le,pe)}}function S(le,pe){(pe==null||pe>le.length)&&(pe=le.length);for(var be=0,ae=new Array(pe);be<pe;be++)ae[be]=le[be];return ae}function A(le,pe){var be=typeof Symbol!="undefined"&&le[Symbol.iterator]||le["@@iterator"];if(be)return(be=be.call(le)).next.bind(be);if(Array.isArray(le)||(be=n(le))||pe&&le&&typeof le.length=="number"){be&&(le=be);var ae=0;return function(){return ae>=le.length?{done:!0}:{done:!1,value:le[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}X.defaults=C();function D(le){X.defaults=le}var E=/[&<>"']/,k=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,_={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(pe){return _[pe]};function b(le,pe){if(pe){if(E.test(le))return le.replace(k,P)}else if(R.test(le))return le.replace(I,P);return le}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(le){return le.replace(w,function(pe,be){return be=be.toLowerCase(),be==="colon"?":":be.charAt(0)==="#"?be.charAt(1)==="x"?String.fromCharCode(parseInt(be.substring(2),16)):String.fromCharCode(+be.substring(1)):""})}var g=/(^|[^\[])\^/g;function v(le,pe){le=typeof le=="string"?le:le.source,pe=pe||"";var be={replace:function(he,ee){return ee=ee.source||ee,ee=ee.replace(g,"$1"),le=le.replace(he,ee),be},getRegex:function(){return new RegExp(le,pe)}};return be}var f=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(le,pe,be){if(le){var ae;try{ae=decodeURIComponent(p(be)).replace(f,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}pe&&!c.test(be)&&(be=i(pe,be));try{be=encodeURI(be).replace(/%25/g,"%")}catch{return null}return be}var a={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(le,pe){a[" "+le]||(h.test(le)?a[" "+le]=le+"/":a[" "+le]=d(le,"/",!0)),le=a[" "+le];var be=le.indexOf(":")===-1;return pe.substring(0,2)==="//"?be?pe:le.replace(r,"$1")+pe:pe.charAt(0)==="/"?be?pe:le.replace(s,"$1")+pe:le+pe}var t={exec:function(){}};function o(le){for(var pe=1,be,ae;pe<arguments.length;pe++){be=arguments[pe];for(ae in be)Object.prototype.hasOwnProperty.call(be,ae)&&(le[ae]=be[ae])}return le}function l(le,pe){var be=le.replace(/\|/g,function(ee,ne,O){for(var $=!1,G=ne;--G>=0&&O[G]==="\\";)$=!$;return $?"|":" |"}),ae=be.split(/ \|/),he=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>pe)ae.splice(pe);else for(;ae.length<pe;)ae.push("");for(;he<ae.length;he++)ae[he]=ae[he].trim().replace(/\\\|/g,"|");return ae}function d(le,pe,be){var ae=le.length;if(ae===0)return"";for(var he=0;he<ae;){var ee=le.charAt(ae-he-1);if(ee===pe&&!be)he++;else if(ee!==pe&&be)he++;else break}return le.slice(0,ae-he)}function y(le,pe){if(le.indexOf(pe[1])===-1)return-1;for(var be=le.length,ae=0,he=0;he<be;he++)if(le[he]==="\\")he++;else if(le[he]===pe[0])ae++;else if(le[he]===pe[1]&&(ae--,ae<0))return he;return-1}function L(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(le,pe){if(pe<1)return"";for(var be="";pe>1;)pe&1&&(be+=le),pe>>=1,le+=le;return be+le}function F(le,pe,be,ae){var he=pe.href,ee=pe.title?b(pe.title):null,ne=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){ae.state.inLink=!0;var O={type:"link",raw:be,href:he,title:ee,text:ne,tokens:ae.inlineTokens(ne,[])};return ae.state.inLink=!1,O}return{type:"image",raw:be,href:he,title:ee,text:b(ne)}}function T(le,pe){var be=le.match(/^(\s+)(?:```)/);if(be===null)return pe;var ae=be[1];return pe.split(`
`).map(function(he){var ee=he.match(/^\s+/);if(ee===null)return he;var ne=ee[0];return ne.length>=ae.length?he.slice(ae.length):he}).join(`
`)}var U=function(){function le(be){this.options=be||X.defaults}var pe=le.prototype;return pe.space=function(ae){var he=this.rules.block.newline.exec(ae);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},pe.code=function(ae){var he=this.rules.block.code.exec(ae);if(he){var ee=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:d(ee,`
`)}}},pe.fences=function(ae){var he=this.rules.block.fences.exec(ae);if(he){var ee=he[0],ne=T(ee,he[3]||"");return{type:"code",raw:ee,lang:he[2]?he[2].trim():he[2],text:ne}}},pe.heading=function(ae){var he=this.rules.block.heading.exec(ae);if(he){var ee=he[2].trim();if(/#$/.test(ee)){var ne=d(ee,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(ee=ne.trim())}var O={type:"heading",raw:he[0],depth:he[1].length,text:ee,tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},pe.hr=function(ae){var he=this.rules.block.hr.exec(ae);if(he)return{type:"hr",raw:he[0]}},pe.blockquote=function(ae){var he=this.rules.block.blockquote.exec(ae);if(he){var ee=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},pe.list=function(ae){var he=this.rules.block.list.exec(ae);if(he){var ee,ne,O,$,G,K,de,we,se,De,Ce,ze,Ke=he[1].trim(),Ne=Ke.length>1,Ye={type:"list",raw:"",ordered:Ne,start:Ne?+Ke.slice(0,-1):"",loose:!1,items:[]};Ke=Ne?"\\d{1,9}\\"+Ke.slice(-1):"\\"+Ke,this.options.pedantic&&(Ke=Ne?Ke:"[*+-]");for(var Z=new RegExp("^( {0,3}"+Ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(ze=!1,!(!(he=Z.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=he[0],ae=ae.substring(ee.length),we=he[2].split(`
`,1)[0],se=ae.split(`
`,1)[0],this.options.pedantic?($=2,Ce=we.trimLeft()):($=he[2].search(/[^ ]/),$=$>4?1:$,Ce=we.slice($),$+=he[1].length),K=!1,!we&&/^ *$/.test(se)&&(ee+=se+`
`,ae=ae.substring(se.length+1),ze=!0),!ze)for(var re=new RegExp("^ {0,"+Math.min(3,$-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ye=new RegExp("^ {0,"+Math.min(3,$-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ae&&(De=ae.split(`
`,1)[0],we=De,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(re.test(we)||ye.test(ae)));){if(we.search(/[^ ]/)>=$||!we.trim())Ce+=`
`+we.slice($);else if(!K)Ce+=`
`+we;else break;!K&&!we.trim()&&(K=!0),ee+=De+`
`,ae=ae.substring(De.length+1)}Ye.loose||(de?Ye.loose=!0:/\n *\n *$/.test(ee)&&(de=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(Ce),ne&&(O=ne[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!ne,checked:O,loose:!1,text:Ce}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=Ce.trimRight(),Ye.raw=Ye.raw.trimRight();var We=Ye.items.length;for(G=0;G<We;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var oe=Ye.items[G].tokens.filter(function(Be){return Be.type==="space"}),Re=oe.every(function(Be){for(var qe=Be.raw.split(""),je=0,Ve=A(qe),nt;!(nt=Ve()).done;){var ot=nt.value;if(ot===`
`&&(je+=1),je>1)return!0}return!1});!Ye.loose&&oe.length&&Re&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},pe.html=function(ae){var he=this.rules.block.html.exec(ae);if(he){var ee={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};return this.options.sanitize&&(ee.type="paragraph",ee.text=this.options.sanitizer?this.options.sanitizer(he[0]):b(he[0]),ee.tokens=[],this.lexer.inline(ee.text,ee.tokens)),ee}},pe.def=function(ae){var he=this.rules.block.def.exec(ae);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var ee=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:he[0],href:he[2],title:he[3]}}},pe.table=function(ae){var he=this.rules.block.table.exec(ae);if(he){var ee={type:"table",header:l(he[1]).map(function(de){return{text:de}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=he[0];var ne=ee.align.length,O,$,G,K;for(O=0;O<ne;O++)/^ *-+: *$/.test(ee.align[O])?ee.align[O]="right":/^ *:-+: *$/.test(ee.align[O])?ee.align[O]="center":/^ *:-+ *$/.test(ee.align[O])?ee.align[O]="left":ee.align[O]=null;for(ne=ee.rows.length,O=0;O<ne;O++)ee.rows[O]=l(ee.rows[O],ee.header.length).map(function(de){return{text:de}});for(ne=ee.header.length,$=0;$<ne;$++)ee.header[$].tokens=[],this.lexer.inline(ee.header[$].text,ee.header[$].tokens);for(ne=ee.rows.length,$=0;$<ne;$++)for(K=ee.rows[$],G=0;G<K.length;G++)K[G].tokens=[],this.lexer.inline(K[G].text,K[G].tokens);return ee}}},pe.lheading=function(ae){var he=this.rules.block.lheading.exec(ae);if(he){var ee={type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},pe.paragraph=function(ae){var he=this.rules.block.paragraph.exec(ae);if(he){var ee={type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},pe.text=function(ae){var he=this.rules.block.text.exec(ae);if(he){var ee={type:"text",raw:he[0],text:he[0],tokens:[]};return this.lexer.inline(ee.text,ee.tokens),ee}},pe.escape=function(ae){var he=this.rules.inline.escape.exec(ae);if(he)return{type:"escape",raw:he[0],text:b(he[1])}},pe.tag=function(ae){var he=this.rules.inline.tag.exec(ae);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):b(he[0]):he[0]}},pe.link=function(ae){var he=this.rules.inline.link.exec(ae);if(he){var ee=he[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ne=d(ee.slice(0,-1),"\\");if((ee.length-ne.length)%2==0)return}else{var O=y(he[2],"()");if(O>-1){var $=he[0].indexOf("!")===0?5:4,G=$+he[1].length+O;he[2]=he[2].substring(0,O),he[0]=he[0].substring(0,G).trim(),he[3]=""}}var K=he[2],de="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);we&&(K=we[1],de=we[3])}else de=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(ee)?K=K.slice(1):K=K.slice(1,-1)),F(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},pe.reflink=function(ae,he){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var ne=(ee[2]||ee[1]).replace(/\s+/g," ");if(ne=he[ne.toLowerCase()],!ne||!ne.href){var O=ee[0].charAt(0);return{type:"text",raw:O,text:O}}return F(ee,ne,ee[0],this.lexer)}},pe.emStrong=function(ae,he,ee){ee===void 0&&(ee="");var ne=this.rules.inline.emStrong.lDelim.exec(ae);if(!!ne&&!(ne[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ne[1]||ne[2]||"";if(!O||O&&(ee===""||this.rules.inline.punctuation.exec(ee))){var $=ne[0].length-1,G,K,de=$,we=0,se=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,he=he.slice(-1*ae.length+$);(ne=se.exec(he))!=null;)if(G=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!G){if(K=G.length,ne[3]||ne[4]){de+=K;continue}else if((ne[5]||ne[6])&&$%3&&!(($+K)%3)){we+=K;continue}if(de-=K,!(de>0)){if(K=Math.min(K,K+de+we),Math.min($,K)%2){var De=ae.slice(1,$+ne.index+K);return{type:"em",raw:ae.slice(0,$+ne.index+K+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var Ce=ae.slice(2,$+ne.index+K-1);return{type:"strong",raw:ae.slice(0,$+ne.index+K+1),text:Ce,tokens:this.lexer.inlineTokens(Ce,[])}}}}}},pe.codespan=function(ae){var he=this.rules.inline.code.exec(ae);if(he){var ee=he[2].replace(/\n/g," "),ne=/[^ ]/.test(ee),O=/^ /.test(ee)&&/ $/.test(ee);return ne&&O&&(ee=ee.substring(1,ee.length-1)),ee=b(ee,!0),{type:"codespan",raw:he[0],text:ee}}},pe.br=function(ae){var he=this.rules.inline.br.exec(ae);if(he)return{type:"br",raw:he[0]}},pe.del=function(ae){var he=this.rules.inline.del.exec(ae);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2],[])}},pe.autolink=function(ae,he){var ee=this.rules.inline.autolink.exec(ae);if(ee){var ne,O;return ee[2]==="@"?(ne=b(this.options.mangle?he(ee[1]):ee[1]),O="mailto:"+ne):(ne=b(ee[1]),O=ne),{type:"link",raw:ee[0],text:ne,href:O,tokens:[{type:"text",raw:ne,text:ne}]}}},pe.url=function(ae,he){var ee;if(ee=this.rules.inline.url.exec(ae)){var ne,O;if(ee[2]==="@")ne=b(this.options.mangle?he(ee[0]):ee[0]),O="mailto:"+ne;else{var $;do $=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while($!==ee[0]);ne=b(ee[0]),ee[1]==="www."?O="http://"+ne:O=ne}return{type:"link",raw:ee[0],text:ne,href:O,tokens:[{type:"text",raw:ne,text:ne}]}}},pe.inlineText=function(ae,he){var ee=this.rules.inline.text.exec(ae);if(ee){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]):ee[0]:ne=b(this.options.smartypants?he(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ne}}},le}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=v(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=v(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=v(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=v(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=v(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=v(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=o({},N),N.gfm=o({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=v(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=v(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=o({},N.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:v(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var H={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};H._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",H.punctuation=v(H.punctuation).replace(/punctuation/g,H._punctuation).getRegex(),H.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,H.escapedEmSt=/\\\*|\\_/g,H._comment=v(N._comment).replace("(?:-->|$)","-->").getRegex(),H.emStrong.lDelim=v(H.emStrong.lDelim).replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimAst=v(H.emStrong.rDelimAst,"g").replace(/punct/g,H._punctuation).getRegex(),H.emStrong.rDelimUnd=v(H.emStrong.rDelimUnd,"g").replace(/punct/g,H._punctuation).getRegex(),H._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,H._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,H._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,H.autolink=v(H.autolink).replace("scheme",H._scheme).replace("email",H._email).getRegex(),H._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,H.tag=v(H.tag).replace("comment",H._comment).replace("attribute",H._attribute).getRegex(),H._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,H._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,H._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,H.link=v(H.link).replace("label",H._label).replace("href",H._href).replace("title",H._title).getRegex(),H.reflink=v(H.reflink).replace("label",H._label).replace("ref",N._label).getRegex(),H.nolink=v(H.nolink).replace("ref",N._label).getRegex(),H.reflinkSearch=v(H.reflinkSearch,"g").replace("reflink",H.reflink).replace("nolink",H.nolink).getRegex(),H.normal=o({},H),H.pedantic=o({},H.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",H._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",H._label).getRegex()}),H.gfm=o({},H.normal,{escape:v(H.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),H.gfm.url=v(H.gfm.url,"i").replace("email",H.gfm._extended_email).getRegex(),H.breaks=o({},H.gfm,{br:v(H.br).replace("{2,}","*").getRegex(),text:v(H.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function te(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(le){var pe="",be,ae,he=le.length;for(be=0;be<he;be++)ae=le.charCodeAt(be),Math.random()>.5&&(ae="x"+ae.toString(16)),pe+="&#"+ae+";";return pe}var z=function(){function le(be){this.tokens=[],this.tokens.links=Object.create(null),this.options=be||X.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:N.normal,inline:H.normal};this.options.pedantic?(ae.block=N.pedantic,ae.inline=H.pedantic):this.options.gfm&&(ae.block=N.gfm,this.options.breaks?ae.inline=H.breaks:ae.inline=H.gfm),this.tokenizer.rules=ae}le.lex=function(ae,he){var ee=new le(he);return ee.lex(ae)},le.lexInline=function(ae,he){var ee=new le(he);return ee.inlineTokens(ae)};var pe=le.prototype;return pe.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},pe.blockTokens=function(ae,he){var ee=this;he===void 0&&(he=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(de,we,se){return we+"    ".repeat(se.length)});for(var ne,O,$,G;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(ne=de.call({lexer:ee},ae,he))?(ae=ae.substring(ne.raw.length),he.push(ne),!0):!1}))){if(ne=this.tokenizer.space(ae)){ae=ae.substring(ne.raw.length),ne.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(ne);continue}if(ne=this.tokenizer.code(ae)){ae=ae.substring(ne.raw.length),O=he[he.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ne.raw,O.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):he.push(ne);continue}if(ne=this.tokenizer.fences(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.heading(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.hr(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.blockquote(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.list(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.html(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.def(ae)){ae=ae.substring(ne.raw.length),O=he[he.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ne.raw,O.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.lheading(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if($=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,we=ae.slice(1),se=void 0;ee.options.extensions.startBlock.forEach(function(De){se=De.call({lexer:this},we),typeof se=="number"&&se>=0&&(de=Math.min(de,se))}),de<1/0&&de>=0&&($=ae.substring(0,de+1))}(),this.state.top&&(ne=this.tokenizer.paragraph($))){O=he[he.length-1],G&&O.type==="paragraph"?(O.raw+=`
`+ne.raw,O.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):he.push(ne),G=$.length!==ae.length,ae=ae.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(ae)){ae=ae.substring(ne.raw.length),O=he[he.length-1],O&&O.type==="text"?(O.raw+=`
`+ne.raw,O.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):he.push(ne);continue}if(ae){var K="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},pe.inline=function(ae,he){this.inlineQueue.push({src:ae,tokens:he})},pe.inlineTokens=function(ae,he){var ee=this;he===void 0&&(he=[]);var ne,O,$,G=ae,K,de,we;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)se.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,K.index)+"["+M("a",K[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,K.index)+"["+M("a",K[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,K.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(de||(we=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ce){return(ne=Ce.call({lexer:ee},ae,he))?(ae=ae.substring(ne.raw.length),he.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.tag(ae)){ae=ae.substring(ne.raw.length),O=he[he.length-1],O&&ne.type==="text"&&O.type==="text"?(O.raw+=ne.raw,O.text+=ne.text):he.push(ne);continue}if(ne=this.tokenizer.link(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ne.raw.length),O=he[he.length-1],O&&ne.type==="text"&&O.type==="text"?(O.raw+=ne.raw,O.text+=ne.text):he.push(ne);continue}if(ne=this.tokenizer.emStrong(ae,G,we)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.codespan(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.br(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.del(ae)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(ne=this.tokenizer.autolink(ae,B)){ae=ae.substring(ne.raw.length),he.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(ae,B))){ae=ae.substring(ne.raw.length),he.push(ne);continue}if($=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Ce=1/0,ze=ae.slice(1),Ke=void 0;ee.options.extensions.startInline.forEach(function(Ne){Ke=Ne.call({lexer:this},ze),typeof Ke=="number"&&Ke>=0&&(Ce=Math.min(Ce,Ke))}),Ce<1/0&&Ce>=0&&($=ae.substring(0,Ce+1))}(),ne=this.tokenizer.inlineText($,te)){ae=ae.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(we=ne.raw.slice(-1)),de=!0,O=he[he.length-1],O&&O.type==="text"?(O.raw+=ne.raw,O.text+=ne.text):he.push(ne);continue}if(ae){var De="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return he},u(le,null,[{key:"rules",get:function(){return{block:N,inline:H}}}]),le}(),q=function(){function le(be){this.options=be||X.defaults}var pe=le.prototype;return pe.code=function(ae,he,ee){var ne=(he||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(ae,ne);O!=null&&O!==ae&&(ee=!0,ae=O)}return ae=ae.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+b(ne,!0)+'">'+(ee?ae:b(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:b(ae,!0))+`</code></pre>
`},pe.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},pe.html=function(ae){return ae},pe.heading=function(ae,he,ee,ne){if(this.options.headerIds){var O=this.options.headerPrefix+ne.slug(ee);return"<h"+he+' id="'+O+'">'+ae+"</h"+he+`>
`}return"<h"+he+">"+ae+"</h"+he+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(ae,he,ee){var ne=he?"ol":"ul",O=he&&ee!==1?' start="'+ee+'"':"";return"<"+ne+O+`>
`+ae+"</"+ne+`>
`},pe.listitem=function(ae){return"<li>"+ae+`</li>
`},pe.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(ae){return"<p>"+ae+`</p>
`},pe.table=function(ae,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+he+`</table>
`},pe.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},pe.tablecell=function(ae,he){var ee=he.header?"th":"td",ne=he.align?"<"+ee+' align="'+he.align+'">':"<"+ee+">";return ne+ae+("</"+ee+`>
`)},pe.strong=function(ae){return"<strong>"+ae+"</strong>"},pe.em=function(ae){return"<em>"+ae+"</em>"},pe.codespan=function(ae){return"<code>"+ae+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(ae){return"<del>"+ae+"</del>"},pe.link=function(ae,he,ee){if(ae=m(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var ne='<a href="'+b(ae)+'"';return he&&(ne+=' title="'+he+'"'),ne+=">"+ee+"</a>",ne},pe.image=function(ae,he,ee){if(ae=m(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var ne='<img src="'+ae+'" alt="'+ee+'"';return he&&(ne+=' title="'+he+'"'),ne+=this.options.xhtml?"/>":">",ne},pe.text=function(ae){return ae},le}(),V=function(){function le(){}var pe=le.prototype;return pe.strong=function(ae){return ae},pe.em=function(ae){return ae},pe.codespan=function(ae){return ae},pe.del=function(ae){return ae},pe.html=function(ae){return ae},pe.text=function(ae){return ae},pe.link=function(ae,he,ee){return""+ee},pe.image=function(ae,he,ee){return""+ee},pe.br=function(){return""},le}(),j=function(){function le(){this.seen={}}var pe=le.prototype;return pe.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(ae,he){var ee=ae,ne=0;if(this.seen.hasOwnProperty(ee)){ne=this.seen[ae];do ne++,ee=ae+"-"+ne;while(this.seen.hasOwnProperty(ee))}return he||(this.seen[ae]=ne,this.seen[ee]=0),ee},pe.slug=function(ae,he){he===void 0&&(he={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,he.dryrun)},le}(),ie=function(){function le(be){this.options=be||X.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new j}le.parse=function(ae,he){var ee=new le(he);return ee.parse(ae)},le.parseInline=function(ae,he){var ee=new le(he);return ee.parseInline(ae)};var pe=le.prototype;return pe.parse=function(ae,he){he===void 0&&(he=!0);var ee="",ne,O,$,G,K,de,we,se,De,Ce,ze,Ke,Ne,Ye,Z,re,ye,We,oe,Re=ae.length;for(ne=0;ne<Re;ne++){if(Ce=ae[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(oe=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),oe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ce.type))){ee+=oe||"";continue}switch(Ce.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Ce.tokens),Ce.depth,p(this.parseInline(Ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Ce.text,Ce.lang,Ce.escaped);continue}case"table":{for(se="",we="",G=Ce.header.length,O=0;O<G;O++)we+=this.renderer.tablecell(this.parseInline(Ce.header[O].tokens),{header:!0,align:Ce.align[O]});for(se+=this.renderer.tablerow(we),De="",G=Ce.rows.length,O=0;O<G;O++){for(de=Ce.rows[O],we="",K=de.length,$=0;$<K;$++)we+=this.renderer.tablecell(this.parseInline(de[$].tokens),{header:!1,align:Ce.align[$]});De+=this.renderer.tablerow(we)}ee+=this.renderer.table(se,De);continue}case"blockquote":{De=this.parse(Ce.tokens),ee+=this.renderer.blockquote(De);continue}case"list":{for(ze=Ce.ordered,Ke=Ce.start,Ne=Ce.loose,G=Ce.items.length,De="",O=0;O<G;O++)Z=Ce.items[O],re=Z.checked,ye=Z.task,Ye="",Z.task&&(We=this.renderer.checkbox(re),Ne?Z.tokens.length>0&&Z.tokens[0].type==="paragraph"?(Z.tokens[0].text=We+" "+Z.tokens[0].text,Z.tokens[0].tokens&&Z.tokens[0].tokens.length>0&&Z.tokens[0].tokens[0].type==="text"&&(Z.tokens[0].tokens[0].text=We+" "+Z.tokens[0].tokens[0].text)):Z.tokens.unshift({type:"text",text:We}):Ye+=We),Ye+=this.parse(Z.tokens,Ne),De+=this.renderer.listitem(Ye,ye,re);ee+=this.renderer.list(De,ze,Ke);continue}case"html":{ee+=this.renderer.html(Ce.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Ce.tokens));continue}case"text":{for(De=Ce.tokens?this.parseInline(Ce.tokens):Ce.text;ne+1<Re&&ae[ne+1].type==="text";)Ce=ae[++ne],De+=`
`+(Ce.tokens?this.parseInline(Ce.tokens):Ce.text);ee+=he?this.renderer.paragraph(De):De;continue}default:{var Be='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return ee},pe.parseInline=function(ae,he){he=he||this.renderer;var ee="",ne,O,$,G=ae.length;for(ne=0;ne<G;ne++){if(O=ae[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&($=this.options.extensions.renderers[O.type].call({parser:this},O),$!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){ee+=$||"";continue}switch(O.type){case"escape":{ee+=he.text(O.text);break}case"html":{ee+=he.html(O.text);break}case"link":{ee+=he.link(O.href,O.title,this.parseInline(O.tokens,he));break}case"image":{ee+=he.image(O.href,O.title,O.text);break}case"strong":{ee+=he.strong(this.parseInline(O.tokens,he));break}case"em":{ee+=he.em(this.parseInline(O.tokens,he));break}case"codespan":{ee+=he.codespan(O.text);break}case"br":{ee+=he.br();break}case"del":{ee+=he.del(this.parseInline(O.tokens,he));break}case"text":{ee+=he.text(O.text);break}default:{var K='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return ee},le}();function Q(le,pe,be){if(typeof le=="undefined"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof pe=="function"&&(be=pe,pe=null),pe=o({},Q.defaults,pe||{}),L(pe),be){var ae=pe.highlight,he;try{he=z.lex(le,pe)}catch($){return be($)}var ee=function(G){var K;if(!G)try{pe.walkTokens&&Q.walkTokens(he,pe.walkTokens),K=ie.parse(he,pe)}catch(de){G=de}return pe.highlight=ae,G?be(G):be(null,K)};if(!ae||ae.length<3||(delete pe.highlight,!he.length))return ee();var ne=0;Q.walkTokens(he,function($){$.type==="code"&&(ne++,setTimeout(function(){ae($.text,$.lang,function(G,K){if(G)return ee(G);K!=null&&K!==$.text&&($.text=K,$.escaped=!0),ne--,ne===0&&ee()})},0))}),ne===0&&ee();return}try{var O=z.lex(le,pe);return pe.walkTokens&&Q.walkTokens(O,pe.walkTokens),ie.parse(O,pe)}catch($){if($.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+b($.message+"",!0)+"</pre>";throw $}}Q.options=Q.setOptions=function(le){return o(Q.defaults,le),D(Q.defaults),Q},Q.getDefaults=C,Q.defaults=X.defaults,Q.use=function(){for(var le=arguments.length,pe=new Array(le),be=0;be<le;be++)pe[be]=arguments[be];var ae=o.apply(void 0,[{}].concat(pe)),he=Q.defaults.extensions||{renderers:{},childTokens:{}},ee;pe.forEach(function(ne){if(ne.extensions&&(ee=!0,ne.extensions.forEach(function($){if(!$.name)throw new Error("extension name required");if($.renderer){var G=he.renderers?he.renderers[$.name]:null;G?he.renderers[$.name]=function(){for(var K=arguments.length,de=new Array(K),we=0;we<K;we++)de[we]=arguments[we];var se=$.renderer.apply(this,de);return se===!1&&(se=G.apply(this,de)),se}:he.renderers[$.name]=$.renderer}if($.tokenizer){if(!$.level||$.level!=="block"&&$.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[$.level]?he[$.level].unshift($.tokenizer):he[$.level]=[$.tokenizer],$.start&&($.level==="block"?he.startBlock?he.startBlock.push($.start):he.startBlock=[$.start]:$.level==="inline"&&(he.startInline?he.startInline.push($.start):he.startInline=[$.start]))}$.childTokens&&(he.childTokens[$.name]=$.childTokens)})),ne.renderer&&function(){var $=Q.defaults.renderer||new q,G=function(we){var se=$[we];$[we]=function(){for(var De=arguments.length,Ce=new Array(De),ze=0;ze<De;ze++)Ce[ze]=arguments[ze];var Ke=ne.renderer[we].apply($,Ce);return Ke===!1&&(Ke=se.apply($,Ce)),Ke}};for(var K in ne.renderer)G(K);ae.renderer=$}(),ne.tokenizer&&function(){var $=Q.defaults.tokenizer||new U,G=function(we){var se=$[we];$[we]=function(){for(var De=arguments.length,Ce=new Array(De),ze=0;ze<De;ze++)Ce[ze]=arguments[ze];var Ke=ne.tokenizer[we].apply($,Ce);return Ke===!1&&(Ke=se.apply($,Ce)),Ke}};for(var K in ne.tokenizer)G(K);ae.tokenizer=$}(),ne.walkTokens){var O=Q.defaults.walkTokens;ae.walkTokens=function($){ne.walkTokens.call(this,$),O&&O.call(this,$)}}ee&&(ae.extensions=he),Q.setOptions(ae)})},Q.walkTokens=function(le,pe){for(var be=function(){var ne=he.value;switch(pe.call(Q,ne),ne.type){case"table":{for(var O=A(ne.header),$;!($=O()).done;){var G=$.value;Q.walkTokens(G.tokens,pe)}for(var K=A(ne.rows),de;!(de=K()).done;)for(var we=de.value,se=A(we),De;!(De=se()).done;){var Ce=De.value;Q.walkTokens(Ce.tokens,pe)}break}case"list":{Q.walkTokens(ne.items,pe);break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[ne.type]?Q.defaults.extensions.childTokens[ne.type].forEach(function(ze){Q.walkTokens(ne[ze],pe)}):ne.tokens&&Q.walkTokens(ne.tokens,pe)}},ae=A(le),he;!(he=ae()).done;)be()},Q.parseInline=function(le,pe){if(typeof le=="undefined"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");pe=o({},Q.defaults,pe||{}),L(pe);try{var be=z.lexInline(le,pe);return pe.walkTokens&&Q.walkTokens(be,pe.walkTokens),ie.parseInline(be,pe)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+b(ae.message+"",!0)+"</pre>";throw ae}},Q.Parser=ie,Q.parser=ie.parse,Q.Renderer=q,Q.TextRenderer=V,Q.Lexer=z,Q.lexer=z.lex,Q.Tokenizer=U,Q.Slugger=j,Q.parse=Q;var ue=Q.options,ve=Q.setOptions,J=Q.use,ge=Q.walkTokens,Ee=Q.parseInline,Pe=Q,me=ie.parse,Te=z.lex;X.Lexer=z,X.Parser=ie,X.Renderer=q,X.Slugger=j,X.TextRenderer=V,X.Tokenizer=U,X.getDefaults=C,X.lexer=Te,X.marked=Q,X.options=ue,X.parse=Pe,X.parseInline=Ee,X.parser=me,X.setOptions=ve,X.use=J,X.walkTokens=ge,Object.defineProperty(X,"__esModule",{value:!0})}),define(Ie[94],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(D,E,k){return Math.min(Math.max(D,E),k)}e.clamp=u;function n(D,E){return(E+D%E)%E}e.rot=n;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class A{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class C{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const k=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function X(S){const A=[];typeof S=="number"&&A.push("code/timeOrigin",S);function C(E){A.push(E,Date.now())}function D(){const E=[];for(let k=0;k<A.length;k+=2)E.push({name:A[k],startTime:A[k+1]});return E}return{mark:C,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const C of performance.getEntriesByType("mark"))A.push({name:C.name,startTime:Math.round(S+C.startTime)});return A}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function u(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=u(n))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var n in u)(typeof exports=="object"?exports:X)[n]=u[n]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function u(n){if(e[n])return e[n].exports;var S=e[n]={i:n,l:!1,exports:{}};return X[n].call(S.exports,S,S.exports,u),S.l=!0,S.exports}return u.m=X,u.c=e,u.d=function(n,S,A){u.o(n,S)||Object.defineProperty(n,S,{enumerable:!0,get:A})},u.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},u.t=function(n,S){if(1&S&&(n=u(n)),8&S||4&S&&typeof n=="object"&&n&&n.__esModule)return n;var A=Object.create(null);if(u.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:n}),2&S&&typeof n!="string")for(var C in n)u.d(A,C,function(D){return n[D]}.bind(null,C));return A},u.n=function(n){var S=n&&n.__esModule?function(){return n.default}:function(){return n};return u.d(S,"a",S),S},u.o=function(n,S){return Object.prototype.hasOwnProperty.call(n,S)},u.p="",u(u.s=0)}([function(X,e,u){(function(n){var S;e=X.exports=J,S=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],E=e.src=[],k=0,R=k++;E[R]="0|[1-9]\\d*";var I=k++;E[I]="[0-9]+";var _=k++;E[_]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=k++;E[P]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var b=k++;E[b]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var w=k++;E[w]="(?:"+E[R]+"|"+E[_]+")";var p=k++;E[p]="(?:"+E[I]+"|"+E[_]+")";var g=k++;E[g]="(?:-("+E[w]+"(?:\\."+E[w]+")*))";var v=k++;E[v]="(?:-?("+E[p]+"(?:\\."+E[p]+")*))";var f=k++;E[f]="[0-9A-Za-z-]+";var c=k++;E[c]="(?:\\+("+E[f]+"(?:\\."+E[f]+")*))";var m=k++,a="v?"+E[P]+E[g]+"?"+E[c]+"?";E[m]="^"+a+"$";var h="[v=\\s]*"+E[b]+E[v]+"?"+E[c]+"?",r=k++;E[r]="^"+h+"$";var s=k++;E[s]="((?:<|>)?=?)";var i=k++;E[i]=E[I]+"|x|X|\\*";var t=k++;E[t]=E[R]+"|x|X|\\*";var o=k++;E[o]="[v=\\s]*("+E[t]+")(?:\\.("+E[t]+")(?:\\.("+E[t]+")(?:"+E[g]+")?"+E[c]+"?)?)?";var l=k++;E[l]="[v=\\s]*("+E[i]+")(?:\\.("+E[i]+")(?:\\.("+E[i]+")(?:"+E[v]+")?"+E[c]+"?)?)?";var d=k++;E[d]="^"+E[s]+"\\s*"+E[o]+"$";var y=k++;E[y]="^"+E[s]+"\\s*"+E[l]+"$";var L=k++;E[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=k++;E[M]="(?:~>?)";var F=k++;E[F]="(\\s*)"+E[M]+"\\s+",D[F]=new RegExp(E[F],"g");var T=k++;E[T]="^"+E[M]+E[o]+"$";var U=k++;E[U]="^"+E[M]+E[l]+"$";var N=k++;E[N]="(?:\\^)";var H=k++;E[H]="(\\s*)"+E[N]+"\\s+",D[H]=new RegExp(E[H],"g");var te=k++;E[te]="^"+E[N]+E[o]+"$";var B=k++;E[B]="^"+E[N]+E[l]+"$";var z=k++;E[z]="^"+E[s]+"\\s*("+h+")$|^$";var q=k++;E[q]="^"+E[s]+"\\s*("+a+")$|^$";var V=k++;E[V]="(\\s*)"+E[s]+"\\s*("+h+"|"+E[o]+")",D[V]=new RegExp(E[V],"g");var j=k++;E[j]="^\\s*("+E[o]+")\\s+-\\s+("+E[o]+")\\s*$";var ie=k++;E[ie]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var Q=k++;E[Q]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)S(ue,E[ue]),D[ue]||(D[ue]=new RegExp(E[ue]));function ve(se,De){if(se instanceof J)return se;if(typeof se!="string"||se.length>A||!(De?D[r]:D[m]).test(se))return null;try{return new J(se,De)}catch{return null}}function J(se,De){if(se instanceof J){if(se.loose===De)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof J))return new J(se,De);S("SemVer",se,De),this.loose=De;var Ce=se.trim().match(De?D[r]:D[m]);if(!Ce)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+Ce[1],this.minor=+Ce[2],this.patch=+Ce[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");Ce[4]?this.prerelease=Ce[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ke=+ze;if(Ke>=0&&Ke<C)return Ke}return ze}):this.prerelease=[],this.build=Ce[5]?Ce[5].split("."):[],this.format()}e.parse=ve,e.valid=function(se,De){var Ce=ve(se,De);return Ce?Ce.version:null},e.clean=function(se,De){var Ce=ve(se.trim().replace(/^[=v]+/,""),De);return Ce?Ce.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(se){return S("SemVer.compare",this.version,this.loose,se),se instanceof J||(se=new J(se,this.loose)),this.compareMain(se)||this.comparePre(se)},J.prototype.compareMain=function(se){return se instanceof J||(se=new J(se,this.loose)),Ee(this.major,se.major)||Ee(this.minor,se.minor)||Ee(this.patch,se.patch)},J.prototype.comparePre=function(se){if(se instanceof J||(se=new J(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var De=0;do{var Ce=this.prerelease[De],ze=se.prerelease[De];if(S("prerelease compare",De,Ce,ze),Ce===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ce===void 0)return-1;if(Ce!==ze)return Ee(Ce,ze)}while(++De)},J.prototype.inc=function(se,De){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ce=this.prerelease.length;--Ce>=0;)typeof this.prerelease[Ce]=="number"&&(this.prerelease[Ce]++,Ce=-2);Ce===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,De,Ce,ze){typeof Ce=="string"&&(ze=Ce,Ce=void 0);try{return new J(se,Ce).inc(De,ze).version}catch{return null}},e.diff=function(se,De){if(le(se,De))return null;var Ce=ve(se),ze=ve(De);if(Ce.prerelease.length||ze.prerelease.length){for(var Ke in Ce)if((Ke==="major"||Ke==="minor"||Ke==="patch")&&Ce[Ke]!==ze[Ke])return"pre"+Ke;return"prerelease"}for(var Ke in Ce)if((Ke==="major"||Ke==="minor"||Ke==="patch")&&Ce[Ke]!==ze[Ke])return Ke},e.compareIdentifiers=Ee;var ge=/^[0-9]+$/;function Ee(se,De){var Ce=ge.test(se),ze=ge.test(De);return Ce&&ze&&(se=+se,De=+De),Ce&&!ze?-1:ze&&!Ce?1:se<De?-1:se>De?1:0}function Pe(se,De,Ce){return new J(se,Ce).compare(new J(De,Ce))}function me(se,De,Ce){return Pe(se,De,Ce)>0}function Te(se,De,Ce){return Pe(se,De,Ce)<0}function le(se,De,Ce){return Pe(se,De,Ce)===0}function pe(se,De,Ce){return Pe(se,De,Ce)!==0}function be(se,De,Ce){return Pe(se,De,Ce)>=0}function ae(se,De,Ce){return Pe(se,De,Ce)<=0}function he(se,De,Ce,ze){var Ke;switch(De){case"===":typeof se=="object"&&(se=se.version),typeof Ce=="object"&&(Ce=Ce.version),Ke=se===Ce;break;case"!==":typeof se=="object"&&(se=se.version),typeof Ce=="object"&&(Ce=Ce.version),Ke=se!==Ce;break;case"":case"=":case"==":Ke=le(se,Ce,ze);break;case"!=":Ke=pe(se,Ce,ze);break;case">":Ke=me(se,Ce,ze);break;case">=":Ke=be(se,Ce,ze);break;case"<":Ke=Te(se,Ce,ze);break;case"<=":Ke=ae(se,Ce,ze);break;default:throw new TypeError("Invalid operator: "+De)}return Ke}function ee(se,De){if(se instanceof ee){if(se.loose===De)return se;se=se.value}if(!(this instanceof ee))return new ee(se,De);S("comparator",se,De),this.loose=De,this.parse(se),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(se,De){return Ee(De,se)},e.major=function(se,De){return new J(se,De).major},e.minor=function(se,De){return new J(se,De).minor},e.patch=function(se,De){return new J(se,De).patch},e.compare=Pe,e.compareLoose=function(se,De){return Pe(se,De,!0)},e.rcompare=function(se,De,Ce){return Pe(De,se,Ce)},e.sort=function(se,De){return se.sort(function(Ce,ze){return e.compare(Ce,ze,De)})},e.rsort=function(se,De){return se.sort(function(Ce,ze){return e.rcompare(Ce,ze,De)})},e.gt=me,e.lt=Te,e.eq=le,e.neq=pe,e.gte=be,e.lte=ae,e.cmp=he,e.Comparator=ee;var ne={};function O(se,De){if(se instanceof O)return se.loose===De?se:new O(se.raw,De);if(se instanceof ee)return new O(se.value,De);if(!(this instanceof O))return new O(se,De);if(this.loose=De,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(Ce){return this.parseRange(Ce.trim())},this).filter(function(Ce){return Ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function $(se){return!se||se.toLowerCase()==="x"||se==="*"}function G(se,De,Ce,ze,Ke,Ne,Ye,Z,re,ye,We,oe,Re){return((De=$(Ce)?"":$(ze)?">="+Ce+".0.0":$(Ke)?">="+Ce+"."+ze+".0":">="+De)+" "+(Z=$(re)?"":$(ye)?"<"+(+re+1)+".0.0":$(We)?"<"+re+"."+(+ye+1)+".0":oe?"<="+re+"."+ye+"."+We+"-"+oe:"<="+Z)).trim()}function K(se,De){for(var Ce=0;Ce<se.length;Ce++)if(!se[Ce].test(De))return!1;if(De.prerelease.length){for(Ce=0;Ce<se.length;Ce++)if(S(se[Ce].semver),se[Ce].semver!==ne&&se[Ce].semver.prerelease.length>0){var ze=se[Ce].semver;if(ze.major===De.major&&ze.minor===De.minor&&ze.patch===De.patch)return!0}return!1}return!0}function de(se,De,Ce){try{De=new O(De,Ce)}catch{return!1}return De.test(se)}function we(se,De,Ce,ze){var Ke,Ne,Ye,Z,re;switch(se=new J(se,ze),De=new O(De,ze),Ce){case">":Ke=me,Ne=ae,Ye=Te,Z=">",re=">=";break;case"<":Ke=Te,Ne=be,Ye=me,Z="<",re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(se,De,ze))return!1;for(var ye=0;ye<De.set.length;++ye){var We=De.set[ye],oe=null,Re=null;if(We.forEach(function(Be){Be.semver===ne&&(Be=new ee(">=0.0.0")),oe=oe||Be,Re=Re||Be,Ke(Be.semver,oe.semver,ze)?oe=Be:Ye(Be.semver,Re.semver,ze)&&(Re=Be)}),oe.operator===Z||oe.operator===re||(!Re.operator||Re.operator===Z)&&Ne(se,Re.semver)||Re.operator===re&&Ye(se,Re.semver))return!1}return!0}ee.prototype.parse=function(se){var De=this.loose?D[z]:D[q],Ce=se.match(De);if(!Ce)throw new TypeError("Invalid comparator: "+se);this.operator=Ce[1],this.operator==="="&&(this.operator=""),Ce[2]?this.semver=new J(Ce[2],this.loose):this.semver=ne},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(se){return S("Comparator.test",se,this.loose),this.semver===ne||(typeof se=="string"&&(se=new J(se,this.loose)),he(se,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(se,De){if(!(se instanceof ee))throw new TypeError("a Comparator is required");var Ce;if(this.operator==="")return Ce=new O(se.value,De),de(this.value,Ce,De);if(se.operator==="")return Ce=new O(this.value,De),de(se.semver,Ce,De);var ze=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Ke=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),Ne=this.semver.version===se.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),Z=he(this.semver,"<",se.semver,De)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),re=he(this.semver,">",se.semver,De)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return ze||Ke||Ne&&Ye||Z||re},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(se){var De=this.loose;se=se.trim(),S("range",se,De);var Ce=De?D[ie]:D[j];se=se.replace(Ce,G),S("hyphen replace",se),se=se.replace(D[V],"$1$2$3"),S("comparator trim",se,D[V]),se=(se=(se=se.replace(D[F],"$1~")).replace(D[H],"$1^")).split(/\s+/).join(" ");var ze=De?D[z]:D[q],Ke=se.split(" ").map(function(Ne){return function(Ye,Z){return S("comp",Ye),Ye=function(re,ye){return re.trim().split(/\s+/).map(function(We){return function(oe,Re){S("caret",oe,Re);var Be=Re?D[B]:D[te];return oe.replace(Be,function(qe,je,Ve,nt,ot){var st;return S("caret",oe,qe,je,Ve,nt,ot),$(je)?st="":$(Ve)?st=">="+je+".0.0 <"+(+je+1)+".0.0":$(nt)?st=je==="0"?">="+je+"."+Ve+".0 <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+".0 <"+(+je+1)+".0.0":ot?(S("replaceCaret pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),st=je==="0"?Ve==="0"?">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+Ve+"."+(+nt+1):">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+"."+nt+ot+" <"+(+je+1)+".0.0"):(S("no pr"),st=je==="0"?Ve==="0"?">="+je+"."+Ve+"."+nt+" <"+je+"."+Ve+"."+(+nt+1):">="+je+"."+Ve+"."+nt+" <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+"."+nt+" <"+(+je+1)+".0.0"),S("caret return",st),st})}(We,ye)}).join(" ")}(Ye,Z),S("caret",Ye),Ye=function(re,ye){return re.trim().split(/\s+/).map(function(We){return function(oe,Re){var Be=Re?D[U]:D[T];return oe.replace(Be,function(qe,je,Ve,nt,ot){var st;return S("tilde",oe,qe,je,Ve,nt,ot),$(je)?st="":$(Ve)?st=">="+je+".0.0 <"+(+je+1)+".0.0":$(nt)?st=">="+je+"."+Ve+".0 <"+je+"."+(+Ve+1)+".0":ot?(S("replaceTilde pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),st=">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+(+Ve+1)+".0"):st=">="+je+"."+Ve+"."+nt+" <"+je+"."+(+Ve+1)+".0",S("tilde return",st),st})}(We,ye)}).join(" ")}(Ye,Z),S("tildes",Ye),Ye=function(re,ye){return S("replaceXRanges",re,ye),re.split(/\s+/).map(function(We){return function(oe,Re){oe=oe.trim();var Be=Re?D[y]:D[d];return oe.replace(Be,function(qe,je,Ve,nt,ot,st){S("xRange",oe,qe,je,Ve,nt,ot,st);var it=$(Ve),at=it||$(nt),bt=at||$(ot);return je==="="&&bt&&(je=""),it?qe=je===">"||je==="<"?"<0.0.0":"*":je&&bt?(at&&(nt=0),bt&&(ot=0),je===">"?(je=">=",at?(Ve=+Ve+1,nt=0,ot=0):bt&&(nt=+nt+1,ot=0)):je==="<="&&(je="<",at?Ve=+Ve+1:nt=+nt+1),qe=je+Ve+"."+nt+"."+ot):at?qe=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":bt&&(qe=">="+Ve+"."+nt+".0 <"+Ve+"."+(+nt+1)+".0"),S("xRange return",qe),qe})}(We,ye)}).join(" ")}(Ye,Z),S("xrange",Ye),Ye=function(re,ye){return S("replaceStars",re,ye),re.trim().replace(D[Q],"")}(Ye,Z),S("stars",Ye),Ye}(Ne,De)}).join(" ").split(/\s+/);return this.loose&&(Ke=Ke.filter(function(Ne){return!!Ne.match(ze)})),Ke=Ke.map(function(Ne){return new ee(Ne,De)})},O.prototype.intersects=function(se,De){if(!(se instanceof O))throw new TypeError("a Range is required");return this.set.some(function(Ce){return Ce.every(function(ze){return se.set.some(function(Ke){return Ke.every(function(Ne){return ze.intersects(Ne,De)})})})})},e.toComparators=function(se,De){return new O(se,De).set.map(function(Ce){return Ce.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},O.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new J(se,this.loose));for(var De=0;De<this.set.length;De++)if(K(this.set[De],se))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(se,De,Ce){var ze=null,Ke=null;try{var Ne=new O(De,Ce)}catch{return null}return se.forEach(function(Ye){Ne.test(Ye)&&(ze&&Ke.compare(Ye)!==-1||(Ke=new J(ze=Ye,Ce)))}),ze},e.minSatisfying=function(se,De,Ce){var ze=null,Ke=null;try{var Ne=new O(De,Ce)}catch{return null}return se.forEach(function(Ye){Ne.test(Ye)&&(ze&&Ke.compare(Ye)!==1||(Ke=new J(ze=Ye,Ce)))}),ze},e.validRange=function(se,De){try{return new O(se,De).range||"*"}catch{return null}},e.ltr=function(se,De,Ce){return we(se,De,"<",Ce)},e.gtr=function(se,De,Ce){return we(se,De,">",Ce)},e.outside=we,e.prerelease=function(se,De){var Ce=ve(se,De);return Ce&&Ce.prerelease.length?Ce.prerelease:null},e.intersects=function(se,De,Ce){return se=new O(se,Ce),De=new O(De,Ce),se.intersects(De)},e.coerce=function(se){if(se instanceof J)return se;if(typeof se!="string")return null;var De=se.match(D[L]);return De==null?null:ve((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,u(1))},function(X,e){var u,n,S=X.exports={};function A(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function D(p){if(u===setTimeout)return setTimeout(p,0);if((u===A||!u)&&setTimeout)return u=setTimeout,setTimeout(p,0);try{return u(p,0)}catch{try{return u.call(null,p,0)}catch{return u.call(this,p,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:A}catch{u=A}try{n=typeof clearTimeout=="function"?clearTimeout:C}catch{n=C}})();var E,k=[],R=!1,I=-1;function _(){R&&E&&(R=!1,E.length?k=E.concat(k):I=-1,k.length&&P())}function P(){if(!R){var p=D(_);R=!0;for(var g=k.length;g;){for(E=k,k=[];++I<g;)E&&E[I].run();I=-1,g=k.length}E=null,R=!1,function(v){if(n===clearTimeout)return clearTimeout(v);if((n===C||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(v);try{n(v)}catch{try{return n.call(null,v)}catch{return n.call(this,v)}}}(p)}}function b(p,g){this.fun=p,this.array=g}function w(){}S.nextTick=function(p){var g=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)g[v-1]=arguments[v];k.push(new b(p,g)),k.length!==1||R||D(P)},b.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=w,S.addListener=w,S.once=w,S.off=w,S.removeListener=w,S.removeAllListeners=w,S.emit=w,S.prependListener=w,S.prependOnceListener=w,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ie[95],ke([1,0,12,6]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(c){const m=c;return m?typeof m.read=="function":!1}e.isReadable=S;function A(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=A;function C(c){const m=c;return m?A(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=C;function D(c,m){return new E(c,m)}e.newWriteableStream=D;class E{constructor(m,a){this.reducer=m,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(a=>a(m))}emitError(m){this.listeners.error.length===0?(0,u.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(a=>a(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,a){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(m,a){if(this.state.destroyed)return;let h;switch(m){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const r=h.indexOf(a);r>=0&&h.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(c,m){const a=[];let h;for(;(h=c.read())!==null;)a.push(h);return m(a)}e.consumeReadable=k;function R(c,m,a){const h=[];let r;for(;(r=c.read())!==null&&h.length<a;)h.push(r);return r===null&&h.length>0?m(h):{read:()=>{if(h.length>0)return h.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return c.read()}}}e.peekReadable=R;function I(c,m){return new Promise((a,h)=>{const r=[];_(c,{onData:s=>{m&&r.push(s)},onError:s=>{m?h(s):a(void 0)},onEnd:()=>{a(m?m(r):void 0)}})})}e.consumeStream=I;function _(c,m){let a=!1;return c.on("error",h=>{a||m.onError(h)}),c.on("end",()=>{a||m.onEnd()}),c.on("data",h=>{a||m.onData(h)}),(0,n.toDisposable)(()=>a=!0)}e.listenStream=_;function P(c,m){return new Promise((a,h)=>{const r=new n.DisposableStore,s=[],i=l=>{if(s.push(l),s.length>m)return r.dispose(),c.pause(),a({stream:c,buffer:s,ended:!1})},t=l=>h(l),o=()=>a({stream:c,buffer:s,ended:!0});r.add((0,n.toDisposable)(()=>c.removeListener("error",t))),c.on("error",t),r.add((0,n.toDisposable)(()=>c.removeListener("end",o))),c.on("end",o),r.add((0,n.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=P;function b(c,m){const a=D(m);return a.end(c),a}e.toStream=b;function w(){const c=D(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=w;function p(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}e.toReadable=p;function g(c,m,a){const h=D(a);return _(c,{onData:r=>h.write(m.data(r)),onError:r=>h.error(m.error?m.error(r):r),onEnd:()=>h.end()}),h}e.transform=g;function v(c,m,a){let h=!1;return{read:()=>{const r=m.read();return h?r:(h=!0,r!==null?a([c,r]):c)}}}e.prefixedReadable=v;function f(c,m,a){let h=!1;const r=D(a);return _(m,{onData:s=>h?r.write(s):(h=!0,r.write(a([c,s]))),onError:s=>r.error(s),onEnd:()=>{h||(h=!0,r.write(c)),r.end()}}),r}e.prefixedStream=f}),define(Ie[23],ke([1,0,95]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let S,A;class C{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return n?new C(Buffer.allocUnsafe(l)):new C(new Uint8Array(l))}static wrap(l){return n&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new C(l)}static fromString(l,d){return!(d?.dontUseNodeBuffer||!1)&&n?new C(Buffer.from(l)):(S||(S=new TextEncoder),new C(S.encode(l)))}static fromByteArray(l){const d=C.alloc(l.length);for(let y=0,L=l.length;y<L;y++)d.buffer[y]=l[y];return d}static concat(l,d){if(typeof d=="undefined"){d=0;for(let M=0,F=l.length;M<F;M++)d+=l[M].byteLength}const y=C.alloc(d);let L=0;for(let M=0,F=l.length;M<F;M++){const T=l[M];y.set(T,L),L+=T.byteLength}return y}clone(){const l=C.alloc(this.byteLength);return l.set(this),l}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(l,d){return new C(this.buffer.subarray(l,d))}set(l,d){if(l instanceof C)this.buffer.set(l.buffer,d);else if(l instanceof Uint8Array)this.buffer.set(l,d);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),d);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return k(this.buffer,l)}writeUInt32BE(l,d){R(this.buffer,l,d)}readUInt32LE(l){return I(this.buffer,l)}writeUInt32LE(l,d){_(this.buffer,l,d)}readUInt8(l){return P(this.buffer,l)}writeUInt8(l,d){b(this.buffer,l,d)}}e.VSBuffer=C;function D(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=D;function E(o,l,d){o[d+0]=l&255,l=l>>>8,o[d+1]=l&255}e.writeUInt16LE=E;function k(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=k;function R(o,l,d){o[d+3]=l,l=l>>>8,o[d+2]=l,l=l>>>8,o[d+1]=l,l=l>>>8,o[d]=l}e.writeUInt32BE=R;function I(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=I;function _(o,l,d){o[d+0]=l&255,l=l>>>8,o[d+1]=l&255,l=l>>>8,o[d+2]=l&255,l=l>>>8,o[d+3]=l&255}e.writeUInt32LE=_;function P(o,l){return o[l]}e.readUInt8=P;function b(o,l,d){o[d]=l}e.writeUInt8=b;function w(o){return u.consumeReadable(o,l=>C.concat(l))}e.readableToBuffer=w;function p(o){return u.toReadable(o)}e.bufferToReadable=p;function g(o){return u.consumeStream(o,l=>C.concat(l))}e.streamToBuffer=g;async function v(o){return o.ended?C.concat(o.buffer):C.concat([...o.buffer,await g(o.stream)])}e.bufferedStreamToBuffer=v;function f(o){return u.toStream(o,l=>C.concat(l))}e.bufferToStream=f;function c(o){return u.transform(o,{data:l=>typeof l=="string"?C.fromString(l):C.wrap(l)},l=>C.concat(l))}e.streamToBufferReadableStream=c;function m(o){return u.newWriteableStream(l=>C.concat(l),o)}e.newWriteableBufferStream=m;function a(o,l){return u.prefixedReadable(o,l,d=>C.concat(d))}e.prefixedBufferReadable=a;function h(o,l){return u.prefixedStream(o,l,d=>C.concat(d))}e.prefixedBufferStream=h;function r(o){let l=0,d=0,y=0;const L=new Uint8Array(Math.floor(o.length/4*3)),M=T=>{switch(d){case 3:L[y++]=l|T,d=0;break;case 2:L[y++]=l|T>>>2,l=T<<6,d=3;break;case 1:L[y++]=l|T>>>4,l=T<<4,d=2;break;default:l=T<<2,d=1}};for(let T=0;T<o.length;T++){const U=o.charCodeAt(T);if(U>=65&&U<=90)M(U-65);else if(U>=97&&U<=122)M(U-97+26);else if(U>=48&&U<=57)M(U-48+52);else if(U===43||U===45)M(62);else if(U===47||U===95)M(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${o[T]}`)}}const F=y;for(;d>0;)M(0);return C.wrap(L).slice(0,F)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:o},l=!0,d=!1){const y=d?i:s;let L="";const M=o.byteLength%3;let F=0;for(;F<o.byteLength-M;F+=3){const T=o[F+0],U=o[F+1],N=o[F+2];L+=y[T>>>2],L+=y[(T<<4|U>>>4)&63],L+=y[(U<<2|N>>>6)&63],L+=y[N&63]}if(M===1){const T=o[F+0];L+=y[T>>>2],L+=y[T<<4&63],l&&(L+="==")}else if(M===2){const T=o[F+0],U=o[F+1];L+=y[T>>>2],L+=y[(T<<4|U>>>4)&63],L+=y[U<<2&63],l&&(L+="=")}return L}e.encodeBase64=t}),define(Ie[10],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function u(o){return Array.isArray(o)}e.isArray=u;function n(o){return typeof o=="string"}e.isString=n;function S(o){return Array.isArray(o)&&o.every(l=>n(l))}e.isStringArray=S;function A(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=A;function C(o){return typeof o=="object"&&(o instanceof Uint8Array||o instanceof Uint16Array||o instanceof Uint32Array||o instanceof Float32Array||o instanceof Float64Array||o instanceof Int8Array||o instanceof Int16Array||o instanceof Int32Array||o instanceof BigInt64Array||o instanceof BigUint64Array||o instanceof Uint8ClampedArray)}e.isTypedArray=C;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function E(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=E;function k(o){return o===!0||o===!1}e.isBoolean=k;function R(o){return typeof o=="undefined"}e.isUndefined=R;function I(o){return!_(o)}e.isDefined=I;function _(o){return R(o)||o===null}e.isUndefinedOrNull=_;function P(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=P;function b(o){if(_(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=b;function w(...o){const l=[];for(let d=0;d<o.length;d++){const y=o[d];if(_(y))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);l.push(y)}return l}e.assertAllDefined=w;const p=Object.prototype.hasOwnProperty;function g(o){if(!A(o))return!1;for(const l in o)if(p.call(o,l))return!1;return!0}e.isEmptyObject=g;function v(o){return typeof o=="function"}e.isFunction=v;function f(...o){return o.length>0&&o.every(v)}e.areFunctions=f;function c(o,l){const d=Math.min(o.length,l.length);for(let y=0;y<d;y++)m(o[y],l[y])}e.validateConstraints=c;function m(o,l){if(n(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(v(l)){try{if(o instanceof l)return}catch{}if(!_(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function a(o){let l=[],d=Object.getPrototypeOf(o);for(;Object.prototype!==d;)l=l.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return l}e.getAllPropertyNames=a;function h(o){const l=[];for(const d of a(o))typeof o[d]=="function"&&l.push(d);return l}e.getAllMethodNames=h;function r(o,l){const d=L=>function(){const M=Array.prototype.slice.call(arguments,0);return l(L,M)},y={};for(const L of o)y[L]=d(L);return y}e.createProxyObject=r;function s(o){return o===null?void 0:o}e.withNullAsUndefined=s;function i(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=i;function t(o,l="Unreachable"){throw new Error(l)}e.assertNever=t}),define(Ie[24],ke([1,0,10]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const w=Array.isArray(b)?[]:{};return Object.keys(b).forEach(p=>{b[p]&&typeof b[p]=="object"?w[p]=n(b[p]):w[p]=b[p]}),w}e.deepClone=n;function S(b){if(!b||typeof b!="object")return b;const w=[b];for(;w.length>0;){const p=w.shift();Object.freeze(p);for(const g in p)if(A.call(p,g)){const v=p[g];typeof v=="object"&&!Object.isFrozen(v)&&!(0,u.isTypedArray)(v)&&w.push(v)}}return b}e.deepFreeze=S;const A=Object.prototype.hasOwnProperty;function C(b,w){return D(b,w,new Set)}e.cloneAndChange=C;function D(b,w,p){if((0,u.isUndefinedOrNull)(b))return b;const g=w(b);if(typeof g!="undefined")return g;if((0,u.isArray)(b)){const v=[];for(const f of b)v.push(D(f,w,p));return v}if((0,u.isObject)(b)){if(p.has(b))throw new Error("Cannot clone recursive data-structure");p.add(b);const v={};for(const f in b)A.call(b,f)&&(v[f]=D(b[f],w,p));return p.delete(b),v}return b}function E(b,w,p=!0){return(0,u.isObject)(b)?((0,u.isObject)(w)&&Object.keys(w).forEach(g=>{g in b?p&&((0,u.isObject)(b[g])&&(0,u.isObject)(w[g])?E(b[g],w[g],p):b[g]=w[g]):b[g]=w[g]}),b):w}e.mixin=E;function k(b,w){if(b===w)return!0;if(b==null||w===null||w===void 0||typeof b!=typeof w||typeof b!="object"||Array.isArray(b)!==Array.isArray(w))return!1;let p,g;if(Array.isArray(b)){if(b.length!==w.length)return!1;for(p=0;p<b.length;p++)if(!k(b[p],w[p]))return!1}else{const v=[];for(g in b)v.push(g);v.sort();const f=[];for(g in w)f.push(g);if(f.sort(),!k(v,f))return!1;for(p=0;p<v.length;p++)if(!k(b[v[p]],w[v[p]]))return!1}return!0}e.equals=k;function R(b){const w=new Set;return JSON.stringify(b,(p,g)=>{if((0,u.isObject)(g)||Array.isArray(g)){if(w.has(g))return"[Circular]";w.add(g)}return g})}e.safeStringify=R;function I(b,w){const p=Object.create(null);return!b||!w||Object.keys(w).forEach(v=>{const f=b[v],c=w[v];k(f,c)||(p[v]=c)}),p}e.distinct=I;function _(b,w){const p=w.toLowerCase(),g=Object.keys(b).find(v=>v.toLowerCase()===p);return g?b[g]:b[w]}e.getCaseInsensitive=_;function P(b,w){const p=Object.create(null);for(const[g,v]of Object.entries(b))w(g,v)&&(p[g]=v);return p}e.filter=P}),define(Ie[96],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u=e.Constants||(e.Constants={}));function n(A){return A<0?0:A>255?255:A|0}e.toUint8=n;function S(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=S}),define(Ie[34],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(S){return u.test(S)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(D){for(let E=0;E<D.length;E++)D[E]=Math.floor(Math.random()*256);return D};const A=new Uint8Array(16),C=[];for(let D=0;D<256;D++)C.push(D.toString(16).padStart(2,"0"));return function(){S(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let E=0,k="";return k+=C[A[E++]],k+=C[A[E++]],k+=C[A[E++]],k+=C[A[E++]],k+="-",k+=C[A[E++]],k+=C[A[E++]],k+="-",k+=C[A[E++]],k+=C[A[E++]],k+="-",k+=C[A[E++]],k+=C[A[E++]],k+="-",k+=C[A[E++]],k+=C[A[E++]],k+=C[A[E++]],k+=C[A[E++]],k+=C[A[E++]],k+=C[A[E++]],k}}()}),define(Ie[144],ke([1,0,97]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(A="utf8"){this.stringDecoder=new u.StringDecoder(A),this.remaining=null}write(A){const C=[],D=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(D.length<1)return C;let E=0,k,R=E;for(;R<D.length;)if(k=D.charCodeAt(R),k===13||k===10){if(C.push(D.substring(E,R)),R++,R<D.length){const I=k;k=D.charCodeAt(R),(I===13&&k===10||I===10&&k===13)&&R++}E=R}else R++;return this.remaining=E<D.length?D.substr(E):null,C}end(){return this.remaining}}e.LineDecoder=n}),define(Ie[98],ke([1,0,96]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class n{constructor(D){const E=(0,u.toUint8)(D);this._defaultValue=E,this._asciiMap=n._createAsciiMap(E),this._map=new Map}static _createAsciiMap(D){const E=new Uint8Array(256);for(let k=0;k<256;k++)E[k]=D;return E}set(D,E){const k=(0,u.toUint8)(E);D>=0&&D<256?this._asciiMap[D]=k:this._map.set(D,k)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=n;var S;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(S||(S={}));class A{constructor(){this._actual=new n(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=A}),define(Ie[48],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(S,A){this.lineNumber=S,this.column=A}with(S=this.lineNumber,A=this.column){return S===this.lineNumber&&A===this.column?this:new u(S,A)}delta(S=0,A=0){return this.with(this.lineNumber+S,this.column+A)}equals(S){return u.equals(this,S)}static equals(S,A){return!S&&!A?!0:!!S&&!!A&&S.lineNumber===A.lineNumber&&S.column===A.column}isBefore(S){return u.isBefore(this,S)}static isBefore(S,A){return S.lineNumber<A.lineNumber?!0:A.lineNumber<S.lineNumber?!1:S.column<A.column}isBeforeOrEqual(S){return u.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,A){return S.lineNumber<A.lineNumber?!0:A.lineNumber<S.lineNumber?!1:S.column<=A.column}static compare(S,A){const C=S.lineNumber|0,D=A.lineNumber|0;if(C===D){const E=S.column|0,k=A.column|0;return E-k}return C-D}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new u(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=u}),define(Ie[35],ke([1,0,48]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class n{constructor(A,C,D,E){A>D||A===D&&C>E?(this.startLineNumber=D,this.startColumn=E,this.endLineNumber=A,this.endColumn=C):(this.startLineNumber=A,this.startColumn=C,this.endLineNumber=D,this.endColumn=E)}isEmpty(){return n.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return n.containsPosition(this,A)}static containsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<A.startColumn||C.lineNumber===A.endLineNumber&&C.column>A.endColumn)}static strictContainsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<=A.startColumn||C.lineNumber===A.endLineNumber&&C.column>=A.endColumn)}containsRange(A){return n.containsRange(this,A)}static containsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>A.endColumn)}strictContainsRange(A){return n.strictContainsRange(this,A)}static strictContainsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<=A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>=A.endColumn)}plusRange(A){return n.plusRange(this,A)}static plusRange(A,C){let D,E,k,R;return C.startLineNumber<A.startLineNumber?(D=C.startLineNumber,E=C.startColumn):C.startLineNumber===A.startLineNumber?(D=C.startLineNumber,E=Math.min(C.startColumn,A.startColumn)):(D=A.startLineNumber,E=A.startColumn),C.endLineNumber>A.endLineNumber?(k=C.endLineNumber,R=C.endColumn):C.endLineNumber===A.endLineNumber?(k=C.endLineNumber,R=Math.max(C.endColumn,A.endColumn)):(k=A.endLineNumber,R=A.endColumn),new n(D,E,k,R)}intersectRanges(A){return n.intersectRanges(this,A)}static intersectRanges(A,C){let D=A.startLineNumber,E=A.startColumn,k=A.endLineNumber,R=A.endColumn;const I=C.startLineNumber,_=C.startColumn,P=C.endLineNumber,b=C.endColumn;return D<I?(D=I,E=_):D===I&&(E=Math.max(E,_)),k>P?(k=P,R=b):k===P&&(R=Math.min(R,b)),D>k||D===k&&E>R?null:new n(D,E,k,R)}equalsRange(A){return n.equalsRange(this,A)}static equalsRange(A,C){return!!A&&!!C&&A.startLineNumber===C.startLineNumber&&A.startColumn===C.startColumn&&A.endLineNumber===C.endLineNumber&&A.endColumn===C.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(A){return new u.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(A){return new u.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,C){return new n(this.startLineNumber,this.startColumn,A,C)}setStartPosition(A,C){return new n(A,C,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(A){return new n(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,C=A){return new n(A.lineNumber,A.column,C.lineNumber,C.column)}static lift(A){return A?new n(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn)}static areIntersecting(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,C){if(A&&C){const k=A.startLineNumber|0,R=C.startLineNumber|0;if(k===R){const I=A.startColumn|0,_=C.startColumn|0;if(I===_){const P=A.endLineNumber|0,b=C.endLineNumber|0;if(P===b){const w=A.endColumn|0,p=C.endColumn|0;return w-p}return P-b}return I-_}return k-R}return(A?1:0)-(C?1:0)}static compareRangesUsingEnds(A,C){return A.endLineNumber===C.endLineNumber?A.endColumn===C.endColumn?A.startLineNumber===C.startLineNumber?A.startColumn-C.startColumn:A.startLineNumber-C.startLineNumber:A.endColumn-C.endColumn:A.endLineNumber-C.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=n}),define(Ie[145],ke([1,0,48,35]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class A extends n.Range{constructor(D,E,k,R){super(D,E,k,R);this.selectionStartLineNumber=D,this.selectionStartColumn=E,this.positionLineNumber=k,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return A.selectionsEqual(this,D)}static selectionsEqual(D,E){return D.selectionStartLineNumber===E.selectionStartLineNumber&&D.selectionStartColumn===E.selectionStartColumn&&D.positionLineNumber===E.positionLineNumber&&D.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,E){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,D,E):new A(D,E,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,E){return this.getDirection()===0?new A(D,E,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,D,E)}static fromPositions(D,E=D){return new A(D.lineNumber,D.column,E.lineNumber,E.column)}static fromRange(D,E){return E===0?new A(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new A(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new A(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,E){if(D&&!E||!D&&E)return!1;if(!D&&!E)return!0;if(D.length!==E.length)return!1;for(let k=0,R=D.length;k<R;k++)if(!this.selectionsEqual(D[k],E[k]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,E,k,R,I){return I===0?new A(D,E,k,R):new A(k,R,D,E)}}e.Selection=A}),define(Ie[146],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[147],ke([1,0,98]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var n;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(n=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends u.CharacterClassifier{constructor(D){super(0);for(let E=0,k=D.length;E<k;E++)this.set(D.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function A(C){const D={};return E=>(D.hasOwnProperty(E)||(D[E]=C(E)),D[E])}e.getMapForWordSeparators=A(C=>new S(C))}),define(Ie[99],ke([1,0,59,6,79]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)I.indexOf(P)>=0||(_+="\\"+P);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=A();function C(I){let _=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)_=I;else{let P="g";I.ignoreCase&&(P+="i"),I.multiline&&(P+="m"),I.unicode&&(P+="u"),_=new RegExp(I.source,P)}return _.lastIndex=0,_}e.ensureValidWordDefinition=C;const D=new S.LinkedList;D.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const _=D.unshift(I);return(0,n.toDisposable)(_)}e.setDefaultGetWordAtTextConfig=E;function k(I,_,P,b,w){if(w||(w=u.Iterable.first(D)),P.length>w.maxLen){let c=I-w.maxLen/2;return c<0?c=0:b+=c,P=P.substring(c,I+w.maxLen/2),k(I,_,P,b,w)}const p=Date.now(),g=I-1-b;let v=-1,f=null;for(let c=1;!(Date.now()-p>=w.timeBudget);c++){const m=g-w.windowSize*c;_.lastIndex=Math.max(0,m);const a=R(_,P,g,v);if(!a&&f||(f=a,m<=0))break;v=m}if(f){const c={word:f[0],startColumn:b+1+f.index,endColumn:b+1+f.index+f[0].length};return _.lastIndex=0,c}return null}e.getWordAtText=k;function R(I,_,P,b){let w;for(;w=I.exec(_);){const p=w.index||0;if(p<=P&&I.lastIndex>=P)return w;if(b>0&&p>b)return null}return null}}),define(Ie[148],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class n{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(D.notIn))for(let E=0,k=D.notIn.length;E<k;E++)switch(D.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(D){switch(D){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(D,E){if(D.getTokenCount()===0)return!0;const k=D.findTokenIndexAtOffset(E-2),R=D.getStandardTokenType(k);return this.isOK(R)}_findNeutralCharacterInRange(D,E){for(let k=D;k<=E;k++){const R=String.fromCharCode(k);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=n;class S{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of D)A(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),A(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),A(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),A(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&A(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=S;function A(C,D,E){C.has(D)?C.get(D).push(E):C.set(D,[E])}}),define(Ie[149],ke([1,0,98]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var n;(function(P){P[P.Invalid=0]="Invalid",P[P.Start=1]="Start",P[P.H=2]="H",P[P.HT=3]="HT",P[P.HTT=4]="HTT",P[P.HTTP=5]="HTTP",P[P.F=6]="F",P[P.FI=7]="FI",P[P.FIL=8]="FIL",P[P.BeforeColon=9]="BeforeColon",P[P.AfterColon=10]="AfterColon",P[P.AlmostThere=11]="AlmostThere",P[P.End=12]="End",P[P.Accept=13]="Accept",P[P.LastKnownState=14]="LastKnownState"})(n=e.State||(e.State={}));class S{constructor(b,w,p){const g=new Uint8Array(b*w);for(let v=0,f=b*w;v<f;v++)g[v]=p;this._data=g,this.rows=b,this.cols=w}get(b,w){return this._data[b*this.cols+w]}set(b,w,p){this._data[b*this.cols+w]=p}}e.Uint8Matrix=S;class A{constructor(b){let w=0,p=0;for(let v=0,f=b.length;v<f;v++){const[c,m,a]=b[v];m>w&&(w=m),c>p&&(p=c),a>p&&(p=a)}w++,p++;const g=new S(p,w,0);for(let v=0,f=b.length;v<f;v++){const[c,m,a]=b[v];g.set(c,m,a)}this._states=g,this._maxCharCode=w}nextState(b,w){return w<0||w>=this._maxCharCode?0:this._states.get(b,w)}}e.StateMachine=A;let C=null;function D(){return C===null&&(C=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var E;(function(P){P[P.None=0]="None",P[P.ForceTermination=1]="ForceTermination",P[P.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let k=null;function R(){if(k===null){k=new u.CharacterClassifier(0);const P=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<P.length;w++)k.set(P.charCodeAt(w),1);const b=".,;:";for(let w=0;w<b.length;w++)k.set(b.charCodeAt(w),2)}return k}class I{static _createLink(b,w,p,g,v){let f=v-1;do{const c=w.charCodeAt(f);if(b.get(c)!==2)break;f--}while(f>g);if(g>0){const c=w.charCodeAt(g-1),m=w.charCodeAt(f);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&f--}return{range:{startLineNumber:p,startColumn:g+1,endLineNumber:p,endColumn:f+2},url:w.substring(g,f+1)}}static computeLinks(b,w=D()){const p=R(),g=[];for(let v=1,f=b.getLineCount();v<=f;v++){const c=b.getLineContent(v),m=c.length;let a=0,h=0,r=0,s=1,i=!1,t=!1,o=!1,l=!1;for(;a<m;){let d=!1;const y=c.charCodeAt(a);if(s===13){let L;switch(y){case 40:i=!0,L=0;break;case 41:L=i?0:1;break;case 91:o=!0,t=!0,L=0;break;case 93:o=!1,L=t?0:1;break;case 123:l=!0,L=0;break;case 125:L=l?0:1;break;case 39:L=r===39?1:0;break;case 34:L=r===34?1:0;break;case 96:L=r===96?1:0;break;case 42:L=r===42?1:0;break;case 124:L=r===124?1:0;break;case 32:L=o?0:1;break;default:L=p.get(y)}L===1&&(g.push(I._createLink(p,c,v,h,a)),d=!0)}else if(s===12){let L;y===91?(t=!0,L=0):L=p.get(y),L===1?d=!0:s=13}else s=w.nextState(s,y),s===0&&(d=!0);d&&(s=1,i=!1,t=!1,l=!1,h=a+1,r=y),a++}s===13&&g.push(I._createLink(p,c,v,h,m))}return g}}e.LinkComputer=I;function _(P){return!P||typeof P.getLineCount!="function"||typeof P.getLineContent!="function"?[]:I.computeLinks(P)}e.computeLinks=_}),define(Ie[100],ke([1,0,24]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var n;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(n=e.OverviewRulerLane||(e.OverviewRulerLane={}));var S;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(S=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var D;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(D=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace),this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class R{constructor(f,c){this._findMatchBrand=void 0,this.range=f,this.matches=c}}e.FindMatch=R;var I;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None",v[v.LeftOfInjectedText=3]="LeftOfInjectedText",v[v.RightOfInjectedText=4]="RightOfInjectedText"})(_=e.PositionAffinity||(e.PositionAffinity={}));var P;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class b{constructor(f,c,m,a,h,r){this.identifier=f,this.range=c,this.text=m,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=h,this._isTracked=r}}e.ValidAnnotatedEditOperation=b;class w{constructor(f,c,m){this.regex=f,this.wordSeparators=c,this.simpleSearch=m}}e.SearchData=w;class p{constructor(f,c,m){this.reverseEdits=f,this.changes=c,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=p;function g(v){return!v.isTooLargeForSyncing()&&!v.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(Ie[150],ke([1,0,16,96]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class S{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,k){E=(0,n.toUint32)(E);const R=this.values,I=this.prefixSum,_=k.length;return _===0?!1:(this.values=new Uint32Array(R.length+_),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E),E+_),this.values.set(k,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,k){return E=(0,n.toUint32)(E),k=(0,n.toUint32)(k),this.values[E]===k?!1:(this.values[E]=k,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,k){E=(0,n.toUint32)(E),k=(0,n.toUint32)(k);const R=this.values,I=this.prefixSum;if(E>=R.length)return!1;const _=R.length-E;return k>=_&&(k=_),k===0?!1:(this.values=new Uint32Array(R.length-k),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E+k),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,n.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),E>=this.values.length&&(E=this.values.length-1);for(let R=k;R<=E;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let k=0,R=this.values.length-1,I=0,_=0,P=0;for(;k<=R;)if(I=k+(R-k)/2|0,_=this.prefixSum[I],P=_-this.values[I],E<P)R=I-1;else if(E>=_)k=I+1;else break;return new C(I,E-P)}}e.PrefixSumComputer=S;class A{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const k=this._indexBySum[E],R=k>0?this._prefixSum[k-1]:0;return new C(k,E-R)}removeValues(E,k){this._values.splice(E,k),this._invalidate(E)}insertValues(E,k){this._values=(0,u.arrayInsert)(this._values,E,k),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,k=this._values.length;E<k;E++){const R=this._values[E],I=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=I+R;for(let _=0;_<R;_++)this._indexBySum[I+_]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,k){this._values[E]!==k&&(this._values[E]=k,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=A;class C{constructor(E,k){this.index=E,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=k}}e.PrefixSumIndexOfResult=C}),define(Ie[151],ke([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(Ie[152],ke([1,0,151]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,S=n*60,A=S*24,C=A*7,D=A*30,E=A*365;function k(I,_,P){typeof I!="number"&&(I=I.getTime());const b=Math.round((new Date().getTime()-I)/1e3);if(b<-30)return(0,u.localize)(0,null,k(new Date().getTime()+b*1e3,!1));if(b<30)return(0,u.localize)(1,null);let w;return b<n?(w=b,_?w===1?P?(0,u.localize)(2,null,w):(0,u.localize)(3,null,w):P?(0,u.localize)(4,null,w):(0,u.localize)(5,null,w):w===1?P?(0,u.localize)(6,null,w):(0,u.localize)(7,null,w):P?(0,u.localize)(8,null,w):(0,u.localize)(9,null,w)):b<S?(w=Math.floor(b/n),_?w===1?P?(0,u.localize)(10,null,w):(0,u.localize)(11,null,w):P?(0,u.localize)(12,null,w):(0,u.localize)(13,null,w):w===1?P?(0,u.localize)(14,null,w):(0,u.localize)(15,null,w):P?(0,u.localize)(16,null,w):(0,u.localize)(17,null,w)):b<A?(w=Math.floor(b/S),_?w===1?P?(0,u.localize)(18,null,w):(0,u.localize)(19,null,w):P?(0,u.localize)(20,null,w):(0,u.localize)(21,null,w):w===1?P?(0,u.localize)(22,null,w):(0,u.localize)(23,null,w):P?(0,u.localize)(24,null,w):(0,u.localize)(25,null,w)):b<C?(w=Math.floor(b/A),_?w===1?(0,u.localize)(26,null,w):(0,u.localize)(27,null,w):w===1?(0,u.localize)(28,null,w):(0,u.localize)(29,null,w)):b<D?(w=Math.floor(b/C),_?w===1?P?(0,u.localize)(30,null,w):(0,u.localize)(31,null,w):P?(0,u.localize)(32,null,w):(0,u.localize)(33,null,w):w===1?P?(0,u.localize)(34,null,w):(0,u.localize)(35,null,w):P?(0,u.localize)(36,null,w):(0,u.localize)(37,null,w)):b<E?(w=Math.floor(b/D),_?w===1?P?(0,u.localize)(38,null,w):(0,u.localize)(39,null,w):P?(0,u.localize)(40,null,w):(0,u.localize)(41,null,w):w===1?P?(0,u.localize)(42,null,w):(0,u.localize)(43,null,w):P?(0,u.localize)(44,null,w):(0,u.localize)(45,null,w)):(w=Math.floor(b/E),_?w===1?P?(0,u.localize)(46,null,w):(0,u.localize)(47,null,w):P?(0,u.localize)(48,null,w):(0,u.localize)(49,null,w):w===1?P?(0,u.localize)(50,null,w):(0,u.localize)(51,null,w):P?(0,u.localize)(52,null,w):(0,u.localize)(53,null,w))}e.fromNow=k;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ie[153],ke([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(Ie[49],ke([1,0,16,10,153]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(I,_){return _&&(I.stack||I.stacktrace)?S.localize(0,null,D(I),C(I.stack)||C(I.stacktrace)):D(I)}function C(I){return Array.isArray(I)?I.join(`
`):I}function D(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?S.localize(1,null,I.message):I.message||S.localize(2,null)}function E(I=null,_=!1){if(!I)return S.localize(3,null);if(Array.isArray(I)){const P=u.coalesce(I),b=E(P[0],_);return P.length>1?S.localize(4,null,b,P.length):b}if(n.isString(I))return I;if(I.detail){const P=I.detail;if(P.error)return A(P.error,_);if(P.exception)return A(P.exception,_)}return I.stack?A(I,_):I.message?I.message:S.localize(5,null)}e.toErrorMessage=E;function k(I){const _=I;return _ instanceof Error&&Array.isArray(_.actions)}e.isErrorWithActions=k;function R(I,_){let P;return typeof I=="string"?P=new Error(I):P=I,P.actions=_,P}e.createErrorWithActions=R}),define(Ie[154],ke([19,20]),function(X,e){return X.create("vs/base/common/platform",e)}),define(Ie[13],ke([1,0,154]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let S=!1,A=!1,C=!1,D=!1,E=!1,k=!1,R=!1,I=!1,_=!1,P,b=n,w,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const v=typeof g?.versions?.electron=="string",f=v&&g?.type==="renderer";if(typeof navigator=="object"&&!f)p=navigator.userAgent,S=p.indexOf("Windows")>=0,A=p.indexOf("Macintosh")>=0,I=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,k=!0,P=u.getConfiguredDefaultLocale(u.localize(0,null))||n,b=P;else if(typeof g=="object"){S=g.platform==="win32",A=g.platform==="darwin",C=g.platform==="linux",D=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,R=v,_=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=n,b=n;const o=g.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),d=l.availableLanguages["*"];P=l.locale,b=d||n,w=l._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var c;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function m(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let a=0;A?a=1:S?a=3:C&&(a=2),e.isWindows=S,e.isMacintosh=A,e.isLinux=C,e.isLinuxSnap=D,e.isNative=E,e.isElectron=R,e.isWeb=k,e.isWebWorker=k&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isCI=_,e.platform=a,e.userAgent=p,e.language=b;var h;(function(o){function l(){return e.language}o.value=l;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=d;function y(){return e.language==="en"}o.isDefault=y})(h=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let y=0,L=o.length;y<L;y++){const M=o[y];if(M.id===d.data.vscodeScheduleAsyncWork){o.splice(y,1),M.callback();return}}});let l=0;return d=>{const y=++l;o.push({id:y,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||I?2:S?1:3;let s=!0,i=!1;function t(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=t,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ie[40],ke([1,0,13]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof u.globals.vscode!="undefined"&&typeof u.globals.vscode.process!="undefined"){const S=u.globals.vscode.process;n={get platform(){return S.platform},get arch(){return S.arch},get env(){return S.env},cwd(){return S.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(Ie[9],ke([1,0,40]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,S=97,A=90,C=122,D=46,E=47,k=92,R=58,I=63;class _ extends Error{constructor(c,m,a){let h;typeof m=="string"&&m.indexOf("not ")===0?(h="must not be",m=m.replace(/^not /,"")):h="must be";const r=c.indexOf(".")!==-1?"property":"argument";let s=`The "${c}" ${r} ${h} of type ${m}`;s+=`. Received type ${typeof a}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function P(f,c){if(typeof f!="string")throw new _(c,"string",f)}function b(f){return f===E||f===k}function w(f){return f===E}function p(f){return f>=n&&f<=A||f>=S&&f<=C}function g(f,c,m,a){let h="",r=0,s=-1,i=0,t=0;for(let o=0;o<=f.length;++o){if(o<f.length)t=f.charCodeAt(o);else{if(a(t))break;t=E}if(a(t)){if(!(s===o-1||i===1))if(i===2){if(h.length<2||r!==2||h.charCodeAt(h.length-1)!==D||h.charCodeAt(h.length-2)!==D){if(h.length>2){const l=h.lastIndexOf(m);l===-1?(h="",r=0):(h=h.slice(0,l),r=h.length-1-h.lastIndexOf(m)),s=o,i=0;continue}else if(h.length!==0){h="",r=0,s=o,i=0;continue}}c&&(h+=h.length>0?`${m}..`:"..",r=2)}else h.length>0?h+=`${m}${f.slice(s+1,o)}`:h=f.slice(s+1,o),r=o-s-1;s=o,i=0}else t===D&&i!==-1?++i:i=-1}return h}function v(f,c){if(c===null||typeof c!="object")throw new _("pathObject","Object",c);const m=c.dir||c.root,a=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${a}`:`${m}${f}${a}`:a}e.win32={resolve(...f){let c="",m="",a=!1;for(let h=f.length-1;h>=-1;h--){let r;if(h>=0){if(r=f[h],P(r,"path"),r.length===0)continue}else c.length===0?r=u.cwd():(r=u.env[`=${c}`]||u.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===k)&&(r=`${c}\\`));const s=r.length;let i=0,t="",o=!1;const l=r.charCodeAt(0);if(s===1)b(l)&&(i=1,o=!0);else if(b(l))if(o=!0,b(r.charCodeAt(1))){let d=2,y=d;for(;d<s&&!b(r.charCodeAt(d));)d++;if(d<s&&d!==y){const L=r.slice(y,d);for(y=d;d<s&&b(r.charCodeAt(d));)d++;if(d<s&&d!==y){for(y=d;d<s&&!b(r.charCodeAt(d));)d++;(d===s||d!==y)&&(t=`\\\\${L}\\${r.slice(y,d)}`,i=d)}}}else i=1;else p(l)&&r.charCodeAt(1)===R&&(t=r.slice(0,2),i=2,s>2&&b(r.charCodeAt(2))&&(o=!0,i=3));if(t.length>0)if(c.length>0){if(t.toLowerCase()!==c.toLowerCase())continue}else c=t;if(a){if(c.length>0)break}else if(m=`${r.slice(i)}\\${m}`,a=o,o&&c.length>0)break}return m=g(m,!a,"\\",b),a?`${c}\\${m}`:`${c}${m}`||"."},normalize(f){P(f,"path");const c=f.length;if(c===0)return".";let m=0,a,h=!1;const r=f.charCodeAt(0);if(c===1)return w(r)?"\\":f;if(b(r))if(h=!0,b(f.charCodeAt(1))){let i=2,t=i;for(;i<c&&!b(f.charCodeAt(i));)i++;if(i<c&&i!==t){const o=f.slice(t,i);for(t=i;i<c&&b(f.charCodeAt(i));)i++;if(i<c&&i!==t){for(t=i;i<c&&!b(f.charCodeAt(i));)i++;if(i===c)return`\\\\${o}\\${f.slice(t)}\\`;i!==t&&(a=`\\\\${o}\\${f.slice(t,i)}`,m=i)}}}else m=1;else p(r)&&f.charCodeAt(1)===R&&(a=f.slice(0,2),m=2,c>2&&b(f.charCodeAt(2))&&(h=!0,m=3));let s=m<c?g(f.slice(m),!h,"\\",b):"";return s.length===0&&!h&&(s="."),s.length>0&&b(f.charCodeAt(c-1))&&(s+="\\"),a===void 0?h?`\\${s}`:s:h?`${a}\\${s}`:`${a}${s}`},isAbsolute(f){P(f,"path");const c=f.length;if(c===0)return!1;const m=f.charCodeAt(0);return b(m)||c>2&&p(m)&&f.charCodeAt(1)===R&&b(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,m;for(let r=0;r<f.length;++r){const s=f[r];P(s,"path"),s.length>0&&(c===void 0?c=m=s:c+=`\\${s}`)}if(c===void 0)return".";let a=!0,h=0;if(typeof m=="string"&&b(m.charCodeAt(0))){++h;const r=m.length;r>1&&b(m.charCodeAt(1))&&(++h,r>2&&(b(m.charCodeAt(2))?++h:a=!1))}if(a){for(;h<c.length&&b(c.charCodeAt(h));)h++;h>=2&&(c=`\\${c.slice(h)}`)}return e.win32.normalize(c)},relative(f,c){if(P(f,"from"),P(c,"to"),f===c)return"";const m=e.win32.resolve(f),a=e.win32.resolve(c);if(m===a||(f=m.toLowerCase(),c=a.toLowerCase(),f===c))return"";let h=0;for(;h<f.length&&f.charCodeAt(h)===k;)h++;let r=f.length;for(;r-1>h&&f.charCodeAt(r-1)===k;)r--;const s=r-h;let i=0;for(;i<c.length&&c.charCodeAt(i)===k;)i++;let t=c.length;for(;t-1>i&&c.charCodeAt(t-1)===k;)t--;const o=t-i,l=s<o?s:o;let d=-1,y=0;for(;y<l;y++){const M=f.charCodeAt(h+y);if(M!==c.charCodeAt(i+y))break;M===k&&(d=y)}if(y!==l){if(d===-1)return a}else{if(o>l){if(c.charCodeAt(i+y)===k)return a.slice(i+y+1);if(y===2)return a.slice(i+y)}s>l&&(f.charCodeAt(h+y)===k?d=y:y===2&&(d=3)),d===-1&&(d=0)}let L="";for(y=h+d+1;y<=r;++y)(y===r||f.charCodeAt(y)===k)&&(L+=L.length===0?"..":"\\..");return i+=d,L.length>0?`${L}${a.slice(i,t)}`:(a.charCodeAt(i)===k&&++i,a.slice(i,t))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const m=c.charCodeAt(2);if(m!==I&&m!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===R&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return f},dirname(f){P(f,"path");const c=f.length;if(c===0)return".";let m=-1,a=0;const h=f.charCodeAt(0);if(c===1)return b(h)?f:".";if(b(h)){if(m=a=1,b(f.charCodeAt(1))){let i=2,t=i;for(;i<c&&!b(f.charCodeAt(i));)i++;if(i<c&&i!==t){for(t=i;i<c&&b(f.charCodeAt(i));)i++;if(i<c&&i!==t){for(t=i;i<c&&!b(f.charCodeAt(i));)i++;if(i===c)return f;i!==t&&(m=a=i+1)}}}}else p(h)&&f.charCodeAt(1)===R&&(m=c>2&&b(f.charCodeAt(2))?3:2,a=m);let r=-1,s=!0;for(let i=c-1;i>=a;--i)if(b(f.charCodeAt(i))){if(!s){r=i;break}}else s=!1;if(r===-1){if(m===-1)return".";r=m}return f.slice(0,r)},basename(f,c){c!==void 0&&P(c,"ext"),P(f,"path");let m=0,a=-1,h=!0,r;if(f.length>=2&&p(f.charCodeAt(0))&&f.charCodeAt(1)===R&&(m=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let s=c.length-1,i=-1;for(r=f.length-1;r>=m;--r){const t=f.charCodeAt(r);if(b(t)){if(!h){m=r+1;break}}else i===-1&&(h=!1,i=r+1),s>=0&&(t===c.charCodeAt(s)?--s==-1&&(a=r):(s=-1,a=i))}return m===a?a=i:a===-1&&(a=f.length),f.slice(m,a)}for(r=f.length-1;r>=m;--r)if(b(f.charCodeAt(r))){if(!h){m=r+1;break}}else a===-1&&(h=!1,a=r+1);return a===-1?"":f.slice(m,a)},extname(f){P(f,"path");let c=0,m=-1,a=0,h=-1,r=!0,s=0;f.length>=2&&f.charCodeAt(1)===R&&p(f.charCodeAt(0))&&(c=a=2);for(let i=f.length-1;i>=c;--i){const t=f.charCodeAt(i);if(b(t)){if(!r){a=i+1;break}continue}h===-1&&(r=!1,h=i+1),t===D?m===-1?m=i:s!==1&&(s=1):m!==-1&&(s=-1)}return m===-1||h===-1||s===0||s===1&&m===h-1&&m===a+1?"":f.slice(m,h)},format:v.bind(null,"\\"),parse(f){P(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const m=f.length;let a=0,h=f.charCodeAt(0);if(m===1)return b(h)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(b(h)){if(a=1,b(f.charCodeAt(1))){let d=2,y=d;for(;d<m&&!b(f.charCodeAt(d));)d++;if(d<m&&d!==y){for(y=d;d<m&&b(f.charCodeAt(d));)d++;if(d<m&&d!==y){for(y=d;d<m&&!b(f.charCodeAt(d));)d++;d===m?a=d:d!==y&&(a=d+1)}}}}else if(p(h)&&f.charCodeAt(1)===R){if(m<=2)return c.root=c.dir=f,c;if(a=2,b(f.charCodeAt(2))){if(m===3)return c.root=c.dir=f,c;a=3}}a>0&&(c.root=f.slice(0,a));let r=-1,s=a,i=-1,t=!0,o=f.length-1,l=0;for(;o>=a;--o){if(h=f.charCodeAt(o),b(h)){if(!t){s=o+1;break}continue}i===-1&&(t=!1,i=o+1),h===D?r===-1?r=o:l!==1&&(l=1):r!==-1&&(l=-1)}return i!==-1&&(r===-1||l===0||l===1&&r===i-1&&r===s+1?c.base=c.name=f.slice(s,i):(c.name=f.slice(s,r),c.base=f.slice(s,i),c.ext=f.slice(r,i))),s>0&&s!==a?c.dir=f.slice(0,s-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",m=!1;for(let a=f.length-1;a>=-1&&!m;a--){const h=a>=0?f[a]:u.cwd();P(h,"path"),h.length!==0&&(c=`${h}/${c}`,m=h.charCodeAt(0)===E)}return c=g(c,!m,"/",w),m?`/${c}`:c.length>0?c:"."},normalize(f){if(P(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===E,m=f.charCodeAt(f.length-1)===E;return f=g(f,!c,"/",w),f.length===0?c?"/":m?"./":".":(m&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return P(f,"path"),f.length>0&&f.charCodeAt(0)===E},join(...f){if(f.length===0)return".";let c;for(let m=0;m<f.length;++m){const a=f[m];P(a,"path"),a.length>0&&(c===void 0?c=a:c+=`/${a}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(P(f,"from"),P(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const m=1,a=f.length,h=a-m,r=1,s=c.length-r,i=h<s?h:s;let t=-1,o=0;for(;o<i;o++){const d=f.charCodeAt(m+o);if(d!==c.charCodeAt(r+o))break;d===E&&(t=o)}if(o===i)if(s>i){if(c.charCodeAt(r+o)===E)return c.slice(r+o+1);if(o===0)return c.slice(r+o)}else h>i&&(f.charCodeAt(m+o)===E?t=o:o===0&&(t=0));let l="";for(o=m+t+1;o<=a;++o)(o===a||f.charCodeAt(o)===E)&&(l+=l.length===0?"..":"/..");return`${l}${c.slice(r+t)}`},toNamespacedPath(f){return f},dirname(f){if(P(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===E;let m=-1,a=!0;for(let h=f.length-1;h>=1;--h)if(f.charCodeAt(h)===E){if(!a){m=h;break}}else a=!1;return m===-1?c?"/":".":c&&m===1?"//":f.slice(0,m)},basename(f,c){c!==void 0&&P(c,"ext"),P(f,"path");let m=0,a=-1,h=!0,r;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let s=c.length-1,i=-1;for(r=f.length-1;r>=0;--r){const t=f.charCodeAt(r);if(t===E){if(!h){m=r+1;break}}else i===-1&&(h=!1,i=r+1),s>=0&&(t===c.charCodeAt(s)?--s==-1&&(a=r):(s=-1,a=i))}return m===a?a=i:a===-1&&(a=f.length),f.slice(m,a)}for(r=f.length-1;r>=0;--r)if(f.charCodeAt(r)===E){if(!h){m=r+1;break}}else a===-1&&(h=!1,a=r+1);return a===-1?"":f.slice(m,a)},extname(f){P(f,"path");let c=-1,m=0,a=-1,h=!0,r=0;for(let s=f.length-1;s>=0;--s){const i=f.charCodeAt(s);if(i===E){if(!h){m=s+1;break}continue}a===-1&&(h=!1,a=s+1),i===D?c===-1?c=s:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||a===-1||r===0||r===1&&c===a-1&&c===m+1?"":f.slice(c,a)},format:v.bind(null,"/"),parse(f){P(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const m=f.charCodeAt(0)===E;let a;m?(c.root="/",a=1):a=0;let h=-1,r=0,s=-1,i=!0,t=f.length-1,o=0;for(;t>=a;--t){const l=f.charCodeAt(t);if(l===E){if(!i){r=t+1;break}continue}s===-1&&(i=!1,s=t+1),l===D?h===-1?h=t:o!==1&&(o=1):h!==-1&&(o=-1)}if(s!==-1){const l=r===0&&m?1:r;h===-1||o===0||o===1&&h===s-1&&h===r+1?c.base=c.name=f.slice(l,s):(c.name=f.slice(l,h),c.base=f.slice(l,s),c.ext=f.slice(h,s))}return r>0?c.dir=f.slice(0,r-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ie[101],ke([1,0,9]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const I=(0,u.extname)(R),_=n[I.toLowerCase()];return _!==void 0?_:C(R)}e.getMediaOrTextMime=A;function C(R){const I=(0,u.extname)(R);return S[I.toLowerCase()]}e.getMediaMime=C;function D(R){for(const I in S)if(S[I]===R)return I}e.getExtensionForMimeType=D;const E=/^(.+)\/(.+?)(;.+)?$/;function k(R,I){const _=E.exec(R);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:I?void 0:R}e.normalizeMimeType=k}),define(Ie[102],ke([1,0,13]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var S;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(S=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(D,...E){const k=E.reduce((_,P)=>(_[P]=!0,_),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(_=>!k[_]).forEach(_=>{for(let P=0;P<R.length;P++)if(_.search(R[P])!==-1){delete D[_];break}})}e.sanitizeProcessEnvironment=A;function C(D){!D||(delete D.DEBUG,u.isMacintosh&&delete D.DYLD_LIBRARY_PATH,u.isLinux&&delete D.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(Ie[50],ke([1,0,13]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=u.globals.performance&&typeof u.globals.performance.now=="function";class S{constructor(C){this._highResolution=n&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new S(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=S}),define(Ie[3],ke([1,0,12,58,6,79,50]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const D=!1,E=!1;var k;(function(t){t.None=()=>S.Disposable.None;function o(ge){if(E){const{onListenerDidAdd:Ee}=ge,Pe=b.create();let me=0;ge.onListenerDidAdd=()=>{++me==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),Ee?.()}}}function l(ge){return(Ee,Pe=null,me)=>{let Te=!1,le;return le=ge(pe=>{if(!Te)return le?le.dispose():Te=!0,Ee.call(Pe,pe)},null,me),Te&&le.dispose(),le}}t.once=l;function d(ge,Ee,Pe){return U((me,Te=null,le)=>ge(pe=>me.call(Te,Ee(pe)),null,le),Pe)}t.map=d;function y(ge,Ee,Pe){return U((me,Te=null,le)=>ge(pe=>{Ee(pe),me.call(Te,pe)},null,le),Pe)}t.forEach=y;function L(ge,Ee,Pe){return U((me,Te=null,le)=>ge(pe=>Ee(pe)&&me.call(Te,pe),null,le),Pe)}t.filter=L;function M(ge){return ge}t.signal=M;function F(...ge){return(Ee,Pe=null,me)=>(0,S.combinedDisposable)(...ge.map(Te=>Te(le=>Ee.call(Pe,le),null,me)))}t.any=F;function T(ge,Ee,Pe,me){let Te=Pe;return d(ge,le=>(Te=Ee(Te,le),Te),me)}t.reduce=T;function U(ge,Ee){let Pe;const me={onFirstListenerAdd(){Pe=ge(Te.fire,Te)},onLastListenerRemove(){Pe?.dispose()}};Ee||o(me);const Te=new p(me);return Ee?.add(Te),Te.event}function N(ge,Ee,Pe=100,me=!1,Te,le){let pe,be,ae,he=0;const ee={leakWarningThreshold:Te,onFirstListenerAdd(){pe=ge(O=>{he++,be=Ee(be,O),me&&!ae&&(ne.fire(be),be=void 0),clearTimeout(ae),ae=setTimeout(()=>{const $=be;be=void 0,ae=void 0,(!me||he>1)&&ne.fire($),he=0},Pe)})},onLastListenerRemove(){pe.dispose()}};le||o(ee);const ne=new p(ee);return le?.add(ne),ne.event}t.debounce=N;function H(ge,Ee=(me,Te)=>me===Te,Pe){let me=!0,Te;return L(ge,le=>{const pe=me||!Ee(le,Te);return me=!1,Te=le,pe},Pe)}t.latch=H;function te(ge,Ee,Pe){return[t.filter(ge,Ee,Pe),t.filter(ge,me=>!Ee(me),Pe)]}t.split=te;function B(ge,Ee=!1,Pe=[]){let me=Pe.slice(),Te=ge(be=>{me?me.push(be):pe.fire(be)});const le=()=>{me?.forEach(be=>pe.fire(be)),me=null},pe=new p({onFirstListenerAdd(){Te||(Te=ge(be=>pe.fire(be)))},onFirstListenerDidAdd(){me&&(Ee?setTimeout(le):le())},onLastListenerRemove(){Te&&Te.dispose(),Te=null}});return pe.event}t.buffer=B;class z{constructor(Ee){this.event=Ee,this.disposables=new S.DisposableStore}map(Ee){return new z(d(this.event,Ee,this.disposables))}forEach(Ee){return new z(y(this.event,Ee,this.disposables))}filter(Ee){return new z(L(this.event,Ee,this.disposables))}reduce(Ee,Pe){return new z(T(this.event,Ee,Pe,this.disposables))}latch(){return new z(H(this.event,void 0,this.disposables))}debounce(Ee,Pe=100,me=!1,Te){return new z(N(this.event,Ee,Pe,me,Te,this.disposables))}on(Ee,Pe,me){return this.event(Ee,Pe,me)}once(Ee,Pe,me){return l(this.event)(Ee,Pe,me)}dispose(){this.disposables.dispose()}}function q(ge){return new z(ge)}t.chain=q;function V(ge,Ee,Pe=me=>me){const me=(...be)=>pe.fire(Pe(...be)),Te=()=>ge.on(Ee,me),le=()=>ge.removeListener(Ee,me),pe=new p({onFirstListenerAdd:Te,onLastListenerRemove:le});return pe.event}t.fromNodeEventEmitter=V;function j(ge,Ee,Pe=me=>me){const me=(...be)=>pe.fire(Pe(...be)),Te=()=>ge.addEventListener(Ee,me),le=()=>ge.removeEventListener(Ee,me),pe=new p({onFirstListenerAdd:Te,onLastListenerRemove:le});return pe.event}t.fromDOMEventEmitter=j;function ie(ge){return new Promise(Ee=>l(ge)(Ee))}t.toPromise=ie;function Q(ge,Ee){return Ee(void 0),ge(Pe=>Ee(Pe))}t.runAndSubscribe=Q;function ue(ge,Ee){let Pe=null;function me(le){Pe?.dispose(),Pe=new S.DisposableStore,Ee(le,Pe)}me(void 0);const Te=ge(le=>me(le));return(0,S.toDisposable)(()=>{Te.dispose(),Pe?.dispose()})}t.runAndSubscribeWithStore=ue;class ve{constructor(Ee,Pe){this.obs=Ee,this._counter=0,this._hasChanged=!1;const me={onFirstListenerAdd:()=>{Ee.addObserver(this)},onLastListenerRemove:()=>{Ee.removeObserver(this)}};Pe||o(me),this.emitter=new p(me),Pe&&Pe.add(this.emitter)}beginUpdate(Ee){this._counter++}handleChange(Ee,Pe){this._hasChanged=!0}endUpdate(Ee){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function J(ge,Ee){return new ve(ge,Ee).emitter.event}t.fromObservable=J})(k=e.Event||(e.Event={}));class R{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${R._idPool++}`}start(o){this._stopWatch=new C.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let I=-1;function _(t){const o=I;return I=t,{dispose(){I=o}}}e.setGlobalLeakWarningThreshold=_;class P{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,l){let d=I;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),d<=0||l<d)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let L,M=0;for(const[F,T]of this._stacks)(!L||M<T)&&(L=F,M=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${M}):`),console.warn(L)}return()=>{const L=this._stacks.get(o.value)||0;this._stacks.set(o.value,L-1)}}}class b{constructor(o){this.value=o}static create(){return new b(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(o,l,d){this.callback=o,this.callbackThis=l,this.stack=d,this.subscription=new S.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class p{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=I>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const l of o)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,l,d)=>{this._listeners||(this._listeners=new A.LinkedList);const y=this._listeners.isEmpty();y&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let L,M;this._leakageMon&&this._listeners.size>=30&&(M=b.create(),L=this._leakageMon.check(M,this._listeners.size+1)),D&&(M=M??b.create());const F=new w(o,l,M),T=this._listeners.push(F);y&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const U=F.subscription.set(()=>{L?.(),this._disposed||(T(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return d instanceof S.DisposableStore?d.add(U):Array.isArray(d)&&d.push(U),U}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const l of this._listeners)this._deliveryQueue.push(this,l,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class g{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(o,l,d){this._queue.push(new f(o,l,d))}clear(o){const l=new A.LinkedList;for(const d of this._queue)d.emitter!==o&&l.push(d);this._queue=l}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(l){(0,u.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=g;class v extends g{clear(o){this._queue.clear()}}class f{constructor(o,l,d){this.emitter=o,this.listener=l,this.event=d}}class c extends p{async fireAsync(o,l,d){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const y of this._listeners)this._asyncDeliveryQueue.push([y,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[y,L]=this._asyncDeliveryQueue.shift(),M=[],F={...L,token:l,waitUntil:T=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");d&&(T=d(T,y.callback)),M.push(T)}};try{y.invoke(F)}catch(T){(0,u.onUnexpectedError)(T);continue}Object.freeze(M),await Promise.allSettled(M).then(T=>{for(const U of T)U.status==="rejected"&&(0,u.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=c;class m extends p{constructor(o){super(o);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=m;class a extends m{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=a;class h extends p{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=h;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const d=()=>{this.hasListeners&&this.unhook(l);const y=this.events.indexOf(l);this.events.splice(y,1)};return(0,S.toDisposable)((0,n.once)(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(o){return(l,d,y)=>o(L=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>l.call(d,L)):l.call(d,L)},void 0,y)}bufferEvents(o){const l=[];this.buffers.push(l);const d=o();return this.buffers.pop(),l.forEach(y=>y()),d}}e.EventBufferer=s;class i{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=S.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=i}),define(Ie[21],ke([1,0,3]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(D,E){const k=setTimeout(D.bind(E),0);return{dispose(){clearTimeout(k)}}});var S;(function(D){function E(k){return k===D.None||k===D.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}D.isCancellationToken=E,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(S=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=S.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=C}),define(Ie[155],ke([1,0,21]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new u.CancellationTokenSource,E=this.task(D.token);return this.result={promise:E,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}e.Cache=n;class S{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const E=JSON.stringify(D);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(D)),this.lastCache}}e.LRUCachedFunction=S;class A{constructor(D){this.fn=D,this._map=new Map}get cachedValues(){return this._map}get(D){if(this._map.has(D))return this._map.get(D);const E=this.fn(D);return this._map.set(D,E),E}}e.CachedFunction=A}),define(Ie[8],ke([1,0,155,78]),function(X,e,u,n){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.isFalsyOrWhitespace=A;const C=/{(\d+)}/g;function D(oe,...Re){return Re.length===0?oe:oe.replace(C,function(Be,qe){const je=parseInt(qe,10);return isNaN(je)||je<0||je>=Re.length?Be:Re[je]})}e.format=D;const E=/{([^}]+)}/g;function k(oe,Re){return oe.replace(E,(Be,qe)=>Re[qe]??Be)}e.format2=k;function R(oe){return oe.replace(/[<>&]/g,function(Re){switch(Re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Re}})}e.escape=R;function I(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function _(oe,Re){let Be=0;const qe=Re.charCodeAt(0);for(let je=oe.length-1;je>=0;je--)oe.charCodeAt(je)===qe&&Be++;return Be}e.count=_;function P(oe,Re,Be="\u2026"){return oe.length<=Re?oe:`${oe.substr(0,Re)}${Be}`}e.truncate=P;function b(oe,Re=" "){const Be=w(oe,Re);return p(Be,Re)}e.trim=b;function w(oe,Re){if(!oe||!Re)return oe;const Be=Re.length;if(Be===0||oe.length===0)return oe;let qe=0;for(;oe.indexOf(Re,qe)===qe;)qe=qe+Be;return oe.substring(qe)}e.ltrim=w;function p(oe,Re){if(!oe||!Re)return oe;const Be=Re.length,qe=oe.length;if(Be===0||qe===0)return oe;let je=qe,Ve=-1;for(;Ve=oe.lastIndexOf(Re,je-1),!(Ve===-1||Ve+Be!==je);){if(Ve===0)return"";je=Ve}return oe.substring(0,je)}e.rtrim=p;function g(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function v(oe){return oe.replace(/\*/g,"")}e.stripWildcards=v;function f(oe,Re,Be={}){if(!oe)throw new Error("Cannot create regex from empty string");Re||(oe=I(oe)),Be.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let qe="";return Be.global&&(qe+="g"),Be.matchCase||(qe+="i"),Be.multiline&&(qe+="m"),Be.unicode&&(qe+="u"),new RegExp(oe,qe)}e.createRegExp=f;function c(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function m(oe){return!!oe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function a(oe){return(oe.global?"g":"")+(oe.ignoreCase?"i":"")+(oe.multiline?"m":"")+(oe.unicode?"u":"")}e.regExpFlags=a;function h(oe){return oe.split(/\r\n|\r|\n/)}e.splitLines=h;function r(oe){for(let Re=0,Be=oe.length;Re<Be;Re++){const qe=oe.charCodeAt(Re);if(qe!==32&&qe!==9)return Re}return-1}e.firstNonWhitespaceIndex=r;function s(oe,Re=0,Be=oe.length){for(let qe=Re;qe<Be;qe++){const je=oe.charCodeAt(qe);if(je!==32&&je!==9)return oe.substring(Re,qe)}return oe.substring(Re,Be)}e.getLeadingWhitespace=s;function i(oe,Re=oe.length-1){for(let Be=Re;Be>=0;Be--){const qe=oe.charCodeAt(Be);if(qe!==32&&qe!==9)return Be}return-1}e.lastNonWhitespaceIndex=i;function t(oe,Re,Be){const qe=[];let je=0;for(const Ve of oe.matchAll(Re)){if(qe.push(oe.slice(je,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");je=Ve.index+Ve[0].length,qe.push(Be(Ve[0],...Ve.slice(1),Ve.index,oe,Ve.groups))}return qe.push(oe.slice(je)),Promise.all(qe).then(Ve=>Ve.join(""))}e.replaceAsync=t;function o(oe,Re){return oe<Re?-1:oe>Re?1:0}e.compare=o;function l(oe,Re,Be=0,qe=oe.length,je=0,Ve=Re.length){for(;Be<qe&&je<Ve;Be++,je++){const st=oe.charCodeAt(Be),it=Re.charCodeAt(je);if(st<it)return-1;if(st>it)return 1}const nt=qe-Be,ot=Ve-je;return nt<ot?-1:nt>ot?1:0}e.compareSubstring=l;function d(oe,Re){return y(oe,Re,0,oe.length,0,Re.length)}e.compareIgnoreCase=d;function y(oe,Re,Be=0,qe=oe.length,je=0,Ve=Re.length){for(;Be<qe&&je<Ve;Be++,je++){let st=oe.charCodeAt(Be),it=Re.charCodeAt(je);if(st===it)continue;if(st>=128||it>=128)return l(oe.toLowerCase(),Re.toLowerCase(),Be,qe,je,Ve);M(st)&&(st-=32),M(it)&&(it-=32);const at=st-it;if(at!==0)return at}const nt=qe-Be,ot=Ve-je;return nt<ot?-1:nt>ot?1:0}e.compareSubstringIgnoreCase=y;function L(oe){return oe>=48&&oe<=57}e.isAsciiDigit=L;function M(oe){return oe>=97&&oe<=122}e.isLowerAsciiLetter=M;function F(oe){return oe>=65&&oe<=90}e.isUpperAsciiLetter=F;function T(oe,Re){return oe.length===Re.length&&y(oe,Re)===0}e.equalsIgnoreCase=T;function U(oe,Re){const Be=Re.length;return Re.length>oe.length?!1:y(oe,Re,0,Be)===0}e.startsWithIgnoreCase=U;function N(oe,Re){const Be=Math.min(oe.length,Re.length);let qe;for(qe=0;qe<Be;qe++)if(oe.charCodeAt(qe)!==Re.charCodeAt(qe))return qe;return Be}e.commonPrefixLength=N;function H(oe,Re){const Be=Math.min(oe.length,Re.length);let qe;const je=oe.length-1,Ve=Re.length-1;for(qe=0;qe<Be;qe++)if(oe.charCodeAt(je-qe)!==Re.charCodeAt(Ve-qe))return qe;return Be}e.commonSuffixLength=H;function te(oe){return 55296<=oe&&oe<=56319}e.isHighSurrogate=te;function B(oe){return 56320<=oe&&oe<=57343}e.isLowSurrogate=B;function z(oe,Re){return(oe-55296<<10)+(Re-56320)+65536}e.computeCodePoint=z;function q(oe,Re,Be){const qe=oe.charCodeAt(Be);if(te(qe)&&Be+1<Re){const je=oe.charCodeAt(Be+1);if(B(je))return z(qe,je)}return qe}e.getNextCodePoint=q;function V(oe,Re){const Be=oe.charCodeAt(Re-1);if(B(Be)&&Re>1){const qe=oe.charCodeAt(Re-2);if(te(qe))return z(qe,Be)}return Be}class j{constructor(Re,Be=0){this._str=Re,this._len=Re.length,this._offset=Be}get offset(){return this._offset}setOffset(Re){this._offset=Re}prevCodePoint(){const Re=V(this._str,this._offset);return this._offset-=Re>=65536?2:1,Re}nextCodePoint(){const Re=q(this._str,this._len,this._offset);return this._offset+=Re>=65536?2:1,Re}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class ie{constructor(Re,Be=0){this._iterator=new j(Re,Be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Re=ze.getInstance(),Be=this._iterator,qe=Be.offset;let je=Re.getGraphemeBreakType(Be.nextCodePoint());for(;!Be.eol();){const Ve=Be.offset,nt=Re.getGraphemeBreakType(Be.nextCodePoint());if(De(je,nt)){Be.setOffset(Ve);break}je=nt}return Be.offset-qe}prevGraphemeLength(){const Re=ze.getInstance(),Be=this._iterator,qe=Be.offset;let je=Re.getGraphemeBreakType(Be.prevCodePoint());for(;Be.offset>0;){const Ve=Be.offset,nt=Re.getGraphemeBreakType(Be.prevCodePoint());if(De(nt,je)){Be.setOffset(Ve);break}je=nt}return qe-Be.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function Q(oe,Re){return new ie(oe,Re).nextGraphemeLength()}e.nextCharLength=Q;function ue(oe,Re){return new ie(oe,Re).prevGraphemeLength()}e.prevCharLength=ue;function ve(oe,Re){Re>0&&B(oe.charCodeAt(Re))&&Re--;const Be=Re+Q(oe,Re);return[Be-ue(oe,Be),Be]}e.getCharContainingOffset=ve;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ge(oe){return J.test(oe)}e.containsRTL=ge;const Ee=/^[\t\n\r\x20-\x7E]*$/;function Pe(oe){return Ee.test(oe)}e.isBasicASCII=Pe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function me(oe){return e.UNUSUAL_LINE_TERMINATORS.test(oe)}e.containsUnusualLineTerminators=me;function Te(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.isFullWidthCharacter=Te;function le(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.isEmojiImprecise=le;function pe(oe,Re){if(oe.length<Re)return oe;const Be=/\b/g;let qe=0;for(;Be.test(oe)&&!(oe.length-Be.lastIndex<Re);)qe=Be.lastIndex,Be.lastIndex+=1;return oe.substring(qe).replace(/^\s/,"")}e.lcut=pe;const be=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function ee(oe){return oe&&(oe=oe.replace(be,""),oe=oe.replace(ae,""),oe=oe.replace(he,"")),oe}e.removeAnsiEscapeCodes=ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ne(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ne;function O(oe){return ne(oe)?oe.substr(1):oe}e.stripUTF8BOM=O;function $(oe,Re){if(!oe||!Re||oe.length<Re.length)return!1;const Be=Re.length,qe=oe.toLowerCase();let je=0,Ve=-1;for(;je<Be;){const nt=qe.indexOf(Re[je],Ve+1);if(nt<0)return!1;Ve=nt,je++}return!0}e.fuzzyContains=$;function G(oe,Re=!1){return oe?(Re&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.containsUppercaseCharacter=G;function K(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.uppercaseFirstLetter=K;function de(oe,Re=1){if(Re===0)return"";let Be=-1;do Be=oe.indexOf(`
`,Be+1),Re--;while(Re>0&&Be>=0);return Be===-1?oe:(oe[Be-1]==="\r"&&Be--,oe.substr(0,Be))}e.getNLines=de;function we(oe){const Re=90-65+1;return oe=oe%(2*Re),oe<Re?String.fromCharCode(97+oe):String.fromCharCode(65+oe-Re)}e.singleLetterHash=we;function se(oe){return ze.getInstance().getGraphemeBreakType(oe)}e.getGraphemeBreakType=se;function De(oe,Re){return oe===0?Re!==5&&Re!==7:oe===2&&Re===3?!1:oe===4||oe===2||oe===3||Re===4||Re===2||Re===3?!0:!(oe===8&&(Re===8||Re===9||Re===11||Re===12)||(oe===11||oe===9)&&(Re===9||Re===10)||(oe===12||oe===10)&&Re===10||Re===5||Re===13||Re===7||oe===1||oe===13&&Re===14||oe===6&&Re===6)}var Ce;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ke()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(Re){if(Re<32)return Re===10?3:Re===13?2:4;if(Re<127)return 0;const Be=this._data,qe=Be.length/3;let je=1;for(;je<=qe;)if(Re<Be[3*je])je=2*je;else if(Re>Be[3*je+1])je=2*je+1;else return Be[3*je+2];return 0}}ze._INSTANCE=null;function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(oe,Re){if(oe===0)return 0;const Be=Ye(oe,Re);if(Be!==void 0)return Be;const qe=new j(Re,oe);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=Ne;function Ye(oe,Re){const Be=new j(Re,oe);let qe=Be.prevCodePoint();for(;Z(qe)||qe===65039||qe===8419;){if(Be.offset===0)return;qe=Be.prevCodePoint()}if(!le(qe))return;let je=Be.offset;return je>0&&Be.prevCodePoint()===8205&&(je=Be.offset),je}function Z(oe){return 127995<=oe&&oe<=127999}var re;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(re||(re={})),e.noBreakWhitespace="\xA0";class ye{constructor(Re){this.confusableDictionary=Re}static getInstance(Re){return ye.cache.get(Array.from(Re))}static getLocales(){return ye._locales.getValue()}isAmbiguous(Re){return this.confusableDictionary.has(Re)}getPrimaryConfusable(Re){return this.confusableDictionary.get(Re)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ye,S=ye,ye.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ye.cache=new u.LRUCachedFunction(oe=>{function Re(it){const at=new Map;for(let bt=0;bt<it.length;bt+=2)at.set(it[bt],it[bt+1]);return at}function Be(it,at){const bt=new Map(it);for(const[Pt,St]of at)bt.set(Pt,St);return bt}function qe(it,at){if(!it)return at;const bt=new Map;for(const[Pt,St]of it)at.has(Pt)&&bt.set(Pt,St);return bt}const je=S.ambiguousCharacterData.getValue();let Ve=oe.filter(it=>!it.startsWith("_")&&it in je);Ve.length===0&&(Ve=["_default"]);let nt;for(const it of Ve){const at=Re(je[it]);nt=qe(nt,at)}const ot=Re(je._common),st=Be(ot,nt);return new ye(st)}),ye._locales=new n.Lazy(()=>Object.keys(ye.ambiguousCharacterData.getValue()).filter(oe=>!oe.startsWith("_")));class We{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(We.getRawData())),this._data}static isInvisibleCharacter(Re){return We.getData().has(Re)}static get codePoints(){return We.getData()}}e.InvisibleCharacters=We,We._data=void 0}),define(Ie[30],ke([1,0,9,13,8,10]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(i){return i===47||i===92}e.isPathSeparator=C;function D(i){return i.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=D;function E(i){return i.indexOf("/")===-1&&(i=D(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=E;function k(i,t=u.posix.sep){if(!i)return"";const o=i.length,l=i.charCodeAt(0);if(C(l)){if(C(i.charCodeAt(1))&&!C(i.charCodeAt(2))){let y=3;const L=y;for(;y<o&&!C(i.charCodeAt(y));y++);if(L!==y&&!C(i.charCodeAt(y+1))){for(y+=1;y<o;y++)if(C(i.charCodeAt(y)))return i.slice(0,y+1).replace(/[\\/]/g,t)}}return t}else if(g(l)&&i.charCodeAt(1)===58)return C(i.charCodeAt(2))?i.slice(0,2)+t:i.slice(0,2);let d=i.indexOf("://");if(d!==-1){for(d+=3;d<o;d++)if(C(i.charCodeAt(d)))return i.slice(0,d+1)}return""}e.getRoot=k;function R(i){if(!n.isWindows||!i||i.length<5)return!1;let t=i.charCodeAt(0);if(t!==92||(t=i.charCodeAt(1),t!==92))return!1;let o=2;const l=o;for(;o<i.length&&(t=i.charCodeAt(o),t!==92);o++);return!(l===o||(t=i.charCodeAt(o+1),isNaN(t)||t===92))}e.isUNC=R;const I=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,P=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(i,t=n.isWindows){const o=t?I:_;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||t&&P.test(i)||i==="."||i===".."||t&&i[i.length-1]==="."||t&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=b;function w(i,t,o){const l=i===t;return!o||l?l:!i||!t?!1:(0,S.equalsIgnoreCase)(i,t)}e.isEqual=w;function p(i,t,o,l=u.sep){if(i===t)return!0;if(!i||!t||t.length>i.length)return!1;if(o){if(!(0,S.startsWithIgnoreCase)(i,t))return!1;if(t.length===i.length)return!0;let y=t.length;return t.charAt(t.length-1)===l&&y--,i.charAt(y)===l}return t.charAt(t.length-1)!==l&&(t+=l),i.indexOf(t)===0}e.isEqualOrParent=p;function g(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=g;function v(i,t){return n.isWindows&&i.endsWith(":")&&(i+=u.sep),(0,u.isAbsolute)(i)||(i=(0,u.join)(t,i)),i=(0,u.normalize)(i),n.isWindows?(i=(0,S.rtrim)(i,u.sep),i.endsWith(":")&&(i+=u.sep)):(i=(0,S.rtrim)(i,u.sep),i||(i=u.sep)),i}e.sanitizeFilePath=v;function f(i){const t=(0,u.normalize)(i);return n.isWindows?i.length>3?!1:c(t)&&(i.length===2||t.charCodeAt(2)===92):t===u.posix.sep}e.isRootOrDriveLetter=f;function c(i,t=n.isWindows){return t?g(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function m(i){return c(i)?i[0]:void 0}e.getDriveLetter=m;function a(i,t,o){return t.length>i.length?-1:i===t?0:(o&&(i=i.toLowerCase(),t=t.toLowerCase()),i.indexOf(t))}e.indexOfPath=a;function h(i){const t=i.split(":");let o,l,d;for(const y of t){const L=Number(y);(0,A.isNumber)(L)?l===void 0?l=L:d===void 0&&(d=L):o=o?[o,y].join(":"):y}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:d!==void 0?d:l!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(i,t,o=8){let l="";for(let y=0;y<o;y++)l+=r.charAt(Math.floor(Math.random()*r.length));let d;return t?d=`${t}-${l}`:d=l,i?(0,u.join)(i,d):d}e.randomPath=s}),define(Ie[60],ke([1,0,8]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(g){return S(g,0)}e.hash=n;function S(g,v){switch(typeof g){case"object":return g===null?A(349,v):Array.isArray(g)?E(g,v):k(g,v);case"string":return D(g,v);case"boolean":return C(g,v);case"number":return A(g,v);case"undefined":return A(937,v);default:return A(617,v)}}e.doHash=S;function A(g,v){return(v<<5)-v+g|0}e.numberHash=A;function C(g,v){return A(g?433:863,v)}function D(g,v){v=A(149417,v);for(let f=0,c=g.length;f<c;f++)v=A(g.charCodeAt(f),v);return v}e.stringHash=D;function E(g,v){return v=A(104579,v),g.reduce((f,c)=>S(c,f),v)}function k(g,v){return v=A(181387,v),Object.keys(g).sort().reduce((f,c)=>(f=D(c,f),S(g[c],f)),v)}class R{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=S(v,this._value),this._value}}e.Hasher=R;var I;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function _(g,v,f=32){const c=f-v,m=~((1<<c)-1);return(g<<v|(m&g)>>>c)>>>0}function P(g,v=0,f=g.byteLength,c=0){for(let m=0;m<f;m++)g[v+m]=c}function b(g,v,f="0"){for(;g.length<v;)g=f+g;return g}function w(g,v=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(f=>f.toString(16).padStart(2,"0")).join(""):b((g>>>0).toString(16),v/4)}e.toHexString=w;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const f=v.length;if(f===0)return;const c=this._buff;let m=this._buffLen,a=this._leftoverHighSurrogate,h,r;for(a!==0?(h=a,r=-1,a=0):(h=v.charCodeAt(0),r=0);;){let s=h;if(u.isHighSurrogate(h))if(r+1<f){const i=v.charCodeAt(r+1);u.isLowSurrogate(i)?(r++,s=u.computeCodePoint(h,i)):s=65533}else{a=h;break}else u.isLowSurrogate(h)&&(s=65533);if(m=this._push(c,m,s),r++,r<f)h=v.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=a}_push(v,f,c){return c<128?v[f++]=c:c<2048?(v[f++]=192|(c&1984)>>>6,v[f++]=128|(c&63)>>>0):c<65536?(v[f++]=224|(c&61440)>>>12,v[f++]=128|(c&4032)>>>6,v[f++]=128|(c&63)>>>0):(v[f++]=240|(c&1835008)>>>18,v[f++]=128|(c&258048)>>>12,v[f++]=128|(c&4032)>>>6,v[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,P(this._buff,this._buffLen),this._buffLen>56&&(this._step(),P(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=p._bigBlock32,f=this._buffDV;for(let o=0;o<64;o+=4)v.setUint32(o,f.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,_(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let c=this._h0,m=this._h1,a=this._h2,h=this._h3,r=this._h4,s,i,t;for(let o=0;o<80;o++)o<20?(s=m&a|~m&h,i=1518500249):o<40?(s=m^a^h,i=1859775393):o<60?(s=m&a|m&h|a&h,i=2400959708):(s=m^a^h,i=3395469782),t=_(c,5)+s+r+i+v.getUint32(o*4,!1)&4294967295,r=h,h=a,a=_(m,30),m=c,c=t;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[25],ke([1,0,16,8]),function(X,e,u,n){"use strict";var S,A,C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(i,t,o){let l=i.get(t);return l===void 0&&(l=o,i.set(t,l)),l}e.getOrSet=E;function k(i){const t=[];return i.forEach((o,l)=>{t.push(`${l} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=k;function R(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=R;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=I;class _{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class P{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var b;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(b||(b={}));class w{constructor(t,o){this._ignorePathCasing=t,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(g||(g={}));class v{constructor(t){this._iter=t}static forUris(t=()=>!1,o=()=>!1){return new v(new w(t,o))}static forPaths(t=!1){return new v(new P(void 0,!t))}static forStrings(){return new v(new I)}static forConfigKeys(){return new v(new _)}clear(){this._root=void 0}fill(t,o){if(o){const l=o.slice(0);(0,u.shuffle)(l);for(const d of l)this.set(d,t)}else{const l=t.slice(0);(0,u.shuffle)(l);for(const d of l)this.set(d[0],d[1])}}set(t,o){const l=this._iter.reset(t);let d;this._root||(this._root=new p,this._root.segment=l.value());const y=[];for(d=this._root;;){const M=l.cmp(d.segment);if(M>0)d.left||(d.left=new p,d.left.segment=l.value()),y.push([-1,d]),d=d.left;else if(M<0)d.right||(d.right=new p,d.right.segment=l.value()),y.push([1,d]),d=d.right;else if(l.hasNext())l.next(),d.mid||(d.mid=new p,d.mid.segment=l.value()),y.push([0,d]),d=d.mid;else break}const L=d.value;d.value=o,d.key=t;for(let M=y.length-1;M>=0;M--){const F=y[M][1];F.updateHeight();const T=F.balanceFactor();if(T<-1||T>1){const U=y[M][0],N=y[M+1][0];if(U===1&&N===1)y[M][1]=F.rotateLeft();else if(U===-1&&N===-1)y[M][1]=F.rotateRight();else if(U===1&&N===-1)F.right=y[M+1][1]=y[M+1][1].rotateRight(),y[M][1]=F.rotateLeft();else if(U===-1&&N===1)F.left=y[M+1][1]=y[M+1][1].rotateLeft(),y[M][1]=F.rotateRight();else throw new Error;if(M>0)switch(y[M-1][0]){case-1:y[M-1][1].left=y[M][1];break;case 1:y[M-1][1].right=y[M][1];break;case 0:y[M-1][1].mid=y[M][1];break}else this._root=y[0][1]}}return L}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let l=this._root;for(;l;){const d=o.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const l=this._iter.reset(t),d=[];let y=this._root;for(;y;){const L=l.cmp(y.segment);if(L>0)d.push([-1,y]),y=y.left;else if(L<0)d.push([1,y]),y=y.right;else if(l.hasNext())l.next(),d.push([0,y]),y=y.mid;else break}if(!!y){if(o?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const L=this._min(y.right),{key:M,value:F,segment:T}=L;this._delete(L.key,!1),y.key=M,y.value=F,y.segment=T}else{const L=y.left??y.right;if(d.length>0){const[M,F]=d[d.length-1];switch(M){case-1:F.left=L;break;case 0:F.mid=L;break;case 1:F.right=L;break}}else this._root=L}for(let L=d.length-1;L>=0;L--){const M=d[L][1];M.updateHeight();const F=M.balanceFactor();if(F>1?(M.right.balanceFactor()>=0||(M.right=M.right.rotateRight()),d[L][1]=M.rotateLeft()):F<-1&&(M.left.balanceFactor()<=0||(M.left=M.left.rotateLeft()),d[L][1]=M.rotateRight()),L>0)switch(d[L-1][0]){case-1:d[L-1][1].left=d[L][1];break;case 1:d[L-1][1].right=d[L][1];break;case 0:d[L-1][1].mid=d[L][1];break}else this._root=d[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let l=this._root,d;for(;l;){const y=o.cmp(l.segment);if(y>0)l=l.left;else if(y<0)l=l.right;else if(o.hasNext())o.next(),d=l.value||d,l=l.mid;else break}return l&&l.value||d}findSuperstr(t){const o=this._iter.reset(t);let l=this._root;for(;l;){const d=o.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[o,l]of this)t(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=v;class f{constructor(t,o){this.uri=t,this.value=o}}class c{constructor(t,o){this[S]="ResourceMap",t instanceof c?(this.map=new Map(t.map),this.toKey=o??c.defaultToKey):(this.map=new Map,this.toKey=t??c.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new f(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(const[l,d]of this.map)t(d.value,d.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=c,c.defaultToKey=i=>i.toString();class m{constructor(t,o){this[A]="ResourceSet",!t||typeof t=="function"?this._map=new c(t):(this._map=new c(o),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,o){this._map.forEach((l,d)=>t.call(o,d,d,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var a;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class h{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const l=this._map.get(t);if(!!l)return o!==0&&this.touch(l,o),l.value}set(t,o,l=0){let d=this._map.get(t);if(d)d.value=o,l!==0&&this.touch(d,l);else{switch(d={key:t,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(t,d),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const l=this._state;let d=this._head;for(;d;){if(o?t.bind(o)(d.value,d.key,this):t(d.value,d.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const t=this,o=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.key,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return d}values(){const t=this,o=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.value,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return d}entries(){const t=this,o=this._state;let l=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:[l.key,l.value],done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return d}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>t;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,l=t.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const l=t.next,d=t.previous;t===this._tail?(d.next=void 0,this._tail=d):(l.previous=d,d.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const l=t.next,d=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=d,d.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,l)=>{t.push([l,o])}),t}fromJSON(t){this.clear();for(const[o,l]of t)this.set(o,l)}}e.LinkedMap=h;class r extends h{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class s{constructor(t){D.set(this,void 0),tt(this,D,t,"f")}get size(){return Me(this,D,"f").size}forEach(t,o){Me(this,D,"f").forEach(t,o)}get(t){return Me(this,D,"f").get(t)}has(t){return Me(this,D,"f").has(t)}entries(){return Me(this,D,"f").entries()}keys(){return Me(this,D,"f").keys()}values(){return Me(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Me(this,D,"f").entries()}}e.ReadonlyMapView=s}),define(Ie[103],ke([1,0,25,8]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...ee){return function(ne,O){for(let $=0,G=ee.length;$<G;$++){const K=ee[$](ne,O);if(K)return K}return null}}e.or=S,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ee,ne,O){if(!O||O.length<ne.length)return null;let $;return ee?$=n.startsWithIgnoreCase(O,ne):$=O.indexOf(ne)===0,$?ne.length>0?[{start:0,end:ne.length}]:[]:null}function C(ee,ne){const O=ne.toLowerCase().indexOf(ee.toLowerCase());return O===-1?null:[{start:O,end:O+ee.length}]}e.matchesContiguousSubString=C;function D(ee,ne){return E(ee.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=D;function E(ee,ne,O,$){if(O===ee.length)return[];if($===ne.length)return null;if(ee[O]===ne[$]){let G=null;return(G=E(ee,ne,O+1,$+1))?g({start:$,end:$+1},G):null}return E(ee,ne,O,$+1)}function k(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function I(ee){return 48<=ee&&ee<=57}function _(ee){return ee===32||ee===9||ee===10||ee===13}const P=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>P.add(ee.charCodeAt(0)));function b(ee){return _(ee)||P.has(ee)}function w(ee,ne){return ee===ne||b(ee)&&b(ne)}function p(ee){return k(ee)||R(ee)||I(ee)}function g(ee,ne){return ne.length===0?ne=[ee]:ee.end===ne[0].start?ne[0].start=ee.start:ne.unshift(ee),ne}function v(ee,ne){for(let O=ne;O<ee.length;O++){const $=ee.charCodeAt(O);if(R($)||I($)||O>0&&!p(ee.charCodeAt(O-1)))return O}return ee.length}function f(ee,ne,O,$){if(O===ee.length)return[];if($===ne.length)return null;if(ee[O]!==ne[$].toLowerCase())return null;{let G=null,K=$+1;for(G=f(ee,ne,O+1,$+1);!G&&(K=v(ne,K))<ne.length;)G=f(ee,ne,O+1,K),K++;return G===null?null:g({start:$,end:$+1},G)}}function c(ee){let ne=0,O=0,$=0,G=0,K=0;for(let Ce=0;Ce<ee.length;Ce++)K=ee.charCodeAt(Ce),R(K)&&ne++,k(K)&&O++,p(K)&&$++,I(K)&&G++;const de=ne/ee.length,we=O/ee.length,se=$/ee.length,De=G/ee.length;return{upperPercent:de,lowerPercent:we,alphaPercent:se,numericPercent:De}}function m(ee){const{upperPercent:ne,lowerPercent:O}=ee;return O===0&&ne>.6}function a(ee){const{upperPercent:ne,lowerPercent:O,alphaPercent:$,numericPercent:G}=ee;return O>.2&&ne<.8&&$>.6&&G<.2}function h(ee){let ne=0,O=0,$=0,G=0;for(let K=0;K<ee.length;K++)$=ee.charCodeAt(K),R($)&&ne++,k($)&&O++,_($)&&G++;return(ne===0||O===0)&&G===0?ee.length<=30:ne<=5}function r(ee,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!h(ee)||ne.length>60)return null;const O=c(ne);if(!a(O)){if(!m(O))return null;ne=ne.toLowerCase()}let $=null,G=0;for(ee=ee.toLowerCase();G<ne.length&&($=f(ee,ne,0,G))===null;)G=v(ne,G+1);return $}e.matchesCamelCase=r;function s(ee,ne,O=!1){if(!ne||ne.length===0)return null;let $=null,G=0;for(ee=ee.toLowerCase(),ne=ne.toLowerCase();G<ne.length&&($=i(ee,ne,0,G,O))===null;)G=t(ne,G+1);return $}e.matchesWords=s;function i(ee,ne,O,$,G){if(O===ee.length)return[];if($===ne.length)return null;if(w(ee.charCodeAt(O),ne.charCodeAt($))){let K=null,de=$+1;if(K=i(ee,ne,O+1,$+1,G),!G)for(;!K&&(de=t(ne,de))<ne.length;)K=i(ee,ne,O+1,de,G),de++;return K===null?null:g({start:$,end:$+1},K)}else return null}function t(ee,ne){for(let O=ne;O<ee.length;O++)if(b(ee.charCodeAt(O))||O>0&&b(ee.charCodeAt(O-1)))return O;return ee.length}const o=S(e.matchesPrefix,r,C),l=S(e.matchesPrefix,r,D),d=new u.LRUCache(1e4);function y(ee,ne,O=!1){if(typeof ee!="string"||typeof ne!="string")return null;let $=d.get(ee);$||($=new RegExp(n.convertSimple2RegExpPattern(ee),"i"),d.set(ee,$));const G=$.exec(ne);return G?[{start:G.index,end:G.index+G[0].length}]:O?l(ee,ne):o(ee,ne)}e.matchesFuzzy=y;function L(ee,ne){const O=me(ee,ee.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?F(O):null}e.matchesFuzzy2=L;function M(ee,ne,O,$,G,K){const de=Math.min(13,ee.length);for(;O<de;O++){const we=me(ee,ne,O,$,G,K,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,K]}e.anyScore=M;function F(ee){if(typeof ee=="undefined")return[];const ne=[],O=ee[1];for(let $=ee.length-1;$>1;$--){const G=ee[$]+O,K=ne[ne.length-1];K&&K.end===G?K.end=G+1:ne.push({start:G,end:G+1})}return ne}e.createMatches=F;const T=128;function U(){const ee=[],ne=[];for(let O=0;O<=T;O++)ne[O]=0;for(let O=0;O<=T;O++)ee.push(ne.slice(0));return ee}function N(ee){const ne=[];for(let O=0;O<=ee;O++)ne[O]=0;return ne}const H=N(2*T),te=N(2*T),B=U(),z=U(),q=U(),V=!1;function j(ee,ne,O,$,G){function K(we,se,De=" "){for(;we.length<se;)we=De+we;return we}let de=` |   |${$.split("").map(we=>K(we,3)).join("|")}
`;for(let we=0;we<=O;we++)we===0?de+=" |":de+=`${ne[we-1]}|`,de+=ee[we].slice(0,G+1).map(se=>K(se.toString(),3)).join("|")+`
`;return de}function ie(ee,ne,O,$){ee=ee.substr(ne),O=O.substr($),console.log(j(z,ee,ee.length,O,O.length)),console.log(j(q,ee,ee.length,O,O.length)),console.log(j(B,ee,ee.length,O,O.length))}function Q(ee,ne){if(ne<0||ne>=ee.length)return!1;const O=ee.codePointAt(ne);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(O)}}function ue(ee,ne){if(ne<0||ne>=ee.length)return!1;switch(ee.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function ve(ee,ne,O){return ne[ee]!==O[ee]}function J(ee,ne,O,$,G,K,de=!1){for(;ne<O&&G<K;)ee[ne]===$[G]&&(de&&(H[ne]=G),ne+=1),G+=1;return ne===O}e.isPatternInWord=J;var ge;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Ee;(function(ee){ee.Default=[-100,0];function ne(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}ee.isDefault=ne})(Ee=e.FuzzyScore||(e.FuzzyScore={}));class Pe{constructor(ne,O){this.firstMatchCanBeWeak=ne,this.boostFullMatch=O}}e.FuzzyScoreOptions=Pe,Pe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function me(ee,ne,O,$,G,K,de=Pe.default){const we=ee.length>T?T:ee.length,se=$.length>T?T:$.length;if(O>=we||K>=se||we-O>se-K||!J(ne,O,we,G,K,se,!0))return;Te(we,se,O,K,ne,G);let De=1,Ce=1,ze=O,Ke=K;const Ne=[!1];for(De=1,ze=O;ze<we;De++,ze++){const We=H[ze],oe=te[ze],Re=ze+1<we?te[ze+1]:se;for(Ce=We-K+1,Ke=We;Ke<Re;Ce++,Ke++){let Be=Number.MIN_SAFE_INTEGER,qe=!1;Ke<=oe&&(Be=le(ee,ne,ze,O,$,G,Ke,se,K,B[De-1][Ce-1]===0,Ne));let je=0;Be!==Number.MAX_SAFE_INTEGER&&(qe=!0,je=Be+z[De-1][Ce-1]);const Ve=Ke>We,nt=Ve?z[De][Ce-1]+(B[De][Ce-1]>0?-5:0):0,ot=Ke>We+1&&B[De][Ce-1]>0,st=ot?z[De][Ce-2]+(B[De][Ce-2]>0?-5:0):0;if(ot&&(!Ve||st>=nt)&&(!qe||st>=je))z[De][Ce]=st,q[De][Ce]=3,B[De][Ce]=0;else if(Ve&&(!qe||nt>=je))z[De][Ce]=nt,q[De][Ce]=2,B[De][Ce]=0;else if(qe)z[De][Ce]=je,q[De][Ce]=1,B[De][Ce]=B[De-1][Ce-1]+1;else throw new Error("not possible")}}if(V&&ie(ee,O,$,K),!Ne[0]&&!de.firstMatchCanBeWeak)return;De--,Ce--;const Ye=[z[De][Ce],K];let Z=0,re=0;for(;De>=1;){let We=Ce;do{const oe=q[De][We];if(oe===3)We=We-2;else if(oe===2)We=We-1;else break}while(We>=1);Z>1&&ne[O+De-1]===G[K+Ce-1]&&!ve(We+K-1,$,G)&&Z+1>B[De][We]&&(We=Ce),We===Ce?Z++:Z=1,re||(re=We),De--,Ce=We-1,Ye.push(Ce)}se===we&&de.boostFullMatch&&(Ye[0]+=2);const ye=re-we;return Ye[0]-=ye,Ye}e.fuzzyScore=me;function Te(ee,ne,O,$,G,K){let de=ee-1,we=ne-1;for(;de>=O&&we>=$;)G[de]===K[we]&&(te[de]=we,de--),we--}function le(ee,ne,O,$,G,K,de,we,se,De,Ce){if(ne[O]!==K[de])return Number.MIN_SAFE_INTEGER;let ze=1,Ke=!1;return de===O-$?ze=ee[O]===G[de]?7:5:ve(de,G,K)&&(de===0||!ve(de-1,G,K))?(ze=ee[O]===G[de]?7:5,Ke=!0):Q(K,de)&&(de===0||!Q(K,de-1))?ze=5:(Q(K,de-1)||ue(K,de-1))&&(ze=5,Ke=!0),ze>1&&O===$&&(Ce[0]=!0),Ke||(Ke=ve(de,G,K)||Q(K,de-1)||ue(K,de-1)),O===$?de>se&&(ze-=Ke?3:5):De?ze+=Ke?2:0:ze+=Ke?0:1,de+1===we&&(ze-=Ke?3:5),ze}function pe(ee,ne,O,$,G,K,de){return ae(ee,ne,O,$,G,K,!0,de)}e.fuzzyScoreGracefulAggressive=pe;function be(ee,ne,O,$,G,K,de){return ae(ee,ne,O,$,G,K,!1,de)}e.fuzzyScoreGraceful=be;function ae(ee,ne,O,$,G,K,de,we){let se=me(ee,ne,O,$,G,K,we);if(se&&!de)return se;if(ee.length>=3){const De=Math.min(7,ee.length-1);for(let Ce=O+1;Ce<De;Ce++){const ze=he(ee,Ce);if(ze){const Ke=me(ze,ze.toLowerCase(),O,$,G,K,we);Ke&&(Ke[0]-=3,(!se||Ke[0]>se[0])&&(se=Ke))}}}return se}function he(ee,ne){if(ne+1>=ee.length)return;const O=ee[ne],$=ee[ne+1];if(O!==$)return ee.slice(0,ne)+$+O+ee.slice(ne+2)}}),define(Ie[156],ke([1,0,76,103,8]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(u.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${A.source}`,"g");function E(p){return p.replace(D,(g,v)=>v?g:`\\${g}`)}e.escapeIcons=E;const k=new RegExp(`\\\\${A.source}`,"g");function R(p){return p.replace(k,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=R;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(I,(g,v,f,c)=>f?g:v||c||"")}e.stripIcons=_;function P(p){const g=p.indexOf(e.iconStartMarker);return g===-1?{text:p}:b(p,g)}e.parseLabelWithIcons=P;function b(p,g){const v=[];let f="";function c(o){if(o){f+=o;for(const l of o)v.push(h)}}let m=-1,a="",h=0,r,s,i=g;const t=p.length;for(c(p.substr(0,g));i<t;)r=p[i],s=p[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(m=i,c(a),a=e.iconStartMarker,i++):r===")"&&m!==-1?(h+=i-m+1,m=-1,a=""):m!==-1?C.test(r)?a+=r:(c(a),m=-1,a=""):c(r),i++;return c(a),{text:f,iconOffsets:v}}function w(p,g,v=!1){const{text:f,iconOffsets:c}=g;if(!c||c.length===0)return(0,n.matchesFuzzy)(p,f,v);const m=(0,S.ltrim)(f," "),a=f.length-m.length,h=(0,n.matchesFuzzy)(p,m,v);if(h)for(const r of h){const s=c[r.start+a]+a;r.start+=s,r.end+=s}return h}e.matchesFuzzyIconAware=w}),define(Ie[80],ke([1,0,25]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new u.LRUCache(1e4);function S(k){return E(k,"NFC",n)}e.normalizeNFC=S;const A=new u.LRUCache(1e4);function C(k){return E(k,"NFD",A)}e.normalizeNFD=C;const D=/[^\u0000-\u0080]/;function E(k,R,I){if(!k)return k;const _=I.get(k);if(_)return _;let P;return D.test(k)?P=k.normalize(R):P=k,I.set(k,P),P}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(R){return C(R).replace(k,"")}}()}),define(Ie[41],ke([1,0,8]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(n||(n={})),function(S){const A="error",C="warning",D="warn",E="info",k="ignore";function R(_){return _?u.equalsIgnoreCase(A,_)?S.Error:u.equalsIgnoreCase(C,_)||u.equalsIgnoreCase(D,_)?S.Warning:u.equalsIgnoreCase(E,_)?S.Info:S.Ignore:S.Ignore}S.fromValue=R;function I(_){switch(_){case S.Error:return A;case S.Warning:return C;case S.Info:return E;default:return k}}S.toString=I}(n||(n={})),e.default=n}),define(Ie[2],ke([1,0,9,13]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,A=/^\//,C=/^\/\//;function D(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!S.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,s){return!r&&!s?"file":r}function k(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const R="",I="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class P{constructor(s,i,t,o,l,d=!1){typeof s=="object"?(this.scheme=s.scheme||R,this.authority=s.authority||R,this.path=s.path||R,this.query=s.query||R,this.fragment=s.fragment||R):(this.scheme=E(s,d),this.authority=i||R,this.path=k(this.scheme,t||R),this.query=o||R,this.fragment=l||R,D(this,d))}static isUri(s){return s instanceof P?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:i,authority:t,path:o,query:l,fragment:d}=s;return i===void 0?i=this.scheme:i===null&&(i=R),t===void 0?t=this.authority:t===null&&(t=R),o===void 0?o=this.path:o===null&&(o=R),l===void 0?l=this.query:l===null&&(l=R),d===void 0?d=this.fragment:d===null&&(d=R),i===this.scheme&&t===this.authority&&o===this.path&&l===this.query&&d===this.fragment?this:new w(i,t,o,l,d)}static parse(s,i=!1){const t=_.exec(s);return t?new w(t[2]||R,h(t[4]||R),h(t[5]||R),h(t[7]||R),h(t[9]||R),i):new w(R,R,R,R,R)}static file(s){let i=R;if(n.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const t=s.indexOf(I,2);t===-1?(i=s.substring(2),s=I):(i=s.substring(2,t),s=s.substring(t)||I)}return new w("file",i,s,R,R)}static from(s){const i=new w(s.scheme,s.authority,s.path,s.query,s.fragment);return D(i,!0),i}static joinPath(s,...i){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return n.isWindows&&s.scheme==="file"?t=P.file(u.win32.join(f(s,!0),...i)).path:t=u.posix.join(s.path,...i),s.with({path:t})}toString(s=!1){return c(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof P)return s;{const i=new w(s);return i._formatted=s.external,i._fsPath=s._sep===b?s.fsPath:null,i}}else return s}}e.URI=P;const b=n.isWindows?1:void 0;class w extends P{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=b),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(r,s){let i,t=-1;for(let o=0;o<r.length;o++){const l=r.charCodeAt(o);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||s&&l===47)t!==-1&&(i+=encodeURIComponent(r.substring(t,o)),t=-1),i!==void 0&&(i+=r.charAt(o));else{i===void 0&&(i=r.substr(0,o));const d=p[l];d!==void 0?(t!==-1&&(i+=encodeURIComponent(r.substring(t,o)),t=-1),i+=d):t===-1&&(t=o)}}return t!==-1&&(i+=encodeURIComponent(r.substring(t))),i!==void 0?i:r}function v(r){let s;for(let i=0;i<r.length;i++){const t=r.charCodeAt(i);t===35||t===63?(s===void 0&&(s=r.substr(0,i)),s+=p[t]):s!==void 0&&(s+=r[i])}return s!==void 0?s:r}function f(r,s){let i;return r.authority&&r.path.length>1&&r.scheme==="file"?i=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?i=r.path.substr(1):i=r.path[1].toLowerCase()+r.path.substr(2):i=r.path,n.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=f;function c(r,s){const i=s?v:g;let t="",{scheme:o,authority:l,path:d,query:y,fragment:L}=r;if(o&&(t+=o,t+=":"),(l||o==="file")&&(t+=I,t+=I),l){let M=l.indexOf("@");if(M!==-1){const F=l.substr(0,M);l=l.substr(M+1),M=F.indexOf(":"),M===-1?t+=i(F,!1):(t+=i(F.substr(0,M),!1),t+=":",t+=i(F.substr(M+1),!1)),t+="@"}l=l.toLowerCase(),M=l.indexOf(":"),M===-1?t+=i(l,!1):(t+=i(l.substr(0,M),!1),t+=l.substr(M))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const M=d.charCodeAt(1);M>=65&&M<=90&&(d=`/${String.fromCharCode(M+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const M=d.charCodeAt(0);M>=65&&M<=90&&(d=`${String.fromCharCode(M+32)}:${d.substr(2)}`)}t+=i(d,!0)}return y&&(t+="?",t+=i(y,!1)),L&&(t+="#",t+=s?L:g(L,!1)),t}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(r){return r.match(a)?r.replace(a,s=>m(s)):r}}),define(Ie[61],ke([1,0,23,8,2]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,D)}e.stringify=A;function C(k){let R=JSON.parse(k);return R=E(R),R}e.parse=C;function D(k,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,n.regExpFlags)(R)}:R}function E(k,R=0){if(!k||R>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 14:return new Date(k.source)}if(k instanceof u.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let I=0;I<k.length;++I)k[I]=E(k[I],R+1);else for(const I in k)Object.hasOwnProperty.call(k,I)&&(k[I]=E(k[I],R+1))}return k}e.revive=E}),define(Ie[11],ke([1,0,13,2]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var S;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(S=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${S.vscodeRemoteResource}`}set(E,k,R){this._hosts[E]=k,this._ports[E]=R}setConnectionToken(E,k){this._connectionTokens[E]=k}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const k=E.authority;let R=this._hosts[k];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const I=this._ports[k],_=this._connectionTokens[k];let P=`path=${encodeURIComponent(E.path)}`;return typeof _=="string"&&(P+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),n.URI.from({scheme:u.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${R}:${I}`,path:this._remoteResourcesPath,query:P})}}e.RemoteAuthorities=new A;class C{asBrowserUri(E,k){const R=this.toUri(E,k);return R.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===S.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${S.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?R.with({scheme:S.vscodeFileResource,authority:R.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(E,k){const R=this.toUri(E,k);return R.scheme===S.vscodeFileResource?R.with({scheme:S.file,authority:R.authority!==C.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(E,k){return n.URI.isUri(E)?E:n.URI.parse(k.toUrl(E))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(Ie[22],ke([1,0,30,11,9,13,8,2]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(P){return(0,D.uriToFsPath)(P,!0)}e.originalFSPath=E;class k{constructor(b){this._ignorePathCasing=b}compare(b,w,p=!1){return b===w?0:(0,C.compare)(this.getComparisonKey(b,p),this.getComparisonKey(w,p))}isEqual(b,w,p=!1){return b===w?!0:!b||!w?!1:this.getComparisonKey(b,p)===this.getComparisonKey(w,p)}getComparisonKey(b,w=!1){return b.with({path:this._ignorePathCasing(b)?b.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(b){return this._ignorePathCasing(b)}isEqualOrParent(b,w,p=!1){if(b.scheme===w.scheme){if(b.scheme===n.Schemas.file)return u.isEqualOrParent(E(b),E(w),this._ignorePathCasing(b))&&b.query===w.query&&(p||b.fragment===w.fragment);if((0,e.isEqualAuthority)(b.authority,w.authority))return u.isEqualOrParent(b.path,w.path,this._ignorePathCasing(b),"/")&&b.query===w.query&&(p||b.fragment===w.fragment)}return!1}joinPath(b,...w){return D.URI.joinPath(b,...w)}basenameOrAuthority(b){return(0,e.basename)(b)||b.authority}basename(b){return S.posix.basename(b.path)}extname(b){return S.posix.extname(b.path)}dirname(b){if(b.path.length===0)return b;let w;return b.scheme===n.Schemas.file?w=D.URI.file(S.dirname(E(b))).path:(w=S.posix.dirname(b.path),b.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),w="/")),b.with({path:w})}normalizePath(b){if(!b.path.length)return b;let w;return b.scheme===n.Schemas.file?w=D.URI.file(S.normalize(E(b))).path:w=S.posix.normalize(b.path),b.with({path:w})}relativePath(b,w){if(b.scheme!==w.scheme||!(0,e.isEqualAuthority)(b.authority,w.authority))return;if(b.scheme===n.Schemas.file){const v=S.relative(E(b),E(w));return A.isWindows?u.toSlashes(v):v}let p=b.path||"/";const g=w.path||"/";if(this._ignorePathCasing(b)){let v=0;for(const f=Math.min(p.length,g.length);v<f&&!(p.charCodeAt(v)!==g.charCodeAt(v)&&p.charAt(v).toLowerCase()!==g.charAt(v).toLowerCase());v++);p=g.substr(0,v)+p.substr(v)}return S.posix.relative(p,g)}resolvePath(b,w){if(b.scheme===n.Schemas.file){const p=D.URI.file(S.resolve(E(b),w));return b.with({authority:p.authority,path:p.path})}return w=u.toPosixPath(w),b.with({path:S.posix.resolve(b.path,w)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,w){return b===w||b!==void 0&&w!==void 0&&(0,C.equalsIgnoreCase)(b,w)}hasTrailingPathSeparator(b,w=S.sep){if(b.scheme===n.Schemas.file){const p=E(b);return p.length>u.getRoot(p).length&&p[p.length-1]===w}else{const p=b.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,w=S.sep){return(0,e.hasTrailingPathSeparator)(b,w)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,w=S.sep){let p=!1;if(b.scheme===n.Schemas.file){const g=E(b);p=g!==void 0&&g.length===u.getRoot(g).length&&g[g.length-1]===w}else{w="/";const g=b.path;p=g.length===1&&g.charCodeAt(g.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(b,w)?b.with({path:b.path+"/"}):b}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(P=>P.scheme===n.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new k(P=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(P,b){const w=[];for(let p=0;p<P.length;p++){const g=b(P[p]);P.some((v,f)=>f===p?!1:(0,e.isEqualOrParent)(g,b(v)))||w.push(P[p])}return w}e.distinctParents=R;var I;(function(P){P.META_DATA_LABEL="label",P.META_DATA_DESCRIPTION="description",P.META_DATA_SIZE="size",P.META_DATA_MIME="mime";function b(w){const p=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,m]=f.split(":");c&&m&&p.set(c,m)});const v=w.path.substring(0,w.path.indexOf(";"));return v&&p.set(P.META_DATA_MIME,v),p}P.parseMetaData=b})(I=e.DataUri||(e.DataUri={}));function _(P,b,w){if(b){let p=P.path;return p&&p[0]!==S.posix.sep&&(p=S.posix.sep+p),P.with({scheme:w,authority:b,path:p})}return P.with({scheme:w})}e.toLocalResource=_}),define(Ie[18],ke([1,0,21,12,3,6,22,13]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(ve){return!!ve&&typeof ve.then=="function"}e.isThenable=E;function k(ve){const J=new u.CancellationTokenSource,ge=ve(J.token),Ee=new Promise((Pe,me)=>{const Te=J.token.onCancellationRequested(()=>{Te.dispose(),J.dispose(),me(new n.CancellationError)});Promise.resolve(ge).then(le=>{Te.dispose(),J.dispose(),Pe(le)},le=>{Te.dispose(),J.dispose(),me(le)})});return new class{cancel(){J.cancel()}then(Pe,me){return Ee.then(Pe,me)}catch(Pe){return this.then(void 0,Pe)}finally(Pe){return Ee.finally(Pe)}}}e.createCancelablePromise=k;function R(ve,J,ge){return new Promise((Ee,Pe)=>{const me=J.onCancellationRequested(()=>{me.dispose(),Ee(ge)});ve.then(Ee,Pe).finally(()=>me.dispose())})}e.raceCancellation=R;function I(ve,J){return new Promise((ge,Ee)=>{const Pe=J.onCancellationRequested(()=>{Pe.dispose(),Ee(new n.CancellationError)});ve.then(ge,Ee).finally(()=>Pe.dispose())})}e.raceCancellationError=I;async function _(ve){let J=-1;const ge=ve.map((Pe,me)=>Pe.then(Te=>(J=me,Te))),Ee=await Promise.race(ge);return ve.forEach((Pe,me)=>{me!==J&&Pe.cancel()}),Ee}e.raceCancellablePromises=_;function P(ve,J,ge){let Ee;const Pe=setTimeout(()=>{Ee?.(void 0),ge?.()},J);return Promise.race([ve.finally(()=>clearTimeout(Pe)),new Promise(me=>Ee=me)])}e.raceTimeout=P;function b(ve){return new Promise((J,ge)=>{const Ee=ve();E(Ee)?Ee.then(J,ge):J(Ee)})}e.asPromise=b;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(J){if(this.activePromise){if(this.queuedPromiseFactory=J,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(ge,ge).then(Ee)})}return new Promise((ge,Ee)=>{this.queuedPromise.then(ge,Ee)})}return this.activePromise=J(),new Promise((ge,Ee)=>{this.activePromise.then(Pe=>{this.activePromise=null,ge(Pe)},Pe=>{this.activePromise=null,Ee(Pe)})})}}e.Throttler=w;class p{constructor(){this.current=Promise.resolve(null)}queue(J){return this.current=this.current.then(()=>J(),()=>J())}}e.Sequencer=p;class g{constructor(){this.promiseMap=new Map}queue(J,ge){const Pe=(this.promiseMap.get(J)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(J)===Pe&&this.promiseMap.delete(J)});return this.promiseMap.set(J,Pe),Pe}}e.SequencerByKey=g;const v=(ve,J)=>{let ge=!0;const Ee=setTimeout(()=>{ge=!1,J()},ve);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Ee),ge=!1}}},f=ve=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ve())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(J){this.defaultDelay=J,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(J,ge=this.defaultDelay){this.task=J,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Pe,me)=>{this.doResolve=Pe,this.doReject=me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Pe=this.task;return this.task=null,Pe()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?f(Ee):v(ge,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class m{constructor(J){this.delayer=new c(J),this.throttler=new w}trigger(J,ge){return this.delayer.trigger(()=>this.throttler.queue(J),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class a{constructor(){this._isOpen=!1,this._promise=new Promise((J,ge)=>{this._completePromise=J})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class h extends a{constructor(J){super();this._timeout=setTimeout(()=>this.open(),J)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function r(ve,J){return J?new Promise((ge,Ee)=>{const Pe=setTimeout(()=>{me.dispose(),ge()},ve),me=J.onCancellationRequested(()=>{clearTimeout(Pe),me.dispose(),Ee(new n.CancellationError)})}):k(ge=>r(ve,ge))}e.timeout=r;function s(ve,J=0){const ge=setTimeout(ve,J);return(0,A.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=s;function i(ve){const J=[];let ge=0;const Ee=ve.length;function Pe(){return ge<Ee?ve[ge++]():null}function me(Te){Te!=null&&J.push(Te);const le=Pe();return le?le.then(me):Promise.resolve(J)}return Promise.resolve(null).then(me)}e.sequence=i;function t(ve,J=Ee=>!!Ee,ge=null){let Ee=0;const Pe=ve.length,me=()=>{if(Ee>=Pe)return Promise.resolve(ge);const Te=ve[Ee++];return Promise.resolve(Te()).then(pe=>J(pe)?Promise.resolve(pe):me())};return me()}e.first=t;function o(ve,J=Ee=>!!Ee,ge=null){if(ve.length===0)return Promise.resolve(ge);let Ee=ve.length;const Pe=()=>{Ee=-1;for(const me of ve)me.cancel?.()};return new Promise((me,Te)=>{for(const le of ve)le.then(pe=>{--Ee>=0&&J(pe)?(Pe(),me(pe)):Ee===0&&me(ge)}).catch(pe=>{--Ee>=0&&(Pe(),Te(pe))})})}e.firstParallel=o;class l{constructor(J){this._size=0,this.maxDegreeOfParalellism=J,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(J){return this._size++,new Promise((ge,Ee)=>{this.outstandingPromises.push({factory:J,c:ge,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const J=this.outstandingPromises.shift();this.runningPromises++;const ge=J.factory();ge.then(J.c,J.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class d extends l{constructor(){super(1)}}e.Queue=d;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const J=new q;return this.drainers.add(J),J.p}isDrained(){for(const[,J]of this.queues)if(J.size>0)return!1;return!0}queueFor(J,ge=C.extUri){const Ee=ge.getComparisonKey(J);let Pe=this.queues.get(Ee);return Pe||(Pe=new d,S.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.queues.delete(Ee),this.onDidQueueDrain()}),this.queues.set(Ee,Pe)),Pe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const J of this.drainers)J.complete();this.drainers.clear()}dispose(){for(const[,J]of this.queues)J.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class L{constructor(J,ge){this._token=-1,typeof J=="function"&&typeof ge=="number"&&this.setIfNotSet(J,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(J,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,J()},ge)}setIfNotSet(J,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,J()},ge))}}e.TimeoutTimer=L;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(J,ge){this.cancel(),this._token=setInterval(()=>{J()},ge)}}e.IntervalTimer=M;class F{constructor(J,ge){this.timeoutToken=-1,this.runner=J,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(J=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,J)}get delay(){return this.timeout}set delay(J){this.timeout=J}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class T{constructor(J,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=J,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(J=this.timeout){J%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(J/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=T;class U extends F{constructor(J,ge){super(J,ge);this.units=[]}work(J){this.units.push(J),this.isScheduled()||this.schedule()}doRun(){const J=this.units;this.units=[],this.runner?.(J)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class N extends A.Disposable{constructor(J,ge){super();this.options=J,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(J){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+J.length>this.options.maxBufferedWork)return!1}else if(this.pending+J.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...J),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ve=>{(0,D.setTimeout0)(()=>{if(J)return;const ge=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(ve,J)=>{const ge=requestIdleCallback(ve,typeof J=="number"?{timeout:J}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(ge))}}}}();class H{constructor(J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function te(ve,J,ge){let Ee;for(let Pe=0;Pe<ge;Pe++)try{return await ve()}catch(me){Ee=me,await r(J)}throw Ee}e.retry=te;class B{hasPending(J){return this._pending?typeof J=="number"?this._pending.taskId===J:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(J,ge,Ee){return this._pending={taskId:J,cancel:()=>Ee?.(),promise:ge},ge.then(()=>this.donePending(J),()=>this.donePending(J)),ge}donePending(J){this._pending&&J===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const J=this._next;this._next=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this._next)this._next.run=J;else{let ge,Ee;const Pe=new Promise((me,Te)=>{ge=me,Ee=Te});this._next={run:J,promise:Pe,promiseResolve:ge,promiseReject:Ee}}return this._next.promise}}e.TaskSequentializer=B;class z{constructor(J,ge=()=>Date.now()){this.interval=J,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const J=this.nowFn();return J-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=J,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((J,ge)=>{this.completeCallback=J,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(J){return new Promise(ge=>{this.completeCallback(J),this.resolved=!0,ge()})}error(J){return new Promise(ge=>{this.errorCallback(J),this.rejected=!0,ge()})}cancel(){new Promise(J=>{this.errorCallback(new n.CancellationError),this.rejected=!0,J()})}}e.DeferredPromise=q;var V;(function(ve){async function J(Ee){let Pe;const me=await Promise.all(Ee.map(Te=>Te.then(le=>le,le=>{Pe||(Pe=le)})));if(typeof Pe!="undefined")throw Pe;return me}ve.settled=J;function ge(Ee){return new Promise(async(Pe,me)=>{try{await Ee(Pe,me)}catch(Te){me(Te)}})}ve.withAsyncBody=ge})(V=e.Promises||(e.Promises={}));var j;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(j||(j={}));class ie{constructor(J){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const ge={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(J(ge)),this.resolve()}catch(Ee){this.reject(Ee)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(J){return new ie(ge=>{ge.emitMany(J)})}static fromPromise(J){return new ie(async ge=>{ge.emitMany(await J)})}static fromPromises(J){return new ie(async ge=>{await Promise.all(J.map(async Ee=>ge.emitOne(await Ee)))})}static merge(J){return new ie(async ge=>{await Promise.all(J.map(async Ee=>{for await(const Pe of Ee)ge.emitOne(Pe)}))})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(J<this._results.length)return{done:!1,value:this._results[J++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(J,ge){return new ie(async Ee=>{for await(const Pe of J)Ee.emitOne(ge(Pe))})}map(J){return ie.map(this,J)}static filter(J,ge){return new ie(async Ee=>{for await(const Pe of J)ge(Pe)&&Ee.emitOne(Pe)})}filter(J){return ie.filter(this,J)}static coalesce(J){return ie.filter(J,ge=>!!ge)}coalesce(){return ie.coalesce(this)}static async toPromise(J){const ge=[];for await(const Ee of J)ge.push(Ee);return ge}toPromise(){return ie.toPromise(this)}emitOne(J){this._state===0&&(this._results.push(J),this._onStateChanged.fire())}emitMany(J){this._state===0&&(this._results=this._results.concat(J),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(J){this._state===0&&(this._state=2,this._error=J,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class Q extends ie{constructor(J,ge){super(ge);this._source=J}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function ue(ve){const J=new u.CancellationTokenSource,ge=ve(J.token);return new Q(J,async Ee=>{const Pe=J.token.onCancellationRequested(()=>{Pe.dispose(),J.dispose(),Ee.reject(new n.CancellationError)});try{for await(const me of ge){if(J.token.isCancellationRequested)return;Ee.emitOne(me)}Pe.dispose(),J.dispose()}catch(me){Pe.dispose(),J.dispose(),Ee.reject(me)}})}e.createCancelableAsyncIterable=ue}),define(Ie[104],ke([1,0,18,9]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new u.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),A=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(d,y,L=!1){const M=d||"",F=y||"",T=S.value.collator.compare(M,F);return S.value.collatorIsNumeric&&T===0&&M!==F?M<F?-1:1:T}e.compareFileNames=D;function E(d,y){const L=A.value.collator;return d=d||"",y=y||"",m(L,d,y)}e.compareFileNamesDefault=E;function k(d,y){const L=A.value.collator;return d=d||"",y=y||"",s(d,y)||m(L,d,y)}e.compareFileNamesUpper=k;function R(d,y){const L=A.value.collator;return d=d||"",y=y||"",r(d,y)||m(L,d,y)}e.compareFileNamesLower=R;function I(d,y){return d=d||"",y=y||"",d===y?0:d<y?-1:1}e.compareFileNamesUnicode=I;function _(d,y,L=!1){L||(d=d&&d.toLowerCase(),y=y&&y.toLowerCase());const[M,F]=f(d),[T,U]=f(y);return M!==T?M<T?-1:1:F===U?0:F<U?-1:1}e.noIntlCompareFileNames=_;function P(d,y){const[L,M]=f(d),[F,T]=f(y);let U=S.value.collator.compare(M,T);if(U===0){if(S.value.collatorIsNumeric&&M!==T)return M<T?-1:1;if(U=S.value.collator.compare(L,F),S.value.collatorIsNumeric&&U===0&&L!==F)return L<F?-1:1}return U}e.compareFileExtensions=P;function b(d,y){d=d||"",y=y||"";const L=c(d),M=c(y),F=A.value.collator,T=C.value.collator;return m(T,L,M)||m(F,d,y)}e.compareFileExtensionsDefault=b;function w(d,y){d=d||"",y=y||"";const L=c(d),M=c(y),F=A.value.collator,T=C.value.collator;return m(T,L,M)||s(d,y)||m(F,d,y)}e.compareFileExtensionsUpper=w;function p(d,y){d=d||"",y=y||"";const L=c(d),M=c(y),F=A.value.collator,T=C.value.collator;return m(T,L,M)||r(d,y)||m(F,d,y)}e.compareFileExtensionsLower=p;function g(d,y){d=d||"",y=y||"";const L=c(d).toLowerCase(),M=c(y).toLowerCase();return L!==M?L<M?-1:1:d!==y?d<y?-1:1:0}e.compareFileExtensionsUnicode=g;const v=/^(.*?)(\.([^.]*))?$/;function f(d,y=!1){const L=d?v.exec(d):[];let M=[L&&L[1]||"",L&&L[3]||""];return y&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function c(d){const y=d?v.exec(d):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function m(d,y,L){const M=d.compare(y,L);return M!==0?M:y.length!==L.length?y.length<L.length?-1:1:0}function a(d){const y=d.charAt(0);return y.toLocaleUpperCase()!==y}function h(d){const y=d.charAt(0);return y.toLocaleLowerCase()!==y}function r(d,y){return a(d)&&h(y)?-1:h(d)&&a(y)?1:0}function s(d,y){return h(d)&&a(y)?-1:a(d)&&h(y)?1:0}function i(d,y,L=!1){return L||(d=d&&d.toLowerCase(),y=y&&y.toLowerCase()),d===y?0:d<y?-1:1}function t(d,y,L=!1){const M=d.split(n.sep),F=y.split(n.sep),T=M.length-1,U=F.length-1;let N,H;for(let te=0;;te++){if(N=T===te,H=U===te,N&&H)return D(M[te],F[te],L);if(N)return-1;if(H)return 1;const B=i(M[te],F[te],L);if(B!==0)return B}}e.comparePaths=t;function o(d,y,L){const M=d.toLowerCase(),F=y.toLowerCase(),T=l(d,y,L);if(T)return T;const U=M.endsWith(L),N=F.endsWith(L);if(U!==N)return U?-1:1;const H=D(M,F);return H!==0?H:M.localeCompare(F)}e.compareAnything=o;function l(d,y,L){const M=d.toLowerCase(),F=y.toLowerCase(),T=M.startsWith(L),U=F.startsWith(L);if(T!==U)return T?-1:1;if(T&&U){if(M.length<F.length)return-1;if(M.length>F.length)return 1}return 0}e.compareByPrefix=l}),define(Ie[105],ke([1,0,104,103,60,9,13,8]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,k=[E,[]];function R(B,z,q,V){if(!B||!z)return k;const j=B.length,ie=z.length;if(j<ie)return k;const Q=B.toLowerCase();return I(z,q,ie,B,Q,j,V)}e.scoreFuzzy=R;function I(B,z,q,V,j,ie,Q){const ue=[],ve=[];for(let Pe=0;Pe<q;Pe++){const me=Pe*ie,Te=me-ie,le=Pe>0,pe=B[Pe],be=z[Pe];for(let ae=0;ae<ie;ae++){const he=ae>0,ee=me+ae,ne=ee-1,O=Te+ae-1,$=he?ue[ne]:0,G=le&&he?ue[O]:0,K=le&&he?ve[O]:0;let de;!G&&le?de=0:de=_(pe,be,V,j,ae,K),de&&G+de>=$&&(Q||le||j.startsWith(z,ae))?(ve[ee]=K+1,ue[ee]=G+de):(ve[ee]=E,ue[ee]=$)}}const J=[];let ge=q-1,Ee=ie-1;for(;ge>=0&&Ee>=0;){const Pe=ge*ie+Ee;ve[Pe]===E||(J.push(Ee),ge--),Ee--}return[ue[q*ie-1],J.reverse()]}function _(B,z,q,V,j,ie){let Q=0;if(!P(z,V[j]))return Q;if(Q+=1,ie>0&&(Q+=ie*5),B===q[j]&&(Q+=1),j===0)Q+=8;else{const ue=b(q.charCodeAt(j-1));ue?Q+=ue:(0,n.isUpper)(q.charCodeAt(j))&&ie===0&&(Q+=2)}return Q}function P(B,z){return B===z?!0:B==="/"||B==="\\"?z==="/"||z==="\\":!1}function b(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function p(B,z,q=0,V=0){const j=z;return j.values&&j.values.length>1?g(B,j.values,q,V):v(B,z,q,V)}e.scoreFuzzy2=p;function g(B,z,q,V){let j=0;const ie=[];for(const Q of z){const[ue,ve]=v(B,Q,q,V);if(typeof ue!="number")return w;j+=ue,ie.push(...ve)}return[j,l(ie)]}function v(B,z,q,V){const j=(0,n.fuzzyScore)(z.original,z.originalLowercase,q,B,B.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?[j[0],(0,n.createMatches)(j)]:w}const f=Object.freeze({score:0}),c=1<<18,m=1<<17,a=1<<16;function h(B,z,q,V){const j=V.values?V.values:[V];return(0,S.hash)({[V.normalized]:{values:j.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:B,description:z,allowNonContiguousMatches:q}})}function r(B,z,q,V,j){if(!B||!z.normalized)return f;const ie=V.getItemLabel(B);if(!ie)return f;const Q=V.getItemDescription(B),ue=h(ie,Q,q,z),ve=j[ue];if(ve)return ve;const J=s(ie,Q,V.getItemPath(B),z,q);return j[ue]=J,J}e.scoreItemFuzzy=r;function s(B,z,q,V,j){const ie=!q||!V.containsPathSeparator;return q&&(C.isLinux?V.pathNormalized===q:(0,D.equalsIgnoreCase)(V.pathNormalized,q))?{score:c,labelMatch:[{start:0,end:B.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:V.values&&V.values.length>1?i(B,z,q,V.values,ie,j):t(B,z,q,V,ie,j)}function i(B,z,q,V,j,ie){let Q=0;const ue=[],ve=[];for(const J of V){const{score:ge,labelMatch:Ee,descriptionMatch:Pe}=t(B,z,q,J,j,ie);if(ge===E)return f;Q+=ge,Ee&&ue.push(...Ee),Pe&&ve.push(...Pe)}return{score:Q,labelMatch:l(ue),descriptionMatch:l(ve)}}function t(B,z,q,V,j,ie){if(j||!z){const[Q,ue]=R(B,V.normalized,V.normalizedLowercase,ie&&!V.expectContiguousMatch);if(Q){const ve=(0,n.matchesPrefix)(V.normalized,B);let J;return ve?(J=m,J+=Math.round(V.normalized.length/B.length*100)):J=a,{score:J+Q,labelMatch:ve||o(ue)}}}if(z){let Q=z;q&&(Q=`${z}${A.sep}`);const ue=Q.length,ve=`${Q}${B}`,[J,ge]=R(ve,V.normalized,V.normalizedLowercase,ie&&!V.expectContiguousMatch);if(J){const Ee=o(ge),Pe=[],me=[];return Ee.forEach(Te=>{Te.start<ue&&Te.end>ue?(Pe.push({start:0,end:Te.end-ue}),me.push({start:Te.start,end:ue})):Te.start>=ue?Pe.push({start:Te.start-ue,end:Te.end-ue}):me.push(Te)}),{score:J,labelMatch:Pe,descriptionMatch:me}}}return f}function o(B){const z=[];if(!B)return z;let q;for(const V of B)q&&q.end===V?q.end+=1:(q={start:V,end:V+1},z.push(q));return z}function l(B){const z=B.sort((j,ie)=>j.start-ie.start),q=[];let V;for(const j of z)!V||!d(V,j)?(V=j,q.push(j)):(V.start=Math.min(V.start,j.start),V.end=Math.max(V.end,j.end));return q}function d(B,z){return!(B.end<z.start||z.end<B.start)}function y(B,z,q,V,j,ie){const Q=r(B,q,V,j,ie),ue=r(z,q,V,j,ie),ve=Q.score,J=ue.score;if((ve===c||J===c)&&ve!==J)return ve===c?-1:1;if(ve>a||J>a){if(ve!==J)return ve>J?-1:1;if(ve<m&&J<m){const pe=M(Q.labelMatch,ue.labelMatch);if(pe!==0)return pe}const Te=j.getItemLabel(B)||"",le=j.getItemLabel(z)||"";if(Te.length!==le.length)return Te.length-le.length}if(ve!==J)return ve>J?-1:1;const ge=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Ee=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0;if(ge&&!Ee)return-1;if(Ee&&!ge)return 1;const Pe=L(B,Q,j),me=L(z,ue,j);return Pe&&me&&Pe!==me?me>Pe?-1:1:F(B,z,q,j)}e.compareItemsByFuzzyScore=y;function L(B,z,q){let V=-1,j=-1;if(z.descriptionMatch&&z.descriptionMatch.length?V=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(V=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(j=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const ie=q.getItemDescription(B);ie&&(j+=ie.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(j=z.descriptionMatch[z.descriptionMatch.length-1].end);return j-V}function M(B,z){if(!B&&!z||(!B||!B.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!B||!B.length)return 1;const q=B[0].start,j=B[B.length-1].end-q,ie=z[0].start,ue=z[z.length-1].end-ie;return j===ue?0:ue<j?1:-1}function F(B,z,q,V){const j=V.getItemLabel(B)||"",ie=V.getItemLabel(z)||"",Q=V.getItemDescription(B),ue=V.getItemDescription(z),ve=j.length+(Q?Q.length:0),J=ie.length+(ue?ue.length:0);if(ve!==J)return ve-J;const ge=V.getItemPath(B),Ee=V.getItemPath(z);return ge&&Ee&&ge.length!==Ee.length?ge.length-Ee.length:j!==ie?(0,u.compareAnything)(j,ie,q.normalized):Q&&ue&&Q!==ue?(0,u.compareAnything)(Q,ue,q.normalized):ge&&Ee&&ge!==Ee?(0,u.compareAnything)(ge,Ee,q.normalized):0}function T(B){return B.startsWith('"')&&B.endsWith('"')}const U=" ";function N(B){typeof B!="string"&&(B="");const z=B.toLowerCase(),{pathNormalized:q,normalized:V,normalizedLowercase:j}=H(B),ie=q.indexOf(A.sep)>=0,Q=T(B);let ue;const ve=B.split(U);if(ve.length>1)for(const J of ve){const ge=T(J),{pathNormalized:Ee,normalized:Pe,normalizedLowercase:me}=H(J);Pe&&(ue||(ue=[]),ue.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:Ee,normalized:Pe,normalizedLowercase:me,expectContiguousMatch:ge}))}return{original:B,originalLowercase:z,pathNormalized:q,normalized:V,normalizedLowercase:j,values:ue,containsPathSeparator:ie,expectContiguousMatch:Q}}e.prepareQuery=N;function H(B){let z;C.isWindows?z=B.replace(/\//g,A.sep):z=B.replace(/\\/g,A.sep);const q=(0,D.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:q,normalizedLowercase:q.toLowerCase()}}function te(B){return Array.isArray(B)?N(B.map(z=>z.original).join(U)):N(B.original)}e.pieceToQuery=te}),define(Ie[36],ke([1,0,16,18,30,25,9,13,8]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",I="[^/\\\\]",_=/\//g;function P(q,V){switch(q){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${V?`|${R}${I}+`:""})*?`}}function b(q,V){if(!q)return[];const j=[];let ie=!1,Q=!1,ue="";for(const ve of q){switch(ve){case V:if(!ie&&!Q){j.push(ue),ue="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ue+=ve}return ue&&j.push(ue),j}e.splitGlobAware=b;function w(q){if(!q)return"";let V="";const j=b(q,e.GLOB_SPLIT);if(j.every(ie=>ie===e.GLOBSTAR))V=".*";else{let ie=!1;j.forEach((Q,ue)=>{if(Q===e.GLOBSTAR){if(ie)return;V+=P(2,ue===j.length-1)}else{let ve=!1,J="",ge=!1,Ee="";for(const Pe of Q){if(Pe!=="}"&&ve){J+=Pe;continue}if(ge&&(Pe!=="]"||!Ee)){let me;Pe==="-"?me=Pe:(Pe==="^"||Pe==="!")&&!Ee?me="^":Pe===e.GLOB_SPLIT?me="":me=(0,E.escapeRegExpCharacters)(Pe),Ee+=me;continue}switch(Pe){case"{":ve=!0;continue;case"[":ge=!0;continue;case"}":{V+=`(?:${b(J,",").map(le=>w(le)).join("|")})`,ve=!1,J="";break}case"]":{V+="["+Ee+"]",ge=!1,Ee="";break}case"?":V+=I;continue;case"*":V+=P(1);continue;default:V+=(0,E.escapeRegExpCharacters)(Pe)}}ue<j.length-1&&(j[ue+1]!==e.GLOBSTAR||ue+2<j.length)&&(V+=R)}ie=Q===e.GLOBSTAR})}return V}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new A.LRUCache(1e4),h=function(){return!1},r=function(){return null};function s(q,V){if(!q)return r;let j;typeof q!="string"?j=q.pattern:j=q,j=j.trim();const ie=`${j}_${!!V.trimForExclusions}`;let Q=a.get(ie);if(Q)return i(Q,q);let ue;return p.test(j)?Q=o(j.substr(4),j):(ue=g.exec(t(j,V)))?Q=l(ue[1],j):(V.trimForExclusions?f:v).test(j)?Q=d(j,V):(ue=c.exec(t(j,V)))?Q=y(ue[1].substr(1),j,!0):(ue=m.exec(t(j,V)))?Q=y(ue[1],j,!1):Q=L(j),a.set(ie,Q),i(Q,q)}function i(q,V){if(typeof V=="string")return q;const j=function(ie,Q){return(0,S.isEqualOrParent)(ie,V.base,!D.isLinux)?q(ie.substr(V.base.length+1),Q):null};return j.allBasenames=q.allBasenames,j.allPaths=q.allPaths,j.basenames=q.basenames,j.patterns=q.patterns,j}function t(q,V){return V.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function o(q,V){return function(j,ie){return typeof j=="string"&&j.endsWith(q)?V:null}}function l(q,V){const j=`/${q}`,ie=`\\${q}`,Q=function(ve,J){return typeof ve!="string"?null:J?J===q?V:null:ve===q||ve.endsWith(j)||ve.endsWith(ie)?V:null},ue=[q];return Q.basenames=ue,Q.patterns=[V],Q.allBasenames=ue,Q}function d(q,V){const j=B(q.slice(1,-1).split(",").map(J=>s(J,V)).filter(J=>J!==r),q),ie=j.length;if(!ie)return r;if(ie===1)return j[0];const Q=function(J,ge){for(let Ee=0,Pe=j.length;Ee<Pe;Ee++)if(j[Ee](J,ge))return q;return null},ue=j.find(J=>!!J.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const ve=j.reduce((J,ge)=>ge.allPaths?J.concat(ge.allPaths):J,[]);return ve.length&&(Q.allPaths=ve),Q}function y(q,V,j){const ie=C.sep===C.posix.sep,Q=ie?q:q.replace(_,C.sep),ue=C.sep+Q,ve=C.posix.sep+q;let J;return j?J=function(ge,Ee){return typeof ge=="string"&&(ge===Q||ge.endsWith(ue)||!ie&&(ge===q||ge.endsWith(ve)))?V:null}:J=function(ge,Ee){return typeof ge=="string"&&(ge===Q||!ie&&ge===q)?V:null},J.allPaths=[(j?"*/":"./")+q],J}function L(q){try{const V=new RegExp(`^${w(q)}$`);return function(j){return V.lastIndex=0,typeof j=="string"&&V.test(j)?q:null}}catch{return r}}function M(q,V,j){return!q||typeof V!="string"?!1:F(q)(V,void 0,j)}e.match=M;function F(q,V={}){if(!q)return h;if(typeof q=="string"||T(q)){const j=s(q,V);if(j===r)return h;const ie=function(Q,ue){return!!j(Q,ue)};return j.allBasenames&&(ie.allBasenames=j.allBasenames),j.allPaths&&(ie.allPaths=j.allPaths),ie}return H(q,V)}e.parse=F;function T(q){const V=q;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=T;function U(q){return q.allBasenames||[]}e.getBasenameTerms=U;function N(q){return q.allPaths||[]}e.getPathTerms=N;function H(q,V){const j=B(Object.getOwnPropertyNames(q).map(J=>te(J,q[J],V)).filter(J=>J!==r)),ie=j.length;if(!ie)return r;if(!j.some(J=>!!J.requiresSiblings)){if(ie===1)return j[0];const J=function(Pe,me){let Te;for(let le=0,pe=j.length;le<pe;le++){const be=j[le](Pe,me);if(typeof be=="string")return be;(0,n.isThenable)(be)&&(Te||(Te=[]),Te.push(be))}return Te?(async()=>{for(const le of Te){const pe=await le;if(typeof pe=="string")return pe}return null})():null},ge=j.find(Pe=>!!Pe.allBasenames);ge&&(J.allBasenames=ge.allBasenames);const Ee=j.reduce((Pe,me)=>me.allPaths?Pe.concat(me.allPaths):Pe,[]);return Ee.length&&(J.allPaths=Ee),J}const Q=function(J,ge,Ee){let Pe,me;for(let Te=0,le=j.length;Te<le;Te++){const pe=j[Te];pe.requiresSiblings&&Ee&&(ge||(ge=(0,C.basename)(J)),Pe||(Pe=ge.substr(0,ge.length-(0,C.extname)(J).length)));const be=pe(J,ge,Pe,Ee);if(typeof be=="string")return be;(0,n.isThenable)(be)&&(me||(me=[]),me.push(be))}return me?(async()=>{for(const Te of me){const le=await Te;if(typeof le=="string")return le}return null})():null},ue=j.find(J=>!!J.allBasenames);ue&&(Q.allBasenames=ue.allBasenames);const ve=j.reduce((J,ge)=>ge.allPaths?J.concat(ge.allPaths):J,[]);return ve.length&&(Q.allPaths=ve),Q}function te(q,V,j){if(V===!1)return r;const ie=s(q,j);if(ie===r)return r;if(typeof V=="boolean")return ie;if(V){const Q=V.when;if(typeof Q=="string"){const ue=(ve,J,ge,Ee)=>{if(!Ee||!ie(ve,J))return null;const Pe=Q.replace("$(basename)",ge),me=Ee(Pe);return(0,n.isThenable)(me)?me.then(Te=>Te?q:null):me?q:null};return ue.requiresSiblings=!0,ue}}return ie}function B(q,V){const j=q.filter(J=>!!J.basenames);if(j.length<2)return q;const ie=j.reduce((J,ge)=>{const Ee=ge.basenames;return Ee?J.concat(Ee):J},[]);let Q;if(V){Q=[];for(let J=0,ge=ie.length;J<ge;J++)Q.push(V)}else Q=j.reduce((J,ge)=>{const Ee=ge.patterns;return Ee?J.concat(Ee):J},[]);const ue=function(J,ge){if(typeof J!="string")return null;if(!ge){let Pe;for(Pe=J.length;Pe>0;Pe--){const me=J.charCodeAt(Pe-1);if(me===47||me===92)break}ge=J.substr(Pe)}const Ee=ie.indexOf(ge);return Ee!==-1?Q[Ee]:null};ue.basenames=ie,ue.patterns=Q,ue.allBasenames=ie;const ve=q.filter(J=>!J.basenames);return ve.push(ue),ve}function z(q,V){return(0,u.equals)(q,V,(j,ie)=>typeof j=="string"&&typeof ie=="string"?j===ie:typeof j!="string"&&typeof ie!="string"?j.base===ie.base&&j.pattern===ie.pattern:!1)}e.patternsEquals=z}),define(Ie[106],ke([1,0,12,156,22,8,2]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(g="",v=!1){if(this.value=g,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(g,v=0){return this.value+=_(this.supportThemeIcons?(0,n.escapeIcons)(g):g).replace(/([ \t]+)/g,(f,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,v){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(g,v,f){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(g),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(g,v){const f=new RegExp((0,A.escapeRegExpCharacters)(v),"g");return g.replace(f,(c,m)=>g.charAt(m-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=E;function k(p){return R(p)?!p.value:Array.isArray(p)?p.every(k):!0}e.isEmptyMarkdownString=k;function R(p){return p instanceof E?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function I(p,g){return p===g?!0:!p||!g?!1:p.value===g.value&&p.isTrusted===g.isTrusted&&p.supportThemeIcons===g.supportThemeIcons&&p.supportHtml===g.supportHtml&&(p.baseUri===g.baseUri||!!p.baseUri&&!!g.baseUri&&(0,S.isEqual)(C.URI.from(p.baseUri),C.URI.from(g.baseUri)))}e.markdownStringEqual=I;function _(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=_;function P(p){return p.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=P;function b(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function w(p){const g=[],v=p.split("|").map(c=>c.trim());p=v[0];const f=v[1];if(f){const c=/height=(\d+)/.exec(f),m=/width=(\d+)/.exec(f),a=c?c[1]:"",h=m?m[1]:"",r=isFinite(parseInt(h)),s=isFinite(parseInt(a));r&&g.push(`width="${h}"`),s&&g.push(`height="${a}"`)}return{href:p,dimensions:g}}e.parseHrefAndDimensions=w}),define(Ie[107],ke([1,0,16,30,9,13,22,8]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(r,s){const{os:i,tildify:t,relative:o}=s;if(o){const y=k(r,o,i);if(typeof y=="string")return y}let l=r.fsPath;if(i===1&&!A.isWindows?l=l.replace(/\//g,"\\"):i!==1&&A.isWindows&&(l=l.replace(/\\/g,"/")),i!==1&&t?.userHome){const y=t.userHome.fsPath;let L;r.scheme!==t.userHome.scheme&&r.path.startsWith(S.posix.sep)?L=t.userHome.with({path:r.path}).fsPath:L=r.fsPath,l=_(L,y,i)}return(i===1?S.win32:S.posix).normalize(R(l,i===1))}e.getPathLabel=E;function k(r,s,i){const t=i===1?S.win32:S.posix,o=i===3?C.extUri:C.extUriIgnorePathCase,l=s.getWorkspace(),d=(0,u.firstOrDefault)(l.folders);if(!d)return;r.scheme!==d.uri.scheme&&r.path.startsWith(S.posix.sep)&&(r=d.uri.with({path:r.path}));const y=s.getWorkspaceFolder(r);if(!y)return;let L;if(o.isEqual(y.uri,r)?L="":L=o.relativePath(y.uri,r)??"",L&&(L=t.normalize(L)),l.folders.length>1&&!s.noPrefix){const M=y.name?y.name:o.basenameOrAuthority(y.uri);L=L?`${M} \u2022 ${L}`:M}return L}function R(r,s=A.isWindows){return(0,n.hasDriveLetter)(r,s)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=R;let I=Object.create(null);function _(r,s,i=A.OS){if(i===1||!r||!s)return r;let t=I.original===s?I.normalized:void 0;t||(t=s,A.isWindows&&(t=(0,n.toSlashes)(t)),t=`${(0,D.rtrim)(t,S.posix.sep)}${S.posix.sep}`,I={original:s,normalized:t});let o=r;return A.isWindows&&(o=(0,n.toSlashes)(o)),(i===3?o.startsWith(t):(0,D.startsWithIgnoreCase)(o,t))?`~/${o.substr(t.length)}`:r}e.tildify=_;function P(r,s){return r.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=P;const b="\u2026",w="\\\\",p="~";function g(r,s=S.sep){const i=new Array(r.length);let t=!1;for(let o=0;o<r.length;o++){const l=r[o];if(l===""){i[o]=`.${s}`;continue}if(!l){i[o]=l;continue}t=!0;let d="",y=l;y.indexOf(w)===0?(d=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(s)===0?(d=y.substr(0,y.indexOf(s)+s.length),y=y.substr(y.indexOf(s)+s.length)):y.indexOf(p)===0&&(d=y.substr(0,y.indexOf(p)+p.length),y=y.substr(y.indexOf(p)+p.length));const L=y.split(s);for(let M=1;t&&M<=L.length;M++)for(let F=L.length-M;t&&F>=0;F--){t=!1;let T=L.slice(F,F+M).join(s);for(let U=0;!t&&U<r.length;U++)if(U!==o&&r[U]&&r[U].indexOf(T)>-1){const N=F+M===L.length,H=F>0&&r[U].indexOf(s)>-1?s+T:T,te=r[U].endsWith(H);t=!N||te}if(!t){let U="";(L[0].endsWith(":")||d!=="")&&(F===1&&(F=0,M++,T=L[0]+s+T),F>0&&(U=L[0]+s),U=d+U),F>0&&(U=U+b+s),U=U+T,F+M<L.length&&(U=U+s+b),i[o]=U}}t&&(i[o]=l)}return i}e.shorten=g;var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function f(r,s=Object.create(null)){const i=[];let t=!1,o="";for(const l of r)if(l==="$"||t&&l==="{")o&&i.push({value:o,type:v.TEXT}),o="",t=!0;else if(l==="}"&&t){const d=s[o];if(typeof d=="string")d.length&&i.push({value:d,type:v.VARIABLE});else if(d){const y=i[i.length-1];(!y||y.type!==v.SEPARATOR)&&i.push({value:d.label,type:v.SEPARATOR})}o="",t=!1}else o+=l;return o&&!t&&i.push({value:o,type:v.TEXT}),i.filter((l,d)=>{if(l.type===v.SEPARATOR){const y=i[d-1],L=i[d+1];return[y,L].every(M=>M&&(M.type===v.VARIABLE||M.type===v.TEXT)&&M.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=f;function c(r,s){return A.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function m(r,s){return A.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,i=>i==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function a(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=a;function h(r){const s=r.indexOf("/")!==-1?S.posix:S.win32,i=s.basename(r),t=s.dirname(r);return i.length?{name:i,parentPath:t}:{name:t,parentPath:""}}e.splitName=h}),define(Ie[108],ke([1,0,2]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(R){return R.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const _=this._uriTransformer.transformIncoming(I);return _===I?I:n(u.URI.from(_))}transformOutgoing(I){const _=this._uriTransformer.transformOutgoing(I);return _===I?I:n(u.URI.from(_))}transformOutgoingURI(I){const _=this._uriTransformer.transformOutgoing(I);return _===I?I:u.URI.from(_)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,I,_){if(!R||_>200)return null;if(typeof R=="object"){if(R instanceof u.URI)return I.transformOutgoing(R);for(const P in R)if(Object.hasOwnProperty.call(R,P)){const b=A(R[P],I,_+1);b!==null&&(R[P]=b)}}return null}function C(R,I){const _=A(R,I,0);return _===null?R:_}e.transformOutgoingURIs=C;function D(R,I,_,P){if(!R||P>200)return null;if(typeof R=="object"){if(R.$mid===1)return _?u.URI.revive(I.transformIncoming(R)):I.transformIncoming(R);for(const b in R)if(Object.hasOwnProperty.call(R,b)){const w=D(R[b],I,_,P+1);w!==null&&(R[b]=w)}}return null}function E(R,I){const _=D(R,I,!1,0);return _===null?R:_}e.transformIncomingURIs=E;function k(R,I){const _=D(R,I,!0,0);return _===null?R:_}e.transformAndReviveIncomingURIs=k}),define(Ie[29],ke([1,0,62,81,302,18,30,80,9,13,22,2]),function(X,e,u,n,S,A,C,D,E,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var _;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(_=e.RimRafMode||(e.RimRafMode={}));async function P(N,H=_.UNLINK){if((0,C.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return H===_.UNLINK?w(N):b(N)}async function b(N){try{const H=(0,C.randomPath)((0,n.tmpdir)());try{await u.promises.rename(N,H)}catch{return w(N)}w(H).catch(te=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function w(N){return(0,S.promisify)(u.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function p(N){if((0,C.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function g(N,H){return c(await(H?v(N):(0,S.promisify)(u.readdir)(N)))}async function v(N){try{return await(0,S.promisify)(u.readdir)(N,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const H=[],te=await g(N);for(const B of te){let z=!1,q=!1,V=!1;try{const j=await e.Promises.lstat((0,E.join)(N,B));z=j.isFile(),q=j.isDirectory(),V=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}H.push({name:B,isFile:()=>z,isDirectory:()=>q,isSymbolicLink:()=>V})}return H}function f(N){return c(u.readdirSync(N))}e.readdirSync=f;function c(N){return N.map(H=>typeof H=="string"?k.isMacintosh?(0,D.normalizeNFC)(H):H:(H.name=k.isMacintosh?(0,D.normalizeNFC)(H.name):H.name,H))}async function m(N){const H=await g(N),te=[];for(const B of H)await h.existsDirectory((0,E.join)(N,B))&&te.push(B);return te}function a(N,H=1e3){return new Promise(te=>{let B=!1;const z=setInterval(()=>{B||(B=!0,u.access(N,q=>{B=!1,q&&(clearInterval(z),te(void 0))}))},H)})}e.whenDeleted=a;var h;(function(N){async function H(z){let q;try{if(q=await e.Promises.lstat(z),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(k.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw j}throw V}}N.stat=H;async function te(z){try{const{stat:q,symbolicLink:V}=await N.stat(z);return q.isFile()&&V?.dangling!==!0}catch{}return!1}N.existsFile=te;async function B(z){try{const{stat:q,symbolicLink:V}=await N.stat(z);return q.isDirectory()&&V?.dangling!==!0}catch{}return!1}N.existsDirectory=B})(h=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function s(N,H,te){return r.queueFor(I.URI.file(N),R.extUriBiasedIgnorePathCase).queue(()=>{const B=l(te);return new Promise((z,q)=>t(N,H,B,V=>V?q(V):z()))})}let i=!0;function t(N,H,te,B){if(!i)return u.writeFile(N,H,{mode:te.mode,flag:te.flag},B);u.open(N,te.flag,te.mode,(z,q)=>{if(z)return B(z);u.writeFile(q,H,V=>{if(V)return u.close(q,()=>B(V));u.fdatasync(q,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),i=!1),u.close(q,ie=>B(ie))))})})}function o(N,H,te){const B=l(te);if(!i)return u.writeFileSync(N,H,{mode:B.mode,flag:B.flag});const z=u.openSync(N,B.flag,B.mode);try{u.writeFileSync(z,H);try{u.fdatasyncSync(z)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),i=!1}}finally{u.closeSync(z)}}e.writeFileSync=o;function l(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function d(N,H){if(N!==H)try{await e.Promises.rename(N,H)}catch(te){if(N.toLowerCase()!==H.toLowerCase()&&te.code==="EXDEV"||N.endsWith("."))await y(N,H,{preserveSymlinks:!1}),await P(N,_.MOVE);else throw te}}async function y(N,H,te){return M(N,H,{root:{source:N,target:H},options:te,handledSourcePaths:new Set})}const L=511;async function M(N,H,te){if(te.handledSourcePaths.has(N))return;te.handledSourcePaths.add(N);const{stat:B,symbolicLink:z}=await h.stat(N);if(z){if(te.options.preserveSymlinks)try{return await U(N,H,te)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(z.dangling)return}return B.isDirectory()?F(N,H,B.mode&L,te):T(N,H,B.mode&L)}async function F(N,H,te,B){await e.Promises.mkdir(H,{recursive:!0,mode:te});const z=await g(N);for(const q of z)await M((0,E.join)(N,q),(0,E.join)(H,q),B)}async function T(N,H,te){await e.Promises.copyFile(N,H),await e.Promises.chmod(H,te)}async function U(N,H,te){let B=await e.Promises.readlink(N);(0,C.isEqualOrParent)(B,te.root.source,!k.isLinux)&&(B=(0,E.join)(te.root.target,B.substr(te.root.source.length+1))),await e.Promises.symlink(B,H)}e.Promises=new class{get access(){return(0,S.promisify)(u.access)}get stat(){return(0,S.promisify)(u.stat)}get lstat(){return(0,S.promisify)(u.lstat)}get utimes(){return(0,S.promisify)(u.utimes)}get read(){return(N,H,te,B,z)=>new Promise((q,V)=>{u.read(N,H,te,B,z,(j,ie,Q)=>j?V(j):q({bytesRead:ie,buffer:Q}))})}get readFile(){return(0,S.promisify)(u.readFile)}get write(){return(N,H,te,B,z)=>new Promise((q,V)=>{u.write(N,H,te,B,z,(j,ie,Q)=>j?V(j):q({bytesWritten:ie,buffer:Q}))})}get appendFile(){return(0,S.promisify)(u.appendFile)}get fdatasync(){return(0,S.promisify)(u.fdatasync)}get truncate(){return(0,S.promisify)(u.truncate)}get rename(){return(0,S.promisify)(u.rename)}get copyFile(){return(0,S.promisify)(u.copyFile)}get open(){return(0,S.promisify)(u.open)}get close(){return(0,S.promisify)(u.close)}get symlink(){return(0,S.promisify)(u.symlink)}get readlink(){return(0,S.promisify)(u.readlink)}get chmod(){return(0,S.promisify)(u.chmod)}get mkdir(){return(0,S.promisify)(u.mkdir)}get unlink(){return(0,S.promisify)(u.unlink)}get rmdir(){return(0,S.promisify)(u.rmdir)}get realpath(){return(0,S.promisify)(u.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return m}get writeFile(){return s}get rm(){return P}get move(){return d}get copy(){return y}}}),define(Ie[109],ke([1,0,62,9,13,8,29]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(_){if(S.isLinux)return _;const P=(0,n.dirname)(_);if(_===P)return _;const b=((0,n.basename)(_)||_).toLowerCase();try{const p=(0,C.readdirSync)(P).filter(g=>g.toLowerCase()===b);if(p.length===1){const g=D(P);if(g)return(0,n.join)(g,p[0])}else if(p.length>1){const g=p.indexOf(b);if(g>=0){const v=D(P);if(v)return(0,n.join)(v,p[g])}}}catch{}return null}e.realcaseSync=D;async function E(_){if(S.isLinux)return _;const P=(0,n.dirname)(_);if(_===P)return _;const b=((0,n.basename)(_)||_).toLowerCase();try{const p=(await C.Promises.readdir(P)).filter(g=>g.toLowerCase()===b);if(p.length===1){const g=await E(P);if(g)return(0,n.join)(g,p[0])}else if(p.length>1){const g=p.indexOf(b);if(g>=0){const v=await E(P);if(v)return(0,n.join)(v,p[g])}}}catch{}return null}e.realcase=E;async function k(_){try{return await C.Promises.realpath(_)}catch{const b=I(_);return await C.Promises.access(b,u.constants.R_OK),b}}e.realpath=k;function R(_){try{return u.realpathSync(_)}catch{const b=I(_);return u.accessSync(b,u.constants.R_OK),b}}e.realpathSync=R;function I(_){return(0,A.rtrim)((0,n.normalize)(_),n.sep)}});var Ge=this&&this.__decorate||function(X,e,u,n){var S=arguments.length,A=S<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,u):n,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(X,e,u,n);else for(var D=X.length-1;D>=0;D--)(C=X[D])&&(A=(S<3?C(A):S>3?C(e,u,A):C(e,u))||A);return S>3&&A&&Object.defineProperty(e,u,A),A};define(Ie[110],ke([1,0,16,18,23,21,57,12,3,6,61,8,10]),function(X,e,u,n,S,A,C,D,E,k,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var P;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(P=e.RequestType||(e.RequestType={}));function b(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function p(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(g||(g={}));class v{constructor(V){this.buffer=V,this.pos=0}read(V){const j=this.buffer.slice(this.pos,this.pos+V);return this.pos+=j.byteLength,j}}class f{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(c||(c={}));function m(q){const V=S.VSBuffer.alloc(4);return V.writeUInt32BE(q,0),V}function a(q){return q.read(4).readUInt32BE(0)}function h(q){const V=S.VSBuffer.alloc(1);return V.writeUInt8(q,0),V}const r={Undefined:h(c.Undefined),String:h(c.String),Buffer:h(c.Buffer),VSBuffer:h(c.VSBuffer),Array:h(c.Array),Object:h(c.Object)},s=typeof Buffer!="undefined";function i(q,V){if(typeof V=="undefined")q.write(r.Undefined);else if(typeof V=="string"){const j=S.VSBuffer.fromString(V);q.write(r.String),q.write(m(j.byteLength)),q.write(j)}else if(s&&Buffer.isBuffer(V)){const j=S.VSBuffer.wrap(V);q.write(r.Buffer),q.write(m(j.byteLength)),q.write(j)}else if(V instanceof S.VSBuffer)q.write(r.VSBuffer),q.write(m(V.byteLength)),q.write(V);else if(Array.isArray(V)){q.write(r.Array),q.write(m(V.length));for(const j of V)i(q,j)}else{const j=S.VSBuffer.fromString(JSON.stringify(V));q.write(r.Object),q.write(m(j.byteLength)),q.write(j)}}function t(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(a(q)).toString();case c.Buffer:return q.read(a(q)).buffer;case c.VSBuffer:return q.read(a(q));case c.Array:{const j=a(q),ie=[];for(let Q=0;Q<j;Q++)ie.push(t(q));return ie}case c.Object:return JSON.parse(q.read(a(q)).toString())}}class o{constructor(V,j,ie=null,Q=1e3){this.protocol=V,this.ctx=j,this.logger=ie,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(V,j){this.channels.set(V,j),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const j=this.send([V.type]);this.logger?.logOutgoing(j,0,1,p(V.type));return}case 201:case 202:case 204:case 203:{const j=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(j,V.id,1,p(V.type),V.data);return}}}send(V,j=void 0){const ie=new f;return i(ie,V),i(ie,j),this.sendBuffer(ie.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const j=new v(V),ie=t(j),Q=t(j),ue=ie[0];switch(ue){case 100:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${b(ue)}: ${ie[2]}.${ie[3]}`,Q),this.onPromise({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:Q});case 102:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${b(ue)}: ${ie[2]}.${ie[3]}`,Q),this.onEventListen({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:Q});case 101:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${b(ue)}`),this.disposeActiveRequest({type:ue,id:ie[1]});case 103:return this.logger?.logIncoming(V.byteLength,ie[1],1,`${b(ue)}`),this.disposeActiveRequest({type:ue,id:ie[1]})}}onPromise(V){const j=this.channels.get(V.channelName);if(!j){this.collectPendingRequest(V);return}const ie=new A.CancellationTokenSource;let Q;try{Q=j.call(this.ctx,V.name,V.arg,ie.token)}catch(J){Q=Promise.reject(J)}const ue=V.id;Q.then(J=>{this.sendResponse({id:ue,data:J,type:201}),this.activeRequests.delete(V.id)},J=>{J instanceof Error?this.sendResponse({id:ue,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:ue,data:J,type:203}),this.activeRequests.delete(V.id)});const ve=(0,k.toDisposable)(()=>ie.cancel());this.activeRequests.set(V.id,ve)}onEventListen(V){const j=this.channels.get(V.channelName);if(!j){this.collectPendingRequest(V);return}const ie=V.id,ue=j.listen(this.ctx,V.name,V.arg)(ve=>this.sendResponse({id:ie,data:ve,type:204}));this.activeRequests.set(V.id,ue)}disposeActiveRequest(V){const j=this.activeRequests.get(V.id);j&&(j.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let j=this.pendingRequests.get(V.channelName);j||(j=[],this.pendingRequests.set(V.channelName,j));const ie=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:V,timeoutTimer:ie})}flushPendingRequests(V){const j=this.pendingRequests.get(V);if(j){for(const ie of j)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var l;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(V,j=null){this.protocol=V,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=j}getChannel(V){const j=this;return{call(ie,Q,ue){return j.isDisposed?Promise.reject(D.canceled()):j.requestPromise(V,ie,Q,ue)},listen(ie,Q){return j.isDisposed?E.Event.None:j.requestEvent(V,ie,Q)}}}requestPromise(V,j,ie,Q=A.CancellationToken.None){const ue=this.lastRequestId++,J={id:ue,type:100,channelName:V,name:j,arg:ie};if(Q.isCancellationRequested)return Promise.reject(D.canceled());let ge;return new Promise((Pe,me)=>{if(Q.isCancellationRequested)return me(D.canceled());const Te=()=>{const ae=he=>{switch(he.type){case 201:this.handlers.delete(ue),Pe(he.data);break;case 202:{this.handlers.delete(ue);const ee=new Error(he.data.message);ee.stack=he.data.stack,ee.name=he.data.name,me(ee);break}case 203:this.handlers.delete(ue),me(he.data);break}};this.handlers.set(ue,ae),this.sendRequest(J)};let le=null;this.state===g.Idle?Te():(le=(0,n.createCancelablePromise)(ae=>this.whenInitialized()),le.then(()=>{le=null,Te()}));const pe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:ue,type:101}),me(D.canceled())},be=Q.onCancellationRequested(pe);ge=(0,k.combinedDisposable)((0,k.toDisposable)(pe),be),this.activeRequests.add(ge)}).finally(()=>{this.activeRequests.delete(ge)})}requestEvent(V,j,ie){const Q=this.lastRequestId++,ve={id:Q,type:102,channelName:V,name:j,arg:ie};let J=null;const ge=new E.Emitter({onFirstListenerAdd:()=>{J=(0,n.createCancelablePromise)(Pe=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(ge),this.sendRequest(ve)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(ge),this.sendRequest({id:Q,type:103}))}}),Ee=Pe=>ge.fire(Pe.data);return this.handlers.set(Q,Ee),ge.event}sendRequest(V){switch(V.type){case 100:case 102:{const j=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(j,V.id,0,`${b(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const j=this.send([V.type,V.id]);this.logger?.logOutgoing(j,V.id,0,b(V.type));return}}}send(V,j=void 0){const ie=new f;return i(ie,V),i(ie,j),this.sendBuffer(ie.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const j=new v(V),ie=t(j),Q=t(j),ue=ie[0];switch(ue){case 200:return this.logger?.logIncoming(V.byteLength,0,0,p(ue)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(V.byteLength,ie[1],0,p(ue),Q),this.onResponse({type:ie[0],id:ie[1],data:Q})}}onResponse(V){if(V.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ge([C.memoize],d.prototype,"onDidInitializePromise",null),e.ChannelClient=d;class y{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:j,onDidClientDisconnect:ie})=>{E.Event.once(j.onMessage)(ue=>{const ve=new v(ue),J=t(ve),ge=new o(j,J),Ee=new d(j);this.channels.forEach((me,Te)=>ge.registerChannel(Te,me));const Pe={channelServer:ge,channelClient:Ee,ctx:J};this._connections.add(Pe),this._onDidAddConnection.fire(Pe),ie(()=>{ge.dispose(),Ee.dispose(),this._connections.delete(Pe),this._onDidRemoveConnection.fire(Pe)})})})}get connections(){const V=[];return this._connections.forEach(j=>V.push(j)),V}getChannel(V,j){const ie=this;return{call(Q,ue,ve){let J;if((0,_.isFunction)(j)){const Ee=(0,u.getRandomElement)(ie.connections.filter(j));J=Ee?Promise.resolve(Ee):E.Event.toPromise(E.Event.filter(ie.onDidAddConnection,j))}else J=j.routeCall(ie,Q,ue);const ge=J.then(Ee=>Ee.channelClient.getChannel(V));return M(ge).call(Q,ue,ve)},listen(Q,ue){if((0,_.isFunction)(j))return ie.getMulticastEvent(V,j,Q,ue);const ve=j.routeEvent(ie,Q,ue).then(J=>J.channelClient.getChannel(V));return M(ve).listen(Q,ue)}}}getMulticastEvent(V,j,ie,Q){const ue=this;let ve=new k.DisposableStore;const J=new E.Emitter({onFirstListenerAdd:()=>{ve=new k.DisposableStore;const ge=new E.EventMultiplexer,Ee=new Map,Pe=Te=>{const pe=Te.channelClient.getChannel(V).listen(ie,Q),be=ge.add(pe);Ee.set(Te,be)},me=Te=>{const le=Ee.get(Te);!le||(le.dispose(),Ee.delete(Te))};ue.connections.filter(j).forEach(Pe),E.Event.filter(ue.onDidAddConnection,j)(Pe,void 0,ve),ue.onDidRemoveConnection(me,void 0,ve),ge.event(J.fire,J,ve),ve.add(ge)},onLastListenerRemove:()=>{ve.dispose()}});return J.event}registerChannel(V,j){this.channels.set(V,j),this._connections.forEach(ie=>{ie.channelServer.registerChannel(V,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class L{constructor(V,j,ie=null){const Q=new f;i(Q,j),V.send(Q.buffer),this.channelClient=new d(V,ie),this.channelServer=new o(V,j,ie)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,j){this.channelServer.registerChannel(V,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function M(q){return{call(V,j,ie){return q.then(Q=>Q.call(V,j,ie))},listen(V,j){const ie=new E.Relay;return q.then(Q=>ie.input=Q.listen(V,j)),ie.event}}}e.getDelayedChannel=M;function F(q){let V=!1;return{call(j,ie,Q){return V?q.call(j,ie,Q):(0,n.timeout)(0).then(()=>V=!0).then(()=>q.call(j,ie,Q))},listen(j,ie){if(V)return q.listen(j,ie);const Q=new E.Relay;return(0,n.timeout)(0).then(()=>V=!0).then(()=>Q.input=q.listen(j,ie)),Q.event}}}e.getNextTickChannel=F;class T{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const j of V.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await E.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=T;var U;(function(q){function V(ue,ve){const J=ue,ge=ve&&ve.disableMarshalling,Ee=new Map;for(const Pe in J)ie(Pe)&&Ee.set(Pe,E.Event.buffer(J[Pe],!0));return new class{listen(Pe,me,Te){const le=Ee.get(me);if(le)return le;if(Q(me)){const pe=J[me];if(typeof pe=="function")return pe.call(J,Te)}throw new Error(`Event not found: ${me}`)}call(Pe,me,Te){const le=J[me];if(typeof le=="function"){if(!ge&&Array.isArray(Te))for(let pe=0;pe<Te.length;pe++)Te[pe]=(0,R.revive)(Te[pe]);return le.apply(J,Te)}throw new Error(`Method not found: ${me}`)}}}q.fromService=V;function j(ue,ve){const J=ve&&ve.disableMarshalling;return new Proxy({},{get(ge,Ee){if(typeof Ee=="string")return ve?.properties?.has(Ee)?ve.properties.get(Ee):Q(Ee)?function(Pe){return ue.listen(Ee,Pe)}:ie(Ee)?ue.listen(Ee):async function(...Pe){let me;ve&&!(0,_.isUndefinedOrNull)(ve.context)?me=[ve.context,...Pe]:me=Pe;const Te=await ue.call(Ee,me);return J?Te:(0,R.revive)(Te)};throw new Error(`Property not found: ${String(Ee)}`)}})}q.toService=j;function ie(ue){return ue[0]==="o"&&ue[1]==="n"&&I.isUpperAsciiLetter(ue.charCodeAt(2))}function Q(ue){return/^onDynamic/.test(ue)&&I.isUpperAsciiLetter(ue.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const V=q.toString();if(V!=="[object Object]")return V}return q}function te(q){return Array.isArray(q)?q.map(H):H(q)}function B(q,V,j,ie,Q,ue,ve){ve=te(ve);const J=N[Q],ge=J[ie%J.length];let Ee=[`%c[${q}]%c[${String(V).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${ge}`];/\($/.test(ue)?(Ee=Ee.concat(ve),Ee.push(")")):Ee.push(ve),console.log.apply(console,Ee)}e.logWithColors=B;class z{constructor(V,j){this._outgoingPrefix=V,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,j,ie,Q,ue){this._totalOutgoing+=V,B(this._outgoingPrefix,this._totalOutgoing,V,j,ie,Q,ue)}logIncoming(V,j,ie,Q,ue){this._totalIncoming+=V,B(this._incomingPrefix,this._totalIncoming,V,j,ie,Q,ue)}}e.IPCLogger=z}),define(Ie[111],ke([1,0,23,3,6,110]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let t=0;function o(d,y){if(!i.has(d)){const L=String(++t);i.set(d,L)}return i.get(d)}function l(d,y,L,M){if(!s.enableDiagnostics)return;const F=o(d,y);if(M instanceof u.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const T=u.VSBuffer.alloc(M.byteLength);T.set(M),s.records.push({timestamp:Date.now(),id:F,label:y,type:L,buff:T})}else s.records.push({timestamp:Date.now(),id:F,label:y,type:L,data:M})}s.traceSocketEvent=l})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function R(){return k||(k=u.VSBuffer.alloc(0)),k}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,t){if(i===0)return R();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const y=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=i),y}if(this._chunks[0].byteLength>i){const y=this._chunks[0].slice(0,i);return t&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),y}const o=u.VSBuffer.alloc(i);let l=0,d=0;for(;i>0;){const y=this._chunks[d];if(y.byteLength>i){const L=y.slice(0,i);o.set(L,l),l+=i,t&&(this._chunks[d]=y.slice(i),this._totalLength-=i),i-=i}else o.set(y,l),l+=y.byteLength,t?(this._chunks.shift(),this._totalLength-=y.byteLength):d++,i-=y.byteLength}return o}}e.ChunkStream=I;var _;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(_||(_={}));function P(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var b;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(i,t,o,l){this.type=i,this.id=t,this.ack=o,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends S.Disposable{constructor(i){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:P(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,l=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new w(o,l,d,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=u.VSBuffer.alloc(13);t.writeUInt8(i.type,0),t.writeUInt32BE(i.id,1),t.writeUInt32BE(i.ack,5),t.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:P(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(t,i.data)}_bufferAdd(i,t){const o=this._totalLength===0;return this._data.push(i,t),this._totalLength+=i.byteLength+t.byteLength,o}_bufferTake(){const i=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,t){this._bufferAdd(i,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class v extends S.Disposable{constructor(i){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new w(1,0,0,i))}}e.Protocol=v;class f extends A.IPCClient{constructor(i,t,o=null){super(i,t,o);this.protocol=i}static fromSocket(i,t){return new f(new v(i),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=f;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class m{constructor(i){this.data=i,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const i=[];let t=0,o=this._first;for(;o;)i[t++]=o.data,o=o.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const t=new m(i);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class h{constructor(){this.lastRuns=[];const i=Date.now();for(let t=0;t<h._HISTORY_LENGTH;t++)this.lastRuns[t]=i-1e3*t;setInterval(()=>{for(let t=h._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const i=Date.now(),t=(1+h._HISTORY_LENGTH)*1e3;let o=0;for(let l=0;l<h._HISTORY_LENGTH;l++)i-this.lastRuns[l]<=t&&o++;return 1-o/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class r{constructor(i,t=null,o=h.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=i,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),t&&this._socketReader.acceptChunk(t)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,S.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new w(5,0,0,R());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new w(7,0,0,R());this._socketWriter.write(i)}sendResume(){const i=new w(8,0,0,R());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,t){this._isReconnecting=!0,this._socketDisposables=(0,S.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new w(3,0,this._incomingAckId,R());this._socketWriter.write(i);const t=this._outgoingUnackMsg.toArray();for(let o=0,l=t.length;o<l;o++)this._socketWriter.write(t[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new w(6,0,0,R())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let o=0,l=t.length;o<l;o++)this._socketWriter.write(t[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new w(1,t,this._incomingAckId,i);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(i){const t=new w(2,0,0,i);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),t=Date.now()-i.writtenTime,o=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&o>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const d=Math.max(2e4-t,2e4-o,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},d)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new w(3,0,this._incomingAckId,R());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(Ie[112],ke([1,0,23,12,3,6,9,13,34,110,111]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:X.__$__nodeRequire("crypto"),zlib:X.__$__nodeRequire("zlib"),net:X.__$__nodeRequire("net"),os:X.__$__nodeRequire("os")}}class _{constructor(o,l=""){this.debugLabel=l,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=d=>{if(this.traceSocketEvent("error",{code:d?.code,message:d?.message}),d){if(d.code==="EPIPE")return;(0,n.onUnexpectedError)(d)}},this.socket.on("error",this._errorListener)}traceSocketEvent(o,l){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,l)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(o){const l=d=>{this.traceSocketEvent("read",d),o(u.VSBuffer.wrap(d))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(o){const l=d=>{this.traceSocketEvent("close",{hadError:d}),o({type:0,hadError:d,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(o){const l=()=>{this.traceSocketEvent("nodeEndReceived"),o()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(o){if(!this.socket.destroyed)try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,n.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,n.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=_;var P;(function(t){t[t.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var b;(function(t){t[t.PeekHeader=1]="PeekHeader",t[t.ReadHeader=2]="ReadHeader",t[t.ReadBody=3]="ReadBody",t[t.Fin=4]="Fin"})(b||(b={}));class w extends A.Disposable{constructor(o,l,d,y){super();this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:d?.byteLength||0,recordInflateBytes:y}),this._flowManager=this._register(new p(this,l,d,y,this._onData,(L,M)=>this._write(L,M))),this._register(this._flowManager.onError(L=>{console.error(L),(0,n.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,l){this.socket.traceSocketEvent(o,l)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,l){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let d=2;o.byteLength<126?d+=0:o.byteLength<2**16?d+=2:d+=8;const y=u.VSBuffer.alloc(d);if(l?y.writeUInt8(194,0):y.writeUInt8(130,0),o.byteLength<126)y.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){y.writeUInt8(126,1);let L=1;y.writeUInt8(o.byteLength>>>8&255,++L),y.writeUInt8(o.byteLength>>>0&255,++L)}else{y.writeUInt8(127,1);let L=1;y.writeUInt8(0,++L),y.writeUInt8(0,++L),y.writeUInt8(0,++L),y.writeUInt8(0,++L),y.writeUInt8(o.byteLength>>>24&255,++L),y.writeUInt8(o.byteLength>>>16&255,++L),y.writeUInt8(o.byteLength>>>8&255,++L),y.writeUInt8(o.byteLength>>>0&255,++L)}this.socket.write(u.VSBuffer.concat([y,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const l=this._incomingData.peek(this._state.readLen),d=l.readUInt8(0),y=(d&128)>>>7,L=(d&64)>>>6,M=l.readUInt8(1),F=(M&128)>>>7,T=M&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(T===126?2:0)+(T===127?8:0),this._state.fin=y,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(y),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const l=this._incomingData.read(this._state.readLen),d=l.readUInt8(1),y=(d&128)>>>7;let L=d&127,M=1;L===126?L=l.readUInt8(++M)*2**8+l.readUInt8(++M):L===127&&(L=l.readUInt8(++M)*0+l.readUInt8(++M)*0+l.readUInt8(++M)*0+l.readUInt8(++M)*0+l.readUInt8(++M)*2**24+l.readUInt8(++M)*2**16+l.readUInt8(++M)*2**8+l.readUInt8(++M));let F=0;y&&(F=l.readUInt8(++M)*2**24+l.readUInt8(++M)*2**16+l.readUInt8(++M)*2**8+l.readUInt8(++M)),this._state.state=3,this._state.readLen=L,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const l=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),f(l,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(l,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await S.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class p extends A.Disposable{constructor(o,l,d,y,L,M){super();this._tracer=o,this._onData=L,this._writeFn=M,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new S.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,l?(this._zlibInflateStream=this._register(new g(this._tracer,y,d,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:u.VSBuffer.alloc(0)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const l=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(l,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,l){return new Promise((d,y)=>{o.write(l),o.flush(L=>d(L))})}acceptFrame(o,l,d){this._readQueue.push({data:o,isCompressed:l,isLastFrameOfMessage:d}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const l=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(l)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,l,d){return new Promise((y,L)=>{o.write(l),d&&o.write(u.VSBuffer.fromByteArray([0,0,255,255])),o.flush(M=>y(M))})}}class g extends A.Disposable{constructor(o,l,d,y){super();this._tracer=o,this._recordInflateBytes=l,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=I().zlib.createInflateRaw(y),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(u.VSBuffer.wrap(L))}),d&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",d.buffer),this._zlibInflate.write(d.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?u.VSBuffer.concat(this._recordedInflateBytes):u.VSBuffer.alloc(0)}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const l=u.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(l)})}}class v extends A.Disposable{constructor(o,l){super();this._tracer=o,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=I().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",d=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:d?.message,code:d?.code}),this._onError.fire(d)}),this._zlibDeflate.on("data",d=>{this._tracer.traceSocketEvent("zlibDeflateData",d),this._pendingDeflateData.push(u.VSBuffer.wrap(d))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let l=u.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,l=l.slice(0,l.byteLength-4),o(l)})}}function f(t,o){if(o===0)return;const l=t.byteLength>>>2;for(let T=0;T<l;T++){const U=t.readUInt32BE(T*4);t.writeUInt32BE(U^o,T*4)}const d=l*4,y=t.byteLength-d,L=o>>>24&255,M=o>>>16&255,F=o>>>8&255;y>=1&&t.writeUInt8(t.readUInt8(d)^L,d),y>=2&&t.writeUInt8(t.readUInt8(d+1)^M,d+1),y>=3&&t.writeUInt8(t.readUInt8(d+2)^F,d+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function m(){const t=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${t}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${t}.sock`):o=(0,C.join)(I().os.tmpdir(),`vscode-ipc-${t}.sock`),h(o),o}e.createRandomIPCHandle=m;function a(t,o,l){const d=I().crypto.createHash("md5").update(t).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${l}-${o}-sock`;let y;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?y=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${l}-${o}.sock`):y=(0,C.join)(t,`${l}-${o}.sock`),h(y),y}e.createStaticIPCHandle=a;function h(t){const o=c[D.platform];typeof o=="number"&&t.length>=o&&console.warn(`WARNING: IPC handle "${t}" is longer than ${o} chars, try a shorter --user-data-dir`)}class r extends k.IPCServer{constructor(o){super(r.toClientConnectionEvent(o));this.server=o}static toClientConnectionEvent(o){const l=S.Event.fromNodeEventEmitter(o,"connection");return S.Event.map(l,d=>({protocol:new R.Protocol(new _(d,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(d,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(t){return new Promise((o,l)=>{const d=I().net.createServer();d.on("error",l),d.listen(t,()=>{d.removeListener("error",l),o(new r(d))})})}e.serve=s;function i(t,o){return new Promise((l,d)=>{const y=I().net.createConnection(t,()=>{y.removeListener("error",d),l(R.Client.fromSocket(new _(y,`ipc-client${o}`),o))});y.once("error",d)})}e.connect=i}),define(Ie[157],ke([1,0,36,9]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(A,C,D,E,k,R){if(Array.isArray(A)){let I=0;for(const _ of A){const P=S(_,C,D,E,k,R);if(P===10)return P;P>I&&(I=P)}return I}else{if(typeof A=="string")return E?A==="*"?5:A===D?10:0:0;if(A){const{language:I,pattern:_,scheme:P,hasAccessToAllModels:b,notebookType:w}=A;if(!E&&!b)return 0;w&&k&&(C=k);let p=0;if(P)if(P===C.scheme)p=10;else if(P==="*")p=5;else return 0;if(I)if(I===D)p=10;else if(I==="*")p=Math.max(p,5);else return 0;if(w)if(w===R)p=10;else if(w==="*"&&R!==void 0)p=Math.max(p,5);else return 0;if(_){let g;if(typeof _=="string"?g=_:g={..._,base:(0,n.normalize)(_.base)},g===C.fsPath||(0,u.match)(g,C.fsPath))p=10;else return 0}return p}else return 0}}e.score=S}),define(Ie[158],ke([1,0,8,48,150]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(D,E,k,R){this._uri=D,this._lines=E,this._eol=k,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const E=D.changes;for(const k of E)this._acceptDeleteRange(k.range),this._acceptInsertText(new n.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,E=this._lines.length,k=new Uint32Array(E);for(let R=0;R<E;R++)k[R]=this._lines[R].length+D;this._lineStarts=new S.PrefixSumComputer(k)}}_setLineText(D,E){this._lines[D]=E,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,E){if(E.length===0)return;const k=(0,u.splitLines)(E);if(k.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}k[k.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]);const R=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(D.lineNumber+I-1,0,k[I]),R[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,R)}}e.MirrorTextModel=A}),define(Ie[159],ke([1,0,8,147,48,35,100]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class E{constructor(v,f,c,m){this.searchString=v,this.isRegex=f,this.matchCase=c,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=k(this.searchString):v=this.searchString.indexOf(`
`)>=0;let f=null;try{f=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!f)return null;let c=!this.isRegex&&!v;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new C.SearchData(f,this.wordSeparators?(0,n.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=E;function k(g){if(!g||g.length===0)return!1;for(let v=0,f=g.length;v<f;v++)if(g.charCodeAt(v)===92){if(v++,v>=f)break;const m=g.charCodeAt(v);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=k;function R(g,v,f){if(!f)return new C.FindMatch(g,null);const c=[];for(let m=0,a=v.length;m<a;m++)c[m]=v[m];return new C.FindMatch(g,c)}e.createFindMatch=R;class I{constructor(v){const f=[];let c=0;for(let m=0,a=v.length;m<a;m++)v.charCodeAt(m)===10&&(f[c++]=m);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(v){const f=this._lineFeedsOffsets;let c=0,m=f.length-1;if(m===-1||v<=f[0])return 0;for(;c<m;){const a=c+((m-c)/2>>0);f[a]>=v?m=a-1:f[a+1]>=v?(c=a,m=a):c=a+1}return c+1}}class _{static findMatches(v,f,c,m,a){const h=f.parseSearchRequest();return h?h.regex.multiline?this._doFindMatchesMultiline(v,c,new p(h.wordSeparators,h.regex),m,a):this._doFindMatchesLineByLine(v,c,h,m,a):[]}static _getMultilineMatchRange(v,f,c,m,a,h){let r,s=0;m?(s=m.findLineFeedCountBeforeOffset(a),r=f+a+s):r=f+a;let i;if(m){const d=m.findLineFeedCountBeforeOffset(a+h.length)-s;i=r+h.length+d}else i=r+h.length;const t=v.getPositionAt(r),o=v.getPositionAt(i);return new A.Range(t.lineNumber,t.column,o.lineNumber,o.column)}static _doFindMatchesMultiline(v,f,c,m,a){const h=v.getOffsetAt(f.getStartPosition()),r=v.getValueInRange(f,1),s=v.getEOL()===`\r
`?new I(r):null,i=[];let t=0,o;for(c.reset(0);o=c.next(r);)if(i[t++]=R(this._getMultilineMatchRange(v,h,r,s,o.index,o[0]),o,m),t>=a)return i;return i}static _doFindMatchesLineByLine(v,f,c,m,a){const h=[];let r=0;if(f.startLineNumber===f.endLineNumber){const i=v.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(c,i,f.startLineNumber,f.startColumn-1,r,h,m,a),h}const s=v.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(c,s,f.startLineNumber,f.startColumn-1,r,h,m,a);for(let i=f.startLineNumber+1;i<f.endLineNumber&&r<a;i++)r=this._findMatchesInLine(c,v.getLineContent(i),i,0,r,h,m,a);if(r<a){const i=v.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(c,i,f.endLineNumber,0,r,h,m,a)}return h}static _findMatchesInLine(v,f,c,m,a,h,r,s){const i=v.wordSeparators;if(!r&&v.simpleSearch){const l=v.simpleSearch,d=l.length,y=f.length;let L=-d;for(;(L=f.indexOf(l,L+d))!==-1;)if((!i||w(i,f,y,L,d))&&(h[a++]=new C.FindMatch(new A.Range(c,L+1+m,c,L+1+d+m),null),a>=s))return a;return a}const t=new p(v.wordSeparators,v.regex);let o;t.reset(0);do if(o=t.next(f),o&&(h[a++]=R(new A.Range(c,o.index+1+m,c,o.index+1+o[0].length+m),o,r),a>=s))return a;while(o);return a}static findNextMatch(v,f,c,m){const a=f.parseSearchRequest();if(!a)return null;const h=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(v,c,h,m):this._doFindNextMatchLineByLine(v,c,h,m)}static _doFindNextMatchMultiline(v,f,c,m){const a=new S.Position(f.lineNumber,1),h=v.getOffsetAt(a),r=v.getLineCount(),s=v.getValueInRange(new A.Range(a.lineNumber,a.column,r,v.getLineMaxColumn(r)),1),i=v.getEOL()===`\r
`?new I(s):null;c.reset(f.column-1);const t=c.next(s);return t?R(this._getMultilineMatchRange(v,h,s,i,t.index,t[0]),t,m):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(v,new S.Position(1,1),c,m):null}static _doFindNextMatchLineByLine(v,f,c,m){const a=v.getLineCount(),h=f.lineNumber,r=v.getLineContent(h),s=this._findFirstMatchInLine(c,r,h,f.column,m);if(s)return s;for(let i=1;i<=a;i++){const t=(h+i-1)%a,o=v.getLineContent(t+1),l=this._findFirstMatchInLine(c,o,t+1,1,m);if(l)return l}return null}static _findFirstMatchInLine(v,f,c,m,a){v.reset(m-1);const h=v.next(f);return h?R(new A.Range(c,h.index+1,c,h.index+1+h[0].length),h,a):null}static findPreviousMatch(v,f,c,m){const a=f.parseSearchRequest();if(!a)return null;const h=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(v,c,h,m):this._doFindPreviousMatchLineByLine(v,c,h,m)}static _doFindPreviousMatchMultiline(v,f,c,m){const a=this._doFindMatchesMultiline(v,new A.Range(1,1,f.lineNumber,f.column),c,m,10*D);if(a.length>0)return a[a.length-1];const h=v.getLineCount();return f.lineNumber!==h||f.column!==v.getLineMaxColumn(h)?this._doFindPreviousMatchMultiline(v,new S.Position(h,v.getLineMaxColumn(h)),c,m):null}static _doFindPreviousMatchLineByLine(v,f,c,m){const a=v.getLineCount(),h=f.lineNumber,r=v.getLineContent(h).substring(0,f.column-1),s=this._findLastMatchInLine(c,r,h,m);if(s)return s;for(let i=1;i<=a;i++){const t=(a+h-i-1)%a,o=v.getLineContent(t+1),l=this._findLastMatchInLine(c,o,t+1,m);if(l)return l}return null}static _findLastMatchInLine(v,f,c,m){let a=null,h;for(v.reset(0);h=v.next(f);)a=R(new A.Range(c,h.index+1,c,h.index+1+h[0].length),h,m);return a}}e.TextModelSearch=_;function P(g,v,f,c,m){if(c===0)return!0;const a=v.charCodeAt(c-1);if(g.get(a)!==0||a===13||a===10)return!0;if(m>0){const h=v.charCodeAt(c);if(g.get(h)!==0)return!0}return!1}function b(g,v,f,c,m){if(c+m===f)return!0;const a=v.charCodeAt(c+m);if(g.get(a)!==0||a===13||a===10)return!0;if(m>0){const h=v.charCodeAt(c+m-1);if(g.get(h)!==0)return!0}return!1}function w(g,v,f,c,m){return P(g,v,f,c,m)&&b(g,v,f,c,m)}e.isValidMatch=w;class p{constructor(v,f){this._wordSeparators=v,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const f=v.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(c=this._searchRegex.exec(v),!c))return null;const m=c.index,a=c[0].length;if(m===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){u.getNextCodePoint(v,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=a,!this._wordSeparators||w(this._wordSeparators,v,f,m,a))return c}while(c);return null}}e.Searcher=p}),define(Ie[113],ke([1,0,23,13]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function A(I){for(let _=0,P=I.length;_<P;_+=4){const b=I[_+0],w=I[_+1],p=I[_+2],g=I[_+3];I[_+0]=g,I[_+1]=p,I[_+2]=w,I[_+3]=b}}function C(I){const _=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return n.isLittleEndian()||A(_),u.VSBuffer.wrap(_)}function D(I){const _=I.buffer;if(n.isLittleEndian()||A(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const P=new Uint8Array(_.byteLength);return P.set(_),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function E(I){const _=new Uint32Array(k(I));let P=0;if(_[P++]=I.id,I.type==="full")_[P++]=1,_[P++]=I.data.length,_.set(I.data,P),P+=I.data.length;else{_[P++]=2,_[P++]=I.deltas.length;for(const b of I.deltas)_[P++]=b.start,_[P++]=b.deleteCount,b.data?(_[P++]=b.data.length,_.set(b.data,P),P+=b.data.length):_[P++]=0}return C(_)}e.encodeSemanticTokensDto=E;function k(I){let _=0;if(_+=1+1,I.type==="full")_+=1+I.data.length;else{_+=1,_+=(1+1+1)*I.deltas.length;for(const P of I.deltas)P.data&&(_+=P.data.length)}return _}function R(I){const _=D(I);let P=0;const b=_[P++];if(_[P++]===1){const v=_[P++],f=_.subarray(P,P+v);return P+=v,{id:b,type:"full",data:f}}const p=_[P++],g=[];for(let v=0;v<p;v++){const f=_[P++],c=_[P++],m=_[P++];let a;m>0&&(a=_.subarray(P,P+m),P+=m),g[v]={start:f,deleteCount:c,data:a}}return{id:b,type:"delta",deltas:g}}e.decodeSemanticTokensDto=R}),define(Ie[160],ke([1,0,3,6]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class S{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,E){return this._map.set(D,E),this.fire([D]),(0,n.toDisposable)(()=>{this._map.get(D)===E&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,E){this._factories.get(D)?.dispose();const k=new A(this,D,E);return this._factories.set(D,k),(0,n.toDisposable)(()=>{const R=this._factories.get(D);!R||R!==k||(this._factories.delete(D),R.dispose())})}async getOrCreate(D){const E=this.get(D);if(E)return E;const k=this._factories.get(D);return!k||k.isResolved?null:(await k.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const k=this._factories.get(D);return!!(!k||k.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=S;class A extends n.Disposable{constructor(D,E,k){super();this._registry=D,this._languageId=E,this._factory=k,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(Ie[63],ke([1,0,76,2,35,160]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(d,y,L){this._tokenBrand=void 0,this.offset=d,this.type=y,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class D{constructor(d,y){this._tokenizationResultBrand=void 0,this.tokens=d,this.endState=y}}e.TokenizationResult=D;class E{constructor(d,y){this._encodedTokenizationResultBrand=void 0,this.tokens=d,this.endState=y}}e.EncodedTokenizationResult=E;var k;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(k=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(l){const d=new Map;d.set(0,u.Codicon.symbolMethod),d.set(1,u.Codicon.symbolFunction),d.set(2,u.Codicon.symbolConstructor),d.set(3,u.Codicon.symbolField),d.set(4,u.Codicon.symbolVariable),d.set(5,u.Codicon.symbolClass),d.set(6,u.Codicon.symbolStruct),d.set(7,u.Codicon.symbolInterface),d.set(8,u.Codicon.symbolModule),d.set(9,u.Codicon.symbolProperty),d.set(10,u.Codicon.symbolEvent),d.set(11,u.Codicon.symbolOperator),d.set(12,u.Codicon.symbolUnit),d.set(13,u.Codicon.symbolValue),d.set(15,u.Codicon.symbolEnum),d.set(14,u.Codicon.symbolConstant),d.set(15,u.Codicon.symbolEnum),d.set(16,u.Codicon.symbolEnumMember),d.set(17,u.Codicon.symbolKeyword),d.set(27,u.Codicon.symbolSnippet),d.set(18,u.Codicon.symbolText),d.set(19,u.Codicon.symbolColor),d.set(20,u.Codicon.symbolFile),d.set(21,u.Codicon.symbolReference),d.set(22,u.Codicon.symbolCustomColor),d.set(23,u.Codicon.symbolFolder),d.set(24,u.Codicon.symbolTypeParameter),d.set(25,u.Codicon.account),d.set(26,u.Codicon.issues);function y(F){let T=d.get(F);return T||(console.info("No codicon found for CompletionItemKind "+F),T=u.Codicon.symbolProperty),T}l.toIcon=y;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function M(F,T){let U=L.get(F);return typeof U=="undefined"&&!T&&(U=9),U}l.fromString=M})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(l){l[l.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var P;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(P=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(l){return l&&n.URI.isUri(l.uri)&&S.Range.isIRange(l.range)&&(S.Range.isIRange(l.originSelectionRange)||S.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=v;var f;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var c;(function(l){l[l.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var m;(function(l){const d=new Map;d.set(0,u.Codicon.symbolFile),d.set(1,u.Codicon.symbolModule),d.set(2,u.Codicon.symbolNamespace),d.set(3,u.Codicon.symbolPackage),d.set(4,u.Codicon.symbolClass),d.set(5,u.Codicon.symbolMethod),d.set(6,u.Codicon.symbolProperty),d.set(7,u.Codicon.symbolField),d.set(8,u.Codicon.symbolConstructor),d.set(9,u.Codicon.symbolEnum),d.set(10,u.Codicon.symbolInterface),d.set(11,u.Codicon.symbolFunction),d.set(12,u.Codicon.symbolVariable),d.set(13,u.Codicon.symbolConstant),d.set(14,u.Codicon.symbolString),d.set(15,u.Codicon.symbolNumber),d.set(16,u.Codicon.symbolBoolean),d.set(17,u.Codicon.symbolArray),d.set(18,u.Codicon.symbolObject),d.set(19,u.Codicon.symbolKey),d.set(20,u.Codicon.symbolNull),d.set(21,u.Codicon.symbolEnumMember),d.set(22,u.Codicon.symbolStruct),d.set(23,u.Codicon.symbolEvent),d.set(24,u.Codicon.symbolOperator),d.set(25,u.Codicon.symbolTypeParameter);function y(L){let M=d.get(L);return M||(console.info("No codicon found for SymbolKind "+L),M=u.Codicon.symbolProperty),M}l.toIcon=y})(m=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(d){this.value=d}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var h;(function(l){function d(y){return!y||typeof y!="object"?!1:typeof y.id=="string"&&typeof y.title=="string"}l.is=d})(h=e.Command||(e.Command={}));var r;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(s=e.CommentThreadState||(e.CommentThreadState={}));var i;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(i=e.CommentMode||(e.CommentMode={}));var t;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(t=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var o;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(o=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ie[161],ke([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(Ie[114],ke([1,0,42,30,11,24,9,13,40,102,10,144,29,161]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function b(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(m,a){if(D.isWindows)try{const h={stdio:["pipe","pipe","ignore"]};a&&(h.cwd=a);const r=u.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],h);return new Promise(s=>{r.once("error",i=>{s({success:!1,error:i})}),r.once("exit",(i,t)=>{s(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(h){return Promise.resolve({success:!1,error:h,code:h.status?b(h.status):1})}else if(D.isLinux||D.isMacintosh)try{const h=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(r=>{u.execFile(h,[m.pid.toString()],{encoding:"utf8",shell:!0},(s,i,t)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(h){return Promise.resolve({success:!1,error:h})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function p(m=E.env){return m.comspec||"cmd.exe"}e.getWindowsShell=p;class g{constructor(a,h,r,s){if(h!==void 0&&r!==void 0&&s!==void 0)this.cmd=a,this.args=h,this.shell=r,this.options=s;else{const i=a;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(E.env).forEach(t=>{i[t]=E.env[t]}),Object.keys(this.options.env).forEach(t=>{i[t]=this.options.env[t]}),this.options.env=i}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const h=a.lastIndexOf(C.sep);return h!==-1&&(a=a.substring(h+1)),g.WellKnowCommands[a]?a:"other"}start(a){return D.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(E.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(h=>{let r,s;const i=new Promise((t,o)=>{r=t,s=o});if(h){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=u.exec(t,this.options,(o,l,d)=>{this.childProcess=null;const y=o;y&&y.killed?s({killed:this.terminateRequested,stdout:l.toString(),stderr:d.toString()}):this.handleExec(r,a,o,l,d)})}else{let t=null;const o=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,a,s);const d={terminated:this.terminateRequested};R.isNumber(l)&&(d.cmdCode=l),r(d)};if(this.shell&&D.isWindows){const l=A.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let d=!1,y=!1;const L=[];let M=this.ensureQuotes(this.cmd);L.push(M.value),d=M.quoted,this.args&&this.args.forEach(T=>{M=this.ensureQuotes(T),L.push(M.value),y=y&&M.quoted});const F=["/s","/c"];d?y?F.push('"'+L.join(" ")+'"'):L.length>1?F.push('"'+L[0]+'" '+L.slice(1).join(" ")):F.push('"'+L[0]+'"'):F.push(L.join(" ")),t=u.spawn(p(),F,l)}else this.cmd&&(t=u.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(R.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",l=>{this.childProcess=null,s({terminated:this.terminateRequested,error:l})}),t.pid&&(this.childProcess.on("close",o),this.handleSpawn(t,r,a,s,!0)))}return i})}handleClose(a,h,r,s){}ensureQuotes(a){return g.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,w(a,this.options.cwd).then(h=>(h.success&&(this.childProcess=null),h))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!D.isWindows)return a(!1);const h=u.spawn(p(),["/s","/c"]);h.on("error",r=>a(!0)),h.on("exit",r=>a(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class v extends g{constructor(a,h,r,s){super(a,h,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,h,r,s,i){[s,i].forEach((t,o)=>{const l=new I.LineDecoder;l.write(t).forEach(L=>{h({line:L,source:o===0?0:1})});const y=l.end();y&&h({line:y,source:o===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,h,r,s,i){const t=new I.LineDecoder,o=new I.LineDecoder;a.stdout.on("data",l=>{t.write(l).forEach(y=>r({line:y,source:0}))}),a.stderr.on("data",l=>{o.write(l).forEach(y=>r({line:y,source:1}))}),this.stdoutLineDecoder=t,this.stderrLineDecoder=o}handleClose(a,h,r,s){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const t=this.stderrLineDecoder?this.stderrLineDecoder.end():null;t&&r({line:t,source:1})}}e.LineProcess=v;function f(m){let a=[],h=!1;const r=function(s){if(h){a.push(s);return}(!m.send(s,t=>{if(t&&console.error(t),h=!1,a.length>0){const o=a.slice(0);a=[],o.forEach(l=>r(l))}})||D.isWindows)&&(h=!0)};return{send:r}}e.createQueuedSender=f;var c;(function(m){async function a(h,r,s){if(C.isAbsolute(h))return h;if(r===void 0&&(r=E.cwd()),C.dirname(h)!=="."||(s===void 0&&R.isString(E.env.PATH)&&(s=E.env.PATH.split(C.delimiter)),s===void 0||s.length===0))return C.join(r,h);async function t(o){if(await _.Promises.exists(o)){let l;try{l=await _.Promises.stat(o)}catch(d){d.message.startsWith("EACCES")&&(l=await _.Promises.lstat(o))}return l?!l.isDirectory():!1}return!1}for(const o of s){let l;if(C.isAbsolute(o)?l=C.join(o,h):l=C.join(r,o,h),await t(l))return l;let d=l+".com";if(await t(d)||(d=l+".exe",await t(d)))return d}return C.join(r,h)}m.findExecutable=a})(c=e.win32||(e.win32={}))}),define(Ie[162],ke([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(Ie[115],ke([1,0,162,13,99,16,24,146]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=k;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(re,ye,We,oe){this.id=re,this.name=ye,this.defaultValue=We,this.schema=oe}applyUpdate(re,ye){return P(re,ye)}compute(re,ye,We){return We}}class _{constructor(re,ye){this.newValue=re,this.didChange=ye}}e.ApplyUpdateResult=_;function P(Z,re){if(typeof Z!="object"||typeof re!="object"||!Z||!re)return new _(re,Z!==re);if(Array.isArray(Z)||Array.isArray(re)){const We=Array.isArray(Z)&&Array.isArray(re)&&A.equals(Z,re);return new _(re,We)}let ye=!1;for(const We in re)if(re.hasOwnProperty(We)){const oe=P(Z[We],re[We]);oe.didChange&&(Z[We]=oe.newValue,ye=!0)}return new _(Z,ye)}class b{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,ye){return P(re,ye)}validate(re){return this.defaultValue}}class w{constructor(re,ye,We,oe){this.id=re,this.name=ye,this.defaultValue=We,this.schema=oe}applyUpdate(re,ye){return P(re,ye)}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,ye,We){return We}}function p(Z,re){return typeof Z=="undefined"?re:Z==="false"?!1:Boolean(Z)}e.boolean=p;class g extends w{constructor(re,ye,We,oe=void 0){typeof oe!="undefined"&&(oe.type="boolean",oe.default=We);super(re,ye,We,oe)}validate(re){return p(re,this.defaultValue)}}function v(Z,re,ye,We){if(typeof Z=="undefined")return re;let oe=parseInt(Z,10);return isNaN(oe)?re:(oe=Math.max(ye,oe),oe=Math.min(We,oe),oe|0)}e.clampedInt=v;class f extends w{constructor(re,ye,We,oe,Re,Be=void 0){typeof Be!="undefined"&&(Be.type="integer",Be.default=We,Be.minimum=oe,Be.maximum=Re);super(re,ye,We,Be);this.minimum=oe,this.maximum=Re}static clampedInt(re,ye,We,oe){return v(re,ye,We,oe)}validate(re){return f.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class c extends w{constructor(re,ye,We,oe,Re){typeof Re!="undefined"&&(Re.type="number",Re.default=We);super(re,ye,We,Re);this.validationFn=oe}static clamp(re,ye,We){return re<ye?ye:re>We?We:re}static float(re,ye){if(typeof re=="number")return re;if(typeof re=="undefined")return ye;const We=parseFloat(re);return isNaN(We)?ye:We}validate(re){return this.validationFn(c.float(re,this.defaultValue))}}class m extends w{static string(re,ye){return typeof re!="string"?ye:re}constructor(re,ye,We,oe=void 0){typeof oe!="undefined"&&(oe.type="string",oe.default=We);super(re,ye,We,oe)}validate(re){return m.string(re,this.defaultValue)}}function a(Z,re,ye){return typeof Z!="string"||ye.indexOf(Z)===-1?re:Z}e.stringSet=a;class h extends w{constructor(re,ye,We,oe,Re=void 0){typeof Re!="undefined"&&(Re.type="string",Re.enum=oe,Re.default=We);super(re,ye,We,Re);this._allowedValues=oe}validate(re){return a(re,this.defaultValue,this._allowedValues)}}class r extends I{constructor(re,ye,We,oe,Re,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.enum=Re,qe.default=oe);super(re,ye,We,qe);this._allowedValues=Re,this._convert=Be}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function s(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,ye,We){return We===0?re.accessibilitySupport:We}}class t extends I{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:u.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{insertSpace:p(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function y(Z){switch(Z){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function L(Z){switch(Z){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class M extends b{constructor(){super(129)}compute(re,ye,We){const oe=["monaco-editor"];return ye.get(34)&&oe.push(ye.get(34)),re.extraEditorClassName&&oe.push(re.extraEditorClassName),ye.get(67)==="default"?oe.push("mouse-default"):ye.get(67)==="copy"&&oe.push("mouse-copy"),ye.get(101)&&oe.push("showUnused"),ye.get(127)&&oe.push("showDeprecated"),oe.join(" ")}}class F extends g{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(re,ye,We){return We&&re.emptySelectionClipboard}}class T extends I{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:u.localize(16,null),included:n.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:u.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{cursorMoveOnType:p(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":a(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":a(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(ye.loop,this.defaultValue.loop)}}}class U extends I{constructor(){super(46,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?U.OFF:re==="true"?U.ON:re:Boolean(re)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class N extends b{constructor(){super(45)}compute(re,ye,We){return re.fontInfo}}class H extends w{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(re){const ye=c.float(re,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(ye,6,100)}compute(re,ye,We){return re.fontInfo.fontSize}}class te extends I{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:te.MINIMUM_VALUE,maximum:te.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:te.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(re){return re==="normal"||re==="bold"?re:String(f.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,te.MINIMUM_VALUE,te.MAXIMUM_VALUE))}}te.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],te.MINIMUM_VALUE=1,te.MAXIMUM_VALUE=1e3;class B extends I{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...ye},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...ye},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:We,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:We,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:We,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:We,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:We,description:u.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{multiple:a(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??a(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??a(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??a(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??a(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??a(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends I{constructor(){const re={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:re.above,description:u.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{enabled:p(ye.enabled,this.defaultValue.enabled),delay:f.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:p(ye.sticky,this.defaultValue.sticky),above:p(ye.above,this.defaultValue.above)}}}var q;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class V extends b{constructor(){super(132)}compute(re,ye,We){return V.computeLayout(ye,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const ye=re.height/re.lineHeight,We=re.scrollBeyondLastLine?ye-1:0,oe=(re.viewLineCount+We)/(re.pixelRatio*re.height),Re=Math.floor(re.viewLineCount/oe);return{typicalViewportLineCount:ye,extraLinesBeyondLastLine:We,desiredRatio:oe,minimapLineCount:Re}}static _computeMinimapLayout(re,ye){const We=re.outerWidth,oe=re.outerHeight,Re=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Re*oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:oe};const Be=ye.stableMinimapLayoutInput,qe=Be&&re.outerHeight===Be.outerHeight&&re.lineHeight===Be.lineHeight&&re.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&re.pixelRatio===Be.pixelRatio&&re.scrollBeyondLastLine===Be.scrollBeyondLastLine&&re.minimap.enabled===Be.minimap.enabled&&re.minimap.side===Be.minimap.side&&re.minimap.size===Be.minimap.size&&re.minimap.showSlider===Be.minimap.showSlider&&re.minimap.renderCharacters===Be.minimap.renderCharacters&&re.minimap.maxColumn===Be.minimap.maxColumn&&re.minimap.scale===Be.minimap.scale&&re.verticalScrollbarWidth===Be.verticalScrollbarWidth&&re.isViewportWrapping===Be.isViewportWrapping,je=re.lineHeight,Ve=re.typicalHalfwidthCharacterWidth,nt=re.scrollBeyondLastLine,ot=re.minimap.renderCharacters;let st=Re>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const it=re.minimap.maxColumn,at=re.minimap.size,bt=re.minimap.side,Pt=re.verticalScrollbarWidth,St=re.viewLineCount,ft=re.remainingWidth,It=re.isViewportWrapping,Ft=ot?2:3;let At=Math.floor(Re*oe);const Xe=At/Re;let Rt=!1,Mt=!1,Ot=Ft*st,mt=st/Re,Dt=1;if(at==="fill"||at==="fit"){const{typicalViewportLineCount:Je,extraLinesBeyondLastLine:et,desiredRatio:Ze,minimapLineCount:gt}=V.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:nt,height:oe,lineHeight:je,pixelRatio:Re});if(St/gt>1)Rt=!0,Mt=!0,st=1,Ot=1,mt=st/Re;else{let yt=!1,vt=st+1;if(at==="fit"){const ht=Math.ceil((St+et)*Ot);It&&qe&&ft<=ye.stableFitRemainingWidth?(yt=!0,vt=ye.stableFitMaxMinimapScale):yt=ht>At}if(at==="fill"||yt){Rt=!0;const ht=st;Ot=Math.min(je*Re,Math.max(1,Math.floor(1/Ze))),It&&qe&&ft<=ye.stableFitRemainingWidth&&(vt=ye.stableFitMaxMinimapScale),st=Math.min(vt,Math.max(1,Math.floor(Ot/Ft))),st>ht&&(Dt=Math.min(2,st/ht)),mt=st/Re/Dt,At=Math.ceil(Math.max(Je,St+et)*Ot),It?(ye.stableMinimapLayoutInput=re,ye.stableFitRemainingWidth=ft,ye.stableFitMaxMinimapScale=st):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const Ae=Math.floor(it*mt),Oe=Math.min(Ae,Math.max(0,Math.floor((ft-Pt-2)*mt/(Ve+mt)))+e.MINIMAP_GUTTER_WIDTH);let Se=Math.floor(Re*Oe);const Y=Se/Re;Se=Math.floor(Se*Dt);const Fe=ot?1:2,xe=bt==="left"?0:We-Oe-Pt;return{renderMinimap:Fe,minimapLeft:xe,minimapWidth:Oe,minimapHeightIsEditorHeight:Rt,minimapIsSampling:Mt,minimapScale:st,minimapLineHeight:Ot,minimapCanvasInnerWidth:Se,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Y,minimapCanvasOuterHeight:Xe}}static computeLayout(re,ye){const We=ye.outerWidth|0,oe=ye.outerHeight|0,Re=ye.lineHeight|0,Be=ye.lineNumbersDigitCount|0,qe=ye.typicalHalfwidthCharacterWidth,je=ye.maxDigitWidth,Ve=ye.pixelRatio,nt=ye.viewLineCount,ot=re.get(124),st=ot==="inherit"?re.get(123):ot,it=st==="inherit"?re.get(119):st,at=re.get(122),bt=re.get(2),Pt=ye.isDominatedByLongLines,St=re.get(51),ft=re.get(61).renderType!==0,It=re.get(62),Ft=re.get(95),At=re.get(66),Xe=re.get(93),Rt=Xe.verticalScrollbarSize,Mt=Xe.verticalHasArrows,Ot=Xe.arrowSize,mt=Xe.horizontalScrollbarSize,Dt=re.get(59),Ae=re.get(38);let Oe;if(typeof Dt=="string"&&/^\d+(\.\d+)?ch$/.test(Dt)){const Et=parseFloat(Dt.substr(0,Dt.length-2));Oe=f.clampedInt(Et*qe,0,0,1e3)}else Oe=f.clampedInt(Dt,0,0,1e3);Ae&&(Oe+=16);let Se=0;if(ft){const Et=Math.max(Be,It);Se=Math.round(Et*je)}let Y=0;St&&(Y=Re);let Fe=0,xe=Fe+Y,Je=xe+Se,et=Je+Oe;const Ze=We-Y-Se-Oe;let gt=!1,pt=!1,yt=-1;bt!==2&&(st==="inherit"&&Pt?(gt=!0,pt=!0):it==="on"||it==="bounded"?pt=!0:it==="wordWrapColumn"&&(yt=at));const vt=V._computeMinimapLayout({outerWidth:We,outerHeight:oe,lineHeight:Re,typicalHalfwidthCharacterWidth:qe,pixelRatio:Ve,scrollBeyondLastLine:Ft,minimap:At,verticalScrollbarWidth:Rt,viewLineCount:nt,remainingWidth:Ze,isViewportWrapping:pt},ye.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Fe+=vt.minimapWidth,xe+=vt.minimapWidth,Je+=vt.minimapWidth,et+=vt.minimapWidth);const ht=Ze-vt.minimapWidth,Kt=Math.max(1,Math.floor((ht-Rt-2)/qe)),Xt=Mt?Ot:0;return pt&&(yt=Math.max(1,Kt),it==="bounded"&&(yt=Math.min(yt,at))),{width:We,height:oe,glyphMarginLeft:Fe,glyphMarginWidth:Y,lineNumbersLeft:xe,lineNumbersWidth:Se,decorationsLeft:Je,decorationsWidth:Oe,contentLeft:et,contentWidth:ht,minimap:vt,viewportColumn:Kt,isWordWrapMinified:gt,isViewportWrapping:pt,wrappingColumn:yt,verticalScrollbarWidth:Rt,horizontalScrollbarHeight:mt,overviewRuler:{top:Xt,width:Rt,height:oe-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=V;class j extends I{constructor(){const re={enabled:!0};super(58,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:u.localize(43,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:p(re.enabled,this.defaultValue.enabled)}}}class ie extends I{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:u.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(45,null),u.localize(46,null),u.localize(47,null),u.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:u.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:u.localize(50,null)},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:u.localize(51,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:a(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(ye.fontFamily,this.defaultValue.fontFamily),padding:p(ye.padding,this.defaultValue.padding)}}}class Q extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>c.clamp(re,0,150),{markdownDescription:u.localize(52,null)})}compute(re,ye,We){return re.fontInfo.lineHeight}}class ue extends I{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:u.localize(53,null)},"editor.minimap.autohide":{type:"boolean",default:re.autohide,description:u.localize(54,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(55,null),u.localize(56,null),u.localize(57,null)],default:re.size,description:u.localize(58,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:u.localize(59,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:u.localize(60,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(61,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:u.localize(62,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:u.localize(63,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{enabled:p(ye.enabled,this.defaultValue.enabled),autohide:p(ye.autohide,this.defaultValue.autohide),size:a(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ye.side,this.defaultValue.side,["right","left"]),showSlider:a(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(ye.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(ye.scale,1,1,3),maxColumn:f.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(Z){return Z==="ctrlCmd"?n.isMacintosh?"metaKey":"ctrlKey":"altKey"}class J extends I{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(64,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(65,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{top:f.clampedInt(ye.top,0,0,1e3),bottom:f.clampedInt(ye.bottom,0,0,1e3)}}}class ge extends I{constructor(){const re={enabled:!0,cycle:!1};super(77,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:u.localize(66,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:u.localize(67,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{enabled:p(ye.enabled,this.defaultValue.enabled),cycle:p(ye.cycle,this.defaultValue.cycle)}}}class Ee extends b{constructor(){super(130)}compute(re,ye,We){return re.pixelRatio}}class Pe extends I{constructor(){const re={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(68,null),u.localize(69,null),u.localize(70,null)]}];super(80,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:re.strings,description:u.localize(71,null)},comments:{anyOf:ye,default:re.comments,description:u.localize(72,null)},other:{anyOf:ye,default:re.other,description:u.localize(73,null)}},default:re,markdownDescription:u.localize(74,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean"){const Ve=re?"on":"off";return{comments:Ve,strings:Ve,other:Ve}}if(!re||typeof re!="object")return this.defaultValue;const{other:ye,comments:We,strings:oe}=re,Re=["on","inline","off"];let Be,qe,je;return typeof ye=="boolean"?Be=ye?"on":"off":Be=a(ye,this.defaultValue.other,Re),typeof We=="boolean"?qe=We?"on":"off":qe=a(We,this.defaultValue.comments,Re),typeof oe=="boolean"?je=oe?"on":"off":je=a(oe,this.defaultValue.strings,Re),{other:Be,comments:qe,strings:je}}}var me;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends I{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(75,null),u.localize(76,null),u.localize(77,null),u.localize(78,null)],default:"on",description:u.localize(79,null)})}validate(re){let ye=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(ye=4,We=re):re==="interval"?ye=3:re==="relative"?ye=2:re==="on"?ye=1:ye=0),{renderType:ye,renderFn:We}}}function le(Z){const re=Z.get(88);return re==="editable"?Z.get(82):re!=="on"}e.filterValidationDecorations=le;class pe extends I{constructor(){const re=[],ye={type:"number",description:u.localize(80,null)};super(92,"rulers",re,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:u.localize(81,null),format:"color-hex"}}}]},default:re,description:u.localize(82,null)})}validate(re){if(Array.isArray(re)){const ye=[];for(const We of re)if(typeof We=="number")ye.push({column:f.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const oe=We;ye.push({column:f.clampedInt(oe.column,0,0,1e4),color:oe.color})}return ye.sort((We,oe)=>We.column-oe.column),ye}return this.defaultValue}}function be(Z,re){if(typeof Z!="string")return re;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends I{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(83,null),u.localize(84,null),u.localize(85,null)],default:"auto",description:u.localize(86,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:"auto",description:u.localize(90,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:u.localize(91,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:u.localize(92,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:u.localize(93,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re,We=f.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),oe=f.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:be(ye.vertical,this.defaultValue.vertical),horizontal:be(ye.horizontal,this.defaultValue.horizontal),useShadows:p(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:f.clampedInt(ye.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:oe,verticalSliderSize:f.clampedInt(ye.verticalSliderSize,oe,0,1e3),scrollByPage:p(ye.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class he extends I{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:u.localize(94,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:u.localize(95,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:u.localize(98,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:u.localize(99,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:u.localize(100,null)}})}applyUpdate(re,ye){let We=!1;ye.allowedCharacters&&re&&(C.equals(re.allowedCharacters,ye.allowedCharacters)||(re={...re,allowedCharacters:ye.allowedCharacters},We=!0)),ye.allowedLocales&&re&&(C.equals(re.allowedLocales,ye.allowedLocales)||(re={...re,allowedLocales:ye.allowedLocales},We=!0));const oe=super.applyUpdate(re,ye);return We?new _(oe.newValue,!0):oe}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{nonBasicASCII:$(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:p(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:p(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(re.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(re,ye){if(typeof re!="object"||!re)return ye;const We={};for(const[oe,Re]of Object.entries(re))Re===!0&&(We[oe]=!0);return We}}class ee extends I{constructor(){const re={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:u.localize(101,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{enabled:p(ye.enabled,this.defaultValue.enabled),mode:a(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ne extends I{constructor(){const re={enabled:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:D.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:u.localize(102,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:u.localize(103,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{enabled:p(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:p(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class O extends I{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(104,null),u.localize(105,null),u.localize(106,null)],default:re.bracketPairs,description:u.localize(107,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(108,null),u.localize(109,null),u.localize(110,null)],default:re.bracketPairsHorizontal,description:u.localize(111,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:u.localize(112,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:u.localize(113,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(114,null),u.localize(115,null),u.localize(116,null)],default:re.highlightActiveIndentation,description:u.localize(117,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{bracketPairs:$(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:p(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:p(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:$(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $(Z,re,ye){const We=ye.indexOf(Z);return We===-1?re:ye[We]}class G extends I{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(118,null),u.localize(119,null)],default:re.insertMode,description:u.localize(120,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:u.localize(121,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:u.localize(122,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:u.localize(123,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:u.localize(124,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:u.localize(125,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:u.localize(126,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:u.localize(127,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:u.localize(128,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(129,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(130,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ye=re;return{insertMode:a(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(ye.showIcons,this.defaultValue.showIcons),showStatusBar:p(ye.showStatusBar,this.defaultValue.showStatusBar),preview:p(ye.preview,this.defaultValue.preview),previewMode:a(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:p(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(ye.showMethods,this.defaultValue.showMethods),showFunctions:p(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:p(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:p(ye.showDeprecated,this.defaultValue.showDeprecated),showFields:p(ye.showFields,this.defaultValue.showFields),showVariables:p(ye.showVariables,this.defaultValue.showVariables),showClasses:p(ye.showClasses,this.defaultValue.showClasses),showStructs:p(ye.showStructs,this.defaultValue.showStructs),showInterfaces:p(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:p(ye.showModules,this.defaultValue.showModules),showProperties:p(ye.showProperties,this.defaultValue.showProperties),showEvents:p(ye.showEvents,this.defaultValue.showEvents),showOperators:p(ye.showOperators,this.defaultValue.showOperators),showUnits:p(ye.showUnits,this.defaultValue.showUnits),showValues:p(ye.showValues,this.defaultValue.showValues),showConstants:p(ye.showConstants,this.defaultValue.showConstants),showEnums:p(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:p(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(ye.showKeywords,this.defaultValue.showKeywords),showWords:p(ye.showWords,this.defaultValue.showWords),showColors:p(ye.showColors,this.defaultValue.showColors),showFiles:p(ye.showFiles,this.defaultValue.showFiles),showReferences:p(ye.showReferences,this.defaultValue.showReferences),showFolders:p(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:p(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(ye.showSnippets,this.defaultValue.showSnippets),showUsers:p(ye.showUsers,this.defaultValue.showUsers),showIssues:p(ye.showIssues,this.defaultValue.showIssues)}}}class K extends I{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(160,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends b{constructor(){super(131)}compute(re,ye,We){return ye.get(82)?!0:re.tabFocusMode}}var we;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(we=e.WrappingIndent||(e.WrappingIndent={}));function se(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class De extends b{constructor(){super(133)}compute(re,ye,We){const oe=ye.get(132);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:oe.isWordWrapMinified,isViewportWrapping:oe.isViewportWrapping,wrappingColumn:oe.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:n.isMacintosh?ze:n.isLinux?Ke:Ce,fontWeight:"normal",fontSize:n.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var Ye;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.guides=13]="guides",Z[Z.codeLens=14]="codeLens",Z[Z.codeLensFontFamily=15]="codeLensFontFamily",Z[Z.codeLensFontSize=16]="codeLensFontSize",Z[Z.colorDecorators=17]="colorDecorators",Z[Z.columnSelection=18]="columnSelection",Z[Z.comments=19]="comments",Z[Z.contextmenu=20]="contextmenu",Z[Z.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=22]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=24]="cursorStyle",Z[Z.cursorSurroundingLines=25]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=27]="cursorWidth",Z[Z.disableLayerHinting=28]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",Z[Z.domReadOnly=30]="domReadOnly",Z[Z.dragAndDrop=31]="dragAndDrop",Z[Z.enableDropIntoEditor=32]="enableDropIntoEditor",Z[Z.emptySelectionClipboard=33]="emptySelectionClipboard",Z[Z.extraEditorClassName=34]="extraEditorClassName",Z[Z.fastScrollSensitivity=35]="fastScrollSensitivity",Z[Z.find=36]="find",Z[Z.fixedOverflowWidgets=37]="fixedOverflowWidgets",Z[Z.folding=38]="folding",Z[Z.foldingStrategy=39]="foldingStrategy",Z[Z.foldingHighlight=40]="foldingHighlight",Z[Z.foldingImportsByDefault=41]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=42]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=44]="fontFamily",Z[Z.fontInfo=45]="fontInfo",Z[Z.fontLigatures=46]="fontLigatures",Z[Z.fontSize=47]="fontSize",Z[Z.fontWeight=48]="fontWeight",Z[Z.formatOnPaste=49]="formatOnPaste",Z[Z.formatOnType=50]="formatOnType",Z[Z.glyphMargin=51]="glyphMargin",Z[Z.gotoLocation=52]="gotoLocation",Z[Z.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",Z[Z.hover=54]="hover",Z[Z.inDiffEditor=55]="inDiffEditor",Z[Z.inlineSuggest=56]="inlineSuggest",Z[Z.letterSpacing=57]="letterSpacing",Z[Z.lightbulb=58]="lightbulb",Z[Z.lineDecorationsWidth=59]="lineDecorationsWidth",Z[Z.lineHeight=60]="lineHeight",Z[Z.lineNumbers=61]="lineNumbers",Z[Z.lineNumbersMinChars=62]="lineNumbersMinChars",Z[Z.linkedEditing=63]="linkedEditing",Z[Z.links=64]="links",Z[Z.matchBrackets=65]="matchBrackets",Z[Z.minimap=66]="minimap",Z[Z.mouseStyle=67]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=69]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=71]="multiCursorModifier",Z[Z.multiCursorPaste=72]="multiCursorPaste",Z[Z.occurrencesHighlight=73]="occurrencesHighlight",Z[Z.overviewRulerBorder=74]="overviewRulerBorder",Z[Z.overviewRulerLanes=75]="overviewRulerLanes",Z[Z.padding=76]="padding",Z[Z.parameterHints=77]="parameterHints",Z[Z.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=80]="quickSuggestions",Z[Z.quickSuggestionsDelay=81]="quickSuggestionsDelay",Z[Z.readOnly=82]="readOnly",Z[Z.renameOnType=83]="renameOnType",Z[Z.renderControlCharacters=84]="renderControlCharacters",Z[Z.renderFinalNewline=85]="renderFinalNewline",Z[Z.renderLineHighlight=86]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=88]="renderValidationDecorations",Z[Z.renderWhitespace=89]="renderWhitespace",Z[Z.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",Z[Z.roundedSelection=91]="roundedSelection",Z[Z.rulers=92]="rulers",Z[Z.scrollbar=93]="scrollbar",Z[Z.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=95]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=96]="scrollPredominantAxis",Z[Z.selectionClipboard=97]="selectionClipboard",Z[Z.selectionHighlight=98]="selectionHighlight",Z[Z.selectOnLineNumbers=99]="selectOnLineNumbers",Z[Z.showFoldingControls=100]="showFoldingControls",Z[Z.showUnused=101]="showUnused",Z[Z.snippetSuggestions=102]="snippetSuggestions",Z[Z.smartSelect=103]="smartSelect",Z[Z.smoothScrolling=104]="smoothScrolling",Z[Z.stickyTabStops=105]="stickyTabStops",Z[Z.stopRenderingLineAfter=106]="stopRenderingLineAfter",Z[Z.suggest=107]="suggest",Z[Z.suggestFontSize=108]="suggestFontSize",Z[Z.suggestLineHeight=109]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",Z[Z.suggestSelection=111]="suggestSelection",Z[Z.tabCompletion=112]="tabCompletion",Z[Z.tabIndex=113]="tabIndex",Z[Z.unicodeHighlighting=114]="unicodeHighlighting",Z[Z.unusualLineTerminators=115]="unusualLineTerminators",Z[Z.useShadowDOM=116]="useShadowDOM",Z[Z.useTabStops=117]="useTabStops",Z[Z.wordSeparators=118]="wordSeparators",Z[Z.wordWrap=119]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=122]="wordWrapColumn",Z[Z.wordWrapOverride1=123]="wordWrapOverride1",Z[Z.wordWrapOverride2=124]="wordWrapOverride2",Z[Z.wrappingIndent=125]="wrappingIndent",Z[Z.wrappingStrategy=126]="wrappingStrategy",Z[Z.showDeprecated=127]="showDeprecated",Z[Z.inlayHints=128]="inlayHints",Z[Z.editorClassName=129]="editorClassName",Z[Z.pixelRatio=130]="pixelRatio",Z[Z.tabFocusMode=131]="tabFocusMode",Z[Z.layoutInfo=132]="layoutInfo",Z[Z.wrappingInfo=133]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(161,null)})),acceptSuggestionOnEnter:Ne(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(162,null),""],markdownDescription:u.localize(163,null)})),accessibilitySupport:Ne(new i),accessibilityPageSize:Ne(new f(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(164,null)})),ariaLabel:Ne(new m(4,"ariaLabel",u.localize(165,null))),autoClosingBrackets:Ne(new h(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(166,null),u.localize(167,null),""],description:u.localize(168,null)})),autoClosingDelete:Ne(new h(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(169,null),""],description:u.localize(170,null)})),autoClosingOvertype:Ne(new h(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(171,null),""],description:u.localize(172,null)})),autoClosingQuotes:Ne(new h(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(173,null),u.localize(174,null),""],description:u.localize(175,null)})),autoIndent:Ne(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[u.localize(176,null),u.localize(177,null),u.localize(178,null),u.localize(179,null),u.localize(180,null)],description:u.localize(181,null)})),automaticLayout:Ne(new g(10,"automaticLayout",!1)),autoSurround:Ne(new h(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(182,null),u.localize(183,null),u.localize(184,null),""],description:u.localize(185,null)})),bracketPairColorization:Ne(new ne),bracketPairGuides:Ne(new O),stickyTabStops:Ne(new g(105,"stickyTabStops",!1,{description:u.localize(186,null)})),codeLens:Ne(new g(14,"codeLens",!0,{description:u.localize(187,null)})),codeLensFontFamily:Ne(new m(15,"codeLensFontFamily","",{description:u.localize(188,null)})),codeLensFontSize:Ne(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(189,null)})),colorDecorators:Ne(new g(17,"colorDecorators",!0,{description:u.localize(190,null)})),columnSelection:Ne(new g(18,"columnSelection",!1,{description:u.localize(191,null)})),comments:Ne(new t),contextmenu:Ne(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new g(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(192,null)})),cursorBlinking:Ne(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(193,null)})),cursorSmoothCaretAnimation:Ne(new g(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(194,null)})),cursorStyle:Ne(new r(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:u.localize(195,null)})),cursorSurroundingLines:Ne(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(196,null)})),cursorSurroundingLinesStyle:Ne(new h(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(197,null),u.localize(198,null)],description:u.localize(199,null)})),cursorWidth:Ne(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(200,null)})),disableLayerHinting:Ne(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new g(30,"domReadOnly",!1)),dragAndDrop:Ne(new g(31,"dragAndDrop",!0,{description:u.localize(201,null)})),emptySelectionClipboard:Ne(new F),enableDropIntoEditor:Ne(new g(32,"enableDropIntoEditor",!0)),extraEditorClassName:Ne(new m(34,"extraEditorClassName","")),fastScrollSensitivity:Ne(new c(35,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:u.localize(202,null)})),find:Ne(new T),fixedOverflowWidgets:Ne(new g(37,"fixedOverflowWidgets",!1)),folding:Ne(new g(38,"folding",!0,{description:u.localize(203,null)})),foldingStrategy:Ne(new h(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(204,null),u.localize(205,null)],description:u.localize(206,null)})),foldingHighlight:Ne(new g(40,"foldingHighlight",!0,{description:u.localize(207,null)})),foldingImportsByDefault:Ne(new g(41,"foldingImportsByDefault",!1,{description:u.localize(208,null)})),foldingMaximumRegions:Ne(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(209,null)})),unfoldOnClickAfterEndOfLine:Ne(new g(43,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(210,null)})),fontFamily:Ne(new m(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(211,null)})),fontInfo:Ne(new N),fontLigatures2:Ne(new U),fontSize:Ne(new H),fontWeight:Ne(new te),formatOnPaste:Ne(new g(49,"formatOnPaste",!1,{description:u.localize(212,null)})),formatOnType:Ne(new g(50,"formatOnType",!1,{description:u.localize(213,null)})),glyphMargin:Ne(new g(51,"glyphMargin",!0,{description:u.localize(214,null)})),gotoLocation:Ne(new B),hideCursorInOverviewRuler:Ne(new g(53,"hideCursorInOverviewRuler",!1,{description:u.localize(215,null)})),hover:Ne(new z),inDiffEditor:Ne(new g(55,"inDiffEditor",!1)),letterSpacing:Ne(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>c.clamp(Z,-5,20),{description:u.localize(216,null)})),lightbulb:Ne(new j),lineDecorationsWidth:Ne(new w(59,"lineDecorationsWidth",10)),lineHeight:Ne(new Q),lineNumbers:Ne(new Te),lineNumbersMinChars:Ne(new f(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new g(63,"linkedEditing",!1,{description:u.localize(217,null)})),links:Ne(new g(64,"links",!0,{description:u.localize(218,null)})),matchBrackets:Ne(new h(65,"matchBrackets","always",["always","near","never"],{description:u.localize(219,null)})),minimap:Ne(new ue),mouseStyle:Ne(new h(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new c(68,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:u.localize(220,null)})),mouseWheelZoom:Ne(new g(69,"mouseWheelZoom",!1,{markdownDescription:u.localize(221,null)})),multiCursorMergeOverlapping:Ne(new g(70,"multiCursorMergeOverlapping",!0,{description:u.localize(222,null)})),multiCursorModifier:Ne(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[u.localize(223,null),u.localize(224,null)],markdownDescription:u.localize(225,null)})),multiCursorPaste:Ne(new h(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(226,null),u.localize(227,null)],markdownDescription:u.localize(228,null)})),occurrencesHighlight:Ne(new g(73,"occurrencesHighlight",!0,{description:u.localize(229,null)})),overviewRulerBorder:Ne(new g(74,"overviewRulerBorder",!0,{description:u.localize(230,null)})),overviewRulerLanes:Ne(new f(75,"overviewRulerLanes",3,0,3)),padding:Ne(new J),parameterHints:Ne(new ge),peekWidgetDefaultFocus:Ne(new h(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(231,null),u.localize(232,null)],description:u.localize(233,null)})),definitionLinkOpensInPeek:Ne(new g(79,"definitionLinkOpensInPeek",!1,{description:u.localize(234,null)})),quickSuggestions:Ne(new Pe),quickSuggestionsDelay:Ne(new f(81,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(235,null)})),readOnly:Ne(new g(82,"readOnly",!1)),renameOnType:Ne(new g(83,"renameOnType",!1,{description:u.localize(236,null),markdownDeprecationMessage:u.localize(237,null)})),renderControlCharacters:Ne(new g(84,"renderControlCharacters",!0,{description:u.localize(238,null),restricted:!0})),renderFinalNewline:Ne(new g(85,"renderFinalNewline",!0,{description:u.localize(239,null)})),renderLineHighlight:Ne(new h(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(240,null)],description:u.localize(241,null)})),renderLineHighlightOnlyWhenFocus:Ne(new g(87,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(242,null)})),renderValidationDecorations:Ne(new h(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new h(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(243,null),u.localize(244,null),u.localize(245,null),""],description:u.localize(246,null)})),revealHorizontalRightPadding:Ne(new f(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ne(new g(91,"roundedSelection",!0,{description:u.localize(247,null)})),rulers:Ne(new pe),scrollbar:Ne(new ae),scrollBeyondLastColumn:Ne(new f(94,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(248,null)})),scrollBeyondLastLine:Ne(new g(95,"scrollBeyondLastLine",!0,{description:u.localize(249,null)})),scrollPredominantAxis:Ne(new g(96,"scrollPredominantAxis",!0,{description:u.localize(250,null)})),selectionClipboard:Ne(new g(97,"selectionClipboard",!0,{description:u.localize(251,null),included:n.isLinux})),selectionHighlight:Ne(new g(98,"selectionHighlight",!0,{description:u.localize(252,null)})),selectOnLineNumbers:Ne(new g(99,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new h(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(253,null),u.localize(254,null)],description:u.localize(255,null)})),showUnused:Ne(new g(101,"showUnused",!0,{description:u.localize(256,null)})),showDeprecated:Ne(new g(127,"showDeprecated",!0,{description:u.localize(257,null)})),inlayHints:Ne(new ie),snippetSuggestions:Ne(new h(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(258,null),u.localize(259,null),u.localize(260,null),u.localize(261,null)],description:u.localize(262,null)})),smartSelect:Ne(new K),smoothScrolling:Ne(new g(104,"smoothScrolling",!1,{description:u.localize(263,null)})),stopRenderingLineAfter:Ne(new f(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new G),inlineSuggest:Ne(new ee),suggestFontSize:Ne(new f(108,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(264,null)})),suggestLineHeight:Ne(new f(109,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(265,null)})),suggestOnTriggerCharacters:Ne(new g(110,"suggestOnTriggerCharacters",!0,{description:u.localize(266,null)})),suggestSelection:Ne(new h(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(267,null),u.localize(268,null),u.localize(269,null)],description:u.localize(270,null)})),tabCompletion:Ne(new h(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(271,null),u.localize(272,null),u.localize(273,null)],description:u.localize(274,null)})),tabIndex:Ne(new f(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new he),unusualLineTerminators:Ne(new h(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(275,null),u.localize(276,null),u.localize(277,null)],description:u.localize(278,null)})),useShadowDOM:Ne(new g(116,"useShadowDOM",!0)),useTabStops:Ne(new g(117,"useTabStops",!0,{description:u.localize(279,null)})),wordSeparators:Ne(new m(118,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:u.localize(280,null)})),wordWrap:Ne(new h(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(281,null),u.localize(282,null),u.localize(283,null),u.localize(284,null)],description:u.localize(285,null)})),wordWrapBreakAfterCharacters:Ne(new m(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new m(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new f(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(286,null)})),wordWrapOverride1:Ne(new h(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new h(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new r(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],se,{enumDescriptions:[u.localize(287,null),u.localize(288,null),u.localize(289,null),u.localize(290,null)],description:u.localize(291,null)})),wrappingStrategy:Ne(new h(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(292,null),u.localize(293,null)],description:u.localize(294,null)})),editorClassName:Ne(new M),pixelRatio:Ne(new Ee),tabFocusMode:Ne(new de),layoutInfo:Ne(new V),wrappingInfo:Ne(new De)}}),define(Ie[163],ke([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[164],ke([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[165],ke([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[166],ke([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ie[167],ke([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(Ie[168],ke([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(Ie[169],ke([19,20]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(Ie[170],ke([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[171],ke([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[172],ke([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[173],ke([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[174],ke([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[175],ke([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[176],ke([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[177],ke([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ie[178],ke([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ie[179],ke([19,20]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(Ie[180],ke([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[181],ke([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[182],ke([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ie[183],ke([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[184],ke([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[185],ke([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[186],ke([19,20]),function(X,e){return X.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[187],ke([19,20]),function(X,e){return X.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[188],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var u;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var n;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(n=e.EditorResolution||(e.EditorResolution={}));var S;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(S=e.EditorOpenSource||(e.EditorOpenSource={}));var A;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(D){D.PROGRAMMATIC="api",D.NAVIGATION="code.navigation",D.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Ie[189],ke([1,0,22,41,165,303]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function E(g){return g=g.trim(),g==="*"||C.test(g)}e.isValidVersionStr=E;function k(g){if(!E(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=g.match(C);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function R(g){if(!g)return null;const v=g.majorBase,f=g.majorMustEqual,c=g.minorBase;let m=g.minorMustEqual;const a=g.patchBase;let h=g.patchMustEqual;g.hasCaret&&(v===0||(m=!1),h=!1);let r=0;if(g.preRelease){const s=D.exec(g.preRelease);if(s){const[,i,t,o]=s;r=Date.UTC(Number(i),Number(t)-1,Number(o))}}return{majorBase:v,majorMustEqual:f,minorBase:c,minorMustEqual:m,patchBase:a,patchMustEqual:h,isMinimum:g.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function I(g,v,f){let c;typeof g=="string"?c=R(k(g)):c=g;let m;v instanceof Date?m=v.getTime():typeof v=="string"&&(m=new Date(v).getTime());let a;if(typeof f=="string"?a=R(k(f)):a=f,!c||!a)return!1;const h=c.majorBase,r=c.minorBase,s=c.patchBase;let i=a.majorBase,t=a.minorBase,o=a.patchBase;const l=a.notBefore;let d=a.majorMustEqual,y=a.minorMustEqual,L=a.patchMustEqual;return a.isMinimum?h>i?!0:h<i?!1:r>t?!0:r<t||m&&m<l?!1:s>=o:(h===1&&i===0&&(!d||!y||!L)&&(i=1,t=0,o=0,d=!0,y=!1,L=!1),h<i?!1:h>i?!d:r<t?!1:r>t?!y:s<o?!1:s>o?!L:!(m&&m<l))}e.isValidVersion=I;function _(g,v,f,c,m){const a=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return a.push([n.default.Error,S.localize(0,null)]),a;if(typeof c.name!="string")return a.push([n.default.Error,S.localize(1,null,"name")]),a;if(typeof c.version!="string")return a.push([n.default.Error,S.localize(2,null,"version")]),a;if(!c.engines)return a.push([n.default.Error,S.localize(3,null,"engines")]),a;if(typeof c.engines.vscode!="string")return a.push([n.default.Error,S.localize(4,null,"engines.vscode")]),a;if(typeof c.extensionDependencies!="undefined"&&!p(c.extensionDependencies))return a.push([n.default.Error,S.localize(5,null,"extensionDependencies")]),a;if(typeof c.activationEvents!="undefined"){if(!p(c.activationEvents))return a.push([n.default.Error,S.localize(6,null,"activationEvents")]),a;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return a.push([n.default.Error,S.localize(7,null,"activationEvents","main")]),a}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&a.push([n.default.Warning,S.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return a.push([n.default.Error,S.localize(9,null,"main")]),a;{const s=(0,u.joinPath)(f,c.main);(0,u.isEqualOrParent)(s,f)||a.push([n.default.Warning,S.localize(10,null,s.path,f.path)])}if(typeof c.activationEvents=="undefined")return a.push([n.default.Error,S.localize(11,null,"activationEvents","main")]),a}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return a.push([n.default.Error,S.localize(12,null,"browser")]),a;{const s=(0,u.joinPath)(f,c.browser);(0,u.isEqualOrParent)(s,f)||a.push([n.default.Warning,S.localize(13,null,s.path,f.path)])}if(typeof c.activationEvents=="undefined")return a.push([n.default.Error,S.localize(14,null,"activationEvents","browser")]),a}if(!A.valid(c.version))return a.push([n.default.Error,S.localize(15,null)]),a;const h=[];if(!P(g,v,c,m,h))for(const s of h)a.push([n.default.Error,s]);return a}e.validateExtensionManifest=_;function P(g,v,f,c,m){return c||typeof f.main=="undefined"&&typeof f.browser=="undefined"?!0:w(g,v,f.engines.vscode,m)}e.isValidExtensionVersion=P;function b(g,v,f){return g==="*"||w(v,f,g)}e.isEngineValid=b;function w(g,v,f,c=[]){const m=R(k(f));if(!m)return c.push(S.localize(16,null,f)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return c.push(S.localize(17,null,f)),!1}else if(!m.majorMustEqual)return c.push(S.localize(18,null,f)),!1;return I(g,v,m)?!0:(c.push(S.localize(19,null,g,f)),!1)}function p(g){if(!Array.isArray(g))return!1;for(let v=0,f=g.length;v<f;v++)if(typeof g[v]!="string")return!1;return!0}}),define(Ie[116],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(S,A=[],C=!1){this.ctor=S,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=u}),define(Ie[82],ke([1,0,116]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function S(C,D,E){D instanceof u.SyncDescriptor||(D=new u.SyncDescriptor(D,[],E)),n.push([C,D])}e.registerSingleton=S;function A(){return n}e.getSingletonServiceDescriptors=A}),define(Ie[190],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=u;class n{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const C of this._nodes.values())C.outgoing.size===0&&A.push(C);return A}insertEdge(A,C){const D=this.lookupOrInsertNode(A),E=this.lookupOrInsertNode(C);D.outgoing.set(this._hashFn(C),E),E.incoming.set(this._hashFn(A),D)}removeNode(A){const C=this._hashFn(A);this._nodes.delete(C);for(const D of this._nodes.values())D.outgoing.delete(C),D.incoming.delete(C)}lookupOrInsertNode(A){const C=this._hashFn(A);let D=this._nodes.get(C);return D||(D=new u(A),this._nodes.set(C,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[C,D]of this._nodes)A.push(`${C}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(const[A,C]of this._nodes){const D=new Set([A]),E=this._findCycle(C,D);if(E)return E}}_findCycle(A,C){for(const[D,E]of A.outgoing){if(C.has(D))return[...C,D].join(" -> ");C.add(D);const k=this._findCycle(E,C);if(k)return k;C.delete(D)}}}e.Graph=n}),define(Ie[4],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(E){return E[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(u=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function n(C,D,E){D[u.DI_TARGET]===D?D[u.DI_DEPENDENCIES].push({id:C,index:E}):(D[u.DI_DEPENDENCIES]=[{id:C,index:E}],D[u.DI_TARGET]=D)}function S(C){if(u.serviceIds.has(C))return u.serviceIds.get(C);const D=function(E,k,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(D,E,R)};return D.toString=()=>C,u.serviceIds.set(C,D),D}e.createDecorator=S;function A(C){return C}e.refineServiceDecorator=A}),define(Ie[83],ke([1,0,10,2,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationOverrides=A;function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||u.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=C;var D;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function k(g,v){const f=Object.create(null);for(const c in g)R(f,c,g[c],v);return f}e.toValuesTree=k;function R(g,v,f,c){const m=v.split("."),a=m.pop();let h=g;for(let r=0;r<m.length;r++){const s=m[r];let i=h[s];switch(typeof i){case"undefined":i=h[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}h=i}if(typeof h=="object"&&h!==null)try{h[a]=f}catch{c(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(h)}`)}else c(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=R;function I(g,v){const f=v.split(".");_(g,f)}e.removeFromValueTree=I;function _(g,v){const f=v.shift();if(v.length===0){delete g[f];return}if(Object.keys(g).indexOf(f)!==-1){const c=g[f];typeof c=="object"&&!Array.isArray(c)&&(_(c,v),Object.keys(c).length===0&&delete g[f])}}function P(g,v,f){function c(h,r){let s=h;for(const i of r){if(typeof s!="object"||s===null)return;s=s[i]}return s}const m=v.split("."),a=c(g,m);return typeof a=="undefined"?f:a}e.getConfigurationValue=P;function b(g,v,f){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in g?u.isObject(g[c])&&u.isObject(v[c])?b(g[c],v[c],f):f&&(g[c]=v[c]):g[c]=v[c])})}e.merge=b;function w(g,v,f){const c=g.inspect(v),m=g.inspect(f);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:c.defaultValue}e.getMigratedSettingValue=w;function p(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(Ie[51],ke([1,0,13,8,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",u.isMacintosh),A.set("isLinux",u.isLinux),A.set("isWindows",u.isWindows),A.set("isWeb",u.isWeb),A.set("isMacNative",u.isMacintosh&&!u.isWeb),A.set("isEdge",u.isEdge),A.set("isFirefox",u.isFirefox),A.set("isChrome",u.isChrome),A.set("isSafari",u.isSafari);const C=Object.prototype.hasOwnProperty;var D;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return I.INSTANCE}static true(){return _.INSTANCE}static has(T){return P.create(T)}static equals(T,U){return b.create(T,U)}static notEquals(T,U){return g.create(T,U)}static regex(T,U){return r.create(T,U)}static in(T,U){return w.create(T,U)}static not(T){return v.create(T)}static and(...T){return t.create(T,null)}static or(...T){return o.create(T,null,!0)}static greater(T,U){return c.create(T,U)}static greaterEquals(T,U){return m.create(T,U)}static smaller(T,U){return a.create(T,U)}static smallerEquals(T,U){return h.create(T,U)}static deserialize(T,U=!1){if(!!T)return this._deserializeOrExpression(T,U)}static _deserializeOrExpression(T,U){const N=T.split("||");return o.create(N.map(H=>this._deserializeAndExpression(H,U)),null,!0)}static _deserializeAndExpression(T,U){const N=T.split("&&");return t.create(N.map(H=>this._deserializeOne(H,U)),null)}static _deserializeOne(T,U){if(T=T.trim(),T.indexOf("!=")>=0){const N=T.split("!=");return g.create(N[0].trim(),this._deserializeValue(N[1],U))}if(T.indexOf("==")>=0){const N=T.split("==");return b.create(N[0].trim(),this._deserializeValue(N[1],U))}if(T.indexOf("=~")>=0){const N=T.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],U))}if(T.indexOf(" in ")>=0){const N=T.split(" in ");return w.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const N=T.split(">=");return m.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const N=T.split(">");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const N=T.split("<=");return h.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const N=T.split("<");return a.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(T)?v.create(T.substr(1).trim()):P.create(T)}static _deserializeValue(T,U){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const N=/^'([^']*)'$/.exec(T);return N?N[1].trim():T}static _deserializeRegexValue(T,U){if((0,n.isFalsyOrWhitespace)(T)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const N=T.indexOf("/"),H=T.lastIndexOf("/");if(N===H||N<0){if(U)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}const te=T.slice(N+1,H),B=T[H+1]==="i"?"i":"";try{return new RegExp(te,B)}catch(z){if(U)throw new Error(`bad regexp-value '${T}', parse error: ${z}`);return console.warn(`bad regexp-value '${T}', parse error: ${z}`),null}}}e.ContextKeyExpr=E;function k(F,T){const U=F?F.substituteConstants():void 0,N=T?T.substituteConstants():void 0;return!U&&!N?!0:!U||!N?!1:U.equals(N)}e.expressionsAreEqualWithConstantSubstitution=k;function R(F,T){return F.cmp(T)}class I{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class _{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class P{constructor(T,U){this.key=T,this.negated=U,this.type=2}static create(T,U=null){const N=A.get(T);return typeof N=="boolean"?N?_.INSTANCE:I.INSTANCE:new P(T,U)}cmp(T){return T.type!==this.type?this.type-T.type:d(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=A.get(this.key);return typeof T=="boolean"?T?_.INSTANCE:I.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=P;class b{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=4}static create(T,U,N=null){if(typeof U=="boolean")return U?P.create(T,N):v.create(T,N);const H=A.get(T);return typeof H=="boolean"?U===(H?"true":"false")?_.INSTANCE:I.INSTANCE:new b(T,U,N)}cmp(T){return T.type!==this.type?this.type-T.type:y(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=A.get(this.key);if(typeof T=="boolean"){const U=T?"true":"false";return this.value===U?_.INSTANCE:I.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=b;class w{constructor(T,U){this.key=T,this.valueKey=U,this.type=10,this.negated=null}static create(T,U){return new w(T,U)}cmp(T){return T.type!==this.type?this.type-T.type:y(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const U=T.getValue(this.valueKey),N=T.getValue(this.key);return Array.isArray(U)?U.includes(N):typeof N=="string"&&typeof U=="object"&&U!==null?C.call(U,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyInExpr=w;class p{constructor(T){this._actual=T,this.type=11}static create(T){return new p(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new p(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class g{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=5}static create(T,U,N=null){if(typeof U=="boolean")return U?v.create(T,N):P.create(T,N);const H=A.get(T);return typeof H=="boolean"?U===(H?"true":"false")?I.INSTANCE:_.INSTANCE:new g(T,U,N)}cmp(T){return T.type!==this.type?this.type-T.type:y(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=A.get(this.key);if(typeof T=="boolean"){const U=T?"true":"false";return this.value===U?I.INSTANCE:_.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class v{constructor(T,U){this.key=T,this.negated=U,this.type=3}static create(T,U=null){const N=A.get(T);return typeof N=="boolean"?N?I.INSTANCE:_.INSTANCE:new v(T,U)}cmp(T){return T.type!==this.type?this.type-T.type:d(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=A.get(this.key);return typeof T=="boolean"?T?I.INSTANCE:_.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function f(F,T){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?T(F):I.INSTANCE}class c{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=12}static create(T,U,N=null){return f(U,H=>new c(T,H,N))}cmp(T){return T.type!==this.type?this.type-T.type:y(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class m{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=13}static create(T,U,N=null){return f(U,H=>new m(T,H,N))}cmp(T){return T.type!==this.type?this.type-T.type:y(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class a{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=14}static create(T,U,N=null){return f(U,H=>new a(T,H,N))}cmp(T){return T.type!==this.type?this.type-T.type:y(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class h{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=15}static create(T,U,N=null){return f(U,H=>new h(T,H,N))}cmp(T){return T.type!==this.type?this.type-T.type:y(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class r{constructor(T,U){this.key=T,this.regexp=U,this.type=7,this.negated=null}static create(T,U){return new r(T,U)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const U=this.regexp?this.regexp.source:"",N=T.regexp?T.regexp.source:"";return U<N?-1:U>N?1:0}equals(T){if(T.type===this.type){const U=this.regexp?this.regexp.source:"",N=T.regexp?T.regexp.source:"";return this.key===T.key&&U===N}return!1}substituteConstants(){return this}evaluate(T){const U=T.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(T){this._actual=T,this.type=8}static create(T){return new s(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new s(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function i(F){let T=null;for(let U=0,N=F.length;U<N;U++){const H=F[U].substituteConstants();if(F[U]!==H&&T===null){T=[];for(let te=0;te<U;te++)T[te]=F[te]}T!==null&&(T[U]=H)}return T===null?F:T}class t{constructor(T,U){this.expr=T,this.negated=U,this.type=6}static create(T,U){return t._normalizeArr(T,U)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const H=R(this.expr[U],T.expr[U]);if(H!==0)return H}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(T.expr[U]))return!1;return!0}return!1}substituteConstants(){const T=i(this.expr);return T===this.expr?this:t.create(T,this.negated)}evaluate(T){for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].evaluate(T))return!1;return!0}static _normalizeArr(T,U){const N=[];let H=!1;for(const te of T)if(!!te){if(te.type===1){H=!0;continue}if(te.type===0)return I.INSTANCE;if(te.type===6){N.push(...te.expr);continue}N.push(te)}if(N.length===0&&H)return _.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(R);for(let te=1;te<N.length;te++)N[te-1].equals(N[te])&&(N.splice(te,1),te--);if(N.length===1)return N[0];for(;N.length>1;){const te=N[N.length-1];if(te.type!==9)break;N.pop();const B=N.pop(),z=N.length===0,q=o.create(te.expr.map(V=>t.create([V,B],null)),null,z);q&&(N.push(q),N.sort(R))}return N.length===1?N[0]:new t(N,U)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const U of this.expr)T.push(...U.keys());return T}map(T){return new t(this.expr.map(U=>U.map(T)),null)}negate(){if(!this.negated){const T=[];for(const U of this.expr)T.push(U.negate());this.negated=o.create(T,this,!0)}return this.negated}}class o{constructor(T,U){this.expr=T,this.negated=U,this.type=9}static create(T,U,N){return o._normalizeArr(T,U,N)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const H=R(this.expr[U],T.expr[U]);if(H!==0)return H}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(T.expr[U]))return!1;return!0}return!1}substituteConstants(){const T=i(this.expr);return T===this.expr?this:o.create(T,this.negated,!1)}evaluate(T){for(let U=0,N=this.expr.length;U<N;U++)if(this.expr[U].evaluate(T))return!0;return!1}static _normalizeArr(T,U,N){let H=[],te=!1;if(T){for(let B=0,z=T.length;B<z;B++){const q=T[B];if(!!q){if(q.type===0){te=!0;continue}if(q.type===1)return _.INSTANCE;if(q.type===9){H=H.concat(q.expr);continue}H.push(q)}}if(H.length===0&&te)return I.INSTANCE;H.sort(R)}if(H.length!==0){if(H.length===1)return H[0];for(let B=1;B<H.length;B++)H[B-1].equals(H[B])&&(H.splice(B,1),B--);if(H.length===1)return H[0];if(N){for(let B=0;B<H.length;B++)for(let z=B+1;z<H.length;z++)L(H[B],H[z])&&(H.splice(z,1),z--);if(H.length===1)return H[0]}return new o(H,U)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const U of this.expr)T.push(...U.keys());return T}map(T){return new o(this.expr.map(U=>U.map(T)),null)}negate(){if(!this.negated){const T=[];for(const U of this.expr)T.push(U.negate());for(;T.length>1;){const U=T.shift(),N=T.shift(),H=[];for(const B of M(U))for(const z of M(N))H.push(t.create([B,z],null));const te=T.length===0;T.unshift(o.create(H,null,te))}this.negated=T[0]}return this.negated}}class l extends P{constructor(T,U,N){super(T,null);this._defaultValue=U,typeof N=="object"?l._info.push({...N,key:T}):N!==!0&&l._info.push({key:T,description:N,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return b.create(this.key,T)}notEqualsTo(T){return g.create(this.key,T)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(F,T){return F<T?-1:F>T?1:0}function y(F,T,U,N){return F<U?-1:F>U?1:T<N?-1:T>N?1:0}function L(F,T){if(T.type===6&&F.type!==9&&F.type!==6){for(const H of T.expr)if(F.equals(H))return!0}const U=F.negate(),N=M(U).concat(M(T));N.sort(R);for(let H=0;H<N.length;H++){const B=N[H].negate();for(let z=H+1;z<N.length;z++){const q=N[z];if(B.equals(q))return!0}}return!1}e.implies=L;function M(F){return F.type===9?F.expr:[F]}}),define(Ie[191],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[84],ke([1,0,164,4]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function A(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function C(g,v){switch(g){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function D(g,v){return v==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function E(g,v,f){return D(v,f)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===f?!0:k(f).includes(g)}e.isTargetPlatformCompatible=E;function k(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function R(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=R;var I;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var _;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(_=e.SortOrder||(e.SortOrder={}));var P;(function(g){g.Install="install",g.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var b;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var w;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(v,f){super(v);this.code=f,this.name=f}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,n.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(Ie[192],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(Ie[193],ke([1,0,42,11,9,13,102,29,114,166,192]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=k.localize(0,null);class _{async getDefaultTerminalForPlatforms(){return{windows:P.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class P extends _{openTerminal(c,m){return this.spawnTerminal(u,c,E.getWindowsShell(),m)}spawnTerminal(c,m,a,h){const r=m.windowsExec||P.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const s=S.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return c.spawn(r,h?[h]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return r.indexOf(" ")>=0&&i.push('""'),i.push(r),(s==="wt"||s==="wt.exe")&&i.push("-d ."),new Promise((t,o)=>{const l=p(process),d=c.spawn(a,i,{cwd:h,env:l});d.on("error",o),d.on("exit",()=>t())})}runInTerminal(c,m,a,h,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:P.getDefaultTerminalWindows();return new Promise((i,t)=>{const o=`"${m} - ${I}"`,l=`""${a.join('" "')}" & pause"`,d=["/c","start",o,"/wait",s,"/c",l],y=Object.assign({},p(process),h);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const L={cwd:m,env:y,windowsVerbatimArguments:!0};u.spawn(P.CMD,d,L).on("error",F=>{t(g(F))}),i(void 0)})}static getDefaultTerminalWindows(){if(!P._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");P._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return P._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=P,P.CMD="cmd.exe";class b extends _{openTerminal(c,m){return this.spawnTerminal(u,c,m)}runInTerminal(c,m,a,h,r){const s=r.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((i,t)=>{if(s===R.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const o=s===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,X).fsPath,"-t",c||I,"-w",m];for(const M of a)d.push("-a"),d.push(M);if(h){const M=Object.assign({},p(process),h);for(const F in M){const T=M[F];T===null?(d.push("-u"),d.push(F)):(d.push("-e"),d.push(`${F}=${T}`))}}let y="";const L=u.spawn(b.OSASCRIPT,d);L.on("error",M=>{t(g(M))}),L.stderr.on("data",M=>{y+=M.toString()}),L.on("exit",M=>{if(M===0)i(void 0);else if(y){const F=y.split(`
`,1);t(new Error(F[0]))}else t(new Error(k.localize(1,null,o,M)))})}else t(new Error(k.localize(2,null,s)))})}spawnTerminal(c,m,a){const h=m.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const i=["-a",h];a&&i.push(a);const t=p(process),o=c.spawn("/usr/bin/open",i,{cwd:a,env:t});o.on("error",s),o.on("exit",()=>r())})}}e.MacExternalTerminalService=b,b.OSASCRIPT="/usr/bin/osascript";class w extends _{openTerminal(c,m){return this.spawnTerminal(u,c,m)}runInTerminal(c,m,a,h,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,t)=>{const o=[];s.then(l=>{l.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const d=`${v(a)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;o.push(`''${d}''`);const y=Object.assign({},p(process),h);Object.keys(y).filter(T=>y[T]===null).forEach(T=>delete y[T]);const L={cwd:m,env:y};let M="";const F=u.spawn(l,o,L);F.on("error",T=>{t(g(T))}),F.stderr.on("data",T=>{M+=T.toString()}),F.on("exit",T=>{if(T===0)i(void 0);else if(M){const U=M.split(`
`,1);t(new Error(U[0]))}else t(new Error(k.localize(4,null,l,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await D.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{c?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,m,a){const h=m.linuxExec?Promise.resolve(m.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{h.then(i=>{const t=p(process),o=c.spawn(i,[],{cwd:a,env:t});o.on("error",s),o.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=k.localize(3,null);function p(f){const c={...f.env};return(0,C.sanitizeProcessEnvironment)(c),c}function g(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(k.localize(5,null,f.path)):f}function v(f){let c="";for(const m of f)m.indexOf(" ")>=0?c+='"'+m+'"':c+=m,c+=" ";return c}}),define(Ie[43],ke([1,0,25,9,8,10,2,167,4]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function k(B){return B.create===!0}e.isFileOpenForWriteOptions=k;var R;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var I;(function(B){B[B.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var _;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(_=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function P(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=P;function b(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=b;function w(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=w;function p(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function g(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=g;function v(B){return P(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var f;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(z,q){super(z);this.code=q}}e.FileSystemProviderError=c;function m(B,z){const q=new c(B.toString(),z);return h(q,z),q}e.createFileSystemProviderError=m;function a(B){return B||m((0,D.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=a;function h(B,z){return B.name=z?`${z} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=h;function r(B){if(!B)return f.Unknown;if(B instanceof c)return B.code;const z=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!z)return f.Unknown;switch(z[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=r;function s(B){if(B instanceof y)return B.fileOperationResult;switch(r(B)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(z,q,V){this.resource=z,this.operation=q,this.target=V}isOperation(z){return this.operation===z}}e.FileOperationEvent=t;var o;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(z,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const V=new Map;for(const j of z){const ie=V.get(j.type);switch(ie?ie.push([j.resource,j]):V.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,ie]of V)switch(j){case 1:this.added=u.TernarySearchTree.forUris(()=>q),this.added.fill(ie);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>q),this.updated.fill(ie);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>q),this.deleted.fill(ie);break}}contains(z,...q){return this.doContains(z,{includeChildren:!1},...q)}affects(z,...q){return this.doContains(z,{includeChildren:!0},...q)}doContains(z,q,...V){if(!z)return!1;const j=V.length>0;return!!((!j||V.includes(1))&&(this.added?.get(z)||q.includeChildren&&this.added?.findSuperstr(z))||(!j||V.includes(0))&&(this.updated?.get(z)||q.includeChildren&&this.updated?.findSuperstr(z))||(!j||V.includes(2))&&(this.deleted?.findSubstr(z)||q.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function d(B,z,q){return!B||!z||B===z||z.length>B.length?!1:(z.charAt(z.length-1)!==n.sep&&(z+=n.sep),q?(0,S.startsWithIgnoreCase)(B,z):B.indexOf(z)===0)}e.isParent=d;class y extends Error{constructor(z,q,V){super(z);this.fileOperationResult=q,this.options=V}}e.FileOperationError=y;class L extends y{constructor(z,q,V){super(z,2,V);this.stat=q}}e.NotModifiedSinceFileOperationError=L;var M;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=T;async function U(B,z){if(!z.hasProvider(C.URI.from({scheme:B.scheme})))return new Promise(q=>{const V=z.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===B.scheme&&j.added&&(V.dispose(),q())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(z){return(0,A.isNumber)(z)||(z=0),z<N.KB?(0,D.localize)(1,null,z.toFixed(0)):z<N.MB?(0,D.localize)(2,null,(z/N.KB).toFixed(2)):z<N.GB?(0,D.localize)(3,null,(z/N.MB).toFixed(2)):z<N.TB?(0,D.localize)(4,null,(z/N.GB).toFixed(2)):(0,D.localize)(5,null,(z/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var H;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function te(B){return{maxFileSize:B===0?300*N.MB:16*N.GB,maxHeapSize:B===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=te}),define(Ie[85],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...S){this._entries=new Map;for(const[A,C]of S)this.set(A,C)}set(S,A){const C=this._entries.get(S);return this._entries.set(S,A),C}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=u}),define(Ie[194],ke([1,0,18,12,116,190,4,85]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(b){super("cyclic dependency between services");this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class R{constructor(b=new D.ServiceCollection,w=!1,p){this._activeInstantiations=new Set,this._services=b,this._strict=w,this._parent=p,this._services.set(C.IInstantiationService,this)}createChild(b){return new R(b,this._strict,this)}invokeFunction(b,...w){const p=_.traceInvocation(b);let g=!1;try{return b({get:f=>{if(g)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,p);if(!c)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...w)}finally{g=!0,p.stop()}}createInstance(b,...w){let p,g;return b instanceof S.SyncDescriptor?(p=_.traceCreation(b.ctor),g=this._createInstance(b.ctor,b.staticArguments.concat(w),p)):(p=_.traceCreation(b),g=this._createInstance(b,w,p)),p.stop(),g}_createInstance(b,w=[],p){const g=C._util.getServiceDependencies(b).sort((c,m)=>c.index-m.index),v=[];for(const c of g){const m=this._getOrCreateServiceInstance(c.id,p);m||this._throwIfStrict(`[createInstance] ${b.name} depends on UNKNOWN service ${c.id}.`,!1),v.push(m)}const f=g.length>0?g[0].index:w.length;if(w.length!==f){console.trace(`[createInstance] First service dependency of ${b.name} at position ${f+1} conflicts with ${w.length} static arguments`);const c=f-w.length;c>0?w=w.concat(new Array(c)):w=w.slice(0,f)}return new b(...[...w,...v])}_setServiceInstance(b,w){if(this._services.get(b)instanceof S.SyncDescriptor)this._services.set(b,w);else if(this._parent)this._parent._setServiceInstance(b,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(b){const w=this._services.get(b);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(b):w}_getOrCreateServiceInstance(b,w){const p=this._getServiceInstanceOrDescriptor(b);return p instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(b,p,w.branch(b,!0)):(w.branch(b,!1),p)}_safeCreateAndCacheServiceInstance(b,w,p){if(this._activeInstantiations.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this._activeInstantiations.add(b);try{return this._createAndCacheServiceInstance(b,w,p)}finally{this._activeInstantiations.delete(b)}}_createAndCacheServiceInstance(b,w,p){const g=new A.Graph(c=>c.id.toString());let v=0;const f=[{id:b,desc:w,_trace:p}];for(;f.length;){const c=f.pop();if(g.lookupOrInsertNode(c),v++>1e3)throw new k(g);for(const m of C._util.getServiceDependencies(c.desc.ctor)){const a=this._getServiceInstanceOrDescriptor(m.id);if(a||this._throwIfStrict(`[createInstance] ${b} depends on ${m.id} which is NOT registered.`,!0),a instanceof S.SyncDescriptor){const h={id:m.id,desc:a,_trace:c._trace.branch(m.id,!0)};g.insertEdge(c,h),f.push(h)}}}for(;;){const c=g.roots();if(c.length===0){if(!g.isEmpty())throw new k(g);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof S.SyncDescriptor){const h=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,h)}g.removeNode(m)}}return this._getServiceInstanceOrDescriptor(b)}_createServiceInstanceWithOwner(b,w,p=[],g,v){if(this._services.get(b)instanceof S.SyncDescriptor)return this._createServiceInstance(w,p,g,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(b,w,p,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(b,w=[],p,g){if(p){const v=new u.IdleValue(()=>this._createInstance(b,w,g));return new Proxy(Object.create(null),{get(f,c){if(c in f)return f[c];const m=v.value;let a=m[c];return typeof a!="function"||(a=a.bind(m),f[c]=a),a},set(f,c,m){return v.value[c]=m,!0}})}else return this._createInstance(b,w,g)}_throwIfStrict(b,w){if(w&&console.warn(w),this._strict)throw new Error(b)}}e.InstantiationService=R;var I;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(I||(I={}));class _{constructor(b,w){this.type=b,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(b){return E?new _(1,b.name||b.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(b){return E?new _(0,b.name):_._None}branch(b,w){const p=new _(2,b.toString());return this._dep.push([b,w,p]),p}stop(){const b=Date.now()-this._start;_._totals+=b;let w=!1;function p(v,f){const c=[],m=new Array(v+1).join("	");for(const[a,h,r]of f._dep)if(h&&r){w=!0,c.push(`${m}CREATES -> ${a}`);const s=p(v+1,r);s&&c.push(s)}else c.push(`${m}uses -> ${a}`);return c.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(b>2||w)&&console.log(g.join(`
`))}}e.Trace=_,_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(Ie[14],ke([1,0,49,3,6,13,4]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function D(){return new Date().toISOString()}var E;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function k(h,r,s){switch(r){case E.Trace:h.trace(s);break;case E.Debug:h.debug(s);break;case E.Info:h.info(s);break;case E.Warning:h.warn(s);break;case E.Error:h.error(s);break;case E.Critical:h.critical(s);break;default:throw new Error("Invalid log level")}}e.log=k;function R(h){let r="";for(let s=0;s<h.length;s++){let i=h[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch{}r+=(s>0?" ":"")+i}return r}e.format=R;class I extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class _ extends I{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...s){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([r,...s]))}debug(r,...s){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([r,...s]))}info(r,...s){this.checkLogLevel(E.Info)&&this.log(E.Info,R([r,...s]))}warn(r,...s){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([r,...s]))}error(r,...s){if(this.checkLogLevel(E.Error))if(r instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=r.stack,this.log(E.Error,R(i))}else this.log(E.Error,R([r,...s]))}critical(r,...s){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([r,...s]))}flush(){}}e.AbstractMessageLogger=_;class P extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!A.isWindows}trace(r,...s){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}debug(r,...s){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}info(r,...s){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,r,...s):console.log(`[main ${D()}]`,r,...s))}warn(r,...s){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,r,...s):console.warn(`[main ${D()}]`,r,...s))}error(r,...s){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}critical(r,...s){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,r,...s):console.error(`[main ${D()}]`,r,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class b extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...s){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",r,...s)}debug(r,...s){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...s)}info(r,...s){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",r,...s)}warn(r,...s){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",r,...s)}error(r,...s){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",r,...s)}critical(r,...s){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...s)}dispose(){}flush(){}}e.ConsoleLogger=b;class w extends I{constructor(r,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(s)}trace(r,...s){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(r),...s])}debug(r,...s){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(r),...s])}info(r,...s){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(r),...s])}warn(r,...s){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(r),...s])}error(r,...s){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(r),...s])}critical(r,...s){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(r),...s])}extractMessage(r){return typeof r=="string"?r:(0,u.toErrorMessage)(r,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class p extends I{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const s of this.logServices)s.setLevel(r);super.setLevel(r)}trace(r,...s){for(const i of this.logServices)i.trace(r,...s)}debug(r,...s){for(const i of this.logServices)i.debug(r,...s)}info(r,...s){for(const i of this.logServices)i.info(r,...s)}warn(r,...s){for(const i of this.logServices)i.warn(r,...s)}error(r,...s){for(const i of this.logServices)i.error(r,...s)}critical(r,...s){for(const i of this.logServices)i.critical(r,...s)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=p;class g extends S.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...s){this.logger.trace(r,...s)}debug(r,...s){this.logger.debug(r,...s)}info(r,...s){this.logger.info(r,...s)}warn(r,...s){this.logger.warn(r,...s)}error(r,...s){this.logger.error(r,...s)}critical(r,...s){this.logger.critical(r,...s)}flush(){this.logger.flush()}}e.LogService=g;class v extends S.Disposable{constructor(r,s){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(i))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,s){let i=this.loggers.get(r.toString());return i||(i=this.doCreateLogger(r,s?.always?E.Trace:this.logLevel,s),this.loggers.set(r.toString(),i),s?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return E.Info}trace(r,...s){}debug(r,...s){}info(r,...s){}warn(r,...s){}error(r,...s){}critical(r,...s){}dispose(){}flush(){}}e.NullLogService=f;function c(h){if(h.verbose)return E.Trace;if(typeof h.logLevel=="string"){const r=m(h.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function m(h){switch(h){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=m;function a(h){switch(h){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=a}),define(Ie[195],ke([1,0,43,14]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function S(D,E,k,R,I){try{const _=await new Promise((b,w)=>{X(["spdlog"],b,w)});_.setFlushOn(n.LogLevel.Trace);const P=await _.createAsyncRotatingLogger(D,E,k,R);return I&&P.clearFormatters(),P}catch(_){console.error(_)}return null}function A(D,E,k){switch(E){case n.LogLevel.Trace:D.trace(k);break;case n.LogLevel.Debug:D.debug(k);break;case n.LogLevel.Info:D.info(k);break;case n.LogLevel.Warning:D.warn(k);break;case n.LogLevel.Error:D.error(k);break;case n.LogLevel.Critical:D.critical(k);break;default:throw new Error("Invalid log level")}}class C extends n.AbstractMessageLogger{constructor(E,k,R,I,_){super();this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(E,k,R,I),this._register(this.onDidChangeLogLevel(P=>{this._logger?.setLevel(P)}))}async _createSpdLogLogger(E,k,R,I){const _=R?6:1,P=30/_*u.ByteSize.MB,b=await S(E,k,P,_,I);if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:w,message:p}of this.buffer)A(this._logger,w,p);this.buffer=[]}}log(E,k){this._logger?A(this._logger,E,k):this.getLevel()<=E&&this.buffer.push({level:E,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(Ie[117],ke([1,0,41,168,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var C;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(b,w){return w-b}E.compare=k;const R=Object.create(null);R[E.Error]=(0,n.localize)(0,null),R[E.Warning]=(0,n.localize)(1,null),R[E.Info]=(0,n.localize)(2,null);function I(b){return R[b]||""}E.toString=I;function _(b){switch(b){case u.default.Error:return E.Error;case u.default.Warning:return E.Warning;case u.default.Info:return E.Info;case u.default.Ignore:return E.Hint}}E.fromSeverity=_;function P(b){switch(b){case E.Error:return u.default.Error;case E.Warning:return u.default.Warning;case E.Info:return u.default.Info;case E.Hint:return u.default.Ignore}}E.toSeverity=P}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(E){const k="";function R(_){return I(_,!0)}E.makeKey=R;function I(_,P){const b=[k];return _.source?b.push(_.source.replace("\xA6","\\\xA6")):b.push(k),_.code?typeof _.code=="string"?b.push(_.code.replace("\xA6","\\\xA6")):b.push(_.code.value.replace("\xA6","\\\xA6")):b.push(k),_.severity!==void 0&&_.severity!==null?b.push(C.toString(_.severity)):b.push(k),_.message&&P?b.push(_.message.replace("\xA6","\\\xA6")):b.push(k),_.startLineNumber!==void 0&&_.startLineNumber!==null?b.push(_.startLineNumber.toString()):b.push(k),_.startColumn!==void 0&&_.startColumn!==null?b.push(_.startColumn.toString()):b.push(k),_.endLineNumber!==void 0&&_.endLineNumber!==null?b.push(_.endLineNumber.toString()):b.push(k),_.endColumn!==void 0&&_.endColumn!==null?b.push(_.endColumn.toString()):b.push(k),b.push(k),b.join("\xA6")}E.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ie[196],ke([1,0,3,41,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=n.default,e.INotificationService=(0,S.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new E,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=D;class E{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=E}),define(Ie[118],ke([1,0,6,8,2,4]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function C(R,I){return S.URI.isUri(R)?(0,n.equalsIgnoreCase)(R.scheme,I):(0,n.startsWithIgnoreCase)(R,I+":")}e.matchesScheme=C;function D(R,...I){return I.some(_=>C(R,_))}e.matchesSomeScheme=D;function E(R,I){return R.with({fragment:`${I.startLineNumber},${I.startColumn}${I.endLineNumber?`-${I.endLineNumber}${I.endColumn?`,${I.endColumn}`:""}`:""}`})}e.withSelection=E;function k(R){let I;const _=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return _&&(I={startLineNumber:parseInt(_[1]),startColumn:_[2]?parseInt(_[2]):1,endLineNumber:_[4]?parseInt(_[4]):void 0,endColumn:_[4]?_[5]?parseInt(_[5]):1:void 0},R=R.with({fragment:""})),{selection:I,uri:R}}e.extractSelection=k}),define(Ie[197],ke([1,0,11,13,40,22]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const D=n.globals.vscode.context.configuration();if(D)C=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const D=(0,A.dirname)(u.FileAccess.asFileUri("",X));C=X.__$__nodeRequire((0,A.joinPath)(D,"product.json").fsPath);const E=X.__$__nodeRequire((0,A.joinPath)(D,"package.json").fsPath);S.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{version:E.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(Ie[198],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(X,e){return function(u,n){e(u,n,X)}};define(Ie[119],ke([1,0,18,21,6,4]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var C;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let E=class extends S.Disposable{constructor(I,_){super();this.deferred=new u.DeferredPromise,_.withProgress(I,P=>(this.reporter=P,this.lastStep&&P.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};E=Ge([He(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const _=++this.currentOperationId,P=new n.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>P.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:P.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Ie[44],ke([1,0,56,10]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(C,D){u.ok(n.isString(C)),u.ok(n.isObject(D)),u.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,D)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new S}),define(Ie[120],ke([1,0,3,44]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[S(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new A;n.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[121],ke([1,0,16,3,10,163,83,120,44]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=E.Registry.as(D.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,h=!0){this.registerConfigurations([a],h)}registerConfigurations(a,h=!0){const r=this.doRegisterConfigurations(a,h);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(a){const h=this.doDeregisterConfigurations(a);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}updateConfigurations({add:a,remove:h}){const r=[];r.push(...this.doDeregisterConfigurations(h)),r.push(...this.doRegisterConfigurations(a,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(r)})}registerDefaultConfigurations(a){const h=[],r=[];for(const{overrides:s,source:i}of a)for(const t in s)if(h.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const o=this.configurationDefaultsOverrides.get(t),l=o?.valuesSources??new Map;if(i)for(const M of Object.keys(s[t]))l.set(M,i);const d={...o?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:i,value:d,valuesSources:l});const y=(0,C.getLanguageTagSettingPlainKey)(t),L={type:"object",default:d,description:A.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:S.isString(i)?void 0:i,defaultValueSource:i};r.push(...w(t)),this.configurationProperties[t]=L,this.defaultLanguageConfigurationOverridesNode.properties[t]=L}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:i});const o=this.configurationProperties[t];o&&(this.updatePropertyDefaultValue(t,o),this.updateSchema(t,o))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const h=[];for(const{overrides:r,source:s}of a)for(const i in r){const t=this.configurationDefaultsOverrides.get(i),o=S.isString(s)?s:s?.id,l=S.isString(t?.source)?t?.source:t?.source?.id;if(o===l)if(h.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const d=this.configurationProperties[i];d&&(this.updatePropertyDefaultValue(i,d),this.updateSchema(i,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const h of a)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,h){const r=[];return a.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,h,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),r}doDeregisterConfigurations(a){const h=[],r=s=>{if(s.properties)for(const i in s.properties){h.push(i);const t=this.configurationProperties[i];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i])}s.allOf?.forEach(i=>r(i))};for(const s of a){r(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return h}validateAndRegisterProperties(a,h=!0,r,s,i=3){i=S.isUndefinedOrNull(a.scope)?i:a.scope;const t=[],o=a.properties;if(o)for(const d in o){const y=o[d];if(h&&f(d,y)){delete o[d];continue}if(y.source=r,y.defaultDefaultValue=o[d].default,this.updatePropertyDefaultValue(d,y),e.OVERRIDE_PROPERTY_REGEX.test(d)?y.scope=void 0:(y.scope=S.isUndefinedOrNull(y.scope)?i:y.scope,y.restricted=S.isUndefinedOrNull(y.restricted)?!!s?.includes(d):y.restricted),o[d].hasOwnProperty("included")&&!o[d].included){this.excludedConfigurationProperties[d]=o[d],delete o[d];continue}else this.configurationProperties[d]=o[d],o[d].policy?.name&&this.policyConfigurations.set(o[d].policy.name,d);!o[d].deprecationMessage&&o[d].markdownDeprecationMessage&&(o[d].deprecationMessage=o[d].markdownDeprecationMessage),t.push(d)}const l=a.allOf;if(l)for(const d of l)t.push(...this.validateAndRegisterProperties(d,h,r,s,i));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const h=r=>{const s=r.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);r.allOf?.forEach(h)};h(a)}updateSchema(a,h){switch(e.allSettings.properties[a]=h,h.scope){case 1:e.applicationSettings.properties[a]=h;break;case 2:e.machineSettings.properties[a]=h;break;case 6:e.machineOverridableSettings.properties[a]=h;break;case 3:e.windowSettings.properties[a]=h;break;case 4:e.resourceSettings.properties[a]=h;break;case 5:e.resourceSettings.properties[a]=h,this.resourceLanguageSettingsSchema.properties[a]=h;break}}removeFromSchema(a,h){switch(delete e.allSettings.properties[a],h.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const h=`[${a}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,r),e.allSettings.properties[h]=r,e.applicationSettings.properties[h]=r,e.machineSettings.properties[h]=r,e.machineOverridableSettings.properties[h]=r,e.windowSettings.properties[h]=r,e.resourceSettings.properties[h]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,h){const r=this.configurationDefaultsOverrides.get(a);let s=r?.value,i=r?.source;S.isUndefined(s)&&(s=h.defaultDefaultValue,i=void 0),S.isUndefined(s)&&(s=g(h.type)),h.default=s,h.defaultValueSource=i}}const P="\\[([^\\]]+)\\]",b=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(m){const a=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let h=b.exec(m);for(;h?.length;){const r=h[1].trim();r&&a.push(r),h=b.exec(m)}}return(0,u.distinct)(a)}e.overrideIdentifiersFromKey=w;function p(m){return m.reduce((a,h)=>`${a}[${h}]`,"")}e.keyFromOverrideIdentifiers=p;function g(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const v=new _;E.Registry.add(e.Extensions.Configuration,v);function f(m,a){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?A.localize(7,null,m):v.getConfigurationProperties()[m]!==void 0?A.localize(8,null,m):a.policy?.name&&v.getPolicyConfigurations().get(a.policy?.name)!==void 0?A.localize(9,null,m,a.policy?.name,v.getPolicyConfigurations().get(a.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function c(){const m=[],a=v.getConfigurationProperties();for(const h of Object.keys(a))m.push([h,a[h].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=c}),define(Ie[199],ke([1,0,16,3,142,6,25,24,10,2,83,121,44]),function(X,e,u,n,S,A,C,D,E,k,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class P{constructor(h={},r=[],s=[]){this._contents=h,this._keys=r,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(h){return h?(0,R.getConfigurationValue)(this.contents,h):this.contents}getOverrideValue(h,r){const s=this.getContentsForOverrideIdentifer(r);return s?h?(0,R.getConfigurationValue)(s,h):s:void 0}getKeysForOverrideIdentifier(h){const r=[];for(const s of this.overrides)s.identifiers.includes(h)&&r.push(...s.keys);return u.distinct(r)}getAllOverrideIdentifiers(){const h=[];for(const r of this.overrides)h.push(...r.identifiers);return u.distinct(h)}override(h){let r=this.overrideConfigurations.get(h);return r||(r=this.createOverrideConfigurationModel(h),this.overrideConfigurations.set(h,r)),r}merge(...h){const r=D.deepClone(this.contents),s=D.deepClone(this.overrides),i=[...this.keys];for(const t of h)if(!t.isEmpty()){this.mergeContents(r,t.contents);for(const o of t.overrides){const[l]=s.filter(d=>u.equals(d.identifiers,o.identifiers));l?(this.mergeContents(l.contents,o.contents),l.keys.push(...o.keys),l.keys=u.distinct(l.keys)):s.push(D.deepClone(o))}for(const o of t.keys)i.indexOf(o)===-1&&i.push(o)}return new P(r,i,s)}freeze(){return this.frozen=!0,this}clone(){return new P(D.deepClone(this.contents),[...this.keys],D.deepClone(this.overrides))}createOverrideConfigurationModel(h){const r=this.getContentsForOverrideIdentifer(h);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const s={};for(const i of u.distinct([...Object.keys(this.contents),...Object.keys(r)])){let t=this.contents[i];const o=r[i];o&&(typeof t=="object"&&typeof o=="object"?(t=D.deepClone(t),this.mergeContents(t,o)):t=o),s[i]=t}return new P(s,this.keys,this.overrides)}mergeContents(h,r){for(const s of Object.keys(r)){if(s in h&&E.isObject(h[s])&&E.isObject(r[s])){this.mergeContents(h[s],r[s]);continue}h[s]=D.deepClone(r[s])}}checkAndFreeze(h){return this.frozen&&!Object.isFrozen(h)?D.deepFreeze(h):h}getContentsForOverrideIdentifer(h){let r=null,s=null;const i=t=>{t&&(s?this.mergeContents(s,t):s=D.deepClone(t))};for(const t of this.overrides)u.equals(t.identifiers,[h])?r=t.contents:t.identifiers.includes(h)&&i(t.contents);return i(r),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(h,r){this.addKey(h),(0,R.addToValueTree)(this.contents,h,r,s=>{throw new Error(s)})}removeValue(h){this.removeKey(h)&&(0,R.removeFromValueTree)(this.contents,h)}addKey(h){let r=this.keys.length;for(let s=0;s<r;s++)h.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,h)}removeKey(h){const r=this.keys.indexOf(h);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=P;class b{constructor(h){this._name=h,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(h,r){if(!E.isUndefinedOrNull(h)){const s=this.doParseContent(h);this.parseRaw(s,r)}}reparse(h){this._raw&&this.parseRaw(this._raw,h)}parseRaw(h,r){this._raw=h;const{contents:s,keys:i,overrides:t,restricted:o}=this.doParseRaw(h,r);this._configurationModel=new P(s,i,t),this._restrictedConfigurations=o||[]}doParseContent(h){let r={},s=null,i=[];const t=[],o=[];function l(y){Array.isArray(i)?i.push(y):s!==null&&(i[s]=y)}const d={onObjectBegin:()=>{const y={};l(y),t.push(i),i=y,s=null},onObjectProperty:y=>{s=y},onObjectEnd:()=>{i=t.pop()},onArrayBegin:()=>{const y=[];l(y),t.push(i),i=y,s=null},onArrayEnd:()=>{i=t.pop()},onLiteralValue:l,onError:(y,L,M)=>{o.push({error:y,offset:L,length:M})}};if(h)try{S.visit(h,d),r=i[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return r}doParseRaw(h,r){const s=_.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(h,s,!0,r);h=i.raw;const t=(0,R.toValuesTree)(h,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),o=Object.keys(h),l=this.toOverrides(h,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:t,keys:o,overrides:l,restricted:i.restricted}}filter(h,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:h,restricted:[]};const t={},o=[];for(const l in h)if(I.OVERRIDE_PROPERTY_REGEX.test(l)&&s){const d=this.filter(h[l],r,!1,i);t[l]=d.raw,o.push(...d.restricted)}else{const d=r[l],y=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&o.push(l),(y===void 0||i.scopes===void 0||i.scopes.includes(y))&&(i.skipRestricted&&d?.restricted||(t[l]=h[l]))}return{raw:t,restricted:o}}toOverrides(h,r){const s=[];for(const i of Object.keys(h))if(I.OVERRIDE_PROPERTY_REGEX.test(i)){const t={};for(const o in h[i])t[o]=h[i][o];s.push({identifiers:(0,I.overrideIdentifiersFromKey)(i),keys:Object.keys(t),contents:(0,R.toValuesTree)(t,r)})}return s}}e.ConfigurationModelParser=b;class w extends A.Disposable{constructor(h,r,s,i){super();this.userSettingsResource=h,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&s.isEqual(t.resource,h)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const h=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(h.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new P}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class p{constructor(h,r,s,i,t=new P,o=new P,l=new C.ResourceMap,d=new P,y=new C.ResourceMap,L=!0){this._defaultConfiguration=h,this._policyConfiguration=r,this._applicationConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=t,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=d,this._memoryConfigurationByResource=y,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(h,r,s){return this.getConsolidatedConfigurationModel(h,r,s).getValue(h)}updateValue(h,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new P,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(h):i.setValue(h,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(h,r,s){const i=this.getConsolidatedConfigurationModel(h,r,s),t=this.getFolderConfigurationModelForResource(r.resource,s),o=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this._defaultConfiguration.freeze().getValue(h),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(h),y=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(h),L=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this.userConfiguration.freeze().getValue(h),M=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this.localUserConfiguration.freeze().getValue(h),F=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this.remoteUserConfiguration.freeze().getValue(h),T=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(h):this._workspaceConfiguration.freeze().getValue(h):void 0,U=t?r.overrideIdentifier?t.freeze().override(r.overrideIdentifier).getValue(h):t.freeze().getValue(h):void 0,N=r.overrideIdentifier?o.override(r.overrideIdentifier).getValue(h):o.getValue(h),H=i.getValue(h),te=u.distinct(i.overrides.map(B=>B.identifiers).flat()).filter(B=>i.getOverrideValue(h,B)!==void 0);return{defaultValue:l,policyValue:d,applicationValue:y,userValue:L,userLocalValue:M,userRemoteValue:F,workspaceValue:T,workspaceFolderValue:U,memoryValue:N,value:H,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,policy:d!==void 0?{value:d}:void 0,application:y!==void 0?{value:y,override:r.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(h),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:t?.freeze().getValue(h),override:r.overrideIdentifier?t?.freeze().getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:o.getValue(h),override:r.overrideIdentifier?o.getOverrideValue(h,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(h){const r=this.getFolderConfigurationModelForResource(void 0,h);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(h){this._defaultConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(h){this._policyConfiguration=h}updateApplicationConfiguration(h){this._applicationConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(h){this._localUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(h){this._remoteUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(h){this._workspaceConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(h,r){this._folderConfigurations.set(h,r),this._foldersConsolidatedConfigurations.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this._foldersConsolidatedConfigurations.delete(h)}compareAndUpdateDefaultConfiguration(h,r){const s=[];if(!r){const{added:i,updated:t,removed:o}=c(this._defaultConfiguration,h);r=[...i,...t,...o]}for(const i of r)for(const t of(0,I.overrideIdentifiersFromKey)(i)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(t),l=h.getKeysForOverrideIdentifier(t),d=[...l.filter(y=>o.indexOf(y)===-1),...o.filter(y=>l.indexOf(y)===-1),...o.filter(y=>!D.equals(this._defaultConfiguration.override(t).getValue(y),h.override(t).getValue(y)))];s.push([t,d])}return this.updateDefaultConfiguration(h),{keys:r,overrides:s}}compareAndUpdatePolicyConfiguration(h){const{added:r,updated:s,removed:i}=c(this._policyConfiguration,h),t=[...r,...s,...i];return t.length&&this.updatePolicyConfiguration(h),{keys:t,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:r,updated:s,removed:i,overrides:t}=c(this.applicationConfiguration,h),o=[...r,...s,...i];return o.length&&this.updateApplicationConfiguration(h),{keys:o,overrides:t}}compareAndUpdateLocalUserConfiguration(h){const{added:r,updated:s,removed:i,overrides:t}=c(this.localUserConfiguration,h),o=[...r,...s,...i];return o.length&&this.updateLocalUserConfiguration(h),{keys:o,overrides:t}}compareAndUpdateRemoteUserConfiguration(h){const{added:r,updated:s,removed:i,overrides:t}=c(this.remoteUserConfiguration,h),o=[...r,...s,...i];return o.length&&this.updateRemoteUserConfiguration(h),{keys:o,overrides:t}}compareAndUpdateWorkspaceConfiguration(h){const{added:r,updated:s,removed:i,overrides:t}=c(this.workspaceConfiguration,h),o=[...r,...s,...i];return o.length&&this.updateWorkspaceConfiguration(h),{keys:o,overrides:t}}compareAndUpdateFolderConfiguration(h,r){const s=this.folderConfigurations.get(h),{added:i,updated:t,removed:o,overrides:l}=c(s,r),d=[...i,...t,...o];return(d.length||!s)&&this.updateFolderConfiguration(h,r),{keys:d,overrides:l}}compareAndDeleteFolderConfiguration(h){const r=this.folderConfigurations.get(h);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:s,updated:i,removed:t,overrides:o}=c(r,void 0);return{keys:[...s,...i,...t],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(h,r,s){let i=this.getConsolidatedConfigurationModelForResource(r,s);return r.overrideIdentifier&&(i=i.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(h)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:h},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&h){const i=r.getFolder(h);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const t=this._memoryConfigurationByResource.get(h);t&&(s=s.merge(t))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(h){let r=this._foldersConsolidatedConfigurations.get(h);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(h);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(h,r)):r=s}return r}getFolderConfigurationModelForResource(h,r){if(r&&h){const s=r.getFolder(h);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((h,r)=>{const{contents:s,overrides:i,keys:t}=this._folderConfigurations.get(r);return h.push([r,{contents:s,overrides:i,keys:t}]),h},[])}}allKeys(){const h=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>h.add(r)),this.userConfiguration.freeze().keys.forEach(r=>h.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>h.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>h.add(s))),[...h.values()]}allOverrideIdentifiers(){const h=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>h.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>h.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>h.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(s=>h.add(s))),[...h.values()]}getAllKeysForOverrideIdentifier(h){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(h).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(h).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(h).forEach(i=>r.add(i))),[...r.values()]}static parse(h){const r=this.parseConfigurationModel(h.defaults),s=this.parseConfigurationModel(h.policy),i=this.parseConfigurationModel(h.application),t=this.parseConfigurationModel(h.user),o=this.parseConfigurationModel(h.workspace),l=h.folders.reduce((d,y)=>(d.set(k.URI.revive(y[0]),this.parseConfigurationModel(y[1])),d),new C.ResourceMap);return new p(r,s,i,t,new P,o,l,new P,new C.ResourceMap,!1)}static parseConfigurationModel(h){return new P(h.contents,h.keys,h.overrides).freeze()}}e.Configuration=p;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const h=new Set,r=new Map;for(const i of a)i.keys.forEach(t=>h.add(t)),i.overrides.forEach(([t,o])=>{const l=(0,C.getOrSet)(r,t,new Set);o.forEach(d=>l.add(d))});const s=[];return r.forEach((i,t)=>s.push([t,[...i.values()]])),{keys:[...h.values()],overrides:s}}e.mergeChanges=g;class v{constructor(h,r,s,i){this.change=h,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const t=new Set;h.keys.forEach(l=>t.add(l)),h.overrides.forEach(([,l])=>l.forEach(d=>t.add(d))),this.affectedKeys=[...t.values()];const o=new P;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(h,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,h)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(h,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(h,r,this.currentWorkspace);return!D.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(h,r){let s=(0,R.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(h=h[i],!h)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=v;class f extends v{constructor(h,r,s,i){super({keys:h.allKeys(),overrides:[]},void 0,h,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=f;function c(a,h){const{added:r,removed:s,updated:i}=m(h,a),t=[],o=a?.getAllOverrideIdentifiers()||[],l=h?.getAllOverrideIdentifiers()||[];if(h){const d=l.filter(y=>!o.includes(y));for(const y of d)t.push([y,h.getKeysForOverrideIdentifier(y)])}if(a){const d=o.filter(y=>!l.includes(y));for(const y of d)t.push([y,a.getKeysForOverrideIdentifier(y)])}if(h&&a){for(const d of o)if(l.includes(d)){const y=m({contents:a.getOverrideValue(void 0,d)||{},keys:a.getKeysForOverrideIdentifier(d)},{contents:h.getOverrideValue(void 0,d)||{},keys:h.getKeysForOverrideIdentifier(d)});t.push([d,[...y.added,...y.removed,...y.updated]])}}return{added:r,removed:s,updated:i,overrides:t}}function m(a,h){const r=a?h?a.keys.filter(t=>h.keys.indexOf(t)===-1):[...a.keys]:[],s=h?a?h.keys.filter(t=>a.keys.indexOf(t)===-1):[...h.keys]:[],i=[];if(a&&h){for(const t of h.keys)if(a.keys.indexOf(t)!==-1){const o=(0,R.getConfigurationValue)(h.contents,t),l=(0,R.getConfigurationValue)(a.contents,t);D.equals(o,l)||i.push(t)}}return{added:r,removed:s,updated:i}}}),define(Ie[122],ke([1,0,12,4]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var S;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends u.ErrorNoTelemetry{constructor(D,E=S.Unknown,k){super(D);this._message=D,this._code=E,this._detail=k,this.isHandled=E===S.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(D){return D instanceof A&&D._code===S.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof A&&D._code===S.NoResolverFound}static isHandled(D){return D instanceof A&&D.isHandled}}e.RemoteAuthorityResolverError=A}),define(Ie[123],ke([1,0,11]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(k){return k.scheme===u.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=n;function S(k){if(!k)return;const R=k.indexOf("+");return R<0?k:k.substr(0,R)}e.getRemoteName=S;function A(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=A;function C(k){const{host:R,port:I}=E(k);if(typeof I=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.parseAuthorityWithPort=C;function D(k,R){let{host:I,port:_}=E(k);return typeof _=="undefined"&&(_=R),{host:I,port:_}}e.parseAuthorityWithOptionalPort=D;function E(k){const R=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=k.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const _=k.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:k,port:void 0}}}),define(Ie[28],ke([1,0,8,4,123]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=A;function C(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var E;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,p){if(typeof w=="undefined"||w===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof w=="string"||typeof p=="string"){const g=typeof w=="string"?w:w.value,v=typeof p=="string"?p:p.value;return u.equalsIgnoreCase(g,v)}return w._lower===p._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=k;function R(b){return I(b)}e.isApplicationScopedExtension=R;function I(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function _(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=_;function P(b,w){if(w){const p=`onResolveRemoteAuthority:${(0,S.getRemoteName)(w)}`;return b.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[200],ke([1,0,8,84,28,13,2,12,40]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,u.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=k;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{constructor(s,i,t="undefined"){this.version=i,this.targetPlatform=t,this.id=s.id}static create(s){const i=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new I(s.identifier,i,t)}static parse(s){const i=R.exec(s);return i&&i[1]&&i[2]?new I({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof I?k(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=I;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(r){const s=_.exec(r);return s&&s[1]?[w(s[1]),s[2]]:[w(r),void 0]}e.getIdAndVersion=P;function b(r,s){return`${r}.${s}`}e.getExtensionId=b;function w(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=w;function p(r,s){return w(b(r,s))}e.getGalleryExtensionId=p;function g(r,s){const i=[],t=o=>{for(const l of i)if(l.some(d=>k(s(d),s(o))))return l;return null};for(const o of r){const l=t(o);l?l.push(o):i.push([o])}return i}e.groupByExtension=g;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function f(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function c(r){const s=new Set;if(r.malicious)for(const i of r.malicious)s.add(i.id);return s}e.getMaliciousExtensionsSet=c;function m(r,s){const i=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const o=t.shift();if(o&&i.every(l=>!k(l.identifier,{id:o}))){const l=r.filter(d=>k(d.identifier,{id:o}));l.length===1&&(i.push(l[0]),t.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=m;async function a(r,s){if(!A.isLinux)return!1;let i;try{i=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){s.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(o))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=a;async function h(r,s){const i=await a(r,s),t=(0,n.getTargetPlatform)(i?"alpine":A.platform,E.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=h}),define(Ie[201],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((S,A)=>X(["vsda"],S,A))}async createNewMessage(S){try{const A=await this.vsda(),C=new A.validator;if(C){const D=String(u._nextId++);return this.validators.set(D,C),{id:D,data:C.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,A){if(!S.id)return!0;const C=this.validators.get(S.id);if(!C)return!1;this.validators.delete(S.id);try{return C.validate(A)==="ok"}catch{return!1}}async sign(S){try{const A=await this.vsda(),C=new A.signer;if(C)return C.sign(S)}catch{}return S}}e.SignService=u,u._nextId=1}),define(Ie[202],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,A,C=5){const D=A(E=>{const k=typeof E=="string"?E:E.data;let R=this._terminalBufferMap.get(S);if(R){R.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(S),C);R={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),D.dispose()}},this._terminalBufferMap.set(S,R)});return D}stopBuffering(S){const A=this._terminalBufferMap.get(S);A&&A.dispose()}flushBuffer(S){const A=this._terminalBufferMap.get(S);A&&(this._terminalBufferMap.delete(S),this._callback(S,A.data.join("")))}}e.TerminalDataBufferer=u}),define(Ie[203],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(u=e.ColorScheme||(e.ColorScheme={}));function n(A){return A===u.HIGH_CONTRAST_DARK||A===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function S(A){return A===u.DARK||A===u.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ie[86],ke([1,0,76,3,6,4,44,203]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var E;(function(p){function g(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=g})(E=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var R;(function(p){function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||E.isThemeColor(s.color))}p.isThemeIcon=g;const v=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function f(s){const i=v.exec(s);if(!i)return;const[,t]=i;return{id:t}}p.fromString=f;function c(s){return{id:s}}p.fromId=c;function m(s,i){let t=s.id;const o=t.lastIndexOf("~");return o!==-1&&(t=t.substring(0,o)),i&&(t=`${t}~${i}`),{id:t}}p.modify=m;function a(s){const i=s.id.lastIndexOf("~");if(i!==-1)return s.id.substring(i+1)}p.getModifier=a;function h(s,i){return s.id===i.id&&s.color?.id===i.color?.id}p.isEqual=h;function r(s,i){return{id:s.id,color:i?k(i):void 0}}p.asThemeIcon=r,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function I(p){switch(p){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,S.toDisposable)(()=>{const v=this.themingParticipants.indexOf(g);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const P=new _;C.Registry.add(e.Extensions.ThemingContribution,P);function b(p){return P.onColorThemeChange(p)}e.registerThemingParticipant=b;class w extends S.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,v){let f=this.theme.getColor(g);return f&&v&&(f=v(f,this.theme)),f?f.toString():null}}e.Themable=w}),define(Ie[124],ke([1,0,3,13,4,14]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var C;(function(w){w.Http="http",w.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=I;function _(w,p){return p?p!==1&&w<1024:!n.isWindows&&w<1024}e.isPortPrivileged=_;class P{constructor(p,g,v){this.remoteAddress=p,this.localAddress=g,this._dispose=v,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=P;let b=class{constructor(p){this.logService=p,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],g=Array.from(this._tunnels.values());for(const v of g){const f=Array.from(v.values());for(const c of f){const m=await c.value;m&&p.push(m)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:g}of p.values())await g.then(v=>v?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,g,v,f,c=!1,m,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${v} on local port ${f}.`),!p)return;if(g||(g="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.retainOrCreateTunnel(p,g,v,f,c,m,a);return h?h.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(r);return(r.tunnelRemoteHost!==g||r.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const g=this._tunnels.get(p.tunnelRemoteHost);if(g){const v=g.get(p.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,v))}}}}async tryDisposeTunnel(p,g,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${g}.`);const f=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(g),f}}async closeTunnel(p,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${g} `);const v=this._tunnels.get(p);if(v&&v.has(g)){const f=v.get(g);f.refcount=0,await this.tryDisposeTunnel(p,g,f)}}addTunnelToMap(p,g,v){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(g,{refcount:1,value:v})}async removeEmptyTunnelFromMap(p,g){const v=this._tunnels.get(p);v&&(await v.get(g)||v.delete(g),v.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,g){const v=[p];R(p)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(p)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const f=v.map(c=>this._tunnels.get(c));for(const c of f){const m=c?.get(g);if(m)return m}}canTunnel(p){return!!k(p)}createWithProvider(p,g,v,f,c,m,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${v} on local port ${f}.`);const h=v;this._factoryInProgress.add(h);const s={elevationRequired:c?_(f===void 0?v:f):!1},i={remoteAddress:{host:g,port:v},localAddressPort:f,privacy:m,public:m?m!==D.Private:void 0,protocol:a},t=p.forwardPort(i,s);return t?(this.addTunnelToMap(g,v,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(h)})):this._factoryInProgress.delete(h),t}};b=Ge([He(0,A.ILogService)],b),e.AbstractTunnelService=b}),define(Ie[204],ke([1,0,11]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function n(E){return E.scheme!==u.Schemas.file&&E.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=n;function S(E){if(E.folders.length)return E.folders.every(k=>n(k.uri))?E.folders[0].uri:void 0;if(E.configuration&&n(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=S;function A(E){return S(E)?.scheme}e.getVirtualWorkspaceScheme=A;function C(E){return S(E)?.authority}e.getVirtualWorkspaceAuthority=C;function D(E){return S(E)!==void 0}e.isVirtualWorkspace=D}),define(Ie[45],ke([1,0,169,9,25,22,2,4,11]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function k(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=k;function R(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=R;function I(r){const s=r;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=I;function _(r){const s=r;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const i=r;if(i?.configPath)return{id:i.id,configPath:C.URI.revive(i.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=_;var P;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function b(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=b;function w(r){const s=r;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=w;class p{constructor(s,i,t,o,l){this._id=s,this._transient=t,this._configuration=o,this._ignorePathCasing=l,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class g{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function v(r){return new g({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(r,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,s.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function m(r){let s;return C.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=m;function a(r,s){return!c(r,s)&&!m(r)}e.isSavedWorkspace=a;function h(r){return(typeof r=="string"?(0,n.extname)(r):(0,A.extname)(r))===f}e.hasWorkspaceFileExtension=h}),define(Ie[87],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const A=this._idPool++;return this._data.set(A,S),this.logDebugInfo(),A}get(S,A){return this._data.has(S)?this._data.get(S)[A]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(Ie[46],ke([1,0,11,22,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new n.ExtUri(D=>{const E=this._providerInfo.get(D.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(D,E){E===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,E)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[26],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(Ie[205],ke([1,0,18]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class n{constructor(C,D,E){this._deferredPromises=new Map,this._id=C,this._shared=D,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of k.values())R.complete()}catch(R){for(const I of k.values())I.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,D){let E=this._value[C];return typeof E=="undefined"&&(E=D),E}update(C,D){this._value[C]=D;const E=this._deferredPromises.get(C);if(E!==void 0)return E.p;const k=new u.DeferredPromise;return this._deferredPromises.set(C,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=n;class S extends n{constructor(C,D){super(C.identifier.value,!0,D);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=S}),define(Ie[206],ke([1,0,3,2]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(C){this._notebooksAndEditors=C,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(C,D,E,k){const I=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(C)).acceptModelChanged(D.value,E,k);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(C,D){this._notebooksAndEditors.getNotebookDocument(n.URI.revive(C)).acceptDirty(D)}$acceptModelSaved(C){const D=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(C));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ie[17],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class n{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=n});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[207],ke([1,0,28,3]),function(X,e,u,n){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(D,E){S.set(this,void 0),this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(D.identifier),tt(this,S,E,"f"),Me(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(D){return Me(this,S,"f").get(this._id,D)}store(D,E){return Me(this,S,"f").store(this._id,D,E)}delete(D){return Me(this,S,"f").delete(this._id,D)}}e.ExtensionSecrets=A,S=new WeakMap}),define(Ie[125],ke([1,0,4,3]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new n.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new n.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(C,D){this._level=C,this._productConfig=D||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(Ie[52],ke([1,0,4,124,3,17]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(E){function k(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?n.TunnelPrivacyId.Public:n.TunnelPrivacyId.Private),protocol:I.protocol}}E.fromApiTunnel=k;function R(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==n.TunnelPrivacyId.ConstantPrivate&&I.privacy!==n.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}E.fromServiceTunnel=R})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let D=class{constructor(k){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,R){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,R){return{dispose:()=>{}}}async $providePortAttributes(k,R,I,_,P){return[]}async $forwardPort(k,R){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=Ge([He(0,A.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[7],ke([1,0,16,12,106,25,101,8,10,2,34,43,122]),function(X,e,u,n,S,A,C,D,E,k,R,I,_){"use strict";var P,b,w,p,g,v,f,c,m,a,h,r,s,i,t,o,l,d,y,L,M,F;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(x){function W(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(W,x),Object.setPrototypeOf(W.prototype,x.prototype),W}let U=v=class{constructor(W){P.set(this,void 0),tt(this,P,W,"f")}static from(...W){let ce=W;return new v(function(){if(ce){for(const Le of ce)Le&&typeof Le.dispose=="function"&&Le.dispose();ce=void 0}})}dispose(){typeof Me(this,P,"f")=="function"&&(Me(this,P,"f").call(this),tt(this,P,void 0,"f"))}};P=new WeakMap,U=v=Ge([T],U),e.Disposable=U;let N=f=class{constructor(W,ce){if(W<0)throw(0,n.illegalArgument)("line must be non-negative");if(ce<0)throw(0,n.illegalArgument)("character must be non-negative");this._line=W,this._character=ce}static Min(...W){if(W.length===0)throw new TypeError;let ce=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isBefore(ce)&&(ce=Qe)}return ce}static Max(...W){if(W.length===0)throw new TypeError;let ce=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isAfter(ce)&&(ce=Qe)}return ce}static isPosition(W){if(!W)return!1;if(W instanceof f)return!0;const{line:ce,character:Le}=W;return typeof ce=="number"&&typeof Le=="number"}static of(W){if(W instanceof f)return W;if(this.isPosition(W))return new f(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ce=0){if(W===null||ce===null)throw(0,n.illegalArgument)();let Le;return typeof W=="undefined"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,ce=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&ce===0?this:new f(this.line+Le,this.character+ce)}with(W,ce=this.character){if(W===null||ce===null)throw(0,n.illegalArgument)();let Le;return typeof W=="undefined"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,ce=typeof W.character=="number"?W.character:this.character),Le===this.line&&ce===this.character?this:new f(Le,ce)}toJSON(){return{line:this.line,character:this.character}}};N=f=Ge([T],N),e.Position=N;let H=c=class{constructor(W,ce,Le,Qe){let rt,lt;if(typeof W=="number"&&typeof ce=="number"&&typeof Le=="number"&&typeof Qe=="number"?(rt=new N(W,ce),lt=new N(Le,Qe)):N.isPosition(W)&&N.isPosition(ce)&&(rt=N.of(W),lt=N.of(ce)),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange(W){return W instanceof c?!0:W?N.isPosition(W.start)&&N.isPosition(W.end):!1}static of(W){if(W instanceof c)return W;if(this.isRange(W))return new c(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return c.isRange(W)?this.contains(W.start)&&this.contains(W.end):N.isPosition(W)?!(N.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ce=N.Max(W.start,this._start),Le=N.Min(W.end,this._end);if(!ce.isAfter(Le))return new c(ce,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ce=N.Min(W.start,this._start),Le=N.Max(W.end,this.end);return new c(ce,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ce=this.end){if(W===null||ce===null)throw(0,n.illegalArgument)();let Le;return W?N.isPosition(W)?Le=W:(Le=W.start||this.start,ce=W.end||this.end):Le=this.start,Le.isEqual(this._start)&&ce.isEqual(this.end)?this:new c(Le,ce)}toJSON(){return[this.start,this.end]}};H=c=Ge([T],H),e.Range=H;let te=m=class extends H{constructor(W,ce,Le,Qe){let rt,lt;if(typeof W=="number"&&typeof ce=="number"&&typeof Le=="number"&&typeof Qe=="number"?(rt=new N(W,ce),lt=new N(Le,Qe)):N.isPosition(W)&&N.isPosition(ce)&&(rt=N.of(W),lt=N.of(ce)),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection(W){return W instanceof m?!0:W?H.isRange(W)&&N.isPosition(W.anchor)&&N.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=m=Ge([T],te),e.Selection=te;class B{constructor(W,ce,Le){if(typeof W!="string"||W.length===0)throw(0,n.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,n.illegalArgument)("port");if(typeof Le!="undefined"&&(typeof Le!="string"||Le.length===0||!/^[0-9A-Za-z\-]+$/.test(Le)))throw(0,n.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ce),this.connectionToken=Le}}e.ResolvedAuthority=B;class z extends Error{constructor(W,ce=_.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W);this._message=W,this._code=ce,this._detail=Le,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(W,ce){return new z(W,_.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(W){return new z(W,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var q;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var V;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=a=class{constructor(W,ce){this._range=W,this._newText=ce}static isTextEdit(W){return W instanceof a?!0:W?H.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ce){return new a(W,ce)}static insert(W,ce){return a.replace(new H(W,W),ce)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const ce=new a(new H(new N(0,0),new N(0,0)),"");return ce.newEol=W,ce}get range(){return this._range}set range(W){if(W&&!H.isRange(W))throw(0,n.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,n.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,n.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=a=Ge([T],j),e.TextEdit=j;let ie=h=class{constructor(W,ce){this.range=W,this.newCells=ce}static isNotebookCellEdit(W){return W instanceof h?!0:W?zt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ce){return new h(W,ce)}static insertCells(W,ce){return new h(new zt(W,W),ce)}static deleteCells(W){return new h(W,[])}static updateCellMetadata(W,ce){const Le=new h(new zt(W,W),[]);return Le.newCellMetadata=ce,Le}static updateNotebookMetadata(W){const ce=new h(new zt(0,0),[]);return ce.newNotebookMetadata=W,ce}};ie=h=Ge([T],ie),e.NotebookEdit=ie;var Q;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(Q=e.FileEditType||(e.FileEditType={}));let ue=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ce,Le,Qe){this._edits.push({_type:1,from:W,to:ce,options:Le,metadata:Qe})}createFile(W,ce,Le){this._edits.push({_type:1,from:void 0,to:W,options:ce,metadata:Le})}deleteFile(W,ce,Le){this._edits.push({_type:1,from:W,to:void 0,options:ce,metadata:Le})}replaceNotebookMetadata(W,ce,Le){this._edits.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(W,ce,Le,Qe,rt){let lt,ut,Ct=[],Lt;if(zt.isNotebookRange(ce)&&jt.isNotebookCellDataArray(Le)&&!jt.isNotebookCellDataArray(Qe)?(lt=ce.start,ut=ce.end,Ct=Le,Lt=Qe):typeof ce=="number"&&typeof Le=="number"&&jt.isNotebookCellDataArray(Qe)&&(lt=ce,ut=Le,Ct=Qe,Lt=rt),lt===void 0||ut===void 0)throw new Error("Invalid arguments");(lt!==ut||Ct.length>0)&&this._edits.push({_type:5,uri:W,index:lt,count:ut-lt,cells:Ct,metadata:Lt})}replaceNotebookCellMetadata(W,ce,Le,Qe){this._edits.push({_type:3,metadata:Qe,uri:W,edit:{editType:8,index:ce,metadata:Le}})}replace(W,ce,Le,Qe){this._edits.push({_type:2,uri:W,edit:new j(ce,Le),metadata:Qe})}insert(W,ce,Le,Qe){this.replace(W,new H(ce,ce),Le,Qe)}delete(W,ce,Le){this.replace(W,ce,"",Le)}has(W){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===W.toString())}set(W,ce){if(ce)for(const Le of ce)Le&&(ie.isNotebookCellEdit(Le)?Le.newCellMetadata?this.replaceNotebookCellMetadata(W,Le.range.start,Le.newCellMetadata):Le.newNotebookMetadata?this.replaceNotebookMetadata(W,Le.newNotebookMetadata):this.replaceNotebookCells(W,Le.range,Le.newCells):this._edits.push({_type:2,uri:W,edit:Le}));else{for(let Le=0;Le<this._edits.length;Le++){const Qe=this._edits[Le];Qe._type===2&&Qe.uri.toString()===W.toString()&&(this._edits[Le]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(W){const ce=[];for(const Le of this._edits)Le._type===2&&Le.uri.toString()===W.toString()&&ce.push(Le.edit);return ce}entries(){const W=new A.ResourceMap;for(const ce of this._edits)if(ce._type===2){let Le=W.get(ce.uri);Le||(Le=[ce.uri,[]],W.set(ce.uri,Le)),Le[1].push(ce.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ue=Ge([T],ue),e.WorkspaceEdit=ue;let ve=r=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof r?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=r._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ce=this._tabstop++){if(typeof W=="function"){const Le=new r;Le._tabstop=this._tabstop,W(Le),this._tabstop=Le._tabstop,W=Le.value}else W=r._escape(W);return this.value+="${",this.value+=ce,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ce=this._tabstop++){const Le=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,ce){if(typeof ce=="function"){const Le=new r;Le._tabstop=this._tabstop,ce(Le),this._tabstop=Le._tabstop,ce=Le.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ve=r=Ge([T],ve),e.SnippetString=ve;var J;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(J=e.DiagnosticTag||(e.DiagnosticTag={}));var ge;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ge=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Ee=s=class{constructor(W,ce){if(this.uri=W,ce)if(H.isRange(ce))this.range=H.of(ce);else if(N.isPosition(ce))this.range=new H(ce,ce);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof s?!0:W?H.isRange(W.range)&&k.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Ee=s=Ge([T],Ee),e.Location=Ee;let Pe=class{constructor(W,ce){this.location=W,this.message=ce}static is(W){return W?typeof W.message=="string"&&W.location&&H.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}static isEqual(W,ce){return W===ce?!0:!W||!ce?!1:W.message===ce.message&&W.location.range.isEqual(ce.location.range)&&W.location.uri.toString()===ce.location.uri.toString()}};Pe=Ge([T],Pe),e.DiagnosticRelatedInformation=Pe;let me=class{constructor(W,ce,Le=ge.Error){if(!H.isRange(W))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=W,this.message=ce,this.severity=Le}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ce){return W===ce?!0:!W||!ce?!1:W.message===ce.message&&W.severity===ce.severity&&W.code===ce.code&&W.severity===ce.severity&&W.source===ce.source&&W.range.isEqual(ce.range)&&(0,u.equals)(W.tags,ce.tags)&&(0,u.equals)(W.relatedInformation,ce.relatedInformation,Pe.isEqual)}};me=Ge([T],me),e.Diagnostic=me;let Te=class{constructor(W,ce){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ce}};Te=Ge([T],Te),e.Hover=Te;var le;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let pe=class{constructor(W,ce=le.Text){this.range=W,this.kind=ce}toJSON(){return{range:this.range,kind:le[this.kind]}}};pe=Ge([T],pe),e.DocumentHighlight=pe;var be;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(be=e.SymbolKind||(e.SymbolKind={}));var ae;(function(x){x[x.Deprecated=1]="Deprecated"})(ae=e.SymbolTag||(e.SymbolTag={}));let he=i=class{constructor(W,ce,Le,Qe,rt){this.name=W,this.kind=ce,this.containerName=rt,typeof Le=="string"&&(this.containerName=Le),Qe instanceof Ee?this.location=Qe:Le instanceof H&&(this.location=new Ee(Qe,Le)),i.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:be[this.kind],location:this.location,containerName:this.containerName}}};he=i=Ge([T],he),e.SymbolInformation=he;let ee=t=class{constructor(W,ce,Le,Qe,rt){this.name=W,this.detail=ce,this.kind=Le,this.range=Qe,this.selectionRange=rt,this.children=[],t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(t.validate)}};ee=t=Ge([T],ee),e.DocumentSymbol=ee;var ne;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let O=class{constructor(W,ce){this.title=W,this.kind=ce}};O=Ge([T],O),e.CodeAction=O;let $=o=class{constructor(W){this.value=W}append(W){return new o(this.value?this.value+o.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+o.sep)}};$.sep=".",$=o=Ge([T],$),e.CodeActionKind=$,$.Empty=new $(""),$.QuickFix=$.Empty.append("quickfix"),$.Refactor=$.Empty.append("refactor"),$.RefactorExtract=$.Refactor.append("extract"),$.RefactorInline=$.Refactor.append("inline"),$.RefactorRewrite=$.Refactor.append("rewrite"),$.Source=$.Empty.append("source"),$.SourceOrganizeImports=$.Source.append("organizeImports"),$.SourceFixAll=$.Source.append("fixAll");let G=class{constructor(W,ce){if(this.range=W,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};G=Ge([T],G),e.SelectionRange=G;class K{constructor(W,ce,Le,Qe,rt,lt){this.kind=W,this.name=ce,this.detail=Le,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=K;class de{constructor(W,ce){this.fromRanges=ce,this.from=W}}e.CallHierarchyIncomingCall=de;class we{constructor(W,ce){this.fromRanges=ce,this.to=W}}e.CallHierarchyOutgoingCall=we;var se;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(se=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let De=class{constructor(W,ce){this.range=W,this.command=ce}get isResolved(){return!!this.command}};De=Ge([T],De),e.CodeLens=De;let Ce=l=class{constructor(W,ce=!1){b.set(this,void 0),tt(this,b,new S.MarkdownString(W,{supportThemeIcons:ce}),"f")}static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Me(this,b,"f").value}set value(W){Me(this,b,"f").value=W}get isTrusted(){return Me(this,b,"f").isTrusted}set isTrusted(W){Me(this,b,"f").isTrusted=W}get supportThemeIcons(){return Me(this,b,"f").supportThemeIcons}set supportThemeIcons(W){Me(this,b,"f").supportThemeIcons=W}get supportHtml(){return Me(this,b,"f").supportHtml}set supportHtml(W){Me(this,b,"f").supportHtml=W}get baseUri(){return Me(this,b,"f").baseUri}set baseUri(W){Me(this,b,"f").baseUri=W}appendText(W){return Me(this,b,"f").appendText(W),this}appendMarkdown(W){return Me(this,b,"f").appendMarkdown(W),this}appendCodeblock(W,ce){return Me(this,b,"f").appendCodeblock(ce??"",W),this}};b=new WeakMap,Ce=l=Ge([T],Ce),e.MarkdownString=Ce;let ze=class{constructor(W,ce){this.label=W,this.documentation=ce}};ze=Ge([T],ze),e.ParameterInformation=ze;let Ke=class{constructor(W,ce){this.label=W,this.documentation=ce,this.parameters=[]}};Ke=Ge([T],Ke),e.SignatureInformation=Ke;let Ne=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ne=Ge([T],Ne),e.SignatureHelp=Ne;var Ye;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Ye=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Z;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Z=e.InlayHintKind||(e.InlayHintKind={}));let re=class{constructor(W){this.value=W}};re=Ge([T],re),e.InlayHintLabelPart=re;let ye=class{constructor(W,ce,Le){this.position=W,this.label=ce,this.kind=Le}};ye=Ge([T],ye),e.InlayHint=ye;var We;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(We=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(oe=e.CompletionItemKind||(e.CompletionItemKind={}));var Re;(function(x){x[x.Deprecated=1]="Deprecated"})(Re=e.CompletionItemTag||(e.CompletionItemTag={}));let Be=class{constructor(W,ce){this.label=W,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Be=Ge([T],Be),e.CompletionItem=Be;let qe=class{constructor(W=[],ce=!1){this.items=W,this.isIncomplete=ce}};qe=Ge([T],qe),e.CompletionList=qe;let je=class{constructor(W,ce,Le){this.insertText=W,this.range=ce,this.command=Le}};je=Ge([T],je),e.InlineSuggestion=je;let Ve=class{constructor(W){this.commands=void 0,this.items=W}};Ve=Ge([T],Ve),e.InlineSuggestionList=Ve;let nt=class{constructor(W,ce,Le){this.insertText=W,this.range=ce,this.command=Le}};nt=Ge([T],nt),e.InlineSuggestionNew=nt;let ot=class{constructor(W,ce){this.items=W,this.commands=ce}};ot=Ge([T],ot),e.InlineSuggestionsNew=ot;var st;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var it;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var bt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(bt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Pt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Pt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var St;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(St=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var It;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(It=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function W(ce){switch(ce){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=W}(St=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(W,ce){if(ce&&!k.URI.isUri(ce))throw(0,n.illegalArgument)("target");if(!H.isRange(W)||W.isEmpty)throw(0,n.illegalArgument)("range");this.range=W,this.target=ce}};Ft=Ge([T],Ft),e.DocumentLink=Ft;let At=class{constructor(W,ce,Le,Qe){this.red=W,this.green=ce,this.blue=Le,this.alpha=Qe}};At=Ge([T],At),e.Color=At;let Xe=class{constructor(W,ce){if(ce&&!(ce instanceof At))throw(0,n.illegalArgument)("color");if(!H.isRange(W)||W.isEmpty)throw(0,n.illegalArgument)("range");this.range=W,this.color=ce}};Xe=Ge([T],Xe),e.ColorInformation=Xe;let Rt=class{constructor(W){if(!W||typeof W!="string")throw(0,n.illegalArgument)("label");this.label=W}};Rt=Ge([T],Rt),e.ColorPresentation=Rt;var Mt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class mt{constructor(W,ce,Le){if(this.startIndex=W,this.length=ce,this.tooltip=Le,typeof W!="number"||W<0)throw(0,n.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,n.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,n.illegalArgument)("tooltip")}}e.TerminalLink=mt;var Dt;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Dt=e.TerminalLocation||(e.TerminalLocation={}));class Ae{constructor(W){if(this.options=W,typeof W!="object")throw(0,n.illegalArgument)("options")}}e.TerminalProfile=Ae;var Oe;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var Se;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Se=e.TaskPanelKind||(e.TaskPanelKind={}));let Y=d=class{constructor(W,ce){if(this.label=ce,typeof W!="string"||typeof ce!="string")throw(0,n.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Y.Clean=new d("clean","Clean"),Y.Build=new d("build","Build"),Y.Rebuild=new d("rebuild","Rebuild"),Y.Test=new d("test","Test"),Y=d=Ge([T],Y),e.TaskGroup=Y;function Fe(x){let W="";for(let ce=0;ce<x.length;ce++)W+=x[ce].replace(/,/g,",,")+",";return W}let xe=class{constructor(W,ce,Le){if(typeof W!="string")throw(0,n.illegalArgument)("process");this._args=[],this._process=W,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=Le):this._options=ce)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,n.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ce of this._args)W.push(ce);return Fe(W)}};xe=Ge([T],xe),e.ProcessExecution=xe;let Je=class{constructor(W,ce,Le){if(this._args=[],Array.isArray(ce)){if(!W)throw(0,n.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,n.illegalArgument)("command");this._command=W,this._args=ce,this._options=Le}else{if(typeof W!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=W,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,n.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ce of this._args)W.push(typeof ce=="string"?ce:ce.value);return Fe(W)}};Je=Ge([T],Je),e.ShellExecution=Je;var et;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(et=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class gt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=gt;let pt=y=class{constructor(W,ce,Le,Qe,rt,lt){this.__deprecated=!1,this._definition=this.definition=W;let ut;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=Le,this.execution=Qe,ut=rt,this.__deprecated=!0):ce===Ze.Global||ce===Ze.Workspace?(this.target=ce,this._name=this.name=Le,this._source=this.source=Qe,this.execution=rt,ut=lt):(this.target=ce,this._name=this.name=Le,this._source=this.source=Qe,this.execution=rt,ut=lt),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof xe?this._definition={type:y.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:y.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:y.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:y.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,n.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,n.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ce=this._definition.type;(y.EmptyType===ce||y.ProcessType===ce||y.ShellType===ce||y.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,n.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=y=Ge([T],pt),e.Task=pt;var yt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(W,ce=ht.None){this.collapsibleState=ce,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};vt=Ge([T],vt),e.TreeItem=vt;var ht;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Kt=class{constructor(W){this.value=W}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Kt=Ge([T],Kt),e.DataTransferItem=Kt;let Xt=class{constructor(W){w.set(this,new Map);for(const[ce,Le]of W??[]){const Qe=Me(this,w,"f").get(ce);Qe?Qe.push(Le):Me(this,w,"f").set(ce,[Le])}}get(W){return Me(this,w,"f").get(W)?.[0]}set(W,ce){Me(this,w,"f").set(W,[ce])}forEach(W,ce){for(const[Le,Qe]of Me(this,w,"f"))for(const rt of Qe)W.call(ce,rt,Le,this)}*[(w=new WeakMap,Symbol.iterator)](){for(const[W,ce]of Me(this,w,"f"))for(const Le of ce)yield[W,Le]}};Xt=Ge([T],Xt),e.DataTransfer=Xt;let Et=class{constructor(W){this.insertText=W}};Et=Ge([T],Et),e.DocumentDropEdit=Et;let rn=class{constructor(W){this.insertText=W}};rn=Ge([T],rn),e.DocumentPasteEdit=rn;let Ut=class{constructor(W,ce){this.id=W,this.color=ce}};Ut=Ge([T],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let sn=class{constructor(W){this.id=W}};sn=Ge([T],sn),e.ThemeColor=sn;var kn;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(kn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(W,ce){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,n.illegalArgument)("base");if(typeof ce!="string")throw(0,n.illegalArgument)("pattern");typeof W=="string"?this.baseUri=k.URI.file(W):k.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ce}get base(){return this._base}set base(W){this._base=W,this._baseUri=k.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};kt=Ge([T],kt),e.RelativePattern=kt;let xt=class{constructor(W,ce,Le,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ce=="string"&&(this.condition=ce),typeof Le=="string"&&(this.hitCondition=Le),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};xt=Ge([T],xt),e.Breakpoint=xt;let fn=class extends xt{constructor(W,ce,Le,Qe,rt){super(ce,Le,Qe,rt);if(W===null)throw(0,n.illegalArgument)("location");this.location=W}};fn=Ge([T],fn),e.SourceBreakpoint=fn;let Qt=class extends xt{constructor(W,ce,Le,Qe,rt){super(ce,Le,Qe,rt);this.functionName=W}};Qt=Ge([T],Qt),e.FunctionBreakpoint=Qt;let Yt=class extends xt{constructor(W,ce,Le,Qe,rt,lt,ut){super(Qe,rt,lt,ut);if(!ce)throw(0,n.illegalArgument)("dataId");this.label=W,this.dataId=ce,this.canPersist=Le}};Yt=Ge([T],Yt),e.DataBreakpoint=Yt;let dt=class{constructor(W,ce,Le){this.command=W,this.args=ce||[],this.options=Le}};dt=Ge([T],dt),e.DebugAdapterExecutable=dt;let mn=class{constructor(W,ce){this.port=W,this.host=ce}};mn=Ge([T],mn),e.DebugAdapterServer=mn;let Bt=class{constructor(W){this.path=W}};Bt=Ge([T],Bt),e.DebugAdapterNamedPipeServer=Bt;let Vt=class{constructor(W){this.implementation=W}};Vt=Ge([T],Vt),e.DebugAdapterInlineImplementation=Vt;let on=class{constructor(W,ce){this.range=W,this.expression=ce}};on=Ge([T],on),e.EvaluatableExpression=on;var Tn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Tn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Sn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Sn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let gn=class{constructor(W,ce){this.range=W,this.text=ce}};gn=Ge([T],gn),e.InlineValueText=gn;let an=class{constructor(W,ce,Le=!0){this.range=W,this.variableName=ce,this.caseSensitiveLookup=Le}};an=Ge([T],an),e.InlineValueVariableLookup=an;let Jt=class{constructor(W,ce){this.range=W,this.expression=ce}};Jt=Ge([T],Jt),e.InlineValueEvaluatableExpression=Jt;let pn=class{constructor(W,ce){this.frameId=W,this.stoppedLocation=ce}};pn=Ge([T],pn),e.InlineValueContext=pn;var vn;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(vn=e.FileChangeType||(e.FileChangeType={}));let Zt=L=class extends Error{constructor(W,ce=I.FileSystemProviderErrorCode.Unknown,Le){super(k.URI.isUri(W)?W.toString(!0):W);this.code=Le?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}static FileExists(W){return new L(W,I.FileSystemProviderErrorCode.FileExists,L.FileExists)}static FileNotFound(W){return new L(W,I.FileSystemProviderErrorCode.FileNotFound,L.FileNotFound)}static FileNotADirectory(W){return new L(W,I.FileSystemProviderErrorCode.FileNotADirectory,L.FileNotADirectory)}static FileIsADirectory(W){return new L(W,I.FileSystemProviderErrorCode.FileIsADirectory,L.FileIsADirectory)}static NoPermissions(W){return new L(W,I.FileSystemProviderErrorCode.NoPermissions,L.NoPermissions)}static Unavailable(W){return new L(W,I.FileSystemProviderErrorCode.Unavailable,L.Unavailable)}};Zt=L=Ge([T],Zt),e.FileSystemError=Zt;let wn=class{constructor(W,ce,Le){this.start=W,this.end=ce,this.kind=Le}};wn=Ge([T],wn),e.FoldingRange=wn;var Pn;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Pn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var en;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(en=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var An;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(An=e.CommentMode||(e.CommentMode={}));var Rn;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Rn=e.CommentThreadState||(e.CommentThreadState={}));class Ln{constructor(W,ce=[]){this.tokenTypes=W,this.tokenModifiers=ce}}e.SemanticTokensLegend=Ln;function On(x){return typeof x=="undefined"||(0,E.isStringArray)(x)}class tn{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ce=0,Le=W.tokenTypes.length;ce<Le;ce++)this._tokenTypeStrToInt.set(W.tokenTypes[ce],ce);for(let ce=0,Le=W.tokenModifiers.length;ce<Le;ce++)this._tokenModifierStrToInt.set(W.tokenModifiers[ce],ce)}}push(W,ce,Le,Qe,rt){if(typeof W=="number"&&typeof ce=="number"&&typeof Le=="number"&&typeof Qe=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded(W,ce,Le,Qe,rt);if(H.isRange(W)&&typeof ce=="string"&&On(Le))return this._push(W,ce,Le);throw(0,n.illegalArgument)()}_push(W,ce,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,rt=W.start.character,lt=W.end.character-W.start.character,ut=this._tokenTypeStrToInt.get(ce);let Ct=0;if(Le)for(const Lt of Le){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Lt);Ct|=1<<Wt>>>0}this._pushEncoded(Qe,rt,lt,ut,Ct)}_pushEncoded(W,ce,Le,Qe,rt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Lt=0,Wt=0;for(let Ht=0;Ht<Ct;Ht++){let qt=this._data[5*Ht],En=this._data[5*Ht+1];qt===0?(qt=Lt,En+=Wt):qt+=Lt,this._data[5*Ht]=qt,this._data[5*Ht+1]=En,Lt=qt,Wt=En}}let lt=W,ut=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=rt,this._prevLine=W,this._prevChar=ce}static _sortAndDeltaEncode(W){const ce=[],Le=W.length/5|0;for(let ut=0;ut<Le;ut++)ce[ut]=ut;ce.sort((ut,Ct)=>{const Lt=W[5*ut],Wt=W[5*Ct];if(Lt===Wt){const Ht=W[5*ut+1],qt=W[5*Ct+1];return Ht-qt}return Lt-Wt});const Qe=new Uint32Array(W.length);let rt=0,lt=0;for(let ut=0;ut<Le;ut++){const Ct=5*ce[ut],Lt=W[Ct+0],Wt=W[Ct+1],Ht=W[Ct+2],qt=W[Ct+3],En=W[Ct+4],Xn=Lt-rt,gi=Xn===0?Wt-lt:Wt,_n=5*ut;Qe[_n+0]=Xn,Qe[_n+1]=gi,Qe[_n+2]=Ht,Qe[_n+3]=qt,Qe[_n+4]=En,rt=Lt,lt=Wt}return Qe}build(W){return this._dataIsSortedAndDeltaEncoded?new cn(new Uint32Array(this._data),W):new cn(tn._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=tn;class cn{constructor(W,ce){this.resultId=ce,this.data=W}}e.SemanticTokens=cn;class yn{constructor(W,ce,Le){this.start=W,this.deleteCount=ce,this.data=Le}}e.SemanticTokensEdit=yn;class $e{constructor(W,ce){this.resultId=ce,this.edits=W}}e.SemanticTokensEdits=$e;var $t;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})($t=e.DebugConsoleMode||(e.DebugConsoleMode={}));let nn=class{constructor(){}};nn.Back={iconPath:new Ut("arrow-left")},nn=Ge([T],nn),e.QuickInputButtons=nn;var wt;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(wt=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Nn;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Nn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Fn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Fn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(W,ce,Le){this.badge=W,this.tooltip=ce,this.color=Le}static validate(W){if(W.badge){let ce=(0,D.nextCharLength)(W.badge,0);if(ce<W.badge.length&&(ce+=(0,D.nextCharLength)(W.badge,ce)),W.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Cn;let bn=class{constructor(W){this.kind=W}};bn=Ge([T],bn),e.ColorTheme=bn;var ln;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(ln=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(W,ce){if(W<0)throw(0,n.illegalArgument)("start must be positive");if(ce<0)throw(0,n.illegalArgument)("end must be positive");W<=ce?(this._start=W,this._end=ce):(this._start=ce,this._end=W)}static isNotebookRange(W){return W instanceof zt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let ce=this._start,Le=this._end;return W.start!==void 0&&(ce=W.start),W.end!==void 0&&(Le=W.end),ce===this._start&&Le===this._end?this:new zt(ce,Le)}}e.NotebookRange=zt;class jt{constructor(W,ce,Le,Qe,rt,lt,ut){this.kind=W,this.value=ce,this.languageId=Le,this.mime=Qe,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ut,jt.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ce=>jt.isNotebookCellData(ce))}static isNotebookCellData(W){return!0}}e.NotebookCellData=jt;class Mn{constructor(W){this.cells=W}}e.NotebookData=Mn;class Nt{constructor(W,ce){this.data=W,this.mime=ce;const Le=(0,C.normalizeMimeType)(ce,!0);if(!Le)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}static isNotebookCellOutputItem(W){return W instanceof Nt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ce={name:W.name,message:W.message,stack:W.stack};return Nt.json(ce,"application/vnd.code.notebook.error")}static stdout(W){return Nt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Nt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ce="application/octet-stream"){return new Nt(W,ce)}static text(W,ce=C.Mimes.text){const Le=Me(Nt,p,"f",g).encode(String(W));return new Nt(Le,ce)}static json(W,ce="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Nt.text(Le,ce)}}e.NotebookCellOutputItem=Nt,p=Nt,g={value:new TextEncoder};class un{constructor(W,ce,Le){this.items=un.ensureUniqueMimeTypes(W,!0),typeof ce=="string"?(this.id=ce,this.metadata=Le):(this.id=(0,R.generateUuid)(),this.metadata=ce??Le)}static isNotebookCellOutput(W){return W instanceof un?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,E.isArray)(W.items)}static ensureUniqueMimeTypes(W,ce=!1){const Le=new Set,Qe=new Set;for(let rt=0;rt<W.length;rt++){const lt=W[rt],ut=(0,C.normalizeMimeType)(lt.mime);if(!Le.has(ut)){Le.add(ut);continue}Qe.add(rt),ce&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Qe.size===0?W:W.filter((rt,lt)=>!Qe.has(lt))}}e.NotebookCellOutput=un;var Un;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Un=e.NotebookCellKind||(e.NotebookCellKind={}));var Bn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Bn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var zn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(zn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Wn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Wn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class fe{constructor(W,ce){this.text=W,this.alignment=ce}}e.NotebookCellStatusBarItem=fe;var _e;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(_e=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ue{constructor(W,ce=[]){this.uri=W,this.provides=(0,u.asArray)(ce)}}e.NotebookRendererScript=Ue;let ct=class{constructor(W,ce){this.label=W,this.timestamp=ce}};ct=Ge([T],ct),e.TimelineItem=ct;var _t;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(_t=e.ExtensionMode||(e.ExtensionMode={}));var Tt;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Tt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Zn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Zn=e.StandardTokenType||(e.StandardTokenType={}));class ei{constructor(W,ce){this.ranges=W,this.wordPattern=ce}}e.LinkedEditingRanges=ei;class ti{constructor(W,ce){this._port=W,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ti;var ni;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(ni=e.TestResultState||(e.TestResultState={}));var ii;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(ii=e.TestRunProfileKind||(e.TestRunProfileKind={}));let $n=class{constructor(W=void 0,ce=void 0,Le=void 0){this.include=W,this.exclude=ce,this.profile=Le}};$n=Ge([T],$n),e.TestRunRequest=$n;let Hn=M=class{constructor(W){this.message=W}static diff(W,ce,Le){const Qe=new M(W);return Qe.expectedOutput=ce,Qe.actualOutput=Le,Qe}};Hn=M=Ge([T],Hn),e.TestMessage=Hn;let xn=class{constructor(W){this.id=W}};xn=Ge([T],xn),e.TestTag=xn;let dn=class{constructor(W,ce){this.covered=W,this.total=ce}};dn=Ge([T],dn),e.CoveredCount=dn;let Vn=F=class{constructor(W,ce,Le,Qe){this.uri=W,this.statementCoverage=ce,this.branchCoverage=Le,this.functionCoverage=Qe}static fromDetails(W,ce){const Le=new dn(0,0),Qe=new dn(0,0),rt=new dn(0,0);for(const ut of ce)if("branches"in ut){Le.total+=1,Le.covered+=ut.executionCount>0?1:0;for(const Ct of ut.branches)Qe.total+=1,Qe.covered+=Ct.executionCount>0?1:0}else rt.total+=1,rt.covered+=ut.executionCount>0?1:0;const lt=new F(W,Le,Qe.total>0?Qe:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ce,lt}};Vn=F=Ge([T],Vn),e.FileCoverage=Vn;let jn=class{constructor(W,ce,Le=[]){this.executionCount=W,this.location=ce,this.branches=Le}};jn=Ge([T],jn),e.StatementCoverage=jn;let qn=class{constructor(W,ce){this.executionCount=W,this.location=ce}};qn=Ge([T],qn),e.BranchCoverage=qn;let Gn=class{constructor(W,ce){this.executionCount=W,this.location=ce}};Gn=Ge([T],Gn),e.FunctionCoverage=Gn;var ri;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(ri=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var si;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(si=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var oi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(oi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ai{constructor(W,ce,Le,Qe,rt,lt){this.kind=W,this.name=ce,this.detail=Le,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=ai;class ci{constructor(W){this.uri=W}}e.TextTabInput=ci;class li{constructor(W,ce){this.original=W,this.modified=ce}}e.TextDiffTabInput=li;class ui{constructor(W,ce){this.uri=W,this.viewType=ce}}e.CustomEditorTabInput=ui;class di{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=di;class hi{constructor(W,ce){this.uri=W,this.notebookType=ce}}e.NotebookEditorTabInput=hi;class fi{constructor(W,ce,Le){this.original=W,this.modified=ce,this.notebookType=Le}}e.NotebookDiffEditorTabInput=fi;class mi{constructor(){}}e.TerminalEditorTabInput=mi}),define(Ie[126],ke([1,0,56,11,8,158,99,7,16]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function R(b,w){w?k.set(b,w):k.delete(b)}e.setWordDefinitionFor=R;function I(b){return k.get(b)}e.getWordDefinitionFor=I;class _ extends A.MirrorTextModel{constructor(w,p,g,v,f,c,m,a){super(p,g,v,f);this._proxy=w,this._languageId=c,this._isDirty=m,this.notebook=a,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,E.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===n.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},save(){return w._save()},getText(p){return p?w._getTextInRange(p):w.getText()},get eol(){return w._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(p){return w._lineAt(p)},offsetAt(p){return w._offsetAt(p)},positionAt(p){return w._positionAt(p)},validateRange(p){return w._validateRange(p)},validatePosition(p){return w._validatePosition(p)},getWordRangeAtPosition(p,g){return w._getWordRangeAtPosition(p,g)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,u.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,u.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const p=this._validateRange(w);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const g=this._eol,v=p.start.line,f=p.end.line,c=[];c.push(this._lines[v].substring(p.start.character));for(let m=v+1;m<f;m++)c.push(this._lines[m]);return c.push(this._lines[f].substring(0,p.end.character)),c.join(g)}_lineAt(w){let p;if(w instanceof D.Position?p=w.line:typeof w=="number"&&(p=w),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new P(p,this._lines[p],p===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(w),g=this._lines[p.index].length;return new D.Position(p.index,Math.min(p.remainder,g))}_validateRange(w){if(!(w instanceof D.Range))throw new Error("Invalid argument");const p=this._validatePosition(w.start),g=this._validatePosition(w.end);return p===w.start&&g===w.end?w:new D.Range(p.line,p.character,g.line,g.character)}_validatePosition(w){if(!(w instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:p,character:g}=w,v=!1;if(p<0)p=0,g=0,v=!0;else if(p>=this._lines.length)p=this._lines.length-1,g=this._lines[p].length,v=!0;else{const f=this._lines[p].length;g<0?(g=0,v=!0):g>f&&(g=f,v=!0)}return v?new D.Position(p,g):w}_getWordRangeAtPosition(w,p){const g=this._validatePosition(w);if(!p)p=I(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const v=(0,C.getWordAtText)(g.character+1,(0,C.ensureValidWordDefinition)(p),this._lines[g.line],0);if(v)return new D.Range(g.line,v.startColumn-1,g.line,v.endColumn-1)}}e.ExtHostDocumentData=_;class P{constructor(w,p,g){this._line=w,this._text=p,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=P}),define(Ie[208],ke([1,0,7,17,3]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(D){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let E;switch(D){case"light":E=u.ColorThemeKind.Light;break;case"hcDark":E=u.ColorThemeKind.HighContrast;break;case"hcLight":E=u.ColorThemeKind.HighContrastLight;break;default:E=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ge([He(0,n.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Ie[64],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class n{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=n}),define(Ie[209],ke([1,0,23]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class n{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function S(D,E){if(E.serializeBuffersForPostMessage){const k=new n,R=(P,b)=>{if(b instanceof ArrayBuffer){const w=k.add(b);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(b)){const w=A(b);if(w){const p=k.add(b.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:w,byteLength:b.byteLength,byteOffset:b.byteOffset}}}}return b},I=JSON.stringify(D,R),_=k.buffers.map(P=>{const b=new Uint8Array(P);return u.VSBuffer.wrap(b)});return{message:I,buffers:_}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=S;function A(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(D,E){const k=E.map(_=>{const P=new ArrayBuffer(_.byteLength);return new Uint8Array(P).set(_.buffer),P}),R=E.length?(_,P)=>{if(P&&typeof P=="object"&&P.$$vscode_array_buffer_reference$$){const b=P,{index:w}=b,p=k[w];if(b.view)switch(b.view.type){case 1:return new Int8Array(p,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return P}:void 0;return{message:JSON.parse(D,R),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(Ie[210],ke([1,0,108]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function n(A){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:A,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function S(A){return new u.URITransformer(n(A))}e.createURITransformer=S}),define(Ie[211],ke([1,0,179,10,2,6,4,44,43,16,11]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(B){B[B.PROGRAMMATIC=1]="PROGRAMMATIC",B[B.USER=2]="USER",B[B.EDIT=3]="EDIT",B[B.NAVIGATION=4]="NAVIGATION",B[B.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var _;(function(B){B[B.IDENTICAL=1]="IDENTICAL",B[B.SIMILAR=2]="SIMILAR",B[B.DIFFERENT=3]="DIFFERENT"})(_=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function P(B){const z=B;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}e.isEditorPaneWithSelection=P;function b(B,z,q){for(const V of q.visibleEditorPanes)if(V.group.id===z&&B.matches(V.input))return V.getViewState()}e.findViewStateForEditor=b;function w(B){if(r(B))return!1;const z=B;return S.URI.isUri(z?.resource)}e.isResourceEditorInput=w;function p(B){if(r(B))return!1;const z=B;return z?.original!==void 0&&z.modified!==void 0}e.isResourceDiffEditorInput=p;function g(B){if(r(B)||p(B))return!1;const z=B;return z?.primary!==void 0&&z.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function v(B){if(r(B))return!1;const z=B;return z?z.resource===void 0||z.resource.scheme===R.Schemas.untitled||z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var f;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var c;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class m{constructor(){this.mapIdToSaveSource=new Map}registerSource(z,q){let V=this.mapIdToSaveSource.get(z);return V||(V={source:z,label:q},this.mapIdToSaveSource.set(z,V)),V.source}getSourceLabel(z){return this.mapIdToSaveSource.get(z)?.label??z}}e.SaveSourceRegistry=new m;var a;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription",B[B.CanDropIntoEditor=128]="CanDropIntoEditor"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends A.Disposable{}e.AbstractEditorInput=h;function r(B){return B instanceof h}e.isEditorInput=r;function s(B){const z=B;return S.URI.isUri(z?.preferredResource)}function i(B){const z=B;return r(z?.primary)&&r(z?.secondary)}e.isSideBySideEditorInput=i;function t(B){const z=B;return r(z?.modified)&&r(z?.original)}e.isDiffEditorInput=t;function o(B){return r(B?.editor)}e.isEditorInputWithOptions=o;function l(B){const z=B;return o(B)&&z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=l;function d(B){const z=B;return typeof z?.groupId=="number"&&r(z.editor)}e.isEditorIdentifier=d;var y;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(y=e.EditorCloseContext||(e.EditorCloseContext={}));var L;(function(B){B[B.GROUP_ACTIVE=0]="GROUP_ACTIVE",B[B.GROUP_INDEX=1]="GROUP_INDEX",B[B.GROUP_LOCKED=2]="GROUP_LOCKED",B[B.EDITOR_OPEN=3]="EDITOR_OPEN",B[B.EDITOR_CLOSE=4]="EDITOR_CLOSE",B[B.EDITOR_MOVE=5]="EDITOR_MOVE",B[B.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",B[B.EDITOR_LABEL=7]="EDITOR_LABEL",B[B.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",B[B.EDITOR_PIN=9]="EDITOR_PIN",B[B.EDITOR_STICKY=10]="EDITOR_STICKY",B[B.EDITOR_DIRTY=11]="EDITOR_DIRTY",B[B.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var M;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(M=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(z,q){if(!z)return;if(q?.supportSideBySide){const{primary:j,secondary:ie}=this.getSideEditors(z);if(j&&ie){if(q?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===M.ANY)return this.getOriginalUri(j,{filterByScheme:q.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:q.filterByScheme});z=q.supportSideBySide===M.PRIMARY?j:ie}}if(p(z)||g(z))return;const V=s(z)?z.preferredResource:z.resource;return!V||!q||!q.filterByScheme?V:this.filterUri(V,q.filterByScheme)}getSideEditors(z){return i(z)||g(z)?{primary:z.primary,secondary:z.secondary}:t(z)||p(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,q){if(!z)return;if(q?.supportSideBySide){const{primary:j,secondary:ie}=this.getSideEditors(z);if(j&&ie){if(q?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===M.ANY)return this.getCanonicalUri(j,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:q.filterByScheme});z=q.supportSideBySide===M.PRIMARY?j:ie}}if(p(z)||g(z))return;const V=z.resource;return!V||!q||!q.filterByScheme?V:this.filterUri(V,q.filterByScheme)}filterUri(z,q){if(Array.isArray(q)){if(q.some(V=>z.scheme===V))return z}else if(q===z.scheme)return z}}e.EditorResourceAccessor=new F;var T;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(T=e.CloseDirection||(e.CloseDirection={}));class U{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(z){const q=this.instantiationService=z.get(C.IInstantiationService);for(const[V,j]of this.editorSerializerConstructors)this.createEditorSerializer(V,j,q);this.editorSerializerConstructors.clear()}createEditorSerializer(z,q,V){const j=V.createInstance(q);this.editorSerializerInstances.set(z,j)}registerFileEditorFactory(z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=z}getFileEditorFactory(){return(0,n.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(z,q){if(this.editorSerializerConstructors.has(z)||this.editorSerializerInstances.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(z,q,this.instantiationService):this.editorSerializerConstructors.set(z,q),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(z),this.editorSerializerInstances.delete(z)})}getEditorSerializer(z){return this.editorSerializerInstances.get(typeof z=="string"?z:z.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new U);async function N(B,z){if(!B||!B.length)return[];const q=await Promise.all(B.map(async V=>{const j=S.URI.revive(V.fileUri);if(!j||!await z.canHandleResource(j))return;let Q=V.exists,ue=V.type;if(typeof Q!="boolean"||typeof ue!="number")try{ue=(await z.stat(j)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Q=!0}catch{Q=!1}if(!Q&&V.openOnlyIfExists||ue===E.FileType.Directory)return;const ve={...V.options,pinned:!0};let J;return Q?J={resource:j,options:ve}:J={resource:j,options:ve,forceUntitled:!0},J}));return(0,k.coalesce)(q)}e.pathsToEditors=N;var H;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}));function te(B){const z=B;if(!z)return!1;const q=z;if(q.modified)return te(q.modified);const V=z;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.isTextEditorViewState=te}),define(Ie[88],ke([1,0,11,2]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(D,E){return D.scheme===u.Schemas.http||D.scheme===u.Schemas.https?D:(E&&E.authority&&E.isRemote&&D.scheme===u.Schemas.file&&(D=n.URI.from({scheme:u.Schemas.vscodeRemote,authority:E.authority,path:D.path})),n.URI.from({scheme:u.Schemas.https,authority:`${D.scheme}+${A(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=S;function A(D){return D.replace(/./g,E=>{const k=E.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?E:"-"+k.toString(16).padStart(4,"0")})}function C(D){return D.replace(/-([0-9a-f]{4})/g,(E,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(Ie[212],ke([1,0,3,6,88]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(D,E,k){this._proxy=D,this._editors=E,this._remoteInfo=k,this._handlePool=0,this._disposables=new n.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const I of this._insets.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,E,k,R,I){let _;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===D){_=f;break}if(!_)throw new Error("not a visible editor");const P=this,b=this._handlePool++,w=new u.Emitter,p=new u.Emitter,g=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,S.asWebviewUri)(f,P._remoteInfo)}get cspSource(){return S.webviewGenericCspSource}set options(f){this._options=f,P._proxy.$setOptions(b,f)}get options(){return this._options}set html(f){this._html=f,P._proxy.$setHtml(b,f)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(f){return P._proxy.$postMessage(b,f)}},v=new class{constructor(){this.editor=D,this.line=E,this.height=k,this.webview=g,this.onDidDispose=p.event}dispose(){P._insets.has(b)&&(P._insets.delete(b),P._proxy.$disposeEditorInset(b),p.fire(),p.dispose(),w.dispose())}};return this._proxy.$createEditorInset(b,_.id,_.value.document.uri,E+1,k,R||{},I.identifier,I.extensionLocation),this._insets.set(b,{editor:D,inset:v,onDidReceiveMessage:w}),v}$onDidDispose(D){const E=this._insets.get(D);E&&E.inset.dispose()}$onDidReceiveMessage(D,E){this._insets.get(D)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=A}),define(Ie[127],ke([1,0,3,18,180]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,E,k,R){const I={command:D};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.internalSend("request",I),typeof R=="number"){const _=setTimeout(()=>{clearTimeout(_);const P=this.pendingRequests.get(I.seq);if(P){this.pendingRequests.delete(I.seq);const b={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:(0,S.localize)(0,null,R,D)};P(b)}},R)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,E){return D.type!=="event"||E.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,n.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback?.(D);break;case"request":this.requestCallback?.(D);break;case"response":{const E=D,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}}internalSend(D,E){E.type=D,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((E,k)=>D.set(k,E)),await(0,n.timeout)(500),D.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Ie[213],ke([1,0,181,51,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new n.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new n.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new n.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new n.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new n.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new n.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new n.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new n.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new n.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new n.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new n.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new n.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new n.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new n.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new n.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new n.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new n.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new n.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new n.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new n.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new n.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new n.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new n.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new n.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new n.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new n.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new n.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new n.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new n.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new n.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new n.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new n.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new n.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new n.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new n.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new n.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new n.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new n.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new n.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new n.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new n.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new n.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new n.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new n.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new n.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new n.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new n.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new n.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new n.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new n.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new n.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const A=_=>u.localize(51,null,_);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var C;(function(_){_[_.Inactive=0]="Inactive",_[_.Initializing=1]="Initializing",_[_.Stopped=2]="Stopped",_[_.Running=3]="Running"})(C=e.State||(e.State={}));function D(_){switch(_){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=D;var E;(function(_){_[_.Valid=0]="Valid",_[_.Unreadable=1]="Unreadable",_[_.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(_){_[_.Initial=1]="Initial",_[_.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(_){_.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,S.createDecorator)(e.DEBUG_SERVICE_ID);var I;(function(_){_[_.CONDITION=0]="CONDITION",_[_.HIT_COUNT=1]="HIT_COUNT",_[_.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[214],ke([1,0,8,2,9,24,11]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function E(r,s,i){return r.replace(D,function(t,o){return s&&o.length>0&&o[0]!=="_"?t:i&&i.hasOwnProperty(o)?i[o]:t})}e.formatPII=E;function k(r){const s={};for(const i of Object.keys(r))i.startsWith("!")||(s[i]=r[i]);return s}e.filterExceptionsFromTelemetry=k;function R(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(s,"extensionhost")||(0,u.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function _(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=_;function P(r,s,i){let t,o=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let d=null;for(;d=l.exec(r);){const y=d.index+1,L=y+d[0].length;if(y<=s&&L>=i){t=d[0],o=y;break}}if(t){const y=/\w+/g;let L=null;for(;(L=y.exec(t))&&!(L.index+1+o+L[0].length>=i););L&&(t=t.substring(0,y.lastIndex))}return t?{start:o,end:o+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=P;const b=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(r){return!!(r&&r.match(b))}e.isUri=w;function p(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(w(r.path))return n.URI.parse(r.path);if((0,S.isAbsolute)(r.path))return n.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const s=n.URI.revive(r.path);if(s)return s.scheme===C.Schemas.file?s.fsPath:s.toString()}return r.path}function v(r,s){const i=s?p:g,t=(0,A.deepClone)(r);return c(t,(o,l)=>{o&&l&&(l.path=i(l))}),t}e.convertToDAPaths=v;function f(r,s){const i=s?p:g,t=(0,A.deepClone)(r);return c(t,(o,l)=>{!o&&l&&(l.path=i(l))}),t}e.convertToVSCPaths=f;function c(r,s){switch(r.type){case"event":{const i=r;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break}case"request":{const i=r;switch(i.command){case"setBreakpoints":s(!0,i.arguments.source);break;case"breakpointLocations":s(!0,i.arguments.source);break;case"source":s(!0,i.arguments.source);break;case"gotoTargets":s(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const i=r;if(i.success&&i.body)switch(i.command){case"stackTrace":i.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":i.body.sources.forEach(t=>s(!1,t));break;case"scopes":i.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":i.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":i.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":i.body?.instructions.forEach(o=>s(!1,o.location));break;default:break}break}}}function m(r){return r.filter(s=>!s.presentation?.hidden).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):a(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:a(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=m;function a(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function h(r,s){const i=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(i!=="none"&&(await s.saveAll(),i==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===C.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(Ie[215],ke([1,0,29,42,182,216,9,8,24,13,84,127]),function(X,e,u,n,S,A,C,D,E,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class _ extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(v,f){this.outputStream=f,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,v.on("data",c=>this.handleData(c))}sendMessage(v){if(this.outputStream){const f=JSON.stringify(v);this.outputStream.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${_.TWO_CRLF}${f}`,"utf8")}}handleData(v){for(this.rawData=Buffer.concat([this.rawData,v]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const f=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+f))}continue}}else{const f=this.rawData.indexOf(_.TWO_CRLF);if(f!==-1){const m=this.rawData.toString("utf8",0,f).split(_.HEADER_LINESEPARATOR);for(const a of m){const h=a.split(_.HEADER_FIELDSEPARATOR);h[0]==="Content-Length"&&(this.contentLength=Number(h[1]))}this.rawData=this.rawData.slice(f+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_,_.TWO_CRLF=`\r
\r
`,_.HEADER_LINESEPARATOR=/\r?\n/,_.HEADER_FIELDSEPARATOR=/: */;class P extends _{startSession(){return new Promise((v,f)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),v(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.socket.on("error",m=>{c?this._onError.fire(m):f(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=P;class b extends P{constructor(v){super();this.adapterServer=v}createConnection(v){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",v)}}e.SocketDebugAdapter=b;class w extends P{constructor(v){super();this.adapterServer=v}createConnection(v){return A.createConnection(this.adapterServer.path,v)}}e.NamedPipeDebugAdapter=w;class p extends _{constructor(v,f,c){super();this.adapterExecutable=v,this.debugType=f,this.outputService=c}async startSession(){const v=this.adapterExecutable.command,f=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(v)if(C.isAbsolute(v)){if(!await u.Promises.exists(v))throw new Error(S.localize(0,null,v))}else v.indexOf("/")<0&&v.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.debugType));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=E.mixin(E.deepClone(process.env),c.env)),v==="node")if(Array.isArray(f)&&f.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(r.cwd=c.cwd);const s=n.fork(f[0],f.slice(1),r);if(!s.pid)throw new Error(S.localize(2,null,f[0]));this.serverProcess=s}else throw new Error(S.localize(3,null));else{const h={env:m};c.cwd&&(h.cwd=c.cwd),this.serverProcess=n.spawn(v,f,h)}this.serverProcess.on("error",h=>{this._onError.fire(h)}),this.serverProcess.on("exit",(h,r)=>{this._onExit.fire(h)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",h=>{this._onError.fire(h)}),this.serverProcess.stdin.on("error",h=>{this._onError.fire(h)});const a=this.outputService;if(a){const h=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{a.getChannel(R.ExtensionsChannelId)?.append(h(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((v,f)=>{const c=n.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,a,h){if(m)return f(m)});c.on("exit",v),c.on("error",f)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(v,f){if(!v)return;const c=Object.create(null);v.runtime&&(v.runtime.indexOf("./")===0?c.runtime=C.join(f,v.runtime):c.runtime=v.runtime),v.runtimeArgs&&(c.runtimeArgs=v.runtimeArgs),v.program&&(C.isAbsolute(v.program)?c.program=v.program:c.program=C.join(f,v.program)),v.args&&(c.args=v.args);const m=v;return m.win&&(c.win=p.extract(m.win,f)),m.winx86&&(c.winx86=p.extract(m.winx86,f)),m.windows&&(c.windows=p.extract(m.windows,f)),m.osx&&(c.osx=p.extract(m.osx,f)),m.linux&&(c.linux=p.extract(m.linux,f)),c}static platformAdapterExecutable(v,f){let c=Object.create(null);f=f.toLowerCase();for(const i of v)if(i.contributes){const t=i.contributes.debuggers;t&&t.length>0&&t.filter(o=>typeof o.type=="string"&&D.equalsIgnoreCase(o.type,f)).forEach(o=>{const l=p.extract(o,i.extensionLocation.fsPath);c=E.mixin(c,l,i.isBuiltin)})}let m;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:k.isWindows?m=c.win||c.windows:k.isMacintosh?m=c.osx:k.isLinux&&(m=c.linux),m=m||c;const a=m.program||c.program,h=m.args||c.args,r=m.runtime||c.runtime,s=m.runtimeArgs||c.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof a=="string"?[a]:[]).concat(h||[])};if(a)return{type:"executable",command:a,args:h||[]}}}e.ExecutableDebugAdapter=p}),define(Ie[217],ke([1,0,42,30,13]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(k,R){return new Promise((I,_)=>{let P="";const b=u.spawn(k,R);b.pid&&b.stdout.on("data",w=>{P+=w.toString()}),b.on("error",w=>{_(w)}),b.on("close",w=>{I(P)})})}async function C(k){if(k)if(S.isWindows){const R=await new Promise((I,_)=>{X(["windows-process-tree"],I,_)});return new Promise(I=>{R.getProcessTree(k,_=>{I(!!_&&_.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(k)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var D;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(D||(D={}));function E(k,R,I,_){k=k.trim().toLowerCase();let P;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?P=1:k.indexOf("cmd.exe")>=0?P=0:k.indexOf("bash")>=0?P=2:S.isWindows?P=0:P=2;let b,w=" ";switch(P){case 1:if(b=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),I){const p=(0,n.getDriveLetter)(I);p&&(w+=`${p}:; `),w+=`cd ${b(I)}; `}if(_)for(const p in _){const g=_[p];g===null?w+=`Remove-Item env:${p}; `:w+=`\${env:${p}}='${g}'; `}if(R.length>0){const p=b(R.shift());w+=p[0]==="'"?`& ${p} `:`${p} `;for(const g of R)w+=g==="<"||g===">"?g:b(g),w+=" "}break;case 0:if(b=p=>(p=p.replace(/\"/g,'""'),p=p.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>p.includes(g))||p.length===0?`"${p}"`:p),I){const p=(0,n.getDriveLetter)(I);p&&(w+=`${p}: && `),w+=`cd ${b(I)} && `}if(_){w+='cmd /C "';for(const p in _){let g=_[p];g===null?w+=`set "${p}=" && `:(g=g.replace(/[&^|<>]/g,v=>`^${v}`),w+=`set "${p}=${g}" && `)}}for(const p of R)w+=p==="<"||p===">"?p:b(p),w+=" ";_&&(w+='"');break;case 2:{b=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const p=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(I&&(w+=`cd ${b(I)} ; `),_){w+="/usr/bin/env";for(const g in _){const v=_[g];v===null?w+=` -u ${p(g)}`:w+=` ${p(`${g}=${v}`)}`}w+=" "}for(const g of R)w+=g==="<"||g===">"?g:b(g),w+=" ";break}}return w}e.prepareCommand=E}),define(Ie[128],ke([1,0,36,59,101,11,9,13,51]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var k;(function(i){i[i.Markup=1]="Markup",i[i.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",S.Mimes.latex,S.Mimes.markdown,"image/png","image/jpeg",S.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[S.Mimes.latex,S.Mimes.markdown,"application/json",S.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(i){i[i.Running=1]="Running",i[i.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(i){i[i.Unconfirmed=1]="Unconfirmed",i[i.Pending=2]="Pending",i[i.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(i){i[i.WithHardKernelDependency=0]="WithHardKernelDependency",i[i.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",i[i.Pure=2]="Pure",i[i.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(i){i.Always="always",i.Never="never",i.Optional="optional"})(P=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var b;(function(i){i[i.ModelChange=1]="ModelChange",i[i.Move=2]="Move",i[i.ChangeCellLanguage=5]="ChangeCellLanguage",i[i.Initialize=6]="Initialize",i[i.ChangeCellMetadata=7]="ChangeCellMetadata",i[i.Output=8]="Output",i[i.OutputItem=9]="OutputItem",i[i.ChangeCellContent=10]="ChangeCellContent",i[i.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",i[i.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",i[i.ChangeCellMime=13]="ChangeCellMime",i[i.Unknown=100]="Unknown"})(b=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(i){i[i.Handle=0]="Handle",i[i.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(i){i[i.Replace=1]="Replace",i[i.Output=2]="Output",i[i.Metadata=3]="Metadata",i[i.CellLanguage=4]="CellLanguage",i[i.DocumentMetadata=5]="DocumentMetadata",i[i.Move=6]="Move",i[i.OutputItems=7]="OutputItems",i[i.PartialMetadata=8]="PartialMetadata",i[i.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var g;(function(i){i.scheme=A.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function o(F,T){return F.with({scheme:i.scheme,fragment:`ch${T.toString().padStart(7,"0")}${F.scheme!==A.Schemas.file?F.scheme:""}`})}i.generate=o;function l(F){if(F.scheme!==i.scheme)return;const T=t.exec(F.fragment);return T?{handle:Number(T[1]),notebook:F.with({scheme:F.fragment.substring(T[0].length)||A.Schemas.file,fragment:null})}:void 0}i.parse=l;function d(F,T){return F.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${T??""},${F.scheme!==A.Schemas.file?F.scheme:""}`})}i.generateCellOutputUri=d;function y(F){if(F.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const T=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!T)return;const U=T[1]&&T[1]!==""?T[1]:void 0,N=T[2];return{outputId:U,notebook:F.with({scheme:N||A.Schemas.file,fragment:null})}}i.parseCellOutputUri=y;function L(F,T,U){return F.with({scheme:U,fragment:`ch${T.toString().padStart(7,"0")}${F.scheme!==A.Schemas.file?F.scheme:""}`})}i.generateCellUri=L;function M(F,T){if(F.scheme!==T)return;const U=t.exec(F.fragment);return U?{handle:Number(U[1]),notebook:F.with({scheme:F.fragment.substring(U[0].length)||A.Schemas.file,fragment:null})}:void 0}i.parseCellUri=M})(g=e.CellUri||(e.CellUri={}));const v=i=>D.isWindows?i.replace(/\//g,"\\"):i;class f{constructor(t=[],o=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=o,this.order=[...new Set(t)].map(l=>({pattern:l,matches:u.parse(v(l))}))}sort(t){const o=new Map(n.Iterable.map(t,d=>[d,v(d)]));let l=[];for(const{matches:d}of this.order)for(const[y,L]of o)if(d(L)){l.push(y),o.delete(y);break}return o.size&&(l=l.concat([...o.keys()].sort((d,y)=>this.defaultOrder.indexOf(d)-this.defaultOrder.indexOf(y)))),l}prioritize(t,o){const l=this.findIndex(t);if(l===-1){this.order.unshift({pattern:t,matches:u.parse(v(t))});return}const d=new Set(o.map(L=>this.findIndex(L,l)));d.delete(-1);const y=Array.from(d).sort();this.order.splice(l+1,0,...y.map(L=>this.order[L]));for(let L=y.length-1;L>=0;L--)this.order.splice(y[L],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,o=this.order.length){const l=v(t);for(let d=0;d<o;d++)if(this.order[d].matches(l))return d;return-1}}e.MimeTypeDisplayOrder=f;function c(i,t,o,l=(d,y)=>d===y){const d=[];function y(F,T,U){if(T===0&&U.length===0)return;const N=d[d.length-1];N&&N.start+N.deleteCount===F?(N.deleteCount+=T,N.toInsert.push(...U)):d.push({start:F,deleteCount:T,toInsert:U})}let L=0,M=0;for(;;){if(L===i.length){y(L,0,t.slice(M));break}if(M===t.length){y(L,i.length-L,[]);break}const F=i[L],T=t[M];if(l(F,T)){L+=1,M+=1;continue}o(T)?(y(L,1,[]),L+=1):(y(L,0,[T]),M+=1)}return d}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var m;(function(i){i.default="default",i.option="option"})(m=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(i){const t=i;return!!((typeof t.include=="string"||u.isRelativePattern(t.include))&&(typeof t.exclude=="string"||u.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=a;function h(i,t,o){if(Array.isArray(i.viewType)&&i.viewType.indexOf(t)>=0||i.viewType===t)return!0;if(i.filenamePattern){const l=a(i.filenamePattern)?i.filenamePattern.include:i.filenamePattern,d=a(i.filenamePattern)?i.filenamePattern.exclude:void 0;if(u.match(l,(0,C.basename)(o.fsPath).toLowerCase()))return!(d&&u.match(d,(0,C.basename)(o.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var r;(function(i){i[i.Left=1]="Left",i[i.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Ie[218],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var n;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(n=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(Ie[219],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=u;function n(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=n;function S(C){return Array.from(C.entries()).map(D=>[D[0],u(D[1].map)])}e.serializeEnvironmentVariableCollections=S;function A(C){return new Map(C.map(D=>[D[0],{map:n(D[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Ie[65],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var n;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(n=e.TestPosition||(e.TestPosition={}));class S{constructor(C,D=C.length){if(this.path=C,this.viewEnd=D,C.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,D,E=C.parent){if(C.id===D)return new S([D]);const k=[C.id];for(let R=E;R&&R.id!==D;R=R.parent)k.push(R.id);return k.push(D),new S(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const D=C.indexOf("\0");return D===-1?C:C.slice(0,D)}static fromString(C){return new S(C.split("\0"))}static join(C,D){return new S([...C.path,D])}static joinToString(C,D){return C.toString()+"\0"+D}static compare(C,D){return C===D?0:D.startsWith(C+"\0")?2:C.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new S(this.path,C)}compare(C){if(typeof C=="string")return S.compare(this.toString(),C);for(let D=0;D<C.viewEnd&&D<this.viewEnd;D++)if(C.path[D]!==this.path[D])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=S}),define(Ie[66],ke([1,0,2,35]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var S;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(S=e.TestResultState||(e.TestResultState={}));var A;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(i){i.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),i.deserialize=t=>({range:n.Range.lift(t.range),uri:u.URI.revive(t.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var D;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var E;(function(i){i.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.deserialize(t.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var k;(function(i){i.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.deserialize(t.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(i){i.serialize=t=>t.type===0?E.serialize(t):k.serialize(t),i.deserialize=t=>t.type===0?E.deserialize(t):k.deserialize(t)})(R=e.ITestMessage||(e.ITestMessage={}));var I;(function(i){i.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.serialize)}),i.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.deserialize)})})(I=e.ITestTaskState||(e.ITestTaskState={}));const _="\0",P=(i,t)=>i+_+t;e.namespaceTestTag=P;const b=i=>{const t=i.indexOf(_);return{ctrlId:i.slice(0,t),tagId:i.slice(t+1)}};e.denamespaceTestTag=b;var w;(function(i){i.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),i.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?u.URI.revive(t.uri):void 0,range:t.range?n.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(w=e.ITestItem||(e.ITestItem={}));var p;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(i){i.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:w.serialize(t.item)}),i.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:w.deserialize(t.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(i){i.serialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.uri!==void 0&&(o.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(o.range=t.item.range?.toJSON()),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}},i.deserialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.range!==void 0&&(o.range=t.item.range?n.Range.lift(t.item.range):null),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(i,t)=>{t.expand!==void 0&&(i.expand=t.expand),t.item!==void 0&&(i.item=i.item?Object.assign(i.item,t.item):t.item)};e.applyTestItemUpdate=f;var c;(function(i){i.serialize=(t,o)=>({...g.serialize(t),children:o,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(I.serialize)})})(c=e.TestResultItem||(e.TestResultItem={}));var m;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var a;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.Remove=2]="Remove",i[i.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",i[i.Retire=4]="Retire",i[i.AddTag=5]="AddTag",i[i.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var h;(function(i){i.deserialize=t=>t.op===0?{op:t.op,item:g.deserialize(t.item)}:t.op===1?{op:t.op,item:v.deserialize(t.item)}:t,i.serialize=t=>t.op===0?{op:t.op,item:g.serialize(t.item)}:t.op===1?{op:t.op,item:v.serialize(t.item)}:t})(h=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,o){}complete(){}}e.IncrementalChangeCollector=r;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const o=this.createChangeCollector();for(const l of t)switch(l.op){case 0:{const d=g.deserialize(l.item);if(d.parent){if(this.items.has(d.parent)){const y=this.items.get(d.parent);y.children.add(d.item.extId);const L=this.createItem(d,y);this.items.set(d.item.extId,L),o.add(L)}}else{const y=this.createItem(d);this.roots.add(y),this.items.set(d.item.extId,y),o.add(y)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=v.deserialize(l.item),y=this.items.get(d.extId);if(!y)break;d.expand!==void 0&&(y.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(y,d),o.update(y);break}case 2:{const d=this.items.get(l.itemId);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const y=[[l.itemId]];for(;y.length;)for(const L of y.pop()){const M=this.items.get(L);M&&(y.push(M.children),this.items.delete(L),o.remove(M,M!==d),M.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l.itemId);break;case 3:this.updatePendingRoots(l.amount);break;case 5:this._tags.set(l.tag.id,l.tag);break;case 6:this._tags.delete(l.id);break}o.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=s}),define(Ie[89],ke([1,0,18,3,6,10,66,65]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(g,v)=>g===v,R={range:(g,v)=>g===v?!0:!g||!v?!1:g.equalsRange(v),busy:k,label:k,description:k,error:k,tags:(g,v)=>!(g.length!==v.length||g.some(f=>!v.includes(f)))},I=(g,v)=>{let f;for(const[c,m]of Object.entries(R))m(g[c],v[c])||(f?f[c]=v[c]:f={[c]:v[c]});return f};class _ extends S.Disposable{constructor(v){super();this.options=v,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new n.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const f=this.diff[this.diff.length-1];if(f&&v.op===1){if(f.op===1&&f.item.extId===v.item.extId){(0,C.applyTestItemUpdate)(f.item,v.item);return}if(f.op===0&&f.item.item.extId===v.item.extId){(0,C.applyTestItemUpdate)(f.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,f){const c=this.tree.get(v);if(!!c){if((c.expandLevels===void 0||f>c.expandLevels)&&(c.expandLevels=f),c.expand===1){const m=this.resolveChildren(c);return m.isOpen()?this.expandChildren(c,f-1):m.wait().then(()=>this.expandChildren(c,f-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,f-1)):this.expandChildren(c,f-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,f){switch(f.op){case 3:this.removeItem(D.TestId.joinToString(v.fullId,f.id));break;case 0:this.upsertItem(f.item,v);break;case 5:for(const c of f.ops)this.onTestItemEvent(v,c);break;case 1:this.diffTagRefs(f.new,f.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:f.update}});break;default:(0,A.assertNever)(f)}}upsertItem(v,f){const c=D.TestId.fromExtHostTestItem(v,this.root.id,f?.actual),m=this.options.getApiFor(v);m.parent&&m.parent!==f?.actual&&this.options.getChildren(m.parent).delete(v.id);let a=this.tree.get(c.toString());if(!a){a={fullId:c,actual:v,parent:f?c.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(v,f),this.pushDiff({op:0,item:{parent:a.parent&&a.parent.toString(),controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,a,f);return}if(a.actual===v){this.connectItem(v,a,f);return}const h=this.options.getChildren(a.actual),r=a.actual,s=I(this.options.toITestItem(r),this.options.toITestItem(v));this.options.getApiFor(r).listener=void 0,a.actual=v,a.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,r.tags,c.toString()),delete s.tags),this.onTestItemEvent(a,{op:4,update:s})),this.connectItemAndChildren(v,a,f);for(const[i,t]of h)this.options.getChildren(v).get(t.id)||this.removeItem(D.TestId.joinToString(c,t.id))}diffTagRefs(v,f,c){const m=new Set(f.map(a=>a.id));for(const a of v)m.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:c,item:{tags:v.map(a=>(0,C.namespaceTestTag)(this.options.controllerId,a.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const f=this.tags.get(v.id);f?f.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,C.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const f=this.tags.get(v);f&&!--f.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,C.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,f){this.options.getApiFor(v).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(v,f,c){this.setItemParent(v,c);const m=this.options.getApiFor(v);m.parent=c?.actual,m.listener=a=>this.onTestItemEvent(f,a),this.updateExpandability(f)}connectItemAndChildren(v,f,c){this.connectItem(v,f,c);for(const[m,a]of this.options.getChildren(v))this.upsertItem(a,f)}updateExpandability(v){let f;this._resolveHandler?v.resolveBarrier?f=v.resolveBarrier.isOpen()?3:2:f=v.actual.canResolveChildren?1:0:f=0,f!==v.expand&&(v.expand=f,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:f}}),f===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,f){if(f<0)return;const c=[];for(const[m,a]of this.options.getChildren(v.actual)){const h=this.expand(D.TestId.joinToString(v.fullId,a.id),f);(0,u.isThenable)(h)&&c.push(h)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const a=new u.Barrier;return a.open(),a}v.expand=2,this.pushExpandStateUpdate(v);const f=v.resolveBarrier=new u.Barrier,c=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let m;try{m=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(a){c(a)}return(0,u.isThenable)(m)?m.catch(c).then(()=>{f.open(),this.updateExpandability(v)}):(f.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const f=this.tree.get(v);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const c=[f];for(;c.length;){const m=c.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const a of m.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(m.fullId.toString());for(const[a,h]of this.options.getChildren(m.actual))c.push(this.tree.get(D.TestId.joinToString(m.fullId,h.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=_;class P extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=P;class b extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class w extends Error{constructor(v,f,c){super(`TestItem with ID "${v}" is from controller "${f}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=w;const p=(g,v,f)=>{let c=new Map;return{get size(){return c.size},forEach(m,a){for(const h of c.values())m.call(a,h,this)},[Symbol.iterator](){return c.entries()},replace(m){const a=new Map,h=new Set(c.keys()),r={op:5,ops:[]};for(const s of m){if(!(s instanceof f))throw new b(s.id);const i=v(s).controllerId;if(i!==g.controllerId)throw new w(s.id,i,g.controllerId);if(a.has(s.id))throw new P(s.id);a.set(s.id,s),h.delete(s.id),r.ops.push({op:0,item:s})}for(const s of h.keys())r.ops.push({op:3,id:s});g.listener?.(r),c=a},add(m){if(!(m instanceof f))throw new b(m.id);c.set(m.id,m),g.listener?.({op:0,item:m})},delete(m){c.delete(m)&&g.listener?.({op:3,id:m})},get(m){return c.get(m)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=p}),define(Ie[129],ke([1,0,89]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const n=new WeakMap,S=(C,D)=>{const E={controllerId:D};return n.set(C,E),E};e.createPrivateApiFor=S;const A=C=>{const D=n.get(C);if(!D)throw new u.InvalidTestItemError(C?.id||"<unknown>");return D};e.getPrivateApiFor=A}),define(Ie[220],ke([1,0,9,40,10,24,13,107,185,8]),function(X,e,u,n,S,A,C,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(_,P,b,w){this._contributedVariables=new Map,this._context=_,this._labelService=P,this._userHomePromise=b,w&&(this._envVariablesPromise=w.then(p=>this.prepareEnv(p)))}prepareEnv(_){if(C.isWindows){const P=Object.create(null);return Object.keys(_).forEach(b=>{P[b.toLowerCase()]=_[b]}),P}return _}resolveWithEnvironment(_,P,b){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},P?P.uri:void 0,b)}async resolveAsync(_,P){const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,_?_.uri:void 0,P)}async resolveAnyBase(_,P,b,w){const p=A.deepClone(P);C.isWindows&&p.windows?Object.keys(p.windows).forEach(v=>p[v]=p.windows[v]):C.isMacintosh&&p.osx?Object.keys(p.osx).forEach(v=>p[v]=p.osx[v]):C.isLinux&&p.linux&&Object.keys(p.linux).forEach(v=>p[v]=p.linux[v]),delete p.windows,delete p.osx,delete p.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,_?_.uri:void 0,p,b,w)}async resolveAnyAsync(_,P,b){return this.resolveAnyBase(_,P,b)}async resolveAnyMap(_,P,b){const w=new Map;return{newConfig:await this.resolveAnyBase(_,P,b,w),resolvedVariables:w}}resolveWithInteractionReplace(_,P,b,w){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,P,b,w){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,P){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,P)}async recursiveResolve(_,P,b,w,p){if(S.isString(b))return this.resolveString(_,P,b,w,p);if(S.isArray(b))return Promise.all(b.map(g=>this.recursiveResolve(_,P,g,w,p)));if(S.isObject(b)){const g=Object.create(null),v=await Promise.all(Object.keys(b).map(async f=>[await this.resolveString(_,P,f,w,p),await this.recursiveResolve(_,P,b[f],w,p)]));for(const[f,c]of v)g[f]=c;return g}return b}resolveString(_,P,b,w,p){return(0,k.replaceAsync)(b,R.VARIABLE_REGEXP,async(g,v)=>{if(v.includes(R.VARIABLE_LHS))return g;let f=await this.evaluateSingleVariable(_,g,v,P,w);return p?.set(v,f),f!==g&&S.isString(f)&&f.match(R.VARIABLE_REGEXP)&&(f=await this.resolveString(_,P,f,w,p)),f})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,P,b,w,p){let g;const v=b.split(":");v.length>1&&(b=v[0],g=v[1]);const f=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error((0,E.localize)(0,null,P))},c=()=>{const a=f();if(this._context.getWorkspaceFolderPathForFile){const h=this._context.getWorkspaceFolderPathForFile();if(h)return h}throw new Error((0,E.localize)(1,null,P,u.basename(a)))},m=()=>{if(g){const a=this._context.getFolderUri(g);if(a)return a;throw new Error((0,E.localize)(2,null,P,g))}if(w)return w;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,P)):new Error((0,E.localize)(4,null,P))};switch(b){case"env":if(g){if(_.env){const a=_.env[C.isWindows?g.toLowerCase():g];if(S.isString(a))return a}return""}throw new Error((0,E.localize)(5,null,P));case"config":if(g){const a=this._context.getConfigurationValue(w,g);if(S.isUndefinedOrNull(a))throw new Error((0,E.localize)(6,null,P,g));if(S.isObject(a))throw new Error((0,E.localize)(7,null,P,g));return a}throw new Error((0,E.localize)(8,null,P));case"command":return this.resolveFromMap(P,g,p,"command");case"input":return this.resolveFromMap(P,g,p,"input");case"extensionInstallFolder":if(g){const a=await this._context.getExtension(g);if(!a)throw new Error((0,E.localize)(9,null,P,g));return this.fsPath(a.extensionLocation)}throw new Error((0,E.localize)(10,null,P));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return w||g?(0,D.normalizeDriveLetter)(this.fsPath(m())):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(m()));case"userHome":{if(_.userHome)return _.userHome;throw new Error((0,E.localize)(11,null,P))}case"lineNumber":{const a=this._context.getLineNumber();if(a)return a;throw new Error((0,E.localize)(12,null,P))}case"selectedText":{const a=this._context.getSelectedText();if(a)return a;throw new Error((0,E.localize)(13,null,P))}case"file":return f();case"fileWorkspaceFolder":return c();case"relativeFile":return w||g?u.relative(this.fsPath(m()),f()):f();case"relativeFileDirname":{const a=u.dirname(f());if(w||g){const h=u.relative(this.fsPath(m()),a);return h.length===0?".":h}return a}case"fileDirname":return u.dirname(f());case"fileExtname":return u.extname(f());case"fileBasename":return u.basename(f());case"fileBasenameNoExtension":{const a=u.basename(f());return a.slice(0,a.length-u.extname(a).length)}case"fileDirnameBasename":return u.basename(u.dirname(f()));case"execPath":{const a=this._context.getExecPath();return a||P}case"execInstallFolder":{const a=this._context.getAppRoot();return a||P}case"pathSeparator":return u.sep;default:try{const a=g?`${b}:${g}`:b;return this.resolveFromMap(P,a,p,void 0)}catch{return P}}}}resolveFromMap(_,P,b,w){if(P&&b){const p=w===void 0?b[P]:b[w+":"+P];if(typeof p=="string")return p;throw new Error((0,E.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[130],ke([1,0,4,211]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var S;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var A;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var D;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function k(b){const w=b;return(0,n.isEditorInput)(w?.editor)&&(0,n.isEditorInput)(w?.replacement)}e.isEditorReplacement=k;var R;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function _(b){const w=b;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=_;function P(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(Ie[221],ke([1,0,4,130]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(A){const C=A;return typeof A=="number"||(0,n.isEditorGroup)(C)}e.isPreferredGroup=S}),define(Ie[15],ke([1,0,16,23,106,25,143,61,24,10,2,35,63,188,117,129,128,65,66,221,7,58]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Ae){function Oe(Y){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:Je,positionColumn:et}=Y,Ze=new c.Position(Fe-1,xe-1),gt=new c.Position(Je-1,et-1);return new c.Selection(Ze,gt)}Ae.to=Oe;function Se(Y){const{anchor:Fe,active:xe}=Y;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Ae.from=Se})(a=e.Selection||(e.Selection={}));var h;(function(Ae){function Oe(Y){if(!Y)return;const{start:Fe,end:xe}=Y;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Ae.from=Oe;function Se(Y){if(!Y)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:Je,endColumn:et}=Y;return new c.Range(Fe-1,xe-1,Je-1,et-1)}Ae.to=Se})(h=e.Range||(e.Range={}));var r;(function(Ae){function Oe(Se){switch(Se){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Ae.to=Oe})(r=e.TokenType||(e.TokenType={}));var s;(function(Ae){function Oe(Y){return new c.Position(Y.lineNumber-1,Y.column-1)}Ae.to=Oe;function Se(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ae.from=Se})(s=e.Position||(e.Position={}));var i;(function(Ae){function Oe(Fe,xe){return(0,u.coalesce)((0,u.asArray)(Fe).map(Je=>Se(Je,xe)))}Ae.from=Oe;function Se(Fe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:Y(Fe.scheme,xe),pattern:oe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function Y(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Ae){function Oe(Y){switch(Y){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Se(Y){switch(Y){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Ae.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Ae){function Oe(Y){let Fe;return Y.code&&((0,k.isString)(Y.code)||(0,k.isNumber)(Y.code)?Fe=String(Y.code):Fe={value:String(Y.code.value),target:Y.code.target}),{...h.from(Y.range),message:Y.message,source:Y.source,code:Fe,severity:d.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(l.from),tags:Array.isArray(Y.tags)?(0,u.coalesce)(Y.tags.map(t.from)):void 0}}Ae.from=Oe;function Se(Y){const Fe=new c.Diagnostic(h.to(Y),Y.message,d.to(Y.severity));return Fe.source=Y.source,Fe.code=(0,k.isString)(Y.code)?Y.code:Y.code?.value,Fe.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(l.to),Fe.tags=Y.tags&&(0,u.coalesce)(Y.tags.map(t.to)),Fe}Ae.to=Se})(o=e.Diagnostic||(e.Diagnostic={}));var l;(function(Ae){function Oe(Y){return{...h.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ae.from=Oe;function Se(Y){return new c.DiagnosticRelatedInformation(new c.Location(Y.resource,h.to(Y)),Y.message)}Ae.to=Se})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(Ae){function Oe(Y){switch(Y){case c.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}Ae.from=Oe;function Se(Y){switch(Y){case b.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Ae.to=Se})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var y;(function(Ae){function Oe(Y){return typeof Y=="number"&&Y>=c.ViewColumn.One?Y-1:Y===c.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Ae.from=Oe;function Se(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Se})(y=e.ViewColumn||(e.ViewColumn={}));function L(Ae){return typeof Ae.range!="undefined"}function M(Ae){return Ae.length===0?!0:!!L(Ae[0])}e.isDecorationOptionsArr=M;var F;(function(Ae){function Oe(et){return et.map(Ae.from)}Ae.fromMany=Oe;function Se(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Y(et){let Ze;if(Se(et)){const{language:vt,value:ht}=et;Ze={value:"```"+vt+`
`+ht+"\n```\n"}}else c.MarkdownString.isMarkdownString(et)?Ze={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons,supportHtml:et.supportHtml,baseUri:et.baseUri}:typeof et=="string"?Ze={value:et}:Ze={value:""};const gt=Object.create(null);Ze.uris=gt;const pt=vt=>{try{let ht=R.URI.parse(vt,!0);ht=ht.with({query:Fe(ht.query,gt)}),gt[vt]=ht}catch{}return""},yt=new C.marked.Renderer;return yt.link=pt,yt.image=vt=>typeof vt=="string"?pt(S.parseHrefAndDimensions(vt).href):"",(0,C.marked)(Ze.value,{renderer:yt}),Ze}Ae.from=Y;function Fe(et,Ze){if(!et)return et;let gt;try{gt=(0,D.parse)(et)}catch{}if(!gt)return et;let pt=!1;return gt=(0,E.cloneAndChange)(gt,yt=>{if(R.URI.isUri(yt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[vt]=yt,pt=!0,vt}else return}),pt?JSON.stringify(gt):et}function xe(et){const Ze=new c.MarkdownString(et.value,et.supportThemeIcons);return Ze.isTrusted=et.isTrusted,Ze.supportHtml=et.supportHtml,Ze.baseUri=et.baseUri?R.URI.from(et.baseUri):void 0,Ze}Ae.to=xe;function Je(et){if(!!et)return typeof et=="string"?et:Ae.from(et)}Ae.fromStrict=Je})(F=e.MarkdownString||(e.MarkdownString={}));function T(Ae){return M(Ae)?Ae.map(Oe=>({range:h.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?F.fromMany(Oe.hoverMessage):Oe.hoverMessage?F.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:h.from(Oe)}))}e.fromRangeOrRangeWithMessage=T;function U(Ae){return typeof Ae=="undefined"?Ae:typeof Ae=="string"?R.URI.file(Ae):Ae}e.pathOrURIToURI=U;var N;(function(Ae){function Oe(Se){return typeof Se=="undefined"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?U(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Ae.from=Oe})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(Ae){function Oe(Se){return typeof Se=="undefined"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?N.from(Se.before):void 0,after:Se.after?N.from(Se.after):void 0}}Ae.from=Oe})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var te;(function(Ae){function Oe(Se){if(typeof Se=="undefined")return Se;switch(Se){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(te=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(Ae){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?te.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?H.from(Se.light):void 0,dark:Se.dark?H.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?N.from(Se.before):void 0,after:Se.after?N.from(Se.after):void 0}}Ae.from=Oe})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(Ae){function Oe(Y){return{text:Y.newText,eol:Y.newEol&&Ye.from(Y.newEol),range:h.from(Y.range)}}Ae.from=Oe;function Se(Y){const Fe=new c.TextEdit(h.to(Y.range),Y.text);return Fe.newEol=typeof Y.eol=="undefined"?void 0:Ye.to(Y.eol),Fe}Ae.to=Se})(z=e.TextEdit||(e.TextEdit={}));var q;(function(Ae){function Oe(Y,Fe,xe){const Je={edits:[]};if(Y instanceof c.WorkspaceEdit){const et=new A.ResourceSet;for(const Ze of Y._allEntries())Ze._type===1&&R.URI.isUri(Ze.to)&&Ze.from===void 0&&et.add(Ze.to);for(const Ze of Y._allEntries())if(Ze._type===1)Je.edits.push({_type:1,oldUri:Ze.from,newUri:Ze.to,options:Ze.options,metadata:Ze.metadata});else if(Ze._type===2){const gt={_type:2,resource:Ze.uri,edit:z.from(Ze.edit),modelVersionId:et.has(Ze.uri)?void 0:Fe?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata};xe&&Ze.edit.newText2 instanceof c.SnippetString&&(gt.edit.insertAsSnippet=!0,gt.edit.text=Ze.edit.newText2.value),Je.edits.push(gt)}else Ze._type===3?Je.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ze.uri)}):Ze._type===5&&Je.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ze.uri),edit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(ot.from)}})}return Je}Ae.from=Oe;function Se(Y){const Fe=new c.WorkspaceEdit;for(const xe of Y.edits)xe.edit?Fe.replace(R.URI.revive(xe.resource),h.to(xe.edit.range),xe.edit.text):Fe.renameFile(R.URI.revive(xe.oldUri),R.URI.revive(xe.newUri),xe.options);return Fe}Ae.to=Se})(q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Ae){const Oe=Object.create(null);Oe[c.SymbolKind.File]=0,Oe[c.SymbolKind.Module]=1,Oe[c.SymbolKind.Namespace]=2,Oe[c.SymbolKind.Package]=3,Oe[c.SymbolKind.Class]=4,Oe[c.SymbolKind.Method]=5,Oe[c.SymbolKind.Property]=6,Oe[c.SymbolKind.Field]=7,Oe[c.SymbolKind.Constructor]=8,Oe[c.SymbolKind.Enum]=9,Oe[c.SymbolKind.Interface]=10,Oe[c.SymbolKind.Function]=11,Oe[c.SymbolKind.Variable]=12,Oe[c.SymbolKind.Constant]=13,Oe[c.SymbolKind.String]=14,Oe[c.SymbolKind.Number]=15,Oe[c.SymbolKind.Boolean]=16,Oe[c.SymbolKind.Array]=17,Oe[c.SymbolKind.Object]=18,Oe[c.SymbolKind.Key]=19,Oe[c.SymbolKind.Null]=20,Oe[c.SymbolKind.EnumMember]=21,Oe[c.SymbolKind.Struct]=22,Oe[c.SymbolKind.Event]=23,Oe[c.SymbolKind.Operator]=24,Oe[c.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=Se;function Y(Fe){for(const xe in Oe)if(Oe[xe]===Fe)return Number(xe);return c.SymbolKind.Property}Ae.to=Y})(V=e.SymbolKind||(e.SymbolKind={}));var j;(function(Ae){function Oe(Y){switch(Y){case c.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Se(Y){switch(Y){case 1:return c.SymbolTag.Deprecated}}Ae.to=Se})(j=e.SymbolTag||(e.SymbolTag={}));var ie;(function(Ae){function Oe(Y){return{name:Y.name,kind:V.from(Y.kind),tags:Y.tags&&Y.tags.map(j.from),containerName:Y.containerName,location:ge.from(Y.location)}}Ae.from=Oe;function Se(Y){const Fe=new c.SymbolInformation(Y.name,V.to(Y.kind),Y.containerName,ge.to(Y.location));return Fe.tags=Y.tags&&Y.tags.map(j.to),Fe}Ae.to=Se})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Ae){function Oe(Y){const Fe={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:h.from(Y.range),selectionRange:h.from(Y.selectionRange),kind:V.from(Y.kind),tags:Y.tags?.map(j.from)??[]};return Y.children&&(Fe.children=Y.children.map(Oe)),Fe}Ae.from=Oe;function Se(Y){const Fe=new c.DocumentSymbol(Y.name,Y.detail,V.to(Y.kind),h.to(Y.range),h.to(Y.selectionRange));return(0,u.isNonEmptyArray)(Y.tags)&&(Fe.tags=Y.tags.map(j.to)),Y.children&&(Fe.children=Y.children.map(Se)),Fe}Ae.to=Se})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var ue;(function(Ae){function Oe(Y){const Fe=new c.CallHierarchyItem(V.to(Y.kind),Y.name,Y.detail||"",R.URI.revive(Y.uri),h.to(Y.range),h.to(Y.selectionRange));return Fe._sessionId=Y._sessionId,Fe._itemId=Y._itemId,Fe}Ae.to=Oe;function Se(Y,Fe,xe){if(Fe=Fe??Y._sessionId,xe=xe??Y._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:Y.name,detail:Y.detail,kind:V.from(Y.kind),uri:Y.uri,range:h.from(Y.range),selectionRange:h.from(Y.selectionRange),tags:Y.tags?.map(j.from)}}Ae.from=Se})(ue=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ve;(function(Ae){function Oe(Se){return new c.CallHierarchyIncomingCall(ue.to(Se.from),Se.fromRanges.map(Y=>h.to(Y)))}Ae.to=Oe})(ve=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var J;(function(Ae){function Oe(Se){return new c.CallHierarchyOutgoingCall(ue.to(Se.to),Se.fromRanges.map(Y=>h.to(Y)))}Ae.to=Oe})(J=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ge;(function(Ae){function Oe(Y){return{range:Y.range&&h.from(Y.range),uri:Y.uri}}Ae.from=Oe;function Se(Y){return new c.Location(R.URI.revive(Y.uri),h.to(Y.range))}Ae.to=Se})(ge=e.location||(e.location={}));var Ee;(function(Ae){function Oe(Y){const Fe=Y,xe=Y;return{originSelectionRange:Fe.originSelectionRange?h.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:h.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?h.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function Se(Y){return{targetUri:R.URI.revive(Y.uri),targetRange:h.to(Y.range),targetSelectionRange:Y.targetSelectionRange?h.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?h.to(Y.originSelectionRange):void 0}}Ae.to=Se})(Ee=e.DefinitionLink||(e.DefinitionLink={}));var Pe;(function(Ae){function Oe(Y){return{range:h.from(Y.range),contents:F.fromMany(Y.contents)}}Ae.from=Oe;function Se(Y){return new c.Hover(Y.contents.map(F.to),h.to(Y.range))}Ae.to=Se})(Pe=e.Hover||(e.Hover={}));var me;(function(Ae){function Oe(Y){return{range:h.from(Y.range),expression:Y.expression}}Ae.from=Oe;function Se(Y){return new c.EvaluatableExpression(h.to(Y.range),Y.expression)}Ae.to=Se})(me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Te;(function(Ae){function Oe(Y){if(Y instanceof c.InlineValueText)return{type:"text",range:h.from(Y.range),text:Y.text};if(Y instanceof c.InlineValueVariableLookup)return{type:"variable",range:h.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Se(Y){switch(Y.type){case"text":return{range:h.to(Y.range),text:Y.text};case"variable":return{range:h.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:h.to(Y.range),expression:Y.expression}}}Ae.to=Se})(Te=e.InlineValue||(e.InlineValue={}));var le;(function(Ae){function Oe(Y){return{frameId:Y.frameId,stoppedLocation:h.from(Y.stoppedLocation)}}Ae.from=Oe;function Se(Y){return new c.InlineValueContext(Y.frameId,h.to(Y.stoppedLocation))}Ae.to=Se})(le=e.InlineValueContext||(e.InlineValueContext={}));var pe;(function(Ae){function Oe(Y){return{range:h.from(Y.range),kind:Y.kind}}Ae.from=Oe;function Se(Y){return new c.DocumentHighlight(h.to(Y.range),Y.kind)}Ae.to=Se})(pe=e.DocumentHighlight||(e.DocumentHighlight={}));var be;(function(Ae){function Oe(Se){switch(Se){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Ae.to=Oe})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Ae){function Oe(Se){return{triggerKind:be.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Ae.to=Oe})(ae=e.CompletionContext||(e.CompletionContext={}));var he;(function(Ae){function Oe(Y){switch(Y){case c.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Se(Y){switch(Y){case 1:return c.CompletionItemTag.Deprecated}}Ae.to=Se})(he=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(Ae){const Oe=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function Se(xe){return Oe.get(xe)??9}Ae.from=Se;const Y=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Fe(xe){return Y.get(xe)??c.CompletionItemKind.Property}Ae.to=Fe})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(Ae){function Oe(Se,Y){const Fe=new c.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=ee.to(Se.kind),Fe.tags=Se.tags?.map(he.to),Fe.detail=Se.detail,Fe.documentation=S.isMarkdownString(Se.documentation)?F.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,I.Range.isIRange(Se.range)?Fe.range=h.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:h.to(Se.range.insert),replacing:h.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules=="undefined"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules!="undefined"&&Se.insertTextRules&4?Fe.insertText=new c.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof c.Range?new c.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(xe=>z.to(xe))),Fe.command=Y&&Se.command?Y.fromInternal(Se.command):void 0,Fe}Ae.to=Oe})(ne=e.CompletionItem||(e.CompletionItem={}));var O;(function(Ae){function Oe(Y){return{label:Y.label,documentation:F.fromStrict(Y.documentation)}}Ae.from=Oe;function Se(Y){return{label:Y.label,documentation:S.isMarkdownString(Y.documentation)?F.to(Y.documentation):Y.documentation}}Ae.to=Se})(O=e.ParameterInformation||(e.ParameterInformation={}));var $;(function(Ae){function Oe(Y){return{label:Y.label,documentation:F.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(O.from):[],activeParameter:Y.activeParameter}}Ae.from=Oe;function Se(Y){return{label:Y.label,documentation:S.isMarkdownString(Y.documentation)?F.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(O.to):[],activeParameter:Y.activeParameter}}Ae.to=Se})($=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Ae){function Oe(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map($.from):[]}}Ae.from=Oe;function Se(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map($.to):[]}}Ae.to=Se})(G=e.SignatureHelp||(e.SignatureHelp={}));var K;(function(Ae){function Oe(Se,Y){const Fe=new c.InlayHint(s.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(de.to.bind(void 0,Se)),Y.kind&&we.to(Y.kind));return Fe.textEdits=Y.textEdits&&Y.textEdits.map(z.to),Fe.tooltip=S.isMarkdownString(Y.tooltip)?F.to(Y.tooltip):Y.tooltip,Fe.paddingLeft=Y.paddingLeft,Fe.paddingRight=Y.paddingRight,Fe}Ae.to=Oe})(K=e.InlayHint||(e.InlayHint={}));var de;(function(Ae){function Oe(Se,Y){const Fe=new c.InlayHintLabelPart(Y.label);return Fe.tooltip=S.isMarkdownString(Y.tooltip)?F.to(Y.tooltip):Y.tooltip,_.Command.is(Y.command)&&(Fe.command=Se.fromInternal(Y.command)),Y.location&&(Fe.location=ge.to(Y.location)),Fe}Ae.to=Oe})(de=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Ae){function Oe(Y){return Y}Ae.from=Oe;function Se(Y){return Y}Ae.to=Se})(we=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(Ae){function Oe(Y){return{range:h.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ae.from=Oe;function Se(Y){let Fe;if(Y.url)try{Fe=typeof Y.url=="string"?R.URI.parse(Y.url,!0):R.URI.revive(Y.url)}catch{}return new c.DocumentLink(h.to(Y.range),Fe)}Ae.to=Se})(se=e.DocumentLink||(e.DocumentLink={}));var De;(function(Ae){function Oe(Y){const Fe=new c.ColorPresentation(Y.label);return Y.textEdit&&(Fe.textEdit=z.to(Y.textEdit)),Y.additionalTextEdits&&(Fe.additionalTextEdits=Y.additionalTextEdits.map(xe=>z.to(xe))),Fe}Ae.to=Oe;function Se(Y){return{label:Y.label,textEdit:Y.textEdit?z.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Fe=>z.from(Fe)):void 0}}Ae.from=Se})(De=e.ColorPresentation||(e.ColorPresentation={}));var Ce;(function(Ae){function Oe(Y){return new c.Color(Y[0],Y[1],Y[2],Y[3])}Ae.to=Oe;function Se(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ae.from=Se})(Ce=e.Color||(e.Color={}));var ze;(function(Ae){function Oe(Y){return{range:h.from(Y.range)}}Ae.from=Oe;function Se(Y){return new c.SelectionRange(h.to(Y.range))}Ae.to=Se})(ze=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(Ae){function Oe(Se){switch(Se){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(Ae){function Oe(Y){switch(Y){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Se(Y){switch(Y){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Ae.to=Se})(Ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Ae){function Oe(Y){if(Y===c.EndOfLine.CRLF)return 1;if(Y===c.EndOfLine.LF)return 0}Ae.from=Oe;function Se(Y){if(Y===1)return c.EndOfLine.CRLF;if(Y===0)return c.EndOfLine.LF}Ae.to=Se})(Ye=e.EndOfLine||(e.EndOfLine={}));var Z;(function(Ae){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Z=e.ProgressLocation||(e.ProgressLocation={}));var re;(function(Ae){function Oe(Se){const Y={start:Se.start+1,end:Se.end+1};return Se.kind&&(Y.kind=ye.from(Se.kind)),Y}Ae.from=Oe})(re=e.FoldingRange||(e.FoldingRange={}));var ye;(function(Ae){function Oe(Se){if(Se)switch(Se){case c.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}Ae.from=Oe})(ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(Ae){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?h.from(Se.selection):void 0,override:typeof Se.override=="boolean"?P.EditorResolution.DISABLED:void 0}}Ae.from=Oe})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var oe;(function(Ae){function Oe(xe){return xe instanceof c.RelativePattern?xe.toJSON():typeof xe=="string"?xe:Se(xe)||Y(xe)?new c.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Ae.from=Oe;function Se(xe){const Je=xe;return Je?R.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function Y(xe){const Je=xe;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new c.RelativePattern(R.URI.revive(xe.baseUri),xe.pattern)}Ae.to=Fe})(oe=e.GlobPattern||(e.GlobPattern={}));var Re;(function(Ae){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const Y=Se;return{language:Y.language,scheme:Y.scheme,pattern:oe.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}Ae.from=Oe})(Re=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(Ae){function Oe(Y){return{start:Y.start,end:Y.end}}Ae.from=Oe;function Se(Y){return new c.NotebookRange(Y.start,Y.end)}Ae.to=Se})(Be=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Ae){function Oe(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ae.to=Oe;function Se(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ae.from=Se})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Ae){function Oe(Se){if(Se===p.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;if(Se===p.NotebookCellExecutionState.Pending)return c.NotebookCellExecutionState.Pending;if(Se===p.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${Se}`)}Ae.to=Oe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Ae){function Oe(Y){switch(Y){case c.NotebookCellKind.Markup:return p.CellKind.Markup;case c.NotebookCellKind.Code:default:return p.CellKind.Code}}Ae.from=Oe;function Se(Y){switch(Y){case p.CellKind.Markup:return c.NotebookCellKind.Markup;case p.CellKind.Code:default:return c.NotebookCellKind.Code}}Ae.to=Se})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(Ae){function Oe(Y){const Fe={metadata:Y.metadata??Object.create(null),cells:[]};for(const xe of Y.cells)c.NotebookCellData.validate(xe),Fe.cells.push(ot.from(xe));return Fe}Ae.from=Oe;function Se(Y){const Fe=new c.NotebookData(Y.cells.map(ot.to));return(0,k.isEmptyObject)(Y.metadata)||(Fe.metadata=Y.metadata),Fe}Ae.to=Se})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(Ae){function Oe(Y){return{cellKind:Ve.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:qe.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(it.from):[]}}Ae.from=Oe;function Se(Y){return new c.NotebookCellData(Ve.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(it.to):void 0,Y.metadata,Y.internalMetadata?qe.to(Y.internalMetadata):void 0)}Ae.to=Se})(ot=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Ae){function Oe(Y){return{mime:Y.mime,valueBytes:n.VSBuffer.wrap(Y.data)}}Ae.from=Oe;function Se(Y){return new c.NotebookCellOutputItem(Y.valueBytes.buffer,Y.mime)}Ae.to=Se})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var it;(function(Ae){function Oe(Y){return{outputId:Y.id,items:Y.items.map(st.from),metadata:Y.metadata}}Ae.from=Oe;function Se(Y){const Fe=Y.items.map(st.to);return new c.NotebookCellOutput(Fe,Y.outputId,Y.metadata)}Ae.to=Se})(it=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(Ae){function Oe(Fe){return Y(Fe)?{include:(0,k.withNullAsUndefined)(oe.from(Fe.include)),exclude:(0,k.withNullAsUndefined)(oe.from(Fe.exclude))}:(0,k.withNullAsUndefined)(oe.from(Fe))}Ae.from=Oe;function Se(Fe){return Y(Fe)?{include:oe.to(Fe.include),exclude:oe.to(Fe.exclude)}:oe.to(Fe)}Ae.to=Se;function Y(Fe){const xe=Fe;return xe?!(0,k.isUndefinedOrNull)(xe.include)&&!(0,k.isUndefinedOrNull)(xe.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var bt;(function(Ae){function Oe(Se,Y,Fe){const xe=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(xe,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Ae.from=Oe})(bt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Pt;(function(Ae){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{}}}Ae.from=Oe})(Pt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var St;(function(Ae){function Oe(Y){return{uri:Y.uri,provides:Y.provides}}Ae.from=Oe;function Se(Y){return new c.NotebookRendererScript(R.URI.revive(Y.uri),Y.provides)}Ae.to=Se})(St=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Ae){function Oe(Y){return{message:F.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,location:Y.location&&{range:h.from(Y.location.range),uri:Y.location.uri}}}Ae.from=Oe;function Se(Y){const Fe=new c.TestMessage(typeof Y.message=="string"?Y.message:F.to(Y.message));return Fe.actualOutput=Y.actual,Fe.expectedOutput=Y.expected,Fe.location=Y.location?ge.to(Y.location):void 0,Fe}Ae.to=Se})(ft=e.TestMessage||(e.TestMessage={}));var It;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var Ft;(function(Ae){function Oe(Y){const Fe=(0,w.getPrivateApiFor)(Y).controllerId;return{extId:g.TestId.fromExtHostTestItem(Y,Fe).toString(),label:Y.label,uri:R.URI.revive(Y.uri),busy:!1,tags:Y.tags.map(xe=>It.namespace(Fe,xe.id)),range:I.Range.lift(h.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&F.fromStrict(Y.error)||null}}Ae.from=Oe;function Se(Y){return{parent:void 0,error:void 0,id:g.TestId.fromString(Y.extId).localId,label:Y.label,uri:R.URI.revive(Y.uri),tags:(Y.tags||[]).map(Fe=>{const{tagId:xe}=It.denamespace(Fe);return new c.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(Y.range||void 0),canResolveChildren:!1,busy:!1,description:Y.description||void 0,sortText:Y.sortText||void 0}}Ae.toPlain=Se})(Ft=e.TestItem||(e.TestItem={})),function(Ae){function Oe(Y){return{id:Y.id}}Ae.from=Oe;function Se(Y){return new c.TestTag(Y.id)}Ae.to=Se}(It=e.TestTag||(e.TestTag={}));var At;(function(Ae){const Oe=(Y,Fe)=>{const xe={...Ft.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(et=>et.type===0).map(ft.to)})),children:Y.children.map(Je=>Fe.get(Je)).filter(k.isDefined).map(Je=>Oe(Je,Fe))};for(const Je of xe.children)Je.parent=xe;return xe};function Se(Y){const Fe=[],xe=new Map;for(const Je of Y.items)xe.set(Je.item.extId,Je),Y.request.targets.some(et=>et.controllerId===Je.controllerId&&et.testIds.includes(Je.item.extId))&&Fe.push(Je);return{completedAt:Y.completedAt,results:Fe.map(Je=>Oe(Je,xe))}}Ae.to=Se})(At=e.TestResults||(e.TestResults={}));var Xe;(function(Ae){function Oe(xe){return{covered:xe.covered,total:xe.covered}}function Se(xe){return"line"in xe?s.from(xe):h.from(xe)}function Y(xe){return"branches"in xe?{count:xe.executionCount,location:Se(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Se(Je.location)})):void 0}:{type:0,count:xe.executionCount,location:Se(xe.location)}}Ae.fromDetailed=Y;function Fe(xe){return{uri:xe.uri,statement:Oe(xe.statementCoverage),branch:xe.branchCoverage&&Oe(xe.branchCoverage),function:xe.functionCoverage&&Oe(xe.functionCoverage),details:xe.detailedCoverage?.map(Y)}}Ae.fromFile=Fe})(Xe=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(Ae){function Oe(Se){switch(Se){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Ae){function Oe(Y){const Fe=new c.TypeHierarchyItem(V.to(Y.kind),Y.name,Y.detail||"",R.URI.revive(Y.uri),h.to(Y.range),h.to(Y.selectionRange));return Fe._sessionId=Y._sessionId,Fe._itemId=Y._itemId,Fe}Ae.to=Oe;function Se(Y,Fe,xe){if(Fe=Fe??Y._sessionId,xe=xe??Y._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:V.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:h.from(Y.range),selectionRange:h.from(Y.selectionRange),tags:Y.tags?.map(j.from)}}Ae.from=Se})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(Ae){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Ae.from=Oe})(Ot=e.ViewBadge||(e.ViewBadge={}));var mt;(function(Ae){function Oe(Se,Y){const Fe=Se.fileData;return Fe?new class extends c.DataTransferItem{asFile(){return{name:Fe.name,uri:R.URI.revive(Fe.uri),data:(0,m.once)(()=>Y())}}}(""):new c.DataTransferItem(Se.asString)}Ae.toDataTransferItem=Oe})(mt=e.DataTransferItem||(e.DataTransferItem={}));var Dt;(function(Ae){function Oe(Y,Fe){const xe=Y.items.map(([Je,et],Ze)=>[Je,mt.toDataTransferItem(et,()=>Fe(Ze))]);return new c.DataTransfer(xe)}Ae.toDataTransfer=Oe;async function Se(Y){const Fe={items:[]},xe=[];return Y.forEach((Je,et)=>{xe.push((async()=>{const Ze=await Je.asString(),gt=Je.asFile();Fe.items.push([et,{asString:Ze,fileData:gt?{name:gt.name,uri:gt.uri}:void 0}])})())}),await Promise.all(xe),Fe}Ae.toDataTransferDTO=Se})(Dt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[222],ke([1,0,2,12,7,15,79]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(k,R,I,_={timeout:1500,errors:3}){this._logService=k,this._documents=R,this._mainThreadBulkEdits=I,this._thresholds=_,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(R,I,_)=>{const b={dispose:this._callbacks.push([R,I,k])};return Array.isArray(_)&&_.push(b),b}}async $participateInSave(k,R){const I=u.URI.revive(k);let _=!1;const P=setTimeout(()=>_=!0,this._thresholds.timeout),b=[];try{for(const w of[...this._callbacks]){if(_)break;const p=this._documents.getDocument(I),g=await this._deliverEventAsyncAndBlameBadListeners(w,{document:p,reason:A.TextDocumentSaveReason.to(R)});b.push(g)}}finally{clearTimeout(P)}return b}_deliverEventAsyncAndBlameBadListeners([k,R,I],_){const P=this._badListeners.get(k);return typeof P=="number"&&P>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,R,_).then(()=>!0,b=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const w=this._badListeners.get(k);this._badListeners.set(k,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,R,I,_){const P=[],b=Date.now(),{document:w,reason:p}=_,{version:g}=w,v=Object.freeze({document:w,reason:p,waitUntil(f){if(Object.isFrozen(P))throw(0,n.illegalState)("waitUntil can not be called async");P.push(Promise.resolve(f))}});try{R.apply(I,[v])}catch(f){return Promise.reject(f)}return Object.freeze(P),new Promise((f,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(P).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(m),f(a)}).catch(a=>{clearTimeout(m),c(a)})}).then(f=>{const c={edits:[]};for(const m of f)if(Array.isArray(m)&&m.every(a=>a instanceof S.TextEdit))for(const{newText:a,newEol:h,range:r}of m)c.edits.push({_type:2,resource:w.uri,edit:{range:r&&A.Range.from(r),text:a,eol:h&&A.EndOfLine.from(h)}});if(c.edits.length!==0)return g===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(Ie[223],ke([1,0,11,2,15,7,128]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(I,_,P,b){this.start=I,this.deletedCount=_,this.deletedItems=P,this.items=b}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{constructor(I,_,P){this.notebook=I,this._extHostDocument=_,this._cellData=P,this.handle=P.handle,this.uri=n.URI.revive(P.uri),this.cellKind=P.cellKind,this._outputs=P.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=P.internalMetadata??{},this._metadata=Object.freeze(P.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}static asModelAddData(I,_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1,notebook:I}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,_=this._extHostDocument.getDocument(this.uri);if(!_)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:_.document,get mime(){return I._mime},set mime(b){I._mime=b},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(P)}return this._apiCell}setOutputs(I){this._outputs=I.map(S.NotebookCellOutput.to)}setOutputItems(I,_,P){const b=P.map(S.NotebookCellOutputItem.to),w=this._outputs.find(p=>p.id===I);w&&(_||(w.items.length=0),w.items.push(...b))}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=E;class k{constructor(I,_,P,b,w){this._proxy=I,this._textDocumentsAndEditors=_,this._textDocuments=P,this.uri=b,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=Object.freeze(w.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,w.cells]],!0,void 0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this,_={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===u.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(P){return P=I._validateIndex(P),I._cells[P].apiCell},getCells(P){return(P?I._getCells(P):I._cells).map(w=>w.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(_)}return this._notebook}updateBackup(I){this._backup?.delete(),this._backup=I}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,_,P){this._versionId=I.versionId,this._isDirty=_,this.acceptDocumentPropertiesChanged({metadata:P});const b={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},w=[];for(const g of I.rawEvents)g.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1,b.contentChanges):g.kind===C.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx,b.contentChanges):g.kind===C.NotebookCellsChangeType.Output?(this._setCellOutputs(g.index,g.outputs),w.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===C.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems),w.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(g.index,g.language),w.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document})):g.kind===C.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document}):g.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(g.index,g.metadata),w.push({cell:this._cells[g.index].apiCell,metadata:this._cells[g.index].apiCell.metadata})):g.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(g.index,g.internalMetadata),w.push({cell:this._cells[g.index].apiCell,executionSummary:this._cells[g.index].apiCell.executionSummary}));const p=new Map;for(let g=0;g<w.length;g++){const v=w[g],f=p.get(v.cell);if(f===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});p.set(v.cell,c-1)}else b.cellChanges[f]={...b.cellChanges[f],...v}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let _=I.start|0,P=I.end|0;return _<0&&(_=0),P>this._cells.length&&(P=this._cells.length),I.with({start:_,end:P})}_getCells(I){I=this._validateRange(I);const _=[];for(let P=I.start;P<I.end;P++)_.push(this._cells[P]);return _}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,_,P){if(this._disposed)return;const b=[],w=[],p=[];if(I.reverse().forEach(g=>{const f=g[2].map(a=>{const h=new E(this,this._textDocumentsAndEditors,a);return _||w.push(E.asModelAddData(this.apiNotebook,a)),h}),c=new D(g[0],g[1],[],f),m=this._cells.splice(g[0],g[1],...f);for(const a of m)p.push(a.uri),c.deletedItems.push(a.apiCell);b.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:p}),P)for(const g of b)P.push(g.asApiEvent())}_moveCell(I,_,P){const b=this._cells.splice(I,1);this._cells.splice(_,0,...b);const w=[new D(I,1,b.map(p=>p.apiCell),[]),new D(_,0,[],b)];for(const p of w)P.push(p.asApiEvent())}_setCellOutputs(I,_){this._cells[I].setOutputs(_)}_setCellOutputItems(I,_,P,b){this._cells[I].setOutputItems(_,P,b)}_changeCellLanguage(I,_){const P=this._cells[I];P.apiCell.document.languageId!==_&&this._textDocuments.$acceptModelLanguageChanged(P.uri,_)}_changeCellMime(I,_){const P=this._cells[I];P.apiCell.mime=_}_changeCellMetadata(I,_){this._cells[I].setMetadata(_)}_changeCellInternalMetadata(I,_){this._cells[I].setInternalMetadata(_)}getCellFromApiCell(I){return this._cells.find(_=>_.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(_=>_.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(Ie[131],ke([1,0,7,15,12]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:k})}replaceCells(E,k,R){this._throwIfFinalized(),!(E===k&&R.length===0)&&this._collectedEdits.push({editType:1,index:E,count:k-E,cells:R.map(n.NotebookCellData.from)})}}class C{constructor(E,k,R,I,_,P){this.id=E,this._proxy=k,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=I,this._viewColumn=P}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(k){this.selections=[k]},get selections(){return E._selections},set selections(k){if(!Array.isArray(k)||!k.every(u.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");E._selections=k,E._trySetSelections(k)},get visibleRanges(){return E._visibleRanges},revealRange(k,R){E._proxy.$tryRevealRange(E.id,n.NotebookRange.from(k),R??u.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(k){const R=new A(this.document.version);return k(R),E._applyEdit(R.finalize())}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(n.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const k=[];let R=-1;for(let I=0;I<E.cellEdits.length;I++){if(R<0){k.push(E.cellEdits[I]),R++;continue}const P=k[R],b=E.cellEdits[I];if(P.editType===1&&b.editType===1&&P.index===b.index){P.cells.push(...E.cellEdits[I].cells),P.count+=E.cellEdits[I].count;continue}k.push(E.cellEdits[I]),R++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,k)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(Ie[224],ke([1,0,3,14,15]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(D,E){this._logService=D,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(D,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,E);const k=this._notebooksAndEditors.getEditorById(D);E.visibleRanges&&k._acceptVisibleRanges(E.visibleRanges.ranges.map(S.NotebookRange.to)),E.selections&&k._acceptSelections(E.selections.selections.map(S.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const E in D)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(S.ViewColumn.to(D[E]))}};A=Ge([He(0,n.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Ie[225],ke([1,0,15,119,172,21,57,12]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,P,b){const w=this._handles++,{title:p,location:g,cancellable:v}=P,f={label:(0,S.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(w,{location:u.ProgressLocation.from(g),title:p,source:f,cancellable:v},_.isUnderDevelopment?void 0:_.identifier.value).catch(D.onUnexpectedExternalError),this._withProgress(w,b,!!v)}_withProgress(_,P,b){let w;b&&(w=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,w));const p=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),w&&w.dispose()};let g;try{g=P(new R(this._proxy,_),b&&w?w.token:A.CancellationToken.None)}catch(v){throw p(_),v}return g.then(v=>p(_),v=>p(_)),g}$acceptProgressCanceled(_){const P=this._mapHandleToCancellationSource.get(_);P&&(P.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=E;function k(I,_){return I.message=_.message,typeof _.increment=="number"&&(typeof I.increment=="number"?I.increment+=_.increment:I.increment=_.increment),I}class R extends n.Progress{constructor(_,P){super(b=>this.throttledReport(b));this._proxy=_,this._handle=P}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Ge([(0,C.throttle)(100,(I,_)=>k(I,_),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ie[132],ke([1,0,35,129,65,89,66,15,2]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(f,c,m,a)=>{let h=c;return{enumerable:!0,configurable:!1,get(){return h},set(r){if(!m(h,r)){const s=h;h=r,f.listener?.(a(r,s))}}}},R=(f,c)=>f===c,I={range:(f,c)=>f===c?!0:!f||!c?!1:f.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,c)=>!(f.length!==c.length||f.some(m=>!c.find(a=>m.id===a.id)))},_=f=>c=>({op:4,update:f(c)}),P=(f,c)=>({range:k(f,void 0,I.range,_(m=>({range:u.Range.lift(D.Range.from(m))}))),label:k(f,c,I.label,_(m=>({label:m}))),description:k(f,void 0,I.description,_(m=>({description:m}))),sortText:k(f,void 0,I.sortText,_(m=>({sortText:m}))),canResolveChildren:k(f,!1,I.canResolveChildren,m=>({op:2,state:m})),busy:k(f,!1,I.busy,_(m=>({busy:m}))),error:k(f,void 0,I.error,_(m=>({error:D.MarkdownString.fromStrict(m)||null}))),tags:k(f,[],I.tags,(m,a)=>({op:1,new:m.map(D.TestTag.from),old:a.map(D.TestTag.from)}))}),b=f=>{const c=S.TestId.fromString(f.extId),m=new p(c.controllerId,c.localId,f.label,E.URI.revive(f.uri)||void 0);return m.range=D.Range.to(f.range||void 0),m.description=f.description||void 0,m.sortText=f.sortText||void 0,m.tags=f.tags.map(a=>D.TestTag.to({id:(0,C.denamespaceTestTag)(a).tagId})),m},w=f=>{let c;for(const m of f.tests){const a=b(m.item);(0,n.getPrivateApiFor)(a).parent=c,c=a}return c};e.toItemFromContext=w;class p{constructor(c,m,a,h){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const r=(0,n.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof g?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,n.getPrivateApiFor,p),enumerable:!0,writable:!1},...P(r,a)})}}e.TestItemImpl=p;class g extends p{constructor(c,m){super(c,c,m,void 0)}}e.TestItemRootImpl=g;class v extends A.TestItemCollection{constructor(c,m){super({controllerId:c,getApiFor:n.getPrivateApiFor,getChildren:a=>a.children,root:new g(c,m),toITestItem:D.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ie[133],ke([1,0,56,12,93,15,7]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(_,P,b){const w=D._Keys.nextId();_.$registerTextEditorDecorationType(P.identifier,w,A.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:w,dispose(){_.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=D,D._Keys=new S.IdGenerator("TextEditorDecorationType");class E{constructor(_,P){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=P.undoStopBefore,this._undoStopAfter=P.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,P){this._throwIfFinalized();let b=null;if(_ instanceof C.Position)b=new C.Range(_,_);else if(_ instanceof C.Range)b=_;else throw new Error("Unrecognized location");this._pushEdit(b,P,!1)}insert(_,P){this._throwIfFinalized(),this._pushEdit(new C.Range(_,_),P,!0)}delete(_){this._throwIfFinalized();let P=null;if(_ instanceof C.Range)P=_;else throw new Error("Unrecognized location");this._pushEdit(P,null,!0)}_pushEdit(_,P,b){const w=this._document.validateRange(_);this._collectedEdits.push({range:w,text:P,forceMoveMarkers:b})}setEndOfLine(_){if(this._throwIfFinalized(),_!==C.EndOfLine.LF&&_!==C.EndOfLine.CRLF)throw(0,n.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=E;class k{constructor(_,P,b,w){this._proxy=_,this._id=P,this._accept(b),this._logService=w;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(g){p._setTabSize(g)},get insertSpaces(){return p._insertSpaces},set insertSpaces(g){p._setInsertSpaces(g)},get cursorStyle(){return p._cursorStyle},set cursorStyle(g){p._setCursorStyle(g)},get lineNumbers(){return p._lineNumbers},set lineNumbers(g){p._setLineNumbers(g)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const P=Math.floor(_);return P>0?P:null}if(typeof _=="string"){const P=parseInt(_,10);return isNaN(P)?null:P>0?P:null}return null}_setTabSize(_){const P=this._validateTabSize(_);if(P!==null){if(typeof P=="number"){if(this._tabSize===P)return;this._tabSize=P}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:P}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const P=this._validateInsertSpaces(_);if(typeof P=="boolean"){if(this._insertSpaces===P)return;this._insertSpaces=P}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:P}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(_)})))}assign(_){const P={};let b=!1;if(typeof _.tabSize!="undefined"){const w=this._validateTabSize(_.tabSize);w==="auto"?(b=!0,P.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,b=!0,P.tabSize=w)}if(typeof _.insertSpaces!="undefined"){const w=this._validateInsertSpaces(_.insertSpaces);w==="auto"?(b=!0,P.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,b=!0,P.insertSpaces=w)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,b=!0,P.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,b=!0,P.lineNumbers=A.TextEditorLineNumbersStyle.from(_.lineNumbers)),b&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,P))}_warnOnError(_,P){P.catch(b=>{this._logService.warn(`ExtHostTextEditorOptions '${_}' failed:'`),this._logService.warn(b)})}}e.ExtHostTextEditorOptions=k;class R{constructor(_,P,b,w,p,g,v,f){this.id=_,this._proxy=P,this._logService=b,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,g,b),this._visibleRanges=v,this._viewColumn=f;const c=this;this.value=Object.freeze({get document(){return w.getValue()},set document(m){throw(0,n.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof C.Selection))throw(0,n.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(a=>!(a instanceof C.Selection)))throw(0,n.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,n.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,n.readonly)("viewColumn")},edit(m,a={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new E(w.getValue(),a);return m(h),c._applyEdit(h)},insertSnippet(m,a,h={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!a||Array.isArray(a)&&a.length===0)r=c._selections.map(s=>A.Range.from(s));else if(a instanceof C.Position){const{lineNumber:s,column:i}=A.Position.from(a);r=[{startLineNumber:s,startColumn:i,endLineNumber:s,endColumn:i}]}else if(a instanceof C.Range)r=[A.Range.from(a)];else{r=[];for(const s of a)if(s instanceof C.Range)r.push(A.Range.from(s));else{const{lineNumber:i,column:t}=A.Position.from(s);r.push({startLineNumber:i,startColumn:t,endLineNumber:i,endColumn:t})}}return P.$tryInsertSnippet(_,w.getValue().version,m.value,r,h)},setDecorations(m,a){const h=a.length===0;h&&!c._hasDecorationsForKey.has(m.key)||(h?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(a))return P.$trySetDecorations(_,m.key,A.fromRangeOrRangeWithMessage(a));{const r=new Array(4*a.length);for(let s=0,i=a.length;s<i;s++){const t=a[s];r[4*s]=t.start.line+1,r[4*s+1]=t.start.character+1,r[4*s+2]=t.end.line+1,r[4*s+3]=t.end.character+1}return P.$trySetDecorationsFast(_,m.key,r)}}))},revealRange(m,a){c._runOnProxy(()=>P.$tryRevealRange(_,A.Range.from(m),a||C.TextEditorRevealType.Default))},show(m){P.$tryShowEditor(_,A.ViewColumn.from(m))},hide(){P.$tryHideEditor(_)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,u.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,u.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,u.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,u.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const P=_.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const b=P.edits.map(p=>p.range);b.sort((p,g)=>p.end.line===g.end.line?p.end.character===g.end.character?p.start.line===g.start.line?p.start.character-g.start.character:p.start.line-g.start.line:p.end.character-g.end.character:p.end.line-g.end.line);for(let p=0,g=b.length-1;p<g;p++){const v=b[p].end;if(b[p+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=P.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,w,{setEndOfLine:typeof P.setEndOfLine=="number"?A.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this._logService.warn(P),null))}}e.ExtHostTextEditor=R}),define(Ie[226],ke([1,0,4,191]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(n.IEnvironmentService)}),define(Ie[227],ke([1,0,28,3,9]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(I){this.removedDueToLooping=I}}e.DeltaExtensionsResult=A;class C{constructor(I){this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=I,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const I of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(I.identifier))){console.error("Extension `"+I.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(I.identifier),I),this._extensionsArr.push(I),Array.isArray(I.activationEvents))for(let _ of I.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(I.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(I)}}set(I){this._extensionDescriptions=I,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(I,_){this._extensionDescriptions=k(this._extensionDescriptions,_),this._extensionDescriptions=this._extensionDescriptions.concat(I);const P=C._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,P.map(b=>b.identifier)),this._initialize(),this._onDidChange.fire(void 0),new A(P)}static _findLoopingExtensions(I){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,v){this.addNode(g),this.addNode(v),this._arcs.has(g)?this._arcs.get(g).push(v):this._arcs.set(g,[v])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,v){const f=_.getArcs(g);for(let c=0;c<f.length;c++)if(!v.has(f[c]))return!1;return!0}getNodes(){return this._nodesArr}},P=new Map;for(const g of I){const v=u.ExtensionIdentifier.toKey(g.identifier);if(P.set(v,g),g.extensionDependencies)for(const f of g.extensionDependencies){const c=u.ExtensionIdentifier.toKey(f);_.addArc(v,c)}}const b=new Set;_.getNodes().filter(g=>_.getArcs(g).length===0).forEach(g=>b.add(g));const w=_.getNodes().filter(g=>!b.has(g));let p;do{p=!1;for(let g=0;g<w.length;g++){const v=w[g];_.hasOnlyGoodArcs(v,b)&&(w.splice(g,1),g--,b.add(v),p=!0)}}while(p);return w.map(g=>P.get(g))}containsActivationEvent(I){return this._activationMap.has(I)}containsExtension(I){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(I))}getExtensionDescriptionsForActivationEvent(I){const _=this._activationMap.get(I);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(I){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(I));return _||void 0}getExtensionDescriptionByUUID(I){for(const _ of this._extensionsArr)if(_.uuid===I)return _}getExtensionDescriptionByIdOrUUID(I,_){return this.getExtensionDescription(I)??(_?this.getExtensionDescriptionByUUID(_):void 0)}}e.ExtensionDescriptionRegistry=C;var D;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(D||(D={}));function E(R,I){const _=R.isBuiltin?0:R.isUnderDevelopment?2:1,P=I.isBuiltin?0:I.isUnderDevelopment?2:1;if(_!==P)return _-P;const b=S.posix.basename(R.extensionLocation.path),w=S.posix.basename(I.extensionLocation.path);return b<w?-1:b>w?1:0}function k(R,I){const _=new Set;return I.forEach(P=>_.add(u.ExtensionIdentifier.toKey(P))),R.filter(P=>!_.has(u.ExtensionIdentifier.toKey(P.identifier)))}}),define(Ie[228],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var u;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(u=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class n{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[n.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=n,n.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class S{constructor(){this.type=2}serialize(I){I[S.ENV_KEY]="1"}}e.SocketExtHostConnection=S,S.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(I){I[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(R){delete R[n.ENV_KEY],delete R[S.ENV_KEY],delete R[A.ENV_KEY]}function D(R,I){C(I),R.serialize(I)}e.writeExtHostConnection=D;function E(R){if(R[n.ENV_KEY])return k(R,new n(R[n.ENV_KEY]));if(R[S.ENV_KEY])return k(R,new S);if(R[A.ENV_KEY])return k(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function k(R,I){return C(R),I}}),define(Ie[134],ke([1,0,23]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var n;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(n=e.UIKind||(e.UIKind={}));var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function C(k){const R=u.VSBuffer.alloc(1);switch(k){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=C;function D(k,R){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=D;var E;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[27],ke([1,0,3,2,4,28,200]),function(X,e,u,n,S,A,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:n.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class E{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class k{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=k;class R{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class I{constructor(t){this.dependency=t}}e.MissingExtensionDependency=I;var _;(function(i){i[i.LocalProcess=1]="LocalProcess",i[i.LocalWebWorker=2]="LocalWebWorker",i[i.Remote=3]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));function P(i){if(i===null)return"None";switch(i){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=P;class b{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,o){const l=[],d=[],y=[],L=[],M=g(this._allExtensions),F=g(t),T=(te,B)=>te.extensionLocation.toString()===B.extensionLocation.toString()||te.isBuiltin===B.isBuiltin||te.isUserBuiltin===B.isUserBuiltin||te.isUnderDevelopment===B.isUnderDevelopment;for(const te of this._allExtensions){const B=F.get(A.ExtensionIdentifier.toKey(te.identifier));if(!B){l.push(te.identifier),M.delete(A.ExtensionIdentifier.toKey(te.identifier));continue}if(!T(te,B)){l.push(te.identifier),M.delete(A.ExtensionIdentifier.toKey(te.identifier));continue}}for(const te of t){const B=M.get(A.ExtensionIdentifier.toKey(te.identifier));if(!B){d.push(te);continue}if(!T(B,te)){l.push(B.identifier),M.delete(A.ExtensionIdentifier.toKey(B.identifier));continue}}const U=p(this._myExtensions),N=p(o);for(const te of this._myExtensions)N.has(A.ExtensionIdentifier.toKey(te))||y.push(te);for(const te of o)U.has(A.ExtensionIdentifier.toKey(te))||L.push(te);const H={toRemove:l,toAdd:d,myToRemove:y,myToAdd:L};return this.delta(H),H}delta(t){const{toRemove:o,toAdd:l,myToRemove:d,myToAdd:y}=t,L=p(o),M=p(d);for(let F=0;F<this._allExtensions.length;F++)L.has(A.ExtensionIdentifier.toKey(this._allExtensions[F].identifier))&&(this._allExtensions.splice(F,1),F--);for(let F=0;F<this._myExtensions.length;F++)M.has(A.ExtensionIdentifier.toKey(this._myExtensions[F]))&&(this._myExtensions.splice(F,1),F--);for(const F of l)this._allExtensions.push(F);for(const F of y)this._myExtensions.push(F)}containsExtension(t){for(const o of this._myExtensions)if(A.ExtensionIdentifier.equals(o,t))return!0;return!1}}e.ExtensionHostExtensions=b;class w{constructor(t){if(this[D]="ExtensionIdentifierSet",this._map=new Map,this._toKey=A.ExtensionIdentifier.toKey,t)for(const o of t)this.add(o)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,o){this._map.forEach(l=>t.call(o,l,l,this))}*entries(){for(const[t,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=w;function p(i){const t=new Set;for(const o of i)t.add(A.ExtensionIdentifier.toKey(o));return t}e.extensionIdentifiersArrayToSet=p;function g(i){const t=new Map;for(const o of i)t.set(A.ExtensionIdentifier.toKey(o.identifier),o);return t}function v(i,t){return i.enabledApiProposals?i.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=v;function f(i,t){if(!v(i,t))throw new Error(`Extension '${i.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${i.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${i.identifier.value}`)}e.checkProposedApiEnabled=f;class c{constructor(t,o,l,d){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=l,this.activationReason=d}}e.ActivationTimes=c;class m{constructor(t,o){this.description=t,this.value=o}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var a;(function(i){i[i.Normal=0]="Normal",i[i.Immediate=1]="Immediate"})(a=e.ActivationKind||(e.ActivationKind={}));function h(i){return{type:i.isBuiltin?0:1,isBuiltin:i.isBuiltin||i.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(i.publisher,i.name),uuid:i.uuid},manifest:i,location:i.extensionLocation,targetPlatform:i.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function r(i,t){return{identifier:new A.ExtensionIdentifier((0,C.getExtensionId)(i.manifest.publisher,i.manifest.name)),isBuiltin:i.type===0,isUserBuiltin:i.type===1&&i.isBuiltin,isUnderDevelopment:!!t,extensionLocation:i.location,...i.manifest,uuid:i.identifier.uuid,targetPlatform:i.targetPlatform}}e.toExtensionDescription=r;class s{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,o){return Promise.resolve(0)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,o){return Promise.resolve()}}e.NullExtensionService=s}),define(Ie[229],ke([1,0,12,28,27,14,18]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(p,g,v,f){this.startup=p,this.codeLoadingTime=g,this.activateCallTime=v,this.activateResolvedTime=f}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class E{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,g){return p===-1||g===-1?-1:g-p}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class k{constructor(p,g,v,f,c,m){this.activationFailed=p,this.activationFailedError=g,this.activationTimes=v,this.module=f,this.exports=c,this.subscriptions=m}}e.ActivatedExtension=k;class R extends k{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class I extends k{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class _ extends k{constructor(p){super(!0,p,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let P=class{constructor(p,g,v,f,c){this._logService=c,this._registry=p,this._resolvedExtensionsSet=new Set,g.forEach(m=>this._resolvedExtensionsSet.add(n.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,v.forEach(m=>this._externalExtensionsMap.set(n.ExtensionIdentifier.toKey(m),m)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[p,g]of this._operations)g.dispose()}isActivated(p){const g=this._operations.get(n.ExtensionIdentifier.toKey(p));return Boolean(g&&g.value)}getActivatedExtension(p){const g=this._operations.get(n.ExtensionIdentifier.toKey(p));if(!g||!g.value)throw new Error(`Extension '${p.value}' is not known or not activated`);return g.value}async activateByEvent(p,g){if(this._alreadyActivatedEvents[p])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(p);await this._activateExtensions(v.map(f=>({id:f.identifier,reason:{startup:g,extensionId:f.identifier,activationEvent:p}}))),this._alreadyActivatedEvents[p]=!0}activateById(p,g){const v=this._registry.getExtensionDescription(p);if(!v)throw new Error(`Extension '${p}' is not known`);return this._activateExtensions([{id:v.identifier,reason:g}])}async _activateExtensions(p){const g=p.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(g.map(v=>v.wait()))}_handleActivationRequest(p){if(this._operations.has(n.ExtensionIdentifier.toKey(p.id)))return this._operations.get(n.ExtensionIdentifier.toKey(p.id));if(this._externalExtensionsMap.has(n.ExtensionIdentifier.toKey(p.id)))return this._createAndSaveOperation(p,null,[],null);const g=this._registry.getExtensionDescription(p.id);if(!g){const c=new Error(`Cannot activate unknown extension '${p.id.value}'`),m=this._createAndSaveOperation(p,null,[],new _(c));return this._host.onExtensionActivationError(p.id,c,new S.MissingExtensionDependency(p.id.value)),m}const v=[],f=typeof g.extensionDependencies=="undefined"?[]:g.extensionDependencies;for(const c of f){if(this._resolvedExtensionsSet.has(n.ExtensionIdentifier.toKey(c)))continue;const m=this._operations.get(n.ExtensionIdentifier.toKey(c));if(m){v.push(m);continue}if(this._externalExtensionsMap.has(n.ExtensionIdentifier.toKey(c))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(n.ExtensionIdentifier.toKey(c)),reason:p.reason}));continue}const a=this._registry.getExtensionDescription(c);if(a){if(!a.main&&!a.browser)continue;v.push(this._handleActivationRequest({id:a.identifier,reason:p.reason}));continue}const h=g.displayName||g.identifier.value,r=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${c}'`),s=this._createAndSaveOperation(p,g.displayName,[],new _(r));return this._host.onExtensionActivationError(g.identifier,r,new S.MissingExtensionDependency(c)),s}return this._createAndSaveOperation(p,g.displayName,v,null)}_createAndSaveOperation(p,g,v,f){const c=new b(p.id,g,p.reason,v,f,this._host,this._logService);return this._operations.set(n.ExtensionIdentifier.toKey(p.id),c),c}};P=Ge([He(4,A.ILogService)],P),e.ExtensionsActivator=P;let b=class{constructor(p,g,v,f,c,m,a){this._id=p,this._displayName=g,this._reason=v,this._deps=f,this._value=c,this._host=m,this._logService=a,this._barrier=new C.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let p=0;p<this._deps.length;p++){const g=this._deps[p];if(g.value&&!g.value.activationFailed){this._deps.splice(p,1),p--;continue}if(g.value&&g.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);v.detail=g.value.activationFailedError,this._value=new _(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(p=>p.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(p){const g=new Error;if(p&&p.name&&(g.name=p.name),p&&p.message?g.message=`Activating extension '${this._id.value}' failed: ${p.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${p}.`,p&&p.stack&&(g.stack=p.stack),this._value=new _(g),this._isDisposed&&u.isCancellationError(p))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(p)}}};b=Ge([He(6,A.ILogService)],b)}),define(Ie[230],ke([1,0,14,26,27]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends u.LogService{constructor(D,E){super(D.createLogger(E.logFile,{name:S.ExtensionHostLogFileName}))}};A=Ge([He(0,u.ILoggerService),He(1,n.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(Ie[231],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textEditorDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textEditorDrop.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[232],ke([1,0,186,12,41,84,120,44,28,231,198]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const I=D.Registry.as(C.Extensions.JSONContribution);class _{constructor(c,m,a){this._messageHandler=c,this._extension=m,this._extensionPointId=a}_msg(c,m){this._messageHandler({type:c,message:m,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(S.default.Error,c)}warn(c){this._msg(S.default.Warning,c)}info(c){this._msg(S.default.Info,c)}}e.ExtensionMessageCollector=_;class P{constructor(c,m){this.added=c,this.removed=m}static _toSet(c){const m=new Set;for(let a=0,h=c.length;a<h;a++)m.add(E.ExtensionIdentifier.toKey(c[a].description.identifier));return m}static compute(c,m){if(!c||!c.length)return new P(m,[]);if(!m||!m.length)return new P([],c);const a=this._toSet(c),h=this._toSet(m),r=m.filter(i=>!a.has(E.ExtensionIdentifier.toKey(i.description.identifier))),s=c.filter(i=>!h.has(E.ExtensionIdentifier.toKey(i.description.identifier)));return new P(r,s)}}e.ExtensionPointUserDelta=P;class b{constructor(c,m){this.name=c,this.defaultExtensionKind=m,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=P.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,n.onUnexpectedError)(c)}}}e.ExtensionPoint=b;const w={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:u.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(30,null)},{label:"onUri",body:"onUri",description:u.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(35,null)},{label:"onRenderer",description:u.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(38,null)},{label:"*",description:u.localize(39,null),body:"*"}]}},badges:{type:"array",description:u.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(41,null)},href:{type:"string",description:u.localize(42,null)},description:{type:"string",description:u.localize(43,null)}}}},markdown:{type:"string",description:u.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(48,null),type:"array",items:w,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(49,null)},{body:["workspace"],description:u.localize(50,null)},{body:["ui","workspace"],description:u.localize(51,null)},{body:["workspace","ui"],description:u.localize(52,null)},{body:[],description:u.localize(53,null)}]},capabilities:{description:u.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)]},description:{type:"string",markdownDescription:u.localize(60,null)}}},untrustedWorkspaces:{description:u.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(63,null),u.localize(64,null),u.localize(65,null)]},restrictedConfigurations:{description:u.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(67,null)}}}}},sponsor:{description:u.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(70,null),type:"string"},"vscode:uninstall":{description:u.localize(71,null),type:"string"}}},icon:{type:"string",description:u.localize(72,null)}}};class g{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const m=new b(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,m),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,I.registerSchema(p,e.schema),m}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=g;const v={ExtensionsRegistry:"ExtensionsRegistry"};D.Registry.add(v.ExtensionsRegistry,new g),e.ExtensionsRegistry=D.Registry.as(v.ExtensionsRegistry),I.registerSchema(p,e.schema),I.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[233],ke([1,0,183,10,24,232,51,3]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var k;(function(_){function P(b,w,p){if(!b)return;const g=n.isString(b.type)?b.type:void 0;if(!g||g.length===0){p.error(u.localize(3,null));return}const v=[];if(Array.isArray(b.required))for(const f of b.required)n.isString(f)&&v.push(f);return{extensionId:w.value,taskType:g,required:v,properties:b.properties?S.deepClone(b.properties):{},when:b.when?C.ContextKeyExpr.deserialize(b.when):void 0}}_.from=P})(k||(k={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:E}});class I{constructor(){this._onDefinitionsChanged=new D.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((P,b)=>{R.setHandler((w,p)=>{this._schema=void 0;try{for(const g of p.removed){const v=g.value;for(const f of v)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(const g of p.added){const v=g.value;for(const f of v){const c=k.from(f,g.description.identifier,g.collector);c&&(this.taskTypes[c.taskType]=c)}}(p.removed.length>0||p.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}P(void 0)})})}onReady(){return this.readyPromise}get(P){return this.taskTypes[P]}all(){return Object.keys(this.taskTypes).map(P=>this.taskTypes[P])}getJsonSchema(){if(this._schema===void 0){const P=[];for(const b of this.all()){const w={type:"object",additionalProperties:!1};b.required.length>0&&(w.required=b.required.slice(0)),b.properties!==void 0?w.properties=S.deepClone(b.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[b.taskType]},P.push(w)}this._schema={oneOf:P}}return this._schema}}e.TaskDefinitionRegistryImpl=I,e.TaskDefinitionRegistry=new I}),define(Ie[234],ke([1,0,184,10,22,24,51,233]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var E;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function N(H){if(!H)return U.Strong;switch(H.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=N}(E=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var R;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(U){function N(H){switch(H.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=N}(R=e.RevealKind||(e.RevealKind={}));var I;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function N(H){switch(H.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=N}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var _;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(_=e.PanelKind||(e.PanelKind={})),function(U){function N(H){switch(H.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=N}(_=e.PanelKind||(e.PanelKind={}));var P;(function(U){U.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:_.Shared,showReuseMessage:!0,clear:!1}})(P=e.PresentationOptions||(e.PresentationOptions={}));var b;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(b=e.RuntimeType||(e.RuntimeType={})),function(U){function N(te){switch(te.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=N;function H(te){switch(te){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=H}(b=e.RuntimeType||(e.RuntimeType={}));var w;(function(U){function N(H){return n.isString(H)?H:H.value}U.value=N})(w=e.CommandString||(e.CommandString={}));var p;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function N(te){return te===U.Clean._id||te===U.Build._id||te===U.Rebuild._id||te===U.Test._id}U.is=N;function H(te){if(te!==void 0)return n.isString(te)?N(te)?{_id:te,isDefault:!1}:void 0:te}U.from=H})(p=e.TaskGroup||(e.TaskGroup={}));var g;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(g=e.TaskScope||(e.TaskScope={}));var v;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function N(H){switch(H){case U.User:return 1;case U.WorkspaceFile:return 4;default:return 5}}U.toConfigurationTarget=N})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(U){U.parallel="parallel",U.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var c;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class a{constructor(N,H,te,B,z,q){this._label="",this._id=N,H&&(this._label=H),te&&(this.type=te),this.runOptions=B,this.configurationProperties=z,this._source=q}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.getFolderId(),id:this._id};return JSON.stringify(N)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,H=!1){if(N===void 0)return!1;if(n.isString(N))return N===this._label||N===this.configurationProperties.identifier||H&&N===this._id;const te=this.getDefinition(!0);return te!==void 0&&te._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),N&&(this._taskLoadMessages=this._taskLoadMessages.concat(N))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=a;class h extends a{constructor(N,H,te,B,z,q,V,j){super(N,te,void 0,V,j,H);this.command={},this._source=H,this.hasDefinedMatchers=q,z&&(this.command=z)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case b.Shell:H="shell";break;case b.Process:H="process";break;case b.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(N){return N instanceof h}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let H=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(H+=this._source.kind);const te={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:H};return JSON.stringify(te)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(N){return new h(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.CustomTask=h;class r extends a{constructor(N,H,te,B,z,q,V){super(N,te,B,q,V,H);this._source=H,this.configures=z}static is(N){return N instanceof r}fromObject(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.getFolderId();if(!N)return;let H=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(H+=this._source.kind);const te={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:H};return JSON.stringify(te)}}e.ConfiguringTask=r;class s extends a{constructor(N,H,te,B,z,q,V,j,ie){super(N,te,B,j,ie,H);this.defines=z,this.hasDefinedMatchers=V,this.command=q,this.icon=ie.icon}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof s}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.getFolderId(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(N){return new s(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.ContributedTask=s;class i extends a{constructor(N,H,te,B,z,q){super(N,te,B,z,q,H);this._source=H}clone(){return new i(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof i}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(N){return new i(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.InMemoryTask=i;var t;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor(N){this._order=new Map;for(let H=0;H<N.length;H++)this._order.set(N[H].uri.toString(),H)}compare(N,H){const te=N.getWorkspaceFolder(),B=H.getWorkspaceFolder();if(te&&B){let z=this._order.get(te.uri.toString());z=z===void 0?0:z+1;let q=this._order.get(B.uri.toString());return q=q===void 0?0:q+1,z===q?N._label.localeCompare(H._label):z-q}else return!te&&B?-1:te&&!B?1:0}}e.TaskSorter=l;var d;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var y;(function(U){U.SingleRun="singleRun",U.Background="background"})(y=e.TaskRunType||(e.TaskRunType={}));var L;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange"})(L=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(U){function N(H,te,B,z){if(te){const q={kind:H,taskId:te._id,taskName:te.configurationProperties.name,runType:te.configurationProperties.isBackground?"background":"singleRun",group:te.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:te};return H==="start"?(q.terminalId=B,q.resolvedVariables=z):H==="processStarted"?q.processId=B:H==="processEnded"&&(q.exitCode=B),Object.freeze(q)}else return Object.freeze({kind:"changed"})}U.create=N})(M=e.TaskEvent||(e.TaskEvent={}));var F;(function(U){function N(te){const B=Object.keys(te).sort();let z="";for(const q of B){let V=te[q];V instanceof Object?V=N(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),z+=q+","+V+","}return z}function H(te){const z={_key:N(te),type:te.taskType};return Object.assign(z,te),z}U.create=H})(F=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var T;(function(U){function N(H,te){const B=D.TaskDefinitionRegistry.get(H.type);if(B===void 0){const j=A.deepClone(H);return delete j._key,F.create(j)}const z=Object.create(null);z.type=B.taskType;const q=new Set;B.required.forEach(j=>q.add(j));const V=B.properties;for(const j of Object.keys(V)){const ie=H[j];if(ie!=null)z[j]=ie;else if(q.has(j)){const Q=V[j];if(Q.default!==void 0)z[j]=A.deepClone(Q.default);else switch(Q.type){case"boolean":z[j]=!1;break;case"number":case"integer":z[j]=0;break;case"string":z[j]="";break;default:te.error(u.localize(2,null,JSON.stringify(H,void 0,0),j));return}}}return F.create(z)}U.createTaskIdentifier=N})(T=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[235],ke([1,0,12]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class n{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,D)=>{this._actualOk=C,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,u.onUnexpectedError)(C))}then(C,D){return this._ensureActual().then(C,D)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=n;class S extends n{constructor(){super();this._hasErr=!0,this._err=new u.CancellationError}}e.CanceledLazyPromise=S}),define(Ie[53],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const n=[];function S(D){const E=new u(D);return n[E.nid]=E,E}e.createProxyIdentifier=S;function A(D){return n[D].sid}e.getStringIdentifierForProxy=A;class C{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=C}),define(Ie[5],ke([1,0,61,2,53]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.NotebookInput=3]="NotebookInput",f[f.NotebookDiffInput=4]="NotebookDiffInput",f[f.CustomEditorInput=5]="CustomEditorInput",f[f.WebviewEditorInput=6]="WebviewEditorInput",f[f.TerminalEditorInput=7]="TerminalEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var D;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var E;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var k;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(k=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(c){return c._id=P._n++,c}}e.IdObject=P,P._n=0;var b;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(f){if(f&&f.edits)for(const c of f.edits)typeof c.resource=="object"?c.resource=n.URI.revive(c.resource):(c.newUri=n.URI.revive(c.newUri),c.oldUri=n.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,u.revive)(c.metadata));return f}e.reviveWorkspaceEditDto=g;var v;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ie[90],ke([1,0,5,3,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(D){this._onDidChangePassword=new n.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,E){return this._proxy.$getPassword(D,E)}store(D,E,k){return this._proxy.$setPassword(D,E,k)}delete(D,E){return this._proxy.$deletePassword(D,E)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(Ie[67],ke([1,0,4,14,5,17]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(S.MainContext.MainThreadTelemetry)}report(E,k,R){const I=this.getUsageKey(E,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};C=Ge([He(0,A.IExtHostRpcService),He(1,n.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(D,E,k){}})}),define(Ie[236],ke([1,0,3,5,7,28]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(n.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,k,R,I={}){const _=A.ExtensionIdentifier.toKey(E.identifier),P=this._inFlightRequests.get(_)||[],b=[...R].sort().join(" ");let w=P.find(p=>p.providerId===k&&p.scopes===b);if(w)return w.result;{const p=this._getSession(E,_,k,R,I);w={providerId:k,scopes:b,result:p},P.push(w),this._inFlightRequests.set(_,P);try{await p}finally{const g=P.findIndex(v=>v.providerId===k&&v.scopes===b);g>-1&&(P.splice(g),this._inFlightRequests.set(_,P))}return p}}async _getSession(E,k,R,I,_={}){await this._proxy.$ensureProvider(R);const P=E.displayName||E.name;return this._proxy.$getSession(R,I,k,P,_)}async removeSession(E,k){const R=this._authenticationProviders.get(E);return R?R.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,R,I){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:R,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(P=>P.id===E)||this._providers.push({id:E,label:k});const _=R.onDidChangeSessions(P=>{this._proxy.$sendDidChangeSessions(E,{added:P.added??[],changed:P.changed??[],removed:P.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,k,I?.supportsMultipleAccounts??!1),new S.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(E);const P=this._providers.findIndex(b=>b.id===E);P>-1&&this._providers.splice(P),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[237],ke([1,0,5,17,15,27]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(E,k){this._proxy=E.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>k.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,k){const R=(0,A.isProposedApiEnabled)(k,"snippetWorkspaceEdit"),I=S.WorkspaceEdit.from(E,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(I)}};C=Ge([He(0,n.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(Ie[238],ke([1,0,5]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class n{constructor(A){const C=A.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(D){return C.$writeText(D)}})}}e.ExtHostClipboard=n});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[37],ke([1,0,10,7,15,24,5,16,14,61,35,48,2,6,4,17,132,23,53,49]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(o,l){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),tt(this,c,o.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=l,tt(this,m,o.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new h(this,d=>{const y=this._apiCommands.get(d);return y?.result===s.Void?y:void 0},l),this._argumentProcessors=[{processArgument(d){return(0,k.revive)(d)}},{processArgument(d){return(0,A.cloneAndChange)(d,function(y){if(R.Range.isIRange(y))return S.Range.to(y);if(I.Position.isIPosition(y))return S.Position.to(y);if(R.Range.isIRange(y.range)&&_.URI.isUri(y.uri))return S.location.to(y);if(y instanceof g.VSBuffer)return y.buffer.buffer;if(!Array.isArray(y))return y})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const l=this.registerCommand(!1,o.id,async(...d)=>{const y=o.args.map((M,F)=>{if(!M.validate(d[F]))throw new Error(`Invalid argument '${M.name}' when running '${o.id}', received: ${d[F]}`);return M.convert(d[F])}),L=await this.executeCommand(o.internalId,...y);return o.result.convert(L,d,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new n.Disposable(()=>{l.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,l,d,y,L,M){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:d,thisArg:y,description:L,extension:M}),o&&Me(this,c,"f").$registerCommand(l),new n.Disposable(()=>{this._commands.delete(l)&&o&&Me(this,c,"f").$unregisterCommand(l)})}executeCommand(o,...l){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,l,!0)}async _doExecuteCommand(o,l,d){if(this._commands.has(o))return Me(this,c,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,l,!1);{let y=!1;const L=(0,A.cloneAndChange)(l,function(M){if(M instanceof n.Position)return S.Position.from(M);if(M instanceof n.Range)return S.Range.from(M);if(M instanceof n.Location)return S.location.from(M);if(n.NotebookRange.isNotebookRange(M))return S.NotebookRange.from(M);if(M instanceof ArrayBuffer)return y=!0,g.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return y=!0,g.VSBuffer.wrap(M);if(M instanceof g.VSBuffer)return y=!0,M;if(!Array.isArray(M))return M});try{const M=await Me(this,c,"f").$executeCommand(o,y?new v.SerializableObjectWithBuffers(L):L,d);return(0,k.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(o,l,!1);throw M}}}async _executeContributedCommand(o,l,d){const y=this._commands.get(o);if(!y)throw new Error("Unknown command");this._reportTelemetry(y,o);const{callback:L,thisArg:M,description:F}=y;if(F)for(let T=0;T<F.args.length;T++)try{(0,u.validateConstraint)(l[T],F.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${F.args[T].name}' - ${F.args[T].description}`)}try{return await L.apply(M,l)}catch(T){if(o===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...l);U&&(o=U.command)}throw this._logService.error(T,o,y.extension?.identifier),d?new class extends Error{constructor(){super((0,f.toErrorMessage)(T));this.id=o,this.source=y.extension?.displayName??y.extension?.name}}:T}}_reportTelemetry(o,l){!o.extension||o.extension.isBuiltin||Me(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:l})}$executeContributedCommand(o,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(l=l.map(d=>this._argumentProcessors.reduce((y,L)=>L.processArgument(y),d)),this._executeContributedCommand(o,l,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Me(this,c,"f").$getCommands().then(l=>(o&&(l=l.filter(d=>d[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[l,d]of this._commands){const{description:y}=d;y&&(o[l]=y)}return Promise.resolve(o)}};c=new WeakMap,m=new WeakMap,a=Ge([He(0,w.IExtHostRpcService),He(1,E.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,b.createDecorator)("IExtHostCommands");class h{constructor(o,l,d){this._commands=o,this._lookupApiCommand=l,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,l){if(!o)return;const d={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return d;const y=this._lookupApiCommand(o.command);if(y)d.id=y.internalId,d.arguments=y.args.map((L,M)=>L.convert(o.arguments&&o.arguments[M]));else if((0,D.isNonEmptyArray)(o.arguments)){const L=++this._cachIdPool;this._cache.set(L,o),l.add((0,P.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),d.$ident=L,d.id=this.delegatingCommandId,d.arguments=[L],this._logService.trace("CommandsConverter#CREATE",o.command,L)}return d}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const l=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class r{constructor(o,l,d,y){this.name=o,this.description=l,this.validate=d,this.convert=y}optional(){return new r(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,l){return new r(o??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>_.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>n.Position.isPosition(t),S.Position.from),r.Range=new r("range","A range in a text document",t=>n.Range.isRange(t),S.Range.from),r.Selection=new r("selection","A selection in a text document",t=>n.Selection.isSelection(t),S.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof n.CallHierarchyItem,S.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof n.TypeHierarchyItem,S.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof p.TestItemImpl,S.TestItem.from);class s{constructor(o,l){this.description=o,this.convert=l}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class i{constructor(o,l,d,y,L){this.id=o,this.internalId=l,this.description=d,this.args=y,this.result=L}}e.ApiCommand=i}),define(Ie[239],ke([1,0,2,15,7,63,37,16,113,118,11]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",P(n.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(w,p)=>{if((0,D.isFalsyOrEmpty)(w))return;class g extends S.SymbolInformation{static to(f){const c=new g(f.name,n.SymbolKind.to(f.kind),f.containerName||"",new S.Location(p[0],n.Range.to(f.range)));return c.detail=f.detail,c.range=c.location.range,c.selectionRange=n.Range.to(f.selectionRange),c.children=f.children?f.children.map(g.to):[],c}}return w.map(g.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",w=>!0,w=>w)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",w=>!0,w=>w)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",w=>typeof w=="string",w=>w),new C.ApiCommandArgument("options","Formatting options",w=>!0,w=>w)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(n.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",P(n.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",P(n.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",w=>Array.isArray(w)&&w.every(p=>S.Position.isPosition(p)),w=>w.map(n.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",w=>w.map(p=>{let g;for(const v of p.reverse())g=new S.SelectionRange(n.Range.to(v),g);return g}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",w=>w.map(n.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",w=>w.map(n.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",w=>w.map(n.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",w=>w.map(n.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",w=>{if(!!w)return{range:n.Range.to(w.range),placeholder:w.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",w=>{if(!!w){if(w.rejectReason)throw new Error(w.rejectReason);return n.WorkspaceEdit.to(w)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",w=>w.map(n.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",w=>{if(!!w)return new S.SemanticTokensLegend(w.tokenTypes,w.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",w=>{if(!w)return;const p=(0,E.decodeSemanticTokensDto)(w);if(p.type==="full")return new S.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",w=>{if(!!w)return new S.SemanticTokensLegend(w.tokenTypes,w.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",w=>{if(!w)return;const p=(0,E.decodeSemanticTokensDto)(w);if(p.type==="full")return new S.SemanticTokens(p.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(w,p,g)=>{if(!w)return new S.CompletionList([]);const v=w.suggestions.map(f=>n.CompletionItem.to(f,g));return new S.CompletionList(v,w.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",w=>{if(w)return n.SignatureHelp.to(w)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(w,p,g)=>P(v=>new S.CodeLens(n.Range.to(v.range),v.command&&g.fromInternal(v.command)))(w))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",w=>S.Range.isRange(w),w=>S.Selection.isSelection(w)?n.Selection.from(w):n.Range.from(w)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(w,p,g)=>P(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(v.command)}else{const f=new S.CodeAction(v.title,v.kind?new S.CodeActionKind(v.kind):void 0);return v.edit&&(f.edit=n.WorkspaceEdit.to(v.edit)),v.command&&(f.command=g.fromInternal(v.command)),f.isPreferred=v.isPreferred,f}})(w))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",w=>w?w.map(p=>new S.ColorInformation(n.Range.to(p.range),n.Color.to(p.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",w=>w instanceof S.Color,n.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",w=>!0,w=>({uri:w.uri,range:n.Range.from(w.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",w=>w?w.map(n.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(w,p,g)=>w.map(n.InlayHint.to.bind(void 0,g)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",P(w=>({viewType:w.viewType,displayName:w.displayName,options:{transientOutputs:w.options.transientOutputs,transientCellMetadata:w.options.transientCellMetadata,transientDocumentMetadata:w.options.transientDocumentMetadata},filenamePattern:w.filenamePattern.map(p=>n.NotebookExclusiveDocumentPattern.to(p))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",w=>w.map(n.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",w=>u.URI.isUri(w)||typeof w=="string"&&(0,k.matchesSomeScheme)(w,R.Schemas.http,R.Schemas.https),w=>w),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",w=>w===void 0||typeof w=="number"||typeof w=="object",w=>w&&(typeof w=="number"?[n.ViewColumn.from(w),void 0]:[n.ViewColumn.from(w.viewColumn),n.TextEditorOpenOptions.from(w)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",w=>w===void 0||typeof w=="number"||typeof w=="object",w=>w&&(typeof w=="number"?[n.ViewColumn.from(w),void 0]:[n.ViewColumn.from(w.viewColumn),n.TextEditorOpenOptions.from(w)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",w=>w===void 0||typeof w=="object",w=>w&&[n.ViewColumn.from(w.viewColumn),n.TextEditorOpenOptions.from(w)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",w=>w.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",w=>w.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",w=>w.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void)];class _{static register(p){I.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=_;function P(w){return p=>{if(Array.isArray(p))return p.map(w)}}function b(w){if(!Array.isArray(w))return;const p=[];for(const g of w)A.isLocationLink(g)?p.push(n.DefinitionLink.to(g)):p.push(n.location.to(g));return p}}),define(Ie[240],ke([1,0,18,57,3,6,2,63,28,15,7,27,5]),function(X,e,u,n,S,A,C,D,E,k,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function P(b,w,p){const g=b.getProxy(_.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,w.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const o=this._commentControllers.get(t.handle);return o?o.value:t}else if(t&&t.$mid===7){const o=this._commentControllers.get(t.commentControlHandle);if(!o)return t;const l=o.getCommentThread(t.commentThreadHandle);return l?l.value:t}else if(t&&t.$mid===8){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const l=o.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l.value,text:t.text}:t}else if(t&&t.$mid===9){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const l=o.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;const d=t.commentUniqueId,y=l.getCommentByUniqueId(d);return y||t}else if(t&&t.$mid===10){const o=this._commentControllers.get(t.thread.commentControlHandle);if(!o)return t;const l=o.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;const d=t.text,y=t.commentUniqueId,L=l.getCommentByUniqueId(y);return L?(L.body=d,L):t}return t}})}createCommentController(t,o,l){const d=v.handlePool++,y=new c(t,d,o,l);this._commentControllers.set(y.handle,y);const L=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(t.identifier))||[];return L.push(y),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(t.identifier),L),y.value}$createCommentThreadTemplate(t,o,l){const d=this._commentControllers.get(t);!d||d.$createCommentThreadTemplate(o,l)}async $updateCommentThreadTemplate(t,o,l){const d=this._commentControllers.get(t);!d||d.$updateCommentThreadTemplate(o,l)}$deleteCommentThread(t,o){this._commentControllers.get(t)?.$deleteCommentThread(o)}$provideCommentingRanges(t,o,l){const d=this._commentControllers.get(t);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const y=p.getDocument(C.URI.revive(o));return(0,u.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(y,l)).then(L=>L?L.map(M=>k.Range.from(M)):void 0)}$toggleReaction(t,o,l,d,y){const L=this._commentControllers.get(t);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const M=L.getCommentThread(o);if(M){const F=M.getCommentByUniqueId(d.uniqueIdInThread);if(L!==void 0&&F&&L.reactionHandler)return L.reactionHandler(F,h(y))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class f{constructor(t,o,l,d,y,L,M,F){this._commentControllerHandle=o,this._id=l,this._uri=d,this._range=y,this._comments=L,this.extensionDescription=M,this._isTemplate=F,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),g.$createCommentThread(o,this.handle,this._id,this._uri,k.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(o,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(U){T.range=U},get comments(){return T.comments},set comments(U){T.comments=U},get collapsibleState(){return T.collapsibleState},set collapsibleState(U){T.collapsibleState=U},get canReply(){return T.canReply},set canReply(U){T.canReply=U},get contextValue(){return T.contextValue},set contextValue(U){T.contextValue=U},get label(){return T.label},set label(U){T.label=U},get state(){return T.state},set state(U){T.state=U},dispose:()=>{T.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),o={};t("range")&&(o.range=k.Range.from(this._range)),t("label")&&(o.label=this.label),t("contextValue")&&(o.contextValue=this.contextValue??null),t("comments")&&(o.comments=this._comments.map(l=>m(this,l,this._commentsMap))),t("collapsibleState")&&(o.collapseState=r(this._collapseState)),t("canReply")&&(o.canReply=this.canReply),t("state")&&(o.state=s(this._state)),t("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(t){for(const o of this._commentsMap){const l=o[0],d=o[1];if(t===d)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}f._handlePool=0,Ge([(0,n.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(t,o,l,d){this._extension=t,this._handle=o,this._id=l,this._label=d,this._threads=new Map,g.$registerCommentController(this.handle,l,d);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(L){y.options=L},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(L){y.commentingRangeProvider=L},get reactionHandler(){return y.reactionHandler},set reactionHandler(L){y.reactionHandler=L},createCommentThread(L,M,F){return y.createCommentThread(L,M,F).value},dispose:()=>{y.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,o,l,d){if(typeof t=="string"){const y=new f(this.id,this.handle,t,o,l,d,this._extension,!1);return this._threads.set(y.handle,y),y}else{const y=new f(this.id,this.handle,void 0,t,o,l,this._extension,!1);return this._threads.set(y.handle,y),y}}$createCommentThreadTemplate(t,o){const l=new f(this.id,this.handle,void 0,C.URI.revive(t),k.Range.to(o),[],this._extension,!0);return l.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,o){const l=this._threads.get(t);l&&(l.range=k.Range.to(o))}$deleteCommentThread(t){const o=this._threads.get(t);o&&o.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function m(i,t,o){let l=o.get(t);l||(l=++i.commentHandle,o.set(t,l));const d=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:typeof t.body=="string"?t.body:k.MarkdownString.from(t.body),userName:t.author.name,userIconPath:d,label:t.label,commentReactions:t.reactions?t.reactions.map(y=>a(y)):void 0,timestamp:t.timestamp?.toJSON()}}function a(i){return{label:i.label,iconPath:i.iconPath?k.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function h(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?C.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function r(i){if(i!==void 0)switch(i){case R.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}function s(i){if(i!==void 0)switch(i){case R.CommentThreadState.Unresolved:return D.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return D.CommentThreadState.Resolved}return D.CommentThreadState.Unresolved}return new v}e.createExtHostComments=P}),define(Ie[241],ke([1,0,24,5,26,17]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(R,I){this._mainThreadConsole=R.getProxy(n.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,I){const _=this,P=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){_._handleConsoleCall(R,I,P,arguments)}})}_handleConsoleCall(R,I,_,P){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(P,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,_,P)}};C=Ge([He(0,A.IExtHostRpcService),He(1,S.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const D=1e5;function E(k,R){const I=[];if(k.length)for(let _=0;_<k.length;_++){let P=k[_];if(typeof P=="undefined")P="undefined";else if(P instanceof Error){const b=P;b.stack?P=b.stack:P=b.toString()}I.push(P)}if(R){const _=new Error().stack;_&&I.push({__$stack:_.split(`
`).slice(3).join(`
`)})}try{const _=(0,u.safeStringify)(I);return _.length>D?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}),define(Ie[135],ke([1,0,2,5,7,4,17,14,16,8,9]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class Dn{constructor(P,b){this._logService=b,this._provider=new Map,this._proxy=P.getProxy(n.MainContext.MainThreadDecorations)}registerFileDecorationProvider(P,b){const w=Dn._handlePool++;this._provider.set(w,{provider:P,extensionId:b}),this._proxy.$registerDecorationProvider(w,b.value);const p=P.onDidChangeFileDecorations&&P.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(w,null);return}const v=(0,E.asArray)(g);if(v.length<=Dn._maxEventSize){this._proxy.$onDidChange(w,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",b.value,v.length);const f=v.map(a=>({uri:a,rank:(0,k.count)(a.path,"/")})),c=(0,E.groupBy)(f,(a,h)=>a.rank-h.rank||(0,k.compare)(a.uri.path,h.uri.path)),m=[];e:for(const a of c){let h;for(const r of a){const s=(0,R.dirname)(r.uri.path);if(h!==s&&(h=s,m.push(r.uri)>=Dn._maxEventSize))break e}}this._proxy.$onDidChange(w,m)});return new S.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(P,b,w){if(!this._provider.has(P))return Object.create(null);const p=Object.create(null),{provider:g,extensionId:v}=this._provider.get(P);return await Promise.all(b.map(async f=>{try{const{uri:c,id:m}=f,a=await Promise.resolve(g.provideFileDecoration(u.URI.revive(c),w));if(!a)return;try{S.FileDecoration.validate(a),p[m]=[a.propagate,a.tooltip,a.badge,a.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${v.value}': ${h}`)}}catch(c){this._logService.error(c)}})),p}};I._handlePool=0,I._maxEventSize=250,I=Ge([He(0,C.IExtHostRpcService),He(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[242],ke([1,0,170,117,2,5,7,15,3,14,25,46]),function(X,e,u,n,S,A,C,D,E,k,R,I){"use strict";var _,P,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(v,f,c,m,a,h){this._name=v,this._owner=f,this._maxDiagnosticsPerFile=c,_.set(this,void 0),P.set(this,void 0),b.set(this,void 0),this._isDisposed=!1,tt(this,b,new R.ResourceMap(r=>m.getComparisonKey(r)),"f"),tt(this,_,a,"f"),tt(this,P,h,"f")}dispose(){this._isDisposed||(Me(this,P,"f").fire([...Me(this,b,"f").keys()]),Me(this,_,"f")?.$clear(this._owner),Me(this,b,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,f){if(!v){this.clear();return}this._checkDisposed();let c=[];if(S.URI.isUri(v)){if(!f){this.delete(v);return}Me(this,b,"f").set(v,f.slice()),c=[v]}else if(Array.isArray(v)){c=[];let a;v=[...v].sort(w._compareIndexedTuplesByUri);for(const h of v){const[r,s]=h;if((!a||r.toString()!==a.toString())&&(a&&Me(this,b,"f").get(a).length===0&&Me(this,b,"f").delete(a),a=r,c.push(r),Me(this,b,"f").set(r,[])),s)Me(this,b,"f").get(r)?.push(...s);else{const i=Me(this,b,"f").get(r);i&&(i.length=0)}}}if(Me(this,P,"f").fire(c),!Me(this,_,"f"))return;const m=[];for(const a of c){let h=[];const r=Me(this,b,"f").get(a);if(r)if(r.length>this._maxDiagnosticsPerFile){h=[];const s=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const t of r)if(t.severity===s[i]&&h.push(D.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;h.push({severity:n.MarkerSeverity.Info,message:(0,u.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=r.map(s=>D.Diagnostic.from(s));m.push([a,h])}Me(this,_,"f").$changeMany(this._owner,m)}delete(v){this._checkDisposed(),Me(this,P,"f").fire([v]),Me(this,b,"f").delete(v),Me(this,_,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Me(this,P,"f").fire([...Me(this,b,"f").keys()]),Me(this,b,"f").clear(),Me(this,_,"f")?.$clear(this._owner)}forEach(v,f){this._checkDisposed();for(const[c,m]of this)v.call(f,c,m,this)}*[(_=new WeakMap,P=new WeakMap,b=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Me(this,b,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const f=Me(this,b,"f").get(v);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Me(this,b,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,f){return v[0].toString()<f[0].toString()?-1:v[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=w;let p=class hn{constructor(v,f,c){this._logService=f,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,hn._mapper),this._proxy=v.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(v){const f=new R.ResourceMap;for(const c of v)f.set(c,c);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(v,f){const{_collections:c,_proxy:m,_onDidChangeDiagnostics:a,_logService:h,_fileSystemInfoService:r}=this,s=new class{$changeMany(o,l){m.$changeMany(o,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,o,l.length===0?"CLEARING":l)}$clear(o){m.$clear(o),h.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,o)}dispose(){m.dispose()}};let i;if(!f)f="_generated_diagnostic_collection_name_#"+hn._idPool++,i=f;else if(!c.has(f))i=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do i=f+hn._idPool++;while(c.has(i))}return new class extends w{constructor(){super(f,i,hn._maxDiagnosticsPerFile,r.extUri,s,a);c.set(i,this)}dispose(){super.dispose(),c.delete(i)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const f=new Map,c=[];for(const m of this._collections.values())m.forEach((a,h)=>{let r=f.get(a.toString());typeof r=="undefined"&&(r=c.length,f.set(a.toString(),r),c.push([a,[]])),c[r][1]=c[r][1].concat(...h)});return c}}_getDiagnostics(v){let f=[];for(const c of this._collections.values())c.has(v)&&(f=f.concat(c.get(v)));return f}$acceptMarkersChange(v){if(!this._mirrorCollection){const f="_generated_mirror",c=new w(f,f,hn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,c),this._mirrorCollection=c}for(const[f,c]of v)this._mirrorCollection.set(S.URI.revive(f),c.map(D.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Ge([He(1,k.ILogService),He(2,I.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(Ie[243],ke([1,0,2,5]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(C){this._proxy=C.getProxy(n.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(D=>D?D.map(E=>u.URI.revive(E)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(D=>D?u.URI.revive(D):void 0)}}e.ExtHostDialogs=S}),define(Ie[244],ke([1,0,12,2,7,5,11,21,8]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,_,P){this._documentsAndEditors=_,this._logService=P,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,_){if(Object.keys(C.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const P=k._handlePool++;this._documentContentProviders.set(P,_),this._proxy.$registerTextContentProvider(P,I);let b;return typeof _.onDidChange=="function"&&(b=_.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(P,w).then(p=>{if(!p&&typeof p!="string")return;const g=this._documentsAndEditors.getDocument(w);if(!g)return;const v=(0,E.splitLines)(p);if(!g.equalLines(v))return this._proxy.$onVirtualDocumentChange(w,p)},u.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(P)&&this._proxy.$unregisterTextContentProvider(P),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(I,_){const P=this._documentContentProviders.get(I);return P?Promise.resolve(P.provideTextDocumentContent(n.URI.revive(_),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(Ie[245],ke([1,0,3,6,2,5,126,15,10,24,7]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(P,b){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new n.DisposableStore,this._documentLoader=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=b,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const p of w)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const p of w)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(P){if(!P)return;const b=this._documentsAndEditors.getDocument(P);if(b)return b}getDocument(P){const b=this.getDocumentData(P);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return b.document}ensureDocumentData(P){const b=this._documentsAndEditors.getDocument(P);if(b)return Promise.resolve(b);let w=this._documentLoader.get(P.toString());return w||(w=this._proxy.$tryOpenDocument(P).then(p=>{this._documentLoader.delete(P.toString());const g=S.URI.revive(p);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(g))},p=>(this._documentLoader.delete(P.toString()),Promise.reject(p))),this._documentLoader.set(P.toString(),w)),w}createDocumentData(P){return this._proxy.$tryCreateDocument(P).then(b=>S.URI.revive(b))}$acceptModelLanguageChanged(P,b){const w=S.URI.revive(P),p=this._documentsAndEditors.getDocument(w);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(b),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(P){const b=S.URI.revive(P),w=this._documentsAndEditors.getDocument(b);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(P,b){const w=S.URI.revive(P),p=this._documentsAndEditors.getDocument(w);if(!p)throw new Error("unknown document");p._acceptIsDirty(b),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,b,w){const p=S.URI.revive(P),g=this._documentsAndEditors.getDocument(p);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),g.onEvents(b);let v;b.isUndoing?v=R.TextDocumentChangeReason.Undo:b.isRedoing&&(v=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:g.document,contentChanges:b.changes.map(f=>({range:D.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:v}))}setWordDefinitionFor(P,b){(0,C.setWordDefinitionFor)(P,b)}}e.ExtHostDocuments=I}),define(Ie[54],ke([1,0,56,3,6,2,4,5,126,17,133,15,14,25,11,59,78]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new P.ResourceMap,this._onDidAddDocuments=new n.Emitter,this._onDidRemoveDocuments=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],a=[],h=[];if(c.removedDocuments)for(const r of c.removedDocuments){const s=A.URI.revive(r),i=this._documents.get(s);i?.unref()&&(this._documents.delete(s),m.push(i.value))}if(c.addedDocuments)for(const r of c.addedDocuments){const s=A.URI.revive(r.uri);let i=this._documents.get(s);if(i&&s.scheme!==b.Schemas.vscodeNotebookCell&&s.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);i||(i=new g(new E.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,i),a.push(i.value)),i.ref()}if(c.removedEditors)for(const r of c.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&h.push(s)}if(c.addedEditors)for(const r of c.addedEditors){const s=A.URI.revive(r.documentUri);u.ok(this._documents.has(s),`document '${s}' does not exist`),u.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const i=this._documents.get(s).value,t=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>i.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(o=>I.Range.to(o)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}c.newActiveEditor!==void 0&&(u.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,S.dispose)(m),(0,S.dispose)(h),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(a),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return c?m:m?.value}allEditors(){return[...this._editors.values()]}};v=Ge([He(0,k.IExtHostRpcService),He(1,_.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[55],ke([1,0,15,5,2,3,4,7,17,10,77]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class I{constructor(p,g,v){this._activeTabIdGetter=v,this._parentGroup=g,this.acceptDtoUpdate(p)}get apiObject(){if(!this._apiObject){const p=this,g={get isActive(){return p._dto.id===p._activeTabIdGetter()},get label(){return p._dto.label},get input(){return p._input},get isDirty(){return p._dto.isDirty},get isPinned(){return p._dto.isPinned},get isPreview(){return p._dto.isPreview},get group(){return p._parentGroup.apiObject}};this._apiObject=Object.freeze(g)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(p){this._dto=p,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new D.TextTabInput(S.URI.revive(this._dto.input.uri));case 2:return new D.TextDiffTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified));case 5:return new D.CustomEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new D.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new D.NotebookEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new D.NotebookDiffEditorTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new D.TerminalEditorTabInput;default:return}}}class _{constructor(p,g,v){this._tabs=[],this._activeTabId="",this._dto=p,this._activeGroupIdGetter=v;for(const f of p.tabs)f.isActive&&(this._activeTabId=f.id),this._tabs.push(new I(f,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const p=this,g={get isActive(){return p._dto.groupId===p._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(p._dto.viewColumn)},get activeTab(){return p._tabs.find(v=>v.tabId===p._activeTabId)?.apiObject},get tabs(){return Object.freeze(p._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(g)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(p){this._dto=p}acceptTabOperation(p){if(p.kind===0){const v=new I(p.tabDto,this,()=>this.activeTabId());return this._tabs.splice(p.index,0,v),p.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(p.kind===1){const v=this._tabs.splice(p.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${p.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(p.kind===3){if(p.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(p.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${p.oldIndex} which does not exist`);return this._tabs.splice(p.index,0,v),v}const g=this._tabs.find(v=>v.tabId===p.tabDto.id);if(!g)throw new Error("INVALID tab");return p.tabDto.isActive?this._activeTabId=p.tabDto.id:this._activeTabId===p.tabDto.id&&!p.tabDto.isActive&&(this._activeTabId=""),g.acceptDtoUpdate(p.tabDto),g}activeTabId(){return this._activeTabId}}let P=class{constructor(p){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=p.getProxy(n.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const p=this,g={onDidChangeTabGroups:p._onDidChangeTabGroups.event,onDidChangeTabs:p._onDidChangeTabs.event,get all(){return Object.freeze(p._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=p._activeGroupId;return(0,k.assertIsDefined)(p._extHostTabGroups.find(c=>c.groupId===v)?.apiObject)},close:async(v,f)=>{const c=Array.isArray(v)?v:[v];return c.length?b(c[0])?this._closeGroups(c,f):this._closeTabs(c,f):!0}};this._apiObject=Object.freeze(g)}return this._apiObject}$acceptEditorTabModel(p){const g=new Set(this._extHostTabGroups.map(r=>r.groupId)),v=new Set(p.map(r=>r.groupId)),f=(0,R.diffSets)(g,v),c=this._extHostTabGroups.filter(r=>f.removed.includes(r.groupId)).map(r=>r.apiObject),m=[],a=[];this._extHostTabGroups=p.map(r=>{const s=new _(r,this._proxy,()=>this._activeGroupId);return f.added.includes(s.groupId)?m.push(s.apiObject):a.push(s.apiObject),s});const h=(0,k.assertIsDefined)(p.find(r=>r.isActive===!0)?.groupId);h!==void 0&&this._activeGroupId!==h&&(this._activeGroupId=h),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:c,changed:a}))}$acceptTabGroupUpdate(p){const g=this._extHostTabGroups.find(v=>v.groupId===p.groupId);if(!g)throw new Error("Update Group IPC call received before group creation.");g.acceptGroupDtoUpdate(p),p.isActive&&(this._activeGroupId=p.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[g.apiObject],opened:[],closed:[]}))}$acceptTabOperation(p){const g=this._extHostTabGroups.find(f=>f.groupId===p.groupId);if(!g)throw new Error("Update Tabs IPC call received before group creation.");const v=g.acceptTabOperation(p);switch(p.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(p){for(const g of this._extHostTabGroups)for(const v of g.tabs)if(v.apiObject===p)return v}_findExtHostTabGroupFromApi(p){return this._extHostTabGroups.find(g=>g.apiObject===p)}async _closeTabs(p,g){const v=[];for(const f of p){const c=this._findExtHostTabFromApi(f);if(!c)throw new Error("Tab close: Invalid tab not found!");v.push(c.tabId)}return this._proxy.$closeTab(v,g)}async _closeGroups(p,g){const v=[];for(const f of p){const c=this._findExtHostTabGroupFromApi(f);if(!c)throw new Error("Group close: Invalid group not found!");v.push(c.groupId)}return this._proxy.$closeGroup(v,g)}};P=Ge([He(0,E.IExtHostRpcService)],P),e.ExtHostEditorTabs=P;function b(w){return w.tabs!==void 0}}),define(Ie[246],ke([1,0,2,5,6,7,15,149,8,23,27]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(b){this._stateMachine=void 0,this._schemes.push(b)}delete(b){const w=this._schemes.indexOf(b);w>=0&&(this._schemes.splice(w,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const b=this._schemes.sort(),w=[];let p,g,v=14,f=14;for(const c of b){let m=p?(0,E.commonPrefixLength)(p,c):0;for(m===0?g=1:g=f;m<c.length;m++)m+1===c.length?(v=f,f=9):f+=1,w.push([g,c.toUpperCase().charCodeAt(m),f]),w.push([g,c.toLowerCase().charCodeAt(m),f]),g=f;p=c,f=v}w.push([9,58,10]),w.push([10,47,12]),this._stateMachine=new D.StateMachine(w)}}provideDocumentLinks(b){this._initStateMachine();const w=[],p=D.LinkComputer.computeLinks({getLineContent(g){return b.lineAt(g-1).text},getLineCount(){return b.lineCount}},this._stateMachine);for(const g of p){const v=C.DocumentLink.to(g);v.target&&w.push(v)}return w}}class _{constructor(b,w){this._extHostLanguageFeatures=w,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=b.getProxy(n.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(b,w,p,g={}){if(this._registeredSchemes.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(b,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(w),this._registeredSchemes.add(w),this._fsProvider.set(v,p);let f=2;g.isCaseSensitive&&(f+=1024),g.isReadonly&&(f+=2048),typeof p.copy=="function"&&(f+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,R.checkProposedApiEnabled)(b,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(v,w,f).catch(m=>{console.error(`FAILED to register filesystem provider of ${b.identifier.value}-extension for the scheme ${w}`),console.error(m)});const c=p.onDidChangeFile(m=>{const a=[];for(const h of m){const{uri:r,type:s}=h;if(r.scheme!==w)continue;let i;switch(s){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:i})}this._proxy.$onFileSystemChange(v,a)});return(0,S.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(w),this._registeredSchemes.delete(w),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(b){const{type:w,ctime:p,mtime:g,size:v,permissions:f}=b;return{type:w,ctime:p,mtime:g,size:v,permissions:f}}$stat(b,w){return Promise.resolve(this._getFsProvider(b).stat(u.URI.revive(w))).then(p=>_._asIStat(p))}$readdir(b,w){return Promise.resolve(this._getFsProvider(b).readDirectory(u.URI.revive(w)))}$readFile(b,w){return Promise.resolve(this._getFsProvider(b).readFile(u.URI.revive(w))).then(p=>k.VSBuffer.wrap(p))}$writeFile(b,w,p,g){return Promise.resolve(this._getFsProvider(b).writeFile(u.URI.revive(w),p.buffer,g))}$delete(b,w,p){return Promise.resolve(this._getFsProvider(b).delete(u.URI.revive(w),p))}$rename(b,w,p,g){return Promise.resolve(this._getFsProvider(b).rename(u.URI.revive(w),u.URI.revive(p),g))}$copy(b,w,p,g){const v=this._getFsProvider(b);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(u.URI.revive(w),u.URI.revive(p),g))}$mkdir(b,w){return Promise.resolve(this._getFsProvider(b).createDirectory(u.URI.revive(w)))}$watch(b,w,p,g){const v=this._getFsProvider(b).watch(u.URI.revive(p),g);this._watches.set(w,v)}$unwatch(b,w){const p=this._watches.get(w);p&&(p.dispose(),this._watches.delete(w))}$open(b,w,p){const g=this._getFsProvider(b);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(u.URI.revive(w),p))}$close(b,w){const p=this._getFsProvider(b);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(w))}$read(b,w,p,g){const v=this._getFsProvider(b);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const f=k.VSBuffer.alloc(g);return Promise.resolve(v.read(w,p,f.buffer,0,g)).then(c=>f.slice(0,c))}$write(b,w,p,g){const v=this._getFsProvider(b);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(w,p,g.buffer,0,g.byteLength))}_getFsProvider(b){const w=this._fsProvider.get(b);if(!w){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return w}}e.ExtHostFileSystem=_}),define(Ie[68],ke([1,0,5,43,7,23,4,17,46,6]),function(X,e,u,n,S,A,C,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Gt{constructor(_,P){this._fileSystemProvider=new Map,this._proxy=_.getProxy(u.MainContext.MainThreadFileSystem);const b=this;this.value=Object.freeze({async stat(w){try{const p=b._fileSystemProvider.get(w.scheme);if(!p)return await b._proxy.$stat(w);await b._proxy.$ensureActivation(w.scheme);const g=await p.stat(w);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions}}catch(p){Gt._handleError(p)}},async readDirectory(w){try{const p=b._fileSystemProvider.get(w.scheme);return p?(await b._proxy.$ensureActivation(w.scheme),(await p.readDirectory(w)).slice()):await b._proxy.$readdir(w)}catch(p){return Gt._handleError(p)}},async createDirectory(w){try{return await b._proxy.$mkdir(w)}catch(p){return Gt._handleError(p)}},async readFile(w){try{const p=b._fileSystemProvider.get(w.scheme);return p?(await b._proxy.$ensureActivation(w.scheme),(await p.readFile(w)).slice()):(await b._proxy.$readFile(w)).buffer}catch(p){return Gt._handleError(p)}},async writeFile(w,p){try{return await b._proxy.$writeFile(w,A.VSBuffer.wrap(p))}catch(g){return Gt._handleError(g)}},async delete(w,p){try{const g=b._fileSystemProvider.get(w.scheme);return g?(await b._proxy.$ensureActivation(w.scheme),await g.delete(w,{recursive:!1,...p})):await b._proxy.$delete(w,{recursive:!1,useTrash:!1,...p})}catch(g){return Gt._handleError(g)}},async rename(w,p,g){try{return await b._proxy.$rename(w,p,{overwrite:!1,...g})}catch(v){return Gt._handleError(v)}},async copy(w,p,g){try{return await b._proxy.$copy(w,p,{overwrite:!1,...g})}catch(v){return Gt._handleError(v)}},isWritableFileSystem(w){const p=P.getCapabilities(w);if(typeof p=="number")return!(p&2048)}})}static _handleError(_){if(_ instanceof S.FileSystemError)throw _;if(!(_ instanceof Error))throw new S.FileSystemError(String(_));if(_.name==="ENOPRO")throw S.FileSystemError.Unavailable(_.message);switch(_.name){case n.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(_.message);case n.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(_.message);case n.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(_.message);case n.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(_.message);case n.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(_.message);case n.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(_.message);default:throw new S.FileSystemError(_.message,_.name)}}addFileSystemProvider(_,P){return this._fileSystemProvider.set(_,P),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(_))}};R=Ge([He(0,D.IExtHostRpcService),He(1,E.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[247],ke([1,0,3,36,2,5,15,7]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(I,_,P,b,w,p,g,v){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const f=this.ensureWatching(I,P,w);this._config=0,p&&(this._config+=1),g&&(this._config+=2),v&&(this._config+=4);const c=(0,n.parse)(w),m=typeof w=="string",a=b(h=>{if(!p)for(const r of h.created){const s=S.URI.revive(r);c(s.fsPath)&&(!m||_.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(const r of h.changed){const s=S.URI.revive(r);c(s.fsPath)&&(!m||_.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!v)for(const r of h.deleted){const s=S.URI.revive(r);c(s.fsPath)&&(!m||_.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=D.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(I,_,P){const b=D.Disposable.from();if(typeof P=="string")return b;const w=I.getProxy(A.MainContext.MainThreadFileSystem);let p=!1;(P.pattern.includes(n.GLOBSTAR)||P.pattern.includes(n.GLOB_SPLIT))&&(p=!0);const g=Math.random();return w.$watch(_.identifier.value,g,P.baseUri,{recursive:p,excludes:[]}),D.Disposable.from({dispose:()=>w.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(I,_,P){this._mainContext=I,this._logService=_,this._extHostDocumentsAndEditors=P,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,_,P,b,w,p){return new E(this._mainContext,I,_,this._onFileSystemEvent.event,C.GlobPattern.from(P),b,w,p)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,_){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(P=>({oldUri:S.URI.revive(P.source),newUri:S.URI.revive(P.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(P=>S.URI.revive(P.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:_.map(P=>S.URI.revive(P.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,_){return(P,b,w)=>{const p=function(v){P.call(b,v)};return p.extension=I,_.event(p,void 0,w)}}async $onWillRunFileOperation(I,_,P,b){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(w=>({oldUri:S.URI.revive(w.source),newUri:S.URI.revive(w.target)}))},P,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(w=>S.URI.revive(w.target))},P,b);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(w=>S.URI.revive(w.target))},P,b)}}async _fireWillEvent(I,_,P,b){const w=new Set,p=[];if(await I.fireAsync(_,b,async(v,f)=>{const c=Date.now(),m=await Promise.resolve(v);m instanceof D.WorkspaceEdit&&(p.push(m),w.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-c>P&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),b.isCancellationRequested||p.length===0)return;const g={edits:[]};for(const v of p){const{edits:f}=C.WorkspaceEdit.from(v,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});g.edits=g.edits.concat(f)}return{edit:g,extensionNames:Array.from(w)}}}e.ExtHostFileSystemEventService=k}),define(Ie[248],ke([1,0,2,37]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(C,D,E,k,R){this._extHostNotebooks=D,this._textDocumentsAndEditors=E,this._commands=k;const I=new n.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new n.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new n.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new n.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new n.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new n.ApiCommandResult("Notebook and input URI",_=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",_.notebookEditorId),_.notebookEditorId!==void 0){const P=this._extHostNotebooks.getEditorById(_.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:P.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",_.notebookUri,_.inputUri),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(C,D,E,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:E,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=S}),define(Ie[249],ke([1,0,6,5]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(C){this._handlePool=0,this._proxy=C.getProxy(n.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,C),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=S}),define(Ie[250],ke([1,0,2,24,15,7,63,5,8,35,16,10,145,21,6,113,93,87,50,12,18,27]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(O,$){this._documents=O,this._provider=$}async provideDocumentSymbols(O,$){const G=this._documents.getDocument(O),K=await this._provider.provideDocumentSymbols(G,$);if(!(0,R.isFalsyOrEmpty)(K))return K[0]instanceof A.DocumentSymbol?K.map(S.DocumentSymbol.from):a._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((K,de)=>{let we=K.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(K.location.range.end)),we});const $=[],G=[];for(const K of O){const de={name:K.name||"!!MISSING: name!!",kind:S.SymbolKind.from(K.kind),tags:K.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:S.Range.from(K.location.range),selectionRange:S.Range.from(K.location.range),children:[]};for(;;){if(G.length===0){G.push(de),$.push(de);break}const we=G[G.length-1];if(k.Range.containsRange(we.range,de.range)&&!k.Range.equalsRange(we.range,de.range)){we.children?.push(de),G.push(de);break}G.pop()}}return $}}class h{constructor(O,$,G){this._documents=O,this._commands=$,this._provider=G,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,$){const G=this._documents.getDocument(O),K=await this._provider.provideCodeLenses(G,$);if(!K||$.isCancellationRequested)return;const de=this._cache.add(K),we=new b.DisposableStore;this._disposables.set(de,we);const se={cacheId:de,lenses:[]};for(let De=0;De<K.length;De++)se.lenses.push({cacheId:[de,De],range:S.Range.from(K[De].range),command:this._commands.toInternal(K[De].command,we)});return se}async resolveCodeLens(O,$){const G=O.cacheId&&this._cache.get(...O.cacheId);if(!G)return;let K;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?K=G:K=await this._provider.resolveCodeLens(G,$),K||(K=G),$.isCancellationRequested)return;const de=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!de)return O.command=this._commands.toInternal(K.command??h._badCmd,de),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ne){return Array.isArray(ne)?ne.map(S.DefinitionLink.from):ne?[S.DefinitionLink.from(ne)]:[]}class s{constructor(O,$){this._documents=O,this._provider=$}async provideDefinition(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideDefinition(K,de,G);return r(we)}}class i{constructor(O,$){this._documents=O,this._provider=$}async provideDeclaration(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideDeclaration(K,de,G);return r(we)}}class t{constructor(O,$){this._documents=O,this._provider=$}async provideImplementation(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideImplementation(K,de,G);return r(we)}}class o{constructor(O,$){this._documents=O,this._provider=$}async provideTypeDefinition(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideTypeDefinition(K,de,G);return r(we)}}class l{constructor(O,$){this._documents=O,this._provider=$}async provideHover(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideHover(K,de,G);if(!(!we||(0,R.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=K.getWordRangeAtPosition(de)),we.range||(we.range=new A.Range(de,de)),S.Hover.from(we)}}class d{constructor(O,$){this._documents=O,this._provider=$}async provideEvaluatableExpression(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideEvaluatableExpression(K,de,G);if(we)return S.EvaluatableExpression.from(we)}}class y{constructor(O,$){this._documents=O,this._provider=$}async provideInlineValues(O,$,G,K){const de=this._documents.getDocument(O),we=await this._provider.provideInlineValues(de,S.Range.to($),S.InlineValueContext.to(G),K);if(Array.isArray(we))return we.map(se=>S.InlineValue.from(se))}}class L{constructor(O,$){this._documents=O,this._provider=$}async provideDocumentHighlights(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideDocumentHighlights(K,de,G);if(Array.isArray(we))return we.map(S.DocumentHighlight.from)}}class M{constructor(O,$){this._documents=O,this._provider=$}async provideLinkedEditingRanges(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.provideLinkedEditingRanges(K,de,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,R.coalesce)(we.ranges.map(S.Range.from)),wordPattern:we.wordPattern}}}class F{constructor(O,$){this._documents=O,this._provider=$}async provideReferences(O,$,G,K){const de=this._documents.getDocument(O),we=S.Position.to($),se=await this._provider.provideReferences(de,we,G,K);if(Array.isArray(se))return se.map(S.location.from)}}class T{constructor(O,$,G,K,de,we,se){this._documents=O,this._commands=$,this._diagnostics=G,this._provider=K,this._logService=de,this._extension=we,this._apiDeprecation=se,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,$,G,K){const de=this._documents.getDocument(O),we=_.Selection.isISelection($)?S.Selection.to($):S.Range.to($),se=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(we.intersection(Ye.range)&&se.push(Ye)>T._maxCodeActionsPerFile)break;const De={diagnostics:se,only:G.only?new A.CodeActionKind(G.only):void 0,triggerKind:S.CodeActionTriggerKind.to(G.trigger)},Ce=await this._provider.provideCodeActions(de,we,De,K);if(!(0,R.isNonEmptyArray)(Ce)||K.isCancellationRequested)return;const ze=this._cache.add(Ce),Ke=new b.DisposableStore;this._disposables.set(ze,Ke);const Ne=[];for(let Ye=0;Ye<Ce.length;Ye++){const Z=Ce[Ye];!Z||(T._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ne.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,Ke)})):(De.only&&(Z.kind?De.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ne.push({cacheId:[ze,Ye],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,Ke),diagnostics:Z.diagnostics&&Z.diagnostics.map(S.Diagnostic.from),edit:Z.edit&&S.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:Z.disabled?.reason})))}return{cacheId:ze,actions:Ne}}async resolveCodeAction(O,$){const[G,K]=O,de=this._cache.get(G,K);if(!de||T._isCommand(de)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(de,$)??de;return we?.edit?S.WorkspaceEdit.from(we.edit):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}T._maxCodeActionsPerFile=1e3;class U{constructor(O,$,G,K){this._proxy=O,this._documents=$,this._provider=G,this._handle=K}async prepareDocumentPaste(O,$,G,K){if(!this._provider.prepareDocumentPaste)return;const de=this._documents.getDocument(O),we=$.map(De=>S.Range.to(De)),se=S.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this._provider.prepareDocumentPaste(de,we,se,K),S.DataTransfer.toDataTransferDTO(se)}async providePasteEdits(O,$,G,K,de){const we=this._documents.getDocument($),se=G.map(ze=>S.Range.to(ze)),De=S.DataTransfer.toDataTransfer(K,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,ze)).buffer),Ce=await this._provider.provideDocumentPasteEdits(we,se,De,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?S.WorkspaceEdit.from(Ce.additionalEdit):void 0}}}class N{constructor(O,$){this._documents=O,this._provider=$}async provideDocumentFormattingEdits(O,$,G){const K=this._documents.getDocument(O),de=await this._provider.provideDocumentFormattingEdits(K,$,G);if(Array.isArray(de))return de.map(S.TextEdit.from)}}class H{constructor(O,$){this._documents=O,this._provider=$}async provideDocumentRangeFormattingEdits(O,$,G,K){const de=this._documents.getDocument(O),we=S.Range.to($),se=await this._provider.provideDocumentRangeFormattingEdits(de,we,G,K);if(Array.isArray(se))return se.map(S.TextEdit.from)}}class te{constructor(O,$){this._documents=O,this._provider=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,$,G,K,de){const we=this._documents.getDocument(O),se=S.Position.to($),De=await this._provider.provideOnTypeFormattingEdits(we,se,G,K,de);if(Array.isArray(De))return De.map(S.TextEdit.from)}}class B{constructor(O,$){this._provider=O,this._logService=$,this._cache=new g.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,$){const G=await this._provider.provideWorkspaceSymbols(O,$);if(!(0,R.isNonEmptyArray)(G))return{symbols:[]};const K=this._cache.add(G),de={cacheId:K,symbols:[]};for(let we=0;we<G.length;we++){const se=G[we];if(!se||!se.name){this._logService.warn("INVALID SymbolInformation",se);continue}de.symbols.push({...S.WorkspaceSymbol.from(se),cacheId:[K,we]})}return de}async resolveWorkspaceSymbol(O,$){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this._cache.get(...O.cacheId);if(G){const K=await this._provider.resolveWorkspaceSymbol(G,$);return K&&(0,n.mixin)(O,S.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class z{constructor(O,$,G){this._documents=O,this._provider=$,this._logService=G}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,$,G,K){const de=this._documents.getDocument(O),we=S.Position.to($);try{const se=await this._provider.provideRenameEdits(de,we,G,K);return se?S.WorkspaceEdit.from(se):void 0}catch(se){const De=z._asMessage(se);return De?{rejectReason:De,edits:void 0}:Promise.reject(se)}}async resolveRenameLocation(O,$,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(O),de=S.Position.to($);try{const we=await this._provider.prepareRename(K,de,G);let se,De;if(A.Range.isRange(we)?(se=we,De=K.getText(we)):(0,I.isObject)(we)&&(se=we.range,De=we.placeholder),!se||!De)return;if(se.start.line>de.line||se.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(se),text:De}}catch(we){const se=z._asMessage(we);return se?{rejectReason:se,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class q{constructor(O,$){this.resultId=O,this.tokens=$}}class V{constructor(O,$){this._documents=O,this._provider=$,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,$,G){const K=this._documents.getDocument(O),de=$!==0?this._previousResults.get($):null;let we=typeof de?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,de.resultId,G):await this._provider.provideDocumentSemanticTokens(K,G);return de&&this._previousResults.delete($),we?(we=V._fixProvidedSemanticTokens(we),this._send(V._convertToEdits(de,we),we)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return V._isSemanticTokens(O)?V._isCorrectSemanticTokens(O)?O:new A.SemanticTokens(new Uint32Array(O.data),O.resultId):V._isSemanticTokensEdits(O)?V._isCorrectSemanticTokensEdits(O)?O:new A.SemanticTokensEdits(O.edits.map($=>new A.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const $ of O.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,$){if(!V._isSemanticTokens($)||!O||!O.tokens)return $;const G=O.tokens,K=G.length,de=$.data,we=de.length;let se=0;const De=Math.min(K,we);for(;se<De&&G[se]===de[se];)se++;if(se===K&&se===we)return new A.SemanticTokensEdits([],$.resultId);let Ce=0;const ze=De-se;for(;Ce<ze&&G[K-Ce-1]===de[we-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:se,deleteCount:K-se-Ce,data:de.subarray(se,we-Ce)}],$.resultId)}_send(O,$){if(V._isSemanticTokens(O)){const G=this._nextResultId++;return this._previousResults.set(G,new q(O.resultId,O.data)),(0,w.encodeSemanticTokensDto)({id:G,type:"full",data:O.data})}if(V._isSemanticTokensEdits(O)){const G=this._nextResultId++;return V._isSemanticTokens($)?this._previousResults.set(G,new q($.resultId,$.data)):this._previousResults.set(G,new q(O.resultId)),(0,w.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(O.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class j{constructor(O,$){this._documents=O,this._provider=$}async provideDocumentRangeSemanticTokens(O,$,G){const K=this._documents.getDocument(O),de=await this._provider.provideDocumentRangeSemanticTokens(K,S.Range.to($),G);return de?this._send(de):null}_send(O){return(0,w.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=j;class ie{constructor(O,$,G,K,de){this._documents=O,this._commands=$,this._provider=G,this._apiDeprecation=K,this._extension=de,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,$,G,K){const de=this._documents.getDocument(O),we=S.Position.to($),se=de.getWordRangeAtPosition(we)||new A.Range(we,we),De=se.with({end:we}),Ce=new v.StopWatch(!0),ze=await this._provider.provideCompletionItems(de,we,K,S.CompletionContext.to(G));if(!ze||K.isCancellationRequested)return;const Ke=Array.isArray(ze)?new A.CompletionList(ze):ze,Ne=ie.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),Ye=new b.DisposableStore;this._disposables.set(Ne,Ye);const Z=[],re={x:Ne,b:Z,a:{replace:S.Range.from(se),insert:S.Range.from(De)},c:Ke.isIncomplete||void 0,d:Ce.elapsed()};for(let ye=0;ye<Ke.items.length;ye++){const We=Ke.items[ye],oe=this._convertCompletionItem(We,[Ne,ye],De,se);Z.push(oe)}return re}async resolveCompletionItem(O,$){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...O);if(!G)return;const K=await this._provider.resolveCompletionItem(G,$);if(!!K)return this._convertCompletionItem(K,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,$,G,K){const de=this._disposables.get($[0]);if(!de)throw Error("DisposableStore is missing...");const we={x:$,a:O.label,b:O.kind!==void 0?S.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(S.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(O.command,de)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=O.textEdit.newText):typeof O.insertText=="string"?we.h=O.insertText:O.insertText instanceof A.SnippetString&&(we.h=O.insertText.value,we.i|=4);let se;return O.textEdit?se=O.textEdit.range:O.range&&(se=O.range),A.Range.isRange(se)?we.j=S.Range.from(se):se&&(!G?.isEqual(se.inserting)||!K?.isEqual(se.replacing))&&(we.j={insert:S.Range.from(se.inserting),replace:S.Range.from(se.replacing)}),we}}class Q{async provideInlineCompletions(O,$,G,K){}disposeCompletions(O){}handleDidShowCompletionItem(O,$){}}class ue extends Q{constructor(O,$,G,K){super();this._extension=O,this._documents=$,this._provider=G,this._commands=K,this._references=new J,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,$,G,K){const de=this._documents.getDocument(O),we=S.Position.to($),se=await this._provider.provideInlineCompletionItems(de,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:S.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},K);if(!se||K.isCancellationRequested)return;const De=(0,I.isArray)(se)?se:se.items,Ce=this._isAdditionsProposedApiEnabled?(0,I.isArray)(se)?[]:se.commands||[]:[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Ne,Ye)=>{let Z;Ne.command&&(ze||(ze=new b.DisposableStore),Z=this._commands.toInternal(Ne.command,ze));const re=Ne.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Ne.filterText,range:Ne.range?S.Range.from(Ne.range):void 0,command:Z,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ne.completeBracketPairs:!1}}),commands:Ce.map(Ne=>(ze||(ze=new b.DisposableStore),this._commands.toInternal(Ne,ze)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,$){const G=this._references.get(O)?.items[$];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ve extends Q{constructor(O,$,G,K){super();this.extension=O,this._documents=$,this._provider=G,this._commands=K,this._references=new J,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKindNew.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,$,G,K){const de=this._documents.getDocument(O),we=S.Position.to($),se=await this._provider.provideInlineCompletionItems(de,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:S.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},K);if(!se||K.isCancellationRequested)return;const De=(0,I.isArray)(se)?se:se.items,Ce=(0,I.isArray)(se)?[]:se.commands||[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Ne,Ye)=>{let Z;Ne.command&&(ze||(ze=new b.DisposableStore),Z=this._commands.toInternal(Ne.command,ze));const re=Ne.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Ne.filterText,range:Ne.range?S.Range.from(Ne.range):void 0,command:Z,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ne.completeBracketPairs:!1}}),commands:Ce.map(Ne=>(ze||(ze=new b.DisposableStore),this._commands.toInternal(Ne,ze)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,$){const G=this._references.get(O)?.items[$];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class J{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const $=this._idPool++;return this._references.set($,O),$}disposeReferenceId(O){const $=this._references.get(O);return this._references.delete(O),$}get(O){return this._references.get(O)}}class ge{constructor(O,$){this._documents=O,this._provider=$,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(O,$,G,K){const de=this._documents.getDocument(O),we=S.Position.to($),se=this.reviveContext(G),De=await this._provider.provideSignatureHelp(de,we,K,se);if(De){const Ce=this._cache.add([De]);return{...S.SignatureHelp.from(De),id:Ce}}}reviveContext(O){let $;if(O.activeSignatureHelp){const G=S.SignatureHelp.to(O.activeSignatureHelp),K=this._cache.get(O.activeSignatureHelp.id,0);K?($=K,$.activeSignature=G.activeSignature,$.activeParameter=G.activeParameter):$=G}return{...O,activeSignatureHelp:$}}releaseSignatureHelp(O){this._cache.delete(O)}}class Ee{constructor(O,$,G,K,de){this._documents=O,this._commands=$,this._provider=G,this._logService=K,this._extension=de,this._cache=new g.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,$,G){const K=this._documents.getDocument(O),de=S.Range.to($),we=await this._provider.provideInlayHints(K,de,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${$}`);return}if(G.isCancellationRequested)return;const se=this._cache.add(we);this._disposables.set(se,new b.DisposableStore);const De={hints:[],cacheId:se};for(let Ce=0;Ce<we.length;Ce++)this._isValidInlayHint(we[Ce],de)&&De.hints.push(this._convertInlayHint(we[Ce],[se,Ce]));return this._logService.trace(`[InlayHints] ${De.hints.length} inlay hints from '${this._extension.identifier.value}' for ${$}`),De}async resolveInlayHint(O,$){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...O);if(!G)return;const K=await this._provider.resolveInlayHint(G,$);if(!!K&&!!this._isValidInlayHint(K))return this._convertInlayHint(K,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,$){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!($&&!$.contains(O.position))}_convertInlayHint(O,$){const G=this._disposables.get($[0]);if(!G)throw Error("DisposableStore is missing...");const K={label:"",cacheId:$,tooltip:S.MarkdownString.fromStrict(O.tooltip),position:S.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(S.TextEdit.from),kind:O.kind&&S.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?K.label=O.label:K.label=O.label.map(de=>{const we={label:de.value};return we.tooltip=S.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(we.location=S.location.from(de.location)),de.command&&(we.command=this._commands.toInternal(de.command,G)),we}),K}}class Pe{constructor(O,$){this._documents=O,this._provider=$,this._cache=new g.Cache("DocumentLink")}async provideLinks(O,$){const G=this._documents.getDocument(O),K=await this._provider.provideDocumentLinks(G,$);if(!(!Array.isArray(K)||K.length===0)&&!$.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(Pe._validateLink).map(S.DocumentLink.from)};{const de=this._cache.add(K),we={links:[],cacheId:de};for(let se=0;se<K.length;se++){if(!Pe._validateLink(K[se]))continue;const De=S.DocumentLink.from(K[se]);De.cacheId=[de,se],we.links.push(De)}return we}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,$){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...O);if(!G)return;const K=await this._provider.resolveDocumentLink(G,$);if(!(!K||!Pe._validateLink(K)))return S.DocumentLink.from(K)}releaseLinks(O){this._cache.delete(O)}}class me{constructor(O,$){this._documents=O,this._provider=$}async provideColors(O,$){const G=this._documents.getDocument(O),K=await this._provider.provideDocumentColors(G,$);return Array.isArray(K)?K.map(we=>({color:S.Color.from(we.color),range:S.Range.from(we.range)})):[]}async provideColorPresentations(O,$,G){const K=this._documents.getDocument(O),de=S.Range.to($.range),we=S.Color.to($.color),se=await this._provider.provideColorPresentations(we,{document:K,range:de},G);if(!!Array.isArray(se))return se.map(S.ColorPresentation.from)}}class Te{constructor(O,$){this._documents=O,this._provider=$}async provideFoldingRanges(O,$,G){const K=this._documents.getDocument(O),de=await this._provider.provideFoldingRanges(K,$,G);if(!!Array.isArray(de))return de.map(S.FoldingRange.from)}}class le{constructor(O,$,G){this._documents=O,this._provider=$,this._logService=G}async provideSelectionRanges(O,$,G){const K=this._documents.getDocument(O),de=$.map(S.Position.to),we=await this._provider.provideSelectionRanges(K,de,G);if(!(0,R.isNonEmptyArray)(we))return[];if(we.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const se=[];for(let De=0;De<de.length;De++){const Ce=[];se.push(Ce);let ze=de[De],Ke=we[De];for(;;){if(!Ke.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(S.SelectionRange.from(Ke)),!Ke.parent)break;ze=Ke.range,Ke=Ke.parent}}return se}}class pe{constructor(O,$){this._documents=O,this._provider=$,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.prepareCallHierarchy(K,de,G);if(!we)return;const se=this._idPool.nextId();return this._cache.set(se,new Map),Array.isArray(we)?we.map(De=>this._cacheAndConvertItem(se,De)):[this._cacheAndConvertItem(se,we)]}async provideCallsTo(O,$,G){const K=this._itemFromCache(O,$);if(!K)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(K,G);if(!!de)return de.map(we=>({from:this._cacheAndConvertItem(O,we.from),fromRanges:we.fromRanges.map(se=>S.Range.from(se))}))}async provideCallsFrom(O,$,G){const K=this._itemFromCache(O,$);if(!K)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(K,G);if(!!de)return de.map(we=>({to:this._cacheAndConvertItem(O,we.to),fromRanges:we.fromRanges.map(se=>S.Range.from(se))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,$){const G=this._cache.get(O),K=S.CallHierarchyItem.from($,O,G.size.toString(36));return G.set(K._itemId,$),K}_itemFromCache(O,$){return this._cache.get(O)?.get($)}}class be{constructor(O,$){this._documents=O,this._provider=$,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(O,$,G){const K=this._documents.getDocument(O),de=S.Position.to($),we=await this._provider.prepareTypeHierarchy(K,de,G);if(!we)return;const se=this._idPool.nextId();return this._cache.set(se,new Map),Array.isArray(we)?we.map(De=>this._cacheAndConvertItem(se,De)):[this._cacheAndConvertItem(se,we)]}async provideSupertypes(O,$,G){const K=this._itemFromCache(O,$);if(!K)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySupertypes(K,G);if(!!de)return de.map(we=>this._cacheAndConvertItem(O,we))}async provideSubtypes(O,$,G){const K=this._itemFromCache(O,$);if(!K)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySubtypes(K,G);if(!!de)return de.map(we=>this._cacheAndConvertItem(O,we))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,$){const G=this._cache.get(O),K=S.TypeHierarchyItem.from($,O,G.size.toString(36));return G.set(K._itemId,$),K}_itemFromCache(O,$){return this._cache.get(O)?.get($)}}class ae{constructor(O,$,G,K){this._proxy=O,this._documents=$,this._provider=G,this._handle=K}async provideDocumentOnDropEdits(O,$,G,K,de){const we=this._documents.getDocument($),se=S.Position.to(G),De=S.DataTransfer.toDataTransfer(K,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,ze)).buffer),Ce=await this._provider.provideDocumentOnDropEdits(we,se,De,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?S.WorkspaceEdit.from(Ce.additionalEdit):void 0}}}class he{constructor(O,$){this.adapter=O,this.extension=$}}class ee{constructor(O,$,G,K,de,we,se){this._adapter=new Map,this._uriTransformer=$,this._proxy=O.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=K,this._diagnostics=de,this._logService=we,this._apiDeprecation=se}_transformDocumentSelector(O){return S.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new A.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ee._handlePool++}async _withAdapter(O,$,G,K,de,we=!1){const se=this._adapter.get(O);if(!se||!(se.adapter instanceof $))return K;const De=Date.now();we||this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(se.adapter,se.extension);return Promise.resolve(Ce).catch(ze=>{(0,f.isCancellationError)(ze)||(this._logService.error(`[${se.extension.identifier.value}] provider FAILED`),this._logService.error(ze))}).finally(()=>{we||this._logService.trace(`[${se.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),P.CancellationToken.isCancellationToken(de)?(0,c.raceCancellationError)(Ce,de):Ce}_addNewAdapter(O,$){const G=this._nextHandle();return this._adapter.set(G,new he(O,$)),G}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,$,G,K){const de=this._addNewAdapter(new a(this._documents,G),O),we=K&&K.label||ee._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector($),we),this._createDisposable(de)}$provideDocumentSymbols(O,$,G){return this._withAdapter(O,a,K=>K.provideDocumentSymbols(u.URI.revive($),G),void 0,G)}registerCodeLensProvider(O,$,G){const K=this._nextHandle(),de=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new he(new h(this._documents,this._commands.converter,G),O)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector($),de);let we=this._createDisposable(K);if(de!==void 0){const se=G.onDidChangeCodeLenses(De=>this._proxy.$emitCodeLensEvent(de));we=A.Disposable.from(we,se)}return we}$provideCodeLenses(O,$,G){return this._withAdapter(O,h,K=>K.provideCodeLenses(u.URI.revive($),G),void 0,G)}$resolveCodeLens(O,$,G){return this._withAdapter(O,h,K=>K.resolveCodeLens($,G),void 0,void 0)}$releaseCodeLenses(O,$){this._withAdapter(O,h,G=>Promise.resolve(G.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(O,$,G){const K=this._addNewAdapter(new s(this._documents,G),O);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDefinition(O,$,G,K){return this._withAdapter(O,s,de=>de.provideDefinition(u.URI.revive($),G,K),[],K)}registerDeclarationProvider(O,$,G){const K=this._addNewAdapter(new i(this._documents,G),O);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDeclaration(O,$,G,K){return this._withAdapter(O,i,de=>de.provideDeclaration(u.URI.revive($),G,K),[],K)}registerImplementationProvider(O,$,G){const K=this._addNewAdapter(new t(this._documents,G),O);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideImplementation(O,$,G,K){return this._withAdapter(O,t,de=>de.provideImplementation(u.URI.revive($),G,K),[],K)}registerTypeDefinitionProvider(O,$,G){const K=this._addNewAdapter(new o(this._documents,G),O);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideTypeDefinition(O,$,G,K){return this._withAdapter(O,o,de=>de.provideTypeDefinition(u.URI.revive($),G,K),[],K)}registerHoverProvider(O,$,G,K){const de=this._addNewAdapter(new l(this._documents,G),O);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector($)),this._createDisposable(de)}$provideHover(O,$,G,K){return this._withAdapter(O,l,de=>de.provideHover(u.URI.revive($),G,K),void 0,K)}registerEvaluatableExpressionProvider(O,$,G,K){const de=this._addNewAdapter(new d(this._documents,G),O);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector($)),this._createDisposable(de)}$provideEvaluatableExpression(O,$,G,K){return this._withAdapter(O,d,de=>de.provideEvaluatableExpression(u.URI.revive($),G,K),void 0,K)}registerInlineValuesProvider(O,$,G,K){const de=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new y(this._documents,G),O);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector($),de);let se=this._createDisposable(we);if(de!==void 0){const De=G.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(de));se=A.Disposable.from(se,De)}return se}$provideInlineValues(O,$,G,K,de){return this._withAdapter(O,y,we=>we.provideInlineValues(u.URI.revive($),G,K,de),void 0,de)}registerDocumentHighlightProvider(O,$,G){const K=this._addNewAdapter(new L(this._documents,G),O);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDocumentHighlights(O,$,G,K){return this._withAdapter(O,L,de=>de.provideDocumentHighlights(u.URI.revive($),G,K),void 0,K)}registerLinkedEditingRangeProvider(O,$,G){const K=this._addNewAdapter(new M(this._documents,G),O);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideLinkedEditingRanges(O,$,G,K){return this._withAdapter(O,M,async de=>{const we=await de.provideLinkedEditingRanges(u.URI.revive($),G,K);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ee._serializeRegExp(we.wordPattern):void 0}},void 0,K)}registerReferenceProvider(O,$,G){const K=this._addNewAdapter(new F(this._documents,G),O);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideReferences(O,$,G,K,de){return this._withAdapter(O,F,we=>we.provideReferences(u.URI.revive($),G,K,de),void 0,de)}registerCodeActionProvider(O,$,G,K){const de=new b.DisposableStore,we=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,G,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector($),{providedKinds:K?.providedCodeActionKinds?.map(se=>se.value),documentation:K?.documentation?.map(se=>({kind:se.kind.value,command:this._commands.converter.toInternal(se.command,de)}))},ee._extLabel(O),Boolean(G.resolveCodeAction)),de.add(this._createDisposable(we)),de}$provideCodeActions(O,$,G,K,de){return this._withAdapter(O,T,we=>we.provideCodeActions(u.URI.revive($),G,K,de),void 0,de)}$resolveCodeAction(O,$,G){return this._withAdapter(O,T,K=>K.resolveCodeAction($,G),void 0,void 0)}$releaseCodeActions(O,$){this._withAdapter(O,T,G=>Promise.resolve(G.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(O,$,G){const K=this._addNewAdapter(new N(this._documents,G),O);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector($),O.identifier,O.displayName||O.name),this._createDisposable(K)}$provideDocumentFormattingEdits(O,$,G,K){return this._withAdapter(O,N,de=>de.provideDocumentFormattingEdits(u.URI.revive($),G,K),void 0,K)}registerDocumentRangeFormattingEditProvider(O,$,G){const K=this._addNewAdapter(new H(this._documents,G),O);return this._proxy.$registerRangeFormattingSupport(K,this._transformDocumentSelector($),O.identifier,O.displayName||O.name),this._createDisposable(K)}$provideDocumentRangeFormattingEdits(O,$,G,K,de){return this._withAdapter(O,H,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive($),G,K,de),void 0,de)}registerOnTypeFormattingEditProvider(O,$,G,K){const de=this._addNewAdapter(new te(this._documents,G),O);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector($),K,O.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(O,$,G,K,de,we){return this._withAdapter(O,te,se=>se.provideOnTypeFormattingEdits(u.URI.revive($),G,K,de,we),void 0,we)}registerWorkspaceSymbolProvider(O,$){const G=this._addNewAdapter(new B($,this._logService),O);return this._proxy.$registerNavigateTypeSupport(G,typeof $.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(O,$,G){return this._withAdapter(O,B,K=>K.provideWorkspaceSymbols($,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,$,G){return this._withAdapter(O,B,K=>K.resolveWorkspaceSymbol($,G),void 0,void 0)}$releaseWorkspaceSymbols(O,$){this._withAdapter(O,B,G=>G.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(O,$,G){const K=this._addNewAdapter(new z(this._documents,G,this._logService),O);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector($),z.supportsResolving(G)),this._createDisposable(K)}$provideRenameEdits(O,$,G,K,de){return this._withAdapter(O,z,we=>we.provideRenameEdits(u.URI.revive($),G,K,de),void 0,de)}$resolveRenameLocation(O,$,G,K){return this._withAdapter(O,z,de=>de.resolveRenameLocation(u.URI.revive($),G,K),void 0,K)}registerDocumentSemanticTokensProvider(O,$,G,K){const de=this._addNewAdapter(new V(this._documents,G),O),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector($),K,we);let se=this._createDisposable(de);if(we){const De=G.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(we));se=A.Disposable.from(se,De)}return se}$provideDocumentSemanticTokens(O,$,G,K){return this._withAdapter(O,V,de=>de.provideDocumentSemanticTokens(u.URI.revive($),G,K),null,K)}$releaseDocumentSemanticTokens(O,$){this._withAdapter(O,V,G=>G.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,$,G,K){const de=this._addNewAdapter(new j(this._documents,G),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector($),K),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(O,$,G,K){return this._withAdapter(O,j,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive($),G,K),null,K)}registerCompletionItemProvider(O,$,G,K){const de=this._addNewAdapter(new ie(this._documents,this._commands.converter,G,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(de,this._transformDocumentSelector($),K,ie.supportsResolving(G),`${O.identifier.value}(${K.join("")})`),this._createDisposable(de)}$provideCompletionItems(O,$,G,K,de){return this._withAdapter(O,ie,we=>we.provideCompletionItems(u.URI.revive($),G,K,de),void 0,de)}$resolveCompletionItem(O,$,G){return this._withAdapter(O,ie,K=>K.resolveCompletionItem($,G),void 0,G)}$releaseCompletionItems(O,$){this._withAdapter(O,ie,G=>G.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(O,$,G){const K=new ue(O,this._documents,G,this._commands.converter),de=this._addNewAdapter(K,O);return this._proxy.$registerInlineCompletionsSupport(de,this._transformDocumentSelector($),K.supportsHandleDidShowCompletionItem),this._createDisposable(de)}registerInlineCompletionsProviderNew(O,$,G){const K=this._addNewAdapter(new ve(O,this._documents,G,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(K,this._transformDocumentSelector($),!0),this._createDisposable(K)}$provideInlineCompletions(O,$,G,K,de){return this._withAdapter(O,Q,we=>we.provideInlineCompletions(u.URI.revive($),G,K,de),void 0,de)}$handleInlineCompletionDidShow(O,$,G){this._withAdapter(O,Q,async K=>{K.handleDidShowCompletionItem($,G)},void 0,void 0)}$freeInlineCompletionsList(O,$){this._withAdapter(O,Q,async G=>{G.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(O,$,G,K){const de=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,we=this._addNewAdapter(new ge(this._documents,G),O);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector($),de),this._createDisposable(we)}$provideSignatureHelp(O,$,G,K,de){return this._withAdapter(O,ge,we=>we.provideSignatureHelp(u.URI.revive($),G,K,de),void 0,de)}$releaseSignatureHelp(O,$){this._withAdapter(O,ge,G=>G.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(O,$,G){const K=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new Ee(this._documents,this._commands.converter,G,this._logService,O),O);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector($),typeof G.resolveInlayHint=="function",K,ee._extLabel(O));let we=this._createDisposable(de);if(K!==void 0){const se=G.onDidChangeInlayHints(De=>this._proxy.$emitInlayHintsEvent(K));we=A.Disposable.from(we,se)}return we}$provideInlayHints(O,$,G,K){return this._withAdapter(O,Ee,de=>de.provideInlayHints(u.URI.revive($),G,K),void 0,K)}$resolveInlayHint(O,$,G){return this._withAdapter(O,Ee,K=>K.resolveInlayHint($,G),void 0,G)}$releaseInlayHints(O,$){this._withAdapter(O,Ee,G=>G.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(O,$,G){const K=this._addNewAdapter(new Pe(this._documents,G),O);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector($),typeof G.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(O,$,G){return this._withAdapter(O,Pe,K=>K.provideLinks(u.URI.revive($),G),void 0,G,$.scheme==="output")}$resolveDocumentLink(O,$,G){return this._withAdapter(O,Pe,K=>K.resolveLink($,G),void 0,void 0,!0)}$releaseDocumentLinks(O,$){this._withAdapter(O,Pe,G=>G.releaseLinks($),void 0,void 0,!0)}registerColorProvider(O,$,G){const K=this._addNewAdapter(new me(this._documents,G),O);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDocumentColors(O,$,G){return this._withAdapter(O,me,K=>K.provideColors(u.URI.revive($),G),[],G)}$provideColorPresentations(O,$,G,K){return this._withAdapter(O,me,de=>de.provideColorPresentations(u.URI.revive($),G,K),void 0,K)}registerFoldingRangeProvider(O,$,G){const K=this._nextHandle(),de=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new he(new Te(this._documents,G),O)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector($),de);let we=this._createDisposable(K);if(de!==void 0){const se=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));we=A.Disposable.from(we,se)}return we}$provideFoldingRanges(O,$,G,K){return this._withAdapter(O,Te,de=>de.provideFoldingRanges(u.URI.revive($),G,K),void 0,K)}registerSelectionRangeProvider(O,$,G){const K=this._addNewAdapter(new le(this._documents,G,this._logService),O);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideSelectionRanges(O,$,G,K){return this._withAdapter(O,le,de=>de.provideSelectionRanges(u.URI.revive($),G,K),[],K)}registerCallHierarchyProvider(O,$,G){const K=this._addNewAdapter(new pe(this._documents,G),O);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$prepareCallHierarchy(O,$,G,K){return this._withAdapter(O,pe,de=>Promise.resolve(de.prepareSession(u.URI.revive($),G,K)),void 0,K)}$provideCallHierarchyIncomingCalls(O,$,G,K){return this._withAdapter(O,pe,de=>de.provideCallsTo($,G,K),void 0,K)}$provideCallHierarchyOutgoingCalls(O,$,G,K){return this._withAdapter(O,pe,de=>de.provideCallsFrom($,G,K),void 0,K)}$releaseCallHierarchy(O,$){this._withAdapter(O,pe,G=>Promise.resolve(G.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(O,$,G){const K=this._addNewAdapter(new be(this._documents,G),O);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$prepareTypeHierarchy(O,$,G,K){return this._withAdapter(O,be,de=>Promise.resolve(de.prepareSession(u.URI.revive($),G,K)),void 0,K)}$provideTypeHierarchySupertypes(O,$,G,K){return this._withAdapter(O,be,de=>de.provideSupertypes($,G,K),void 0,K)}$provideTypeHierarchySubtypes(O,$,G,K){return this._withAdapter(O,be,de=>de.provideSubtypes($,G,K),void 0,K)}$releaseTypeHierarchy(O,$){this._withAdapter(O,be,G=>Promise.resolve(G.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(O,$,G){const K=this._nextHandle();return this._adapter.set(K,new he(new ae(this._proxy,this._documents,G,K),O)),this._proxy.$registerDocumentOnDropEditProvider(K,this._transformDocumentSelector($)),this._createDisposable(K)}$provideDocumentOnDropEdits(O,$,G,K,de,we){return this._withAdapter(O,ae,se=>Promise.resolve(se.provideDocumentOnDropEdits($,u.URI.revive(G),K,de,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,$,G,K){const de=this._nextHandle();return this._adapter.set(de,new he(new U(this._proxy,this._documents,G,de),O)),this._proxy.$registerPasteEditProvider(de,this._transformDocumentSelector($),!!G.prepareDocumentPaste,K.pasteMimeTypes),this._createDisposable(de)}$prepareDocumentPaste(O,$,G,K,de){return this._withAdapter(O,U,we=>we.prepareDocumentPaste(u.URI.revive($),G,K,de),void 0,de)}$providePasteEdits(O,$,G,K,de){return this._withAdapter(O,U,we=>we.providePasteEdits(0,u.URI.revive($),G,K,de),void 0,de)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,E.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ee._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ee._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ee._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ee._serializeRegExp(O.beforeText),afterText:O.afterText?ee._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ee._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ee._serializeOnEnterRule)}setLanguageConfiguration(O,$,G){const{wordPattern:K}=G;if(K&&(0,E.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor($,K):this._documents.setWordDefinitionFor($,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const de=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ee._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ee._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ee._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,$,we),this._createDisposable(de)}$setWordDefinitions(O){for(const $ of O)this._documents.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(Ie[251],ke([1,0,5,15,7,41,18,6]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(R,I,_,P){this._documents=I,this._commands=_,this._uriTransformer=P,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,I){await this._proxy.$changeLanguage(R,I);const _=this._documents.getDocumentData(R);if(!_)throw new Error(`document '${R.toString()}' NOT found`);return _.document}async tokenAtPosition(R,I){const _=R.version,P=n.Position.from(I),b=await this._proxy.$tokensAtPosition(R.uri,P),w={type:S.StandardTokenType.Other,range:R.getWordRangeAtPosition(I)??new S.Range(I.line,I.character,I.line,I.character)};if(!b)return w;const p={range:n.Range.to(b.range),type:n.TokenType.to(b.type)};return!p.range.contains(I)||_!==R.version?w:p}createLanguageStatusItem(R,I,_){const P=this._handlePool++,b=this._proxy,w=this._ids,p=`${R.identifier.value}/${I}`;if(w.has(p))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(p);const g={selector:_,id:I,name:R.displayName??R.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const f=new D.DisposableStore,c=()=>{v?.dispose(),v=(0,C.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(P,{id:p,name:g.name??R.displayName??R.name,source:R.displayName??R.name,selector:n.DocumentSelector.from(g.selector,this._uriTransformer),label:g.text,detail:g.detail??"",severity:g.severity===S.LanguageStatusSeverity.Error?A.default.Error:g.severity===S.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:g.command&&this._commands.toInternal(g.command,f),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},m={dispose(){f.dispose(),v?.dispose(),b.$removeLanguageStatus(P),w.delete(p)},get id(){return g.id},get name(){return g.name},set name(a){g.name=a,c()},get selector(){return g.selector},set selector(a){g.selector=a,c()},get text(){return g.text},set text(a){g.text=a,c()},get detail(){return g.detail},set detail(a){g.detail=a,c()},get severity(){return g.severity},set severity(a){g.severity=a,c()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(a){g.accessibilityInformation=a,c()},get command(){return g.command},set command(a){g.command=a,c()},get busy(){return g.busy},set busy(a){g.busy=a,c()}};return c(),m}}e.ExtHostLanguages=E}),define(Ie[136],ke([1,0,14,5,26,17,3]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends u.AbstractLoggerService{constructor(R,I){const _=new C.Emitter;super(I.logLevel,_.event);this._proxy=R.getProxy(n.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(_)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,I,_){return new E(this._proxy,R,I,_)}};D=Ge([He(0,A.IExtHostRpcService),He(1,S.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class E extends u.AbstractMessageLogger{constructor(R,I,_,P){super(P?.always);this.proxy=R,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(I,P).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,I){const _=[[R,I]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ie[252],ke([1,0,5,14,27]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(D){return D&&D.title}let C=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(u.MainContext.MainThreadMessageService)}showMessage(E,k,R,I,_){const P={source:{identifier:E.identifier,label:E.displayName||E.name}};let b;typeof I=="string"||A(I)?b=[I,..._]:(P.modal=I?.modal,P.useCustom=I?.useCustom,P.detail=I?.detail,b=_),P.useCustom&&(0,S.checkProposedApiEnabled)(E,"resolvers");const w=[];for(let p=0;p<b.length;p++){const g=b[p];if(typeof g=="string")w.push({title:g,handle:p,isCloseAffordance:!1});else if(typeof g=="object"){const{title:v,isCloseAffordance:f}=g;w.push({title:v,isCloseAffordance:!!f,handle:p})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(k,R,P,w).then(p=>{if(typeof p=="number")return b[p]})}};C=Ge([He(1,n.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[253],ke([1,0,23,3,60,6,25,8,10,2,87,5,37,15,7,53,223,131]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class v{constructor(c,m,a,h,r){this._textDocumentsAndEditors=a,this._textDocuments=h,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new n.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new n.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new n.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new n.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,t=s.cell.handle,l=this._documents.get(i)?.getCell(t);if(l)return l.apiCell}return s}}),v._registerApiCommands(m)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const m=this._editors.get(c);if(!m)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(c){for(const[m,a]of this._editors)if(a.apiEditor===c)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,m){const a=this._documents.get(c);if(!a&&!m)throw new Error(`NO notebook document for '${c}'`);return a}_getProviderData(c){const m=this._notebookContentProviders.get(c);if(!m)throw new Error(`NO provider for '${c}'`);return m}registerNotebookContentProvider(c,m,a,h,r){if((0,D.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:c,provider:a});let s;return a.onDidChangeNotebookContentOptions&&(s=a.onDidChangeNotebookContentOptions(()=>{const i=P.NotebookDocumentContentOptions.from(a.options);this._notebookProxy.$updateNotebookProviderOptions(m,i)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},m,P.NotebookDocumentContentOptions.from(h),v._convertNotebookRegistrationData(c,r)),new b.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(c,m){if(!m)return;const a=m.filenamePattern.map(h=>P.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(m.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:m.displayName,filenamePattern:a,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,m,a){const h=v._notebookStatusBarItemProviderHandlePool++,r=typeof a.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(h,a),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(h,r,m);let s;return r!==void 0&&(s=a.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(r))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(h),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(h,r),s&&s.dispose()})}async createNotebookDocument(c){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&P.NotebookData.from(c.content)});return k.URI.revive(m)}async openNotebookDocument(c){const m=this._documents.get(c);if(m)return m.apiNotebook;const a=await this._notebookDocumentsProxy.$tryOpenNotebook(c),h=this._documents.get(k.URI.revive(a));return(0,E.assertIsDefined)(h?.apiNotebook)}async showNotebookDocument(c,m){k.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let a;typeof m=="object"?a={position:P.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(P.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:a={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,a),r=h&&this._editors.get(h)?.apiEditor;if(r)return r;throw h?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,m,a,h){const r=this._notebookStatusBarItemProviders.get(c),s=k.URI.revive(m),i=this._documents.get(s);if(!i||!r)return;const t=i.getCellFromIndex(a);if(!t)return;const o=await r.provideCellStatusBarItems(t.apiCell,h);if(!o)return;const l=new A.DisposableStore,d=this._statusBarCache.add([l]),L=(Array.isArray(o)?o:[o]).map(M=>P.NotebookStatusBarItem.from(M,this._commandsConverter,l));return{cacheId:d,items:L}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,m,a,h,r){if((0,D.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,a),this._notebookProxy.$registerNotebookSerializer(s,{id:c.identifier,location:c.extensionLocation},m,P.NotebookDocumentContentOptions.from(h),v._convertNotebookRegistrationData(c,r)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(c,m,a){const h=this._notebookSerializer.get(c);if(!h)throw new Error("NO serializer found");const r=await h.deserializeNotebook(m.buffer,a);return new w.SerializableObjectWithBuffers(P.NotebookData.from(r))}async $notebookToData(c,m,a){const h=this._notebookSerializer.get(c);if(!h)throw new Error("NO serializer found");const r=await h.serializeNotebook(P.NotebookData.to(m.value),a);return u.VSBuffer.wrap(r)}async $openNotebook(c,m,a,h,r){const{provider:s}=this._getProviderData(c),i=await s.openNotebook(k.URI.revive(m),{backupId:a,untitledDocumentData:h?.buffer},r);return new w.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(P.NotebookCellData.from)})}async $saveNotebook(c,m,a){const h=this.getNotebookDocument(k.URI.revive(m)),{provider:r}=this._getProviderData(c);return await r.saveNotebook(h.apiNotebook,a),!0}async $saveNotebookAs(c,m,a,h){const r=this.getNotebookDocument(k.URI.revive(m)),{provider:s}=this._getProviderData(c);return await s.saveNotebookAs(k.URI.revive(a),r.apiNotebook,h),!0}async $backupNotebook(c,m,a){const h=this.getNotebookDocument(k.URI.revive(m)),r=this._getProviderData(c),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),i=String((0,S.hash)([h.uri.toString(),this._backupIdPool++])),t=k.URI.joinPath(s,i),o=await r.provider.backupNotebook(h.apiNotebook,{destination:t},a);return h.updateBackup(o),o.id}_createExtHostEditor(c,m,a){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const h=new g.ExtHostNotebookEditor(m,this._notebookEditorsProxy,c,a.visibleRanges.map(P.NotebookRange.to),a.selections.map(P.NotebookRange.to),typeof a.viewColumn=="number"?P.ViewColumn.to(a.viewColumn):void 0);this._editors.set(m,h)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const a of c.value.removedDocuments){const h=k.URI.revive(a),r=this._documents.get(h);r&&(r.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===h.toString()&&this._editors.delete(s.id)}if(c.value.addedDocuments){const a=[];for(const h of c.value.addedDocuments){const r=k.URI.revive(h.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,h);a.push(...h.cells.map(i=>p.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(c.value.addedEditors)for(const a of c.value.addedEditors){if(this._editors.has(a.id))return;const h=k.URI.revive(a.documentUri),r=this._documents.get(h);r&&this._createExtHostEditor(r,a.id,a)}const m=[];if(c.value.removedEditors)for(const a of c.value.removedEditors){const h=this._editors.get(a);h&&(this._editors.delete(a),this._activeNotebookEditor?.id===h.id&&(this._activeNotebookEditor=void 0),m.push(h))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const a=new Set;this._visibleNotebookEditors.forEach(h=>a.add(h.id));for(const h of this._editors.values()){const r=a.has(h.id);h._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(c){const m=_.ApiCommandArgument.String.with("notebookType","A notebook type"),a=new _.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new _.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>u.VSBuffer.wrap(r))],new _.ApiCommandResult("Notebook Data",r=>P.NotebookData.to(r.value))),h=new _.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new _.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new w.SerializableObjectWithBuffers(P.NotebookData.from(r)))],new _.ApiCommandResult("Bytes",r=>r.buffer));c.registerApiCommand(a),c.registerApiCommand(h)}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0}),define(Ie[254],ke([1,0,16,18,21,3,6,25,2,28,14,5,37,15,7,88,218,27,53]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(s,i,t,o,l){this._initData=i,this._extHostNotebook=t,this._commands=o,this._logService=l,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(I.MainContext.MainThreadNotebookKernels);const d=new _.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new _.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const L=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:L}}else if(y&&"notebookEditor"in y){const L=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return y})],_.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(s,i,t,o,l,d){for(const ie of this._kernelData.values())if(ie.controller.id===i&&k.ExtensionIdentifier.equals(s.identifier,ie.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const y=this._handlePool++,L=this;this._logService.trace(`NotebookController[${y}], CREATED by ${s.identifier.value}, ${i}`);const M=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${s.identifier}'`);let F=!1;const T=new C.DisposableStore,U=new A.Emitter,N=new A.Emitter,H={id:h(s.identifier,i),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:o||s.identifier.value,preloads:d?d.map(P.NotebookRendererScript.from):[]};let te=l??M,B;this._proxy.$addKernel(y,H).catch(ie=>{console.log(ie),F=!0});let z=0;const q=()=>{if(F)return;const ie=++z;Promise.resolve().then(()=>{ie===z&&this._proxy.$updateKernel(y,H)})},V=new D.ResourceMap,j={get id(){return i},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return H.label},set label(ie){H.label=ie??s.displayName??s.name,q()},get detail(){return H.detail??""},set detail(ie){H.detail=ie,q()},get description(){return H.description??""},set description(ie){H.description=ie,q()},get kind(){return(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),H.kind??""},set kind(ie){(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),H.kind=ie,q()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ie){H.supportedLanguages=ie,q()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){H.supportsExecutionOrder=ie,q()},get rendererScripts(){return H.preloads?H.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(ie){te=ie??M},get interruptHandler(){return B},set interruptHandler(ie){B=ie,H.supportsInterrupt=Boolean(ie),q()},createNotebookCellExecution(ie){if(F)throw new Error("notebook controller is DISPOSED");if(!V.has(ie.notebook.uri))throw L._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return L._createNotebookCellExecution(ie,h(s.identifier,this.id))},dispose:()=>{F||(this._logService.trace(`NotebookController[${y}], DISPOSED`),F=!0,this._kernelData.delete(y),T.dispose(),U.dispose(),N.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(ie,Q){L._proxy.$updateNotebookPriority(y,ie.uri,Q)},onDidReceiveMessage:N.event,postMessage(ie,Q){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),L._proxy.$postMessage(y,Q&&L._extHostNotebook.getIdByEditor(Q),ie)},asWebviewUri(ie){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),(0,w.asWebviewUri)(ie,L._initData.remote)}};return this._kernelData.set(y,{extensionId:s.identifier,controller:j,onDidReceiveMessage:N,onDidChangeSelection:U,associatedNotebooks:V}),j}getIdByController(s){for(const[i,t]of this._kernelData)if(t.controller===s)return h(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,i,t){const o=this._kernelData.get(s);if(o){const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(i));t?o.associatedNotebooks.set(l.uri,!0):o.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,l.uri.toString(),t),o.onDidChangeSelection.fire({selected:t,notebook:l.apiNotebook})}}async $executeCells(s,i,t){const o=this._kernelData.get(s);if(!o)return;const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)),d=[];for(const y of t){const L=l.getCell(y);L&&d.push(L.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,l.uri.toString(),d.length),await o.controller.executeHandler.call(o.controller,d,l.apiNotebook,o.controller)}catch(y){this._logService.error(`NotebookController[${s}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(s,i,t){const o=this._kernelData.get(s);if(!o)return;const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(i));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,l.apiNotebook);else for(const d of t){const y=l.getCell(d);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,i,t){const o=this._kernelData.get(s);if(!o)return;const l=this._extHostNotebook.getEditorById(i);o.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:t}))}$cellExecutionChanged(s,i,t){const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(s)).getCell(i);l&&this._onDidChangeCellExecutionState.fire({cell:l.apiCell,state:t?P.NotebookCellExecutionState.to(t):b.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,i){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const l=new m(i,o,this._proxy);this._activeExecutions.set(o.uri,l);const d=l.onDidChangeState(()=>{l.state===c.Resolved&&(l.dispose(),d.dispose(),this._activeExecutions.delete(o.uri))});return l.asApiObject()}};f=Ge([He(4,R.ILogService)],f),e.ExtHostNotebookKernels=f;var c;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(c||(c={}));class m extends C.Disposable{constructor(s,i,t){super();this._cell=i,this._proxy=t,this._handle=m.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new a(10,o=>this.update(o)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const i=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let i=this._cell;if(s&&(i=this._cell.notebook.getCellFromApiCell(s)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(s){return s.map(i=>{const t=b.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return t===i.items?P.NotebookCellOutput.from(i):P.NotebookCellOutput.from({items:t,id:i.id,metadata:i.metadata})})}async updateOutputs(s,i,t){const o=this.cellIndexToHandle(i),l=this.validateAndConvertOutputs((0,u.asArray)(s));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,cellHandle:o,append:t,outputs:l})}async updateOutputItems(s,i,t){return s=b.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(s),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,items:s.map(P.NotebookCellOutputItem.from),outputId:i.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===c.Resolved||s._state===c.Started)throw new Error("Cannot call start again");s._state=c.Started,s._onDidChangeState.fire(),s.update({editType:p.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,o){if(s._state===c.Resolved)throw new Error("Cannot call resolve twice");s._state=c.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new v.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,o){return s.verifyStateForOutput(),s.updateOutputs(t,o,!0)},replaceOutput(t,o){return s.verifyStateForOutput(),s.updateOutputs(t,o,!1)},appendOutputItems(t,o){return s.verifyStateForOutput(),s.updateOutputItems(t,o,!0)},replaceOutputItems(t,o){return s.verifyStateForOutput(),s.updateOutputItems(t,o,!1)}})}}m.HANDLE=0;class a{constructor(s,i){this.delay=s,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new n.DeferredPromise,this.startedTimer=Date.now(),(0,n.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>s.complete())}}function h(r,s){return`${r.value}/${s}`}e.createKernelId=h}),define(Ie[255],ke([1,0,3,5,131]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(D,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(n.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,E,k){const R=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(E)?.fire({editor:R.apiEditor,message:k})}createRendererMessaging(D,E){if(!D.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,I,_)=>this.getOrCreateEmitterFor(E).event(R,I,_),postMessage:(R,I)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const _=I&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(_?.id,E,R)}}}getOrCreateEmitterFor(D){let E=this._rendererMessageEmitters.get(D);return E||(E=new u.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,E),E)}}e.ExtHostNotebookRenderers=A}),define(Ie[256],ke([1,0,21,3,6,5,2,7,12,16,41,86]),function(X,e,u,n,S,A,C,D,E,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(P,b,w){const p=P.getProxy(A.MainContext.MainThreadQuickOpen);class g{constructor(i,t){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=t}showQuickPick(i,t,o=u.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(i),d=++this._instances,y=p.$show(d,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},o),L={},M=y.then(()=>L);return Promise.race([M,l]).then(F=>{if(F!==L)return l.then(T=>{const U=[];for(let N=0;N<T.length;N++){const H=T[N];typeof H=="string"?U.push({label:H,handle:N}):H.kind===D.QuickPickItemKind.Separator?U.push({type:"separator",label:H.label}):U.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:N})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{t.onDidSelectItem(T[N])}),p.$setItems(d,U),y.then(N=>{if(typeof N=="number")return T[N];if(Array.isArray(N))return N.map(H=>T[H])})})}).then(void 0,F=>{if(!(0,E.isCancellationError)(F))return p.$setError(d,F),Promise.reject(F)})}$onItemSelected(i){this._onDidSelectItem?.(i)}showInput(i,t=u.CancellationToken.None){return this._validateInput=i?.validateInput,p.$input(i,typeof this._validateInput=="function",t).then(void 0,o=>{if(!(0,E.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(i){if(!this._validateInput)return;const t=await this._validateInput(i);if(!t||typeof t=="string")return t;let o;switch(t.severity){case D.InputBoxValidationSeverity.Info:o=R.default.Info;break;case D.InputBoxValidationSeverity.Warning:o=R.default.Warning;break;case D.InputBoxValidationSeverity.Error:o=R.default.Error;break;default:o=t.message?R.default.Error:R.default.Ignore;break}return{content:t.message,severity:o}}async showWorkspaceFolderPick(i,t=u.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!o)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(d=>d.uri.toString()===o.uri.toString())}createQuickPick(i){const t=new h(i,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(i){const t=new r(i,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(i,t){this._sessions.get(i)?._fireDidChangeValue(t)}$onDidAccept(i){const t=this._sessions.get(i);t&&t._fireDidAccept()}$onDidChangeActive(i,t){const o=this._sessions.get(i);o instanceof h&&o._fireDidChangeActive(t)}$onDidChangeSelection(i,t){const o=this._sessions.get(i);o instanceof h&&o._fireDidChangeSelection(t)}$onDidTriggerButton(i,t){this._sessions.get(i)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(i,t,o){const l=this._sessions.get(i);l instanceof h&&l._fireDidTriggerItemButton(t,o)}$onDidHide(i){const t=this._sessions.get(i);t&&t._fireDidHide()}}class v{constructor(i,t){this._extensionId=i,this._onDidDispose=t,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new n.Emitter,this._onDidChangeValueEmitter=new n.Emitter,this._onDidTriggerButtonEmitter=new n.Emitter,this._onDidHideEmitter=new n.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((t,o)=>{const l=t===D.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(l,t)}),this.update({buttons:i.map((t,o)=>({...a(t),tooltip:t.tooltip,handle:t===D.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const t=this._handlesToButtons.get(i);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(i){if(!this._disposed){for(const t of Object.keys(i)){const o=i[t];this._pendingUpdate[t]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function f(s){if(s instanceof D.ThemeIcon)return{id:s.id};const i=m(s),t=c(s);return{dark:typeof i=="string"?C.URI.file(i):i,light:typeof t=="string"?C.URI.file(t):t}}function c(s){return typeof s=="object"&&"light"in s?s.light:s}function m(s){return typeof s=="object"&&"dark"in s?s.dark:s}function a(s){const i=f(s.iconPath);let t,o;return"id"in i?o=I.ThemeIcon.asClassName(i):t=i,{iconPath:t,iconClass:o}}class h extends v{constructor(i,t){super(i.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new n.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new n.Emitter,this._onDidTriggerItemButtonEmitter=new n.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((o,l)=>{this._handlesToItems.set(l,o),this._itemsToHandles.set(o,l)});const t=[];for(let o=0;o<i.length;o++){const l=i[o];l.kind===D.QuickPickItemKind.Separator?t.push({type:"separator",label:l.label}):t.push({handle:o,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((d,y)=>({...a(d),tooltip:d.tooltip,handle:y}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(i){const t=(0,k.coalesce)(i.map(o=>this._handlesToItems.get(o)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(i){const t=(0,k.coalesce)(i.map(o=>this._handlesToItems.get(o)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(i,t){const o=this._handlesToItems.get(i);if(!o||!o.buttons||!o.buttons.length)return;const l=o.buttons[t];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:o})}}class r extends v{constructor(i,t){super(i.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,i?typeof i=="string"?this.update({validationMessage:i,severity:R.default.Error}):this.update({validationMessage:i.message,severity:i.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new g(b,w)}e.createExtHostQuickOpen=_});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[257],ke([1,0,2,3,57,6,18,5,16,104,14,28,86,15,27]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b){"use strict";var w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(l){if(l)return typeof l.iconPath=="string"?u.URI.file(l.iconPath):u.URI.isUri(l.iconPath)||_.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function v(l,d){if(!l.iconPath&&!d.iconPath)return 0;if(l.iconPath){if(!d.iconPath)return 1}else return-1;const y=typeof l.iconPath=="string"?l.iconPath:u.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,L=typeof d.iconPath=="string"?d.iconPath:u.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,k.comparePaths)(y,L)}function f(l,d){let y=0;if(l.strikeThrough!==d.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==d.faded)return l.faded?1:-1;if(l.tooltip!==d.tooltip)return(l.tooltip||"").localeCompare(d.tooltip||"");if(y=v(l,d),y!==0)return y;if(l.light&&d.light)y=v(l.light,d.light);else{if(l.light)return 1;if(d.light)return-1}if(y!==0)return y;if(l.dark&&d.dark)y=v(l.dark,d.dark);else{if(l.dark)return 1;if(d.dark)return-1}return y}function c(l,d){if(l.command!==d.command)return l.command<d.command?-1:1;if(l.title!==d.title)return l.title<d.title?-1:1;if(l.tooltip!==d.tooltip){if(l.tooltip!==void 0&&d.tooltip!==void 0)return l.tooltip<d.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(l.arguments===d.arguments)return 0;if(l.arguments)if(d.arguments){if(l.arguments.length!==d.arguments.length)return l.arguments.length-d.arguments.length}else return 1;else return-1;for(let y=0;y<l.arguments.length;y++){const L=l.arguments[y],M=d.arguments[y];if(L!==M)return L<M?-1:1}return 0}function m(l,d){let y=(0,k.comparePaths)(l.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(y!==0)return y;if(l.command&&d.command)y=c(l.command,d.command);else{if(l.command)return 1;if(d.command)return-1}if(y!==0)return y;if(l.decorations&&d.decorations)y=f(l.decorations,d.decorations);else{if(l.decorations)return 1;if(d.decorations)return-1}return y}function a(l,d){for(let y=0;y<l.length;y++)if(l[y]!==d[y])return!1;return!0}function h(l,d){return l.command===d.command&&l.title===d.title&&l.tooltip===d.tooltip&&(l.arguments&&d.arguments?a(l.arguments,d.arguments):l.arguments===d.arguments)}function r(l,d){return(0,E.equals)(l,d,h)}class s{constructor(d,y,L){this._extension=d,this._sourceControlHandle=L,w.set(this,void 0),this._value="",this._onDidChange=new n.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,w,y,"f")}get value(){return this._value}set value(d){d=d??"",Me(this,w,"f").$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){Me(this,w,"f").$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,b.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(d){if((0,b.checkProposedApiEnabled)(this._extension,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,Me(this,w,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get enabled(){return this._enabled}set enabled(d){d=!!d,this._enabled!==d&&(this._enabled=d,Me(this,w,"f").$setInputBoxEnablement(this._sourceControlHandle,d))}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,Me(this,w,"f").$setInputBoxVisibility(this._sourceControlHandle,d))}showValidationMessage(d,y){(0,b.checkProposedApiEnabled)(this._extension,"scmValidation"),Me(this,w,"f").$showValidationMessage(this._sourceControlHandle,d,y)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=s,w=new WeakMap;class i{constructor(d,y,L,M,F){this._proxy=d,this._commands=y,this._sourceControlHandle=L,this._id=M,this._label=F,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new n.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,y){const L=this._resourceStatesCommandsMap.get(d);return L?(0,C.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],y)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(m),L=(0,E.sortedDiff)(this._resourceSnapshot,d,m).map(T=>{const U=T.toInsert.map(N=>{const H=this._resourceHandlePool++;this._resourceStatesMap.set(H,N);const te=N.resourceUri;let B;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const ge=new A.DisposableStore;B=this._commands.converter.toInternal(N.command,ge),this._resourceStatesDisposablesMap.set(H,ge)}else this._resourceStatesCommandsMap.set(H,N.command);const z=g(N.decorations),q=N.decorations&&g(N.decorations.light)||z,V=N.decorations&&g(N.decorations.dark)||z,j=[q,V],ie=N.decorations&&N.decorations.tooltip||"",Q=N.decorations&&!!N.decorations.strikeThrough,ue=N.decorations&&!!N.decorations.faded,ve=N.contextValue||"";return{rawResource:[H,te,j,ie,Q,ue,ve,B],handle:H}});return{start:T.start,deleteCount:T.deleteCount,toInsert:U}}),M=L.map(({start:T,deleteCount:U,toInsert:N})=>[T,U,N.map(H=>H.rawResource)]),F=L.reverse();for(const{start:T,deleteCount:U,toInsert:N}of F){const H=N.map(B=>B.handle),te=this._handlesSnapshot.splice(T,U,...H);for(const B of te)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=d,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class t{constructor(d,y,L,M,F,T){this._extension=d,this._commands=L,this._id=M,this._label=F,this._rootUri=T,p.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new n.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,p,y,"f"),this._inputBox=new s(d,Me(this,p,"f"),this.handle),Me(this,p,"f").$registerSourceControl(this.handle,M,F,T)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,Me(this,p,"f").$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,Me(this,p,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,Me(this,p,"f").$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=d;const y=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);Me(this,p,"f").$updateSourceControl(this.handle,{acceptInputCommand:y})}get actionButton(){return(0,b.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(d){(0,b.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=d;const y=d!==void 0?{command:this._commands.converter.toInternal(d.command,this._actionButtonDisposables.value),secondaryCommands:d.secondaryCommands?.map(L=>L.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:d.description,enabled:d.enabled}:void 0;Me(this,p,"f").$updateSourceControl(this.handle,{actionButton:y??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&r(this._statusBarCommands,d))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=d;const y=(d||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Me(this,p,"f").$updateSourceControl(this.handle,{statusBarCommands:y})}get selected(){return this._selected}createResourceGroup(d,y){const L=new i(Me(this,p,"f"),this._commands,this.handle,d,y),M=n.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,M),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const d=[],y=[];for(const[L,M]of this.createdResourceGroups){M.dispose();const F=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});n.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),F.dispose(),this._groups.delete(L.handle),Me(this,p,"f").$unregisterGroup(this.handle,L.handle)}),d.push([L.handle,L.id,L.label,L.features]);const T=L._takeResourceStateSnapshot();T.length>0&&y.push([L.handle,T]),this._groups.set(L.handle,L)}Me(this,p,"f").$registerGroups(this.handle,d,y),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(y=>{const L=y._takeResourceStateSnapshot();L.length!==0&&d.push([y.handle,L])}),d.length>0&&Me(this,p,"f").$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),Me(this,p,"f").$unregisterSourceControl(this.handle)}}p=new WeakMap,t._handlePool=0,Ge([(0,S.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ge([(0,S.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let o=class Qn{constructor(d,y,L){this._commands=y,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new n.Emitter,this._proxy=d.getProxy(D.MainContext.MainThreadSCM),this._telemetry=d.getProxy(D.MainContext.MainThreadTelemetry),y.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const F=this._sourceControls.get(M.sourceControlHandle);if(!F)return M;const T=F.getResourceGroup(M.groupHandle);return T?T.getResourceState(M.handle):M}else if(M&&M.$mid===4){const F=this._sourceControls.get(M.sourceControlHandle);return F?F.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const F=this._sourceControls.get(M.handle);return F||M}return M}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,y,L,M){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,y,L,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const F=Qn._handlePool++,T=new t(d,this._proxy,this._commands,y,L,M);this._sourceControls.set(F,T);const U=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier))||[];return U.push(T),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(d.identifier),U),T}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const y=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier)),L=y&&y[y.length-1];return L&&L.inputBox}$provideOriginalResource(d,y,L){const M=u.URI.revive(y);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,M.toString());const F=this._sourceControls.get(d);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>F.quickDiffProvider.provideOriginalResource(M,L)).then(T=>T||null)}$onInputBoxValueChange(d,y){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const L=this._sourceControls.get(d);return L&&L.inputBox.$onInputBoxValueChange(y),Promise.resolve(void 0)}$executeResourceCommand(d,y,L,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,y,L);const F=this._sourceControls.get(d);if(!F)return Promise.resolve(void 0);const T=F.getResourceGroup(y);return T?T.$executeResourceCommand(L,M):Promise.resolve(void 0)}$validateInput(d,y,L){this.logService.trace("ExtHostSCM#$validateInput",d);const M=this._sourceControls.get(d);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>M.inputBox.validateInput(y,L)).then(F=>{if(!F)return Promise.resolve(void 0);const T=P.MarkdownString.fromStrict(F.message);return T?Promise.resolve([T,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};o._handlePool=0,o=Ge([He(2,R.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[258],ke([1,0,7,5,173,6,15,10]),function(X,e,u,n,S,A,C,D){"use strict";var E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(b,w,p,g,v=u.StatusBarAlignment.Left,f){E.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,E,b,"f"),tt(this,k,w,"f"),this._entryId=R.ID_GEN++,this._extension=p,this._id=g,this._alignment=v,this._priority=this.validatePriority(f)}validatePriority(b){if(!!(0,D.isNumber)(b))return b===Number.POSITIVE_INFINITY?Number.MAX_VALUE:b===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set name(b){this._name=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!R.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){this._command?.fromApi!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:Me(this,k,"f").toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:Me(this,k,"f").toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let b;this._extension?this._id?b=`${this._extension.identifier.value}.${this._id}`:b=this._extension.identifier.value:b=this._id;let w;this._name?w=this._name:w=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const g=C.MarkdownString.fromStrict(this._tooltip);Me(this,E,"f").$setEntry(this._entryId,b,w,this._text,g,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,E=new WeakMap,k=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(b){this._messages=[],this._item=b.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const w={message:b};return this._messages.unshift(w),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(w);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(b,w){this._proxy=b.getProxy(n.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(b,w,p,g){return new R(this._proxy,this._commands,b,w,p,g)}setStatusBarMessage(b,w){const p=this._statusMessage.setMessage(b);let g;return typeof w=="number"?g=setTimeout(()=>p.dispose(),w):typeof w!="undefined"&&w.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(g)})}}e.ExtHostStatusBar=_}),define(Ie[91],ke([1,0,5,3,4]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(D){this._onDidChangeStorage=new n.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,E){this._proxy.$registerExtensionStorageKeysToSync(D,E)}initializeExtensionStorage(D,E,k){return this._proxy.$initializeExtensionStorage(D,E).then(R=>R||k)}setValue(D,E,k){return this._proxy.$setValue(D,E,k)}$acceptValue(D,E,k){this._onDidChangeStorage.fire({shared:D,key:E,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ie[69],ke([1,0,4,26,14,68,2]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let D=class{constructor(k,R,I){this._logService=R,this._extHostFileSystem=I,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(_=>this._value=_)}async _getWorkspaceStorageURI(k){return C.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,R=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this._value)return C.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return C.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=Ge([He(0,n.IExtHostInitDataService),He(1,S.ILogService),He(2,A.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(Ie[38],ke([1,0,3,5,4,2,17,6,7,174,12,219,21,34,202,86,10,18]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class v{constructor(t,o,l,d){this._proxy=t,this._id=o,this._creationOptions=l,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(L,M=!0){y._checkDisposed(),y._proxy.$sendText(y._id,L,M)},show(L){y._checkDisposed(),y._proxy.$show(y._id,L)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(t,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,p.withNullAsUndefined)(t.shellPath),shellArgs:(0,p.withNullAsUndefined)(t.shellArgs),cwd:(0,p.withNullAsUndefined)(t.cwd),env:(0,p.withNullAsUndefined)(t.env),icon:(0,p.withNullAsUndefined)(r(t.iconPath)),color:w.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,p.withNullAsUndefined)(t.message),strictEnv:(0,p.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(t.location,o?.resolvedExtHostIdentifier),isTransient:(0,p.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,o,l,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,color:w.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(t,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,o){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,o){return t===this._cols&&o===this._rows||t===0||o===0?!1:(this._cols=t,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=v;class f{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,o){this._pty.setDimensions?.({columns:t,rows:o})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let c=1,m=class extends D.Disposable{constructor(t,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(n.MainContext.MainThreadTerminalService),this._bufferer=new b.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,o){const l=new v(this._proxy,(0,P.generateUuid)(),t,t.name),d=new f(t.pty);return l.createExtensionTerminal(t.location,this._serializeParentTerminal(t,o).resolvedExtHostIdentifier,r(t.iconPath),s(t.color)).then(y=>{const L=this._setupExtHostProcessListeners(y,d);this._terminalProcessDisposables[y]=L}),this._terminals.push(l),l.value}_serializeParentTerminal(t,o){if(o=o||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const l=t.location.parentTerminal;if(l){const d=this._terminals.find(y=>y.value===l);d&&(o.resolvedExtHostIdentifier=d._id)}}else t.location&&typeof t.location!="object"?o.location=t.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(t,o){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const d=new f(o),y=this._setupExtHostProcessListeners(t,d);this._terminalProcessDisposables[t]=y}async $acceptActiveTerminalChanged(t){const o=this._activeTerminal;if(t===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,o){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:o})}async $acceptTerminalDimensions(t,o,l){const d=this._getTerminalById(t);d&&d.setDimensions(o,l)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(t,o,l){this._terminalProcesses.get(t)?.resize(o,l)}async $acceptTerminalTitleChange(t,o){const l=this._getTerminalById(t);l&&(l.name=o)}async $acceptTerminalClosed(t,o){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const d=this._terminals.splice(l,1)[0];d.setExitCode(o),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(t,o,l,d){if(o){const M=this._getTerminalObjectIndexById(this._terminals,o);if(M!==null){this._terminals[M]._id=t,this._onDidOpenTerminal.fire(this.terminals[M]),this._terminals[M].isOpen=!0;return}}const y={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:A.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},L=new v(this._proxy,t,y,l);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(t,o){this._getTerminalById(t)?._setProcessId(o)}async $startExtensionTerminal(t,o){const l=this._getTerminalById(t);if(!l)return{message:(0,k.localize)(0,null,t)};l.isOpen||await new Promise(y=>{const L=this.onDidOpenTerminal(async M=>{M===l.value&&(L.dispose(),y())})});const d=this._terminalProcesses.get(t);d?d.startSendingEvents(o):this._extensionTerminalAwaitingStart[t]={initialDimensions:o}}_setupExtHostProcessListeners(t,o){const l=new D.DisposableStore;l.add(o.onProcessReady(y=>this._proxy.$sendProcessReady(t,y.pid,y.cwd))),l.add(o.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(t,y))),this._bufferer.startBuffering(t,o.onProcessData),l.add(o.onProcessExit(y=>this._onProcessExit(t,y))),this._terminalProcesses.set(t,o);const d=this._extensionTerminalAwaitingStart[t];return d&&o instanceof f&&(o.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,o){this._terminalProcesses.get(t)?.acknowledgeDataEvent(o)}$acceptProcessInput(t,o){this._terminalProcesses.get(t)?.input(o)}$acceptTerminalInteraction(t){const o=this._getTerminalById(t);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(t,o,l){try{this._terminalProcesses.get(t)?.resize(o,l)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(t,o){this._terminalProcesses.get(t)?.shutdown(o)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:o}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,o,l){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,l),this._proxy.$registerProfileProvider(o,t.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(t,o){const l=new _.CancellationTokenSource().token;let d=await this._profileProviders.get(t)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,o);return}this.createTerminalFromOptions(d.options,o)}}async $provideLinks(t,o){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const y=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,y);const L=[],M={terminal:l.value,line:o},F=[];for(const N of this._linkProviders)F.push(g.Promises.withAsyncBody(async H=>{y.token.onCancellationRequested(()=>H({provider:N,links:[]}));const te=await N.provideTerminalLinks(M,y.token)||[];y.token.isCancellationRequested||H({provider:N,links:te})}));const T=await Promise.all(F);if(y.token.isCancellationRequested)return[];const U=new Map;for(const N of T)N&&N.links.length>0&&L.push(...N.links.map(H=>{const te={id:c++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return U.set(te.id,{provider:N.provider,link:H}),te}));return this._terminalLinkCache.set(t,U),L}$activateLink(t,o){const l=this._terminalLinkCache.get(t)?.get(o);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,o){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,o)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,o){const l=this._getTerminalObjectIndexById(t,o);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,o){let l=null;return t.some((d,y)=>d._id===o?(l=y,!0):!1),l}getEnvironmentVariableCollection(t){let o=this._environmentVariableCollections.get(t.identifier.value);return o||(o=new a,this._setEnvironmentVariableCollection(t.identifier.value,o)),o}_syncEnvironmentVariableCollection(t,o){const l=(0,I.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(t,o.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(o=>{const l=o[0],d=new a(o[1]);this._setEnvironmentVariableCollection(l,d)})}$acceptDefaultProfile(t,o){this._defaultProfile=t,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(t,o){this._environmentVariableCollections.set(t,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,o)})}};m=Ge([He(1,C.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class a{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,o){this._setIfDiffers(t,{value:o,type:E.EnvironmentVariableMutatorType.Replace})}append(t,o){this._setIfDiffers(t,{value:o,type:E.EnvironmentVariableMutatorType.Append})}prepend(t,o){this._setIfDiffers(t,{value:o,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,o){const l=this.map.get(t);(!l||l.value!==o.value||l.type!==o.type)&&(this.map.set(t,o),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,o){this.map.forEach((l,d)=>t.call(o,d,l,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let h=class extends m{constructor(t){super(!1,t)}createTerminal(t,o,l){throw new R.NotSupportedError}createTerminalFromOptions(t,o){throw new R.NotSupportedError}};h=Ge([He(0,C.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function s(i){return w.ThemeColor.isThemeColor(i)?i:void 0}});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[259],ke([1,0,16,23,21,3,58,60,6,24,10,34,5,17,132,15,7,65,89,66]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(F,T){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(_.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new r(this.proxy),T.registerArgumentProcessor({processArgument:U=>U?.$mid===13?(0,b.toItemFromContext)(U):U})}createTestController(F,T,U){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const N=new E.DisposableStore,H=N.add(new b.ExtHostTestItemCollection(F,T));H.root.label=T;const te=new Map,B=this.proxy,z={items:H.root.children,get label(){return T},set label(V){T=V,H.root.label=V,B.$updateController(F,{label:T})},get refreshHandler(){return U},set refreshHandler(V){U=V,B.$updateController(F,{canRefresh:!!V})},get id(){return F},createRunProfile:(V,j,ie,Q,ue)=>{let ve=(0,D.hash)(V);for(;te.has(ve);)ve++;return new y(this.proxy,te,F,ve,V,j,ie,Q,ue)},createTestItem(V,j,ie){return new b.TestItemImpl(F,V,j,ie)},createTestRun:(V,j,ie=!0)=>this.runTracker.createTestRun(F,H,V,j,ie),set resolveHandler(V){H.resolveHandler=V},get resolveHandler(){return H.resolveHandler},dispose:()=>{N.dispose()}};B.$registerTestController(F,T,!!U),N.add((0,E.toDisposable)(()=>B.$unregisterTestController(F)));const q={controller:z,collection:H,profiles:te};return this.controllers.set(F,q),N.add((0,E.toDisposable)(()=>this.controllers.delete(F))),N.add(H.onDidGenerateDiff(V=>B.$publishDiff(F,V.map(f.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(F,T=S.CancellationToken.None){const U=s(F);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.controllers.get(U.controllerId);if(!N)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(H=>g.TestId.fromExtHostTestItem(H,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:L[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:F.exclude?.map(H=>H.id)},T)}$provideFileCoverage(F,T,U){return(0,u.mapFind)(this.runTracker.trackers,H=>H.id===F?H.getCoverage(T):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(F,T,U,N){return(0,u.mapFind)(this.runTracker.trackers,te=>te.id===F?te.getCoverage(T):void 0)?.resolveFileCoverage(U,N)??Promise.resolve([])}$configureRunProfile(F,T){this.controllers.get(F)?.profiles.get(T)?.configureHandler?.()}async $refreshTests(F,T){await this.controllers.get(F)?.controller.refreshHandler?.(T)}$publishTestResults(F){this.results=Object.freeze(F.map(T=>(0,k.deepFreeze)(w.TestResults.to(T))).concat(this.results).sort((T,U)=>U.completedAt-T.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,T){const U=this.controllers.get(g.TestId.fromString(F).controllerId)?.collection;U&&(await U.expand(F,T<0?1/0:T),U.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F.map(f.TestsDiffOp.deserialize))}async $runControllerTests(F,T){const U=this.controllers.get(F.controllerId);if(!U)return;const{collection:N,profiles:H}=U,te=H.get(F.profileId);if(!te)return;const B=F.testIds.map(j=>N.tree.get(j)).filter(R.isDefined),z=F.excludeExtIds.map(j=>U.collection.tree.get(j)).filter(R.isDefined).filter(j=>B.some(ie=>ie.fullId.compare(j.fullId)===2));if(!B.length)return;const q=new p.TestRunRequest(B.some(j=>j.actual instanceof b.TestItemRootImpl)?void 0:B.map(j=>j.actual),z.map(j=>j.actual),te),V=this.runTracker.prepareForMainThreadTestRun(q,i.fromInternal(F,U.collection),T);try{await te.runHandler(q,T)}finally{V.isRunning&&!T.isCancellationRequested&&await A.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};a=Ge([He(0,P.IExtHostRpcService)],a),e.ExtHostTesting=a;class h extends E.Disposable{constructor(F,T,U){super();this.dto=F,this.proxy=T,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(U)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:N}of this.tasks.values())N.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const T=this.dto.id,U=this.dto.controllerId,N=(0,I.generateUuid)(),H=new t(this.proxy,T,N),te=V=>(j,...ie)=>{if(z){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),V(j,...ie))},B=(V,j)=>{const ie=j instanceof Array?j.map(w.TestMessage.from):[w.TestMessage.from(j)];if(V.uri&&V.range){const Q={range:w.Range.from(V.range),uri:V.uri};for(const ue of ie)ue.location=ue.location||Q}this.proxy.$appendTestMessagesInRun(T,N,g.TestId.fromExtHostTestItem(V,U).toString(),ie)};let z=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return H.coverageProvider},set coverageProvider(V){H.coverageProvider=V},enqueued:te(V=>{this.proxy.$updateTestStateInRun(T,N,g.TestId.fromExtHostTestItem(V,U).toString(),1)}),skipped:te(V=>{this.proxy.$updateTestStateInRun(T,N,g.TestId.fromExtHostTestItem(V,U).toString(),5)}),started:te(V=>{this.proxy.$updateTestStateInRun(T,N,g.TestId.fromExtHostTestItem(V,U).toString(),2)}),errored:te((V,j,ie)=>{B(V,j),this.proxy.$updateTestStateInRun(T,N,g.TestId.fromExtHostTestItem(V,U).toString(),6,ie)}),failed:te((V,j,ie)=>{B(V,j),this.proxy.$updateTestStateInRun(T,N,g.TestId.fromExtHostTestItem(V,U).toString(),4,ie)}),passed:te((V,j)=>{this.proxy.$updateTestStateInRun(T,N,g.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,j)}),appendOutput:(V,j,ie)=>{z||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(T,N,n.VSBuffer.fromString(V),j&&w.location.from(j),ie&&g.TestId.fromExtHostTestItem(ie,U).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(T,N),this.tasks.delete(N),this.isRunning||this.dispose())}};return this.tasks.set(N,{run:q,coverage:H}),this.proxy.$startedTestRunTask(T,{id:N,name:F,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof b.TestItemImpl))throw new v.InvalidTestItemError(F.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(F,this.dto.controllerId).toString()))return;const T=[],U=this.dto.colllection.root;for(;;){const N=w.TestItem.from(F);if(T.unshift(N),this.sharedTestIds.has(N.extId)||(this.sharedTestIds.add(N.extId),F===U))break;F=F.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,T)}}class r{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,T,U){return this.getTracker(F,T,U)}cancelRunById(F){for(const T of this.tracked.values())if(T.id===F){T.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,T,U,N,H){const te=this.tracked.get(U);if(te)return te.createRun(N);const B=i.fromPublic(F,T,U,H),z=s(U);this.proxy.$startedExtensionTestRun({controllerId:F,profile:z&&{group:L[z.kind],id:z.profileId},exclude:U.exclude?.map(V=>g.TestId.fromExtHostTestItem(V,T.root.id).toString())??[],id:B.id,include:U.include?.map(V=>g.TestId.fromExtHostTestItem(V,T.root.id).toString())??[T.root.id],persist:H});const q=this.getTracker(U,B);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),q.createRun(N)}getTracker(F,T,U){const N=new h(T,this.proxy,U);return this.tracked.set(F,N),N.onEnd(()=>this.tracked.delete(F)),N}}e.TestRunCoordinator=r;const s=M=>{if(!!M.profile){if(!(M.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class i{constructor(F,T,U,N,H,te){this.controllerId=F,this.id=T,this.isPersisted=H,this.colllection=te,this.includePrefix=U.map(B=>B+"\0"),this.excludePrefix=N.map(B=>B+"\0")}static fromPublic(F,T,U,N){return new i(F,(0,I.generateUuid)(),U.include?.map(H=>g.TestId.fromExtHostTestItem(H,F).toString())??[F],U.exclude?.map(H=>g.TestId.fromExtHostTestItem(H,F).toString())??[],N,T)}static fromInternal(F,T){return new i(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,T)}isIncluded(F){const T=g.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(T===U||T.startsWith(U))return!1;for(const U of this.includePrefix)if(T===U||T.startsWith(U))return!0;return!1}}e.TestRunDto=i;class t{constructor(F,T,U){this.proxy=F,this.runId=T,this.taskId=U}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(T){throw this.fileCoverage=void 0,T}}async resolveFileCoverage(F,T){const U=await this.fileCoverage;let N=U?.[F];return!this._coverageProvider||!U||!N?[]:(N.detailedCoverage||(N=U[F]=await this._coverageProvider.resolveFileCoverage?.(N,T)??N),N.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class o extends f.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,w.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:T,removed:U}=this;return{get added(){return[...F].map(N=>N.revived)},get updated(){return[...T].map(N=>N.revived)},get removed(){return[...U].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,T){return{...F,revived:w.TestItem.toPlain(F.item),depth:T?T.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=l;class d{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(T=>T.revived)},dispose:(0,C.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class y{constructor(F,T,U,N,H,te,B,z=!1,q=void 0){this.controllerId=U,this.profileId=N,this._label=H,this.kind=te,this.runHandler=B,this._isDefault=z,this._tag=q,c.set(this,void 0),m.set(this,void 0),tt(this,c,F,"f"),tt(this,m,T,"f"),T.set(N,this);const V=L[te];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${te}`);Me(this,c,"f").$publishTestRunProfile({profileId:N,controllerId:U,tag:q?w.TestTag.namespace(this.controllerId,q.id):null,label:H,group:V,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?w.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Me(this,m,"f")?.delete(this.profileId)&&(tt(this,m,void 0,"f"),Me(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=y,c=new WeakMap,m=new WeakMap;const L={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(Ie[260],ke([1,0,16,3,5,133,15,7]),function(X,e,u,n,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(R,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new n.Emitter,this._onDidChangeTextEditorOptions=new n.Emitter,this._onDidChangeTextEditorVisibleRanges=new n.Emitter,this._onDidChangeTextEditorViewColumn=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const I=this._extHostDocumentsAndEditors.allEditors();return R?I:I.map(_=>_.value)}async showTextDocument(R,I,_){let P;typeof I=="number"?P={position:C.ViewColumn.from(I),preserveFocus:_}:typeof I=="object"?P={position:C.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?C.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:P={preserveFocus:!1};const b=await this._proxy.$tryShowTextDocument(R.uri,P),w=b&&this._extHostDocumentsAndEditors.getEditor(b);if(w)return w.value;throw b?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,I){return new A.TextEditorDecorationType(this._proxy,R,I).value}$acceptEditorPropertiesChanged(R,I){const _=this._extHostDocumentsAndEditors.getEditor(R);if(!_)throw new Error("unknown text editor");if(I.options&&_._acceptOptions(I.options),I.selections){const P=I.selections.selections.map(C.Selection.to);_._acceptSelections(P)}if(I.visibleRanges){const P=u.coalesce(I.visibleRanges.map(C.Range.to));_._acceptVisibleRanges(P)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...I.options,lineNumbers:C.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const P=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),b=I.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:b,kind:P})}if(I.visibleRanges){const P=u.coalesce(I.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:P})}}$acceptEditorPositionData(R){for(const I in R){const _=this._extHostDocumentsAndEditors.getEditor(I);if(!_)throw new Error("Unknown text editor");const P=C.ViewColumn.to(R[I]);_.value.viewColumn!==P&&(_._acceptViewColumn(P),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:P}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=E}),define(Ie[261],ke([1,0,2,4,5,6,7,15,10]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,n.createDecorator)("IExtHostTimeline");class k{constructor(_,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=_.getProxy(S.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===11){const w=b.uri===void 0?void 0:u.URI.revive(b.uri);return this._itemsBySourceAndUriMap.get(b.source)?.get(R(w))?.get(b.handle)}return b}})}async $getTimeline(_,P,b,w){return this._providers.get(_)?.provideTimeline(u.URI.revive(P),b,w)}registerTimelineProvider(_,P,b,w){const p=new A.DisposableStore,g=this.convertTimelineItem(P.id,w,p).bind(this);let v;P.onDidChange&&(v=P.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:P.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:_,onDidChange:void 0,async provideTimeline(c,m,a){m?.resetCache&&(p.clear(),f.get(P.id)?.clear());const h=await P.provideTimeline(c,m,a);if(h==null)return;const r=g(c,m);return{...h,source:P.id,items:h.items.map(r)}},dispose(){for(const c of f.values())c.get(P.id)?.clear();v?.dispose(),p.dispose()}})}convertTimelineItem(_,P,b){return(w,p)=>{let g;if(p?.cacheResults){let v=this._itemsBySourceAndUriMap.get(_);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(_,v));const f=R(w);g=v.get(f),g===void 0&&(g=new Map,v.set(f,g))}return v=>{const{iconPath:f,...c}=v,m=`${_}|${v.id??v.timestamp}`;g?.set(m,v);let a,h,r;v.iconPath&&(f instanceof C.ThemeIcon?r={id:f.id,color:f.color}:u.URI.isUri(f)?(a=f,h=f):{light:a,dark:h}=f);let s;return C.MarkdownString.isMarkdownString(c.tooltip)?s=D.MarkdownString.from(c.tooltip):(0,E.isString)(c.tooltip)?s=c.tooltip:C.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=D.MarkdownString.from(c.detail)):(0,E.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=c.detail),{...c,id:c.id??void 0,handle:m,source:_,command:v.command?P.toInternal(v.command,b):void 0,icon:a,iconDark:h,themeIcon:r,tooltip:s,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(_){if(this._providers.get(_.id))throw new Error(`Timeline Provider ${_.id} already exists.`);return this._proxy.$registerTimelineProvider({id:_.id,label:_.label,scheme:_.scheme}),this._providers.set(_.id,_),(0,A.toDisposable)(()=>{for(const b of this._itemsBySourceAndUriMap.values())b.get(_.id)?.clear();this._providers.delete(_.id),this._proxy.$unregisterTimelineProvider(_.id),_.dispose()})}}e.ExtHostTimeline=k;function R(I){return I?.toString()}}),define(Ie[262],ke([1,0,6,11,2,5]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(E){this._openers=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,R,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const _=I.schemes.find(P=>!C.supportedSchemes.has(P));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,R),this._proxy.$registerUriOpener(k,I.schemes,E,I.label),(0,u.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,R){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const _=S.URI.revive(k);return I.canOpenExternalUri(_,R)}async $openUri(E,k,R){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},R)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([n.Schemas.http,n.Schemas.https])}),define(Ie[263],ke([1,0,5,2,6,12,28]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(k,R){if(this.handles.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=D.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(k)),this.handlers.set(I,R),this._proxy.$registerUriHandler(I,k),(0,S.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,R){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(n.URI.revive(R))}catch(_){(0,A.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(k){return n.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[70],ke([1,0,3,11,2,189,209,88,5]),function(X,e,u,n,S,A,C,D,E){"use strict";var k,R,I,_,P,b,w,p,g,v,f,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(l,d,y,L,M,F,T){k.set(this,void 0),R.set(this,void 0),I.set(this,void 0),_.set(this,void 0),P.set(this,void 0),b.set(this,void 0),w.set(this,""),p.set(this,void 0),g.set(this,!1),v.set(this,!1),f.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new u.Emitter),this._onDidDispose=Me(this,c,"f").event,tt(this,k,l,"f"),tt(this,R,d,"f"),tt(this,p,y,"f"),tt(this,_,L,"f"),tt(this,P,M,"f"),tt(this,b,F,"f"),tt(this,f,a(F),"f"),tt(this,I,T,"f")}dispose(){tt(this,g,!0,"f"),Me(this,c,"f").fire(),Me(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return tt(this,v,!0,"f"),(0,D.asWebviewUri)(l,Me(this,_,"f"))}get cspSource(){const l=Me(this,b,"f").extensionLocation;if(l.scheme===n.Schemas.https||l.scheme===n.Schemas.http){let d=l.toString();return d.endsWith("/")||(d+="/"),d+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,w,"f")}set html(l){this.assertNotDisposed(),Me(this,w,"f")!==l&&(tt(this,w,l,"f"),!Me(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(tt(this,v,!0,"f"),Me(this,I,"f").report("Webview vscode-resource: uris",Me(this,b,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,R,"f").$setHtml(Me(this,k,"f"),l))}get options(){return this.assertNotDisposed(),Me(this,p,"f")}set options(l){this.assertNotDisposed(),Me(this,R,"f").$setOptions(Me(this,k,"f"),s(Me(this,b,"f"),Me(this,P,"f"),l)),tt(this,p,l,"f")}async postMessage(l){if(Me(this,g,"f"))return!1;const d=(0,C.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:Me(this,f,"f")});return Me(this,R,"f").$postMessage(Me(this,k,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Me(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,k=new WeakMap,R=new WeakMap,I=new WeakMap,_=new WeakMap,P=new WeakMap,b=new WeakMap,w=new WeakMap,p=new WeakMap,g=new WeakMap,v=new WeakMap,f=new WeakMap,c=new WeakMap;function a(o){try{const l=(0,A.normalizeVersion)((0,A.parseVersion)(o.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class h{constructor(l,d,y,L,M){this.remoteInfo=d,this.workspace=y,this._logService=L,this._deprecationService=M,this._webviews=new Map,this._webviewProxy=l.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(l,d,y){const L=this.getWebview(l);if(L){const{message:M}=(0,C.deserializeWebviewMessage)(d,y.value);L._onMessageEmitter.fire(M)}}$onMissingCsp(l,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,d,y){const L=new m(l,this._webviewProxy,i(d),this.remoteInfo,this.workspace,y,this._deprecationService);return this._webviews.set(l,L),L._onDidDispose(()=>{this._webviews.delete(l)}),L}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=h;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=r;function s(o,l,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||t(o,l)}}e.serializeWebviewOptions=s;function i(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(l=>S.URI.from(l))}}e.reviveOptions=i;function t(o,l){return[...(l?.getWorkspaceFolders()||[]).map(d=>d.uri),o.extensionLocation]}}),define(Ie[264],ke([1,0,21,60,6,11,22,2,15,70,87,5,7]),function(X,e,u,n,S,A,C,D,E,k,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class P{constructor(a,h){this.document=a,this._storagePath=h,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,h){await this.getEdit(a).undo(),h||this.disposeBackup()}async redo(a,h){await this.getEdit(a).redo(),h||this.disposeBackup()}disposeEdits(a){for(const h of a)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=c(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const h=this._edits.get(a,0);if(!h)throw new Error("No edit found");return h}}class b{constructor(){this._documents=new Map}get(a,h){return this._documents.get(this.key(a,h))}add(a,h,r){const s=this.key(a,h.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${a} resource:${h.uri}`);const i=new P(h,r);return this._documents.set(s,i),i}delete(a,h){const r=this.key(a,h.uri);this._documents.delete(r)}key(a,h){return`${a}@@@${h}`}}var w;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(w||(w={}));class p{constructor(){this._providers=new Map}addTextProvider(a,h,r){return this.add(0,a,h,r)}addCustomProvider(a,h,r){return this.add(1,a,h,r)}get(a){return this._providers.get(a)}add(a,h,r,s){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:a,extension:r,provider:s}),new _.Disposable(()=>this._providers.delete(h))}}class g{constructor(a,h,r,s,i){this._extHostDocuments=h,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=i,this._editorProviders=new p,this._documents=new b,this._proxy=a.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,h,r,s){const i=new S.DisposableStore;return v(r)?(i.add(this._editorProviders.addTextProvider(h,a,r)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(a),h,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(a))):(i.add(this._editorProviders.addCustomProvider(h,a,r)),this.supportEditing(r)&&i.add(r.onDidChangeCustomDocument(t=>{const o=this.getCustomDocumentEntry(h,t.document.uri);if(f(t)){const l=o.addEdit(t);this._proxy.$onDidEdit(t.document.uri,h,l,t.label)}else this._proxy.$onContentChange(t.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(a),h,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(a))),_.Disposable.from(i,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(a,h,r,s,i){const t=this._editorProviders.get(h);if(!t)throw new Error(`No provider found for '${h}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${h}'`);const o=D.URI.revive(a),l=await t.provider.openCustomDocument(o,{backupId:r,untitledDocumentData:s?.buffer},i);let d;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(h,l,d),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(a,h){const r=this._editorProviders.get(h);if(!r)throw new Error(`No provider found for '${h}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${h}'`);const s=D.URI.revive(a),{document:i}=this.getCustomDocumentEntry(h,s);this._documents.delete(h,i),i.dispose()}async $resolveWebviewEditor(a,h,r,s,i,t){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);const l=E.ViewColumn.to(i),d=this._extHostWebview.createNewWebview(h,s.webviewOptions,o.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(h,r,s.title,l,s.panelOptions,d,!0),L=D.URI.revive(a);switch(o.type){case 1:{const{document:M}=this.getCustomDocumentEntry(r,L);return o.provider.resolveCustomEditor(M,y,t)}case 0:{const M=this._extHostDocuments.getDocument(L);return o.provider.resolveCustomTextEditor(M,y,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,h,r){this.getCustomDocumentEntry(h,a).disposeEdits(r)}async $onMoveCustomEditor(a,h,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const i=this._extHostWebviewPanels.getWebviewPanel(a);if(!i)throw new Error("No webview found");const t=D.URI.revive(h),o=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(o,i,u.CancellationToken.None)}async $undo(a,h,r,s){return this.getCustomDocumentEntry(h,a).undo(r,s)}async $redo(a,h,r,s){return this.getCustomDocumentEntry(h,a).redo(r,s)}async $revert(a,h,r){const s=this.getCustomDocumentEntry(h,a);await this.getCustomEditorProvider(h).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(a,h,r){const s=this.getCustomDocumentEntry(h,a);await this.getCustomEditorProvider(h).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(a,h,r,s){const i=this.getCustomDocumentEntry(h,a);return this.getCustomEditorProvider(h).saveCustomDocumentAs(i.document,D.URI.revive(r),s)}async $backup(a,h,r){const s=this.getCustomDocumentEntry(h,a),t=await this.getCustomEditorProvider(h).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(t),t.id}getCustomDocumentEntry(a,h){const r=this._documents.get(a,D.URI.revive(h));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(a){const r=this._editorProviders.get(a)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function v(m){return typeof m.resolveCustomTextEditor=="function"}function f(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const a=m.scheme===A.Schemas.file||m.scheme===A.Schemas.untitled?m.fsPath:m.toString();return(0,n.hash)(a)+""}});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[265],ke([1,0,3,6,2,34,15,70,5,7]),function(X,e,u,n,S,A,C,D,E,k){"use strict";var R,I,_,P,b,w,p,g,v,f,c,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends n.Disposable{constructor(t,o,l,d){super();R.set(this,void 0),I.set(this,void 0),_.set(this,void 0),P.set(this,void 0),b.set(this,void 0),w.set(this,void 0),p.set(this,void 0),g.set(this,void 0),v.set(this,!0),f.set(this,void 0),c.set(this,!1),m.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,m,"f").event,a.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Me(this,a,"f").event,tt(this,R,t,"f"),tt(this,I,o,"f"),tt(this,P,l,"f"),tt(this,_,d.viewType,"f"),tt(this,b,d.panelOptions,"f"),tt(this,g,d.viewColumn,"f"),tt(this,w,d.title,"f"),tt(this,f,d.active,"f")}dispose(){Me(this,c,"f")||(tt(this,c,!0,"f"),Me(this,m,"f").fire(),Me(this,I,"f").$disposeWebview(Me(this,R,"f")),Me(this,P,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,P,"f")}get viewType(){return this.assertNotDisposed(),Me(this,_,"f")}get title(){return this.assertNotDisposed(),Me(this,w,"f")}set title(t){this.assertNotDisposed(),Me(this,w,"f")!==t&&(tt(this,w,t,"f"),Me(this,I,"f").$setTitle(Me(this,R,"f"),t))}get iconPath(){return this.assertNotDisposed(),Me(this,p,"f")}set iconPath(t){this.assertNotDisposed(),Me(this,p,"f")!==t&&(tt(this,p,t,"f"),Me(this,I,"f").$setIconPath(Me(this,R,"f"),S.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Me(this,b,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,g,"f")=="number"&&Me(this,g,"f")<0))return Me(this,g,"f")}get active(){return this.assertNotDisposed(),Me(this,f,"f")}get visible(){return this.assertNotDisposed(),Me(this,v,"f")}_updateViewState(t){Me(this,c,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(tt(this,f,t.active,"f"),tt(this,v,t.visible,"f"),tt(this,g,t.viewColumn,"f"),Me(this,a,"f").fire({webviewPanel:this}))}reveal(t,o){this.assertNotDisposed(),Me(this,I,"f").$reveal(Me(this,R,"f"),{viewColumn:typeof t=="undefined"?void 0:C.ViewColumn.from(t),preserveFocus:!!o})}assertNotDisposed(){if(Me(this,c,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,I=new WeakMap,_=new WeakMap,P=new WeakMap,b=new WeakMap,w=new WeakMap,p=new WeakMap,g=new WeakMap,v=new WeakMap,f=new WeakMap,c=new WeakMap,m=new WeakMap,a=new WeakMap;class r{constructor(t,o,l){this.webviews=o,this.workspace=l,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(t,o,l,d,y={}){const L=typeof d=="object"?d.viewColumn:d,M={viewColumn:C.ViewColumn.from(L),preserveFocus:typeof d=="object"&&!!d.preserveFocus},F=(0,D.shouldSerializeBuffersForPostMessage)(t),T=r.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(t),T,o,{title:l,panelOptions:s(y),webviewOptions:(0,D.serializeWebviewOptions)(t,this.workspace,y),serializeBuffersForPostMessage:F},M);const U=this.webviews.createNewWebview(T,y,t);return this.createNewWebviewPanel(T,o,l,L,y,U,!0)}$onDidChangeWebviewPanelViewStates(t){const o=Object.keys(t);o.sort((l,d)=>{const y=t[l],L=t[d];return y.active?1:L.active?-1:+y.visible-+L.visible});for(const l of o){const d=this.getWebviewPanel(l);if(!d)continue;const y=t[l];d._updateViewState({active:y.active,visible:y.visible,viewColumn:C.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,o,l){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:l,extension:t}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new k.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(t,o,l,d){const y=this._serializers.get(o);if(!y)throw new Error(`No serializer found for '${o}'`);const{serializer:L,extension:M}=y,F=this.webviews.createNewWebview(t,l.webviewOptions,M),T=this.createNewWebviewPanel(t,o,l.title,d,l.panelOptions,F,l.active);await L.deserializeWebviewPanel(T,l.state)}createNewWebviewPanel(t,o,l,d,y,L,M){const F=new h(t,this._proxy,L,{viewType:o,title:l,viewColumn:d,panelOptions:y,active:M});return this._webviewPanels.set(t,F),F}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function s(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[266],ke([1,0,3,6,70,27,15,5,7]),function(X,e,u,n,S,A,C,D,E){"use strict";var k,R,I,_,P,b,w,p,g,v,f,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends n.Disposable{constructor(r,s,i,t,o,l,d){super();k.set(this,void 0),R.set(this,void 0),I.set(this,void 0),_.set(this,void 0),P.set(this,void 0),b.set(this,!1),w.set(this,void 0),p.set(this,void 0),g.set(this,void 0),v.set(this,void 0),f.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Me(this,f,"f").event,c.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,c,"f").event,tt(this,I,i,"f"),tt(this,p,t,"f"),tt(this,k,r,"f"),tt(this,R,s,"f"),tt(this,_,o,"f"),tt(this,P,l,"f"),tt(this,w,d,"f")}dispose(){Me(this,b,"f")||(tt(this,b,!0,"f"),Me(this,c,"f").fire(),Me(this,_,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,p,"f")}set title(r){this.assertNotDisposed(),Me(this,p,"f")!==r&&(tt(this,p,r,"f"),Me(this,R,"f").$setWebviewViewTitle(Me(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Me(this,g,"f")}set description(r){this.assertNotDisposed(),Me(this,g,"f")!==r&&(tt(this,g,r,"f"),Me(this,R,"f").$setWebviewViewDescription(Me(this,k,"f"),r))}get visible(){return Me(this,w,"f")}get webview(){return Me(this,_,"f")}get viewType(){return Me(this,I,"f")}_setVisible(r){r===Me(this,w,"f")||Me(this,b,"f")||(tt(this,w,r,"f"),Me(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Me(this,P,"f"),"badges"),Me(this,v,"f")}set badge(r){this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Me(this,P,"f"),"badges"),!(r?.value===Me(this,v,"f")?.value&&r?.tooltip===Me(this,v,"f")?.tooltip)&&(tt(this,v,C.ViewBadge.from(r),"f"),Me(this,R,"f").$setWebviewViewBadge(Me(this,k,"f"),r))}show(r){this.assertNotDisposed(),Me(this,R,"f").$show(Me(this,k,"f"),!!r)}assertNotDisposed(){if(Me(this,b,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,R=new WeakMap,I=new WeakMap,_=new WeakMap,P=new WeakMap,b=new WeakMap,w=new WeakMap,p=new WeakMap,g=new WeakMap,v=new WeakMap,f=new WeakMap,c=new WeakMap;class a{constructor(r,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,s,i,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:i,extension:r}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(r),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(r)}),new E.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(r,s,i,t,o){const l=this._viewProviders.get(s);if(!l)throw new Error(`No view provider found for '${s}'`);const{provider:d,extension:y}=l,L=this._extHostWebview.createNewWebview(r,{},y),M=new m(r,this._proxy,s,i,L,y,!0);this._webviewViews.set(r,M),await d.resolveWebviewView(M,{state:t},o)}async $onDidChangeWebviewViewVisibility(r,s){this.getWebviewView(r)._setVisible(s)}async $disposeWebviewView(r){const s=this.getWebviewView(r);this._webviewViews.delete(r),s.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const s=this._webviewViews.get(r);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=a}),define(Ie[137],ke([1,0,3,5,2,11,8,4,17]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Yn{constructor(I){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yn.InitialState,this._proxy=I.getProxy(n.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,_){let P;if(typeof I=="string"){P=I;try{I=S.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,C.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,P,_)}async asExternalUri(I,_){if((0,C.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const P=await this._proxy.$asExternalUri(I,_);return S.URI.from(P)}};k.InitialState={focused:!0},k=Ge([He(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(Ie[267],ke([1,0,112,268,62,37,2,14,45]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(_,P,b){this._commands=_,this.logService=P,this._ipcHandlePath=b,this._server=n.createServer((w,p)=>this.onRequest(w,p)),this.setup().catch(w=>(P.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",_=>this.logService.error(_))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(_,P){const b=(p,g)=>{P.writeHead(p,{"content-type":"application/json"}),P.end(JSON.stringify(g||null),v=>v&&this.logService.error(v))},w=[];_.setEncoding("utf8"),_.on("data",p=>w.push(p)),_.on("end",async()=>{try{const p=JSON.parse(w.join(""));let g;switch(p.type){case"open":g=await this.open(p);break;case"openExternal":g=await this.openExternal(p);break;case"status":g=await this.getStatus(p);break;case"extensionManagement":g=await this.manageExtensions(p);break;default:b(404,`Unknown message type: ${p.type}`);break}b(200,g)}catch(p){const g=p instanceof Error?p.message:JSON.stringify(p);b(500,g),this.logService.error("Error while processing pipe request",p)}})}async open(_){const{fileURIs:P,folderURIs:b,forceNewWindow:w,diffMode:p,addMode:g,forceReuseWindow:v,gotoLineMode:f,waitMarkerFilePath:c,remoteAuthority:m}=_,a=[];if(Array.isArray(b))for(const i of b)try{a.push({folderUri:C.URI.parse(i)})}catch{}if(Array.isArray(P))for(const i of P)try{(0,E.hasWorkspaceFileExtension)(i)?a.push({workspaceUri:C.URI.parse(i)}):a.push({fileUri:C.URI.parse(i)})}catch{}const h=c?C.URI.file(c):void 0,s={forceNewWindow:w,diffMode:p,addMode:g,gotoLineMode:f,forceReuseWindow:v,preferNewWindow:!v&&!h&&!g,waitMarkerFileURI:h,remoteAuthority:m};return this._commands.executeCommand("_remoteCLI.windowOpen",a,s),""}async openExternal(_){for(const P of _.uris){const b=C.URI.parse(P),w=b.scheme==="file"?b:P;await this._commands.executeCommand("_remoteCLI.openExternal",w)}}async manageExtensions(_){const P=w=>w?.map(p=>/\.vsix$/i.test(p)?C.URI.parse(p):p),b={list:_.list,install:P(_.install),uninstall:P(_.uninstall),force:_.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",b)}async getStatus(_){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&S.existsSync(this._ipcHandlePath)&&S.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let R=class extends k{constructor(_,P){super(_,P,(0,u.createRandomIPCHandle)())}};R=Ge([He(0,A.IExtHostCommands),He(1,D.ILogService)],R),e.CLIServer=R}),define(Ie[269],ke([1,0,241,26,17]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let C=class extends u.AbstractExtHostConsoleForwarder{constructor(E,k){super(E,k);this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(E,k,R){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),k.apply(console,R),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(E,k){const R=process[E],I=R.write;let _="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(P,b,w)=>{if(!this._isMakingConsoleCall){_+=P.toString(b);const p=_.length>A?_.length:_.lastIndexOf(`
`);p!==-1&&(console[k](_.slice(0,p)),_=_.slice(p+1))}I.call(R,P,b,w)}})}};C=Ge([He(0,S.IExtHostRpcService),He(1,n.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(Ie[270],ke([1,0,9,81,34,37,6,5,2,17]),function(X,e,u,n,S,A,C,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends C.Disposable{constructor(_,P){super();const b=_.getProxy(D.MainContext.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async w=>{const p=E.URI.file((0,u.join)((0,n.tmpdir)(),(0,S.generateUuid)()));return await b.$download(w,p),p})}};R=Ge([He(0,k.IExtHostRpcService),He(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Ie[271],ke([1,0,136,11,195,34]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends u.ExtHostLoggerService{doCreateLogger(E,k,R){return E.scheme===n.Schemas.file?new S.SpdLogLogger(R?.name||(0,A.generateUuid)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,k):super.doCreateLogger(E,k,R)}}e.ExtHostLoggerService=C}),define(Ie[272],ke([1,0,62,9,2,69,6,11,18,29]),function(X,e,u,n,S,A,C,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const h=await super._getWorkspaceStorageURI(a);if(h.scheme!==D.Schemas.file)return h;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const r=h.fsPath;let s=0;do{let i;s===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await I(i);const t=n.join(i,"vscode.lock"),o=await w(this._logService,t,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),S.URI.file(i);s++}while(s<10);return h}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function I(m){try{await k.Promises.stat(m);return}catch{}try{await k.Promises.mkdir(m,{recursive:!0})}catch{}}const _=1e3,P=10*60*1e3;class b extends C.Disposable{constructor(a,h){super();this.logService=a,this.filename=h,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await p(a,h);(!r||r.pid!==process.pid)&&(a.info(`Lock '${h}': The lock was lost unexpectedly.`),this._timer.cancel());try{await k.Promises.utimes(h,new Date,new Date)}catch(s){a.error(s),a.info(`Lock '${h}': Could not update mtime.`)}},_)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+a};await k.Promises.writeFile(this.filename,JSON.stringify(h),{flag:"w"})}catch(h){this.logService.error(h)}}}async function w(m,a,h){try{const s={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(a,JSON.stringify(s),{flag:"wx"})}catch(s){m.error(s)}const r=await p(m,a);return!r||r.pid!==process.pid?h?(m.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),f(m,a)):(m.info(`Lock '${a}': Lock acquired.`),new b(m,a))}async function p(m,a){let h;try{h=await k.Promises.readFile(a)}catch(r){return m.error(r),null}try{return JSON.parse(String(h))}catch(r){return m.error(r),null}}async function g(m,a){let h;try{h=await k.Promises.stat(a)}catch(r){return m.error(r),0}return h.mtime.getTime()}function v(m){try{return process.kill(m,0),!0}catch{return!1}}async function f(m,a){const h=await p(m,a);if(!h)return m.info(`Lock '${a}': Could not read pid of lock holder.`),c(m,a);if(h.willReleaseAt){let o=h.willReleaseAt-Date.now();if(o<5e3){for(o>0?m.info(`Lock '${a}': The lockfile is scheduled to be released in ${o} ms.`):m.info(`Lock '${a}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,E.timeout)(Math.min(100,o)),await g(m,a)===0)return c(m,a);o=h.willReleaseAt-Date.now()}return c(m,a)}}if(!v(h.pid))return m.info(`Lock '${a}': The pid ${h.pid} appears to be gone.`),c(m,a);const r=await g(m,a),s=Date.now()-r;if(s<=P)return m.info(`Lock '${a}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;m.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const i=await g(m,a),t=Date.now()-i;return t<=P?(m.info(`Lock '${a}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(m.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),c(m,a))}async function c(m,a){m.info(`Lock '${a}': Deleting a stale lock.`);try{await k.Promises.unlink(a)}catch{}return w(m,a,!0)}}),define(Ie[273],ke([1,0,34,17,38]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends S.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,E,k){return this.createTerminalFromOptions({name:D,shellPath:E,shellArgs:k})}createTerminalFromOptions(D,E){const k=new S.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),D,D.name);return this._terminals.push(k),k.create(D,this._serializeParentTerminal(D,E)),k.value}};A=Ge([He(0,n.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Ie[274],ke([1,0,5,17,178,6,26,2,42,22,29,7,13,52,3,124,94,14]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends w.DisposableTunnel{}function f(o){const l=o.trim().split(`
`),d=[];return l.forEach(L=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);M&&M.length>=3&&d.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),d.reduce((L,M)=>(L[M.socket]=M,L),{})}e.getSockets=f;function c(...o){const l=[].concat(...o.map(a));return[...new Map(l.filter(d=>d.st==="0A").map(d=>{const y=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:m(y[0]),port:parseInt(y[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=c;function m(o){let l="";if(o.length===8)for(let d=o.length-2;d>=0;d-=2)l+=parseInt(o.substr(d,2),16),d!==0&&(l+=".");else for(let d=o.length-4;d>=0;d-=4)l+=parseInt(o.substr(d,4),16).toString(16),d!==0&&(l+=":");return l}e.parseIpAddress=m;function a(o){const l=o.trim().split(`
`),d=l.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return l.map(L=>L.trim().split(/\s+/).reduce((M,F,T)=>(M[d[T]||T]=F,M),{}))}e.loadConnectionTable=a;function h(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/server-main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function r(o){const l=o.trim().split(`
`),d=[];return l.forEach(y=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);L&&L.length>=4&&d.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),d}e.getRootProcesses=r;async function s(o,l,d){const y=d.reduce((M,F)=>(M[F.pid]=F,M),{}),L=[];return o.forEach(({socket:M,ip:F,port:T})=>{const U=l[M]?l[M].pid:void 0,N=U?y[U]?.cmd:void 0;U&&N&&!h(N)&&L.push({host:F,port:T,detail:N,pid:U})}),L}e.findPorts=s;function i(o,l,d){const y=new Map,L=r(l);for(const M of o){const F=d.get(M.port);if(F){y.set(M.port,F);continue}const T=L.find(U=>U.cmd.includes(`${M.port}`));if(T){let U=T,N;do N=L.find(H=>H.ppid===U.pid),N&&(U=N);while(N);y.set(M.port,{host:M.ip,port:M.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else y.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=i;let t=class extends A.Disposable{constructor(l,d,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new b.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(u.MainContext.MainThreadTunnelService),_.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(l,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(d,l.displayName);if(y){const L=new v(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(L),L}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(l){return Math.max(l*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,d){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:l,provider:d}),this._proxy.$registerPortsAttributesProvider(l,y),new I.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(l,d,y,L,M){const F=[];for(const U of l){const N=this._portAttributesProviders.get(U);if(!N)return[];F.push(...await Promise.all(d.map(async H=>N.provider.providePortAttributes(H,y,L,M))))}const T=F.filter(U=>!!U);return T.length>0?T.map(U=>({autoForwardAction:U.autoForwardAction,port:U.port})):[]}async $registerCandidateFinder(l){if(l&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=l;const d=new p.MovingAverage;let y;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),M=(await this.findCandidatePorts()).filter(T=>(0,w.isLocalhost)(T.host)||(0,w.isAllInterfaces)(T.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(T=>T.port).join(", ")}`);const F=new Date().getTime()-L;d.update(F),(!y||JSON.stringify(y)!==JSON.stringify(M))&&(y=M,await this._proxy.$onFoundNewCandidates(y)),await new Promise(T=>setTimeout(()=>T(),this.calculateDelay(d.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,this._proxy.$setCandidateFilter()),l.tunnelFactory){this._forwardPortProvider=l.tunnelFactory;let d=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:S.localize(0,null),themeIcon:"lock"},{id:"public",label:S.localize(1,null),themeIcon:"eye"}]);const y=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:d}:void 0;this._proxy.$setTunnelProvider(y)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(l,d){if(this._extensionTunnels.has(l.host)){const y=this._extensionTunnels.get(l.host);y.has(l.port)&&(d&&y.get(l.port).disposeListener.dispose(),await y.get(l.port).tunnel.dispose(),y.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(l,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const L=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const M=this._register(L.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(L.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:L,disposeListener:M}),P.TunnelDtoConverter.fromApiTunnel(L)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const d=await Promise.all(l.map(L=>this._showCandidatePort(L.host,L.port,L.detail??""))),y=l.filter((L,M)=>d[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(L=>L.port).join(", ")} to ${y.map(L=>L.port).join(", ")}`),y}async findCandidatePorts(){let l="",d="";try{l=await R.Promises.readFile("/proc/net/tcp","utf8"),d=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const y=c(l,d),L=await new Promise(B=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,q,V)=>{B(q)})}),M=f(L),F=await R.Promises.readdir("/proc"),T=[];for(const B of F)try{const z=Number(B),q=k.joinPath(D.URI.file("/proc"),B);if((await R.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(z)){const j=await R.Promises.readlink(k.joinPath(q,"cwd").fsPath),ie=await R.Promises.readFile(k.joinPath(q,"cmdline").fsPath,"utf8");T.push({pid:z,cwd:j,cmd:ie})}}catch{}const U=[],N=y.filter(B=>{const z=M[B.socket];return z||U.push(B),z}),H=s(N,M,T);let te;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const B=await new Promise(z=>{(0,E.exec)("ps -F -A -l | grep root",(q,V,j)=>{z(V)})});this._foundRootPorts=i(U,B,this._foundRootPorts),te=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.join(", ")}`)}return H.then(B=>te?B.concat(te):B)}};t=Ge([He(0,n.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,g.ILogService)],t),e.ExtHostTunnelService=t}),define(Ie[275],ke([1,0,18,23,21,12,3,6,108,235,53]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function _(y,L){try{return JSON.stringify(y,L)}catch{return"null"}}const P="$$ref$$",b={[P]:-1};class w{constructor(L,M){this.jsonString=L,this.referencedBuffers=M}}function p(y,L=null,M=!1){const F=[];return{jsonString:(M?_:JSON.stringify)(y,(U,N)=>{if(typeof N=="undefined")return b;if(typeof N=="object"){if(N instanceof n.VSBuffer){const H=F.push(N)-1;return{[P]:H}}if(L)return L(U,N)}return N}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=p;function g(y,L,M){return JSON.parse(y,(F,T)=>{if(T){const U=T[P];if(typeof U=="number")return L[U];if(M&&T.$mid===1)return M.transformIncoming(T)}return T})}e.parseJsonAndRestoreBufferRefs=g;function v(y,L){return JSON.stringify(y,L)}function f(y){return y?(L,M)=>M&&M.$mid===1?y.transformOutgoing(M):M:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends D.Disposable{constructor(L,M=null,F=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=M,this._uriTransformer=F,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let T=0,U=R.ProxyIdentifier.count;T<U;T++)this._locals[T]=null,this._proxies[T]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(T=>this._receiveOneMessage(T))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,E.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:M,sid:F}=L;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,F)),this._proxies[M]}_createProxy(L,M){const F={get:(T,U)=>(typeof U=="string"&&!T[U]&&U.charCodeAt(0)===36&&(T[U]=(...N)=>this._remoteCall(L,U,N)),U===r?M:T[U])};return new Proxy(Object.create(null),F)}set(L,M){return this._locals[L.nid]=M,M}assertRegistered(L){for(let M=0,F=L.length;M<F;M++){const T=L[M];if(!this._locals[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const M=L.byteLength,F=i.read(L,0),T=F.readUInt8(),U=F.readUInt32();switch(T){case 1:case 2:{let{rpcId:N,method:H,args:te}=o.deserializeRequestJSONArgs(F);this._uriTransformer&&(te=(0,E.transformIncomingURIs)(te,this._uriTransformer)),this._receiveRequest(M,U,N,H,te,T===2);break}case 3:case 4:{let{rpcId:N,method:H,args:te}=o.deserializeRequestMixedArgs(F);this._uriTransformer&&(te=(0,E.transformIncomingURIs)(te,this._uriTransformer)),this._receiveRequest(M,U,N,H,te,T===4);break}case 5:{this._logger?.logIncoming(M,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(M,U);break}case 7:{this._receiveReply(M,U,void 0);break}case 9:{let N=o.deserializeReplyOKJSON(F);this._uriTransformer&&(N=(0,E.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(M,U,N);break}case 10:{const N=o.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(M,U,N);break}case 8:{const N=o.deserializeReplyOKVSBuffer(F);this._receiveReply(M,U,N);break}case 11:{let N=o.deserializeReplyErrError(F);this._uriTransformer&&(N=(0,E.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(M,U,N);break}case 12:{this._receiveReplyErr(M,U,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,M,F,T,U,N){this._logger?.logIncoming(L,M,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(F)}.${T}(`,U);const H=String(M);let te,B;if(N){const q=new S.CancellationTokenSource;U.push(q.token),te=this._invokeHandler(F,T,U),B=()=>q.cancel()}else te=this._invokeHandler(F,T,U),B=a;this._cancelInvokedHandlers[H]=B;const z=o.serializeAcknowledged(M);this._logger?.logOutgoing(z.byteLength,M,1,"ack"),this._protocol.send(z),te.then(q=>{delete this._cancelInvokedHandlers[H];const V=o.serializeReplyOK(M,q,this._uriReplacer);this._logger?.logOutgoing(V.byteLength,M,1,"reply:",q),this._protocol.send(V)},q=>{delete this._cancelInvokedHandlers[H];const V=o.serializeReplyErr(M,q);this._logger?.logOutgoing(V.byteLength,M,1,"replyErr:",q),this._protocol.send(V)})}_receiveCancel(L,M){this._logger?.logIncoming(L,M,1,"receiveCancel");const F=String(M);this._cancelInvokedHandlers[F]?.()}_receiveReply(L,M,F){this._logger?.logIncoming(L,M,0,"receiveReply:",F);const T=String(M);if(!this._pendingRPCReplies.hasOwnProperty(T))return;const U=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],U.resolveOk(F)}_receiveReplyErr(L,M,F){this._logger?.logIncoming(L,M,0,"receiveReplyErr:",F);const T=String(M);if(!this._pendingRPCReplies.hasOwnProperty(T))return;const U=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T];let N;F&&(F.$isError?(N=new Error,N.name=F.name,N.message=F.message,N.stack=F.stack):N=F),U.resolveErr(N)}_invokeHandler(L,M,F){try{return Promise.resolve(this._doInvokeHandler(L,M,F))}catch(T){return Promise.reject(T)}}_doInvokeHandler(L,M,F){const T=this._locals[L];if(!T)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const U=T[M];if(typeof U!="function")throw new Error("Unknown method "+M+" on actor "+(0,R.getStringIdentifierForProxy)(L));return U.apply(T,F)}_remoteCall(L,M,F){if(this._isDisposed)return new k.CanceledLazyPromise;let T=null;if(F.length>0&&S.CancellationToken.isCancellationToken(F[F.length-1])&&(T=F.pop()),T&&T.isCancellationRequested)return Promise.reject(A.canceled());const U=o.serializeRequestArguments(F,this._uriReplacer),N=++this._lastMessageId,H=String(N),te=new k.LazyPromise;T&&T.onCancellationRequested(()=>{const z=o.serializeCancel(N);this._logger?.logOutgoing(z.byteLength,N,0,"cancel"),this._protocol.send(o.serializeCancel(N))}),this._pendingRPCReplies[H]=te,this._onWillSendRequest(N);const B=o.serializeRequest(N,L,M,U,!!T);return this._logger?.logOutgoing(B.byteLength,N,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${M}(`,F),this._protocol.send(B),te}}e.RPCProtocol=s,I=h,s.UNRESPONSIVE_TIME=3*1e3;class i{constructor(L,M){this._buff=L,this._offset=M}static alloc(L,M,F){const T=new i(n.VSBuffer.alloc(F+1+4),0);return T.writeUInt8(L),T.writeUInt32(M),T}static read(L,M){return new i(L,M)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,F}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,F}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,M}static sizeMixedArray(L){let M=0;M+=1;for(let F=0,T=L.length;F<T;F++){const U=L[F];switch(M+=1,U.type){case 1:M+=this.sizeLongString(U.value);break;case 2:M+=this.sizeVSBuffer(U.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(U.value);for(let N=0;N<U.buffers.length;++N)M+=this.sizeVSBuffer(U.buffers[N]);break;case 4:break}}return M}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let M=0,F=L.length;M<F;M++){const T=L[M];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let U=0;U<T.buffers.length;++U)this.writeBuffer(T.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(L);for(let F=0;F<L;F++)switch(this.readUInt8()){case 1:M[F]=this.readLongString();break;case 2:M[F]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),N=this.readLongString(),H=[];for(let te=0;te<U;++te)H.push(this.readVSBuffer());M[F]=new R.SerializableObjectWithBuffers(g(N,H,null));break}case 4:M[F]=void 0;break}return M}}i.sizeUInt32=4;var t;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(t||(t={}));class o{static _useMixedArgSerialization(L){for(let M=0,F=L.length;M<F;M++)if(L[M]instanceof n.VSBuffer||L[M]instanceof R.SerializableObjectWithBuffers||typeof L[M]=="undefined")return!0;return!1}static serializeRequestArguments(L,M){if(this._useMixedArgSerialization(L)){const F=[];for(let T=0,U=L.length;T<U;T++){const N=L[T];if(N instanceof n.VSBuffer)F[T]={type:2,value:N};else if(typeof N=="undefined")F[T]={type:4};else if(N instanceof R.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:te}=p(N.value,M);F[T]={type:3,value:n.VSBuffer.fromString(H),buffers:te}}else F[T]={type:1,value:n.VSBuffer.fromString(v(N,M))}}return{type:1,args:F}}return{type:0,args:v(L,M)}}static serializeRequest(L,M,F,T,U){switch(T.type){case 0:return this._requestJSONArgs(L,M,F,T.args,U);case 1:return this._requestMixedArgs(L,M,F,T.args,U)}}static _requestJSONArgs(L,M,F,T,U){const N=n.VSBuffer.fromString(F),H=n.VSBuffer.fromString(T);let te=0;te+=i.sizeUInt8(),te+=i.sizeShortString(N),te+=i.sizeLongString(H);const B=i.alloc(U?2:1,L,te);return B.writeUInt8(M),B.writeShortString(N),B.writeLongString(H),B.buffer}static deserializeRequestJSONArgs(L){const M=L.readUInt8(),F=L.readShortString(),T=L.readLongString();return{rpcId:M,method:F,args:JSON.parse(T)}}static _requestMixedArgs(L,M,F,T,U){const N=n.VSBuffer.fromString(F);let H=0;H+=i.sizeUInt8(),H+=i.sizeShortString(N),H+=i.sizeMixedArray(T);const te=i.alloc(U?4:3,L,H);return te.writeUInt8(M),te.writeShortString(N),te.writeMixedArray(T),te.buffer}static deserializeRequestMixedArgs(L){const M=L.readUInt8(),F=L.readShortString(),T=L.readMixedArray(),U=new Array(T.length);for(let N=0,H=T.length;N<H;N++){const te=T[N];typeof te=="string"?U[N]=JSON.parse(te):U[N]=te}return{rpcId:M,method:F,args:U}}static serializeAcknowledged(L){return i.alloc(5,L,0).buffer}static serializeCancel(L){return i.alloc(6,L,0).buffer}static serializeReplyOK(L,M,F){if(typeof M=="undefined")return this._serializeReplyOKEmpty(L);if(M instanceof n.VSBuffer)return this._serializeReplyOKVSBuffer(L,M);if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:U}=p(M.value,F,!0);return this._serializeReplyOKJSONWithBuffers(L,T,U)}else return this._serializeReplyOKJSON(L,_(M,F))}static _serializeReplyOKEmpty(L){return i.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,M){let F=0;F+=i.sizeVSBuffer(M);const T=i.alloc(8,L,F);return T.writeVSBuffer(M),T.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,M){const F=n.VSBuffer.fromString(M);let T=0;T+=i.sizeLongString(F);const U=i.alloc(9,L,T);return U.writeLongString(F),U.buffer}static _serializeReplyOKJSONWithBuffers(L,M,F){const T=n.VSBuffer.fromString(M);let U=0;U+=i.sizeUInt32,U+=i.sizeLongString(T);for(const H of F)U+=i.sizeVSBuffer(H);const N=i.alloc(10,L,U);N.writeUInt32(F.length),N.writeLongString(T);for(const H of F)N.writeBuffer(H);return N.buffer}static deserializeReplyOKJSON(L){const M=L.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(L,M){const F=L.readUInt32(),T=L.readLongString(),U=[];for(let N=0;N<F;++N)U.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(g(T,U,M))}static serializeReplyErr(L,M){const F=M?_(A.transformErrorForSerialization(M),null):void 0;if(typeof F!="string")return this._serializeReplyErrEmpty(L);const T=n.VSBuffer.fromString(F);let U=0;U+=i.sizeLongString(T);const N=i.alloc(11,L,U);return N.writeLongString(T),N.buffer}static deserializeReplyErrError(L){const M=L.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(L){return i.alloc(12,L,0).buffer}}var l;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var d;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(d||(d={}))}),define(Ie[276],ke([1,0,3,44,51,4,43,12,18]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(P){P[P.Append=1]="Append",P[P.Replace=2]="Replace",P[P.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(b){this.channels.has(b.id)||(this.channels.set(b.id,b),this._onDidRegisterChannel.fire(b.id))}getChannels(){const b=[];return this.channels.forEach(w=>b.push(w)),b}getChannel(b){return this.channels.get(b)}removeChannel(b){this.channels.delete(b),this._onDidRemoveChannel.fire(b)}}n.Registry.add(e.Extensions.OutputChannels,new R);function I(P,b,w,p,g){return(0,E.createCancelablePromise)(async v=>{await(0,C.whenProviderRegistered)(w,p);const f=n.Registry.as(e.Extensions.OutputChannels);try{await _(w,1,p,g,v),f.registerChannel({id:P,label:b,file:w,log:!0})}catch(c){(0,D.isCancellationError)(c)||g.error("Error while registering log channel",w.toString(),(0,D.getErrorMessage)(c))}})}e.registerLogChannel=I;async function _(P,b,w,p,g){if(!await w.exists(P)){if(g.isCancellationRequested)throw new D.CancellationError;if(b>10)throw new Error("Timed out while waiting for file to be created");p.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",P.toString()),await(0,E.timeout)(1e3,g),await _(P,b+1,w,p,g)}}}),define(Ie[138],ke([1,0,5,6,4,17,14,276,68,26,46,152,23,10]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends n.Disposable{constructor(g,v,f,c){super();this.id=g,this.name=v,this.logger=f,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,g)}replace(g){const v=this.offset;this.write(g),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(g,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:v))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=_.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let w=class{constructor(g,v,f,c,m){this.extHostFileSystem=f,this.extHostFileSystemInfo=c,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[v,f]of this.channels)f.visible=v===this.visibleChannelId}createOutputChannel(g,v,f){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");if((0,P.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(g,v,f);return c.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,c)}async doCreateOutputChannel(g,v,f){const c=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.proxy.$register(g,!1,m,v,f.identifier.value);return new b(h,g,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,v){let f=!1;const c=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return g},append(m){c(),v.then(a=>a.append(m))},appendLine(m){c(),v.then(a=>a.appendLine(m))},clear(){c(),v.then(m=>m.clear())},replace(m){c(),v.then(a=>a.replace(m))},show(m,a){c(),v.then(h=>h.show(m,a))},hide(){c(),v.then(m=>m.hide())},dispose(){f=!0,v.then(m=>m.dispose())}}}};w=Ge([He(0,A.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,E.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,C.ILoggerService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(Ie[277],ke([1,0,4]),function(X,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(Ie[278],ke([1,0,30,11,9,13,22,2,4,204,45,226,277]),function(X,e,u,n,S,A,C,D,E,k,R,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let P=class Jn{constructor(w,p,g,v){this.localUserHome=w,this.remoteAgentService=p,this.environmentService=g,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome??w})()}hasValidBasename(w,p,g){return typeof p=="string"||typeof p=="undefined"?this.resolveOS.then(v=>this.doHasValidBasename(w,v,p)):this.doHasValidBasename(w,p,g)}doHasValidBasename(w,p,g){return w.scheme===n.Schemas.file||w.scheme===n.Schemas.vscodeRemote?(0,u.isValidBasename)(g??(0,C.basename)(w),p===1):!0}get defaultUriScheme(){return Jn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(w,p){if(w.remoteAuthority)return n.Schemas.vscodeRemote;const g=(0,k.getVirtualWorkspaceScheme)(p.getWorkspace());if(g)return g;const v=p.getWorkspace().folders[0];if(v)return v.uri.scheme;const f=p.getWorkspace().configuration;return f?f.scheme:n.Schemas.file}userHome(w){return w?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(w=>w===1?S.win32:S.posix)}async fileURI(w){let p="";if(await this.resolveOS===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const v=w.indexOf("/",2);v===-1?(p=w.substring(2),w="/"):(p=w.substring(2,v),w=w.substring(v)||"/")}return D.URI.from({scheme:n.Schemas.file,authority:p,path:w,query:"",fragment:""})}};P=Ge([He(1,_.IRemoteAgentService),He(2,I.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(Ie[71],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(C,D){this.line=C,this.character=D}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,D){return new u(0,0)}with(C){return new u(0,0)}}e.Position=u;class n{constructor(C,D,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(C,D),this.end=new u(E,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new n(0,0,0,0)}with(C){return new n(0,0,0,0)}}e.Range=n;var S;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[31],ke([1,0,16,36,24,30,8,4,9,12,71,18]),function(X,e,u,n,S,A,C,D,E,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const _="\u27EA ",P=" characters skipped \u27EB",b=(_.length+P.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var w;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function g(j){return!!j.preview}e.resultIsMatch=g;function v(j){return!!j.resource}e.isFileMatch=v;function f(j){return!!j.message}e.isProgressMessage=f;var c;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=m;class a{constructor(ie,Q,ue){this.ranges=Q;const ve=Array.isArray(Q)?Q:[Q];if(ue&&ue.matchLines===1&&h(ve)){ie=(0,C.getNLines)(ie,ue.matchLines);let J="",ge=0,Ee=0;const Pe=Math.floor(ue.charsPerLine/5),me=[];for(const Te of ve){const le=Math.max(Te.startColumn-Pe,0),pe=Te.startColumn+ue.charsPerLine;if(le>Ee+Pe+b){const be=_+(le-Ee)+P;J+=be+ie.slice(le,pe),ge+=le-(Ee+be.length)}else J+=ie.slice(Ee,pe);me.push(new s(0,Te.startColumn-ge,Te.endColumn-ge)),Ee=pe}this.preview={text:J,matches:Array.isArray(this.ranges)?me:me[0]}}else{const J=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:ie,matches:(0,u.mapArrayOrNot)(Q,ge=>new r(ge.startLineNumber-J,ge.startColumn,ge.endLineNumber-J,ge.endColumn))}}}}e.TextSearchMatch=a;function h(j){const ie=j[0].startLineNumber;for(const Q of j)if(Q.startLineNumber!==ie||Q.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,Q,ue,ve){this.startLineNumber=ie,this.startColumn=Q,this.endLineNumber=ue,this.endColumn=ve}}e.SearchRange=r;class s extends r{constructor(ie,Q,ue){super(ie,Q,ie,ue)}}e.OneLineRange=s;var i;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function t(j,ie=!0){const Q=j&&j.files&&j.files.exclude,ue=ie&&j&&j.search&&j.search.exclude;if(!Q&&!ue)return;if(!Q||!ue)return Q||ue;let ve=Object.create(null);return ve=S.mixin(ve,S.deepClone(Q)),ve=S.mixin(ve,S.deepClone(ue),!0),ve}e.getExcludes=t;function o(j,ie){return j.excludePattern&&n.match(j.excludePattern,ie)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&n.match(j.includePattern,ie)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(Q=>{const ue=Q.folder.fsPath;if(A.isEqualOrParent(ie,ue)){const ve=E.relative(ue,ie);return!Q.includePattern||!!n.match(Q.includePattern,ve)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var l;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(ie,Q){super(ie);this.code=Q}}e.SearchError=d;function y(j){const ie=j.message;if((0,k.isCancellationError)(j))return new d(ie,l.canceled);try{const Q=JSON.parse(ie);return new d(Q.message,Q.code)}catch{return new d(ie,l.other)}}e.deserializeSearchError=y;function L(j){const ie={message:j.message,code:j.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=L;function M(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=M;function F(j){return j.type==="success"}e.isSerializedSearchSuccess=F;function T(j){return!!j.path}e.isSerializedFileMatch=T;function U(j,ie){const Q=j.searchPath?j.searchPath:j.relativePath;return(0,C.fuzzyContains)(Q,ie)}e.isFilePatternMatch=U;class N{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function H(j,ie){const Q={...j||{},...ie||{}};return Object.keys(Q).filter(ue=>{const ve=Q[ue];return typeof ve=="boolean"&&ve})}e.resolvePatternsForProvider=H;class te{constructor(ie,Q){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=n.parse(this._excludeExpression);let ue=ie.includePattern;Q.includePattern&&(ue?ue={...ue,...Q.includePattern}:ue=Q.includePattern),ue&&(this._parsedIncludeExpression=n.parse(ue))}matchesExcludesSync(ie,Q,ue){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,Q,ue))}includedInQuerySync(ie,Q,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,Q,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,Q,ue))}includedInQuery(ie,Q,ue){const ve=this._parsedExcludeExpression(ie,Q,ue),J=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,Q,ue):!0;return(0,I.isThenable)(ve)?ve.then(ge=>ge?!1:J()):J()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=te;function B(j){for(const ie in j)if(typeof j[ie]!="boolean")return!0;return!1}function z(j){if(!j)return;let ie;return Q=>(ie||(ie=(j()||Promise.resolve([])).then(ue=>ue?V(ue):{})),ie.then(ue=>!!ue[Q]))}e.hasSiblingPromiseFn=z;function q(j){if(!j)return;let ie;return Q=>{if(!ie){const ue=j();ie=ue?V(ue):{}}return!!ie[Q]}}e.hasSiblingFn=q;function V(j){const ie={};for(const Q of j)ie[Q]=!0;return ie}}),define(Ie[32],ke([1,0,16,18,21,3,25,11,94,22,8,10,2,176,4,14,196,45,46,26,17,15,7,31,5]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c,m,a,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(M,F,T){return new k.ExtUri(U=>l(U,T)).isEqual(M,F)}function i(M,F,T){return s(M.uri,F.uri,T)?0:(0,R.compare)(M.uri.toString(),F.uri.toString())}function t(M,F,T){return M.index!==F.index?M.index<F.index?-1:1:s(M.uri,F.uri,T)?(0,R.compare)(M.name,F.name):(0,R.compare)(M.uri.toString(),F.uri.toString())}function o(M,F,T,U){const N=M.slice(0).sort((te,B)=>T(te,B,U)),H=F.slice(0).sort((te,B)=>T(te,B,U));return(0,u.delta)(N,H,(te,B)=>T(te,B,U))}function l(M,F){const T=F.getCapabilities(M.scheme);return!(T&&T&1024)}class d extends g.Workspace{constructor(F,T,U,N,H,te,B){super(F,U.map(z=>new g.WorkspaceFolder(z)),N,H,B);this._name=T,this._isUntitled=te,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(B),U.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(F,T,U,N){if(!F)return{workspace:null,added:[],removed:[]};const{id:H,name:te,folders:B,configuration:z,transient:q,isUntitled:V}=F,j=[],ie=T;T?B.forEach((J,ge)=>{const Ee=_.URI.revive(J.uri),Pe=d._findFolder(U||T,Ee,N);Pe?(Pe.name=J.name,Pe.index=J.index,j.push(Pe)):j.push({uri:Ee,name:J.name,index:ge})}):j.push(...B.map(({uri:J,name:ge,index:Ee})=>({uri:_.URI.revive(J),name:ge,index:Ee}))),j.sort((J,ge)=>J.index<ge.index?-1:1);const Q=new d(H,te,j,!!q,z?_.URI.revive(z):null,!!V,J=>l(J,N)),{added:ue,removed:ve}=o(ie?ie.workspaceFolders:[],Q.workspaceFolders,i,N);return{workspace:Q,added:ue,removed:ve}}static _findFolder(F,T,U){for(let N=0;N<F.folders.length;N++){const H=F.workspaceFolders[N];if(s(H.uri,T,U))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,T){return T&&this._structure.get(F)&&(F=(0,k.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let y=class{constructor(F,T,U,N){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=N,this._extHostFileSystemInfo=U,this._requestIdProvider=new E.Counter,this._barrier=new n.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const H=T.workspace;this._confirmedWorkspace=H?new d(H.id,H.name,[],!!H.transient,H.configuration?_.URI.revive(H.configuration):null,!!H.isUntitled,te=>l(te,U)):void 0}$initializeWorkspace(F,T){this._trusted=T,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:D.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,T,U,...N){const H=[];if(Array.isArray(N)&&N.forEach(V=>{_.URI.isUri(V.uri)&&!H.some(j=>s(j.uri,V.uri,this._extHostFileSystemInfo))&&H.push({uri:V.uri,name:V.name||(0,k.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[T,U].some(V=>typeof V!="number"||V<0)||U===0&&H.length===0)return!1;const te=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(T+U>te.length)return!1;const B=te.slice(0);B.splice(T,U,...H.map(V=>({uri:V.uri,name:V.name||(0,k.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<B.length;V++){const j=B[V];if(B.some((ie,Q)=>Q!==V&&s(j.uri,ie.uri,this._extHostFileSystemInfo)))return!1}B.forEach((V,j)=>V.index=j);const{added:z,removed:q}=o(te,B,t,this._extHostFileSystemInfo);if(z.length===0&&q.length===0)return!1;if(this._proxy){const V=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(V,T,U,H).then(void 0,j=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:F.identifier,label:F.displayName||F.name}};this._messageService.$showMessage(p.Severity.Error,(0,P.localize)(0,null,V,j.toString()),ie,[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(F,T){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,T)}async getWorkspaceFolder2(F,T){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,T)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,T){let U,N="";if(typeof F=="string"?(U=_.URI.file(F),N=F):typeof F!="undefined"&&(U=F,N=F.fsPath),!U)return N;const H=this.getWorkspaceFolder(U,!0);if(!H)return N;typeof T=="undefined"&&this._actualWorkspace&&(T=this._actualWorkspace.folders.length>1);let te=(0,k.relativePath)(H.uri,U);return T&&H.name&&(te=`${H.name}/${te}`),te}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=d.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:T,added:U,removed:N}=d.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=T||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:N}))}findFiles(F,T,U,N,H=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let te;if(T===null?te=!1:T&&(typeof T=="string"?te=T:te=T.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:z}=L(m.GlobPattern.from(F));return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(B),(0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(te),(0,I.withUndefinedAsNull)(U),H).then(q=>Array.isArray(q)?q.map(V=>_.URI.revive(V)):[])}async findTextInFiles(F,T,U,N,H=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const te=this._requestIdProvider.getNext(),B=typeof T.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:z,folder:q}=L(m.GlobPattern.from(T.include)),V=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,j={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:B,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:z,excludePattern:V},ie=!1;if(this._activeSearchCallbacks[te]=Q=>{if(ie)return;const ue=_.URI.revive(Q.resource);Q.results.forEach(ve=>{(0,h.resultIsMatch)(ve)?U({uri:ue,preview:{text:ve.preview.text,matches:(0,u.mapArrayOrNot)(ve.preview.matches,J=>new a.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))},ranges:(0,u.mapArrayOrNot)(ve.ranges,J=>new a.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))}):U({uri:ue,text:ve.text,lineNumber:ve.lineNumber})})},H.isCancellationRequested)return{};try{const Q=await this._proxy.$startTextSearch(F,(0,I.withUndefinedAsNull)(q),j,te,H);return delete this._activeSearchCallbacks[te],Q||{}}catch(Q){throw delete this._activeSearchCallbacks[te],Q}}$handleTextSearchResult(F,T){this._activeSearchCallbacks[T]?.(F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ge([He(0,c.IExtHostRpcService),He(1,f.IExtHostInitDataService),He(2,v.IExtHostFileSystemInfo),He(3,w.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,b.createDecorator)("IExtHostWorkspace");function L(M){let F,T;return M&&(typeof M=="string"?F=M:(F=M.pattern,T=_.URI.revive(M.baseUri))),{includePattern:F,folder:T}}}),define(Ie[33],ke([1,0,24,3,32,5,7,199,121,10,18,4,17,14,2]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(h,r){if(r){const s=r.split(".");let i=h;for(let t=0;i&&t<s.length;t++)i=i[s[t]];return i}}function p(h){return h instanceof b.URI}function g(h){return h&&h.uri instanceof b.URI&&h.languageId&&typeof h.languageId=="string"}function v(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function f(h){return h&&h.uri instanceof b.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function c(h){if(p(h))return{resource:h};if(g(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(v(h))return{overrideIdentifier:h.languageId};if(f(h))return{resource:h.uri};if(h===null)return{resource:null}}let m=class{constructor(r,s,i){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=i,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new a(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(r,s))}};m=Ge([He(0,_.IExtHostRpcService),He(1,S.IExtHostWorkspace),He(2,P.ILogService)],m),e.ExtHostConfiguration=m;class a{constructor(r,s,i,t){this._onDidChangeConfiguration=new n.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=s,this._configuration=D.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,i))}getConfiguration(r,s,i){const t=c(s)||{},o=this._toReadonlyValue(r?w(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,i?.identifier);function l(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(y){return typeof w(o,y)!="undefined"},get:(y,L)=>{this._validateConfigurationAccess(r?`${r}.${y}`:y,t,i?.identifier);let M=w(o,y);if(typeof M=="undefined")M=L;else{let F;const T=(U,N)=>{let H;const te=()=>{F=F||(0,u.deepClone)(o),H=H||w(F,N)};return(0,k.isObject)(U)?new Proxy(U,{get:(B,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return te(),()=>H;if(F)return H=H||w(F,N),H[z];const q=B[z];return typeof z=="string"?T(q,`${N}.${z}`):q},set:(B,z,q)=>(te(),H&&(H[z]=q),!0),deleteProperty:(B,z)=>(te(),H&&delete H[z],!0),defineProperty:(B,z,q)=>(te(),H&&Object.defineProperty(H,z,q),!0)}):U};M=T(M,y)}return M},update:(y,L,M,F)=>{y=r?`${r}.${y}`:y;const T=l(M);return L!==void 0?this._proxy.$updateConfigurationOption(T,y,L,t,F):this._proxy.$removeConfigurationOption(T,y,t,F)},inspect:y=>{y=r?`${r}.${y}`:y;const L=(0,u.deepClone)(this._configuration.inspect(y,t,this._extHostWorkspace.workspace));if(L)return{key:y,defaultValue:L.policy?.value??L.default?.value,globalValue:L.user?.value??L.application?.value,workspaceValue:L.workspace?.value,workspaceFolderValue:L.workspaceFolder?.value,defaultLanguageValue:L.default?.override,globalLanguageValue:L.user?.override??L.application?.override,workspaceLanguageValue:L.workspace?.override,workspaceFolderLanguageValue:L.workspaceFolder?.override,languageIds:L.overrideIdentifiers}}};return typeof o=="object"&&(0,u.mixin)(d,o,!1),Object.freeze(d)}_toReadonlyValue(r){const s=i=>(0,k.isObject)(i)?new Proxy(i,{get:(t,o)=>s(t[o]),set:(t,o,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(t,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(t,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return s(r)}_validateConfigurationAccess(r,s,i){const t=E.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),o=i?`[${i.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const i=new D.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,o)=>i.affectsConfiguration(t,c(o))})}_toMap(r){return r.reduce((s,i)=>(s.set(i[0],i[1]),s),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[72],ke([1,0,2,18,3,5,7,32,54,33,21,38,17,26,4,11,13,14,67,234,12]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(N){function H(B){if(B!=null)return B}N.from=H;function te(B){if(B!=null)return B}N.to=te})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var h;(function(N){function H(B){if(B!=null)return B}N.from=H;function te(B){if(B!=null)return B}N.to=te})(h=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(N){function H(B){if(B!=null)return B}N.from=H;function te(B){if(B!=null)return B}N.to=te})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(N){function H(z){if(z){const q=z;return q&&!!q.process}else return!1}N.is=H;function te(z){if(z==null)return;const q={process:z.process,args:z.args};return z.options&&(q.options=r.from(z.options)),q}N.from=te;function B(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}N.to=B})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var i;(function(N){function H(B){if(B!=null)return B}N.from=H;function te(B){if(B!=null)return B}N.to=te})(i=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(N){function H(z){if(z){const q=z;return q&&(!!q.commandLine||!!q.command)}else return!1}N.is=H;function te(z){if(z==null)return;const q={};return z.commandLine!==void 0?q.commandLine=z.commandLine:(q.command=z.command,q.args=z.args),z.options&&(q.options=i.from(z.options)),q}N.from=te;function B(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}N.to=B})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(N){function H(z){if(z){const q=z;return q&&q.customExecution==="customExecution"}else return!1}N.is=H;function te(z){return{customExecution:"customExecution"}}N.from=te;function B(z,q){return q.get(z)}N.to=B})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(N){function H(te,B){let z;return te.scope!==void 0&&typeof te.scope!="number"?z=te.scope.uri:te.scope!==void 0&&typeof te.scope=="number"&&(te.scope===C.TaskScope.Workspace&&B&&B.workspaceFile?z=B.workspaceFile:z=f.USER_TASKS_GROUP_KEY),{id:te._id,workspaceFolder:z}}N.from=H})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(N){function H(te){if(te!=null)return{_id:te.id,isDefault:te.isDefault}}N.from=H})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(N){function H(z,q){if(z==null)return[];const V=[];for(const j of z){const ie=te(j,q);ie&&V.push(ie)}return V}N.fromMany=H;function te(z,q){if(z==null)return;let V;z.execution instanceof C.ProcessExecution?V=s.from(z.execution):z.execution instanceof C.ShellExecution?V=t.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(V=o.from(z.execution));const j=a.from(z.definition);let ie;return z.scope?typeof z.scope=="number"?ie=z.scope:ie=z.scope.uri:ie=C.TaskScope.Workspace,!j||!ie?void 0:{_id:z._id,definition:j,name:z.name,source:{extensionId:q.identifier.value,label:z.source,scope:ie},execution:V,isBackground:z.isBackground,group:d.from(z.group),presentationOptions:h.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}N.from=te;async function B(z,q,V){if(z==null)return;let j;s.is(z.execution)?j=s.to(z.execution):t.is(z.execution)?j=t.to(z.execution):o.is(z.execution)&&(j=o.to(z._id,V));const ie=a.to(z.definition);let Q;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Q=z.source.scope:Q=await q.resolveWorkspaceFolder(u.URI.revive(z.source.scope)):Q=C.TaskScope.Workspace),!ie||!Q)return;const ue=new C.Task(ie,Q,z.name,z.source.label,j,z.problemMatchers);return z.isBackground!==void 0&&(ue.isBackground=z.isBackground),z.group!==void 0&&(ue.group=C.TaskGroup.from(z.group._id),ue.group&&z.group.isDefault&&(ue.group=new C.TaskGroup(ue.group.id,ue.group.label),z.group.isDefault===!0&&(ue.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ue.presentationOptions=h.to(z.presentationOptions)),z._id&&(ue._id=z._id),z.detail&&(ue.detail=z.detail),ue}N.to=B})(y=e.TaskDTO||(e.TaskDTO={}));var L;(function(N){function H(B){return B}N.from=H;function te(B){if(!!B)return Object.assign(Object.create(null),B)}N.to=te})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(H,te,B){this._id=te,this._task=B,m.set(this,void 0),tt(this,m,H,"f")}get task(){return this._task}terminate(){Me(this,m,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}m=new WeakMap;var F;(function(N){function H(te){return{id:te._id,task:void 0}}N.from=H})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let T=class{constructor(H,te,B,z,q,V,j,ie){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=H.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=z,this._configurationService=q,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,te,B){if(!B)return new C.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:te,provider:B,extension:H}),this._proxy.$registerTaskProvider(z,te),new C.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(H,te){this._proxy.$registerTaskSystem(H,te)}fetchTasks(H){return this._proxy.$fetchTasks(L.from(H)).then(async te=>{const B=[];for(const z of te){const q=await y.to(z,this._workspaceProvider,this._providedCustomExecutions2);q&&B.push(q)}return B})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(te=>H.push(te)),H}terminateTask(H){if(!(H instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,te,B){const z=this._providedCustomExecutions2.get(H.id);z&&(this._activeCustomExecutions2.set(H.id,z),this._terminalService.attachPtyToTerminal(te,await z.callback(B))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const te=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:te})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const te=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:te,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const te=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:te,exitCode:H.exitCode})}$provideTasks(H,te){const B=this._handlers.get(H);if(!B)return Promise.reject(new Error("no handler found"));const z=[],q=(0,n.asPromise)(()=>B.provider.provideTasks(R.CancellationToken.None)).then(V=>this.provideTasksInternal(te,z,B,V));return new Promise(V=>{q.then(j=>{Promise.all(z).then(()=>{V(j)})})})}async $resolveTask(H,te){const B=this._handlers.get(H);if(!B)return Promise.reject(new Error("no handler found"));if(te.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${te.definition.type}] cannot be resolved by provider of type [${B.type}].`);const z=await y.to(te,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const q=await B.provider.resolveTask(z,R.CancellationToken.None);if(!q)return;this.checkDeprecation(q,B);const V=y.from(q,B.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(V.execution)&&await this.addCustomExecution(V,q,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,te,B){const z=await this._proxy.$createTaskId(H);!B&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,te.execution)),this._providedCustomExecutions2.set(z,te.execution)}async getTaskExecution(H,te){if(typeof H=="string"){const q=this._taskExecutionPromises.get(H);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}const B=this._taskExecutionPromises.get(H.id);if(B)return B;const z=new Promise((q,V)=>{function j(ie,Q,ue){ue?q(new M(ie,Q.id,ue)):V("Unexpected: Task does not exist.")}te?j(this,H,te):y.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>j(this,H,ie))});return this._taskExecutionPromises.set(H.id,z),z.then(q=>(this._taskExecutions.set(H.id,q),q),q=>Promise.reject(q))}checkDeprecation(H,te){H._deprecated&&this._deprecationService.report("Task.constructor",te.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));const B=this._notProvidedCustomExecutions.values();let z=B.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=B.next()}};T=Ge([He(0,_.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,E.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,g.ILogService),He(7,v.IExtHostApiDeprecationService)],T),e.ExtHostTaskBase=T;let U=class extends T{constructor(H,te,B,z,q,V,j,ie){super(H,te,B,z,q,V,j,ie);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(H,te){if(!te.execution)throw new Error("Tasks to execute must include an execution");const B=y.from(te,H);if(B===void 0)throw new Error("Task is not valid");if(o.is(B.execution))await this.addCustomExecution(B,te,!1);else throw new c.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),te);return this._proxy.$executeTask(B).catch(q=>{throw new Error(q)}),z}provideTasksInternal(H,te,B,z){const q=[];if(z)for(const V of z){this.checkDeprecation(V,B),(!V.definition||!H[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const j=y.from(V,B.extension);j&&o.is(j.execution)?(q.push(j),te.push(this.addCustomExecution(j,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:B.extension}}async resolveTaskInternal(H){if(o.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,te){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,te,B){}};U=Ge([He(0,_.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,E.IExtHostDocumentsAndEditors),He(4,k.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,g.ILogService),He(7,v.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,b.createDecorator)("IExtHostTask")}),define(Ie[279],ke([1,0,9,21,49,36,22,50,31]),function(X,e,u,n,S,A,C,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(_,P,b){this.config=_,this.provider=P,this.sessionToken=b,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=_.filePattern,this.includePattern=_.includePattern&&A.parse(_.includePattern),this.maxResults=_.maxResults||void 0,this.exists=_.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=_.excludePattern&&A.parse(_.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(_=>_.cancel()),this.activeCancellationTokens=new Set}search(_){const P=this.config.folderQueries||[];return new Promise((b,w)=>{const p=g=>{this.resultCount++,_(g)};if(this.isCanceled)return b({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(g=>{const v=g.toString(),f=u.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,f)||this.matchFile(p,{base:g,basename:f})}),Promise.all(P.map(g=>this.searchInFolder(g,p))).then(g=>{b({limitHit:this.isLimitHit,stats:g[0]||void 0})},g=>{w(new Error((0,S.toErrorMessage)(g)))})})}async searchInFolder(_,P){const b=new n.CancellationTokenSource,w=this.getSearchOptionsForFolder(_),p=this.initDirectoryTree(),g=new E.QueryGlobTester(this.config,_),v=!g.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(b),f=D.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,b.token),m=f.elapsed(),a=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(h=>{const r=u.posix.relative(_.folder.path,h.path);if(v){const s=u.basename(h.path);this.matchFile(P,{base:_.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(p,_.folder,r,P)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,g,P),{providerTime:m,postProcessTime:a.elapsed()})}finally{b.dispose(),this.activeCancellationTokens.delete(b)}}getSearchOptionsForFolder(_){const P=(0,E.resolvePatternsForProvider)(this.config.includePattern,_.includePattern),b=(0,E.resolvePatternsForProvider)(this.config.excludePattern,_.excludePattern);return{folder:_.folder,excludes:b,includes:P,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!_.disregardParentIgnoreFiles,followSymlinks:!_.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const _={rootEntries:[],pathToEntries:Object.create(null)};return _.pathToEntries["."]=_.rootEntries,_}addDirectoryEntries({pathToEntries:_},P,b,w){if(b===this.filePattern){const g=u.basename(this.filePattern);this.matchFile(w,{base:P,relativePath:this.filePattern,basename:g})}function p(g){const v=u.basename(g),f=u.dirname(g);let c=_[f];c||(c=_[f]=[],p(f)),c.push({base:P,relativePath:g,basename:v})}p(b)}matchDirectoryTree({rootEntries:_,pathToEntries:P},b,w){const p=this,g=this.filePattern;function v(f){const c=(0,E.hasSiblingFn)(()=>f.map(m=>m.basename));for(let m=0,a=f.length;m<a;m++){const h=f[m],{relativePath:r,basename:s}=h;if(b.matchesExcludesSync(r,s,g!==s?c:void 0))continue;const i=P[r];if(i)v(i);else{if(r===g)continue;p.matchFile(w,h)}if(p.isLimitHit)break}}v(_)}matchFile(_,P){(!this.includePattern||P.relativePath&&this.includePattern(P.relativePath,P.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||_(P))}}class R{constructor(){this.sessions=new Map}fileSearch(_,P,b,w){const p=this.getSessionTokenSource(_.cacheKey),g=new k(_,P,p&&p.token);let v=0;const f=c=>{v+=c.length,b(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(g,R.BATCH_SIZE,f,w).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:c.stats}}))}clearCache(_){const P=this.getSessionTokenSource(_);P&&P.cancel()}getSessionTokenSource(_){if(!!_)return this.sessions.has(_)||this.sessions.set(_,new n.CancellationTokenSource),this.sessions.get(_)}rawMatchToSearchItem(_){return _.relativePath?{resource:C.joinPath(_.base,_.relativePath)}:{resource:_.base}}doSearch(_,P,b,w){w.onCancellationRequested(()=>{_.cancel()});const p=v=>{v&&(g.push(v),P>0&&g.length>=P&&(b(g),g=[]))};let g=[];return _.search(p).then(v=>(g.length&&b(g),v),v=>(g.length&&b(g),Promise.reject(v)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ie[280],ke([1,0,16,77,36,107,25,11,9,22,8,10,2,159,187,83,14,45,130,278,31]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(d,y,L,M,F){this.configurationService=d,this.workspaceContextService=y,this.editorGroupsService=L,this.logService=M,this.pathService=F}text(d,y,L={}){d=this.getContentPattern(d,L);const M=this.configurationService.getValue(),F=y&&y.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(y?.map(g.toWorkspaceFolder),L),type:2,contentPattern:d,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:M.search.usePCRE2||F||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(d,y){const L=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const M={...d,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(d,y)&&(M.isCaseSensitive=!0),this.isMultiline(d)&&(M.isMultiline=!0),M}file(d,y={}){return{...this.commonQuery(d,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(d,y){return d?(d=Array.isArray(d)?d.map(i):i(d),y?this.parseSearchPaths(d):{pattern:h(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],y={}){const L=this.handleIncludeExclude(y.includePattern,y.expandPatterns),M=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),F=d.length>1,T=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,y,M)):d.map(H=>this.getFolderQueryForRoot(H,y,M,F))).filter(H=>!!H),U={_reason:y._reason,folderQueries:T,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:M.pattern,includePattern:L.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const H=u.coalesce(u.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(q=>q.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(H));const te=H.filter(z=>(0,c.pathIncludedInQuery)(U,z.fsPath)),B=this.commonQueryFromFileList(te);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...U,...B}}const N=y.extraFileResources&&y.extraFileResources.filter(H=>(0,c.pathIncludedInQuery)(U,H.fsPath));return U.extraFileResources=N&&N.length?N:void 0,U}commonQueryFromFileList(d){const y=[],L=new C.ResourceMap,M={};let F=!1;return d.forEach(T=>{if(T.scheme===D.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(T)){const N=this.workspaceContextService.getWorkspaceFolder(T)?.uri??T.with({path:E.dirname(T.fsPath)});let H=L.get(N);H||(F=!0,H={folder:N,includePattern:{}},y.push(H),L.set(N,H));const te=E.relative(N.fsPath,T.fsPath);(0,I.assertIsDefined)(H.includePattern)[te.replace(/\\/g,"/")]=!0}else T.fsPath&&(F=!0,M[T.fsPath]=!0)}),{folderQueries:y,includePattern:M,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(d,y){if(y.isSmartCase){if(d.isRegExp){if(R.containsUppercaseCharacter(d.pattern,!0))return!0}else if(R.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,P.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const y=B=>E.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),M=(Array.isArray(d)?d:r(d)).map(B=>{const z=this.pathService.resolvedUserHome;return z?(0,A.untildify)(B,z.scheme===D.Schemas.file?z.fsPath:z.path):B}),F=n.groupBy(M,B=>y(B)?"searchPaths":"exprSegments"),T=(F.exprSegments||[]).map(B=>R.rtrim(B,"/")).map(B=>R.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),s(B))),U={},N=this.expandSearchPathPatterns(F.searchPaths||[]);N&&N.length&&(U.searchPaths=N);const H=u.flatten(T),te=h(...H);return te&&(U.pattern=te),U}getExcludesForFolder(d,y){return y.disregardExcludeSettings?void 0:(0,c.getExcludes)(d,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const y=u.flatten(d.map(M=>{let{pathPortion:F,globPortion:T}=a(M);T&&(T=t(T));const U=this.expandOneSearchPath(F);return u.flatten(U.map(N=>this.resolveOneSearchPathPattern(N,T)))})),L=new Map;return y.forEach(M=>{const F=M.searchPath.toString(),T=L.get(F);T?M.pattern&&(T.pattern=T.pattern||{},T.pattern[M.pattern]=!0):L.set(F,{searchPath:M.searchPath,pattern:M.pattern?h(M.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(d){if(E.isAbsolute(d)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==D.Schemas.file?[{searchPath:y[0].uri.with({path:d})}]:[{searchPath:_.URI.file(E.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=i(d),d.startsWith("../")||d===".."){const M=E.posix.resolve(y.path,d);return[{searchPath:y.with({path:M})}]}const L=t(d);return[{searchPath:y,pattern:L}]}else{if(d==="./"||d===".\\")return[];{const y=d.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(F=>{const T=y.match(new RegExp(`^${R.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return T?{match:T,folder:F}:null}).filter(I.isDefined);if(M.length)return M.map(F=>{const T=F.match[1];return{searchPath:F.folder.uri,pattern:T&&t(T)}});{const F=d.match(/\.[\/\\](.+)[\/\\]?/),T=F?F[1]:d,U=b.localize(0,null,T);throw new Error(U)}}}}resolveOneSearchPathPattern(d,y){const L=d.pattern&&y?`${d.pattern}/${y}`:d.pattern||y,M=[{searchPath:d.searchPath,pattern:L}];return L&&!L.endsWith("**")&&M.push({searchPath:d.searchPath,pattern:L+"/**"}),M}getFolderQueryForSearchPath(d,y,L){const M=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(d.searchPath),y,L,!1);return M?{...M,includePattern:d.pattern}:null}getFolderQueryForRoot(d,y,L,M){let F;const T=_.URI.isUri(d)?d:d.uri;if(L.searchPaths){const B=L.searchPaths.filter(z=>(0,k.isEqual)(z.searchPath,T))[0];if(B&&!B.pattern)return null;B&&(F=B.pattern)}const U=this.configurationService.getValue({resource:T}),H={...this.getExcludesForFolder(U,y)||{},...F||{}},te=_.URI.isUri(d)?(0,k.basename)(d):d.name;return{folder:T,folderName:M?te:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!U.search.followSymlinks}}};m=Ge([He(0,w.IConfigurationService),He(1,g.IWorkspaceContextService),He(2,v.IEditorGroupsService),He(3,p.ILogService),He(4,f.IPathService)],m),e.QueryBuilder=m;function a(l){const d=l.match(/[\*\{\}\(\)\[\]\?]/);if(d){const y=d.index,L=l.substr(0,y).match(/[/|\\][^/\\]*$/);if(L){let M=l.substr(0,L.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:l.substr((L.index||0)+1)}}}return{pathPortion:l}}function h(...l){return l.length?l.reduce((d,y)=>(d[y]=!0,d),Object.create(null)):void 0}function r(l){return S.splitGlobAware(l,",").map(d=>d.trim()).filter(d=>!!d.length)}function s(l){return[`**/${l}/**`,`**/${l}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(l){return l.replace(/\\/g,"/")}function t(l){return i(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(l,d){l=u.distinct(l,M=>M.toString());const y=[],L=d.getWorkspace();return l&&l.forEach(M=>{let F;if(d.getWorkbenchState()===2)F=(0,k.relativePath)(L.folders[0].uri,M),F&&F!=="."&&(F="./"+F);else{const T=d.getWorkspaceFolder(M);if(T){const U=T.name;if(L.folders.filter(H=>H.name===U).length===1){const H=(0,k.relativePath)(T.uri,M);H===""?F=`./${T.name}`:F=`./${T.name}/${H}`}else F=M.fsPath}}F&&y.push(F)}),y}e.resolveResourcesForSearchIncludes=o}),define(Ie[281],ke([1,0,22,2,21,12,4,280,31,45]),function(X,e,u,n,S,A,C,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function I(w,p){const g=p.activationEvents;if(!g)return Promise.resolve(void 0);const v=[],f=[];for(const s of g)if(/^workspaceContains:/.test(s)){const i=s.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||w.forceUsingSearch?f.push(i):v.push(i)}if(v.length===0&&f.length===0)return Promise.resolve(void 0);let c;const m=new Promise((s,i)=>{c=s}),a=s=>c({activationEvent:s}),h=Promise.all(v.map(s=>_(w,s,a))).then(()=>{}),r=P(w,p.identifier,f,a);return Promise.all([h,r]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=I;async function _(w,p,g){for(const v of w.folders)if(await w.exists(u.joinPath(n.URI.revive(v),p))){g(`workspaceContains:${p}`);return}}async function P(w,p,g,v){if(g.length===0)return Promise.resolve(void 0);const f=new S.CancellationTokenSource,c=w.checkExists(w.folders,g,f.token),m=setTimeout(async()=>{f.cancel(),w.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},R);let a=!1;try{a=await c}catch(h){A.isCancellationError(h)||A.onUnexpectedError(h)}f.dispose(),clearTimeout(m),a&&v(`workspaceContains:${g.join(",")}`)}function b(w,p,g,v){const f=w.get(C.IInstantiationService),c=w.get(E.ISearchService),a=f.createInstance(D.QueryBuilder).file(p.map(h=>(0,k.toWorkspaceFolder)(n.URI.revive(h))),{_reason:"checkExists",includePattern:g,exists:!0});return c.fileSearch(a,v).then(h=>!!h.limitHit,h=>A.isCancellationError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=b});var tt=this&&this.__classPrivateFieldSet||function(X,e,u,n,S){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!S:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?S.call(X,u):S?S.value=u:e.set(X,u),u},Me=this&&this.__classPrivateFieldGet||function(X,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(X):n?n.value:e.get(X)};define(Ie[39],ke([1,0,171,9,73,22,18,6,25,2,14,5,33,229,91,32,27,227,12,28,23,205,7,122,4,26,69,17,85,52,38,3,281,90,207,11]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c,m,a,h,r,s,i,t,o,l,d,y,L,M,F,T){"use strict";var U,N,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let te=class In extends D.Disposable{constructor(Q,ue,ve,J,ge,Ee,Pe,me,Te,le){super();this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=ue,this._extHostContext=ve,this._initData=Pe,this._extHostWorkspace=J,this._extHostConfiguration=ge,this._logService=Ee,this._extHostTunnelService=Te,this._extHostTerminalService=le,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._globalRegistry=new g.ExtensionDescriptionRegistry(this._initData.allExtensions);const pe=(0,p.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new g.ExtensionDescriptionRegistry(q(this._globalRegistry,pe)),this._storage=new b.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=me,this._instaService=Q.createChild(new o.ServiceCollection([b.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let be=[],ae=[];this._initData.remote.isRemote&&(be=this._initData.allExtensions.filter(ee=>!ee.main&&!ee.browser).map(ee=>ee.identifier),ae=this._initData.allExtensions.filter(ee=>!pe.has(f.ExtensionIdentifier.toKey(ee.identifier.value))).filter(ee=>(ee.main||ee.browser)&&ee.api==="none").map(ee=>ee.identifier));const he=(0,p.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new P.ExtensionsActivator(this._myRegistry,be,ae,{onExtensionActivationError:(ee,ne,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,v.transformErrorForSerialization(ne),O)},actualActivateExtension:async(ee,ne)=>{if(he.has(f.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ne),new P.HostExtension;const O=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(O,ne)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){v.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(ge=>ge.identifier).filter(ge=>this.isActivated(ge)).map(ge=>this._deactivate(ge))}catch{}await Promise.all(Q)}terminate(Q,ue=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(J=>{this._logService.error(J)}),this._extHostContext.dispose();const ve=this._deactivateAll();Promise.race([(0,C.timeout)(5e3),ve]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ue}`):this._logService.info(`Extension host exiting with code ${ue}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ue)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const ue=await this._mainThreadExtensionsProxy.$getExtension(Q);return ue&&{...ue,identifier:new f.ExtensionIdentifier(ue.identifier.value),extensionLocation:k.URI.revive(ue.extensionLocation)}}_activateByEvent(Q,ue){return this._activator.activateByEvent(Q,ue)}_activateById(Q,ue){return this._activator.activateById(Q,ue)}activateByIdWithErrors(Q,ue){return this._activateById(Q,ue).then(()=>{const ve=this._activator.getActivatedExtension(Q);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==T.Schemas.file)return Q;const ue=await this._hostUtils.realpath(Q.fsPath);return k.URI.file(ue)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new j(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const ue=E.TernarySearchTree.forUris(ve=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ve));return await Promise.all(Q.map(async ve=>{if(this._getEntryPoint(ve)){const J=await this._realPathExtensionUri(ve.extensionLocation);ue.set(J,ve)}})),ue}_deactivate(Q){let ue=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return ue;const ve=this._activator.getActivatedExtension(Q);if(!ve)return ue;try{typeof ve.module.deactivate=="function"&&(ue=Promise.resolve(ve.module.deactivate()).then(void 0,J=>(this._logService.error(J),Promise.resolve(void 0))))}catch(J){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(J)}try{(0,D.dispose)(ve.subscriptions)}catch(J){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(J)}return ue}async _activateExtension(Q,ue){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,ue).then(ve=>{const J=ve.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,ue),this._logExtensionActivationTimes(Q,ue,"success",J),ve},ve=>{throw this._logExtensionActivationTimes(Q,ue,"failure"),ve})}_logExtensionActivationTimes(Q,ue,ve,J){const ge=B(Q,ue);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ge,...J||{},outcome:ve})}_doActivateExtension(Q,ue){const ve=B(Q,ue);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ve);const J=this._getEntryPoint(Q);if(!J)return Promise.resolve(new P.EmptyExtension(P.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${Q.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this._logService.flush();const ge=new P.ExtensionActivationTimesBuilder(ue.startup);return Promise.all([this._loadCommonJSModule(Q.identifier,(0,A.joinPath)(Q.extensionLocation,J),ge),this._loadExtensionContext(Q)]).then(Ee=>(S.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),In._callActivate(this._logService,Q.identifier,Ee[0],Ee[1],ge))).then(Ee=>(S.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),Ee))}_loadExtensionContext(Q){const ue=new m.ExtensionGlobalMemento(Q,this._storage),ve=new m.ExtensionMemento(Q.identifier.value,!1,this._storage),J=new F.ExtensionSecrets(Q,this._secretState),ge=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,Ee=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([ue.whenReady,ve.whenReady,this._storagePath.whenReady]).then(()=>{const Pe=this;let me,Te;const le=(0,p.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:ve,secrets:J,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(pe){return n.join(Q.extensionLocation.fsPath,pe)},get storagePath(){return Pe._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return Pe._storagePath.globalValue(Q).fsPath},get logPath(){return n.join(Pe._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return k.URI.joinPath(Pe._initData.logsLocation,Q.identifier.value)},get storageUri(){return Pe._storagePath.workspaceValue(Q)},get globalStorageUri(){return Pe._storagePath.globalValue(Q)},get extensionMode(){return ge},get extension(){return me===void 0&&(me=new z(Pe,Q.identifier,Q,Ee,!1)),me},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(Q,"extensionRuntime"),Pe.extensionRuntime},get environmentVariableCollection(){return Pe._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!Te){if(!le)return;const pe=y.Event.buffer(y.Event.fromDOMEventEmitter(le,"message",be=>be.data));le.start(),Te={onDidReceiveMessage:pe,postMessage:le.postMessage.bind(le)}}return Te}})})}static _callActivate(Q,ue,ve,J,ge){return ve=ve||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,ue,ve,J,ge).then(Ee=>new P.ActivatedExtension(!1,null,ge.build(),ve,Ee,J.subscriptions))}static _callActivateOptional(Q,ue,ve,J,ge){if(typeof ve.activate=="function")try{ge.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const Ee=typeof global=="object"?global:self,Pe=ve.activate.apply(Ee,[J]);return ge.activateCallStop(),ge.activateResolveStart(),Promise.resolve(Pe).then(me=>(ge.activateResolveStop(),me))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(ve)}_activateOneStartupFinished(Q,ue){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:ue}).then(void 0,ve=>{this._logService.error(ve)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const ue of Q.activationEvents)ue==="onStartupFinished"&&this._activateOneStartupFinished(Q,ue)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const ue=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ve=this._handleWorkspaceContainsEagerExtensions(ue),J=Promise.all([Q,ve]).then(()=>{});return Promise.race([J,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ue=>this._handleWorkspaceContainsEagerExtension(Q,ue))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,ue){if(this.isActivated(ue.identifier))return;const ve=!this._initData.remote.isRemote&&!!this._initData.remote.authority,J={logService:this._logService,folders:Q.map(Ee=>Ee.uri),forceUsingSearch:ve,exists:Ee=>this._hostUtils.exists(Ee.fsPath),checkExists:(Ee,Pe,me)=>this._mainThreadWorkspaceProxy.$checkExists(Ee,Pe,me)},ge=await(0,L.checkActivateWorkspaceContainsExtension)(J,ue);if(!!ge)return this._activateById(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:ge.activationEvent}).then(void 0,Ee=>this._logService.error(Ee))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:ue}=this._initData.environment;if(!Q||!ue)throw new Error(u.localize(0,null));const ve=await this._loadCommonJSModule(null,ue,new P.ExtensionActivationTimesBuilder(!1));if(!ve||typeof ve.run!="function")throw new Error(u.localize(1,null,ue.toString()));return new Promise((J,ge)=>{const Ee=(Te,le)=>{Te?ge(Te):J(typeof le=="number"&&le>0?1:0)},Pe=(0,A.originalFSPath)(ue),me=ve.run(Pe,Ee);me&&me.then&&me.then(()=>{J(0)}).catch(Te=>{ge(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,ue){return this._resolvers[Q]=ue,(0,D.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const ue=Q.indexOf("+");if(ue===-1)throw new Error("Not an authority that can be resolved!");const ve=Q.substr(0,ue);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this._resolvers[ve]}}async $resolveAuthority(Q,ue){this._logService.info(`$resolveAuthority invoked for authority (${V(Q)})`);const{authorityPrefix:ve,resolver:J}=await this._activateAndGetResolver(Q);if(!J)return{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(J)),S.mark(`code/extHost/willResolveAuthority/${ve}`);const ge=await J.resolve(Q,{resolveAttempt:ue});S.mark(`code/extHost/didResolveAuthorityOK/${ve}`);const Ee={authority:Q,host:ge.host,port:ge.port,connectionToken:ge.connectionToken},Pe={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ee,options:Pe,tunnelInformation:{environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures}}}}catch(ge){if(S.mark(`code/extHost/didResolveAuthorityError/${ve}`),ge instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:ge._code,message:ge._message,detail:ge._detail}};throw ge}}async $getCanonicalURI(Q,ue){this._logService.info(`$getCanonicalURI invoked for authority (${V(Q)})`);const{resolver:ve}=await this._activateAndGetResolver(Q);if(!ve)return null;const J=k.URI.revive(ue);if(typeof ve.getCanonicalURI=="undefined")return J;const ge=await(0,C.asPromise)(()=>ve.getCanonicalURI(J));return ge||J}static _applyExtensionsDelta(Q,ue,ve){const J=new g.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());J.deltaExtensions(ve.toAdd,ve.toRemove);const ge=(0,p.extensionIdentifiersArrayToSet)(ue.getAllExtensionDescriptions().map(Pe=>Pe.identifier));for(const Pe of ve.myToRemove)ge.delete(f.ExtensionIdentifier.toKey(Pe));for(const Pe of ve.myToAdd)ge.add(f.ExtensionIdentifier.toKey(Pe));const Ee=q(J,ge);return{globalRegistry:J,myExtensions:Ee}}$startExtensionHost(Q){Q.toAdd.forEach(J=>J.extensionLocation=k.URI.revive(J.extensionLocation));const{globalRegistry:ue,myExtensions:ve}=In._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(ue.getAllExtensionDescriptions()),this._myRegistry.set(ve),this._startExtensionHost()}$activateByEvent(Q,ue){return ue===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(ve=>this._activateByEvent(Q,!1))}async $activate(Q,ue){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,ue),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(Ee=>Ee.extensionLocation=k.URI.revive(Ee.extensionLocation));const{globalRegistry:ue,myExtensions:ve}=In._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),J=await this._createExtensionPathIndex(ve);return(await this.getExtensionPathIndex()).setSearchTree(J),this._globalRegistry.set(ue.getAllExtensionDescriptions()),this._myRegistry.set(ve),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const ue=c.VSBuffer.alloc(Q),ve=Math.random()%256;for(let J=0;J<Q;J++)ue.writeUInt8(ve,J);return ue}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};te=Ge([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,t.IExtHostRpcService),He(3,w.IExtHostWorkspace),He(4,_.IExtHostConfiguration),He(5,R.ILogService),He(6,s.IExtHostInitDataService),He(7,i.IExtensionStoragePaths),He(8,l.IExtHostTunnelService),He(9,d.IExtHostTerminalService)],te),e.AbstractExtHostExtensionService=te;function B(ie,Q){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class z{constructor(Q,ue,ve,J,ge){U.set(this,void 0),N.set(this,void 0),H.set(this,void 0),tt(this,U,Q,"f"),tt(this,N,ue,"f"),tt(this,H,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=n.normalize((0,A.originalFSPath)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=J,this.isFromDifferentExtensionHost=ge}get isActive(){return Me(this,U,"f").isActivated(Me(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,U,"f").getExtensionExports(Me(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,U,"f").activateByIdWithErrors(Me(this,H,"f"),{startup:!1,extensionId:Me(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=z,U=new WeakMap,N=new WeakMap,H=new WeakMap;function q(ie,Q){return ie.getAllExtensionDescriptions().filter(ue=>Q.has(f.ExtensionIdentifier.toKey(ue.identifier)))}function V(ie){const Q=ie.indexOf("+");return Q===-1?ie:ie.substring(0,Q)}class j{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=j}),define(Ie[282],ke([1,0,73,2,5,33,27,28,17,26,4,39,40,14,8]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(m,a,h,r,s,i,t){this._apiFactory=m,this._extensionRegistry=a,this._instaService=h,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=i,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,a,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(v,a)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,a,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const a of m.nodeModuleName)this._factories.set(a,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(a=>m.alternativeModuleName(a))}};w=Ge([He(2,R.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,I.IExtHostExtensionService),He(5,k.IExtHostInitDataService),He(6,P.ILogService)],w),e.RequireInterceptor=w;let p=class Kn{constructor(m){if(m.environment.appRoot&&Kn.aliased.size){const a=(0,b.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),h="[a-z0-9_.-]",r=`@${h}+\\/${h}+|${h}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(m));if(!a)return;const[,h,r,s]=a,i=Kn.aliased.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),h+i+s}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};p.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),p=Ge([He(0,k.IExtHostInitDataService)],p);class g{constructor(m,a,h,r,s){this._apiFactory=m,this._extensionPaths=a,this._extensionRegistry=h,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,a){const h=this._extensionPaths.findSubstr(a);if(h){let r=this._extApiImpl.get(D.ExtensionIdentifier.toKey(h.identifier));return r||(r=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(h.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,i)=>r+=`	${i} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(m,a,h){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(S.MainContext.MainThreadTelemetry);const{environment:r}=h,s=a.getProxy(S.MainContext.MainThreadKeytar);if(r.appRoot){let i=r.appRoot.fsPath;_.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,t)=>s.$getPassword(i,t),setPassword:(i,t,o)=>s.$setPassword(i,t,o),deletePassword:(i,t)=>s.$deletePassword(i,t),findPassword:i=>s.$findPassword(i),findCredentials(i){return s.$findCredentials(i)}}}load(m,a){const h=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const a=m.length;if(a<=7||!this.alternativeNames)return;const h=a-7;if((m.charAt(h)==="/"||m.charAt(h)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};v=Ge([He(1,E.IExtHostRpcService),He(2,k.IExtHostInitDataService)],v);let f=class{constructor(m,a,h){this._extensionPaths=m,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(S.MainContext.MainThreadTelemetry);const r=h.getProxy(S.MainContext.MainThreadWindow);this._impl=(s,i)=>{const t=n.URI.parse(s);return i?this.callOriginal(s,i):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,s,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,s,{}):this.callOriginal(s,i)}}load(m,a,h){const r=this._extensionPaths.findSubstr(a);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=h(m),this._impl}callOriginal(m,a){return this.sendNoForwardTelemetry(),this._original(m,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=Ge([He(2,E.IExtHostRpcService)],f)}),define(Ie[47],ke([1,0,78,6,9,40,4,54,55,39,7,32,220,33]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class b extends _.AbstractVariableResolverService{constructor(g,v,f,c,m,a,h){function r(){if(f){const s=f.activeEditor();if(s)return s.document.uri;const i=c.tabGroups.all.find(t=>t.isActive)?.activeTab;if(i!==void 0){if(i.input instanceof R.TextDiffTabInput||i.input instanceof R.NotebookDiffEditorTabInput)return i.input.modified;if(i.input instanceof R.TextTabInput||i.input instanceof R.NotebookEditorTabInput||i.input instanceof R.CustomEditorTabInput)return i.input.uri}}}super({getFolderUri:s=>{const i=a.folders.filter(t=>t.name===s);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>a.folders.length,getConfigurationValue:(s,i)=>m.getConfiguration(void 0,s).get(i),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return S.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const s=r();if(s){const i=v.getWorkspaceFolder(s);if(i)return S.normalize(i.uri.fsPath)}}},getSelectedText:()=>{if(f){const s=f.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(f){const s=f.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>g.getExtension(s)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(A.env))}}let w=class extends n.Disposable{constructor(g,v,f,c,m){super();this.extensionService=g,this.workspaceService=v,this.editorService=f,this.configurationService=c,this.editorTabs=m,this._resolver=new u.Lazy(async()=>{const a=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new b(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,a,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};w=Ge([He(0,k.IExtHostExtensionService),He(1,I.IExtHostWorkspace),He(2,D.IExtHostDocumentsAndEditors),He(3,P.IExtHostConfiguration),He(4,E.IExtHostEditorTabs)],w),e.ExtHostVariableResolverProviderService=w}),define(Ie[74],ke([1,0,18,3,10,2,4,5,55,39,17,7,32,127,214,33,47]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let g=class{constructor(r,s,i,t,o,l){this._workspaceService=s,this._extensionService=i,this._configurationService=t,this._editorTabs=o,this._variableResolver=l,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new n.Emitter,this._onDidTerminateDebugSession=new n.Emitter,this._onDidChangeActiveDebugSession=new n.Emitter,this._onDidReceiveDebugSessionCustomEvent=new n.Emitter,this._debugServiceProxy=r.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new n.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(d=>{d.onDidChange(y=>{this.registerAllDebugTypes(d)}),this.registerAllDebugTypes(d)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,s){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let t=`debug:${encodeURIComponent(i.path||"")}`,o="?";return s&&(t+=`${o}session=${encodeURIComponent(s.id)}`,o="&"),t+=`${o}ref=${i.sourceReference}`,A.URI.parse(t)}else{if(i.path)return A.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const t=i.contributes.debuggers;if(t&&t.length>0)for(const o of t)(0,b.isDebuggerMainContribution)(o)&&s.push(o.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(o=>{const l=o.id;return this._breakpoints.has(l)?!1:(this._breakpoints.set(l,o),!0)});this.fireBreakpointChanges(s,[],[]);const i=[],t=new Map;for(const o of s)if(o instanceof I.SourceBreakpoint){let l=t.get(o.location.uri.toString());l||(l={type:"sourceMulti",uri:o.location.uri,lines:[]},t.set(o.location.uri.toString(),l),i.push(l)),l.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof I.FunctionBreakpoint&&i.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(l=>this._breakpoints.delete(l.id));this.fireBreakpointChanges([],s,[]);const i=s.filter(l=>l instanceof I.SourceBreakpoint).map(l=>l.id),t=s.filter(l=>l instanceof I.FunctionBreakpoint).map(l=>l.id),o=s.filter(l=>l instanceof I.DataBreakpoint).map(l=>l.id);return this._debugServiceProxy.$unregisterBreakpoints(i,t,o)}startDebugging(r,s,i){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,debugUI:i.debugUI,suppressSaveBeforeStart:i.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,i){if(!s)return new I.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,i,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(r,s,i){if(!i)return new I.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new I.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:i,factory:s}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let i;const t=await this.getFolder(r);return t&&(i={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(i,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new m(r.implementation)}createSignService(){}async $startDASession(r,s){const i=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const l=this.convertToDto(o),d=this.createDebugAdapter(l,t);if(!d)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const y=d;return this._debugAdapters.set(r,y),this.getDebugAdapterTrackers(t).then(L=>(L&&this._debugAdaptersTrackers.set(r,L),y.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const F=M,T={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(F.arguments.value);T.body={signature:U},y.sendResponse(T)}else throw new Error("no signer")}catch(U){T.success=!1,T.message=U.message,y.sendResponse(T)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(M),M=(0,b.convertToVSCPaths)(M,!0),i._debugServiceProxy.$acceptDAMessage(r,M)}),y.onError(M=>{L&&L.onError&&L.onError(M),this._debugServiceProxy.$acceptDAError(r,M.name,M.message,M.stack)}),y.onExit(M=>{L&&L.onExit&&L.onExit((0,S.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,S.withNullAsUndefined)(M),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),y.startSession()))})}$sendDAMessage(r,s){s=(0,b.convertToDAPaths)(s,!1);const i=this._debugAdaptersTrackers.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(s),this._debugAdapters.get(r)?.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const i=this._debugAdapters.get(r);return this._debugAdapters.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],i=[],t=[];if(r.added)for(const o of r.added){const l=o.id;if(l&&!this._breakpoints.has(l)){let d;if(o.type==="function")d=new I.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")d=new I.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const y=A.URI.revive(o.uri);d=new I.SourceBreakpoint(new I.Location(y,new I.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}d._id=l,this._breakpoints.set(l,d),s.push(d)}}if(r.removed)for(const o of r.removed){const l=this._breakpoints.get(o);l&&(this._breakpoints.delete(o),i.push(l))}if(r.changed){for(const o of r.changed)if(o.id){const l=this._breakpoints.get(o.id);if(l){if(l instanceof I.FunctionBreakpoint&&o.type==="function"){const d=l;d.enabled=o.enabled,d.condition=o.condition,d.hitCondition=o.hitCondition,d.logMessage=o.logMessage,d.functionName=o.functionName}else if(l instanceof I.SourceBreakpoint&&o.type==="source"){const d=l;d.enabled=o.enabled,d.condition=o.condition,d.hitCondition=o.hitCondition,d.logMessage=o.logMessage,d.location=new I.Location(A.URI.revive(o.uri),new I.Position(o.line,o.character))}t.push(l)}}}this.fireBreakpointChanges(s,i,t)}$provideDebugConfigurations(r,s,i){return(0,u.asPromise)(async()=>{const t=this.getConfigProviderByHandle(r);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(s);return t.provideDebugConfigurations(o,i)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(r,s,i,t){return(0,u.asPromise)(async()=>{const o=this.getConfigProviderByHandle(r);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.getFolder(s);return o.resolveDebugConfiguration(l,i,t)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,i,t){return(0,u.asPromise)(async()=>{const o=this.getConfigProviderByHandle(r);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.getFolder(s);return o.resolveDebugConfigurationWithSubstitutedVariables(l,i,t)})}async $provideDebugAdapter(r,s){const i=this.getAdapterDescriptorFactoryByHandle(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(i,t).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){(await this.getSession(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const t={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(r){if(r instanceof I.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof I.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(i=>i.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(i=>i.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(i=>i.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const t of i)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const i=r.configuration.type,t=this._trackerFactories.filter(o=>o.type===i||o.type==="*").map(o=>(0,u.asPromise)(()=>o.factory.createDebugAdapterTracker(r)).then(l=>l,l=>null));return Promise.race([Promise.all(t).then(o=>{const l=o.filter(d=>!!d);if(l.length>0)return new c(l)}),new Promise((o,l)=>{const d=setTimeout(()=>{clearTimeout(d),l(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(r,s){const i=s.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new I.DebugAdapterServer(i));if(r){const o=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,o))).then(l=>{if(l)return l})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,i){(r.length>0||s.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:i}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const i=await this.getFolder(r.folderUri),t=r.parent?this._debugSessions.get(r.parent):void 0;s=new v(this._debugServiceProxy,r.id,r.type,r.name,i,r.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=A.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};g=Ge([He(0,R.IExtHostRpcService),He(1,_.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,w.IExtHostConfiguration),He(4,E.IExtHostEditorTabs),He(5,p.IExtHostVariableResolverProvider)],g),e.ExtHostDebugServiceBase=g;class v{constructor(r,s,i,t,o,l,d){this._debugServiceProxy=r,this._id=s,this._type=i,this._name=t,this._workspaceFolder=o,this._configuration=l,this._parentSession=d}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=v;class f{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=f;class c{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(i=>i.onExit?i.onExit(r,s):void 0)}}class m extends P.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends g{constructor(r,s,i,t,o,l){super(r,s,i,t,o,l)}};a=Ge([He(0,R.IExtHostRpcService),He(1,_.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,w.IExtHostConfiguration),He(4,E.IExtHostEditorTabs),He(5,p.IExtHostVariableResolverProvider)],a),e.WorkerExtHostDebugService=a}),define(Ie[283],ke([1,0,12,73,2,5,275,14,82,85,26,194,17,64,39]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(g,v,f,c,m){this._hostUtils=f,this._rpcProtocol=new C.RPCProtocol(g,null,c),v=w._transform(v,this._rpcProtocol);const a=new k.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());a.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:m}),a.set(_.IExtHostRpcService,new _.ExtHostRpcService(this._rpcProtocol)),a.set(P.IURITransformerService,new P.URITransformerService(c)),a.set(b.IHostUtils,f);const h=new I.InstantiationService(a,!0);this._logService=h.invokeFunction(t=>t.get(D.ILogService)),n.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=h.invokeFunction(t=>t.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(o,l)=>{let d="",y,L;for(const M of l)d+=`
	at ${M.toString()}`,L=M.getFileName(),!y&&L&&(y=t.findSubstr(S.URI.file(L)));return r.set(o,y),`${o.name||"Error"}: ${o.message||""}${d}`}});const s=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),i=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(t=>{const o=u.transformErrorForSerialization(t),l=r.get(t);l?s.$onExtensionRuntimeError(l.identifier,o):i.$onUnexpectedError(o)})}async asBrowserUri(g){const v=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return S.URI.revive(await v.$asBrowserUri(g))}terminate(g){this._extensionService.terminate(g)}static _transform(g,v){g.allExtensions.forEach(c=>c.extensionLocation=S.URI.revive(v.transformIncomingURIs(c.extensionLocation))),g.environment.appRoot=S.URI.revive(v.transformIncomingURIs(g.environment.appRoot));const f=g.environment.extensionDevelopmentLocationURI;return f&&(g.environment.extensionDevelopmentLocationURI=f.map(c=>S.URI.revive(v.transformIncomingURIs(c)))),g.environment.extensionTestsLocationURI=S.URI.revive(v.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=S.URI.revive(v.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=S.URI.revive(v.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=S.URI.revive(v.transformIncomingURIs(g.logsLocation)),g.logFile=S.URI.revive(v.transformIncomingURIs(g.logFile)),g.workspace=v.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=w}),define(Ie[284],ke([1,0,18,13,177,193,201,74,55,39,17,38,7,47,32,215,217,33]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends D.ExtHostDebugServiceBase{constructor(h,r,s,i,t,o,l){super(h,r,s,i,o,l);this._terminalService=t,this._integratedTerminalInstances=new m}createDebugAdapter(h,r){switch(h.type){case"server":return new w.SocketDebugAdapter(h);case"pipeServer":return new w.NamedPipeDebugAdapter(h);case"executable":return new w.ExecutableDebugAdapter(h,r.type)}return super.createDebugAdapter(h,r)}daExecutableFromPackage(h,r){const s=w.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),h.type);if(s)return new _.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new C.SignService}async $runInTerminal(h,r){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)}));const s=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),t=this._terminalService.getDefaultShellArgs(!0),o=h.title||S.localize(0,null),l=JSON.stringify({shell:i,shellArgs:t});let d=await this._integratedTerminalInstances.checkout(l,o),y,L=!1;if(d)y=h.cwd;else{const U={shellPath:i,shellArgs:t,cwd:h.cwd,name:o,iconPath:new _.ThemeIcon("debug")};L=!0,d=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,l)}d.show(!0);const M=await d.processId;L?await new Promise(U=>setTimeout(U,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?d.sendText("cls"):i.indexOf("bash")>=0?d.sendText("clear"):n.isWindows?d.sendText("cls"):d.sendText("clear"));const F=(0,p.prepareCommand)(i,h.args,y,h.env);d.sendText(F);const T=this.onDidTerminateDebugSession(U=>{U.id===r&&(this._integratedTerminalInstances.free(d),T.dispose())});return M}else if(h.kind==="external")return c(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,r)}};v=Ge([He(0,R.IExtHostRpcService),He(1,b.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,g.IExtHostConfiguration),He(4,I.IExtHostTerminalService),He(5,E.IExtHostEditorTabs),He(6,P.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let f;function c(a,h){if(!f)if(n.isWindows)f=new A.WindowsExternalTerminalService;else if(n.isMacintosh)f=new A.MacExternalTerminalService;else if(n.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=h.getConfiguration("terminal");return f.runInTerminal(a.title,a.cwd,a.args,a.env||{},r.external||{})}e.runInExternalTerminal=c;class m{constructor(){this._terminalInstances=new Map}async checkout(h,r){const i=[...this._terminalInstances.entries()].map(([t,o])=>(0,u.createCancelablePromise)(async l=>{if(t.name!==r||o.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await t.processId))return null;const d=Date.now();return o.lastUsedAt+m.minUseDelay>d||l.isCancellationRequested||o.config!==h?null:(o.lastUsedAt=d,t)}));return await(0,u.firstParallel)(i,t=>!!t)}insert(h,r){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:r})}free(h){const r=this._terminalInstances.get(h);r&&(r.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}m.minUseDelay=1e3}),define(Ie[285],ke([1,0,9,2,114,32,54,33,45,38,17,26,72,11,14,67,22,81,47]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends _.ExtHostTaskBase{constructor(m,a,h,r,s,i,t,o,l){super(m,a,h,r,s,i,t,o);this.workspaceService=h,this.variableResolver=l,a.remote.isRemote&&a.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:a.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,a){const h=a;if(!a.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const r=_.TaskHandleDTO.from(h,this.workspaceService),s=await this._proxy.$getTaskExecution(r);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(s,a);return this._proxy.$executeTask(r).catch(()=>{}),i}else{const r=_.TaskDTO.from(a,m);if(r===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,a,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),a);return this._proxy.$executeTask(r).catch(()=>{}),s}}provideTasksInternal(m,a,h,r){const s=[];if(r)for(const i of r){this.checkDeprecation(i,h),(!i.definition||!m[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const t=_.TaskDTO.from(i,h.extension);t&&(s.push(t),_.CustomExecutionDTO.is(t.execution)&&a.push(this.addCustomExecution(t,i,!0)))}return{tasks:s,extension:h.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let a=m&&m.length>0?m[0]:void 0;if(!a){const h=n.URI.file((0,g.homedir)());a=new E.WorkspaceFolder({uri:h,name:p.basename(h),index:0})}return{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,a){const h=n.URI.revive(m),r={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(h),i=await this._workspaceProvider.getWorkspaceFolders2()??[],t=await this.variableResolver.getResolver(),o=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(i);for(const l of a.variables)r.variables[l]=await t.resolveAsync(o,l);if(a.process!==void 0){let l;if(a.process.path!==void 0){l=a.process.path.split(u.delimiter);for(let d=0;d<l.length;d++)l[d]=await t.resolveAsync(o,l[d])}r.process=await S.win32.findExecutable(await t.resolveAsync(o,a.process.name),a.process.cwd!==void 0?await t.resolveAsync(o,a.process.cwd):void 0,l)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(m,a,h){return S.win32.findExecutable(m,a,h)}};f=Ge([He(0,R.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,k.IExtHostTerminalService),He(6,b.ILogService),He(7,w.IExtHostApiDeprecationService),He(8,v.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(Ie[286],ke([1,0,81,47]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class S extends n.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=S}),define(Ie[139],ke([1,0,16,18,21,49,11,9,22,10,2,31]),function(X,e,u,n,S,A,C,D,E,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(f,c,m,a){this.query=f,this.provider=c,this.fileUtils=m,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,c){const m=this.query.folderQueries||[],a=new S.CancellationTokenSource;return c.onCancellationRequested(()=>a.cancel()),new Promise((h,r)=>{this.collector=new b(f);let s=!1;const i=(t,o)=>{if(!s&&!this.isLimitHit){const l=this.resultSize(t);p(t)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,s=!0,a.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const d=this.resultSize(t);this.resultCount+=d,(d>0||!p(t))&&this.collector.add(t,o)}};Promise.all(m.map((t,o)=>this.searchInFolder(t,l=>i(l,o),a.token))).then(t=>{a.dispose(),this.collector.flush();const o=t.some(l=>!!l&&!!l.limitHit);h({limitHit:this.isLimitHit||o,messages:(0,u.flatten)(t.map(l=>l?.message?(0,k.isArray)(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},t=>{a.dispose();const o=(0,A.toErrorMessage)(t);r(new Error(o))})})}resultSize(f){return p(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,c){const m=Array.isArray(f.ranges)?f.ranges:[f.ranges],a=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:m.slice(0,c),preview:{matches:a.slice(0,c),text:f.preview.text},uri:f.uri}}async searchInFolder(f,c,m){const a=new I.QueryGlobTester(this.query,f),h=[],r={report:t=>{if(!this.validateProviderResult(t))return;const o=f.folder.scheme===C.Schemas.file?(0,I.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(t.uri))):void 0,l=E.relativePath(f.folder,t.uri);if(l){const d=a.includedInQuery(l,D.basename(l),o);(0,n.isThenable)(d)?h.push(d.then(y=>{y&&c(t)})):d&&c(t)}}},s=this.getSearchOptionsForFolder(f),i=await this.provider.provideTextSearchResults(P(this.query.contentPattern),s,r,m);return h.length&&await Promise.all(h),i}validateProviderResult(f){if(p(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const c=(0,I.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),m=(0,I.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),a={folder:R.URI.from(f.folder),excludes:m,includes:c,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=_;function P(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class b{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,c=>this.sendItems(c))}add(f,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!E.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(w(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=b;function w(v){return p(v)?{preview:{matches:(0,u.mapArrayOrNot)(v.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:v.preview.text},ranges:(0,u.mapArrayOrNot)(v.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function p(v){return!!v.preview}e.extensionResultIsMatch=p;class g{constructor(f,c){this.maxBatchSize=f,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,c){!f||this.addItemToBatch(f,c)}addItems(f,c){!f||this.addItemsToBatch(f,c)}addItemToBatch(f,c){this.batch.push(f),this.batchSize+=c,this.onUpdate()}addItemsToBatch(f,c){this.batch=this.batch.concat(f),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(Ie[75],ke([1,0,6,5,4,279,17,64,14,2,139]),function(X,e,u,n,S,A,C,D,E,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let I=class{constructor(w,p,g){this.extHostRpc=w,this._uriTransformer=p,this._logService=g,this._proxy=this.extHostRpc.getProxy(n.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,p){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const g=this._handlePool++;return this._textSearchProvider.set(g,p),this._proxy.$registerTextSearchProvider(g,this._transformScheme(w)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(w,p){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const g=this._handlePool++;return this._fileSearchProvider.set(g,p),this._proxy.$registerFileSearchProvider(g,this._transformScheme(w)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(w,p,g,v){const f=_(g),c=this._fileSearchProvider.get(w);if(c)return this._fileSearchManager.fileSearch(f,c,m=>{this._proxy.$handleFileMatch(w,p,m.map(a=>a.resource))},v);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,p,g,v){const f=this._textSearchProvider.get(w);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const c=_(g);return this.createTextSearchManager(c,f).search(a=>this._proxy.$handleTextMatch(w,p,a),v)}$enableExtensionHostSearch(){}createTextSearchManager(w,p){return new R.TextSearchManager(w,p,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"textSearchProvider")}};I=Ge([He(0,C.IExtHostRpcService),He(1,D.IURITransformerService),He(2,E.ILogService)],I),e.ExtHostSearch=I;function _(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(P),extraFileResources:b.extraFileResources&&b.extraFileResources.map(w=>k.URI.revive(w))}}e.reviveQuery=_;function P(b){return{...b,folder:k.URI.revive(b.folder)}}}),define(Ie[287],ke([1,0,82,138,32,135,33,37,54,38,72,74,75,91,52,67,137,68,46,90,125,55,136,14,230,47]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c,m,a,h,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(h.ILoggerService,a.ExtHostLoggerService),(0,u.registerSingleton)(h.ILogService,r.ExtHostLogService),(0,u.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,u.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,u.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,u.registerSingleton)(g.IExtHostConsumerFileSystem,g.ExtHostConsumerFileSystem),(0,u.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,u.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,u.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,u.registerSingleton)(n.IExtHostOutputService,n.ExtHostOutputService),(0,u.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,u.registerSingleton)(P.IExtHostStorage,P.ExtHostStorage),(0,u.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,u.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,u.registerSingleton)(b.IExtHostTunnelService,b.ExtHostTunnelService),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,u.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,u.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,u.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,u.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs),(0,u.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(Ie[92],ke([1,0,16,14,31,71]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=C;function D(I,_,P,b){const w=(0,u.mapArrayOrNot)(P,E),p=new S.TextSearchMatch(_,w,b),g=p.preview.matches;return{ranges:(0,u.mapArrayOrNot)(w,k),uri:I,preview:{text:p.preview.text,matches:(0,u.mapArrayOrNot)(g,k)}}}e.createTextSearchResult=D;function E(I){return new S.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(_,P){this.prefix=_,this.logService=P}appendLine(_){this.logService.debug(`${this.prefix}#search`,_)}};R=Ge([He(1,n.ILogService)],R),e.OutputChannel=R}),define(Ie[288],ke([1,0,42,9,80,30,13,8,92,289]),function(X,e,u,n,S,A,C,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(f,c,m,a){const h=_(f,c,m,a),r=c.folder.fsPath;return{cmd:u.spawn(R,h.args,{cwd:r}),rgDiskPath:R,siblingClauses:h.siblingClauses,rgArgs:h,cwd:r}}e.spawnRipgrepCmd=I;function _(f,c,m,a){const h=["--files","--hidden","--case-sensitive"];b([c],m,!1).forEach(s=>{const i=(0,E.anchorGlob)(s);if(h.push("-g",i),C.isMacintosh){const t=(0,S.normalizeNFD)(i);t!==i&&h.push("-g",t)}});const r=P([c],a,void 0,!1);return r.globArgs.forEach(s=>{const i=`!${(0,E.anchorGlob)(s)}`;if(h.push("-g",i),C.isMacintosh){const t=(0,S.normalizeNFD)(i);t!==i&&h.push("-g",t)}}),c.disregardIgnoreFiles!==!1?h.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),c.ignoreSymlinks||h.push("--follow"),f.exists&&h.push("--quiet"),h.push("--no-config"),c.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:r.siblingClauses}}function P(f,c,m,a=!0){const h=[];let r={};return f.forEach(s=>{const i=Object.assign({},s.excludePattern||{},c||{}),t=w(i,a?s.folder.fsPath:void 0,m);h.push(...t.globArgs),t.siblingClauses&&(r=Object.assign(r,t.siblingClauses))}),{globArgs:h,siblingClauses:r}}e.foldersToRgExcludeGlobs=P;function b(f,c,m=!0){const a=[];return f.forEach(h=>{const r=Object.assign({},c||{},h.includePattern||{}),s=w(r,m?h.folder.fsPath:void 0);a.push(...s.globArgs)}),a}e.foldersToIncludeGlobs=b;function w(f,c,m){const a=[],h={};return Object.keys(f).forEach(r=>{if(m&&m.has(r)||!r)return;const s=f[r];r=g(c?p(c,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof s=="boolean"&&s?(r.startsWith("\\\\")&&(r+="**"),a.push(v(r))):s&&s.when&&(h[r]=s)}),{globArgs:a,siblingClauses:h}}function p(f,c){return n.isAbsolute(c)?c:n.join(f,c)}e.getAbsoluteGlob=p;function g(f){return f=D.rtrim(f,"\\"),D.rtrim(f,"/")}function v(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=v}),define(Ie[290],ke([1,0,42,62,9,97,16,49,36,80,30,13,50,8,10,29,31,288,105]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(r=>r())});class c{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&E.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&E.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(i=>{const t=Object.assign({},i.excludePattern||{},this.config.excludePattern||{}),o=i.folder.fsPath;s.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==o).forEach(l=>{(0,R.isEqualOrParent)(l,o)&&(t[S.relative(o,l)]=!0)}),this.folderExcludePatterns.set(o,new a(t,o))})}cancel(){this.isCanceled=!0,f.forEach(s=>s())}walk(s,i,t,o,l){if(this.fileWalkSW=_.StopWatch.create(!1),this.isCanceled)return l(null,this.isLimitHit);i.forEach(d=>{const y=S.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,y)||this.matchFile(t,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=_.StopWatch.create(!1),this.parallel(s,(d,y)=>{this.call(this.cmdTraversal,this,d,t,o,L=>{if(L){const M=(0,D.toErrorMessage)(L);console.error(M),this.errors.push(M),y(L,void 0)}else y(null,void 0)})},(d,y)=>{this.fileWalkSW.stop();const L=d?C.coalesce(d)[0]:null;l(L,this.isLimitHit)})}parallel(s,i,t){const o=new Array(s.length),l=new Array(s.length);let d=!1,y=0;if(s.length===0)return t(null,[]);s.forEach((L,M)=>{i(L,(F,T)=>{if(F?(d=!0,o[M]=null,l[M]=F):(o[M]=T,l[M]=null),++y===s.length)return t(d?l:null,o)})})}call(s,i,...t){try{s.apply(i,t)}catch(o){t[t.length-1](o)}}cmdTraversal(s,i,t,o){const l=s.folder.fsPath,d=I.isMacintosh,y=()=>U&&U.kill();f.add(y);let L=B=>{f.delete(y),L=()=>{},o(B)},M="";const F=this.initDirectoryTree(),T=(0,g.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression),U=T.cmd,N=!Object.keys(T.siblingClauses).length,H=T.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let te=`${T.rgDiskPath} ${H}
 - cwd: ${T.cwd}`;T.rgArgs.siblingClauses&&(te+=`
 - Sibling clauses: ${JSON.stringify(T.rgArgs.siblingClauses)}`),t({message:te}),this.cmdResultCount=0,this.collectStdout(U,"utf8",t,(B,z,q)=>{if(B){L(B);return}if(this.isLimitHit){L();return}const j=(M+(d?k.normalizeNFC(z||""):z)).split(`
`);if(q){const ie=j.length;j[ie-1]=j[ie-1].trim(),j[ie-1]||j.pop()}else M=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,N){for(const ie of j)if(this.matchFile(i,{base:l,relativePath:ie,searchPath:this.getSearchPath(s,ie)}),this.isLimitHit){y();break}(q||this.isLimitHit)&&L();return}this.addDirectoryEntries(s,F,l,j,i),q&&(this.matchDirectoryTree(F,l,i),L())})}spawnFindCmd(s){const i=this.folderExcludePatterns.get(s.folder.fsPath),t=i.getBasenameTerms(),o=i.getPathTerms(),l=["-L","."];if(t.length||o.length){l.push("-not","(","(");for(const d of t)l.push("-name",d),l.push("-o");for(const d of o)l.push("-path",d),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),u.spawn("find",l,{cwd:s.folder.fsPath})}readStdout(s,i,t){let o="";this.collectStdout(s,i,()=>{},(l,d,y)=>{if(l){t(l);return}o+=d,y&&t(null,o)})}collectStdout(s,i,t,o){let l=(L,M,F)=>{(L||F)&&(l=()=>{},this.cmdSW&&this.cmdSW.stop()),o(L,M,F)},d=!1;s.stdout?(this.forwardData(s.stdout,i,l),s.stdout.once("data",()=>d=!0)):t({message:"stdout is null"});let y;s.stderr?y=this.collectData(s.stderr):t({message:"stderr is null"}),s.on("error",L=>{l(L)}),s.on("close",L=>{let M;!d&&(M=this.decodeData(y,i))&&h(M)?l(new Error(`command failed with error code ${L}: ${this.decodeData(y,i)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),l(null,"",!0))})}forwardData(s,i,t){const o=new A.StringDecoder(i);return s.on("data",l=>{t(null,o.write(l))}),o}collectData(s){const i=[];return s.on("data",t=>{i.push(t)}),i}decodeData(s,i){const t=new A.StringDecoder(i);return s.map(o=>t.write(o)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:i},t,o,l){o.indexOf(this.filePattern)!==-1&&this.matchFile(l,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const d=y=>{const L=S.basename(y),M=S.dirname(y);let F=i[M];F||(F=i[M]=[],d(M)),F.push({base:t,relativePath:y,basename:L,searchPath:this.getSearchPath(s,y)})};o.forEach(d)}matchDirectoryTree({rootEntries:s,pathToEntries:i},t,o){const l=this,d=this.folderExcludePatterns.get(t),y=this.filePattern;function L(M){l.directoriesWalked++;const F=(0,p.hasSiblingFn)(()=>M.map(T=>T.basename));for(let T=0,U=M.length;T<U;T++){const N=M[T],{relativePath:H,basename:te}=N;if(d.test(H,te,y!==te?F:void 0))continue;const B=i[H];if(B)L(B);else{if(l.filesWalked++,H===y)continue;l.matchFile(o,N)}if(l.isLimitHit)break}}L(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,i,t,o,l){const d=s.folder,y=(0,p.hasSiblingFn)(()=>t);this.parallel(t,(L,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const F=i?[i,L].join(S.sep):L;if(this.folderExcludePatterns.get(s.folder.fsPath).test(F,L,this.config.filePattern!==L?y:void 0))return M(null);const T=[d.fsPath,F].join(S.sep);n.lstat(T,(U,N)=>{if(U||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(T,N,(H,te)=>H||this.isCanceled||this.isLimitHit?M(null):te.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(T,N,(B,z)=>B||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?M(null):(this.walkedPaths[z]=!0,w.Promises.readdir(T).then(q=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(s,F,q,o,V=>M(V||null))},q=>{M(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&b.isNumber(te.size)&&te.size>this.maxFilesize||this.matchFile(o,{base:d.fsPath,relativePath:F,searchPath:this.getSearchPath(s,F)}),M(null,void 0)))})},L=>{const M=L&&C.coalesce(L);return l(M&&M.length>0?M[0]:void 0)})}matchFile(s,i){this.isFileMatch(i)&&(!this.includePattern||this.includePattern(i.relativePath,S.basename(i.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(i))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,p.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,i,t){return i.isSymbolicLink()?n.stat(s,t):t(null,i)}realPathIfNeeded(s,i,t){return i.isSymbolicLink()?n.realpath(s,(o,l)=>o?t(o):t(null,l)):t(null,s)}getSearchPath(s,i){return s.folderName?S.join(s.folderName,i):i}}e.FileWalker=c;class m{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new c(s)}search(s,i,t){this.walker.walk(this.folderQueries,this.extraFiles,s,i,(o,l)=>{t(o,{limitHit:l,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class a{constructor(s,i){this.expression=s,this.root=i,this.init(s)}init(s){let i,t;Object.keys(s).filter(o=>s[o]).forEach(o=>{S.isAbsolute(o)?(i=i||E.getEmptyExpression(),i[o]=s[o]):(t=t||E.getEmptyExpression(),t[o]=s[o])}),this.absoluteParsedExpr=i&&E.parse(i,{trimForExclusions:!0}),this.relativeParsedExpr=t&&E.parse(t,{trimForExclusions:!0})}test(s,i,t){return this.relativeParsedExpr&&this.relativeParsedExpr(s,i,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(S.join(this.root,s),i,t)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...E.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...E.getPathTerms(this.relativeParsedExpr)),s}}function h(r){const s=r.trim().split(`
`),i=s[0].trim();if(i.startsWith("Error parsing regex"))return i;if(i.startsWith("regex parse error"))return P.uppercaseFirstLetter(s[s.length-1].trim());if(i.startsWith("error parsing glob")||i.startsWith("unsupported encoding"))return i.charAt(0).toUpperCase()+i.substr(1);if(i==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(i.startsWith("Literal "))return i}e.rgErrorMsgForDisplay=h}),define(Ie[291],ke([1,0,95,23]),function(X,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function S(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===r)}e.isUTFEncoding=S,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,C=512,D=512*8,E=512*128;var k;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(s,i){super(s);this.decodeStreamErrorKind=i}}e.DecodeStreamError=R;class I{constructor(s){this.iconvLiteDecoder=s}static async create(s){let i;if(s!==e.UTF8)i=(await new Promise((o,l)=>{X(["@vscode/iconv-lite-umd"],o,l)})).getDecoder(w(s));else{const t=new TextDecoder;i={write(o){return t.decode(o,{stream:!0})},end(){return t.decode()}}}return new I(i)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function _(r,s){const i=s.minBytesRequiredForDetection??s.guessEncoding?D:C;return new Promise((t,o)=>{const l=(0,u.newWriteableStream)(T=>T.join("")),d=[];let y=0,L,M;const F=async()=>{try{const T=await h({buffer:n.VSBuffer.concat(d),bytesRead:y},s.guessEncoding);if(T.seemsBinary&&s.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);T.encoding=await s.overwriteEncoding(T.encoding),L=await I.create(T.encoding);const U=L.write(n.VSBuffer.concat(d).buffer);l.write(U),d.length=0,y=0,t({stream:l,detected:T})}catch(T){M?.dispose(),l.destroy(),o(T)}};M=(0,u.listenStream)(r,{onData:async T=>{L?l.write(L.write(T.buffer)):(d.push(T),y+=T.byteLength,y>=i&&(r.pause(),await F(),setTimeout(()=>r.resume())))},onError:T=>l.error(T),onEnd:async()=>{L||await F(),l.end(L?.end())}})})}e.toDecodeStream=_;async function P(r,s,i){const o=(await new Promise((y,L)=>{X(["@vscode/iconv-lite-umd"],y,L)})).getEncoder(w(s),i);let l=!1,d=!1;return{read(){if(d)return null;const y=r.read();if(typeof y!="string"){if(d=!0,!l&&i?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return n.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=o.end();return L&&L.length>0?(l=!0,n.VSBuffer.wrap(L)):null}return l=!0,n.VSBuffer.wrap(o.write(y))}}}e.toEncodeReadable=P;async function b(r){return(await new Promise((i,t)=>{X(["@vscode/iconv-lite-umd"],i,t)})).encodingExists(w(r))}e.encodingExists=b;function w(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=w;function p(r,s){if(!r||s<e.UTF16be_BOM.length)return null;const i=r.readUInt8(0),t=r.readUInt8(1);if(i===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const o=r.readUInt8(2);return i===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=p;const g=["ascii","utf-16","utf-32"];async function v(r){const s=await new Promise((d,y)=>{X(["jschardet"],d,y)}),i=r.slice(0,E),t=m(i.buffer),o=s.detect(t);if(!o||!o.encoding)return null;const l=o.encoding.toLowerCase();return 0<=g.indexOf(l)?null:c(o.encoding)}const f={ibm866:"cp866",big5:"cp950"};function c(r){const s=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[s]||s}function m(r){let s="";for(let i=0;i<r.length;i++)s+=String.fromCharCode(r[i]);return s}function a(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=r.match(/windows(\d+)/);return s?"windows-"+s[1]:r}}}e.toCanonicalName=a;function h({buffer:r,bytesRead:s},i){let t=p(r,s),o=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&r){let l=!0,d=!0,y=!1;for(let L=0;L<s&&L<A;L++){const M=L%2==1,F=r.readUInt8(L)===0;if(F&&(y=!0),l&&(M&&!F||!M&&F)&&(l=!1),d&&(M&&F||!M&&!F)&&(d=!1),F&&!l&&!d)break}y&&(l?t=e.UTF16le:d?t=e.UTF16be:o=!0)}return i&&!o&&!t&&r?v(r.slice(0,s)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:o,encoding:t}}e.detectEncodingFromBuffer=h,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ie[140],ke([1,0,291,29,139]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends S.TextSearchManager{constructor(D,E,k=n,R="searchProcess"){super(D,E,{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,u.toCanonicalName)(I)},R)}}e.NativeTextSearchManager=A}),define(Ie[292],ke([1,0]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const A=this._dragOperations.get(S);return this._dragOperations.delete(S),A}}addDragOperationTransfer(S,A){this._dragOperations.set(S,A)}getRenderedTreeElement(S){if(this._renderedElements.has(S))return this._renderedElements.get(S)}addRenderedTreeItemElement(S,A){this._renderedElements.set(S,A)}removeRenderedTreeItemElement(S){this._renderedElements.has(S)&&this._renderedElements.delete(S)}}e.TreeviewsService=u}),define(Ie[293],ke([1,0,175,7,22,2,3,6,18,7,10,16,15,21,292,27]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(f,c){if((0,R.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let m;return Array.isArray(f.highlights)&&(m=f.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),m=m.length?m:void 0),{label:f.label,highlights:m}}}class g{constructor(c,m,a){this._proxy=c,this.commands=m,this.logService=a,this.treeViews=new Map,this.treeDragAndDropService=new b.TreeviewsService;function h(r){return r&&r.$treeViewId&&r.$treeItemHandle}m.registerArgumentProcessor({processArgument:r=>h(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>h(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(c,m,a){const h=this.createTreeView(c,{treeDataProvider:m},a);return{dispose:()=>h.dispose()}}createTreeView(c,m,a){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=m.dragAndDropController?.dropMimeTypes??[],r=m.dragAndDropController?.dragMimeTypes??[],s=!!m.dragAndDropController?.handleDrag,i=!!m.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:h,dragMimeTypes:r,hasHandleDrag:s,hasHandleDrop:i}),o=this.createExtHostTreeView(c,m,a);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(l){o.message=l},get title(){return o.title},set title(l){o.title=l},get description(){return o.description},set description(l){o.description=l},get badge(){return(0,w.checkProposedApiEnabled)(a,"badges"),o.badge},set badge(l){(0,w.checkProposedApiEnabled)(a,"badges"),o.badge=l},reveal:(l,d)=>o.reveal(l,d),dispose:async()=>{await t,this.treeViews.delete(c),o.dispose()}}}$getChildren(c,m){const a=this.treeViews.get(c);return a?a.getChildren(m):Promise.reject(new Error((0,u.localize)(0,null,c)))}async $handleDrop(c,m,a,h,r,s,i,t){const o=this.treeViews.get(c);if(!o)return Promise.reject(new Error((0,u.localize)(1,null,c)));const l=_.DataTransfer.toDataTransfer(a,async d=>(await this._proxy.$resolveDropFileData(c,m,d)).buffer);return i===c&&t&&await this.addAdditionalTransferItems(l,o,t,r,s),o.onDrop(l,h,r)}async addAdditionalTransferItems(c,m,a,h,r){const s=this.treeDragAndDropService.removeDragOperationTransfer(r);if(s)(await s)?.forEach((i,t)=>{i&&c.set(t,i)});else if(r&&m.handleDrag){const i=m.handleDrag(a,c,h);this.treeDragAndDropService.addDragOperationTransfer(r,i),await i}return c}async $handleDrag(c,m,a,h){const r=this.treeViews.get(c);if(!r)return Promise.reject(new Error((0,u.localize)(2,null,c)));const s=await this.addAdditionalTransferItems(new n.DataTransfer,r,m,h,a);if(!!s)return _.DataTransfer.toDataTransferDTO(s)}async $hasResolve(c){const m=this.treeViews.get(c);if(!m)throw new Error((0,u.localize)(3,null,c));return m.hasResolve}$resolve(c,m,a){const h=this.treeViews.get(c);if(!h)throw new Error((0,u.localize)(4,null,c));return h.resolveTreeItem(m,a)}$setExpanded(c,m,a){const h=this.treeViews.get(c);if(!h)throw new Error((0,u.localize)(5,null,c));h.setExpanded(m,a)}$setSelection(c,m){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(6,null,c));a.setSelection(m)}$setVisible(c,m){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(7,null,c));a.setVisible(m)}createExtHostTreeView(c,m,a){const h=new v(c,m,this._proxy,this.commands.converter,this.logService,a);return this.treeViews.set(c,h),h}convertArgument(c){const m=this.treeViews.get(c.$treeViewId);return m?m.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=g;class v extends D.Disposable{constructor(c,m,a,h,r,s){super();if(this.viewId=c,this.proxy=a,this.commands=h,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new P.CancellationTokenSource,s.contributes&&s.contributes.views)for(const o in s.contributes.views)for(const l of s.contributes.views[o])l.id===c&&(this._title=l.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let i,t;this._register(C.Event.debounce(this._onDidChangeData.event,(o,l)=>(o||(o={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(d=>t=d),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(l.element)?o.elements.push(...l.element):o.elements.push(l.element)),l.message&&(o.message=!0),o),200,!0)(({message:o,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=t;return i=null,this.refresh(l).then(()=>d())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,R.isUndefinedOrNull)(c))}async getChildren(c){const m=c?this.getExtensionElement(c):void 0;if(c&&!m)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let a=this.getChildrenNodes(c);return a||(a=await this.fetchChildrenNodes(m)),a?a.map(h=>h.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,m){m=m||{select:!0,focus:!1};const a=(0,R.isUndefinedOrNull)(m.select)?!0:m.select,h=(0,R.isUndefinedOrNull)(m.focus)?!1:m.focus,r=(0,R.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(s=>this.resolveTreeNode(c,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(t=>t.item)},{select:a,focus:h,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:a,focus:h,expand:r})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=_.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,m){const a=this.getExtensionElement(c);a&&(m?this._onDidExpandElement.fire(Object.freeze({element:a})):this._onDidCollapseElement.fire(Object.freeze({element:a})))}setSelection(c){(0,I.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(c,m,a){const h=[];for(const r of c){const s=this.getExtensionElement(r);s&&h.push(s)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,m,a),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,m,a){const h=m?this.getExtensionElement(m):void 0;if(!(!h&&m||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,c,a):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,m){if(!this.dataProvider.resolveTreeItem)return;const a=this.elements.get(c);if(a){const h=this.nodes.get(a);if(h){const r=await this.dataProvider.resolveTreeItem(h.extensionItem,a,m)??h.extensionItem;return h.item.tooltip=this.getTooltip(r.tooltip),h.item.command=this.getCommand(h.disposableStore,r.command),h.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(m=>m?this.resolveUnknownParentChain(m).then(a=>this.resolveTreeNode(m,a[a.length-1]).then(h=>(a.push(h),a))):Promise.resolve([]))}resolveParent(c){const m=this.nodes.get(c);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,m){const a=this.nodes.get(c);return a?Promise.resolve(a):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(h=>this.createHandle(c,h,m,!0)).then(h=>this.getChildren(m?m.item.handle:void 0).then(()=>{const r=this.getExtensionElement(h);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(c){if(c){let m;if(typeof c=="string"){const a=this.getExtensionElement(c);m=a?this.nodes.get(a):void 0}else m=c;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const m=new P.CancellationTokenSource(this._refreshCancellationSource.token);try{const a=c?this.nodes.get(c):void 0,h=await this.dataProvider.getChildren(c);if(m.token.isCancellationRequested)return;const r=await Promise.all((0,I.coalesce)(h||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,a):null}));return m.token.isCancellationRequested?void 0:(0,I.coalesce)(r)}finally{m.dispose()}}refresh(c){if(c.some(a=>!a))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new P.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const a=this.getHandlesToRefresh(c);if(a.length)return this.refreshHandles(a)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const m=new Set,a=c.map(r=>this.nodes.get(r));for(const r of a)if(r&&!m.has(r.item.handle)){let s=r;for(;s&&s.parent&&a.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&m.add(r.item.handle)}const h=[];return m.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!m.has(i.parent.item.handle))&&h.push(r)}}),h}refreshHandles(c){const m={};return Promise.all(c.map(a=>this.refreshNode(a).then(h=>{h&&(m[a]=h.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(c){const m=this.getExtensionElement(c);if(m){const a=this.nodes.get(m);if(a)return this.clearChildren(m),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(h=>{if(h){const r=this.createTreeNode(m,h,a.parent);return this.updateNodeCache(m,r,a,a.parent),a.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,m,a){const h=this.createTreeNode(c,m,a);if(m.id&&this.elements.has(h.item.handle))throw new Error((0,u.localize)(8,null,m.id));return this.addNodeToCache(c,h),this.addNodeToParentCache(h,a),h}getTooltip(c){return k.MarkdownString.isMarkdownString(c)?_.MarkdownString.from(c):c}getCommand(c,m){return m?this.commands.toInternal(m,c):void 0}createTreeNode(c,m,a){const h=new D.DisposableStore,r=this.createHandle(c,m,a),s=this.getLightIconPath(m);return{item:{handle:r,parentHandle:a?a.item.handle:void 0,label:p(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(h,m.command),contextValue:m.contextValue,icon:s,iconDark:this.getDarkIconPath(m)||s,themeIcon:this.getThemeIcon(m),collapsibleState:(0,R.isUndefinedOrNull)(m.collapsibleState)?k.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:a,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(c){return c.iconPath instanceof k.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:m,label:a,resourceUri:h},r,s){if(m)return`${v.ID_HANDLE_PREFIX}/${m}`;const i=p(a,this.extension),t=r?r.item.handle:v.LABEL_HANDLE_PREFIX;let o=i?i.label:h?(0,S.basename)(h):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const l=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,d=this.getChildrenNodes(r)||[];let y,L=0;do{if(y=`${t}/${L}:${o}`,s||!this.elements.has(y)||l===y)break;L++}while(L<=d.length);return y}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon))return typeof c.iconPath=="string"||A.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return A.URI.isUri(c)?c:A.URI.file(c)}addNodeToCache(c,m){this.elements.set(m.item.handle,c),this.nodes.set(c,m)}updateNodeCache(c,m,a,h){this.elements.delete(m.item.handle),this.nodes.delete(c),m.item.handle!==a.item.handle&&this.elements.delete(a.item.handle),this.addNodeToCache(c,m);const r=this.getChildrenNodes(h)||[],s=r.filter(i=>i.item.handle===a.item.handle)[0];s&&r.splice(r.indexOf(s),1,m)}addNodeToParentCache(c,m){m?(m.children||(m.children=[]),m.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const m=this.nodes.get(c);if(m){if(m.children)for(const a of m.children){const h=this.elements.get(a.item.handle);h&&this.clear(h)}m.children=void 0}}else this.clearAll()}clear(c){const m=this.nodes.get(c);if(m){if(m.children)for(const a of m.children){const h=this.elements.get(a.item.handle);h&&this.clear(h)}this.nodes.delete(c),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ie[294],ke([1,0,21,12,3,41,2,115,100,148,157,43,5,134,239,238,37,240,33,242,243,244,222,245,54,39,246,247,250,251,252,138,225,256,257,258,91,38,260,293,15,7,263,70,137,32,212,249,123,135,72,74,75,14,64,17,26,253,208,52,67,236,261,69,68,266,264,265,237,46,259,262,90,55,125,254,71,255,11,118,224,206,248,6,27,213,8]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c,m,a,h,r,s,i,t,o,l,d,y,L,M,F,T,U,N,H,te,B,z,q,V,j,ie,Q,ue,ve,J,ge,Ee,Pe,me,Te,le,pe,be,ae,he,ee,ne,O,$,G,K,de,we,se,De,Ce,ze,Ke,Ne,Ye,Z,re,ye,We,oe,Re,Be,qe,je,Ve,nt,ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function st(it){const at=it.get(pe.IExtHostInitDataService),bt=it.get(De.IExtHostFileSystemInfo),Pt=it.get(G.IExtHostConsumerFileSystem),St=it.get(s.IExtHostExtensionService),ft=it.get(ie.IExtHostWorkspace),It=it.get(Ye.IExtHostTelemetry),Ft=it.get(v.IExtHostConfiguration),At=it.get(Te.IURITransformerService),Xe=it.get(le.IExtHostRpcService),Rt=it.get(U.IExtHostStorage),Mt=it.get($.IExtensionStoragePaths),Ot=it.get(me.ILoggerService),mt=it.get(me.ILogService),Dt=it.get(he.IExtHostTunnelService),Ae=it.get(ee.IExtHostApiDeprecationService),Oe=it.get(j.IExtHostWindow),Se=it.get(Ke.IExtHostSecretState),Y=it.get(Ne.IExtHostEditorTabs);Xe.set(_.ExtHostContext.ExtHostFileSystemInfo,bt),Xe.set(_.ExtHostContext.ExtHostLogLevelServiceShape,Ot),Xe.set(_.ExtHostContext.ExtHostWorkspace,ft),Xe.set(_.ExtHostContext.ExtHostConfiguration,Ft),Xe.set(_.ExtHostContext.ExtHostExtensionService,St),Xe.set(_.ExtHostContext.ExtHostStorage,Rt),Xe.set(_.ExtHostContext.ExtHostTunnelService,Dt),Xe.set(_.ExtHostContext.ExtHostWindow,Oe),Xe.set(_.ExtHostContext.ExtHostSecretState,Se),Xe.set(_.ExtHostContext.ExtHostTelemetry,It),Xe.set(_.ExtHostContext.ExtHostEditorTabs,Y);const Fe=Xe.set(_.ExtHostContext.ExtHostDecorations,it.get(J.IExtHostDecorations)),xe=Xe.set(_.ExtHostContext.ExtHostDocumentsAndEditors,it.get(r.IExtHostDocumentsAndEditors)),Je=Xe.set(_.ExtHostContext.ExtHostCommands,it.get(p.IExtHostCommands)),et=Xe.set(_.ExtHostContext.ExtHostTerminalService,it.get(N.IExtHostTerminalService)),Ze=Xe.set(_.ExtHostContext.ExtHostDebugService,it.get(Ee.IExtHostDebugService)),gt=Xe.set(_.ExtHostContext.ExtHostSearch,it.get(Pe.IExtHostSearch)),pt=Xe.set(_.ExtHostContext.ExtHostTask,it.get(ge.IExtHostTask)),yt=Xe.set(_.ExtHostContext.ExtHostOutputService,it.get(y.IExtHostOutputService)),vt=Xe.set(_.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Xe)),ht=Xe.set(_.ExtHostContext.ExtHostDocuments,new h.ExtHostDocuments(Xe,xe)),Kt=Xe.set(_.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Xe,xe,mt)),Xt=Xe.set(_.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(mt,ht,Xe.getProxy(_.MainContext.MainThreadBulkEdits))),Et=Xe.set(_.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(Xe,Je,xe,ht,Mt)),rn=Xe.set(_.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(Et)),Ut=Xe.set(_.ExtHostContext.ExtHostNotebookEditors,new Re.ExtHostNotebookEditors(mt,Et)),sn=Xe.set(_.ExtHostContext.ExtHostNotebookKernels,new Z.ExtHostNotebookKernels(Xe,at,Et,Je,mt)),kn=Xe.set(_.ExtHostContext.ExtHostNotebookRenderers,new ye.ExtHostNotebookRenderers(Xe,Et)),kt=Xe.set(_.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(Xe,xe)),xt=Xe.set(_.ExtHostContext.ExtHostTreeViews,new te.ExtHostTreeViews(Xe.getProxy(_.MainContext.MainThreadTreeViews),Je,mt)),fn=Xe.set(_.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(Xe.getProxy(_.MainContext.MainThreadEditorInsets),kt,at.remote)),Qt=Xe.set(_.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Xe,mt,bt)),Yt=Xe.set(_.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Xe,ht,Je.converter,At)),dt=Xe.set(_.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Xe,At,ht,Je,Qt,mt,Ae)),mn=Xe.set(_.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Xe,dt)),Bt=Xe.set(_.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Xe,mt,xe)),Vt=Xe.set(_.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Xe,ft,Je)),on=Xe.set(_.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Xe,Je,mt)),Tn=Xe.set(_.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Xe,Je,ht)),Sn=Xe.set(_.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Xe.getProxy(_.MainContext.MainThreadProgress))),gn=Xe.set(_.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Xe)),an=Xe.set(_.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Xe)),Jt=Xe.set(_.ExtHostContext.ExtHostAuthentication,new ne.ExtHostAuthentication(Xe)),pn=Xe.set(_.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Xe,Je)),vn=Xe.set(_.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Xe,at.remote,ft,mt,Ae)),Zt=Xe.set(_.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Xe,vn,ft)),wn=Xe.set(_.ExtHostContext.ExtHostCustomEditors,new de.ExtHostCustomEditors(Xe,ht,Mt,vn,Zt)),Pn=Xe.set(_.ExtHostContext.ExtHostWebviewViews,new K.ExtHostWebviewViews(Xe,vn)),en=Xe.set(_.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(Xe,Je)),An=Xe.set(_.ExtHostContext.ExtHostUriOpeners,new ze.ExtHostUriOpeners(Xe));Xe.set(_.ExtHostContext.ExtHostInteractive,new qe.ExtHostInteractive(Xe,Et,xe,Je,mt));const Rn=Object.values(_.ExtHostContext);Xe.assertRegistered(Rn);const Ln=new se.ExtHostBulkEdits(Xe,xe),On=new w.ExtHostClipboard(Xe),tn=new d.ExtHostMessageService(Xe,mt),cn=new c.ExtHostDialogs(Xe),yn=new T.ExtHostStatusBar(Xe,Je.converter);return b.ExtHostApiCommands.register(Je),function($e,$t,nn){const wt=function(){let fe=!$e.isUnderDevelopment;function _e(){fe||(mt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")_e();else{const _t=ct;typeof _t.scheme=="undefined"&&_e(),typeof _t.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ct}}(),Nn={getSession(fe,_e,Ue){return Jt.getSession($e,fe,_e,Ue)},async hasSession(fe,_e){return(0,Ve.checkProposedApiEnabled)($e,"authSession"),!!await Jt.getSession($e,fe,_e,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(fe,_e,Ue,ct){return Jt.registerAuthenticationProvider(fe,_e,Ue,ct)}},Fn={registerCommand(fe,_e,Ue){return Je.registerCommand(!0,fe,_e,Ue,void 0,$e)},registerTextEditorCommand(fe,_e,Ue){return Je.registerCommand(!0,fe,(...ct)=>{const _t=kt.getActiveTextEditor();if(!_t){mt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return _t.edit(Tt=>{_e.apply(Ue,[_t,Tt,...ct])}).then(Tt=>{Tt||mt.warn("Edits from command "+fe+" were not applied.")},Tt=>{mt.warn("An error occurred while running command "+fe,Tt)})},void 0,void 0,$e)},registerDiffInformationCommand:(fe,_e,Ue)=>((0,Ve.checkProposedApiEnabled)($e,"diffCommand"),Je.registerCommand(!0,fe,async(...ct)=>{const _t=xe.activeEditor(!0);if(!_t){mt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Tt=await kt.getDiffInformation(_t.id);_e.apply(Ue,[Tt,...ct])},void 0,void 0,$e)),executeCommand(fe,..._e){return Je.executeCommand(fe,..._e)},getCommands(fe=!1){return Je.getCommands(fe)}},Cn={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return On.value},get shell(){return et.getDefaultShell(!1)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)($e,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)($e,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const fe=Date.now()-new Date(at.telemetryInfo.firstSessionDate).getTime();return isNaN(fe)?!1:fe<1e3*60*60*24},openExternal(fe,_e){return Oe.openUri(fe,{allowTunneling:!!at.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===at.environment.appUriScheme)return vt.createAppUri(fe);try{return await Oe.asExternalUri(fe,{allowTunneling:!!at.remote.authority})}catch(_e){if((0,oe.matchesScheme)(fe,We.Schemas.http)||(0,oe.matchesScheme)(fe,We.Schemas.https))return fe;throw _e}},get remoteName(){return(0,ve.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)($e,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind}};at.environment.extensionTestsLocationURI||Object.freeze(Cn);const bn={createTestController(fe,_e,Ue){return en.createTestController(fe,_e,Ue)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),en.createTestObserver()},runTests(fe){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),en.runTests(fe)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),en.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),en.results}},ln=at.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,zt={getExtension(fe,_e){(0,ot.equalsIgnoreCase)(fe,"ms-vscode.references-view")&&(Ae.report("The extension 'ms-vscode.references-view' has been renamed.",$e,"Use 'vscode.references-view' instead."),fe="vscode.references-view"),(0,Ve.isProposedApiEnabled)($e,"extensionsAny")||(_e=!1);const Ue=$t.mine.getExtensionDescription(fe);if(Ue)return new s.Extension(St,$e.identifier,Ue,ln,!1);if(_e){const ct=$t.all.getExtensionDescription(fe);if(ct)return new s.Extension(St,$e.identifier,ct,ln,!0)}},get all(){const fe=[];for(const _e of $t.mine.getAllExtensionDescriptions())fe.push(new s.Extension(St,$e.identifier,_e,ln,!1));return fe},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)($e,"extensionsAny");const fe=new Ve.ExtensionIdentifierSet($t.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),_e=[];for(const Ue of $t.all.getAllExtensionDescriptions()){const ct=!fe.has(Ue.identifier);_e.push(new s.Extension(St,$e.identifier,Ue,ln,ct))}return _e},get onDidChange(){return(0,Ve.isProposedApiEnabled)($e,"extensionsAny")?S.Event.any($t.mine.onDidChange,$t.all.onDidChange):$t.mine.onDidChange}},jt={createDiagnosticCollection(fe){return Qt.createDiagnosticCollection($e.identifier,fe)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:fe=>Qt.getDiagnostics(fe),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(fe,_e){return Yt.changeLanguage(fe.uri,_e)},match(fe,_e){const Ue=ht.getDocumentData(_e.uri)?.notebook;return(0,R.score)(B.LanguageSelector.from(fe),_e.uri,_e.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(fe,_e,Ue){return dt.registerCodeActionProvider($e,wt(fe),_e,Ue)},registerDocumentPasteEditProvider(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,wt(fe),_e,Ue)},registerCodeLensProvider(fe,_e){return dt.registerCodeLensProvider($e,wt(fe),_e)},registerDefinitionProvider(fe,_e){return dt.registerDefinitionProvider($e,wt(fe),_e)},registerDeclarationProvider(fe,_e){return dt.registerDeclarationProvider($e,wt(fe),_e)},registerImplementationProvider(fe,_e){return dt.registerImplementationProvider($e,wt(fe),_e)},registerTypeDefinitionProvider(fe,_e){return dt.registerTypeDefinitionProvider($e,wt(fe),_e)},registerHoverProvider(fe,_e){return dt.registerHoverProvider($e,wt(fe),_e,$e.identifier)},registerEvaluatableExpressionProvider(fe,_e){return dt.registerEvaluatableExpressionProvider($e,wt(fe),_e,$e.identifier)},registerInlineValuesProvider(fe,_e){return dt.registerInlineValuesProvider($e,wt(fe),_e,$e.identifier)},registerDocumentHighlightProvider(fe,_e){return dt.registerDocumentHighlightProvider($e,wt(fe),_e)},registerLinkedEditingRangeProvider(fe,_e){return dt.registerLinkedEditingRangeProvider($e,wt(fe),_e)},registerReferenceProvider(fe,_e){return dt.registerReferenceProvider($e,wt(fe),_e)},registerRenameProvider(fe,_e){return dt.registerRenameProvider($e,wt(fe),_e)},registerDocumentSymbolProvider(fe,_e,Ue){return dt.registerDocumentSymbolProvider($e,wt(fe),_e,Ue)},registerWorkspaceSymbolProvider(fe){return dt.registerWorkspaceSymbolProvider($e,fe)},registerDocumentFormattingEditProvider(fe,_e){return dt.registerDocumentFormattingEditProvider($e,wt(fe),_e)},registerDocumentRangeFormattingEditProvider(fe,_e){return dt.registerDocumentRangeFormattingEditProvider($e,wt(fe),_e)},registerOnTypeFormattingEditProvider(fe,_e,Ue,...ct){return dt.registerOnTypeFormattingEditProvider($e,wt(fe),_e,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(fe,_e,Ue){return dt.registerDocumentSemanticTokensProvider($e,wt(fe),_e,Ue)},registerDocumentRangeSemanticTokensProvider(fe,_e,Ue){return dt.registerDocumentRangeSemanticTokensProvider($e,wt(fe),_e,Ue)},registerSignatureHelpProvider(fe,_e,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider($e,wt(fe),_e,Ue):dt.registerSignatureHelpProvider($e,wt(fe),_e,typeof Ue=="undefined"?[]:[Ue,...ct])},registerCompletionItemProvider(fe,_e,...Ue){return dt.registerCompletionItemProvider($e,wt(fe),_e,Ue)},registerInlineCompletionItemProvider(fe,_e){return _e.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,wt(fe),_e)},registerInlineCompletionItemProviderNew(fe,_e){if((0,Ve.checkProposedApiEnabled)($e,"inlineCompletionsNew"),_e.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)($e,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew($e,wt(fe),_e)},registerDocumentLinkProvider(fe,_e){return dt.registerDocumentLinkProvider($e,wt(fe),_e)},registerColorProvider(fe,_e){return dt.registerColorProvider($e,wt(fe),_e)},registerFoldingRangeProvider(fe,_e){return dt.registerFoldingRangeProvider($e,wt(fe),_e)},registerSelectionRangeProvider(fe,_e){return dt.registerSelectionRangeProvider($e,fe,_e)},registerCallHierarchyProvider(fe,_e){return dt.registerCallHierarchyProvider($e,fe,_e)},registerTypeHierarchyProvider(fe,_e){return dt.registerTypeHierarchyProvider($e,fe,_e)},setLanguageConfiguration:(fe,_e)=>dt.setLanguageConfiguration($e,fe,_e),getTokenInformationAtPosition(fe,_e){return(0,Ve.checkProposedApiEnabled)($e,"tokenInformation"),Yt.tokenAtPosition(fe,_e)},registerInlayHintsProvider(fe,_e){return dt.registerInlayHintsProvider($e,fe,_e)},createLanguageStatusItem(fe,_e){return Yt.createLanguageStatusItem($e,fe,_e)},registerDocumentOnDropEditProvider(fe,_e){return(0,Ve.checkProposedApiEnabled)($e,"textEditorDrop"),dt.registerDocumentOnDropEditProvider($e,fe,_e)}},Mn={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return et.activeTerminal},get terminals(){return et.terminals},async showTextDocument(fe,_e,Ue){const ct=await(C.URI.isUri(fe)?Promise.resolve(Nt.openTextDocument(fe)):Promise.resolve(fe));return kt.showTextDocument(ct,_e,Ue)},createTextEditorDecorationType(fe){return kt.createTextEditorDecorationType($e,fe)},onDidChangeActiveTextEditor(fe,_e,Ue){return kt.onDidChangeActiveTextEditor(fe,_e,Ue)},onDidChangeVisibleTextEditors(fe,_e,Ue){return kt.onDidChangeVisibleTextEditors(fe,_e,Ue)},onDidChangeTextEditorSelection(fe,_e,Ue){return kt.onDidChangeTextEditorSelection(fe,_e,Ue)},onDidChangeTextEditorOptions(fe,_e,Ue){return kt.onDidChangeTextEditorOptions(fe,_e,Ue)},onDidChangeTextEditorVisibleRanges(fe,_e,Ue){return kt.onDidChangeTextEditorVisibleRanges(fe,_e,Ue)},onDidChangeTextEditorViewColumn(fe,_e,Ue){return kt.onDidChangeTextEditorViewColumn(fe,_e,Ue)},onDidCloseTerminal(fe,_e,Ue){return et.onDidCloseTerminal(fe,_e,Ue)},onDidOpenTerminal(fe,_e,Ue){return et.onDidOpenTerminal(fe,_e,Ue)},onDidChangeActiveTerminal(fe,_e,Ue){return et.onDidChangeActiveTerminal(fe,_e,Ue)},onDidChangeTerminalDimensions(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"terminalDimensions"),et.onDidChangeTerminalDimensions(fe,_e,Ue)},onDidChangeTerminalState(fe,_e,Ue){return et.onDidChangeTerminalState(fe,_e,Ue)},onDidWriteTerminalData(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),et.onDidWriteTerminalData(fe,_e,Ue)},get state(){return Oe.state},onDidChangeWindowState(fe,_e,Ue){return Oe.onDidChangeWindowState(fe,_e,Ue)},showInformationMessage(fe,..._e){return tn.showMessage($e,A.default.Info,fe,_e[0],_e.slice(1))},showWarningMessage(fe,..._e){return tn.showMessage($e,A.default.Warning,fe,_e[0],_e.slice(1))},showErrorMessage(fe,..._e){return tn.showMessage($e,A.default.Error,fe,_e[0],_e.slice(1))},showQuickPick(fe,_e,Ue){return Vt.showQuickPick(fe,_e,Ue)},showWorkspaceFolderPick(fe){return Vt.showWorkspaceFolderPick(fe)},showInputBox(fe,_e){return Vt.showInput(fe,_e)},showOpenDialog(fe){return cn.showOpenDialog(fe)},showSaveDialog(fe){return cn.showSaveDialog(fe)},createStatusBarItem(fe,_e,Ue){let ct,_t,Tt;return typeof fe=="string"?(ct=fe,_t=_e,Tt=Ue):(_t=fe,Tt=_e),yn.createStatusBarEntry($e,ct,_t,Tt)},setStatusBarMessage(fe,_e){return yn.setStatusBarMessage(fe,_e)},withScmProgress(fe){return Ae.report("window.withScmProgress",$e,"Use 'withProgress' instead."),Sn.withProgress($e,{location:z.ProgressLocation.SourceControl},(_e,Ue)=>fe({report(ct){}}))},withProgress(fe,_e){return Sn.withProgress($e,fe,_e)},createOutputChannel(fe,_e){return yt.createOutputChannel(fe,_e,$e)},createWebviewPanel(fe,_e,Ue,ct){return Zt.createWebviewPanel($e,fe,_e,Ue,ct)},createWebviewTextEditorInset(fe,_e,Ue,ct){return(0,Ve.checkProposedApiEnabled)($e,"editorInsets"),fn.createWebviewEditorInset(fe,_e,Ue,ct,$e)},createTerminal(fe,_e,Ue){return typeof fe=="object"?"pty"in fe?et.createExtensionTerminal(fe):et.createTerminalFromOptions(fe):et.createTerminal(fe,_e,Ue)},registerTerminalLinkProvider(fe){return et.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,_e){return et.registerProfileProvider($e,fe,_e)},registerTreeDataProvider(fe,_e){return xt.registerTreeDataProvider(fe,_e,$e)},createTreeView(fe,_e){return xt.createTreeView(fe,_e,$e)},registerWebviewPanelSerializer:(fe,_e)=>Zt.registerWebviewPanelSerializer($e,fe,_e),registerCustomEditorProvider:(fe,_e,Ue={})=>wn.registerCustomEditorProvider($e,fe,_e,Ue),registerFileDecorationProvider(fe){return Fe.registerFileDecorationProvider(fe,$e.identifier)},registerUriHandler(fe){return vt.registerUriHandler($e.identifier,fe)},createQuickPick(){return Vt.createQuickPick($e)},createInputBox(){return Vt.createInputBox($e)},get activeColorTheme(){return an.activeColorTheme},onDidChangeActiveColorTheme(fe,_e,Ue){return an.onDidChangeActiveColorTheme(fe,_e,Ue)},registerWebviewViewProvider(fe,_e,Ue){return Pn.registerWebviewViewProvider($e,fe,_e,Ue?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,_e,Ue){return Et.onDidChangeActiveNotebookEditor(fe,_e,Ue)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(fe,_e,Ue){return Ut.onDidChangeNotebookEditorSelection(fe,_e,Ue)},onDidChangeNotebookEditorVisibleRanges(fe,_e,Ue){return Ut.onDidChangeNotebookEditorVisibleRanges(fe,_e,Ue)},showNotebookDocument(fe,_e){return C.URI.isUri(fe)&&Ae.report("window.showNotebookDocument(uri)",$e,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),Et.showNotebookDocument(fe,_e)},registerExternalUriOpener(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"externalUriOpener"),An.registerExternalUriOpener($e.identifier,fe,_e,Ue)},get tabGroups(){return Y.tabGroups}},Nt={get rootPath(){return Ae.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(fe){throw n.readonly()},getWorkspaceFolder(fe){return ft.getWorkspaceFolder(fe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(fe){throw n.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(fe){throw n.readonly()},updateWorkspaceFolders:(fe,_e,...Ue)=>ft.updateWorkspaceFolders($e,fe,_e||0,...Ue),onDidChangeWorkspaceFolders:function(fe,_e,Ue){return ft.onDidChangeWorkspace(fe,_e,Ue)},asRelativePath:(fe,_e)=>ft.getRelativePath(fe,_e),findFiles:(fe,_e,Ue,ct)=>ft.findFiles(fe,_e,Ue,$e.identifier,ct),findTextInFiles:(fe,_e,Ue,ct)=>{(0,Ve.checkProposedApiEnabled)($e,"findTextInFiles");let _t,Tt;return typeof _e=="object"?(_t=_e,Tt=Ue):(_t={},Tt=_e,ct=Ue),ft.findTextInFiles(fe,_t||{},Tt,$e.identifier,ct)},saveAll:fe=>ft.saveAll(fe),applyEdit(fe){return Ln.applyWorkspaceEdit(fe,$e)},createFileSystemWatcher:(fe,_e,Ue,ct)=>Bt.createFileSystemWatcher(ft,$e,fe,_e,Ue,ct),get textDocuments(){return ht.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw n.readonly()},openTextDocument(fe){let _e;const Ue=fe;if(typeof fe=="string")_e=Promise.resolve(C.URI.file(fe));else if(C.URI.isUri(fe))_e=Promise.resolve(fe);else if(!Ue||typeof Ue=="object")_e=ht.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(ct=>ht.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(fe,_e,Ue)=>ht.onDidAddDocument(fe,_e,Ue),onDidCloseTextDocument:(fe,_e,Ue)=>ht.onDidRemoveDocument(fe,_e,Ue),onDidChangeTextDocument:(fe,_e,Ue)=>ht.onDidChangeDocument(fe,_e,Ue),onDidSaveTextDocument:(fe,_e,Ue)=>ht.onDidSaveDocument(fe,_e,Ue),onWillSaveTextDocument:(fe,_e,Ue)=>Xt.getOnWillSaveTextDocumentEvent($e)(fe,_e,Ue),get notebookDocuments(){return Et.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,_e){let Ue;if(C.URI.isUri(fe))Ue=fe,await Et.openNotebookDocument(fe);else if(typeof fe=="string")Ue=C.URI.revive(await Et.createNotebookDocument({viewType:fe,content:_e}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(fe,_e,Ue){return rn.onDidSaveNotebookDocument(fe,_e,Ue)},onDidChangeNotebookDocument(fe,_e,Ue){return rn.onDidChangeNotebookDocument(fe,_e,Ue)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(fe,_e,Ue,ct){return Et.registerNotebookSerializer($e,fe,_e,Ue,(0,Ve.isProposedApiEnabled)($e,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(fe,_e,Ue,ct)=>((0,Ve.checkProposedApiEnabled)($e,"notebookContentProvider"),Ae.report("workspace.registerNotebookContentProvider",$e,"The notebookContentProvider API is not on track for finalization and will be removed."),Et.registerNotebookContentProvider($e,fe,_e,Ue,(0,Ve.isProposedApiEnabled)($e,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(fe,_e,Ue)=>nn.onDidChangeConfiguration(fe,_e,Ue),getConfiguration(fe,_e){return _e=arguments.length===1?void 0:_e,nn.getConfiguration(fe,_e,$e)},registerTextDocumentContentProvider(fe,_e){return Kt.registerTextDocumentContentProvider(fe,_e)},registerTaskProvider:(fe,_e)=>(Ae.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider($e,fe,_e)),registerFileSystemProvider(fe,_e,Ue){return(0,je.combinedDisposable)(mn.registerFileSystemProvider($e,fe,_e,Ue),Pt.addFileSystemProvider(fe,_e))},get fs(){return Pt.value},registerFileSearchProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"fileSearchProvider"),gt.registerFileSearchProvider(fe,_e)),registerTextSearchProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"textSearchProvider"),gt.registerTextSearchProvider(fe,_e)),registerRemoteAuthorityResolver:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),St.registerRemoteAuthorityResolver(fe,_e)),registerResourceLabelFormatter:fe=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),gn.$registerResourceLabelFormatter(fe)),onDidCreateFiles:(fe,_e,Ue)=>Bt.onDidCreateFile(fe,_e,Ue),onDidDeleteFiles:(fe,_e,Ue)=>Bt.onDidDeleteFile(fe,_e,Ue),onDidRenameFiles:(fe,_e,Ue)=>Bt.onDidRenameFile(fe,_e,Ue),onWillCreateFiles:(fe,_e,Ue)=>Bt.getOnWillCreateFileEvent($e)(fe,_e,Ue),onWillDeleteFiles:(fe,_e,Ue)=>Bt.getOnWillDeleteFileEvent($e)(fe,_e,Ue),onWillRenameFiles:(fe,_e,Ue)=>Bt.getOnWillRenameFileEvent($e)(fe,_e,Ue),openTunnel:fe=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),Dt.openTunnel($e,fe).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,Ve.checkProposedApiEnabled)($e,"resolvers"),Dt.getTunnels()},onDidChangeTunnels:(fe,_e,Ue)=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),Dt.onDidChangeTunnels(fe,_e,Ue)),registerPortAttributesProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"portsAttributes"),Dt.registerPortsAttributesProvider(fe,_e)),registerTimelineProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"timeline"),pn.registerTimelineProvider(fe,_e,$e.identifier,Je.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:fe=>((0,Ve.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,_e,Ue)=>ft.onDidGrantWorkspaceTrust(fe,_e,Ue)},un={get inputBox(){return Ae.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),on.getLastInputBox($e)},createSourceControl(fe,_e,Ue){return on.createSourceControl($e,fe,_e,Ue)}},Un={createCommentController(fe,_e){return Tn.createCommentController($e,fe,_e)}},Bn={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(fe,_e,Ue){return Ze.onDidStartDebugSession(fe,_e,Ue)},onDidTerminateDebugSession(fe,_e,Ue){return Ze.onDidTerminateDebugSession(fe,_e,Ue)},onDidChangeActiveDebugSession(fe,_e,Ue){return Ze.onDidChangeActiveDebugSession(fe,_e,Ue)},onDidReceiveDebugSessionCustomEvent(fe,_e,Ue){return Ze.onDidReceiveDebugSessionCustomEvent(fe,_e,Ue)},onDidChangeBreakpoints(fe,_e,Ue){return Ze.onDidChangeBreakpoints(fe,_e,Ue)},registerDebugConfigurationProvider(fe,_e,Ue){return Ze.registerDebugConfigurationProvider(fe,_e,Ue||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,_e){return Ze.registerDebugAdapterDescriptorFactory($e,fe,_e)},registerDebugAdapterTrackerFactory(fe,_e){return Ze.registerDebugAdapterTrackerFactory(fe,_e)},startDebugging(fe,_e,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Ze.startDebugging(fe,_e,{parentSession:Ue}):Ze.startDebugging(fe,_e,Ue||{})},stopDebugging(fe){return Ze.stopDebugging(fe)},addBreakpoints(fe){return Ze.addBreakpoints(fe)},removeBreakpoints(fe){return Ze.removeBreakpoints(fe)},asDebugSourceUri(fe,_e){return Ze.asDebugSourceUri(fe,_e)}},zn={registerTaskProvider:(fe,_e)=>pt.registerTaskProvider($e,fe,_e),fetchTasks:fe=>pt.fetchTasks(fe),executeTask:fe=>pt.executeTask($e,fe),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(fe,_e,Ue)=>pt.onDidStartTask(fe,_e,Ue),onDidEndTask:(fe,_e,Ue)=>pt.onDidEndTask(fe,_e,Ue),onDidStartTaskProcess:(fe,_e,Ue)=>pt.onDidStartTaskProcess(fe,_e,Ue),onDidEndTaskProcess:(fe,_e,Ue)=>pt.onDidEndTaskProcess(fe,_e,Ue)},Wn={createNotebookController(fe,_e,Ue,ct,_t){return sn.createNotebookController($e,fe,_e,Ue,ct,(0,Ve.isProposedApiEnabled)($e,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(fe,_e)=>Et.registerNotebookCellStatusBarItemProvider($e,fe,_e),createRendererMessaging(fe){return kn.createRendererMessaging($e,fe)},onDidChangeNotebookCellExecutionState(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"notebookCellExecutionState"),sn.onDidChangeNotebookCellExecutionState(fe,_e,Ue)}};return{version:at.version,authentication:Nn,commands:Fn,comments:Un,debug:Bn,env:Cn,extensions:zt,languages:jt,notebooks:Wn,scm:un,tasks:zn,tests:bn,window:Mn,workspace:Nt,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:n.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:_.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:z.InlineCompletionTriggerKindNew,EventEmitter:S.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionItemNew:z.InlineSuggestionNew,InlineCompletionList:z.InlineSuggestionList,InlineCompletionListNew:z.InlineSuggestionsNew,Hover:z.Hover,IndentAction:k.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:P.UIKind,Uri:C.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookEdit:z.NotebookEdit,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:re.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=st}),define(Ie[295],ke([1,0,268,304,305,2,306]),function(X,e,u,n,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(I,_,P,b,w,p){const g=p.environment.useHostProxy,v=typeof g=="boolean"?g:!p.remote.isRemote,f=(0,C.createProxyResolver)({resolveProxy:m=>I.resolveProxy(m),getHttpProxySetting:()=>_.getConfiguration("http").get("proxy"),log:(m,a,...h)=>{switch(m){case C.LogLevel.Trace:b.trace(a,...h);break;case C.LogLevel.Debug:b.debug(a,...h);break;case C.LogLevel.Info:b.info(a,...h);break;case C.LogLevel.Warning:b.warn(a,...h);break;case C.LogLevel.Error:b.error(a,...h);break;case C.LogLevel.Critical:b.critical(a,...h);break;case C.LogLevel.Off:break;default:r(m,a,h);break}function r(s,i,...t){b.error("Unknown log level",s),b.error(i,...t)}},getLogLevel:()=>b.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),c=E(_,f);return R(P,c)}e.connectProxyResolver=D;function E(I,_){const P={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(w=>{P.config=I.getConfiguration("http").get("proxySupport")||"off"});const b={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(w=>{b.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,C.createHttpPatch)(u,_,{config:"off"},b,!0)),on:Object.assign({},u,(0,C.createHttpPatch)(u,_,{config:"on"},b,!0)),override:Object.assign({},u,(0,C.createHttpPatch)(u,_,{config:"override"},b,!0)),onRequest:Object.assign({},u,(0,C.createHttpPatch)(u,_,P,b,!0)),default:Object.assign(u,(0,C.createHttpPatch)(u,_,P,b,!1))},https:{off:Object.assign({},n,(0,C.createHttpPatch)(n,_,{config:"off"},b,!0)),on:Object.assign({},n,(0,C.createHttpPatch)(n,_,{config:"on"},b,!0)),override:Object.assign({},n,(0,C.createHttpPatch)(n,_,{config:"override"},b,!0)),onRequest:Object.assign({},n,(0,C.createHttpPatch)(n,_,P,b,!0)),default:Object.assign(n,(0,C.createHttpPatch)(n,_,P,b,!1))},tls:Object.assign(S,(0,C.createTlsPatch)(S))}}const k=new Map;function R(I,_){return I.getExtensionPathIndex().then(P=>{const b=X.__$__nodeRequire("module"),w=b._load;b._load=function(g,v,f){if(g==="tls")return _.tls;if(g!=="http"&&g!=="https")return w.apply(this,arguments);const c=_[g],m=P.findSubstr(A.URI.file(v.filename));let a=k.get(m);if(a||k.set(m,a={}),!a[g]){const h=c.default;a[g]={...h}}return a[g]}})}}),define(Ie[296],ke([1,0,73,294,282,295,39,270,2,11,7,267,109,269]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class b extends S.RequireInterceptor{_installInterceptor(){const g=this,v=X.__$__nodeRequire("module"),f=v._load;v._load=function(h,r,s){return h=m(h),g._factories.has(h)?g._factories.get(h).load(h,E.URI.file((0,_.realpathSync)(r.filename)),i=>f.apply(this,[i,r,s])):f.apply(this,arguments)};const c=v._resolveLookupPaths;v._resolveLookupPaths=(a,h)=>c.call(this,m(a),h);const m=a=>{for(const h of g._alternatives){const r=h(a);if(r){a=r;break}}return a}}}class w extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(P.ExtHostConsoleForwarder);const g=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(b,g,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(g){return g.main}_loadCommonJSModule(g,v,f){if(v.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let c=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();try{g&&u.mark(`code/extHost/willLoadExtensionCode/${g.value}`),c=X.__$__nodeRequire(v.fsPath)}catch(m){return Promise.reject(m)}finally{g&&u.mark(`code/extHost/didLoadExtensionCode/${g.value}`),f.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(g){if(!!this._initData.remote.isRemote)for(const v in g){const f=g[v];f===null?delete process.env[v]:process.env[v]=f}}}e.ExtHostExtensionService=w}),define(Ie[141],ke([1,0,42,307,97,16,77,36,9,8,2,31,71,308,289,92]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const p=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(d){this.outputChannel=d}provideTextSearchResults(d,y,L,M){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((F,T)=>{M.onCancellationRequested(()=>V());const U=h(d,y),N=y.folder.fsPath,H=U.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${p} ${H}
 - cwd: ${N}`);let te=u.spawn(p,U,{cwd:N});te.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),T((0,I.serializeSearchError)(new I.SearchError(ve&&ve.message,I.SearchErrorCode.rgProcessError)))});let B=!1;const z=new c(y.maxResults,N,y.previewOptions);z.on("result",ve=>{B=!0,ie="",L.report(ve)});let q=!1;const V=()=>{q=!0,te&&te.kill(),z&&z.cancel()};let j=!1;z.on("hitLimit",()=>{j=!0,V()});let ie="";te.stdout.on("data",ve=>{z.handleData(ve),B||(ie+=ve)});let Q=!1;te.stdout.once("data",()=>Q=!0);let ue="";te.stderr.on("data",ve=>{const J=ve.toString();this.outputChannel.appendLine(J),ue+=J}),te.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),ie&&this.outputChannel.appendLine(`Got data without result: ${ie}`),this.outputChannel.appendLine(""),q)F({limitHit:j});else{z.flush(),te=null;let ve;ue&&!Q&&(ve=v(ue))?T((0,I.serializeSearchError)(new I.SearchError(ve.message,ve.code))):F({limitHit:j})}})})}}e.RipgrepTextSearchEngine=g;function v(l){const d=l.split(`
`),y=d[0].trim();if(d.some(M=>M.startsWith("regex parse error")))return new I.SearchError(f(d),I.SearchErrorCode.regexParseError);const L=y.match(/grep config error: unknown encoding: (.*)/);if(L)return new I.SearchError(`Unknown encoding: ${L[1]}`,I.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new I.SearchError(y.charAt(0).toUpperCase()+y.substr(1),I.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new I.SearchError(y.charAt(0).toUpperCase()+y.substr(1),I.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(y,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function f(l){const d=["Regex parse error"],y=l.filter(L=>L.startsWith("PCRE2:"));if(y.length>=1){const L=y[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const M=L.split(":")[1];d.push(":"+M)}}return d.join("")}e.buildRegexParseError=f;class c extends n.EventEmitter{constructor(d,y,L){super();this.maxResults=d,this.rootFolder=y,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new S.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,y){return super.on(d,y),this}handleData(d){if(this.isDone)return;const y=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(y)}handleDecodedData(d){let y=d.indexOf(`
`);const L=this.remainder+d;if(y>=0)y+=this.remainder.length;else{this.remainder=L;return}let M=0;for(;y>=0;)this.handleLine(L.substring(M,y).trim()),M=y+1,y=L.indexOf(`
`,M);this.remainder=L.substring(M)}handleLine(d){if(this.isDone||!d)return;let y;try{y=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(y.type==="match"){const L=m(y.data.path),M=R.URI.file(E.join(this.rootFolder,L)),F=this.createTextSearchMatch(y.data,M);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const L=m(y.data.path),M=R.URI.file(E.join(this.rootFolder,L));this.createTextSearchContext(y.data,M).forEach(T=>this.onResult(T))}}createTextSearchMatch(d,y){const L=d.line_number-1,M=m(d.lines),F=Buffer.from(M);let T=0,U=0,N=L;d.submatches.length===0&&d.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const H=(0,A.coalesce)(d.submatches.map((te,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=m(te.match),q=F.slice(T,te.start).toString().length,V=U+q,j=a(z),ie=N,Q=j.numLines+ie,ue=j.numLines>0?j.lastLineLength:j.lastLineLength+V;return T=te.end,U=ue,N=Q,new _.Range(ie,V,Q,ue)}));return(0,w.createTextSearchResult)(y,M,H,this.previewOptions)}createTextSearchContext(d,y){const L=m(d.lines),M=d.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((F,T)=>({text:F,uri:y,lineNumber:M+T}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=c;function m(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function a(l){const d=/\n/g;let y=0,L=-1,M;for(;M=d.exec(l);)y++,L=M.index;const F=L>=0?l.length-L-1:l.length;return{numLines:y,lastLineLength:F}}function h(l,d){const y=["--hidden"];y.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:M}=(0,C.groupBy)(d.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const T=new Set;M.forEach(U=>{T.add(U)}),y.push("-g","!*"),T.forEach(U=>{r(U).map(w.anchorGlob).forEach(N=>{y.push("-g",N)})})}L&&L.length&&L.forEach(T=>{y.push("-g",T)}),d.excludes.map(w.anchorGlob).forEach(T=>y.push("-g",`!${T}`)),d.maxFileSize&&y.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),d.followSymlinks&&y.push("--follow"),d.encoding&&d.encoding!=="utf8"&&y.push("--encoding",d.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,k.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),d.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),l.isRegExp&&(l.pattern=s(l.pattern),y.push("--engine","auto"));let F;if(l.isWordMatch){const U=(0,k.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",U)}else if(l.isRegExp){let T=t(l.pattern);T=o(T),y.push("--regexp",T)}else F=l.pattern,y.push("--fixed-strings");return y.push("--no-config"),d.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),l.isMultiline&&y.push("--multiline"),d.beforeContext&&y.push("--before-context",d.beforeContext+""),d.afterContext&&y.push("--after-context",d.afterContext+""),y.push("--"),F&&y.push(F),y.push("."),y}function r(l){const d=(0,D.splitGlobAware)(l,"/");return d.map((y,L)=>d.slice(0,L+1).join("/"))}e.spreadGlobComponents=r;function s(l){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(d);)l=l.replace(d,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(y);)l=l.replace(y,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=s;const i=l=>l.type==="Assertion"&&l.kind==="lookbehind";function t(l){let d;try{d=new P.RegExpParser().parsePattern(l)}catch{return l}let y="",L=0;const M=(U,N,H)=>{y+=l.slice(L,U)+H,L=N},F=[];return new P.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const N=F[0];if(!N)M(U.start,U.end,"\\r?\\n");else if(!F.some(i))if(N.type==="CharacterClass")if(N.negate){const H=l.slice(N.start+2,U.start)+l.slice(U.end,N.end-1);N.parent?.type==="Quantifier"?M(N.start,N.end,H?`[^${H}]`:"."):M(N.start,N.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=l.slice(N.start+1,U.start)+l.slice(U.end,N.end-1);M(N.start,N.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else N.type==="Quantifier"&&M(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){F.unshift(U)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(U){F.unshift(U)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(U){F.unshift(U)},onCharacterClassLeave(){F.shift()},onAssertionEnter(U){i(U)&&F.push(U)},onAssertionLeave(U){F[0]===U&&F.shift()}}).visit(d),y+=l.slice(L),y}e.fixRegexNewline=t;function o(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(Ie[297],ke([1,0,21,141,119,11]),function(X,e,u,n,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,R,I,_){const P=new n.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===A.Schemas.vscodeUserData){const b={...R,folder:R.folder.with({scheme:A.Schemas.file})},w=new S.Progress(p=>I.report({...p,uri:p.uri.with({scheme:R.folder.scheme})}));return this.withToken(_,p=>P.provideTextSearchResults(k,b,w,p))}else return this.withToken(_,b=>P.provideTextSearchResults(k,R,I,b))}async withToken(k,R){const I=D(k);this.inProgress.add(I);const _=await R(I.token);return this.inProgress.delete(I),_}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=C;function D(E){const k=new u.CancellationTokenSource;return E.onCancellationRequested(()=>k.cancel()),k}}),define(Ie[298],ke([1,0,29,141,140]),function(X,e,u,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(E){this.query=E}search(E,k,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(P){R({message:P})}},_=new S.NativeTextSearchManager(this.query,new n.RipgrepTextSearchEngine(I),u);return new Promise((P,b)=>_.search(w=>{k(w.map(C))},E).then(w=>P({limitHit:w.limitHit,type:"success",stats:w.stats}),b))}}e.TextSearchEngineAdapter=A;function C(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((E,k)=>{if(k.ranges){const R=k;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(Ie[299],ke([1,0,16,18,12,3,105,9,50,2,43,31,290,298]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class b{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let m;const a=g(c),h=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(r=>this.doFileSearchWithEngine(_.Engine,a,s=>h.fire(s),r)),m.then(r=>h.fire(r),r=>h.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return h.event}textSearch(c){let m;const a=g(c),h=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(r=>this.ripgrepTextSearch(a,s=>h.fire(s),r)),m.then(r=>h.fire(r),r=>h.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return h.event}ripgrepTextSearch(c,m,a){return c.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new P.TextSearchEngineAdapter(c).search(a,m,m)}doFileSearch(c,m,a){return this.doFileSearchWithEngine(_.Engine,c,m,a)}doFileSearchWithEngine(c,m,a,h,r=b.BATCH_SIZE){let s=0;const i=o=>{Array.isArray(o)?(s+=o.length,a(o.map(l=>this.rawMatchToSearchItem(l)))):o.relativePath?(s++,a(this.rawMatchToSearchItem(o))):a(o)};if(m.sortByScore){let o=this.trySortedSearchFromCache(m,i,h);if(!o){const l=m.maxResults?Object.assign({},m,{maxResults:null}):m,d=new c(l);o=this.doSortedSearch(d,m,a,i,h)}return new Promise((l,d)=>{o.then(([y,L])=>{const M=L.map(F=>this.rawMatchToSearchItem(F));this.sendProgress(M,a,r),l(y)},d)})}const t=new c(m);return this.doSearch(t,i,r,h).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,D.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,m,a,h,r){const s=new A.Emitter;let i=(0,n.createCancelablePromise)(o=>{let l=[];const d=y=>{Array.isArray(y)?l=y:(h(y),s.fire(y))};return this.doSearch(c,d,-1,o).then(y=>[y,l])}),t;if(m.cacheKey){t=this.getOrCreateCache(m.cacheKey);const o={promise:i,event:s.event,resolved:!1};t.resultsToSearchCache[m.filePattern||""]=o,i.then(()=>{o.resolved=!0},l=>{delete t.resultsToSearchCache[m.filePattern||""]}),i=this.preventCancellation(i)}return i.then(([o,l])=>{const d=t?t.scorerCache:Object.create(null),y=(typeof m.maxResults!="number"||m.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(m,l,d,r).then(L=>{const M=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:L.length},messages:o.messages,limitHit:o.limitHit||typeof m.maxResults=="number"&&l.length>m.maxResults},L]})})}getOrCreateCache(c){const m=this.caches[c];return m||(this.caches[c]=new w)}trySortedSearchFromCache(c,m,a){const h=c.cacheKey&&this.caches[c.cacheKey];if(!h)return;const r=this.getResultsFromCache(h,c.filePattern||"",m,a);if(r)return r.then(([s,i,t])=>{const o=E.StopWatch.create(!1);return this.sortResults(c,i,h.scorerCache,a).then(l=>{const d=o.elapsed(),y={fromCache:!0,detailStats:t,type:this.processType,resultCount:i.length,sortingTime:d};return[{type:"success",limitHit:s.limitHit||typeof c.maxResults=="number"&&i.length>c.maxResults,stats:y},l]})})}sortResults(c,m,a,h){const r=(0,C.prepareQuery)(c.filePattern||""),s=(t,o)=>(0,C.compareItemsByFuzzyScore)(t,o,r,!0,p,a),i=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return u.topAsync(m,s,i,1e4,h)}sendProgress(c,m,a){if(a&&a>0)for(let h=0;h<c.length;h+=a)m(c.slice(h,h+a));else m(c)}getResultsFromCache(c,m,a,h){const r=E.StopWatch.create(!1),s=m.indexOf(D.sep)>=0;let i;for(const d in c.resultsToSearchCache)if(m.startsWith(d)){if(s&&d.indexOf(D.sep)<0&&d!=="")continue;const y=c.resultsToSearchCache[d];i={promise:this.preventCancellation(y.promise),event:y.event,resolved:y.resolved};break}if(!i)return null;const t=r.elapsed(),o=E.StopWatch.create(!1),l=i.event(a);return h&&h.onCancellationRequested(()=>{l.dispose()}),i.promise.then(([d,y])=>{if(h&&h.isCancellationRequested)throw(0,S.canceled)();const L=[],M=(0,C.prepareQuery)(m).normalizedLowercase;for(const F of y)!(0,I.isFilePatternMatch)(F,M)||L.push(F);return[d,L,{cacheWasResolved:i.resolved,cacheLookupTime:t,cacheFilterTime:o.elapsed(),cacheEntryCount:y.length}]})}doSearch(c,m,a,h){return new Promise((r,s)=>{let i=[];h?.onCancellationRequested(()=>c.cancel()),c.search(t=>{t&&(a?(i.push(t),a>0&&i.length>=a&&(m(i),i=[])):m(t))},t=>{m(t)},(t,o)=>{i.length&&m(i),t?s(t):r(o)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,a){return c.then(m,a)}catch(m){return this.then(void 0,m)}finally(m){return c.finally(m)}}}}e.SearchService=b,b.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(f){return(0,D.basename)(f.relativePath)}getItemDescription(f){return(0,D.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function g(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(v),extraFileResources:f.extraFileResources&&f.extraFileResources.map(c=>k.URI.revive(c))}}function v(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ie[300],ke([1,0,6,11,2,29,14,26,17,75,64,31,299,297,92,140]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let p=class extends k.ExtHostSearch{constructor(v,f,c,m){super(v,c,m);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new b.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(n.Schemas.vscodeUserData,new P.RipgrepSearchProvider(a)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new b.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(n.Schemas.file,new P.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(n.Schemas.file,new _.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,f){const c=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(v)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(v,f,c,m){const a=(0,k.reviveQuery)(c);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,f,a,m):super.$provideFileSearchResults(v,f,c,m)}doInternalFileSearch(v,f,c,m){const a=h=>{if((0,I.isSerializedFileMatch)(h)&&(h=[h]),Array.isArray(h)){this._proxy.$handleFileMatch(v,f,h.map(r=>S.URI.file(r.path)));return}h.message&&this._logService.debug("ExtHostSearch",h.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,a,m)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,f){return new w.NativeTextSearchManager(v,f,void 0,"textSearchProvider")}};p=Ge([He(0,E.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,R.IURITransformerService),He(3,C.ILogService)],p),e.NativeExtHostSearch=p}),define(Ie[301],ke([1,0,82,273,285,284,300,296,274,74,39,75,72,38,52,69,272,271,14,286,47]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g,v,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(R.IExtHostExtensionService,D.ExtHostExtensionService),(0,u.registerSingleton)(v.ILoggerService,g.ExtHostLoggerService),(0,u.registerSingleton)(w.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,u.registerSingleton)(k.IExtHostDebugService,A.ExtHostDebugService),(0,u.registerSingleton)(I.IExtHostSearch,C.NativeExtHostSearch),(0,u.registerSingleton)(_.IExtHostTask,S.ExtHostTask),(0,u.registerSingleton)(P.IExtHostTerminalService,n.ExtHostTerminalService),(0,u.registerSingleton)(b.IExtHostTunnelService,E.ExtHostTunnelService),(0,u.registerSingleton)(c.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService)}),define(Ie[309],ke([1,0,216,310,73,12,111,112,197,134,283,23,29,109,18,115,210,228,287,301]),function(X,e,u,n,S,A,C,D,E,k,R,I,_,P,b,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let t=0;t<process.execArgv.length;t++)process.execArgv[t]==="--inspect-port=0"&&(process.execArgv.splice(t,1),t--)}();const v=n(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const i=X.__$__nodeRequire("module"),t=i._load;i._load=function(o){if(o==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return t.apply(this,arguments)}})();const f=process.exit.bind(process);function c(i){process.exit=function(t){if(i)f(t);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const t=new Error("An extension called process.crash() and this was prevented.");console.warn(t.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let m=function(i){f()};function a(){const i=(0,g.readExtHostConnection)(process.env);if(i.type===3)return new Promise((t,o)=>{const l=d=>{const y=d[0],L=new C.BufferedEmitter;y.on("message",M=>L.fire(I.VSBuffer.wrap(M.data))),y.on("close",()=>{m("renderer closed the MessagePort")}),y.start(),t({onMessage:L.event,send:M=>y.postMessage(M.buffer)})};if(global.vscodePorts){const d=global.vscodePorts;delete global.vscodePorts,l(d)}else global.vscodePortsCallback=l});if(i.type===2)return new Promise((t,o)=>{let l=null;const d=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,L=3e5,M=new b.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),y),F=new b.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),L);process.on("message",(U,N)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const H=I.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let te;if(U.skipWebSocketFrames)te=new D.NodeSocket(N,"extHost-socket");else{const B=I.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));te=new D.WebSocketNodeSocket(new D.NodeSocket(N,"extHost-socket"),U.permessageDeflate,B,!1)}l?(M.cancel(),F.cancel(),l.beginAcceptReconnection(te,H),l.endAcceptReconnection(),l.sendResume()):(clearTimeout(d),l=new C.PersistentProtocol(te,H),l.sendResume(),l.onDidDispose(()=>m("renderer disconnected")),t(l),l.onSocketClose(()=>{M.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;M.isScheduled()&&F.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const t=i.pipeName;return new Promise((o,l)=>{const d=u.createConnection(t,()=>{d.removeListener("error",l);const y=new C.PersistentProtocol(new D.NodeSocket(d,"extHost-renderer"));y.sendResume(),o(y)});d.once("error",l),d.on("close",()=>{m("renderer closed the socket")})})}}async function h(){const i=await a();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(t=>{(0,k.isMessageOfType)(t,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(t)})}send(t){this._terminating||i.send(t)}async drain(){if(i.drain)return i.drain()}}}function r(i){return new Promise(t=>{const o=i.onMessage(l=>{o.dispose();const d=JSON.parse(l.toString()),y=d.commit,L=E.default.commit;y&&L&&y!==L&&f(55);let M=0;setInterval(function(){try{process.kill(d.parentPid,0),M=0}catch(T){T&&T.code==="EPERM"?(M++,M>=3&&m(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):m(`parent process ${d.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let F;try{F=X.__$__nodeRequire("native-watchdog"),F.start(d.parentPid)}catch(T){(0,A.onUnexpectedError)(T)}i.send((0,k.createMessageOfType)(0)),t({protocol:i,initData:d})});i.send((0,k.createMessageOfType)(1))})}async function s(){const i=[];process.on("unhandledRejection",(M,F)=>{i.push(F),setTimeout(()=>{const T=i.indexOf(F);T>=0&&F.catch(U=>{i.splice(T,1),(0,A.isCancellationError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),M&&(0,A.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const F=i.indexOf(M);F>=0&&i.splice(F,1)}),process.on("uncaughtException",function(M){(0,A.onUnexpectedError)(M)}),S.mark("code/extHost/willConnectToRenderer");const t=await h();S.mark("code/extHost/didConnectToRenderer");const o=await r(t);S.mark("code/extHost/didWaitForInitData");const{initData:l}=o;c(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,w.boolean)(v.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(F){f(F)}exists(F){return _.Promises.exists(F)}realpath(F){return(0,P.realpath)(F)}};let y=null;l.remote.authority&&v.transformURIs&&(y=(0,p.createURITransformer)(l.remote.authority));const L=new R.ExtensionHostMain(o.protocol,l,d,y);m=M=>L.terminate(M)}e.startExtensionHostProcess=s,s().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a36f047dd34d67abb45728037a02cfdb530fc59c/core/vs/workbench/api/node/extensionHostProcess.js.map
